/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the BPF target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 11;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(BPFInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(BPFInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static BPFInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static BPFInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s32,
  GILLT_s64,
};
const static size_t NumTypeObjects = 2;
const static LLT TypeObjects[] = {
  LLT::scalar(32),
  LLT::scalar(64),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_BPFIsLittleEndianBit = 7,
  Feature_BPFIsBigEndianBit = 8,
  Feature_BPFHasALU32Bit = 5,
  Feature_BPFNoALU32Bit = 2,
  Feature_BPFHasLdsxBit = 4,
  Feature_BPFHasMovsxBit = 1,
  Feature_BPFHasBswapBit = 6,
  Feature_BPFHasSdivSmodBit = 0,
  Feature_BPFNoMovsxBit = 10,
  Feature_BPFHasStoreImmBit = 3,
  Feature_BPFHasLoadAcqStoreRelBit = 9,
};

PredicateBitset BPFInstructionSelector::
computeAvailableModuleFeatures(const BPFSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->isLittleEndian())
    Features.set(Feature_BPFIsLittleEndianBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_BPFIsBigEndianBit);
  if (Subtarget->getHasAlu32())
    Features.set(Feature_BPFHasALU32Bit);
  if (!Subtarget->getHasAlu32())
    Features.set(Feature_BPFNoALU32Bit);
  if (Subtarget->hasLdsx())
    Features.set(Feature_BPFHasLdsxBit);
  if (Subtarget->hasMovsx())
    Features.set(Feature_BPFHasMovsxBit);
  if (Subtarget->hasBswap())
    Features.set(Feature_BPFHasBswapBit);
  if (Subtarget->hasSdivSmod())
    Features.set(Feature_BPFHasSdivSmodBit);
  if (!Subtarget->hasMovsx())
    Features.set(Feature_BPFNoMovsxBit);
  if (Subtarget->hasStoreImm())
    Features.set(Feature_BPFHasStoreImmBit);
  if (Subtarget->hasLoadAcqStoreRel())
    Features.set(Feature_BPFHasLoadAcqStoreRelBit);
  return Features;
}

void BPFInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const BPFSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset BPFInstructionSelector::
computeAvailableFunctionFeatures(const BPFSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_BPFHasBswap,
  GIFBS_BPFHasMovsx,
  GIFBS_BPFHasSdivSmod,
  GIFBS_BPFIsBigEndian,
  GIFBS_BPFIsLittleEndian,
  GIFBS_BPFNoMovsx,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_BPFHasBswapBit, },
  {Feature_BPFHasMovsxBit, },
  {Feature_BPFHasSdivSmodBit, },
  {Feature_BPFIsBigEndianBit, },
  {Feature_BPFIsLittleEndianBit, },
  {Feature_BPFNoMovsxBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

BPFInstructionSelector::ComplexMatcherMemFn
BPFInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool BPFInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool BPFInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("BPFInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
BPFInstructionSelector::CustomRendererFn
BPFInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool BPFInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool BPFInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("BPFInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *BPFInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(250), /*)*//*default:*//*Label 22*/ GIMT_Encode4(2647),
     /*   10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(798),
     /*   14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(864),
     /*   18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(978),
     /*   22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(1044),
     /*   26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(1116),
     /*   30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(1182),
     /*   34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(1254), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(1320),
     /*   50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(1446),
     /*   54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(1512), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 10*/ GIMT_Encode4(1578), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  330 */ /*TargetOpcode::G_ANYEXT*//*Label 11*/ GIMT_Encode4(1642),
     /*  334 */ /*TargetOpcode::G_TRUNC*//*Label 12*/ GIMT_Encode4(1705),
     /*  338 */ /*TargetOpcode::G_CONSTANT*//*Label 13*/ GIMT_Encode4(1747), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  354 */ /*TargetOpcode::G_SEXT*//*Label 14*/ GIMT_Encode4(1770),
     /*  358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 15*/ GIMT_Encode4(1886),
     /*  362 */ /*TargetOpcode::G_ZEXT*//*Label 16*/ GIMT_Encode4(2082),
     /*  366 */ /*TargetOpcode::G_SHL*//*Label 17*/ GIMT_Encode4(2109),
     /*  370 */ /*TargetOpcode::G_LSHR*//*Label 18*/ GIMT_Encode4(2175),
     /*  374 */ /*TargetOpcode::G_ASHR*//*Label 19*/ GIMT_Encode4(2499), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  730 */ /*TargetOpcode::G_BR*//*Label 20*/ GIMT_Encode4(2565), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  794 */ /*TargetOpcode::G_BSWAP*//*Label 21*/ GIMT_Encode4(2581),
     /*  798 */ // Label 0: @798
     /*  798 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 25*/ GIMT_Encode4(863),
     /*  809 */ /*GILLT_s32*//*Label 23*/ GIMT_Encode4(817),
     /*  813 */ /*GILLT_s64*//*Label 24*/ GIMT_Encode4(840),
     /*  817 */ // Label 23: @817
     /*  817 */ GIM_Try, /*On fail goto*//*Label 26*/ GIMT_Encode4(839), // Rule ID 46 //
     /*  822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /*  832 */   // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (ADD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /*  832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::ADD_rr_32),
     /*  837 */   GIR_RootConstrainSelectedInstOperands,
     /*  838 */   // GIR_Coverage, 46,
     /*  838 */   GIR_Done,
     /*  839 */ // Label 26: @839
     /*  839 */ GIM_Reject,
     /*  840 */ // Label 24: @840
     /*  840 */ GIM_Try, /*On fail goto*//*Label 27*/ GIMT_Encode4(862), // Rule ID 44 //
     /*  845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /*  855 */   // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (ADD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /*  855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::ADD_rr),
     /*  860 */   GIR_RootConstrainSelectedInstOperands,
     /*  861 */   // GIR_Coverage, 44,
     /*  861 */   GIR_Done,
     /*  862 */ // Label 27: @862
     /*  862 */ GIM_Reject,
     /*  863 */ // Label 25: @863
     /*  863 */ GIM_Reject,
     /*  864 */ // Label 1: @864
     /*  864 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 30*/ GIMT_Encode4(977),
     /*  875 */ /*GILLT_s32*//*Label 28*/ GIMT_Encode4(883),
     /*  879 */ /*GILLT_s64*//*Label 29*/ GIMT_Encode4(930),
     /*  883 */ // Label 28: @883
     /*  883 */ GIM_Try, /*On fail goto*//*Label 31*/ GIMT_Encode4(929),
     /*  888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /*  898 */   GIM_Try, /*On fail goto*//*Label 32*/ GIMT_Encode4(916), // Rule ID 97 //
     /*  903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  907 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG_32:{ *:[i32] } i32:{ *:[i32] }:$src)
     /*  907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::NEG_32),
     /*  910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  912 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  914 */     GIR_RootConstrainSelectedInstOperands,
     /*  915 */     // GIR_Coverage, 97,
     /*  915 */     GIR_EraseRootFromParent_Done,
     /*  916 */   // Label 32: @916
     /*  916 */   GIM_Try, /*On fail goto*//*Label 33*/ GIMT_Encode4(928), // Rule ID 50 //
     /*  921 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SUB_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /*  921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SUB_rr_32),
     /*  926 */     GIR_RootConstrainSelectedInstOperands,
     /*  927 */     // GIR_Coverage, 50,
     /*  927 */     GIR_Done,
     /*  928 */   // Label 33: @928
     /*  928 */   GIM_Reject,
     /*  929 */ // Label 31: @929
     /*  929 */ GIM_Reject,
     /*  930 */ // Label 29: @930
     /*  930 */ GIM_Try, /*On fail goto*//*Label 34*/ GIMT_Encode4(976),
     /*  935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /*  945 */   GIM_Try, /*On fail goto*//*Label 35*/ GIMT_Encode4(963), // Rule ID 96 //
     /*  950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  954 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, i64:{ *:[i64] }:$src)  =>  (NEG_64:{ *:[i64] } i64:{ *:[i64] }:$src)
     /*  954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::NEG_64),
     /*  957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  961 */     GIR_RootConstrainSelectedInstOperands,
     /*  962 */     // GIR_Coverage, 96,
     /*  962 */     GIR_EraseRootFromParent_Done,
     /*  963 */   // Label 35: @963
     /*  963 */   GIM_Try, /*On fail goto*//*Label 36*/ GIMT_Encode4(975), // Rule ID 48 //
     /*  968 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SUB_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /*  968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SUB_rr),
     /*  973 */     GIR_RootConstrainSelectedInstOperands,
     /*  974 */     // GIR_Coverage, 48,
     /*  974 */     GIR_Done,
     /*  975 */   // Label 36: @975
     /*  975 */   GIM_Reject,
     /*  976 */ // Label 34: @976
     /*  976 */ GIM_Reject,
     /*  977 */ // Label 30: @977
     /*  977 */ GIM_Reject,
     /*  978 */ // Label 2: @978
     /*  978 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 39*/ GIMT_Encode4(1043),
     /*  989 */ /*GILLT_s32*//*Label 37*/ GIMT_Encode4(997),
     /*  993 */ /*GILLT_s64*//*Label 38*/ GIMT_Encode4(1020),
     /*  997 */ // Label 37: @997
     /*  997 */ GIM_Try, /*On fail goto*//*Label 40*/ GIMT_Encode4(1019), // Rule ID 78 //
     /* 1002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1012 */   // (mul:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (MUL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MUL_rr_32),
     /* 1017 */   GIR_RootConstrainSelectedInstOperands,
     /* 1018 */   // GIR_Coverage, 78,
     /* 1018 */   GIR_Done,
     /* 1019 */ // Label 40: @1019
     /* 1019 */ GIM_Reject,
     /* 1020 */ // Label 38: @1020
     /* 1020 */ GIM_Try, /*On fail goto*//*Label 41*/ GIMT_Encode4(1042), // Rule ID 76 //
     /* 1025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1035 */   // (mul:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (MUL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MUL_rr),
     /* 1040 */   GIR_RootConstrainSelectedInstOperands,
     /* 1041 */   // GIR_Coverage, 76,
     /* 1041 */   GIR_Done,
     /* 1042 */ // Label 41: @1042
     /* 1042 */ GIM_Reject,
     /* 1043 */ // Label 39: @1043
     /* 1043 */ GIM_Reject,
     /* 1044 */ // Label 3: @1044
     /* 1044 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 44*/ GIMT_Encode4(1115),
     /* 1055 */ /*GILLT_s32*//*Label 42*/ GIMT_Encode4(1063),
     /* 1059 */ /*GILLT_s64*//*Label 43*/ GIMT_Encode4(1089),
     /* 1063 */ // Label 42: @1063
     /* 1063 */ GIM_Try, /*On fail goto*//*Label 45*/ GIMT_Encode4(1088), // Rule ID 90 //
     /* 1068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1081 */   // (sdiv:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SDIV_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SDIV_rr_32),
     /* 1086 */   GIR_RootConstrainSelectedInstOperands,
     /* 1087 */   // GIR_Coverage, 90,
     /* 1087 */   GIR_Done,
     /* 1088 */ // Label 45: @1088
     /* 1088 */ GIM_Reject,
     /* 1089 */ // Label 43: @1089
     /* 1089 */ GIM_Try, /*On fail goto*//*Label 46*/ GIMT_Encode4(1114), // Rule ID 88 //
     /* 1094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1107 */   // (sdiv:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SDIV_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SDIV_rr),
     /* 1112 */   GIR_RootConstrainSelectedInstOperands,
     /* 1113 */   // GIR_Coverage, 88,
     /* 1113 */   GIR_Done,
     /* 1114 */ // Label 46: @1114
     /* 1114 */ GIM_Reject,
     /* 1115 */ // Label 44: @1115
     /* 1115 */ GIM_Reject,
     /* 1116 */ // Label 4: @1116
     /* 1116 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 49*/ GIMT_Encode4(1181),
     /* 1127 */ /*GILLT_s32*//*Label 47*/ GIMT_Encode4(1135),
     /* 1131 */ /*GILLT_s64*//*Label 48*/ GIMT_Encode4(1158),
     /* 1135 */ // Label 47: @1135
     /* 1135 */ GIM_Try, /*On fail goto*//*Label 50*/ GIMT_Encode4(1157), // Rule ID 82 //
     /* 1140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1150 */   // (udiv:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (DIV_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::DIV_rr_32),
     /* 1155 */   GIR_RootConstrainSelectedInstOperands,
     /* 1156 */   // GIR_Coverage, 82,
     /* 1156 */   GIR_Done,
     /* 1157 */ // Label 50: @1157
     /* 1157 */ GIM_Reject,
     /* 1158 */ // Label 48: @1158
     /* 1158 */ GIM_Try, /*On fail goto*//*Label 51*/ GIMT_Encode4(1180), // Rule ID 80 //
     /* 1163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1173 */   // (udiv:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (DIV_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::DIV_rr),
     /* 1178 */   GIR_RootConstrainSelectedInstOperands,
     /* 1179 */   // GIR_Coverage, 80,
     /* 1179 */   GIR_Done,
     /* 1180 */ // Label 51: @1180
     /* 1180 */ GIM_Reject,
     /* 1181 */ // Label 49: @1181
     /* 1181 */ GIM_Reject,
     /* 1182 */ // Label 5: @1182
     /* 1182 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 54*/ GIMT_Encode4(1253),
     /* 1193 */ /*GILLT_s32*//*Label 52*/ GIMT_Encode4(1201),
     /* 1197 */ /*GILLT_s64*//*Label 53*/ GIMT_Encode4(1227),
     /* 1201 */ // Label 52: @1201
     /* 1201 */ GIM_Try, /*On fail goto*//*Label 55*/ GIMT_Encode4(1226), // Rule ID 94 //
     /* 1206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1219 */   // (srem:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SMOD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SMOD_rr_32),
     /* 1224 */   GIR_RootConstrainSelectedInstOperands,
     /* 1225 */   // GIR_Coverage, 94,
     /* 1225 */   GIR_Done,
     /* 1226 */ // Label 55: @1226
     /* 1226 */ GIM_Reject,
     /* 1227 */ // Label 53: @1227
     /* 1227 */ GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(1252), // Rule ID 92 //
     /* 1232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1245 */   // (srem:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SMOD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SMOD_rr),
     /* 1250 */   GIR_RootConstrainSelectedInstOperands,
     /* 1251 */   // GIR_Coverage, 92,
     /* 1251 */   GIR_Done,
     /* 1252 */ // Label 56: @1252
     /* 1252 */ GIM_Reject,
     /* 1253 */ // Label 54: @1253
     /* 1253 */ GIM_Reject,
     /* 1254 */ // Label 6: @1254
     /* 1254 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 59*/ GIMT_Encode4(1319),
     /* 1265 */ /*GILLT_s32*//*Label 57*/ GIMT_Encode4(1273),
     /* 1269 */ /*GILLT_s64*//*Label 58*/ GIMT_Encode4(1296),
     /* 1273 */ // Label 57: @1273
     /* 1273 */ GIM_Try, /*On fail goto*//*Label 60*/ GIMT_Encode4(1295), // Rule ID 86 //
     /* 1278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1288 */   // (urem:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (MOD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOD_rr_32),
     /* 1293 */   GIR_RootConstrainSelectedInstOperands,
     /* 1294 */   // GIR_Coverage, 86,
     /* 1294 */   GIR_Done,
     /* 1295 */ // Label 60: @1295
     /* 1295 */ GIM_Reject,
     /* 1296 */ // Label 58: @1296
     /* 1296 */ GIM_Try, /*On fail goto*//*Label 61*/ GIMT_Encode4(1318), // Rule ID 84 //
     /* 1301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1311 */   // (urem:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (MOD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOD_rr),
     /* 1316 */   GIR_RootConstrainSelectedInstOperands,
     /* 1317 */   // GIR_Coverage, 84,
     /* 1317 */   GIR_Done,
     /* 1318 */ // Label 61: @1318
     /* 1318 */ GIM_Reject,
     /* 1319 */ // Label 59: @1319
     /* 1319 */ GIM_Reject,
     /* 1320 */ // Label 7: @1320
     /* 1320 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 64*/ GIMT_Encode4(1445),
     /* 1331 */ /*GILLT_s32*//*Label 62*/ GIMT_Encode4(1339),
     /* 1335 */ /*GILLT_s64*//*Label 63*/ GIMT_Encode4(1362),
     /* 1339 */ // Label 62: @1339
     /* 1339 */ GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(1361), // Rule ID 58 //
     /* 1344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1354 */   // (and:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (AND_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::AND_rr_32),
     /* 1359 */   GIR_RootConstrainSelectedInstOperands,
     /* 1360 */   // GIR_Coverage, 58,
     /* 1360 */   GIR_Done,
     /* 1361 */ // Label 65: @1361
     /* 1361 */ GIM_Reject,
     /* 1362 */ // Label 63: @1362
     /* 1362 */ GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(1444),
     /* 1367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1377 */   GIM_Try, /*On fail goto*//*Label 67*/ GIMT_Encode4(1431), // Rule ID 171 //
     /* 1382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1386 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /* 1397 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$src, 4294967295:{ *:[i64] })  =>  (SRL_ri:{ *:[i64] } (SLL_ri:{ *:[i64] } GPR:{ *:[i64] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 1397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::SLL_ri),
     /* 1404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1409 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1413 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 1416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::SRL_ri),
     /* 1421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 1429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430 */     // GIR_Coverage, 171,
     /* 1430 */     GIR_EraseRootFromParent_Done,
     /* 1431 */   // Label 67: @1431
     /* 1431 */   GIM_Try, /*On fail goto*//*Label 68*/ GIMT_Encode4(1443), // Rule ID 56 //
     /* 1436 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (AND_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::AND_rr),
     /* 1441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442 */     // GIR_Coverage, 56,
     /* 1442 */     GIR_Done,
     /* 1443 */   // Label 68: @1443
     /* 1443 */   GIM_Reject,
     /* 1444 */ // Label 66: @1444
     /* 1444 */ GIM_Reject,
     /* 1445 */ // Label 64: @1445
     /* 1445 */ GIM_Reject,
     /* 1446 */ // Label 8: @1446
     /* 1446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 71*/ GIMT_Encode4(1511),
     /* 1457 */ /*GILLT_s32*//*Label 69*/ GIMT_Encode4(1465),
     /* 1461 */ /*GILLT_s64*//*Label 70*/ GIMT_Encode4(1488),
     /* 1465 */ // Label 69: @1465
     /* 1465 */ GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1487), // Rule ID 54 //
     /* 1470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1480 */   // (or:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (OR_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::OR_rr_32),
     /* 1485 */   GIR_RootConstrainSelectedInstOperands,
     /* 1486 */   // GIR_Coverage, 54,
     /* 1486 */   GIR_Done,
     /* 1487 */ // Label 72: @1487
     /* 1487 */ GIM_Reject,
     /* 1488 */ // Label 70: @1488
     /* 1488 */ GIM_Try, /*On fail goto*//*Label 73*/ GIMT_Encode4(1510), // Rule ID 52 //
     /* 1493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1503 */   // (or:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (OR_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::OR_rr),
     /* 1508 */   GIR_RootConstrainSelectedInstOperands,
     /* 1509 */   // GIR_Coverage, 52,
     /* 1509 */   GIR_Done,
     /* 1510 */ // Label 73: @1510
     /* 1510 */ GIM_Reject,
     /* 1511 */ // Label 71: @1511
     /* 1511 */ GIM_Reject,
     /* 1512 */ // Label 9: @1512
     /* 1512 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 76*/ GIMT_Encode4(1577),
     /* 1523 */ /*GILLT_s32*//*Label 74*/ GIMT_Encode4(1531),
     /* 1527 */ /*GILLT_s64*//*Label 75*/ GIMT_Encode4(1554),
     /* 1531 */ // Label 74: @1531
     /* 1531 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(1553), // Rule ID 70 //
     /* 1536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1546 */   // (xor:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (XOR_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::XOR_rr_32),
     /* 1551 */   GIR_RootConstrainSelectedInstOperands,
     /* 1552 */   // GIR_Coverage, 70,
     /* 1552 */   GIR_Done,
     /* 1553 */ // Label 77: @1553
     /* 1553 */ GIM_Reject,
     /* 1554 */ // Label 75: @1554
     /* 1554 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(1576), // Rule ID 68 //
     /* 1559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1569 */   // (xor:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (XOR_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::XOR_rr),
     /* 1574 */   GIR_RootConstrainSelectedInstOperands,
     /* 1575 */   // GIR_Coverage, 68,
     /* 1575 */   GIR_Done,
     /* 1576 */ // Label 78: @1576
     /* 1576 */ GIM_Reject,
     /* 1577 */ // Label 76: @1577
     /* 1577 */ GIM_Reject,
     /* 1578 */ // Label 10: @1578
     /* 1578 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(1641), // Rule ID 107 //
     /* 1583 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 1586 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::bpf_pseudo),
     /* 1591 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1597 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1604 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1612 */   // MIs[1] Operand 1
     /* 1612 */   // No operand predicates
     /* 1612 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 1616 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1620 */   // MIs[2] Operand 1
     /* 1620 */   // No operand predicates
     /* 1620 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1622 */   // (intrinsic_w_chain:{ *:[i64] } 3952:{ *:[iPTR] }, (imm:{ *:[i64] }):$pseudo, (imm:{ *:[i64] }):$imm)  =>  (LD_pseudo:{ *:[i64] } (imm:{ *:[i64] }):$pseudo, (imm:{ *:[i64] }):$imm)
     /* 1622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LD_pseudo),
     /* 1625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1627 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pseudo
     /* 1630 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 1633 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 1639 */   GIR_RootConstrainSelectedInstOperands,
     /* 1640 */   // GIR_Coverage, 107,
     /* 1640 */   GIR_EraseRootFromParent_Done,
     /* 1641 */ // Label 79: @1641
     /* 1641 */ GIM_Reject,
     /* 1642 */ // Label 11: @1642
     /* 1642 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(1704), // Rule ID 238 //
     /* 1647 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1661 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 1661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 1668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 1678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1703 */   // GIR_Coverage, 238,
     /* 1703 */   GIR_EraseRootFromParent_Done,
     /* 1704 */ // Label 80: @1704
     /* 1704 */ GIM_Reject,
     /* 1705 */ // Label 12: @1705
     /* 1705 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1746), // Rule ID 237 //
     /* 1710 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 1713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1724 */   // (trunc:{ *:[i32] } GPR:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 1724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 1727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1729 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 1735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1740 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1745 */   // GIR_Coverage, 237,
     /* 1745 */   GIR_EraseRootFromParent_Done,
     /* 1746 */ // Label 81: @1746
     /* 1746 */ GIM_Reject,
     /* 1747 */ // Label 13: @1747
     /* 1747 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1769), // Rule ID 98 //
     /* 1752 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1759 */   // MIs[0] Operand 1
     /* 1759 */   // No operand predicates
     /* 1759 */   // (imm:{ *:[i64] }):$imm  =>  (LD_imm64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 1759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LD_imm64),
     /* 1762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1764 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 1767 */   GIR_RootConstrainSelectedInstOperands,
     /* 1768 */   // GIR_Coverage, 98,
     /* 1768 */   GIR_EraseRootFromParent_Done,
     /* 1769 */ // Label 82: @1769
     /* 1769 */ GIM_Reject,
     /* 1770 */ // Label 14: @1770
     /* 1770 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1885),
     /* 1775 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1789 */   GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1848), // Rule ID 234 //
     /* 1794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFNoMovsx),
     /* 1797 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SRA_ri:{ *:[i64] } (SLL_ri:{ *:[i64] } (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src), 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 1797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 1800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 1804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1809 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 1815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::SLL_ri),
     /* 1822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 1830 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 1833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::SRA_ri),
     /* 1838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 1846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847 */     // GIR_Coverage, 234,
     /* 1847 */     GIR_EraseRootFromParent_Done,
     /* 1848 */   // Label 84: @1848
     /* 1848 */   GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1884), // Rule ID 235 //
     /* 1853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1856 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (MOVSX_rr_32:{ *:[i64] } (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src))
     /* 1856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 1863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32),
     /* 1877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883 */     // GIR_Coverage, 235,
     /* 1883 */     GIR_EraseRootFromParent_Done,
     /* 1884 */   // Label 85: @1884
     /* 1884 */   GIM_Reject,
     /* 1885 */ // Label 83: @1885
     /* 1885 */ GIM_Reject,
     /* 1886 */ // Label 15: @1886
     /* 1886 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 88*/ GIMT_Encode4(2081),
     /* 1897 */ /*GILLT_s32*//*Label 86*/ GIMT_Encode4(1905),
     /* 1901 */ /*GILLT_s64*//*Label 87*/ GIMT_Encode4(1979),
     /* 1905 */ // Label 86: @1905
     /* 1905 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1978),
     /* 1910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1921 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1949), // Rule ID 104 //
     /* 1926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1929 */     // MIs[0] Operand 2
     /* 1929 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 1940 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX_rr_32_8:{ *:[i32] } GPR32:{ *:[i32] }:$src)
     /* 1940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32_8),
     /* 1943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948 */     // GIR_Coverage, 104,
     /* 1948 */     GIR_EraseRootFromParent_Done,
     /* 1949 */   // Label 90: @1949
     /* 1949 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1977), // Rule ID 105 //
     /* 1954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1957 */     // MIs[0] Operand 2
     /* 1957 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 1968 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX_rr_32_16:{ *:[i32] } GPR32:{ *:[i32] }:$src)
     /* 1968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32_16),
     /* 1971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1973 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976 */     // GIR_Coverage, 105,
     /* 1976 */     GIR_EraseRootFromParent_Done,
     /* 1977 */   // Label 91: @1977
     /* 1977 */   GIM_Reject,
     /* 1978 */ // Label 89: @1978
     /* 1978 */ GIM_Reject,
     /* 1979 */ // Label 87: @1979
     /* 1979 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(2080),
     /* 1984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1995 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(2023), // Rule ID 101 //
     /* 2000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 2003 */     // MIs[0] Operand 2
     /* 2003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2014 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (MOVSX_rr_8:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_8),
     /* 2017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022 */     // GIR_Coverage, 101,
     /* 2022 */     GIR_EraseRootFromParent_Done,
     /* 2023 */   // Label 93: @2023
     /* 2023 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(2051), // Rule ID 102 //
     /* 2028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 2031 */     // MIs[0] Operand 2
     /* 2031 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2042 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (MOVSX_rr_16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_16),
     /* 2045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2047 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050 */     // GIR_Coverage, 102,
     /* 2050 */     GIR_EraseRootFromParent_Done,
     /* 2051 */   // Label 94: @2051
     /* 2051 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(2079), // Rule ID 103 //
     /* 2056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 2059 */     // MIs[0] Operand 2
     /* 2059 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2070 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (MOVSX_rr_32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32),
     /* 2073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2075 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078 */     // GIR_Coverage, 103,
     /* 2078 */     GIR_EraseRootFromParent_Done,
     /* 2079 */   // Label 95: @2079
     /* 2079 */   GIM_Reject,
     /* 2080 */ // Label 92: @2080
     /* 2080 */ GIM_Reject,
     /* 2081 */ // Label 88: @2081
     /* 2081 */ GIM_Reject,
     /* 2082 */ // Label 16: @2082
     /* 2082 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(2108), // Rule ID 236 //
     /* 2087 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2101 */   // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src)
     /* 2101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 2106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2107 */   // GIR_Coverage, 236,
     /* 2107 */   GIR_Done,
     /* 2108 */ // Label 96: @2108
     /* 2108 */ GIM_Reject,
     /* 2109 */ // Label 17: @2109
     /* 2109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 99*/ GIMT_Encode4(2174),
     /* 2120 */ /*GILLT_s32*//*Label 97*/ GIMT_Encode4(2128),
     /* 2124 */ /*GILLT_s64*//*Label 98*/ GIMT_Encode4(2151),
     /* 2128 */ // Label 97: @2128
     /* 2128 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(2150), // Rule ID 62 //
     /* 2133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2143 */   // (shl:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SLL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SLL_rr_32),
     /* 2148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2149 */   // GIR_Coverage, 62,
     /* 2149 */   GIR_Done,
     /* 2150 */ // Label 100: @2150
     /* 2150 */ GIM_Reject,
     /* 2151 */ // Label 98: @2151
     /* 2151 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2173), // Rule ID 60 //
     /* 2156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2166 */   // (shl:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SLL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SLL_rr),
     /* 2171 */   GIR_RootConstrainSelectedInstOperands,
     /* 2172 */   // GIR_Coverage, 60,
     /* 2172 */   GIR_Done,
     /* 2173 */ // Label 101: @2173
     /* 2173 */ GIM_Reject,
     /* 2174 */ // Label 99: @2174
     /* 2174 */ GIM_Reject,
     /* 2175 */ // Label 18: @2175
     /* 2175 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 104*/ GIMT_Encode4(2498),
     /* 2186 */ /*GILLT_s32*//*Label 102*/ GIMT_Encode4(2194),
     /* 2190 */ /*GILLT_s64*//*Label 103*/ GIMT_Encode4(2217),
     /* 2194 */ // Label 102: @2194
     /* 2194 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2216), // Rule ID 66 //
     /* 2199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2209 */   // (srl:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SRL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRL_rr_32),
     /* 2214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215 */   // GIR_Coverage, 66,
     /* 2215 */   GIR_Done,
     /* 2216 */ // Label 105: @2216
     /* 2216 */ GIM_Reject,
     /* 2217 */ // Label 103: @2217
     /* 2217 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2497),
     /* 2222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2232 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2274), // Rule ID 139 //
     /* 2237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2263 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (BSWAP16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BSWAP16),
     /* 2266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273 */     // GIR_Coverage, 139,
     /* 2273 */     GIR_EraseRootFromParent_Done,
     /* 2274 */   // Label 107: @2274
     /* 2274 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2316), // Rule ID 140 //
     /* 2279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (BSWAP32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BSWAP32),
     /* 2308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315 */     // GIR_Coverage, 140,
     /* 2315 */     GIR_EraseRootFromParent_Done,
     /* 2316 */   // Label 108: @2316
     /* 2316 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(2358), // Rule ID 142 //
     /* 2321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2347 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (BE16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BE16),
     /* 2350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357 */     // GIR_Coverage, 142,
     /* 2357 */     GIR_EraseRootFromParent_Done,
     /* 2358 */   // Label 109: @2358
     /* 2358 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(2400), // Rule ID 143 //
     /* 2363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2389 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (BE32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BE32),
     /* 2392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399 */     // GIR_Coverage, 143,
     /* 2399 */     GIR_EraseRootFromParent_Done,
     /* 2400 */   // Label 110: @2400
     /* 2400 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(2442), // Rule ID 145 //
     /* 2405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (LE16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LE16),
     /* 2434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441 */     // GIR_Coverage, 145,
     /* 2441 */     GIR_EraseRootFromParent_Done,
     /* 2442 */   // Label 111: @2442
     /* 2442 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(2484), // Rule ID 146 //
     /* 2447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2473 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (LE32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LE32),
     /* 2476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2483 */     // GIR_Coverage, 146,
     /* 2483 */     GIR_EraseRootFromParent_Done,
     /* 2484 */   // Label 112: @2484
     /* 2484 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(2496), // Rule ID 64 //
     /* 2489 */     // (srl:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SRL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRL_rr),
     /* 2494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2495 */     // GIR_Coverage, 64,
     /* 2495 */     GIR_Done,
     /* 2496 */   // Label 113: @2496
     /* 2496 */   GIM_Reject,
     /* 2497 */ // Label 106: @2497
     /* 2497 */ GIM_Reject,
     /* 2498 */ // Label 104: @2498
     /* 2498 */ GIM_Reject,
     /* 2499 */ // Label 19: @2499
     /* 2499 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 116*/ GIMT_Encode4(2564),
     /* 2510 */ /*GILLT_s32*//*Label 114*/ GIMT_Encode4(2518),
     /* 2514 */ /*GILLT_s64*//*Label 115*/ GIMT_Encode4(2541),
     /* 2518 */ // Label 114: @2518
     /* 2518 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2540), // Rule ID 74 //
     /* 2523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2533 */   // (sra:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SRA_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRA_rr_32),
     /* 2538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2539 */   // GIR_Coverage, 74,
     /* 2539 */   GIR_Done,
     /* 2540 */ // Label 117: @2540
     /* 2540 */ GIM_Reject,
     /* 2541 */ // Label 115: @2541
     /* 2541 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2563), // Rule ID 72 //
     /* 2546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2556 */   // (sra:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SRA_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRA_rr),
     /* 2561 */   GIR_RootConstrainSelectedInstOperands,
     /* 2562 */   // GIR_Coverage, 72,
     /* 2562 */   GIR_Done,
     /* 2563 */ // Label 118: @2563
     /* 2563 */ GIM_Reject,
     /* 2564 */ // Label 116: @2564
     /* 2564 */ GIM_Reject,
     /* 2565 */ // Label 20: @2565
     /* 2565 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2580), // Rule ID 123 //
     /* 2570 */   // MIs[0] BrDst
     /* 2570 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2573 */   // (br (bb:{ *:[Other] }):$BrDst)  =>  (JMP (bb:{ *:[Other] }):$BrDst)
     /* 2573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::JMP),
     /* 2578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2579 */   // GIR_Coverage, 123,
     /* 2579 */   GIR_Done,
     /* 2580 */ // Label 119: @2580
     /* 2580 */ GIM_Reject,
     /* 2581 */ // Label 21: @2581
     /* 2581 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2646),
     /* 2586 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2600 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2615), // Rule ID 141 //
     /* 2605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2608 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (BSWAP64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::BSWAP64),
     /* 2613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2614 */     // GIR_Coverage, 141,
     /* 2614 */     GIR_Done,
     /* 2615 */   // Label 121: @2615
     /* 2615 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2630), // Rule ID 144 //
     /* 2620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2623 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (BE64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::BE64),
     /* 2628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2629 */     // GIR_Coverage, 144,
     /* 2629 */     GIR_Done,
     /* 2630 */   // Label 122: @2630
     /* 2630 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2645), // Rule ID 147 //
     /* 2635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2638 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (LE64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::LE64),
     /* 2643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2644 */     // GIR_Coverage, 147,
     /* 2644 */     GIR_Done,
     /* 2645 */   // Label 123: @2645
     /* 2645 */   GIM_Reject,
     /* 2646 */ // Label 120: @2646
     /* 2646 */ GIM_Reject,
     /* 2647 */ // Label 22: @2647
     /* 2647 */ GIM_Reject,
     /* 2648 */ }; // Size: 2648 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const BPFSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const BPFSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
