/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* RISCVPostLegalizerCombinerImpl Combiner Match Table                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct RISCVPostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 10:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 10;	 // "i2p_to_p2i"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 9;	 // "p2i_to_i2p"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_to_add", 9) != 0)
        break;
      return 0;	 // "sub_to_add"
    }
    break;
  case 11:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "add_sub_reg", 11) != 0)
      break;
    return 15;	 // "add_sub_reg"
  case 13:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 2;	 // "load_and_mask"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 3;	 // "redundant_and"
    }
    break;
  case 14:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_same_val", 13) != 0)
        break;
      return 6;	 // "binop_same_val"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_fneg_fold", 13) != 0)
        break;
      return 12;	 // "fneg_fneg_fold"
    }
    break;
  case 15:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 1;	 // "extending_loads"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 4;	 // "select_same_val"
    }
    break;
  case 17:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_trunc_fold", 16) != 0)
        break;
      return 11;	 // "anyext_trunc_fold"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_immed_chain", 16) != 0)
        break;
      return 23;	 // "shift_immed_chain"
    }
    break;
  case 18:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 7;	 // "binop_left_to_zero"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 20;	 // "fptrunc_fpext_fold"
    }
    break;
  case 19:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 8;	 // "binop_right_to_zero"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_zero", 18) != 0)
        break;
      return 5;	 // "right_identity_zero"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "implify_neg_minmax", 18) != 0)
        break;
      return 26;	 // "simplify_neg_minmax"
    }
    break;
  case 20:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "bitcast_bitcast_fold", 20) != 0)
      break;
    return 19;	 // "bitcast_bitcast_fold"
  case 21:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "right_identity_one_fp", 21) != 0)
      break;
    return 14;	 // "right_identity_one_fp"
  case 22:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_int", 21) != 0)
        break;
      return 13;	 // "right_identity_one_int"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 17;	 // "trunc_buildvector_fold"
    }
    break;
  case 25:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_identity_fold", 24) != 0)
        break;
      return 16;	 // "buildvector_identity_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 22;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 25;	 // "commute_fp_constant_to_rhs"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 21;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_int_constant_to_rhs", 26) != 0)
        break;
      return 24;	 // "commute_int_constant_to_rhs"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 18;	 // "trunc_lshr_buildvector_fold"
    }
    break;
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 27}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool RISCVPostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool RISCVPostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> RISCVPostLegalizerCombinerOption;
static cl::list<std::string> RISCVPostLegalizerCombinerDisableOption(
    "riscvpostlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the RISCVPostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      RISCVPostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> RISCVPostLegalizerCombinerOnlyEnableOption(
    "riscvpostlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the RISCVPostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      RISCVPostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        RISCVPostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool RISCVPostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool RISCVPostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : RISCVPostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVPostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVPostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVPostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVPostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset RISCVPostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void RISCVPostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVPostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

RISCVPostLegalizerCombinerImpl::ComplexMatcherMemFn
RISCVPostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
};
bool RISCVPostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
};

bool RISCVPostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
RISCVPostLegalizerCombinerImpl::CustomRendererFn
RISCVPostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool RISCVPostLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
};
bool RISCVPostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVPostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(230), /*)*//*default:*//*Label 55*/ GIMT_Encode4(1938),
     /*   10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(718),
     /*   14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(821),
     /*   18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(877),
     /*   22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(935),
     /*   26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(947),
     /*   30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(959),
     /*   34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(971), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(983),
     /*   50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(1041),
     /*   54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(1100), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 10*/ GIMT_Encode4(1135),
     /*  110 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 11*/ GIMT_Encode4(1147), GIMT_Encode4(0),
     /*  118 */ /*TargetOpcode::G_PTRTOINT*//*Label 12*/ GIMT_Encode4(1159),
     /*  122 */ /*TargetOpcode::G_INTTOPTR*//*Label 13*/ GIMT_Encode4(1181),
     /*  126 */ /*TargetOpcode::G_BITCAST*//*Label 14*/ GIMT_Encode4(1193), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  170 */ /*TargetOpcode::G_LOAD*//*Label 15*/ GIMT_Encode4(1215),
     /*  174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 16*/ GIMT_Encode4(1227),
     /*  178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 17*/ GIMT_Encode4(1239), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  330 */ /*TargetOpcode::G_ANYEXT*//*Label 18*/ GIMT_Encode4(1251),
     /*  334 */ /*TargetOpcode::G_TRUNC*//*Label 19*/ GIMT_Encode4(1263), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  366 */ /*TargetOpcode::G_SHL*//*Label 20*/ GIMT_Encode4(1286),
     /*  370 */ /*TargetOpcode::G_LSHR*//*Label 21*/ GIMT_Encode4(1332),
     /*  374 */ /*TargetOpcode::G_ASHR*//*Label 22*/ GIMT_Encode4(1378), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  386 */ /*TargetOpcode::G_ROTR*//*Label 23*/ GIMT_Encode4(1424),
     /*  390 */ /*TargetOpcode::G_ROTL*//*Label 24*/ GIMT_Encode4(1448), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  410 */ /*TargetOpcode::G_SELECT*//*Label 25*/ GIMT_Encode4(1472),
     /*  414 */ /*TargetOpcode::G_UADDO*//*Label 26*/ GIMT_Encode4(1484), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  430 */ /*TargetOpcode::G_SADDO*//*Label 27*/ GIMT_Encode4(1496), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  446 */ /*TargetOpcode::G_UMULO*//*Label 28*/ GIMT_Encode4(1508),
     /*  450 */ /*TargetOpcode::G_SMULO*//*Label 29*/ GIMT_Encode4(1520),
     /*  454 */ /*TargetOpcode::G_UMULH*//*Label 30*/ GIMT_Encode4(1532),
     /*  458 */ /*TargetOpcode::G_SMULH*//*Label 31*/ GIMT_Encode4(1544),
     /*  462 */ /*TargetOpcode::G_UADDSAT*//*Label 32*/ GIMT_Encode4(1556),
     /*  466 */ /*TargetOpcode::G_SADDSAT*//*Label 33*/ GIMT_Encode4(1568), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  478 */ /*TargetOpcode::G_USHLSAT*//*Label 34*/ GIMT_Encode4(1580),
     /*  482 */ /*TargetOpcode::G_SSHLSAT*//*Label 35*/ GIMT_Encode4(1592),
     /*  486 */ /*TargetOpcode::G_SMULFIX*//*Label 36*/ GIMT_Encode4(1604),
     /*  490 */ /*TargetOpcode::G_UMULFIX*//*Label 37*/ GIMT_Encode4(1616),
     /*  494 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 38*/ GIMT_Encode4(1628),
     /*  498 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 39*/ GIMT_Encode4(1640), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  518 */ /*TargetOpcode::G_FADD*//*Label 40*/ GIMT_Encode4(1652), GIMT_Encode4(0),
     /*  526 */ /*TargetOpcode::G_FMUL*//*Label 41*/ GIMT_Encode4(1687), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  586 */ /*TargetOpcode::G_FNEG*//*Label 42*/ GIMT_Encode4(1742), GIMT_Encode4(0),
     /*  594 */ /*TargetOpcode::G_FPTRUNC*//*Label 43*/ GIMT_Encode4(1772), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  638 */ /*TargetOpcode::G_FMINNUM*//*Label 44*/ GIMT_Encode4(1794),
     /*  642 */ /*TargetOpcode::G_FMAXNUM*//*Label 45*/ GIMT_Encode4(1806),
     /*  646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 46*/ GIMT_Encode4(1818),
     /*  650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 47*/ GIMT_Encode4(1830),
     /*  654 */ /*TargetOpcode::G_FMINIMUM*//*Label 48*/ GIMT_Encode4(1842),
     /*  658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 49*/ GIMT_Encode4(1854), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  694 */ /*TargetOpcode::G_PTR_ADD*//*Label 50*/ GIMT_Encode4(1866), GIMT_Encode4(0),
     /*  702 */ /*TargetOpcode::G_SMIN*//*Label 51*/ GIMT_Encode4(1890),
     /*  706 */ /*TargetOpcode::G_SMAX*//*Label 52*/ GIMT_Encode4(1902),
     /*  710 */ /*TargetOpcode::G_UMIN*//*Label 53*/ GIMT_Encode4(1914),
     /*  714 */ /*TargetOpcode::G_UMAX*//*Label 54*/ GIMT_Encode4(1926),
     /*  718 */ // Label 0: @718
     /*  718 */ GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(729), // Rule ID 48 //
     /*  723 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /*  726 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /*  726 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /*  729 */ // Label 56: @729
     /*  729 */ GIM_Try, /*On fail goto*//*Label 57*/ GIMT_Encode4(763), // Rule ID 34 //
     /*  734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /*  737 */   // MIs[0] dst
     /*  737 */   // No operand predicates
     /*  737 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  737 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  745 */   // MIs[1] src
     /*  745 */   // No operand predicates
     /*  745 */   // MIs[1] __add_sub_reg_match_0.x
     /*  745 */   // No operand predicates
     /*  745 */   // MIs[0] __add_sub_reg_match_0.x
     /*  745 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  750 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  755 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  757 */   // Combiner Rule #15: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /*  757 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  762 */   GIR_EraseRootFromParent_Done,
     /*  763 */ // Label 57: @763
     /*  763 */ GIM_Try, /*On fail goto*//*Label 58*/ GIMT_Encode4(797), // Rule ID 33 //
     /*  768 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /*  771 */   // MIs[0] dst
     /*  771 */   // No operand predicates
     /*  771 */   // MIs[0] __add_sub_reg_match_0.x
     /*  771 */   // No operand predicates
     /*  771 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  771 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  779 */   // MIs[1] src
     /*  779 */   // No operand predicates
     /*  779 */   // MIs[1] __add_sub_reg_match_0.x
     /*  779 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  784 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  791 */   // Combiner Rule #15: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /*  791 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  796 */   GIR_EraseRootFromParent_Done,
     /*  797 */ // Label 58: @797
     /*  797 */ GIM_Try, /*On fail goto*//*Label 59*/ GIMT_Encode4(820), // Rule ID 8 //
     /*  802 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /*  805 */   // MIs[0] dst
     /*  805 */   // No operand predicates
     /*  805 */   // MIs[0] lhs
     /*  805 */   // No operand predicates
     /*  805 */   // MIs[0] Operand 2
     /*  805 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  809 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  814 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /*  814 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  819 */   GIR_EraseRootFromParent_Done,
     /*  820 */ // Label 59: @820
     /*  820 */ GIM_Reject,
     /*  821 */ // Label 1: @821
     /*  821 */ GIM_Try, /*On fail goto*//*Label 60*/ GIMT_Encode4(832), // Rule ID 77 //
     /*  826 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /*  829 */   // Combiner Rule #26: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /*  829 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /*  832 */ // Label 60: @832
     /*  832 */ GIM_Try, /*On fail goto*//*Label 61*/ GIMT_Encode4(855), // Rule ID 7 //
     /*  837 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /*  840 */   // MIs[0] dst
     /*  840 */   // No operand predicates
     /*  840 */   // MIs[0] lhs
     /*  840 */   // No operand predicates
     /*  840 */   // MIs[0] Operand 2
     /*  840 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  844 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  849 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /*  849 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  854 */   GIR_EraseRootFromParent_Done,
     /*  855 */ // Label 61: @855
     /*  855 */ GIM_Try, /*On fail goto*//*Label 62*/ GIMT_Encode4(876), // Rule ID 0 //
     /*  860 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /*  863 */   // MIs[0] d
     /*  863 */   // No operand predicates
     /*  863 */   // MIs[0] op1
     /*  863 */   // No operand predicates
     /*  863 */   // MIs[0] c
     /*  863 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  871 */   // MIs[1] imm
     /*  871 */   // No operand predicates
     /*  871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  873 */   // Combiner Rule #0: sub_to_add
     /*  873 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /*  876 */ // Label 62: @876
     /*  876 */ GIM_Reject,
     /*  877 */ // Label 2: @877
     /*  877 */ GIM_Try, /*On fail goto*//*Label 63*/ GIMT_Encode4(888), // Rule ID 49 //
     /*  882 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /*  885 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /*  885 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /*  888 */ // Label 63: @888
     /*  888 */ GIM_Try, /*On fail goto*//*Label 64*/ GIMT_Encode4(911), // Rule ID 26 //
     /*  893 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /*  896 */   // MIs[0] dst
     /*  896 */   // No operand predicates
     /*  896 */   // MIs[0] lhs
     /*  896 */   // No operand predicates
     /*  896 */   // MIs[0] zero
     /*  896 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  900 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /*  905 */   // Combiner Rule #8: binop_right_to_zero
     /*  905 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /*  910 */   GIR_EraseRootFromParent_Done,
     /*  911 */ // Label 64: @911
     /*  911 */ GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(934), // Rule ID 31 //
     /*  916 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /*  919 */   // MIs[0] dst
     /*  919 */   // No operand predicates
     /*  919 */   // MIs[0] x
     /*  919 */   // No operand predicates
     /*  919 */   // MIs[0] Operand 2
     /*  919 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  923 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  928 */   // Combiner Rule #13: right_identity_one_int
     /*  928 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  933 */   GIR_EraseRootFromParent_Done,
     /*  934 */ // Label 65: @934
     /*  934 */ GIM_Reject,
     /*  935 */ // Label 3: @935
     /*  935 */ GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(946), // Rule ID 22 //
     /*  940 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  943 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /*  943 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  946 */ // Label 66: @946
     /*  946 */ GIM_Reject,
     /*  947 */ // Label 4: @947
     /*  947 */ GIM_Try, /*On fail goto*//*Label 67*/ GIMT_Encode4(958), // Rule ID 23 //
     /*  952 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  955 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /*  955 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  958 */ // Label 67: @958
     /*  958 */ GIM_Reject,
     /*  959 */ // Label 5: @959
     /*  959 */ GIM_Try, /*On fail goto*//*Label 68*/ GIMT_Encode4(970), // Rule ID 24 //
     /*  964 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  967 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /*  967 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  970 */ // Label 68: @970
     /*  970 */ GIM_Reject,
     /*  971 */ // Label 6: @971
     /*  971 */ GIM_Try, /*On fail goto*//*Label 69*/ GIMT_Encode4(982), // Rule ID 25 //
     /*  976 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  979 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /*  979 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  982 */ // Label 69: @982
     /*  982 */ GIM_Reject,
     /*  983 */ // Label 7: @983
     /*  983 */ GIM_Try, /*On fail goto*//*Label 70*/ GIMT_Encode4(994), // Rule ID 4 //
     /*  988 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /*  991 */   // Combiner Rule #2: load_and_mask; wip_match_opcode 'G_AND'
     /*  991 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /*  994 */ // Label 70: @994
     /*  994 */ GIM_Try, /*On fail goto*//*Label 71*/ GIMT_Encode4(1005), // Rule ID 5 //
     /*  999 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1002 */   // Combiner Rule #3: redundant_and; wip_match_opcode 'G_AND'
     /* 1002 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1005 */ // Label 71: @1005
     /* 1005 */ GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1016), // Rule ID 50 //
     /* 1010 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1013 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 1013 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1016 */ // Label 72: @1016
     /* 1016 */ GIM_Try, /*On fail goto*//*Label 73*/ GIMT_Encode4(1040), // Rule ID 17 //
     /* 1021 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1024 */   // MIs[0] dst
     /* 1024 */   // No operand predicates
     /* 1024 */   // MIs[0] src
     /* 1024 */   // No operand predicates
     /* 1024 */   // MIs[0] src
     /* 1024 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1029 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1034 */   // Combiner Rule #6: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 1034 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1039 */   GIR_EraseRootFromParent_Done,
     /* 1040 */ // Label 73: @1040
     /* 1040 */ GIM_Reject,
     /* 1041 */ // Label 8: @1041
     /* 1041 */ GIM_Try, /*On fail goto*//*Label 74*/ GIMT_Encode4(1052), // Rule ID 51 //
     /* 1046 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1049 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 1049 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1052 */ // Label 74: @1052
     /* 1052 */ GIM_Try, /*On fail goto*//*Label 75*/ GIMT_Encode4(1076), // Rule ID 18 //
     /* 1057 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1060 */   // MIs[0] dst
     /* 1060 */   // No operand predicates
     /* 1060 */   // MIs[0] src
     /* 1060 */   // No operand predicates
     /* 1060 */   // MIs[0] src
     /* 1060 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1065 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1070 */   // Combiner Rule #6: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 1070 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1075 */   GIR_EraseRootFromParent_Done,
     /* 1076 */ // Label 75: @1076
     /* 1076 */ GIM_Try, /*On fail goto*//*Label 76*/ GIMT_Encode4(1099), // Rule ID 9 //
     /* 1081 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1084 */   // MIs[0] dst
     /* 1084 */   // No operand predicates
     /* 1084 */   // MIs[0] lhs
     /* 1084 */   // No operand predicates
     /* 1084 */   // MIs[0] Operand 2
     /* 1084 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1088 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1093 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 1093 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1098 */   GIR_EraseRootFromParent_Done,
     /* 1099 */ // Label 76: @1099
     /* 1099 */ GIM_Reject,
     /* 1100 */ // Label 9: @1100
     /* 1100 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(1111), // Rule ID 52 //
     /* 1105 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1108 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 1108 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1111 */ // Label 77: @1111
     /* 1111 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(1134), // Rule ID 10 //
     /* 1116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1119 */   // MIs[0] dst
     /* 1119 */   // No operand predicates
     /* 1119 */   // MIs[0] lhs
     /* 1119 */   // No operand predicates
     /* 1119 */   // MIs[0] Operand 2
     /* 1119 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1123 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1128 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 1128 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1133 */   GIR_EraseRootFromParent_Done,
     /* 1134 */ // Label 78: @1134
     /* 1134 */ GIM_Reject,
     /* 1135 */ // Label 10: @1135
     /* 1135 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(1146), // Rule ID 36 //
     /* 1140 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1143 */   // Combiner Rule #16: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1143 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 1146 */ // Label 79: @1146
     /* 1146 */ GIM_Reject,
     /* 1147 */ // Label 11: @1147
     /* 1147 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(1158), // Rule ID 35 //
     /* 1152 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1155 */   // Combiner Rule #16: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 1155 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 1158 */ // Label 80: @1158
     /* 1158 */ GIM_Reject,
     /* 1159 */ // Label 12: @1159
     /* 1159 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1180), // Rule ID 28 //
     /* 1164 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1167 */   // MIs[0] dst
     /* 1167 */   // No operand predicates
     /* 1167 */   // MIs[0] t
     /* 1167 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 1175 */   // MIs[1] ptr
     /* 1175 */   // No operand predicates
     /* 1175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1177 */   // Combiner Rule #10: i2p_to_p2i
     /* 1177 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1180 */ // Label 81: @1180
     /* 1180 */ GIM_Reject,
     /* 1181 */ // Label 13: @1181
     /* 1181 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1192), // Rule ID 27 //
     /* 1186 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1189 */   // Combiner Rule #9: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 1189 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 1192 */ // Label 82: @1192
     /* 1192 */ GIM_Reject,
     /* 1193 */ // Label 14: @1193
     /* 1193 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1214), // Rule ID 39 //
     /* 1198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1201 */   // MIs[0] dst
     /* 1201 */   // No operand predicates
     /* 1201 */   // MIs[0] src1
     /* 1201 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 1209 */   // MIs[1] src0
     /* 1209 */   // No operand predicates
     /* 1209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1211 */   // Combiner Rule #19: bitcast_bitcast_fold
     /* 1211 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1214 */ // Label 83: @1214
     /* 1214 */ GIM_Reject,
     /* 1215 */ // Label 15: @1215
     /* 1215 */ GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1226), // Rule ID 1 //
     /* 1220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1223 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_LOAD'
     /* 1223 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1226 */ // Label 84: @1226
     /* 1226 */ GIM_Reject,
     /* 1227 */ // Label 16: @1227
     /* 1227 */ GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1238), // Rule ID 2 //
     /* 1232 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1235 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 1235 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1238 */ // Label 85: @1238
     /* 1238 */ GIM_Reject,
     /* 1239 */ // Label 17: @1239
     /* 1239 */ GIM_Try, /*On fail goto*//*Label 86*/ GIMT_Encode4(1250), // Rule ID 3 //
     /* 1244 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1247 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 1247 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1250 */ // Label 86: @1250
     /* 1250 */ GIM_Reject,
     /* 1251 */ // Label 18: @1251
     /* 1251 */ GIM_Try, /*On fail goto*//*Label 87*/ GIMT_Encode4(1262), // Rule ID 29 //
     /* 1256 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1259 */   // Combiner Rule #11: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 1259 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1262 */ // Label 87: @1262
     /* 1262 */ GIM_Reject,
     /* 1263 */ // Label 19: @1263
     /* 1263 */ GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1274), // Rule ID 37 //
     /* 1268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1271 */   // Combiner Rule #17: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 1271 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 1274 */ // Label 88: @1274
     /* 1274 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1285), // Rule ID 38 //
     /* 1279 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 1282 */   // Combiner Rule #18: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 1282 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1285 */ // Label 89: @1285
     /* 1285 */ GIM_Reject,
     /* 1286 */ // Label 20: @1286
     /* 1286 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1297), // Rule ID 19 //
     /* 1291 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1294 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 1294 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1297 */ // Label 90: @1297
     /* 1297 */ GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1308), // Rule ID 43 //
     /* 1302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1305 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 1305 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1308 */ // Label 91: @1308
     /* 1308 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1331), // Rule ID 11 //
     /* 1313 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1316 */   // MIs[0] dst
     /* 1316 */   // No operand predicates
     /* 1316 */   // MIs[0] lhs
     /* 1316 */   // No operand predicates
     /* 1316 */   // MIs[0] Operand 2
     /* 1316 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1320 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1325 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 1325 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1330 */   GIR_EraseRootFromParent_Done,
     /* 1331 */ // Label 92: @1331
     /* 1331 */ GIM_Reject,
     /* 1332 */ // Label 21: @1332
     /* 1332 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1343), // Rule ID 20 //
     /* 1337 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1340 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 1340 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1343 */ // Label 93: @1343
     /* 1343 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1354), // Rule ID 45 //
     /* 1348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1351 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 1351 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1354 */ // Label 94: @1354
     /* 1354 */ GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1377), // Rule ID 13 //
     /* 1359 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1362 */   // MIs[0] dst
     /* 1362 */   // No operand predicates
     /* 1362 */   // MIs[0] lhs
     /* 1362 */   // No operand predicates
     /* 1362 */   // MIs[0] Operand 2
     /* 1362 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1366 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1371 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 1371 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1376 */   GIR_EraseRootFromParent_Done,
     /* 1377 */ // Label 95: @1377
     /* 1377 */ GIM_Reject,
     /* 1378 */ // Label 22: @1378
     /* 1378 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1389), // Rule ID 21 //
     /* 1383 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1386 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 1386 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1389 */ // Label 96: @1389
     /* 1389 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1400), // Rule ID 44 //
     /* 1394 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1397 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 1397 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1400 */ // Label 97: @1400
     /* 1400 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1423), // Rule ID 12 //
     /* 1405 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1408 */   // MIs[0] dst
     /* 1408 */   // No operand predicates
     /* 1408 */   // MIs[0] lhs
     /* 1408 */   // No operand predicates
     /* 1408 */   // MIs[0] Operand 2
     /* 1408 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1412 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1417 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 1417 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1422 */   GIR_EraseRootFromParent_Done,
     /* 1423 */ // Label 98: @1423
     /* 1423 */ GIM_Reject,
     /* 1424 */ // Label 23: @1424
     /* 1424 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1447), // Rule ID 16 //
     /* 1429 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1432 */   // MIs[0] dst
     /* 1432 */   // No operand predicates
     /* 1432 */   // MIs[0] lhs
     /* 1432 */   // No operand predicates
     /* 1432 */   // MIs[0] Operand 2
     /* 1432 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1436 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1441 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 1441 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1446 */   GIR_EraseRootFromParent_Done,
     /* 1447 */ // Label 99: @1447
     /* 1447 */ GIM_Reject,
     /* 1448 */ // Label 24: @1448
     /* 1448 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1471), // Rule ID 15 //
     /* 1453 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1456 */   // MIs[0] dst
     /* 1456 */   // No operand predicates
     /* 1456 */   // MIs[0] lhs
     /* 1456 */   // No operand predicates
     /* 1456 */   // MIs[0] Operand 2
     /* 1456 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1460 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1465 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 1465 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1470 */   GIR_EraseRootFromParent_Done,
     /* 1471 */ // Label 100: @1471
     /* 1471 */ GIM_Reject,
     /* 1472 */ // Label 25: @1472
     /* 1472 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1483), // Rule ID 6 //
     /* 1477 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1480 */   // Combiner Rule #4: select_same_val; wip_match_opcode 'G_SELECT'
     /* 1480 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1483 */ // Label 101: @1483
     /* 1483 */ GIM_Reject,
     /* 1484 */ // Label 26: @1484
     /* 1484 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1495), // Rule ID 57 //
     /* 1489 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1492 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 1492 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1495 */ // Label 102: @1495
     /* 1495 */ GIM_Reject,
     /* 1496 */ // Label 27: @1496
     /* 1496 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1507), // Rule ID 58 //
     /* 1501 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1504 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 1504 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1507 */ // Label 103: @1507
     /* 1507 */ GIM_Reject,
     /* 1508 */ // Label 28: @1508
     /* 1508 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1519), // Rule ID 59 //
     /* 1513 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1516 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 1516 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1519 */ // Label 104: @1519
     /* 1519 */ GIM_Reject,
     /* 1520 */ // Label 29: @1520
     /* 1520 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1531), // Rule ID 60 //
     /* 1525 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1528 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 1528 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1531 */ // Label 105: @1531
     /* 1531 */ GIM_Reject,
     /* 1532 */ // Label 30: @1532
     /* 1532 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1543), // Rule ID 61 //
     /* 1537 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1540 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 1540 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1543 */ // Label 106: @1543
     /* 1543 */ GIM_Reject,
     /* 1544 */ // Label 31: @1544
     /* 1544 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1555), // Rule ID 62 //
     /* 1549 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1552 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 1552 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1555 */ // Label 107: @1555
     /* 1555 */ GIM_Reject,
     /* 1556 */ // Label 32: @1556
     /* 1556 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1567), // Rule ID 63 //
     /* 1561 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1564 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 1564 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1567 */ // Label 108: @1567
     /* 1567 */ GIM_Reject,
     /* 1568 */ // Label 33: @1568
     /* 1568 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1579), // Rule ID 64 //
     /* 1573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1576 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 1576 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1579 */ // Label 109: @1579
     /* 1579 */ GIM_Reject,
     /* 1580 */ // Label 34: @1580
     /* 1580 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1591), // Rule ID 47 //
     /* 1585 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1588 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 1588 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1591 */ // Label 110: @1591
     /* 1591 */ GIM_Reject,
     /* 1592 */ // Label 35: @1592
     /* 1592 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1603), // Rule ID 46 //
     /* 1597 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1600 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 1600 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1603 */ // Label 111: @1603
     /* 1603 */ GIM_Reject,
     /* 1604 */ // Label 36: @1604
     /* 1604 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1615), // Rule ID 65 //
     /* 1609 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1612 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 1612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1615 */ // Label 112: @1615
     /* 1615 */ GIM_Reject,
     /* 1616 */ // Label 37: @1616
     /* 1616 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1627), // Rule ID 66 //
     /* 1621 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1624 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 1624 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1627 */ // Label 113: @1627
     /* 1627 */ GIM_Reject,
     /* 1628 */ // Label 38: @1628
     /* 1628 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1639), // Rule ID 67 //
     /* 1633 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1636 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 1636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1639 */ // Label 114: @1639
     /* 1639 */ GIM_Reject,
     /* 1640 */ // Label 39: @1640
     /* 1640 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1651), // Rule ID 68 //
     /* 1645 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1648 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 1648 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1651 */ // Label 115: @1651
     /* 1651 */ GIM_Reject,
     /* 1652 */ // Label 40: @1652
     /* 1652 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1663), // Rule ID 69 //
     /* 1657 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1660 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 1660 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1663 */ // Label 116: @1663
     /* 1663 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1686), // Rule ID 41 //
     /* 1668 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 1671 */   // MIs[0] dst
     /* 1671 */   // No operand predicates
     /* 1671 */   // MIs[0] x
     /* 1671 */   // No operand predicates
     /* 1671 */   // MIs[0] y
     /* 1671 */   // No operand predicates
     /* 1671 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 1675 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1680 */   // Combiner Rule #21: right_identity_neg_zero_fp
     /* 1680 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1685 */   GIR_EraseRootFromParent_Done,
     /* 1686 */ // Label 117: @1686
     /* 1686 */ GIM_Reject,
     /* 1687 */ // Label 41: @1687
     /* 1687 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1698), // Rule ID 70 //
     /* 1692 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1695 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 1695 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1698 */ // Label 118: @1698
     /* 1698 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1721), // Rule ID 32 //
     /* 1703 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 1706 */   // MIs[0] dst
     /* 1706 */   // No operand predicates
     /* 1706 */   // MIs[0] x
     /* 1706 */   // No operand predicates
     /* 1706 */   // MIs[0] y
     /* 1706 */   // No operand predicates
     /* 1706 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 1710 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1715 */   // Combiner Rule #14: right_identity_one_fp
     /* 1715 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1720 */   GIR_EraseRootFromParent_Done,
     /* 1721 */ // Label 119: @1721
     /* 1721 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1741), // Rule ID 42 //
     /* 1726 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 1729 */   // MIs[0] dst
     /* 1729 */   // No operand predicates
     /* 1729 */   // MIs[0] x
     /* 1729 */   // No operand predicates
     /* 1729 */   // MIs[0] y
     /* 1729 */   // No operand predicates
     /* 1729 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 1733 */   // Combiner Rule #22: right_identity_neg_one_fp
     /* 1733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 1736 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1738 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 1740 */   GIR_EraseRootFromParent_Done,
     /* 1741 */ // Label 120: @1741
     /* 1741 */ GIM_Reject,
     /* 1742 */ // Label 42: @1742
     /* 1742 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1771), // Rule ID 30 //
     /* 1747 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1750 */   // MIs[0] dst
     /* 1750 */   // No operand predicates
     /* 1750 */   // MIs[0] t
     /* 1750 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 1758 */   // MIs[1] src
     /* 1758 */   // No operand predicates
     /* 1758 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1763 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1765 */   // Combiner Rule #12: fneg_fneg_fold
     /* 1765 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1770 */   GIR_EraseRootFromParent_Done,
     /* 1771 */ // Label 121: @1771
     /* 1771 */ GIM_Reject,
     /* 1772 */ // Label 43: @1772
     /* 1772 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1793), // Rule ID 40 //
     /* 1777 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 1780 */   // MIs[0] dst
     /* 1780 */   // No operand predicates
     /* 1780 */   // MIs[0] src1
     /* 1780 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1784 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 1788 */   // MIs[1] src0
     /* 1788 */   // No operand predicates
     /* 1788 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1790 */   // Combiner Rule #20: fptrunc_fpext_fold
     /* 1790 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1793 */ // Label 122: @1793
     /* 1793 */ GIM_Reject,
     /* 1794 */ // Label 44: @1794
     /* 1794 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1805), // Rule ID 71 //
     /* 1799 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1802 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 1802 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1805 */ // Label 123: @1805
     /* 1805 */ GIM_Reject,
     /* 1806 */ // Label 45: @1806
     /* 1806 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1817), // Rule ID 72 //
     /* 1811 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1814 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 1814 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1817 */ // Label 124: @1817
     /* 1817 */ GIM_Reject,
     /* 1818 */ // Label 46: @1818
     /* 1818 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1829), // Rule ID 73 //
     /* 1823 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1826 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 1826 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1829 */ // Label 125: @1829
     /* 1829 */ GIM_Reject,
     /* 1830 */ // Label 47: @1830
     /* 1830 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1841), // Rule ID 74 //
     /* 1835 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1838 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 1838 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1841 */ // Label 126: @1841
     /* 1841 */ GIM_Reject,
     /* 1842 */ // Label 48: @1842
     /* 1842 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1853), // Rule ID 75 //
     /* 1847 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1850 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 1850 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1853 */ // Label 127: @1853
     /* 1853 */ GIM_Reject,
     /* 1854 */ // Label 49: @1854
     /* 1854 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1865), // Rule ID 76 //
     /* 1859 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1862 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 1862 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1865 */ // Label 128: @1865
     /* 1865 */ GIM_Reject,
     /* 1866 */ // Label 50: @1866
     /* 1866 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1889), // Rule ID 14 //
     /* 1871 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1874 */   // MIs[0] dst
     /* 1874 */   // No operand predicates
     /* 1874 */   // MIs[0] lhs
     /* 1874 */   // No operand predicates
     /* 1874 */   // MIs[0] Operand 2
     /* 1874 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1878 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1883 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 1883 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1888 */   GIR_EraseRootFromParent_Done,
     /* 1889 */ // Label 129: @1889
     /* 1889 */ GIM_Reject,
     /* 1890 */ // Label 51: @1890
     /* 1890 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1901), // Rule ID 53 //
     /* 1895 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1898 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 1898 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1901 */ // Label 130: @1901
     /* 1901 */ GIM_Reject,
     /* 1902 */ // Label 52: @1902
     /* 1902 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1913), // Rule ID 54 //
     /* 1907 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1910 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 1910 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1913 */ // Label 131: @1913
     /* 1913 */ GIM_Reject,
     /* 1914 */ // Label 53: @1914
     /* 1914 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1925), // Rule ID 55 //
     /* 1919 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1922 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 1922 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1925 */ // Label 132: @1925
     /* 1925 */ GIM_Reject,
     /* 1926 */ // Label 54: @1926
     /* 1926 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1937), // Rule ID 56 //
     /* 1931 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1934 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 1934 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1937 */ // Label 133: @1937
     /* 1937 */ GIM_Reject,
     /* 1938 */ // Label 55: @1938
     /* 1938 */ GIM_Reject,
     /* 1939 */ }; // Size: 1939 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

