/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_AMDGPUEMULATEATOMICSPASS
#define GEN_PASS_DECL_AMDGPURESOLVESTRIDEDMETADATAPASS
#define GEN_PASS_DECL_AMDGPUTRANSFERREADTOLOADPASS
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// AmdgpuEmulateAtomicsPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_AMDGPUEMULATEATOMICSPASS
struct AmdgpuEmulateAtomicsPassOptions {
  std::string chipset = "gfx000";
};
std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass();
std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass(AmdgpuEmulateAtomicsPassOptions options);
#undef GEN_PASS_DECL_AMDGPUEMULATEATOMICSPASS
#endif // GEN_PASS_DECL_AMDGPUEMULATEATOMICSPASS
#ifdef GEN_PASS_DEF_AMDGPUEMULATEATOMICSPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass();
} // namespace impl

namespace impl {
  std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass(AmdgpuEmulateAtomicsPassOptions options);
} // namespace impl
namespace impl {

template <typename DerivedT>
class AmdgpuEmulateAtomicsPassBase : public ::mlir::OperationPass<> {
public:
  using Base = AmdgpuEmulateAtomicsPassBase;

  AmdgpuEmulateAtomicsPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  AmdgpuEmulateAtomicsPassBase(const AmdgpuEmulateAtomicsPassBase &other) : ::mlir::OperationPass<>(other) {}
  AmdgpuEmulateAtomicsPassBase& operator=(const AmdgpuEmulateAtomicsPassBase &) = delete;
  AmdgpuEmulateAtomicsPassBase(AmdgpuEmulateAtomicsPassBase &&) = delete;
  AmdgpuEmulateAtomicsPassBase& operator=(AmdgpuEmulateAtomicsPassBase &&) = delete;
  ~AmdgpuEmulateAtomicsPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("amdgpu-emulate-atomics");
  }
  ::llvm::StringRef getArgument() const override { return "amdgpu-emulate-atomics"; }

  ::llvm::StringRef getDescription() const override { return "Emulate atomic operations on chipsets that do not support them"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AmdgpuEmulateAtomicsPass");
  }
  ::llvm::StringRef getName() const override { return "AmdgpuEmulateAtomicsPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<cf::ControlFlowDialect>();
    registry.insert<arith::ArithDialect>();
    registry.insert<vector::VectorDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AmdgpuEmulateAtomicsPassBase<DerivedT>)

  AmdgpuEmulateAtomicsPassBase(AmdgpuEmulateAtomicsPassOptions options) : AmdgpuEmulateAtomicsPassBase() {
    chipset = std::move(options.chipset);
  }
protected:
  ::mlir::Pass::Option<std::string> chipset{*this, "chipset", ::llvm::cl::desc("Chipset that these operations will run on"), ::llvm::cl::init("gfx000")};
private:

  friend std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass() {
    return std::make_unique<DerivedT>();
  }

  friend std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass(AmdgpuEmulateAtomicsPassOptions options) {
    return std::make_unique<DerivedT>(std::move(options));
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass() {
  return impl::createAmdgpuEmulateAtomicsPass();
}

std::unique_ptr<::mlir::Pass> createAmdgpuEmulateAtomicsPass(AmdgpuEmulateAtomicsPassOptions options) {
  return impl::createAmdgpuEmulateAtomicsPass(std::move(options));
}
#undef GEN_PASS_DEF_AMDGPUEMULATEATOMICSPASS
#endif // GEN_PASS_DEF_AMDGPUEMULATEATOMICSPASS

//===----------------------------------------------------------------------===//
// AmdgpuResolveStridedMetadataPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_AMDGPURESOLVESTRIDEDMETADATAPASS
std::unique_ptr<::mlir::Pass> createAmdgpuResolveStridedMetadataPass();
#undef GEN_PASS_DECL_AMDGPURESOLVESTRIDEDMETADATAPASS
#endif // GEN_PASS_DECL_AMDGPURESOLVESTRIDEDMETADATAPASS
#ifdef GEN_PASS_DEF_AMDGPURESOLVESTRIDEDMETADATAPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createAmdgpuResolveStridedMetadataPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class AmdgpuResolveStridedMetadataPassBase : public ::mlir::OperationPass<> {
public:
  using Base = AmdgpuResolveStridedMetadataPassBase;

  AmdgpuResolveStridedMetadataPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  AmdgpuResolveStridedMetadataPassBase(const AmdgpuResolveStridedMetadataPassBase &other) : ::mlir::OperationPass<>(other) {}
  AmdgpuResolveStridedMetadataPassBase& operator=(const AmdgpuResolveStridedMetadataPassBase &) = delete;
  AmdgpuResolveStridedMetadataPassBase(AmdgpuResolveStridedMetadataPassBase &&) = delete;
  AmdgpuResolveStridedMetadataPassBase& operator=(AmdgpuResolveStridedMetadataPassBase &&) = delete;
  ~AmdgpuResolveStridedMetadataPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("amdgpu-resolve-strided-metadata");
  }
  ::llvm::StringRef getArgument() const override { return "amdgpu-resolve-strided-metadata"; }

  ::llvm::StringRef getDescription() const override { return "Resolve memref.extract_strided_metadata on AMDGPU ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AmdgpuResolveStridedMetadataPass");
  }
  ::llvm::StringRef getName() const override { return "AmdgpuResolveStridedMetadataPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<arith::ArithDialect>();
    registry.insert<memref::MemRefDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AmdgpuResolveStridedMetadataPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createAmdgpuResolveStridedMetadataPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createAmdgpuResolveStridedMetadataPass() {
  return impl::createAmdgpuResolveStridedMetadataPass();
}
#undef GEN_PASS_DEF_AMDGPURESOLVESTRIDEDMETADATAPASS
#endif // GEN_PASS_DEF_AMDGPURESOLVESTRIDEDMETADATAPASS

//===----------------------------------------------------------------------===//
// AmdgpuTransferReadToLoadPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_AMDGPUTRANSFERREADTOLOADPASS
std::unique_ptr<::mlir::Pass> createAmdgpuTransferReadToLoadPass();
#undef GEN_PASS_DECL_AMDGPUTRANSFERREADTOLOADPASS
#endif // GEN_PASS_DECL_AMDGPUTRANSFERREADTOLOADPASS
#ifdef GEN_PASS_DEF_AMDGPUTRANSFERREADTOLOADPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createAmdgpuTransferReadToLoadPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class AmdgpuTransferReadToLoadPassBase : public ::mlir::OperationPass<> {
public:
  using Base = AmdgpuTransferReadToLoadPassBase;

  AmdgpuTransferReadToLoadPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  AmdgpuTransferReadToLoadPassBase(const AmdgpuTransferReadToLoadPassBase &other) : ::mlir::OperationPass<>(other) {}
  AmdgpuTransferReadToLoadPassBase& operator=(const AmdgpuTransferReadToLoadPassBase &) = delete;
  AmdgpuTransferReadToLoadPassBase(AmdgpuTransferReadToLoadPassBase &&) = delete;
  AmdgpuTransferReadToLoadPassBase& operator=(AmdgpuTransferReadToLoadPassBase &&) = delete;
  ~AmdgpuTransferReadToLoadPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("amdgpu-transfer-read-to-load");
  }
  ::llvm::StringRef getArgument() const override { return "amdgpu-transfer-read-to-load"; }

  ::llvm::StringRef getDescription() const override { return "Lower the operations from the vector transfer_read to vector load"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AmdgpuTransferReadToLoadPass");
  }
  ::llvm::StringRef getName() const override { return "AmdgpuTransferReadToLoadPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<scf::SCFDialect>();
    registry.insert<memref::MemRefDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AmdgpuTransferReadToLoadPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createAmdgpuTransferReadToLoadPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createAmdgpuTransferReadToLoadPass() {
  return impl::createAmdgpuTransferReadToLoadPass();
}
#undef GEN_PASS_DEF_AMDGPUTRANSFERREADTOLOADPASS
#endif // GEN_PASS_DEF_AMDGPUTRANSFERREADTOLOADPASS
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// AmdgpuEmulateAtomicsPass Registration
//===----------------------------------------------------------------------===//

inline void registerAmdgpuEmulateAtomicsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createAmdgpuEmulateAtomicsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerAmdgpuEmulateAtomicsPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createAmdgpuEmulateAtomicsPass();
  });
}

//===----------------------------------------------------------------------===//
// AmdgpuResolveStridedMetadataPass Registration
//===----------------------------------------------------------------------===//

inline void registerAmdgpuResolveStridedMetadataPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createAmdgpuResolveStridedMetadataPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerAmdgpuResolveStridedMetadataPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createAmdgpuResolveStridedMetadataPass();
  });
}

//===----------------------------------------------------------------------===//
// AmdgpuTransferReadToLoadPass Registration
//===----------------------------------------------------------------------===//

inline void registerAmdgpuTransferReadToLoadPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createAmdgpuTransferReadToLoadPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerAmdgpuTransferReadToLoadPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createAmdgpuTransferReadToLoadPass();
  });
}

//===----------------------------------------------------------------------===//
// AMDGPU Registration
//===----------------------------------------------------------------------===//

inline void registerAMDGPUPasses() {
  registerAmdgpuEmulateAtomicsPass();
  registerAmdgpuResolveStridedMetadataPass();
  registerAmdgpuTransferReadToLoadPass();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class AmdgpuEmulateAtomicsPassBase : public ::mlir::OperationPass<> {
public:
  using Base = AmdgpuEmulateAtomicsPassBase;

  AmdgpuEmulateAtomicsPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  AmdgpuEmulateAtomicsPassBase(const AmdgpuEmulateAtomicsPassBase &other) : ::mlir::OperationPass<>(other) {}
  AmdgpuEmulateAtomicsPassBase& operator=(const AmdgpuEmulateAtomicsPassBase &) = delete;
  AmdgpuEmulateAtomicsPassBase(AmdgpuEmulateAtomicsPassBase &&) = delete;
  AmdgpuEmulateAtomicsPassBase& operator=(AmdgpuEmulateAtomicsPassBase &&) = delete;
  ~AmdgpuEmulateAtomicsPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("amdgpu-emulate-atomics");
  }
  ::llvm::StringRef getArgument() const override { return "amdgpu-emulate-atomics"; }

  ::llvm::StringRef getDescription() const override { return "Emulate atomic operations on chipsets that do not support them"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AmdgpuEmulateAtomicsPass");
  }
  ::llvm::StringRef getName() const override { return "AmdgpuEmulateAtomicsPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<cf::ControlFlowDialect>();
    registry.insert<arith::ArithDialect>();
    registry.insert<vector::VectorDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AmdgpuEmulateAtomicsPassBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> chipset{*this, "chipset", ::llvm::cl::desc("Chipset that these operations will run on"), ::llvm::cl::init("gfx000")};
};

template <typename DerivedT>
class AmdgpuResolveStridedMetadataPassBase : public ::mlir::OperationPass<> {
public:
  using Base = AmdgpuResolveStridedMetadataPassBase;

  AmdgpuResolveStridedMetadataPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  AmdgpuResolveStridedMetadataPassBase(const AmdgpuResolveStridedMetadataPassBase &other) : ::mlir::OperationPass<>(other) {}
  AmdgpuResolveStridedMetadataPassBase& operator=(const AmdgpuResolveStridedMetadataPassBase &) = delete;
  AmdgpuResolveStridedMetadataPassBase(AmdgpuResolveStridedMetadataPassBase &&) = delete;
  AmdgpuResolveStridedMetadataPassBase& operator=(AmdgpuResolveStridedMetadataPassBase &&) = delete;
  ~AmdgpuResolveStridedMetadataPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("amdgpu-resolve-strided-metadata");
  }
  ::llvm::StringRef getArgument() const override { return "amdgpu-resolve-strided-metadata"; }

  ::llvm::StringRef getDescription() const override { return "Resolve memref.extract_strided_metadata on AMDGPU ops"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AmdgpuResolveStridedMetadataPass");
  }
  ::llvm::StringRef getName() const override { return "AmdgpuResolveStridedMetadataPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<arith::ArithDialect>();
    registry.insert<memref::MemRefDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AmdgpuResolveStridedMetadataPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class AmdgpuTransferReadToLoadPassBase : public ::mlir::OperationPass<> {
public:
  using Base = AmdgpuTransferReadToLoadPassBase;

  AmdgpuTransferReadToLoadPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  AmdgpuTransferReadToLoadPassBase(const AmdgpuTransferReadToLoadPassBase &other) : ::mlir::OperationPass<>(other) {}
  AmdgpuTransferReadToLoadPassBase& operator=(const AmdgpuTransferReadToLoadPassBase &) = delete;
  AmdgpuTransferReadToLoadPassBase(AmdgpuTransferReadToLoadPassBase &&) = delete;
  AmdgpuTransferReadToLoadPassBase& operator=(AmdgpuTransferReadToLoadPassBase &&) = delete;
  ~AmdgpuTransferReadToLoadPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("amdgpu-transfer-read-to-load");
  }
  ::llvm::StringRef getArgument() const override { return "amdgpu-transfer-read-to-load"; }

  ::llvm::StringRef getDescription() const override { return "Lower the operations from the vector transfer_read to vector load"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("AmdgpuTransferReadToLoadPass");
  }
  ::llvm::StringRef getName() const override { return "AmdgpuTransferReadToLoadPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<scf::SCFDialect>();
    registry.insert<memref::MemRefDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(AmdgpuTransferReadToLoadPassBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
