/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Enum Utility Declarations                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: TestEnumDefs.td                                                      *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// Multi-result op kinds
enum class MultiResultOpEnum : uint64_t {
  kind1 = 1,
  kind2 = 2,
  kind3 = 3,
  kind4 = 4,
  kind5 = 5,
  kind6 = 6,
};

::std::optional<MultiResultOpEnum> symbolizeMultiResultOpEnum(uint64_t);
::llvm::StringRef stringifyMultiResultOpEnum(MultiResultOpEnum);
::std::optional<MultiResultOpEnum> symbolizeMultiResultOpEnum(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForMultiResultOpEnum() {
  return 6;
}


inline ::llvm::StringRef stringifyEnum(MultiResultOpEnum enumValue) {
  return stringifyMultiResultOpEnum(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<MultiResultOpEnum> symbolizeEnum<MultiResultOpEnum>(::llvm::StringRef str) {
  return symbolizeMultiResultOpEnum(str);
}

class MultiResultOpEnumAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = MultiResultOpEnum;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static MultiResultOpEnumAttr get(::mlir::MLIRContext *context, MultiResultOpEnum val);
  MultiResultOpEnum getValue() const;
};

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::MultiResultOpEnum, ::MultiResultOpEnum> {
  template <typename ParserT>
  static FailureOr<::MultiResultOpEnum> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for Multi-result op kinds");

    // Symbolize the keyword.
    if (::std::optional<::MultiResultOpEnum> attr = ::symbolizeEnum<::MultiResultOpEnum>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "expected one of [kind1, kind2, kind3, kind4, kind5, kind6] for Multi-result op kinds, got: ") << enumKeyword;
  }
};

/// Support for std::optional, useful in attribute/type definition where the enum is
/// used as:
///
///    let parameters = (ins OptionalParameter<"std::optional<TheEnumName>">:$value);
template<>
struct FieldParser<std::optional<::MultiResultOpEnum>, std::optional<::MultiResultOpEnum>> {
  template <typename ParserT>
  static FailureOr<std::optional<::MultiResultOpEnum>> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return std::optional<::MultiResultOpEnum>{};

    // Symbolize the keyword.
    if (::std::optional<::MultiResultOpEnum> attr = ::symbolizeEnum<::MultiResultOpEnum>(enumKeyword))
      return attr;
    return parser.emitError(loc, "expected one of [kind1, kind2, kind3, kind4, kind5, kind6] for Multi-result op kinds, got: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::MultiResultOpEnum value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::MultiResultOpEnum> {
  using StorageInfo = ::llvm::DenseMapInfo<uint64_t>;

  static inline ::MultiResultOpEnum getEmptyKey() {
    return static_cast<::MultiResultOpEnum>(StorageInfo::getEmptyKey());
  }

  static inline ::MultiResultOpEnum getTombstoneKey() {
    return static_cast<::MultiResultOpEnum>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::MultiResultOpEnum &val) {
    return StorageInfo::getHashValue(static_cast<uint64_t>(val));
  }

  static bool isEqual(const ::MultiResultOpEnum &lhs, const ::MultiResultOpEnum &rhs) {
    return lhs == rhs;
  }
};
}

// allowed 32-bit signless integer cases: 5, 10, 2147483648, 4294967295
enum class SomeI32Enum : uint32_t {
  case5 = 5,
  case10 = 10,
  caseSignedMaxPlusOne = 2147483648,
  caseUnsignedMax = 4294967295,
};

::std::optional<SomeI32Enum> symbolizeSomeI32Enum(uint32_t);
::llvm::StringRef stringifySomeI32Enum(SomeI32Enum);
::std::optional<SomeI32Enum> symbolizeSomeI32Enum(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForSomeI32Enum() {
  return 4294967295;
}


inline ::llvm::StringRef stringifyEnum(SomeI32Enum enumValue) {
  return stringifySomeI32Enum(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<SomeI32Enum> symbolizeEnum<SomeI32Enum>(::llvm::StringRef str) {
  return symbolizeSomeI32Enum(str);
}

class SomeI32EnumAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = SomeI32Enum;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static SomeI32EnumAttr get(::mlir::MLIRContext *context, SomeI32Enum val);
  SomeI32Enum getValue() const;
};

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::SomeI32Enum, ::SomeI32Enum> {
  template <typename ParserT>
  static FailureOr<::SomeI32Enum> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for allowed 32-bit signless integer cases: 5, 10, 2147483648, 4294967295");

    // Symbolize the keyword.
    if (::std::optional<::SomeI32Enum> attr = ::symbolizeEnum<::SomeI32Enum>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "expected one of [case5, case10, caseSignedMaxPlusOne, caseUnsignedMax] for allowed 32-bit signless integer cases: 5, 10, 2147483648, 4294967295, got: ") << enumKeyword;
  }
};

/// Support for std::optional, useful in attribute/type definition where the enum is
/// used as:
///
///    let parameters = (ins OptionalParameter<"std::optional<TheEnumName>">:$value);
template<>
struct FieldParser<std::optional<::SomeI32Enum>, std::optional<::SomeI32Enum>> {
  template <typename ParserT>
  static FailureOr<std::optional<::SomeI32Enum>> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return std::optional<::SomeI32Enum>{};

    // Symbolize the keyword.
    if (::std::optional<::SomeI32Enum> attr = ::symbolizeEnum<::SomeI32Enum>(enumKeyword))
      return attr;
    return parser.emitError(loc, "expected one of [case5, case10, caseSignedMaxPlusOne, caseUnsignedMax] for allowed 32-bit signless integer cases: 5, 10, 2147483648, 4294967295, got: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::SomeI32Enum value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::SomeI32Enum> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::SomeI32Enum getEmptyKey() {
    return static_cast<::SomeI32Enum>(StorageInfo::getEmptyKey());
  }

  static inline ::SomeI32Enum getTombstoneKey() {
    return static_cast<::SomeI32Enum>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::SomeI32Enum &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::SomeI32Enum &lhs, const ::SomeI32Enum &rhs) {
    return lhs == rhs;
  }
};
}

// allowed 64-bit signless integer cases: 5, 10
enum class SomeI64Enum : uint64_t {
  case5 = 5,
  case10 = 10,
};

::std::optional<SomeI64Enum> symbolizeSomeI64Enum(uint64_t);
::llvm::StringRef stringifySomeI64Enum(SomeI64Enum);
::std::optional<SomeI64Enum> symbolizeSomeI64Enum(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForSomeI64Enum() {
  return 10;
}


inline ::llvm::StringRef stringifyEnum(SomeI64Enum enumValue) {
  return stringifySomeI64Enum(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<SomeI64Enum> symbolizeEnum<SomeI64Enum>(::llvm::StringRef str) {
  return symbolizeSomeI64Enum(str);
}

class SomeI64EnumAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = SomeI64Enum;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static SomeI64EnumAttr get(::mlir::MLIRContext *context, SomeI64Enum val);
  SomeI64Enum getValue() const;
};

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::SomeI64Enum, ::SomeI64Enum> {
  template <typename ParserT>
  static FailureOr<::SomeI64Enum> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for allowed 64-bit signless integer cases: 5, 10");

    // Symbolize the keyword.
    if (::std::optional<::SomeI64Enum> attr = ::symbolizeEnum<::SomeI64Enum>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "expected one of [case5, case10] for allowed 64-bit signless integer cases: 5, 10, got: ") << enumKeyword;
  }
};

/// Support for std::optional, useful in attribute/type definition where the enum is
/// used as:
///
///    let parameters = (ins OptionalParameter<"std::optional<TheEnumName>">:$value);
template<>
struct FieldParser<std::optional<::SomeI64Enum>, std::optional<::SomeI64Enum>> {
  template <typename ParserT>
  static FailureOr<std::optional<::SomeI64Enum>> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return std::optional<::SomeI64Enum>{};

    // Symbolize the keyword.
    if (::std::optional<::SomeI64Enum> attr = ::symbolizeEnum<::SomeI64Enum>(enumKeyword))
      return attr;
    return parser.emitError(loc, "expected one of [case5, case10] for allowed 64-bit signless integer cases: 5, 10, got: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::SomeI64Enum value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::SomeI64Enum> {
  using StorageInfo = ::llvm::DenseMapInfo<uint64_t>;

  static inline ::SomeI64Enum getEmptyKey() {
    return static_cast<::SomeI64Enum>(StorageInfo::getEmptyKey());
  }

  static inline ::SomeI64Enum getTombstoneKey() {
    return static_cast<::SomeI64Enum>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::SomeI64Enum &val) {
    return StorageInfo::getHashValue(static_cast<uint64_t>(val));
  }

  static bool isEqual(const ::SomeI64Enum &lhs, const ::SomeI64Enum &rhs) {
    return lhs == rhs;
  }
};
}

namespace test {
// a test bit enum
enum class TestBitEnum : uint32_t {
  Read = 1,
  Write = 2,
  Execute = 4,
};

::std::optional<TestBitEnum> symbolizeTestBitEnum(uint32_t);
std::string stringifyTestBitEnum(TestBitEnum);
::std::optional<TestBitEnum> symbolizeTestBitEnum(::llvm::StringRef);

inline constexpr TestBitEnum operator|(TestBitEnum a, TestBitEnum b) {
  return static_cast<TestBitEnum>(static_cast<uint32_t>(a) | static_cast<uint32_t>(b));
}
inline constexpr TestBitEnum operator&(TestBitEnum a, TestBitEnum b) {
  return static_cast<TestBitEnum>(static_cast<uint32_t>(a) & static_cast<uint32_t>(b));
}
inline constexpr TestBitEnum operator^(TestBitEnum a, TestBitEnum b) {
  return static_cast<TestBitEnum>(static_cast<uint32_t>(a) ^ static_cast<uint32_t>(b));
}
inline constexpr TestBitEnum operator~(TestBitEnum bits) {
  // Ensure only bits that can be present in the enum are set
  return static_cast<TestBitEnum>(~static_cast<uint32_t>(bits) & static_cast<uint32_t>(7u));
}
inline constexpr bool bitEnumContainsAll(TestBitEnum bits, TestBitEnum bit) {
  return (bits & bit) == bit;
}
inline constexpr bool bitEnumContainsAny(TestBitEnum bits, TestBitEnum bit) {
  return (static_cast<uint32_t>(bits) & static_cast<uint32_t>(bit)) != 0;
}
inline constexpr TestBitEnum bitEnumClear(TestBitEnum bits, TestBitEnum bit) {
  return bits & ~bit;
}
inline constexpr TestBitEnum bitEnumSet(TestBitEnum bits, TestBitEnum bit, /*optional*/bool value=true) {
  return value ? (bits | bit) : bitEnumClear(bits, bit);
}
  
inline std::string stringifyEnum(TestBitEnum enumValue) {
  return stringifyTestBitEnum(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<TestBitEnum> symbolizeEnum<TestBitEnum>(::llvm::StringRef str) {
  return symbolizeTestBitEnum(str);
}
} // namespace test

  namespace mlir {
  template <typename T, typename>
  struct FieldParser;

  template<>
  struct FieldParser<test::TestBitEnum, test::TestBitEnum> {
    template <typename ParserT>
    static FailureOr<test::TestBitEnum> parse(ParserT &parser) {
      test::TestBitEnum flags = {};
      do {
        // Parse the keyword containing a part of the enum.
        ::llvm::StringRef enumKeyword;
        auto loc = parser.getCurrentLocation();
        if (failed(parser.parseOptionalKeyword(&enumKeyword))) {
          return parser.emitError(loc, "expected keyword for a test bit enum");
        }

        // Symbolize the keyword.
        if (::std::optional<test::TestBitEnum> flag = test::symbolizeEnum<test::TestBitEnum>(enumKeyword)) {
          flags = flags | *flag;
        } else {
          return parser.emitError(loc, "expected one of [read, write, execute] for a test bit enum, got: ") << enumKeyword;
        }
      } while (::mlir::succeeded(parser.parseOptionalComma()));
      return flags;
    }
  };

  /// Support for std::optional, useful in attribute/type definition where the enum is
  /// used as:
  ///
  ///    let parameters = (ins OptionalParameter<"std::optional<TheEnumName>">:$value);
  template<>
  struct FieldParser<std::optional<test::TestBitEnum>, std::optional<test::TestBitEnum>> {
    template <typename ParserT>
    static FailureOr<std::optional<test::TestBitEnum>> parse(ParserT &parser) {
      test::TestBitEnum flags = {};
      bool firstIter = true;
      do {
        // Parse the keyword containing a part of the enum.
        ::llvm::StringRef enumKeyword;
        auto loc = parser.getCurrentLocation();
        if (failed(parser.parseOptionalKeyword(&enumKeyword))) {
          if (firstIter)
            return std::optional<test::TestBitEnum>{};
          return parser.emitError(loc, "expected keyword for a test bit enum after ', '");
        }
        firstIter = false;

        // Symbolize the keyword.
        if (::std::optional<test::TestBitEnum> flag = test::symbolizeEnum<test::TestBitEnum>(enumKeyword)) {
          flags = flags | *flag;
        } else {
          return parser.emitError(loc, "expected one of [read, write, execute] for a test bit enum, got: ") << enumKeyword;
        }
      } while(::mlir::succeeded(parser.parseOptionalComma()));
      return std::optional<test::TestBitEnum>{flags};
    }
  };
  } // namespace mlir

  namespace llvm {
  inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, test::TestBitEnum value) {
    auto valueStr = stringifyEnum(value);
    return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<test::TestBitEnum> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline test::TestBitEnum getEmptyKey() {
    return static_cast<test::TestBitEnum>(StorageInfo::getEmptyKey());
  }

  static inline test::TestBitEnum getTombstoneKey() {
    return static_cast<test::TestBitEnum>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const test::TestBitEnum &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const test::TestBitEnum &lhs, const test::TestBitEnum &rhs) {
    return lhs == rhs;
  }
};
}

namespace test {
// another test bit enum
enum class TestBitEnumVerticalBar : uint32_t {
  User = 1,
  Group = 2,
  Other = 4,
};

::std::optional<TestBitEnumVerticalBar> symbolizeTestBitEnumVerticalBar(uint32_t);
std::string stringifyTestBitEnumVerticalBar(TestBitEnumVerticalBar);
::std::optional<TestBitEnumVerticalBar> symbolizeTestBitEnumVerticalBar(::llvm::StringRef);

inline constexpr TestBitEnumVerticalBar operator|(TestBitEnumVerticalBar a, TestBitEnumVerticalBar b) {
  return static_cast<TestBitEnumVerticalBar>(static_cast<uint32_t>(a) | static_cast<uint32_t>(b));
}
inline constexpr TestBitEnumVerticalBar operator&(TestBitEnumVerticalBar a, TestBitEnumVerticalBar b) {
  return static_cast<TestBitEnumVerticalBar>(static_cast<uint32_t>(a) & static_cast<uint32_t>(b));
}
inline constexpr TestBitEnumVerticalBar operator^(TestBitEnumVerticalBar a, TestBitEnumVerticalBar b) {
  return static_cast<TestBitEnumVerticalBar>(static_cast<uint32_t>(a) ^ static_cast<uint32_t>(b));
}
inline constexpr TestBitEnumVerticalBar operator~(TestBitEnumVerticalBar bits) {
  // Ensure only bits that can be present in the enum are set
  return static_cast<TestBitEnumVerticalBar>(~static_cast<uint32_t>(bits) & static_cast<uint32_t>(7u));
}
inline constexpr bool bitEnumContainsAll(TestBitEnumVerticalBar bits, TestBitEnumVerticalBar bit) {
  return (bits & bit) == bit;
}
inline constexpr bool bitEnumContainsAny(TestBitEnumVerticalBar bits, TestBitEnumVerticalBar bit) {
  return (static_cast<uint32_t>(bits) & static_cast<uint32_t>(bit)) != 0;
}
inline constexpr TestBitEnumVerticalBar bitEnumClear(TestBitEnumVerticalBar bits, TestBitEnumVerticalBar bit) {
  return bits & ~bit;
}
inline constexpr TestBitEnumVerticalBar bitEnumSet(TestBitEnumVerticalBar bits, TestBitEnumVerticalBar bit, /*optional*/bool value=true) {
  return value ? (bits | bit) : bitEnumClear(bits, bit);
}
  
inline std::string stringifyEnum(TestBitEnumVerticalBar enumValue) {
  return stringifyTestBitEnumVerticalBar(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<TestBitEnumVerticalBar> symbolizeEnum<TestBitEnumVerticalBar>(::llvm::StringRef str) {
  return symbolizeTestBitEnumVerticalBar(str);
}
} // namespace test

  namespace mlir {
  template <typename T, typename>
  struct FieldParser;

  template<>
  struct FieldParser<test::TestBitEnumVerticalBar, test::TestBitEnumVerticalBar> {
    template <typename ParserT>
    static FailureOr<test::TestBitEnumVerticalBar> parse(ParserT &parser) {
      test::TestBitEnumVerticalBar flags = {};
      do {
        // Parse the keyword containing a part of the enum.
        ::llvm::StringRef enumKeyword;
        auto loc = parser.getCurrentLocation();
        if (failed(parser.parseOptionalKeyword(&enumKeyword))) {
          return parser.emitError(loc, "expected keyword for another test bit enum");
        }

        // Symbolize the keyword.
        if (::std::optional<test::TestBitEnumVerticalBar> flag = test::symbolizeEnum<test::TestBitEnumVerticalBar>(enumKeyword)) {
          flags = flags | *flag;
        } else {
          return parser.emitError(loc, "expected one of [user, group, other] for another test bit enum, got: ") << enumKeyword;
        }
      } while (::mlir::succeeded(parser.parseOptionalVerticalBar()));
      return flags;
    }
  };

  /// Support for std::optional, useful in attribute/type definition where the enum is
  /// used as:
  ///
  ///    let parameters = (ins OptionalParameter<"std::optional<TheEnumName>">:$value);
  template<>
  struct FieldParser<std::optional<test::TestBitEnumVerticalBar>, std::optional<test::TestBitEnumVerticalBar>> {
    template <typename ParserT>
    static FailureOr<std::optional<test::TestBitEnumVerticalBar>> parse(ParserT &parser) {
      test::TestBitEnumVerticalBar flags = {};
      bool firstIter = true;
      do {
        // Parse the keyword containing a part of the enum.
        ::llvm::StringRef enumKeyword;
        auto loc = parser.getCurrentLocation();
        if (failed(parser.parseOptionalKeyword(&enumKeyword))) {
          if (firstIter)
            return std::optional<test::TestBitEnumVerticalBar>{};
          return parser.emitError(loc, "expected keyword for another test bit enum after ' | '");
        }
        firstIter = false;

        // Symbolize the keyword.
        if (::std::optional<test::TestBitEnumVerticalBar> flag = test::symbolizeEnum<test::TestBitEnumVerticalBar>(enumKeyword)) {
          flags = flags | *flag;
        } else {
          return parser.emitError(loc, "expected one of [user, group, other] for another test bit enum, got: ") << enumKeyword;
        }
      } while(::mlir::succeeded(parser.parseOptionalVerticalBar()));
      return std::optional<test::TestBitEnumVerticalBar>{flags};
    }
  };
  } // namespace mlir

  namespace llvm {
  inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, test::TestBitEnumVerticalBar value) {
    auto valueStr = stringifyEnum(value);
    return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<test::TestBitEnumVerticalBar> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline test::TestBitEnumVerticalBar getEmptyKey() {
    return static_cast<test::TestBitEnumVerticalBar>(StorageInfo::getEmptyKey());
  }

  static inline test::TestBitEnumVerticalBar getTombstoneKey() {
    return static_cast<test::TestBitEnumVerticalBar>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const test::TestBitEnumVerticalBar &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const test::TestBitEnumVerticalBar &lhs, const test::TestBitEnumVerticalBar &rhs) {
    return lhs == rhs;
  }
};
}

namespace test {
// a test enum
enum class TestEnum : uint32_t {
  First = 0,
  Second = 1,
  Third = 2,
};

::std::optional<TestEnum> symbolizeTestEnum(uint32_t);
::llvm::StringRef stringifyTestEnum(TestEnum);
::std::optional<TestEnum> symbolizeTestEnum(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForTestEnum() {
  return 2;
}


inline ::llvm::StringRef stringifyEnum(TestEnum enumValue) {
  return stringifyTestEnum(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<TestEnum> symbolizeEnum<TestEnum>(::llvm::StringRef str) {
  return symbolizeTestEnum(str);
}
} // namespace test

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<test::TestEnum, test::TestEnum> {
  template <typename ParserT>
  static FailureOr<test::TestEnum> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for a test enum");

    // Symbolize the keyword.
    if (::std::optional<test::TestEnum> attr = test::symbolizeEnum<test::TestEnum>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "expected one of [first, second, third] for a test enum, got: ") << enumKeyword;
  }
};

/// Support for std::optional, useful in attribute/type definition where the enum is
/// used as:
///
///    let parameters = (ins OptionalParameter<"std::optional<TheEnumName>">:$value);
template<>
struct FieldParser<std::optional<test::TestEnum>, std::optional<test::TestEnum>> {
  template <typename ParserT>
  static FailureOr<std::optional<test::TestEnum>> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return std::optional<test::TestEnum>{};

    // Symbolize the keyword.
    if (::std::optional<test::TestEnum> attr = test::symbolizeEnum<test::TestEnum>(enumKeyword))
      return attr;
    return parser.emitError(loc, "expected one of [first, second, third] for a test enum, got: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, test::TestEnum value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<test::TestEnum> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline test::TestEnum getEmptyKey() {
    return static_cast<test::TestEnum>(StorageInfo::getEmptyKey());
  }

  static inline test::TestEnum getTombstoneKey() {
    return static_cast<test::TestEnum>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const test::TestEnum &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const test::TestEnum &lhs, const test::TestEnum &rhs) {
    return lhs == rhs;
  }
};
}

namespace test {
// allowed i32 cases: 0, 1
enum class SimpleEnum : uint32_t {
  a = 0,
  b = 1,
};

::std::optional<SimpleEnum> symbolizeSimpleEnum(uint32_t);
::llvm::StringRef stringifySimpleEnum(SimpleEnum);
::std::optional<SimpleEnum> symbolizeSimpleEnum(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForSimpleEnum() {
  return 1;
}


inline ::llvm::StringRef stringifyEnum(SimpleEnum enumValue) {
  return stringifySimpleEnum(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<SimpleEnum> symbolizeEnum<SimpleEnum>(::llvm::StringRef str) {
  return symbolizeSimpleEnum(str);
}
} // namespace test

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<::test::SimpleEnum, ::test::SimpleEnum> {
  template <typename ParserT>
  static FailureOr<::test::SimpleEnum> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for allowed i32 cases: 0, 1");

    // Symbolize the keyword.
    if (::std::optional<::test::SimpleEnum> attr = ::test::symbolizeEnum<::test::SimpleEnum>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "expected one of [a, b] for allowed i32 cases: 0, 1, got: ") << enumKeyword;
  }
};

/// Support for std::optional, useful in attribute/type definition where the enum is
/// used as:
///
///    let parameters = (ins OptionalParameter<"std::optional<TheEnumName>">:$value);
template<>
struct FieldParser<std::optional<::test::SimpleEnum>, std::optional<::test::SimpleEnum>> {
  template <typename ParserT>
  static FailureOr<std::optional<::test::SimpleEnum>> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return std::optional<::test::SimpleEnum>{};

    // Symbolize the keyword.
    if (::std::optional<::test::SimpleEnum> attr = ::test::symbolizeEnum<::test::SimpleEnum>(enumKeyword))
      return attr;
    return parser.emitError(loc, "expected one of [a, b] for allowed i32 cases: 0, 1, got: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, ::test::SimpleEnum value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<::test::SimpleEnum> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline ::test::SimpleEnum getEmptyKey() {
    return static_cast<::test::SimpleEnum>(StorageInfo::getEmptyKey());
  }

  static inline ::test::SimpleEnum getTombstoneKey() {
    return static_cast<::test::SimpleEnum>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const ::test::SimpleEnum &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const ::test::SimpleEnum &lhs, const ::test::SimpleEnum &rhs) {
    return lhs == rhs;
  }
};
}

