/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace mlir {
class TestExternalOpInterface;
namespace detail {
struct TestExternalOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    unsigned (*getNameLengthPlusArg)(const Concept *impl, ::mlir::Operation *, unsigned);
    unsigned (*getNameLengthPlusArgTwice)(unsigned);
    unsigned (*getNameLengthTimesArg)(const Concept *impl, ::mlir::Operation *, unsigned);
    unsigned (*getNameLengthMinusArg)(unsigned);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::mlir::TestExternalOpInterface;
    Model() : Concept{getNameLengthPlusArg, getNameLengthPlusArgTwice, getNameLengthTimesArg, getNameLengthMinusArg} {}

    static inline unsigned getNameLengthPlusArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg);
    static inline unsigned getNameLengthPlusArgTwice(unsigned arg);
    static inline unsigned getNameLengthTimesArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg);
    static inline unsigned getNameLengthMinusArg(unsigned arg);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::TestExternalOpInterface;
    FallbackModel() : Concept{getNameLengthPlusArg, getNameLengthPlusArgTwice, getNameLengthTimesArg, getNameLengthMinusArg} {}

    static inline unsigned getNameLengthPlusArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg);
    static inline unsigned getNameLengthPlusArgTwice(unsigned arg);
    static inline unsigned getNameLengthTimesArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg);
    static inline unsigned getNameLengthMinusArg(unsigned arg);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    unsigned getNameLengthTimesArg(::mlir::Operation *tablegen_opaque_val, unsigned arg) const;
    static unsigned getNameLengthMinusArg(unsigned arg);
  };
};
template <typename ConcreteOp>
struct TestExternalOpInterfaceTrait;

} // namespace detail
class TestExternalOpInterface : public ::mlir::OpInterface<TestExternalOpInterface, detail::TestExternalOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<TestExternalOpInterface, detail::TestExternalOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::TestExternalOpInterfaceTrait<ConcreteOp> {};

  /// Returns the length of the operation name plus arg.
  unsigned getNameLengthPlusArg(unsigned arg);

  /// Returns the length of the operation name plus arg twice.
  unsigned getNameLengthPlusArgTwice(unsigned arg);

  /// Returns the length of the product of the operation name and arg.
  unsigned getNameLengthTimesArg(unsigned arg);

  /// Returns the length of the operation name minus arg.
  unsigned getNameLengthMinusArg(unsigned arg);
};
namespace detail {
  template <typename ConcreteOp>
  struct TestExternalOpInterfaceTrait : public ::mlir::OpInterface<TestExternalOpInterface, detail::TestExternalOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {

    /// Returns the length of the product of the operation name and arg.
    unsigned getNameLengthTimesArg(unsigned arg) {
      return arg * (*static_cast<ConcreteOp *>(this))->getName().getStringRef().size();
    }

    /// Returns the length of the operation name minus arg.
    static unsigned getNameLengthMinusArg(unsigned arg) {
      return ConcreteOp::getOperationName().size() - arg;
    }
  };
}// namespace detail
} // namespace mlir
namespace mlir {
class TestEffectOpInterface;
namespace detail {
struct TestEffectOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    void (*getEffects)(const Concept *impl, ::mlir::Operation *, ::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> &);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::mlir::TestEffectOpInterface;
    Model() : Concept{getEffects} {}

    static inline void getEffects(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> & effects);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::TestEffectOpInterface;
    FallbackModel() : Concept{getEffects} {}

    static inline void getEffects(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> & effects);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
  };
};
template <typename ConcreteOp>
struct TestEffectOpInterfaceTrait;

} // namespace detail
class TestEffectOpInterface : public ::mlir::OpInterface<TestEffectOpInterface, detail::TestEffectOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<TestEffectOpInterface, detail::TestEffectOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::TestEffectOpInterfaceTrait<ConcreteOp> {};

  /// Collects all of the operation's effects into `effects`.
  void getEffects(::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> & effects);

    /// Collect all of the effect instances that correspond to the given
    /// `Effect` and place them in 'effects'.
    template <typename Effect> void getEffects(
      ::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<
                                              ::mlir::TestEffects::Effect>> &effects) {
      getEffects(effects);
      ::llvm::erase_if(effects, [&](auto &it) {
        return !::llvm::isa<Effect>(it.getEffect());
      });
    }

    /// Returns true if this operation exhibits the given effect.
    template <typename Effect> bool hasEffect() {
      ::llvm::SmallVector<::mlir::SideEffects::EffectInstance<
                                            ::mlir::TestEffects::Effect>, 4> effects;
      getEffects(effects);
      return ::llvm::any_of(effects, [](const auto &it) {
        return ::llvm::isa<Effect>(it.getEffect());
      });
    }

    /// Returns true if this operation only has the given effect.
    template <typename Effect> bool onlyHasEffect() {
      ::llvm::SmallVector<::mlir::SideEffects::EffectInstance<
                                            ::mlir::TestEffects::Effect>, 4> effects;
      getEffects(effects);
      return !effects.empty() && ::llvm::all_of(effects, [](const auto &it) {
        return ::llvm::isa<Effect>(it.getEffect());
      });
    }

    /// Returns true if this operation has no effects.
    bool hasNoEffect() {
      ::llvm::SmallVector<::mlir::SideEffects::EffectInstance<
                                            ::mlir::TestEffects::Effect>, 4> effects;
      getEffects(effects);
      return effects.empty();
    }

    /// Collect all of the effect instances that operate on the provided value
    /// and place them in 'effects'.
    void getEffectsOnValue(::mlir::Value value,
              ::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<
              ::mlir::TestEffects::Effect>> & effects) {
      getEffects(effects);
      ::llvm::erase_if(effects, [&](auto &it) { return it.getValue() != value; });
    }

    /// Return the effect of the given type `Effect` that is applied to the
    /// given value, or std::nullopt if no effect exists.
    template <typename Effect>
    ::std::optional<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>>
    getEffectOnValue(::mlir::Value value) {
      ::llvm::SmallVector<::mlir::SideEffects::EffectInstance<
              ::mlir::TestEffects::Effect>, 4> effects;
      getEffects(effects);
      auto it = ::llvm::find_if(effects, [&](auto &it) {
        return ::llvm::isa<Effect>(it.getEffect()) && it.getValue() == value;
      });
      if (it == effects.end())
        return std::nullopt;
      return *it;
    }

    /// Collect all of the effect instances that operate on the provided symbol
    /// reference and place them in 'effects'.
    void getEffectsOnSymbol(::mlir::SymbolRefAttr value,
              ::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<
              ::mlir::TestEffects::Effect>> & effects) {
      getEffects(effects);
      ::llvm::erase_if(effects, [&](auto &it) {
        return it.getSymbolRef() != value;
      });
    }

    /// Collect all of the effect instances that operate on the provided
    /// resource and place them in 'effects'.
    void getEffectsOnResource(::mlir::SideEffects::Resource *resource,
              ::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<
              ::mlir::TestEffects::Effect>> & effects) {
      getEffects(effects);
      ::llvm::erase_if(effects, [&](auto &it) {
        return it.getResource()->getResourceID() != resource->getResourceID();
      });
    }
};
namespace detail {
  template <typename ConcreteOp>
  struct TestEffectOpInterfaceTrait : public ::mlir::OpInterface<TestEffectOpInterface, detail::TestEffectOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
  };
}// namespace detail
} // namespace mlir
namespace mlir {
class TestOptionallyImplementedOpInterface;
namespace detail {
struct TestOptionallyImplementedOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    bool (*getImplementsInterface)(const Concept *impl, ::mlir::Operation *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::mlir::TestOptionallyImplementedOpInterface;
    Model() : Concept{getImplementsInterface} {}

    static inline bool getImplementsInterface(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::TestOptionallyImplementedOpInterface;
    FallbackModel() : Concept{getImplementsInterface} {}

    static inline bool getImplementsInterface(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
  };
};
template <typename ConcreteOp>
struct TestOptionallyImplementedOpInterfaceTrait;

} // namespace detail
class TestOptionallyImplementedOpInterface : public ::mlir::OpInterface<TestOptionallyImplementedOpInterface, detail::TestOptionallyImplementedOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<TestOptionallyImplementedOpInterface, detail::TestOptionallyImplementedOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::TestOptionallyImplementedOpInterfaceTrait<ConcreteOp> {};
  bool getImplementsInterface();
  static bool classof(::mlir::Operation * base) {
    auto* interface = getInterfaceFor(base);
    if (!interface)
      return false;
    TestOptionallyImplementedOpInterface odsInterfaceInstance(base, interface);
    return odsInterfaceInstance.getImplementsInterface();
  }
};
namespace detail {
  template <typename ConcreteOp>
  struct TestOptionallyImplementedOpInterfaceTrait : public ::mlir::OpInterface<TestOptionallyImplementedOpInterface, detail::TestOptionallyImplementedOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
  };
}// namespace detail
} // namespace mlir
namespace mlir {
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::Model<ConcreteOp>::getNameLengthPlusArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getNameLengthPlusArg(arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::Model<ConcreteOp>::getNameLengthPlusArgTwice(unsigned arg) {
  return ConcreteOp::getNameLengthPlusArgTwice(arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::Model<ConcreteOp>::getNameLengthTimesArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getNameLengthTimesArg(arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::Model<ConcreteOp>::getNameLengthMinusArg(unsigned arg) {
  return ConcreteOp::getNameLengthMinusArg(arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getNameLengthPlusArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg) {
  return static_cast<const ConcreteOp *>(impl)->getNameLengthPlusArg(tablegen_opaque_val, arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getNameLengthPlusArgTwice(unsigned arg) {
  return ConcreteOp::getNameLengthPlusArgTwice(arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getNameLengthTimesArg(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, unsigned arg) {
  return static_cast<const ConcreteOp *>(impl)->getNameLengthTimesArg(tablegen_opaque_val, arg);
}
template<typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getNameLengthMinusArg(unsigned arg) {
  return ConcreteOp::getNameLengthMinusArg(arg);
}
template<typename ConcreteModel, typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getNameLengthTimesArg(::mlir::Operation *tablegen_opaque_val, unsigned arg) const {
return arg * (llvm::cast<ConcreteOp>(tablegen_opaque_val))->getName().getStringRef().size();
}
template<typename ConcreteModel, typename ConcreteOp>
unsigned detail::TestExternalOpInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getNameLengthMinusArg(unsigned arg) {
return ConcreteOp::getOperationName().size() - arg;
}
} // namespace mlir
namespace mlir {
template<typename ConcreteOp>
void detail::TestEffectOpInterfaceInterfaceTraits::Model<ConcreteOp>::getEffects(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> & effects) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getEffects(effects);
}
template<typename ConcreteOp>
void detail::TestEffectOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getEffects(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, ::llvm::SmallVectorImpl<::mlir::SideEffects::EffectInstance<::mlir::TestEffects::Effect>> & effects) {
  return static_cast<const ConcreteOp *>(impl)->getEffects(tablegen_opaque_val, effects);
}
} // namespace mlir
namespace mlir {
template<typename ConcreteOp>
bool detail::TestOptionallyImplementedOpInterfaceInterfaceTraits::Model<ConcreteOp>::getImplementsInterface(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getImplementsInterface();
}
template<typename ConcreteOp>
bool detail::TestOptionallyImplementedOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getImplementsInterface(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getImplementsInterface(tablegen_opaque_val);
}
} // namespace mlir
