/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AArch64PostLegalizerCombinerImpl Combiner Match Table                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AArch64PostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 0;	 // "copy_prop"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_const", 8) != 0)
        break;
      return 24;	 // "mul_const"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "r_to_bsp", 8) != 0)
        break;
      return 85;	 // "or_to_bsp"
    }
    break;
  case 10:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 56;	 // "i2p_to_p2i"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 55;	 // "p2i_to_i2p"
    }
    break;
  case 11:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 61;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 32;	 // "match_addos"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 42;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtmultomull", 11) != 0)
        break;
      return 94;	 // "extmultomull"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 23;	 // "redundant_or"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_sext", 11) != 0)
        break;
      return 6;	 // "sext_of_sext"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 4;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 16;	 // "load_and_mask"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 37;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 41;	 // "merge_unmerge"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 20;	 // "redundant_and"
    case 'u':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
          break;
        return 40;	 // "unmerge_merge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
          break;
        return 43;	 // "unmerge_undef"
      }
      break;
    }
    break;
  case 14:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 10;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 9;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_same_val", 13) != 0)
        break;
      return 52;	 // "binop_same_val"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_fneg_fold", 13) != 0)
        break;
      return 58;	 // "fneg_fneg_fold"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 7;	 // "sext_of_anyext"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 5;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 15;	 // "extending_loads"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 70;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 50;	 // "select_same_val"
    }
    break;
  case 16:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 8;	 // "anyext_of_anyext"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_mul_cmlt", 15) != 0)
        break;
      return 92;	 // "combine_mul_cmlt"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 84;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 34;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 2;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 1;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 72;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_trunc_fold", 16) != 0)
        break;
      return 57;	 // "anyext_trunc_fold"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 82;	 // "erase_undef_store"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_to_iminmax", 16) != 0)
        break;
      return 36;	 // "select_to_iminmax"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_int_zero", 16) != 0)
        break;
      return 73;	 // "undef_to_int_zero"
    }
    break;
  case 18:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 53;	 // "binop_left_to_zero"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_merge_to_zext", 16) != 0)
          break;
        return 38;	 // "fold_merge_to_zext"
      case 'p':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "trunc_fpext_fold", 16) != 0)
          break;
        return 66;	 // "fptrunc_fpext_fold"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 3;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 10 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 54;	 // "binop_right_to_zero"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "onstant_fold_binop", 18) != 0)
        break;
      return 48;	 // "constant_fold_binop"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 13;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 47;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 69;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 51;	 // "right_identity_zero"
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tate_out_of_range", 17) != 0)
          break;
        return 30;	 // "rotate_out_of_range"
      }
      break;
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_constant_cmp", 16) != 0)
          break;
        return 35;	 // "select_constant_cmp"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_trunc_sextload", 16) != 0)
          break;
        return 18;	 // "sext_trunc_sextload"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 77;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 65;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 46;	 // "merge_of_x_and_undef"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_sext_inreg", 19) != 0)
        break;
      return 25;	 // "redundant_sext_inreg"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "plit_store_zero_128", 19) != 0)
        break;
      return 71;	 // "split_store_zero_128"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 78;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 45;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_concat_vector", 20) != 0)
        break;
      return 86;	 // "combine_concat_vector"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "utate_anyext_to_zext", 20) != 0)
        break;
      return 14;	 // "mutate_anyext_to_zext"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 60;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 74;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 44;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "onstant_fold_fp_binop", 21) != 0)
        break;
      return 49;	 // "constant_fold_fp_binop"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 33;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 79;	 // "propagate_undef_any_op"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_int", 21) != 0)
        break;
      return 59;	 // "right_identity_one_int"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 63;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 12;	 // "buildvector_of_truncate"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 80;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 75;	 // "binop_left_undef_to_zero"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_of_sext_inreg", 23) != 0)
        break;
      return 11;	 // "sext_inreg_of_sext_inreg"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 21;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 27;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 28;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 62;	 // "buildvector_identity_fold"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 89;	 // "extract_vec_elt_build_vec"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 68;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 76;	 // "binop_right_undef_to_undef"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_indexed_load_store", 22) != 0)
          break;
        return 17;	 // "combine_indexed_load_store"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_fp_constant_to_rhs", 22) != 0)
          break;
        return 88;	 // "commute_fp_constant_to_rhs"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtractvecelt_pairwise_add", 25) != 0)
        break;
      return 22;	 // "extractvecelt_pairwise_add"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 67;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 93;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 87;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 64;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 39;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "propagate_undef_shuffle_mask", 28) != 0)
      break;
    return 81;	 // "propagate_undef_shuffle_mask"
  case 29:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 29;	 // "bitfield_extract_from_shr_and"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 31;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 32:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "bitfield_extract_from_sext_inreg", 32) != 0)
      break;
    return 26;	 // "bitfield_extract_from_sext_inreg"
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 90;	 // "extract_all_elts_from_build_vector"
  case 36:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_extract_vec_elt_out_of_bounds", 36) != 0)
      break;
    return 83;	 // "insert_extract_vec_elt_out_of_bounds"
  case 37:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "hoist_logic_op_with_same_opcode_hands", 37) != 0)
      break;
    return 19;	 // "hoist_logic_op_with_same_opcode_hands"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 91;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 95}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AArch64PostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AArch64PostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AArch64PostLegalizerCombinerOption;
static cl::list<std::string> AArch64PostLegalizerCombinerDisableOption(
    "aarch64postlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AArch64PostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AArch64PostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AArch64PostLegalizerCombinerOnlyEnableOption(
    "aarch64postlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AArch64PostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AArch64PostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AArch64PostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AArch64PostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AArch64PostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AArch64PostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64PostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64PostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64PostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64PostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset AArch64PostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void AArch64PostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64PostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AArch64PostLegalizerCombinerImpl::ComplexMatcherMemFn
AArch64PostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
};
bool AArch64PostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
};

bool AArch64PostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AArch64PostLegalizerCombinerImpl::CustomRendererFn
AArch64PostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AArch64PostLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
};
bool AArch64PostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    // Match Patterns
    if(![&](){return matchMutateAnyExtToZExt(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyMutateAnyExtToZExt(*State.MIs[0], MRI, B, Observer);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    IndexedLoadStoreMatchInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineIndexedLoadStore(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineIndexedLoadStore(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    // Match Patterns
    if(![&](){return Helper.matchSextTruncSextLoad(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextTruncSextLoad(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::tuple<unsigned, LLT, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtractVecEltPairwiseAdd(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtractVecEltPairwiseAdd(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder&, Register)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchAArch64MulConstCombine(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyAArch64MulConstCombine(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    // Match Patterns
    if(![&](){return Helper.matchRotateOutOfRange(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyRotateOutOfRange(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    // Match Patterns
    if(![&](){return matchFoldMergeToZext(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyFoldMergeToZext(*State.MIs[0], MRI, B, Observer);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return matchSplitStoreZero128(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applySplitStoreZero128(*State.MIs[0], MRI, B, Observer);
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchOrToBSP(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyOrToBSP(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCombineMulCMLT(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyCombineMulCMLT(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    std::tuple<bool, Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtMulToMULL(*State.MIs[0], MRI, VT, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtMulToMULL(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64PostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(241), /*)*//*default:*//*Label 75*/ GIMT_Encode4(3634),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(894), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(906),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1031),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(1077),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(1190),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(1213),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(1247),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(1270), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(1304),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(1443),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(1557), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(1636), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(1703),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 13*/ GIMT_Encode4(1788),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 14*/ GIMT_Encode4(1836),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 15*/ GIMT_Encode4(1848),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 16*/ GIMT_Encode4(1860),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 17*/ GIMT_Encode4(1903),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 18*/ GIMT_Encode4(1936),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 19*/ GIMT_Encode4(1979), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 20*/ GIMT_Encode4(1991),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 21*/ GIMT_Encode4(2014),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 22*/ GIMT_Encode4(2037), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 23*/ GIMT_Encode4(2060), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  462 */ /*TargetOpcode::G_ANYEXT*//*Label 24*/ GIMT_Encode4(2094),
     /*  466 */ /*TargetOpcode::G_TRUNC*//*Label 25*/ GIMT_Encode4(2201), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  486 */ /*TargetOpcode::G_SEXT*//*Label 26*/ GIMT_Encode4(2353),
     /*  490 */ /*TargetOpcode::G_SEXT_INREG*//*Label 27*/ GIMT_Encode4(2396),
     /*  494 */ /*TargetOpcode::G_ZEXT*//*Label 28*/ GIMT_Encode4(2451),
     /*  498 */ /*TargetOpcode::G_SHL*//*Label 29*/ GIMT_Encode4(2494),
     /*  502 */ /*TargetOpcode::G_LSHR*//*Label 30*/ GIMT_Encode4(2562),
     /*  506 */ /*TargetOpcode::G_ASHR*//*Label 31*/ GIMT_Encode4(2641), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  518 */ /*TargetOpcode::G_ROTR*//*Label 32*/ GIMT_Encode4(2720),
     /*  522 */ /*TargetOpcode::G_ROTL*//*Label 33*/ GIMT_Encode4(2755),
     /*  526 */ /*TargetOpcode::G_ICMP*//*Label 34*/ GIMT_Encode4(2790), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  542 */ /*TargetOpcode::G_SELECT*//*Label 35*/ GIMT_Encode4(2802),
     /*  546 */ /*TargetOpcode::G_UADDO*//*Label 36*/ GIMT_Encode4(2897), GIMT_Encode4(0),
     /*  554 */ /*TargetOpcode::G_USUBO*//*Label 37*/ GIMT_Encode4(2920), GIMT_Encode4(0),
     /*  562 */ /*TargetOpcode::G_SADDO*//*Label 38*/ GIMT_Encode4(2932), GIMT_Encode4(0),
     /*  570 */ /*TargetOpcode::G_SSUBO*//*Label 39*/ GIMT_Encode4(2955), GIMT_Encode4(0),
     /*  578 */ /*TargetOpcode::G_UMULO*//*Label 40*/ GIMT_Encode4(2967),
     /*  582 */ /*TargetOpcode::G_SMULO*//*Label 41*/ GIMT_Encode4(2979),
     /*  586 */ /*TargetOpcode::G_UMULH*//*Label 42*/ GIMT_Encode4(2991),
     /*  590 */ /*TargetOpcode::G_SMULH*//*Label 43*/ GIMT_Encode4(3003),
     /*  594 */ /*TargetOpcode::G_UADDSAT*//*Label 44*/ GIMT_Encode4(3015),
     /*  598 */ /*TargetOpcode::G_SADDSAT*//*Label 45*/ GIMT_Encode4(3027), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  618 */ /*TargetOpcode::G_SMULFIX*//*Label 46*/ GIMT_Encode4(3039),
     /*  622 */ /*TargetOpcode::G_UMULFIX*//*Label 47*/ GIMT_Encode4(3051),
     /*  626 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 48*/ GIMT_Encode4(3063),
     /*  630 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 49*/ GIMT_Encode4(3075), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  650 */ /*TargetOpcode::G_FADD*//*Label 50*/ GIMT_Encode4(3087),
     /*  654 */ /*TargetOpcode::G_FSUB*//*Label 51*/ GIMT_Encode4(3133),
     /*  658 */ /*TargetOpcode::G_FMUL*//*Label 52*/ GIMT_Encode4(3145), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  670 */ /*TargetOpcode::G_FDIV*//*Label 53*/ GIMT_Encode4(3211), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FNEG*//*Label 54*/ GIMT_Encode4(3223), GIMT_Encode4(0),
     /*  726 */ /*TargetOpcode::G_FPTRUNC*//*Label 55*/ GIMT_Encode4(3253),
     /*  730 */ /*TargetOpcode::G_FPTOSI*//*Label 56*/ GIMT_Encode4(3275),
     /*  734 */ /*TargetOpcode::G_FPTOUI*//*Label 57*/ GIMT_Encode4(3297),
     /*  738 */ /*TargetOpcode::G_SITOFP*//*Label 58*/ GIMT_Encode4(3319),
     /*  742 */ /*TargetOpcode::G_UITOFP*//*Label 59*/ GIMT_Encode4(3331), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  770 */ /*TargetOpcode::G_FMINNUM*//*Label 60*/ GIMT_Encode4(3343),
     /*  774 */ /*TargetOpcode::G_FMAXNUM*//*Label 61*/ GIMT_Encode4(3355),
     /*  778 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 62*/ GIMT_Encode4(3367),
     /*  782 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 63*/ GIMT_Encode4(3379),
     /*  786 */ /*TargetOpcode::G_FMINIMUM*//*Label 64*/ GIMT_Encode4(3391),
     /*  790 */ /*TargetOpcode::G_FMAXIMUM*//*Label 65*/ GIMT_Encode4(3403), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  826 */ /*TargetOpcode::G_PTR_ADD*//*Label 66*/ GIMT_Encode4(3415), GIMT_Encode4(0),
     /*  834 */ /*TargetOpcode::G_SMIN*//*Label 67*/ GIMT_Encode4(3461),
     /*  838 */ /*TargetOpcode::G_SMAX*//*Label 68*/ GIMT_Encode4(3484),
     /*  842 */ /*TargetOpcode::G_UMIN*//*Label 69*/ GIMT_Encode4(3507),
     /*  846 */ /*TargetOpcode::G_UMAX*//*Label 70*/ GIMT_Encode4(3530),
     /*  850 */ /*TargetOpcode::G_ABS*//*Label 71*/ GIMT_Encode4(3553), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  882 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 72*/ GIMT_Encode4(3565),
     /*  886 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 73*/ GIMT_Encode4(3577),
     /*  890 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 74*/ GIMT_Encode4(3611),
     /*  894 */ // Label 0: @894
     /*  894 */ GIM_Try, /*On fail goto*//*Label 76*/ GIMT_Encode4(905), // Rule ID 0 //
     /*  899 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /*  902 */   // MIs[0] d
     /*  902 */   // No operand predicates
     /*  902 */   // MIs[0] s
     /*  902 */   // No operand predicates
     /*  902 */   // Combiner Rule #0: copy_prop
     /*  902 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /*  905 */ // Label 76: @905
     /*  905 */ GIM_Reject,
     /*  906 */ // Label 1: @906
     /*  906 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(917), // Rule ID 60 //
     /*  911 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /*  914 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_ADD'
     /*  914 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /*  917 */ // Label 77: @917
     /*  917 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(928), // Rule ID 141 //
     /*  922 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /*  925 */   // Combiner Rule #79: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /*  925 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /*  928 */ // Label 78: @928
     /*  928 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(939), // Rule ID 153 //
     /*  933 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /*  936 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /*  936 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /*  939 */ // Label 79: @939
     /*  939 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(973), // Rule ID 110 //
     /*  944 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /*  947 */   // MIs[0] dst
     /*  947 */   // No operand predicates
     /*  947 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  947 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  955 */   // MIs[1] src
     /*  955 */   // No operand predicates
     /*  955 */   // MIs[1] __add_sub_reg_match_0.x
     /*  955 */   // No operand predicates
     /*  955 */   // MIs[0] __add_sub_reg_match_0.x
     /*  955 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  960 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  965 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967 */   // Combiner Rule #61: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /*  967 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  972 */   GIR_EraseRootFromParent_Done,
     /*  973 */ // Label 80: @973
     /*  973 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1007), // Rule ID 109 //
     /*  978 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /*  981 */   // MIs[0] dst
     /*  981 */   // No operand predicates
     /*  981 */   // MIs[0] __add_sub_reg_match_0.x
     /*  981 */   // No operand predicates
     /*  981 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  981 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  985 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  989 */   // MIs[1] src
     /*  989 */   // No operand predicates
     /*  989 */   // MIs[1] __add_sub_reg_match_0.x
     /*  989 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  994 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  999 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1001 */   // Combiner Rule #61: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1001 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1006 */   GIR_EraseRootFromParent_Done,
     /* 1007 */ // Label 81: @1007
     /* 1007 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1030), // Rule ID 84 //
     /* 1012 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1015 */   // MIs[0] dst
     /* 1015 */   // No operand predicates
     /* 1015 */   // MIs[0] lhs
     /* 1015 */   // No operand predicates
     /* 1015 */   // MIs[0] Operand 2
     /* 1015 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1019 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1024 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1024 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1029 */   GIR_EraseRootFromParent_Done,
     /* 1030 */ // Label 82: @1030
     /* 1030 */ GIM_Reject,
     /* 1031 */ // Label 2: @1031
     /* 1031 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1042), // Rule ID 68 //
     /* 1036 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1039 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1039 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1042 */ // Label 83: @1042
     /* 1042 */ GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1053), // Rule ID 142 //
     /* 1047 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 1050 */   // Combiner Rule #79: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1050 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 1053 */ // Label 84: @1053
     /* 1053 */ GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1076), // Rule ID 83 //
     /* 1058 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1061 */   // MIs[0] dst
     /* 1061 */   // No operand predicates
     /* 1061 */   // MIs[0] lhs
     /* 1061 */   // No operand predicates
     /* 1061 */   // MIs[0] Operand 2
     /* 1061 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1065 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1070 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 1070 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1075 */   GIR_EraseRootFromParent_Done,
     /* 1076 */ // Label 85: @1076
     /* 1076 */ GIM_Reject,
     /* 1077 */ // Label 3: @1077
     /* 1077 */ GIM_Try, /*On fail goto*//*Label 86*/ GIMT_Encode4(1088), // Rule ID 31 //
     /* 1082 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1085 */   // Combiner Rule #24: mul_const; wip_match_opcode 'G_MUL'
     /* 1085 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 1088 */ // Label 86: @1088
     /* 1088 */ GIM_Try, /*On fail goto*//*Label 87*/ GIMT_Encode4(1099), // Rule ID 65 //
     /* 1093 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1096 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 1096 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1099 */ // Label 87: @1099
     /* 1099 */ GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1110), // Rule ID 125 //
     /* 1104 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 1107 */   // Combiner Rule #73: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 1107 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1110 */ // Label 88: @1110
     /* 1110 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1121), // Rule ID 154 //
     /* 1115 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1118 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 1118 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1121 */ // Label 89: @1121
     /* 1121 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1132), // Rule ID 185 //
     /* 1126 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 1129 */   // Combiner Rule #92: combine_mul_cmlt; wip_match_opcode 'G_MUL'
     /* 1129 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 1132 */ // Label 90: @1132
     /* 1132 */ GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1155), // Rule ID 102 //
     /* 1137 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 1140 */   // MIs[0] dst
     /* 1140 */   // No operand predicates
     /* 1140 */   // MIs[0] lhs
     /* 1140 */   // No operand predicates
     /* 1140 */   // MIs[0] zero
     /* 1140 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1144 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1149 */   // Combiner Rule #54: binop_right_to_zero
     /* 1149 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1154 */   GIR_EraseRootFromParent_Done,
     /* 1155 */ // Label 91: @1155
     /* 1155 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1178), // Rule ID 107 //
     /* 1160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 1163 */   // MIs[0] dst
     /* 1163 */   // No operand predicates
     /* 1163 */   // MIs[0] x
     /* 1163 */   // No operand predicates
     /* 1163 */   // MIs[0] Operand 2
     /* 1163 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 1167 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1172 */   // Combiner Rule #59: right_identity_one_int
     /* 1172 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1177 */   GIR_EraseRootFromParent_Done,
     /* 1178 */ // Label 92: @1178
     /* 1178 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1189), // Rule ID 187 //
     /* 1183 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1186 */   // MIs[0] dst
     /* 1186 */   // No operand predicates
     /* 1186 */   // MIs[0] src1
     /* 1186 */   // No operand predicates
     /* 1186 */   // MIs[0] src2
     /* 1186 */   // No operand predicates
     /* 1186 */   // Combiner Rule #94: extmultomull
     /* 1186 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 1189 */ // Label 93: @1189
     /* 1189 */ GIM_Reject,
     /* 1190 */ // Label 4: @1190
     /* 1190 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1201), // Rule ID 71 //
     /* 1195 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1198 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 1198 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1201 */ // Label 94: @1201
     /* 1201 */ GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1212), // Rule ID 98 //
     /* 1206 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1209 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 1209 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1212 */ // Label 95: @1212
     /* 1212 */ GIM_Reject,
     /* 1213 */ // Label 5: @1213
     /* 1213 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1224), // Rule ID 70 //
     /* 1218 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1221 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 1221 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1224 */ // Label 96: @1224
     /* 1224 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1235), // Rule ID 99 //
     /* 1229 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1232 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 1232 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1235 */ // Label 97: @1235
     /* 1235 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1246), // Rule ID 128 //
     /* 1240 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 1243 */   // Combiner Rule #75: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 1243 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 1246 */ // Label 98: @1246
     /* 1246 */ GIM_Reject,
     /* 1247 */ // Label 6: @1247
     /* 1247 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1258), // Rule ID 73 //
     /* 1252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1255 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 1255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1258 */ // Label 99: @1258
     /* 1258 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1269), // Rule ID 100 //
     /* 1263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1266 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 1266 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1269 */ // Label 100: @1269
     /* 1269 */ GIM_Reject,
     /* 1270 */ // Label 7: @1270
     /* 1270 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1281), // Rule ID 72 //
     /* 1275 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1278 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 1278 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1281 */ // Label 101: @1281
     /* 1281 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1292), // Rule ID 101 //
     /* 1286 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1289 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 1289 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1292 */ // Label 102: @1292
     /* 1292 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1303), // Rule ID 129 //
     /* 1297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 1300 */   // Combiner Rule #75: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 1300 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 1303 */ // Label 103: @1303
     /* 1303 */ GIM_Reject,
     /* 1304 */ // Label 8: @1304
     /* 1304 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1315), // Rule ID 18 //
     /* 1309 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1312 */   // Combiner Rule #16: load_and_mask; wip_match_opcode 'G_AND'
     /* 1312 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1315 */ // Label 104: @1315
     /* 1315 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1326), // Rule ID 24 //
     /* 1320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1323 */   // Combiner Rule #19: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 1323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1326 */ // Label 105: @1326
     /* 1326 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1337), // Rule ID 27 //
     /* 1331 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 1334 */   // Combiner Rule #20: redundant_and; wip_match_opcode 'G_AND'
     /* 1334 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1337 */ // Label 106: @1337
     /* 1337 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1348), // Rule ID 62 //
     /* 1342 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1345 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 1345 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1348 */ // Label 107: @1348
     /* 1348 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1359), // Rule ID 120 //
     /* 1353 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 1356 */   // Combiner Rule #70: overlapping_and; wip_match_opcode 'G_AND'
     /* 1356 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 1359 */ // Label 108: @1359
     /* 1359 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1370), // Rule ID 124 //
     /* 1364 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 1367 */   // Combiner Rule #73: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 1367 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1370 */ // Label 109: @1370
     /* 1370 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1381), // Rule ID 155 //
     /* 1375 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1378 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 1378 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1381 */ // Label 110: @1381
     /* 1381 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1418), // Rule ID 34 //
     /* 1386 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 1389 */   // MIs[0] root
     /* 1389 */   // No operand predicates
     /* 1389 */   // MIs[0] shift
     /* 1389 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 1397 */   // MIs[1] x
     /* 1397 */   // No operand predicates
     /* 1397 */   // MIs[1] lsb
     /* 1397 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1401 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1405 */   // MIs[2] imm1
     /* 1405 */   // No operand predicates
     /* 1405 */   // MIs[0] mask
     /* 1405 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1409 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413 */   // MIs[3] imm2
     /* 1413 */   // No operand predicates
     /* 1413 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1415 */   // Combiner Rule #27: bitfield_extract_from_and
     /* 1415 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 1418 */ // Label 111: @1418
     /* 1418 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1442), // Rule ID 93 //
     /* 1423 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 1426 */   // MIs[0] dst
     /* 1426 */   // No operand predicates
     /* 1426 */   // MIs[0] src
     /* 1426 */   // No operand predicates
     /* 1426 */   // MIs[0] src
     /* 1426 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1431 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1436 */   // Combiner Rule #52: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 1436 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1441 */   GIR_EraseRootFromParent_Done,
     /* 1442 */ // Label 112: @1442
     /* 1442 */ GIM_Reject,
     /* 1443 */ // Label 9: @1443
     /* 1443 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1454), // Rule ID 25 //
     /* 1448 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1451 */   // Combiner Rule #19: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 1451 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1454 */ // Label 113: @1454
     /* 1454 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1465), // Rule ID 30 //
     /* 1459 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1462 */   // Combiner Rule #23: redundant_or; wip_match_opcode 'G_OR'
     /* 1462 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1465 */ // Label 114: @1465
     /* 1465 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1476), // Rule ID 66 //
     /* 1470 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1473 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 1473 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1476 */ // Label 115: @1476
     /* 1476 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1487), // Rule ID 126 //
     /* 1481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 1484 */   // Combiner Rule #74: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 1484 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 1487 */ // Label 116: @1487
     /* 1487 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1498), // Rule ID 156 //
     /* 1492 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1495 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 1495 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1498 */ // Label 117: @1498
     /* 1498 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1522), // Rule ID 94 //
     /* 1503 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 1506 */   // MIs[0] dst
     /* 1506 */   // No operand predicates
     /* 1506 */   // MIs[0] src
     /* 1506 */   // No operand predicates
     /* 1506 */   // MIs[0] src
     /* 1506 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1511 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1516 */   // Combiner Rule #52: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 1516 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1521 */   GIR_EraseRootFromParent_Done,
     /* 1522 */ // Label 118: @1522
     /* 1522 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1545), // Rule ID 85 //
     /* 1527 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1530 */   // MIs[0] dst
     /* 1530 */   // No operand predicates
     /* 1530 */   // MIs[0] lhs
     /* 1530 */   // No operand predicates
     /* 1530 */   // MIs[0] Operand 2
     /* 1530 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1534 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1539 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 1539 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1544 */   GIR_EraseRootFromParent_Done,
     /* 1545 */ // Label 119: @1545
     /* 1545 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1556), // Rule ID 151 //
     /* 1550 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 1553 */   // MIs[0] dst
     /* 1553 */   // No operand predicates
     /* 1553 */   // MIs[0] src1
     /* 1553 */   // No operand predicates
     /* 1553 */   // MIs[0] src2
     /* 1553 */   // No operand predicates
     /* 1553 */   // Combiner Rule #85: or_to_bsp
     /* 1553 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 1556 */ // Label 120: @1556
     /* 1556 */ GIM_Reject,
     /* 1557 */ // Label 10: @1557
     /* 1557 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1568), // Rule ID 26 //
     /* 1562 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1565 */   // Combiner Rule #19: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 1565 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1568 */ // Label 121: @1568
     /* 1568 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1579), // Rule ID 28 //
     /* 1573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 1576 */   // Combiner Rule #21: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 1576 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1579 */ // Label 122: @1579
     /* 1579 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1590), // Rule ID 69 //
     /* 1584 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1587 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 1587 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1590 */ // Label 123: @1590
     /* 1590 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1601), // Rule ID 143 //
     /* 1595 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 1598 */   // Combiner Rule #79: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 1598 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 1601 */ // Label 124: @1601
     /* 1601 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1612), // Rule ID 157 //
     /* 1606 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1609 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 1609 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1612 */ // Label 125: @1612
     /* 1612 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1635), // Rule ID 86 //
     /* 1617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1620 */   // MIs[0] dst
     /* 1620 */   // No operand predicates
     /* 1620 */   // MIs[0] lhs
     /* 1620 */   // No operand predicates
     /* 1620 */   // MIs[0] Operand 2
     /* 1620 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1624 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1629 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 1629 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1634 */   GIR_EraseRootFromParent_Done,
     /* 1635 */ // Label 126: @1635
     /* 1635 */ GIM_Reject,
     /* 1636 */ // Label 11: @1636
     /* 1636 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1647), // Rule ID 51 //
     /* 1641 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 1644 */   // Combiner Rule #39: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1644 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 1647 */ // Label 127: @1647
     /* 1647 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1658), // Rule ID 52 //
     /* 1652 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 1655 */   // Combiner Rule #40: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1655 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 1658 */ // Label 128: @1658
     /* 1658 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1669), // Rule ID 54 //
     /* 1663 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 1666 */   // Combiner Rule #42: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1666 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 1669 */ // Label 129: @1669
     /* 1669 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1680), // Rule ID 55 //
     /* 1674 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 1677 */   // Combiner Rule #43: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1677 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 1680 */ // Label 130: @1680
     /* 1680 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1691), // Rule ID 56 //
     /* 1685 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 1688 */   // Combiner Rule #44: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1688 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 1691 */ // Label 131: @1691
     /* 1691 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1702), // Rule ID 57 //
     /* 1696 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 1699 */   // Combiner Rule #45: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1699 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 1702 */ // Label 132: @1702
     /* 1702 */ GIM_Reject,
     /* 1703 */ // Label 12: @1703
     /* 1703 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1714), // Rule ID 50 //
     /* 1708 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 1711 */   // Combiner Rule #38: fold_merge_to_zext; wip_match_opcode 'G_MERGE_VALUES'
     /* 1711 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 1714 */ // Label 133: @1714
     /* 1714 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1725), // Rule ID 53 //
     /* 1719 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 1722 */   // Combiner Rule #41: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 1722 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 1725 */ // Label 134: @1725
     /* 1725 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(1787),
     /* 1730 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 1733 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(1754), // Rule ID 58 //
     /* 1738 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 1741 */     // MIs[0] root
     /* 1741 */     // No operand predicates
     /* 1741 */     // MIs[0] x
     /* 1741 */     // No operand predicates
     /* 1741 */     // MIs[0] undef
     /* 1741 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1751 */     // Combiner Rule #46: merge_of_x_and_undef
     /* 1751 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 1754 */   // Label 136: @1754
     /* 1754 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(1786), // Rule ID 59 //
     /* 1759 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 1762 */     // MIs[0] root
     /* 1762 */     // No operand predicates
     /* 1762 */     // MIs[0] x
     /* 1762 */     // No operand predicates
     /* 1762 */     // MIs[0] zero
     /* 1762 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1770 */     // MIs[1] Operand 1
     /* 1770 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 1781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1783 */     // Combiner Rule #47: merge_of_x_and_zero
     /* 1783 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1786 */   // Label 137: @1786
     /* 1786 */   GIM_Reject,
     /* 1787 */ // Label 135: @1787
     /* 1787 */ GIM_Reject,
     /* 1788 */ // Label 13: @1788
     /* 1788 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(1799), // Rule ID 112 //
     /* 1793 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 1796 */   // Combiner Rule #62: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1796 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 1799 */ // Label 138: @1799
     /* 1799 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(1810), // Rule ID 145 //
     /* 1804 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 1807 */   // Combiner Rule #80: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1807 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 1810 */ // Label 139: @1810
     /* 1810 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(1821), // Rule ID 183 //
     /* 1815 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 1818 */   // Combiner Rule #90: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1818 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 1821 */ // Label 140: @1821
     /* 1821 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(1835), // Rule ID 186 //
     /* 1826 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1829 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 1832 */   // MIs[0] dst
     /* 1832 */   // No operand predicates
     /* 1832 */   // MIs[0] unused
     /* 1832 */   // No operand predicates
     /* 1832 */   // Combiner Rule #93: combine_use_vector_truncate
     /* 1832 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 1835 */ // Label 141: @1835
     /* 1835 */ GIM_Reject,
     /* 1836 */ // Label 14: @1836
     /* 1836 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(1847), // Rule ID 111 //
     /* 1841 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 1844 */   // Combiner Rule #62: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 1844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 1847 */ // Label 142: @1847
     /* 1847 */ GIM_Reject,
     /* 1848 */ // Label 15: @1848
     /* 1848 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(1859), // Rule ID 152 //
     /* 1853 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 1856 */   // Combiner Rule #86: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 1856 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 1859 */ // Label 143: @1859
     /* 1859 */ GIM_Reject,
     /* 1860 */ // Label 16: @1860
     /* 1860 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(1881), // Rule ID 104 //
     /* 1865 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 1868 */   // MIs[0] dst
     /* 1868 */   // No operand predicates
     /* 1868 */   // MIs[0] t
     /* 1868 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 1876 */   // MIs[1] ptr
     /* 1876 */   // No operand predicates
     /* 1876 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1878 */   // Combiner Rule #56: i2p_to_p2i
     /* 1878 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 1881 */ // Label 144: @1881
     /* 1881 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(1902), // Rule ID 137 //
     /* 1886 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1889 */   // MIs[0] dst
     /* 1889 */   // No operand predicates
     /* 1889 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 1889 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1893 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1897 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1899 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 1899 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1902 */ // Label 145: @1902
     /* 1902 */ GIM_Reject,
     /* 1903 */ // Label 17: @1903
     /* 1903 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(1914), // Rule ID 103 //
     /* 1908 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 1911 */   // Combiner Rule #55: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 1911 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 1914 */ // Label 146: @1914
     /* 1914 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(1935), // Rule ID 138 //
     /* 1919 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1922 */   // MIs[0] dst
     /* 1922 */   // No operand predicates
     /* 1922 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 1922 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1930 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1932 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 1932 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1935 */ // Label 147: @1935
     /* 1935 */ GIM_Reject,
     /* 1936 */ // Label 18: @1936
     /* 1936 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(1957), // Rule ID 115 //
     /* 1941 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 1944 */   // MIs[0] dst
     /* 1944 */   // No operand predicates
     /* 1944 */   // MIs[0] src1
     /* 1944 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 1952 */   // MIs[1] src0
     /* 1952 */   // No operand predicates
     /* 1952 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1954 */   // Combiner Rule #65: bitcast_bitcast_fold
     /* 1954 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 1957 */ // Label 148: @1957
     /* 1957 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(1978), // Rule ID 135 //
     /* 1962 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1965 */   // MIs[0] dst
     /* 1965 */   // No operand predicates
     /* 1965 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 1965 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1973 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1975 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 1975 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1978 */ // Label 149: @1978
     /* 1978 */ GIM_Reject,
     /* 1979 */ // Label 19: @1979
     /* 1979 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(1990), // Rule ID 184 //
     /* 1984 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 1987 */   // MIs[0] dst
     /* 1987 */   // No operand predicates
     /* 1987 */   // MIs[0] src
     /* 1987 */   // No operand predicates
     /* 1987 */   // Combiner Rule #91: push_freeze_to_prevent_poison_from_propagating
     /* 1987 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 1990 */ // Label 150: @1990
     /* 1990 */ GIM_Reject,
     /* 1991 */ // Label 20: @1991
     /* 1991 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2002), // Rule ID 15 //
     /* 1996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 1999 */   // Combiner Rule #15: extending_loads; wip_match_opcode 'G_LOAD'
     /* 1999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2002 */ // Label 151: @2002
     /* 2002 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2013), // Rule ID 19 //
     /* 2007 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2010 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_LOAD'
     /* 2010 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2013 */ // Label 152: @2013
     /* 2013 */ GIM_Reject,
     /* 2014 */ // Label 21: @2014
     /* 2014 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2025), // Rule ID 16 //
     /* 2019 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2022 */   // Combiner Rule #15: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 2022 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2025 */ // Label 153: @2025
     /* 2025 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2036), // Rule ID 20 //
     /* 2030 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2033 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_SEXTLOAD'
     /* 2033 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2036 */ // Label 154: @2036
     /* 2036 */ GIM_Reject,
     /* 2037 */ // Label 22: @2037
     /* 2037 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2048), // Rule ID 17 //
     /* 2042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2045 */   // Combiner Rule #15: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 2045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2048 */ // Label 155: @2048
     /* 2048 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2059), // Rule ID 21 //
     /* 2053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2056 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_ZEXTLOAD'
     /* 2056 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2059 */ // Label 156: @2059
     /* 2059 */ GIM_Reject,
     /* 2060 */ // Label 23: @2060
     /* 2060 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2071), // Rule ID 22 //
     /* 2065 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2068 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_STORE'
     /* 2068 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2071 */ // Label 157: @2071
     /* 2071 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2082), // Rule ID 147 //
     /* 2076 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 2079 */   // Combiner Rule #82: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 2079 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 2082 */ // Label 158: @2082
     /* 2082 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2093), // Rule ID 121 //
     /* 2087 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 2090 */   // MIs[0] src
     /* 2090 */   // No operand predicates
     /* 2090 */   // MIs[0] addr
     /* 2090 */   // No operand predicates
     /* 2090 */   // Combiner Rule #71: split_store_zero_128
     /* 2090 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 2093 */ // Label 159: @2093
     /* 2093 */ GIM_Reject,
     /* 2094 */ // Label 24: @2094
     /* 2094 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2105), // Rule ID 14 //
     /* 2099 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2102 */   // Combiner Rule #14: mutate_anyext_to_zext; wip_match_opcode 'G_ANYEXT'
     /* 2102 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2105 */ // Label 160: @2105
     /* 2105 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2116), // Rule ID 105 //
     /* 2110 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 2113 */   // Combiner Rule #57: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 2113 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2116 */ // Label 161: @2116
     /* 2116 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2137), // Rule ID 8 //
     /* 2121 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 2124 */   // MIs[0] root
     /* 2124 */   // No operand predicates
     /* 2124 */   // MIs[0] second
     /* 2124 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2128 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2132 */   // MIs[1] src
     /* 2132 */   // No operand predicates
     /* 2132 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2134 */   // Combiner Rule #8: anyext_of_anyext
     /* 2134 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2137 */ // Label 162: @2137
     /* 2137 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2158), // Rule ID 10 //
     /* 2142 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 2145 */   // MIs[0] root
     /* 2145 */   // No operand predicates
     /* 2145 */   // MIs[0] second
     /* 2145 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2153 */   // MIs[1] src
     /* 2153 */   // No operand predicates
     /* 2153 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2155 */   // Combiner Rule #10: anyext_of_sext
     /* 2155 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2158 */ // Label 163: @2158
     /* 2158 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2179), // Rule ID 9 //
     /* 2163 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 2166 */   // MIs[0] root
     /* 2166 */   // No operand predicates
     /* 2166 */   // MIs[0] second
     /* 2166 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2170 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2174 */   // MIs[1] src
     /* 2174 */   // No operand predicates
     /* 2174 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2176 */   // Combiner Rule #9: anyext_of_zext
     /* 2176 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2179 */ // Label 164: @2179
     /* 2179 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2200), // Rule ID 136 //
     /* 2184 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 2187 */   // MIs[0] dst
     /* 2187 */   // No operand predicates
     /* 2187 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 2187 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 2195 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2197 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 2197 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 2200 */ // Label 165: @2200
     /* 2200 */ GIM_Reject,
     /* 2201 */ // Label 25: @2201
     /* 2201 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2212), // Rule ID 113 //
     /* 2206 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 2209 */   // Combiner Rule #63: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 2209 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 2212 */ // Label 166: @2212
     /* 2212 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2223), // Rule ID 114 //
     /* 2217 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 2220 */   // Combiner Rule #64: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 2220 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 2223 */ // Label 167: @2223
     /* 2223 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2244), // Rule ID 3 //
     /* 2228 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 2231 */   // MIs[0] root
     /* 2231 */   // No operand predicates
     /* 2231 */   // MIs[0] ext
     /* 2231 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2239 */   // MIs[1] src
     /* 2239 */   // No operand predicates
     /* 2239 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241 */   // Combiner Rule #3: truncate_of_anyext
     /* 2241 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2244 */ // Label 168: @2244
     /* 2244 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2268), // Rule ID 12 //
     /* 2249 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 2252 */   // MIs[0] root
     /* 2252 */   // No operand predicates
     /* 2252 */   // MIs[0] bv
     /* 2252 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 2260 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 2263 */   // MIs[1] unused
     /* 2263 */   // No operand predicates
     /* 2263 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2265 */   // Combiner Rule #12: buildvector_of_truncate
     /* 2265 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 2268 */ // Label 169: @2268
     /* 2268 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2289), // Rule ID 2 //
     /* 2273 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 2276 */   // MIs[0] root
     /* 2276 */   // No operand predicates
     /* 2276 */   // MIs[0] ext
     /* 2276 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2284 */   // MIs[1] src
     /* 2284 */   // No operand predicates
     /* 2284 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2286 */   // Combiner Rule #2: truncate_of_sext
     /* 2286 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2289 */ // Label 170: @2289
     /* 2289 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2310), // Rule ID 1 //
     /* 2294 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 2297 */   // MIs[0] root
     /* 2297 */   // No operand predicates
     /* 2297 */   // MIs[0] ext
     /* 2297 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2301 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2305 */   // MIs[1] src
     /* 2305 */   // No operand predicates
     /* 2305 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307 */   // Combiner Rule #1: truncate_of_zext
     /* 2307 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2310 */ // Label 171: @2310
     /* 2310 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2331), // Rule ID 134 //
     /* 2315 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 2318 */   // MIs[0] dst
     /* 2318 */   // No operand predicates
     /* 2318 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 2318 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 2326 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2328 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 2328 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 2331 */ // Label 172: @2331
     /* 2331 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2352), // Rule ID 13 //
     /* 2336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 2339 */   // MIs[0] root
     /* 2339 */   // No operand predicates
     /* 2339 */   // MIs[0] int
     /* 2339 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2347 */   // MIs[1] imm
     /* 2347 */   // No operand predicates
     /* 2347 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2349 */   // Combiner Rule #13: integer_of_truncate
     /* 2349 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 2352 */ // Label 173: @2352
     /* 2352 */ GIM_Reject,
     /* 2353 */ // Label 26: @2353
     /* 2353 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2374), // Rule ID 7 //
     /* 2358 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 2361 */   // MIs[0] root
     /* 2361 */   // No operand predicates
     /* 2361 */   // MIs[0] second
     /* 2361 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2365 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2369 */   // MIs[1] src
     /* 2369 */   // No operand predicates
     /* 2369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2371 */   // Combiner Rule #7: sext_of_anyext
     /* 2371 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2374 */ // Label 174: @2374
     /* 2374 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2395), // Rule ID 6 //
     /* 2379 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 2382 */   // MIs[0] root
     /* 2382 */   // No operand predicates
     /* 2382 */   // MIs[0] second
     /* 2382 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2390 */   // MIs[1] src
     /* 2390 */   // No operand predicates
     /* 2390 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392 */   // Combiner Rule #6: sext_of_sext
     /* 2392 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2395 */ // Label 175: @2395
     /* 2395 */ GIM_Reject,
     /* 2396 */ // Label 27: @2396
     /* 2396 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2407), // Rule ID 23 //
     /* 2401 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 2404 */   // Combiner Rule #18: sext_trunc_sextload; wip_match_opcode 'G_SEXT_INREG'
     /* 2404 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 2407 */ // Label 176: @2407
     /* 2407 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2418), // Rule ID 32 //
     /* 2412 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 2415 */   // Combiner Rule #25: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 2415 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 2418 */ // Label 177: @2418
     /* 2418 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2429), // Rule ID 33 //
     /* 2423 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 2426 */   // Combiner Rule #26: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 2426 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 2429 */ // Label 178: @2429
     /* 2429 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2450), // Rule ID 11 //
     /* 2434 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 2437 */   // MIs[0] dst
     /* 2437 */   // No operand predicates
     /* 2437 */   // MIs[0] x
     /* 2437 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2441 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2445 */   // MIs[1] src
     /* 2445 */   // No operand predicates
     /* 2445 */   // MIs[1] a
     /* 2445 */   // No operand predicates
     /* 2445 */   // MIs[0] b
     /* 2445 */   // No operand predicates
     /* 2445 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447 */   // Combiner Rule #11: sext_inreg_of_sext_inreg
     /* 2447 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 2450 */ // Label 179: @2450
     /* 2450 */ GIM_Reject,
     /* 2451 */ // Label 28: @2451
     /* 2451 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2472), // Rule ID 5 //
     /* 2456 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 2459 */   // MIs[0] root
     /* 2459 */   // No operand predicates
     /* 2459 */   // MIs[0] second
     /* 2459 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2467 */   // MIs[1] src
     /* 2467 */   // No operand predicates
     /* 2467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2469 */   // Combiner Rule #5: zext_of_anyext
     /* 2469 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2472 */ // Label 180: @2472
     /* 2472 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2493), // Rule ID 4 //
     /* 2477 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 2480 */   // MIs[0] root
     /* 2480 */   // No operand predicates
     /* 2480 */   // MIs[0] second
     /* 2480 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2488 */   // MIs[1] src
     /* 2488 */   // No operand predicates
     /* 2488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2490 */   // Combiner Rule #4: zext_of_zext
     /* 2490 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2493 */ // Label 181: @2493
     /* 2493 */ GIM_Reject,
     /* 2494 */ // Label 29: @2494
     /* 2494 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2505), // Rule ID 67 //
     /* 2499 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 2502 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 2502 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2505 */ // Label 182: @2505
     /* 2505 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2516), // Rule ID 95 //
     /* 2510 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 2513 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 2513 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 2516 */ // Label 183: @2516
     /* 2516 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2527), // Rule ID 127 //
     /* 2521 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 2524 */   // Combiner Rule #75: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 2524 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 2527 */ // Label 184: @2527
     /* 2527 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2538), // Rule ID 130 //
     /* 2532 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 2535 */   // Combiner Rule #76: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 2535 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 2538 */ // Label 185: @2538
     /* 2538 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2561), // Rule ID 87 //
     /* 2543 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2546 */   // MIs[0] dst
     /* 2546 */   // No operand predicates
     /* 2546 */   // MIs[0] lhs
     /* 2546 */   // No operand predicates
     /* 2546 */   // MIs[0] Operand 2
     /* 2546 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2550 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2555 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 2555 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2560 */   GIR_EraseRootFromParent_Done,
     /* 2561 */ // Label 186: @2561
     /* 2561 */ GIM_Reject,
     /* 2562 */ // Label 30: @2562
     /* 2562 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2573), // Rule ID 36 //
     /* 2567 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 2570 */   // Combiner Rule #28: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 2570 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 2573 */ // Label 187: @2573
     /* 2573 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2584), // Rule ID 38 //
     /* 2578 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 2581 */   // Combiner Rule #29: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 2581 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 2584 */ // Label 188: @2584
     /* 2584 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2595), // Rule ID 64 //
     /* 2589 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 2592 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 2592 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2595 */ // Label 189: @2595
     /* 2595 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2606), // Rule ID 96 //
     /* 2600 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 2603 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 2603 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 2606 */ // Label 190: @2606
     /* 2606 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2617), // Rule ID 132 //
     /* 2611 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 2614 */   // Combiner Rule #76: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 2614 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 2617 */ // Label 191: @2617
     /* 2617 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2640), // Rule ID 89 //
     /* 2622 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2625 */   // MIs[0] dst
     /* 2625 */   // No operand predicates
     /* 2625 */   // MIs[0] lhs
     /* 2625 */   // No operand predicates
     /* 2625 */   // MIs[0] Operand 2
     /* 2625 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2629 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2634 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 2634 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2639 */   GIR_EraseRootFromParent_Done,
     /* 2640 */ // Label 192: @2640
     /* 2640 */ GIM_Reject,
     /* 2641 */ // Label 31: @2641
     /* 2641 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2652), // Rule ID 35 //
     /* 2646 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 2649 */   // Combiner Rule #28: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 2649 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 2652 */ // Label 193: @2652
     /* 2652 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2663), // Rule ID 37 //
     /* 2657 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 2660 */   // Combiner Rule #29: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 2660 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 2663 */ // Label 194: @2663
     /* 2663 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2674), // Rule ID 63 //
     /* 2668 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 2671 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 2671 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2674 */ // Label 195: @2674
     /* 2674 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(2685), // Rule ID 97 //
     /* 2679 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 2682 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 2682 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 2685 */ // Label 196: @2685
     /* 2685 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(2696), // Rule ID 131 //
     /* 2690 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 2693 */   // Combiner Rule #76: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 2693 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 2696 */ // Label 197: @2696
     /* 2696 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(2719), // Rule ID 88 //
     /* 2701 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2704 */   // MIs[0] dst
     /* 2704 */   // No operand predicates
     /* 2704 */   // MIs[0] lhs
     /* 2704 */   // No operand predicates
     /* 2704 */   // MIs[0] Operand 2
     /* 2704 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2708 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2713 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 2713 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2718 */   GIR_EraseRootFromParent_Done,
     /* 2719 */ // Label 198: @2719
     /* 2719 */ GIM_Reject,
     /* 2720 */ // Label 32: @2720
     /* 2720 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(2731), // Rule ID 39 //
     /* 2725 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 2728 */   // Combiner Rule #30: rotate_out_of_range; wip_match_opcode 'G_ROTR'
     /* 2728 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 2731 */ // Label 199: @2731
     /* 2731 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(2754), // Rule ID 92 //
     /* 2736 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2739 */   // MIs[0] dst
     /* 2739 */   // No operand predicates
     /* 2739 */   // MIs[0] lhs
     /* 2739 */   // No operand predicates
     /* 2739 */   // MIs[0] Operand 2
     /* 2739 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2743 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2748 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 2748 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2753 */   GIR_EraseRootFromParent_Done,
     /* 2754 */ // Label 200: @2754
     /* 2754 */ GIM_Reject,
     /* 2755 */ // Label 33: @2755
     /* 2755 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2766), // Rule ID 40 //
     /* 2760 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 2763 */   // Combiner Rule #30: rotate_out_of_range; wip_match_opcode 'G_ROTL'
     /* 2763 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 2766 */ // Label 201: @2766
     /* 2766 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(2789), // Rule ID 91 //
     /* 2771 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2774 */   // MIs[0] dst
     /* 2774 */   // No operand predicates
     /* 2774 */   // MIs[0] lhs
     /* 2774 */   // No operand predicates
     /* 2774 */   // MIs[0] Operand 2
     /* 2774 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2778 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2783 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 2783 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2788 */   GIR_EraseRootFromParent_Done,
     /* 2789 */ // Label 202: @2789
     /* 2789 */ GIM_Reject,
     /* 2790 */ // Label 34: @2790
     /* 2790 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(2801), // Rule ID 41 //
     /* 2795 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 2798 */   // Combiner Rule #31: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 2798 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 2801 */ // Label 203: @2801
     /* 2801 */ GIM_Reject,
     /* 2802 */ // Label 35: @2802
     /* 2802 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(2813), // Rule ID 47 //
     /* 2807 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 2810 */   // Combiner Rule #35: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 2810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 2813 */ // Label 204: @2813
     /* 2813 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(2824), // Rule ID 49 //
     /* 2818 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 2821 */   // Combiner Rule #37: match_selects; wip_match_opcode 'G_SELECT'
     /* 2821 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 2824 */ // Label 205: @2824
     /* 2824 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(2835), // Rule ID 82 //
     /* 2829 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 2832 */   // Combiner Rule #50: select_same_val; wip_match_opcode 'G_SELECT'
     /* 2832 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 2835 */ // Label 206: @2835
     /* 2835 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(2846), // Rule ID 150 //
     /* 2840 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2843 */   // Combiner Rule #84: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 2843 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 2846 */ // Label 207: @2846
     /* 2846 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(2867), // Rule ID 48 //
     /* 2851 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 2854 */   // MIs[0] root
     /* 2854 */   // No operand predicates
     /* 2854 */   // MIs[0] tst
     /* 2854 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2862 */   // MIs[1] tst1
     /* 2862 */   // No operand predicates
     /* 2862 */   // MIs[1] a
     /* 2862 */   // No operand predicates
     /* 2862 */   // MIs[1] b
     /* 2862 */   // No operand predicates
     /* 2862 */   // MIs[0] x
     /* 2862 */   // No operand predicates
     /* 2862 */   // MIs[0] y
     /* 2862 */   // No operand predicates
     /* 2862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2864 */   // Combiner Rule #36: select_to_iminmax
     /* 2864 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 2867 */ // Label 208: @2867
     /* 2867 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(2896), // Rule ID 46 //
     /* 2872 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 2875 */   // MIs[0] dst
     /* 2875 */   // No operand predicates
     /* 2875 */   // MIs[0] undef
     /* 2875 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 2883 */   // MIs[0] x
     /* 2883 */   // No operand predicates
     /* 2883 */   // MIs[0] y
     /* 2883 */   // No operand predicates
     /* 2883 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 2888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2890 */   // Combiner Rule #34: select_undef_cmp
     /* 2890 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 2895 */   GIR_EraseRootFromParent_Done,
     /* 2896 */ // Label 209: @2896
     /* 2896 */ GIM_Reject,
     /* 2897 */ // Label 36: @2897
     /* 2897 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(2908), // Rule ID 43 //
     /* 2902 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 2905 */   // Combiner Rule #32: match_addos; wip_match_opcode 'G_UADDO'
     /* 2905 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 2908 */ // Label 210: @2908
     /* 2908 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(2919), // Rule ID 162 //
     /* 2913 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2916 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 2916 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2919 */ // Label 211: @2919
     /* 2919 */ GIM_Reject,
     /* 2920 */ // Label 37: @2920
     /* 2920 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(2931), // Rule ID 45 //
     /* 2925 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 2928 */   // Combiner Rule #33: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 2928 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 2931 */ // Label 212: @2931
     /* 2931 */ GIM_Reject,
     /* 2932 */ // Label 38: @2932
     /* 2932 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(2943), // Rule ID 42 //
     /* 2937 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 2940 */   // Combiner Rule #32: match_addos; wip_match_opcode 'G_SADDO'
     /* 2940 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 2943 */ // Label 213: @2943
     /* 2943 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(2954), // Rule ID 163 //
     /* 2948 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2951 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 2951 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2954 */ // Label 214: @2954
     /* 2954 */ GIM_Reject,
     /* 2955 */ // Label 39: @2955
     /* 2955 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(2966), // Rule ID 44 //
     /* 2960 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 2963 */   // Combiner Rule #33: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 2963 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 2966 */ // Label 215: @2966
     /* 2966 */ GIM_Reject,
     /* 2967 */ // Label 40: @2967
     /* 2967 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(2978), // Rule ID 164 //
     /* 2972 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2975 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 2975 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2978 */ // Label 216: @2978
     /* 2978 */ GIM_Reject,
     /* 2979 */ // Label 41: @2979
     /* 2979 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(2990), // Rule ID 165 //
     /* 2984 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2987 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 2987 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2990 */ // Label 217: @2990
     /* 2990 */ GIM_Reject,
     /* 2991 */ // Label 42: @2991
     /* 2991 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3002), // Rule ID 166 //
     /* 2996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2999 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 2999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3002 */ // Label 218: @3002
     /* 3002 */ GIM_Reject,
     /* 3003 */ // Label 43: @3003
     /* 3003 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3014), // Rule ID 167 //
     /* 3008 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3011 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 3011 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3014 */ // Label 219: @3014
     /* 3014 */ GIM_Reject,
     /* 3015 */ // Label 44: @3015
     /* 3015 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3026), // Rule ID 168 //
     /* 3020 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3023 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 3023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3026 */ // Label 220: @3026
     /* 3026 */ GIM_Reject,
     /* 3027 */ // Label 45: @3027
     /* 3027 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3038), // Rule ID 169 //
     /* 3032 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3035 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 3035 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3038 */ // Label 221: @3038
     /* 3038 */ GIM_Reject,
     /* 3039 */ // Label 46: @3039
     /* 3039 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3050), // Rule ID 170 //
     /* 3044 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3047 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 3047 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3050 */ // Label 222: @3050
     /* 3050 */ GIM_Reject,
     /* 3051 */ // Label 47: @3051
     /* 3051 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3062), // Rule ID 171 //
     /* 3056 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3059 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 3059 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3062 */ // Label 223: @3062
     /* 3062 */ GIM_Reject,
     /* 3063 */ // Label 48: @3063
     /* 3063 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3074), // Rule ID 172 //
     /* 3068 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3071 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 3071 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3074 */ // Label 224: @3074
     /* 3074 */ GIM_Reject,
     /* 3075 */ // Label 49: @3075
     /* 3075 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3086), // Rule ID 173 //
     /* 3080 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3083 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 3083 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3086 */ // Label 225: @3086
     /* 3086 */ GIM_Reject,
     /* 3087 */ // Label 50: @3087
     /* 3087 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3098), // Rule ID 78 //
     /* 3092 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3095 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 3095 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3098 */ // Label 226: @3098
     /* 3098 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3109), // Rule ID 174 //
     /* 3103 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3106 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 3106 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3109 */ // Label 227: @3109
     /* 3109 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3132), // Rule ID 117 //
     /* 3114 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3117 */   // MIs[0] dst
     /* 3117 */   // No operand predicates
     /* 3117 */   // MIs[0] x
     /* 3117 */   // No operand predicates
     /* 3117 */   // MIs[0] y
     /* 3117 */   // No operand predicates
     /* 3117 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3121 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3126 */   // Combiner Rule #67: right_identity_neg_zero_fp
     /* 3126 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3131 */   GIR_EraseRootFromParent_Done,
     /* 3132 */ // Label 228: @3132
     /* 3132 */ GIM_Reject,
     /* 3133 */ // Label 51: @3133
     /* 3133 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3144), // Rule ID 79 //
     /* 3138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3141 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 3141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3144 */ // Label 229: @3144
     /* 3144 */ GIM_Reject,
     /* 3145 */ // Label 52: @3145
     /* 3145 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3156), // Rule ID 80 //
     /* 3150 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3153 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 3153 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3156 */ // Label 230: @3156
     /* 3156 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3167), // Rule ID 175 //
     /* 3161 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3164 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 3164 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3167 */ // Label 231: @3167
     /* 3167 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3190), // Rule ID 108 //
     /* 3172 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3175 */   // MIs[0] dst
     /* 3175 */   // No operand predicates
     /* 3175 */   // MIs[0] x
     /* 3175 */   // No operand predicates
     /* 3175 */   // MIs[0] y
     /* 3175 */   // No operand predicates
     /* 3175 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 3179 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3184 */   // Combiner Rule #60: right_identity_one_fp
     /* 3184 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3189 */   GIR_EraseRootFromParent_Done,
     /* 3190 */ // Label 232: @3190
     /* 3190 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3210), // Rule ID 118 //
     /* 3195 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3198 */   // MIs[0] dst
     /* 3198 */   // No operand predicates
     /* 3198 */   // MIs[0] x
     /* 3198 */   // No operand predicates
     /* 3198 */   // MIs[0] y
     /* 3198 */   // No operand predicates
     /* 3198 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 3202 */   // Combiner Rule #68: right_identity_neg_one_fp
     /* 3202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 3205 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 3207 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 3209 */   GIR_EraseRootFromParent_Done,
     /* 3210 */ // Label 233: @3210
     /* 3210 */ GIM_Reject,
     /* 3211 */ // Label 53: @3211
     /* 3211 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3222), // Rule ID 81 //
     /* 3216 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3219 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 3219 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3222 */ // Label 234: @3222
     /* 3222 */ GIM_Reject,
     /* 3223 */ // Label 54: @3223
     /* 3223 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3252), // Rule ID 106 //
     /* 3228 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3231 */   // MIs[0] dst
     /* 3231 */   // No operand predicates
     /* 3231 */   // MIs[0] t
     /* 3231 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 3239 */   // MIs[1] src
     /* 3239 */   // No operand predicates
     /* 3239 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 3244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3246 */   // Combiner Rule #58: fneg_fneg_fold
     /* 3246 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 3251 */   GIR_EraseRootFromParent_Done,
     /* 3252 */ // Label 235: @3252
     /* 3252 */ GIM_Reject,
     /* 3253 */ // Label 55: @3253
     /* 3253 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3274), // Rule ID 116 //
     /* 3258 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 3261 */   // MIs[0] dst
     /* 3261 */   // No operand predicates
     /* 3261 */   // MIs[0] src1
     /* 3261 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3265 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 3269 */   // MIs[1] src0
     /* 3269 */   // No operand predicates
     /* 3269 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3271 */   // Combiner Rule #66: fptrunc_fpext_fold
     /* 3271 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3274 */ // Label 236: @3274
     /* 3274 */ GIM_Reject,
     /* 3275 */ // Label 56: @3275
     /* 3275 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3296), // Rule ID 139 //
     /* 3280 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3283 */   // MIs[0] dst
     /* 3283 */   // No operand predicates
     /* 3283 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3283 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3293 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 3293 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 3296 */ // Label 237: @3296
     /* 3296 */ GIM_Reject,
     /* 3297 */ // Label 57: @3297
     /* 3297 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3318), // Rule ID 140 //
     /* 3302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3305 */   // MIs[0] dst
     /* 3305 */   // No operand predicates
     /* 3305 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3305 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3309 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3313 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3315 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 3315 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 3318 */ // Label 238: @3318
     /* 3318 */ GIM_Reject,
     /* 3319 */ // Label 58: @3319
     /* 3319 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3330), // Rule ID 123 //
     /* 3324 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 3327 */   // Combiner Rule #72: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 3327 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 3330 */ // Label 239: @3330
     /* 3330 */ GIM_Reject,
     /* 3331 */ // Label 59: @3331
     /* 3331 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3342), // Rule ID 122 //
     /* 3336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 3339 */   // Combiner Rule #72: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 3339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 3342 */ // Label 240: @3342
     /* 3342 */ GIM_Reject,
     /* 3343 */ // Label 60: @3343
     /* 3343 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3354), // Rule ID 176 //
     /* 3348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3351 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 3351 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3354 */ // Label 241: @3354
     /* 3354 */ GIM_Reject,
     /* 3355 */ // Label 61: @3355
     /* 3355 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3366), // Rule ID 177 //
     /* 3360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3363 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 3363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3366 */ // Label 242: @3366
     /* 3366 */ GIM_Reject,
     /* 3367 */ // Label 62: @3367
     /* 3367 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3378), // Rule ID 178 //
     /* 3372 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3375 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 3375 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3378 */ // Label 243: @3378
     /* 3378 */ GIM_Reject,
     /* 3379 */ // Label 63: @3379
     /* 3379 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3390), // Rule ID 179 //
     /* 3384 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3387 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 3387 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3390 */ // Label 244: @3390
     /* 3390 */ GIM_Reject,
     /* 3391 */ // Label 64: @3391
     /* 3391 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3402), // Rule ID 180 //
     /* 3396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3399 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 3399 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3402 */ // Label 245: @3402
     /* 3402 */ GIM_Reject,
     /* 3403 */ // Label 65: @3403
     /* 3403 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3414), // Rule ID 181 //
     /* 3408 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3411 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 3411 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3414 */ // Label 246: @3414
     /* 3414 */ GIM_Reject,
     /* 3415 */ // Label 66: @3415
     /* 3415 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3426), // Rule ID 61 //
     /* 3420 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3423 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 3423 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3426 */ // Label 247: @3426
     /* 3426 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3437), // Rule ID 119 //
     /* 3431 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 3434 */   // Combiner Rule #69: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 3434 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3437 */ // Label 248: @3437
     /* 3437 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(3460), // Rule ID 90 //
     /* 3442 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3445 */   // MIs[0] dst
     /* 3445 */   // No operand predicates
     /* 3445 */   // MIs[0] lhs
     /* 3445 */   // No operand predicates
     /* 3445 */   // MIs[0] Operand 2
     /* 3445 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3449 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3454 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 3454 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3459 */   GIR_EraseRootFromParent_Done,
     /* 3460 */ // Label 249: @3460
     /* 3460 */ GIM_Reject,
     /* 3461 */ // Label 67: @3461
     /* 3461 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(3472), // Rule ID 74 //
     /* 3466 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3469 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 3469 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3472 */ // Label 250: @3472
     /* 3472 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(3483), // Rule ID 158 //
     /* 3477 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3480 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 3480 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3483 */ // Label 251: @3483
     /* 3483 */ GIM_Reject,
     /* 3484 */ // Label 68: @3484
     /* 3484 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(3495), // Rule ID 75 //
     /* 3489 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3492 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 3492 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3495 */ // Label 252: @3495
     /* 3495 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(3506), // Rule ID 159 //
     /* 3500 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3503 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 3503 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3506 */ // Label 253: @3506
     /* 3506 */ GIM_Reject,
     /* 3507 */ // Label 69: @3507
     /* 3507 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(3518), // Rule ID 76 //
     /* 3512 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3515 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 3515 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3518 */ // Label 254: @3518
     /* 3518 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(3529), // Rule ID 160 //
     /* 3523 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3526 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 3526 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3529 */ // Label 255: @3529
     /* 3529 */ GIM_Reject,
     /* 3530 */ // Label 70: @3530
     /* 3530 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(3541), // Rule ID 77 //
     /* 3535 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3538 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 3538 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3541 */ // Label 256: @3541
     /* 3541 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(3552), // Rule ID 161 //
     /* 3546 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3549 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 3549 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3552 */ // Label 257: @3552
     /* 3552 */ GIM_Reject,
     /* 3553 */ // Label 71: @3553
     /* 3553 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(3564), // Rule ID 133 //
     /* 3558 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3561 */   // Combiner Rule #77: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 3561 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 3564 */ // Label 258: @3564
     /* 3564 */ GIM_Reject,
     /* 3565 */ // Label 72: @3565
     /* 3565 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(3576), // Rule ID 148 //
     /* 3570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 3573 */   // Combiner Rule #83: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 3573 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 3576 */ // Label 259: @3576
     /* 3576 */ GIM_Reject,
     /* 3577 */ // Label 73: @3577
     /* 3577 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(3588), // Rule ID 29 //
     /* 3582 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 3585 */   // Combiner Rule #22: extractvecelt_pairwise_add; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 3585 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 3588 */ // Label 260: @3588
     /* 3588 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(3599), // Rule ID 149 //
     /* 3593 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 3596 */   // Combiner Rule #83: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 3596 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 3599 */ // Label 261: @3599
     /* 3599 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(3610), // Rule ID 182 //
     /* 3604 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3607 */   // Combiner Rule #89: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 3607 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 3610 */ // Label 262: @3610
     /* 3610 */ GIM_Reject,
     /* 3611 */ // Label 74: @3611
     /* 3611 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(3622), // Rule ID 144 //
     /* 3616 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 3619 */   // Combiner Rule #80: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 3619 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 3622 */ // Label 263: @3622
     /* 3622 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(3633), // Rule ID 146 //
     /* 3627 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 3630 */   // Combiner Rule #81: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 3630 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 3633 */ // Label 264: @3633
     /* 3633 */ GIM_Reject,
     /* 3634 */ // Label 75: @3634
     /* 3634 */ GIM_Reject,
     /* 3635 */ }; // Size: 3635 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

