/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(308), /*)*//*default:*//*Label 79*/ GIMT_Encode4(131053),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1030),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10357),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13601),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15305),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15401), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15497),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18677),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26181), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35580),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(35876), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 12*/ GIMT_Encode4(36139), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 13*/ GIMT_Encode4(36402), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 14*/ GIMT_Encode4(36565), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 15*/ GIMT_Encode4(36586),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 16*/ GIMT_Encode4(91626), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 17*/ GIMT_Encode4(99288),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 18*/ GIMT_Encode4(99446),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 19*/ GIMT_Encode4(99604),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 20*/ GIMT_Encode4(99925), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 21*/ GIMT_Encode4(100021),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 22*/ GIMT_Encode4(100179),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 23*/ GIMT_Encode4(100784),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 24*/ GIMT_Encode4(100942),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 25*/ GIMT_Encode4(101158),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 26*/ GIMT_Encode4(101266), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 27*/ GIMT_Encode4(101539), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 28*/ GIMT_Encode4(101871),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 29*/ GIMT_Encode4(102119),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 30*/ GIMT_Encode4(102488),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 31*/ GIMT_Encode4(103133),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 32*/ GIMT_Encode4(104433),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 33*/ GIMT_Encode4(105078), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 34*/ GIMT_Encode4(106098),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 35*/ GIMT_Encode4(108451),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 36*/ GIMT_Encode4(110128),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 37*/ GIMT_Encode4(111109), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 38*/ GIMT_Encode4(113200), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 39*/ GIMT_Encode4(113365),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 40*/ GIMT_Encode4(114896),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 41*/ GIMT_Encode4(115132),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 42*/ GIMT_Encode4(115404),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 43*/ GIMT_Encode4(116738),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 44*/ GIMT_Encode4(118072),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 45*/ GIMT_Encode4(118724), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 46*/ GIMT_Encode4(119376), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 47*/ GIMT_Encode4(120152),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 48*/ GIMT_Encode4(120744), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 49*/ GIMT_Encode4(121336),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 50*/ GIMT_Encode4(122070), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    670 */ /*TargetOpcode::G_GET_FPENV*//*Label 51*/ GIMT_Encode4(122804),
     /*    674 */ /*TargetOpcode::G_SET_FPENV*//*Label 52*/ GIMT_Encode4(122837),
     /*    678 */ /*TargetOpcode::G_RESET_FPENV*//*Label 53*/ GIMT_Encode4(122873),
     /*    682 */ /*TargetOpcode::G_GET_FPMODE*//*Label 54*/ GIMT_Encode4(123002), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 55*/ GIMT_Encode4(123035),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 56*/ GIMT_Encode4(123578),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 57*/ GIMT_Encode4(124121),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 58*/ GIMT_Encode4(125042),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 59*/ GIMT_Encode4(125963), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 60*/ GIMT_Encode4(126434), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(126507),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 62*/ GIMT_Encode4(126807), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 63*/ GIMT_Encode4(126864), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 64*/ GIMT_Encode4(127425),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 65*/ GIMT_Encode4(127533),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 66*/ GIMT_Encode4(127823),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 67*/ GIMT_Encode4(128255), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 68*/ GIMT_Encode4(128518),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 69*/ GIMT_Encode4(128656),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 70*/ GIMT_Encode4(128919),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 71*/ GIMT_Encode4(129215), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 72*/ GIMT_Encode4(129353),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 73*/ GIMT_Encode4(129399), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 74*/ GIMT_Encode4(129486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 75*/ GIMT_Encode4(129907),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 76*/ GIMT_Encode4(130187),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 77*/ GIMT_Encode4(130476),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 78*/ GIMT_Encode4(130757),
     /*   1030 */ // Label 0: @1030
     /*   1030 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 89*/ GIMT_Encode4(10356),
     /*   1041 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(1101),
     /*   1045 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(6877), GIMT_Encode4(0),
     /*   1053 */ /*GILLT_v2s32*//*Label 82*/ GIMT_Encode4(6924),
     /*   1057 */ /*GILLT_v2s64*//*Label 83*/ GIMT_Encode4(7109), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v4s16*//*Label 84*/ GIMT_Encode4(7820),
     /*   1069 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(8005), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1081 */ /*GILLT_v8s8*//*Label 86*/ GIMT_Encode4(8961),
     /*   1085 */ /*GILLT_v8s16*//*Label 87*/ GIMT_Encode4(9146), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1097 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(10102),
     /*   1101 */ // Label 80: @1101
     /*   1101 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(6876),
     /*   1106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1112 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1187), // Rule ID 5670 //
     /*   1117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1145 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1162 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1185 */     GIR_RootConstrainSelectedInstOperands,
     /*   1186 */     // GIR_Coverage, 5670,
     /*   1186 */     GIR_EraseRootFromParent_Done,
     /*   1187 */   // Label 91: @1187
     /*   1187 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1262), // Rule ID 5671 //
     /*   1192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1220 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1237 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1260 */     GIR_RootConstrainSelectedInstOperands,
     /*   1261 */     // GIR_Coverage, 5671,
     /*   1261 */     GIR_EraseRootFromParent_Done,
     /*   1262 */   // Label 92: @1262
     /*   1262 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1337), // Rule ID 5705 //
     /*   1267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1295 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1312 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1335 */     GIR_RootConstrainSelectedInstOperands,
     /*   1336 */     // GIR_Coverage, 5705,
     /*   1336 */     GIR_EraseRootFromParent_Done,
     /*   1337 */   // Label 93: @1337
     /*   1337 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1412), // Rule ID 5706 //
     /*   1342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1370 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1387 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1410 */     GIR_RootConstrainSelectedInstOperands,
     /*   1411 */     // GIR_Coverage, 5706,
     /*   1411 */     GIR_EraseRootFromParent_Done,
     /*   1412 */   // Label 94: @1412
     /*   1412 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1487), // Rule ID 2000 //
     /*   1417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1449 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1462 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1485 */     GIR_RootConstrainSelectedInstOperands,
     /*   1486 */     // GIR_Coverage, 2000,
     /*   1486 */     GIR_EraseRootFromParent_Done,
     /*   1487 */   // Label 95: @1487
     /*   1487 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1562), // Rule ID 2001 //
     /*   1492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1524 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1537 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1560 */     GIR_RootConstrainSelectedInstOperands,
     /*   1561 */     // GIR_Coverage, 2001,
     /*   1561 */     GIR_EraseRootFromParent_Done,
     /*   1562 */   // Label 96: @1562
     /*   1562 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1637), // Rule ID 2239 //
     /*   1567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1599 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1612 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1635 */     GIR_RootConstrainSelectedInstOperands,
     /*   1636 */     // GIR_Coverage, 2239,
     /*   1636 */     GIR_EraseRootFromParent_Done,
     /*   1637 */   // Label 97: @1637
     /*   1637 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1712), // Rule ID 2240 //
     /*   1642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1674 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1687 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1710 */     GIR_RootConstrainSelectedInstOperands,
     /*   1711 */     // GIR_Coverage, 2240,
     /*   1711 */     GIR_EraseRootFromParent_Done,
     /*   1712 */   // Label 98: @1712
     /*   1712 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1840), // Rule ID 5681 //
     /*   1717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1773 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1789 */     // MIs[4] Rm
     /*   1789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1794 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1798 */     // MIs[1] Operand 2
     /*   1798 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1815 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1838 */     GIR_RootConstrainSelectedInstOperands,
     /*   1839 */     // GIR_Coverage, 5681,
     /*   1839 */     GIR_EraseRootFromParent_Done,
     /*   1840 */   // Label 99: @1840
     /*   1840 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1968), // Rule ID 5682 //
     /*   1845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1901 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1913 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1917 */     // MIs[4] Rm
     /*   1917 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1922 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1926 */     // MIs[1] Operand 2
     /*   1926 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1943 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1966 */     GIR_RootConstrainSelectedInstOperands,
     /*   1967 */     // GIR_Coverage, 5682,
     /*   1967 */     GIR_EraseRootFromParent_Done,
     /*   1968 */   // Label 100: @1968
     /*   1968 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2096), // Rule ID 2106 //
     /*   1973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2028 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2033 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2041 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2045 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2049 */     // MIs[4] Rm
     /*   2049 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2054 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2058 */     // MIs[1] Operand 2
     /*   2058 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2071 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2094 */     GIR_RootConstrainSelectedInstOperands,
     /*   2095 */     // GIR_Coverage, 2106,
     /*   2095 */     GIR_EraseRootFromParent_Done,
     /*   2096 */   // Label 101: @2096
     /*   2096 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2224), // Rule ID 5680 //
     /*   2101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2161 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2165 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2169 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2173 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2177 */     // MIs[4] Rm
     /*   2177 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2182 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2186 */     // MIs[1] Operand 2
     /*   2186 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2199 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2222 */     GIR_RootConstrainSelectedInstOperands,
     /*   2223 */     // GIR_Coverage, 5680,
     /*   2223 */     GIR_EraseRootFromParent_Done,
     /*   2224 */   // Label 102: @2224
     /*   2224 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2334), // Rule ID 5449 //
     /*   2229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2273 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2298 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2308 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2332 */     GIR_RootConstrainSelectedInstOperands,
     /*   2333 */     // GIR_Coverage, 5449,
     /*   2333 */     GIR_EraseRootFromParent_Done,
     /*   2334 */   // Label 103: @2334
     /*   2334 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2444), // Rule ID 5486 //
     /*   2339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2408 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2418 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2442 */     GIR_RootConstrainSelectedInstOperands,
     /*   2443 */     // GIR_Coverage, 5486,
     /*   2443 */     GIR_EraseRootFromParent_Done,
     /*   2444 */   // Label 104: @2444
     /*   2444 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2554), // Rule ID 192 //
     /*   2449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2509 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2517 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2522 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2528 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2552 */     GIR_RootConstrainSelectedInstOperands,
     /*   2553 */     // GIR_Coverage, 192,
     /*   2553 */     GIR_EraseRootFromParent_Done,
     /*   2554 */   // Label 105: @2554
     /*   2554 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2664), // Rule ID 521 //
     /*   2559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2607 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2632 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2638 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2662 */     GIR_RootConstrainSelectedInstOperands,
     /*   2663 */     // GIR_Coverage, 521,
     /*   2663 */     GIR_EraseRootFromParent_Done,
     /*   2664 */   // Label 106: @2664
     /*   2664 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2777), // Rule ID 5448 //
     /*   2669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2734 */     // MIs[3] Operand 2
     /*   2734 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2751 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2775 */     GIR_RootConstrainSelectedInstOperands,
     /*   2776 */     // GIR_Coverage, 5448,
     /*   2776 */     GIR_EraseRootFromParent_Done,
     /*   2777 */   // Label 107: @2777
     /*   2777 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2890), // Rule ID 5485 //
     /*   2782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2842 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2847 */     // MIs[3] Operand 2
     /*   2847 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2864 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2888 */     GIR_RootConstrainSelectedInstOperands,
     /*   2889 */     // GIR_Coverage, 5485,
     /*   2889 */     GIR_EraseRootFromParent_Done,
     /*   2890 */   // Label 108: @2890
     /*   2890 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3003), // Rule ID 5447 //
     /*   2895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2935 */     // MIs[2] Operand 2
     /*   2935 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2962 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2967 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2977 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3001 */     GIR_RootConstrainSelectedInstOperands,
     /*   3002 */     // GIR_Coverage, 5447,
     /*   3002 */     GIR_EraseRootFromParent_Done,
     /*   3003 */   // Label 109: @3003
     /*   3003 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3116), // Rule ID 5484 //
     /*   3008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3048 */     // MIs[2] Operand 2
     /*   3048 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3080 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3090 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3114 */     GIR_RootConstrainSelectedInstOperands,
     /*   3115 */     // GIR_Coverage, 5484,
     /*   3115 */     GIR_EraseRootFromParent_Done,
     /*   3116 */   // Label 110: @3116
     /*   3116 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3229), // Rule ID 191 //
     /*   3121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3169 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3190 */     // MIs[3] Operand 2
     /*   3190 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3203 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3227 */     GIR_RootConstrainSelectedInstOperands,
     /*   3228 */     // GIR_Coverage, 191,
     /*   3228 */     GIR_EraseRootFromParent_Done,
     /*   3229 */   // Label 111: @3229
     /*   3229 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3342), // Rule ID 520 //
     /*   3234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3282 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3303 */     // MIs[3] Operand 2
     /*   3303 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3316 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3340 */     GIR_RootConstrainSelectedInstOperands,
     /*   3341 */     // GIR_Coverage, 520,
     /*   3341 */     GIR_EraseRootFromParent_Done,
     /*   3342 */   // Label 112: @3342
     /*   3342 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3455), // Rule ID 190 //
     /*   3347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3391 */     // MIs[2] Operand 2
     /*   3391 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3418 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3423 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3429 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3453 */     GIR_RootConstrainSelectedInstOperands,
     /*   3454 */     // GIR_Coverage, 190,
     /*   3454 */     GIR_EraseRootFromParent_Done,
     /*   3455 */   // Label 113: @3455
     /*   3455 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3568), // Rule ID 519 //
     /*   3460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3504 */     // MIs[2] Operand 2
     /*   3504 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3536 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3542 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3566 */     GIR_RootConstrainSelectedInstOperands,
     /*   3567 */     // GIR_Coverage, 519,
     /*   3567 */     GIR_EraseRootFromParent_Done,
     /*   3568 */   // Label 114: @3568
     /*   3568 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3659), // Rule ID 5679 //
     /*   3573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3613 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3617 */     // MIs[1] Operand 2
     /*   3617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3634 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3657 */     GIR_RootConstrainSelectedInstOperands,
     /*   3658 */     // GIR_Coverage, 5679,
     /*   3658 */     GIR_EraseRootFromParent_Done,
     /*   3659 */   // Label 115: @3659
     /*   3659 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3750), // Rule ID 2105 //
     /*   3664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3712 */     // MIs[1] Operand 2
     /*   3712 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3725 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3748 */     GIR_RootConstrainSelectedInstOperands,
     /*   3749 */     // GIR_Coverage, 2105,
     /*   3749 */     GIR_EraseRootFromParent_Done,
     /*   3750 */   // Label 116: @3750
     /*   3750 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3866), // Rule ID 5446 //
     /*   3755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3795 */     // MIs[2] Operand 2
     /*   3795 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3823 */     // MIs[3] Operand 2
     /*   3823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3840 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3864 */     GIR_RootConstrainSelectedInstOperands,
     /*   3865 */     // GIR_Coverage, 5446,
     /*   3865 */     GIR_EraseRootFromParent_Done,
     /*   3866 */   // Label 117: @3866
     /*   3866 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(3982), // Rule ID 5483 //
     /*   3871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3911 */     // MIs[2] Operand 2
     /*   3911 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3939 */     // MIs[3] Operand 2
     /*   3939 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3956 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3980 */     GIR_RootConstrainSelectedInstOperands,
     /*   3981 */     // GIR_Coverage, 5483,
     /*   3981 */     GIR_EraseRootFromParent_Done,
     /*   3982 */   // Label 118: @3982
     /*   3982 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4098), // Rule ID 189 //
     /*   3987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4031 */     // MIs[2] Operand 2
     /*   4031 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4059 */     // MIs[3] Operand 2
     /*   4059 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4072 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4096 */     GIR_RootConstrainSelectedInstOperands,
     /*   4097 */     // GIR_Coverage, 189,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 119: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4214), // Rule ID 518 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4147 */     // MIs[2] Operand 2
     /*   4147 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4175 */     // MIs[3] Operand 2
     /*   4175 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4188 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4212 */     GIR_RootConstrainSelectedInstOperands,
     /*   4213 */     // GIR_Coverage, 518,
     /*   4213 */     GIR_EraseRootFromParent_Done,
     /*   4214 */   // Label 120: @4214
     /*   4214 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4302), // Rule ID 3248 //
     /*   4219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4270 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4300 */     GIR_RootConstrainSelectedInstOperands,
     /*   4301 */     // GIR_Coverage, 3248,
     /*   4301 */     GIR_EraseRootFromParent_Done,
     /*   4302 */   // Label 121: @4302
     /*   4302 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4390), // Rule ID 3249 //
     /*   4307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4358 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4388 */     GIR_RootConstrainSelectedInstOperands,
     /*   4389 */     // GIR_Coverage, 3249,
     /*   4389 */     GIR_EraseRootFromParent_Done,
     /*   4390 */   // Label 122: @4390
     /*   4390 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4478), // Rule ID 3252 //
     /*   4395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4446 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4476 */     GIR_RootConstrainSelectedInstOperands,
     /*   4477 */     // GIR_Coverage, 3252,
     /*   4477 */     GIR_EraseRootFromParent_Done,
     /*   4478 */   // Label 123: @4478
     /*   4478 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4566), // Rule ID 5950 //
     /*   4483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4534 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4564 */     GIR_RootConstrainSelectedInstOperands,
     /*   4565 */     // GIR_Coverage, 5950,
     /*   4565 */     GIR_EraseRootFromParent_Done,
     /*   4566 */   // Label 124: @4566
     /*   4566 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4654), // Rule ID 5951 //
     /*   4571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4622 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4652 */     GIR_RootConstrainSelectedInstOperands,
     /*   4653 */     // GIR_Coverage, 5951,
     /*   4653 */     GIR_EraseRootFromParent_Done,
     /*   4654 */   // Label 125: @4654
     /*   4654 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4742), // Rule ID 5954 //
     /*   4659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4710 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4740 */     GIR_RootConstrainSelectedInstOperands,
     /*   4741 */     // GIR_Coverage, 5954,
     /*   4741 */     GIR_EraseRootFromParent_Done,
     /*   4742 */   // Label 126: @4742
     /*   4742 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4799), // Rule ID 72 //
     /*   4747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4770 */     // MIs[1] Operand 1
     /*   4770 */     // No operand predicates
     /*   4770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4772 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4797 */     GIR_RootConstrainSelectedInstOperands,
     /*   4798 */     // GIR_Coverage, 72,
     /*   4798 */     GIR_EraseRootFromParent_Done,
     /*   4799 */   // Label 127: @4799
     /*   4799 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4856), // Rule ID 303 //
     /*   4804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4827 */     // MIs[1] Operand 1
     /*   4827 */     // No operand predicates
     /*   4827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4829 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4854 */     GIR_RootConstrainSelectedInstOperands,
     /*   4855 */     // GIR_Coverage, 303,
     /*   4855 */     GIR_EraseRootFromParent_Done,
     /*   4856 */   // Label 128: @4856
     /*   4856 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4913), // Rule ID 304 //
     /*   4861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4884 */     // MIs[1] Operand 1
     /*   4884 */     // No operand predicates
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4886 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4911 */     GIR_RootConstrainSelectedInstOperands,
     /*   4912 */     // GIR_Coverage, 304,
     /*   4912 */     GIR_EraseRootFromParent_Done,
     /*   4913 */   // Label 129: @4913
     /*   4913 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(4970), // Rule ID 407 //
     /*   4918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4941 */     // MIs[1] Operand 1
     /*   4941 */     // No operand predicates
     /*   4941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4943 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4968 */     GIR_RootConstrainSelectedInstOperands,
     /*   4969 */     // GIR_Coverage, 407,
     /*   4969 */     GIR_EraseRootFromParent_Done,
     /*   4970 */   // Label 130: @4970
     /*   4970 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5021), // Rule ID 408 //
     /*   4975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   4998 */     // MIs[1] Operand 1
     /*   4998 */     // No operand predicates
     /*   4998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5000 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   5000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   5003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   5010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5019 */     GIR_RootConstrainSelectedInstOperands,
     /*   5020 */     // GIR_Coverage, 408,
     /*   5020 */     GIR_EraseRootFromParent_Done,
     /*   5021 */   // Label 131: @5021
     /*   5021 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5097), // Rule ID 171 //
     /*   5026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5065 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5095 */     GIR_RootConstrainSelectedInstOperands,
     /*   5096 */     // GIR_Coverage, 171,
     /*   5096 */     GIR_EraseRootFromParent_Done,
     /*   5097 */   // Label 132: @5097
     /*   5097 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5173), // Rule ID 172 //
     /*   5102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5141 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5171 */     GIR_RootConstrainSelectedInstOperands,
     /*   5172 */     // GIR_Coverage, 172,
     /*   5172 */     GIR_EraseRootFromParent_Done,
     /*   5173 */   // Label 133: @5173
     /*   5173 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5243), // Rule ID 503 //
     /*   5178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5217 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5241 */     GIR_RootConstrainSelectedInstOperands,
     /*   5242 */     // GIR_Coverage, 503,
     /*   5242 */     GIR_EraseRootFromParent_Done,
     /*   5243 */   // Label 134: @5243
     /*   5243 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5314), // Rule ID 5672 //
     /*   5248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5272 */     // MIs[1] Operand 2
     /*   5272 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5289 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5312 */     GIR_RootConstrainSelectedInstOperands,
     /*   5313 */     // GIR_Coverage, 5672,
     /*   5313 */     GIR_EraseRootFromParent_Done,
     /*   5314 */   // Label 135: @5314
     /*   5314 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5385), // Rule ID 5673 //
     /*   5319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5343 */     // MIs[1] Operand 2
     /*   5343 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5360 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5383 */     GIR_RootConstrainSelectedInstOperands,
     /*   5384 */     // GIR_Coverage, 5673,
     /*   5384 */     GIR_EraseRootFromParent_Done,
     /*   5385 */   // Label 136: @5385
     /*   5385 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5456), // Rule ID 5707 //
     /*   5390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5414 */     // MIs[1] Operand 2
     /*   5414 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5431 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5454 */     GIR_RootConstrainSelectedInstOperands,
     /*   5455 */     // GIR_Coverage, 5707,
     /*   5455 */     GIR_EraseRootFromParent_Done,
     /*   5456 */   // Label 137: @5456
     /*   5456 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5527), // Rule ID 5708 //
     /*   5461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5485 */     // MIs[1] Operand 2
     /*   5485 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5502 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5525 */     GIR_RootConstrainSelectedInstOperands,
     /*   5526 */     // GIR_Coverage, 5708,
     /*   5526 */     GIR_EraseRootFromParent_Done,
     /*   5527 */   // Label 138: @5527
     /*   5527 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5597), // Rule ID 180 //
     /*   5532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5571 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5595 */     GIR_RootConstrainSelectedInstOperands,
     /*   5596 */     // GIR_Coverage, 180,
     /*   5596 */     GIR_EraseRootFromParent_Done,
     /*   5597 */   // Label 139: @5597
     /*   5597 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5667), // Rule ID 509 //
     /*   5602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5641 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5665 */     GIR_RootConstrainSelectedInstOperands,
     /*   5666 */     // GIR_Coverage, 509,
     /*   5666 */     GIR_EraseRootFromParent_Done,
     /*   5667 */   // Label 140: @5667
     /*   5667 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5730), // Rule ID 3053 //
     /*   5672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5702 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5707 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5728 */     GIR_RootConstrainSelectedInstOperands,
     /*   5729 */     // GIR_Coverage, 3053,
     /*   5729 */     GIR_EraseRootFromParent_Done,
     /*   5730 */   // Label 141: @5730
     /*   5730 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5793), // Rule ID 3081 //
     /*   5735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5765 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5770 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5791 */     GIR_RootConstrainSelectedInstOperands,
     /*   5792 */     // GIR_Coverage, 3081,
     /*   5792 */     GIR_EraseRootFromParent_Done,
     /*   5793 */   // Label 142: @5793
     /*   5793 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5856), // Rule ID 3091 //
     /*   5798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5828 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5833 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5854 */     GIR_RootConstrainSelectedInstOperands,
     /*   5855 */     // GIR_Coverage, 3091,
     /*   5855 */     GIR_EraseRootFromParent_Done,
     /*   5856 */   // Label 143: @5856
     /*   5856 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(5932), // Rule ID 5443 //
     /*   5861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5900 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5930 */     GIR_RootConstrainSelectedInstOperands,
     /*   5931 */     // GIR_Coverage, 5443,
     /*   5931 */     GIR_EraseRootFromParent_Done,
     /*   5932 */   // Label 144: @5932
     /*   5932 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6008), // Rule ID 5444 //
     /*   5937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5976 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6006 */     GIR_RootConstrainSelectedInstOperands,
     /*   6007 */     // GIR_Coverage, 5444,
     /*   6007 */     GIR_EraseRootFromParent_Done,
     /*   6008 */   // Label 145: @6008
     /*   6008 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6078), // Rule ID 5481 //
     /*   6013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6052 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6076 */     GIR_RootConstrainSelectedInstOperands,
     /*   6077 */     // GIR_Coverage, 5481,
     /*   6077 */     GIR_EraseRootFromParent_Done,
     /*   6078 */   // Label 146: @6078
     /*   6078 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6149), // Rule ID 2004 //
     /*   6083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6111 */     // MIs[1] Operand 2
     /*   6111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6124 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6147 */     GIR_RootConstrainSelectedInstOperands,
     /*   6148 */     // GIR_Coverage, 2004,
     /*   6148 */     GIR_EraseRootFromParent_Done,
     /*   6149 */   // Label 147: @6149
     /*   6149 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6220), // Rule ID 2005 //
     /*   6154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6182 */     // MIs[1] Operand 2
     /*   6182 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6195 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6218 */     GIR_RootConstrainSelectedInstOperands,
     /*   6219 */     // GIR_Coverage, 2005,
     /*   6219 */     GIR_EraseRootFromParent_Done,
     /*   6220 */   // Label 148: @6220
     /*   6220 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6291), // Rule ID 2243 //
     /*   6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6253 */     // MIs[1] Operand 2
     /*   6253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6266 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6289 */     GIR_RootConstrainSelectedInstOperands,
     /*   6290 */     // GIR_Coverage, 2243,
     /*   6290 */     GIR_EraseRootFromParent_Done,
     /*   6291 */   // Label 149: @6291
     /*   6291 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6362), // Rule ID 2244 //
     /*   6296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6324 */     // MIs[1] Operand 2
     /*   6324 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6337 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6360 */     GIR_RootConstrainSelectedInstOperands,
     /*   6361 */     // GIR_Coverage, 2244,
     /*   6361 */     GIR_EraseRootFromParent_Done,
     /*   6362 */   // Label 150: @6362
     /*   6362 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6432), // Rule ID 5445 //
     /*   6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6406 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6430 */     GIR_RootConstrainSelectedInstOperands,
     /*   6431 */     // GIR_Coverage, 5445,
     /*   6431 */     GIR_EraseRootFromParent_Done,
     /*   6432 */   // Label 151: @6432
     /*   6432 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6502), // Rule ID 5482 //
     /*   6437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6476 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6500 */     GIR_RootConstrainSelectedInstOperands,
     /*   6501 */     // GIR_Coverage, 5482,
     /*   6501 */     GIR_EraseRootFromParent_Done,
     /*   6502 */   // Label 152: @6502
     /*   6502 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6565), // Rule ID 5926 //
     /*   6507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6537 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6542 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6563 */     GIR_RootConstrainSelectedInstOperands,
     /*   6564 */     // GIR_Coverage, 5926,
     /*   6564 */     GIR_EraseRootFromParent_Done,
     /*   6565 */   // Label 153: @6565
     /*   6565 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6628), // Rule ID 5940 //
     /*   6570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6600 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6605 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6626 */     GIR_RootConstrainSelectedInstOperands,
     /*   6627 */     // GIR_Coverage, 5940,
     /*   6627 */     GIR_EraseRootFromParent_Done,
     /*   6628 */   // Label 154: @6628
     /*   6628 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6691), // Rule ID 5945 //
     /*   6633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6663 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6668 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6689 */     GIR_RootConstrainSelectedInstOperands,
     /*   6690 */     // GIR_Coverage, 5945,
     /*   6690 */     GIR_EraseRootFromParent_Done,
     /*   6691 */   // Label 155: @6691
     /*   6691 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6737), // Rule ID 73 //
     /*   6696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6711 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6735 */     GIR_RootConstrainSelectedInstOperands,
     /*   6736 */     // GIR_Coverage, 73,
     /*   6736 */     GIR_EraseRootFromParent_Done,
     /*   6737 */   // Label 156: @6737
     /*   6737 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6783), // Rule ID 305 //
     /*   6742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6757 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6781 */     GIR_RootConstrainSelectedInstOperands,
     /*   6782 */     // GIR_Coverage, 305,
     /*   6782 */     GIR_EraseRootFromParent_Done,
     /*   6783 */   // Label 157: @6783
     /*   6783 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6829), // Rule ID 409 //
     /*   6788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6803 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6827 */     GIR_RootConstrainSelectedInstOperands,
     /*   6828 */     // GIR_Coverage, 409,
     /*   6828 */     GIR_EraseRootFromParent_Done,
     /*   6829 */   // Label 158: @6829
     /*   6829 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6875), // Rule ID 5463 //
     /*   6834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6849 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6873 */     GIR_RootConstrainSelectedInstOperands,
     /*   6874 */     // GIR_Coverage, 5463,
     /*   6874 */     GIR_EraseRootFromParent_Done,
     /*   6875 */   // Label 159: @6875
     /*   6875 */   GIM_Reject,
     /*   6876 */ // Label 90: @6876
     /*   6876 */ GIM_Reject,
     /*   6877 */ // Label 81: @6877
     /*   6877 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(6923), // Rule ID 762 //
     /*   6882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6903 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6910 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6915 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6921 */   GIR_RootConstrainSelectedInstOperands,
     /*   6922 */   // GIR_Coverage, 762,
     /*   6922 */   GIR_EraseRootFromParent_Done,
     /*   6923 */ // Label 160: @6923
     /*   6923 */ GIM_Reject,
     /*   6924 */ // Label 82: @6924
     /*   6924 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(7108),
     /*   6929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6939 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7005), // Rule ID 5532 //
     /*   6944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6979 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7003 */     GIR_RootConstrainSelectedInstOperands,
     /*   7004 */     // GIR_Coverage, 5532,
     /*   7004 */     GIR_EraseRootFromParent_Done,
     /*   7005 */   // Label 162: @7005
     /*   7005 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7071), // Rule ID 889 //
     /*   7010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7045 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7069 */     GIR_RootConstrainSelectedInstOperands,
     /*   7070 */     // GIR_Coverage, 889,
     /*   7070 */     GIR_EraseRootFromParent_Done,
     /*   7071 */   // Label 163: @7071
     /*   7071 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7107), // Rule ID 758 //
     /*   7076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7087 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7105 */     GIR_RootConstrainSelectedInstOperands,
     /*   7106 */     // GIR_Coverage, 758,
     /*   7106 */     GIR_EraseRootFromParent_Done,
     /*   7107 */   // Label 164: @7107
     /*   7107 */   GIM_Reject,
     /*   7108 */ // Label 161: @7108
     /*   7108 */ GIM_Reject,
     /*   7109 */ // Label 83: @7109
     /*   7109 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7819),
     /*   7114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7124 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7192), // Rule ID 782 //
     /*   7129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7168 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7190 */     GIR_RootConstrainSelectedInstOperands,
     /*   7191 */     // GIR_Coverage, 782,
     /*   7191 */     GIR_EraseRootFromParent_Done,
     /*   7192 */   // Label 166: @7192
     /*   7192 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7260), // Rule ID 781 //
     /*   7197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7236 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7258 */     GIR_RootConstrainSelectedInstOperands,
     /*   7259 */     // GIR_Coverage, 781,
     /*   7259 */     GIR_EraseRootFromParent_Done,
     /*   7260 */   // Label 167: @7260
     /*   7260 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7328), // Rule ID 770 //
     /*   7265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7304 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7326 */     GIR_RootConstrainSelectedInstOperands,
     /*   7327 */     // GIR_Coverage, 770,
     /*   7327 */     GIR_EraseRootFromParent_Done,
     /*   7328 */   // Label 168: @7328
     /*   7328 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7396), // Rule ID 780 //
     /*   7333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7372 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7394 */     GIR_RootConstrainSelectedInstOperands,
     /*   7395 */     // GIR_Coverage, 780,
     /*   7395 */     GIR_EraseRootFromParent_Done,
     /*   7396 */   // Label 169: @7396
     /*   7396 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7464), // Rule ID 779 //
     /*   7401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7440 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7462 */     GIR_RootConstrainSelectedInstOperands,
     /*   7463 */     // GIR_Coverage, 779,
     /*   7463 */     GIR_EraseRootFromParent_Done,
     /*   7464 */   // Label 170: @7464
     /*   7464 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7517), // Rule ID 5511 //
     /*   7469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7495 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7515 */     GIR_RootConstrainSelectedInstOperands,
     /*   7516 */     // GIR_Coverage, 5511,
     /*   7516 */     GIR_EraseRootFromParent_Done,
     /*   7517 */   // Label 171: @7517
     /*   7517 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7570), // Rule ID 5505 //
     /*   7522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7548 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7568 */     GIR_RootConstrainSelectedInstOperands,
     /*   7569 */     // GIR_Coverage, 5505,
     /*   7569 */     GIR_EraseRootFromParent_Done,
     /*   7570 */   // Label 172: @7570
     /*   7570 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7623), // Rule ID 5510 //
     /*   7575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7601 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7621 */     GIR_RootConstrainSelectedInstOperands,
     /*   7622 */     // GIR_Coverage, 5510,
     /*   7622 */     GIR_EraseRootFromParent_Done,
     /*   7623 */   // Label 173: @7623
     /*   7623 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7676), // Rule ID 791 //
     /*   7628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7654 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 791,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 174: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7729), // Rule ID 785 //
     /*   7681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7707 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7727 */     GIR_RootConstrainSelectedInstOperands,
     /*   7728 */     // GIR_Coverage, 785,
     /*   7728 */     GIR_EraseRootFromParent_Done,
     /*   7729 */   // Label 175: @7729
     /*   7729 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7782), // Rule ID 790 //
     /*   7734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7760 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7780 */     GIR_RootConstrainSelectedInstOperands,
     /*   7781 */     // GIR_Coverage, 790,
     /*   7781 */     GIR_EraseRootFromParent_Done,
     /*   7782 */   // Label 176: @7782
     /*   7782 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(7818), // Rule ID 763 //
     /*   7787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7798 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7816 */     GIR_RootConstrainSelectedInstOperands,
     /*   7817 */     // GIR_Coverage, 763,
     /*   7817 */     GIR_EraseRootFromParent_Done,
     /*   7818 */   // Label 177: @7818
     /*   7818 */   GIM_Reject,
     /*   7819 */ // Label 165: @7819
     /*   7819 */ GIM_Reject,
     /*   7820 */ // Label 84: @7820
     /*   7820 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(8004),
     /*   7825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7835 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7901), // Rule ID 5531 //
     /*   7840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7875 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7899 */     GIR_RootConstrainSelectedInstOperands,
     /*   7900 */     // GIR_Coverage, 5531,
     /*   7900 */     GIR_EraseRootFromParent_Done,
     /*   7901 */   // Label 179: @7901
     /*   7901 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7967), // Rule ID 888 //
     /*   7906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7941 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7965 */     GIR_RootConstrainSelectedInstOperands,
     /*   7966 */     // GIR_Coverage, 888,
     /*   7966 */     GIR_EraseRootFromParent_Done,
     /*   7967 */   // Label 180: @7967
     /*   7967 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8003), // Rule ID 757 //
     /*   7972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7983 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8001 */     GIR_RootConstrainSelectedInstOperands,
     /*   8002 */     // GIR_Coverage, 757,
     /*   8002 */     GIR_EraseRootFromParent_Done,
     /*   8003 */   // Label 181: @8003
     /*   8003 */   GIM_Reject,
     /*   8004 */ // Label 178: @8004
     /*   8004 */ GIM_Reject,
     /*   8005 */ // Label 85: @8005
     /*   8005 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8960),
     /*   8010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8016 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8088), // Rule ID 778 //
     /*   8021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8064 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8086 */     GIR_RootConstrainSelectedInstOperands,
     /*   8087 */     // GIR_Coverage, 778,
     /*   8087 */     GIR_EraseRootFromParent_Done,
     /*   8088 */   // Label 183: @8088
     /*   8088 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8160), // Rule ID 777 //
     /*   8093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8136 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8158 */     GIR_RootConstrainSelectedInstOperands,
     /*   8159 */     // GIR_Coverage, 777,
     /*   8159 */     GIR_EraseRootFromParent_Done,
     /*   8160 */   // Label 184: @8160
     /*   8160 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8232), // Rule ID 769 //
     /*   8165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8208 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8230 */     GIR_RootConstrainSelectedInstOperands,
     /*   8231 */     // GIR_Coverage, 769,
     /*   8231 */     GIR_EraseRootFromParent_Done,
     /*   8232 */   // Label 185: @8232
     /*   8232 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8304), // Rule ID 776 //
     /*   8237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8280 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8302 */     GIR_RootConstrainSelectedInstOperands,
     /*   8303 */     // GIR_Coverage, 776,
     /*   8303 */     GIR_EraseRootFromParent_Done,
     /*   8304 */   // Label 186: @8304
     /*   8304 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8376), // Rule ID 775 //
     /*   8309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8352 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8374 */     GIR_RootConstrainSelectedInstOperands,
     /*   8375 */     // GIR_Coverage, 775,
     /*   8375 */     GIR_EraseRootFromParent_Done,
     /*   8376 */   // Label 187: @8376
     /*   8376 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8446), // Rule ID 5535 //
     /*   8381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8420 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8444 */     GIR_RootConstrainSelectedInstOperands,
     /*   8445 */     // GIR_Coverage, 5535,
     /*   8445 */     GIR_EraseRootFromParent_Done,
     /*   8446 */   // Label 188: @8446
     /*   8446 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8503), // Rule ID 5509 //
     /*   8451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8481 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 5509,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 189: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8560), // Rule ID 5504 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8538 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8558 */     GIR_RootConstrainSelectedInstOperands,
     /*   8559 */     // GIR_Coverage, 5504,
     /*   8559 */     GIR_EraseRootFromParent_Done,
     /*   8560 */   // Label 190: @8560
     /*   8560 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8617), // Rule ID 5508 //
     /*   8565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8595 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8615 */     GIR_RootConstrainSelectedInstOperands,
     /*   8616 */     // GIR_Coverage, 5508,
     /*   8616 */     GIR_EraseRootFromParent_Done,
     /*   8617 */   // Label 191: @8617
     /*   8617 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8687), // Rule ID 892 //
     /*   8622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8661 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8685 */     GIR_RootConstrainSelectedInstOperands,
     /*   8686 */     // GIR_Coverage, 892,
     /*   8686 */     GIR_EraseRootFromParent_Done,
     /*   8687 */   // Label 192: @8687
     /*   8687 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8744), // Rule ID 789 //
     /*   8692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8722 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8742 */     GIR_RootConstrainSelectedInstOperands,
     /*   8743 */     // GIR_Coverage, 789,
     /*   8743 */     GIR_EraseRootFromParent_Done,
     /*   8744 */   // Label 193: @8744
     /*   8744 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8801), // Rule ID 784 //
     /*   8749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8779 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8799 */     GIR_RootConstrainSelectedInstOperands,
     /*   8800 */     // GIR_Coverage, 784,
     /*   8800 */     GIR_EraseRootFromParent_Done,
     /*   8801 */   // Label 194: @8801
     /*   8801 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8858), // Rule ID 788 //
     /*   8806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8836 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8856 */     GIR_RootConstrainSelectedInstOperands,
     /*   8857 */     // GIR_Coverage, 788,
     /*   8857 */     GIR_EraseRootFromParent_Done,
     /*   8858 */   // Label 195: @8858
     /*   8858 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8898), // Rule ID 761 //
     /*   8863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8878 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8896 */     GIR_RootConstrainSelectedInstOperands,
     /*   8897 */     // GIR_Coverage, 761,
     /*   8897 */     GIR_EraseRootFromParent_Done,
     /*   8898 */   // Label 196: @8898
     /*   8898 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(8959), // Rule ID 3496 //
     /*   8903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8918 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8957 */     GIR_RootConstrainSelectedInstOperands,
     /*   8958 */     // GIR_Coverage, 3496,
     /*   8958 */     GIR_EraseRootFromParent_Done,
     /*   8959 */   // Label 197: @8959
     /*   8959 */   GIM_Reject,
     /*   8960 */ // Label 182: @8960
     /*   8960 */ GIM_Reject,
     /*   8961 */ // Label 86: @8961
     /*   8961 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9145),
     /*   8966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8976 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9042), // Rule ID 5530 //
     /*   8981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9016 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9040 */     GIR_RootConstrainSelectedInstOperands,
     /*   9041 */     // GIR_Coverage, 5530,
     /*   9041 */     GIR_EraseRootFromParent_Done,
     /*   9042 */   // Label 199: @9042
     /*   9042 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9108), // Rule ID 887 //
     /*   9047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9082 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9106 */     GIR_RootConstrainSelectedInstOperands,
     /*   9107 */     // GIR_Coverage, 887,
     /*   9107 */     GIR_EraseRootFromParent_Done,
     /*   9108 */   // Label 200: @9108
     /*   9108 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(9144), // Rule ID 756 //
     /*   9113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9124 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9142 */     GIR_RootConstrainSelectedInstOperands,
     /*   9143 */     // GIR_Coverage, 756,
     /*   9143 */     GIR_EraseRootFromParent_Done,
     /*   9144 */   // Label 201: @9144
     /*   9144 */   GIM_Reject,
     /*   9145 */ // Label 198: @9145
     /*   9145 */ GIM_Reject,
     /*   9146 */ // Label 87: @9146
     /*   9146 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(10101),
     /*   9151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9157 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9229), // Rule ID 774 //
     /*   9162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9205 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9227 */     GIR_RootConstrainSelectedInstOperands,
     /*   9228 */     // GIR_Coverage, 774,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 203: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9301), // Rule ID 773 //
     /*   9234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9277 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9299 */     GIR_RootConstrainSelectedInstOperands,
     /*   9300 */     // GIR_Coverage, 773,
     /*   9300 */     GIR_EraseRootFromParent_Done,
     /*   9301 */   // Label 204: @9301
     /*   9301 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9373), // Rule ID 768 //
     /*   9306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9349 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9371 */     GIR_RootConstrainSelectedInstOperands,
     /*   9372 */     // GIR_Coverage, 768,
     /*   9372 */     GIR_EraseRootFromParent_Done,
     /*   9373 */   // Label 205: @9373
     /*   9373 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9445), // Rule ID 772 //
     /*   9378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9421 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9443 */     GIR_RootConstrainSelectedInstOperands,
     /*   9444 */     // GIR_Coverage, 772,
     /*   9444 */     GIR_EraseRootFromParent_Done,
     /*   9445 */   // Label 206: @9445
     /*   9445 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9517), // Rule ID 771 //
     /*   9450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9493 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9515 */     GIR_RootConstrainSelectedInstOperands,
     /*   9516 */     // GIR_Coverage, 771,
     /*   9516 */     GIR_EraseRootFromParent_Done,
     /*   9517 */   // Label 207: @9517
     /*   9517 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9587), // Rule ID 5534 //
     /*   9522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9561 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9585 */     GIR_RootConstrainSelectedInstOperands,
     /*   9586 */     // GIR_Coverage, 5534,
     /*   9586 */     GIR_EraseRootFromParent_Done,
     /*   9587 */   // Label 208: @9587
     /*   9587 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9644), // Rule ID 5507 //
     /*   9592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9622 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9642 */     GIR_RootConstrainSelectedInstOperands,
     /*   9643 */     // GIR_Coverage, 5507,
     /*   9643 */     GIR_EraseRootFromParent_Done,
     /*   9644 */   // Label 209: @9644
     /*   9644 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9701), // Rule ID 5503 //
     /*   9649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9679 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9699 */     GIR_RootConstrainSelectedInstOperands,
     /*   9700 */     // GIR_Coverage, 5503,
     /*   9700 */     GIR_EraseRootFromParent_Done,
     /*   9701 */   // Label 210: @9701
     /*   9701 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9758), // Rule ID 5506 //
     /*   9706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9736 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9756 */     GIR_RootConstrainSelectedInstOperands,
     /*   9757 */     // GIR_Coverage, 5506,
     /*   9757 */     GIR_EraseRootFromParent_Done,
     /*   9758 */   // Label 211: @9758
     /*   9758 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9828), // Rule ID 891 //
     /*   9763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9802 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9826 */     GIR_RootConstrainSelectedInstOperands,
     /*   9827 */     // GIR_Coverage, 891,
     /*   9827 */     GIR_EraseRootFromParent_Done,
     /*   9828 */   // Label 212: @9828
     /*   9828 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9885), // Rule ID 787 //
     /*   9833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9863 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9883 */     GIR_RootConstrainSelectedInstOperands,
     /*   9884 */     // GIR_Coverage, 787,
     /*   9884 */     GIR_EraseRootFromParent_Done,
     /*   9885 */   // Label 213: @9885
     /*   9885 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9942), // Rule ID 783 //
     /*   9890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9920 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9940 */     GIR_RootConstrainSelectedInstOperands,
     /*   9941 */     // GIR_Coverage, 783,
     /*   9941 */     GIR_EraseRootFromParent_Done,
     /*   9942 */   // Label 214: @9942
     /*   9942 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(9999), // Rule ID 786 //
     /*   9947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9977 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9997 */     GIR_RootConstrainSelectedInstOperands,
     /*   9998 */     // GIR_Coverage, 786,
     /*   9998 */     GIR_EraseRootFromParent_Done,
     /*   9999 */   // Label 215: @9999
     /*   9999 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10039), // Rule ID 760 //
     /*  10004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10019 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10037 */     GIR_RootConstrainSelectedInstOperands,
     /*  10038 */     // GIR_Coverage, 760,
     /*  10038 */     GIR_EraseRootFromParent_Done,
     /*  10039 */   // Label 216: @10039
     /*  10039 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10100), // Rule ID 3492 //
     /*  10044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10059 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10098 */     GIR_RootConstrainSelectedInstOperands,
     /*  10099 */     // GIR_Coverage, 3492,
     /*  10099 */     GIR_EraseRootFromParent_Done,
     /*  10100 */   // Label 217: @10100
     /*  10100 */   GIM_Reject,
     /*  10101 */ // Label 202: @10101
     /*  10101 */ GIM_Reject,
     /*  10102 */ // Label 88: @10102
     /*  10102 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10355),
     /*  10107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10113 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10183), // Rule ID 5533 //
     /*  10118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10157 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10181 */     GIR_RootConstrainSelectedInstOperands,
     /*  10182 */     // GIR_Coverage, 5533,
     /*  10182 */     GIR_EraseRootFromParent_Done,
     /*  10183 */   // Label 219: @10183
     /*  10183 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10253), // Rule ID 890 //
     /*  10188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10227 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 890,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 220: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10293), // Rule ID 759 //
     /*  10258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10273 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10291 */     GIR_RootConstrainSelectedInstOperands,
     /*  10292 */     // GIR_Coverage, 759,
     /*  10292 */     GIR_EraseRootFromParent_Done,
     /*  10293 */   // Label 221: @10293
     /*  10293 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(10354), // Rule ID 3488 //
     /*  10298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10313 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10352 */     GIR_RootConstrainSelectedInstOperands,
     /*  10353 */     // GIR_Coverage, 3488,
     /*  10353 */     GIR_EraseRootFromParent_Done,
     /*  10354 */   // Label 222: @10354
     /*  10354 */   GIM_Reject,
     /*  10355 */ // Label 218: @10355
     /*  10355 */ GIM_Reject,
     /*  10356 */ // Label 89: @10356
     /*  10356 */ GIM_Reject,
     /*  10357 */ // Label 1: @10357
     /*  10357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 232*/ GIMT_Encode4(13600),
     /*  10368 */ /*GILLT_s32*//*Label 223*/ GIMT_Encode4(10428),
     /*  10372 */ /*GILLT_s64*//*Label 224*/ GIMT_Encode4(11042), GIMT_Encode4(0),
     /*  10380 */ /*GILLT_v2s32*//*Label 225*/ GIMT_Encode4(11089),
     /*  10384 */ /*GILLT_v2s64*//*Label 226*/ GIMT_Encode4(11204), GIMT_Encode4(0),
     /*  10392 */ /*GILLT_v4s16*//*Label 227*/ GIMT_Encode4(11756),
     /*  10396 */ /*GILLT_v4s32*//*Label 228*/ GIMT_Encode4(11871), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10408 */ /*GILLT_v8s8*//*Label 229*/ GIMT_Encode4(12586),
     /*  10412 */ /*GILLT_v8s16*//*Label 230*/ GIMT_Encode4(12701), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10424 */ /*GILLT_v16s8*//*Label 231*/ GIMT_Encode4(13416),
     /*  10428 */ // Label 223: @10428
     /*  10428 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(11041),
     /*  10433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10439 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10483), // Rule ID 330 //
     /*  10444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10459 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10481 */     GIR_RootConstrainSelectedInstOperands,
     /*  10482 */     // GIR_Coverage, 330,
     /*  10482 */     GIR_EraseRootFromParent_Done,
     /*  10483 */   // Label 234: @10483
     /*  10483 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10540), // Rule ID 96 //
     /*  10488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10507 */     // MIs[1] Operand 1
     /*  10507 */     // No operand predicates
     /*  10507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10513 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10538 */     GIR_RootConstrainSelectedInstOperands,
     /*  10539 */     // GIR_Coverage, 96,
     /*  10539 */     GIR_EraseRootFromParent_Done,
     /*  10540 */   // Label 235: @10540
     /*  10540 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10597), // Rule ID 427 //
     /*  10545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10564 */     // MIs[1] Operand 1
     /*  10564 */     // No operand predicates
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10570 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10595 */     GIR_RootConstrainSelectedInstOperands,
     /*  10596 */     // GIR_Coverage, 427,
     /*  10596 */     GIR_EraseRootFromParent_Done,
     /*  10597 */   // Label 236: @10597
     /*  10597 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10654), // Rule ID 76 //
     /*  10602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10625 */     // MIs[1] Operand 1
     /*  10625 */     // No operand predicates
     /*  10625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10627 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10652 */     GIR_RootConstrainSelectedInstOperands,
     /*  10653 */     // GIR_Coverage, 76,
     /*  10653 */     GIR_EraseRootFromParent_Done,
     /*  10654 */   // Label 237: @10654
     /*  10654 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10711), // Rule ID 411 //
     /*  10659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10682 */     // MIs[1] Operand 1
     /*  10682 */     // No operand predicates
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10709 */     GIR_RootConstrainSelectedInstOperands,
     /*  10710 */     // GIR_Coverage, 411,
     /*  10710 */     GIR_EraseRootFromParent_Done,
     /*  10711 */   // Label 238: @10711
     /*  10711 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10762), // Rule ID 412 //
     /*  10716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10739 */     // MIs[1] Operand 1
     /*  10739 */     // No operand predicates
     /*  10739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10741 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10760 */     GIR_RootConstrainSelectedInstOperands,
     /*  10761 */     // GIR_Coverage, 412,
     /*  10761 */     GIR_EraseRootFromParent_Done,
     /*  10762 */   // Label 239: @10762
     /*  10762 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10832), // Rule ID 173 //
     /*  10767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10806 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10830 */     GIR_RootConstrainSelectedInstOperands,
     /*  10831 */     // GIR_Coverage, 173,
     /*  10831 */     GIR_EraseRootFromParent_Done,
     /*  10832 */   // Label 240: @10832
     /*  10832 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10902), // Rule ID 504 //
     /*  10837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10876 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10900 */     GIR_RootConstrainSelectedInstOperands,
     /*  10901 */     // GIR_Coverage, 504,
     /*  10901 */     GIR_EraseRootFromParent_Done,
     /*  10902 */   // Label 241: @10902
     /*  10902 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10948), // Rule ID 77 //
     /*  10907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10922 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10946 */     GIR_RootConstrainSelectedInstOperands,
     /*  10947 */     // GIR_Coverage, 77,
     /*  10947 */     GIR_EraseRootFromParent_Done,
     /*  10948 */   // Label 242: @10948
     /*  10948 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10994), // Rule ID 333 //
     /*  10953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10968 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10992 */     GIR_RootConstrainSelectedInstOperands,
     /*  10993 */     // GIR_Coverage, 333,
     /*  10993 */     GIR_EraseRootFromParent_Done,
     /*  10994 */   // Label 243: @10994
     /*  10994 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11040), // Rule ID 413 //
     /*  10999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  11002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  11014 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  11014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11038 */     GIR_RootConstrainSelectedInstOperands,
     /*  11039 */     // GIR_Coverage, 413,
     /*  11039 */     GIR_EraseRootFromParent_Done,
     /*  11040 */   // Label 244: @11040
     /*  11040 */   GIM_Reject,
     /*  11041 */ // Label 233: @11041
     /*  11041 */ GIM_Reject,
     /*  11042 */ // Label 224: @11042
     /*  11042 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11088), // Rule ID 966 //
     /*  11047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11068 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11075 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11080 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11086 */   GIR_RootConstrainSelectedInstOperands,
     /*  11087 */   // GIR_Coverage, 966,
     /*  11087 */   GIR_EraseRootFromParent_Done,
     /*  11088 */ // Label 245: @11088
     /*  11088 */ GIM_Reject,
     /*  11089 */ // Label 225: @11089
     /*  11089 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11203),
     /*  11094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11108 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11170), // Rule ID 917 //
     /*  11113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11144 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11168 */     GIR_RootConstrainSelectedInstOperands,
     /*  11169 */     // GIR_Coverage, 917,
     /*  11169 */     GIR_EraseRootFromParent_Done,
     /*  11170 */   // Label 247: @11170
     /*  11170 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11202), // Rule ID 962 //
     /*  11175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11182 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11200 */     GIR_RootConstrainSelectedInstOperands,
     /*  11201 */     // GIR_Coverage, 962,
     /*  11201 */     GIR_EraseRootFromParent_Done,
     /*  11202 */   // Label 248: @11202
     /*  11202 */   GIM_Reject,
     /*  11203 */ // Label 246: @11203
     /*  11203 */ GIM_Reject,
     /*  11204 */ // Label 226: @11204
     /*  11204 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11755),
     /*  11209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11219 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11287), // Rule ID 986 //
     /*  11224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11263 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11285 */     GIR_RootConstrainSelectedInstOperands,
     /*  11286 */     // GIR_Coverage, 986,
     /*  11286 */     GIR_EraseRootFromParent_Done,
     /*  11287 */   // Label 250: @11287
     /*  11287 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11355), // Rule ID 985 //
     /*  11292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11331 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11353 */     GIR_RootConstrainSelectedInstOperands,
     /*  11354 */     // GIR_Coverage, 985,
     /*  11354 */     GIR_EraseRootFromParent_Done,
     /*  11355 */   // Label 251: @11355
     /*  11355 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11423), // Rule ID 974 //
     /*  11360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11399 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11421 */     GIR_RootConstrainSelectedInstOperands,
     /*  11422 */     // GIR_Coverage, 974,
     /*  11422 */     GIR_EraseRootFromParent_Done,
     /*  11423 */   // Label 252: @11423
     /*  11423 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11491), // Rule ID 984 //
     /*  11428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11467 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 984,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 253: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11559), // Rule ID 983 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11535 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11557 */     GIR_RootConstrainSelectedInstOperands,
     /*  11558 */     // GIR_Coverage, 983,
     /*  11558 */     GIR_EraseRootFromParent_Done,
     /*  11559 */   // Label 254: @11559
     /*  11559 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11612), // Rule ID 995 //
     /*  11564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11610 */     GIR_RootConstrainSelectedInstOperands,
     /*  11611 */     // GIR_Coverage, 995,
     /*  11611 */     GIR_EraseRootFromParent_Done,
     /*  11612 */   // Label 255: @11612
     /*  11612 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11665), // Rule ID 989 //
     /*  11617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11643 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11663 */     GIR_RootConstrainSelectedInstOperands,
     /*  11664 */     // GIR_Coverage, 989,
     /*  11664 */     GIR_EraseRootFromParent_Done,
     /*  11665 */   // Label 256: @11665
     /*  11665 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11718), // Rule ID 994 //
     /*  11670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11696 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11716 */     GIR_RootConstrainSelectedInstOperands,
     /*  11717 */     // GIR_Coverage, 994,
     /*  11717 */     GIR_EraseRootFromParent_Done,
     /*  11718 */   // Label 257: @11718
     /*  11718 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11754), // Rule ID 967 //
     /*  11723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11734 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11752 */     GIR_RootConstrainSelectedInstOperands,
     /*  11753 */     // GIR_Coverage, 967,
     /*  11753 */     GIR_EraseRootFromParent_Done,
     /*  11754 */   // Label 258: @11754
     /*  11754 */   GIM_Reject,
     /*  11755 */ // Label 249: @11755
     /*  11755 */ GIM_Reject,
     /*  11756 */ // Label 227: @11756
     /*  11756 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11870),
     /*  11761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11775 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11837), // Rule ID 916 //
     /*  11780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11811 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11835 */     GIR_RootConstrainSelectedInstOperands,
     /*  11836 */     // GIR_Coverage, 916,
     /*  11836 */     GIR_EraseRootFromParent_Done,
     /*  11837 */   // Label 260: @11837
     /*  11837 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11869), // Rule ID 961 //
     /*  11842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11849 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11867 */     GIR_RootConstrainSelectedInstOperands,
     /*  11868 */     // GIR_Coverage, 961,
     /*  11868 */     GIR_EraseRootFromParent_Done,
     /*  11869 */   // Label 261: @11869
     /*  11869 */   GIM_Reject,
     /*  11870 */ // Label 259: @11870
     /*  11870 */ GIM_Reject,
     /*  11871 */ // Label 228: @11871
     /*  11871 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12585),
     /*  11876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11954), // Rule ID 982 //
     /*  11887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11930 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11952 */     GIR_RootConstrainSelectedInstOperands,
     /*  11953 */     // GIR_Coverage, 982,
     /*  11953 */     GIR_EraseRootFromParent_Done,
     /*  11954 */   // Label 263: @11954
     /*  11954 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12026), // Rule ID 981 //
     /*  11959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12002 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12024 */     GIR_RootConstrainSelectedInstOperands,
     /*  12025 */     // GIR_Coverage, 981,
     /*  12025 */     GIR_EraseRootFromParent_Done,
     /*  12026 */   // Label 264: @12026
     /*  12026 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12098), // Rule ID 973 //
     /*  12031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12074 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12096 */     GIR_RootConstrainSelectedInstOperands,
     /*  12097 */     // GIR_Coverage, 973,
     /*  12097 */     GIR_EraseRootFromParent_Done,
     /*  12098 */   // Label 265: @12098
     /*  12098 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12170), // Rule ID 980 //
     /*  12103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12146 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12168 */     GIR_RootConstrainSelectedInstOperands,
     /*  12169 */     // GIR_Coverage, 980,
     /*  12169 */     GIR_EraseRootFromParent_Done,
     /*  12170 */   // Label 266: @12170
     /*  12170 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12242), // Rule ID 979 //
     /*  12175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12218 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12240 */     GIR_RootConstrainSelectedInstOperands,
     /*  12241 */     // GIR_Coverage, 979,
     /*  12241 */     GIR_EraseRootFromParent_Done,
     /*  12242 */   // Label 267: @12242
     /*  12242 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12312), // Rule ID 920 //
     /*  12247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12286 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12310 */     GIR_RootConstrainSelectedInstOperands,
     /*  12311 */     // GIR_Coverage, 920,
     /*  12311 */     GIR_EraseRootFromParent_Done,
     /*  12312 */   // Label 268: @12312
     /*  12312 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12369), // Rule ID 993 //
     /*  12317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12347 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12367 */     GIR_RootConstrainSelectedInstOperands,
     /*  12368 */     // GIR_Coverage, 993,
     /*  12368 */     GIR_EraseRootFromParent_Done,
     /*  12369 */   // Label 269: @12369
     /*  12369 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12426), // Rule ID 988 //
     /*  12374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12404 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12424 */     GIR_RootConstrainSelectedInstOperands,
     /*  12425 */     // GIR_Coverage, 988,
     /*  12425 */     GIR_EraseRootFromParent_Done,
     /*  12426 */   // Label 270: @12426
     /*  12426 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12483), // Rule ID 992 //
     /*  12431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12461 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12481 */     GIR_RootConstrainSelectedInstOperands,
     /*  12482 */     // GIR_Coverage, 992,
     /*  12482 */     GIR_EraseRootFromParent_Done,
     /*  12483 */   // Label 271: @12483
     /*  12483 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12523), // Rule ID 965 //
     /*  12488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12503 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12521 */     GIR_RootConstrainSelectedInstOperands,
     /*  12522 */     // GIR_Coverage, 965,
     /*  12522 */     GIR_EraseRootFromParent_Done,
     /*  12523 */   // Label 272: @12523
     /*  12523 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12584), // Rule ID 3508 //
     /*  12528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12543 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12582 */     GIR_RootConstrainSelectedInstOperands,
     /*  12583 */     // GIR_Coverage, 3508,
     /*  12583 */     GIR_EraseRootFromParent_Done,
     /*  12584 */   // Label 273: @12584
     /*  12584 */   GIM_Reject,
     /*  12585 */ // Label 262: @12585
     /*  12585 */ GIM_Reject,
     /*  12586 */ // Label 229: @12586
     /*  12586 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12700),
     /*  12591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12605 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12667), // Rule ID 915 //
     /*  12610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12641 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12665 */     GIR_RootConstrainSelectedInstOperands,
     /*  12666 */     // GIR_Coverage, 915,
     /*  12666 */     GIR_EraseRootFromParent_Done,
     /*  12667 */   // Label 275: @12667
     /*  12667 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(12699), // Rule ID 960 //
     /*  12672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12679 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12697 */     GIR_RootConstrainSelectedInstOperands,
     /*  12698 */     // GIR_Coverage, 960,
     /*  12698 */     GIR_EraseRootFromParent_Done,
     /*  12699 */   // Label 276: @12699
     /*  12699 */   GIM_Reject,
     /*  12700 */ // Label 274: @12700
     /*  12700 */ GIM_Reject,
     /*  12701 */ // Label 230: @12701
     /*  12701 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13415),
     /*  12706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12712 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12784), // Rule ID 978 //
     /*  12717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12760 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12782 */     GIR_RootConstrainSelectedInstOperands,
     /*  12783 */     // GIR_Coverage, 978,
     /*  12783 */     GIR_EraseRootFromParent_Done,
     /*  12784 */   // Label 278: @12784
     /*  12784 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12856), // Rule ID 977 //
     /*  12789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12832 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12854 */     GIR_RootConstrainSelectedInstOperands,
     /*  12855 */     // GIR_Coverage, 977,
     /*  12855 */     GIR_EraseRootFromParent_Done,
     /*  12856 */   // Label 279: @12856
     /*  12856 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12928), // Rule ID 972 //
     /*  12861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12904 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12926 */     GIR_RootConstrainSelectedInstOperands,
     /*  12927 */     // GIR_Coverage, 972,
     /*  12927 */     GIR_EraseRootFromParent_Done,
     /*  12928 */   // Label 280: @12928
     /*  12928 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13000), // Rule ID 976 //
     /*  12933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12976 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12998 */     GIR_RootConstrainSelectedInstOperands,
     /*  12999 */     // GIR_Coverage, 976,
     /*  12999 */     GIR_EraseRootFromParent_Done,
     /*  13000 */   // Label 281: @13000
     /*  13000 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13072), // Rule ID 975 //
     /*  13005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13048 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13070 */     GIR_RootConstrainSelectedInstOperands,
     /*  13071 */     // GIR_Coverage, 975,
     /*  13071 */     GIR_EraseRootFromParent_Done,
     /*  13072 */   // Label 282: @13072
     /*  13072 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13142), // Rule ID 919 //
     /*  13077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13140 */     GIR_RootConstrainSelectedInstOperands,
     /*  13141 */     // GIR_Coverage, 919,
     /*  13141 */     GIR_EraseRootFromParent_Done,
     /*  13142 */   // Label 283: @13142
     /*  13142 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13199), // Rule ID 991 //
     /*  13147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13177 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13197 */     GIR_RootConstrainSelectedInstOperands,
     /*  13198 */     // GIR_Coverage, 991,
     /*  13198 */     GIR_EraseRootFromParent_Done,
     /*  13199 */   // Label 284: @13199
     /*  13199 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13256), // Rule ID 987 //
     /*  13204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13234 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13254 */     GIR_RootConstrainSelectedInstOperands,
     /*  13255 */     // GIR_Coverage, 987,
     /*  13255 */     GIR_EraseRootFromParent_Done,
     /*  13256 */   // Label 285: @13256
     /*  13256 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13313), // Rule ID 990 //
     /*  13261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13291 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13311 */     GIR_RootConstrainSelectedInstOperands,
     /*  13312 */     // GIR_Coverage, 990,
     /*  13312 */     GIR_EraseRootFromParent_Done,
     /*  13313 */   // Label 286: @13313
     /*  13313 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13353), // Rule ID 964 //
     /*  13318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13333 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13351 */     GIR_RootConstrainSelectedInstOperands,
     /*  13352 */     // GIR_Coverage, 964,
     /*  13352 */     GIR_EraseRootFromParent_Done,
     /*  13353 */   // Label 287: @13353
     /*  13353 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13414), // Rule ID 3504 //
     /*  13358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13373 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13412 */     GIR_RootConstrainSelectedInstOperands,
     /*  13413 */     // GIR_Coverage, 3504,
     /*  13413 */     GIR_EraseRootFromParent_Done,
     /*  13414 */   // Label 288: @13414
     /*  13414 */   GIM_Reject,
     /*  13415 */ // Label 277: @13415
     /*  13415 */ GIM_Reject,
     /*  13416 */ // Label 231: @13416
     /*  13416 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13599),
     /*  13421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13427 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13497), // Rule ID 918 //
     /*  13432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13471 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13495 */     GIR_RootConstrainSelectedInstOperands,
     /*  13496 */     // GIR_Coverage, 918,
     /*  13496 */     GIR_EraseRootFromParent_Done,
     /*  13497 */   // Label 290: @13497
     /*  13497 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13537), // Rule ID 963 //
     /*  13502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13517 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13535 */     GIR_RootConstrainSelectedInstOperands,
     /*  13536 */     // GIR_Coverage, 963,
     /*  13536 */     GIR_EraseRootFromParent_Done,
     /*  13537 */   // Label 291: @13537
     /*  13537 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(13598), // Rule ID 3500 //
     /*  13542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13557 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13596 */     GIR_RootConstrainSelectedInstOperands,
     /*  13597 */     // GIR_Coverage, 3500,
     /*  13597 */     GIR_EraseRootFromParent_Done,
     /*  13598 */   // Label 292: @13598
     /*  13598 */   GIM_Reject,
     /*  13599 */ // Label 289: @13599
     /*  13599 */ GIM_Reject,
     /*  13600 */ // Label 232: @13600
     /*  13600 */ GIM_Reject,
     /*  13601 */ // Label 2: @13601
     /*  13601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 300*/ GIMT_Encode4(15304),
     /*  13612 */ /*GILLT_s32*//*Label 293*/ GIMT_Encode4(13672), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13624 */ /*GILLT_v2s32*//*Label 294*/ GIMT_Encode4(14591), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13636 */ /*GILLT_v4s16*//*Label 295*/ GIMT_Encode4(14638),
     /*  13640 */ /*GILLT_v4s32*//*Label 296*/ GIMT_Encode4(14685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13652 */ /*GILLT_v8s8*//*Label 297*/ GIMT_Encode4(14914),
     /*  13656 */ /*GILLT_v8s16*//*Label 298*/ GIMT_Encode4(14961), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13668 */ /*GILLT_v16s8*//*Label 299*/ GIMT_Encode4(15190),
     /*  13672 */ // Label 293: @13672
     /*  13672 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(14590),
     /*  13677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13683 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13771), // Rule ID 186 //
     /*  13688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13747 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13769 */     GIR_RootConstrainSelectedInstOperands,
     /*  13770 */     // GIR_Coverage, 186,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 302: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13859), // Rule ID 515 //
     /*  13776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13829 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13835 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13857 */     GIR_RootConstrainSelectedInstOperands,
     /*  13858 */     // GIR_Coverage, 515,
     /*  13858 */     GIR_EraseRootFromParent_Done,
     /*  13859 */   // Label 303: @13859
     /*  13859 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(13950), // Rule ID 185 //
     /*  13864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13913 */     // MIs[2] Operand 2
     /*  13913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13926 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13948 */     GIR_RootConstrainSelectedInstOperands,
     /*  13949 */     // GIR_Coverage, 185,
     /*  13949 */     GIR_EraseRootFromParent_Done,
     /*  13950 */   // Label 304: @13950
     /*  13950 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14041), // Rule ID 514 //
     /*  13955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14004 */     // MIs[2] Operand 2
     /*  14004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14017 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14039 */     GIR_RootConstrainSelectedInstOperands,
     /*  14040 */     // GIR_Coverage, 514,
     /*  14040 */     GIR_EraseRootFromParent_Done,
     /*  14041 */   // Label 305: @14041
     /*  14041 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14132), // Rule ID 184 //
     /*  14046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14070 */     // MIs[1] Operand 2
     /*  14070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14108 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14130 */     GIR_RootConstrainSelectedInstOperands,
     /*  14131 */     // GIR_Coverage, 184,
     /*  14131 */     GIR_EraseRootFromParent_Done,
     /*  14132 */   // Label 306: @14132
     /*  14132 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14223), // Rule ID 513 //
     /*  14137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14161 */     // MIs[1] Operand 2
     /*  14161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14199 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14221 */     GIR_RootConstrainSelectedInstOperands,
     /*  14222 */     // GIR_Coverage, 513,
     /*  14222 */     GIR_EraseRootFromParent_Done,
     /*  14223 */   // Label 307: @14223
     /*  14223 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14317), // Rule ID 183 //
     /*  14228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14252 */     // MIs[1] Operand 2
     /*  14252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14293 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14315 */     GIR_RootConstrainSelectedInstOperands,
     /*  14316 */     // GIR_Coverage, 183,
     /*  14316 */     GIR_EraseRootFromParent_Done,
     /*  14317 */   // Label 308: @14317
     /*  14317 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14411), // Rule ID 512 //
     /*  14322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14346 */     // MIs[1] Operand 2
     /*  14346 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14374 */     // MIs[2] Operand 2
     /*  14374 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14387 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14409 */     GIR_RootConstrainSelectedInstOperands,
     /*  14410 */     // GIR_Coverage, 512,
     /*  14410 */     GIR_EraseRootFromParent_Done,
     /*  14411 */   // Label 309: @14411
     /*  14411 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14457), // Rule ID 169 //
     /*  14416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14431 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14455 */     GIR_RootConstrainSelectedInstOperands,
     /*  14456 */     // GIR_Coverage, 169,
     /*  14456 */     GIR_EraseRootFromParent_Done,
     /*  14457 */   // Label 310: @14457
     /*  14457 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14503), // Rule ID 170 //
     /*  14462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14477 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14501 */     GIR_RootConstrainSelectedInstOperands,
     /*  14502 */     // GIR_Coverage, 170,
     /*  14502 */     GIR_EraseRootFromParent_Done,
     /*  14503 */   // Label 311: @14503
     /*  14503 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14549), // Rule ID 323 //
     /*  14508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14523 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14547 */     GIR_RootConstrainSelectedInstOperands,
     /*  14548 */     // GIR_Coverage, 323,
     /*  14548 */     GIR_EraseRootFromParent_Done,
     /*  14549 */   // Label 312: @14549
     /*  14549 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14589), // Rule ID 502 //
     /*  14554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14569 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14587 */     GIR_RootConstrainSelectedInstOperands,
     /*  14588 */     // GIR_Coverage, 502,
     /*  14588 */     GIR_EraseRootFromParent_Done,
     /*  14589 */   // Label 313: @14589
     /*  14589 */   GIM_Reject,
     /*  14590 */ // Label 301: @14590
     /*  14590 */ GIM_Reject,
     /*  14591 */ // Label 294: @14591
     /*  14591 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14637), // Rule ID 837 //
     /*  14596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14617 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14624 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14635 */   GIR_RootConstrainSelectedInstOperands,
     /*  14636 */   // GIR_Coverage, 837,
     /*  14636 */   GIR_EraseRootFromParent_Done,
     /*  14637 */ // Label 314: @14637
     /*  14637 */ GIM_Reject,
     /*  14638 */ // Label 295: @14638
     /*  14638 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14684), // Rule ID 836 //
     /*  14643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14664 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14669 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14671 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14676 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14682 */   GIR_RootConstrainSelectedInstOperands,
     /*  14683 */   // GIR_Coverage, 836,
     /*  14683 */   GIR_EraseRootFromParent_Done,
     /*  14684 */ // Label 315: @14684
     /*  14684 */ GIM_Reject,
     /*  14685 */ // Label 296: @14685
     /*  14685 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14913),
     /*  14690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14696 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14811), // Rule ID 4421 //
     /*  14701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14725 */     // MIs[1] Operand 2
     /*  14725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14753 */     // MIs[2] Operand 2
     /*  14753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14766 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14809 */     GIR_RootConstrainSelectedInstOperands,
     /*  14810 */     // GIR_Coverage, 4421,
     /*  14810 */     GIR_EraseRootFromParent_Done,
     /*  14811 */   // Label 317: @14811
     /*  14811 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14851), // Rule ID 840 //
     /*  14816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14831 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14849 */     GIR_RootConstrainSelectedInstOperands,
     /*  14850 */     // GIR_Coverage, 840,
     /*  14850 */     GIR_EraseRootFromParent_Done,
     /*  14851 */   // Label 318: @14851
     /*  14851 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14912), // Rule ID 3466 //
     /*  14856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14871 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14910 */     GIR_RootConstrainSelectedInstOperands,
     /*  14911 */     // GIR_Coverage, 3466,
     /*  14911 */     GIR_EraseRootFromParent_Done,
     /*  14912 */   // Label 319: @14912
     /*  14912 */   GIM_Reject,
     /*  14913 */ // Label 316: @14913
     /*  14913 */ GIM_Reject,
     /*  14914 */ // Label 297: @14914
     /*  14914 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(14960), // Rule ID 835 //
     /*  14919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14940 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14947 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14952 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14958 */   GIR_RootConstrainSelectedInstOperands,
     /*  14959 */   // GIR_Coverage, 835,
     /*  14959 */   GIR_EraseRootFromParent_Done,
     /*  14960 */ // Label 320: @14960
     /*  14960 */ GIM_Reject,
     /*  14961 */ // Label 298: @14961
     /*  14961 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15189),
     /*  14966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14972 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15087), // Rule ID 4426 //
     /*  14977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15001 */     // MIs[1] Operand 2
     /*  15001 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  15012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15029 */     // MIs[2] Operand 2
     /*  15029 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15042 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15085 */     GIR_RootConstrainSelectedInstOperands,
     /*  15086 */     // GIR_Coverage, 4426,
     /*  15086 */     GIR_EraseRootFromParent_Done,
     /*  15087 */   // Label 322: @15087
     /*  15087 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15127), // Rule ID 839 //
     /*  15092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15107 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15125 */     GIR_RootConstrainSelectedInstOperands,
     /*  15126 */     // GIR_Coverage, 839,
     /*  15126 */     GIR_EraseRootFromParent_Done,
     /*  15127 */   // Label 323: @15127
     /*  15127 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15188), // Rule ID 3462 //
     /*  15132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15147 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15186 */     GIR_RootConstrainSelectedInstOperands,
     /*  15187 */     // GIR_Coverage, 3462,
     /*  15187 */     GIR_EraseRootFromParent_Done,
     /*  15188 */   // Label 324: @15188
     /*  15188 */   GIM_Reject,
     /*  15189 */ // Label 321: @15189
     /*  15189 */ GIM_Reject,
     /*  15190 */ // Label 299: @15190
     /*  15190 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15303),
     /*  15195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15201 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15241), // Rule ID 838 //
     /*  15206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15221 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15239 */     GIR_RootConstrainSelectedInstOperands,
     /*  15240 */     // GIR_Coverage, 838,
     /*  15240 */     GIR_EraseRootFromParent_Done,
     /*  15241 */   // Label 326: @15241
     /*  15241 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15302), // Rule ID 3458 //
     /*  15246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15261 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15300 */     GIR_RootConstrainSelectedInstOperands,
     /*  15301 */     // GIR_Coverage, 3458,
     /*  15301 */     GIR_EraseRootFromParent_Done,
     /*  15302 */   // Label 327: @15302
     /*  15302 */   GIM_Reject,
     /*  15303 */ // Label 325: @15303
     /*  15303 */ GIM_Reject,
     /*  15304 */ // Label 300: @15304
     /*  15304 */ GIM_Reject,
     /*  15305 */ // Label 3: @15305
     /*  15305 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15400),
     /*  15310 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15319 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15359), // Rule ID 195 //
     /*  15324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15339 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15357 */     GIR_RootConstrainSelectedInstOperands,
     /*  15358 */     // GIR_Coverage, 195,
     /*  15358 */     GIR_EraseRootFromParent_Done,
     /*  15359 */   // Label 329: @15359
     /*  15359 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15399), // Rule ID 532 //
     /*  15364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15379 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15397 */     GIR_RootConstrainSelectedInstOperands,
     /*  15398 */     // GIR_Coverage, 532,
     /*  15398 */     GIR_EraseRootFromParent_Done,
     /*  15399 */   // Label 330: @15399
     /*  15399 */   GIM_Reject,
     /*  15400 */ // Label 328: @15400
     /*  15400 */ GIM_Reject,
     /*  15401 */ // Label 4: @15401
     /*  15401 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15496),
     /*  15406 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15415 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15455), // Rule ID 196 //
     /*  15420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15435 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15453 */     GIR_RootConstrainSelectedInstOperands,
     /*  15454 */     // GIR_Coverage, 196,
     /*  15454 */     GIR_EraseRootFromParent_Done,
     /*  15455 */   // Label 332: @15455
     /*  15455 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15495), // Rule ID 533 //
     /*  15460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15475 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15493 */     GIR_RootConstrainSelectedInstOperands,
     /*  15494 */     // GIR_Coverage, 533,
     /*  15494 */     GIR_EraseRootFromParent_Done,
     /*  15495 */   // Label 333: @15495
     /*  15495 */   GIM_Reject,
     /*  15496 */ // Label 331: @15496
     /*  15496 */ GIM_Reject,
     /*  15497 */ // Label 5: @15497
     /*  15497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 347*/ GIMT_Encode4(18676),
     /*  15508 */ /*GILLT_s32*//*Label 334*/ GIMT_Encode4(15568),
     /*  15512 */ /*GILLT_s64*//*Label 335*/ GIMT_Encode4(17560),
     /*  15516 */ /*GILLT_v2s1*//*Label 336*/ GIMT_Encode4(17607),
     /*  15520 */ /*GILLT_v2s32*//*Label 337*/ GIMT_Encode4(17725),
     /*  15524 */ /*GILLT_v2s64*//*Label 338*/ GIMT_Encode4(17772),
     /*  15528 */ /*GILLT_v4s1*//*Label 339*/ GIMT_Encode4(17886),
     /*  15532 */ /*GILLT_v4s16*//*Label 340*/ GIMT_Encode4(18004),
     /*  15536 */ /*GILLT_v4s32*//*Label 341*/ GIMT_Encode4(18051), GIMT_Encode4(0),
     /*  15544 */ /*GILLT_v8s1*//*Label 342*/ GIMT_Encode4(18165),
     /*  15548 */ /*GILLT_v8s8*//*Label 343*/ GIMT_Encode4(18283),
     /*  15552 */ /*GILLT_v8s16*//*Label 344*/ GIMT_Encode4(18330), GIMT_Encode4(0),
     /*  15560 */ /*GILLT_v16s1*//*Label 345*/ GIMT_Encode4(18444),
     /*  15564 */ /*GILLT_v16s8*//*Label 346*/ GIMT_Encode4(18562),
     /*  15568 */ // Label 334: @15568
     /*  15568 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17559),
     /*  15573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15579 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15652), // Rule ID 1855 //
     /*  15584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15616 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15629 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15650 */     GIR_RootConstrainSelectedInstOperands,
     /*  15651 */     // GIR_Coverage, 1855,
     /*  15651 */     GIR_EraseRootFromParent_Done,
     /*  15652 */   // Label 349: @15652
     /*  15652 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15725), // Rule ID 2112 //
     /*  15657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15689 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15702 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15723 */     GIR_RootConstrainSelectedInstOperands,
     /*  15724 */     // GIR_Coverage, 2112,
     /*  15724 */     GIR_EraseRootFromParent_Done,
     /*  15725 */   // Label 350: @15725
     /*  15725 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15773), // Rule ID 1997 //
     /*  15730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15741 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15752 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15771 */     GIR_RootConstrainSelectedInstOperands,
     /*  15772 */     // GIR_Coverage, 1997,
     /*  15772 */     GIR_EraseRootFromParent_Done,
     /*  15773 */   // Label 351: @15773
     /*  15773 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15821), // Rule ID 1998 //
     /*  15778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15789 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15800 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15819 */     GIR_RootConstrainSelectedInstOperands,
     /*  15820 */     // GIR_Coverage, 1998,
     /*  15820 */     GIR_EraseRootFromParent_Done,
     /*  15821 */   // Label 352: @15821
     /*  15821 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15869), // Rule ID 1999 //
     /*  15826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15837 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15848 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15867 */     GIR_RootConstrainSelectedInstOperands,
     /*  15868 */     // GIR_Coverage, 1999,
     /*  15868 */     GIR_EraseRootFromParent_Done,
     /*  15869 */   // Label 353: @15869
     /*  15869 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15917), // Rule ID 2236 //
     /*  15874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15885 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15896 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15915 */     GIR_RootConstrainSelectedInstOperands,
     /*  15916 */     // GIR_Coverage, 2236,
     /*  15916 */     GIR_EraseRootFromParent_Done,
     /*  15917 */   // Label 354: @15917
     /*  15917 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15965), // Rule ID 2237 //
     /*  15922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15933 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15944 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 2237,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 355: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16013), // Rule ID 2238 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15981 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15992 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16011 */     GIR_RootConstrainSelectedInstOperands,
     /*  16012 */     // GIR_Coverage, 2238,
     /*  16012 */     GIR_EraseRootFromParent_Done,
     /*  16013 */   // Label 356: @16013
     /*  16013 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16090), // Rule ID 5439 //
     /*  16018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16057 */     // MIs[2] Operand 1
     /*  16057 */     // No operand predicates
     /*  16057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16063 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16088 */     GIR_RootConstrainSelectedInstOperands,
     /*  16089 */     // GIR_Coverage, 5439,
     /*  16089 */     GIR_EraseRootFromParent_Done,
     /*  16090 */   // Label 357: @16090
     /*  16090 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16167), // Rule ID 5472 //
     /*  16095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16134 */     // MIs[2] Operand 1
     /*  16134 */     // No operand predicates
     /*  16134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16140 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16165 */     GIR_RootConstrainSelectedInstOperands,
     /*  16166 */     // GIR_Coverage, 5472,
     /*  16166 */     GIR_EraseRootFromParent_Done,
     /*  16167 */   // Label 358: @16167
     /*  16167 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16244), // Rule ID 5438 //
     /*  16172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16207 */     // MIs[2] Operand 1
     /*  16207 */     // No operand predicates
     /*  16207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16217 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16242 */     GIR_RootConstrainSelectedInstOperands,
     /*  16243 */     // GIR_Coverage, 5438,
     /*  16243 */     GIR_EraseRootFromParent_Done,
     /*  16244 */   // Label 359: @16244
     /*  16244 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16321), // Rule ID 5471 //
     /*  16249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16284 */     // MIs[2] Operand 1
     /*  16284 */     // No operand predicates
     /*  16284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16294 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16319 */     GIR_RootConstrainSelectedInstOperands,
     /*  16320 */     // GIR_Coverage, 5471,
     /*  16320 */     GIR_EraseRootFromParent_Done,
     /*  16321 */   // Label 360: @16321
     /*  16321 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16398), // Rule ID 5437 //
     /*  16326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16369 */     // MIs[2] Operand 1
     /*  16369 */     // No operand predicates
     /*  16369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16371 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16396 */     GIR_RootConstrainSelectedInstOperands,
     /*  16397 */     // GIR_Coverage, 5437,
     /*  16397 */     GIR_EraseRootFromParent_Done,
     /*  16398 */   // Label 361: @16398
     /*  16398 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16475), // Rule ID 5470 //
     /*  16403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16446 */     // MIs[2] Operand 1
     /*  16446 */     // No operand predicates
     /*  16446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16448 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16473 */     GIR_RootConstrainSelectedInstOperands,
     /*  16474 */     // GIR_Coverage, 5470,
     /*  16474 */     GIR_EraseRootFromParent_Done,
     /*  16475 */   // Label 362: @16475
     /*  16475 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16552), // Rule ID 159 //
     /*  16480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16519 */     // MIs[2] Operand 1
     /*  16519 */     // No operand predicates
     /*  16519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16525 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16550 */     GIR_RootConstrainSelectedInstOperands,
     /*  16551 */     // GIR_Coverage, 159,
     /*  16551 */     GIR_EraseRootFromParent_Done,
     /*  16552 */   // Label 363: @16552
     /*  16552 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16629), // Rule ID 490 //
     /*  16557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16596 */     // MIs[2] Operand 1
     /*  16596 */     // No operand predicates
     /*  16596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16602 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16627 */     GIR_RootConstrainSelectedInstOperands,
     /*  16628 */     // GIR_Coverage, 490,
     /*  16628 */     GIR_EraseRootFromParent_Done,
     /*  16629 */   // Label 364: @16629
     /*  16629 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16700), // Rule ID 5440 //
     /*  16634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16672 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16698 */     GIR_RootConstrainSelectedInstOperands,
     /*  16699 */     // GIR_Coverage, 5440,
     /*  16699 */     GIR_EraseRootFromParent_Done,
     /*  16700 */   // Label 365: @16700
     /*  16700 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16771), // Rule ID 5461 //
     /*  16705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16743 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16769 */     GIR_RootConstrainSelectedInstOperands,
     /*  16770 */     // GIR_Coverage, 5461,
     /*  16770 */     GIR_EraseRootFromParent_Done,
     /*  16771 */   // Label 366: @16771
     /*  16771 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16842), // Rule ID 5473 //
     /*  16776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16814 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16840 */     GIR_RootConstrainSelectedInstOperands,
     /*  16841 */     // GIR_Coverage, 5473,
     /*  16841 */     GIR_EraseRootFromParent_Done,
     /*  16842 */   // Label 367: @16842
     /*  16842 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16913), // Rule ID 160 //
     /*  16847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16879 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16885 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16911 */     GIR_RootConstrainSelectedInstOperands,
     /*  16912 */     // GIR_Coverage, 160,
     /*  16912 */     GIR_EraseRootFromParent_Done,
     /*  16913 */   // Label 368: @16913
     /*  16913 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16984), // Rule ID 313 //
     /*  16918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16956 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16982 */     GIR_RootConstrainSelectedInstOperands,
     /*  16983 */     // GIR_Coverage, 313,
     /*  16983 */     GIR_EraseRootFromParent_Done,
     /*  16984 */   // Label 369: @16984
     /*  16984 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17055), // Rule ID 491 //
     /*  16989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17027 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17053 */     GIR_RootConstrainSelectedInstOperands,
     /*  17054 */     // GIR_Coverage, 491,
     /*  17054 */     GIR_EraseRootFromParent_Done,
     /*  17055 */   // Label 370: @17055
     /*  17055 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17100), // Rule ID 345 //
     /*  17060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17071 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17082 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17098 */     GIR_RootConstrainSelectedInstOperands,
     /*  17099 */     // GIR_Coverage, 345,
     /*  17099 */     GIR_EraseRootFromParent_Done,
     /*  17100 */   // Label 371: @17100
     /*  17100 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17145), // Rule ID 346 //
     /*  17105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17116 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17127 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17143 */     GIR_RootConstrainSelectedInstOperands,
     /*  17144 */     // GIR_Coverage, 346,
     /*  17144 */     GIR_EraseRootFromParent_Done,
     /*  17145 */   // Label 372: @17145
     /*  17145 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17204), // Rule ID 1894 //
     /*  17150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17173 */     // MIs[1] Operand 1
     /*  17173 */     // No operand predicates
     /*  17173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17175 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17182 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17202 */     GIR_RootConstrainSelectedInstOperands,
     /*  17203 */     // GIR_Coverage, 1894,
     /*  17203 */     GIR_EraseRootFromParent_Done,
     /*  17204 */   // Label 373: @17204
     /*  17204 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17261), // Rule ID 147 //
     /*  17209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17232 */     // MIs[1] Operand 1
     /*  17232 */     // No operand predicates
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17234 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17259 */     GIR_RootConstrainSelectedInstOperands,
     /*  17260 */     // GIR_Coverage, 147,
     /*  17260 */     GIR_EraseRootFromParent_Done,
     /*  17261 */   // Label 374: @17261
     /*  17261 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17318), // Rule ID 481 //
     /*  17266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17289 */     // MIs[1] Operand 1
     /*  17289 */     // No operand predicates
     /*  17289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17291 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17316 */     GIR_RootConstrainSelectedInstOperands,
     /*  17317 */     // GIR_Coverage, 481,
     /*  17317 */     GIR_EraseRootFromParent_Done,
     /*  17318 */   // Label 375: @17318
     /*  17318 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17369), // Rule ID 163 //
     /*  17323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17342 */     // MIs[1] Operand 1
     /*  17342 */     // No operand predicates
     /*  17342 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17348 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 163,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 376: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17420), // Rule ID 493 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17393 */     // MIs[1] Operand 1
     /*  17393 */     // No operand predicates
     /*  17393 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17399 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17418 */     GIR_RootConstrainSelectedInstOperands,
     /*  17419 */     // GIR_Coverage, 493,
     /*  17419 */     GIR_EraseRootFromParent_Done,
     /*  17420 */   // Label 377: @17420
     /*  17420 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17466), // Rule ID 148 //
     /*  17425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17440 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17464 */     GIR_RootConstrainSelectedInstOperands,
     /*  17465 */     // GIR_Coverage, 148,
     /*  17465 */     GIR_EraseRootFromParent_Done,
     /*  17466 */   // Label 378: @17466
     /*  17466 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17512), // Rule ID 310 //
     /*  17471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17486 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17510 */     GIR_RootConstrainSelectedInstOperands,
     /*  17511 */     // GIR_Coverage, 310,
     /*  17511 */     GIR_EraseRootFromParent_Done,
     /*  17512 */   // Label 379: @17512
     /*  17512 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17558), // Rule ID 482 //
     /*  17517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17532 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17556 */     GIR_RootConstrainSelectedInstOperands,
     /*  17557 */     // GIR_Coverage, 482,
     /*  17557 */     GIR_EraseRootFromParent_Done,
     /*  17558 */   // Label 380: @17558
     /*  17558 */   GIM_Reject,
     /*  17559 */ // Label 348: @17559
     /*  17559 */ GIM_Reject,
     /*  17560 */ // Label 335: @17560
     /*  17560 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17606), // Rule ID 2526 //
     /*  17565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17586 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17591 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17593 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17604 */   GIR_RootConstrainSelectedInstOperands,
     /*  17605 */   // GIR_Coverage, 2526,
     /*  17605 */   GIR_EraseRootFromParent_Done,
     /*  17606 */ // Label 381: @17606
     /*  17606 */ GIM_Reject,
     /*  17607 */ // Label 336: @17607
     /*  17607 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17724), // Rule ID 1826 //
     /*  17612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17633 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17633 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17636 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17640 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17645 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17666 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17670 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17690 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17693 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17696 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17702 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17723 */   // GIR_Coverage, 1826,
     /*  17723 */   GIR_EraseRootFromParent_Done,
     /*  17724 */ // Label 382: @17724
     /*  17724 */ GIM_Reject,
     /*  17725 */ // Label 337: @17725
     /*  17725 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17771), // Rule ID 1133 //
     /*  17730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17751 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17756 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17758 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17763 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17769 */   GIR_RootConstrainSelectedInstOperands,
     /*  17770 */   // GIR_Coverage, 1133,
     /*  17770 */   GIR_EraseRootFromParent_Done,
     /*  17771 */ // Label 383: @17771
     /*  17771 */ GIM_Reject,
     /*  17772 */ // Label 338: @17772
     /*  17772 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17885),
     /*  17777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17783 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17823), // Rule ID 2529 //
     /*  17788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17803 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17808 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17810 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17821 */     GIR_RootConstrainSelectedInstOperands,
     /*  17822 */     // GIR_Coverage, 2529,
     /*  17822 */     GIR_EraseRootFromParent_Done,
     /*  17823 */   // Label 385: @17823
     /*  17823 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17884), // Rule ID 3370 //
     /*  17828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17843 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17882 */     GIR_RootConstrainSelectedInstOperands,
     /*  17883 */     // GIR_Coverage, 3370,
     /*  17883 */     GIR_EraseRootFromParent_Done,
     /*  17884 */   // Label 386: @17884
     /*  17884 */   GIM_Reject,
     /*  17885 */ // Label 384: @17885
     /*  17885 */ GIM_Reject,
     /*  17886 */ // Label 339: @17886
     /*  17886 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18003), // Rule ID 1827 //
     /*  17891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17912 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17924 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17928 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17972 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17975 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17981 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18002 */   // GIR_Coverage, 1827,
     /*  18002 */   GIR_EraseRootFromParent_Done,
     /*  18003 */ // Label 387: @18003
     /*  18003 */ GIM_Reject,
     /*  18004 */ // Label 340: @18004
     /*  18004 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18050), // Rule ID 2525 //
     /*  18009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  18015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18030 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18035 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18037 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18048 */   GIR_RootConstrainSelectedInstOperands,
     /*  18049 */   // GIR_Coverage, 2525,
     /*  18049 */   GIR_EraseRootFromParent_Done,
     /*  18050 */ // Label 388: @18050
     /*  18050 */ GIM_Reject,
     /*  18051 */ // Label 341: @18051
     /*  18051 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18164),
     /*  18056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18062 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18102), // Rule ID 1134 //
     /*  18067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18082 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18100 */     GIR_RootConstrainSelectedInstOperands,
     /*  18101 */     // GIR_Coverage, 1134,
     /*  18101 */     GIR_EraseRootFromParent_Done,
     /*  18102 */   // Label 390: @18102
     /*  18102 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18163), // Rule ID 3366 //
     /*  18107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18122 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18161 */     GIR_RootConstrainSelectedInstOperands,
     /*  18162 */     // GIR_Coverage, 3366,
     /*  18162 */     GIR_EraseRootFromParent_Done,
     /*  18163 */   // Label 391: @18163
     /*  18163 */   GIM_Reject,
     /*  18164 */ // Label 389: @18164
     /*  18164 */ GIM_Reject,
     /*  18165 */ // Label 342: @18165
     /*  18165 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18282), // Rule ID 1828 //
     /*  18170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18191 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18191 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18194 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18198 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18203 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18228 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18251 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18254 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18260 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18281 */   // GIR_Coverage, 1828,
     /*  18281 */   GIR_EraseRootFromParent_Done,
     /*  18282 */ // Label 392: @18282
     /*  18282 */ GIM_Reject,
     /*  18283 */ // Label 343: @18283
     /*  18283 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18329), // Rule ID 2524 //
     /*  18288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18309 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18314 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18316 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18327 */   GIR_RootConstrainSelectedInstOperands,
     /*  18328 */   // GIR_Coverage, 2524,
     /*  18328 */   GIR_EraseRootFromParent_Done,
     /*  18329 */ // Label 393: @18329
     /*  18329 */ GIM_Reject,
     /*  18330 */ // Label 344: @18330
     /*  18330 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18443),
     /*  18335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18341 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18381), // Rule ID 2528 //
     /*  18346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18361 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18366 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18368 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 2528,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 395: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18442), // Rule ID 3362 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18401 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18440 */     GIR_RootConstrainSelectedInstOperands,
     /*  18441 */     // GIR_Coverage, 3362,
     /*  18441 */     GIR_EraseRootFromParent_Done,
     /*  18442 */   // Label 396: @18442
     /*  18442 */   GIM_Reject,
     /*  18443 */ // Label 394: @18443
     /*  18443 */ GIM_Reject,
     /*  18444 */ // Label 345: @18444
     /*  18444 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18561), // Rule ID 1829 //
     /*  18449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18470 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18470 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18473 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18477 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18482 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18503 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18507 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18533 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18539 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18560 */   // GIR_Coverage, 1829,
     /*  18560 */   GIR_EraseRootFromParent_Done,
     /*  18561 */ // Label 397: @18561
     /*  18561 */ GIM_Reject,
     /*  18562 */ // Label 346: @18562
     /*  18562 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18675),
     /*  18567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18573 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18613), // Rule ID 2527 //
     /*  18578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18593 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18598 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18600 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18611 */     GIR_RootConstrainSelectedInstOperands,
     /*  18612 */     // GIR_Coverage, 2527,
     /*  18612 */     GIR_EraseRootFromParent_Done,
     /*  18613 */   // Label 399: @18613
     /*  18613 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(18674), // Rule ID 3358 //
     /*  18618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18633 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18672 */     GIR_RootConstrainSelectedInstOperands,
     /*  18673 */     // GIR_Coverage, 3358,
     /*  18673 */     GIR_EraseRootFromParent_Done,
     /*  18674 */   // Label 400: @18674
     /*  18674 */   GIM_Reject,
     /*  18675 */ // Label 398: @18675
     /*  18675 */ GIM_Reject,
     /*  18676 */ // Label 347: @18676
     /*  18676 */ GIM_Reject,
     /*  18677 */ // Label 6: @18677
     /*  18677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 414*/ GIMT_Encode4(24485),
     /*  18688 */ /*GILLT_s32*//*Label 401*/ GIMT_Encode4(18748),
     /*  18692 */ /*GILLT_s64*//*Label 402*/ GIMT_Encode4(23369),
     /*  18696 */ /*GILLT_v2s1*//*Label 403*/ GIMT_Encode4(23416),
     /*  18700 */ /*GILLT_v2s32*//*Label 404*/ GIMT_Encode4(23534),
     /*  18704 */ /*GILLT_v2s64*//*Label 405*/ GIMT_Encode4(23581),
     /*  18708 */ /*GILLT_v4s1*//*Label 406*/ GIMT_Encode4(23695),
     /*  18712 */ /*GILLT_v4s16*//*Label 407*/ GIMT_Encode4(23813),
     /*  18716 */ /*GILLT_v4s32*//*Label 408*/ GIMT_Encode4(23860), GIMT_Encode4(0),
     /*  18724 */ /*GILLT_v8s1*//*Label 409*/ GIMT_Encode4(23974),
     /*  18728 */ /*GILLT_v8s8*//*Label 410*/ GIMT_Encode4(24092),
     /*  18732 */ /*GILLT_v8s16*//*Label 411*/ GIMT_Encode4(24139), GIMT_Encode4(0),
     /*  18740 */ /*GILLT_v16s1*//*Label 412*/ GIMT_Encode4(24253),
     /*  18744 */ /*GILLT_v16s8*//*Label 413*/ GIMT_Encode4(24371),
     /*  18748 */ // Label 401: @18748
     /*  18748 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(23368),
     /*  18753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18759 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(18886), // Rule ID 5655 //
     /*  18764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18812 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18843 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18847 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18851 */     // MIs[4] Rm
     /*  18851 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18856 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18860 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18866 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18884 */     GIR_RootConstrainSelectedInstOperands,
     /*  18885 */     // GIR_Coverage, 5655,
     /*  18885 */     GIR_EraseRootFromParent_Done,
     /*  18886 */   // Label 416: @18886
     /*  18886 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19013), // Rule ID 5697 //
     /*  18891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18935 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18939 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18978 */     // MIs[4] Rm
     /*  18978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18983 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18993 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  18993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  18996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19011 */     GIR_RootConstrainSelectedInstOperands,
     /*  19012 */     // GIR_Coverage, 5697,
     /*  19012 */     GIR_EraseRootFromParent_Done,
     /*  19013 */   // Label 417: @19013
     /*  19013 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19140), // Rule ID 1914 //
     /*  19018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19094 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19098 */     // MIs[4] Rm
     /*  19098 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19103 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19107 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19120 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19138 */     GIR_RootConstrainSelectedInstOperands,
     /*  19139 */     // GIR_Coverage, 1914,
     /*  19139 */     GIR_EraseRootFromParent_Done,
     /*  19140 */   // Label 418: @19140
     /*  19140 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19267), // Rule ID 2196 //
     /*  19145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19225 */     // MIs[4] Rm
     /*  19225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19247 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19265 */     GIR_RootConstrainSelectedInstOperands,
     /*  19266 */     // GIR_Coverage, 2196,
     /*  19266 */     GIR_EraseRootFromParent_Done,
     /*  19267 */   // Label 419: @19267
     /*  19267 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19400), // Rule ID 5453 //
     /*  19272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19328 */     // MIs[3] Operand 1
     /*  19328 */     // No operand predicates
     /*  19328 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19351 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19355 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19360 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19373 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19398 */     GIR_RootConstrainSelectedInstOperands,
     /*  19399 */     // GIR_Coverage, 5453,
     /*  19399 */     GIR_EraseRootFromParent_Done,
     /*  19400 */   // Label 420: @19400
     /*  19400 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19533), // Rule ID 5490 //
     /*  19405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19461 */     // MIs[3] Operand 1
     /*  19461 */     // No operand predicates
     /*  19461 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19484 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19493 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19504 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19506 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19531 */     GIR_RootConstrainSelectedInstOperands,
     /*  19532 */     // GIR_Coverage, 5490,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 421: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19666), // Rule ID 5660 //
     /*  19538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19594 */     // MIs[3] Operand 1
     /*  19594 */     // No operand predicates
     /*  19594 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19605 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19609 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19613 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19617 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19621 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19626 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19639 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19664 */     GIR_RootConstrainSelectedInstOperands,
     /*  19665 */     // GIR_Coverage, 5660,
     /*  19665 */     GIR_EraseRootFromParent_Done,
     /*  19666 */   // Label 422: @19666
     /*  19666 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19799), // Rule ID 5702 //
     /*  19671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19727 */     // MIs[3] Operand 1
     /*  19727 */     // No operand predicates
     /*  19727 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19746 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19750 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19759 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19772 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19797 */     GIR_RootConstrainSelectedInstOperands,
     /*  19798 */     // GIR_Coverage, 5702,
     /*  19798 */     GIR_EraseRootFromParent_Done,
     /*  19799 */   // Label 423: @19799
     /*  19799 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(19932), // Rule ID 5452 //
     /*  19804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19860 */     // MIs[3] Operand 1
     /*  19860 */     // No operand predicates
     /*  19860 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19871 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19875 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19879 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19883 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19887 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19892 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19905 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19930 */     GIR_RootConstrainSelectedInstOperands,
     /*  19931 */     // GIR_Coverage, 5452,
     /*  19931 */     GIR_EraseRootFromParent_Done,
     /*  19932 */   // Label 424: @19932
     /*  19932 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20065), // Rule ID 5489 //
     /*  19937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19993 */     // MIs[3] Operand 1
     /*  19993 */     // No operand predicates
     /*  19993 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20008 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20012 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20016 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20020 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20025 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20038 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20063 */     GIR_RootConstrainSelectedInstOperands,
     /*  20064 */     // GIR_Coverage, 5489,
     /*  20064 */     GIR_EraseRootFromParent_Done,
     /*  20065 */   // Label 425: @20065
     /*  20065 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20198), // Rule ID 203 //
     /*  20070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20098 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20133 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20137 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20141 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20154 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20158 */     // MIs[4] Operand 1
     /*  20158 */     // No operand predicates
     /*  20158 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20169 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20171 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20196 */     GIR_RootConstrainSelectedInstOperands,
     /*  20197 */     // GIR_Coverage, 203,
     /*  20197 */     GIR_EraseRootFromParent_Done,
     /*  20198 */   // Label 426: @20198
     /*  20198 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20331), // Rule ID 540 //
     /*  20203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20231 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20279 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20283 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20287 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20291 */     // MIs[4] Operand 1
     /*  20291 */     // No operand predicates
     /*  20291 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20304 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20329 */     GIR_RootConstrainSelectedInstOperands,
     /*  20330 */     // GIR_Coverage, 540,
     /*  20330 */     GIR_EraseRootFromParent_Done,
     /*  20331 */   // Label 427: @20331
     /*  20331 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20464), // Rule ID 1919 //
     /*  20336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20364 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20399 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20407 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20420 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20424 */     // MIs[4] Operand 1
     /*  20424 */     // No operand predicates
     /*  20424 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20437 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20462 */     GIR_RootConstrainSelectedInstOperands,
     /*  20463 */     // GIR_Coverage, 1919,
     /*  20463 */     GIR_EraseRootFromParent_Done,
     /*  20464 */   // Label 428: @20464
     /*  20464 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20597), // Rule ID 2201 //
     /*  20469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20497 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20553 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20557 */     // MIs[4] Operand 1
     /*  20557 */     // No operand predicates
     /*  20557 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20570 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20595 */     GIR_RootConstrainSelectedInstOperands,
     /*  20596 */     // GIR_Coverage, 2201,
     /*  20596 */     GIR_EraseRootFromParent_Done,
     /*  20597 */   // Label 429: @20597
     /*  20597 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20730), // Rule ID 202 //
     /*  20602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20630 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20686 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20690 */     // MIs[4] Operand 1
     /*  20690 */     // No operand predicates
     /*  20690 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20703 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20728 */     GIR_RootConstrainSelectedInstOperands,
     /*  20729 */     // GIR_Coverage, 202,
     /*  20729 */     GIR_EraseRootFromParent_Done,
     /*  20730 */   // Label 430: @20730
     /*  20730 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20863), // Rule ID 539 //
     /*  20735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20763 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20806 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20811 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20815 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20819 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20823 */     // MIs[4] Operand 1
     /*  20823 */     // No operand predicates
     /*  20823 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20836 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20861 */     GIR_RootConstrainSelectedInstOperands,
     /*  20862 */     // GIR_Coverage, 539,
     /*  20862 */     GIR_EraseRootFromParent_Done,
     /*  20863 */   // Label 431: @20863
     /*  20863 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20968), // Rule ID 1915 //
     /*  20868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20896 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20928 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20941 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20966 */     GIR_RootConstrainSelectedInstOperands,
     /*  20967 */     // GIR_Coverage, 1915,
     /*  20967 */     GIR_EraseRootFromParent_Done,
     /*  20968 */   // Label 432: @20968
     /*  20968 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21073), // Rule ID 2197 //
     /*  20973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21001 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21033 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21046 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21071 */     GIR_RootConstrainSelectedInstOperands,
     /*  21072 */     // GIR_Coverage, 2197,
     /*  21072 */     GIR_EraseRootFromParent_Done,
     /*  21073 */   // Label 433: @21073
     /*  21073 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21178), // Rule ID 5656 //
     /*  21078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21138 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21151 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21176 */     GIR_RootConstrainSelectedInstOperands,
     /*  21177 */     // GIR_Coverage, 5656,
     /*  21177 */     GIR_EraseRootFromParent_Done,
     /*  21178 */   // Label 434: @21178
     /*  21178 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21283), // Rule ID 5698 //
     /*  21183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21211 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21243 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21256 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21281 */     GIR_RootConstrainSelectedInstOperands,
     /*  21282 */     // GIR_Coverage, 5698,
     /*  21282 */     GIR_EraseRootFromParent_Done,
     /*  21283 */   // Label 435: @21283
     /*  21283 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21389), // Rule ID 1918 //
     /*  21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21316 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21360 */     // MIs[3] Operand 1
     /*  21360 */     // No operand predicates
     /*  21360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21362 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21387 */     GIR_RootConstrainSelectedInstOperands,
     /*  21388 */     // GIR_Coverage, 1918,
     /*  21388 */     GIR_EraseRootFromParent_Done,
     /*  21389 */   // Label 436: @21389
     /*  21389 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21495), // Rule ID 2200 //
     /*  21394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21422 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21466 */     // MIs[3] Operand 1
     /*  21466 */     // No operand predicates
     /*  21466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21468 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21493 */     GIR_RootConstrainSelectedInstOperands,
     /*  21494 */     // GIR_Coverage, 2200,
     /*  21494 */     GIR_EraseRootFromParent_Done,
     /*  21495 */   // Label 437: @21495
     /*  21495 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21601), // Rule ID 1917 //
     /*  21500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21528 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21572 */     // MIs[3] Operand 1
     /*  21572 */     // No operand predicates
     /*  21572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21574 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21599 */     GIR_RootConstrainSelectedInstOperands,
     /*  21600 */     // GIR_Coverage, 1917,
     /*  21600 */     GIR_EraseRootFromParent_Done,
     /*  21601 */   // Label 438: @21601
     /*  21601 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21707), // Rule ID 2199 //
     /*  21606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21634 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21678 */     // MIs[3] Operand 1
     /*  21678 */     // No operand predicates
     /*  21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21680 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21705 */     GIR_RootConstrainSelectedInstOperands,
     /*  21706 */     // GIR_Coverage, 2199,
     /*  21706 */     GIR_EraseRootFromParent_Done,
     /*  21707 */   // Label 439: @21707
     /*  21707 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21813), // Rule ID 1916 //
     /*  21712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21740 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21784 */     // MIs[3] Operand 1
     /*  21784 */     // No operand predicates
     /*  21784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21786 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21811 */     GIR_RootConstrainSelectedInstOperands,
     /*  21812 */     // GIR_Coverage, 1916,
     /*  21812 */     GIR_EraseRootFromParent_Done,
     /*  21813 */   // Label 440: @21813
     /*  21813 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21919), // Rule ID 2198 //
     /*  21818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21890 */     // MIs[3] Operand 1
     /*  21890 */     // No operand predicates
     /*  21890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21892 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21917 */     GIR_RootConstrainSelectedInstOperands,
     /*  21918 */     // GIR_Coverage, 2198,
     /*  21918 */     GIR_EraseRootFromParent_Done,
     /*  21919 */   // Label 441: @21919
     /*  21919 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22025), // Rule ID 5659 //
     /*  21924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21964 */     // MIs[2] Operand 1
     /*  21964 */     // No operand predicates
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21980 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21985 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21998 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22023 */     GIR_RootConstrainSelectedInstOperands,
     /*  22024 */     // GIR_Coverage, 5659,
     /*  22024 */     GIR_EraseRootFromParent_Done,
     /*  22025 */   // Label 442: @22025
     /*  22025 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22131), // Rule ID 5701 //
     /*  22030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22066 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22070 */     // MIs[2] Operand 1
     /*  22070 */     // No operand predicates
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22086 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22091 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22104 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22129 */     GIR_RootConstrainSelectedInstOperands,
     /*  22130 */     // GIR_Coverage, 5701,
     /*  22130 */     GIR_EraseRootFromParent_Done,
     /*  22131 */   // Label 443: @22131
     /*  22131 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22237), // Rule ID 5658 //
     /*  22136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22176 */     // MIs[2] Operand 1
     /*  22176 */     // No operand predicates
     /*  22176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22192 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22197 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22210 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22235 */     GIR_RootConstrainSelectedInstOperands,
     /*  22236 */     // GIR_Coverage, 5658,
     /*  22236 */     GIR_EraseRootFromParent_Done,
     /*  22237 */   // Label 444: @22237
     /*  22237 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22343), // Rule ID 5700 //
     /*  22242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22282 */     // MIs[2] Operand 1
     /*  22282 */     // No operand predicates
     /*  22282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22303 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22316 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22341 */     GIR_RootConstrainSelectedInstOperands,
     /*  22342 */     // GIR_Coverage, 5700,
     /*  22342 */     GIR_EraseRootFromParent_Done,
     /*  22343 */   // Label 445: @22343
     /*  22343 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22449), // Rule ID 5657 //
     /*  22348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22388 */     // MIs[2] Operand 1
     /*  22388 */     // No operand predicates
     /*  22388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22409 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22422 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22447 */     GIR_RootConstrainSelectedInstOperands,
     /*  22448 */     // GIR_Coverage, 5657,
     /*  22448 */     GIR_EraseRootFromParent_Done,
     /*  22449 */   // Label 446: @22449
     /*  22449 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22555), // Rule ID 5699 //
     /*  22454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22494 */     // MIs[2] Operand 1
     /*  22494 */     // No operand predicates
     /*  22494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22510 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22515 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22528 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22553 */     GIR_RootConstrainSelectedInstOperands,
     /*  22554 */     // GIR_Coverage, 5699,
     /*  22554 */     GIR_EraseRootFromParent_Done,
     /*  22555 */   // Label 447: @22555
     /*  22555 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22632), // Rule ID 5477 //
     /*  22560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22599 */     // MIs[2] Operand 1
     /*  22599 */     // No operand predicates
     /*  22599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22605 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22630 */     GIR_RootConstrainSelectedInstOperands,
     /*  22631 */     // GIR_Coverage, 5477,
     /*  22631 */     GIR_EraseRootFromParent_Done,
     /*  22632 */   // Label 448: @22632
     /*  22632 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22709), // Rule ID 5476 //
     /*  22637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22672 */     // MIs[2] Operand 1
     /*  22672 */     // No operand predicates
     /*  22672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22682 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22707 */     GIR_RootConstrainSelectedInstOperands,
     /*  22708 */     // GIR_Coverage, 5476,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 449: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22786), // Rule ID 5475 //
     /*  22714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22757 */     // MIs[2] Operand 1
     /*  22757 */     // No operand predicates
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22784 */     GIR_RootConstrainSelectedInstOperands,
     /*  22785 */     // GIR_Coverage, 5475,
     /*  22785 */     GIR_EraseRootFromParent_Done,
     /*  22786 */   // Label 450: @22786
     /*  22786 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22863), // Rule ID 496 //
     /*  22791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22830 */     // MIs[2] Operand 1
     /*  22830 */     // No operand predicates
     /*  22830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22836 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22861 */     GIR_RootConstrainSelectedInstOperands,
     /*  22862 */     // GIR_Coverage, 496,
     /*  22862 */     GIR_EraseRootFromParent_Done,
     /*  22863 */   // Label 451: @22863
     /*  22863 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22934), // Rule ID 5478 //
     /*  22868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22906 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22932 */     GIR_RootConstrainSelectedInstOperands,
     /*  22933 */     // GIR_Coverage, 5478,
     /*  22933 */     GIR_EraseRootFromParent_Done,
     /*  22934 */   // Label 452: @22934
     /*  22934 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23005), // Rule ID 497 //
     /*  22939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22971 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22977 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23003 */     GIR_RootConstrainSelectedInstOperands,
     /*  23004 */     // GIR_Coverage, 497,
     /*  23004 */     GIR_EraseRootFromParent_Done,
     /*  23005 */   // Label 453: @23005
     /*  23005 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23060), // Rule ID 1848 //
     /*  23010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  23013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23021 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23032 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23039 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23058 */     GIR_RootConstrainSelectedInstOperands,
     /*  23059 */     // GIR_Coverage, 1848,
     /*  23059 */     GIR_EraseRootFromParent_Done,
     /*  23060 */   // Label 454: @23060
     /*  23060 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23115), // Rule ID 2094 //
     /*  23065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23076 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23087 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23113 */     GIR_RootConstrainSelectedInstOperands,
     /*  23114 */     // GIR_Coverage, 2094,
     /*  23114 */     GIR_EraseRootFromParent_Done,
     /*  23115 */   // Label 455: @23115
     /*  23115 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23172), // Rule ID 151 //
     /*  23120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23143 */     // MIs[1] Operand 1
     /*  23143 */     // No operand predicates
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23145 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23170 */     GIR_RootConstrainSelectedInstOperands,
     /*  23171 */     // GIR_Coverage, 151,
     /*  23171 */     GIR_EraseRootFromParent_Done,
     /*  23172 */   // Label 456: @23172
     /*  23172 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23229), // Rule ID 484 //
     /*  23177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23200 */     // MIs[1] Operand 1
     /*  23200 */     // No operand predicates
     /*  23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23202 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23227 */     GIR_RootConstrainSelectedInstOperands,
     /*  23228 */     // GIR_Coverage, 484,
     /*  23228 */     GIR_EraseRootFromParent_Done,
     /*  23229 */   // Label 457: @23229
     /*  23229 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23275), // Rule ID 152 //
     /*  23234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23249 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23273 */     GIR_RootConstrainSelectedInstOperands,
     /*  23274 */     // GIR_Coverage, 152,
     /*  23274 */     GIR_EraseRootFromParent_Done,
     /*  23275 */   // Label 458: @23275
     /*  23275 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23321), // Rule ID 325 //
     /*  23280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23295 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23319 */     GIR_RootConstrainSelectedInstOperands,
     /*  23320 */     // GIR_Coverage, 325,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 459: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23367), // Rule ID 485 //
     /*  23326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23341 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 485,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 460: @23367
     /*  23367 */   GIM_Reject,
     /*  23368 */ // Label 415: @23368
     /*  23368 */ GIM_Reject,
     /*  23369 */ // Label 402: @23369
     /*  23369 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23415), // Rule ID 2532 //
     /*  23374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23395 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23400 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23402 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23413 */   GIR_RootConstrainSelectedInstOperands,
     /*  23414 */   // GIR_Coverage, 2532,
     /*  23414 */   GIR_EraseRootFromParent_Done,
     /*  23415 */ // Label 461: @23415
     /*  23415 */ GIM_Reject,
     /*  23416 */ // Label 403: @23416
     /*  23416 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23533), // Rule ID 1834 //
     /*  23421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23442 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23442 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23445 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23449 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23454 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23458 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23502 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23505 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23511 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23532 */   // GIR_Coverage, 1834,
     /*  23532 */   GIR_EraseRootFromParent_Done,
     /*  23533 */ // Label 462: @23533
     /*  23533 */ GIM_Reject,
     /*  23534 */ // Label 404: @23534
     /*  23534 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23580), // Rule ID 1137 //
     /*  23539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23560 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23565 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23567 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23572 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23578 */   GIR_RootConstrainSelectedInstOperands,
     /*  23579 */   // GIR_Coverage, 1137,
     /*  23579 */   GIR_EraseRootFromParent_Done,
     /*  23580 */ // Label 463: @23580
     /*  23580 */ GIM_Reject,
     /*  23581 */ // Label 405: @23581
     /*  23581 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23694),
     /*  23586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23592 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23632), // Rule ID 2535 //
     /*  23597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23612 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23630 */     GIR_RootConstrainSelectedInstOperands,
     /*  23631 */     // GIR_Coverage, 2535,
     /*  23631 */     GIR_EraseRootFromParent_Done,
     /*  23632 */   // Label 465: @23632
     /*  23632 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23693), // Rule ID 3384 //
     /*  23637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23652 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23691 */     GIR_RootConstrainSelectedInstOperands,
     /*  23692 */     // GIR_Coverage, 3384,
     /*  23692 */     GIR_EraseRootFromParent_Done,
     /*  23693 */   // Label 466: @23693
     /*  23693 */   GIM_Reject,
     /*  23694 */ // Label 464: @23694
     /*  23694 */ GIM_Reject,
     /*  23695 */ // Label 406: @23695
     /*  23695 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23812), // Rule ID 1835 //
     /*  23700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23721 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23733 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23737 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23781 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23784 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23790 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23811 */   // GIR_Coverage, 1835,
     /*  23811 */   GIR_EraseRootFromParent_Done,
     /*  23812 */ // Label 467: @23812
     /*  23812 */ GIM_Reject,
     /*  23813 */ // Label 407: @23813
     /*  23813 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23859), // Rule ID 2531 //
     /*  23818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23839 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23844 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23846 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23857 */   GIR_RootConstrainSelectedInstOperands,
     /*  23858 */   // GIR_Coverage, 2531,
     /*  23858 */   GIR_EraseRootFromParent_Done,
     /*  23859 */ // Label 468: @23859
     /*  23859 */ GIM_Reject,
     /*  23860 */ // Label 408: @23860
     /*  23860 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23973),
     /*  23865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23871 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23911), // Rule ID 1138 //
     /*  23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23891 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23909 */     GIR_RootConstrainSelectedInstOperands,
     /*  23910 */     // GIR_Coverage, 1138,
     /*  23910 */     GIR_EraseRootFromParent_Done,
     /*  23911 */   // Label 470: @23911
     /*  23911 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(23972), // Rule ID 3380 //
     /*  23916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23931 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23970 */     GIR_RootConstrainSelectedInstOperands,
     /*  23971 */     // GIR_Coverage, 3380,
     /*  23971 */     GIR_EraseRootFromParent_Done,
     /*  23972 */   // Label 471: @23972
     /*  23972 */   GIM_Reject,
     /*  23973 */ // Label 469: @23973
     /*  23973 */ GIM_Reject,
     /*  23974 */ // Label 409: @23974
     /*  23974 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24091), // Rule ID 1836 //
     /*  23979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  23988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24000 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24012 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24016 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24063 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24069 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24090 */   // GIR_Coverage, 1836,
     /*  24090 */   GIR_EraseRootFromParent_Done,
     /*  24091 */ // Label 472: @24091
     /*  24091 */ GIM_Reject,
     /*  24092 */ // Label 410: @24092
     /*  24092 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24138), // Rule ID 2530 //
     /*  24097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24118 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24123 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24125 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24136 */   GIR_RootConstrainSelectedInstOperands,
     /*  24137 */   // GIR_Coverage, 2530,
     /*  24137 */   GIR_EraseRootFromParent_Done,
     /*  24138 */ // Label 473: @24138
     /*  24138 */ GIM_Reject,
     /*  24139 */ // Label 411: @24139
     /*  24139 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24252),
     /*  24144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24150 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24190), // Rule ID 2534 //
     /*  24155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24170 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24175 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24177 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24188 */     GIR_RootConstrainSelectedInstOperands,
     /*  24189 */     // GIR_Coverage, 2534,
     /*  24189 */     GIR_EraseRootFromParent_Done,
     /*  24190 */   // Label 475: @24190
     /*  24190 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24251), // Rule ID 3376 //
     /*  24195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24210 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24249 */     GIR_RootConstrainSelectedInstOperands,
     /*  24250 */     // GIR_Coverage, 3376,
     /*  24250 */     GIR_EraseRootFromParent_Done,
     /*  24251 */   // Label 476: @24251
     /*  24251 */   GIM_Reject,
     /*  24252 */ // Label 474: @24252
     /*  24252 */ GIM_Reject,
     /*  24253 */ // Label 412: @24253
     /*  24253 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24370), // Rule ID 1837 //
     /*  24258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24279 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24279 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24282 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24286 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24291 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24295 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24300 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24303 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24307 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24312 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24316 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24342 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24348 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24369 */   // GIR_Coverage, 1837,
     /*  24369 */   GIR_EraseRootFromParent_Done,
     /*  24370 */ // Label 477: @24370
     /*  24370 */ GIM_Reject,
     /*  24371 */ // Label 413: @24371
     /*  24371 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24484),
     /*  24376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24382 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24422), // Rule ID 2533 //
     /*  24387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24402 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24407 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24409 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24420 */     GIR_RootConstrainSelectedInstOperands,
     /*  24421 */     // GIR_Coverage, 2533,
     /*  24421 */     GIR_EraseRootFromParent_Done,
     /*  24422 */   // Label 479: @24422
     /*  24422 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24483), // Rule ID 3372 //
     /*  24427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24442 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24481 */     GIR_RootConstrainSelectedInstOperands,
     /*  24482 */     // GIR_Coverage, 3372,
     /*  24482 */     GIR_EraseRootFromParent_Done,
     /*  24483 */   // Label 480: @24483
     /*  24483 */   GIM_Reject,
     /*  24484 */ // Label 478: @24484
     /*  24484 */ GIM_Reject,
     /*  24485 */ // Label 414: @24485
     /*  24485 */ GIM_Reject,
     /*  24486 */ // Label 7: @24486
     /*  24486 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 494*/ GIMT_Encode4(26180),
     /*  24497 */ /*GILLT_s32*//*Label 481*/ GIMT_Encode4(24557),
     /*  24501 */ /*GILLT_s64*//*Label 482*/ GIMT_Encode4(25064),
     /*  24505 */ /*GILLT_v2s1*//*Label 483*/ GIMT_Encode4(25111),
     /*  24509 */ /*GILLT_v2s32*//*Label 484*/ GIMT_Encode4(25229),
     /*  24513 */ /*GILLT_v2s64*//*Label 485*/ GIMT_Encode4(25276),
     /*  24517 */ /*GILLT_v4s1*//*Label 486*/ GIMT_Encode4(25390),
     /*  24521 */ /*GILLT_v4s16*//*Label 487*/ GIMT_Encode4(25508),
     /*  24525 */ /*GILLT_v4s32*//*Label 488*/ GIMT_Encode4(25555), GIMT_Encode4(0),
     /*  24533 */ /*GILLT_v8s1*//*Label 489*/ GIMT_Encode4(25669),
     /*  24537 */ /*GILLT_v8s8*//*Label 490*/ GIMT_Encode4(25787),
     /*  24541 */ /*GILLT_v8s16*//*Label 491*/ GIMT_Encode4(25834), GIMT_Encode4(0),
     /*  24549 */ /*GILLT_v16s1*//*Label 492*/ GIMT_Encode4(25948),
     /*  24553 */ /*GILLT_v16s8*//*Label 493*/ GIMT_Encode4(26066),
     /*  24557 */ // Label 481: @24557
     /*  24557 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(25063),
     /*  24562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24568 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24623), // Rule ID 5480 //
     /*  24573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24596 */     // MIs[1] Operand 1
     /*  24596 */     // No operand predicates
     /*  24596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24598 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24621 */     GIR_RootConstrainSelectedInstOperands,
     /*  24622 */     // GIR_Coverage, 5480,
     /*  24622 */     GIR_EraseRootFromParent_Done,
     /*  24623 */   // Label 496: @24623
     /*  24623 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24678), // Rule ID 499 //
     /*  24628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24647 */     // MIs[1] Operand 1
     /*  24647 */     // No operand predicates
     /*  24647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24653 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24676 */     GIR_RootConstrainSelectedInstOperands,
     /*  24677 */     // GIR_Coverage, 499,
     /*  24677 */     GIR_EraseRootFromParent_Done,
     /*  24678 */   // Label 497: @24678
     /*  24678 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24722), // Rule ID 500 //
     /*  24683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24698 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24720 */     GIR_RootConstrainSelectedInstOperands,
     /*  24721 */     // GIR_Coverage, 500,
     /*  24721 */     GIR_EraseRootFromParent_Done,
     /*  24722 */   // Label 498: @24722
     /*  24722 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24766), // Rule ID 165 //
     /*  24727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24742 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24764 */     GIR_RootConstrainSelectedInstOperands,
     /*  24765 */     // GIR_Coverage, 165,
     /*  24765 */     GIR_EraseRootFromParent_Done,
     /*  24766 */   // Label 499: @24766
     /*  24766 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24810), // Rule ID 324 //
     /*  24771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24786 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24808 */     GIR_RootConstrainSelectedInstOperands,
     /*  24809 */     // GIR_Coverage, 324,
     /*  24809 */     GIR_EraseRootFromParent_Done,
     /*  24810 */   // Label 500: @24810
     /*  24810 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24867), // Rule ID 155 //
     /*  24815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24838 */     // MIs[1] Operand 1
     /*  24838 */     // No operand predicates
     /*  24838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24840 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24865 */     GIR_RootConstrainSelectedInstOperands,
     /*  24866 */     // GIR_Coverage, 155,
     /*  24866 */     GIR_EraseRootFromParent_Done,
     /*  24867 */   // Label 501: @24867
     /*  24867 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24924), // Rule ID 487 //
     /*  24872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24895 */     // MIs[1] Operand 1
     /*  24895 */     // No operand predicates
     /*  24895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24897 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24922 */     GIR_RootConstrainSelectedInstOperands,
     /*  24923 */     // GIR_Coverage, 487,
     /*  24923 */     GIR_EraseRootFromParent_Done,
     /*  24924 */   // Label 502: @24924
     /*  24924 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(24970), // Rule ID 156 //
     /*  24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24944 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24968 */     GIR_RootConstrainSelectedInstOperands,
     /*  24969 */     // GIR_Coverage, 156,
     /*  24969 */     GIR_EraseRootFromParent_Done,
     /*  24970 */   // Label 503: @24970
     /*  24970 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25016), // Rule ID 317 //
     /*  24975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24990 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  24990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  24993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  24995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  25001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25014 */     GIR_RootConstrainSelectedInstOperands,
     /*  25015 */     // GIR_Coverage, 317,
     /*  25015 */     GIR_EraseRootFromParent_Done,
     /*  25016 */   // Label 504: @25016
     /*  25016 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25062), // Rule ID 488 //
     /*  25021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25036 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25060 */     GIR_RootConstrainSelectedInstOperands,
     /*  25061 */     // GIR_Coverage, 488,
     /*  25061 */     GIR_EraseRootFromParent_Done,
     /*  25062 */   // Label 505: @25062
     /*  25062 */   GIM_Reject,
     /*  25063 */ // Label 495: @25063
     /*  25063 */ GIM_Reject,
     /*  25064 */ // Label 482: @25064
     /*  25064 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25110), // Rule ID 2538 //
     /*  25069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25090 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25095 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25097 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25102 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25108 */   GIR_RootConstrainSelectedInstOperands,
     /*  25109 */   // GIR_Coverage, 2538,
     /*  25109 */   GIR_EraseRootFromParent_Done,
     /*  25110 */ // Label 506: @25110
     /*  25110 */ GIM_Reject,
     /*  25111 */ // Label 483: @25111
     /*  25111 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25228), // Rule ID 1830 //
     /*  25116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25137 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25153 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25170 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25174 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25191 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25194 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25197 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25200 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25206 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25227 */   // GIR_Coverage, 1830,
     /*  25227 */   GIR_EraseRootFromParent_Done,
     /*  25228 */ // Label 507: @25228
     /*  25228 */ GIM_Reject,
     /*  25229 */ // Label 484: @25229
     /*  25229 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25275), // Rule ID 1135 //
     /*  25234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25255 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25260 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25262 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25267 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25273 */   GIR_RootConstrainSelectedInstOperands,
     /*  25274 */   // GIR_Coverage, 1135,
     /*  25274 */   GIR_EraseRootFromParent_Done,
     /*  25275 */ // Label 508: @25275
     /*  25275 */ GIM_Reject,
     /*  25276 */ // Label 485: @25276
     /*  25276 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25389),
     /*  25281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25287 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25327), // Rule ID 2541 //
     /*  25292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25307 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25312 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25314 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25325 */     GIR_RootConstrainSelectedInstOperands,
     /*  25326 */     // GIR_Coverage, 2541,
     /*  25326 */     GIR_EraseRootFromParent_Done,
     /*  25327 */   // Label 510: @25327
     /*  25327 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25388), // Rule ID 3398 //
     /*  25332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25347 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25386 */     GIR_RootConstrainSelectedInstOperands,
     /*  25387 */     // GIR_Coverage, 3398,
     /*  25387 */     GIR_EraseRootFromParent_Done,
     /*  25388 */   // Label 511: @25388
     /*  25388 */   GIM_Reject,
     /*  25389 */ // Label 509: @25389
     /*  25389 */ GIM_Reject,
     /*  25390 */ // Label 486: @25390
     /*  25390 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25507), // Rule ID 1831 //
     /*  25395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25416 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25416 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25419 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25423 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25428 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25432 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25453 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25470 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25473 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25479 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25485 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25506 */   // GIR_Coverage, 1831,
     /*  25506 */   GIR_EraseRootFromParent_Done,
     /*  25507 */ // Label 512: @25507
     /*  25507 */ GIM_Reject,
     /*  25508 */ // Label 487: @25508
     /*  25508 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25554), // Rule ID 2537 //
     /*  25513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25534 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25539 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25541 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25552 */   GIR_RootConstrainSelectedInstOperands,
     /*  25553 */   // GIR_Coverage, 2537,
     /*  25553 */   GIR_EraseRootFromParent_Done,
     /*  25554 */ // Label 513: @25554
     /*  25554 */ GIM_Reject,
     /*  25555 */ // Label 488: @25555
     /*  25555 */ GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25668),
     /*  25560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25566 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25606), // Rule ID 1136 //
     /*  25571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25586 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25604 */     GIR_RootConstrainSelectedInstOperands,
     /*  25605 */     // GIR_Coverage, 1136,
     /*  25605 */     GIR_EraseRootFromParent_Done,
     /*  25606 */   // Label 515: @25606
     /*  25606 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25667), // Rule ID 3394 //
     /*  25611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25626 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25665 */     GIR_RootConstrainSelectedInstOperands,
     /*  25666 */     // GIR_Coverage, 3394,
     /*  25666 */     GIR_EraseRootFromParent_Done,
     /*  25667 */   // Label 516: @25667
     /*  25667 */   GIM_Reject,
     /*  25668 */ // Label 514: @25668
     /*  25668 */ GIM_Reject,
     /*  25669 */ // Label 489: @25669
     /*  25669 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25786), // Rule ID 1832 //
     /*  25674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25695 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25695 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25698 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25702 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25707 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25711 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25732 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25755 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25758 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25764 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25785 */   // GIR_Coverage, 1832,
     /*  25785 */   GIR_EraseRootFromParent_Done,
     /*  25786 */ // Label 517: @25786
     /*  25786 */ GIM_Reject,
     /*  25787 */ // Label 490: @25787
     /*  25787 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25833), // Rule ID 2536 //
     /*  25792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25813 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25818 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25820 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25825 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25831 */   GIR_RootConstrainSelectedInstOperands,
     /*  25832 */   // GIR_Coverage, 2536,
     /*  25832 */   GIR_EraseRootFromParent_Done,
     /*  25833 */ // Label 518: @25833
     /*  25833 */ GIM_Reject,
     /*  25834 */ // Label 491: @25834
     /*  25834 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25947),
     /*  25839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25845 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25885), // Rule ID 2540 //
     /*  25850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25865 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25872 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25883 */     GIR_RootConstrainSelectedInstOperands,
     /*  25884 */     // GIR_Coverage, 2540,
     /*  25884 */     GIR_EraseRootFromParent_Done,
     /*  25885 */   // Label 520: @25885
     /*  25885 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(25946), // Rule ID 3390 //
     /*  25890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25905 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25944 */     GIR_RootConstrainSelectedInstOperands,
     /*  25945 */     // GIR_Coverage, 3390,
     /*  25945 */     GIR_EraseRootFromParent_Done,
     /*  25946 */   // Label 521: @25946
     /*  25946 */   GIM_Reject,
     /*  25947 */ // Label 519: @25947
     /*  25947 */ GIM_Reject,
     /*  25948 */ // Label 492: @25948
     /*  25948 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26065), // Rule ID 1833 //
     /*  25953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25974 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25974 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25977 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25981 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25986 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25990 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25995 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25998 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26002 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26007 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  26011 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26034 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26037 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26043 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26064 */   // GIR_Coverage, 1833,
     /*  26064 */   GIR_EraseRootFromParent_Done,
     /*  26065 */ // Label 522: @26065
     /*  26065 */ GIM_Reject,
     /*  26066 */ // Label 493: @26066
     /*  26066 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26179),
     /*  26071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26077 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26117), // Rule ID 2539 //
     /*  26082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26097 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26102 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26104 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26115 */     GIR_RootConstrainSelectedInstOperands,
     /*  26116 */     // GIR_Coverage, 2539,
     /*  26116 */     GIR_EraseRootFromParent_Done,
     /*  26117 */   // Label 524: @26117
     /*  26117 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26178), // Rule ID 3386 //
     /*  26122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26137 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26176 */     GIR_RootConstrainSelectedInstOperands,
     /*  26177 */     // GIR_Coverage, 3386,
     /*  26177 */     GIR_EraseRootFromParent_Done,
     /*  26178 */   // Label 525: @26178
     /*  26178 */   GIM_Reject,
     /*  26179 */ // Label 523: @26179
     /*  26179 */ GIM_Reject,
     /*  26180 */ // Label 494: @26180
     /*  26180 */ GIM_Reject,
     /*  26181 */ // Label 8: @26181
     /*  26181 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(26567),
     /*  26186 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26189 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 531*/ GIMT_Encode4(26566),
     /*  26200 */   /*GILLT_v2s64*//*Label 527*/ GIMT_Encode4(26244), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26212 */   /*GILLT_v4s32*//*Label 528*/ GIMT_Encode4(26302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26228 */   /*GILLT_v8s16*//*Label 529*/ GIMT_Encode4(26405), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26240 */   /*GILLT_v16s8*//*Label 530*/ GIMT_Encode4(26508),
     /*  26244 */   // Label 527: @26244
     /*  26244 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26301), // Rule ID 3024 //
     /*  26249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26252 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26270 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26277 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26282 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26300 */     // GIR_Coverage, 3024,
     /*  26300 */     GIR_EraseRootFromParent_Done,
     /*  26301 */   // Label 532: @26301
     /*  26301 */   GIM_Reject,
     /*  26302 */   // Label 528: @26302
     /*  26302 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26404),
     /*  26307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26325 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26364), // Rule ID 3025 //
     /*  26330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26333 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26338 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26340 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26343 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26345 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26348 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26353 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26358 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26363 */       // GIR_Coverage, 3025,
     /*  26363 */       GIR_EraseRootFromParent_Done,
     /*  26364 */     // Label 534: @26364
     /*  26364 */     GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26403), // Rule ID 3028 //
     /*  26369 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26372 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26372 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26375 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26377 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26379 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26382 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26384 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26397 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26402 */       // GIR_Coverage, 3028,
     /*  26402 */       GIR_EraseRootFromParent_Done,
     /*  26403 */     // Label 535: @26403
     /*  26403 */     GIM_Reject,
     /*  26404 */   // Label 533: @26404
     /*  26404 */   GIM_Reject,
     /*  26405 */   // Label 529: @26405
     /*  26405 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26507),
     /*  26410 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26428 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26467), // Rule ID 3026 //
     /*  26433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26436 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26441 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26443 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26446 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26448 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26451 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26456 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26461 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26466 */       // GIR_Coverage, 3026,
     /*  26466 */       GIR_EraseRootFromParent_Done,
     /*  26467 */     // Label 537: @26467
     /*  26467 */     GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26506), // Rule ID 3029 //
     /*  26472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26475 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26475 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26478 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26480 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26482 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26485 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26487 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26490 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26495 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26500 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26505 */       // GIR_Coverage, 3029,
     /*  26505 */       GIR_EraseRootFromParent_Done,
     /*  26506 */     // Label 538: @26506
     /*  26506 */     GIM_Reject,
     /*  26507 */   // Label 536: @26507
     /*  26507 */   GIM_Reject,
     /*  26508 */   // Label 530: @26508
     /*  26508 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(26565), // Rule ID 3027 //
     /*  26513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26516 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26534 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26541 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26546 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26564 */     // GIR_Coverage, 3027,
     /*  26564 */     GIR_EraseRootFromParent_Done,
     /*  26565 */   // Label 539: @26565
     /*  26565 */   GIM_Reject,
     /*  26566 */   // Label 531: @26566
     /*  26566 */   GIM_Reject,
     /*  26567 */ // Label 526: @26567
     /*  26567 */ GIM_Reject,
     /*  26568 */ // Label 9: @26568
     /*  26568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 549*/ GIMT_Encode4(35579),
     /*  26579 */ /*GILLT_s32*//*Label 540*/ GIMT_Encode4(26639),
     /*  26583 */ /*GILLT_s64*//*Label 541*/ GIMT_Encode4(26787), GIMT_Encode4(0),
     /*  26591 */ /*GILLT_v2s32*//*Label 542*/ GIMT_Encode4(27542),
     /*  26595 */ /*GILLT_v2s64*//*Label 543*/ GIMT_Encode4(28297), GIMT_Encode4(0),
     /*  26603 */ /*GILLT_v4s16*//*Label 544*/ GIMT_Encode4(30016),
     /*  26607 */ /*GILLT_v4s32*//*Label 545*/ GIMT_Encode4(30771), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26619 */ /*GILLT_v8s8*//*Label 546*/ GIMT_Encode4(32490),
     /*  26623 */ /*GILLT_v8s16*//*Label 547*/ GIMT_Encode4(32905), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26635 */ /*GILLT_v16s8*//*Label 548*/ GIMT_Encode4(34624),
     /*  26639 */ // Label 540: @26639
     /*  26639 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26786),
     /*  26644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26647 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26681), // Rule ID 692 //
     /*  26652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26663 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26679 */     GIR_RootConstrainSelectedInstOperands,
     /*  26680 */     // GIR_Coverage, 692,
     /*  26680 */     GIR_EraseRootFromParent_Done,
     /*  26681 */   // Label 551: @26681
     /*  26681 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26715), // Rule ID 693 //
     /*  26686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26697 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26713 */     GIR_RootConstrainSelectedInstOperands,
     /*  26714 */     // GIR_Coverage, 693,
     /*  26714 */     GIR_EraseRootFromParent_Done,
     /*  26715 */   // Label 552: @26715
     /*  26715 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26785), // Rule ID 2718 //
     /*  26720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26731 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26754 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26784 */     // GIR_Coverage, 2718,
     /*  26784 */     GIR_EraseRootFromParent_Done,
     /*  26785 */   // Label 553: @26785
     /*  26785 */   GIM_Reject,
     /*  26786 */ // Label 550: @26786
     /*  26786 */ GIM_Reject,
     /*  26787 */ // Label 541: @26787
     /*  26787 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26819), // Rule ID 2720 //
     /*  26792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26806 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26818 */   // GIR_Coverage, 2720,
     /*  26818 */   GIR_EraseRootFromParent_Done,
     /*  26819 */ // Label 554: @26819
     /*  26819 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26851), // Rule ID 2721 //
     /*  26824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26838 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26850 */   // GIR_Coverage, 2721,
     /*  26850 */   GIR_EraseRootFromParent_Done,
     /*  26851 */ // Label 555: @26851
     /*  26851 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26883), // Rule ID 2732 //
     /*  26856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26870 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26882 */   // GIR_Coverage, 2732,
     /*  26882 */   GIR_EraseRootFromParent_Done,
     /*  26883 */ // Label 556: @26883
     /*  26883 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26915), // Rule ID 2733 //
     /*  26888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26902 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26914 */   // GIR_Coverage, 2733,
     /*  26914 */   GIR_EraseRootFromParent_Done,
     /*  26915 */ // Label 557: @26915
     /*  26915 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26947), // Rule ID 2734 //
     /*  26920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26934 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26946 */   // GIR_Coverage, 2734,
     /*  26946 */   GIR_EraseRootFromParent_Done,
     /*  26947 */ // Label 558: @26947
     /*  26947 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(26979), // Rule ID 2735 //
     /*  26952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26966 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26978 */   // GIR_Coverage, 2735,
     /*  26978 */   GIR_EraseRootFromParent_Done,
     /*  26979 */ // Label 559: @26979
     /*  26979 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27011), // Rule ID 2736 //
     /*  26984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26998 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27010 */   // GIR_Coverage, 2736,
     /*  27010 */   GIR_EraseRootFromParent_Done,
     /*  27011 */ // Label 560: @27011
     /*  27011 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27043), // Rule ID 2737 //
     /*  27016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27030 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27042 */   // GIR_Coverage, 2737,
     /*  27042 */   GIR_EraseRootFromParent_Done,
     /*  27043 */ // Label 561: @27043
     /*  27043 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27075), // Rule ID 2738 //
     /*  27048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27062 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27074 */   // GIR_Coverage, 2738,
     /*  27074 */   GIR_EraseRootFromParent_Done,
     /*  27075 */ // Label 562: @27075
     /*  27075 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27107), // Rule ID 2739 //
     /*  27080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27094 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27106 */   // GIR_Coverage, 2739,
     /*  27106 */   GIR_EraseRootFromParent_Done,
     /*  27107 */ // Label 563: @27107
     /*  27107 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27139), // Rule ID 2740 //
     /*  27112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27126 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27138 */   // GIR_Coverage, 2740,
     /*  27138 */   GIR_EraseRootFromParent_Done,
     /*  27139 */ // Label 564: @27139
     /*  27139 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27171), // Rule ID 2741 //
     /*  27144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27158 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27161 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27170 */   // GIR_Coverage, 2741,
     /*  27170 */   GIR_EraseRootFromParent_Done,
     /*  27171 */ // Label 565: @27171
     /*  27171 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27208), // Rule ID 2804 //
     /*  27176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27190 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27206 */   GIR_RootConstrainSelectedInstOperands,
     /*  27207 */   // GIR_Coverage, 2804,
     /*  27207 */   GIR_EraseRootFromParent_Done,
     /*  27208 */ // Label 566: @27208
     /*  27208 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27245), // Rule ID 2805 //
     /*  27213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27227 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27237 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27243 */   GIR_RootConstrainSelectedInstOperands,
     /*  27244 */   // GIR_Coverage, 2805,
     /*  27244 */   GIR_EraseRootFromParent_Done,
     /*  27245 */ // Label 567: @27245
     /*  27245 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27282), // Rule ID 2806 //
     /*  27250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27264 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27274 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27280 */   GIR_RootConstrainSelectedInstOperands,
     /*  27281 */   // GIR_Coverage, 2806,
     /*  27281 */   GIR_EraseRootFromParent_Done,
     /*  27282 */ // Label 568: @27282
     /*  27282 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27319), // Rule ID 2807 //
     /*  27287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27301 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27311 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27317 */   GIR_RootConstrainSelectedInstOperands,
     /*  27318 */   // GIR_Coverage, 2807,
     /*  27318 */   GIR_EraseRootFromParent_Done,
     /*  27319 */ // Label 569: @27319
     /*  27319 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27356), // Rule ID 2808 //
     /*  27324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27338 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27348 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27354 */   GIR_RootConstrainSelectedInstOperands,
     /*  27355 */   // GIR_Coverage, 2808,
     /*  27355 */   GIR_EraseRootFromParent_Done,
     /*  27356 */ // Label 570: @27356
     /*  27356 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27393), // Rule ID 2809 //
     /*  27361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27375 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27380 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27385 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27391 */   GIR_RootConstrainSelectedInstOperands,
     /*  27392 */   // GIR_Coverage, 2809,
     /*  27392 */   GIR_EraseRootFromParent_Done,
     /*  27393 */ // Label 571: @27393
     /*  27393 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27430), // Rule ID 2810 //
     /*  27398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27412 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27428 */   GIR_RootConstrainSelectedInstOperands,
     /*  27429 */   // GIR_Coverage, 2810,
     /*  27429 */   GIR_EraseRootFromParent_Done,
     /*  27430 */ // Label 572: @27430
     /*  27430 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27467), // Rule ID 2811 //
     /*  27435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27449 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27459 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27465 */   GIR_RootConstrainSelectedInstOperands,
     /*  27466 */   // GIR_Coverage, 2811,
     /*  27466 */   GIR_EraseRootFromParent_Done,
     /*  27467 */ // Label 573: @27467
     /*  27467 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27504), // Rule ID 2812 //
     /*  27472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27486 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27502 */   GIR_RootConstrainSelectedInstOperands,
     /*  27503 */   // GIR_Coverage, 2812,
     /*  27503 */   GIR_EraseRootFromParent_Done,
     /*  27504 */ // Label 574: @27504
     /*  27504 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27541), // Rule ID 2813 //
     /*  27509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27523 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27528 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27533 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27539 */   GIR_RootConstrainSelectedInstOperands,
     /*  27540 */   // GIR_Coverage, 2813,
     /*  27540 */   GIR_EraseRootFromParent_Done,
     /*  27541 */ // Label 575: @27541
     /*  27541 */ GIM_Reject,
     /*  27542 */ // Label 542: @27542
     /*  27542 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27574), // Rule ID 2722 //
     /*  27547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27561 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27573 */   // GIR_Coverage, 2722,
     /*  27573 */   GIR_EraseRootFromParent_Done,
     /*  27574 */ // Label 576: @27574
     /*  27574 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27606), // Rule ID 2723 //
     /*  27579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27593 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27605 */   // GIR_Coverage, 2723,
     /*  27605 */   GIR_EraseRootFromParent_Done,
     /*  27606 */ // Label 577: @27606
     /*  27606 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27638), // Rule ID 2742 //
     /*  27611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27625 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27637 */   // GIR_Coverage, 2742,
     /*  27637 */   GIR_EraseRootFromParent_Done,
     /*  27638 */ // Label 578: @27638
     /*  27638 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27670), // Rule ID 2743 //
     /*  27643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27657 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27669 */   // GIR_Coverage, 2743,
     /*  27669 */   GIR_EraseRootFromParent_Done,
     /*  27670 */ // Label 579: @27670
     /*  27670 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27702), // Rule ID 2744 //
     /*  27675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27689 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27701 */   // GIR_Coverage, 2744,
     /*  27701 */   GIR_EraseRootFromParent_Done,
     /*  27702 */ // Label 580: @27702
     /*  27702 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27734), // Rule ID 2745 //
     /*  27707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27721 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27733 */   // GIR_Coverage, 2745,
     /*  27733 */   GIR_EraseRootFromParent_Done,
     /*  27734 */ // Label 581: @27734
     /*  27734 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27766), // Rule ID 2746 //
     /*  27739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27753 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27765 */   // GIR_Coverage, 2746,
     /*  27765 */   GIR_EraseRootFromParent_Done,
     /*  27766 */ // Label 582: @27766
     /*  27766 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27798), // Rule ID 2747 //
     /*  27771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27785 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27788 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27790 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27797 */   // GIR_Coverage, 2747,
     /*  27797 */   GIR_EraseRootFromParent_Done,
     /*  27798 */ // Label 583: @27798
     /*  27798 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27830), // Rule ID 2748 //
     /*  27803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27817 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27829 */   // GIR_Coverage, 2748,
     /*  27829 */   GIR_EraseRootFromParent_Done,
     /*  27830 */ // Label 584: @27830
     /*  27830 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27862), // Rule ID 2749 //
     /*  27835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27849 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27852 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27861 */   // GIR_Coverage, 2749,
     /*  27861 */   GIR_EraseRootFromParent_Done,
     /*  27862 */ // Label 585: @27862
     /*  27862 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27894), // Rule ID 2750 //
     /*  27867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27881 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27884 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27886 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27893 */   // GIR_Coverage, 2750,
     /*  27893 */   GIR_EraseRootFromParent_Done,
     /*  27894 */ // Label 586: @27894
     /*  27894 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27926), // Rule ID 2751 //
     /*  27899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27913 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27916 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27918 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27925 */   // GIR_Coverage, 2751,
     /*  27925 */   GIR_EraseRootFromParent_Done,
     /*  27926 */ // Label 587: @27926
     /*  27926 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(27963), // Rule ID 2814 //
     /*  27931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27945 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27950 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27955 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27961 */   GIR_RootConstrainSelectedInstOperands,
     /*  27962 */   // GIR_Coverage, 2814,
     /*  27962 */   GIR_EraseRootFromParent_Done,
     /*  27963 */ // Label 588: @27963
     /*  27963 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28000), // Rule ID 2815 //
     /*  27968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27982 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27998 */   GIR_RootConstrainSelectedInstOperands,
     /*  27999 */   // GIR_Coverage, 2815,
     /*  27999 */   GIR_EraseRootFromParent_Done,
     /*  28000 */ // Label 589: @28000
     /*  28000 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28037), // Rule ID 2816 //
     /*  28005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28019 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28029 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28035 */   GIR_RootConstrainSelectedInstOperands,
     /*  28036 */   // GIR_Coverage, 2816,
     /*  28036 */   GIR_EraseRootFromParent_Done,
     /*  28037 */ // Label 590: @28037
     /*  28037 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28074), // Rule ID 2817 //
     /*  28042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28056 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28072 */   GIR_RootConstrainSelectedInstOperands,
     /*  28073 */   // GIR_Coverage, 2817,
     /*  28073 */   GIR_EraseRootFromParent_Done,
     /*  28074 */ // Label 591: @28074
     /*  28074 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28111), // Rule ID 2818 //
     /*  28079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28093 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28109 */   GIR_RootConstrainSelectedInstOperands,
     /*  28110 */   // GIR_Coverage, 2818,
     /*  28110 */   GIR_EraseRootFromParent_Done,
     /*  28111 */ // Label 592: @28111
     /*  28111 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28148), // Rule ID 2819 //
     /*  28116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28130 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28140 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28146 */   GIR_RootConstrainSelectedInstOperands,
     /*  28147 */   // GIR_Coverage, 2819,
     /*  28147 */   GIR_EraseRootFromParent_Done,
     /*  28148 */ // Label 593: @28148
     /*  28148 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28185), // Rule ID 2820 //
     /*  28153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28167 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28177 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28183 */   GIR_RootConstrainSelectedInstOperands,
     /*  28184 */   // GIR_Coverage, 2820,
     /*  28184 */   GIR_EraseRootFromParent_Done,
     /*  28185 */ // Label 594: @28185
     /*  28185 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28222), // Rule ID 2821 //
     /*  28190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28204 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28214 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28220 */   GIR_RootConstrainSelectedInstOperands,
     /*  28221 */   // GIR_Coverage, 2821,
     /*  28221 */   GIR_EraseRootFromParent_Done,
     /*  28222 */ // Label 595: @28222
     /*  28222 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28259), // Rule ID 2822 //
     /*  28227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28241 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28251 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28257 */   GIR_RootConstrainSelectedInstOperands,
     /*  28258 */   // GIR_Coverage, 2822,
     /*  28258 */   GIR_EraseRootFromParent_Done,
     /*  28259 */ // Label 596: @28259
     /*  28259 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28296), // Rule ID 2823 //
     /*  28264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28278 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28294 */   GIR_RootConstrainSelectedInstOperands,
     /*  28295 */   // GIR_Coverage, 2823,
     /*  28295 */   GIR_EraseRootFromParent_Done,
     /*  28296 */ // Label 597: @28296
     /*  28296 */ GIM_Reject,
     /*  28297 */ // Label 543: @28297
     /*  28297 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28329), // Rule ID 2726 //
     /*  28302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28316 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28319 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28328 */   // GIR_Coverage, 2726,
     /*  28328 */   GIR_EraseRootFromParent_Done,
     /*  28329 */ // Label 598: @28329
     /*  28329 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28361), // Rule ID 2727 //
     /*  28334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28348 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28351 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28353 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28360 */   // GIR_Coverage, 2727,
     /*  28360 */   GIR_EraseRootFromParent_Done,
     /*  28361 */ // Label 599: @28361
     /*  28361 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28393), // Rule ID 2768 //
     /*  28366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28380 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28392 */   // GIR_Coverage, 2768,
     /*  28392 */   GIR_EraseRootFromParent_Done,
     /*  28393 */ // Label 600: @28393
     /*  28393 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28425), // Rule ID 2769 //
     /*  28398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28412 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28424 */   // GIR_Coverage, 2769,
     /*  28424 */   GIR_EraseRootFromParent_Done,
     /*  28425 */ // Label 601: @28425
     /*  28425 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28457), // Rule ID 2770 //
     /*  28430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28444 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28447 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28449 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28456 */   // GIR_Coverage, 2770,
     /*  28456 */   GIR_EraseRootFromParent_Done,
     /*  28457 */ // Label 602: @28457
     /*  28457 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28489), // Rule ID 2771 //
     /*  28462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28476 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28479 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28481 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28488 */   // GIR_Coverage, 2771,
     /*  28488 */   GIR_EraseRootFromParent_Done,
     /*  28489 */ // Label 603: @28489
     /*  28489 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28521), // Rule ID 2772 //
     /*  28494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28508 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28520 */   // GIR_Coverage, 2772,
     /*  28520 */   GIR_EraseRootFromParent_Done,
     /*  28521 */ // Label 604: @28521
     /*  28521 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28553), // Rule ID 2773 //
     /*  28526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28540 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28552 */   // GIR_Coverage, 2773,
     /*  28552 */   GIR_EraseRootFromParent_Done,
     /*  28553 */ // Label 605: @28553
     /*  28553 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28585), // Rule ID 2774 //
     /*  28558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28572 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28575 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28577 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28584 */   // GIR_Coverage, 2774,
     /*  28584 */   GIR_EraseRootFromParent_Done,
     /*  28585 */ // Label 606: @28585
     /*  28585 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28617), // Rule ID 2775 //
     /*  28590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28604 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28607 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28616 */   // GIR_Coverage, 2775,
     /*  28616 */   GIR_EraseRootFromParent_Done,
     /*  28617 */ // Label 607: @28617
     /*  28617 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28649), // Rule ID 2776 //
     /*  28622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28636 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28639 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28641 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28648 */   // GIR_Coverage, 2776,
     /*  28648 */   GIR_EraseRootFromParent_Done,
     /*  28649 */ // Label 608: @28649
     /*  28649 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28681), // Rule ID 2777 //
     /*  28654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28668 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28680 */   // GIR_Coverage, 2777,
     /*  28680 */   GIR_EraseRootFromParent_Done,
     /*  28681 */ // Label 609: @28681
     /*  28681 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28718), // Rule ID 2840 //
     /*  28686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28700 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28716 */   GIR_RootConstrainSelectedInstOperands,
     /*  28717 */   // GIR_Coverage, 2840,
     /*  28717 */   GIR_EraseRootFromParent_Done,
     /*  28718 */ // Label 610: @28718
     /*  28718 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28755), // Rule ID 2841 //
     /*  28723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28737 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28753 */   GIR_RootConstrainSelectedInstOperands,
     /*  28754 */   // GIR_Coverage, 2841,
     /*  28754 */   GIR_EraseRootFromParent_Done,
     /*  28755 */ // Label 611: @28755
     /*  28755 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28792), // Rule ID 2842 //
     /*  28760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28774 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28784 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28790 */   GIR_RootConstrainSelectedInstOperands,
     /*  28791 */   // GIR_Coverage, 2842,
     /*  28791 */   GIR_EraseRootFromParent_Done,
     /*  28792 */ // Label 612: @28792
     /*  28792 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28829), // Rule ID 2843 //
     /*  28797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28811 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28821 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28827 */   GIR_RootConstrainSelectedInstOperands,
     /*  28828 */   // GIR_Coverage, 2843,
     /*  28828 */   GIR_EraseRootFromParent_Done,
     /*  28829 */ // Label 613: @28829
     /*  28829 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28866), // Rule ID 2844 //
     /*  28834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28848 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28858 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28864 */   GIR_RootConstrainSelectedInstOperands,
     /*  28865 */   // GIR_Coverage, 2844,
     /*  28865 */   GIR_EraseRootFromParent_Done,
     /*  28866 */ // Label 614: @28866
     /*  28866 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28903), // Rule ID 2845 //
     /*  28871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28885 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28895 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28901 */   GIR_RootConstrainSelectedInstOperands,
     /*  28902 */   // GIR_Coverage, 2845,
     /*  28902 */   GIR_EraseRootFromParent_Done,
     /*  28903 */ // Label 615: @28903
     /*  28903 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28940), // Rule ID 2846 //
     /*  28908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28922 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28927 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28938 */   GIR_RootConstrainSelectedInstOperands,
     /*  28939 */   // GIR_Coverage, 2846,
     /*  28939 */   GIR_EraseRootFromParent_Done,
     /*  28940 */ // Label 616: @28940
     /*  28940 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(28977), // Rule ID 2847 //
     /*  28945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28959 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28975 */   GIR_RootConstrainSelectedInstOperands,
     /*  28976 */   // GIR_Coverage, 2847,
     /*  28976 */   GIR_EraseRootFromParent_Done,
     /*  28977 */ // Label 617: @28977
     /*  28977 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29014), // Rule ID 2848 //
     /*  28982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28996 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  28996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29012 */   GIR_RootConstrainSelectedInstOperands,
     /*  29013 */   // GIR_Coverage, 2848,
     /*  29013 */   GIR_EraseRootFromParent_Done,
     /*  29014 */ // Label 618: @29014
     /*  29014 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29051), // Rule ID 2849 //
     /*  29019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29033 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29043 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29049 */   GIR_RootConstrainSelectedInstOperands,
     /*  29050 */   // GIR_Coverage, 2849,
     /*  29050 */   GIR_EraseRootFromParent_Done,
     /*  29051 */ // Label 619: @29051
     /*  29051 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29083), // Rule ID 5283 //
     /*  29056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29070 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29073 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29075 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29082 */   // GIR_Coverage, 5283,
     /*  29082 */   GIR_EraseRootFromParent_Done,
     /*  29083 */ // Label 620: @29083
     /*  29083 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29115), // Rule ID 5284 //
     /*  29088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29102 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29114 */   // GIR_Coverage, 5284,
     /*  29114 */   GIR_EraseRootFromParent_Done,
     /*  29115 */ // Label 621: @29115
     /*  29115 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29147), // Rule ID 5289 //
     /*  29120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29134 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29137 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29139 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29146 */   // GIR_Coverage, 5289,
     /*  29146 */   GIR_EraseRootFromParent_Done,
     /*  29147 */ // Label 622: @29147
     /*  29147 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29179), // Rule ID 5290 //
     /*  29152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29166 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29178 */   // GIR_Coverage, 5290,
     /*  29178 */   GIR_EraseRootFromParent_Done,
     /*  29179 */ // Label 623: @29179
     /*  29179 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29211), // Rule ID 5291 //
     /*  29184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29198 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29201 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29203 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29210 */   // GIR_Coverage, 5291,
     /*  29210 */   GIR_EraseRootFromParent_Done,
     /*  29211 */ // Label 624: @29211
     /*  29211 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29243), // Rule ID 5292 //
     /*  29216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29230 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29233 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29242 */   // GIR_Coverage, 5292,
     /*  29242 */   GIR_EraseRootFromParent_Done,
     /*  29243 */ // Label 625: @29243
     /*  29243 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29275), // Rule ID 5293 //
     /*  29248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29262 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29265 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29274 */   // GIR_Coverage, 5293,
     /*  29274 */   GIR_EraseRootFromParent_Done,
     /*  29275 */ // Label 626: @29275
     /*  29275 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29307), // Rule ID 5294 //
     /*  29280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29294 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29306 */   // GIR_Coverage, 5294,
     /*  29306 */   GIR_EraseRootFromParent_Done,
     /*  29307 */ // Label 627: @29307
     /*  29307 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29339), // Rule ID 5295 //
     /*  29312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29326 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29338 */   // GIR_Coverage, 5295,
     /*  29338 */   GIR_EraseRootFromParent_Done,
     /*  29339 */ // Label 628: @29339
     /*  29339 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29371), // Rule ID 5296 //
     /*  29344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29358 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29370 */   // GIR_Coverage, 5296,
     /*  29370 */   GIR_EraseRootFromParent_Done,
     /*  29371 */ // Label 629: @29371
     /*  29371 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29403), // Rule ID 5297 //
     /*  29376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29390 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29402 */   // GIR_Coverage, 5297,
     /*  29402 */   GIR_EraseRootFromParent_Done,
     /*  29403 */ // Label 630: @29403
     /*  29403 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29435), // Rule ID 5298 //
     /*  29408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29422 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29434 */   // GIR_Coverage, 5298,
     /*  29434 */   GIR_EraseRootFromParent_Done,
     /*  29435 */ // Label 631: @29435
     /*  29435 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29493), // Rule ID 5325 //
     /*  29440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29454 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29476 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29491 */   GIR_RootConstrainSelectedInstOperands,
     /*  29492 */   // GIR_Coverage, 5325,
     /*  29492 */   GIR_EraseRootFromParent_Done,
     /*  29493 */ // Label 632: @29493
     /*  29493 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29551), // Rule ID 5326 //
     /*  29498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29512 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29534 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29549 */   GIR_RootConstrainSelectedInstOperands,
     /*  29550 */   // GIR_Coverage, 5326,
     /*  29550 */   GIR_EraseRootFromParent_Done,
     /*  29551 */ // Label 633: @29551
     /*  29551 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29609), // Rule ID 5327 //
     /*  29556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29570 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29592 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29607 */   GIR_RootConstrainSelectedInstOperands,
     /*  29608 */   // GIR_Coverage, 5327,
     /*  29608 */   GIR_EraseRootFromParent_Done,
     /*  29609 */ // Label 634: @29609
     /*  29609 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29667), // Rule ID 5328 //
     /*  29614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29628 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29656 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29665 */   GIR_RootConstrainSelectedInstOperands,
     /*  29666 */   // GIR_Coverage, 5328,
     /*  29666 */   GIR_EraseRootFromParent_Done,
     /*  29667 */ // Label 635: @29667
     /*  29667 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29725), // Rule ID 5329 //
     /*  29672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29686 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29703 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29714 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29723 */   GIR_RootConstrainSelectedInstOperands,
     /*  29724 */   // GIR_Coverage, 5329,
     /*  29724 */   GIR_EraseRootFromParent_Done,
     /*  29725 */ // Label 636: @29725
     /*  29725 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29783), // Rule ID 5330 //
     /*  29730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29744 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29766 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29772 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29781 */   GIR_RootConstrainSelectedInstOperands,
     /*  29782 */   // GIR_Coverage, 5330,
     /*  29782 */   GIR_EraseRootFromParent_Done,
     /*  29783 */ // Label 637: @29783
     /*  29783 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29841), // Rule ID 5331 //
     /*  29788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29802 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29830 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29839 */   GIR_RootConstrainSelectedInstOperands,
     /*  29840 */   // GIR_Coverage, 5331,
     /*  29840 */   GIR_EraseRootFromParent_Done,
     /*  29841 */ // Label 638: @29841
     /*  29841 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29899), // Rule ID 5332 //
     /*  29846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29860 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29897 */   GIR_RootConstrainSelectedInstOperands,
     /*  29898 */   // GIR_Coverage, 5332,
     /*  29898 */   GIR_EraseRootFromParent_Done,
     /*  29899 */ // Label 639: @29899
     /*  29899 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(29957), // Rule ID 5333 //
     /*  29904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29918 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29946 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29955 */   GIR_RootConstrainSelectedInstOperands,
     /*  29956 */   // GIR_Coverage, 5333,
     /*  29956 */   GIR_EraseRootFromParent_Done,
     /*  29957 */ // Label 640: @29957
     /*  29957 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30015), // Rule ID 5334 //
     /*  29962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29976 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30013 */   GIR_RootConstrainSelectedInstOperands,
     /*  30014 */   // GIR_Coverage, 5334,
     /*  30014 */   GIR_EraseRootFromParent_Done,
     /*  30015 */ // Label 641: @30015
     /*  30015 */ GIM_Reject,
     /*  30016 */ // Label 544: @30016
     /*  30016 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30048), // Rule ID 2724 //
     /*  30021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30035 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30047 */   // GIR_Coverage, 2724,
     /*  30047 */   GIR_EraseRootFromParent_Done,
     /*  30048 */ // Label 642: @30048
     /*  30048 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30080), // Rule ID 2725 //
     /*  30053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30067 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30070 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30072 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30079 */   // GIR_Coverage, 2725,
     /*  30079 */   GIR_EraseRootFromParent_Done,
     /*  30080 */ // Label 643: @30080
     /*  30080 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30112), // Rule ID 2752 //
     /*  30085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30099 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30102 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30104 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30111 */   // GIR_Coverage, 2752,
     /*  30111 */   GIR_EraseRootFromParent_Done,
     /*  30112 */ // Label 644: @30112
     /*  30112 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30144), // Rule ID 2753 //
     /*  30117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30131 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30143 */   // GIR_Coverage, 2753,
     /*  30143 */   GIR_EraseRootFromParent_Done,
     /*  30144 */ // Label 645: @30144
     /*  30144 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30176), // Rule ID 2754 //
     /*  30149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30163 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30175 */   // GIR_Coverage, 2754,
     /*  30175 */   GIR_EraseRootFromParent_Done,
     /*  30176 */ // Label 646: @30176
     /*  30176 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30208), // Rule ID 2755 //
     /*  30181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30195 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30207 */   // GIR_Coverage, 2755,
     /*  30207 */   GIR_EraseRootFromParent_Done,
     /*  30208 */ // Label 647: @30208
     /*  30208 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30240), // Rule ID 2756 //
     /*  30213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30227 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30230 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30239 */   // GIR_Coverage, 2756,
     /*  30239 */   GIR_EraseRootFromParent_Done,
     /*  30240 */ // Label 648: @30240
     /*  30240 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30272), // Rule ID 2757 //
     /*  30245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30259 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30271 */   // GIR_Coverage, 2757,
     /*  30271 */   GIR_EraseRootFromParent_Done,
     /*  30272 */ // Label 649: @30272
     /*  30272 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30304), // Rule ID 2758 //
     /*  30277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30291 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30303 */   // GIR_Coverage, 2758,
     /*  30303 */   GIR_EraseRootFromParent_Done,
     /*  30304 */ // Label 650: @30304
     /*  30304 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30336), // Rule ID 2759 //
     /*  30309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30323 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30335 */   // GIR_Coverage, 2759,
     /*  30335 */   GIR_EraseRootFromParent_Done,
     /*  30336 */ // Label 651: @30336
     /*  30336 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30368), // Rule ID 2760 //
     /*  30341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30355 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30367 */   // GIR_Coverage, 2760,
     /*  30367 */   GIR_EraseRootFromParent_Done,
     /*  30368 */ // Label 652: @30368
     /*  30368 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30400), // Rule ID 2761 //
     /*  30373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30387 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30399 */   // GIR_Coverage, 2761,
     /*  30399 */   GIR_EraseRootFromParent_Done,
     /*  30400 */ // Label 653: @30400
     /*  30400 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30437), // Rule ID 2824 //
     /*  30405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30419 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30435 */   GIR_RootConstrainSelectedInstOperands,
     /*  30436 */   // GIR_Coverage, 2824,
     /*  30436 */   GIR_EraseRootFromParent_Done,
     /*  30437 */ // Label 654: @30437
     /*  30437 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30474), // Rule ID 2825 //
     /*  30442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30456 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30472 */   GIR_RootConstrainSelectedInstOperands,
     /*  30473 */   // GIR_Coverage, 2825,
     /*  30473 */   GIR_EraseRootFromParent_Done,
     /*  30474 */ // Label 655: @30474
     /*  30474 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30511), // Rule ID 2826 //
     /*  30479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30493 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30509 */   GIR_RootConstrainSelectedInstOperands,
     /*  30510 */   // GIR_Coverage, 2826,
     /*  30510 */   GIR_EraseRootFromParent_Done,
     /*  30511 */ // Label 656: @30511
     /*  30511 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30548), // Rule ID 2827 //
     /*  30516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30530 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30546 */   GIR_RootConstrainSelectedInstOperands,
     /*  30547 */   // GIR_Coverage, 2827,
     /*  30547 */   GIR_EraseRootFromParent_Done,
     /*  30548 */ // Label 657: @30548
     /*  30548 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30585), // Rule ID 2828 //
     /*  30553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30567 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30583 */   GIR_RootConstrainSelectedInstOperands,
     /*  30584 */   // GIR_Coverage, 2828,
     /*  30584 */   GIR_EraseRootFromParent_Done,
     /*  30585 */ // Label 658: @30585
     /*  30585 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30622), // Rule ID 2829 //
     /*  30590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30604 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30620 */   GIR_RootConstrainSelectedInstOperands,
     /*  30621 */   // GIR_Coverage, 2829,
     /*  30621 */   GIR_EraseRootFromParent_Done,
     /*  30622 */ // Label 659: @30622
     /*  30622 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30659), // Rule ID 2830 //
     /*  30627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30641 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30657 */   GIR_RootConstrainSelectedInstOperands,
     /*  30658 */   // GIR_Coverage, 2830,
     /*  30658 */   GIR_EraseRootFromParent_Done,
     /*  30659 */ // Label 660: @30659
     /*  30659 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30696), // Rule ID 2831 //
     /*  30664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30678 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30688 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30694 */   GIR_RootConstrainSelectedInstOperands,
     /*  30695 */   // GIR_Coverage, 2831,
     /*  30695 */   GIR_EraseRootFromParent_Done,
     /*  30696 */ // Label 661: @30696
     /*  30696 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30733), // Rule ID 2832 //
     /*  30701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30715 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30725 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30731 */   GIR_RootConstrainSelectedInstOperands,
     /*  30732 */   // GIR_Coverage, 2832,
     /*  30732 */   GIR_EraseRootFromParent_Done,
     /*  30733 */ // Label 662: @30733
     /*  30733 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30770), // Rule ID 2833 //
     /*  30738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30752 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30762 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30768 */   GIR_RootConstrainSelectedInstOperands,
     /*  30769 */   // GIR_Coverage, 2833,
     /*  30769 */   GIR_EraseRootFromParent_Done,
     /*  30770 */ // Label 663: @30770
     /*  30770 */ GIM_Reject,
     /*  30771 */ // Label 545: @30771
     /*  30771 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30803), // Rule ID 2728 //
     /*  30776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30790 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30802 */   // GIR_Coverage, 2728,
     /*  30802 */   GIR_EraseRootFromParent_Done,
     /*  30803 */ // Label 664: @30803
     /*  30803 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30835), // Rule ID 2729 //
     /*  30808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30822 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30834 */   // GIR_Coverage, 2729,
     /*  30834 */   GIR_EraseRootFromParent_Done,
     /*  30835 */ // Label 665: @30835
     /*  30835 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30867), // Rule ID 2778 //
     /*  30840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30854 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30866 */   // GIR_Coverage, 2778,
     /*  30866 */   GIR_EraseRootFromParent_Done,
     /*  30867 */ // Label 666: @30867
     /*  30867 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30899), // Rule ID 2779 //
     /*  30872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30886 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30898 */   // GIR_Coverage, 2779,
     /*  30898 */   GIR_EraseRootFromParent_Done,
     /*  30899 */ // Label 667: @30899
     /*  30899 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30931), // Rule ID 2780 //
     /*  30904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30918 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30930 */   // GIR_Coverage, 2780,
     /*  30930 */   GIR_EraseRootFromParent_Done,
     /*  30931 */ // Label 668: @30931
     /*  30931 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30963), // Rule ID 2781 //
     /*  30936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30950 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30962 */   // GIR_Coverage, 2781,
     /*  30962 */   GIR_EraseRootFromParent_Done,
     /*  30963 */ // Label 669: @30963
     /*  30963 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(30995), // Rule ID 2782 //
     /*  30968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30982 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30994 */   // GIR_Coverage, 2782,
     /*  30994 */   GIR_EraseRootFromParent_Done,
     /*  30995 */ // Label 670: @30995
     /*  30995 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31027), // Rule ID 2783 //
     /*  31000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31014 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31026 */   // GIR_Coverage, 2783,
     /*  31026 */   GIR_EraseRootFromParent_Done,
     /*  31027 */ // Label 671: @31027
     /*  31027 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31059), // Rule ID 2784 //
     /*  31032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31046 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31058 */   // GIR_Coverage, 2784,
     /*  31058 */   GIR_EraseRootFromParent_Done,
     /*  31059 */ // Label 672: @31059
     /*  31059 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31091), // Rule ID 2785 //
     /*  31064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31078 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31090 */   // GIR_Coverage, 2785,
     /*  31090 */   GIR_EraseRootFromParent_Done,
     /*  31091 */ // Label 673: @31091
     /*  31091 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31123), // Rule ID 2786 //
     /*  31096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31110 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31122 */   // GIR_Coverage, 2786,
     /*  31122 */   GIR_EraseRootFromParent_Done,
     /*  31123 */ // Label 674: @31123
     /*  31123 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31155), // Rule ID 2787 //
     /*  31128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31142 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31154 */   // GIR_Coverage, 2787,
     /*  31154 */   GIR_EraseRootFromParent_Done,
     /*  31155 */ // Label 675: @31155
     /*  31155 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31192), // Rule ID 2850 //
     /*  31160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31174 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31190 */   GIR_RootConstrainSelectedInstOperands,
     /*  31191 */   // GIR_Coverage, 2850,
     /*  31191 */   GIR_EraseRootFromParent_Done,
     /*  31192 */ // Label 676: @31192
     /*  31192 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31229), // Rule ID 2851 //
     /*  31197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31211 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31227 */   GIR_RootConstrainSelectedInstOperands,
     /*  31228 */   // GIR_Coverage, 2851,
     /*  31228 */   GIR_EraseRootFromParent_Done,
     /*  31229 */ // Label 677: @31229
     /*  31229 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31266), // Rule ID 2852 //
     /*  31234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31248 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31264 */   GIR_RootConstrainSelectedInstOperands,
     /*  31265 */   // GIR_Coverage, 2852,
     /*  31265 */   GIR_EraseRootFromParent_Done,
     /*  31266 */ // Label 678: @31266
     /*  31266 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31303), // Rule ID 2853 //
     /*  31271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31285 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31301 */   GIR_RootConstrainSelectedInstOperands,
     /*  31302 */   // GIR_Coverage, 2853,
     /*  31302 */   GIR_EraseRootFromParent_Done,
     /*  31303 */ // Label 679: @31303
     /*  31303 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31340), // Rule ID 2854 //
     /*  31308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31322 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31332 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31338 */   GIR_RootConstrainSelectedInstOperands,
     /*  31339 */   // GIR_Coverage, 2854,
     /*  31339 */   GIR_EraseRootFromParent_Done,
     /*  31340 */ // Label 680: @31340
     /*  31340 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31377), // Rule ID 2855 //
     /*  31345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31359 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31369 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31375 */   GIR_RootConstrainSelectedInstOperands,
     /*  31376 */   // GIR_Coverage, 2855,
     /*  31376 */   GIR_EraseRootFromParent_Done,
     /*  31377 */ // Label 681: @31377
     /*  31377 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31414), // Rule ID 2856 //
     /*  31382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31396 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31412 */   GIR_RootConstrainSelectedInstOperands,
     /*  31413 */   // GIR_Coverage, 2856,
     /*  31413 */   GIR_EraseRootFromParent_Done,
     /*  31414 */ // Label 682: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31451), // Rule ID 2857 //
     /*  31419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31433 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31449 */   GIR_RootConstrainSelectedInstOperands,
     /*  31450 */   // GIR_Coverage, 2857,
     /*  31450 */   GIR_EraseRootFromParent_Done,
     /*  31451 */ // Label 683: @31451
     /*  31451 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31488), // Rule ID 2858 //
     /*  31456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31470 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31486 */   GIR_RootConstrainSelectedInstOperands,
     /*  31487 */   // GIR_Coverage, 2858,
     /*  31487 */   GIR_EraseRootFromParent_Done,
     /*  31488 */ // Label 684: @31488
     /*  31488 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31525), // Rule ID 2859 //
     /*  31493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31507 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31517 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31523 */   GIR_RootConstrainSelectedInstOperands,
     /*  31524 */   // GIR_Coverage, 2859,
     /*  31524 */   GIR_EraseRootFromParent_Done,
     /*  31525 */ // Label 685: @31525
     /*  31525 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31557), // Rule ID 5285 //
     /*  31530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31544 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31556 */   // GIR_Coverage, 5285,
     /*  31556 */   GIR_EraseRootFromParent_Done,
     /*  31557 */ // Label 686: @31557
     /*  31557 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31589), // Rule ID 5286 //
     /*  31562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31576 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31588 */   // GIR_Coverage, 5286,
     /*  31588 */   GIR_EraseRootFromParent_Done,
     /*  31589 */ // Label 687: @31589
     /*  31589 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31621), // Rule ID 5299 //
     /*  31594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31608 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31620 */   // GIR_Coverage, 5299,
     /*  31620 */   GIR_EraseRootFromParent_Done,
     /*  31621 */ // Label 688: @31621
     /*  31621 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31653), // Rule ID 5300 //
     /*  31626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31640 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31652 */   // GIR_Coverage, 5300,
     /*  31652 */   GIR_EraseRootFromParent_Done,
     /*  31653 */ // Label 689: @31653
     /*  31653 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31685), // Rule ID 5301 //
     /*  31658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31672 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31684 */   // GIR_Coverage, 5301,
     /*  31684 */   GIR_EraseRootFromParent_Done,
     /*  31685 */ // Label 690: @31685
     /*  31685 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31717), // Rule ID 5302 //
     /*  31690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31704 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31707 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31709 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31716 */   // GIR_Coverage, 5302,
     /*  31716 */   GIR_EraseRootFromParent_Done,
     /*  31717 */ // Label 691: @31717
     /*  31717 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31749), // Rule ID 5303 //
     /*  31722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31736 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31748 */   // GIR_Coverage, 5303,
     /*  31748 */   GIR_EraseRootFromParent_Done,
     /*  31749 */ // Label 692: @31749
     /*  31749 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31781), // Rule ID 5304 //
     /*  31754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31768 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31780 */   // GIR_Coverage, 5304,
     /*  31780 */   GIR_EraseRootFromParent_Done,
     /*  31781 */ // Label 693: @31781
     /*  31781 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31813), // Rule ID 5305 //
     /*  31786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31800 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31812 */   // GIR_Coverage, 5305,
     /*  31812 */   GIR_EraseRootFromParent_Done,
     /*  31813 */ // Label 694: @31813
     /*  31813 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31845), // Rule ID 5306 //
     /*  31818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31832 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31844 */   // GIR_Coverage, 5306,
     /*  31844 */   GIR_EraseRootFromParent_Done,
     /*  31845 */ // Label 695: @31845
     /*  31845 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31877), // Rule ID 5307 //
     /*  31850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31864 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31876 */   // GIR_Coverage, 5307,
     /*  31876 */   GIR_EraseRootFromParent_Done,
     /*  31877 */ // Label 696: @31877
     /*  31877 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31909), // Rule ID 5308 //
     /*  31882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31896 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31908 */   // GIR_Coverage, 5308,
     /*  31908 */   GIR_EraseRootFromParent_Done,
     /*  31909 */ // Label 697: @31909
     /*  31909 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(31967), // Rule ID 5335 //
     /*  31914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31928 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31950 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31965 */   GIR_RootConstrainSelectedInstOperands,
     /*  31966 */   // GIR_Coverage, 5335,
     /*  31966 */   GIR_EraseRootFromParent_Done,
     /*  31967 */ // Label 698: @31967
     /*  31967 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32025), // Rule ID 5336 //
     /*  31972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31986 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32014 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32023 */   GIR_RootConstrainSelectedInstOperands,
     /*  32024 */   // GIR_Coverage, 5336,
     /*  32024 */   GIR_EraseRootFromParent_Done,
     /*  32025 */ // Label 699: @32025
     /*  32025 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32083), // Rule ID 5337 //
     /*  32030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32044 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32072 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32081 */   GIR_RootConstrainSelectedInstOperands,
     /*  32082 */   // GIR_Coverage, 5337,
     /*  32082 */   GIR_EraseRootFromParent_Done,
     /*  32083 */ // Label 700: @32083
     /*  32083 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32141), // Rule ID 5338 //
     /*  32088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32102 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32124 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32139 */   GIR_RootConstrainSelectedInstOperands,
     /*  32140 */   // GIR_Coverage, 5338,
     /*  32140 */   GIR_EraseRootFromParent_Done,
     /*  32141 */ // Label 701: @32141
     /*  32141 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32199), // Rule ID 5339 //
     /*  32146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32160 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32182 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32188 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32197 */   GIR_RootConstrainSelectedInstOperands,
     /*  32198 */   // GIR_Coverage, 5339,
     /*  32198 */   GIR_EraseRootFromParent_Done,
     /*  32199 */ // Label 702: @32199
     /*  32199 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32257), // Rule ID 5340 //
     /*  32204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32218 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32240 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32246 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32255 */   GIR_RootConstrainSelectedInstOperands,
     /*  32256 */   // GIR_Coverage, 5340,
     /*  32256 */   GIR_EraseRootFromParent_Done,
     /*  32257 */ // Label 703: @32257
     /*  32257 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32315), // Rule ID 5341 //
     /*  32262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32276 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32298 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32304 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32313 */   GIR_RootConstrainSelectedInstOperands,
     /*  32314 */   // GIR_Coverage, 5341,
     /*  32314 */   GIR_EraseRootFromParent_Done,
     /*  32315 */ // Label 704: @32315
     /*  32315 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32373), // Rule ID 5342 //
     /*  32320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32334 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32356 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32371 */   GIR_RootConstrainSelectedInstOperands,
     /*  32372 */   // GIR_Coverage, 5342,
     /*  32372 */   GIR_EraseRootFromParent_Done,
     /*  32373 */ // Label 705: @32373
     /*  32373 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32431), // Rule ID 5343 //
     /*  32378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32392 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32420 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32429 */   GIR_RootConstrainSelectedInstOperands,
     /*  32430 */   // GIR_Coverage, 5343,
     /*  32430 */   GIR_EraseRootFromParent_Done,
     /*  32431 */ // Label 706: @32431
     /*  32431 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32489), // Rule ID 5344 //
     /*  32436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32450 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32487 */   GIR_RootConstrainSelectedInstOperands,
     /*  32488 */   // GIR_Coverage, 5344,
     /*  32488 */   GIR_EraseRootFromParent_Done,
     /*  32489 */ // Label 707: @32489
     /*  32489 */ GIM_Reject,
     /*  32490 */ // Label 546: @32490
     /*  32490 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32522), // Rule ID 2762 //
     /*  32495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32509 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32521 */   // GIR_Coverage, 2762,
     /*  32521 */   GIR_EraseRootFromParent_Done,
     /*  32522 */ // Label 708: @32522
     /*  32522 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32554), // Rule ID 2763 //
     /*  32527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32541 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32553 */   // GIR_Coverage, 2763,
     /*  32553 */   GIR_EraseRootFromParent_Done,
     /*  32554 */ // Label 709: @32554
     /*  32554 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32586), // Rule ID 2764 //
     /*  32559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32573 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32576 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32578 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32585 */   // GIR_Coverage, 2764,
     /*  32585 */   GIR_EraseRootFromParent_Done,
     /*  32586 */ // Label 710: @32586
     /*  32586 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32618), // Rule ID 2765 //
     /*  32591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32605 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32608 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32610 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32617 */   // GIR_Coverage, 2765,
     /*  32617 */   GIR_EraseRootFromParent_Done,
     /*  32618 */ // Label 711: @32618
     /*  32618 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32650), // Rule ID 2766 //
     /*  32623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32637 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32640 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32649 */   // GIR_Coverage, 2766,
     /*  32649 */   GIR_EraseRootFromParent_Done,
     /*  32650 */ // Label 712: @32650
     /*  32650 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32682), // Rule ID 2767 //
     /*  32655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32669 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32672 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32674 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32681 */   // GIR_Coverage, 2767,
     /*  32681 */   GIR_EraseRootFromParent_Done,
     /*  32682 */ // Label 713: @32682
     /*  32682 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32719), // Rule ID 2834 //
     /*  32687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32701 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32717 */   GIR_RootConstrainSelectedInstOperands,
     /*  32718 */   // GIR_Coverage, 2834,
     /*  32718 */   GIR_EraseRootFromParent_Done,
     /*  32719 */ // Label 714: @32719
     /*  32719 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32756), // Rule ID 2835 //
     /*  32724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32738 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32754 */   GIR_RootConstrainSelectedInstOperands,
     /*  32755 */   // GIR_Coverage, 2835,
     /*  32755 */   GIR_EraseRootFromParent_Done,
     /*  32756 */ // Label 715: @32756
     /*  32756 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32793), // Rule ID 2836 //
     /*  32761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32775 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32791 */   GIR_RootConstrainSelectedInstOperands,
     /*  32792 */   // GIR_Coverage, 2836,
     /*  32792 */   GIR_EraseRootFromParent_Done,
     /*  32793 */ // Label 716: @32793
     /*  32793 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32830), // Rule ID 2837 //
     /*  32798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32812 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32828 */   GIR_RootConstrainSelectedInstOperands,
     /*  32829 */   // GIR_Coverage, 2837,
     /*  32829 */   GIR_EraseRootFromParent_Done,
     /*  32830 */ // Label 717: @32830
     /*  32830 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32867), // Rule ID 2838 //
     /*  32835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32849 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32859 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32865 */   GIR_RootConstrainSelectedInstOperands,
     /*  32866 */   // GIR_Coverage, 2838,
     /*  32866 */   GIR_EraseRootFromParent_Done,
     /*  32867 */ // Label 718: @32867
     /*  32867 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32904), // Rule ID 2839 //
     /*  32872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32886 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32896 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32902 */   GIR_RootConstrainSelectedInstOperands,
     /*  32903 */   // GIR_Coverage, 2839,
     /*  32903 */   GIR_EraseRootFromParent_Done,
     /*  32904 */ // Label 719: @32904
     /*  32904 */ GIM_Reject,
     /*  32905 */ // Label 547: @32905
     /*  32905 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32937), // Rule ID 2730 //
     /*  32910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32924 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32936 */   // GIR_Coverage, 2730,
     /*  32936 */   GIR_EraseRootFromParent_Done,
     /*  32937 */ // Label 720: @32937
     /*  32937 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(32969), // Rule ID 2731 //
     /*  32942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32956 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32968 */   // GIR_Coverage, 2731,
     /*  32968 */   GIR_EraseRootFromParent_Done,
     /*  32969 */ // Label 721: @32969
     /*  32969 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33001), // Rule ID 2788 //
     /*  32974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32988 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33000 */   // GIR_Coverage, 2788,
     /*  33000 */   GIR_EraseRootFromParent_Done,
     /*  33001 */ // Label 722: @33001
     /*  33001 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33033), // Rule ID 2789 //
     /*  33006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33020 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33032 */   // GIR_Coverage, 2789,
     /*  33032 */   GIR_EraseRootFromParent_Done,
     /*  33033 */ // Label 723: @33033
     /*  33033 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33065), // Rule ID 2790 //
     /*  33038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33052 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33064 */   // GIR_Coverage, 2790,
     /*  33064 */   GIR_EraseRootFromParent_Done,
     /*  33065 */ // Label 724: @33065
     /*  33065 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33097), // Rule ID 2791 //
     /*  33070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33084 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33096 */   // GIR_Coverage, 2791,
     /*  33096 */   GIR_EraseRootFromParent_Done,
     /*  33097 */ // Label 725: @33097
     /*  33097 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33129), // Rule ID 2792 //
     /*  33102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33116 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33119 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33128 */   // GIR_Coverage, 2792,
     /*  33128 */   GIR_EraseRootFromParent_Done,
     /*  33129 */ // Label 726: @33129
     /*  33129 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33161), // Rule ID 2793 //
     /*  33134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33148 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33160 */   // GIR_Coverage, 2793,
     /*  33160 */   GIR_EraseRootFromParent_Done,
     /*  33161 */ // Label 727: @33161
     /*  33161 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33193), // Rule ID 2794 //
     /*  33166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33180 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33192 */   // GIR_Coverage, 2794,
     /*  33192 */   GIR_EraseRootFromParent_Done,
     /*  33193 */ // Label 728: @33193
     /*  33193 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33225), // Rule ID 2795 //
     /*  33198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33212 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33215 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33217 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33224 */   // GIR_Coverage, 2795,
     /*  33224 */   GIR_EraseRootFromParent_Done,
     /*  33225 */ // Label 729: @33225
     /*  33225 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33257), // Rule ID 2796 //
     /*  33230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33244 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33247 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33256 */   // GIR_Coverage, 2796,
     /*  33256 */   GIR_EraseRootFromParent_Done,
     /*  33257 */ // Label 730: @33257
     /*  33257 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33289), // Rule ID 2797 //
     /*  33262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33276 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33288 */   // GIR_Coverage, 2797,
     /*  33288 */   GIR_EraseRootFromParent_Done,
     /*  33289 */ // Label 731: @33289
     /*  33289 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33326), // Rule ID 2860 //
     /*  33294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33308 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33318 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33324 */   GIR_RootConstrainSelectedInstOperands,
     /*  33325 */   // GIR_Coverage, 2860,
     /*  33325 */   GIR_EraseRootFromParent_Done,
     /*  33326 */ // Label 732: @33326
     /*  33326 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33363), // Rule ID 2861 //
     /*  33331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33345 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33361 */   GIR_RootConstrainSelectedInstOperands,
     /*  33362 */   // GIR_Coverage, 2861,
     /*  33362 */   GIR_EraseRootFromParent_Done,
     /*  33363 */ // Label 733: @33363
     /*  33363 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33400), // Rule ID 2862 //
     /*  33368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33382 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33398 */   GIR_RootConstrainSelectedInstOperands,
     /*  33399 */   // GIR_Coverage, 2862,
     /*  33399 */   GIR_EraseRootFromParent_Done,
     /*  33400 */ // Label 734: @33400
     /*  33400 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33437), // Rule ID 2863 //
     /*  33405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33419 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33435 */   GIR_RootConstrainSelectedInstOperands,
     /*  33436 */   // GIR_Coverage, 2863,
     /*  33436 */   GIR_EraseRootFromParent_Done,
     /*  33437 */ // Label 735: @33437
     /*  33437 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33474), // Rule ID 2864 //
     /*  33442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33456 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33472 */   GIR_RootConstrainSelectedInstOperands,
     /*  33473 */   // GIR_Coverage, 2864,
     /*  33473 */   GIR_EraseRootFromParent_Done,
     /*  33474 */ // Label 736: @33474
     /*  33474 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33511), // Rule ID 2865 //
     /*  33479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33493 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33509 */   GIR_RootConstrainSelectedInstOperands,
     /*  33510 */   // GIR_Coverage, 2865,
     /*  33510 */   GIR_EraseRootFromParent_Done,
     /*  33511 */ // Label 737: @33511
     /*  33511 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33548), // Rule ID 2866 //
     /*  33516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33530 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33546 */   GIR_RootConstrainSelectedInstOperands,
     /*  33547 */   // GIR_Coverage, 2866,
     /*  33547 */   GIR_EraseRootFromParent_Done,
     /*  33548 */ // Label 738: @33548
     /*  33548 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33585), // Rule ID 2867 //
     /*  33553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33567 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33583 */   GIR_RootConstrainSelectedInstOperands,
     /*  33584 */   // GIR_Coverage, 2867,
     /*  33584 */   GIR_EraseRootFromParent_Done,
     /*  33585 */ // Label 739: @33585
     /*  33585 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33622), // Rule ID 2868 //
     /*  33590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33604 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33620 */   GIR_RootConstrainSelectedInstOperands,
     /*  33621 */   // GIR_Coverage, 2868,
     /*  33621 */   GIR_EraseRootFromParent_Done,
     /*  33622 */ // Label 740: @33622
     /*  33622 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33659), // Rule ID 2869 //
     /*  33627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33641 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33657 */   GIR_RootConstrainSelectedInstOperands,
     /*  33658 */   // GIR_Coverage, 2869,
     /*  33658 */   GIR_EraseRootFromParent_Done,
     /*  33659 */ // Label 741: @33659
     /*  33659 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33691), // Rule ID 5287 //
     /*  33664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33678 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33690 */   // GIR_Coverage, 5287,
     /*  33690 */   GIR_EraseRootFromParent_Done,
     /*  33691 */ // Label 742: @33691
     /*  33691 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33723), // Rule ID 5288 //
     /*  33696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33710 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33722 */   // GIR_Coverage, 5288,
     /*  33722 */   GIR_EraseRootFromParent_Done,
     /*  33723 */ // Label 743: @33723
     /*  33723 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33755), // Rule ID 5309 //
     /*  33728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33742 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33754 */   // GIR_Coverage, 5309,
     /*  33754 */   GIR_EraseRootFromParent_Done,
     /*  33755 */ // Label 744: @33755
     /*  33755 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33787), // Rule ID 5310 //
     /*  33760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33774 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33786 */   // GIR_Coverage, 5310,
     /*  33786 */   GIR_EraseRootFromParent_Done,
     /*  33787 */ // Label 745: @33787
     /*  33787 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33819), // Rule ID 5311 //
     /*  33792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33806 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33818 */   // GIR_Coverage, 5311,
     /*  33818 */   GIR_EraseRootFromParent_Done,
     /*  33819 */ // Label 746: @33819
     /*  33819 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33851), // Rule ID 5312 //
     /*  33824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33838 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33850 */   // GIR_Coverage, 5312,
     /*  33850 */   GIR_EraseRootFromParent_Done,
     /*  33851 */ // Label 747: @33851
     /*  33851 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33883), // Rule ID 5313 //
     /*  33856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33870 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33882 */   // GIR_Coverage, 5313,
     /*  33882 */   GIR_EraseRootFromParent_Done,
     /*  33883 */ // Label 748: @33883
     /*  33883 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33915), // Rule ID 5314 //
     /*  33888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33902 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33914 */   // GIR_Coverage, 5314,
     /*  33914 */   GIR_EraseRootFromParent_Done,
     /*  33915 */ // Label 749: @33915
     /*  33915 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33947), // Rule ID 5315 //
     /*  33920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33934 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33946 */   // GIR_Coverage, 5315,
     /*  33946 */   GIR_EraseRootFromParent_Done,
     /*  33947 */ // Label 750: @33947
     /*  33947 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(33979), // Rule ID 5316 //
     /*  33952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33966 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33978 */   // GIR_Coverage, 5316,
     /*  33978 */   GIR_EraseRootFromParent_Done,
     /*  33979 */ // Label 751: @33979
     /*  33979 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34011), // Rule ID 5317 //
     /*  33984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33998 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34010 */   // GIR_Coverage, 5317,
     /*  34010 */   GIR_EraseRootFromParent_Done,
     /*  34011 */ // Label 752: @34011
     /*  34011 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34043), // Rule ID 5318 //
     /*  34016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34030 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34042 */   // GIR_Coverage, 5318,
     /*  34042 */   GIR_EraseRootFromParent_Done,
     /*  34043 */ // Label 753: @34043
     /*  34043 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34101), // Rule ID 5345 //
     /*  34048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34062 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34090 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34099 */   GIR_RootConstrainSelectedInstOperands,
     /*  34100 */   // GIR_Coverage, 5345,
     /*  34100 */   GIR_EraseRootFromParent_Done,
     /*  34101 */ // Label 754: @34101
     /*  34101 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34159), // Rule ID 5346 //
     /*  34106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34120 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34148 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34157 */   GIR_RootConstrainSelectedInstOperands,
     /*  34158 */   // GIR_Coverage, 5346,
     /*  34158 */   GIR_EraseRootFromParent_Done,
     /*  34159 */ // Label 755: @34159
     /*  34159 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34217), // Rule ID 5347 //
     /*  34164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34178 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34206 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34215 */   GIR_RootConstrainSelectedInstOperands,
     /*  34216 */   // GIR_Coverage, 5347,
     /*  34216 */   GIR_EraseRootFromParent_Done,
     /*  34217 */ // Label 756: @34217
     /*  34217 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34275), // Rule ID 5348 //
     /*  34222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34236 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34273 */   GIR_RootConstrainSelectedInstOperands,
     /*  34274 */   // GIR_Coverage, 5348,
     /*  34274 */   GIR_EraseRootFromParent_Done,
     /*  34275 */ // Label 757: @34275
     /*  34275 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34333), // Rule ID 5349 //
     /*  34280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34294 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34316 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34322 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34331 */   GIR_RootConstrainSelectedInstOperands,
     /*  34332 */   // GIR_Coverage, 5349,
     /*  34332 */   GIR_EraseRootFromParent_Done,
     /*  34333 */ // Label 758: @34333
     /*  34333 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34391), // Rule ID 5350 //
     /*  34338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34352 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34380 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34389 */   GIR_RootConstrainSelectedInstOperands,
     /*  34390 */   // GIR_Coverage, 5350,
     /*  34390 */   GIR_EraseRootFromParent_Done,
     /*  34391 */ // Label 759: @34391
     /*  34391 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34449), // Rule ID 5351 //
     /*  34396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34410 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34447 */   GIR_RootConstrainSelectedInstOperands,
     /*  34448 */   // GIR_Coverage, 5351,
     /*  34448 */   GIR_EraseRootFromParent_Done,
     /*  34449 */ // Label 760: @34449
     /*  34449 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34507), // Rule ID 5352 //
     /*  34454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34468 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34505 */   GIR_RootConstrainSelectedInstOperands,
     /*  34506 */   // GIR_Coverage, 5352,
     /*  34506 */   GIR_EraseRootFromParent_Done,
     /*  34507 */ // Label 761: @34507
     /*  34507 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34565), // Rule ID 5353 //
     /*  34512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34526 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34554 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34563 */   GIR_RootConstrainSelectedInstOperands,
     /*  34564 */   // GIR_Coverage, 5353,
     /*  34564 */   GIR_EraseRootFromParent_Done,
     /*  34565 */ // Label 762: @34565
     /*  34565 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34623), // Rule ID 5354 //
     /*  34570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34584 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34621 */   GIR_RootConstrainSelectedInstOperands,
     /*  34622 */   // GIR_Coverage, 5354,
     /*  34622 */   GIR_EraseRootFromParent_Done,
     /*  34623 */ // Label 763: @34623
     /*  34623 */ GIM_Reject,
     /*  34624 */ // Label 548: @34624
     /*  34624 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34656), // Rule ID 2798 //
     /*  34629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34643 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34655 */   // GIR_Coverage, 2798,
     /*  34655 */   GIR_EraseRootFromParent_Done,
     /*  34656 */ // Label 764: @34656
     /*  34656 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34688), // Rule ID 2799 //
     /*  34661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34675 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34687 */   // GIR_Coverage, 2799,
     /*  34687 */   GIR_EraseRootFromParent_Done,
     /*  34688 */ // Label 765: @34688
     /*  34688 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34720), // Rule ID 2800 //
     /*  34693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34707 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34719 */   // GIR_Coverage, 2800,
     /*  34719 */   GIR_EraseRootFromParent_Done,
     /*  34720 */ // Label 766: @34720
     /*  34720 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34752), // Rule ID 2801 //
     /*  34725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34739 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34742 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34744 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34751 */   // GIR_Coverage, 2801,
     /*  34751 */   GIR_EraseRootFromParent_Done,
     /*  34752 */ // Label 767: @34752
     /*  34752 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34784), // Rule ID 2802 //
     /*  34757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34771 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34783 */   // GIR_Coverage, 2802,
     /*  34783 */   GIR_EraseRootFromParent_Done,
     /*  34784 */ // Label 768: @34784
     /*  34784 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34816), // Rule ID 2803 //
     /*  34789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34803 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34815 */   // GIR_Coverage, 2803,
     /*  34815 */   GIR_EraseRootFromParent_Done,
     /*  34816 */ // Label 769: @34816
     /*  34816 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34853), // Rule ID 2870 //
     /*  34821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34835 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34840 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34845 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34851 */   GIR_RootConstrainSelectedInstOperands,
     /*  34852 */   // GIR_Coverage, 2870,
     /*  34852 */   GIR_EraseRootFromParent_Done,
     /*  34853 */ // Label 770: @34853
     /*  34853 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34890), // Rule ID 2871 //
     /*  34858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34872 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34888 */   GIR_RootConstrainSelectedInstOperands,
     /*  34889 */   // GIR_Coverage, 2871,
     /*  34889 */   GIR_EraseRootFromParent_Done,
     /*  34890 */ // Label 771: @34890
     /*  34890 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34927), // Rule ID 2872 //
     /*  34895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34909 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34914 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34919 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34925 */   GIR_RootConstrainSelectedInstOperands,
     /*  34926 */   // GIR_Coverage, 2872,
     /*  34926 */   GIR_EraseRootFromParent_Done,
     /*  34927 */ // Label 772: @34927
     /*  34927 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(34964), // Rule ID 2873 //
     /*  34932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34946 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34962 */   GIR_RootConstrainSelectedInstOperands,
     /*  34963 */   // GIR_Coverage, 2873,
     /*  34963 */   GIR_EraseRootFromParent_Done,
     /*  34964 */ // Label 773: @34964
     /*  34964 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35001), // Rule ID 2874 //
     /*  34969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34983 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34999 */   GIR_RootConstrainSelectedInstOperands,
     /*  35000 */   // GIR_Coverage, 2874,
     /*  35000 */   GIR_EraseRootFromParent_Done,
     /*  35001 */ // Label 774: @35001
     /*  35001 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35038), // Rule ID 2875 //
     /*  35006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  35009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35020 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35030 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35036 */   GIR_RootConstrainSelectedInstOperands,
     /*  35037 */   // GIR_Coverage, 2875,
     /*  35037 */   GIR_EraseRootFromParent_Done,
     /*  35038 */ // Label 775: @35038
     /*  35038 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35070), // Rule ID 5319 //
     /*  35043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35057 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35069 */   // GIR_Coverage, 5319,
     /*  35069 */   GIR_EraseRootFromParent_Done,
     /*  35070 */ // Label 776: @35070
     /*  35070 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35102), // Rule ID 5320 //
     /*  35075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35089 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35101 */   // GIR_Coverage, 5320,
     /*  35101 */   GIR_EraseRootFromParent_Done,
     /*  35102 */ // Label 777: @35102
     /*  35102 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35134), // Rule ID 5321 //
     /*  35107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35121 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35133 */   // GIR_Coverage, 5321,
     /*  35133 */   GIR_EraseRootFromParent_Done,
     /*  35134 */ // Label 778: @35134
     /*  35134 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35166), // Rule ID 5322 //
     /*  35139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35153 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35165 */   // GIR_Coverage, 5322,
     /*  35165 */   GIR_EraseRootFromParent_Done,
     /*  35166 */ // Label 779: @35166
     /*  35166 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35198), // Rule ID 5323 //
     /*  35171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35185 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35197 */   // GIR_Coverage, 5323,
     /*  35197 */   GIR_EraseRootFromParent_Done,
     /*  35198 */ // Label 780: @35198
     /*  35198 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35230), // Rule ID 5324 //
     /*  35203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35217 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35229 */   // GIR_Coverage, 5324,
     /*  35229 */   GIR_EraseRootFromParent_Done,
     /*  35230 */ // Label 781: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35288), // Rule ID 5355 //
     /*  35235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35249 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35271 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35277 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35286 */   GIR_RootConstrainSelectedInstOperands,
     /*  35287 */   // GIR_Coverage, 5355,
     /*  35287 */   GIR_EraseRootFromParent_Done,
     /*  35288 */ // Label 782: @35288
     /*  35288 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35346), // Rule ID 5356 //
     /*  35293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35307 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35335 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35344 */   GIR_RootConstrainSelectedInstOperands,
     /*  35345 */   // GIR_Coverage, 5356,
     /*  35345 */   GIR_EraseRootFromParent_Done,
     /*  35346 */ // Label 783: @35346
     /*  35346 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35404), // Rule ID 5357 //
     /*  35351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35365 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35393 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35402 */   GIR_RootConstrainSelectedInstOperands,
     /*  35403 */   // GIR_Coverage, 5357,
     /*  35403 */   GIR_EraseRootFromParent_Done,
     /*  35404 */ // Label 784: @35404
     /*  35404 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35462), // Rule ID 5358 //
     /*  35409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35423 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35460 */   GIR_RootConstrainSelectedInstOperands,
     /*  35461 */   // GIR_Coverage, 5358,
     /*  35461 */   GIR_EraseRootFromParent_Done,
     /*  35462 */ // Label 785: @35462
     /*  35462 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35520), // Rule ID 5359 //
     /*  35467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35481 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35518 */   GIR_RootConstrainSelectedInstOperands,
     /*  35519 */   // GIR_Coverage, 5359,
     /*  35519 */   GIR_EraseRootFromParent_Done,
     /*  35520 */ // Label 786: @35520
     /*  35520 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(35578), // Rule ID 5360 //
     /*  35525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35539 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35576 */   GIR_RootConstrainSelectedInstOperands,
     /*  35577 */   // GIR_Coverage, 5360,
     /*  35577 */   GIR_EraseRootFromParent_Done,
     /*  35578 */ // Label 787: @35578
     /*  35578 */ GIM_Reject,
     /*  35579 */ // Label 549: @35579
     /*  35579 */ GIM_Reject,
     /*  35580 */ // Label 10: @35580
     /*  35580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 793*/ GIMT_Encode4(35875),
     /*  35591 */ /*GILLT_s16*//*Label 788*/ GIMT_Encode4(35643),
     /*  35595 */ /*GILLT_s32*//*Label 789*/ GIMT_Encode4(35681),
     /*  35599 */ /*GILLT_s64*//*Label 790*/ GIMT_Encode4(35719), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35623 */ /*GILLT_v4s32*//*Label 791*/ GIMT_Encode4(35757), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35639 */ /*GILLT_v8s16*//*Label 792*/ GIMT_Encode4(35816),
     /*  35643 */ // Label 788: @35643
     /*  35643 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(35680), // Rule ID 665 //
     /*  35648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35662 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35678 */   GIR_RootConstrainSelectedInstOperands,
     /*  35679 */   // GIR_Coverage, 665,
     /*  35679 */   GIR_EraseRootFromParent_Done,
     /*  35680 */ // Label 794: @35680
     /*  35680 */ GIM_Reject,
     /*  35681 */ // Label 789: @35681
     /*  35681 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(35718), // Rule ID 666 //
     /*  35686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35700 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35716 */   GIR_RootConstrainSelectedInstOperands,
     /*  35717 */   // GIR_Coverage, 666,
     /*  35717 */   GIR_EraseRootFromParent_Done,
     /*  35718 */ // Label 795: @35718
     /*  35718 */ GIM_Reject,
     /*  35719 */ // Label 790: @35719
     /*  35719 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35756), // Rule ID 667 //
     /*  35724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35738 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35743 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35754 */   GIR_RootConstrainSelectedInstOperands,
     /*  35755 */   // GIR_Coverage, 667,
     /*  35755 */   GIR_EraseRootFromParent_Done,
     /*  35756 */ // Label 796: @35756
     /*  35756 */ GIM_Reject,
     /*  35757 */ // Label 791: @35757
     /*  35757 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35815), // Rule ID 3982 //
     /*  35762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35776 */   // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35793 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35798 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35804 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35813 */   GIR_RootConstrainSelectedInstOperands,
     /*  35814 */   // GIR_Coverage, 3982,
     /*  35814 */   GIR_EraseRootFromParent_Done,
     /*  35815 */ // Label 797: @35815
     /*  35815 */ GIM_Reject,
     /*  35816 */ // Label 792: @35816
     /*  35816 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(35874), // Rule ID 3970 //
     /*  35821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35835 */   // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35852 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35857 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35863 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35872 */   GIR_RootConstrainSelectedInstOperands,
     /*  35873 */   // GIR_Coverage, 3970,
     /*  35873 */   GIR_EraseRootFromParent_Done,
     /*  35874 */ // Label 798: @35874
     /*  35874 */ GIM_Reject,
     /*  35875 */ // Label 793: @35875
     /*  35875 */ GIM_Reject,
     /*  35876 */ // Label 11: @35876
     /*  35876 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 804*/ GIMT_Encode4(36138),
     /*  35887 */ /*GILLT_s16*//*Label 799*/ GIMT_Encode4(35939),
     /*  35891 */ /*GILLT_s32*//*Label 800*/ GIMT_Encode4(35966),
     /*  35895 */ /*GILLT_s64*//*Label 801*/ GIMT_Encode4(35993), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35919 */ /*GILLT_v4s32*//*Label 802*/ GIMT_Encode4(36020), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35935 */ /*GILLT_v8s16*//*Label 803*/ GIMT_Encode4(36079),
     /*  35939 */ // Label 799: @35939
     /*  35939 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(35965), // Rule ID 674 //
     /*  35944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35958 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  35963 */   GIR_RootConstrainSelectedInstOperands,
     /*  35964 */   // GIR_Coverage, 674,
     /*  35964 */   GIR_Done,
     /*  35965 */ // Label 805: @35965
     /*  35965 */ GIM_Reject,
     /*  35966 */ // Label 800: @35966
     /*  35966 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(35992), // Rule ID 675 //
     /*  35971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35985 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  35990 */   GIR_RootConstrainSelectedInstOperands,
     /*  35991 */   // GIR_Coverage, 675,
     /*  35991 */   GIR_Done,
     /*  35992 */ // Label 806: @35992
     /*  35992 */ GIM_Reject,
     /*  35993 */ // Label 801: @35993
     /*  35993 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(36019), // Rule ID 676 //
     /*  35998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36012 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36017 */   GIR_RootConstrainSelectedInstOperands,
     /*  36018 */   // GIR_Coverage, 676,
     /*  36018 */   GIR_Done,
     /*  36019 */ // Label 807: @36019
     /*  36019 */ GIM_Reject,
     /*  36020 */ // Label 802: @36020
     /*  36020 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(36078), // Rule ID 3980 //
     /*  36025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36039 */   // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36056 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36061 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36067 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36076 */   GIR_RootConstrainSelectedInstOperands,
     /*  36077 */   // GIR_Coverage, 3980,
     /*  36077 */   GIR_EraseRootFromParent_Done,
     /*  36078 */ // Label 808: @36078
     /*  36078 */ GIM_Reject,
     /*  36079 */ // Label 803: @36079
     /*  36079 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(36137), // Rule ID 3968 //
     /*  36084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36098 */   // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36115 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36120 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36126 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36135 */   GIR_RootConstrainSelectedInstOperands,
     /*  36136 */   // GIR_Coverage, 3968,
     /*  36136 */   GIR_EraseRootFromParent_Done,
     /*  36137 */ // Label 809: @36137
     /*  36137 */ GIM_Reject,
     /*  36138 */ // Label 804: @36138
     /*  36138 */ GIM_Reject,
     /*  36139 */ // Label 12: @36139
     /*  36139 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 815*/ GIMT_Encode4(36401),
     /*  36150 */ /*GILLT_s16*//*Label 810*/ GIMT_Encode4(36202),
     /*  36154 */ /*GILLT_s32*//*Label 811*/ GIMT_Encode4(36229),
     /*  36158 */ /*GILLT_s64*//*Label 812*/ GIMT_Encode4(36256), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36182 */ /*GILLT_v4s32*//*Label 813*/ GIMT_Encode4(36283), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36198 */ /*GILLT_v8s16*//*Label 814*/ GIMT_Encode4(36342),
     /*  36202 */ // Label 810: @36202
     /*  36202 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36228), // Rule ID 678 //
     /*  36207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36221 */   // (froundeven:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36226 */   GIR_RootConstrainSelectedInstOperands,
     /*  36227 */   // GIR_Coverage, 678,
     /*  36227 */   GIR_Done,
     /*  36228 */ // Label 816: @36228
     /*  36228 */ GIM_Reject,
     /*  36229 */ // Label 811: @36229
     /*  36229 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36255), // Rule ID 680 //
     /*  36234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36248 */   // (froundeven:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36253 */   GIR_RootConstrainSelectedInstOperands,
     /*  36254 */   // GIR_Coverage, 680,
     /*  36254 */   GIR_Done,
     /*  36255 */ // Label 817: @36255
     /*  36255 */ GIM_Reject,
     /*  36256 */ // Label 812: @36256
     /*  36256 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(36282), // Rule ID 682 //
     /*  36261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36275 */   // (froundeven:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36280 */   GIR_RootConstrainSelectedInstOperands,
     /*  36281 */   // GIR_Coverage, 682,
     /*  36281 */   GIR_Done,
     /*  36282 */ // Label 818: @36282
     /*  36282 */ GIM_Reject,
     /*  36283 */ // Label 813: @36283
     /*  36283 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(36341), // Rule ID 3976 //
     /*  36288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36302 */   // (froundeven:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  36317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36319 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36324 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36330 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36336 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36339 */   GIR_RootConstrainSelectedInstOperands,
     /*  36340 */   // GIR_Coverage, 3976,
     /*  36340 */   GIR_EraseRootFromParent_Done,
     /*  36341 */ // Label 819: @36341
     /*  36341 */ GIM_Reject,
     /*  36342 */ // Label 814: @36342
     /*  36342 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(36400), // Rule ID 3964 //
     /*  36347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36361 */   // (froundeven:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  36376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36378 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36383 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36389 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36398 */   GIR_RootConstrainSelectedInstOperands,
     /*  36399 */   // GIR_Coverage, 3964,
     /*  36399 */   GIR_EraseRootFromParent_Done,
     /*  36400 */ // Label 820: @36400
     /*  36400 */ GIM_Reject,
     /*  36401 */ // Label 815: @36401
     /*  36401 */ GIM_Reject,
     /*  36402 */ // Label 13: @36402
     /*  36402 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(36564),
     /*  36407 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36410 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36413 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(36488), // Rule ID 2053 //
     /*  36418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36432 */     // MIs[0] Rn
     /*  36432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36440 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36452 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36458 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36464 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36486 */     GIR_RootConstrainSelectedInstOperands,
     /*  36487 */     // GIR_Coverage, 2053,
     /*  36487 */     GIR_EraseRootFromParent_Done,
     /*  36488 */   // Label 822: @36488
     /*  36488 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(36563), // Rule ID 2054 //
     /*  36493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36496 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36507 */     // MIs[0] Rn
     /*  36507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36515 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36527 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36539 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36561 */     GIR_RootConstrainSelectedInstOperands,
     /*  36562 */     // GIR_Coverage, 2054,
     /*  36562 */     GIR_EraseRootFromParent_Done,
     /*  36563 */   // Label 823: @36563
     /*  36563 */   GIM_Reject,
     /*  36564 */ // Label 821: @36564
     /*  36564 */ GIM_Reject,
     /*  36565 */ // Label 14: @36565
     /*  36565 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36585), // Rule ID 5421 //
     /*  36570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36573 */   // MIs[0] Operand 0
     /*  36573 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36576 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36580 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36583 */   GIR_RootConstrainSelectedInstOperands,
     /*  36584 */   // GIR_Coverage, 5421,
     /*  36584 */   GIR_EraseRootFromParent_Done,
     /*  36585 */ // Label 824: @36585
     /*  36585 */ GIM_Reject,
     /*  36586 */ // Label 15: @36586
     /*  36586 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(42269),
     /*  36591 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36594 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(36642), // Rule ID 1856 //
     /*  36599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36621 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36640 */     GIR_RootConstrainSelectedInstOperands,
     /*  36641 */     // GIR_Coverage, 1856,
     /*  36641 */     GIR_EraseRootFromParent_Done,
     /*  36642 */   // Label 826: @36642
     /*  36642 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(36690), // Rule ID 2110 //
     /*  36647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36669 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  36669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  36672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  36676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36688 */     GIR_RootConstrainSelectedInstOperands,
     /*  36689 */     // GIR_Coverage, 2110,
     /*  36689 */     GIR_EraseRootFromParent_Done,
     /*  36690 */   // Label 827: @36690
     /*  36690 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(36726), // Rule ID 677 //
     /*  36695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  36706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  36709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36717 */     // (intrinsic_wo_chain:{ *:[f16] } 3824:{ *:[iPTR] }, HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36724 */     GIR_RootConstrainSelectedInstOperands,
     /*  36725 */     // GIR_Coverage, 677,
     /*  36725 */     GIR_EraseRootFromParent_Done,
     /*  36726 */   // Label 828: @36726
     /*  36726 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(36762), // Rule ID 679 //
     /*  36731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36753 */     // (intrinsic_wo_chain:{ *:[f32] } 3824:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36760 */     GIR_RootConstrainSelectedInstOperands,
     /*  36761 */     // GIR_Coverage, 679,
     /*  36761 */     GIR_EraseRootFromParent_Done,
     /*  36762 */   // Label 829: @36762
     /*  36762 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(36798), // Rule ID 681 //
     /*  36767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36789 */     // (intrinsic_wo_chain:{ *:[f64] } 3824:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  36794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36796 */     GIR_RootConstrainSelectedInstOperands,
     /*  36797 */     // GIR_Coverage, 681,
     /*  36797 */     GIR_EraseRootFromParent_Done,
     /*  36798 */   // Label 830: @36798
     /*  36798 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(36843), // Rule ID 696 //
     /*  36803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36825 */     // (intrinsic_wo_chain:{ *:[f32] } 3939:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  36828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36841 */     GIR_RootConstrainSelectedInstOperands,
     /*  36842 */     // GIR_Coverage, 696,
     /*  36842 */     GIR_EraseRootFromParent_Done,
     /*  36843 */   // Label 831: @36843
     /*  36843 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(36888), // Rule ID 697 //
     /*  36848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36870 */     // (intrinsic_wo_chain:{ *:[f32] } 3939:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  36873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36886 */     GIR_RootConstrainSelectedInstOperands,
     /*  36887 */     // GIR_Coverage, 697,
     /*  36887 */     GIR_EraseRootFromParent_Done,
     /*  36888 */   // Label 832: @36888
     /*  36888 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(36933), // Rule ID 698 //
     /*  36893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36915 */     // (intrinsic_wo_chain:{ *:[f32] } 3940:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  36918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36931 */     GIR_RootConstrainSelectedInstOperands,
     /*  36932 */     // GIR_Coverage, 698,
     /*  36932 */     GIR_EraseRootFromParent_Done,
     /*  36933 */   // Label 833: @36933
     /*  36933 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(36978), // Rule ID 699 //
     /*  36938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36960 */     // (intrinsic_wo_chain:{ *:[f32] } 3940:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  36963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36976 */     GIR_RootConstrainSelectedInstOperands,
     /*  36977 */     // GIR_Coverage, 699,
     /*  36977 */     GIR_EraseRootFromParent_Done,
     /*  36978 */   // Label 834: @36978
     /*  36978 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(37023), // Rule ID 1242 //
     /*  36983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  36994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  36997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37005 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3790:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  37008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37021 */     GIR_RootConstrainSelectedInstOperands,
     /*  37022 */     // GIR_Coverage, 1242,
     /*  37022 */     GIR_EraseRootFromParent_Done,
     /*  37023 */   // Label 835: @37023
     /*  37023 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(37068), // Rule ID 1243 //
     /*  37028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37050 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3790:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  37053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37066 */     GIR_RootConstrainSelectedInstOperands,
     /*  37067 */     // GIR_Coverage, 1243,
     /*  37067 */     GIR_EraseRootFromParent_Done,
     /*  37068 */   // Label 836: @37068
     /*  37068 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(37113), // Rule ID 1244 //
     /*  37073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37095 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3790:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  37098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37111 */     GIR_RootConstrainSelectedInstOperands,
     /*  37112 */     // GIR_Coverage, 1244,
     /*  37112 */     GIR_EraseRootFromParent_Done,
     /*  37113 */   // Label 837: @37113
     /*  37113 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(37158), // Rule ID 1245 //
     /*  37118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37140 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3790:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  37143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37156 */     GIR_RootConstrainSelectedInstOperands,
     /*  37157 */     // GIR_Coverage, 1245,
     /*  37157 */     GIR_EraseRootFromParent_Done,
     /*  37158 */   // Label 838: @37158
     /*  37158 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(37203), // Rule ID 1246 //
     /*  37163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37185 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3790:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  37188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37201 */     GIR_RootConstrainSelectedInstOperands,
     /*  37202 */     // GIR_Coverage, 1246,
     /*  37202 */     GIR_EraseRootFromParent_Done,
     /*  37203 */   // Label 839: @37203
     /*  37203 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(37248), // Rule ID 1247 //
     /*  37208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37230 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3790:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  37233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37246 */     GIR_RootConstrainSelectedInstOperands,
     /*  37247 */     // GIR_Coverage, 1247,
     /*  37247 */     GIR_EraseRootFromParent_Done,
     /*  37248 */   // Label 840: @37248
     /*  37248 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(37293), // Rule ID 1248 //
     /*  37253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37275 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3791:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  37278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37291 */     GIR_RootConstrainSelectedInstOperands,
     /*  37292 */     // GIR_Coverage, 1248,
     /*  37292 */     GIR_EraseRootFromParent_Done,
     /*  37293 */   // Label 841: @37293
     /*  37293 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(37338), // Rule ID 1249 //
     /*  37298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37320 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3791:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37336 */     GIR_RootConstrainSelectedInstOperands,
     /*  37337 */     // GIR_Coverage, 1249,
     /*  37337 */     GIR_EraseRootFromParent_Done,
     /*  37338 */   // Label 842: @37338
     /*  37338 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(37383), // Rule ID 1250 //
     /*  37343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37365 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3791:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37381 */     GIR_RootConstrainSelectedInstOperands,
     /*  37382 */     // GIR_Coverage, 1250,
     /*  37382 */     GIR_EraseRootFromParent_Done,
     /*  37383 */   // Label 843: @37383
     /*  37383 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(37428), // Rule ID 1251 //
     /*  37388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37410 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3791:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37426 */     GIR_RootConstrainSelectedInstOperands,
     /*  37427 */     // GIR_Coverage, 1251,
     /*  37427 */     GIR_EraseRootFromParent_Done,
     /*  37428 */   // Label 844: @37428
     /*  37428 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(37473), // Rule ID 1252 //
     /*  37433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37455 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3791:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37471 */     GIR_RootConstrainSelectedInstOperands,
     /*  37472 */     // GIR_Coverage, 1252,
     /*  37472 */     GIR_EraseRootFromParent_Done,
     /*  37473 */   // Label 845: @37473
     /*  37473 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(37518), // Rule ID 1253 //
     /*  37478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37500 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3791:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37516 */     GIR_RootConstrainSelectedInstOperands,
     /*  37517 */     // GIR_Coverage, 1253,
     /*  37517 */     GIR_EraseRootFromParent_Done,
     /*  37518 */   // Label 846: @37518
     /*  37518 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(37563), // Rule ID 1282 //
     /*  37523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37545 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3818:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37561 */     GIR_RootConstrainSelectedInstOperands,
     /*  37562 */     // GIR_Coverage, 1282,
     /*  37562 */     GIR_EraseRootFromParent_Done,
     /*  37563 */   // Label 847: @37563
     /*  37563 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(37608), // Rule ID 1283 //
     /*  37568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37590 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3818:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37606 */     GIR_RootConstrainSelectedInstOperands,
     /*  37607 */     // GIR_Coverage, 1283,
     /*  37607 */     GIR_EraseRootFromParent_Done,
     /*  37608 */   // Label 848: @37608
     /*  37608 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(37653), // Rule ID 1284 //
     /*  37613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37635 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3818:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37651 */     GIR_RootConstrainSelectedInstOperands,
     /*  37652 */     // GIR_Coverage, 1284,
     /*  37652 */     GIR_EraseRootFromParent_Done,
     /*  37653 */   // Label 849: @37653
     /*  37653 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(37698), // Rule ID 1285 //
     /*  37658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37680 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3818:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37696 */     GIR_RootConstrainSelectedInstOperands,
     /*  37697 */     // GIR_Coverage, 1285,
     /*  37697 */     GIR_EraseRootFromParent_Done,
     /*  37698 */   // Label 850: @37698
     /*  37698 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(37743), // Rule ID 1286 //
     /*  37703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37725 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3818:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37741 */     GIR_RootConstrainSelectedInstOperands,
     /*  37742 */     // GIR_Coverage, 1286,
     /*  37742 */     GIR_EraseRootFromParent_Done,
     /*  37743 */   // Label 851: @37743
     /*  37743 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(37788), // Rule ID 1287 //
     /*  37748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37770 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3818:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  37773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37786 */     GIR_RootConstrainSelectedInstOperands,
     /*  37787 */     // GIR_Coverage, 1287,
     /*  37787 */     GIR_EraseRootFromParent_Done,
     /*  37788 */   // Label 852: @37788
     /*  37788 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(37833), // Rule ID 1292 //
     /*  37793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37815 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3831:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  37818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37831 */     GIR_RootConstrainSelectedInstOperands,
     /*  37832 */     // GIR_Coverage, 1292,
     /*  37832 */     GIR_EraseRootFromParent_Done,
     /*  37833 */   // Label 853: @37833
     /*  37833 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(37878), // Rule ID 1293 //
     /*  37838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37860 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3831:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  37863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37876 */     GIR_RootConstrainSelectedInstOperands,
     /*  37877 */     // GIR_Coverage, 1293,
     /*  37877 */     GIR_EraseRootFromParent_Done,
     /*  37878 */   // Label 854: @37878
     /*  37878 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(37923), // Rule ID 1294 //
     /*  37883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37905 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3831:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  37908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37921 */     GIR_RootConstrainSelectedInstOperands,
     /*  37922 */     // GIR_Coverage, 1294,
     /*  37922 */     GIR_EraseRootFromParent_Done,
     /*  37923 */   // Label 855: @37923
     /*  37923 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(37968), // Rule ID 1295 //
     /*  37928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37950 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3831:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  37953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37966 */     GIR_RootConstrainSelectedInstOperands,
     /*  37967 */     // GIR_Coverage, 1295,
     /*  37967 */     GIR_EraseRootFromParent_Done,
     /*  37968 */   // Label 856: @37968
     /*  37968 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(38013), // Rule ID 1296 //
     /*  37973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37995 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3831:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  37998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38011 */     GIR_RootConstrainSelectedInstOperands,
     /*  38012 */     // GIR_Coverage, 1296,
     /*  38012 */     GIR_EraseRootFromParent_Done,
     /*  38013 */   // Label 857: @38013
     /*  38013 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(38058), // Rule ID 1297 //
     /*  38018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38040 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3831:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  38040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  38043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38056 */     GIR_RootConstrainSelectedInstOperands,
     /*  38057 */     // GIR_Coverage, 1297,
     /*  38057 */     GIR_EraseRootFromParent_Done,
     /*  38058 */   // Label 858: @38058
     /*  38058 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(38103), // Rule ID 1518 //
     /*  38063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38085 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3796:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  38088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38101 */     GIR_RootConstrainSelectedInstOperands,
     /*  38102 */     // GIR_Coverage, 1518,
     /*  38102 */     GIR_EraseRootFromParent_Done,
     /*  38103 */   // Label 859: @38103
     /*  38103 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(38148), // Rule ID 1519 //
     /*  38108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38130 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3796:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  38133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38146 */     GIR_RootConstrainSelectedInstOperands,
     /*  38147 */     // GIR_Coverage, 1519,
     /*  38147 */     GIR_EraseRootFromParent_Done,
     /*  38148 */   // Label 860: @38148
     /*  38148 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(38193), // Rule ID 1520 //
     /*  38153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38175 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3796:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  38178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38191 */     GIR_RootConstrainSelectedInstOperands,
     /*  38192 */     // GIR_Coverage, 1520,
     /*  38192 */     GIR_EraseRootFromParent_Done,
     /*  38193 */   // Label 861: @38193
     /*  38193 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(38238), // Rule ID 1521 //
     /*  38198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38220 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3796:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  38223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38236 */     GIR_RootConstrainSelectedInstOperands,
     /*  38237 */     // GIR_Coverage, 1521,
     /*  38237 */     GIR_EraseRootFromParent_Done,
     /*  38238 */   // Label 862: @38238
     /*  38238 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(38283), // Rule ID 1522 //
     /*  38243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38265 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3796:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  38268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38281 */     GIR_RootConstrainSelectedInstOperands,
     /*  38282 */     // GIR_Coverage, 1522,
     /*  38282 */     GIR_EraseRootFromParent_Done,
     /*  38283 */   // Label 863: @38283
     /*  38283 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(38328), // Rule ID 1523 //
     /*  38288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38310 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3796:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38326 */     GIR_RootConstrainSelectedInstOperands,
     /*  38327 */     // GIR_Coverage, 1523,
     /*  38327 */     GIR_EraseRootFromParent_Done,
     /*  38328 */   // Label 864: @38328
     /*  38328 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(38373), // Rule ID 1534 //
     /*  38333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38355 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3802:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38371 */     GIR_RootConstrainSelectedInstOperands,
     /*  38372 */     // GIR_Coverage, 1534,
     /*  38372 */     GIR_EraseRootFromParent_Done,
     /*  38373 */   // Label 865: @38373
     /*  38373 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(38418), // Rule ID 1535 //
     /*  38378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38400 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3802:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38416 */     GIR_RootConstrainSelectedInstOperands,
     /*  38417 */     // GIR_Coverage, 1535,
     /*  38417 */     GIR_EraseRootFromParent_Done,
     /*  38418 */   // Label 866: @38418
     /*  38418 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(38463), // Rule ID 1536 //
     /*  38423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38445 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3802:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38461 */     GIR_RootConstrainSelectedInstOperands,
     /*  38462 */     // GIR_Coverage, 1536,
     /*  38462 */     GIR_EraseRootFromParent_Done,
     /*  38463 */   // Label 867: @38463
     /*  38463 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(38508), // Rule ID 1537 //
     /*  38468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38490 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3802:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38506 */     GIR_RootConstrainSelectedInstOperands,
     /*  38507 */     // GIR_Coverage, 1537,
     /*  38507 */     GIR_EraseRootFromParent_Done,
     /*  38508 */   // Label 868: @38508
     /*  38508 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(38553), // Rule ID 1538 //
     /*  38513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38535 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3802:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38551 */     GIR_RootConstrainSelectedInstOperands,
     /*  38552 */     // GIR_Coverage, 1538,
     /*  38552 */     GIR_EraseRootFromParent_Done,
     /*  38553 */   // Label 869: @38553
     /*  38553 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(38598), // Rule ID 1539 //
     /*  38558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38580 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3802:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38596 */     GIR_RootConstrainSelectedInstOperands,
     /*  38597 */     // GIR_Coverage, 1539,
     /*  38597 */     GIR_EraseRootFromParent_Done,
     /*  38598 */   // Label 870: @38598
     /*  38598 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(38643), // Rule ID 1540 //
     /*  38603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38625 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3743:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38641 */     GIR_RootConstrainSelectedInstOperands,
     /*  38642 */     // GIR_Coverage, 1540,
     /*  38642 */     GIR_EraseRootFromParent_Done,
     /*  38643 */   // Label 871: @38643
     /*  38643 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(38688), // Rule ID 1541 //
     /*  38648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38670 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3743:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38686 */     GIR_RootConstrainSelectedInstOperands,
     /*  38687 */     // GIR_Coverage, 1541,
     /*  38687 */     GIR_EraseRootFromParent_Done,
     /*  38688 */   // Label 872: @38688
     /*  38688 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(38733), // Rule ID 1542 //
     /*  38693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38715 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3743:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38731 */     GIR_RootConstrainSelectedInstOperands,
     /*  38732 */     // GIR_Coverage, 1542,
     /*  38732 */     GIR_EraseRootFromParent_Done,
     /*  38733 */   // Label 873: @38733
     /*  38733 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(38778), // Rule ID 1543 //
     /*  38738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38760 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3743:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  38763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38776 */     GIR_RootConstrainSelectedInstOperands,
     /*  38777 */     // GIR_Coverage, 1543,
     /*  38777 */     GIR_EraseRootFromParent_Done,
     /*  38778 */   // Label 874: @38778
     /*  38778 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(38823), // Rule ID 1544 //
     /*  38783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38805 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3743:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  38808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38821 */     GIR_RootConstrainSelectedInstOperands,
     /*  38822 */     // GIR_Coverage, 1544,
     /*  38822 */     GIR_EraseRootFromParent_Done,
     /*  38823 */   // Label 875: @38823
     /*  38823 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(38868), // Rule ID 1545 //
     /*  38828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38850 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3743:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  38853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38866 */     GIR_RootConstrainSelectedInstOperands,
     /*  38867 */     // GIR_Coverage, 1545,
     /*  38867 */     GIR_EraseRootFromParent_Done,
     /*  38868 */   // Label 876: @38868
     /*  38868 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(38913), // Rule ID 1589 //
     /*  38873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38895 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3799:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  38898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38911 */     GIR_RootConstrainSelectedInstOperands,
     /*  38912 */     // GIR_Coverage, 1589,
     /*  38912 */     GIR_EraseRootFromParent_Done,
     /*  38913 */   // Label 877: @38913
     /*  38913 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(38958), // Rule ID 1590 //
     /*  38918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38940 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3799:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  38943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38956 */     GIR_RootConstrainSelectedInstOperands,
     /*  38957 */     // GIR_Coverage, 1590,
     /*  38957 */     GIR_EraseRootFromParent_Done,
     /*  38958 */   // Label 878: @38958
     /*  38958 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(39003), // Rule ID 1591 //
     /*  38963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38985 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3799:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  38988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39001 */     GIR_RootConstrainSelectedInstOperands,
     /*  39002 */     // GIR_Coverage, 1591,
     /*  39002 */     GIR_EraseRootFromParent_Done,
     /*  39003 */   // Label 879: @39003
     /*  39003 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(39048), // Rule ID 1592 //
     /*  39008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39030 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3801:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  39033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39046 */     GIR_RootConstrainSelectedInstOperands,
     /*  39047 */     // GIR_Coverage, 1592,
     /*  39047 */     GIR_EraseRootFromParent_Done,
     /*  39048 */   // Label 880: @39048
     /*  39048 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(39093), // Rule ID 1593 //
     /*  39053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39075 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3801:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  39078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39091 */     GIR_RootConstrainSelectedInstOperands,
     /*  39092 */     // GIR_Coverage, 1593,
     /*  39092 */     GIR_EraseRootFromParent_Done,
     /*  39093 */   // Label 881: @39093
     /*  39093 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(39138), // Rule ID 1594 //
     /*  39098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39120 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3801:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  39123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39136 */     GIR_RootConstrainSelectedInstOperands,
     /*  39137 */     // GIR_Coverage, 1594,
     /*  39137 */     GIR_EraseRootFromParent_Done,
     /*  39138 */   // Label 882: @39138
     /*  39138 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(39183), // Rule ID 1595 //
     /*  39143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39165 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3800:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  39168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39181 */     GIR_RootConstrainSelectedInstOperands,
     /*  39182 */     // GIR_Coverage, 1595,
     /*  39182 */     GIR_EraseRootFromParent_Done,
     /*  39183 */   // Label 883: @39183
     /*  39183 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(39228), // Rule ID 1596 //
     /*  39188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39210 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3800:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  39213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39226 */     GIR_RootConstrainSelectedInstOperands,
     /*  39227 */     // GIR_Coverage, 1596,
     /*  39227 */     GIR_EraseRootFromParent_Done,
     /*  39228 */   // Label 884: @39228
     /*  39228 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(39273), // Rule ID 1597 //
     /*  39233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39255 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3800:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  39258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39271 */     GIR_RootConstrainSelectedInstOperands,
     /*  39272 */     // GIR_Coverage, 1597,
     /*  39272 */     GIR_EraseRootFromParent_Done,
     /*  39273 */   // Label 885: @39273
     /*  39273 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(39309), // Rule ID 1620 //
     /*  39278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39300 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3744:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39307 */     GIR_RootConstrainSelectedInstOperands,
     /*  39308 */     // GIR_Coverage, 1620,
     /*  39308 */     GIR_EraseRootFromParent_Done,
     /*  39309 */   // Label 886: @39309
     /*  39309 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(39345), // Rule ID 1621 //
     /*  39314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39336 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3744:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39343 */     GIR_RootConstrainSelectedInstOperands,
     /*  39344 */     // GIR_Coverage, 1621,
     /*  39344 */     GIR_EraseRootFromParent_Done,
     /*  39345 */   // Label 887: @39345
     /*  39345 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(39381), // Rule ID 1622 //
     /*  39350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39372 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3745:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39379 */     GIR_RootConstrainSelectedInstOperands,
     /*  39380 */     // GIR_Coverage, 1622,
     /*  39380 */     GIR_EraseRootFromParent_Done,
     /*  39381 */   // Label 888: @39381
     /*  39381 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(39417), // Rule ID 1623 //
     /*  39386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39408 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3745:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39415 */     GIR_RootConstrainSelectedInstOperands,
     /*  39416 */     // GIR_Coverage, 1623,
     /*  39416 */     GIR_EraseRootFromParent_Done,
     /*  39417 */   // Label 889: @39417
     /*  39417 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(39453), // Rule ID 1624 //
     /*  39422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39444 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3744:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39451 */     GIR_RootConstrainSelectedInstOperands,
     /*  39452 */     // GIR_Coverage, 1624,
     /*  39452 */     GIR_EraseRootFromParent_Done,
     /*  39453 */   // Label 890: @39453
     /*  39453 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(39489), // Rule ID 1625 //
     /*  39458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39480 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3744:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39487 */     GIR_RootConstrainSelectedInstOperands,
     /*  39488 */     // GIR_Coverage, 1625,
     /*  39488 */     GIR_EraseRootFromParent_Done,
     /*  39489 */   // Label 891: @39489
     /*  39489 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(39525), // Rule ID 1626 //
     /*  39494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3745:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39523 */     GIR_RootConstrainSelectedInstOperands,
     /*  39524 */     // GIR_Coverage, 1626,
     /*  39524 */     GIR_EraseRootFromParent_Done,
     /*  39525 */   // Label 892: @39525
     /*  39525 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(39561), // Rule ID 1627 //
     /*  39530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39552 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3745:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39559 */     GIR_RootConstrainSelectedInstOperands,
     /*  39560 */     // GIR_Coverage, 1627,
     /*  39560 */     GIR_EraseRootFromParent_Done,
     /*  39561 */   // Label 893: @39561
     /*  39561 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(39597), // Rule ID 1628 //
     /*  39566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39588 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3756:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39595 */     GIR_RootConstrainSelectedInstOperands,
     /*  39596 */     // GIR_Coverage, 1628,
     /*  39596 */     GIR_EraseRootFromParent_Done,
     /*  39597 */   // Label 894: @39597
     /*  39597 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39633), // Rule ID 1629 //
     /*  39602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3756:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39631 */     GIR_RootConstrainSelectedInstOperands,
     /*  39632 */     // GIR_Coverage, 1629,
     /*  39632 */     GIR_EraseRootFromParent_Done,
     /*  39633 */   // Label 895: @39633
     /*  39633 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39669), // Rule ID 1630 //
     /*  39638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39660 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3757:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39667 */     GIR_RootConstrainSelectedInstOperands,
     /*  39668 */     // GIR_Coverage, 1630,
     /*  39668 */     GIR_EraseRootFromParent_Done,
     /*  39669 */   // Label 896: @39669
     /*  39669 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39705), // Rule ID 1631 //
     /*  39674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39696 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3757:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39703 */     GIR_RootConstrainSelectedInstOperands,
     /*  39704 */     // GIR_Coverage, 1631,
     /*  39704 */     GIR_EraseRootFromParent_Done,
     /*  39705 */   // Label 897: @39705
     /*  39705 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39741), // Rule ID 1632 //
     /*  39710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39732 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3756:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39739 */     GIR_RootConstrainSelectedInstOperands,
     /*  39740 */     // GIR_Coverage, 1632,
     /*  39740 */     GIR_EraseRootFromParent_Done,
     /*  39741 */   // Label 898: @39741
     /*  39741 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39777), // Rule ID 1633 //
     /*  39746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39768 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3756:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  39771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39775 */     GIR_RootConstrainSelectedInstOperands,
     /*  39776 */     // GIR_Coverage, 1633,
     /*  39776 */     GIR_EraseRootFromParent_Done,
     /*  39777 */   // Label 899: @39777
     /*  39777 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39813), // Rule ID 1634 //
     /*  39782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39804 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3757:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  39807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39811 */     GIR_RootConstrainSelectedInstOperands,
     /*  39812 */     // GIR_Coverage, 1634,
     /*  39812 */     GIR_EraseRootFromParent_Done,
     /*  39813 */   // Label 900: @39813
     /*  39813 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(39849), // Rule ID 1635 //
     /*  39818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39840 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3757:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  39843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39847 */     GIR_RootConstrainSelectedInstOperands,
     /*  39848 */     // GIR_Coverage, 1635,
     /*  39848 */     GIR_EraseRootFromParent_Done,
     /*  39849 */   // Label 901: @39849
     /*  39849 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(39885), // Rule ID 1636 //
     /*  39854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39876 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3758:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  39879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39883 */     GIR_RootConstrainSelectedInstOperands,
     /*  39884 */     // GIR_Coverage, 1636,
     /*  39884 */     GIR_EraseRootFromParent_Done,
     /*  39885 */   // Label 902: @39885
     /*  39885 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(39921), // Rule ID 1637 //
     /*  39890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39912 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3758:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  39915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39919 */     GIR_RootConstrainSelectedInstOperands,
     /*  39920 */     // GIR_Coverage, 1637,
     /*  39920 */     GIR_EraseRootFromParent_Done,
     /*  39921 */   // Label 903: @39921
     /*  39921 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(39957), // Rule ID 1638 //
     /*  39926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39948 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3759:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  39951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39955 */     GIR_RootConstrainSelectedInstOperands,
     /*  39956 */     // GIR_Coverage, 1638,
     /*  39956 */     GIR_EraseRootFromParent_Done,
     /*  39957 */   // Label 904: @39957
     /*  39957 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(39993), // Rule ID 1639 //
     /*  39962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3759:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  39987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39991 */     GIR_RootConstrainSelectedInstOperands,
     /*  39992 */     // GIR_Coverage, 1639,
     /*  39992 */     GIR_EraseRootFromParent_Done,
     /*  39993 */   // Label 905: @39993
     /*  39993 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(40029), // Rule ID 1640 //
     /*  39998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40020 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3758:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  40023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40027 */     GIR_RootConstrainSelectedInstOperands,
     /*  40028 */     // GIR_Coverage, 1640,
     /*  40028 */     GIR_EraseRootFromParent_Done,
     /*  40029 */   // Label 906: @40029
     /*  40029 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(40065), // Rule ID 1641 //
     /*  40034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40056 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3758:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  40059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40063 */     GIR_RootConstrainSelectedInstOperands,
     /*  40064 */     // GIR_Coverage, 1641,
     /*  40064 */     GIR_EraseRootFromParent_Done,
     /*  40065 */   // Label 907: @40065
     /*  40065 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(40101), // Rule ID 1642 //
     /*  40070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40092 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3759:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  40095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40099 */     GIR_RootConstrainSelectedInstOperands,
     /*  40100 */     // GIR_Coverage, 1642,
     /*  40100 */     GIR_EraseRootFromParent_Done,
     /*  40101 */   // Label 908: @40101
     /*  40101 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(40137), // Rule ID 1643 //
     /*  40106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40128 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3759:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  40131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40135 */     GIR_RootConstrainSelectedInstOperands,
     /*  40136 */     // GIR_Coverage, 1643,
     /*  40136 */     GIR_EraseRootFromParent_Done,
     /*  40137 */   // Label 909: @40137
     /*  40137 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(40173), // Rule ID 1644 //
     /*  40142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40164 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3754:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  40167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40171 */     GIR_RootConstrainSelectedInstOperands,
     /*  40172 */     // GIR_Coverage, 1644,
     /*  40172 */     GIR_EraseRootFromParent_Done,
     /*  40173 */   // Label 910: @40173
     /*  40173 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(40209), // Rule ID 1645 //
     /*  40178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40200 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3754:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  40203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40207 */     GIR_RootConstrainSelectedInstOperands,
     /*  40208 */     // GIR_Coverage, 1645,
     /*  40208 */     GIR_EraseRootFromParent_Done,
     /*  40209 */   // Label 911: @40209
     /*  40209 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(40245), // Rule ID 1646 //
     /*  40214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40236 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3755:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  40239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40243 */     GIR_RootConstrainSelectedInstOperands,
     /*  40244 */     // GIR_Coverage, 1646,
     /*  40244 */     GIR_EraseRootFromParent_Done,
     /*  40245 */   // Label 912: @40245
     /*  40245 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(40281), // Rule ID 1647 //
     /*  40250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40272 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3755:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  40275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40279 */     GIR_RootConstrainSelectedInstOperands,
     /*  40280 */     // GIR_Coverage, 1647,
     /*  40280 */     GIR_EraseRootFromParent_Done,
     /*  40281 */   // Label 913: @40281
     /*  40281 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(40317), // Rule ID 1648 //
     /*  40286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40308 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3754:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40315 */     GIR_RootConstrainSelectedInstOperands,
     /*  40316 */     // GIR_Coverage, 1648,
     /*  40316 */     GIR_EraseRootFromParent_Done,
     /*  40317 */   // Label 914: @40317
     /*  40317 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(40353), // Rule ID 1649 //
     /*  40322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40344 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3754:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40351 */     GIR_RootConstrainSelectedInstOperands,
     /*  40352 */     // GIR_Coverage, 1649,
     /*  40352 */     GIR_EraseRootFromParent_Done,
     /*  40353 */   // Label 915: @40353
     /*  40353 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(40389), // Rule ID 1650 //
     /*  40358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40380 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3755:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40387 */     GIR_RootConstrainSelectedInstOperands,
     /*  40388 */     // GIR_Coverage, 1650,
     /*  40388 */     GIR_EraseRootFromParent_Done,
     /*  40389 */   // Label 916: @40389
     /*  40389 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(40425), // Rule ID 1651 //
     /*  40394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40416 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3755:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40423 */     GIR_RootConstrainSelectedInstOperands,
     /*  40424 */     // GIR_Coverage, 1651,
     /*  40424 */     GIR_EraseRootFromParent_Done,
     /*  40425 */   // Label 917: @40425
     /*  40425 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(40470), // Rule ID 1668 //
     /*  40430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40452 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3750:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40468 */     GIR_RootConstrainSelectedInstOperands,
     /*  40469 */     // GIR_Coverage, 1668,
     /*  40469 */     GIR_EraseRootFromParent_Done,
     /*  40470 */   // Label 918: @40470
     /*  40470 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(40515), // Rule ID 1669 //
     /*  40475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40497 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3753:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40513 */     GIR_RootConstrainSelectedInstOperands,
     /*  40514 */     // GIR_Coverage, 1669,
     /*  40514 */     GIR_EraseRootFromParent_Done,
     /*  40515 */   // Label 919: @40515
     /*  40515 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40551), // Rule ID 1691 //
     /*  40520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40542 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3824:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  40545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40549 */     GIR_RootConstrainSelectedInstOperands,
     /*  40550 */     // GIR_Coverage, 1691,
     /*  40550 */     GIR_EraseRootFromParent_Done,
     /*  40551 */   // Label 920: @40551
     /*  40551 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40587), // Rule ID 1692 //
     /*  40556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40578 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3824:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  40581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40585 */     GIR_RootConstrainSelectedInstOperands,
     /*  40586 */     // GIR_Coverage, 1692,
     /*  40586 */     GIR_EraseRootFromParent_Done,
     /*  40587 */   // Label 921: @40587
     /*  40587 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40623), // Rule ID 1693 //
     /*  40592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40614 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3824:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  40617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40621 */     GIR_RootConstrainSelectedInstOperands,
     /*  40622 */     // GIR_Coverage, 1693,
     /*  40622 */     GIR_EraseRootFromParent_Done,
     /*  40623 */   // Label 922: @40623
     /*  40623 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40659), // Rule ID 1694 //
     /*  40628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40650 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3824:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  40653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40657 */     GIR_RootConstrainSelectedInstOperands,
     /*  40658 */     // GIR_Coverage, 1694,
     /*  40658 */     GIR_EraseRootFromParent_Done,
     /*  40659 */   // Label 923: @40659
     /*  40659 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40695), // Rule ID 1695 //
     /*  40664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40686 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3826:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /*  40689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40693 */     GIR_RootConstrainSelectedInstOperands,
     /*  40694 */     // GIR_Coverage, 1695,
     /*  40694 */     GIR_EraseRootFromParent_Done,
     /*  40695 */   // Label 924: @40695
     /*  40695 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40731), // Rule ID 1696 //
     /*  40700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40722 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3826:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /*  40725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40729 */     GIR_RootConstrainSelectedInstOperands,
     /*  40730 */     // GIR_Coverage, 1696,
     /*  40730 */     GIR_EraseRootFromParent_Done,
     /*  40731 */   // Label 925: @40731
     /*  40731 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40767), // Rule ID 1697 //
     /*  40736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40758 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3826:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /*  40761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40765 */     GIR_RootConstrainSelectedInstOperands,
     /*  40766 */     // GIR_Coverage, 1697,
     /*  40766 */     GIR_EraseRootFromParent_Done,
     /*  40767 */   // Label 926: @40767
     /*  40767 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40803), // Rule ID 1698 //
     /*  40772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40794 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3826:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /*  40797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40801 */     GIR_RootConstrainSelectedInstOperands,
     /*  40802 */     // GIR_Coverage, 1698,
     /*  40802 */     GIR_EraseRootFromParent_Done,
     /*  40803 */   // Label 927: @40803
     /*  40803 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(40839), // Rule ID 1699 //
     /*  40808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40830 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3822:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  40833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40837 */     GIR_RootConstrainSelectedInstOperands,
     /*  40838 */     // GIR_Coverage, 1699,
     /*  40838 */     GIR_EraseRootFromParent_Done,
     /*  40839 */   // Label 928: @40839
     /*  40839 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(40875), // Rule ID 1700 //
     /*  40844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40866 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3822:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  40869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40873 */     GIR_RootConstrainSelectedInstOperands,
     /*  40874 */     // GIR_Coverage, 1700,
     /*  40874 */     GIR_EraseRootFromParent_Done,
     /*  40875 */   // Label 929: @40875
     /*  40875 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(40911), // Rule ID 1701 //
     /*  40880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40902 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3822:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  40905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40909 */     GIR_RootConstrainSelectedInstOperands,
     /*  40910 */     // GIR_Coverage, 1701,
     /*  40910 */     GIR_EraseRootFromParent_Done,
     /*  40911 */   // Label 930: @40911
     /*  40911 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(40947), // Rule ID 1702 //
     /*  40916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40938 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3822:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  40941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40945 */     GIR_RootConstrainSelectedInstOperands,
     /*  40946 */     // GIR_Coverage, 1702,
     /*  40946 */     GIR_EraseRootFromParent_Done,
     /*  40947 */   // Label 931: @40947
     /*  40947 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(40983), // Rule ID 1703 //
     /*  40952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40974 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3827:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  40977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40981 */     GIR_RootConstrainSelectedInstOperands,
     /*  40982 */     // GIR_Coverage, 1703,
     /*  40982 */     GIR_EraseRootFromParent_Done,
     /*  40983 */   // Label 932: @40983
     /*  40983 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(41019), // Rule ID 1704 //
     /*  40988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41010 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3827:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  41010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  41013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41017 */     GIR_RootConstrainSelectedInstOperands,
     /*  41018 */     // GIR_Coverage, 1704,
     /*  41018 */     GIR_EraseRootFromParent_Done,
     /*  41019 */   // Label 933: @41019
     /*  41019 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(41055), // Rule ID 1705 //
     /*  41024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  41032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41046 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3827:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  41049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41053 */     GIR_RootConstrainSelectedInstOperands,
     /*  41054 */     // GIR_Coverage, 1705,
     /*  41054 */     GIR_EraseRootFromParent_Done,
     /*  41055 */   // Label 934: @41055
     /*  41055 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(41091), // Rule ID 1706 //
     /*  41060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  41068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41082 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3827:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  41085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41089 */     GIR_RootConstrainSelectedInstOperands,
     /*  41090 */     // GIR_Coverage, 1706,
     /*  41090 */     GIR_EraseRootFromParent_Done,
     /*  41091 */   // Label 935: @41091
     /*  41091 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(41127), // Rule ID 1707 //
     /*  41096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  41104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  41107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41118 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3823:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  41118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /*  41121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41125 */     GIR_RootConstrainSelectedInstOperands,
     /*  41126 */     // GIR_Coverage, 1707,
     /*  41126 */     GIR_EraseRootFromParent_Done,
     /*  41127 */   // Label 936: @41127
     /*  41127 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(41163), // Rule ID 1708 //
     /*  41132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  41140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41154 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3823:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  41154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /*  41157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41161 */     GIR_RootConstrainSelectedInstOperands,
     /*  41162 */     // GIR_Coverage, 1708,
     /*  41162 */     GIR_EraseRootFromParent_Done,
     /*  41163 */   // Label 937: @41163
     /*  41163 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(41199), // Rule ID 1709 //
     /*  41168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  41176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41190 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3823:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /*  41193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41197 */     GIR_RootConstrainSelectedInstOperands,
     /*  41198 */     // GIR_Coverage, 1709,
     /*  41198 */     GIR_EraseRootFromParent_Done,
     /*  41199 */   // Label 938: @41199
     /*  41199 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(41235), // Rule ID 1710 //
     /*  41204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  41212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41226 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3823:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /*  41229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41233 */     GIR_RootConstrainSelectedInstOperands,
     /*  41234 */     // GIR_Coverage, 1710,
     /*  41234 */     GIR_EraseRootFromParent_Done,
     /*  41235 */   // Label 939: @41235
     /*  41235 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(41271), // Rule ID 1711 //
     /*  41240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  41251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41262 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3825:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  41262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /*  41265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41269 */     GIR_RootConstrainSelectedInstOperands,
     /*  41270 */     // GIR_Coverage, 1711,
     /*  41270 */     GIR_EraseRootFromParent_Done,
     /*  41271 */   // Label 940: @41271
     /*  41271 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(41307), // Rule ID 1712 //
     /*  41276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41298 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3825:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  41298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /*  41301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41305 */     GIR_RootConstrainSelectedInstOperands,
     /*  41306 */     // GIR_Coverage, 1712,
     /*  41306 */     GIR_EraseRootFromParent_Done,
     /*  41307 */   // Label 941: @41307
     /*  41307 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(41343), // Rule ID 1713 //
     /*  41312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41334 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3825:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /*  41337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41341 */     GIR_RootConstrainSelectedInstOperands,
     /*  41342 */     // GIR_Coverage, 1713,
     /*  41342 */     GIR_EraseRootFromParent_Done,
     /*  41343 */   // Label 942: @41343
     /*  41343 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(41379), // Rule ID 1714 //
     /*  41348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41370 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3825:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /*  41373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41377 */     GIR_RootConstrainSelectedInstOperands,
     /*  41378 */     // GIR_Coverage, 1714,
     /*  41378 */     GIR_EraseRootFromParent_Done,
     /*  41379 */   // Label 943: @41379
     /*  41379 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(41415), // Rule ID 1717 //
     /*  41384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  41392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41406 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  41409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41413 */     GIR_RootConstrainSelectedInstOperands,
     /*  41414 */     // GIR_Coverage, 1717,
     /*  41414 */     GIR_EraseRootFromParent_Done,
     /*  41415 */   // Label 944: @41415
     /*  41415 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(41451), // Rule ID 1718 //
     /*  41420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  41428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41442 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3714:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  41445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41449 */     GIR_RootConstrainSelectedInstOperands,
     /*  41450 */     // GIR_Coverage, 1718,
     /*  41450 */     GIR_EraseRootFromParent_Done,
     /*  41451 */   // Label 945: @41451
     /*  41451 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41499), // Rule ID 1851 //
     /*  41456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41478 */     // (intrinsic_wo_chain:{ *:[i32] } 3913:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  41478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  41481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  41485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41497 */     GIR_RootConstrainSelectedInstOperands,
     /*  41498 */     // GIR_Coverage, 1851,
     /*  41498 */     GIR_EraseRootFromParent_Done,
     /*  41499 */   // Label 946: @41499
     /*  41499 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41547), // Rule ID 2099 //
     /*  41504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41526 */     // (intrinsic_wo_chain:{ *:[i32] } 3913:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  41526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  41529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41545 */     GIR_RootConstrainSelectedInstOperands,
     /*  41546 */     // GIR_Coverage, 2099,
     /*  41546 */     GIR_EraseRootFromParent_Done,
     /*  41547 */   // Label 947: @41547
     /*  41547 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(41613), // Rule ID 3648 //
     /*  41552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41574 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3596:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  41574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  41589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41591 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41611 */     GIR_RootConstrainSelectedInstOperands,
     /*  41612 */     // GIR_Coverage, 3648,
     /*  41612 */     GIR_EraseRootFromParent_Done,
     /*  41613 */   // Label 948: @41613
     /*  41613 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(41679), // Rule ID 3650 //
     /*  41618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41640 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3596:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41657 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41677 */     GIR_RootConstrainSelectedInstOperands,
     /*  41678 */     // GIR_Coverage, 3650,
     /*  41678 */     GIR_EraseRootFromParent_Done,
     /*  41679 */   // Label 949: @41679
     /*  41679 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(41745), // Rule ID 3652 //
     /*  41684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41706 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3596:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41723 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41743 */     GIR_RootConstrainSelectedInstOperands,
     /*  41744 */     // GIR_Coverage, 3652,
     /*  41744 */     GIR_EraseRootFromParent_Done,
     /*  41745 */   // Label 950: @41745
     /*  41745 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(41796), // Rule ID 4864 //
     /*  41750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41772 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3604:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41794 */     GIR_RootConstrainSelectedInstOperands,
     /*  41795 */     // GIR_Coverage, 4864,
     /*  41795 */     GIR_EraseRootFromParent_Done,
     /*  41796 */   // Label 951: @41796
     /*  41796 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(41847), // Rule ID 4866 //
     /*  41801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41823 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3601:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41845 */     GIR_RootConstrainSelectedInstOperands,
     /*  41846 */     // GIR_Coverage, 4866,
     /*  41846 */     GIR_EraseRootFromParent_Done,
     /*  41847 */   // Label 952: @41847
     /*  41847 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(41898), // Rule ID 4868 //
     /*  41852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41874 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3602:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41896 */     GIR_RootConstrainSelectedInstOperands,
     /*  41897 */     // GIR_Coverage, 4868,
     /*  41897 */     GIR_EraseRootFromParent_Done,
     /*  41898 */   // Label 953: @41898
     /*  41898 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(41949), // Rule ID 4870 //
     /*  41903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41925 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3603:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41947 */     GIR_RootConstrainSelectedInstOperands,
     /*  41948 */     // GIR_Coverage, 4870,
     /*  41948 */     GIR_EraseRootFromParent_Done,
     /*  41949 */   // Label 954: @41949
     /*  41949 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(41995), // Rule ID 600 //
     /*  41954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41969 */     // MIs[0] Rn
     /*  41969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41977 */     // (intrinsic_wo_chain:{ *:[i32] } 3486:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41993 */     GIR_RootConstrainSelectedInstOperands,
     /*  41994 */     // GIR_Coverage, 600,
     /*  41994 */     GIR_EraseRootFromParent_Done,
     /*  41995 */   // Label 955: @41995
     /*  41995 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(42041), // Rule ID 601 //
     /*  42000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  42003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  42008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42015 */     // MIs[0] Rn
     /*  42015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  42019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42023 */     // (intrinsic_wo_chain:{ *:[i32] } 3489:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  42023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  42026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  42028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42039 */     GIR_RootConstrainSelectedInstOperands,
     /*  42040 */     // GIR_Coverage, 601,
     /*  42040 */     GIR_EraseRootFromParent_Done,
     /*  42041 */   // Label 956: @42041
     /*  42041 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(42087), // Rule ID 602 //
     /*  42046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  42049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  42054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42061 */     // MIs[0] Rn
     /*  42061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  42065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42069 */     // (intrinsic_wo_chain:{ *:[i32] } 3487:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  42069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  42072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  42074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42085 */     GIR_RootConstrainSelectedInstOperands,
     /*  42086 */     // GIR_Coverage, 602,
     /*  42086 */     GIR_EraseRootFromParent_Done,
     /*  42087 */   // Label 957: @42087
     /*  42087 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(42133), // Rule ID 603 //
     /*  42092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  42095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  42100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42107 */     // MIs[0] Rn
     /*  42107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  42111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42115 */     // (intrinsic_wo_chain:{ *:[i32] } 3488:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  42115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  42118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  42120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42131 */     GIR_RootConstrainSelectedInstOperands,
     /*  42132 */     // GIR_Coverage, 603,
     /*  42132 */     GIR_EraseRootFromParent_Done,
     /*  42133 */   // Label 958: @42133
     /*  42133 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(42268), // Rule ID 2693 //
     /*  42138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  42146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  42156 */     // (intrinsic_wo_chain:{ *:[i32] } 3721:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  42156 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  42159 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42163 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42168 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  42172 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42177 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  42180 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  42184 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42189 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  42192 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  42195 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  42198 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  42203 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42208 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  42211 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  42215 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42220 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  42225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42237 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  42244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  42267 */     // GIR_Coverage, 2693,
     /*  42267 */     GIR_EraseRootFromParent_Done,
     /*  42268 */   // Label 959: @42268
     /*  42268 */   GIM_Reject,
     /*  42269 */ // Label 825: @42269
     /*  42269 */ GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(62823),
     /*  42274 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  42277 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(42334), // Rule ID 2117 //
     /*  42282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  42290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42311 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  42311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  42314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42332 */     GIR_RootConstrainSelectedInstOperands,
     /*  42333 */     // GIR_Coverage, 2117,
     /*  42333 */     GIR_EraseRootFromParent_Done,
     /*  42334 */   // Label 961: @42334
     /*  42334 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(42433), // Rule ID 1888 //
     /*  42339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  42342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42389 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42393 */     // MIs[2] Operand 1
     /*  42393 */     // No operand predicates
     /*  42393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42401 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42405 */     // MIs[3] Operand 1
     /*  42405 */     // No operand predicates
     /*  42405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42407 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  42410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42431 */     GIR_RootConstrainSelectedInstOperands,
     /*  42432 */     // GIR_Coverage, 1888,
     /*  42432 */     GIR_EraseRootFromParent_Done,
     /*  42433 */   // Label 962: @42433
     /*  42433 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(42532), // Rule ID 2154 //
     /*  42438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  42441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42488 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42492 */     // MIs[2] Operand 1
     /*  42492 */     // No operand predicates
     /*  42492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42500 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42504 */     // MIs[3] Operand 1
     /*  42504 */     // No operand predicates
     /*  42504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42506 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  42509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42530 */     GIR_RootConstrainSelectedInstOperands,
     /*  42531 */     // GIR_Coverage, 2154,
     /*  42531 */     GIR_EraseRootFromParent_Done,
     /*  42532 */   // Label 963: @42532
     /*  42532 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(42616), // Rule ID 5430 //
     /*  42537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42566 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42569 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42583 */     // MIs[1] Rn
     /*  42583 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42594 */     // (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42614 */     GIR_RootConstrainSelectedInstOperands,
     /*  42615 */     // GIR_Coverage, 5430,
     /*  42615 */     GIR_EraseRootFromParent_Done,
     /*  42616 */   // Label 964: @42616
     /*  42616 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(42700), // Rule ID 5687 //
     /*  42621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42650 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42653 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42667 */     // MIs[1] Rn
     /*  42667 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42678 */     // (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42698 */     GIR_RootConstrainSelectedInstOperands,
     /*  42699 */     // GIR_Coverage, 5687,
     /*  42699 */     GIR_EraseRootFromParent_Done,
     /*  42700 */   // Label 965: @42700
     /*  42700 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(42784), // Rule ID 109 //
     /*  42705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42738 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42741 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42755 */     // MIs[1] Rn
     /*  42755 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42762 */     // (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42782 */     GIR_RootConstrainSelectedInstOperands,
     /*  42783 */     // GIR_Coverage, 109,
     /*  42783 */     GIR_EraseRootFromParent_Done,
     /*  42784 */   // Label 966: @42784
     /*  42784 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(42868), // Rule ID 110 //
     /*  42789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42822 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42825 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42839 */     // MIs[1] Rn
     /*  42839 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42846 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42866 */     GIR_RootConstrainSelectedInstOperands,
     /*  42867 */     // GIR_Coverage, 110,
     /*  42867 */     GIR_EraseRootFromParent_Done,
     /*  42868 */   // Label 967: @42868
     /*  42868 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(42952), // Rule ID 2132 //
     /*  42873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42906 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42909 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42923 */     // MIs[1] Rn
     /*  42923 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42930 */     // (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42950 */     GIR_RootConstrainSelectedInstOperands,
     /*  42951 */     // GIR_Coverage, 2132,
     /*  42951 */     GIR_EraseRootFromParent_Done,
     /*  42952 */   // Label 968: @42952
     /*  42952 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(43036), // Rule ID 2133 //
     /*  42957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42990 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42993 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  43007 */     // MIs[1] Rn
     /*  43007 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  43012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43014 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  43014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  43017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  43021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  43028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43034 */     GIR_RootConstrainSelectedInstOperands,
     /*  43035 */     // GIR_Coverage, 2133,
     /*  43035 */     GIR_EraseRootFromParent_Done,
     /*  43036 */   // Label 969: @43036
     /*  43036 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(43109), // Rule ID 4058 //
     /*  43041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43070 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3612:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  43085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43087 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43107 */     GIR_RootConstrainSelectedInstOperands,
     /*  43108 */     // GIR_Coverage, 4058,
     /*  43108 */     GIR_EraseRootFromParent_Done,
     /*  43109 */   // Label 970: @43109
     /*  43109 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(43182), // Rule ID 4060 //
     /*  43114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43143 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3616:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  43158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43160 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43180 */     GIR_RootConstrainSelectedInstOperands,
     /*  43181 */     // GIR_Coverage, 4060,
     /*  43181 */     GIR_EraseRootFromParent_Done,
     /*  43182 */   // Label 971: @43182
     /*  43182 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(43255), // Rule ID 4062 //
     /*  43187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43216 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3618:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  43231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43233 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43253 */     GIR_RootConstrainSelectedInstOperands,
     /*  43254 */     // GIR_Coverage, 4062,
     /*  43254 */     GIR_EraseRootFromParent_Done,
     /*  43255 */   // Label 972: @43255
     /*  43255 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(43328), // Rule ID 4064 //
     /*  43260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43289 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3614:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  43304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43306 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43326 */     GIR_RootConstrainSelectedInstOperands,
     /*  43327 */     // GIR_Coverage, 4064,
     /*  43327 */     GIR_EraseRootFromParent_Done,
     /*  43328 */   // Label 973: @43328
     /*  43328 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(43401), // Rule ID 4066 //
     /*  43333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43362 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3612:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  43377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43379 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43399 */     GIR_RootConstrainSelectedInstOperands,
     /*  43400 */     // GIR_Coverage, 4066,
     /*  43400 */     GIR_EraseRootFromParent_Done,
     /*  43401 */   // Label 974: @43401
     /*  43401 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(43474), // Rule ID 4068 //
     /*  43406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43427 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43435 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3616:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  43450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43452 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43472 */     GIR_RootConstrainSelectedInstOperands,
     /*  43473 */     // GIR_Coverage, 4068,
     /*  43473 */     GIR_EraseRootFromParent_Done,
     /*  43474 */   // Label 975: @43474
     /*  43474 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(43547), // Rule ID 4070 //
     /*  43479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43508 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3618:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  43523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43525 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43545 */     GIR_RootConstrainSelectedInstOperands,
     /*  43546 */     // GIR_Coverage, 4070,
     /*  43546 */     GIR_EraseRootFromParent_Done,
     /*  43547 */   // Label 976: @43547
     /*  43547 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(43620), // Rule ID 4072 //
     /*  43552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43581 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3614:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  43596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43598 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43618 */     GIR_RootConstrainSelectedInstOperands,
     /*  43619 */     // GIR_Coverage, 4072,
     /*  43619 */     GIR_EraseRootFromParent_Done,
     /*  43620 */   // Label 977: @43620
     /*  43620 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(43693), // Rule ID 4074 //
     /*  43625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43654 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3612:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43671 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43691 */     GIR_RootConstrainSelectedInstOperands,
     /*  43692 */     // GIR_Coverage, 4074,
     /*  43692 */     GIR_EraseRootFromParent_Done,
     /*  43693 */   // Label 978: @43693
     /*  43693 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(43766), // Rule ID 4076 //
     /*  43698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43727 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3616:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43744 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43764 */     GIR_RootConstrainSelectedInstOperands,
     /*  43765 */     // GIR_Coverage, 4076,
     /*  43765 */     GIR_EraseRootFromParent_Done,
     /*  43766 */   // Label 979: @43766
     /*  43766 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(43839), // Rule ID 4078 //
     /*  43771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43800 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3618:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43817 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43837 */     GIR_RootConstrainSelectedInstOperands,
     /*  43838 */     // GIR_Coverage, 4078,
     /*  43838 */     GIR_EraseRootFromParent_Done,
     /*  43839 */   // Label 980: @43839
     /*  43839 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(43912), // Rule ID 4080 //
     /*  43844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43873 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3614:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43890 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43910 */     GIR_RootConstrainSelectedInstOperands,
     /*  43911 */     // GIR_Coverage, 4080,
     /*  43911 */     GIR_EraseRootFromParent_Done,
     /*  43912 */   // Label 981: @43912
     /*  43912 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(43985), // Rule ID 4082 //
     /*  43917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43946 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3612:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43963 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43983 */     GIR_RootConstrainSelectedInstOperands,
     /*  43984 */     // GIR_Coverage, 4082,
     /*  43984 */     GIR_EraseRootFromParent_Done,
     /*  43985 */   // Label 982: @43985
     /*  43985 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(44058), // Rule ID 4084 //
     /*  43990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  44007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  44015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44019 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3616:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  44019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  44034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44036 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44056 */     GIR_RootConstrainSelectedInstOperands,
     /*  44057 */     // GIR_Coverage, 4084,
     /*  44057 */     GIR_EraseRootFromParent_Done,
     /*  44058 */   // Label 983: @44058
     /*  44058 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(44131), // Rule ID 4086 //
     /*  44063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  44071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  44080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  44088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44092 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3618:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  44092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  44107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44109 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44129 */     GIR_RootConstrainSelectedInstOperands,
     /*  44130 */     // GIR_Coverage, 4086,
     /*  44130 */     GIR_EraseRootFromParent_Done,
     /*  44131 */   // Label 984: @44131
     /*  44131 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(44204), // Rule ID 4088 //
     /*  44136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  44144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  44153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  44161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44165 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3614:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  44165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  44180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44182 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44202 */     GIR_RootConstrainSelectedInstOperands,
     /*  44203 */     // GIR_Coverage, 4088,
     /*  44203 */     GIR_EraseRootFromParent_Done,
     /*  44204 */   // Label 985: @44204
     /*  44204 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(44277), // Rule ID 4532 //
     /*  44209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  44238 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3610:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  44253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44275 */     GIR_RootConstrainSelectedInstOperands,
     /*  44276 */     // GIR_Coverage, 4532,
     /*  44276 */     GIR_EraseRootFromParent_Done,
     /*  44277 */   // Label 986: @44277
     /*  44277 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(44350), // Rule ID 4538 //
     /*  44282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  44311 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3610:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  44326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44348 */     GIR_RootConstrainSelectedInstOperands,
     /*  44349 */     // GIR_Coverage, 4538,
     /*  44349 */     GIR_EraseRootFromParent_Done,
     /*  44350 */   // Label 987: @44350
     /*  44350 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(44418), // Rule ID 1881 //
     /*  44355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44392 */     // MIs[1] Operand 1
     /*  44392 */     // No operand predicates
     /*  44392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44394 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  44397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44402 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44416 */     GIR_RootConstrainSelectedInstOperands,
     /*  44417 */     // GIR_Coverage, 1881,
     /*  44417 */     GIR_EraseRootFromParent_Done,
     /*  44418 */   // Label 988: @44418
     /*  44418 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(44483), // Rule ID 1885 //
     /*  44423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44460 */     // MIs[1] Operand 1
     /*  44460 */     // No operand predicates
     /*  44460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44462 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  44462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  44465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44470 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44481 */     GIR_RootConstrainSelectedInstOperands,
     /*  44482 */     // GIR_Coverage, 1885,
     /*  44482 */     GIR_EraseRootFromParent_Done,
     /*  44483 */   // Label 989: @44483
     /*  44483 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(44551), // Rule ID 2149 //
     /*  44488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44525 */     // MIs[1] Operand 1
     /*  44525 */     // No operand predicates
     /*  44525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44527 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  44530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44535 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44549 */     GIR_RootConstrainSelectedInstOperands,
     /*  44550 */     // GIR_Coverage, 2149,
     /*  44550 */     GIR_EraseRootFromParent_Done,
     /*  44551 */   // Label 990: @44551
     /*  44551 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(44616), // Rule ID 2151 //
     /*  44556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44593 */     // MIs[1] Operand 1
     /*  44593 */     // No operand predicates
     /*  44593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44595 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  44595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  44598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44603 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44614 */     GIR_RootConstrainSelectedInstOperands,
     /*  44615 */     // GIR_Coverage, 2151,
     /*  44615 */     GIR_EraseRootFromParent_Done,
     /*  44616 */   // Label 991: @44616
     /*  44616 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(44699), // Rule ID 3928 //
     /*  44621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  44629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  44632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44655 */     // MIs[1] Operand 1
     /*  44655 */     // No operand predicates
     /*  44655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44657 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44697 */     GIR_RootConstrainSelectedInstOperands,
     /*  44698 */     // GIR_Coverage, 3928,
     /*  44698 */     GIR_EraseRootFromParent_Done,
     /*  44699 */   // Label 992: @44699
     /*  44699 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(44782), // Rule ID 3930 //
     /*  44704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44738 */     // MIs[1] Operand 1
     /*  44738 */     // No operand predicates
     /*  44738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44740 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44780 */     GIR_RootConstrainSelectedInstOperands,
     /*  44781 */     // GIR_Coverage, 3930,
     /*  44781 */     GIR_EraseRootFromParent_Done,
     /*  44782 */   // Label 993: @44782
     /*  44782 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(44865), // Rule ID 3932 //
     /*  44787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44821 */     // MIs[1] Operand 1
     /*  44821 */     // No operand predicates
     /*  44821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44823 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44840 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44863 */     GIR_RootConstrainSelectedInstOperands,
     /*  44864 */     // GIR_Coverage, 3932,
     /*  44864 */     GIR_EraseRootFromParent_Done,
     /*  44865 */   // Label 994: @44865
     /*  44865 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(44926), // Rule ID 1652 //
     /*  44870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44903 */     // MIs[1] Operand 1
     /*  44903 */     // No operand predicates
     /*  44903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44905 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3748:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44924 */     GIR_RootConstrainSelectedInstOperands,
     /*  44925 */     // GIR_Coverage, 1652,
     /*  44925 */     GIR_EraseRootFromParent_Done,
     /*  44926 */   // Label 995: @44926
     /*  44926 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(44987), // Rule ID 1653 //
     /*  44931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44964 */     // MIs[1] Operand 1
     /*  44964 */     // No operand predicates
     /*  44964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44966 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3749:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44985 */     GIR_RootConstrainSelectedInstOperands,
     /*  44986 */     // GIR_Coverage, 1653,
     /*  44986 */     GIR_EraseRootFromParent_Done,
     /*  44987 */   // Label 996: @44987
     /*  44987 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(45048), // Rule ID 1654 //
     /*  44992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  45003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45025 */     // MIs[1] Operand 1
     /*  45025 */     // No operand predicates
     /*  45025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45027 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3751:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  45030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45046 */     GIR_RootConstrainSelectedInstOperands,
     /*  45047 */     // GIR_Coverage, 1654,
     /*  45047 */     GIR_EraseRootFromParent_Done,
     /*  45048 */   // Label 997: @45048
     /*  45048 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(45109), // Rule ID 1655 //
     /*  45053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  45064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45086 */     // MIs[1] Operand 1
     /*  45086 */     // No operand predicates
     /*  45086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45088 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3752:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  45091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45107 */     GIR_RootConstrainSelectedInstOperands,
     /*  45108 */     // GIR_Coverage, 1655,
     /*  45108 */     GIR_EraseRootFromParent_Done,
     /*  45109 */   // Label 998: @45109
     /*  45109 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(45170), // Rule ID 1656 //
     /*  45114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45147 */     // MIs[1] Operand 1
     /*  45147 */     // No operand predicates
     /*  45147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45149 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3748:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  45152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45168 */     GIR_RootConstrainSelectedInstOperands,
     /*  45169 */     // GIR_Coverage, 1656,
     /*  45169 */     GIR_EraseRootFromParent_Done,
     /*  45170 */   // Label 999: @45170
     /*  45170 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(45231), // Rule ID 1657 //
     /*  45175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45208 */     // MIs[1] Operand 1
     /*  45208 */     // No operand predicates
     /*  45208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45210 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3749:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  45213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45229 */     GIR_RootConstrainSelectedInstOperands,
     /*  45230 */     // GIR_Coverage, 1657,
     /*  45230 */     GIR_EraseRootFromParent_Done,
     /*  45231 */   // Label 1000: @45231
     /*  45231 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(45292), // Rule ID 1658 //
     /*  45236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45269 */     // MIs[1] Operand 1
     /*  45269 */     // No operand predicates
     /*  45269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45271 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3751:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  45274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45290 */     GIR_RootConstrainSelectedInstOperands,
     /*  45291 */     // GIR_Coverage, 1658,
     /*  45291 */     GIR_EraseRootFromParent_Done,
     /*  45292 */   // Label 1001: @45292
     /*  45292 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(45353), // Rule ID 1659 //
     /*  45297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45330 */     // MIs[1] Operand 1
     /*  45330 */     // No operand predicates
     /*  45330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45332 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3752:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  45335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45351 */     GIR_RootConstrainSelectedInstOperands,
     /*  45352 */     // GIR_Coverage, 1659,
     /*  45352 */     GIR_EraseRootFromParent_Done,
     /*  45353 */   // Label 1002: @45353
     /*  45353 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(45414), // Rule ID 1660 //
     /*  45358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45391 */     // MIs[1] Operand 1
     /*  45391 */     // No operand predicates
     /*  45391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45393 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3748:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  45396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45412 */     GIR_RootConstrainSelectedInstOperands,
     /*  45413 */     // GIR_Coverage, 1660,
     /*  45413 */     GIR_EraseRootFromParent_Done,
     /*  45414 */   // Label 1003: @45414
     /*  45414 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45475), // Rule ID 1661 //
     /*  45419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45452 */     // MIs[1] Operand 1
     /*  45452 */     // No operand predicates
     /*  45452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45454 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3749:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  45457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45473 */     GIR_RootConstrainSelectedInstOperands,
     /*  45474 */     // GIR_Coverage, 1661,
     /*  45474 */     GIR_EraseRootFromParent_Done,
     /*  45475 */   // Label 1004: @45475
     /*  45475 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(45536), // Rule ID 1662 //
     /*  45480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45513 */     // MIs[1] Operand 1
     /*  45513 */     // No operand predicates
     /*  45513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45515 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3751:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  45518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45534 */     GIR_RootConstrainSelectedInstOperands,
     /*  45535 */     // GIR_Coverage, 1662,
     /*  45535 */     GIR_EraseRootFromParent_Done,
     /*  45536 */   // Label 1005: @45536
     /*  45536 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(45597), // Rule ID 1663 //
     /*  45541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45574 */     // MIs[1] Operand 1
     /*  45574 */     // No operand predicates
     /*  45574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45576 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3752:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  45579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45595 */     GIR_RootConstrainSelectedInstOperands,
     /*  45596 */     // GIR_Coverage, 1663,
     /*  45596 */     GIR_EraseRootFromParent_Done,
     /*  45597 */   // Label 1006: @45597
     /*  45597 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(45658), // Rule ID 1664 //
     /*  45602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45635 */     // MIs[1] Operand 1
     /*  45635 */     // No operand predicates
     /*  45635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45637 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3748:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45656 */     GIR_RootConstrainSelectedInstOperands,
     /*  45657 */     // GIR_Coverage, 1664,
     /*  45657 */     GIR_EraseRootFromParent_Done,
     /*  45658 */   // Label 1007: @45658
     /*  45658 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(45719), // Rule ID 1665 //
     /*  45663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45696 */     // MIs[1] Operand 1
     /*  45696 */     // No operand predicates
     /*  45696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45698 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3749:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45717 */     GIR_RootConstrainSelectedInstOperands,
     /*  45718 */     // GIR_Coverage, 1665,
     /*  45718 */     GIR_EraseRootFromParent_Done,
     /*  45719 */   // Label 1008: @45719
     /*  45719 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(45780), // Rule ID 1666 //
     /*  45724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45757 */     // MIs[1] Operand 1
     /*  45757 */     // No operand predicates
     /*  45757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45759 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3751:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45778 */     GIR_RootConstrainSelectedInstOperands,
     /*  45779 */     // GIR_Coverage, 1666,
     /*  45779 */     GIR_EraseRootFromParent_Done,
     /*  45780 */   // Label 1009: @45780
     /*  45780 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(45841), // Rule ID 1667 //
     /*  45785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45818 */     // MIs[1] Operand 1
     /*  45818 */     // No operand predicates
     /*  45818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45820 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3752:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45839 */     GIR_RootConstrainSelectedInstOperands,
     /*  45840 */     // GIR_Coverage, 1667,
     /*  45840 */     GIR_EraseRootFromParent_Done,
     /*  45841 */   // Label 1010: @45841
     /*  45841 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(45902), // Rule ID 1725 //
     /*  45846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45879 */     // MIs[1] Operand 1
     /*  45879 */     // No operand predicates
     /*  45879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45881 */     // (intrinsic_wo_chain:{ *:[i32] } 3576:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45886 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45900 */     GIR_RootConstrainSelectedInstOperands,
     /*  45901 */     // GIR_Coverage, 1725,
     /*  45901 */     GIR_EraseRootFromParent_Done,
     /*  45902 */   // Label 1011: @45902
     /*  45902 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(45963), // Rule ID 1726 //
     /*  45907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45940 */     // MIs[1] Operand 1
     /*  45940 */     // No operand predicates
     /*  45940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45942 */     // (intrinsic_wo_chain:{ *:[i32] } 3578:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45947 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45961 */     GIR_RootConstrainSelectedInstOperands,
     /*  45962 */     // GIR_Coverage, 1726,
     /*  45962 */     GIR_EraseRootFromParent_Done,
     /*  45963 */   // Label 1012: @45963
     /*  45963 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(46024), // Rule ID 1727 //
     /*  45968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46001 */     // MIs[1] Operand 1
     /*  46001 */     // No operand predicates
     /*  46001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46003 */     // (intrinsic_wo_chain:{ *:[i32] } 3583:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  46003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  46006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  46008 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  46010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  46013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46022 */     GIR_RootConstrainSelectedInstOperands,
     /*  46023 */     // GIR_Coverage, 1727,
     /*  46023 */     GIR_EraseRootFromParent_Done,
     /*  46024 */   // Label 1013: @46024
     /*  46024 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(46085), // Rule ID 1728 //
     /*  46029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  46032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  46037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  46050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  46054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  46058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46062 */     // MIs[1] Operand 1
     /*  46062 */     // No operand predicates
     /*  46062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46064 */     // (intrinsic_wo_chain:{ *:[i32] } 3585:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  46064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  46067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  46069 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  46071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  46074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46083 */     GIR_RootConstrainSelectedInstOperands,
     /*  46084 */     // GIR_Coverage, 1728,
     /*  46084 */     GIR_EraseRootFromParent_Done,
     /*  46085 */   // Label 1014: @46085
     /*  46085 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(46139), // Rule ID 105 //
     /*  46090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  46098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46119 */     // (intrinsic_wo_chain:{ *:[i32] } 3857:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  46122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46137 */     GIR_RootConstrainSelectedInstOperands,
     /*  46138 */     // GIR_Coverage, 105,
     /*  46138 */     GIR_EraseRootFromParent_Done,
     /*  46139 */   // Label 1015: @46139
     /*  46139 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(46193), // Rule ID 106 //
     /*  46144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  46152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46173 */     // (intrinsic_wo_chain:{ *:[i32] } 3856:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  46176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46191 */     GIR_RootConstrainSelectedInstOperands,
     /*  46192 */     // GIR_Coverage, 106,
     /*  46192 */     GIR_EraseRootFromParent_Done,
     /*  46193 */   // Label 1016: @46193
     /*  46193 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(46247), // Rule ID 107 //
     /*  46198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  46206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46227 */     // (intrinsic_wo_chain:{ *:[i32] } 3861:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  46230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46245 */     GIR_RootConstrainSelectedInstOperands,
     /*  46246 */     // GIR_Coverage, 107,
     /*  46246 */     GIR_EraseRootFromParent_Done,
     /*  46247 */   // Label 1017: @46247
     /*  46247 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(46301), // Rule ID 108 //
     /*  46252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  46260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46281 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  46284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46299 */     GIR_RootConstrainSelectedInstOperands,
     /*  46300 */     // GIR_Coverage, 108,
     /*  46300 */     GIR_EraseRootFromParent_Done,
     /*  46301 */   // Label 1018: @46301
     /*  46301 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(46355), // Rule ID 111 //
     /*  46306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  46314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46335 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  46338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46353 */     GIR_RootConstrainSelectedInstOperands,
     /*  46354 */     // GIR_Coverage, 111,
     /*  46354 */     GIR_EraseRootFromParent_Done,
     /*  46355 */   // Label 1019: @46355
     /*  46355 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(46409), // Rule ID 112 //
     /*  46360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  46368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46389 */     // (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  46392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46407 */     GIR_RootConstrainSelectedInstOperands,
     /*  46408 */     // GIR_Coverage, 112,
     /*  46408 */     GIR_EraseRootFromParent_Done,
     /*  46409 */   // Label 1020: @46409
     /*  46409 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(46463), // Rule ID 113 //
     /*  46414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  46422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46443 */     // (intrinsic_wo_chain:{ *:[i32] } 3924:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  46446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46461 */     GIR_RootConstrainSelectedInstOperands,
     /*  46462 */     // GIR_Coverage, 113,
     /*  46462 */     GIR_EraseRootFromParent_Done,
     /*  46463 */   // Label 1021: @46463
     /*  46463 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46517), // Rule ID 114 //
     /*  46468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  46476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46497 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  46500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46515 */     GIR_RootConstrainSelectedInstOperands,
     /*  46516 */     // GIR_Coverage, 114,
     /*  46516 */     GIR_EraseRootFromParent_Done,
     /*  46517 */   // Label 1022: @46517
     /*  46517 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46571), // Rule ID 115 //
     /*  46522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  46530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46551 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  46554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46569 */     GIR_RootConstrainSelectedInstOperands,
     /*  46570 */     // GIR_Coverage, 115,
     /*  46570 */     GIR_EraseRootFromParent_Done,
     /*  46571 */   // Label 1023: @46571
     /*  46571 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(46625), // Rule ID 116 //
     /*  46576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  46584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46605 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  46608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46623 */     GIR_RootConstrainSelectedInstOperands,
     /*  46624 */     // GIR_Coverage, 116,
     /*  46624 */     GIR_EraseRootFromParent_Done,
     /*  46625 */   // Label 1024: @46625
     /*  46625 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(46679), // Rule ID 117 //
     /*  46630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46659 */     // (intrinsic_wo_chain:{ *:[i32] } 3858:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46677 */     GIR_RootConstrainSelectedInstOperands,
     /*  46678 */     // GIR_Coverage, 117,
     /*  46678 */     GIR_EraseRootFromParent_Done,
     /*  46679 */   // Label 1025: @46679
     /*  46679 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(46733), // Rule ID 118 //
     /*  46684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46713 */     // (intrinsic_wo_chain:{ *:[i32] } 3859:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46731 */     GIR_RootConstrainSelectedInstOperands,
     /*  46732 */     // GIR_Coverage, 118,
     /*  46732 */     GIR_EraseRootFromParent_Done,
     /*  46733 */   // Label 1026: @46733
     /*  46733 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(46787), // Rule ID 119 //
     /*  46738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46767 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46785 */     GIR_RootConstrainSelectedInstOperands,
     /*  46786 */     // GIR_Coverage, 119,
     /*  46786 */     GIR_EraseRootFromParent_Done,
     /*  46787 */   // Label 1027: @46787
     /*  46787 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(46841), // Rule ID 120 //
     /*  46792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46821 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46839 */     GIR_RootConstrainSelectedInstOperands,
     /*  46840 */     // GIR_Coverage, 120,
     /*  46840 */     GIR_EraseRootFromParent_Done,
     /*  46841 */   // Label 1028: @46841
     /*  46841 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(46895), // Rule ID 133 //
     /*  46846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46875 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46893 */     GIR_RootConstrainSelectedInstOperands,
     /*  46894 */     // GIR_Coverage, 133,
     /*  46894 */     GIR_EraseRootFromParent_Done,
     /*  46895 */   // Label 1029: @46895
     /*  46895 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(46949), // Rule ID 134 //
     /*  46900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46929 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46947 */     GIR_RootConstrainSelectedInstOperands,
     /*  46948 */     // GIR_Coverage, 134,
     /*  46948 */     GIR_EraseRootFromParent_Done,
     /*  46949 */   // Label 1030: @46949
     /*  46949 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(47003), // Rule ID 135 //
     /*  46954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46983 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47001 */     GIR_RootConstrainSelectedInstOperands,
     /*  47002 */     // GIR_Coverage, 135,
     /*  47002 */     GIR_EraseRootFromParent_Done,
     /*  47003 */   // Label 1031: @47003
     /*  47003 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(47057), // Rule ID 136 //
     /*  47008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  47016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47037 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  47040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47055 */     GIR_RootConstrainSelectedInstOperands,
     /*  47056 */     // GIR_Coverage, 136,
     /*  47056 */     GIR_EraseRootFromParent_Done,
     /*  47057 */   // Label 1032: @47057
     /*  47057 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(47111), // Rule ID 137 //
     /*  47062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  47070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47091 */     // (intrinsic_wo_chain:{ *:[i32] } 3872:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  47094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47109 */     GIR_RootConstrainSelectedInstOperands,
     /*  47110 */     // GIR_Coverage, 137,
     /*  47110 */     GIR_EraseRootFromParent_Done,
     /*  47111 */   // Label 1033: @47111
     /*  47111 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(47165), // Rule ID 138 //
     /*  47116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  47124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47145 */     // (intrinsic_wo_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  47148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47163 */     GIR_RootConstrainSelectedInstOperands,
     /*  47164 */     // GIR_Coverage, 138,
     /*  47164 */     GIR_EraseRootFromParent_Done,
     /*  47165 */   // Label 1034: @47165
     /*  47165 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(47219), // Rule ID 139 //
     /*  47170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  47178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47199 */     // (intrinsic_wo_chain:{ *:[i32] } 3919:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  47202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47217 */     GIR_RootConstrainSelectedInstOperands,
     /*  47218 */     // GIR_Coverage, 139,
     /*  47218 */     GIR_EraseRootFromParent_Done,
     /*  47219 */   // Label 1035: @47219
     /*  47219 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(47273), // Rule ID 140 //
     /*  47224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  47232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47253 */     // (intrinsic_wo_chain:{ *:[i32] } 3917:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  47256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47271 */     GIR_RootConstrainSelectedInstOperands,
     /*  47272 */     // GIR_Coverage, 140,
     /*  47272 */     GIR_EraseRootFromParent_Done,
     /*  47273 */   // Label 1036: @47273
     /*  47273 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(47327), // Rule ID 141 //
     /*  47278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  47286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47307 */     // (intrinsic_wo_chain:{ *:[i32] } 3918:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  47310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47325 */     GIR_RootConstrainSelectedInstOperands,
     /*  47326 */     // GIR_Coverage, 141,
     /*  47326 */     GIR_EraseRootFromParent_Done,
     /*  47327 */   // Label 1037: @47327
     /*  47327 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(47381), // Rule ID 142 //
     /*  47332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  47340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47361 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  47364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47379 */     GIR_RootConstrainSelectedInstOperands,
     /*  47380 */     // GIR_Coverage, 142,
     /*  47380 */     GIR_EraseRootFromParent_Done,
     /*  47381 */   // Label 1038: @47381
     /*  47381 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(47435), // Rule ID 143 //
     /*  47386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  47394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47415 */     // (intrinsic_wo_chain:{ *:[i32] } 3921:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  47418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47433 */     GIR_RootConstrainSelectedInstOperands,
     /*  47434 */     // GIR_Coverage, 143,
     /*  47434 */     GIR_EraseRootFromParent_Done,
     /*  47435 */   // Label 1039: @47435
     /*  47435 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(47489), // Rule ID 144 //
     /*  47440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  47448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47469 */     // (intrinsic_wo_chain:{ *:[i32] } 3922:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  47472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47487 */     GIR_RootConstrainSelectedInstOperands,
     /*  47488 */     // GIR_Coverage, 144,
     /*  47488 */     GIR_EraseRootFromParent_Done,
     /*  47489 */   // Label 1040: @47489
     /*  47489 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47543), // Rule ID 145 //
     /*  47494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  47497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  47502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47523 */     // (intrinsic_wo_chain:{ *:[i32] } 3930:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  47523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  47526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47541 */     GIR_RootConstrainSelectedInstOperands,
     /*  47542 */     // GIR_Coverage, 145,
     /*  47542 */     GIR_EraseRootFromParent_Done,
     /*  47543 */   // Label 1041: @47543
     /*  47543 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47588), // Rule ID 204 //
     /*  47548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  47556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47577 */     // (intrinsic_wo_chain:{ *:[i32] } 3490:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  47580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47586 */     GIR_RootConstrainSelectedInstOperands,
     /*  47587 */     // GIR_Coverage, 204,
     /*  47587 */     GIR_EraseRootFromParent_Done,
     /*  47588 */   // Label 1042: @47588
     /*  47588 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(47633), // Rule ID 205 //
     /*  47593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  47601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47622 */     // (intrinsic_wo_chain:{ *:[i32] } 3491:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  47625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47631 */     GIR_RootConstrainSelectedInstOperands,
     /*  47632 */     // GIR_Coverage, 205,
     /*  47632 */     GIR_EraseRootFromParent_Done,
     /*  47633 */   // Label 1043: @47633
     /*  47633 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(47678), // Rule ID 206 //
     /*  47638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47667 */     // (intrinsic_wo_chain:{ *:[i32] } 3494:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47676 */     GIR_RootConstrainSelectedInstOperands,
     /*  47677 */     // GIR_Coverage, 206,
     /*  47677 */     GIR_EraseRootFromParent_Done,
     /*  47678 */   // Label 1044: @47678
     /*  47678 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(47723), // Rule ID 207 //
     /*  47683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47712 */     // (intrinsic_wo_chain:{ *:[i32] } 3492:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47721 */     GIR_RootConstrainSelectedInstOperands,
     /*  47722 */     // GIR_Coverage, 207,
     /*  47722 */     GIR_EraseRootFromParent_Done,
     /*  47723 */   // Label 1045: @47723
     /*  47723 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(47768), // Rule ID 208 //
     /*  47728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47757 */     // (intrinsic_wo_chain:{ *:[i32] } 3495:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47766 */     GIR_RootConstrainSelectedInstOperands,
     /*  47767 */     // GIR_Coverage, 208,
     /*  47767 */     GIR_EraseRootFromParent_Done,
     /*  47768 */   // Label 1046: @47768
     /*  47768 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(47813), // Rule ID 209 //
     /*  47773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47802 */     // (intrinsic_wo_chain:{ *:[i32] } 3493:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47811 */     GIR_RootConstrainSelectedInstOperands,
     /*  47812 */     // GIR_Coverage, 209,
     /*  47812 */     GIR_EraseRootFromParent_Done,
     /*  47813 */   // Label 1047: @47813
     /*  47813 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(47867), // Rule ID 432 //
     /*  47818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47847 */     // (intrinsic_wo_chain:{ *:[i32] } 3856:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47865 */     GIR_RootConstrainSelectedInstOperands,
     /*  47866 */     // GIR_Coverage, 432,
     /*  47866 */     GIR_EraseRootFromParent_Done,
     /*  47867 */   // Label 1048: @47867
     /*  47867 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(47921), // Rule ID 433 //
     /*  47872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47901 */     // (intrinsic_wo_chain:{ *:[i32] } 3857:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47919 */     GIR_RootConstrainSelectedInstOperands,
     /*  47920 */     // GIR_Coverage, 433,
     /*  47920 */     GIR_EraseRootFromParent_Done,
     /*  47921 */   // Label 1049: @47921
     /*  47921 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(47975), // Rule ID 434 //
     /*  47926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47955 */     // (intrinsic_wo_chain:{ *:[i32] } 3858:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47973 */     GIR_RootConstrainSelectedInstOperands,
     /*  47974 */     // GIR_Coverage, 434,
     /*  47974 */     GIR_EraseRootFromParent_Done,
     /*  47975 */   // Label 1050: @47975
     /*  47975 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(48029), // Rule ID 435 //
     /*  47980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48009 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  48012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48027 */     GIR_RootConstrainSelectedInstOperands,
     /*  48028 */     // GIR_Coverage, 435,
     /*  48028 */     GIR_EraseRootFromParent_Done,
     /*  48029 */   // Label 1051: @48029
     /*  48029 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(48083), // Rule ID 436 //
     /*  48034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  48042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48063 */     // (intrinsic_wo_chain:{ *:[i32] } 3859:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  48066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48081 */     GIR_RootConstrainSelectedInstOperands,
     /*  48082 */     // GIR_Coverage, 436,
     /*  48082 */     GIR_EraseRootFromParent_Done,
     /*  48083 */   // Label 1052: @48083
     /*  48083 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(48137), // Rule ID 437 //
     /*  48088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  48096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48117 */     // (intrinsic_wo_chain:{ *:[i32] } 3861:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  48120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48135 */     GIR_RootConstrainSelectedInstOperands,
     /*  48136 */     // GIR_Coverage, 437,
     /*  48136 */     GIR_EraseRootFromParent_Done,
     /*  48137 */   // Label 1053: @48137
     /*  48137 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(48191), // Rule ID 438 //
     /*  48142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  48150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48171 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  48174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48189 */     GIR_RootConstrainSelectedInstOperands,
     /*  48190 */     // GIR_Coverage, 438,
     /*  48190 */     GIR_EraseRootFromParent_Done,
     /*  48191 */   // Label 1054: @48191
     /*  48191 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(48245), // Rule ID 439 //
     /*  48196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  48204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48225 */     // (intrinsic_wo_chain:{ *:[i32] } 3924:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  48228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48243 */     GIR_RootConstrainSelectedInstOperands,
     /*  48244 */     // GIR_Coverage, 439,
     /*  48244 */     GIR_EraseRootFromParent_Done,
     /*  48245 */   // Label 1055: @48245
     /*  48245 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(48299), // Rule ID 440 //
     /*  48250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  48258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48279 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  48282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48297 */     GIR_RootConstrainSelectedInstOperands,
     /*  48298 */     // GIR_Coverage, 440,
     /*  48298 */     GIR_EraseRootFromParent_Done,
     /*  48299 */   // Label 1056: @48299
     /*  48299 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(48353), // Rule ID 441 //
     /*  48304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  48312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48333 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  48336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48351 */     GIR_RootConstrainSelectedInstOperands,
     /*  48352 */     // GIR_Coverage, 441,
     /*  48352 */     GIR_EraseRootFromParent_Done,
     /*  48353 */   // Label 1057: @48353
     /*  48353 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(48407), // Rule ID 442 //
     /*  48358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  48366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48387 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  48390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48405 */     GIR_RootConstrainSelectedInstOperands,
     /*  48406 */     // GIR_Coverage, 442,
     /*  48406 */     GIR_EraseRootFromParent_Done,
     /*  48407 */   // Label 1058: @48407
     /*  48407 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(48461), // Rule ID 443 //
     /*  48412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  48420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48441 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  48444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48459 */     GIR_RootConstrainSelectedInstOperands,
     /*  48460 */     // GIR_Coverage, 443,
     /*  48460 */     GIR_EraseRootFromParent_Done,
     /*  48461 */   // Label 1059: @48461
     /*  48461 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48515), // Rule ID 456 //
     /*  48466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  48474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48495 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  48498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48513 */     GIR_RootConstrainSelectedInstOperands,
     /*  48514 */     // GIR_Coverage, 456,
     /*  48514 */     GIR_EraseRootFromParent_Done,
     /*  48515 */   // Label 1060: @48515
     /*  48515 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48569), // Rule ID 457 //
     /*  48520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  48528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48549 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  48552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48567 */     GIR_RootConstrainSelectedInstOperands,
     /*  48568 */     // GIR_Coverage, 457,
     /*  48568 */     GIR_EraseRootFromParent_Done,
     /*  48569 */   // Label 1061: @48569
     /*  48569 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(48623), // Rule ID 458 //
     /*  48574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  48582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48603 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  48606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48621 */     GIR_RootConstrainSelectedInstOperands,
     /*  48622 */     // GIR_Coverage, 458,
     /*  48622 */     GIR_EraseRootFromParent_Done,
     /*  48623 */   // Label 1062: @48623
     /*  48623 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(48677), // Rule ID 459 //
     /*  48628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48657 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48675 */     GIR_RootConstrainSelectedInstOperands,
     /*  48676 */     // GIR_Coverage, 459,
     /*  48676 */     GIR_EraseRootFromParent_Done,
     /*  48677 */   // Label 1063: @48677
     /*  48677 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(48731), // Rule ID 460 //
     /*  48682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48711 */     // (intrinsic_wo_chain:{ *:[i32] } 3872:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48729 */     GIR_RootConstrainSelectedInstOperands,
     /*  48730 */     // GIR_Coverage, 460,
     /*  48730 */     GIR_EraseRootFromParent_Done,
     /*  48731 */   // Label 1064: @48731
     /*  48731 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(48785), // Rule ID 461 //
     /*  48736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48765 */     // (intrinsic_wo_chain:{ *:[i32] } 3873:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48783 */     GIR_RootConstrainSelectedInstOperands,
     /*  48784 */     // GIR_Coverage, 461,
     /*  48784 */     GIR_EraseRootFromParent_Done,
     /*  48785 */   // Label 1065: @48785
     /*  48785 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(48839), // Rule ID 462 //
     /*  48790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48819 */     // (intrinsic_wo_chain:{ *:[i32] } 3919:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48837 */     GIR_RootConstrainSelectedInstOperands,
     /*  48838 */     // GIR_Coverage, 462,
     /*  48838 */     GIR_EraseRootFromParent_Done,
     /*  48839 */   // Label 1066: @48839
     /*  48839 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(48893), // Rule ID 463 //
     /*  48844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48873 */     // (intrinsic_wo_chain:{ *:[i32] } 3917:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48891 */     GIR_RootConstrainSelectedInstOperands,
     /*  48892 */     // GIR_Coverage, 463,
     /*  48892 */     GIR_EraseRootFromParent_Done,
     /*  48893 */   // Label 1067: @48893
     /*  48893 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(48947), // Rule ID 464 //
     /*  48898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48927 */     // (intrinsic_wo_chain:{ *:[i32] } 3918:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48945 */     GIR_RootConstrainSelectedInstOperands,
     /*  48946 */     // GIR_Coverage, 464,
     /*  48946 */     GIR_EraseRootFromParent_Done,
     /*  48947 */   // Label 1068: @48947
     /*  48947 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(49001), // Rule ID 465 //
     /*  48952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48981 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48999 */     GIR_RootConstrainSelectedInstOperands,
     /*  49000 */     // GIR_Coverage, 465,
     /*  49000 */     GIR_EraseRootFromParent_Done,
     /*  49001 */   // Label 1069: @49001
     /*  49001 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(49055), // Rule ID 466 //
     /*  49006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  49014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49035 */     // (intrinsic_wo_chain:{ *:[i32] } 3921:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  49038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49053 */     GIR_RootConstrainSelectedInstOperands,
     /*  49054 */     // GIR_Coverage, 466,
     /*  49054 */     GIR_EraseRootFromParent_Done,
     /*  49055 */   // Label 1070: @49055
     /*  49055 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(49109), // Rule ID 467 //
     /*  49060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  49068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49089 */     // (intrinsic_wo_chain:{ *:[i32] } 3922:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  49092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49107 */     GIR_RootConstrainSelectedInstOperands,
     /*  49108 */     // GIR_Coverage, 467,
     /*  49108 */     GIR_EraseRootFromParent_Done,
     /*  49109 */   // Label 1071: @49109
     /*  49109 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(49163), // Rule ID 468 //
     /*  49114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  49122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49143 */     // (intrinsic_wo_chain:{ *:[i32] } 3930:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  49146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49161 */     GIR_RootConstrainSelectedInstOperands,
     /*  49162 */     // GIR_Coverage, 468,
     /*  49162 */     GIR_EraseRootFromParent_Done,
     /*  49163 */   // Label 1072: @49163
     /*  49163 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(49217), // Rule ID 524 //
     /*  49168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  49176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49197 */     // (intrinsic_wo_chain:{ *:[i32] } 3888:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  49200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49215 */     GIR_RootConstrainSelectedInstOperands,
     /*  49216 */     // GIR_Coverage, 524,
     /*  49216 */     GIR_EraseRootFromParent_Done,
     /*  49217 */   // Label 1073: @49217
     /*  49217 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(49271), // Rule ID 525 //
     /*  49222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  49230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49251 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  49254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49269 */     GIR_RootConstrainSelectedInstOperands,
     /*  49270 */     // GIR_Coverage, 525,
     /*  49270 */     GIR_EraseRootFromParent_Done,
     /*  49271 */   // Label 1074: @49271
     /*  49271 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(49325), // Rule ID 526 //
     /*  49276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  49284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49305 */     // (intrinsic_wo_chain:{ *:[i32] } 3896:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  49308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49323 */     GIR_RootConstrainSelectedInstOperands,
     /*  49324 */     // GIR_Coverage, 526,
     /*  49324 */     GIR_EraseRootFromParent_Done,
     /*  49325 */   // Label 1075: @49325
     /*  49325 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(49379), // Rule ID 527 //
     /*  49330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  49338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49359 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  49362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49377 */     GIR_RootConstrainSelectedInstOperands,
     /*  49378 */     // GIR_Coverage, 527,
     /*  49378 */     GIR_EraseRootFromParent_Done,
     /*  49379 */   // Label 1076: @49379
     /*  49379 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(49424), // Rule ID 541 //
     /*  49384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  49392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49413 */     // (intrinsic_wo_chain:{ *:[i32] } 3490:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  49416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49422 */     GIR_RootConstrainSelectedInstOperands,
     /*  49423 */     // GIR_Coverage, 541,
     /*  49423 */     GIR_EraseRootFromParent_Done,
     /*  49424 */   // Label 1077: @49424
     /*  49424 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(49469), // Rule ID 542 //
     /*  49429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  49437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49458 */     // (intrinsic_wo_chain:{ *:[i32] } 3491:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  49461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49467 */     GIR_RootConstrainSelectedInstOperands,
     /*  49468 */     // GIR_Coverage, 542,
     /*  49468 */     GIR_EraseRootFromParent_Done,
     /*  49469 */   // Label 1078: @49469
     /*  49469 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49514), // Rule ID 543 //
     /*  49474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  49482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49503 */     // (intrinsic_wo_chain:{ *:[i32] } 3494:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  49506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49512 */     GIR_RootConstrainSelectedInstOperands,
     /*  49513 */     // GIR_Coverage, 543,
     /*  49513 */     GIR_EraseRootFromParent_Done,
     /*  49514 */   // Label 1079: @49514
     /*  49514 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49559), // Rule ID 544 //
     /*  49519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  49527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49548 */     // (intrinsic_wo_chain:{ *:[i32] } 3492:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  49551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49557 */     GIR_RootConstrainSelectedInstOperands,
     /*  49558 */     // GIR_Coverage, 544,
     /*  49558 */     GIR_EraseRootFromParent_Done,
     /*  49559 */   // Label 1080: @49559
     /*  49559 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(49604), // Rule ID 545 //
     /*  49564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  49572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49593 */     // (intrinsic_wo_chain:{ *:[i32] } 3495:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  49596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49602 */     GIR_RootConstrainSelectedInstOperands,
     /*  49603 */     // GIR_Coverage, 545,
     /*  49603 */     GIR_EraseRootFromParent_Done,
     /*  49604 */   // Label 1081: @49604
     /*  49604 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(49649), // Rule ID 546 //
     /*  49609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  49617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49638 */     // (intrinsic_wo_chain:{ *:[i32] } 3493:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49647 */     GIR_RootConstrainSelectedInstOperands,
     /*  49648 */     // GIR_Coverage, 546,
     /*  49648 */     GIR_EraseRootFromParent_Done,
     /*  49649 */   // Label 1082: @49649
     /*  49649 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(49703), // Rule ID 792 //
     /*  49654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49683 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3760:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49701 */     GIR_RootConstrainSelectedInstOperands,
     /*  49702 */     // GIR_Coverage, 792,
     /*  49702 */     GIR_EraseRootFromParent_Done,
     /*  49703 */   // Label 1083: @49703
     /*  49703 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(49757), // Rule ID 793 //
     /*  49708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49737 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3760:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49755 */     GIR_RootConstrainSelectedInstOperands,
     /*  49756 */     // GIR_Coverage, 793,
     /*  49756 */     GIR_EraseRootFromParent_Done,
     /*  49757 */   // Label 1084: @49757
     /*  49757 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(49811), // Rule ID 794 //
     /*  49762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49791 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3760:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49809 */     GIR_RootConstrainSelectedInstOperands,
     /*  49810 */     // GIR_Coverage, 794,
     /*  49810 */     GIR_EraseRootFromParent_Done,
     /*  49811 */   // Label 1085: @49811
     /*  49811 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(49865), // Rule ID 795 //
     /*  49816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49845 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3760:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49863 */     GIR_RootConstrainSelectedInstOperands,
     /*  49864 */     // GIR_Coverage, 795,
     /*  49864 */     GIR_EraseRootFromParent_Done,
     /*  49865 */   // Label 1086: @49865
     /*  49865 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(49919), // Rule ID 796 //
     /*  49870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49899 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3760:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49917 */     GIR_RootConstrainSelectedInstOperands,
     /*  49918 */     // GIR_Coverage, 796,
     /*  49918 */     GIR_EraseRootFromParent_Done,
     /*  49919 */   // Label 1087: @49919
     /*  49919 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(49973), // Rule ID 797 //
     /*  49924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49953 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3760:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49971 */     GIR_RootConstrainSelectedInstOperands,
     /*  49972 */     // GIR_Coverage, 797,
     /*  49972 */     GIR_EraseRootFromParent_Done,
     /*  49973 */   // Label 1088: @49973
     /*  49973 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(50027), // Rule ID 798 //
     /*  49978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50007 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3761:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  50010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50025 */     GIR_RootConstrainSelectedInstOperands,
     /*  50026 */     // GIR_Coverage, 798,
     /*  50026 */     GIR_EraseRootFromParent_Done,
     /*  50027 */   // Label 1089: @50027
     /*  50027 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(50081), // Rule ID 799 //
     /*  50032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50061 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3761:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  50064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50079 */     GIR_RootConstrainSelectedInstOperands,
     /*  50080 */     // GIR_Coverage, 799,
     /*  50080 */     GIR_EraseRootFromParent_Done,
     /*  50081 */   // Label 1090: @50081
     /*  50081 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(50135), // Rule ID 800 //
     /*  50086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50115 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3761:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  50118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50133 */     GIR_RootConstrainSelectedInstOperands,
     /*  50134 */     // GIR_Coverage, 800,
     /*  50134 */     GIR_EraseRootFromParent_Done,
     /*  50135 */   // Label 1091: @50135
     /*  50135 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(50189), // Rule ID 801 //
     /*  50140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50169 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3761:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  50172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50187 */     GIR_RootConstrainSelectedInstOperands,
     /*  50188 */     // GIR_Coverage, 801,
     /*  50188 */     GIR_EraseRootFromParent_Done,
     /*  50189 */   // Label 1092: @50189
     /*  50189 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(50243), // Rule ID 802 //
     /*  50194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50223 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3761:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  50226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50241 */     GIR_RootConstrainSelectedInstOperands,
     /*  50242 */     // GIR_Coverage, 802,
     /*  50242 */     GIR_EraseRootFromParent_Done,
     /*  50243 */   // Label 1093: @50243
     /*  50243 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(50297), // Rule ID 803 //
     /*  50248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50277 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3761:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  50280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50295 */     GIR_RootConstrainSelectedInstOperands,
     /*  50296 */     // GIR_Coverage, 803,
     /*  50296 */     GIR_EraseRootFromParent_Done,
     /*  50297 */   // Label 1094: @50297
     /*  50297 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(50351), // Rule ID 804 //
     /*  50302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50331 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3820:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  50334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50349 */     GIR_RootConstrainSelectedInstOperands,
     /*  50350 */     // GIR_Coverage, 804,
     /*  50350 */     GIR_EraseRootFromParent_Done,
     /*  50351 */   // Label 1095: @50351
     /*  50351 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(50405), // Rule ID 805 //
     /*  50356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50385 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3820:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  50388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50403 */     GIR_RootConstrainSelectedInstOperands,
     /*  50404 */     // GIR_Coverage, 805,
     /*  50404 */     GIR_EraseRootFromParent_Done,
     /*  50405 */   // Label 1096: @50405
     /*  50405 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(50459), // Rule ID 806 //
     /*  50410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50439 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3820:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  50442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50457 */     GIR_RootConstrainSelectedInstOperands,
     /*  50458 */     // GIR_Coverage, 806,
     /*  50458 */     GIR_EraseRootFromParent_Done,
     /*  50459 */   // Label 1097: @50459
     /*  50459 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50513), // Rule ID 807 //
     /*  50464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50493 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3820:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  50496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50511 */     GIR_RootConstrainSelectedInstOperands,
     /*  50512 */     // GIR_Coverage, 807,
     /*  50512 */     GIR_EraseRootFromParent_Done,
     /*  50513 */   // Label 1098: @50513
     /*  50513 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50567), // Rule ID 808 //
     /*  50518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50547 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3820:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  50550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50565 */     GIR_RootConstrainSelectedInstOperands,
     /*  50566 */     // GIR_Coverage, 808,
     /*  50566 */     GIR_EraseRootFromParent_Done,
     /*  50567 */   // Label 1099: @50567
     /*  50567 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(50621), // Rule ID 809 //
     /*  50572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50601 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3820:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  50604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50619 */     GIR_RootConstrainSelectedInstOperands,
     /*  50620 */     // GIR_Coverage, 809,
     /*  50620 */     GIR_EraseRootFromParent_Done,
     /*  50621 */   // Label 1100: @50621
     /*  50621 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(50675), // Rule ID 810 //
     /*  50626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50655 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3821:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50673 */     GIR_RootConstrainSelectedInstOperands,
     /*  50674 */     // GIR_Coverage, 810,
     /*  50674 */     GIR_EraseRootFromParent_Done,
     /*  50675 */   // Label 1101: @50675
     /*  50675 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(50729), // Rule ID 811 //
     /*  50680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50709 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3821:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50727 */     GIR_RootConstrainSelectedInstOperands,
     /*  50728 */     // GIR_Coverage, 811,
     /*  50728 */     GIR_EraseRootFromParent_Done,
     /*  50729 */   // Label 1102: @50729
     /*  50729 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(50783), // Rule ID 812 //
     /*  50734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50763 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3821:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50781 */     GIR_RootConstrainSelectedInstOperands,
     /*  50782 */     // GIR_Coverage, 812,
     /*  50782 */     GIR_EraseRootFromParent_Done,
     /*  50783 */   // Label 1103: @50783
     /*  50783 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(50837), // Rule ID 813 //
     /*  50788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50817 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3821:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50835 */     GIR_RootConstrainSelectedInstOperands,
     /*  50836 */     // GIR_Coverage, 813,
     /*  50836 */     GIR_EraseRootFromParent_Done,
     /*  50837 */   // Label 1104: @50837
     /*  50837 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(50891), // Rule ID 814 //
     /*  50842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50871 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3821:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50889 */     GIR_RootConstrainSelectedInstOperands,
     /*  50890 */     // GIR_Coverage, 814,
     /*  50890 */     GIR_EraseRootFromParent_Done,
     /*  50891 */   // Label 1105: @50891
     /*  50891 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(50945), // Rule ID 815 //
     /*  50896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50925 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3821:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50943 */     GIR_RootConstrainSelectedInstOperands,
     /*  50944 */     // GIR_Coverage, 815,
     /*  50944 */     GIR_EraseRootFromParent_Done,
     /*  50945 */   // Label 1106: @50945
     /*  50945 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(50999), // Rule ID 832 //
     /*  50950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50979 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3817:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50997 */     GIR_RootConstrainSelectedInstOperands,
     /*  50998 */     // GIR_Coverage, 832,
     /*  50998 */     GIR_EraseRootFromParent_Done,
     /*  50999 */   // Label 1107: @50999
     /*  50999 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(51053), // Rule ID 833 //
     /*  51004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  51012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51033 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3817:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  51036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51051 */     GIR_RootConstrainSelectedInstOperands,
     /*  51052 */     // GIR_Coverage, 833,
     /*  51052 */     GIR_EraseRootFromParent_Done,
     /*  51053 */   // Label 1108: @51053
     /*  51053 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(51107), // Rule ID 834 //
     /*  51058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  51066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  51072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  51075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51087 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3817:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  51087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  51090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51105 */     GIR_RootConstrainSelectedInstOperands,
     /*  51106 */     // GIR_Coverage, 834,
     /*  51106 */     GIR_EraseRootFromParent_Done,
     /*  51107 */   // Label 1109: @51107
     /*  51107 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(51161), // Rule ID 841 //
     /*  51112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  51120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51141 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3786:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  51144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51159 */     GIR_RootConstrainSelectedInstOperands,
     /*  51160 */     // GIR_Coverage, 841,
     /*  51160 */     GIR_EraseRootFromParent_Done,
     /*  51161 */   // Label 1110: @51161
     /*  51161 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(51215), // Rule ID 842 //
     /*  51166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  51174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51195 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3786:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  51198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51213 */     GIR_RootConstrainSelectedInstOperands,
     /*  51214 */     // GIR_Coverage, 842,
     /*  51214 */     GIR_EraseRootFromParent_Done,
     /*  51215 */   // Label 1111: @51215
     /*  51215 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(51269), // Rule ID 855 //
     /*  51220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51249 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3797:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  51252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51267 */     GIR_RootConstrainSelectedInstOperands,
     /*  51268 */     // GIR_Coverage, 855,
     /*  51268 */     GIR_EraseRootFromParent_Done,
     /*  51269 */   // Label 1112: @51269
     /*  51269 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(51323), // Rule ID 856 //
     /*  51274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51303 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3797:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  51306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51321 */     GIR_RootConstrainSelectedInstOperands,
     /*  51322 */     // GIR_Coverage, 856,
     /*  51322 */     GIR_EraseRootFromParent_Done,
     /*  51323 */   // Label 1113: @51323
     /*  51323 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(51377), // Rule ID 857 //
     /*  51328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51357 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3797:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  51360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51375 */     GIR_RootConstrainSelectedInstOperands,
     /*  51376 */     // GIR_Coverage, 857,
     /*  51376 */     GIR_EraseRootFromParent_Done,
     /*  51377 */   // Label 1114: @51377
     /*  51377 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(51431), // Rule ID 858 //
     /*  51382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51411 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3797:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  51414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51429 */     GIR_RootConstrainSelectedInstOperands,
     /*  51430 */     // GIR_Coverage, 858,
     /*  51430 */     GIR_EraseRootFromParent_Done,
     /*  51431 */   // Label 1115: @51431
     /*  51431 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51485), // Rule ID 863 //
     /*  51436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51465 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3805:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  51468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51483 */     GIR_RootConstrainSelectedInstOperands,
     /*  51484 */     // GIR_Coverage, 863,
     /*  51484 */     GIR_EraseRootFromParent_Done,
     /*  51485 */   // Label 1116: @51485
     /*  51485 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51539), // Rule ID 864 //
     /*  51490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51519 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3805:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  51522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51537 */     GIR_RootConstrainSelectedInstOperands,
     /*  51538 */     // GIR_Coverage, 864,
     /*  51538 */     GIR_EraseRootFromParent_Done,
     /*  51539 */   // Label 1117: @51539
     /*  51539 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51593), // Rule ID 865 //
     /*  51544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51573 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3805:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  51576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51591 */     GIR_RootConstrainSelectedInstOperands,
     /*  51592 */     // GIR_Coverage, 865,
     /*  51592 */     GIR_EraseRootFromParent_Done,
     /*  51593 */   // Label 1118: @51593
     /*  51593 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(51647), // Rule ID 866 //
     /*  51598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51627 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3805:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  51630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51645 */     GIR_RootConstrainSelectedInstOperands,
     /*  51646 */     // GIR_Coverage, 866,
     /*  51646 */     GIR_EraseRootFromParent_Done,
     /*  51647 */   // Label 1119: @51647
     /*  51647 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(51701), // Rule ID 877 //
     /*  51652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51681 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3783:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51699 */     GIR_RootConstrainSelectedInstOperands,
     /*  51700 */     // GIR_Coverage, 877,
     /*  51700 */     GIR_EraseRootFromParent_Done,
     /*  51701 */   // Label 1120: @51701
     /*  51701 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(51746), // Rule ID 878 //
     /*  51706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51735 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3783:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51744 */     GIR_RootConstrainSelectedInstOperands,
     /*  51745 */     // GIR_Coverage, 878,
     /*  51745 */     GIR_EraseRootFromParent_Done,
     /*  51746 */   // Label 1121: @51746
     /*  51746 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(51800), // Rule ID 883 //
     /*  51751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51780 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51798 */     GIR_RootConstrainSelectedInstOperands,
     /*  51799 */     // GIR_Coverage, 883,
     /*  51799 */     GIR_EraseRootFromParent_Done,
     /*  51800 */   // Label 1122: @51800
     /*  51800 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(51854), // Rule ID 884 //
     /*  51805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51834 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51852 */     GIR_RootConstrainSelectedInstOperands,
     /*  51853 */     // GIR_Coverage, 884,
     /*  51853 */     GIR_EraseRootFromParent_Done,
     /*  51854 */   // Label 1123: @51854
     /*  51854 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(51908), // Rule ID 996 //
     /*  51859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51888 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3762:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51906 */     GIR_RootConstrainSelectedInstOperands,
     /*  51907 */     // GIR_Coverage, 996,
     /*  51907 */     GIR_EraseRootFromParent_Done,
     /*  51908 */   // Label 1124: @51908
     /*  51908 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(51962), // Rule ID 997 //
     /*  51913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51942 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3762:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51960 */     GIR_RootConstrainSelectedInstOperands,
     /*  51961 */     // GIR_Coverage, 997,
     /*  51961 */     GIR_EraseRootFromParent_Done,
     /*  51962 */   // Label 1125: @51962
     /*  51962 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(52016), // Rule ID 998 //
     /*  51967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51996 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3762:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52014 */     GIR_RootConstrainSelectedInstOperands,
     /*  52015 */     // GIR_Coverage, 998,
     /*  52015 */     GIR_EraseRootFromParent_Done,
     /*  52016 */   // Label 1126: @52016
     /*  52016 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(52070), // Rule ID 999 //
     /*  52021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  52029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52050 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3762:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  52053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52068 */     GIR_RootConstrainSelectedInstOperands,
     /*  52069 */     // GIR_Coverage, 999,
     /*  52069 */     GIR_EraseRootFromParent_Done,
     /*  52070 */   // Label 1127: @52070
     /*  52070 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(52124), // Rule ID 1000 //
     /*  52075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  52083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52104 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3762:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  52107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52122 */     GIR_RootConstrainSelectedInstOperands,
     /*  52123 */     // GIR_Coverage, 1000,
     /*  52123 */     GIR_EraseRootFromParent_Done,
     /*  52124 */   // Label 1128: @52124
     /*  52124 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(52178), // Rule ID 1001 //
     /*  52129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  52137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52158 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3762:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  52161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52176 */     GIR_RootConstrainSelectedInstOperands,
     /*  52177 */     // GIR_Coverage, 1001,
     /*  52177 */     GIR_EraseRootFromParent_Done,
     /*  52178 */   // Label 1129: @52178
     /*  52178 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(52232), // Rule ID 1002 //
     /*  52183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52212 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3763:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  52212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  52215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52230 */     GIR_RootConstrainSelectedInstOperands,
     /*  52231 */     // GIR_Coverage, 1002,
     /*  52231 */     GIR_EraseRootFromParent_Done,
     /*  52232 */   // Label 1130: @52232
     /*  52232 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(52286), // Rule ID 1003 //
     /*  52237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52266 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3763:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  52266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  52269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52284 */     GIR_RootConstrainSelectedInstOperands,
     /*  52285 */     // GIR_Coverage, 1003,
     /*  52285 */     GIR_EraseRootFromParent_Done,
     /*  52286 */   // Label 1131: @52286
     /*  52286 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(52340), // Rule ID 1004 //
     /*  52291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52320 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3763:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  52323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52338 */     GIR_RootConstrainSelectedInstOperands,
     /*  52339 */     // GIR_Coverage, 1004,
     /*  52339 */     GIR_EraseRootFromParent_Done,
     /*  52340 */   // Label 1132: @52340
     /*  52340 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(52394), // Rule ID 1005 //
     /*  52345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52374 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3763:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  52377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52392 */     GIR_RootConstrainSelectedInstOperands,
     /*  52393 */     // GIR_Coverage, 1005,
     /*  52393 */     GIR_EraseRootFromParent_Done,
     /*  52394 */   // Label 1133: @52394
     /*  52394 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(52448), // Rule ID 1006 //
     /*  52399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52428 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3763:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  52431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52446 */     GIR_RootConstrainSelectedInstOperands,
     /*  52447 */     // GIR_Coverage, 1006,
     /*  52447 */     GIR_EraseRootFromParent_Done,
     /*  52448 */   // Label 1134: @52448
     /*  52448 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52502), // Rule ID 1007 //
     /*  52453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52482 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3763:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  52485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52500 */     GIR_RootConstrainSelectedInstOperands,
     /*  52501 */     // GIR_Coverage, 1007,
     /*  52501 */     GIR_EraseRootFromParent_Done,
     /*  52502 */   // Label 1135: @52502
     /*  52502 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52556), // Rule ID 1024 //
     /*  52507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52536 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3833:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  52539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52554 */     GIR_RootConstrainSelectedInstOperands,
     /*  52555 */     // GIR_Coverage, 1024,
     /*  52555 */     GIR_EraseRootFromParent_Done,
     /*  52556 */   // Label 1136: @52556
     /*  52556 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(52610), // Rule ID 1025 //
     /*  52561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52590 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3833:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  52593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52608 */     GIR_RootConstrainSelectedInstOperands,
     /*  52609 */     // GIR_Coverage, 1025,
     /*  52609 */     GIR_EraseRootFromParent_Done,
     /*  52610 */   // Label 1137: @52610
     /*  52610 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(52664), // Rule ID 1026 //
     /*  52615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  52632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52644 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3833:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52662 */     GIR_RootConstrainSelectedInstOperands,
     /*  52663 */     // GIR_Coverage, 1026,
     /*  52663 */     GIR_EraseRootFromParent_Done,
     /*  52664 */   // Label 1138: @52664
     /*  52664 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(52718), // Rule ID 1119 //
     /*  52669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52698 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3738:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52716 */     GIR_RootConstrainSelectedInstOperands,
     /*  52717 */     // GIR_Coverage, 1119,
     /*  52717 */     GIR_EraseRootFromParent_Done,
     /*  52718 */   // Label 1139: @52718
     /*  52718 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(52772), // Rule ID 1120 //
     /*  52723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52752 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3738:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52770 */     GIR_RootConstrainSelectedInstOperands,
     /*  52771 */     // GIR_Coverage, 1120,
     /*  52771 */     GIR_EraseRootFromParent_Done,
     /*  52772 */   // Label 1140: @52772
     /*  52772 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(52826), // Rule ID 1121 //
     /*  52777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52806 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3738:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52824 */     GIR_RootConstrainSelectedInstOperands,
     /*  52825 */     // GIR_Coverage, 1121,
     /*  52825 */     GIR_EraseRootFromParent_Done,
     /*  52826 */   // Label 1141: @52826
     /*  52826 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(52880), // Rule ID 1122 //
     /*  52831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52860 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3738:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52878 */     GIR_RootConstrainSelectedInstOperands,
     /*  52879 */     // GIR_Coverage, 1122,
     /*  52879 */     GIR_EraseRootFromParent_Done,
     /*  52880 */   // Label 1142: @52880
     /*  52880 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(52934), // Rule ID 1123 //
     /*  52885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52914 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3739:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52932 */     GIR_RootConstrainSelectedInstOperands,
     /*  52933 */     // GIR_Coverage, 1123,
     /*  52933 */     GIR_EraseRootFromParent_Done,
     /*  52934 */   // Label 1143: @52934
     /*  52934 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(52988), // Rule ID 1124 //
     /*  52939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52968 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3739:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52986 */     GIR_RootConstrainSelectedInstOperands,
     /*  52987 */     // GIR_Coverage, 1124,
     /*  52987 */     GIR_EraseRootFromParent_Done,
     /*  52988 */   // Label 1144: @52988
     /*  52988 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(53042), // Rule ID 1125 //
     /*  52993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  53001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53022 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3739:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  53025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53040 */     GIR_RootConstrainSelectedInstOperands,
     /*  53041 */     // GIR_Coverage, 1125,
     /*  53041 */     GIR_EraseRootFromParent_Done,
     /*  53042 */   // Label 1145: @53042
     /*  53042 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(53096), // Rule ID 1126 //
     /*  53047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  53055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53076 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3739:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  53076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  53079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53094 */     GIR_RootConstrainSelectedInstOperands,
     /*  53095 */     // GIR_Coverage, 1126,
     /*  53095 */     GIR_EraseRootFromParent_Done,
     /*  53096 */   // Label 1146: @53096
     /*  53096 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(53150), // Rule ID 1169 //
     /*  53101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53130 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3735:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  53133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53148 */     GIR_RootConstrainSelectedInstOperands,
     /*  53149 */     // GIR_Coverage, 1169,
     /*  53149 */     GIR_EraseRootFromParent_Done,
     /*  53150 */   // Label 1147: @53150
     /*  53150 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(53204), // Rule ID 1170 //
     /*  53155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53184 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3735:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  53184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  53187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53202 */     GIR_RootConstrainSelectedInstOperands,
     /*  53203 */     // GIR_Coverage, 1170,
     /*  53203 */     GIR_EraseRootFromParent_Done,
     /*  53204 */   // Label 1148: @53204
     /*  53204 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(53258), // Rule ID 1171 //
     /*  53209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53238 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3735:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  53241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53256 */     GIR_RootConstrainSelectedInstOperands,
     /*  53257 */     // GIR_Coverage, 1171,
     /*  53257 */     GIR_EraseRootFromParent_Done,
     /*  53258 */   // Label 1149: @53258
     /*  53258 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(53312), // Rule ID 1172 //
     /*  53263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53292 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3735:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  53292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  53295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53310 */     GIR_RootConstrainSelectedInstOperands,
     /*  53311 */     // GIR_Coverage, 1172,
     /*  53311 */     GIR_EraseRootFromParent_Done,
     /*  53312 */   // Label 1150: @53312
     /*  53312 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(53366), // Rule ID 1237 //
     /*  53317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53346 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3789:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  53349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53364 */     GIR_RootConstrainSelectedInstOperands,
     /*  53365 */     // GIR_Coverage, 1237,
     /*  53365 */     GIR_EraseRootFromParent_Done,
     /*  53366 */   // Label 1151: @53366
     /*  53366 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(53420), // Rule ID 1238 //
     /*  53371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53400 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3789:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  53403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53418 */     GIR_RootConstrainSelectedInstOperands,
     /*  53419 */     // GIR_Coverage, 1238,
     /*  53419 */     GIR_EraseRootFromParent_Done,
     /*  53420 */   // Label 1152: @53420
     /*  53420 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53474), // Rule ID 1239 //
     /*  53425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53454 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3789:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  53457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53472 */     GIR_RootConstrainSelectedInstOperands,
     /*  53473 */     // GIR_Coverage, 1239,
     /*  53473 */     GIR_EraseRootFromParent_Done,
     /*  53474 */   // Label 1153: @53474
     /*  53474 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53528), // Rule ID 1240 //
     /*  53479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53508 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3789:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  53511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53526 */     GIR_RootConstrainSelectedInstOperands,
     /*  53527 */     // GIR_Coverage, 1240,
     /*  53527 */     GIR_EraseRootFromParent_Done,
     /*  53528 */   // Label 1154: @53528
     /*  53528 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53582), // Rule ID 1241 //
     /*  53533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53562 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3789:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  53565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53580 */     GIR_RootConstrainSelectedInstOperands,
     /*  53581 */     // GIR_Coverage, 1241,
     /*  53581 */     GIR_EraseRootFromParent_Done,
     /*  53582 */   // Label 1155: @53582
     /*  53582 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(53636), // Rule ID 1254 //
     /*  53587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53616 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3787:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  53619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53621 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53634 */     GIR_RootConstrainSelectedInstOperands,
     /*  53635 */     // GIR_Coverage, 1254,
     /*  53635 */     GIR_EraseRootFromParent_Done,
     /*  53636 */   // Label 1156: @53636
     /*  53636 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(53690), // Rule ID 1255 //
     /*  53641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53670 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3787:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53675 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53688 */     GIR_RootConstrainSelectedInstOperands,
     /*  53689 */     // GIR_Coverage, 1255,
     /*  53689 */     GIR_EraseRootFromParent_Done,
     /*  53690 */   // Label 1157: @53690
     /*  53690 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(53744), // Rule ID 1256 //
     /*  53695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53724 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3787:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53729 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53742 */     GIR_RootConstrainSelectedInstOperands,
     /*  53743 */     // GIR_Coverage, 1256,
     /*  53743 */     GIR_EraseRootFromParent_Done,
     /*  53744 */   // Label 1158: @53744
     /*  53744 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(53798), // Rule ID 1257 //
     /*  53749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53778 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3787:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53783 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53796 */     GIR_RootConstrainSelectedInstOperands,
     /*  53797 */     // GIR_Coverage, 1257,
     /*  53797 */     GIR_EraseRootFromParent_Done,
     /*  53798 */   // Label 1159: @53798
     /*  53798 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(53852), // Rule ID 1258 //
     /*  53803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53832 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3787:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53837 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53850 */     GIR_RootConstrainSelectedInstOperands,
     /*  53851 */     // GIR_Coverage, 1258,
     /*  53851 */     GIR_EraseRootFromParent_Done,
     /*  53852 */   // Label 1160: @53852
     /*  53852 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(53906), // Rule ID 1259 //
     /*  53857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53886 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3787:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53891 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53904 */     GIR_RootConstrainSelectedInstOperands,
     /*  53905 */     // GIR_Coverage, 1259,
     /*  53905 */     GIR_EraseRootFromParent_Done,
     /*  53906 */   // Label 1161: @53906
     /*  53906 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(53960), // Rule ID 1260 //
     /*  53911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53940 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3788:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53945 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53958 */     GIR_RootConstrainSelectedInstOperands,
     /*  53959 */     // GIR_Coverage, 1260,
     /*  53959 */     GIR_EraseRootFromParent_Done,
     /*  53960 */   // Label 1162: @53960
     /*  53960 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(54014), // Rule ID 1261 //
     /*  53965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53994 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3788:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53999 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54012 */     GIR_RootConstrainSelectedInstOperands,
     /*  54013 */     // GIR_Coverage, 1261,
     /*  54013 */     GIR_EraseRootFromParent_Done,
     /*  54014 */   // Label 1163: @54014
     /*  54014 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(54068), // Rule ID 1262 //
     /*  54019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  54030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54048 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3788:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  54048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  54051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54066 */     GIR_RootConstrainSelectedInstOperands,
     /*  54067 */     // GIR_Coverage, 1262,
     /*  54067 */     GIR_EraseRootFromParent_Done,
     /*  54068 */   // Label 1164: @54068
     /*  54068 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(54122), // Rule ID 1263 //
     /*  54073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  54084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  54090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54102 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3788:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  54102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  54105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54107 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54120 */     GIR_RootConstrainSelectedInstOperands,
     /*  54121 */     // GIR_Coverage, 1263,
     /*  54121 */     GIR_EraseRootFromParent_Done,
     /*  54122 */   // Label 1165: @54122
     /*  54122 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(54176), // Rule ID 1264 //
     /*  54127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  54138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54156 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3788:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  54156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  54159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54161 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54174 */     GIR_RootConstrainSelectedInstOperands,
     /*  54175 */     // GIR_Coverage, 1264,
     /*  54175 */     GIR_EraseRootFromParent_Done,
     /*  54176 */   // Label 1166: @54176
     /*  54176 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(54230), // Rule ID 1265 //
     /*  54181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  54192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54210 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3788:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  54210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  54213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54228 */     GIR_RootConstrainSelectedInstOperands,
     /*  54229 */     // GIR_Coverage, 1265,
     /*  54229 */     GIR_EraseRootFromParent_Done,
     /*  54230 */   // Label 1167: @54230
     /*  54230 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(54284), // Rule ID 1266 //
     /*  54235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54264 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3792:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  54267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54282 */     GIR_RootConstrainSelectedInstOperands,
     /*  54283 */     // GIR_Coverage, 1266,
     /*  54283 */     GIR_EraseRootFromParent_Done,
     /*  54284 */   // Label 1168: @54284
     /*  54284 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(54338), // Rule ID 1267 //
     /*  54289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54318 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3792:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  54321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54336 */     GIR_RootConstrainSelectedInstOperands,
     /*  54337 */     // GIR_Coverage, 1267,
     /*  54337 */     GIR_EraseRootFromParent_Done,
     /*  54338 */   // Label 1169: @54338
     /*  54338 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(54392), // Rule ID 1268 //
     /*  54343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54372 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3792:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  54375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54390 */     GIR_RootConstrainSelectedInstOperands,
     /*  54391 */     // GIR_Coverage, 1268,
     /*  54391 */     GIR_EraseRootFromParent_Done,
     /*  54392 */   // Label 1170: @54392
     /*  54392 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(54446), // Rule ID 1269 //
     /*  54397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54426 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3793:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  54429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54444 */     GIR_RootConstrainSelectedInstOperands,
     /*  54445 */     // GIR_Coverage, 1269,
     /*  54445 */     GIR_EraseRootFromParent_Done,
     /*  54446 */   // Label 1171: @54446
     /*  54446 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54500), // Rule ID 1270 //
     /*  54451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54480 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3793:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  54483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54498 */     GIR_RootConstrainSelectedInstOperands,
     /*  54499 */     // GIR_Coverage, 1270,
     /*  54499 */     GIR_EraseRootFromParent_Done,
     /*  54500 */   // Label 1172: @54500
     /*  54500 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54554), // Rule ID 1271 //
     /*  54505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54534 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3793:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  54537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54552 */     GIR_RootConstrainSelectedInstOperands,
     /*  54553 */     // GIR_Coverage, 1271,
     /*  54553 */     GIR_EraseRootFromParent_Done,
     /*  54554 */   // Label 1173: @54554
     /*  54554 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(54608), // Rule ID 1272 //
     /*  54559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54588 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3792:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  54591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54606 */     GIR_RootConstrainSelectedInstOperands,
     /*  54607 */     // GIR_Coverage, 1272,
     /*  54607 */     GIR_EraseRootFromParent_Done,
     /*  54608 */   // Label 1174: @54608
     /*  54608 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(54662), // Rule ID 1273 //
     /*  54613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54642 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3792:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54660 */     GIR_RootConstrainSelectedInstOperands,
     /*  54661 */     // GIR_Coverage, 1273,
     /*  54661 */     GIR_EraseRootFromParent_Done,
     /*  54662 */   // Label 1175: @54662
     /*  54662 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(54716), // Rule ID 1274 //
     /*  54667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54696 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3794:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54714 */     GIR_RootConstrainSelectedInstOperands,
     /*  54715 */     // GIR_Coverage, 1274,
     /*  54715 */     GIR_EraseRootFromParent_Done,
     /*  54716 */   // Label 1176: @54716
     /*  54716 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(54770), // Rule ID 1275 //
     /*  54721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54750 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3794:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54768 */     GIR_RootConstrainSelectedInstOperands,
     /*  54769 */     // GIR_Coverage, 1275,
     /*  54769 */     GIR_EraseRootFromParent_Done,
     /*  54770 */   // Label 1177: @54770
     /*  54770 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(54824), // Rule ID 1276 //
     /*  54775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54804 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3794:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54822 */     GIR_RootConstrainSelectedInstOperands,
     /*  54823 */     // GIR_Coverage, 1276,
     /*  54823 */     GIR_EraseRootFromParent_Done,
     /*  54824 */   // Label 1178: @54824
     /*  54824 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(54878), // Rule ID 1277 //
     /*  54829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54858 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3795:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54876 */     GIR_RootConstrainSelectedInstOperands,
     /*  54877 */     // GIR_Coverage, 1277,
     /*  54877 */     GIR_EraseRootFromParent_Done,
     /*  54878 */   // Label 1179: @54878
     /*  54878 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(54932), // Rule ID 1278 //
     /*  54883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54912 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3795:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54930 */     GIR_RootConstrainSelectedInstOperands,
     /*  54931 */     // GIR_Coverage, 1278,
     /*  54931 */     GIR_EraseRootFromParent_Done,
     /*  54932 */   // Label 1180: @54932
     /*  54932 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(54986), // Rule ID 1279 //
     /*  54937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54966 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3795:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54984 */     GIR_RootConstrainSelectedInstOperands,
     /*  54985 */     // GIR_Coverage, 1279,
     /*  54985 */     GIR_EraseRootFromParent_Done,
     /*  54986 */   // Label 1181: @54986
     /*  54986 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(55040), // Rule ID 1280 //
     /*  54991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55020 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3794:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  55023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55038 */     GIR_RootConstrainSelectedInstOperands,
     /*  55039 */     // GIR_Coverage, 1280,
     /*  55039 */     GIR_EraseRootFromParent_Done,
     /*  55040 */   // Label 1182: @55040
     /*  55040 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(55094), // Rule ID 1281 //
     /*  55045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  55053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55074 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3794:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  55077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55092 */     GIR_RootConstrainSelectedInstOperands,
     /*  55093 */     // GIR_Coverage, 1281,
     /*  55093 */     GIR_EraseRootFromParent_Done,
     /*  55094 */   // Label 1183: @55094
     /*  55094 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(55148), // Rule ID 1288 //
     /*  55099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55128 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3819:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  55131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55146 */     GIR_RootConstrainSelectedInstOperands,
     /*  55147 */     // GIR_Coverage, 1288,
     /*  55147 */     GIR_EraseRootFromParent_Done,
     /*  55148 */   // Label 1184: @55148
     /*  55148 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(55202), // Rule ID 1289 //
     /*  55153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55182 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3819:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  55185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55200 */     GIR_RootConstrainSelectedInstOperands,
     /*  55201 */     // GIR_Coverage, 1289,
     /*  55201 */     GIR_EraseRootFromParent_Done,
     /*  55202 */   // Label 1185: @55202
     /*  55202 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(55256), // Rule ID 1290 //
     /*  55207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55236 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3819:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  55239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55254 */     GIR_RootConstrainSelectedInstOperands,
     /*  55255 */     // GIR_Coverage, 1290,
     /*  55255 */     GIR_EraseRootFromParent_Done,
     /*  55256 */   // Label 1186: @55256
     /*  55256 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(55310), // Rule ID 1291 //
     /*  55261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55290 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3819:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  55293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55308 */     GIR_RootConstrainSelectedInstOperands,
     /*  55309 */     // GIR_Coverage, 1291,
     /*  55309 */     GIR_EraseRootFromParent_Done,
     /*  55310 */   // Label 1187: @55310
     /*  55310 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(55364), // Rule ID 1298 //
     /*  55315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55344 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3832:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  55347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55362 */     GIR_RootConstrainSelectedInstOperands,
     /*  55363 */     // GIR_Coverage, 1298,
     /*  55363 */     GIR_EraseRootFromParent_Done,
     /*  55364 */   // Label 1188: @55364
     /*  55364 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(55418), // Rule ID 1299 //
     /*  55369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55398 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3832:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  55401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55416 */     GIR_RootConstrainSelectedInstOperands,
     /*  55417 */     // GIR_Coverage, 1299,
     /*  55417 */     GIR_EraseRootFromParent_Done,
     /*  55418 */   // Label 1189: @55418
     /*  55418 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(55472), // Rule ID 1300 //
     /*  55423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55452 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3832:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  55455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55470 */     GIR_RootConstrainSelectedInstOperands,
     /*  55471 */     // GIR_Coverage, 1300,
     /*  55471 */     GIR_EraseRootFromParent_Done,
     /*  55472 */   // Label 1190: @55472
     /*  55472 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55526), // Rule ID 1301 //
     /*  55477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55506 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3832:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  55509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55524 */     GIR_RootConstrainSelectedInstOperands,
     /*  55525 */     // GIR_Coverage, 1301,
     /*  55525 */     GIR_EraseRootFromParent_Done,
     /*  55526 */   // Label 1191: @55526
     /*  55526 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55580), // Rule ID 1302 //
     /*  55531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55560 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3835:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  55563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55578 */     GIR_RootConstrainSelectedInstOperands,
     /*  55579 */     // GIR_Coverage, 1302,
     /*  55579 */     GIR_EraseRootFromParent_Done,
     /*  55580 */   // Label 1192: @55580
     /*  55580 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(55634), // Rule ID 1303 //
     /*  55585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55614 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3835:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  55617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55632 */     GIR_RootConstrainSelectedInstOperands,
     /*  55633 */     // GIR_Coverage, 1303,
     /*  55633 */     GIR_EraseRootFromParent_Done,
     /*  55634 */   // Label 1193: @55634
     /*  55634 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(55688), // Rule ID 1304 //
     /*  55639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55668 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3835:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55686 */     GIR_RootConstrainSelectedInstOperands,
     /*  55687 */     // GIR_Coverage, 1304,
     /*  55687 */     GIR_EraseRootFromParent_Done,
     /*  55688 */   // Label 1194: @55688
     /*  55688 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(55742), // Rule ID 1305 //
     /*  55693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55722 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3835:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55740 */     GIR_RootConstrainSelectedInstOperands,
     /*  55741 */     // GIR_Coverage, 1305,
     /*  55741 */     GIR_EraseRootFromParent_Done,
     /*  55742 */   // Label 1195: @55742
     /*  55742 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(55796), // Rule ID 1306 //
     /*  55747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55776 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3835:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55794 */     GIR_RootConstrainSelectedInstOperands,
     /*  55795 */     // GIR_Coverage, 1306,
     /*  55795 */     GIR_EraseRootFromParent_Done,
     /*  55796 */   // Label 1196: @55796
     /*  55796 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(55850), // Rule ID 1307 //
     /*  55801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55830 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3835:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55848 */     GIR_RootConstrainSelectedInstOperands,
     /*  55849 */     // GIR_Coverage, 1307,
     /*  55849 */     GIR_EraseRootFromParent_Done,
     /*  55850 */   // Label 1197: @55850
     /*  55850 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(55904), // Rule ID 1308 //
     /*  55855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55884 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3835:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55902 */     GIR_RootConstrainSelectedInstOperands,
     /*  55903 */     // GIR_Coverage, 1308,
     /*  55903 */     GIR_EraseRootFromParent_Done,
     /*  55904 */   // Label 1198: @55904
     /*  55904 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(55958), // Rule ID 1309 //
     /*  55909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55938 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3835:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55956 */     GIR_RootConstrainSelectedInstOperands,
     /*  55957 */     // GIR_Coverage, 1309,
     /*  55957 */     GIR_EraseRootFromParent_Done,
     /*  55958 */   // Label 1199: @55958
     /*  55958 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(56012), // Rule ID 1310 //
     /*  55963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55992 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3836:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56010 */     GIR_RootConstrainSelectedInstOperands,
     /*  56011 */     // GIR_Coverage, 1310,
     /*  56011 */     GIR_EraseRootFromParent_Done,
     /*  56012 */   // Label 1200: @56012
     /*  56012 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(56066), // Rule ID 1311 //
     /*  56017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56046 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3836:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  56049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56064 */     GIR_RootConstrainSelectedInstOperands,
     /*  56065 */     // GIR_Coverage, 1311,
     /*  56065 */     GIR_EraseRootFromParent_Done,
     /*  56066 */   // Label 1201: @56066
     /*  56066 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(56120), // Rule ID 1312 //
     /*  56071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56100 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3836:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  56103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56118 */     GIR_RootConstrainSelectedInstOperands,
     /*  56119 */     // GIR_Coverage, 1312,
     /*  56119 */     GIR_EraseRootFromParent_Done,
     /*  56120 */   // Label 1202: @56120
     /*  56120 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(56174), // Rule ID 1313 //
     /*  56125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56154 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3836:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  56157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56172 */     GIR_RootConstrainSelectedInstOperands,
     /*  56173 */     // GIR_Coverage, 1313,
     /*  56173 */     GIR_EraseRootFromParent_Done,
     /*  56174 */   // Label 1203: @56174
     /*  56174 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(56228), // Rule ID 1314 //
     /*  56179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56208 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3836:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  56211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56226 */     GIR_RootConstrainSelectedInstOperands,
     /*  56227 */     // GIR_Coverage, 1314,
     /*  56227 */     GIR_EraseRootFromParent_Done,
     /*  56228 */   // Label 1204: @56228
     /*  56228 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(56282), // Rule ID 1315 //
     /*  56233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56262 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3836:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  56265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56280 */     GIR_RootConstrainSelectedInstOperands,
     /*  56281 */     // GIR_Coverage, 1315,
     /*  56281 */     GIR_EraseRootFromParent_Done,
     /*  56282 */   // Label 1205: @56282
     /*  56282 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(56336), // Rule ID 1316 //
     /*  56287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56316 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3836:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  56319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56334 */     GIR_RootConstrainSelectedInstOperands,
     /*  56335 */     // GIR_Coverage, 1316,
     /*  56335 */     GIR_EraseRootFromParent_Done,
     /*  56336 */   // Label 1206: @56336
     /*  56336 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(56390), // Rule ID 1317 //
     /*  56341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56370 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3836:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  56373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56388 */     GIR_RootConstrainSelectedInstOperands,
     /*  56389 */     // GIR_Coverage, 1317,
     /*  56389 */     GIR_EraseRootFromParent_Done,
     /*  56390 */   // Label 1207: @56390
     /*  56390 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(56444), // Rule ID 1351 //
     /*  56395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56424 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3829:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  56427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56442 */     GIR_RootConstrainSelectedInstOperands,
     /*  56443 */     // GIR_Coverage, 1351,
     /*  56443 */     GIR_EraseRootFromParent_Done,
     /*  56444 */   // Label 1208: @56444
     /*  56444 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56498), // Rule ID 1352 //
     /*  56449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56478 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3829:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  56481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56496 */     GIR_RootConstrainSelectedInstOperands,
     /*  56497 */     // GIR_Coverage, 1352,
     /*  56497 */     GIR_EraseRootFromParent_Done,
     /*  56498 */   // Label 1209: @56498
     /*  56498 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56552), // Rule ID 1353 //
     /*  56503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56532 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3829:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  56535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56550 */     GIR_RootConstrainSelectedInstOperands,
     /*  56551 */     // GIR_Coverage, 1353,
     /*  56551 */     GIR_EraseRootFromParent_Done,
     /*  56552 */   // Label 1210: @56552
     /*  56552 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(56606), // Rule ID 1354 //
     /*  56557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56586 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3829:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  56589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56604 */     GIR_RootConstrainSelectedInstOperands,
     /*  56605 */     // GIR_Coverage, 1354,
     /*  56605 */     GIR_EraseRootFromParent_Done,
     /*  56606 */   // Label 1211: @56606
     /*  56606 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(56660), // Rule ID 1355 //
     /*  56611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56640 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3829:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56658 */     GIR_RootConstrainSelectedInstOperands,
     /*  56659 */     // GIR_Coverage, 1355,
     /*  56659 */     GIR_EraseRootFromParent_Done,
     /*  56660 */   // Label 1212: @56660
     /*  56660 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(56714), // Rule ID 1356 //
     /*  56665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56694 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3829:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56712 */     GIR_RootConstrainSelectedInstOperands,
     /*  56713 */     // GIR_Coverage, 1356,
     /*  56713 */     GIR_EraseRootFromParent_Done,
     /*  56714 */   // Label 1213: @56714
     /*  56714 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(56768), // Rule ID 1357 //
     /*  56719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56748 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3829:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56766 */     GIR_RootConstrainSelectedInstOperands,
     /*  56767 */     // GIR_Coverage, 1357,
     /*  56767 */     GIR_EraseRootFromParent_Done,
     /*  56768 */   // Label 1214: @56768
     /*  56768 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(56822), // Rule ID 1358 //
     /*  56773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56802 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3829:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56820 */     GIR_RootConstrainSelectedInstOperands,
     /*  56821 */     // GIR_Coverage, 1358,
     /*  56821 */     GIR_EraseRootFromParent_Done,
     /*  56822 */   // Label 1215: @56822
     /*  56822 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(56876), // Rule ID 1359 //
     /*  56827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56856 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3830:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56874 */     GIR_RootConstrainSelectedInstOperands,
     /*  56875 */     // GIR_Coverage, 1359,
     /*  56875 */     GIR_EraseRootFromParent_Done,
     /*  56876 */   // Label 1216: @56876
     /*  56876 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(56930), // Rule ID 1360 //
     /*  56881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56910 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3830:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56928 */     GIR_RootConstrainSelectedInstOperands,
     /*  56929 */     // GIR_Coverage, 1360,
     /*  56929 */     GIR_EraseRootFromParent_Done,
     /*  56930 */   // Label 1217: @56930
     /*  56930 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(56984), // Rule ID 1361 //
     /*  56935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56964 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3830:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56982 */     GIR_RootConstrainSelectedInstOperands,
     /*  56983 */     // GIR_Coverage, 1361,
     /*  56983 */     GIR_EraseRootFromParent_Done,
     /*  56984 */   // Label 1218: @56984
     /*  56984 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(57038), // Rule ID 1362 //
     /*  56989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3830:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  57021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57036 */     GIR_RootConstrainSelectedInstOperands,
     /*  57037 */     // GIR_Coverage, 1362,
     /*  57037 */     GIR_EraseRootFromParent_Done,
     /*  57038 */   // Label 1219: @57038
     /*  57038 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(57092), // Rule ID 1363 //
     /*  57043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57072 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3830:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  57075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57090 */     GIR_RootConstrainSelectedInstOperands,
     /*  57091 */     // GIR_Coverage, 1363,
     /*  57091 */     GIR_EraseRootFromParent_Done,
     /*  57092 */   // Label 1220: @57092
     /*  57092 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(57146), // Rule ID 1364 //
     /*  57097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57126 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3830:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  57129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57144 */     GIR_RootConstrainSelectedInstOperands,
     /*  57145 */     // GIR_Coverage, 1364,
     /*  57145 */     GIR_EraseRootFromParent_Done,
     /*  57146 */   // Label 1221: @57146
     /*  57146 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(57200), // Rule ID 1365 //
     /*  57151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57180 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3830:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  57183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57198 */     GIR_RootConstrainSelectedInstOperands,
     /*  57199 */     // GIR_Coverage, 1365,
     /*  57199 */     GIR_EraseRootFromParent_Done,
     /*  57200 */   // Label 1222: @57200
     /*  57200 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(57254), // Rule ID 1366 //
     /*  57205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57234 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3830:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  57237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57252 */     GIR_RootConstrainSelectedInstOperands,
     /*  57253 */     // GIR_Coverage, 1366,
     /*  57253 */     GIR_EraseRootFromParent_Done,
     /*  57254 */   // Label 1223: @57254
     /*  57254 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(57308), // Rule ID 1386 //
     /*  57259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57288 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3814:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  57291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57306 */     GIR_RootConstrainSelectedInstOperands,
     /*  57307 */     // GIR_Coverage, 1386,
     /*  57307 */     GIR_EraseRootFromParent_Done,
     /*  57308 */   // Label 1224: @57308
     /*  57308 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(57362), // Rule ID 1387 //
     /*  57313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57342 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3814:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  57345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57360 */     GIR_RootConstrainSelectedInstOperands,
     /*  57361 */     // GIR_Coverage, 1387,
     /*  57361 */     GIR_EraseRootFromParent_Done,
     /*  57362 */   // Label 1225: @57362
     /*  57362 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(57416), // Rule ID 1388 //
     /*  57367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57396 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3814:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  57399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57414 */     GIR_RootConstrainSelectedInstOperands,
     /*  57415 */     // GIR_Coverage, 1388,
     /*  57415 */     GIR_EraseRootFromParent_Done,
     /*  57416 */   // Label 1226: @57416
     /*  57416 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(57470), // Rule ID 1389 //
     /*  57421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57450 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3814:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  57453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57468 */     GIR_RootConstrainSelectedInstOperands,
     /*  57469 */     // GIR_Coverage, 1389,
     /*  57469 */     GIR_EraseRootFromParent_Done,
     /*  57470 */   // Label 1227: @57470
     /*  57470 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57524), // Rule ID 1390 //
     /*  57475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57504 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3814:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  57507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57522 */     GIR_RootConstrainSelectedInstOperands,
     /*  57523 */     // GIR_Coverage, 1390,
     /*  57523 */     GIR_EraseRootFromParent_Done,
     /*  57524 */   // Label 1228: @57524
     /*  57524 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57578), // Rule ID 1391 //
     /*  57529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57558 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3814:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  57561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57576 */     GIR_RootConstrainSelectedInstOperands,
     /*  57577 */     // GIR_Coverage, 1391,
     /*  57577 */     GIR_EraseRootFromParent_Done,
     /*  57578 */   // Label 1229: @57578
     /*  57578 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(57632), // Rule ID 1392 //
     /*  57583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57612 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3814:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  57615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57630 */     GIR_RootConstrainSelectedInstOperands,
     /*  57631 */     // GIR_Coverage, 1392,
     /*  57631 */     GIR_EraseRootFromParent_Done,
     /*  57632 */   // Label 1230: @57632
     /*  57632 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(57686), // Rule ID 1393 //
     /*  57637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57666 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3814:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57684 */     GIR_RootConstrainSelectedInstOperands,
     /*  57685 */     // GIR_Coverage, 1393,
     /*  57685 */     GIR_EraseRootFromParent_Done,
     /*  57686 */   // Label 1231: @57686
     /*  57686 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(57740), // Rule ID 1394 //
     /*  57691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57720 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3816:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57738 */     GIR_RootConstrainSelectedInstOperands,
     /*  57739 */     // GIR_Coverage, 1394,
     /*  57739 */     GIR_EraseRootFromParent_Done,
     /*  57740 */   // Label 1232: @57740
     /*  57740 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(57794), // Rule ID 1395 //
     /*  57745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57774 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3816:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57792 */     GIR_RootConstrainSelectedInstOperands,
     /*  57793 */     // GIR_Coverage, 1395,
     /*  57793 */     GIR_EraseRootFromParent_Done,
     /*  57794 */   // Label 1233: @57794
     /*  57794 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(57848), // Rule ID 1396 //
     /*  57799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57828 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3816:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57846 */     GIR_RootConstrainSelectedInstOperands,
     /*  57847 */     // GIR_Coverage, 1396,
     /*  57847 */     GIR_EraseRootFromParent_Done,
     /*  57848 */   // Label 1234: @57848
     /*  57848 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(57902), // Rule ID 1397 //
     /*  57853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57882 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3816:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57900 */     GIR_RootConstrainSelectedInstOperands,
     /*  57901 */     // GIR_Coverage, 1397,
     /*  57901 */     GIR_EraseRootFromParent_Done,
     /*  57902 */   // Label 1235: @57902
     /*  57902 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(57956), // Rule ID 1398 //
     /*  57907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57936 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3816:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57954 */     GIR_RootConstrainSelectedInstOperands,
     /*  57955 */     // GIR_Coverage, 1398,
     /*  57955 */     GIR_EraseRootFromParent_Done,
     /*  57956 */   // Label 1236: @57956
     /*  57956 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(58010), // Rule ID 1399 //
     /*  57961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57990 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3816:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58008 */     GIR_RootConstrainSelectedInstOperands,
     /*  58009 */     // GIR_Coverage, 1399,
     /*  58009 */     GIR_EraseRootFromParent_Done,
     /*  58010 */   // Label 1237: @58010
     /*  58010 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(58064), // Rule ID 1400 //
     /*  58015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  58023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58044 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3816:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  58047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58062 */     GIR_RootConstrainSelectedInstOperands,
     /*  58063 */     // GIR_Coverage, 1400,
     /*  58063 */     GIR_EraseRootFromParent_Done,
     /*  58064 */   // Label 1238: @58064
     /*  58064 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(58118), // Rule ID 1401 //
     /*  58069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  58077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58098 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3816:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  58101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58116 */     GIR_RootConstrainSelectedInstOperands,
     /*  58117 */     // GIR_Coverage, 1401,
     /*  58117 */     GIR_EraseRootFromParent_Done,
     /*  58118 */   // Label 1239: @58118
     /*  58118 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(58172), // Rule ID 1435 //
     /*  58123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58152 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  58155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58170 */     GIR_RootConstrainSelectedInstOperands,
     /*  58171 */     // GIR_Coverage, 1435,
     /*  58171 */     GIR_EraseRootFromParent_Done,
     /*  58172 */   // Label 1240: @58172
     /*  58172 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(58226), // Rule ID 1436 //
     /*  58177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58206 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  58209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58224 */     GIR_RootConstrainSelectedInstOperands,
     /*  58225 */     // GIR_Coverage, 1436,
     /*  58225 */     GIR_EraseRootFromParent_Done,
     /*  58226 */   // Label 1241: @58226
     /*  58226 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(58280), // Rule ID 1437 //
     /*  58231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58260 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3809:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  58263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58278 */     GIR_RootConstrainSelectedInstOperands,
     /*  58279 */     // GIR_Coverage, 1437,
     /*  58279 */     GIR_EraseRootFromParent_Done,
     /*  58280 */   // Label 1242: @58280
     /*  58280 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(58334), // Rule ID 1438 //
     /*  58285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58314 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  58317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58332 */     GIR_RootConstrainSelectedInstOperands,
     /*  58333 */     // GIR_Coverage, 1438,
     /*  58333 */     GIR_EraseRootFromParent_Done,
     /*  58334 */   // Label 1243: @58334
     /*  58334 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(58388), // Rule ID 1439 //
     /*  58339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58368 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3809:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  58371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58386 */     GIR_RootConstrainSelectedInstOperands,
     /*  58387 */     // GIR_Coverage, 1439,
     /*  58387 */     GIR_EraseRootFromParent_Done,
     /*  58388 */   // Label 1244: @58388
     /*  58388 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(58442), // Rule ID 1440 //
     /*  58393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58422 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3809:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  58425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58440 */     GIR_RootConstrainSelectedInstOperands,
     /*  58441 */     // GIR_Coverage, 1440,
     /*  58441 */     GIR_EraseRootFromParent_Done,
     /*  58442 */   // Label 1245: @58442
     /*  58442 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58496), // Rule ID 1441 //
     /*  58447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58476 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  58479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58494 */     GIR_RootConstrainSelectedInstOperands,
     /*  58495 */     // GIR_Coverage, 1441,
     /*  58495 */     GIR_EraseRootFromParent_Done,
     /*  58496 */   // Label 1246: @58496
     /*  58496 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58550), // Rule ID 1442 //
     /*  58501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58530 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  58533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58548 */     GIR_RootConstrainSelectedInstOperands,
     /*  58549 */     // GIR_Coverage, 1442,
     /*  58549 */     GIR_EraseRootFromParent_Done,
     /*  58550 */   // Label 1247: @58550
     /*  58550 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58604), // Rule ID 1443 //
     /*  58555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58584 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3810:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  58587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58602 */     GIR_RootConstrainSelectedInstOperands,
     /*  58603 */     // GIR_Coverage, 1443,
     /*  58603 */     GIR_EraseRootFromParent_Done,
     /*  58604 */   // Label 1248: @58604
     /*  58604 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(58658), // Rule ID 1444 //
     /*  58609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58638 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3810:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58656 */     GIR_RootConstrainSelectedInstOperands,
     /*  58657 */     // GIR_Coverage, 1444,
     /*  58657 */     GIR_EraseRootFromParent_Done,
     /*  58658 */   // Label 1249: @58658
     /*  58658 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(58712), // Rule ID 1445 //
     /*  58663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58692 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3810:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58710 */     GIR_RootConstrainSelectedInstOperands,
     /*  58711 */     // GIR_Coverage, 1445,
     /*  58711 */     GIR_EraseRootFromParent_Done,
     /*  58712 */   // Label 1250: @58712
     /*  58712 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(58766), // Rule ID 1446 //
     /*  58717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58746 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3810:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58764 */     GIR_RootConstrainSelectedInstOperands,
     /*  58765 */     // GIR_Coverage, 1446,
     /*  58765 */     GIR_EraseRootFromParent_Done,
     /*  58766 */   // Label 1251: @58766
     /*  58766 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(58820), // Rule ID 1447 //
     /*  58771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58800 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3810:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58818 */     GIR_RootConstrainSelectedInstOperands,
     /*  58819 */     // GIR_Coverage, 1447,
     /*  58819 */     GIR_EraseRootFromParent_Done,
     /*  58820 */   // Label 1252: @58820
     /*  58820 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(58874), // Rule ID 1448 //
     /*  58825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58854 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3810:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58872 */     GIR_RootConstrainSelectedInstOperands,
     /*  58873 */     // GIR_Coverage, 1448,
     /*  58873 */     GIR_EraseRootFromParent_Done,
     /*  58874 */   // Label 1253: @58874
     /*  58874 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(58928), // Rule ID 1449 //
     /*  58879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58908 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3810:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58926 */     GIR_RootConstrainSelectedInstOperands,
     /*  58927 */     // GIR_Coverage, 1449,
     /*  58927 */     GIR_EraseRootFromParent_Done,
     /*  58928 */   // Label 1254: @58928
     /*  58928 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(58982), // Rule ID 1450 //
     /*  58933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58962 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3810:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58980 */     GIR_RootConstrainSelectedInstOperands,
     /*  58981 */     // GIR_Coverage, 1450,
     /*  58981 */     GIR_EraseRootFromParent_Done,
     /*  58982 */   // Label 1255: @58982
     /*  58982 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(59027), // Rule ID 1715 //
     /*  58987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  59001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  59004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59016 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3711:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  59016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  59019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59025 */     GIR_RootConstrainSelectedInstOperands,
     /*  59026 */     // GIR_Coverage, 1715,
     /*  59026 */     GIR_EraseRootFromParent_Done,
     /*  59027 */   // Label 1256: @59027
     /*  59027 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(59072), // Rule ID 1716 //
     /*  59032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  59035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  59040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  59043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  59046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  59049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59061 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  59061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  59064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59066 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59070 */     GIR_RootConstrainSelectedInstOperands,
     /*  59071 */     // GIR_Coverage, 1716,
     /*  59071 */     GIR_EraseRootFromParent_Done,
     /*  59072 */   // Label 1257: @59072
     /*  59072 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(59117), // Rule ID 1719 //
     /*  59077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  59080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  59085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  59088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  59091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  59094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59106 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3725:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  59106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  59109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59115 */     GIR_RootConstrainSelectedInstOperands,
     /*  59116 */     // GIR_Coverage, 1719,
     /*  59116 */     GIR_EraseRootFromParent_Done,
     /*  59117 */   // Label 1258: @59117
     /*  59117 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(59162), // Rule ID 1720 //
     /*  59122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  59125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  59130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  59133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  59136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  59139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59151 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3728:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  59151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  59154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59160 */     GIR_RootConstrainSelectedInstOperands,
     /*  59161 */     // GIR_Coverage, 1720,
     /*  59161 */     GIR_EraseRootFromParent_Done,
     /*  59162 */   // Label 1259: @59162
     /*  59162 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(59216), // Rule ID 1729 //
     /*  59167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  59175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59196 */     // (intrinsic_wo_chain:{ *:[i32] } 3574:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  59199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59201 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59214 */     GIR_RootConstrainSelectedInstOperands,
     /*  59215 */     // GIR_Coverage, 1729,
     /*  59215 */     GIR_EraseRootFromParent_Done,
     /*  59216 */   // Label 1260: @59216
     /*  59216 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(59270), // Rule ID 1730 //
     /*  59221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  59229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59250 */     // (intrinsic_wo_chain:{ *:[i32] } 3581:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  59253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59255 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59268 */     GIR_RootConstrainSelectedInstOperands,
     /*  59269 */     // GIR_Coverage, 1730,
     /*  59269 */     GIR_EraseRootFromParent_Done,
     /*  59270 */   // Label 1261: @59270
     /*  59270 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(59327), // Rule ID 1853 //
     /*  59275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59304 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  59307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59309 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59311 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59325 */     GIR_RootConstrainSelectedInstOperands,
     /*  59326 */     // GIR_Coverage, 1853,
     /*  59326 */     GIR_EraseRootFromParent_Done,
     /*  59327 */   // Label 1262: @59327
     /*  59327 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(59384), // Rule ID 1860 //
     /*  59332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  59340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59361 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  59364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59366 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59368 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59382 */     GIR_RootConstrainSelectedInstOperands,
     /*  59383 */     // GIR_Coverage, 1860,
     /*  59383 */     GIR_EraseRootFromParent_Done,
     /*  59384 */   // Label 1263: @59384
     /*  59384 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(59438), // Rule ID 1907 //
     /*  59389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  59397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59418 */     // (intrinsic_wo_chain:{ *:[i32] } 3888:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  59421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59436 */     GIR_RootConstrainSelectedInstOperands,
     /*  59437 */     // GIR_Coverage, 1907,
     /*  59437 */     GIR_EraseRootFromParent_Done,
     /*  59438 */   // Label 1264: @59438
     /*  59438 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59492), // Rule ID 1908 //
     /*  59443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  59451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59472 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  59475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59490 */     GIR_RootConstrainSelectedInstOperands,
     /*  59491 */     // GIR_Coverage, 1908,
     /*  59491 */     GIR_EraseRootFromParent_Done,
     /*  59492 */   // Label 1265: @59492
     /*  59492 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59546), // Rule ID 1909 //
     /*  59497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  59505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59526 */     // (intrinsic_wo_chain:{ *:[i32] } 3896:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  59529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59544 */     GIR_RootConstrainSelectedInstOperands,
     /*  59545 */     // GIR_Coverage, 1909,
     /*  59545 */     GIR_EraseRootFromParent_Done,
     /*  59546 */   // Label 1266: @59546
     /*  59546 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(59600), // Rule ID 1910 //
     /*  59551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  59559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59580 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  59583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59598 */     GIR_RootConstrainSelectedInstOperands,
     /*  59599 */     // GIR_Coverage, 1910,
     /*  59599 */     GIR_EraseRootFromParent_Done,
     /*  59600 */   // Label 1267: @59600
     /*  59600 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(59654), // Rule ID 1984 //
     /*  59605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59634 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59639 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59641 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59652 */     GIR_RootConstrainSelectedInstOperands,
     /*  59653 */     // GIR_Coverage, 1984,
     /*  59653 */     GIR_EraseRootFromParent_Done,
     /*  59654 */   // Label 1268: @59654
     /*  59654 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(59708), // Rule ID 1985 //
     /*  59659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59688 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59693 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59695 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59706 */     GIR_RootConstrainSelectedInstOperands,
     /*  59707 */     // GIR_Coverage, 1985,
     /*  59707 */     GIR_EraseRootFromParent_Done,
     /*  59708 */   // Label 1269: @59708
     /*  59708 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(59762), // Rule ID 1986 //
     /*  59713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59742 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59747 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59749 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59760 */     GIR_RootConstrainSelectedInstOperands,
     /*  59761 */     // GIR_Coverage, 1986,
     /*  59761 */     GIR_EraseRootFromParent_Done,
     /*  59762 */   // Label 1270: @59762
     /*  59762 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(59816), // Rule ID 1987 //
     /*  59767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59796 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59801 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59803 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59814 */     GIR_RootConstrainSelectedInstOperands,
     /*  59815 */     // GIR_Coverage, 1987,
     /*  59815 */     GIR_EraseRootFromParent_Done,
     /*  59816 */   // Label 1271: @59816
     /*  59816 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(59870), // Rule ID 1988 //
     /*  59821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59850 */     // (intrinsic_wo_chain:{ *:[i32] } 3894:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59855 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59857 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59868 */     GIR_RootConstrainSelectedInstOperands,
     /*  59869 */     // GIR_Coverage, 1988,
     /*  59869 */     GIR_EraseRootFromParent_Done,
     /*  59870 */   // Label 1272: @59870
     /*  59870 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(59924), // Rule ID 1989 //
     /*  59875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59904 */     // (intrinsic_wo_chain:{ *:[i32] } 3895:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59909 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59911 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59922 */     GIR_RootConstrainSelectedInstOperands,
     /*  59923 */     // GIR_Coverage, 1989,
     /*  59923 */     GIR_EraseRootFromParent_Done,
     /*  59924 */   // Label 1273: @59924
     /*  59924 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(59981), // Rule ID 2100 //
     /*  59929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59958 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59979 */     GIR_RootConstrainSelectedInstOperands,
     /*  59980 */     // GIR_Coverage, 2100,
     /*  59980 */     GIR_EraseRootFromParent_Done,
     /*  59981 */   // Label 1274: @59981
     /*  59981 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(60035), // Rule ID 2130 //
     /*  59986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60015 */     // (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  60015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  60018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  60022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  60024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60033 */     GIR_RootConstrainSelectedInstOperands,
     /*  60034 */     // GIR_Coverage, 2130,
     /*  60034 */     GIR_EraseRootFromParent_Done,
     /*  60035 */   // Label 1275: @60035
     /*  60035 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(60089), // Rule ID 2131 //
     /*  60040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  60048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60069 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  60069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  60072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  60076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  60078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60087 */     GIR_RootConstrainSelectedInstOperands,
     /*  60088 */     // GIR_Coverage, 2131,
     /*  60088 */     GIR_EraseRootFromParent_Done,
     /*  60089 */   // Label 1276: @60089
     /*  60089 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(60143), // Rule ID 2171 //
     /*  60094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  60102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60123 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  60126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60141 */     GIR_RootConstrainSelectedInstOperands,
     /*  60142 */     // GIR_Coverage, 2171,
     /*  60142 */     GIR_EraseRootFromParent_Done,
     /*  60143 */   // Label 1277: @60143
     /*  60143 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(60197), // Rule ID 2172 //
     /*  60148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  60156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60177 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  60180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60195 */     GIR_RootConstrainSelectedInstOperands,
     /*  60196 */     // GIR_Coverage, 2172,
     /*  60196 */     GIR_EraseRootFromParent_Done,
     /*  60197 */   // Label 1278: @60197
     /*  60197 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(60251), // Rule ID 2173 //
     /*  60202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  60210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60231 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  60234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60249 */     GIR_RootConstrainSelectedInstOperands,
     /*  60250 */     // GIR_Coverage, 2173,
     /*  60250 */     GIR_EraseRootFromParent_Done,
     /*  60251 */   // Label 1279: @60251
     /*  60251 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(60305), // Rule ID 2174 //
     /*  60256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  60264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60285 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  60288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60303 */     GIR_RootConstrainSelectedInstOperands,
     /*  60304 */     // GIR_Coverage, 2174,
     /*  60304 */     GIR_EraseRootFromParent_Done,
     /*  60305 */   // Label 1280: @60305
     /*  60305 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(60359), // Rule ID 2175 //
     /*  60310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  60318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60339 */     // (intrinsic_wo_chain:{ *:[i32] } 3894:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  60342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60357 */     GIR_RootConstrainSelectedInstOperands,
     /*  60358 */     // GIR_Coverage, 2175,
     /*  60358 */     GIR_EraseRootFromParent_Done,
     /*  60359 */   // Label 1281: @60359
     /*  60359 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(60413), // Rule ID 2176 //
     /*  60364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  60372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60393 */     // (intrinsic_wo_chain:{ *:[i32] } 3895:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  60396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60411 */     GIR_RootConstrainSelectedInstOperands,
     /*  60412 */     // GIR_Coverage, 2176,
     /*  60412 */     GIR_EraseRootFromParent_Done,
     /*  60413 */   // Label 1282: @60413
     /*  60413 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(60461), // Rule ID 2513 //
     /*  60418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60447 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3742:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  60447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60459 */     GIR_RootConstrainSelectedInstOperands,
     /*  60460 */     // GIR_Coverage, 2513,
     /*  60460 */     GIR_EraseRootFromParent_Done,
     /*  60461 */   // Label 1283: @60461
     /*  60461 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(60509), // Rule ID 2514 //
     /*  60466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60495 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3741:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  60495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60507 */     GIR_RootConstrainSelectedInstOperands,
     /*  60508 */     // GIR_Coverage, 2514,
     /*  60508 */     GIR_EraseRootFromParent_Done,
     /*  60509 */   // Label 1284: @60509
     /*  60509 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(60557), // Rule ID 2515 //
     /*  60514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60543 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3742:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  60543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60555 */     GIR_RootConstrainSelectedInstOperands,
     /*  60556 */     // GIR_Coverage, 2515,
     /*  60556 */     GIR_EraseRootFromParent_Done,
     /*  60557 */   // Label 1285: @60557
     /*  60557 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(60605), // Rule ID 2516 //
     /*  60562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60591 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3741:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  60591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60603 */     GIR_RootConstrainSelectedInstOperands,
     /*  60604 */     // GIR_Coverage, 2516,
     /*  60604 */     GIR_EraseRootFromParent_Done,
     /*  60605 */   // Label 1286: @60605
     /*  60605 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(60653), // Rule ID 2517 //
     /*  60610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60639 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3742:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60651 */     GIR_RootConstrainSelectedInstOperands,
     /*  60652 */     // GIR_Coverage, 2517,
     /*  60652 */     GIR_EraseRootFromParent_Done,
     /*  60653 */   // Label 1287: @60653
     /*  60653 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(60701), // Rule ID 2518 //
     /*  60658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60687 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3741:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60699 */     GIR_RootConstrainSelectedInstOperands,
     /*  60700 */     // GIR_Coverage, 2518,
     /*  60700 */     GIR_EraseRootFromParent_Done,
     /*  60701 */   // Label 1288: @60701
     /*  60701 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(60749), // Rule ID 2519 //
     /*  60706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60735 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3742:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60747 */     GIR_RootConstrainSelectedInstOperands,
     /*  60748 */     // GIR_Coverage, 2519,
     /*  60748 */     GIR_EraseRootFromParent_Done,
     /*  60749 */   // Label 1289: @60749
     /*  60749 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(60797), // Rule ID 2520 //
     /*  60754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60783 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3741:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60795 */     GIR_RootConstrainSelectedInstOperands,
     /*  60796 */     // GIR_Coverage, 2520,
     /*  60796 */     GIR_EraseRootFromParent_Done,
     /*  60797 */   // Label 1290: @60797
     /*  60797 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(60902), // Rule ID 3105 //
     /*  60802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60831 */     // (intrinsic_wo_chain:{ *:[f32] } 3550:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60843 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60864 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60874 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60880 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60901 */     // GIR_Coverage, 3105,
     /*  60901 */     GIR_EraseRootFromParent_Done,
     /*  60902 */   // Label 1291: @60902
     /*  60902 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(61007), // Rule ID 3107 //
     /*  60907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60936 */     // (intrinsic_wo_chain:{ *:[f16] } 3550:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60948 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60969 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60979 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60985 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61006 */     // GIR_Coverage, 3107,
     /*  61006 */     GIR_EraseRootFromParent_Done,
     /*  61007 */   // Label 1292: @61007
     /*  61007 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(61112), // Rule ID 3109 //
     /*  61012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  61020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61041 */     // (intrinsic_wo_chain:{ *:[f32] } 3541:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61041 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61044 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61048 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61053 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  61069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61074 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61081 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61084 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61090 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61111 */     // GIR_Coverage, 3109,
     /*  61111 */     GIR_EraseRootFromParent_Done,
     /*  61112 */   // Label 1293: @61112
     /*  61112 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(61217), // Rule ID 3111 //
     /*  61117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  61125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61146 */     // (intrinsic_wo_chain:{ *:[f16] } 3541:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61162 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  61174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61186 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61189 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61195 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61216 */     // GIR_Coverage, 3111,
     /*  61216 */     GIR_EraseRootFromParent_Done,
     /*  61217 */   // Label 1294: @61217
     /*  61217 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(61322), // Rule ID 3113 //
     /*  61222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61251 */     // (intrinsic_wo_chain:{ *:[f32] } 3548:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61251 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61254 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61258 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61263 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  61279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61284 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61291 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61294 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61300 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61321 */     // GIR_Coverage, 3113,
     /*  61321 */     GIR_EraseRootFromParent_Done,
     /*  61322 */   // Label 1295: @61322
     /*  61322 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(61427), // Rule ID 3115 //
     /*  61327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61356 */     // (intrinsic_wo_chain:{ *:[f16] } 3548:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61368 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  61384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61389 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61396 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61399 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61405 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61426 */     // GIR_Coverage, 3115,
     /*  61426 */     GIR_EraseRootFromParent_Done,
     /*  61427 */   // Label 1296: @61427
     /*  61427 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(61532), // Rule ID 3117 //
     /*  61432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61461 */     // (intrinsic_wo_chain:{ *:[f32] } 3539:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61461 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61464 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61468 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61473 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61477 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  61489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61494 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61501 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61504 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61510 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61531 */     // GIR_Coverage, 3117,
     /*  61531 */     GIR_EraseRootFromParent_Done,
     /*  61532 */   // Label 1297: @61532
     /*  61532 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(61637), // Rule ID 3119 //
     /*  61537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61566 */     // (intrinsic_wo_chain:{ *:[f16] } 3539:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61582 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  61594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61599 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61606 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61609 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61615 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61636 */     // GIR_Coverage, 3119,
     /*  61636 */     GIR_EraseRootFromParent_Done,
     /*  61637 */   // Label 1298: @61637
     /*  61637 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(61697), // Rule ID 3169 //
     /*  61642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61671 */     // (intrinsic_wo_chain:{ *:[i32] } 3546:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61676 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61678 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61695 */     GIR_RootConstrainSelectedInstOperands,
     /*  61696 */     // GIR_Coverage, 3169,
     /*  61696 */     GIR_EraseRootFromParent_Done,
     /*  61697 */   // Label 1299: @61697
     /*  61697 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(61757), // Rule ID 3171 //
     /*  61702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61731 */     // (intrinsic_wo_chain:{ *:[i32] } 3546:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61736 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61738 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61755 */     GIR_RootConstrainSelectedInstOperands,
     /*  61756 */     // GIR_Coverage, 3171,
     /*  61756 */     GIR_EraseRootFromParent_Done,
     /*  61757 */   // Label 1300: @61757
     /*  61757 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(61817), // Rule ID 3173 //
     /*  61762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61791 */     // (intrinsic_wo_chain:{ *:[i32] } 3546:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61796 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61798 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61809 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61815 */     GIR_RootConstrainSelectedInstOperands,
     /*  61816 */     // GIR_Coverage, 3173,
     /*  61816 */     GIR_EraseRootFromParent_Done,
     /*  61817 */   // Label 1301: @61817
     /*  61817 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(61877), // Rule ID 3175 //
     /*  61822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61851 */     // (intrinsic_wo_chain:{ *:[i32] } 3537:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61856 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61858 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61875 */     GIR_RootConstrainSelectedInstOperands,
     /*  61876 */     // GIR_Coverage, 3175,
     /*  61876 */     GIR_EraseRootFromParent_Done,
     /*  61877 */   // Label 1302: @61877
     /*  61877 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(61937), // Rule ID 3177 //
     /*  61882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61911 */     // (intrinsic_wo_chain:{ *:[i32] } 3537:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61916 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61918 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61935 */     GIR_RootConstrainSelectedInstOperands,
     /*  61936 */     // GIR_Coverage, 3177,
     /*  61936 */     GIR_EraseRootFromParent_Done,
     /*  61937 */   // Label 1303: @61937
     /*  61937 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(61997), // Rule ID 3179 //
     /*  61942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61971 */     // (intrinsic_wo_chain:{ *:[i32] } 3537:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61976 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61978 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61995 */     GIR_RootConstrainSelectedInstOperands,
     /*  61996 */     // GIR_Coverage, 3179,
     /*  61996 */     GIR_EraseRootFromParent_Done,
     /*  61997 */   // Label 1304: @61997
     /*  61997 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(62072), // Rule ID 3470 //
     /*  62002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  62010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  62019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62031 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  62031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  62046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62070 */     GIR_RootConstrainSelectedInstOperands,
     /*  62071 */     // GIR_Coverage, 3470,
     /*  62071 */     GIR_EraseRootFromParent_Done,
     /*  62072 */   // Label 1305: @62072
     /*  62072 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(62147), // Rule ID 3477 //
     /*  62077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  62085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  62094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62106 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  62106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  62121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62145 */     GIR_RootConstrainSelectedInstOperands,
     /*  62146 */     // GIR_Coverage, 3477,
     /*  62146 */     GIR_EraseRootFromParent_Done,
     /*  62147 */   // Label 1306: @62147
     /*  62147 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(62222), // Rule ID 3481 //
     /*  62152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  62160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62181 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  62196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62205 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62220 */     GIR_RootConstrainSelectedInstOperands,
     /*  62221 */     // GIR_Coverage, 3481,
     /*  62221 */     GIR_EraseRootFromParent_Done,
     /*  62222 */   // Label 1307: @62222
     /*  62222 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(62297), // Rule ID 3483 //
     /*  62227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  62244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62256 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  62256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  62271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62295 */     GIR_RootConstrainSelectedInstOperands,
     /*  62296 */     // GIR_Coverage, 3483,
     /*  62296 */     GIR_EraseRootFromParent_Done,
     /*  62297 */   // Label 1308: @62297
     /*  62297 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(62372), // Rule ID 3485 //
     /*  62302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  62319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62331 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  62331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  62346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62370 */     GIR_RootConstrainSelectedInstOperands,
     /*  62371 */     // GIR_Coverage, 3485,
     /*  62371 */     GIR_EraseRootFromParent_Done,
     /*  62372 */   // Label 1309: @62372
     /*  62372 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(62447), // Rule ID 3487 //
     /*  62377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62406 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  62421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62445 */     GIR_RootConstrainSelectedInstOperands,
     /*  62446 */     // GIR_Coverage, 3487,
     /*  62446 */     GIR_EraseRootFromParent_Done,
     /*  62447 */   // Label 1310: @62447
     /*  62447 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(62522), // Rule ID 4755 //
     /*  62452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62481 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3592:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  62496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62520 */     GIR_RootConstrainSelectedInstOperands,
     /*  62521 */     // GIR_Coverage, 4755,
     /*  62521 */     GIR_EraseRootFromParent_Done,
     /*  62522 */   // Label 1311: @62522
     /*  62522 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(62597), // Rule ID 4760 //
     /*  62527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62556 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3592:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62595 */     GIR_RootConstrainSelectedInstOperands,
     /*  62596 */     // GIR_Coverage, 4760,
     /*  62596 */     GIR_EraseRootFromParent_Done,
     /*  62597 */   // Label 1312: @62597
     /*  62597 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(62672), // Rule ID 4762 //
     /*  62602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62631 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3592:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62670 */     GIR_RootConstrainSelectedInstOperands,
     /*  62671 */     // GIR_Coverage, 4762,
     /*  62671 */     GIR_EraseRootFromParent_Done,
     /*  62672 */   // Label 1313: @62672
     /*  62672 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(62747), // Rule ID 4764 //
     /*  62677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62706 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3592:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62745 */     GIR_RootConstrainSelectedInstOperands,
     /*  62746 */     // GIR_Coverage, 4764,
     /*  62746 */     GIR_EraseRootFromParent_Done,
     /*  62747 */   // Label 1314: @62747
     /*  62747 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(62822), // Rule ID 4766 //
     /*  62752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62781 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3592:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62820 */     GIR_RootConstrainSelectedInstOperands,
     /*  62821 */     // GIR_Coverage, 4766,
     /*  62821 */     GIR_EraseRootFromParent_Done,
     /*  62822 */   // Label 1315: @62822
     /*  62822 */   GIM_Reject,
     /*  62823 */ // Label 960: @62823
     /*  62823 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(73746),
     /*  62828 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62831 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(62921), // Rule ID 3916 //
     /*  62836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62873 */     // MIs[1] Operand 1
     /*  62873 */     // No operand predicates
     /*  62873 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62879 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62896 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62919 */     GIR_RootConstrainSelectedInstOperands,
     /*  62920 */     // GIR_Coverage, 3916,
     /*  62920 */     GIR_EraseRootFromParent_Done,
     /*  62921 */   // Label 1317: @62921
     /*  62921 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(63011), // Rule ID 3918 //
     /*  62926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62963 */     // MIs[1] Operand 1
     /*  62963 */     // No operand predicates
     /*  62963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62969 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62986 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63009 */     GIR_RootConstrainSelectedInstOperands,
     /*  63010 */     // GIR_Coverage, 3918,
     /*  63010 */     GIR_EraseRootFromParent_Done,
     /*  63011 */   // Label 1318: @63011
     /*  63011 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(63101), // Rule ID 3920 //
     /*  63016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  63053 */     // MIs[1] Operand 1
     /*  63053 */     // No operand predicates
     /*  63053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63059 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  63059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  63074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63099 */     GIR_RootConstrainSelectedInstOperands,
     /*  63100 */     // GIR_Coverage, 3920,
     /*  63100 */     GIR_EraseRootFromParent_Done,
     /*  63101 */   // Label 1319: @63101
     /*  63101 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(63191), // Rule ID 3922 //
     /*  63106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  63143 */     // MIs[1] Operand 1
     /*  63143 */     // No operand predicates
     /*  63143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63149 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  63149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  63164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63166 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63189 */     GIR_RootConstrainSelectedInstOperands,
     /*  63190 */     // GIR_Coverage, 3922,
     /*  63190 */     GIR_EraseRootFromParent_Done,
     /*  63191 */   // Label 1320: @63191
     /*  63191 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(63281), // Rule ID 3924 //
     /*  63196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63233 */     // MIs[1] Operand 1
     /*  63233 */     // No operand predicates
     /*  63233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63239 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  63254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63256 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63279 */     GIR_RootConstrainSelectedInstOperands,
     /*  63280 */     // GIR_Coverage, 3924,
     /*  63280 */     GIR_EraseRootFromParent_Done,
     /*  63281 */   // Label 1321: @63281
     /*  63281 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(63371), // Rule ID 3926 //
     /*  63286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63323 */     // MIs[1] Operand 1
     /*  63323 */     // No operand predicates
     /*  63323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63329 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  63344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63346 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63369 */     GIR_RootConstrainSelectedInstOperands,
     /*  63370 */     // GIR_Coverage, 3926,
     /*  63370 */     GIR_EraseRootFromParent_Done,
     /*  63371 */   // Label 1322: @63371
     /*  63371 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(63461), // Rule ID 3934 //
     /*  63376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63413 */     // MIs[1] Operand 1
     /*  63413 */     // No operand predicates
     /*  63413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63419 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  63434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63436 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63459 */     GIR_RootConstrainSelectedInstOperands,
     /*  63460 */     // GIR_Coverage, 3934,
     /*  63460 */     GIR_EraseRootFromParent_Done,
     /*  63461 */   // Label 1323: @63461
     /*  63461 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(63551), // Rule ID 3936 //
     /*  63466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63503 */     // MIs[1] Operand 1
     /*  63503 */     // No operand predicates
     /*  63503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63509 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  63524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63526 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63549 */     GIR_RootConstrainSelectedInstOperands,
     /*  63550 */     // GIR_Coverage, 3936,
     /*  63550 */     GIR_EraseRootFromParent_Done,
     /*  63551 */   // Label 1324: @63551
     /*  63551 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(63641), // Rule ID 3938 //
     /*  63556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63593 */     // MIs[1] Operand 1
     /*  63593 */     // No operand predicates
     /*  63593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63599 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  63614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63616 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63639 */     GIR_RootConstrainSelectedInstOperands,
     /*  63640 */     // GIR_Coverage, 3938,
     /*  63640 */     GIR_EraseRootFromParent_Done,
     /*  63641 */   // Label 1325: @63641
     /*  63641 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(63731), // Rule ID 3940 //
     /*  63646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63683 */     // MIs[1] Operand 1
     /*  63683 */     // No operand predicates
     /*  63683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63689 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63706 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63729 */     GIR_RootConstrainSelectedInstOperands,
     /*  63730 */     // GIR_Coverage, 3940,
     /*  63730 */     GIR_EraseRootFromParent_Done,
     /*  63731 */   // Label 1326: @63731
     /*  63731 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(63821), // Rule ID 3942 //
     /*  63736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63773 */     // MIs[1] Operand 1
     /*  63773 */     // No operand predicates
     /*  63773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63779 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3685:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63796 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63819 */     GIR_RootConstrainSelectedInstOperands,
     /*  63820 */     // GIR_Coverage, 3942,
     /*  63820 */     GIR_EraseRootFromParent_Done,
     /*  63821 */   // Label 1327: @63821
     /*  63821 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(63911), // Rule ID 3944 //
     /*  63826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63863 */     // MIs[1] Operand 1
     /*  63863 */     // No operand predicates
     /*  63863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63869 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3685:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63886 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63909 */     GIR_RootConstrainSelectedInstOperands,
     /*  63910 */     // GIR_Coverage, 3944,
     /*  63910 */     GIR_EraseRootFromParent_Done,
     /*  63911 */   // Label 1328: @63911
     /*  63911 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(64000), // Rule ID 4042 //
     /*  63916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63956 */     // MIs[1] Operand 1
     /*  63956 */     // No operand predicates
     /*  63956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63958 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63998 */     GIR_RootConstrainSelectedInstOperands,
     /*  63999 */     // GIR_Coverage, 4042,
     /*  63999 */     GIR_EraseRootFromParent_Done,
     /*  64000 */   // Label 1329: @64000
     /*  64000 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(64089), // Rule ID 4044 //
     /*  64005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64045 */     // MIs[1] Operand 1
     /*  64045 */     // No operand predicates
     /*  64045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64047 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  64062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64087 */     GIR_RootConstrainSelectedInstOperands,
     /*  64088 */     // GIR_Coverage, 4044,
     /*  64088 */     GIR_EraseRootFromParent_Done,
     /*  64089 */   // Label 1330: @64089
     /*  64089 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(64178), // Rule ID 4046 //
     /*  64094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64134 */     // MIs[1] Operand 1
     /*  64134 */     // No operand predicates
     /*  64134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64136 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  64151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64176 */     GIR_RootConstrainSelectedInstOperands,
     /*  64177 */     // GIR_Coverage, 4046,
     /*  64177 */     GIR_EraseRootFromParent_Done,
     /*  64178 */   // Label 1331: @64178
     /*  64178 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(64267), // Rule ID 4048 //
     /*  64183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64223 */     // MIs[1] Operand 1
     /*  64223 */     // No operand predicates
     /*  64223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64225 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  64240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64265 */     GIR_RootConstrainSelectedInstOperands,
     /*  64266 */     // GIR_Coverage, 4048,
     /*  64266 */     GIR_EraseRootFromParent_Done,
     /*  64267 */   // Label 1332: @64267
     /*  64267 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(64356), // Rule ID 4050 //
     /*  64272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64312 */     // MIs[1] Operand 1
     /*  64312 */     // No operand predicates
     /*  64312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64314 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  64329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64354 */     GIR_RootConstrainSelectedInstOperands,
     /*  64355 */     // GIR_Coverage, 4050,
     /*  64355 */     GIR_EraseRootFromParent_Done,
     /*  64356 */   // Label 1333: @64356
     /*  64356 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(64445), // Rule ID 4052 //
     /*  64361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64401 */     // MIs[1] Operand 1
     /*  64401 */     // No operand predicates
     /*  64401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64403 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  64418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64443 */     GIR_RootConstrainSelectedInstOperands,
     /*  64444 */     // GIR_Coverage, 4052,
     /*  64444 */     GIR_EraseRootFromParent_Done,
     /*  64445 */   // Label 1334: @64445
     /*  64445 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(64534), // Rule ID 4054 //
     /*  64450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64490 */     // MIs[1] Operand 1
     /*  64490 */     // No operand predicates
     /*  64490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64492 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  64507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64532 */     GIR_RootConstrainSelectedInstOperands,
     /*  64533 */     // GIR_Coverage, 4054,
     /*  64533 */     GIR_EraseRootFromParent_Done,
     /*  64534 */   // Label 1335: @64534
     /*  64534 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(64623), // Rule ID 4056 //
     /*  64539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64579 */     // MIs[1] Operand 1
     /*  64579 */     // No operand predicates
     /*  64579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64581 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  64596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64621 */     GIR_RootConstrainSelectedInstOperands,
     /*  64622 */     // GIR_Coverage, 4056,
     /*  64622 */     GIR_EraseRootFromParent_Done,
     /*  64623 */   // Label 1336: @64623
     /*  64623 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(64690), // Rule ID 3121 //
     /*  64628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64664 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64669 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64671 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64688 */     GIR_RootConstrainSelectedInstOperands,
     /*  64689 */     // GIR_Coverage, 3121,
     /*  64689 */     GIR_EraseRootFromParent_Done,
     /*  64690 */   // Label 1337: @64690
     /*  64690 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(64757), // Rule ID 3123 //
     /*  64695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64731 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64736 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64738 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64755 */     GIR_RootConstrainSelectedInstOperands,
     /*  64756 */     // GIR_Coverage, 3123,
     /*  64756 */     GIR_EraseRootFromParent_Done,
     /*  64757 */   // Label 1338: @64757
     /*  64757 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(64824), // Rule ID 3125 //
     /*  64762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64798 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64803 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64805 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64822 */     GIR_RootConstrainSelectedInstOperands,
     /*  64823 */     // GIR_Coverage, 3125,
     /*  64823 */     GIR_EraseRootFromParent_Done,
     /*  64824 */   // Label 1339: @64824
     /*  64824 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(64891), // Rule ID 3127 //
     /*  64829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64865 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64870 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64872 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64889 */     GIR_RootConstrainSelectedInstOperands,
     /*  64890 */     // GIR_Coverage, 3127,
     /*  64890 */     GIR_EraseRootFromParent_Done,
     /*  64891 */   // Label 1340: @64891
     /*  64891 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(64958), // Rule ID 3129 //
     /*  64896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64932 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64937 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64939 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64956 */     GIR_RootConstrainSelectedInstOperands,
     /*  64957 */     // GIR_Coverage, 3129,
     /*  64957 */     GIR_EraseRootFromParent_Done,
     /*  64958 */   // Label 1341: @64958
     /*  64958 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(65025), // Rule ID 3131 //
     /*  64963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64999 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  65002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65004 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65006 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65023 */     GIR_RootConstrainSelectedInstOperands,
     /*  65024 */     // GIR_Coverage, 3131,
     /*  65024 */     GIR_EraseRootFromParent_Done,
     /*  65025 */   // Label 1342: @65025
     /*  65025 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(65092), // Rule ID 3133 //
     /*  65030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65066 */     // (intrinsic_wo_chain:{ *:[i32] } 3543:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  65066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  65069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65071 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65073 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65090 */     GIR_RootConstrainSelectedInstOperands,
     /*  65091 */     // GIR_Coverage, 3133,
     /*  65091 */     GIR_EraseRootFromParent_Done,
     /*  65092 */   // Label 1343: @65092
     /*  65092 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(65159), // Rule ID 3135 //
     /*  65097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65133 */     // (intrinsic_wo_chain:{ *:[i32] } 3543:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  65136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65138 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65140 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65157 */     GIR_RootConstrainSelectedInstOperands,
     /*  65158 */     // GIR_Coverage, 3135,
     /*  65158 */     GIR_EraseRootFromParent_Done,
     /*  65159 */   // Label 1344: @65159
     /*  65159 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(65226), // Rule ID 3137 //
     /*  65164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65200 */     // (intrinsic_wo_chain:{ *:[i32] } 3543:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  65203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65205 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65207 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65224 */     GIR_RootConstrainSelectedInstOperands,
     /*  65225 */     // GIR_Coverage, 3137,
     /*  65225 */     GIR_EraseRootFromParent_Done,
     /*  65226 */   // Label 1345: @65226
     /*  65226 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(65293), // Rule ID 3139 //
     /*  65231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65267 */     // (intrinsic_wo_chain:{ *:[i32] } 3543:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  65267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  65270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65272 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65274 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65291 */     GIR_RootConstrainSelectedInstOperands,
     /*  65292 */     // GIR_Coverage, 3139,
     /*  65292 */     GIR_EraseRootFromParent_Done,
     /*  65293 */   // Label 1346: @65293
     /*  65293 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(65360), // Rule ID 3141 //
     /*  65298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65334 */     // (intrinsic_wo_chain:{ *:[i32] } 3543:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  65337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65339 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65341 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65358 */     GIR_RootConstrainSelectedInstOperands,
     /*  65359 */     // GIR_Coverage, 3141,
     /*  65359 */     GIR_EraseRootFromParent_Done,
     /*  65360 */   // Label 1347: @65360
     /*  65360 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(65427), // Rule ID 3143 //
     /*  65365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65401 */     // (intrinsic_wo_chain:{ *:[i32] } 3543:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  65404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65406 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65408 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65425 */     GIR_RootConstrainSelectedInstOperands,
     /*  65426 */     // GIR_Coverage, 3143,
     /*  65426 */     GIR_EraseRootFromParent_Done,
     /*  65427 */   // Label 1348: @65427
     /*  65427 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(65509), // Rule ID 3548 //
     /*  65432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65468 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3589:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  65483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65507 */     GIR_RootConstrainSelectedInstOperands,
     /*  65508 */     // GIR_Coverage, 3548,
     /*  65508 */     GIR_EraseRootFromParent_Done,
     /*  65509 */   // Label 1349: @65509
     /*  65509 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(65591), // Rule ID 3555 //
     /*  65514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65550 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3589:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  65565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65589 */     GIR_RootConstrainSelectedInstOperands,
     /*  65590 */     // GIR_Coverage, 3555,
     /*  65590 */     GIR_EraseRootFromParent_Done,
     /*  65591 */   // Label 1350: @65591
     /*  65591 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(65673), // Rule ID 3559 //
     /*  65596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65632 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3589:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65671 */     GIR_RootConstrainSelectedInstOperands,
     /*  65672 */     // GIR_Coverage, 3559,
     /*  65672 */     GIR_EraseRootFromParent_Done,
     /*  65673 */   // Label 1351: @65673
     /*  65673 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(65755), // Rule ID 3563 //
     /*  65678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65714 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3589:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65753 */     GIR_RootConstrainSelectedInstOperands,
     /*  65754 */     // GIR_Coverage, 3563,
     /*  65754 */     GIR_EraseRootFromParent_Done,
     /*  65755 */   // Label 1352: @65755
     /*  65755 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(65837), // Rule ID 3567 //
     /*  65760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65796 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3589:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65835 */     GIR_RootConstrainSelectedInstOperands,
     /*  65836 */     // GIR_Coverage, 3567,
     /*  65836 */     GIR_EraseRootFromParent_Done,
     /*  65837 */   // Label 1353: @65837
     /*  65837 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(65919), // Rule ID 3571 //
     /*  65842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65878 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3589:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65917 */     GIR_RootConstrainSelectedInstOperands,
     /*  65918 */     // GIR_Coverage, 3571,
     /*  65918 */     GIR_EraseRootFromParent_Done,
     /*  65919 */   // Label 1354: @65919
     /*  65919 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(66001), // Rule ID 3572 //
     /*  65924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65960 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65999 */     GIR_RootConstrainSelectedInstOperands,
     /*  66000 */     // GIR_Coverage, 3572,
     /*  66000 */     GIR_EraseRootFromParent_Done,
     /*  66001 */   // Label 1355: @66001
     /*  66001 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(66083), // Rule ID 3579 //
     /*  66006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66042 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  66057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66081 */     GIR_RootConstrainSelectedInstOperands,
     /*  66082 */     // GIR_Coverage, 3579,
     /*  66082 */     GIR_EraseRootFromParent_Done,
     /*  66083 */   // Label 1356: @66083
     /*  66083 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(66165), // Rule ID 3583 //
     /*  66088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66124 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  66139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66163 */     GIR_RootConstrainSelectedInstOperands,
     /*  66164 */     // GIR_Coverage, 3583,
     /*  66164 */     GIR_EraseRootFromParent_Done,
     /*  66165 */   // Label 1357: @66165
     /*  66165 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(66247), // Rule ID 3587 //
     /*  66170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66206 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  66221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66245 */     GIR_RootConstrainSelectedInstOperands,
     /*  66246 */     // GIR_Coverage, 3587,
     /*  66246 */     GIR_EraseRootFromParent_Done,
     /*  66247 */   // Label 1358: @66247
     /*  66247 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(66329), // Rule ID 3591 //
     /*  66252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66288 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  66303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66327 */     GIR_RootConstrainSelectedInstOperands,
     /*  66328 */     // GIR_Coverage, 3591,
     /*  66328 */     GIR_EraseRootFromParent_Done,
     /*  66329 */   // Label 1359: @66329
     /*  66329 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(66411), // Rule ID 3595 //
     /*  66334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66370 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  66385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66409 */     GIR_RootConstrainSelectedInstOperands,
     /*  66410 */     // GIR_Coverage, 3595,
     /*  66410 */     GIR_EraseRootFromParent_Done,
     /*  66411 */   // Label 1360: @66411
     /*  66411 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(66493), // Rule ID 3596 //
     /*  66416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66452 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3624:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  66467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66491 */     GIR_RootConstrainSelectedInstOperands,
     /*  66492 */     // GIR_Coverage, 3596,
     /*  66492 */     GIR_EraseRootFromParent_Done,
     /*  66493 */   // Label 1361: @66493
     /*  66493 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(66575), // Rule ID 3603 //
     /*  66498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66534 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3624:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  66549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66573 */     GIR_RootConstrainSelectedInstOperands,
     /*  66574 */     // GIR_Coverage, 3603,
     /*  66574 */     GIR_EraseRootFromParent_Done,
     /*  66575 */   // Label 1362: @66575
     /*  66575 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(66657), // Rule ID 3607 //
     /*  66580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66616 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3624:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  66631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66655 */     GIR_RootConstrainSelectedInstOperands,
     /*  66656 */     // GIR_Coverage, 3607,
     /*  66656 */     GIR_EraseRootFromParent_Done,
     /*  66657 */   // Label 1363: @66657
     /*  66657 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(66739), // Rule ID 3611 //
     /*  66662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66698 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3624:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66737 */     GIR_RootConstrainSelectedInstOperands,
     /*  66738 */     // GIR_Coverage, 3611,
     /*  66738 */     GIR_EraseRootFromParent_Done,
     /*  66739 */   // Label 1364: @66739
     /*  66739 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(66821), // Rule ID 3615 //
     /*  66744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66780 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3624:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66819 */     GIR_RootConstrainSelectedInstOperands,
     /*  66820 */     // GIR_Coverage, 3615,
     /*  66820 */     GIR_EraseRootFromParent_Done,
     /*  66821 */   // Label 1365: @66821
     /*  66821 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(66903), // Rule ID 3619 //
     /*  66826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66862 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3624:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66901 */     GIR_RootConstrainSelectedInstOperands,
     /*  66902 */     // GIR_Coverage, 3619,
     /*  66902 */     GIR_EraseRootFromParent_Done,
     /*  66903 */   // Label 1366: @66903
     /*  66903 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(66985), // Rule ID 3620 //
     /*  66908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66944 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3625:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66983 */     GIR_RootConstrainSelectedInstOperands,
     /*  66984 */     // GIR_Coverage, 3620,
     /*  66984 */     GIR_EraseRootFromParent_Done,
     /*  66985 */   // Label 1367: @66985
     /*  66985 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(67067), // Rule ID 3623 //
     /*  66990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67026 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3625:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  67041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67065 */     GIR_RootConstrainSelectedInstOperands,
     /*  67066 */     // GIR_Coverage, 3623,
     /*  67066 */     GIR_EraseRootFromParent_Done,
     /*  67067 */   // Label 1368: @67067
     /*  67067 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(67149), // Rule ID 3626 //
     /*  67072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67108 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3625:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  67123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67147 */     GIR_RootConstrainSelectedInstOperands,
     /*  67148 */     // GIR_Coverage, 3626,
     /*  67148 */     GIR_EraseRootFromParent_Done,
     /*  67149 */   // Label 1369: @67149
     /*  67149 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(67231), // Rule ID 3629 //
     /*  67154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67190 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3625:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  67205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67229 */     GIR_RootConstrainSelectedInstOperands,
     /*  67230 */     // GIR_Coverage, 3629,
     /*  67230 */     GIR_EraseRootFromParent_Done,
     /*  67231 */   // Label 1370: @67231
     /*  67231 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(67313), // Rule ID 3632 //
     /*  67236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67272 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3625:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  67287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67311 */     GIR_RootConstrainSelectedInstOperands,
     /*  67312 */     // GIR_Coverage, 3632,
     /*  67312 */     GIR_EraseRootFromParent_Done,
     /*  67313 */   // Label 1371: @67313
     /*  67313 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(67395), // Rule ID 3635 //
     /*  67318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67354 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3625:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  67369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67393 */     GIR_RootConstrainSelectedInstOperands,
     /*  67394 */     // GIR_Coverage, 3635,
     /*  67394 */     GIR_EraseRootFromParent_Done,
     /*  67395 */   // Label 1372: @67395
     /*  67395 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(67477), // Rule ID 4036 //
     /*  67400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67436 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3589:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  67436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  67451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67475 */     GIR_RootConstrainSelectedInstOperands,
     /*  67476 */     // GIR_Coverage, 4036,
     /*  67476 */     GIR_EraseRootFromParent_Done,
     /*  67477 */   // Label 1373: @67477
     /*  67477 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(67559), // Rule ID 4038 //
     /*  67482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67518 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3589:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  67518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  67533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67557 */     GIR_RootConstrainSelectedInstOperands,
     /*  67558 */     // GIR_Coverage, 4038,
     /*  67558 */     GIR_EraseRootFromParent_Done,
     /*  67559 */   // Label 1374: @67559
     /*  67559 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(67641), // Rule ID 4411 //
     /*  67564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67600 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  67615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67639 */     GIR_RootConstrainSelectedInstOperands,
     /*  67640 */     // GIR_Coverage, 4411,
     /*  67640 */     GIR_EraseRootFromParent_Done,
     /*  67641 */   // Label 1375: @67641
     /*  67641 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(67723), // Rule ID 4413 //
     /*  67646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67682 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67721 */     GIR_RootConstrainSelectedInstOperands,
     /*  67722 */     // GIR_Coverage, 4413,
     /*  67722 */     GIR_EraseRootFromParent_Done,
     /*  67723 */   // Label 1376: @67723
     /*  67723 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(67805), // Rule ID 4415 //
     /*  67728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67764 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67803 */     GIR_RootConstrainSelectedInstOperands,
     /*  67804 */     // GIR_Coverage, 4415,
     /*  67804 */     GIR_EraseRootFromParent_Done,
     /*  67805 */   // Label 1377: @67805
     /*  67805 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(67887), // Rule ID 4417 //
     /*  67810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67846 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67885 */     GIR_RootConstrainSelectedInstOperands,
     /*  67886 */     // GIR_Coverage, 4417,
     /*  67886 */     GIR_EraseRootFromParent_Done,
     /*  67887 */   // Label 1378: @67887
     /*  67887 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(67969), // Rule ID 4444 //
     /*  67892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67928 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3650:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67967 */     GIR_RootConstrainSelectedInstOperands,
     /*  67968 */     // GIR_Coverage, 4444,
     /*  67968 */     GIR_EraseRootFromParent_Done,
     /*  67969 */   // Label 1379: @67969
     /*  67969 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(68051), // Rule ID 4451 //
     /*  67974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68010 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3650:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  68025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68049 */     GIR_RootConstrainSelectedInstOperands,
     /*  68050 */     // GIR_Coverage, 4451,
     /*  68050 */     GIR_EraseRootFromParent_Done,
     /*  68051 */   // Label 1380: @68051
     /*  68051 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(68133), // Rule ID 4455 //
     /*  68056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68092 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3650:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  68107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68131 */     GIR_RootConstrainSelectedInstOperands,
     /*  68132 */     // GIR_Coverage, 4455,
     /*  68132 */     GIR_EraseRootFromParent_Done,
     /*  68133 */   // Label 1381: @68133
     /*  68133 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(68215), // Rule ID 4459 //
     /*  68138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68174 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3650:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  68189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68213 */     GIR_RootConstrainSelectedInstOperands,
     /*  68214 */     // GIR_Coverage, 4459,
     /*  68214 */     GIR_EraseRootFromParent_Done,
     /*  68215 */   // Label 1382: @68215
     /*  68215 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(68297), // Rule ID 4463 //
     /*  68220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68256 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3650:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  68271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68295 */     GIR_RootConstrainSelectedInstOperands,
     /*  68296 */     // GIR_Coverage, 4463,
     /*  68296 */     GIR_EraseRootFromParent_Done,
     /*  68297 */   // Label 1383: @68297
     /*  68297 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(68379), // Rule ID 4467 //
     /*  68302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68338 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3650:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  68353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68377 */     GIR_RootConstrainSelectedInstOperands,
     /*  68378 */     // GIR_Coverage, 4467,
     /*  68378 */     GIR_EraseRootFromParent_Done,
     /*  68379 */   // Label 1384: @68379
     /*  68379 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(68461), // Rule ID 4468 //
     /*  68384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68420 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3684:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  68435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68459 */     GIR_RootConstrainSelectedInstOperands,
     /*  68460 */     // GIR_Coverage, 4468,
     /*  68460 */     GIR_EraseRootFromParent_Done,
     /*  68461 */   // Label 1385: @68461
     /*  68461 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(68543), // Rule ID 4470 //
     /*  68466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68502 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3684:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  68517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68541 */     GIR_RootConstrainSelectedInstOperands,
     /*  68542 */     // GIR_Coverage, 4470,
     /*  68542 */     GIR_EraseRootFromParent_Done,
     /*  68543 */   // Label 1386: @68543
     /*  68543 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(68625), // Rule ID 4472 //
     /*  68548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68584 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3684:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  68599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68623 */     GIR_RootConstrainSelectedInstOperands,
     /*  68624 */     // GIR_Coverage, 4472,
     /*  68624 */     GIR_EraseRootFromParent_Done,
     /*  68625 */   // Label 1387: @68625
     /*  68625 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(68707), // Rule ID 4474 //
     /*  68630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68666 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3684:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68705 */     GIR_RootConstrainSelectedInstOperands,
     /*  68706 */     // GIR_Coverage, 4474,
     /*  68706 */     GIR_EraseRootFromParent_Done,
     /*  68707 */   // Label 1388: @68707
     /*  68707 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(68789), // Rule ID 4476 //
     /*  68712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68748 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3684:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68787 */     GIR_RootConstrainSelectedInstOperands,
     /*  68788 */     // GIR_Coverage, 4476,
     /*  68788 */     GIR_EraseRootFromParent_Done,
     /*  68789 */   // Label 1389: @68789
     /*  68789 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(68871), // Rule ID 4478 //
     /*  68794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68830 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3684:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68869 */     GIR_RootConstrainSelectedInstOperands,
     /*  68870 */     // GIR_Coverage, 4478,
     /*  68870 */     GIR_EraseRootFromParent_Done,
     /*  68871 */   // Label 1390: @68871
     /*  68871 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(68938), // Rule ID 4529 //
     /*  68876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68912 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3608:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68936 */     GIR_RootConstrainSelectedInstOperands,
     /*  68937 */     // GIR_Coverage, 4529,
     /*  68937 */     GIR_EraseRootFromParent_Done,
     /*  68938 */   // Label 1391: @68938
     /*  68938 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(69005), // Rule ID 4535 //
     /*  68943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68979 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3608:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69003 */     GIR_RootConstrainSelectedInstOperands,
     /*  69004 */     // GIR_Coverage, 4535,
     /*  69004 */     GIR_EraseRootFromParent_Done,
     /*  69005 */   // Label 1392: @69005
     /*  69005 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(69087), // Rule ID 4553 //
     /*  69010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  69046 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3660:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  69046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  69061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69085 */     GIR_RootConstrainSelectedInstOperands,
     /*  69086 */     // GIR_Coverage, 4553,
     /*  69086 */     GIR_EraseRootFromParent_Done,
     /*  69087 */   // Label 1393: @69087
     /*  69087 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(69169), // Rule ID 4555 //
     /*  69092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  69128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3660:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  69128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  69143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69167 */     GIR_RootConstrainSelectedInstOperands,
     /*  69168 */     // GIR_Coverage, 4555,
     /*  69168 */     GIR_EraseRootFromParent_Done,
     /*  69169 */   // Label 1394: @69169
     /*  69169 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(69251), // Rule ID 4557 //
     /*  69174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  69210 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3660:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  69225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69249 */     GIR_RootConstrainSelectedInstOperands,
     /*  69250 */     // GIR_Coverage, 4557,
     /*  69250 */     GIR_EraseRootFromParent_Done,
     /*  69251 */   // Label 1395: @69251
     /*  69251 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(69333), // Rule ID 4559 //
     /*  69256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  69292 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3660:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  69307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69331 */     GIR_RootConstrainSelectedInstOperands,
     /*  69332 */     // GIR_Coverage, 4559,
     /*  69332 */     GIR_EraseRootFromParent_Done,
     /*  69333 */   // Label 1396: @69333
     /*  69333 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(69410), // Rule ID 3904 //
     /*  69338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  69379 */     // MIs[1] Operand 1
     /*  69379 */     // No operand predicates
     /*  69379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69381 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3699:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  69381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  69384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69386 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69408 */     GIR_RootConstrainSelectedInstOperands,
     /*  69409 */     // GIR_Coverage, 3904,
     /*  69409 */     GIR_EraseRootFromParent_Done,
     /*  69410 */   // Label 1397: @69410
     /*  69410 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(69487), // Rule ID 3906 //
     /*  69415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  69456 */     // MIs[1] Operand 1
     /*  69456 */     // No operand predicates
     /*  69456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69458 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3699:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  69458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  69461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69463 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69485 */     GIR_RootConstrainSelectedInstOperands,
     /*  69486 */     // GIR_Coverage, 3906,
     /*  69486 */     GIR_EraseRootFromParent_Done,
     /*  69487 */   // Label 1398: @69487
     /*  69487 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(69564), // Rule ID 3908 //
     /*  69492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  69533 */     // MIs[1] Operand 1
     /*  69533 */     // No operand predicates
     /*  69533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69535 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3699:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  69535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  69538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69540 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69562 */     GIR_RootConstrainSelectedInstOperands,
     /*  69563 */     // GIR_Coverage, 3908,
     /*  69563 */     GIR_EraseRootFromParent_Done,
     /*  69564 */   // Label 1399: @69564
     /*  69564 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(69641), // Rule ID 3910 //
     /*  69569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  69610 */     // MIs[1] Operand 1
     /*  69610 */     // No operand predicates
     /*  69610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69612 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3701:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  69612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  69615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69617 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69639 */     GIR_RootConstrainSelectedInstOperands,
     /*  69640 */     // GIR_Coverage, 3910,
     /*  69640 */     GIR_EraseRootFromParent_Done,
     /*  69641 */   // Label 1400: @69641
     /*  69641 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(69718), // Rule ID 3912 //
     /*  69646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69687 */     // MIs[1] Operand 1
     /*  69687 */     // No operand predicates
     /*  69687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69689 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3701:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69694 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69716 */     GIR_RootConstrainSelectedInstOperands,
     /*  69717 */     // GIR_Coverage, 3912,
     /*  69717 */     GIR_EraseRootFromParent_Done,
     /*  69718 */   // Label 1401: @69718
     /*  69718 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(69795), // Rule ID 3914 //
     /*  69723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69764 */     // MIs[1] Operand 1
     /*  69764 */     // No operand predicates
     /*  69764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69766 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3701:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69771 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69793 */     GIR_RootConstrainSelectedInstOperands,
     /*  69794 */     // GIR_Coverage, 3914,
     /*  69794 */     GIR_EraseRootFromParent_Done,
     /*  69795 */   // Label 1402: @69795
     /*  69795 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(69886), // Rule ID 4383 //
     /*  69800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69832 */     // MIs[1] Operand 1
     /*  69832 */     // No operand predicates
     /*  69832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69842 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3599:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69884 */     GIR_RootConstrainSelectedInstOperands,
     /*  69885 */     // GIR_Coverage, 4383,
     /*  69885 */     GIR_EraseRootFromParent_Done,
     /*  69886 */   // Label 1403: @69886
     /*  69886 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(69977), // Rule ID 4385 //
     /*  69891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69923 */     // MIs[1] Operand 1
     /*  69923 */     // No operand predicates
     /*  69923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69933 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3599:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69975 */     GIR_RootConstrainSelectedInstOperands,
     /*  69976 */     // GIR_Coverage, 4385,
     /*  69976 */     GIR_EraseRootFromParent_Done,
     /*  69977 */   // Label 1404: @69977
     /*  69977 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(70040), // Rule ID 146 //
     /*  69982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70018 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  70018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  70021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70038 */     GIR_RootConstrainSelectedInstOperands,
     /*  70039 */     // GIR_Coverage, 146,
     /*  70039 */     GIR_EraseRootFromParent_Done,
     /*  70040 */   // Label 1405: @70040
     /*  70040 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(70103), // Rule ID 469 //
     /*  70045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  70053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70081 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  70084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70101 */     GIR_RootConstrainSelectedInstOperands,
     /*  70102 */     // GIR_Coverage, 469,
     /*  70102 */     GIR_EraseRootFromParent_Done,
     /*  70103 */   // Label 1406: @70103
     /*  70103 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(70166), // Rule ID 528 //
     /*  70108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  70116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70144 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  70147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70164 */     GIR_RootConstrainSelectedInstOperands,
     /*  70165 */     // GIR_Coverage, 528,
     /*  70165 */     GIR_EraseRootFromParent_Done,
     /*  70166 */   // Label 1407: @70166
     /*  70166 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(70229), // Rule ID 529 //
     /*  70171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70207 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  70210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70227 */     GIR_RootConstrainSelectedInstOperands,
     /*  70228 */     // GIR_Coverage, 529,
     /*  70228 */     GIR_EraseRootFromParent_Done,
     /*  70229 */   // Label 1408: @70229
     /*  70229 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(70292), // Rule ID 530 //
     /*  70234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70270 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  70273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70290 */     GIR_RootConstrainSelectedInstOperands,
     /*  70291 */     // GIR_Coverage, 530,
     /*  70291 */     GIR_EraseRootFromParent_Done,
     /*  70292 */   // Label 1409: @70292
     /*  70292 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(70355), // Rule ID 531 //
     /*  70297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  70305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70333 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  70336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70353 */     GIR_RootConstrainSelectedInstOperands,
     /*  70354 */     // GIR_Coverage, 531,
     /*  70354 */     GIR_EraseRootFromParent_Done,
     /*  70355 */   // Label 1410: @70355
     /*  70355 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(70409), // Rule ID 951 //
     /*  70360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70396 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3731:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  70399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70407 */     GIR_RootConstrainSelectedInstOperands,
     /*  70408 */     // GIR_Coverage, 951,
     /*  70408 */     GIR_EraseRootFromParent_Done,
     /*  70409 */   // Label 1411: @70409
     /*  70409 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(70463), // Rule ID 952 //
     /*  70414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70450 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3719:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  70453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70461 */     GIR_RootConstrainSelectedInstOperands,
     /*  70462 */     // GIR_Coverage, 952,
     /*  70462 */     GIR_EraseRootFromParent_Done,
     /*  70463 */   // Label 1412: @70463
     /*  70463 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70517), // Rule ID 953 //
     /*  70468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70504 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3731:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  70507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70515 */     GIR_RootConstrainSelectedInstOperands,
     /*  70516 */     // GIR_Coverage, 953,
     /*  70516 */     GIR_EraseRootFromParent_Done,
     /*  70517 */   // Label 1413: @70517
     /*  70517 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70571), // Rule ID 954 //
     /*  70522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70558 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3719:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  70561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70569 */     GIR_RootConstrainSelectedInstOperands,
     /*  70570 */     // GIR_Coverage, 954,
     /*  70570 */     GIR_EraseRootFromParent_Done,
     /*  70571 */   // Label 1414: @70571
     /*  70571 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(70625), // Rule ID 955 //
     /*  70576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  70584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70612 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3730:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  70615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70623 */     GIR_RootConstrainSelectedInstOperands,
     /*  70624 */     // GIR_Coverage, 955,
     /*  70624 */     GIR_EraseRootFromParent_Done,
     /*  70625 */   // Label 1415: @70625
     /*  70625 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(70679), // Rule ID 956 //
     /*  70630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70666 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3732:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70677 */     GIR_RootConstrainSelectedInstOperands,
     /*  70678 */     // GIR_Coverage, 956,
     /*  70678 */     GIR_EraseRootFromParent_Done,
     /*  70679 */   // Label 1416: @70679
     /*  70679 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(70733), // Rule ID 957 //
     /*  70684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70720 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3734:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70731 */     GIR_RootConstrainSelectedInstOperands,
     /*  70732 */     // GIR_Coverage, 957,
     /*  70732 */     GIR_EraseRootFromParent_Done,
     /*  70733 */   // Label 1417: @70733
     /*  70733 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(70787), // Rule ID 958 //
     /*  70738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70774 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3733:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70785 */     GIR_RootConstrainSelectedInstOperands,
     /*  70786 */     // GIR_Coverage, 958,
     /*  70786 */     GIR_EraseRootFromParent_Done,
     /*  70787 */   // Label 1418: @70787
     /*  70787 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(70841), // Rule ID 959 //
     /*  70792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70828 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3733:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70839 */     GIR_RootConstrainSelectedInstOperands,
     /*  70840 */     // GIR_Coverage, 959,
     /*  70840 */     GIR_EraseRootFromParent_Done,
     /*  70841 */   // Label 1419: @70841
     /*  70841 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(70904), // Rule ID 1690 //
     /*  70846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70882 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3851:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70887 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70902 */     GIR_RootConstrainSelectedInstOperands,
     /*  70903 */     // GIR_Coverage, 1690,
     /*  70903 */     GIR_EraseRootFromParent_Done,
     /*  70904 */   // Label 1420: @70904
     /*  70904 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(70958), // Rule ID 1721 //
     /*  70909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70945 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3724:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70950 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70956 */     GIR_RootConstrainSelectedInstOperands,
     /*  70957 */     // GIR_Coverage, 1721,
     /*  70957 */     GIR_EraseRootFromParent_Done,
     /*  70958 */   // Label 1421: @70958
     /*  70958 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(71012), // Rule ID 1722 //
     /*  70963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70999 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3726:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  71002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  71006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71010 */     GIR_RootConstrainSelectedInstOperands,
     /*  71011 */     // GIR_Coverage, 1722,
     /*  71011 */     GIR_EraseRootFromParent_Done,
     /*  71012 */   // Label 1422: @71012
     /*  71012 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(71066), // Rule ID 1723 //
     /*  71017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  71020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  71025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  71037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71053 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3727:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  71053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  71056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71058 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  71060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71064 */     GIR_RootConstrainSelectedInstOperands,
     /*  71065 */     // GIR_Coverage, 1723,
     /*  71065 */     GIR_EraseRootFromParent_Done,
     /*  71066 */   // Label 1423: @71066
     /*  71066 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(71120), // Rule ID 1724 //
     /*  71071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  71074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  71079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  71091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71107 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3729:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  71107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  71110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71112 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  71114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71118 */     GIR_RootConstrainSelectedInstOperands,
     /*  71119 */     // GIR_Coverage, 1724,
     /*  71119 */     GIR_EraseRootFromParent_Done,
     /*  71120 */   // Label 1424: @71120
     /*  71120 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(71183), // Rule ID 1899 //
     /*  71125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  71133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71161 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  71164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71181 */     GIR_RootConstrainSelectedInstOperands,
     /*  71182 */     // GIR_Coverage, 1899,
     /*  71182 */     GIR_EraseRootFromParent_Done,
     /*  71183 */   // Label 1425: @71183
     /*  71183 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(71246), // Rule ID 1900 //
     /*  71188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  71196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71224 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  71227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71244 */     GIR_RootConstrainSelectedInstOperands,
     /*  71245 */     // GIR_Coverage, 1900,
     /*  71245 */     GIR_EraseRootFromParent_Done,
     /*  71246 */   // Label 1426: @71246
     /*  71246 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(71309), // Rule ID 1901 //
     /*  71251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  71259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71287 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  71290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71307 */     GIR_RootConstrainSelectedInstOperands,
     /*  71308 */     // GIR_Coverage, 1901,
     /*  71308 */     GIR_EraseRootFromParent_Done,
     /*  71309 */   // Label 1427: @71309
     /*  71309 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(71372), // Rule ID 1902 //
     /*  71314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  71322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71350 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  71353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71370 */     GIR_RootConstrainSelectedInstOperands,
     /*  71371 */     // GIR_Coverage, 1902,
     /*  71371 */     GIR_EraseRootFromParent_Done,
     /*  71372 */   // Label 1428: @71372
     /*  71372 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(71435), // Rule ID 1990 //
     /*  71377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71413 */     // (intrinsic_wo_chain:{ *:[i32] } 3874:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  71416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71418 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71420 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71422 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71433 */     GIR_RootConstrainSelectedInstOperands,
     /*  71434 */     // GIR_Coverage, 1990,
     /*  71434 */     GIR_EraseRootFromParent_Done,
     /*  71435 */   // Label 1429: @71435
     /*  71435 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71498), // Rule ID 1991 //
     /*  71440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71476 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  71479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71481 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71483 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71485 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71496 */     GIR_RootConstrainSelectedInstOperands,
     /*  71497 */     // GIR_Coverage, 1991,
     /*  71497 */     GIR_EraseRootFromParent_Done,
     /*  71498 */   // Label 1430: @71498
     /*  71498 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(71561), // Rule ID 1992 //
     /*  71503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71539 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  71542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71544 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71546 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71548 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71559 */     GIR_RootConstrainSelectedInstOperands,
     /*  71560 */     // GIR_Coverage, 1992,
     /*  71560 */     GIR_EraseRootFromParent_Done,
     /*  71561 */   // Label 1431: @71561
     /*  71561 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(71624), // Rule ID 1993 //
     /*  71566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71602 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  71605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71607 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71609 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71611 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71622 */     GIR_RootConstrainSelectedInstOperands,
     /*  71623 */     // GIR_Coverage, 1993,
     /*  71623 */     GIR_EraseRootFromParent_Done,
     /*  71624 */   // Label 1432: @71624
     /*  71624 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(71687), // Rule ID 1994 //
     /*  71629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71665 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71670 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71672 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71674 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71685 */     GIR_RootConstrainSelectedInstOperands,
     /*  71686 */     // GIR_Coverage, 1994,
     /*  71686 */     GIR_EraseRootFromParent_Done,
     /*  71687 */   // Label 1433: @71687
     /*  71687 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(71750), // Rule ID 1995 //
     /*  71692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71728 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71733 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71735 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71737 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71748 */     GIR_RootConstrainSelectedInstOperands,
     /*  71749 */     // GIR_Coverage, 1995,
     /*  71749 */     GIR_EraseRootFromParent_Done,
     /*  71750 */   // Label 1434: @71750
     /*  71750 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(71813), // Rule ID 2181 //
     /*  71755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71791 */     // (intrinsic_wo_chain:{ *:[i32] } 3874:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71796 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71798 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71800 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71811 */     GIR_RootConstrainSelectedInstOperands,
     /*  71812 */     // GIR_Coverage, 2181,
     /*  71812 */     GIR_EraseRootFromParent_Done,
     /*  71813 */   // Label 1435: @71813
     /*  71813 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(71876), // Rule ID 2182 //
     /*  71818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71854 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71859 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71861 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71863 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71874 */     GIR_RootConstrainSelectedInstOperands,
     /*  71875 */     // GIR_Coverage, 2182,
     /*  71875 */     GIR_EraseRootFromParent_Done,
     /*  71876 */   // Label 1436: @71876
     /*  71876 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(71939), // Rule ID 2183 //
     /*  71881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71917 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71922 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71924 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71926 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71937 */     GIR_RootConstrainSelectedInstOperands,
     /*  71938 */     // GIR_Coverage, 2183,
     /*  71938 */     GIR_EraseRootFromParent_Done,
     /*  71939 */   // Label 1437: @71939
     /*  71939 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(72002), // Rule ID 2184 //
     /*  71944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71980 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71985 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71987 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71989 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72000 */     GIR_RootConstrainSelectedInstOperands,
     /*  72001 */     // GIR_Coverage, 2184,
     /*  72001 */     GIR_EraseRootFromParent_Done,
     /*  72002 */   // Label 1438: @72002
     /*  72002 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(72065), // Rule ID 2185 //
     /*  72007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  72010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  72015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  72018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72043 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  72043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  72046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72048 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  72050 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  72052 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  72054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72063 */     GIR_RootConstrainSelectedInstOperands,
     /*  72064 */     // GIR_Coverage, 2185,
     /*  72064 */     GIR_EraseRootFromParent_Done,
     /*  72065 */   // Label 1439: @72065
     /*  72065 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(72128), // Rule ID 2186 //
     /*  72070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  72073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  72078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  72081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72106 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  72106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  72109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72111 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  72113 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  72115 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  72117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72126 */     GIR_RootConstrainSelectedInstOperands,
     /*  72127 */     // GIR_Coverage, 2186,
     /*  72127 */     GIR_EraseRootFromParent_Done,
     /*  72128 */   // Label 1440: @72128
     /*  72128 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(72191), // Rule ID 2472 //
     /*  72133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72169 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  72172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72189 */     GIR_RootConstrainSelectedInstOperands,
     /*  72190 */     // GIR_Coverage, 2472,
     /*  72190 */     GIR_EraseRootFromParent_Done,
     /*  72191 */   // Label 1441: @72191
     /*  72191 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(72254), // Rule ID 2473 //
     /*  72196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72232 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  72235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72252 */     GIR_RootConstrainSelectedInstOperands,
     /*  72253 */     // GIR_Coverage, 2473,
     /*  72253 */     GIR_EraseRootFromParent_Done,
     /*  72254 */   // Label 1442: @72254
     /*  72254 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(72317), // Rule ID 2474 //
     /*  72259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72295 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3803:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  72298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72300 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72315 */     GIR_RootConstrainSelectedInstOperands,
     /*  72316 */     // GIR_Coverage, 2474,
     /*  72316 */     GIR_EraseRootFromParent_Done,
     /*  72317 */   // Label 1443: @72317
     /*  72317 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(72380), // Rule ID 2475 //
     /*  72322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72358 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3803:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  72361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72367 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72378 */     GIR_RootConstrainSelectedInstOperands,
     /*  72379 */     // GIR_Coverage, 2475,
     /*  72379 */     GIR_EraseRootFromParent_Done,
     /*  72380 */   // Label 1444: @72380
     /*  72380 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(72443), // Rule ID 2480 //
     /*  72385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72421 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  72424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72426 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72441 */     GIR_RootConstrainSelectedInstOperands,
     /*  72442 */     // GIR_Coverage, 2480,
     /*  72442 */     GIR_EraseRootFromParent_Done,
     /*  72443 */   // Label 1445: @72443
     /*  72443 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(72506), // Rule ID 2481 //
     /*  72448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72484 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  72487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72489 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72504 */     GIR_RootConstrainSelectedInstOperands,
     /*  72505 */     // GIR_Coverage, 2481,
     /*  72505 */     GIR_EraseRootFromParent_Done,
     /*  72506 */   // Label 1446: @72506
     /*  72506 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(72569), // Rule ID 2482 //
     /*  72511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72547 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3804:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  72550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72552 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72567 */     GIR_RootConstrainSelectedInstOperands,
     /*  72568 */     // GIR_Coverage, 2482,
     /*  72568 */     GIR_EraseRootFromParent_Done,
     /*  72569 */   // Label 1447: @72569
     /*  72569 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(72632), // Rule ID 2483 //
     /*  72574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72610 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3804:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  72613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72615 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72630 */     GIR_RootConstrainSelectedInstOperands,
     /*  72631 */     // GIR_Coverage, 2483,
     /*  72631 */     GIR_EraseRootFromParent_Done,
     /*  72632 */   // Label 1448: @72632
     /*  72632 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(72701), // Rule ID 4840 //
     /*  72637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72673 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3655:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72678 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72680 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72682 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72699 */     GIR_RootConstrainSelectedInstOperands,
     /*  72700 */     // GIR_Coverage, 4840,
     /*  72700 */     GIR_EraseRootFromParent_Done,
     /*  72701 */   // Label 1449: @72701
     /*  72701 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(72770), // Rule ID 4842 //
     /*  72706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72742 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3655:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72747 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72749 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72751 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72768 */     GIR_RootConstrainSelectedInstOperands,
     /*  72769 */     // GIR_Coverage, 4842,
     /*  72769 */     GIR_EraseRootFromParent_Done,
     /*  72770 */   // Label 1450: @72770
     /*  72770 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(72839), // Rule ID 4844 //
     /*  72775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72811 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3655:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72816 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72818 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72820 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72837 */     GIR_RootConstrainSelectedInstOperands,
     /*  72838 */     // GIR_Coverage, 4844,
     /*  72838 */     GIR_EraseRootFromParent_Done,
     /*  72839 */   // Label 1451: @72839
     /*  72839 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(72908), // Rule ID 4846 //
     /*  72844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72880 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72885 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72887 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72889 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72906 */     GIR_RootConstrainSelectedInstOperands,
     /*  72907 */     // GIR_Coverage, 4846,
     /*  72907 */     GIR_EraseRootFromParent_Done,
     /*  72908 */   // Label 1452: @72908
     /*  72908 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(72977), // Rule ID 4848 //
     /*  72913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72949 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72954 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72956 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72958 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72975 */     GIR_RootConstrainSelectedInstOperands,
     /*  72976 */     // GIR_Coverage, 4848,
     /*  72976 */     GIR_EraseRootFromParent_Done,
     /*  72977 */   // Label 1453: @72977
     /*  72977 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(73046), // Rule ID 4850 //
     /*  72982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  73021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73023 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73025 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73027 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73044 */     GIR_RootConstrainSelectedInstOperands,
     /*  73045 */     // GIR_Coverage, 4850,
     /*  73045 */     GIR_EraseRootFromParent_Done,
     /*  73046 */   // Label 1454: @73046
     /*  73046 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(73115), // Rule ID 4852 //
     /*  73051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  73062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73087 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3657:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  73090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73092 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73094 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73096 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73113 */     GIR_RootConstrainSelectedInstOperands,
     /*  73114 */     // GIR_Coverage, 4852,
     /*  73114 */     GIR_EraseRootFromParent_Done,
     /*  73115 */   // Label 1455: @73115
     /*  73115 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(73184), // Rule ID 4854 //
     /*  73120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73156 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3657:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  73159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73161 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73163 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73165 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73182 */     GIR_RootConstrainSelectedInstOperands,
     /*  73183 */     // GIR_Coverage, 4854,
     /*  73183 */     GIR_EraseRootFromParent_Done,
     /*  73184 */   // Label 1456: @73184
     /*  73184 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(73253), // Rule ID 4856 //
     /*  73189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73225 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3657:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  73228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73230 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73232 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73234 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73251 */     GIR_RootConstrainSelectedInstOperands,
     /*  73252 */     // GIR_Coverage, 4856,
     /*  73252 */     GIR_EraseRootFromParent_Done,
     /*  73253 */   // Label 1457: @73253
     /*  73253 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(73322), // Rule ID 4858 //
     /*  73258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  73269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73294 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3666:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  73297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73299 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73301 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73303 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73320 */     GIR_RootConstrainSelectedInstOperands,
     /*  73321 */     // GIR_Coverage, 4858,
     /*  73321 */     GIR_EraseRootFromParent_Done,
     /*  73322 */   // Label 1458: @73322
     /*  73322 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(73391), // Rule ID 4860 //
     /*  73327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73363 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  73366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73368 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73370 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73372 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73389 */     GIR_RootConstrainSelectedInstOperands,
     /*  73390 */     // GIR_Coverage, 4860,
     /*  73390 */     GIR_EraseRootFromParent_Done,
     /*  73391 */   // Label 1459: @73391
     /*  73391 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(73460), // Rule ID 4862 //
     /*  73396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73432 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  73435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73437 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73439 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73441 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73458 */     GIR_RootConstrainSelectedInstOperands,
     /*  73459 */     // GIR_Coverage, 4862,
     /*  73459 */     GIR_EraseRootFromParent_Done,
     /*  73460 */   // Label 1460: @73460
     /*  73460 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(73555), // Rule ID 2694 //
     /*  73465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  73473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73489 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3720:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73501 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73525 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73528 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  73544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73546 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73551 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73553 */     GIR_RootConstrainSelectedInstOperands,
     /*  73554 */     // GIR_Coverage, 2694,
     /*  73554 */     GIR_EraseRootFromParent_Done,
     /*  73555 */   // Label 1461: @73555
     /*  73555 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(73650), // Rule ID 2695 //
     /*  73560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  73568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73584 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3722:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73596 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73600 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73617 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73620 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73641 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73646 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73648 */     GIR_RootConstrainSelectedInstOperands,
     /*  73649 */     // GIR_Coverage, 2695,
     /*  73649 */     GIR_EraseRootFromParent_Done,
     /*  73650 */   // Label 1462: @73650
     /*  73650 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(73745), // Rule ID 2696 //
     /*  73655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73679 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3723:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73715 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73736 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73741 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73743 */     GIR_RootConstrainSelectedInstOperands,
     /*  73744 */     // GIR_Coverage, 2696,
     /*  73744 */     GIR_EraseRootFromParent_Done,
     /*  73745 */   // Label 1463: @73745
     /*  73745 */   GIM_Reject,
     /*  73746 */ // Label 1316: @73746
     /*  73746 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(77132),
     /*  73751 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73754 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(73838), // Rule ID 3727 //
     /*  73759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73799 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73836 */     GIR_RootConstrainSelectedInstOperands,
     /*  73837 */     // GIR_Coverage, 3727,
     /*  73837 */     GIR_EraseRootFromParent_Done,
     /*  73838 */   // Label 1465: @73838
     /*  73838 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(73922), // Rule ID 3731 //
     /*  73843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73871 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73883 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73920 */     GIR_RootConstrainSelectedInstOperands,
     /*  73921 */     // GIR_Coverage, 3731,
     /*  73921 */     GIR_EraseRootFromParent_Done,
     /*  73922 */   // Label 1466: @73922
     /*  73922 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(74006), // Rule ID 3735 //
     /*  73927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73967 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74004 */     GIR_RootConstrainSelectedInstOperands,
     /*  74005 */     // GIR_Coverage, 3735,
     /*  74005 */     GIR_EraseRootFromParent_Done,
     /*  74006 */   // Label 1467: @74006
     /*  74006 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(74090), // Rule ID 3739 //
     /*  74011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74051 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  74066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74088 */     GIR_RootConstrainSelectedInstOperands,
     /*  74089 */     // GIR_Coverage, 3739,
     /*  74089 */     GIR_EraseRootFromParent_Done,
     /*  74090 */   // Label 1468: @74090
     /*  74090 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(74174), // Rule ID 3743 //
     /*  74095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  74127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74135 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  74135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  74150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74152 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74172 */     GIR_RootConstrainSelectedInstOperands,
     /*  74173 */     // GIR_Coverage, 3743,
     /*  74173 */     GIR_EraseRootFromParent_Done,
     /*  74174 */   // Label 1469: @74174
     /*  74174 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(74258), // Rule ID 3747 //
     /*  74179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  74211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74219 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  74219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  74234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74236 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74256 */     GIR_RootConstrainSelectedInstOperands,
     /*  74257 */     // GIR_Coverage, 3747,
     /*  74257 */     GIR_EraseRootFromParent_Done,
     /*  74258 */   // Label 1470: @74258
     /*  74258 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(74342), // Rule ID 3751 //
     /*  74263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74303 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  74318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74340 */     GIR_RootConstrainSelectedInstOperands,
     /*  74341 */     // GIR_Coverage, 3751,
     /*  74341 */     GIR_EraseRootFromParent_Done,
     /*  74342 */   // Label 1471: @74342
     /*  74342 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(74426), // Rule ID 3755 //
     /*  74347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74387 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  74402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74404 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74424 */     GIR_RootConstrainSelectedInstOperands,
     /*  74425 */     // GIR_Coverage, 3755,
     /*  74425 */     GIR_EraseRootFromParent_Done,
     /*  74426 */   // Label 1472: @74426
     /*  74426 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(74515), // Rule ID 4387 //
     /*  74431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74474 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  74489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74513 */     GIR_RootConstrainSelectedInstOperands,
     /*  74514 */     // GIR_Coverage, 4387,
     /*  74514 */     GIR_EraseRootFromParent_Done,
     /*  74515 */   // Label 1473: @74515
     /*  74515 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(74604), // Rule ID 4389 //
     /*  74520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74563 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  74578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74602 */     GIR_RootConstrainSelectedInstOperands,
     /*  74603 */     // GIR_Coverage, 4389,
     /*  74603 */     GIR_EraseRootFromParent_Done,
     /*  74604 */   // Label 1474: @74604
     /*  74604 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(74693), // Rule ID 4391 //
     /*  74609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74652 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74691 */     GIR_RootConstrainSelectedInstOperands,
     /*  74692 */     // GIR_Coverage, 4391,
     /*  74692 */     GIR_EraseRootFromParent_Done,
     /*  74693 */   // Label 1475: @74693
     /*  74693 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(74782), // Rule ID 4393 //
     /*  74698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74741 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74780 */     GIR_RootConstrainSelectedInstOperands,
     /*  74781 */     // GIR_Coverage, 4393,
     /*  74781 */     GIR_EraseRootFromParent_Done,
     /*  74782 */   // Label 1476: @74782
     /*  74782 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(74871), // Rule ID 4395 //
     /*  74787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74822 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74830 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74869 */     GIR_RootConstrainSelectedInstOperands,
     /*  74870 */     // GIR_Coverage, 4395,
     /*  74870 */     GIR_EraseRootFromParent_Done,
     /*  74871 */   // Label 1477: @74871
     /*  74871 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(74960), // Rule ID 4397 //
     /*  74876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74919 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74958 */     GIR_RootConstrainSelectedInstOperands,
     /*  74959 */     // GIR_Coverage, 4397,
     /*  74959 */     GIR_EraseRootFromParent_Done,
     /*  74960 */   // Label 1478: @74960
     /*  74960 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(75049), // Rule ID 4399 //
     /*  74965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75008 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  75008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  75023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75047 */     GIR_RootConstrainSelectedInstOperands,
     /*  75048 */     // GIR_Coverage, 4399,
     /*  75048 */     GIR_EraseRootFromParent_Done,
     /*  75049 */   // Label 1479: @75049
     /*  75049 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(75138), // Rule ID 4401 //
     /*  75054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75097 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  75097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  75112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75136 */     GIR_RootConstrainSelectedInstOperands,
     /*  75137 */     // GIR_Coverage, 4401,
     /*  75137 */     GIR_EraseRootFromParent_Done,
     /*  75138 */   // Label 1480: @75138
     /*  75138 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(75227), // Rule ID 4403 //
     /*  75143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75186 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  75201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75225 */     GIR_RootConstrainSelectedInstOperands,
     /*  75226 */     // GIR_Coverage, 4403,
     /*  75226 */     GIR_EraseRootFromParent_Done,
     /*  75227 */   // Label 1481: @75227
     /*  75227 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(75316), // Rule ID 4405 //
     /*  75232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75275 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  75290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75314 */     GIR_RootConstrainSelectedInstOperands,
     /*  75315 */     // GIR_Coverage, 4405,
     /*  75315 */     GIR_EraseRootFromParent_Done,
     /*  75316 */   // Label 1482: @75316
     /*  75316 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(75405), // Rule ID 4407 //
     /*  75321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75364 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  75379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75403 */     GIR_RootConstrainSelectedInstOperands,
     /*  75404 */     // GIR_Coverage, 4407,
     /*  75404 */     GIR_EraseRootFromParent_Done,
     /*  75405 */   // Label 1483: @75405
     /*  75405 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(75494), // Rule ID 4409 //
     /*  75410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75453 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  75468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75492 */     GIR_RootConstrainSelectedInstOperands,
     /*  75493 */     // GIR_Coverage, 4409,
     /*  75493 */     GIR_EraseRootFromParent_Done,
     /*  75494 */   // Label 1484: @75494
     /*  75494 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(75592), // Rule ID 4032 //
     /*  75499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75538 */     // MIs[1] Operand 1
     /*  75538 */     // No operand predicates
     /*  75538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75548 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3594:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  75563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75567 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75590 */     GIR_RootConstrainSelectedInstOperands,
     /*  75591 */     // GIR_Coverage, 4032,
     /*  75591 */     GIR_EraseRootFromParent_Done,
     /*  75592 */   // Label 1485: @75592
     /*  75592 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(75690), // Rule ID 4034 //
     /*  75597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75636 */     // MIs[1] Operand 1
     /*  75636 */     // No operand predicates
     /*  75636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75646 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3594:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75665 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75688 */     GIR_RootConstrainSelectedInstOperands,
     /*  75689 */     // GIR_Coverage, 4034,
     /*  75689 */     GIR_EraseRootFromParent_Done,
     /*  75690 */   // Label 1486: @75690
     /*  75690 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(75788), // Rule ID 4541 //
     /*  75695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75734 */     // MIs[1] Operand 1
     /*  75734 */     // No operand predicates
     /*  75734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75744 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3594:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75763 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75786 */     GIR_RootConstrainSelectedInstOperands,
     /*  75787 */     // GIR_Coverage, 4541,
     /*  75787 */     GIR_EraseRootFromParent_Done,
     /*  75788 */   // Label 1487: @75788
     /*  75788 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(75886), // Rule ID 4543 //
     /*  75793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75832 */     // MIs[1] Operand 1
     /*  75832 */     // No operand predicates
     /*  75832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75842 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3594:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75861 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75884 */     GIR_RootConstrainSelectedInstOperands,
     /*  75885 */     // GIR_Coverage, 4543,
     /*  75885 */     GIR_EraseRootFromParent_Done,
     /*  75886 */   // Label 1488: @75886
     /*  75886 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(75984), // Rule ID 4545 //
     /*  75891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75930 */     // MIs[1] Operand 1
     /*  75930 */     // No operand predicates
     /*  75930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75940 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3594:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75959 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75982 */     GIR_RootConstrainSelectedInstOperands,
     /*  75983 */     // GIR_Coverage, 4545,
     /*  75983 */     GIR_EraseRootFromParent_Done,
     /*  75984 */   // Label 1489: @75984
     /*  75984 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(76082), // Rule ID 4547 //
     /*  75989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  76024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76028 */     // MIs[1] Operand 1
     /*  76028 */     // No operand predicates
     /*  76028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76038 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3594:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  76053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76057 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76080 */     GIR_RootConstrainSelectedInstOperands,
     /*  76081 */     // GIR_Coverage, 4547,
     /*  76081 */     GIR_EraseRootFromParent_Done,
     /*  76082 */   // Label 1490: @76082
     /*  76082 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(76180), // Rule ID 4549 //
     /*  76087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  76095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  76122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76126 */     // MIs[1] Operand 1
     /*  76126 */     // No operand predicates
     /*  76126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76136 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3594:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  76151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76155 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76178 */     GIR_RootConstrainSelectedInstOperands,
     /*  76179 */     // GIR_Coverage, 4549,
     /*  76179 */     GIR_EraseRootFromParent_Done,
     /*  76180 */   // Label 1491: @76180
     /*  76180 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(76278), // Rule ID 4551 //
     /*  76185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  76193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  76220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76224 */     // MIs[1] Operand 1
     /*  76224 */     // No operand predicates
     /*  76224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76234 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3594:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  76249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76253 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76276 */     GIR_RootConstrainSelectedInstOperands,
     /*  76277 */     // GIR_Coverage, 4551,
     /*  76277 */     GIR_EraseRootFromParent_Done,
     /*  76278 */   // Label 1492: @76278
     /*  76278 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(76354), // Rule ID 3037 //
     /*  76283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76326 */     // (intrinsic_wo_chain:{ *:[i32] } 3587:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  76329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76335 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76340 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76352 */     GIR_RootConstrainSelectedInstOperands,
     /*  76353 */     // GIR_Coverage, 3037,
     /*  76353 */     GIR_EraseRootFromParent_Done,
     /*  76354 */   // Label 1493: @76354
     /*  76354 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(76430), // Rule ID 3039 //
     /*  76359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76402 */     // (intrinsic_wo_chain:{ *:[i32] } 3587:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  76405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76411 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76428 */     GIR_RootConstrainSelectedInstOperands,
     /*  76429 */     // GIR_Coverage, 3039,
     /*  76429 */     GIR_EraseRootFromParent_Done,
     /*  76430 */   // Label 1494: @76430
     /*  76430 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(76506), // Rule ID 3041 //
     /*  76435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76478 */     // (intrinsic_wo_chain:{ *:[i32] } 3587:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  76481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76487 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76504 */     GIR_RootConstrainSelectedInstOperands,
     /*  76505 */     // GIR_Coverage, 3041,
     /*  76505 */     GIR_EraseRootFromParent_Done,
     /*  76506 */   // Label 1495: @76506
     /*  76506 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(76582), // Rule ID 3043 //
     /*  76511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76554 */     // (intrinsic_wo_chain:{ *:[i32] } 3587:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  76557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76563 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76580 */     GIR_RootConstrainSelectedInstOperands,
     /*  76581 */     // GIR_Coverage, 3043,
     /*  76581 */     GIR_EraseRootFromParent_Done,
     /*  76582 */   // Label 1496: @76582
     /*  76582 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(76658), // Rule ID 3045 //
     /*  76587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76630 */     // (intrinsic_wo_chain:{ *:[i32] } 3587:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  76633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76639 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76656 */     GIR_RootConstrainSelectedInstOperands,
     /*  76657 */     // GIR_Coverage, 3045,
     /*  76657 */     GIR_EraseRootFromParent_Done,
     /*  76658 */   // Label 1497: @76658
     /*  76658 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(76734), // Rule ID 3047 //
     /*  76663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76706 */     // (intrinsic_wo_chain:{ *:[i32] } 3587:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76715 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76732 */     GIR_RootConstrainSelectedInstOperands,
     /*  76733 */     // GIR_Coverage, 3047,
     /*  76733 */     GIR_EraseRootFromParent_Done,
     /*  76734 */   // Label 1498: @76734
     /*  76734 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(76819), // Rule ID 3996 //
     /*  76739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76774 */     // MIs[1] Operand 1
     /*  76774 */     // No operand predicates
     /*  76774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76788 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3597:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76797 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76817 */     GIR_RootConstrainSelectedInstOperands,
     /*  76818 */     // GIR_Coverage, 3996,
     /*  76818 */     GIR_EraseRootFromParent_Done,
     /*  76819 */   // Label 1499: @76819
     /*  76819 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(76904), // Rule ID 3999 //
     /*  76824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76859 */     // MIs[1] Operand 1
     /*  76859 */     // No operand predicates
     /*  76859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76873 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3597:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76882 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76902 */     GIR_RootConstrainSelectedInstOperands,
     /*  76903 */     // GIR_Coverage, 3999,
     /*  76903 */     GIR_EraseRootFromParent_Done,
     /*  76904 */   // Label 1500: @76904
     /*  76904 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(77000), // Rule ID 2688 //
     /*  76909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76936 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3852:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76952 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76959 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76982 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76987 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76998 */     GIR_RootConstrainSelectedInstOperands,
     /*  76999 */     // GIR_Coverage, 2688,
     /*  76999 */     GIR_EraseRootFromParent_Done,
     /*  77000 */   // Label 1501: @77000
     /*  77000 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(77131), // Rule ID 2689 //
     /*  77005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  77013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  77016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  77019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  77022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  77025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  77028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  77032 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3849:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  77032 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  77035 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77039 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  77049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  77053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  77062 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  77065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  77069 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  77072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  77076 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  77079 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77082 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  77085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  77090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  77095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  77100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  77105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  77110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  77113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77118 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  77120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  77123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77129 */     GIR_RootConstrainSelectedInstOperands,
     /*  77130 */     // GIR_Coverage, 2689,
     /*  77130 */     GIR_EraseRootFromParent_Done,
     /*  77131 */   // Label 1502: @77131
     /*  77131 */   GIM_Reject,
     /*  77132 */ // Label 1464: @77132
     /*  77132 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(82438),
     /*  77137 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  77140 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(77233), // Rule ID 3838 //
     /*  77145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77192 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  77207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77209 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77211 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77231 */     GIR_RootConstrainSelectedInstOperands,
     /*  77232 */     // GIR_Coverage, 3838,
     /*  77232 */     GIR_EraseRootFromParent_Done,
     /*  77233 */   // Label 1504: @77233
     /*  77233 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(77326), // Rule ID 3840 //
     /*  77238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77285 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  77300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77302 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77304 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77324 */     GIR_RootConstrainSelectedInstOperands,
     /*  77325 */     // GIR_Coverage, 3840,
     /*  77325 */     GIR_EraseRootFromParent_Done,
     /*  77326 */   // Label 1505: @77326
     /*  77326 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(77419), // Rule ID 3842 //
     /*  77331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77378 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  77393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77395 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77397 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77417 */     GIR_RootConstrainSelectedInstOperands,
     /*  77418 */     // GIR_Coverage, 3842,
     /*  77418 */     GIR_EraseRootFromParent_Done,
     /*  77419 */   // Label 1506: @77419
     /*  77419 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(77512), // Rule ID 3844 //
     /*  77424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77471 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  77486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77488 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77490 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77510 */     GIR_RootConstrainSelectedInstOperands,
     /*  77511 */     // GIR_Coverage, 3844,
     /*  77511 */     GIR_EraseRootFromParent_Done,
     /*  77512 */   // Label 1507: @77512
     /*  77512 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(77605), // Rule ID 3846 //
     /*  77517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77564 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  77579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77581 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77583 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77603 */     GIR_RootConstrainSelectedInstOperands,
     /*  77604 */     // GIR_Coverage, 3846,
     /*  77604 */     GIR_EraseRootFromParent_Done,
     /*  77605 */   // Label 1508: @77605
     /*  77605 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(77698), // Rule ID 3848 //
     /*  77610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77657 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77674 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77676 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77696 */     GIR_RootConstrainSelectedInstOperands,
     /*  77697 */     // GIR_Coverage, 3848,
     /*  77697 */     GIR_EraseRootFromParent_Done,
     /*  77698 */   // Label 1509: @77698
     /*  77698 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(77791), // Rule ID 3850 //
     /*  77703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77750 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77767 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77769 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77789 */     GIR_RootConstrainSelectedInstOperands,
     /*  77790 */     // GIR_Coverage, 3850,
     /*  77790 */     GIR_EraseRootFromParent_Done,
     /*  77791 */   // Label 1510: @77791
     /*  77791 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(77884), // Rule ID 3852 //
     /*  77796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77843 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77860 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77862 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77882 */     GIR_RootConstrainSelectedInstOperands,
     /*  77883 */     // GIR_Coverage, 3852,
     /*  77883 */     GIR_EraseRootFromParent_Done,
     /*  77884 */   // Label 1511: @77884
     /*  77884 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(77977), // Rule ID 3854 //
     /*  77889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77936 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77953 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77955 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77975 */     GIR_RootConstrainSelectedInstOperands,
     /*  77976 */     // GIR_Coverage, 3854,
     /*  77976 */     GIR_EraseRootFromParent_Done,
     /*  77977 */   // Label 1512: @77977
     /*  77977 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(78070), // Rule ID 3856 //
     /*  77982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78029 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  78044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78046 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78048 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78068 */     GIR_RootConstrainSelectedInstOperands,
     /*  78069 */     // GIR_Coverage, 3856,
     /*  78069 */     GIR_EraseRootFromParent_Done,
     /*  78070 */   // Label 1513: @78070
     /*  78070 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(78163), // Rule ID 3858 //
     /*  78075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78122 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  78137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78139 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78141 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78161 */     GIR_RootConstrainSelectedInstOperands,
     /*  78162 */     // GIR_Coverage, 3858,
     /*  78162 */     GIR_EraseRootFromParent_Done,
     /*  78163 */   // Label 1514: @78163
     /*  78163 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(78256), // Rule ID 3860 //
     /*  78168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78215 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  78230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78232 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78234 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78254 */     GIR_RootConstrainSelectedInstOperands,
     /*  78255 */     // GIR_Coverage, 3860,
     /*  78255 */     GIR_EraseRootFromParent_Done,
     /*  78256 */   // Label 1515: @78256
     /*  78256 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(78349), // Rule ID 3862 //
     /*  78261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78308 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  78323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78325 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78327 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78347 */     GIR_RootConstrainSelectedInstOperands,
     /*  78348 */     // GIR_Coverage, 3862,
     /*  78348 */     GIR_EraseRootFromParent_Done,
     /*  78349 */   // Label 1516: @78349
     /*  78349 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(78442), // Rule ID 3864 //
     /*  78354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78401 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  78416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78418 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78420 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78440 */     GIR_RootConstrainSelectedInstOperands,
     /*  78441 */     // GIR_Coverage, 3864,
     /*  78441 */     GIR_EraseRootFromParent_Done,
     /*  78442 */   // Label 1517: @78442
     /*  78442 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(78535), // Rule ID 3866 //
     /*  78447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78494 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  78509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78511 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78513 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78533 */     GIR_RootConstrainSelectedInstOperands,
     /*  78534 */     // GIR_Coverage, 3866,
     /*  78534 */     GIR_EraseRootFromParent_Done,
     /*  78535 */   // Label 1518: @78535
     /*  78535 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(78628), // Rule ID 3868 //
     /*  78540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78587 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  78602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78604 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78606 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78626 */     GIR_RootConstrainSelectedInstOperands,
     /*  78627 */     // GIR_Coverage, 3868,
     /*  78627 */     GIR_EraseRootFromParent_Done,
     /*  78628 */   // Label 1519: @78628
     /*  78628 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(78721), // Rule ID 3870 //
     /*  78633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78680 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78697 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78699 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78719 */     GIR_RootConstrainSelectedInstOperands,
     /*  78720 */     // GIR_Coverage, 3870,
     /*  78720 */     GIR_EraseRootFromParent_Done,
     /*  78721 */   // Label 1520: @78721
     /*  78721 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(78814), // Rule ID 3872 //
     /*  78726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78773 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78790 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78792 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78812 */     GIR_RootConstrainSelectedInstOperands,
     /*  78813 */     // GIR_Coverage, 3872,
     /*  78813 */     GIR_EraseRootFromParent_Done,
     /*  78814 */   // Label 1521: @78814
     /*  78814 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(78907), // Rule ID 3874 //
     /*  78819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78866 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78883 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78885 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78905 */     GIR_RootConstrainSelectedInstOperands,
     /*  78906 */     // GIR_Coverage, 3874,
     /*  78906 */     GIR_EraseRootFromParent_Done,
     /*  78907 */   // Label 1522: @78907
     /*  78907 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(79000), // Rule ID 3876 //
     /*  78912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78959 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78976 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78978 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78998 */     GIR_RootConstrainSelectedInstOperands,
     /*  78999 */     // GIR_Coverage, 3876,
     /*  78999 */     GIR_EraseRootFromParent_Done,
     /*  79000 */   // Label 1523: @79000
     /*  79000 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(79093), // Rule ID 3878 //
     /*  79005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  79013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79052 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  79052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  79067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79069 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79071 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79091 */     GIR_RootConstrainSelectedInstOperands,
     /*  79092 */     // GIR_Coverage, 3878,
     /*  79092 */     GIR_EraseRootFromParent_Done,
     /*  79093 */   // Label 1524: @79093
     /*  79093 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(79186), // Rule ID 3880 //
     /*  79098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79145 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  79145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  79160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79162 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79164 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79184 */     GIR_RootConstrainSelectedInstOperands,
     /*  79185 */     // GIR_Coverage, 3880,
     /*  79185 */     GIR_EraseRootFromParent_Done,
     /*  79186 */   // Label 1525: @79186
     /*  79186 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(79279), // Rule ID 3882 //
     /*  79191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79238 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  79238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  79253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79255 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79257 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79277 */     GIR_RootConstrainSelectedInstOperands,
     /*  79278 */     // GIR_Coverage, 3882,
     /*  79278 */     GIR_EraseRootFromParent_Done,
     /*  79279 */   // Label 1526: @79279
     /*  79279 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(79372), // Rule ID 3884 //
     /*  79284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  79292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79331 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  79331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  79346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79348 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79350 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79370 */     GIR_RootConstrainSelectedInstOperands,
     /*  79371 */     // GIR_Coverage, 3884,
     /*  79371 */     GIR_EraseRootFromParent_Done,
     /*  79372 */   // Label 1527: @79372
     /*  79372 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(79450), // Rule ID 4489 //
     /*  79377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79424 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  79427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79448 */     GIR_RootConstrainSelectedInstOperands,
     /*  79449 */     // GIR_Coverage, 4489,
     /*  79449 */     GIR_EraseRootFromParent_Done,
     /*  79450 */   // Label 1528: @79450
     /*  79450 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(79528), // Rule ID 4491 //
     /*  79455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79502 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  79505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79526 */     GIR_RootConstrainSelectedInstOperands,
     /*  79527 */     // GIR_Coverage, 4491,
     /*  79527 */     GIR_EraseRootFromParent_Done,
     /*  79528 */   // Label 1529: @79528
     /*  79528 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(79606), // Rule ID 4493 //
     /*  79533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79580 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  79583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79604 */     GIR_RootConstrainSelectedInstOperands,
     /*  79605 */     // GIR_Coverage, 4493,
     /*  79605 */     GIR_EraseRootFromParent_Done,
     /*  79606 */   // Label 1530: @79606
     /*  79606 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(79684), // Rule ID 4495 //
     /*  79611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79658 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79682 */     GIR_RootConstrainSelectedInstOperands,
     /*  79683 */     // GIR_Coverage, 4495,
     /*  79683 */     GIR_EraseRootFromParent_Done,
     /*  79684 */   // Label 1531: @79684
     /*  79684 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(79762), // Rule ID 4497 //
     /*  79689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79736 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79760 */     GIR_RootConstrainSelectedInstOperands,
     /*  79761 */     // GIR_Coverage, 4497,
     /*  79761 */     GIR_EraseRootFromParent_Done,
     /*  79762 */   // Label 1532: @79762
     /*  79762 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(79840), // Rule ID 4499 //
     /*  79767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79814 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79838 */     GIR_RootConstrainSelectedInstOperands,
     /*  79839 */     // GIR_Coverage, 4499,
     /*  79839 */     GIR_EraseRootFromParent_Done,
     /*  79840 */   // Label 1533: @79840
     /*  79840 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(79918), // Rule ID 4501 //
     /*  79845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79892 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79916 */     GIR_RootConstrainSelectedInstOperands,
     /*  79917 */     // GIR_Coverage, 4501,
     /*  79917 */     GIR_EraseRootFromParent_Done,
     /*  79918 */   // Label 1534: @79918
     /*  79918 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(79996), // Rule ID 4503 //
     /*  79923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79970 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79994 */     GIR_RootConstrainSelectedInstOperands,
     /*  79995 */     // GIR_Coverage, 4503,
     /*  79995 */     GIR_EraseRootFromParent_Done,
     /*  79996 */   // Label 1535: @79996
     /*  79996 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(80074), // Rule ID 4505 //
     /*  80001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80048 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  80048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  80051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80072 */     GIR_RootConstrainSelectedInstOperands,
     /*  80073 */     // GIR_Coverage, 4505,
     /*  80073 */     GIR_EraseRootFromParent_Done,
     /*  80074 */   // Label 1536: @80074
     /*  80074 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(80152), // Rule ID 4507 //
     /*  80079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80126 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  80126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  80129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80150 */     GIR_RootConstrainSelectedInstOperands,
     /*  80151 */     // GIR_Coverage, 4507,
     /*  80151 */     GIR_EraseRootFromParent_Done,
     /*  80152 */   // Label 1537: @80152
     /*  80152 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(80230), // Rule ID 4509 //
     /*  80157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80204 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  80207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80228 */     GIR_RootConstrainSelectedInstOperands,
     /*  80229 */     // GIR_Coverage, 4509,
     /*  80229 */     GIR_EraseRootFromParent_Done,
     /*  80230 */   // Label 1538: @80230
     /*  80230 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(80308), // Rule ID 4511 //
     /*  80235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80282 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  80285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80306 */     GIR_RootConstrainSelectedInstOperands,
     /*  80307 */     // GIR_Coverage, 4511,
     /*  80307 */     GIR_EraseRootFromParent_Done,
     /*  80308 */   // Label 1539: @80308
     /*  80308 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(80386), // Rule ID 4701 //
     /*  80313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80360 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3689:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  80363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80365 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80367 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80384 */     GIR_RootConstrainSelectedInstOperands,
     /*  80385 */     // GIR_Coverage, 4701,
     /*  80385 */     GIR_EraseRootFromParent_Done,
     /*  80386 */   // Label 1540: @80386
     /*  80386 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(80464), // Rule ID 4703 //
     /*  80391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80438 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3689:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  80441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80443 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80445 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80462 */     GIR_RootConstrainSelectedInstOperands,
     /*  80463 */     // GIR_Coverage, 4703,
     /*  80463 */     GIR_EraseRootFromParent_Done,
     /*  80464 */   // Label 1541: @80464
     /*  80464 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(80542), // Rule ID 4705 //
     /*  80469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80516 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3689:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  80519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80521 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80523 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80540 */     GIR_RootConstrainSelectedInstOperands,
     /*  80541 */     // GIR_Coverage, 4705,
     /*  80541 */     GIR_EraseRootFromParent_Done,
     /*  80542 */   // Label 1542: @80542
     /*  80542 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(80620), // Rule ID 4707 //
     /*  80547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80594 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3689:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  80597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80599 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80601 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80618 */     GIR_RootConstrainSelectedInstOperands,
     /*  80619 */     // GIR_Coverage, 4707,
     /*  80619 */     GIR_EraseRootFromParent_Done,
     /*  80620 */   // Label 1543: @80620
     /*  80620 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(80698), // Rule ID 4709 //
     /*  80625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80672 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3689:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80677 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80679 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80696 */     GIR_RootConstrainSelectedInstOperands,
     /*  80697 */     // GIR_Coverage, 4709,
     /*  80697 */     GIR_EraseRootFromParent_Done,
     /*  80698 */   // Label 1544: @80698
     /*  80698 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(80776), // Rule ID 4711 //
     /*  80703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80750 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3689:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80755 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80757 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80774 */     GIR_RootConstrainSelectedInstOperands,
     /*  80775 */     // GIR_Coverage, 4711,
     /*  80775 */     GIR_EraseRootFromParent_Done,
     /*  80776 */   // Label 1545: @80776
     /*  80776 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(80854), // Rule ID 4713 //
     /*  80781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80828 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3689:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80833 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80835 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80852 */     GIR_RootConstrainSelectedInstOperands,
     /*  80853 */     // GIR_Coverage, 4713,
     /*  80853 */     GIR_EraseRootFromParent_Done,
     /*  80854 */   // Label 1546: @80854
     /*  80854 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(80932), // Rule ID 4715 //
     /*  80859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80906 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3689:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80911 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80913 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80930 */     GIR_RootConstrainSelectedInstOperands,
     /*  80931 */     // GIR_Coverage, 4715,
     /*  80931 */     GIR_EraseRootFromParent_Done,
     /*  80932 */   // Label 1547: @80932
     /*  80932 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(81010), // Rule ID 4717 //
     /*  80937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3689:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80989 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80991 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81008 */     GIR_RootConstrainSelectedInstOperands,
     /*  81009 */     // GIR_Coverage, 4717,
     /*  81009 */     GIR_EraseRootFromParent_Done,
     /*  81010 */   // Label 1548: @81010
     /*  81010 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(81088), // Rule ID 4719 //
     /*  81015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81062 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3689:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  81065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81067 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81069 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81086 */     GIR_RootConstrainSelectedInstOperands,
     /*  81087 */     // GIR_Coverage, 4719,
     /*  81087 */     GIR_EraseRootFromParent_Done,
     /*  81088 */   // Label 1549: @81088
     /*  81088 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(81166), // Rule ID 4721 //
     /*  81093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81140 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3689:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  81143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81145 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81147 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81164 */     GIR_RootConstrainSelectedInstOperands,
     /*  81165 */     // GIR_Coverage, 4721,
     /*  81165 */     GIR_EraseRootFromParent_Done,
     /*  81166 */   // Label 1550: @81166
     /*  81166 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(81244), // Rule ID 4723 //
     /*  81171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81218 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3689:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  81221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81223 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81225 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81242 */     GIR_RootConstrainSelectedInstOperands,
     /*  81243 */     // GIR_Coverage, 4723,
     /*  81243 */     GIR_EraseRootFromParent_Done,
     /*  81244 */   // Label 1551: @81244
     /*  81244 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(81322), // Rule ID 4725 //
     /*  81249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81296 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3689:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  81299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81301 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81303 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81320 */     GIR_RootConstrainSelectedInstOperands,
     /*  81321 */     // GIR_Coverage, 4725,
     /*  81321 */     GIR_EraseRootFromParent_Done,
     /*  81322 */   // Label 1552: @81322
     /*  81322 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(81400), // Rule ID 4727 //
     /*  81327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81374 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3689:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  81377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81379 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81381 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81398 */     GIR_RootConstrainSelectedInstOperands,
     /*  81399 */     // GIR_Coverage, 4727,
     /*  81399 */     GIR_EraseRootFromParent_Done,
     /*  81400 */   // Label 1553: @81400
     /*  81400 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(81478), // Rule ID 4729 //
     /*  81405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81452 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3689:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  81455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81457 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81459 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81476 */     GIR_RootConstrainSelectedInstOperands,
     /*  81477 */     // GIR_Coverage, 4729,
     /*  81477 */     GIR_EraseRootFromParent_Done,
     /*  81478 */   // Label 1554: @81478
     /*  81478 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(81556), // Rule ID 4731 //
     /*  81483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81530 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3689:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  81533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81535 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81537 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81554 */     GIR_RootConstrainSelectedInstOperands,
     /*  81555 */     // GIR_Coverage, 4731,
     /*  81555 */     GIR_EraseRootFromParent_Done,
     /*  81556 */   // Label 1555: @81556
     /*  81556 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(81634), // Rule ID 4733 //
     /*  81561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81608 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3689:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  81611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81613 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81615 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81632 */     GIR_RootConstrainSelectedInstOperands,
     /*  81633 */     // GIR_Coverage, 4733,
     /*  81633 */     GIR_EraseRootFromParent_Done,
     /*  81634 */   // Label 1556: @81634
     /*  81634 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(81712), // Rule ID 4735 //
     /*  81639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81686 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3689:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81691 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81693 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81710 */     GIR_RootConstrainSelectedInstOperands,
     /*  81711 */     // GIR_Coverage, 4735,
     /*  81711 */     GIR_EraseRootFromParent_Done,
     /*  81712 */   // Label 1557: @81712
     /*  81712 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(81790), // Rule ID 4737 //
     /*  81717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81764 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3689:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81769 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81771 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81788 */     GIR_RootConstrainSelectedInstOperands,
     /*  81789 */     // GIR_Coverage, 4737,
     /*  81789 */     GIR_EraseRootFromParent_Done,
     /*  81790 */   // Label 1558: @81790
     /*  81790 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(81868), // Rule ID 4739 //
     /*  81795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81842 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3689:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81847 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81849 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81866 */     GIR_RootConstrainSelectedInstOperands,
     /*  81867 */     // GIR_Coverage, 4739,
     /*  81867 */     GIR_EraseRootFromParent_Done,
     /*  81868 */   // Label 1559: @81868
     /*  81868 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(81946), // Rule ID 4741 //
     /*  81873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81920 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3689:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81925 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81927 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81944 */     GIR_RootConstrainSelectedInstOperands,
     /*  81945 */     // GIR_Coverage, 4741,
     /*  81945 */     GIR_EraseRootFromParent_Done,
     /*  81946 */   // Label 1560: @81946
     /*  81946 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(82024), // Rule ID 4743 //
     /*  81951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81998 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3689:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  82001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  82003 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  82005 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  82007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82022 */     GIR_RootConstrainSelectedInstOperands,
     /*  82023 */     // GIR_Coverage, 4743,
     /*  82023 */     GIR_EraseRootFromParent_Done,
     /*  82024 */   // Label 1561: @82024
     /*  82024 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(82102), // Rule ID 4745 //
     /*  82029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  82034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  82037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  82064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  82072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  82076 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3689:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  82076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  82079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  82081 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  82083 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  82085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82100 */     GIR_RootConstrainSelectedInstOperands,
     /*  82101 */     // GIR_Coverage, 4745,
     /*  82101 */     GIR_EraseRootFromParent_Done,
     /*  82102 */   // Label 1562: @82102
     /*  82102 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(82180), // Rule ID 4747 //
     /*  82107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  82112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  82115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  82142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  82150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  82154 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3689:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  82154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  82157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  82159 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  82161 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  82163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82178 */     GIR_RootConstrainSelectedInstOperands,
     /*  82179 */     // GIR_Coverage, 4747,
     /*  82179 */     GIR_EraseRootFromParent_Done,
     /*  82180 */   // Label 1563: @82180
     /*  82180 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(82316), // Rule ID 2690 //
     /*  82185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  82193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82215 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3853:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  82218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  82245 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  82252 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82255 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  82259 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82262 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82265 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  82296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82298 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  82300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82303 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82314 */     GIR_RootConstrainSelectedInstOperands,
     /*  82315 */     // GIR_Coverage, 2690,
     /*  82315 */     GIR_EraseRootFromParent_Done,
     /*  82316 */   // Label 1564: @82316
     /*  82316 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(82437), // Rule ID 2691 //
     /*  82321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  82329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82351 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3850:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  82367 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  82374 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  82381 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  82388 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  82419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82424 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82435 */     GIR_RootConstrainSelectedInstOperands,
     /*  82436 */     // GIR_Coverage, 2691,
     /*  82436 */     GIR_EraseRootFromParent_Done,
     /*  82437 */   // Label 1565: @82437
     /*  82437 */   GIM_Reject,
     /*  82438 */ // Label 1503: @82438
     /*  82438 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(87331),
     /*  82443 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  82446 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(82534), // Rule ID 3181 //
     /*  82451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82500 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82504 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82508 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  82511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82513 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82515 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82532 */     GIR_RootConstrainSelectedInstOperands,
     /*  82533 */     // GIR_Coverage, 3181,
     /*  82533 */     GIR_EraseRootFromParent_Done,
     /*  82534 */   // Label 1567: @82534
     /*  82534 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(82622), // Rule ID 3185 //
     /*  82539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82588 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82592 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82596 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  82599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82601 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82603 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82620 */     GIR_RootConstrainSelectedInstOperands,
     /*  82621 */     // GIR_Coverage, 3185,
     /*  82621 */     GIR_EraseRootFromParent_Done,
     /*  82622 */   // Label 1568: @82622
     /*  82622 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(82710), // Rule ID 3189 //
     /*  82627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82676 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82680 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82684 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82689 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82691 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82708 */     GIR_RootConstrainSelectedInstOperands,
     /*  82709 */     // GIR_Coverage, 3189,
     /*  82709 */     GIR_EraseRootFromParent_Done,
     /*  82710 */   // Label 1569: @82710
     /*  82710 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(82798), // Rule ID 3193 //
     /*  82715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82764 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82768 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82772 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82777 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82779 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82796 */     GIR_RootConstrainSelectedInstOperands,
     /*  82797 */     // GIR_Coverage, 3193,
     /*  82797 */     GIR_EraseRootFromParent_Done,
     /*  82798 */   // Label 1570: @82798
     /*  82798 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(82886), // Rule ID 3197 //
     /*  82803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82852 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82856 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82860 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82865 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82867 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82884 */     GIR_RootConstrainSelectedInstOperands,
     /*  82885 */     // GIR_Coverage, 3197,
     /*  82885 */     GIR_EraseRootFromParent_Done,
     /*  82886 */   // Label 1571: @82886
     /*  82886 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(82974), // Rule ID 3201 //
     /*  82891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82940 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82944 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82948 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82953 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82955 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82972 */     GIR_RootConstrainSelectedInstOperands,
     /*  82973 */     // GIR_Coverage, 3201,
     /*  82973 */     GIR_EraseRootFromParent_Done,
     /*  82974 */   // Label 1572: @82974
     /*  82974 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(83062), // Rule ID 3205 //
     /*  82979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83028 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83032 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83036 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  83039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83041 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83043 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83060 */     GIR_RootConstrainSelectedInstOperands,
     /*  83061 */     // GIR_Coverage, 3205,
     /*  83061 */     GIR_EraseRootFromParent_Done,
     /*  83062 */   // Label 1573: @83062
     /*  83062 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(83150), // Rule ID 3209 //
     /*  83067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83116 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83120 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83124 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  83127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83129 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83131 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83148 */     GIR_RootConstrainSelectedInstOperands,
     /*  83149 */     // GIR_Coverage, 3209,
     /*  83149 */     GIR_EraseRootFromParent_Done,
     /*  83150 */   // Label 1574: @83150
     /*  83150 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(83238), // Rule ID 3213 //
     /*  83155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83204 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83208 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83212 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  83215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83217 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83219 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83236 */     GIR_RootConstrainSelectedInstOperands,
     /*  83237 */     // GIR_Coverage, 3213,
     /*  83237 */     GIR_EraseRootFromParent_Done,
     /*  83238 */   // Label 1575: @83238
     /*  83238 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(83326), // Rule ID 3217 //
     /*  83243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83292 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83296 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83300 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  83303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83305 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83307 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83324 */     GIR_RootConstrainSelectedInstOperands,
     /*  83325 */     // GIR_Coverage, 3217,
     /*  83325 */     GIR_EraseRootFromParent_Done,
     /*  83326 */   // Label 1576: @83326
     /*  83326 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(83414), // Rule ID 3221 //
     /*  83331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83380 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83384 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83388 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  83391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83393 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83395 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83412 */     GIR_RootConstrainSelectedInstOperands,
     /*  83413 */     // GIR_Coverage, 3221,
     /*  83413 */     GIR_EraseRootFromParent_Done,
     /*  83414 */   // Label 1577: @83414
     /*  83414 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(83502), // Rule ID 3225 //
     /*  83419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83468 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83472 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83476 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  83479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83481 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83483 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83500 */     GIR_RootConstrainSelectedInstOperands,
     /*  83501 */     // GIR_Coverage, 3225,
     /*  83501 */     GIR_EraseRootFromParent_Done,
     /*  83502 */   // Label 1578: @83502
     /*  83502 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(83590), // Rule ID 3229 //
     /*  83507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83556 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83560 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83564 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  83567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83569 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83571 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83588 */     GIR_RootConstrainSelectedInstOperands,
     /*  83589 */     // GIR_Coverage, 3229,
     /*  83589 */     GIR_EraseRootFromParent_Done,
     /*  83590 */   // Label 1579: @83590
     /*  83590 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(83678), // Rule ID 3233 //
     /*  83595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83644 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83648 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83652 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83657 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83659 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83676 */     GIR_RootConstrainSelectedInstOperands,
     /*  83677 */     // GIR_Coverage, 3233,
     /*  83677 */     GIR_EraseRootFromParent_Done,
     /*  83678 */   // Label 1580: @83678
     /*  83678 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(83766), // Rule ID 3237 //
     /*  83683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83732 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83736 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83740 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83745 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83747 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83764 */     GIR_RootConstrainSelectedInstOperands,
     /*  83765 */     // GIR_Coverage, 3237,
     /*  83765 */     GIR_EraseRootFromParent_Done,
     /*  83766 */   // Label 1581: @83766
     /*  83766 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(83856), // Rule ID 3183 //
     /*  83771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83820 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83824 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83828 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83833 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83835 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83837 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83854 */     GIR_RootConstrainSelectedInstOperands,
     /*  83855 */     // GIR_Coverage, 3183,
     /*  83855 */     GIR_EraseRootFromParent_Done,
     /*  83856 */   // Label 1582: @83856
     /*  83856 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(83946), // Rule ID 3187 //
     /*  83861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83910 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83914 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83918 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83923 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83925 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83927 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83944 */     GIR_RootConstrainSelectedInstOperands,
     /*  83945 */     // GIR_Coverage, 3187,
     /*  83945 */     GIR_EraseRootFromParent_Done,
     /*  83946 */   // Label 1583: @83946
     /*  83946 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(84036), // Rule ID 3191 //
     /*  83951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84000 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84004 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84008 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  84011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84013 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84015 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84017 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84034 */     GIR_RootConstrainSelectedInstOperands,
     /*  84035 */     // GIR_Coverage, 3191,
     /*  84035 */     GIR_EraseRootFromParent_Done,
     /*  84036 */   // Label 1584: @84036
     /*  84036 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(84126), // Rule ID 3195 //
     /*  84041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84090 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84094 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84098 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  84101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84103 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84105 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84107 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84124 */     GIR_RootConstrainSelectedInstOperands,
     /*  84125 */     // GIR_Coverage, 3195,
     /*  84125 */     GIR_EraseRootFromParent_Done,
     /*  84126 */   // Label 1585: @84126
     /*  84126 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(84216), // Rule ID 3199 //
     /*  84131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84180 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84184 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84188 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  84191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84193 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84195 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84197 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84214 */     GIR_RootConstrainSelectedInstOperands,
     /*  84215 */     // GIR_Coverage, 3199,
     /*  84215 */     GIR_EraseRootFromParent_Done,
     /*  84216 */   // Label 1586: @84216
     /*  84216 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(84306), // Rule ID 3203 //
     /*  84221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84270 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84274 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84278 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  84281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84283 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84285 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84287 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84304 */     GIR_RootConstrainSelectedInstOperands,
     /*  84305 */     // GIR_Coverage, 3203,
     /*  84305 */     GIR_EraseRootFromParent_Done,
     /*  84306 */   // Label 1587: @84306
     /*  84306 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(84396), // Rule ID 3207 //
     /*  84311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84360 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84364 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84368 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  84371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84373 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84375 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84377 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84394 */     GIR_RootConstrainSelectedInstOperands,
     /*  84395 */     // GIR_Coverage, 3207,
     /*  84395 */     GIR_EraseRootFromParent_Done,
     /*  84396 */   // Label 1588: @84396
     /*  84396 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(84486), // Rule ID 3211 //
     /*  84401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84450 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84454 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84458 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  84461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84463 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84465 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84467 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84484 */     GIR_RootConstrainSelectedInstOperands,
     /*  84485 */     // GIR_Coverage, 3211,
     /*  84485 */     GIR_EraseRootFromParent_Done,
     /*  84486 */   // Label 1589: @84486
     /*  84486 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(84576), // Rule ID 3215 //
     /*  84491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84540 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84544 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84548 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  84551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84553 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84555 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84557 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84574 */     GIR_RootConstrainSelectedInstOperands,
     /*  84575 */     // GIR_Coverage, 3215,
     /*  84575 */     GIR_EraseRootFromParent_Done,
     /*  84576 */   // Label 1590: @84576
     /*  84576 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(84666), // Rule ID 3219 //
     /*  84581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84630 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84634 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84638 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84643 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84645 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84647 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84664 */     GIR_RootConstrainSelectedInstOperands,
     /*  84665 */     // GIR_Coverage, 3219,
     /*  84665 */     GIR_EraseRootFromParent_Done,
     /*  84666 */   // Label 1591: @84666
     /*  84666 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(84756), // Rule ID 3223 //
     /*  84671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84720 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84724 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84728 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84733 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84735 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84737 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84754 */     GIR_RootConstrainSelectedInstOperands,
     /*  84755 */     // GIR_Coverage, 3223,
     /*  84755 */     GIR_EraseRootFromParent_Done,
     /*  84756 */   // Label 1592: @84756
     /*  84756 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(84846), // Rule ID 3227 //
     /*  84761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84810 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84814 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84818 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84823 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84825 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84827 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84844 */     GIR_RootConstrainSelectedInstOperands,
     /*  84845 */     // GIR_Coverage, 3227,
     /*  84845 */     GIR_EraseRootFromParent_Done,
     /*  84846 */   // Label 1593: @84846
     /*  84846 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(84936), // Rule ID 3231 //
     /*  84851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84900 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84904 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84908 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84913 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84915 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84917 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84934 */     GIR_RootConstrainSelectedInstOperands,
     /*  84935 */     // GIR_Coverage, 3231,
     /*  84935 */     GIR_EraseRootFromParent_Done,
     /*  84936 */   // Label 1594: @84936
     /*  84936 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(85026), // Rule ID 3235 //
     /*  84941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84990 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84994 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84998 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  85001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  85003 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  85005 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  85007 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  85009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85024 */     GIR_RootConstrainSelectedInstOperands,
     /*  85025 */     // GIR_Coverage, 3235,
     /*  85025 */     GIR_EraseRootFromParent_Done,
     /*  85026 */   // Label 1595: @85026
     /*  85026 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(85116), // Rule ID 3239 //
     /*  85031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  85034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  85039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  85042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  85045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  85048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  85051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  85057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  85060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  85064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  85068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  85072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  85076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  85080 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85084 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85088 */     // (intrinsic_wo_chain:{ *:[i32] } 3644:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  85088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  85091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  85093 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  85095 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  85097 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  85099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85114 */     GIR_RootConstrainSelectedInstOperands,
     /*  85115 */     // GIR_Coverage, 3239,
     /*  85115 */     GIR_EraseRootFromParent_Done,
     /*  85116 */   // Label 1596: @85116
     /*  85116 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(85203), // Rule ID 4335 //
     /*  85121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85175 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3653:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  85178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85180 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85182 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85184 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85201 */     GIR_RootConstrainSelectedInstOperands,
     /*  85202 */     // GIR_Coverage, 4335,
     /*  85202 */     GIR_EraseRootFromParent_Done,
     /*  85203 */   // Label 1597: @85203
     /*  85203 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(85290), // Rule ID 4337 //
     /*  85208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85262 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3653:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  85265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85267 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85269 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85271 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85288 */     GIR_RootConstrainSelectedInstOperands,
     /*  85289 */     // GIR_Coverage, 4337,
     /*  85289 */     GIR_EraseRootFromParent_Done,
     /*  85290 */   // Label 1598: @85290
     /*  85290 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(85377), // Rule ID 4339 //
     /*  85295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85349 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3653:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  85352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85354 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85356 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85358 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85375 */     GIR_RootConstrainSelectedInstOperands,
     /*  85376 */     // GIR_Coverage, 4339,
     /*  85376 */     GIR_EraseRootFromParent_Done,
     /*  85377 */   // Label 1599: @85377
     /*  85377 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(85464), // Rule ID 4341 //
     /*  85382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85436 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3653:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  85439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85441 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85443 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85445 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85462 */     GIR_RootConstrainSelectedInstOperands,
     /*  85463 */     // GIR_Coverage, 4341,
     /*  85463 */     GIR_EraseRootFromParent_Done,
     /*  85464 */   // Label 1600: @85464
     /*  85464 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(85551), // Rule ID 4343 //
     /*  85469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85523 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3653:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  85526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85528 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85530 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85532 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85549 */     GIR_RootConstrainSelectedInstOperands,
     /*  85550 */     // GIR_Coverage, 4343,
     /*  85550 */     GIR_EraseRootFromParent_Done,
     /*  85551 */   // Label 1601: @85551
     /*  85551 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(85638), // Rule ID 4345 //
     /*  85556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85610 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3653:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  85613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85615 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85617 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85619 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85636 */     GIR_RootConstrainSelectedInstOperands,
     /*  85637 */     // GIR_Coverage, 4345,
     /*  85637 */     GIR_EraseRootFromParent_Done,
     /*  85638 */   // Label 1602: @85638
     /*  85638 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(85725), // Rule ID 4347 //
     /*  85643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85697 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3653:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85702 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85704 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85706 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85723 */     GIR_RootConstrainSelectedInstOperands,
     /*  85724 */     // GIR_Coverage, 4347,
     /*  85724 */     GIR_EraseRootFromParent_Done,
     /*  85725 */   // Label 1603: @85725
     /*  85725 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(85812), // Rule ID 4349 //
     /*  85730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85784 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3653:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85789 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85791 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85793 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85810 */     GIR_RootConstrainSelectedInstOperands,
     /*  85811 */     // GIR_Coverage, 4349,
     /*  85811 */     GIR_EraseRootFromParent_Done,
     /*  85812 */   // Label 1604: @85812
     /*  85812 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(85899), // Rule ID 4351 //
     /*  85817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85871 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3653:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85876 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85878 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85880 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85897 */     GIR_RootConstrainSelectedInstOperands,
     /*  85898 */     // GIR_Coverage, 4351,
     /*  85898 */     GIR_EraseRootFromParent_Done,
     /*  85899 */   // Label 1605: @85899
     /*  85899 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(85986), // Rule ID 4353 //
     /*  85904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85958 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3653:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85963 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85965 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85967 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85984 */     GIR_RootConstrainSelectedInstOperands,
     /*  85985 */     // GIR_Coverage, 4353,
     /*  85985 */     GIR_EraseRootFromParent_Done,
     /*  85986 */   // Label 1606: @85986
     /*  85986 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(86073), // Rule ID 4355 //
     /*  85991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  86045 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3653:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  86048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86050 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86052 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86054 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86071 */     GIR_RootConstrainSelectedInstOperands,
     /*  86072 */     // GIR_Coverage, 4355,
     /*  86072 */     GIR_EraseRootFromParent_Done,
     /*  86073 */   // Label 1607: @86073
     /*  86073 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(86160), // Rule ID 4357 //
     /*  86078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  86132 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3653:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  86135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86137 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86139 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86141 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86158 */     GIR_RootConstrainSelectedInstOperands,
     /*  86159 */     // GIR_Coverage, 4357,
     /*  86159 */     GIR_EraseRootFromParent_Done,
     /*  86160 */   // Label 1608: @86160
     /*  86160 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(86247), // Rule ID 4359 //
     /*  86165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86219 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3653:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  86222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86224 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86226 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86228 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86245 */     GIR_RootConstrainSelectedInstOperands,
     /*  86246 */     // GIR_Coverage, 4359,
     /*  86246 */     GIR_EraseRootFromParent_Done,
     /*  86247 */   // Label 1609: @86247
     /*  86247 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(86334), // Rule ID 4361 //
     /*  86252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86306 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3653:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  86309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86311 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86313 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86315 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86332 */     GIR_RootConstrainSelectedInstOperands,
     /*  86333 */     // GIR_Coverage, 4361,
     /*  86333 */     GIR_EraseRootFromParent_Done,
     /*  86334 */   // Label 1610: @86334
     /*  86334 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(86421), // Rule ID 4363 //
     /*  86339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86393 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3653:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  86396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86398 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86400 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86402 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86407 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86419 */     GIR_RootConstrainSelectedInstOperands,
     /*  86420 */     // GIR_Coverage, 4363,
     /*  86420 */     GIR_EraseRootFromParent_Done,
     /*  86421 */   // Label 1611: @86421
     /*  86421 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(86508), // Rule ID 4365 //
     /*  86426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86480 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3653:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  86483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86485 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86487 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86489 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86506 */     GIR_RootConstrainSelectedInstOperands,
     /*  86507 */     // GIR_Coverage, 4365,
     /*  86507 */     GIR_EraseRootFromParent_Done,
     /*  86508 */   // Label 1612: @86508
     /*  86508 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(86595), // Rule ID 4367 //
     /*  86513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86567 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3653:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  86570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86572 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86574 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86576 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86593 */     GIR_RootConstrainSelectedInstOperands,
     /*  86594 */     // GIR_Coverage, 4367,
     /*  86594 */     GIR_EraseRootFromParent_Done,
     /*  86595 */   // Label 1613: @86595
     /*  86595 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(86682), // Rule ID 4369 //
     /*  86600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86654 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3653:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86659 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86661 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86663 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86680 */     GIR_RootConstrainSelectedInstOperands,
     /*  86681 */     // GIR_Coverage, 4369,
     /*  86681 */     GIR_EraseRootFromParent_Done,
     /*  86682 */   // Label 1614: @86682
     /*  86682 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(86769), // Rule ID 4371 //
     /*  86687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86741 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3653:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86746 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86748 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86750 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86767 */     GIR_RootConstrainSelectedInstOperands,
     /*  86768 */     // GIR_Coverage, 4371,
     /*  86768 */     GIR_EraseRootFromParent_Done,
     /*  86769 */   // Label 1615: @86769
     /*  86769 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(86856), // Rule ID 4373 //
     /*  86774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86828 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3653:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86833 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86835 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86837 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86854 */     GIR_RootConstrainSelectedInstOperands,
     /*  86855 */     // GIR_Coverage, 4373,
     /*  86855 */     GIR_EraseRootFromParent_Done,
     /*  86856 */   // Label 1616: @86856
     /*  86856 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(86943), // Rule ID 4375 //
     /*  86861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86915 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3653:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86920 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86922 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86924 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86941 */     GIR_RootConstrainSelectedInstOperands,
     /*  86942 */     // GIR_Coverage, 4375,
     /*  86942 */     GIR_EraseRootFromParent_Done,
     /*  86943 */   // Label 1617: @86943
     /*  86943 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(87030), // Rule ID 4377 //
     /*  86948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87002 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3653:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  87002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  87005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87007 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  87009 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  87011 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  87013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87028 */     GIR_RootConstrainSelectedInstOperands,
     /*  87029 */     // GIR_Coverage, 4377,
     /*  87029 */     GIR_EraseRootFromParent_Done,
     /*  87030 */   // Label 1618: @87030
     /*  87030 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(87117), // Rule ID 4379 //
     /*  87035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  87040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  87052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  87081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87089 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3653:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  87089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  87092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87094 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  87096 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  87098 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  87100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87115 */     GIR_RootConstrainSelectedInstOperands,
     /*  87116 */     // GIR_Coverage, 4379,
     /*  87116 */     GIR_EraseRootFromParent_Done,
     /*  87117 */   // Label 1619: @87117
     /*  87117 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(87204), // Rule ID 4381 //
     /*  87122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  87127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  87139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  87168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87176 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3653:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  87176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  87179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87181 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  87183 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  87185 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  87187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87202 */     GIR_RootConstrainSelectedInstOperands,
     /*  87203 */     // GIR_Coverage, 4381,
     /*  87203 */     GIR_EraseRootFromParent_Done,
     /*  87204 */   // Label 1620: @87204
     /*  87204 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(87330), // Rule ID 2692 //
     /*  87209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  87217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  87220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  87223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  87226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  87229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  87232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  87235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  87238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  87242 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3854:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  87242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  87245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  87249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  87258 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  87261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  87265 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  87268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  87272 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  87275 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  87279 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  87282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  87287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  87310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87312 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  87314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87317 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  87319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  87322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87328 */     GIR_RootConstrainSelectedInstOperands,
     /*  87329 */     // GIR_Coverage, 2692,
     /*  87329 */     GIR_EraseRootFromParent_Done,
     /*  87330 */   // Label 1621: @87330
     /*  87330 */   GIM_Reject,
     /*  87331 */ // Label 1566: @87331
     /*  87331 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(91625),
     /*  87336 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  87339 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  87344 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(87451), // Rule ID 3758 //
     /*  87349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87370 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87373 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87400 */     // MIs[1] Operand 1
     /*  87400 */     // No operand predicates
     /*  87400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87422 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87427 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87449 */     GIR_RootConstrainSelectedInstOperands,
     /*  87450 */     // GIR_Coverage, 3758,
     /*  87450 */     GIR_EraseRootFromParent_Done,
     /*  87451 */   // Label 1623: @87451
     /*  87451 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(87558), // Rule ID 3760 //
     /*  87456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87477 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87480 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87507 */     // MIs[1] Operand 1
     /*  87507 */     // No operand predicates
     /*  87507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87529 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87534 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87556 */     GIR_RootConstrainSelectedInstOperands,
     /*  87557 */     // GIR_Coverage, 3760,
     /*  87557 */     GIR_EraseRootFromParent_Done,
     /*  87558 */   // Label 1624: @87558
     /*  87558 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(87665), // Rule ID 3762 //
     /*  87563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87584 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87587 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87614 */     // MIs[1] Operand 1
     /*  87614 */     // No operand predicates
     /*  87614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87636 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87641 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87663 */     GIR_RootConstrainSelectedInstOperands,
     /*  87664 */     // GIR_Coverage, 3762,
     /*  87664 */     GIR_EraseRootFromParent_Done,
     /*  87665 */   // Label 1625: @87665
     /*  87665 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(87772), // Rule ID 3764 //
     /*  87670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87691 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87694 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87721 */     // MIs[1] Operand 1
     /*  87721 */     // No operand predicates
     /*  87721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87743 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87748 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87770 */     GIR_RootConstrainSelectedInstOperands,
     /*  87771 */     // GIR_Coverage, 3764,
     /*  87771 */     GIR_EraseRootFromParent_Done,
     /*  87772 */   // Label 1626: @87772
     /*  87772 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(87879), // Rule ID 3766 //
     /*  87777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87798 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87801 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87828 */     // MIs[1] Operand 1
     /*  87828 */     // No operand predicates
     /*  87828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87850 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87855 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87877 */     GIR_RootConstrainSelectedInstOperands,
     /*  87878 */     // GIR_Coverage, 3766,
     /*  87878 */     GIR_EraseRootFromParent_Done,
     /*  87879 */   // Label 1627: @87879
     /*  87879 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(87986), // Rule ID 3768 //
     /*  87884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87905 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87908 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87935 */     // MIs[1] Operand 1
     /*  87935 */     // No operand predicates
     /*  87935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87957 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87962 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87984 */     GIR_RootConstrainSelectedInstOperands,
     /*  87985 */     // GIR_Coverage, 3768,
     /*  87985 */     GIR_EraseRootFromParent_Done,
     /*  87986 */   // Label 1628: @87986
     /*  87986 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(88093), // Rule ID 3770 //
     /*  87991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88012 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88015 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88042 */     // MIs[1] Operand 1
     /*  88042 */     // No operand predicates
     /*  88042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88064 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  88067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88069 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88091 */     GIR_RootConstrainSelectedInstOperands,
     /*  88092 */     // GIR_Coverage, 3770,
     /*  88092 */     GIR_EraseRootFromParent_Done,
     /*  88093 */   // Label 1629: @88093
     /*  88093 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(88200), // Rule ID 3772 //
     /*  88098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88119 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88122 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88149 */     // MIs[1] Operand 1
     /*  88149 */     // No operand predicates
     /*  88149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88171 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  88174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88176 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88198 */     GIR_RootConstrainSelectedInstOperands,
     /*  88199 */     // GIR_Coverage, 3772,
     /*  88199 */     GIR_EraseRootFromParent_Done,
     /*  88200 */   // Label 1630: @88200
     /*  88200 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(88307), // Rule ID 3774 //
     /*  88205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88226 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88229 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88256 */     // MIs[1] Operand 1
     /*  88256 */     // No operand predicates
     /*  88256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88278 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88283 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88305 */     GIR_RootConstrainSelectedInstOperands,
     /*  88306 */     // GIR_Coverage, 3774,
     /*  88306 */     GIR_EraseRootFromParent_Done,
     /*  88307 */   // Label 1631: @88307
     /*  88307 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(88414), // Rule ID 3776 //
     /*  88312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88333 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88336 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88363 */     // MIs[1] Operand 1
     /*  88363 */     // No operand predicates
     /*  88363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88385 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88390 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88412 */     GIR_RootConstrainSelectedInstOperands,
     /*  88413 */     // GIR_Coverage, 3776,
     /*  88413 */     GIR_EraseRootFromParent_Done,
     /*  88414 */   // Label 1632: @88414
     /*  88414 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(88521), // Rule ID 3778 //
     /*  88419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88440 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88443 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88470 */     // MIs[1] Operand 1
     /*  88470 */     // No operand predicates
     /*  88470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88492 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88497 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88519 */     GIR_RootConstrainSelectedInstOperands,
     /*  88520 */     // GIR_Coverage, 3778,
     /*  88520 */     GIR_EraseRootFromParent_Done,
     /*  88521 */   // Label 1633: @88521
     /*  88521 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(88628), // Rule ID 3780 //
     /*  88526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88547 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88550 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88577 */     // MIs[1] Operand 1
     /*  88577 */     // No operand predicates
     /*  88577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88599 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88604 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88626 */     GIR_RootConstrainSelectedInstOperands,
     /*  88627 */     // GIR_Coverage, 3780,
     /*  88627 */     GIR_EraseRootFromParent_Done,
     /*  88628 */   // Label 1634: @88628
     /*  88628 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(88735), // Rule ID 3782 //
     /*  88633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88654 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88657 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88684 */     // MIs[1] Operand 1
     /*  88684 */     // No operand predicates
     /*  88684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88706 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88711 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88733 */     GIR_RootConstrainSelectedInstOperands,
     /*  88734 */     // GIR_Coverage, 3782,
     /*  88734 */     GIR_EraseRootFromParent_Done,
     /*  88735 */   // Label 1635: @88735
     /*  88735 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(88842), // Rule ID 3784 //
     /*  88740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88761 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88764 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88791 */     // MIs[1] Operand 1
     /*  88791 */     // No operand predicates
     /*  88791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88813 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88818 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88840 */     GIR_RootConstrainSelectedInstOperands,
     /*  88841 */     // GIR_Coverage, 3784,
     /*  88841 */     GIR_EraseRootFromParent_Done,
     /*  88842 */   // Label 1636: @88842
     /*  88842 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(88949), // Rule ID 3786 //
     /*  88847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88868 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88871 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88898 */     // MIs[1] Operand 1
     /*  88898 */     // No operand predicates
     /*  88898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88920 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88925 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88947 */     GIR_RootConstrainSelectedInstOperands,
     /*  88948 */     // GIR_Coverage, 3786,
     /*  88948 */     GIR_EraseRootFromParent_Done,
     /*  88949 */   // Label 1637: @88949
     /*  88949 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(89056), // Rule ID 3788 //
     /*  88954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88975 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88978 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89005 */     // MIs[1] Operand 1
     /*  89005 */     // No operand predicates
     /*  89005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  89009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89027 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  89030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89032 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89054 */     GIR_RootConstrainSelectedInstOperands,
     /*  89055 */     // GIR_Coverage, 3788,
     /*  89055 */     GIR_EraseRootFromParent_Done,
     /*  89056 */   // Label 1638: @89056
     /*  89056 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(89163), // Rule ID 3790 //
     /*  89061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89082 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89085 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89112 */     // MIs[1] Operand 1
     /*  89112 */     // No operand predicates
     /*  89112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89134 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  89137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89139 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89161 */     GIR_RootConstrainSelectedInstOperands,
     /*  89162 */     // GIR_Coverage, 3790,
     /*  89162 */     GIR_EraseRootFromParent_Done,
     /*  89163 */   // Label 1639: @89163
     /*  89163 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(89270), // Rule ID 3792 //
     /*  89168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89189 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89192 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89219 */     // MIs[1] Operand 1
     /*  89219 */     // No operand predicates
     /*  89219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89241 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  89244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89246 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89268 */     GIR_RootConstrainSelectedInstOperands,
     /*  89269 */     // GIR_Coverage, 3792,
     /*  89269 */     GIR_EraseRootFromParent_Done,
     /*  89270 */   // Label 1640: @89270
     /*  89270 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(89377), // Rule ID 3794 //
     /*  89275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89296 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89299 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89326 */     // MIs[1] Operand 1
     /*  89326 */     // No operand predicates
     /*  89326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89348 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  89351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89353 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89375 */     GIR_RootConstrainSelectedInstOperands,
     /*  89376 */     // GIR_Coverage, 3794,
     /*  89376 */     GIR_EraseRootFromParent_Done,
     /*  89377 */   // Label 1641: @89377
     /*  89377 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(89484), // Rule ID 3796 //
     /*  89382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89403 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89406 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89433 */     // MIs[1] Operand 1
     /*  89433 */     // No operand predicates
     /*  89433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89455 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  89458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89460 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89482 */     GIR_RootConstrainSelectedInstOperands,
     /*  89483 */     // GIR_Coverage, 3796,
     /*  89483 */     GIR_EraseRootFromParent_Done,
     /*  89484 */   // Label 1642: @89484
     /*  89484 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(89591), // Rule ID 3798 //
     /*  89489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89510 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89513 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89540 */     // MIs[1] Operand 1
     /*  89540 */     // No operand predicates
     /*  89540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89562 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  89565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89567 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89589 */     GIR_RootConstrainSelectedInstOperands,
     /*  89590 */     // GIR_Coverage, 3798,
     /*  89590 */     GIR_EraseRootFromParent_Done,
     /*  89591 */   // Label 1643: @89591
     /*  89591 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(89698), // Rule ID 3800 //
     /*  89596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89617 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89620 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89647 */     // MIs[1] Operand 1
     /*  89647 */     // No operand predicates
     /*  89647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89669 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89674 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89696 */     GIR_RootConstrainSelectedInstOperands,
     /*  89697 */     // GIR_Coverage, 3800,
     /*  89697 */     GIR_EraseRootFromParent_Done,
     /*  89698 */   // Label 1644: @89698
     /*  89698 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(89805), // Rule ID 3802 //
     /*  89703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89724 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89727 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89754 */     // MIs[1] Operand 1
     /*  89754 */     // No operand predicates
     /*  89754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89776 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89781 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89803 */     GIR_RootConstrainSelectedInstOperands,
     /*  89804 */     // GIR_Coverage, 3802,
     /*  89804 */     GIR_EraseRootFromParent_Done,
     /*  89805 */   // Label 1645: @89805
     /*  89805 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(89912), // Rule ID 3804 //
     /*  89810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89831 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89834 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89861 */     // MIs[1] Operand 1
     /*  89861 */     // No operand predicates
     /*  89861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89873 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89883 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89888 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89910 */     GIR_RootConstrainSelectedInstOperands,
     /*  89911 */     // GIR_Coverage, 3804,
     /*  89911 */     GIR_EraseRootFromParent_Done,
     /*  89912 */   // Label 1646: @89912
     /*  89912 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(90019), // Rule ID 3806 //
     /*  89917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89938 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89941 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89968 */     // MIs[1] Operand 1
     /*  89968 */     // No operand predicates
     /*  89968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89990 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89995 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90017 */     GIR_RootConstrainSelectedInstOperands,
     /*  90018 */     // GIR_Coverage, 3806,
     /*  90018 */     GIR_EraseRootFromParent_Done,
     /*  90019 */   // Label 1647: @90019
     /*  90019 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(90126), // Rule ID 3808 //
     /*  90024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90045 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90048 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90075 */     // MIs[1] Operand 1
     /*  90075 */     // No operand predicates
     /*  90075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90097 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  90100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90102 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90124 */     GIR_RootConstrainSelectedInstOperands,
     /*  90125 */     // GIR_Coverage, 3808,
     /*  90125 */     GIR_EraseRootFromParent_Done,
     /*  90126 */   // Label 1648: @90126
     /*  90126 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(90233), // Rule ID 3810 //
     /*  90131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90152 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90155 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90182 */     // MIs[1] Operand 1
     /*  90182 */     // No operand predicates
     /*  90182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90204 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  90207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90209 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90231 */     GIR_RootConstrainSelectedInstOperands,
     /*  90232 */     // GIR_Coverage, 3810,
     /*  90232 */     GIR_EraseRootFromParent_Done,
     /*  90233 */   // Label 1649: @90233
     /*  90233 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(90340), // Rule ID 3812 //
     /*  90238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90259 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90262 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90289 */     // MIs[1] Operand 1
     /*  90289 */     // No operand predicates
     /*  90289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90311 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  90314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90316 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90338 */     GIR_RootConstrainSelectedInstOperands,
     /*  90339 */     // GIR_Coverage, 3812,
     /*  90339 */     GIR_EraseRootFromParent_Done,
     /*  90340 */   // Label 1650: @90340
     /*  90340 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(90447), // Rule ID 3814 //
     /*  90345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90366 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90369 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90396 */     // MIs[1] Operand 1
     /*  90396 */     // No operand predicates
     /*  90396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90418 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  90421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90423 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90445 */     GIR_RootConstrainSelectedInstOperands,
     /*  90446 */     // GIR_Coverage, 3814,
     /*  90446 */     GIR_EraseRootFromParent_Done,
     /*  90447 */   // Label 1651: @90447
     /*  90447 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(90554), // Rule ID 3816 //
     /*  90452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90473 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90476 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90503 */     // MIs[1] Operand 1
     /*  90503 */     // No operand predicates
     /*  90503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90525 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  90528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90530 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90552 */     GIR_RootConstrainSelectedInstOperands,
     /*  90553 */     // GIR_Coverage, 3816,
     /*  90553 */     GIR_EraseRootFromParent_Done,
     /*  90554 */   // Label 1652: @90554
     /*  90554 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(90661), // Rule ID 3818 //
     /*  90559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90580 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90583 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90610 */     // MIs[1] Operand 1
     /*  90610 */     // No operand predicates
     /*  90610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90632 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  90635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90637 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90659 */     GIR_RootConstrainSelectedInstOperands,
     /*  90660 */     // GIR_Coverage, 3818,
     /*  90660 */     GIR_EraseRootFromParent_Done,
     /*  90661 */   // Label 1653: @90661
     /*  90661 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(90768), // Rule ID 3820 //
     /*  90666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90687 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90690 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90717 */     // MIs[1] Operand 1
     /*  90717 */     // No operand predicates
     /*  90717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90739 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90744 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90766 */     GIR_RootConstrainSelectedInstOperands,
     /*  90767 */     // GIR_Coverage, 3820,
     /*  90767 */     GIR_EraseRootFromParent_Done,
     /*  90768 */   // Label 1654: @90768
     /*  90768 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(90875), // Rule ID 3822 //
     /*  90773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90794 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90797 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90824 */     // MIs[1] Operand 1
     /*  90824 */     // No operand predicates
     /*  90824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90846 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90851 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90873 */     GIR_RootConstrainSelectedInstOperands,
     /*  90874 */     // GIR_Coverage, 3822,
     /*  90874 */     GIR_EraseRootFromParent_Done,
     /*  90875 */   // Label 1655: @90875
     /*  90875 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(90982), // Rule ID 3824 //
     /*  90880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90901 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90904 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90931 */     // MIs[1] Operand 1
     /*  90931 */     // No operand predicates
     /*  90931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90953 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90958 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90980 */     GIR_RootConstrainSelectedInstOperands,
     /*  90981 */     // GIR_Coverage, 3824,
     /*  90981 */     GIR_EraseRootFromParent_Done,
     /*  90982 */   // Label 1656: @90982
     /*  90982 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91089), // Rule ID 3826 //
     /*  90987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91008 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91011 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91038 */     // MIs[1] Operand 1
     /*  91038 */     // No operand predicates
     /*  91038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  91046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91060 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  91063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91065 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91087 */     GIR_RootConstrainSelectedInstOperands,
     /*  91088 */     // GIR_Coverage, 3826,
     /*  91088 */     GIR_EraseRootFromParent_Done,
     /*  91089 */   // Label 1657: @91089
     /*  91089 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91196), // Rule ID 3828 //
     /*  91094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91115 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91118 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91145 */     // MIs[1] Operand 1
     /*  91145 */     // No operand predicates
     /*  91145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  91153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91167 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  91170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91172 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91194 */     GIR_RootConstrainSelectedInstOperands,
     /*  91195 */     // GIR_Coverage, 3828,
     /*  91195 */     GIR_EraseRootFromParent_Done,
     /*  91196 */   // Label 1658: @91196
     /*  91196 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91303), // Rule ID 3830 //
     /*  91201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91222 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91225 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91252 */     // MIs[1] Operand 1
     /*  91252 */     // No operand predicates
     /*  91252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91274 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  91277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91279 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91301 */     GIR_RootConstrainSelectedInstOperands,
     /*  91302 */     // GIR_Coverage, 3830,
     /*  91302 */     GIR_EraseRootFromParent_Done,
     /*  91303 */   // Label 1659: @91303
     /*  91303 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91410), // Rule ID 3832 //
     /*  91308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91329 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91332 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91359 */     // MIs[1] Operand 1
     /*  91359 */     // No operand predicates
     /*  91359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91381 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3697:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  91384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91386 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91408 */     GIR_RootConstrainSelectedInstOperands,
     /*  91409 */     // GIR_Coverage, 3832,
     /*  91409 */     GIR_EraseRootFromParent_Done,
     /*  91410 */   // Label 1660: @91410
     /*  91410 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91517), // Rule ID 3834 //
     /*  91415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91436 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91439 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91466 */     // MIs[1] Operand 1
     /*  91466 */     // No operand predicates
     /*  91466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91488 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  91491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91493 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91515 */     GIR_RootConstrainSelectedInstOperands,
     /*  91516 */     // GIR_Coverage, 3834,
     /*  91516 */     GIR_EraseRootFromParent_Done,
     /*  91517 */   // Label 1661: @91517
     /*  91517 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91624), // Rule ID 3836 //
     /*  91522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91543 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91546 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91573 */     // MIs[1] Operand 1
     /*  91573 */     // No operand predicates
     /*  91573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91595 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3697:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  91598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91600 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91622 */     GIR_RootConstrainSelectedInstOperands,
     /*  91623 */     // GIR_Coverage, 3836,
     /*  91623 */     GIR_EraseRootFromParent_Done,
     /*  91624 */   // Label 1662: @91624
     /*  91624 */   GIM_Reject,
     /*  91625 */ // Label 1622: @91625
     /*  91625 */ GIM_Reject,
     /*  91626 */ // Label 16: @91626
     /*  91626 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91683),
     /*  91631 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91634 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91639 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91656), // Rule ID 245 //
     /*  91644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91647 */     // (intrinsic_void 3483:{ *:[iPTR] })  =>  (CLREX)
     /*  91647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91654 */     GIR_RootConstrainSelectedInstOperands,
     /*  91655 */     // GIR_Coverage, 245,
     /*  91655 */     GIR_EraseRootFromParent_Done,
     /*  91656 */   // Label 1664: @91656
     /*  91656 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91682), // Rule ID 574 //
     /*  91661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91664 */     // (intrinsic_void 3483:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91680 */     GIR_RootConstrainSelectedInstOperands,
     /*  91681 */     // GIR_Coverage, 574,
     /*  91681 */     GIR_EraseRootFromParent_Done,
     /*  91682 */   // Label 1665: @91682
     /*  91682 */   GIM_Reject,
     /*  91683 */ // Label 1663: @91683
     /*  91683 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(92485),
     /*  91688 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91691 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91727), // Rule ID 344 //
     /*  91696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91704 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91707 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91718 */     // (intrinsic_void 3923:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91725 */     GIR_RootConstrainSelectedInstOperands,
     /*  91726 */     // GIR_Coverage, 344,
     /*  91726 */     GIR_EraseRootFromParent_Done,
     /*  91727 */   // Label 1667: @91727
     /*  91727 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91779), // Rule ID 2 //
     /*  91732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91740 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91755 */     // MIs[1] Operand 1
     /*  91755 */     // No operand predicates
     /*  91755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91757 */     // (intrinsic_void 3501:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91777 */     GIR_RootConstrainSelectedInstOperands,
     /*  91778 */     // GIR_Coverage, 2,
     /*  91778 */     GIR_EraseRootFromParent_Done,
     /*  91779 */   // Label 1668: @91779
     /*  91779 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91831), // Rule ID 10 //
     /*  91784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91792 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91807 */     // MIs[1] Operand 1
     /*  91807 */     // No operand predicates
     /*  91807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91809 */     // (intrinsic_void 3496:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91829 */     GIR_RootConstrainSelectedInstOperands,
     /*  91830 */     // GIR_Coverage, 10,
     /*  91830 */     GIR_EraseRootFromParent_Done,
     /*  91831 */   // Label 1669: @91831
     /*  91831 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91874), // Rule ID 11 //
     /*  91836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91844 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91859 */     // MIs[1] Operand 1
     /*  91859 */     // No operand predicates
     /*  91859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91861 */     // (intrinsic_void 3923:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91872 */     GIR_RootConstrainSelectedInstOperands,
     /*  91873 */     // GIR_Coverage, 11,
     /*  91873 */     GIR_EraseRootFromParent_Done,
     /*  91874 */   // Label 1670: @91874
     /*  91874 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91917), // Rule ID 228 //
     /*  91879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91887 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91902 */     // MIs[1] Operand 1
     /*  91902 */     // No operand predicates
     /*  91902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91904 */     // (intrinsic_void 3497:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91915 */     GIR_RootConstrainSelectedInstOperands,
     /*  91916 */     // GIR_Coverage, 228,
     /*  91916 */     GIR_EraseRootFromParent_Done,
     /*  91917 */   // Label 1671: @91917
     /*  91917 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91960), // Rule ID 229 //
     /*  91922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91930 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91945 */     // MIs[1] Operand 1
     /*  91945 */     // No operand predicates
     /*  91945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91947 */     // (intrinsic_void 3498:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91958 */     GIR_RootConstrainSelectedInstOperands,
     /*  91959 */     // GIR_Coverage, 229,
     /*  91959 */     GIR_EraseRootFromParent_Done,
     /*  91960 */   // Label 1672: @91960
     /*  91960 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(92003), // Rule ID 230 //
     /*  91965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91973 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91988 */     // MIs[1] Operand 1
     /*  91988 */     // No operand predicates
     /*  91988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91990 */     // (intrinsic_void 3502:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92001 */     GIR_RootConstrainSelectedInstOperands,
     /*  92002 */     // GIR_Coverage, 230,
     /*  92002 */     GIR_EraseRootFromParent_Done,
     /*  92003 */   // Label 1673: @92003
     /*  92003 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(92055), // Rule ID 276 //
     /*  92008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  92011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  92016 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92031 */     // MIs[1] Operand 1
     /*  92031 */     // No operand predicates
     /*  92031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92033 */     // (intrinsic_void 3501:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  92033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  92036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  92039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92053 */     GIR_RootConstrainSelectedInstOperands,
     /*  92054 */     // GIR_Coverage, 276,
     /*  92054 */     GIR_EraseRootFromParent_Done,
     /*  92055 */   // Label 1674: @92055
     /*  92055 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(92098), // Rule ID 343 //
     /*  92060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  92063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  92068 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  92083 */     // MIs[1] Operand 1
     /*  92083 */     // No operand predicates
     /*  92083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92085 */     // (intrinsic_void 3923:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  92085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  92088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  92091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92096 */     GIR_RootConstrainSelectedInstOperands,
     /*  92097 */     // GIR_Coverage, 343,
     /*  92097 */     GIR_EraseRootFromParent_Done,
     /*  92098 */   // Label 1675: @92098
     /*  92098 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(92141), // Rule ID 494 //
     /*  92103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  92111 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  92126 */     // MIs[1] Operand 1
     /*  92126 */     // No operand predicates
     /*  92126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92128 */     // (intrinsic_void 3923:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  92128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  92131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  92134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92139 */     GIR_RootConstrainSelectedInstOperands,
     /*  92140 */     // GIR_Coverage, 494,
     /*  92140 */     GIR_EraseRootFromParent_Done,
     /*  92141 */   // Label 1676: @92141
     /*  92141 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92193), // Rule ID 559 //
     /*  92146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  92154 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92169 */     // MIs[1] Operand 1
     /*  92169 */     // No operand predicates
     /*  92169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92171 */     // (intrinsic_void 3497:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  92171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  92174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92191 */     GIR_RootConstrainSelectedInstOperands,
     /*  92192 */     // GIR_Coverage, 559,
     /*  92192 */     GIR_EraseRootFromParent_Done,
     /*  92193 */   // Label 1677: @92193
     /*  92193 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92245), // Rule ID 560 //
     /*  92198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  92206 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92221 */     // MIs[1] Operand 1
     /*  92221 */     // No operand predicates
     /*  92221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92223 */     // (intrinsic_void 3498:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  92223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  92226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92243 */     GIR_RootConstrainSelectedInstOperands,
     /*  92244 */     // GIR_Coverage, 560,
     /*  92244 */     GIR_EraseRootFromParent_Done,
     /*  92245 */   // Label 1678: @92245
     /*  92245 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92297), // Rule ID 561 //
     /*  92250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  92258 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92273 */     // MIs[1] Operand 1
     /*  92273 */     // No operand predicates
     /*  92273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92275 */     // (intrinsic_void 3502:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  92275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  92278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92295 */     GIR_RootConstrainSelectedInstOperands,
     /*  92296 */     // GIR_Coverage, 561,
     /*  92296 */     GIR_EraseRootFromParent_Done,
     /*  92297 */   // Label 1679: @92297
     /*  92297 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92349), // Rule ID 579 //
     /*  92302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  92310 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  92325 */     // MIs[1] Operand 1
     /*  92325 */     // No operand predicates
     /*  92325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92327 */     // (intrinsic_void 3501:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  92327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  92330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  92333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92347 */     GIR_RootConstrainSelectedInstOperands,
     /*  92348 */     // GIR_Coverage, 579,
     /*  92348 */     GIR_EraseRootFromParent_Done,
     /*  92349 */   // Label 1680: @92349
     /*  92349 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92401), // Rule ID 580 //
     /*  92354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  92362 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92377 */     // MIs[1] Operand 1
     /*  92377 */     // No operand predicates
     /*  92377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92379 */     // (intrinsic_void 3496:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  92379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  92382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92399 */     GIR_RootConstrainSelectedInstOperands,
     /*  92400 */     // GIR_Coverage, 580,
     /*  92400 */     GIR_EraseRootFromParent_Done,
     /*  92401 */   // Label 1681: @92401
     /*  92401 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92441), // Rule ID 725 //
     /*  92406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  92414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92421 */     // (intrinsic_w_chain:{ *:[i32] } 3499:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  92421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  92424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  92426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92439 */     GIR_RootConstrainSelectedInstOperands,
     /*  92440 */     // GIR_Coverage, 725,
     /*  92440 */     GIR_EraseRootFromParent_Done,
     /*  92441 */   // Label 1682: @92441
     /*  92441 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92484), // Rule ID 726 //
     /*  92446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  92454 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92461 */     // (intrinsic_void 3867:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /*  92461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  92464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  92466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  92478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92482 */     GIR_RootConstrainSelectedInstOperands,
     /*  92483 */     // GIR_Coverage, 726,
     /*  92483 */     GIR_EraseRootFromParent_Done,
     /*  92484 */   // Label 1683: @92484
     /*  92484 */   GIM_Reject,
     /*  92485 */ // Label 1666: @92485
     /*  92485 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92528), // Rule ID 604 //
     /*  92490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  92493 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92496 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  92501 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  92511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  92515 */   // (intrinsic_w_chain:{ *:[i32] } 348:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  92515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  92518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  92520 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  92522 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92526 */   GIR_RootConstrainSelectedInstOperands,
     /*  92527 */   // GIR_Coverage, 604,
     /*  92527 */   GIR_EraseRootFromParent_Done,
     /*  92528 */ // Label 1684: @92528
     /*  92528 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(94519),
     /*  92533 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92536 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92590), // Rule ID 5051 //
     /*  92541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92571 */     // MIs[1] Operand 1
     /*  92571 */     // No operand predicates
     /*  92571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92573 */     // (intrinsic_w_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92578 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92588 */     GIR_RootConstrainSelectedInstOperands,
     /*  92589 */     // GIR_Coverage, 5051,
     /*  92589 */     GIR_EraseRootFromParent_Done,
     /*  92590 */   // Label 1686: @92590
     /*  92590 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92644), // Rule ID 5057 //
     /*  92595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92625 */     // MIs[1] Operand 1
     /*  92625 */     // No operand predicates
     /*  92625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92627 */     // (intrinsic_w_chain:{ *:[v4f32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92632 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92642 */     GIR_RootConstrainSelectedInstOperands,
     /*  92643 */     // GIR_Coverage, 5057,
     /*  92643 */     GIR_EraseRootFromParent_Done,
     /*  92644 */   // Label 1687: @92644
     /*  92644 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92698), // Rule ID 5059 //
     /*  92649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92679 */     // MIs[1] Operand 1
     /*  92679 */     // No operand predicates
     /*  92679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92681 */     // (intrinsic_w_chain:{ *:[v2i64] } 3632:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92686 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92696 */     GIR_RootConstrainSelectedInstOperands,
     /*  92697 */     // GIR_Coverage, 5059,
     /*  92697 */     GIR_EraseRootFromParent_Done,
     /*  92698 */   // Label 1688: @92698
     /*  92698 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92752), // Rule ID 5061 //
     /*  92703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92733 */     // MIs[1] Operand 1
     /*  92733 */     // No operand predicates
     /*  92733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92735 */     // (intrinsic_w_chain:{ *:[v2f64] } 3632:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92740 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92750 */     GIR_RootConstrainSelectedInstOperands,
     /*  92751 */     // GIR_Coverage, 5061,
     /*  92751 */     GIR_EraseRootFromParent_Done,
     /*  92752 */   // Label 1689: @92752
     /*  92752 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92794), // Rule ID 1741 //
     /*  92757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92772 */     // MIs[0] size
     /*  92772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92779 */     // (intrinsic_w_chain:{ *:[i32] } 3898:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92784 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92792 */     GIR_RootConstrainSelectedInstOperands,
     /*  92793 */     // GIR_Coverage, 1741,
     /*  92793 */     GIR_EraseRootFromParent_Done,
     /*  92794 */   // Label 1690: @92794
     /*  92794 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92848), // Rule ID 5053 //
     /*  92799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92804 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92825 */     // MIs[1] Operand 1
     /*  92825 */     // No operand predicates
     /*  92825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92831 */     // (intrinsic_void 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92834 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92836 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92846 */     GIR_RootConstrainSelectedInstOperands,
     /*  92847 */     // GIR_Coverage, 5053,
     /*  92847 */     GIR_EraseRootFromParent_Done,
     /*  92848 */   // Label 1691: @92848
     /*  92848 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92902), // Rule ID 5063 //
     /*  92853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92858 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92879 */     // MIs[1] Operand 1
     /*  92879 */     // No operand predicates
     /*  92879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92885 */     // (intrinsic_void 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92888 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92890 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92900 */     GIR_RootConstrainSelectedInstOperands,
     /*  92901 */     // GIR_Coverage, 5063,
     /*  92901 */     GIR_EraseRootFromParent_Done,
     /*  92902 */   // Label 1692: @92902
     /*  92902 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92956), // Rule ID 5067 //
     /*  92907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92912 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92933 */     // MIs[1] Operand 1
     /*  92933 */     // No operand predicates
     /*  92933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92939 */     // (intrinsic_void 3705:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92942 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92944 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92954 */     GIR_RootConstrainSelectedInstOperands,
     /*  92955 */     // GIR_Coverage, 5067,
     /*  92955 */     GIR_EraseRootFromParent_Done,
     /*  92956 */   // Label 1693: @92956
     /*  92956 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(93010), // Rule ID 5071 //
     /*  92961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92966 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92987 */     // MIs[1] Operand 1
     /*  92987 */     // No operand predicates
     /*  92987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92993 */     // (intrinsic_void 3705:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92996 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92998 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  93000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  93003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93008 */     GIR_RootConstrainSelectedInstOperands,
     /*  93009 */     // GIR_Coverage, 5071,
     /*  93009 */     GIR_EraseRootFromParent_Done,
     /*  93010 */   // Label 1694: @93010
     /*  93010 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(93068), // Rule ID 3 //
     /*  93015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  93018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93044 */     // (intrinsic_w_chain:{ *:[i32] } 3866:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  93047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93066 */     GIR_RootConstrainSelectedInstOperands,
     /*  93067 */     // GIR_Coverage, 3,
     /*  93067 */     GIR_EraseRootFromParent_Done,
     /*  93068 */   // Label 1695: @93068
     /*  93068 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(93126), // Rule ID 121 //
     /*  93073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93102 */     // (intrinsic_w_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  93105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93124 */     GIR_RootConstrainSelectedInstOperands,
     /*  93125 */     // GIR_Coverage, 121,
     /*  93125 */     GIR_EraseRootFromParent_Done,
     /*  93126 */   // Label 1696: @93126
     /*  93126 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(93184), // Rule ID 122 //
     /*  93131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93160 */     // (intrinsic_w_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  93163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93182 */     GIR_RootConstrainSelectedInstOperands,
     /*  93183 */     // GIR_Coverage, 122,
     /*  93183 */     GIR_EraseRootFromParent_Done,
     /*  93184 */   // Label 1697: @93184
     /*  93184 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(93242), // Rule ID 123 //
     /*  93189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93218 */     // (intrinsic_w_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  93221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93240 */     GIR_RootConstrainSelectedInstOperands,
     /*  93241 */     // GIR_Coverage, 123,
     /*  93241 */     GIR_EraseRootFromParent_Done,
     /*  93242 */   // Label 1698: @93242
     /*  93242 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(93300), // Rule ID 124 //
     /*  93247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93276 */     // (intrinsic_w_chain:{ *:[i32] } 3901:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  93279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93298 */     GIR_RootConstrainSelectedInstOperands,
     /*  93299 */     // GIR_Coverage, 124,
     /*  93299 */     GIR_EraseRootFromParent_Done,
     /*  93300 */   // Label 1699: @93300
     /*  93300 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(93358), // Rule ID 125 //
     /*  93305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93334 */     // (intrinsic_w_chain:{ *:[i32] } 3902:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  93337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93356 */     GIR_RootConstrainSelectedInstOperands,
     /*  93357 */     // GIR_Coverage, 125,
     /*  93357 */     GIR_EraseRootFromParent_Done,
     /*  93358 */   // Label 1700: @93358
     /*  93358 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(93416), // Rule ID 126 //
     /*  93363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93392 */     // (intrinsic_w_chain:{ *:[i32] } 3903:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  93395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93414 */     GIR_RootConstrainSelectedInstOperands,
     /*  93415 */     // GIR_Coverage, 126,
     /*  93415 */     GIR_EraseRootFromParent_Done,
     /*  93416 */   // Label 1701: @93416
     /*  93416 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93474), // Rule ID 127 //
     /*  93421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93450 */     // (intrinsic_w_chain:{ *:[i32] } 3916:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  93453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93472 */     GIR_RootConstrainSelectedInstOperands,
     /*  93473 */     // GIR_Coverage, 127,
     /*  93473 */     GIR_EraseRootFromParent_Done,
     /*  93474 */   // Label 1702: @93474
     /*  93474 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93532), // Rule ID 128 //
     /*  93479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93508 */     // (intrinsic_w_chain:{ *:[i32] } 3914:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  93511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93530 */     GIR_RootConstrainSelectedInstOperands,
     /*  93531 */     // GIR_Coverage, 128,
     /*  93531 */     GIR_EraseRootFromParent_Done,
     /*  93532 */   // Label 1703: @93532
     /*  93532 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(93590), // Rule ID 129 //
     /*  93537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93566 */     // (intrinsic_w_chain:{ *:[i32] } 3915:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  93569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93588 */     GIR_RootConstrainSelectedInstOperands,
     /*  93589 */     // GIR_Coverage, 129,
     /*  93589 */     GIR_EraseRootFromParent_Done,
     /*  93590 */   // Label 1704: @93590
     /*  93590 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(93648), // Rule ID 130 //
     /*  93595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93624 */     // (intrinsic_w_chain:{ *:[i32] } 3934:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  93627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93646 */     GIR_RootConstrainSelectedInstOperands,
     /*  93647 */     // GIR_Coverage, 130,
     /*  93647 */     GIR_EraseRootFromParent_Done,
     /*  93648 */   // Label 1705: @93648
     /*  93648 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93706), // Rule ID 131 //
     /*  93653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93682 */     // (intrinsic_w_chain:{ *:[i32] } 3935:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93704 */     GIR_RootConstrainSelectedInstOperands,
     /*  93705 */     // GIR_Coverage, 131,
     /*  93705 */     GIR_EraseRootFromParent_Done,
     /*  93706 */   // Label 1706: @93706
     /*  93706 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93764), // Rule ID 132 //
     /*  93711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93740 */     // (intrinsic_w_chain:{ *:[i32] } 3936:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93762 */     GIR_RootConstrainSelectedInstOperands,
     /*  93763 */     // GIR_Coverage, 132,
     /*  93763 */     GIR_EraseRootFromParent_Done,
     /*  93764 */   // Label 1707: @93764
     /*  93764 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93822), // Rule ID 431 //
     /*  93769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93798 */     // (intrinsic_w_chain:{ *:[i32] } 3866:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93820 */     GIR_RootConstrainSelectedInstOperands,
     /*  93821 */     // GIR_Coverage, 431,
     /*  93821 */     GIR_EraseRootFromParent_Done,
     /*  93822 */   // Label 1708: @93822
     /*  93822 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93880), // Rule ID 444 //
     /*  93827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93856 */     // (intrinsic_w_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93878 */     GIR_RootConstrainSelectedInstOperands,
     /*  93879 */     // GIR_Coverage, 444,
     /*  93879 */     GIR_EraseRootFromParent_Done,
     /*  93880 */   // Label 1709: @93880
     /*  93880 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(93938), // Rule ID 445 //
     /*  93885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93914 */     // (intrinsic_w_chain:{ *:[i32] } 3863:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93936 */     GIR_RootConstrainSelectedInstOperands,
     /*  93937 */     // GIR_Coverage, 445,
     /*  93937 */     GIR_EraseRootFromParent_Done,
     /*  93938 */   // Label 1710: @93938
     /*  93938 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(93996), // Rule ID 446 //
     /*  93943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93972 */     // (intrinsic_w_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93994 */     GIR_RootConstrainSelectedInstOperands,
     /*  93995 */     // GIR_Coverage, 446,
     /*  93995 */     GIR_EraseRootFromParent_Done,
     /*  93996 */   // Label 1711: @93996
     /*  93996 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(94054), // Rule ID 447 //
     /*  94001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  94009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94030 */     // (intrinsic_w_chain:{ *:[i32] } 3901:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  94033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94052 */     GIR_RootConstrainSelectedInstOperands,
     /*  94053 */     // GIR_Coverage, 447,
     /*  94053 */     GIR_EraseRootFromParent_Done,
     /*  94054 */   // Label 1712: @94054
     /*  94054 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(94112), // Rule ID 448 //
     /*  94059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  94067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94088 */     // (intrinsic_w_chain:{ *:[i32] } 3902:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  94091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94110 */     GIR_RootConstrainSelectedInstOperands,
     /*  94111 */     // GIR_Coverage, 448,
     /*  94111 */     GIR_EraseRootFromParent_Done,
     /*  94112 */   // Label 1713: @94112
     /*  94112 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(94170), // Rule ID 449 //
     /*  94117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  94125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94146 */     // (intrinsic_w_chain:{ *:[i32] } 3903:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  94149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94168 */     GIR_RootConstrainSelectedInstOperands,
     /*  94169 */     // GIR_Coverage, 449,
     /*  94169 */     GIR_EraseRootFromParent_Done,
     /*  94170 */   // Label 1714: @94170
     /*  94170 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(94228), // Rule ID 450 //
     /*  94175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  94183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94204 */     // (intrinsic_w_chain:{ *:[i32] } 3916:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  94207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94226 */     GIR_RootConstrainSelectedInstOperands,
     /*  94227 */     // GIR_Coverage, 450,
     /*  94227 */     GIR_EraseRootFromParent_Done,
     /*  94228 */   // Label 1715: @94228
     /*  94228 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(94286), // Rule ID 451 //
     /*  94233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  94241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94262 */     // (intrinsic_w_chain:{ *:[i32] } 3914:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  94265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94284 */     GIR_RootConstrainSelectedInstOperands,
     /*  94285 */     // GIR_Coverage, 451,
     /*  94285 */     GIR_EraseRootFromParent_Done,
     /*  94286 */   // Label 1716: @94286
     /*  94286 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(94344), // Rule ID 452 //
     /*  94291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  94299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94320 */     // (intrinsic_w_chain:{ *:[i32] } 3915:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  94323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94342 */     GIR_RootConstrainSelectedInstOperands,
     /*  94343 */     // GIR_Coverage, 452,
     /*  94343 */     GIR_EraseRootFromParent_Done,
     /*  94344 */   // Label 1717: @94344
     /*  94344 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94402), // Rule ID 453 //
     /*  94349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  94357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94378 */     // (intrinsic_w_chain:{ *:[i32] } 3934:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  94381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94400 */     GIR_RootConstrainSelectedInstOperands,
     /*  94401 */     // GIR_Coverage, 453,
     /*  94401 */     GIR_EraseRootFromParent_Done,
     /*  94402 */   // Label 1718: @94402
     /*  94402 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(94460), // Rule ID 454 //
     /*  94407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  94415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94436 */     // (intrinsic_w_chain:{ *:[i32] } 3935:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  94439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94458 */     GIR_RootConstrainSelectedInstOperands,
     /*  94459 */     // GIR_Coverage, 454,
     /*  94459 */     GIR_EraseRootFromParent_Done,
     /*  94460 */   // Label 1719: @94460
     /*  94460 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94518), // Rule ID 455 //
     /*  94465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  94473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94494 */     // (intrinsic_w_chain:{ *:[i32] } 3936:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  94497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94516 */     GIR_RootConstrainSelectedInstOperands,
     /*  94517 */     // GIR_Coverage, 455,
     /*  94517 */     GIR_EraseRootFromParent_Done,
     /*  94518 */   // Label 1720: @94518
     /*  94518 */   GIM_Reject,
     /*  94519 */ // Label 1685: @94519
     /*  94519 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94765),
     /*  94524 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  94527 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  94532 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(94590), // Rule ID 5055 //
     /*  94537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94565 */     // MIs[1] Operand 1
     /*  94565 */     // No operand predicates
     /*  94565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94571 */     // (intrinsic_w_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94576 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94578 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94588 */     GIR_RootConstrainSelectedInstOperands,
     /*  94589 */     // GIR_Coverage, 5055,
     /*  94589 */     GIR_EraseRootFromParent_Done,
     /*  94590 */   // Label 1722: @94590
     /*  94590 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(94648), // Rule ID 5065 //
     /*  94595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94623 */     // MIs[1] Operand 1
     /*  94623 */     // No operand predicates
     /*  94623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94629 */     // (intrinsic_w_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94634 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94636 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94646 */     GIR_RootConstrainSelectedInstOperands,
     /*  94647 */     // GIR_Coverage, 5065,
     /*  94647 */     GIR_EraseRootFromParent_Done,
     /*  94648 */   // Label 1723: @94648
     /*  94648 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(94706), // Rule ID 5069 //
     /*  94653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94681 */     // MIs[1] Operand 1
     /*  94681 */     // No operand predicates
     /*  94681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94687 */     // (intrinsic_w_chain:{ *:[v2i64] } 3707:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94692 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94694 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94704 */     GIR_RootConstrainSelectedInstOperands,
     /*  94705 */     // GIR_Coverage, 5069,
     /*  94705 */     GIR_EraseRootFromParent_Done,
     /*  94706 */   // Label 1724: @94706
     /*  94706 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(94764), // Rule ID 5073 //
     /*  94711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94739 */     // MIs[1] Operand 1
     /*  94739 */     // No operand predicates
     /*  94739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94745 */     // (intrinsic_w_chain:{ *:[v2i64] } 3707:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94750 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94752 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94762 */     GIR_RootConstrainSelectedInstOperands,
     /*  94763 */     // GIR_Coverage, 5073,
     /*  94763 */     GIR_EraseRootFromParent_Done,
     /*  94764 */   // Label 1725: @94764
     /*  94764 */   GIM_Reject,
     /*  94765 */ // Label 1721: @94765
     /*  94765 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(95936),
     /*  94770 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94773 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(94834), // Rule ID 4943 //
     /*  94778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94795 */     // MIs[0] base
     /*  94795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94819 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94822 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94824 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94826 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94832 */     GIR_RootConstrainSelectedInstOperands,
     /*  94833 */     // GIR_Coverage, 4943,
     /*  94833 */     GIR_EraseRootFromParent_Done,
     /*  94834 */   // Label 1727: @94834
     /*  94834 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(94895), // Rule ID 4944 //
     /*  94839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94856 */     // MIs[0] base
     /*  94856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94880 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94883 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94885 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94887 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94893 */     GIR_RootConstrainSelectedInstOperands,
     /*  94894 */     // GIR_Coverage, 4944,
     /*  94894 */     GIR_EraseRootFromParent_Done,
     /*  94895 */   // Label 1728: @94895
     /*  94895 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(94956), // Rule ID 4947 //
     /*  94900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94917 */     // MIs[0] base
     /*  94917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94941 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94944 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94946 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94948 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94954 */     GIR_RootConstrainSelectedInstOperands,
     /*  94955 */     // GIR_Coverage, 4947,
     /*  94955 */     GIR_EraseRootFromParent_Done,
     /*  94956 */   // Label 1729: @94956
     /*  94956 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(95017), // Rule ID 5027 //
     /*  94961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94978 */     // MIs[0] base
     /*  94978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95002 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  95005 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95007 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95009 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95015 */     GIR_RootConstrainSelectedInstOperands,
     /*  95016 */     // GIR_Coverage, 5027,
     /*  95016 */     GIR_EraseRootFromParent_Done,
     /*  95017 */   // Label 1730: @95017
     /*  95017 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(95078), // Rule ID 5029 //
     /*  95022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95039 */     // MIs[0] base
     /*  95039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95063 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  95066 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95068 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95070 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95076 */     GIR_RootConstrainSelectedInstOperands,
     /*  95077 */     // GIR_Coverage, 5029,
     /*  95077 */     GIR_EraseRootFromParent_Done,
     /*  95078 */   // Label 1731: @95078
     /*  95078 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(95139), // Rule ID 5031 //
     /*  95083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  95091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95100 */     // MIs[0] base
     /*  95100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95124 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  95127 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95129 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95131 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95137 */     GIR_RootConstrainSelectedInstOperands,
     /*  95138 */     // GIR_Coverage, 5031,
     /*  95138 */     GIR_EraseRootFromParent_Done,
     /*  95139 */   // Label 1732: @95139
     /*  95139 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(95200), // Rule ID 5032 //
     /*  95144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  95152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95161 */     // MIs[0] base
     /*  95161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95185 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  95188 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95190 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95192 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95198 */     GIR_RootConstrainSelectedInstOperands,
     /*  95199 */     // GIR_Coverage, 5032,
     /*  95199 */     GIR_EraseRootFromParent_Done,
     /*  95200 */   // Label 1733: @95200
     /*  95200 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(95261), // Rule ID 5035 //
     /*  95205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95222 */     // MIs[0] base
     /*  95222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95246 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  95249 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95251 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95253 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95259 */     GIR_RootConstrainSelectedInstOperands,
     /*  95260 */     // GIR_Coverage, 5035,
     /*  95260 */     GIR_EraseRootFromParent_Done,
     /*  95261 */   // Label 1734: @95261
     /*  95261 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(95322), // Rule ID 5036 //
     /*  95266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95283 */     // MIs[0] base
     /*  95283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95307 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  95310 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95312 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95314 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95320 */     GIR_RootConstrainSelectedInstOperands,
     /*  95321 */     // GIR_Coverage, 5036,
     /*  95321 */     GIR_EraseRootFromParent_Done,
     /*  95322 */   // Label 1735: @95322
     /*  95322 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(95383), // Rule ID 5039 //
     /*  95327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95344 */     // MIs[0] base
     /*  95344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95368 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95371 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95373 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95375 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95381 */     GIR_RootConstrainSelectedInstOperands,
     /*  95382 */     // GIR_Coverage, 5039,
     /*  95382 */     GIR_EraseRootFromParent_Done,
     /*  95383 */   // Label 1736: @95383
     /*  95383 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(95444), // Rule ID 5040 //
     /*  95388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95405 */     // MIs[0] base
     /*  95405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95429 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95432 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95434 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95436 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95442 */     GIR_RootConstrainSelectedInstOperands,
     /*  95443 */     // GIR_Coverage, 5040,
     /*  95443 */     GIR_EraseRootFromParent_Done,
     /*  95444 */   // Label 1737: @95444
     /*  95444 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95505), // Rule ID 5043 //
     /*  95449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95466 */     // MIs[0] base
     /*  95466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95490 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95493 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95495 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95497 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95503 */     GIR_RootConstrainSelectedInstOperands,
     /*  95504 */     // GIR_Coverage, 5043,
     /*  95504 */     GIR_EraseRootFromParent_Done,
     /*  95505 */   // Label 1738: @95505
     /*  95505 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95566), // Rule ID 5044 //
     /*  95510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95527 */     // MIs[0] base
     /*  95527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95551 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95554 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95556 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95558 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95564 */     GIR_RootConstrainSelectedInstOperands,
     /*  95565 */     // GIR_Coverage, 5044,
     /*  95565 */     GIR_EraseRootFromParent_Done,
     /*  95566 */   // Label 1739: @95566
     /*  95566 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(95627), // Rule ID 5047 //
     /*  95571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95588 */     // MIs[0] base
     /*  95588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95612 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  95615 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95617 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95619 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95625 */     GIR_RootConstrainSelectedInstOperands,
     /*  95626 */     // GIR_Coverage, 5047,
     /*  95626 */     GIR_EraseRootFromParent_Done,
     /*  95627 */   // Label 1740: @95627
     /*  95627 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(95688), // Rule ID 5048 //
     /*  95632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95649 */     // MIs[0] base
     /*  95649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95673 */     // (intrinsic_void 3709:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95676 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95678 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95680 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95686 */     GIR_RootConstrainSelectedInstOperands,
     /*  95687 */     // GIR_Coverage, 5048,
     /*  95687 */     GIR_EraseRootFromParent_Done,
     /*  95688 */   // Label 1741: @95688
     /*  95688 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(95752), // Rule ID 258 //
     /*  95693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95707 */     // MIs[0] cop
     /*  95707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95710 */     // MIs[0] opc1
     /*  95710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95721 */     // MIs[0] CRm
     /*  95721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95724 */     // (intrinsic_void 3513:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95727 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95729 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95735 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95750 */     GIR_RootConstrainSelectedInstOperands,
     /*  95751 */     // GIR_Coverage, 258,
     /*  95751 */     GIR_EraseRootFromParent_Done,
     /*  95752 */   // Label 1742: @95752
     /*  95752 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(95807), // Rule ID 259 //
     /*  95757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95771 */     // MIs[0] cop
     /*  95771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95774 */     // MIs[0] opc1
     /*  95774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95785 */     // MIs[0] CRm
     /*  95785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95788 */     // (intrinsic_void 3514:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95791 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95793 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95799 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95805 */     GIR_RootConstrainSelectedInstOperands,
     /*  95806 */     // GIR_Coverage, 259,
     /*  95806 */     GIR_EraseRootFromParent_Done,
     /*  95807 */   // Label 1743: @95807
     /*  95807 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(95871), // Rule ID 596 //
     /*  95812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95826 */     // MIs[0] cop
     /*  95826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95829 */     // MIs[0] opc1
     /*  95829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95840 */     // MIs[0] CRm
     /*  95840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95843 */     // (intrinsic_void 3513:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95846 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95848 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95854 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95869 */     GIR_RootConstrainSelectedInstOperands,
     /*  95870 */     // GIR_Coverage, 596,
     /*  95870 */     GIR_EraseRootFromParent_Done,
     /*  95871 */   // Label 1744: @95871
     /*  95871 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(95935), // Rule ID 597 //
     /*  95876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95890 */     // MIs[0] cop
     /*  95890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95893 */     // MIs[0] opc1
     /*  95893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95904 */     // MIs[0] CRm
     /*  95904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95907 */     // (intrinsic_void 3514:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95910 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95912 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95918 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95933 */     GIR_RootConstrainSelectedInstOperands,
     /*  95934 */     // GIR_Coverage, 597,
     /*  95934 */     GIR_EraseRootFromParent_Done,
     /*  95935 */   // Label 1745: @95935
     /*  95935 */   GIM_Reject,
     /*  95936 */ // Label 1726: @95936
     /*  95936 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(99287),
     /*  95941 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95944 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(96005), // Rule ID 246 //
     /*  95949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95957 */     // MIs[0] cop
     /*  95957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95960 */     // MIs[0] opc1
     /*  95960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95963 */     // MIs[0] CRd
     /*  95963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95966 */     // MIs[0] CRn
     /*  95966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95969 */     // MIs[0] CRm
     /*  95969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95972 */     // MIs[0] opc2
     /*  95972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95975 */     // (intrinsic_void 3481:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95978 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95980 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95982 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95984 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95986 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95988 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96003 */     GIR_RootConstrainSelectedInstOperands,
     /*  96004 */     // GIR_Coverage, 246,
     /*  96004 */     GIR_EraseRootFromParent_Done,
     /*  96005 */   // Label 1747: @96005
     /*  96005 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(96057), // Rule ID 247 //
     /*  96010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  96013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  96018 */     // MIs[0] cop
     /*  96018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  96021 */     // MIs[0] opc1
     /*  96021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  96024 */     // MIs[0] CRd
     /*  96024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  96027 */     // MIs[0] CRn
     /*  96027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96030 */     // MIs[0] CRm
     /*  96030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  96033 */     // MIs[0] opc2
     /*  96033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  96036 */     // (intrinsic_void 3482:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  96036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  96039 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  96041 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  96043 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  96045 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  96047 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  96049 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  96051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96055 */     GIR_RootConstrainSelectedInstOperands,
     /*  96056 */     // GIR_Coverage, 247,
     /*  96056 */     GIR_EraseRootFromParent_Done,
     /*  96057 */   // Label 1748: @96057
     /*  96057 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(96118), // Rule ID 598 //
     /*  96062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  96065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  96070 */     // MIs[0] cop
     /*  96070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  96073 */     // MIs[0] opc1
     /*  96073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  96076 */     // MIs[0] CRd
     /*  96076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  96079 */     // MIs[0] CRn
     /*  96079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96082 */     // MIs[0] CRm
     /*  96082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  96085 */     // MIs[0] opc2
     /*  96085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  96088 */     // (intrinsic_void 3481:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  96088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  96091 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  96093 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  96095 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  96097 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  96099 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  96101 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  96103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  96106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  96112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96116 */     GIR_RootConstrainSelectedInstOperands,
     /*  96117 */     // GIR_Coverage, 598,
     /*  96117 */     GIR_EraseRootFromParent_Done,
     /*  96118 */   // Label 1749: @96118
     /*  96118 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(96179), // Rule ID 599 //
     /*  96123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  96126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  96131 */     // MIs[0] cop
     /*  96131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  96134 */     // MIs[0] opc1
     /*  96134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  96137 */     // MIs[0] CRd
     /*  96137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  96140 */     // MIs[0] CRn
     /*  96140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96143 */     // MIs[0] CRm
     /*  96143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  96146 */     // MIs[0] opc2
     /*  96146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  96149 */     // (intrinsic_void 3482:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  96149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  96152 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  96154 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  96156 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  96158 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  96160 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  96162 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  96164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  96167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  96173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96177 */     GIR_RootConstrainSelectedInstOperands,
     /*  96178 */     // GIR_Coverage, 599,
     /*  96178 */     GIR_EraseRootFromParent_Done,
     /*  96179 */   // Label 1750: @96179
     /*  96179 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(96247), // Rule ID 4937 //
     /*  96184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96208 */     // MIs[0] base
     /*  96208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96232 */     // (intrinsic_w_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96237 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96239 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96245 */     GIR_RootConstrainSelectedInstOperands,
     /*  96246 */     // GIR_Coverage, 4937,
     /*  96246 */     GIR_EraseRootFromParent_Done,
     /*  96247 */   // Label 1751: @96247
     /*  96247 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(96315), // Rule ID 4938 //
     /*  96252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96276 */     // MIs[0] base
     /*  96276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96300 */     // (intrinsic_w_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96305 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96307 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96313 */     GIR_RootConstrainSelectedInstOperands,
     /*  96314 */     // GIR_Coverage, 4938,
     /*  96314 */     GIR_EraseRootFromParent_Done,
     /*  96315 */   // Label 1752: @96315
     /*  96315 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96383), // Rule ID 4941 //
     /*  96320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96344 */     // MIs[0] base
     /*  96344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96368 */     // (intrinsic_w_chain:{ *:[v16i8] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96373 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96375 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96381 */     GIR_RootConstrainSelectedInstOperands,
     /*  96382 */     // GIR_Coverage, 4941,
     /*  96382 */     GIR_EraseRootFromParent_Done,
     /*  96383 */   // Label 1753: @96383
     /*  96383 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96451), // Rule ID 4949 //
     /*  96388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96412 */     // MIs[0] base
     /*  96412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96436 */     // (intrinsic_w_chain:{ *:[v16i8] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96441 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96443 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96449 */     GIR_RootConstrainSelectedInstOperands,
     /*  96450 */     // GIR_Coverage, 4949,
     /*  96450 */     GIR_EraseRootFromParent_Done,
     /*  96451 */   // Label 1754: @96451
     /*  96451 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96519), // Rule ID 4951 //
     /*  96456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96480 */     // MIs[0] base
     /*  96480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96504 */     // (intrinsic_w_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  96507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96509 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96511 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96517 */     GIR_RootConstrainSelectedInstOperands,
     /*  96518 */     // GIR_Coverage, 4951,
     /*  96518 */     GIR_EraseRootFromParent_Done,
     /*  96519 */   // Label 1755: @96519
     /*  96519 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96587), // Rule ID 4953 //
     /*  96524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96548 */     // MIs[0] base
     /*  96548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96572 */     // (intrinsic_w_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  96575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96577 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96579 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96585 */     GIR_RootConstrainSelectedInstOperands,
     /*  96586 */     // GIR_Coverage, 4953,
     /*  96586 */     GIR_EraseRootFromParent_Done,
     /*  96587 */   // Label 1756: @96587
     /*  96587 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96655), // Rule ID 4955 //
     /*  96592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96616 */     // MIs[0] base
     /*  96616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96640 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96645 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96647 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96653 */     GIR_RootConstrainSelectedInstOperands,
     /*  96654 */     // GIR_Coverage, 4955,
     /*  96654 */     GIR_EraseRootFromParent_Done,
     /*  96655 */   // Label 1757: @96655
     /*  96655 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(96723), // Rule ID 4957 //
     /*  96660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96684 */     // MIs[0] base
     /*  96684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96708 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96713 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96715 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96721 */     GIR_RootConstrainSelectedInstOperands,
     /*  96722 */     // GIR_Coverage, 4957,
     /*  96722 */     GIR_EraseRootFromParent_Done,
     /*  96723 */   // Label 1758: @96723
     /*  96723 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(96791), // Rule ID 4959 //
     /*  96728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96752 */     // MIs[0] base
     /*  96752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96776 */     // (intrinsic_w_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96781 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96783 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96789 */     GIR_RootConstrainSelectedInstOperands,
     /*  96790 */     // GIR_Coverage, 4959,
     /*  96790 */     GIR_EraseRootFromParent_Done,
     /*  96791 */   // Label 1759: @96791
     /*  96791 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(96859), // Rule ID 4960 //
     /*  96796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96820 */     // MIs[0] base
     /*  96820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96844 */     // (intrinsic_w_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96849 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96851 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96857 */     GIR_RootConstrainSelectedInstOperands,
     /*  96858 */     // GIR_Coverage, 4960,
     /*  96858 */     GIR_EraseRootFromParent_Done,
     /*  96859 */   // Label 1760: @96859
     /*  96859 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(96927), // Rule ID 4963 //
     /*  96864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96888 */     // MIs[0] base
     /*  96888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96912 */     // (intrinsic_w_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96917 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96919 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96925 */     GIR_RootConstrainSelectedInstOperands,
     /*  96926 */     // GIR_Coverage, 4963,
     /*  96926 */     GIR_EraseRootFromParent_Done,
     /*  96927 */   // Label 1761: @96927
     /*  96927 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(96995), // Rule ID 4964 //
     /*  96932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96956 */     // MIs[0] base
     /*  96956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96980 */     // (intrinsic_w_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96985 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96987 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96993 */     GIR_RootConstrainSelectedInstOperands,
     /*  96994 */     // GIR_Coverage, 4964,
     /*  96994 */     GIR_EraseRootFromParent_Done,
     /*  96995 */   // Label 1762: @96995
     /*  96995 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97063), // Rule ID 4967 //
     /*  97000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97024 */     // MIs[0] base
     /*  97024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97048 */     // (intrinsic_w_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97053 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97055 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97061 */     GIR_RootConstrainSelectedInstOperands,
     /*  97062 */     // GIR_Coverage, 4967,
     /*  97062 */     GIR_EraseRootFromParent_Done,
     /*  97063 */   // Label 1763: @97063
     /*  97063 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97131), // Rule ID 4968 //
     /*  97068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97092 */     // MIs[0] base
     /*  97092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97116 */     // (intrinsic_w_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97121 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97123 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97129 */     GIR_RootConstrainSelectedInstOperands,
     /*  97130 */     // GIR_Coverage, 4968,
     /*  97130 */     GIR_EraseRootFromParent_Done,
     /*  97131 */   // Label 1764: @97131
     /*  97131 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(97199), // Rule ID 4971 //
     /*  97136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97160 */     // MIs[0] base
     /*  97160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97184 */     // (intrinsic_w_chain:{ *:[v8f16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97189 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97191 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97197 */     GIR_RootConstrainSelectedInstOperands,
     /*  97198 */     // GIR_Coverage, 4971,
     /*  97198 */     GIR_EraseRootFromParent_Done,
     /*  97199 */   // Label 1765: @97199
     /*  97199 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97267), // Rule ID 4972 //
     /*  97204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97228 */     // MIs[0] base
     /*  97228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97252 */     // (intrinsic_w_chain:{ *:[v8f16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97257 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97259 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97265 */     GIR_RootConstrainSelectedInstOperands,
     /*  97266 */     // GIR_Coverage, 4972,
     /*  97266 */     GIR_EraseRootFromParent_Done,
     /*  97267 */   // Label 1766: @97267
     /*  97267 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(97335), // Rule ID 4975 //
     /*  97272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97296 */     // MIs[0] base
     /*  97296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97320 */     // (intrinsic_w_chain:{ *:[v8f16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97325 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97327 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97333 */     GIR_RootConstrainSelectedInstOperands,
     /*  97334 */     // GIR_Coverage, 4975,
     /*  97334 */     GIR_EraseRootFromParent_Done,
     /*  97335 */   // Label 1767: @97335
     /*  97335 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(97403), // Rule ID 4976 //
     /*  97340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97364 */     // MIs[0] base
     /*  97364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97388 */     // (intrinsic_w_chain:{ *:[v8f16] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97393 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97395 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97401 */     GIR_RootConstrainSelectedInstOperands,
     /*  97402 */     // GIR_Coverage, 4976,
     /*  97402 */     GIR_EraseRootFromParent_Done,
     /*  97403 */   // Label 1768: @97403
     /*  97403 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(97471), // Rule ID 4979 //
     /*  97408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97432 */     // MIs[0] base
     /*  97432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97456 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  97459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97461 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97463 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97469 */     GIR_RootConstrainSelectedInstOperands,
     /*  97470 */     // GIR_Coverage, 4979,
     /*  97470 */     GIR_EraseRootFromParent_Done,
     /*  97471 */   // Label 1769: @97471
     /*  97471 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(97539), // Rule ID 4980 //
     /*  97476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97500 */     // MIs[0] base
     /*  97500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97524 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  97527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97529 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97531 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97537 */     GIR_RootConstrainSelectedInstOperands,
     /*  97538 */     // GIR_Coverage, 4980,
     /*  97538 */     GIR_EraseRootFromParent_Done,
     /*  97539 */   // Label 1770: @97539
     /*  97539 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(97607), // Rule ID 4983 //
     /*  97544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97568 */     // MIs[0] base
     /*  97568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97592 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  97595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97597 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97599 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97605 */     GIR_RootConstrainSelectedInstOperands,
     /*  97606 */     // GIR_Coverage, 4983,
     /*  97606 */     GIR_EraseRootFromParent_Done,
     /*  97607 */   // Label 1771: @97607
     /*  97607 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(97675), // Rule ID 4984 //
     /*  97612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97636 */     // MIs[0] base
     /*  97636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97660 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97665 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97667 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97673 */     GIR_RootConstrainSelectedInstOperands,
     /*  97674 */     // GIR_Coverage, 4984,
     /*  97674 */     GIR_EraseRootFromParent_Done,
     /*  97675 */   // Label 1772: @97675
     /*  97675 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(97743), // Rule ID 4987 //
     /*  97680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97704 */     // MIs[0] base
     /*  97704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97728 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97733 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97735 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97741 */     GIR_RootConstrainSelectedInstOperands,
     /*  97742 */     // GIR_Coverage, 4987,
     /*  97742 */     GIR_EraseRootFromParent_Done,
     /*  97743 */   // Label 1773: @97743
     /*  97743 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97811), // Rule ID 4988 //
     /*  97748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97772 */     // MIs[0] base
     /*  97772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97796 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97801 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97803 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97809 */     GIR_RootConstrainSelectedInstOperands,
     /*  97810 */     // GIR_Coverage, 4988,
     /*  97810 */     GIR_EraseRootFromParent_Done,
     /*  97811 */   // Label 1774: @97811
     /*  97811 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(97879), // Rule ID 4991 //
     /*  97816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97840 */     // MIs[0] base
     /*  97840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97864 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97869 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97871 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97877 */     GIR_RootConstrainSelectedInstOperands,
     /*  97878 */     // GIR_Coverage, 4991,
     /*  97878 */     GIR_EraseRootFromParent_Done,
     /*  97879 */   // Label 1775: @97879
     /*  97879 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(97947), // Rule ID 4992 //
     /*  97884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97908 */     // MIs[0] base
     /*  97908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97932 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97937 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97939 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97945 */     GIR_RootConstrainSelectedInstOperands,
     /*  97946 */     // GIR_Coverage, 4992,
     /*  97946 */     GIR_EraseRootFromParent_Done,
     /*  97947 */   // Label 1776: @97947
     /*  97947 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(98015), // Rule ID 4995 //
     /*  97952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97976 */     // MIs[0] base
     /*  97976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98000 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98005 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98007 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98013 */     GIR_RootConstrainSelectedInstOperands,
     /*  98014 */     // GIR_Coverage, 4995,
     /*  98014 */     GIR_EraseRootFromParent_Done,
     /*  98015 */   // Label 1777: @98015
     /*  98015 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(98083), // Rule ID 4996 //
     /*  98020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98044 */     // MIs[0] base
     /*  98044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98068 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98073 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98075 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98081 */     GIR_RootConstrainSelectedInstOperands,
     /*  98082 */     // GIR_Coverage, 4996,
     /*  98082 */     GIR_EraseRootFromParent_Done,
     /*  98083 */   // Label 1778: @98083
     /*  98083 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(98151), // Rule ID 4999 //
     /*  98088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98112 */     // MIs[0] base
     /*  98112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98136 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98141 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98143 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98149 */     GIR_RootConstrainSelectedInstOperands,
     /*  98150 */     // GIR_Coverage, 4999,
     /*  98150 */     GIR_EraseRootFromParent_Done,
     /*  98151 */   // Label 1779: @98151
     /*  98151 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98219), // Rule ID 5000 //
     /*  98156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98180 */     // MIs[0] base
     /*  98180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98204 */     // (intrinsic_w_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98209 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98211 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98217 */     GIR_RootConstrainSelectedInstOperands,
     /*  98218 */     // GIR_Coverage, 5000,
     /*  98218 */     GIR_EraseRootFromParent_Done,
     /*  98219 */   // Label 1780: @98219
     /*  98219 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98287), // Rule ID 5003 //
     /*  98224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98248 */     // MIs[0] base
     /*  98248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98272 */     // (intrinsic_w_chain:{ *:[v4f32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98277 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98279 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98285 */     GIR_RootConstrainSelectedInstOperands,
     /*  98286 */     // GIR_Coverage, 5003,
     /*  98286 */     GIR_EraseRootFromParent_Done,
     /*  98287 */   // Label 1781: @98287
     /*  98287 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98355), // Rule ID 5004 //
     /*  98292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98316 */     // MIs[0] base
     /*  98316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98340 */     // (intrinsic_w_chain:{ *:[v4f32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98345 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98347 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98353 */     GIR_RootConstrainSelectedInstOperands,
     /*  98354 */     // GIR_Coverage, 5004,
     /*  98354 */     GIR_EraseRootFromParent_Done,
     /*  98355 */   // Label 1782: @98355
     /*  98355 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98423), // Rule ID 5007 //
     /*  98360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98384 */     // MIs[0] base
     /*  98384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98408 */     // (intrinsic_w_chain:{ *:[v4f32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98413 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98415 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98421 */     GIR_RootConstrainSelectedInstOperands,
     /*  98422 */     // GIR_Coverage, 5007,
     /*  98422 */     GIR_EraseRootFromParent_Done,
     /*  98423 */   // Label 1783: @98423
     /*  98423 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98491), // Rule ID 5008 //
     /*  98428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98452 */     // MIs[0] base
     /*  98452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98476 */     // (intrinsic_w_chain:{ *:[v4f32] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98481 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98483 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98489 */     GIR_RootConstrainSelectedInstOperands,
     /*  98490 */     // GIR_Coverage, 5008,
     /*  98490 */     GIR_EraseRootFromParent_Done,
     /*  98491 */   // Label 1784: @98491
     /*  98491 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(98559), // Rule ID 5011 //
     /*  98496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98520 */     // MIs[0] base
     /*  98520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98544 */     // (intrinsic_w_chain:{ *:[v2i64] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98549 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98551 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98557 */     GIR_RootConstrainSelectedInstOperands,
     /*  98558 */     // GIR_Coverage, 5011,
     /*  98558 */     GIR_EraseRootFromParent_Done,
     /*  98559 */   // Label 1785: @98559
     /*  98559 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98627), // Rule ID 5012 //
     /*  98564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98588 */     // MIs[0] base
     /*  98588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98612 */     // (intrinsic_w_chain:{ *:[v2i64] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98617 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98619 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98625 */     GIR_RootConstrainSelectedInstOperands,
     /*  98626 */     // GIR_Coverage, 5012,
     /*  98626 */     GIR_EraseRootFromParent_Done,
     /*  98627 */   // Label 1786: @98627
     /*  98627 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(98695), // Rule ID 5015 //
     /*  98632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98656 */     // MIs[0] base
     /*  98656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98680 */     // (intrinsic_w_chain:{ *:[v2i64] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98685 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98687 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98693 */     GIR_RootConstrainSelectedInstOperands,
     /*  98694 */     // GIR_Coverage, 5015,
     /*  98694 */     GIR_EraseRootFromParent_Done,
     /*  98695 */   // Label 1787: @98695
     /*  98695 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98763), // Rule ID 5016 //
     /*  98700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98724 */     // MIs[0] base
     /*  98724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98748 */     // (intrinsic_w_chain:{ *:[v2i64] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98753 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98755 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98761 */     GIR_RootConstrainSelectedInstOperands,
     /*  98762 */     // GIR_Coverage, 5016,
     /*  98762 */     GIR_EraseRootFromParent_Done,
     /*  98763 */   // Label 1788: @98763
     /*  98763 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(98831), // Rule ID 5019 //
     /*  98768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98792 */     // MIs[0] base
     /*  98792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98816 */     // (intrinsic_w_chain:{ *:[v2i64] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98821 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98823 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98829 */     GIR_RootConstrainSelectedInstOperands,
     /*  98830 */     // GIR_Coverage, 5019,
     /*  98830 */     GIR_EraseRootFromParent_Done,
     /*  98831 */   // Label 1789: @98831
     /*  98831 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(98899), // Rule ID 5020 //
     /*  98836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98860 */     // MIs[0] base
     /*  98860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98884 */     // (intrinsic_w_chain:{ *:[v2i64] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98889 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98891 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98897 */     GIR_RootConstrainSelectedInstOperands,
     /*  98898 */     // GIR_Coverage, 5020,
     /*  98898 */     GIR_EraseRootFromParent_Done,
     /*  98899 */   // Label 1790: @98899
     /*  98899 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(98967), // Rule ID 5023 //
     /*  98904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98928 */     // MIs[0] base
     /*  98928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98952 */     // (intrinsic_w_chain:{ *:[v2i64] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98957 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98959 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98965 */     GIR_RootConstrainSelectedInstOperands,
     /*  98966 */     // GIR_Coverage, 5023,
     /*  98966 */     GIR_EraseRootFromParent_Done,
     /*  98967 */   // Label 1791: @98967
     /*  98967 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(99035), // Rule ID 5024 //
     /*  98972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98996 */     // MIs[0] base
     /*  98996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  99000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  99008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  99012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  99016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  99020 */     // (intrinsic_w_chain:{ *:[v2i64] } 3636:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  99020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  99023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  99025 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  99027 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  99029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99033 */     GIR_RootConstrainSelectedInstOperands,
     /*  99034 */     // GIR_Coverage, 5024,
     /*  99034 */     GIR_EraseRootFromParent_Done,
     /*  99035 */   // Label 1792: @99035
     /*  99035 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(99100), // Rule ID 256 //
     /*  99040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  99048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99051 */     // MIs[0] cop
     /*  99051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99054 */     // MIs[0] opc1
     /*  99054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99061 */     // MIs[0] CRn
     /*  99061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99064 */     // MIs[0] CRm
     /*  99064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99067 */     // MIs[0] opc2
     /*  99067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99070 */     // (intrinsic_void 3511:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  99073 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99075 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99079 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99081 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99083 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99098 */     GIR_RootConstrainSelectedInstOperands,
     /*  99099 */     // GIR_Coverage, 256,
     /*  99099 */     GIR_EraseRootFromParent_Done,
     /*  99100 */   // Label 1793: @99100
     /*  99100 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(99156), // Rule ID 257 //
     /*  99105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  99108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  99113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99116 */     // MIs[0] cop
     /*  99116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99119 */     // MIs[0] opc1
     /*  99119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99126 */     // MIs[0] CRn
     /*  99126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99129 */     // MIs[0] CRm
     /*  99129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99132 */     // MIs[0] opc2
     /*  99132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99135 */     // (intrinsic_void 3512:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  99138 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99140 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99144 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99146 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99148 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99154 */     GIR_RootConstrainSelectedInstOperands,
     /*  99155 */     // GIR_Coverage, 257,
     /*  99155 */     GIR_EraseRootFromParent_Done,
     /*  99156 */   // Label 1794: @99156
     /*  99156 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(99221), // Rule ID 594 //
     /*  99161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  99169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99172 */     // MIs[0] cop
     /*  99172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99175 */     // MIs[0] opc1
     /*  99175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99182 */     // MIs[0] CRn
     /*  99182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99185 */     // MIs[0] CRm
     /*  99185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99188 */     // MIs[0] opc2
     /*  99188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99191 */     // (intrinsic_void 3511:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  99194 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99196 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99200 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99202 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99204 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99219 */     GIR_RootConstrainSelectedInstOperands,
     /*  99220 */     // GIR_Coverage, 594,
     /*  99220 */     GIR_EraseRootFromParent_Done,
     /*  99221 */   // Label 1795: @99221
     /*  99221 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(99286), // Rule ID 595 //
     /*  99226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  99229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  99234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99237 */     // MIs[0] cop
     /*  99237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99240 */     // MIs[0] opc1
     /*  99240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99247 */     // MIs[0] CRn
     /*  99247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99250 */     // MIs[0] CRm
     /*  99250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99253 */     // MIs[0] opc2
     /*  99253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99256 */     // (intrinsic_void 3512:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  99259 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99261 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99265 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99267 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99269 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99284 */     GIR_RootConstrainSelectedInstOperands,
     /*  99285 */     // GIR_Coverage, 595,
     /*  99285 */     GIR_EraseRootFromParent_Done,
     /*  99286 */   // Label 1796: @99286
     /*  99286 */   GIM_Reject,
     /*  99287 */ // Label 1746: @99287
     /*  99287 */ GIM_Reject,
     /*  99288 */ // Label 17: @99288
     /*  99288 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1800*/ GIMT_Encode4(99445),
     /*  99299 */ /*GILLT_v2s64*//*Label 1797*/ GIMT_Encode4(99331), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99311 */ /*GILLT_v4s32*//*Label 1798*/ GIMT_Encode4(99369), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99327 */ /*GILLT_v8s16*//*Label 1799*/ GIMT_Encode4(99407),
     /*  99331 */ // Label 1797: @99331
     /*  99331 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(99368), // Rule ID 2668 //
     /*  99336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99350 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  99353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99355 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99360 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99366 */   GIR_RootConstrainSelectedInstOperands,
     /*  99367 */   // GIR_Coverage, 2668,
     /*  99367 */   GIR_EraseRootFromParent_Done,
     /*  99368 */ // Label 1801: @99368
     /*  99368 */ GIM_Reject,
     /*  99369 */ // Label 1798: @99369
     /*  99369 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(99406), // Rule ID 2667 //
     /*  99374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99388 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  99391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99393 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99398 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99404 */   GIR_RootConstrainSelectedInstOperands,
     /*  99405 */   // GIR_Coverage, 2667,
     /*  99405 */   GIR_EraseRootFromParent_Done,
     /*  99406 */ // Label 1802: @99406
     /*  99406 */ GIM_Reject,
     /*  99407 */ // Label 1799: @99407
     /*  99407 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(99444), // Rule ID 2666 //
     /*  99412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99426 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  99429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99431 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99436 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99442 */   GIR_RootConstrainSelectedInstOperands,
     /*  99443 */   // GIR_Coverage, 2666,
     /*  99443 */   GIR_EraseRootFromParent_Done,
     /*  99444 */ // Label 1803: @99444
     /*  99444 */ GIM_Reject,
     /*  99445 */ // Label 1800: @99445
     /*  99445 */ GIM_Reject,
     /*  99446 */ // Label 18: @99446
     /*  99446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1807*/ GIMT_Encode4(99603),
     /*  99457 */ /*GILLT_v2s32*//*Label 1804*/ GIMT_Encode4(99489), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99469 */ /*GILLT_v4s16*//*Label 1805*/ GIMT_Encode4(99527), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99485 */ /*GILLT_v8s8*//*Label 1806*/ GIMT_Encode4(99565),
     /*  99489 */ // Label 1804: @99489
     /*  99489 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99526), // Rule ID 1588 //
     /*  99494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99508 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  99508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  99511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99513 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99518 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99524 */   GIR_RootConstrainSelectedInstOperands,
     /*  99525 */   // GIR_Coverage, 1588,
     /*  99525 */   GIR_EraseRootFromParent_Done,
     /*  99526 */ // Label 1808: @99526
     /*  99526 */ GIM_Reject,
     /*  99527 */ // Label 1805: @99527
     /*  99527 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99564), // Rule ID 1587 //
     /*  99532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99546 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  99546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  99549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99551 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99556 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99562 */   GIR_RootConstrainSelectedInstOperands,
     /*  99563 */   // GIR_Coverage, 1587,
     /*  99563 */   GIR_EraseRootFromParent_Done,
     /*  99564 */ // Label 1809: @99564
     /*  99564 */ GIM_Reject,
     /*  99565 */ // Label 1806: @99565
     /*  99565 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99602), // Rule ID 1586 //
     /*  99570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99584 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  99584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  99587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99589 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99594 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99600 */   GIR_RootConstrainSelectedInstOperands,
     /*  99601 */   // GIR_Coverage, 1586,
     /*  99601 */   GIR_EraseRootFromParent_Done,
     /*  99602 */ // Label 1810: @99602
     /*  99602 */ GIM_Reject,
     /*  99603 */ // Label 1807: @99603
     /*  99603 */ GIM_Reject,
     /*  99604 */ // Label 19: @99604
     /*  99604 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99924),
     /*  99609 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  99612 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(99653), // Rule ID 404 //
     /*  99617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99620 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  99624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99628 */     // MIs[0] Operand 1
     /*  99628 */     // No operand predicates
     /*  99628 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  99631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99651 */     GIR_RootConstrainSelectedInstOperands,
     /*  99652 */     // GIR_Coverage, 404,
     /*  99652 */     GIR_EraseRootFromParent_Done,
     /*  99653 */   // Label 1812: @99653
     /*  99653 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99694), // Rule ID 57 //
     /*  99658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99661 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99669 */     // MIs[0] Operand 1
     /*  99669 */     // No operand predicates
     /*  99669 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99692 */     GIR_RootConstrainSelectedInstOperands,
     /*  99693 */     // GIR_Coverage, 57,
     /*  99693 */     GIR_EraseRootFromParent_Done,
     /*  99694 */   // Label 1813: @99694
     /*  99694 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99729), // Rule ID 58 //
     /*  99699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99702 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99710 */     // MIs[0] Operand 1
     /*  99710 */     // No operand predicates
     /*  99710 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99727 */     GIR_RootConstrainSelectedInstOperands,
     /*  99728 */     // GIR_Coverage, 58,
     /*  99728 */     GIR_EraseRootFromParent_Done,
     /*  99729 */   // Label 1814: @99729
     /*  99729 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99772), // Rule ID 168 //
     /*  99734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99737 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99745 */     // MIs[0] Operand 1
     /*  99745 */     // No operand predicates
     /*  99745 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99750 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99770 */     GIR_RootConstrainSelectedInstOperands,
     /*  99771 */     // GIR_Coverage, 168,
     /*  99771 */     GIR_EraseRootFromParent_Done,
     /*  99772 */   // Label 1815: @99772
     /*  99772 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99798), // Rule ID 268 //
     /*  99777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99780 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99788 */     // MIs[0] Operand 1
     /*  99788 */     // No operand predicates
     /*  99788 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99796 */     GIR_RootConstrainSelectedInstOperands,
     /*  99797 */     // GIR_Coverage, 268,
     /*  99797 */     GIR_EraseRootFromParent_Done,
     /*  99798 */   // Label 1816: @99798
     /*  99798 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99839), // Rule ID 322 //
     /*  99803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99806 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99814 */     // MIs[0] Operand 1
     /*  99814 */     // No operand predicates
     /*  99814 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99837 */     GIR_RootConstrainSelectedInstOperands,
     /*  99838 */     // GIR_Coverage, 322,
     /*  99838 */     GIR_EraseRootFromParent_Done,
     /*  99839 */   // Label 1817: @99839
     /*  99839 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(99874), // Rule ID 405 //
     /*  99844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99847 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99855 */     // MIs[0] Operand 1
     /*  99855 */     // No operand predicates
     /*  99855 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99872 */     GIR_RootConstrainSelectedInstOperands,
     /*  99873 */     // GIR_Coverage, 405,
     /*  99873 */     GIR_EraseRootFromParent_Done,
     /*  99874 */   // Label 1818: @99874
     /*  99874 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(99923),
     /*  99879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99883 */     GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(99904), // Rule ID 353 //
     /*  99888 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99891 */       // MIs[0] Operand 1
     /*  99891 */       // No operand predicates
     /*  99891 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99891 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99894 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99896 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99899 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99902 */       GIR_RootConstrainSelectedInstOperands,
     /*  99903 */       // GIR_Coverage, 353,
     /*  99903 */       GIR_EraseRootFromParent_Done,
     /*  99904 */     // Label 1820: @99904
     /*  99904 */     GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99922), // Rule ID 582 //
     /*  99909 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99912 */       // MIs[0] Operand 1
     /*  99912 */       // No operand predicates
     /*  99912 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99912 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99915 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99917 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99920 */       GIR_RootConstrainSelectedInstOperands,
     /*  99921 */       // GIR_Coverage, 582,
     /*  99921 */       GIR_EraseRootFromParent_Done,
     /*  99922 */     // Label 1821: @99922
     /*  99922 */     GIM_Reject,
     /*  99923 */   // Label 1819: @99923
     /*  99923 */   GIM_Reject,
     /*  99924 */ // Label 1811: @99924
     /*  99924 */ GIM_Reject,
     /*  99925 */ // Label 20: @99925
     /*  99925 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1824*/ GIMT_Encode4(100020),
     /*  99936 */ /*GILLT_s32*//*Label 1822*/ GIMT_Encode4(99944),
     /*  99940 */ /*GILLT_s64*//*Label 1823*/ GIMT_Encode4(99982),
     /*  99944 */ // Label 1822: @99944
     /*  99944 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(99981), // Rule ID 728 //
     /*  99949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99956 */   // MIs[0] Operand 1
     /*  99956 */   // No operand predicates
     /*  99956 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99960 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99965 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99973 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99979 */   GIR_RootConstrainSelectedInstOperands,
     /*  99980 */   // GIR_Coverage, 728,
     /*  99980 */   GIR_EraseRootFromParent_Done,
     /*  99981 */ // Label 1825: @99981
     /*  99981 */ GIM_Reject,
     /*  99982 */ // Label 1823: @99982
     /*  99982 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(100019), // Rule ID 727 //
     /*  99987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99994 */   // MIs[0] Operand 1
     /*  99994 */   // No operand predicates
     /*  99994 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99998 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /* 100001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 100003 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /* 100008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100011 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100017 */   GIR_RootConstrainSelectedInstOperands,
     /* 100018 */   // GIR_Coverage, 727,
     /* 100018 */   GIR_EraseRootFromParent_Done,
     /* 100019 */ // Label 1826: @100019
     /* 100019 */ GIM_Reject,
     /* 100020 */ // Label 1824: @100020
     /* 100020 */ GIM_Reject,
     /* 100021 */ // Label 21: @100021
     /* 100021 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1830*/ GIMT_Encode4(100178),
     /* 100032 */ /*GILLT_v2s64*//*Label 1827*/ GIMT_Encode4(100064), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100044 */ /*GILLT_v4s32*//*Label 1828*/ GIMT_Encode4(100102), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100060 */ /*GILLT_v8s16*//*Label 1829*/ GIMT_Encode4(100140),
     /* 100064 */ // Label 1827: @100064
     /* 100064 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(100101), // Rule ID 1600 //
     /* 100069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100083 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /* 100086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100088 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100093 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100099 */   GIR_RootConstrainSelectedInstOperands,
     /* 100100 */   // GIR_Coverage, 1600,
     /* 100100 */   GIR_EraseRootFromParent_Done,
     /* 100101 */ // Label 1831: @100101
     /* 100101 */ GIM_Reject,
     /* 100102 */ // Label 1828: @100102
     /* 100102 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(100139), // Rule ID 1599 //
     /* 100107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100121 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /* 100124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100126 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100131 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100137 */   GIR_RootConstrainSelectedInstOperands,
     /* 100138 */   // GIR_Coverage, 1599,
     /* 100138 */   GIR_EraseRootFromParent_Done,
     /* 100139 */ // Label 1832: @100139
     /* 100139 */ GIM_Reject,
     /* 100140 */ // Label 1829: @100140
     /* 100140 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(100177), // Rule ID 1598 //
     /* 100145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100159 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /* 100162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100164 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100169 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100175 */   GIR_RootConstrainSelectedInstOperands,
     /* 100176 */   // GIR_Coverage, 1598,
     /* 100176 */   GIR_EraseRootFromParent_Done,
     /* 100177 */ // Label 1833: @100177
     /* 100177 */ GIM_Reject,
     /* 100178 */ // Label 1830: @100178
     /* 100178 */ GIM_Reject,
     /* 100179 */ // Label 22: @100179
     /* 100179 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1837*/ GIMT_Encode4(100783),
     /* 100190 */ /*GILLT_s32*//*Label 1834*/ GIMT_Encode4(100238), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100218 */ /*GILLT_v4s32*//*Label 1835*/ GIMT_Encode4(100530), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100234 */ /*GILLT_v8s16*//*Label 1836*/ GIMT_Encode4(100713),
     /* 100238 */ // Label 1834: @100238
     /* 100238 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(100529),
     /* 100243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100246 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(100291), // Rule ID 340 //
     /* 100251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100262 */     // MIs[0] Operand 2
     /* 100262 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100273 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /* 100276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100289 */     GIR_RootConstrainSelectedInstOperands,
     /* 100290 */     // GIR_Coverage, 340,
     /* 100290 */     GIR_EraseRootFromParent_Done,
     /* 100291 */   // Label 1839: @100291
     /* 100291 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(100336), // Rule ID 341 //
     /* 100296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100307 */     // MIs[0] Operand 2
     /* 100307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100318 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /* 100321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100334 */     GIR_RootConstrainSelectedInstOperands,
     /* 100335 */     // GIR_Coverage, 341,
     /* 100335 */     GIR_EraseRootFromParent_Done,
     /* 100336 */   // Label 1840: @100336
     /* 100336 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(100384), // Rule ID 2002 //
     /* 100341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100352 */     // MIs[0] Operand 2
     /* 100352 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100363 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /* 100366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100382 */     GIR_RootConstrainSelectedInstOperands,
     /* 100383 */     // GIR_Coverage, 2002,
     /* 100383 */     GIR_EraseRootFromParent_Done,
     /* 100384 */   // Label 1841: @100384
     /* 100384 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(100432), // Rule ID 2003 //
     /* 100389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100400 */     // MIs[0] Operand 2
     /* 100400 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100411 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /* 100414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100430 */     GIR_RootConstrainSelectedInstOperands,
     /* 100431 */     // GIR_Coverage, 2003,
     /* 100431 */     GIR_EraseRootFromParent_Done,
     /* 100432 */   // Label 1842: @100432
     /* 100432 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(100480), // Rule ID 2241 //
     /* 100437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100448 */     // MIs[0] Operand 2
     /* 100448 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100459 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /* 100462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100478 */     GIR_RootConstrainSelectedInstOperands,
     /* 100479 */     // GIR_Coverage, 2241,
     /* 100479 */     GIR_EraseRootFromParent_Done,
     /* 100480 */   // Label 1843: @100480
     /* 100480 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100528), // Rule ID 2242 //
     /* 100485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100496 */     // MIs[0] Operand 2
     /* 100496 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100507 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /* 100510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100526 */     GIR_RootConstrainSelectedInstOperands,
     /* 100527 */     // GIR_Coverage, 2242,
     /* 100527 */     GIR_EraseRootFromParent_Done,
     /* 100528 */   // Label 1844: @100528
     /* 100528 */   GIM_Reject,
     /* 100529 */ // Label 1838: @100529
     /* 100529 */ GIM_Reject,
     /* 100530 */ // Label 1835: @100530
     /* 100530 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(100712),
     /* 100535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100546 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(100604), // Rule ID 3713 //
     /* 100551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100554 */     // MIs[0] Operand 2
     /* 100554 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100565 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 100565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100582 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100602 */     GIR_RootConstrainSelectedInstOperands,
     /* 100603 */     // GIR_Coverage, 3713,
     /* 100603 */     GIR_EraseRootFromParent_Done,
     /* 100604 */   // Label 1846: @100604
     /* 100604 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(100711), // Rule ID 3715 //
     /* 100609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100612 */     // MIs[0] Operand 2
     /* 100612 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100623 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /* 100623 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 100626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100635 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100638 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100642 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100659 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100663 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100666 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100672 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100678 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100709 */     GIR_RootConstrainSelectedInstOperands,
     /* 100710 */     // GIR_Coverage, 3715,
     /* 100710 */     GIR_EraseRootFromParent_Done,
     /* 100711 */   // Label 1847: @100711
     /* 100711 */   GIM_Reject,
     /* 100712 */ // Label 1845: @100712
     /* 100712 */ GIM_Reject,
     /* 100713 */ // Label 1836: @100713
     /* 100713 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(100782), // Rule ID 3714 //
     /* 100718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100732 */   // MIs[0] Operand 2
     /* 100732 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100743 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100760 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100765 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100771 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100780 */   GIR_RootConstrainSelectedInstOperands,
     /* 100781 */   // GIR_Coverage, 3714,
     /* 100781 */   GIR_EraseRootFromParent_Done,
     /* 100782 */ // Label 1848: @100782
     /* 100782 */ GIM_Reject,
     /* 100783 */ // Label 1837: @100783
     /* 100783 */ GIM_Reject,
     /* 100784 */ // Label 23: @100784
     /* 100784 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1852*/ GIMT_Encode4(100941),
     /* 100795 */ /*GILLT_v2s64*//*Label 1849*/ GIMT_Encode4(100827), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100807 */ /*GILLT_v4s32*//*Label 1850*/ GIMT_Encode4(100865), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100823 */ /*GILLT_v8s16*//*Label 1851*/ GIMT_Encode4(100903),
     /* 100827 */ // Label 1849: @100827
     /* 100827 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(100864), // Rule ID 1603 //
     /* 100832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100846 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100851 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100856 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100862 */   GIR_RootConstrainSelectedInstOperands,
     /* 100863 */   // GIR_Coverage, 1603,
     /* 100863 */   GIR_EraseRootFromParent_Done,
     /* 100864 */ // Label 1853: @100864
     /* 100864 */ GIM_Reject,
     /* 100865 */ // Label 1850: @100865
     /* 100865 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(100902), // Rule ID 1602 //
     /* 100870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100884 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100889 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100894 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100900 */   GIR_RootConstrainSelectedInstOperands,
     /* 100901 */   // GIR_Coverage, 1602,
     /* 100901 */   GIR_EraseRootFromParent_Done,
     /* 100902 */ // Label 1854: @100902
     /* 100902 */ GIM_Reject,
     /* 100903 */ // Label 1851: @100903
     /* 100903 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(100940), // Rule ID 1601 //
     /* 100908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100922 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100927 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100938 */   GIR_RootConstrainSelectedInstOperands,
     /* 100939 */   // GIR_Coverage, 1601,
     /* 100939 */   GIR_EraseRootFromParent_Done,
     /* 100940 */ // Label 1855: @100940
     /* 100940 */ GIM_Reject,
     /* 100941 */ // Label 1852: @100941
     /* 100941 */ GIM_Reject,
     /* 100942 */ // Label 24: @100942
     /* 100942 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(101157),
     /* 100947 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100956 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(101013), // Rule ID 470 //
     /* 100961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100984 */     // MIs[1] Operand 1
     /* 100984 */     // No operand predicates
     /* 100984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100986 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101011 */     GIR_RootConstrainSelectedInstOperands,
     /* 101012 */     // GIR_Coverage, 470,
     /* 101012 */     GIR_EraseRootFromParent_Done,
     /* 101013 */   // Label 1857: @101013
     /* 101013 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(101110),
     /* 101018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101026 */     GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(101071), // Rule ID 318 //
     /* 101031 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101034 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101038 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101042 */       // MIs[1] Operand 1
     /* 101042 */       // No operand predicates
     /* 101042 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101044 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 101044 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 101047 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101049 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101055 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101057 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 101060 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101063 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101069 */       GIR_RootConstrainSelectedInstOperands,
     /* 101070 */       // GIR_Coverage, 318,
     /* 101070 */       GIR_EraseRootFromParent_Done,
     /* 101071 */     // Label 1859: @101071
     /* 101071 */     GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(101109), // Rule ID 319 //
     /* 101076 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101079 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101083 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101083 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 101086 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101088 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101094 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101096 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101098 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101101 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101107 */       GIR_RootConstrainSelectedInstOperands,
     /* 101108 */       // GIR_Coverage, 319,
     /* 101108 */       GIR_EraseRootFromParent_Done,
     /* 101109 */     // Label 1860: @101109
     /* 101109 */     GIM_Reject,
     /* 101110 */   // Label 1858: @101110
     /* 101110 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(101156), // Rule ID 471 //
     /* 101115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101130 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 101133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101154 */     GIR_RootConstrainSelectedInstOperands,
     /* 101155 */     // GIR_Coverage, 471,
     /* 101155 */     GIR_EraseRootFromParent_Done,
     /* 101156 */   // Label 1861: @101156
     /* 101156 */   GIM_Reject,
     /* 101157 */ // Label 1856: @101157
     /* 101157 */ GIM_Reject,
     /* 101158 */ // Label 25: @101158
     /* 101158 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(101265),
     /* 101163 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101172 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(101218), // Rule ID 321 //
     /* 101177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101192 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 101195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101216 */     GIR_RootConstrainSelectedInstOperands,
     /* 101217 */     // GIR_Coverage, 321,
     /* 101217 */     GIR_EraseRootFromParent_Done,
     /* 101218 */   // Label 1863: @101218
     /* 101218 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(101264), // Rule ID 473 //
     /* 101223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101238 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 101241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101262 */     GIR_RootConstrainSelectedInstOperands,
     /* 101263 */     // GIR_Coverage, 473,
     /* 101263 */     GIR_EraseRootFromParent_Done,
     /* 101264 */   // Label 1864: @101264
     /* 101264 */   GIM_Reject,
     /* 101265 */ // Label 1862: @101265
     /* 101265 */ GIM_Reject,
     /* 101266 */ // Label 26: @101266
     /* 101266 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(101538),
     /* 101271 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101280 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(101335), // Rule ID 201 //
     /* 101285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101315 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 101318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101333 */     GIR_RootConstrainSelectedInstOperands,
     /* 101334 */     // GIR_Coverage, 201,
     /* 101334 */     GIR_EraseRootFromParent_Done,
     /* 101335 */   // Label 1866: @101335
     /* 101335 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(101390), // Rule ID 328 //
     /* 101340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101370 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 101373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101388 */     GIR_RootConstrainSelectedInstOperands,
     /* 101389 */     // GIR_Coverage, 328,
     /* 101389 */     GIR_EraseRootFromParent_Done,
     /* 101390 */   // Label 1867: @101390
     /* 101390 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101445), // Rule ID 538 //
     /* 101395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101425 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 101428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101443 */     GIR_RootConstrainSelectedInstOperands,
     /* 101444 */     // GIR_Coverage, 538,
     /* 101444 */     GIR_EraseRootFromParent_Done,
     /* 101445 */   // Label 1868: @101445
     /* 101445 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(101491), // Rule ID 312 //
     /* 101450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101465 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 101468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101489 */     GIR_RootConstrainSelectedInstOperands,
     /* 101490 */     // GIR_Coverage, 312,
     /* 101490 */     GIR_EraseRootFromParent_Done,
     /* 101491 */   // Label 1869: @101491
     /* 101491 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(101537), // Rule ID 475 //
     /* 101496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101511 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 101514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101535 */     GIR_RootConstrainSelectedInstOperands,
     /* 101536 */     // GIR_Coverage, 475,
     /* 101536 */     GIR_EraseRootFromParent_Done,
     /* 101537 */   // Label 1870: @101537
     /* 101537 */   GIM_Reject,
     /* 101538 */ // Label 1865: @101538
     /* 101538 */ GIM_Reject,
     /* 101539 */ // Label 27: @101539
     /* 101539 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(101870),
     /* 101544 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101553 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(101608), // Rule ID 200 //
     /* 101558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101588 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 101591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101606 */     GIR_RootConstrainSelectedInstOperands,
     /* 101607 */     // GIR_Coverage, 200,
     /* 101607 */     GIR_EraseRootFromParent_Done,
     /* 101608 */   // Label 1872: @101608
     /* 101608 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101663), // Rule ID 327 //
     /* 101613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101643 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101661 */     GIR_RootConstrainSelectedInstOperands,
     /* 101662 */     // GIR_Coverage, 327,
     /* 101662 */     GIR_EraseRootFromParent_Done,
     /* 101663 */   // Label 1873: @101663
     /* 101663 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101777),
     /* 101668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101672 */     GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101723), // Rule ID 537 //
     /* 101677 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101680 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101684 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101688 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101692 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101697 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101701 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101703 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101703 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101706 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101708 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101712 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101715 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101721 */       GIR_RootConstrainSelectedInstOperands,
     /* 101722 */       // GIR_Coverage, 537,
     /* 101722 */       GIR_EraseRootFromParent_Done,
     /* 101723 */     // Label 1875: @101723
     /* 101723 */     GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(101776), // Rule ID 476 //
     /* 101728 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101731 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101735 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101739 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101743 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101747 */       // MIs[1] Operand 1
     /* 101747 */       // No operand predicates
     /* 101747 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101749 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101749 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101752 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101754 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101756 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101759 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101762 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101768 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101774 */       GIR_RootConstrainSelectedInstOperands,
     /* 101775 */       // GIR_Coverage, 476,
     /* 101775 */       GIR_EraseRootFromParent_Done,
     /* 101776 */     // Label 1876: @101776
     /* 101776 */     GIM_Reject,
     /* 101777 */   // Label 1874: @101777
     /* 101777 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(101823), // Rule ID 329 //
     /* 101782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101797 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101821 */     GIR_RootConstrainSelectedInstOperands,
     /* 101822 */     // GIR_Coverage, 329,
     /* 101822 */     GIR_EraseRootFromParent_Done,
     /* 101823 */   // Label 1877: @101823
     /* 101823 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(101869), // Rule ID 477 //
     /* 101828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101843 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101867 */     GIR_RootConstrainSelectedInstOperands,
     /* 101868 */     // GIR_Coverage, 477,
     /* 101868 */     GIR_EraseRootFromParent_Done,
     /* 101869 */   // Label 1878: @101869
     /* 101869 */   GIM_Reject,
     /* 101870 */ // Label 1871: @101870
     /* 101870 */ GIM_Reject,
     /* 101871 */ // Label 28: @101871
     /* 101871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1882*/ GIMT_Encode4(102118),
     /* 101882 */ /*GILLT_v4s32*//*Label 1879*/ GIMT_Encode4(101914), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101898 */ /*GILLT_v8s16*//*Label 1880*/ GIMT_Encode4(101982), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101910 */ /*GILLT_v16s8*//*Label 1881*/ GIMT_Encode4(102050),
     /* 101914 */ // Label 1879: @101914
     /* 101914 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(101981), // Rule ID 4464 //
     /* 101919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101940 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101957 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101959 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101964 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101970 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101979 */   GIR_RootConstrainSelectedInstOperands,
     /* 101980 */   // GIR_Coverage, 4464,
     /* 101980 */   GIR_EraseRootFromParent_Done,
     /* 101981 */ // Label 1883: @101981
     /* 101981 */ GIM_Reject,
     /* 101982 */ // Label 1880: @101982
     /* 101982 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(102049), // Rule ID 4460 //
     /* 101987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102008 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 102023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102025 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102027 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102032 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102038 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102047 */   GIR_RootConstrainSelectedInstOperands,
     /* 102048 */   // GIR_Coverage, 4460,
     /* 102048 */   GIR_EraseRootFromParent_Done,
     /* 102049 */ // Label 1884: @102049
     /* 102049 */ GIM_Reject,
     /* 102050 */ // Label 1881: @102050
     /* 102050 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(102117), // Rule ID 4456 //
     /* 102055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102076 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 102091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102093 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102095 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102100 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102106 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102115 */   GIR_RootConstrainSelectedInstOperands,
     /* 102116 */   // GIR_Coverage, 4456,
     /* 102116 */   GIR_EraseRootFromParent_Done,
     /* 102117 */ // Label 1885: @102117
     /* 102117 */ GIM_Reject,
     /* 102118 */ // Label 1882: @102118
     /* 102118 */ GIM_Reject,
     /* 102119 */ // Label 29: @102119
     /* 102119 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1890*/ GIMT_Encode4(102487),
     /* 102130 */ /*GILLT_s32*//*Label 1886*/ GIMT_Encode4(102190), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102158 */ /*GILLT_v4s32*//*Label 1887*/ GIMT_Encode4(102283), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102174 */ /*GILLT_v8s16*//*Label 1888*/ GIMT_Encode4(102351), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102186 */ /*GILLT_v16s8*//*Label 1889*/ GIMT_Encode4(102419),
     /* 102190 */ // Label 1886: @102190
     /* 102190 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(102282),
     /* 102195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102201 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(102241), // Rule ID 178 //
     /* 102206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 102209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102221 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 102221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 102224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102239 */     GIR_RootConstrainSelectedInstOperands,
     /* 102240 */     // GIR_Coverage, 178,
     /* 102240 */     GIR_EraseRootFromParent_Done,
     /* 102241 */   // Label 1892: @102241
     /* 102241 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(102281), // Rule ID 507 //
     /* 102246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102261 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 102261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 102264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102279 */     GIR_RootConstrainSelectedInstOperands,
     /* 102280 */     // GIR_Coverage, 507,
     /* 102280 */     GIR_EraseRootFromParent_Done,
     /* 102281 */   // Label 1893: @102281
     /* 102281 */   GIM_Reject,
     /* 102282 */ // Label 1891: @102282
     /* 102282 */ GIM_Reject,
     /* 102283 */ // Label 1887: @102283
     /* 102283 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(102350), // Rule ID 4452 //
     /* 102288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102309 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 102324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102326 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102328 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102333 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102339 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102348 */   GIR_RootConstrainSelectedInstOperands,
     /* 102349 */   // GIR_Coverage, 4452,
     /* 102349 */   GIR_EraseRootFromParent_Done,
     /* 102350 */ // Label 1894: @102350
     /* 102350 */ GIM_Reject,
     /* 102351 */ // Label 1888: @102351
     /* 102351 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(102418), // Rule ID 4448 //
     /* 102356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102377 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 102392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102394 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102396 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102401 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102413 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102416 */   GIR_RootConstrainSelectedInstOperands,
     /* 102417 */   // GIR_Coverage, 4448,
     /* 102417 */   GIR_EraseRootFromParent_Done,
     /* 102418 */ // Label 1895: @102418
     /* 102418 */ GIM_Reject,
     /* 102419 */ // Label 1889: @102419
     /* 102419 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(102486), // Rule ID 4445 //
     /* 102424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102445 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 102460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102462 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102464 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102469 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102475 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102484 */   GIR_RootConstrainSelectedInstOperands,
     /* 102485 */   // GIR_Coverage, 4445,
     /* 102485 */   GIR_EraseRootFromParent_Done,
     /* 102486 */ // Label 1896: @102486
     /* 102486 */ GIM_Reject,
     /* 102487 */ // Label 1890: @102487
     /* 102487 */ GIM_Reject,
     /* 102488 */ // Label 30: @102488
     /* 102488 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1905*/ GIMT_Encode4(103132),
     /* 102499 */ /*GILLT_s64*//*Label 1897*/ GIMT_Encode4(102555), GIMT_Encode4(0),
     /* 102507 */ /*GILLT_v2s32*//*Label 1898*/ GIMT_Encode4(102602),
     /* 102511 */ /*GILLT_v2s64*//*Label 1899*/ GIMT_Encode4(102649), GIMT_Encode4(0),
     /* 102519 */ /*GILLT_v4s16*//*Label 1900*/ GIMT_Encode4(102696),
     /* 102523 */ /*GILLT_v4s32*//*Label 1901*/ GIMT_Encode4(102743), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102535 */ /*GILLT_v8s8*//*Label 1902*/ GIMT_Encode4(102857),
     /* 102539 */ /*GILLT_v8s16*//*Label 1903*/ GIMT_Encode4(102904), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102551 */ /*GILLT_v16s8*//*Label 1904*/ GIMT_Encode4(103018),
     /* 102555 */ // Label 1897: @102555
     /* 102555 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102601), // Rule ID 830 //
     /* 102560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102581 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 102584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102586 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102588 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102593 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102599 */   GIR_RootConstrainSelectedInstOperands,
     /* 102600 */   // GIR_Coverage, 830,
     /* 102600 */   GIR_EraseRootFromParent_Done,
     /* 102601 */ // Label 1906: @102601
     /* 102601 */ GIM_Reject,
     /* 102602 */ // Label 1898: @102602
     /* 102602 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102648), // Rule ID 825 //
     /* 102607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102628 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 102631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102633 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102635 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102640 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102646 */   GIR_RootConstrainSelectedInstOperands,
     /* 102647 */   // GIR_Coverage, 825,
     /* 102647 */   GIR_EraseRootFromParent_Done,
     /* 102648 */ // Label 1907: @102648
     /* 102648 */ GIM_Reject,
     /* 102649 */ // Label 1899: @102649
     /* 102649 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102695), // Rule ID 831 //
     /* 102654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102675 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102680 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102682 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102687 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102693 */   GIR_RootConstrainSelectedInstOperands,
     /* 102694 */   // GIR_Coverage, 831,
     /* 102694 */   GIR_EraseRootFromParent_Done,
     /* 102695 */ // Label 1908: @102695
     /* 102695 */ GIM_Reject,
     /* 102696 */ // Label 1900: @102696
     /* 102696 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102742), // Rule ID 824 //
     /* 102701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102722 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102727 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102729 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102734 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102740 */   GIR_RootConstrainSelectedInstOperands,
     /* 102741 */   // GIR_Coverage, 824,
     /* 102741 */   GIR_EraseRootFromParent_Done,
     /* 102742 */ // Label 1909: @102742
     /* 102742 */ GIM_Reject,
     /* 102743 */ // Label 1901: @102743
     /* 102743 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102856),
     /* 102748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102754 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102794), // Rule ID 827 //
     /* 102759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102774 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102792 */     GIR_RootConstrainSelectedInstOperands,
     /* 102793 */     // GIR_Coverage, 827,
     /* 102793 */     GIR_EraseRootFromParent_Done,
     /* 102794 */   // Label 1911: @102794
     /* 102794 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102855), // Rule ID 3527 //
     /* 102799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102814 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102853 */     GIR_RootConstrainSelectedInstOperands,
     /* 102854 */     // GIR_Coverage, 3527,
     /* 102854 */     GIR_EraseRootFromParent_Done,
     /* 102855 */   // Label 1912: @102855
     /* 102855 */   GIM_Reject,
     /* 102856 */ // Label 1910: @102856
     /* 102856 */ GIM_Reject,
     /* 102857 */ // Label 1902: @102857
     /* 102857 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102903), // Rule ID 828 //
     /* 102862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102883 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102888 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102890 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102895 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102901 */   GIR_RootConstrainSelectedInstOperands,
     /* 102902 */   // GIR_Coverage, 828,
     /* 102902 */   GIR_EraseRootFromParent_Done,
     /* 102903 */ // Label 1913: @102903
     /* 102903 */ GIM_Reject,
     /* 102904 */ // Label 1903: @102904
     /* 102904 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(103017),
     /* 102909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102915 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102955), // Rule ID 826 //
     /* 102920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102935 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102953 */     GIR_RootConstrainSelectedInstOperands,
     /* 102954 */     // GIR_Coverage, 826,
     /* 102954 */     GIR_EraseRootFromParent_Done,
     /* 102955 */   // Label 1915: @102955
     /* 102955 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(103016), // Rule ID 3524 //
     /* 102960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102975 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103014 */     GIR_RootConstrainSelectedInstOperands,
     /* 103015 */     // GIR_Coverage, 3524,
     /* 103015 */     GIR_EraseRootFromParent_Done,
     /* 103016 */   // Label 1916: @103016
     /* 103016 */   GIM_Reject,
     /* 103017 */ // Label 1914: @103017
     /* 103017 */ GIM_Reject,
     /* 103018 */ // Label 1904: @103018
     /* 103018 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(103131),
     /* 103023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 103026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 103029 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(103069), // Rule ID 829 //
     /* 103034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103049 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 103049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 103052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103067 */     GIR_RootConstrainSelectedInstOperands,
     /* 103068 */     // GIR_Coverage, 829,
     /* 103068 */     GIR_EraseRootFromParent_Done,
     /* 103069 */   // Label 1918: @103069
     /* 103069 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(103130), // Rule ID 3521 //
     /* 103074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103089 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 103089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 103104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103128 */     GIR_RootConstrainSelectedInstOperands,
     /* 103129 */     // GIR_Coverage, 3521,
     /* 103129 */     GIR_EraseRootFromParent_Done,
     /* 103130 */   // Label 1919: @103130
     /* 103130 */   GIM_Reject,
     /* 103131 */ // Label 1917: @103131
     /* 103131 */ GIM_Reject,
     /* 103132 */ // Label 1905: @103132
     /* 103132 */ GIM_Reject,
     /* 103133 */ // Label 31: @103133
     /* 103133 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1929*/ GIMT_Encode4(104432),
     /* 103144 */ /*GILLT_s32*//*Label 1920*/ GIMT_Encode4(103204),
     /* 103148 */ /*GILLT_s64*//*Label 1921*/ GIMT_Encode4(103545), GIMT_Encode4(0),
     /* 103156 */ /*GILLT_v2s32*//*Label 1922*/ GIMT_Encode4(103592),
     /* 103160 */ /*GILLT_v2s64*//*Label 1923*/ GIMT_Encode4(103639), GIMT_Encode4(0),
     /* 103168 */ /*GILLT_v4s16*//*Label 1924*/ GIMT_Encode4(103840),
     /* 103172 */ /*GILLT_v4s32*//*Label 1925*/ GIMT_Encode4(103887), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103184 */ /*GILLT_v8s8*//*Label 1926*/ GIMT_Encode4(104157),
     /* 103188 */ /*GILLT_v8s16*//*Label 1927*/ GIMT_Encode4(104204), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103200 */ /*GILLT_v16s8*//*Label 1928*/ GIMT_Encode4(104318),
     /* 103204 */ // Label 1920: @103204
     /* 103204 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103544),
     /* 103209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 103212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 103215 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103277), // Rule ID 5654 //
     /* 103220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103244 */     // MIs[1] Rn
     /* 103244 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103255 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103275 */     GIR_RootConstrainSelectedInstOperands,
     /* 103276 */     // GIR_Coverage, 5654,
     /* 103276 */     GIR_EraseRootFromParent_Done,
     /* 103277 */   // Label 1931: @103277
     /* 103277 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103339), // Rule ID 5688 //
     /* 103282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103306 */     // MIs[1] Rn
     /* 103306 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103317 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103337 */     GIR_RootConstrainSelectedInstOperands,
     /* 103338 */     // GIR_Coverage, 5688,
     /* 103338 */     GIR_EraseRootFromParent_Done,
     /* 103339 */   // Label 1932: @103339
     /* 103339 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103401), // Rule ID 1870 //
     /* 103344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103372 */     // MIs[1] Rn
     /* 103372 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103379 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103399 */     GIR_RootConstrainSelectedInstOperands,
     /* 103400 */     // GIR_Coverage, 1870,
     /* 103400 */     GIR_EraseRootFromParent_Done,
     /* 103401 */   // Label 1933: @103401
     /* 103401 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(103463), // Rule ID 2136 //
     /* 103406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103434 */     // MIs[1] Rn
     /* 103434 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103441 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103461 */     GIR_RootConstrainSelectedInstOperands,
     /* 103462 */     // GIR_Coverage, 2136,
     /* 103462 */     GIR_EraseRootFromParent_Done,
     /* 103463 */   // Label 1934: @103463
     /* 103463 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103503), // Rule ID 1868 //
     /* 103468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103483 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 103483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 103486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103488 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 103490 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 103492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103501 */     GIR_RootConstrainSelectedInstOperands,
     /* 103502 */     // GIR_Coverage, 1868,
     /* 103502 */     GIR_EraseRootFromParent_Done,
     /* 103503 */   // Label 1935: @103503
     /* 103503 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103543), // Rule ID 2134 //
     /* 103508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103523 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 103526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 103532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103541 */     GIR_RootConstrainSelectedInstOperands,
     /* 103542 */     // GIR_Coverage, 2134,
     /* 103542 */     GIR_EraseRootFromParent_Done,
     /* 103543 */   // Label 1936: @103543
     /* 103543 */   GIM_Reject,
     /* 103544 */ // Label 1930: @103544
     /* 103544 */ GIM_Reject,
     /* 103545 */ // Label 1921: @103545
     /* 103545 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103591), // Rule ID 822 //
     /* 103550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103571 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 103574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103576 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103578 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103583 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103589 */   GIR_RootConstrainSelectedInstOperands,
     /* 103590 */   // GIR_Coverage, 822,
     /* 103590 */   GIR_EraseRootFromParent_Done,
     /* 103591 */ // Label 1937: @103591
     /* 103591 */ GIM_Reject,
     /* 103592 */ // Label 1922: @103592
     /* 103592 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(103638), // Rule ID 817 //
     /* 103597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103618 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 103621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103623 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103625 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103630 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103636 */   GIR_RootConstrainSelectedInstOperands,
     /* 103637 */   // GIR_Coverage, 817,
     /* 103637 */   GIR_EraseRootFromParent_Done,
     /* 103638 */ // Label 1938: @103638
     /* 103638 */ GIM_Reject,
     /* 103639 */ // Label 1923: @103639
     /* 103639 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(103839),
     /* 103644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103654 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(103728), // Rule ID 5745 //
     /* 103659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103670 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103673 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103682 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103702 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103707 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103726 */     GIR_RootConstrainSelectedInstOperands,
     /* 103727 */     // GIR_Coverage, 5745,
     /* 103727 */     GIR_EraseRootFromParent_Done,
     /* 103728 */   // Label 1940: @103728
     /* 103728 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(103802), // Rule ID 2489 //
     /* 103733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103748 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103751 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103760 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103776 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103781 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103800 */     GIR_RootConstrainSelectedInstOperands,
     /* 103801 */     // GIR_Coverage, 2489,
     /* 103801 */     GIR_EraseRootFromParent_Done,
     /* 103802 */   // Label 1941: @103802
     /* 103802 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(103838), // Rule ID 823 //
     /* 103807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103818 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103836 */     GIR_RootConstrainSelectedInstOperands,
     /* 103837 */     // GIR_Coverage, 823,
     /* 103837 */     GIR_EraseRootFromParent_Done,
     /* 103838 */   // Label 1942: @103838
     /* 103838 */   GIM_Reject,
     /* 103839 */ // Label 1939: @103839
     /* 103839 */ GIM_Reject,
     /* 103840 */ // Label 1924: @103840
     /* 103840 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(103886), // Rule ID 816 //
     /* 103845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103866 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103871 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103873 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103878 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103884 */   GIR_RootConstrainSelectedInstOperands,
     /* 103885 */   // GIR_Coverage, 816,
     /* 103885 */   GIR_EraseRootFromParent_Done,
     /* 103886 */ // Label 1943: @103886
     /* 103886 */ GIM_Reject,
     /* 103887 */ // Label 1925: @103887
     /* 103887 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(104156),
     /* 103892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103898 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(103976), // Rule ID 5744 //
     /* 103903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103918 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103921 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103930 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103950 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103955 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103974 */     GIR_RootConstrainSelectedInstOperands,
     /* 103975 */     // GIR_Coverage, 5744,
     /* 103975 */     GIR_EraseRootFromParent_Done,
     /* 103976 */   // Label 1945: @103976
     /* 103976 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(104054), // Rule ID 2488 //
     /* 103981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 104000 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 104003 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 104008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104012 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 104016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104028 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 104031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 104035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 104039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 104043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104052 */     GIR_RootConstrainSelectedInstOperands,
     /* 104053 */     // GIR_Coverage, 2488,
     /* 104053 */     GIR_EraseRootFromParent_Done,
     /* 104054 */   // Label 1946: @104054
     /* 104054 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(104094), // Rule ID 819 //
     /* 104059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104074 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 104077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104092 */     GIR_RootConstrainSelectedInstOperands,
     /* 104093 */     // GIR_Coverage, 819,
     /* 104093 */     GIR_EraseRootFromParent_Done,
     /* 104094 */   // Label 1947: @104094
     /* 104094 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(104155), // Rule ID 3518 //
     /* 104099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104114 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 104129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104153 */     GIR_RootConstrainSelectedInstOperands,
     /* 104154 */     // GIR_Coverage, 3518,
     /* 104154 */     GIR_EraseRootFromParent_Done,
     /* 104155 */   // Label 1948: @104155
     /* 104155 */   GIM_Reject,
     /* 104156 */ // Label 1944: @104156
     /* 104156 */ GIM_Reject,
     /* 104157 */ // Label 1926: @104157
     /* 104157 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(104203), // Rule ID 820 //
     /* 104162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104183 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 104186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104188 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104190 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104195 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104201 */   GIR_RootConstrainSelectedInstOperands,
     /* 104202 */   // GIR_Coverage, 820,
     /* 104202 */   GIR_EraseRootFromParent_Done,
     /* 104203 */ // Label 1949: @104203
     /* 104203 */ GIM_Reject,
     /* 104204 */ // Label 1927: @104204
     /* 104204 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(104317),
     /* 104209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104215 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(104255), // Rule ID 818 //
     /* 104220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104235 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 104238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104253 */     GIR_RootConstrainSelectedInstOperands,
     /* 104254 */     // GIR_Coverage, 818,
     /* 104254 */     GIR_EraseRootFromParent_Done,
     /* 104255 */   // Label 1951: @104255
     /* 104255 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(104316), // Rule ID 3515 //
     /* 104260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104275 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 104290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104314 */     GIR_RootConstrainSelectedInstOperands,
     /* 104315 */     // GIR_Coverage, 3515,
     /* 104315 */     GIR_EraseRootFromParent_Done,
     /* 104316 */   // Label 1952: @104316
     /* 104316 */   GIM_Reject,
     /* 104317 */ // Label 1950: @104317
     /* 104317 */ GIM_Reject,
     /* 104318 */ // Label 1928: @104318
     /* 104318 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(104431),
     /* 104323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104329 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(104369), // Rule ID 821 //
     /* 104334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104349 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 104352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104367 */     GIR_RootConstrainSelectedInstOperands,
     /* 104368 */     // GIR_Coverage, 821,
     /* 104368 */     GIR_EraseRootFromParent_Done,
     /* 104369 */   // Label 1954: @104369
     /* 104369 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(104430), // Rule ID 3512 //
     /* 104374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104389 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 104404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104428 */     GIR_RootConstrainSelectedInstOperands,
     /* 104429 */     // GIR_Coverage, 3512,
     /* 104429 */     GIR_EraseRootFromParent_Done,
     /* 104430 */   // Label 1955: @104430
     /* 104430 */   GIM_Reject,
     /* 104431 */ // Label 1953: @104431
     /* 104431 */ GIM_Reject,
     /* 104432 */ // Label 1929: @104432
     /* 104432 */ GIM_Reject,
     /* 104433 */ // Label 32: @104433
     /* 104433 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1964*/ GIMT_Encode4(105077),
     /* 104444 */ /*GILLT_s64*//*Label 1956*/ GIMT_Encode4(104500), GIMT_Encode4(0),
     /* 104452 */ /*GILLT_v2s32*//*Label 1957*/ GIMT_Encode4(104547),
     /* 104456 */ /*GILLT_v2s64*//*Label 1958*/ GIMT_Encode4(104594), GIMT_Encode4(0),
     /* 104464 */ /*GILLT_v4s16*//*Label 1959*/ GIMT_Encode4(104641),
     /* 104468 */ /*GILLT_v4s32*//*Label 1960*/ GIMT_Encode4(104688), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104480 */ /*GILLT_v8s8*//*Label 1961*/ GIMT_Encode4(104802),
     /* 104484 */ /*GILLT_v8s16*//*Label 1962*/ GIMT_Encode4(104849), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104496 */ /*GILLT_v16s8*//*Label 1963*/ GIMT_Encode4(104963),
     /* 104500 */ // Label 1956: @104500
     /* 104500 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104546), // Rule ID 1022 //
     /* 104505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104526 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 104529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104531 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104533 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104538 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104544 */   GIR_RootConstrainSelectedInstOperands,
     /* 104545 */   // GIR_Coverage, 1022,
     /* 104545 */   GIR_EraseRootFromParent_Done,
     /* 104546 */ // Label 1965: @104546
     /* 104546 */ GIM_Reject,
     /* 104547 */ // Label 1957: @104547
     /* 104547 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104593), // Rule ID 1017 //
     /* 104552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104573 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 104576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104578 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104580 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104585 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104591 */   GIR_RootConstrainSelectedInstOperands,
     /* 104592 */   // GIR_Coverage, 1017,
     /* 104592 */   GIR_EraseRootFromParent_Done,
     /* 104593 */ // Label 1966: @104593
     /* 104593 */ GIM_Reject,
     /* 104594 */ // Label 1958: @104594
     /* 104594 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104640), // Rule ID 1023 //
     /* 104599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104620 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 104623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104625 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104627 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104632 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104638 */   GIR_RootConstrainSelectedInstOperands,
     /* 104639 */   // GIR_Coverage, 1023,
     /* 104639 */   GIR_EraseRootFromParent_Done,
     /* 104640 */ // Label 1967: @104640
     /* 104640 */ GIM_Reject,
     /* 104641 */ // Label 1959: @104641
     /* 104641 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104687), // Rule ID 1016 //
     /* 104646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104667 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104672 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104674 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104679 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104685 */   GIR_RootConstrainSelectedInstOperands,
     /* 104686 */   // GIR_Coverage, 1016,
     /* 104686 */   GIR_EraseRootFromParent_Done,
     /* 104687 */ // Label 1968: @104687
     /* 104687 */ GIM_Reject,
     /* 104688 */ // Label 1960: @104688
     /* 104688 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(104801),
     /* 104693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104699 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(104739), // Rule ID 1019 //
     /* 104704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104719 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104737 */     GIR_RootConstrainSelectedInstOperands,
     /* 104738 */     // GIR_Coverage, 1019,
     /* 104738 */     GIR_EraseRootFromParent_Done,
     /* 104739 */   // Label 1970: @104739
     /* 104739 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(104800), // Rule ID 3545 //
     /* 104744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104759 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104798 */     GIR_RootConstrainSelectedInstOperands,
     /* 104799 */     // GIR_Coverage, 3545,
     /* 104799 */     GIR_EraseRootFromParent_Done,
     /* 104800 */   // Label 1971: @104800
     /* 104800 */   GIM_Reject,
     /* 104801 */ // Label 1969: @104801
     /* 104801 */ GIM_Reject,
     /* 104802 */ // Label 1961: @104802
     /* 104802 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(104848), // Rule ID 1020 //
     /* 104807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104828 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104833 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104835 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104840 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104846 */   GIR_RootConstrainSelectedInstOperands,
     /* 104847 */   // GIR_Coverage, 1020,
     /* 104847 */   GIR_EraseRootFromParent_Done,
     /* 104848 */ // Label 1972: @104848
     /* 104848 */ GIM_Reject,
     /* 104849 */ // Label 1962: @104849
     /* 104849 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(104962),
     /* 104854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104860 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(104900), // Rule ID 1018 //
     /* 104865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104880 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104898 */     GIR_RootConstrainSelectedInstOperands,
     /* 104899 */     // GIR_Coverage, 1018,
     /* 104899 */     GIR_EraseRootFromParent_Done,
     /* 104900 */   // Label 1974: @104900
     /* 104900 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(104961), // Rule ID 3542 //
     /* 104905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104920 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104959 */     GIR_RootConstrainSelectedInstOperands,
     /* 104960 */     // GIR_Coverage, 3542,
     /* 104960 */     GIR_EraseRootFromParent_Done,
     /* 104961 */   // Label 1975: @104961
     /* 104961 */   GIM_Reject,
     /* 104962 */ // Label 1973: @104962
     /* 104962 */ GIM_Reject,
     /* 104963 */ // Label 1963: @104963
     /* 104963 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(105076),
     /* 104968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104974 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(105014), // Rule ID 1021 //
     /* 104979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104994 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105012 */     GIR_RootConstrainSelectedInstOperands,
     /* 105013 */     // GIR_Coverage, 1021,
     /* 105013 */     GIR_EraseRootFromParent_Done,
     /* 105014 */   // Label 1977: @105014
     /* 105014 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(105075), // Rule ID 3539 //
     /* 105019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105034 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 105049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105073 */     GIR_RootConstrainSelectedInstOperands,
     /* 105074 */     // GIR_Coverage, 3539,
     /* 105074 */     GIR_EraseRootFromParent_Done,
     /* 105075 */   // Label 1978: @105075
     /* 105075 */   GIM_Reject,
     /* 105076 */ // Label 1976: @105076
     /* 105076 */ GIM_Reject,
     /* 105077 */ // Label 1964: @105077
     /* 105077 */ GIM_Reject,
     /* 105078 */ // Label 33: @105078
     /* 105078 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1988*/ GIMT_Encode4(106097),
     /* 105089 */ /*GILLT_s32*//*Label 1979*/ GIMT_Encode4(105149),
     /* 105093 */ /*GILLT_s64*//*Label 1980*/ GIMT_Encode4(105366), GIMT_Encode4(0),
     /* 105101 */ /*GILLT_v2s32*//*Label 1981*/ GIMT_Encode4(105413),
     /* 105105 */ /*GILLT_v2s64*//*Label 1982*/ GIMT_Encode4(105460), GIMT_Encode4(0),
     /* 105113 */ /*GILLT_v4s16*//*Label 1983*/ GIMT_Encode4(105583),
     /* 105117 */ /*GILLT_v4s32*//*Label 1984*/ GIMT_Encode4(105630), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105129 */ /*GILLT_v8s8*//*Label 1985*/ GIMT_Encode4(105822),
     /* 105133 */ /*GILLT_v8s16*//*Label 1986*/ GIMT_Encode4(105869), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105145 */ /*GILLT_v16s8*//*Label 1987*/ GIMT_Encode4(105983),
     /* 105149 */ // Label 1979: @105149
     /* 105149 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105365),
     /* 105154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105160 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(105222), // Rule ID 1871 //
     /* 105165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105193 */     // MIs[1] Rn
     /* 105193 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105200 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 105203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105220 */     GIR_RootConstrainSelectedInstOperands,
     /* 105221 */     // GIR_Coverage, 1871,
     /* 105221 */     GIR_EraseRootFromParent_Done,
     /* 105222 */   // Label 1990: @105222
     /* 105222 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(105284), // Rule ID 2137 //
     /* 105227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105255 */     // MIs[1] Rn
     /* 105255 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105262 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 105265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105282 */     GIR_RootConstrainSelectedInstOperands,
     /* 105283 */     // GIR_Coverage, 2137,
     /* 105283 */     GIR_EraseRootFromParent_Done,
     /* 105284 */   // Label 1991: @105284
     /* 105284 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(105324), // Rule ID 1869 //
     /* 105289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105304 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 105304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 105307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105309 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 105311 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 105313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105322 */     GIR_RootConstrainSelectedInstOperands,
     /* 105323 */     // GIR_Coverage, 1869,
     /* 105323 */     GIR_EraseRootFromParent_Done,
     /* 105324 */   // Label 1992: @105324
     /* 105324 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105364), // Rule ID 2135 //
     /* 105329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105344 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 105347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 105353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105362 */     GIR_RootConstrainSelectedInstOperands,
     /* 105363 */     // GIR_Coverage, 2135,
     /* 105363 */     GIR_EraseRootFromParent_Done,
     /* 105364 */   // Label 1993: @105364
     /* 105364 */   GIM_Reject,
     /* 105365 */ // Label 1989: @105365
     /* 105365 */ GIM_Reject,
     /* 105366 */ // Label 1980: @105366
     /* 105366 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105412), // Rule ID 1014 //
     /* 105371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105392 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 105392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 105395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105397 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105399 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105404 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105410 */   GIR_RootConstrainSelectedInstOperands,
     /* 105411 */   // GIR_Coverage, 1014,
     /* 105411 */   GIR_EraseRootFromParent_Done,
     /* 105412 */ // Label 1994: @105412
     /* 105412 */ GIM_Reject,
     /* 105413 */ // Label 1981: @105413
     /* 105413 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105459), // Rule ID 1009 //
     /* 105418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105439 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 105442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105444 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105446 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105457 */   GIR_RootConstrainSelectedInstOperands,
     /* 105458 */   // GIR_Coverage, 1009,
     /* 105458 */   GIR_EraseRootFromParent_Done,
     /* 105459 */ // Label 1995: @105459
     /* 105459 */ GIM_Reject,
     /* 105460 */ // Label 1982: @105460
     /* 105460 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105582),
     /* 105465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 105471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105479 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105549), // Rule ID 2496 //
     /* 105484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105495 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105498 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105507 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 105511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105523 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 105526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105547 */     GIR_RootConstrainSelectedInstOperands,
     /* 105548 */     // GIR_Coverage, 2496,
     /* 105548 */     GIR_EraseRootFromParent_Done,
     /* 105549 */   // Label 1997: @105549
     /* 105549 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105581), // Rule ID 1015 //
     /* 105554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105561 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 105561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 105564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105579 */     GIR_RootConstrainSelectedInstOperands,
     /* 105580 */     // GIR_Coverage, 1015,
     /* 105580 */     GIR_EraseRootFromParent_Done,
     /* 105581 */   // Label 1998: @105581
     /* 105581 */   GIM_Reject,
     /* 105582 */ // Label 1996: @105582
     /* 105582 */ GIM_Reject,
     /* 105583 */ // Label 1983: @105583
     /* 105583 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105629), // Rule ID 1008 //
     /* 105588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105609 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 105612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105614 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105616 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105621 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105627 */   GIR_RootConstrainSelectedInstOperands,
     /* 105628 */   // GIR_Coverage, 1008,
     /* 105628 */   GIR_EraseRootFromParent_Done,
     /* 105629 */ // Label 1999: @105629
     /* 105629 */ GIM_Reject,
     /* 105630 */ // Label 1984: @105630
     /* 105630 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105821),
     /* 105635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105641 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(105719), // Rule ID 2495 //
     /* 105646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105665 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105668 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105677 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105693 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105698 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105717 */     GIR_RootConstrainSelectedInstOperands,
     /* 105718 */     // GIR_Coverage, 2495,
     /* 105718 */     GIR_EraseRootFromParent_Done,
     /* 105719 */   // Label 2001: @105719
     /* 105719 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(105759), // Rule ID 1011 //
     /* 105724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105739 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105757 */     GIR_RootConstrainSelectedInstOperands,
     /* 105758 */     // GIR_Coverage, 1011,
     /* 105758 */     GIR_EraseRootFromParent_Done,
     /* 105759 */   // Label 2002: @105759
     /* 105759 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(105820), // Rule ID 3536 //
     /* 105764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105779 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105809 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105818 */     GIR_RootConstrainSelectedInstOperands,
     /* 105819 */     // GIR_Coverage, 3536,
     /* 105819 */     GIR_EraseRootFromParent_Done,
     /* 105820 */   // Label 2003: @105820
     /* 105820 */   GIM_Reject,
     /* 105821 */ // Label 2000: @105821
     /* 105821 */ GIM_Reject,
     /* 105822 */ // Label 1985: @105822
     /* 105822 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(105868), // Rule ID 1012 //
     /* 105827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105848 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105853 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105855 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105860 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105866 */   GIR_RootConstrainSelectedInstOperands,
     /* 105867 */   // GIR_Coverage, 1012,
     /* 105867 */   GIR_EraseRootFromParent_Done,
     /* 105868 */ // Label 2004: @105868
     /* 105868 */ GIM_Reject,
     /* 105869 */ // Label 1986: @105869
     /* 105869 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(105982),
     /* 105874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105880 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(105920), // Rule ID 1010 //
     /* 105885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105900 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105918 */     GIR_RootConstrainSelectedInstOperands,
     /* 105919 */     // GIR_Coverage, 1010,
     /* 105919 */     GIR_EraseRootFromParent_Done,
     /* 105920 */   // Label 2006: @105920
     /* 105920 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(105981), // Rule ID 3533 //
     /* 105925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105940 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105979 */     GIR_RootConstrainSelectedInstOperands,
     /* 105980 */     // GIR_Coverage, 3533,
     /* 105980 */     GIR_EraseRootFromParent_Done,
     /* 105981 */   // Label 2007: @105981
     /* 105981 */   GIM_Reject,
     /* 105982 */ // Label 2005: @105982
     /* 105982 */ GIM_Reject,
     /* 105983 */ // Label 1987: @105983
     /* 105983 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(106096),
     /* 105988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105994 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(106034), // Rule ID 1013 //
     /* 105999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 106002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 106006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 106010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 106014 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 106014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 106017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 106019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 106021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 106023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106032 */     GIR_RootConstrainSelectedInstOperands,
     /* 106033 */     // GIR_Coverage, 1013,
     /* 106033 */     GIR_EraseRootFromParent_Done,
     /* 106034 */   // Label 2009: @106034
     /* 106034 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(106095), // Rule ID 3530 //
     /* 106039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 106042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 106046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 106050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 106054 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 106054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 106057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 106069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 106071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 106073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 106075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106093 */     GIR_RootConstrainSelectedInstOperands,
     /* 106094 */     // GIR_Coverage, 3530,
     /* 106094 */     GIR_EraseRootFromParent_Done,
     /* 106095 */   // Label 2010: @106095
     /* 106095 */   GIM_Reject,
     /* 106096 */ // Label 2008: @106096
     /* 106096 */ GIM_Reject,
     /* 106097 */ // Label 1988: @106097
     /* 106097 */ GIM_Reject,
     /* 106098 */ // Label 34: @106098
     /* 106098 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2018*/ GIMT_Encode4(108450),
     /* 106109 */ /*GILLT_s16*//*Label 2011*/ GIMT_Encode4(106161),
     /* 106113 */ /*GILLT_s32*//*Label 2012*/ GIMT_Encode4(106208),
     /* 106117 */ /*GILLT_s64*//*Label 2013*/ GIMT_Encode4(107803), GIMT_Encode4(0),
     /* 106125 */ /*GILLT_v2s32*//*Label 2014*/ GIMT_Encode4(107850), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106137 */ /*GILLT_v4s16*//*Label 2015*/ GIMT_Encode4(107897),
     /* 106141 */ /*GILLT_v4s32*//*Label 2016*/ GIMT_Encode4(108082), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106157 */ /*GILLT_v8s16*//*Label 2017*/ GIMT_Encode4(108196),
     /* 106161 */ // Label 2011: @106161
     /* 106161 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(106207), // Rule ID 614 //
     /* 106166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 106169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 106172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 106175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106187 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 106187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 106190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 106192 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 106194 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 106196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106199 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106205 */   GIR_RootConstrainSelectedInstOperands,
     /* 106206 */   // GIR_Coverage, 614,
     /* 106206 */   GIR_EraseRootFromParent_Done,
     /* 106207 */ // Label 2019: @106207
     /* 106207 */ GIM_Reject,
     /* 106208 */ // Label 2012: @106208
     /* 106208 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107802),
     /* 106213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106223 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(106551), // Rule ID 5921 //
     /* 106228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106263 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106263 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106266 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106270 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106277 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106280 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106284 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106289 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106292 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106297 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106300 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106304 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106309 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106312 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106316 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106319 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106324 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106329 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106334 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106337 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106341 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106348 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106351 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106355 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106360 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106363 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106368 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106371 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106375 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106380 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106383 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106387 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106390 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106395 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106400 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106405 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106408 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106412 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106419 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106422 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106426 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106431 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106434 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106439 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106442 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106446 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106451 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106454 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106458 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106461 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106466 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106471 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106476 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106479 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106483 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106488 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106491 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106494 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106500 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106520 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106533 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106550 */     // GIR_Coverage, 5921,
     /* 106550 */     GIR_EraseRootFromParent_Done,
     /* 106551 */   // Label 2021: @106551
     /* 106551 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(106879), // Rule ID 5922 //
     /* 106556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106591 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106591 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106594 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106598 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106605 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106608 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106612 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106617 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106620 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106625 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106628 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106632 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106637 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106640 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106644 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106647 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106652 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106657 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106662 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106665 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106669 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106676 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106679 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106683 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106688 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106691 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106696 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106699 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106703 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106708 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106711 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106715 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106718 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106723 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106728 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106733 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106736 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106740 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106747 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106750 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106754 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106759 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106762 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106767 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106770 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106774 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106779 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106782 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106786 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106789 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106794 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106799 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106807 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106811 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106816 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106819 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106822 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106825 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106828 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106848 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106861 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106878 */     // GIR_Coverage, 5922,
     /* 106878 */     GIR_EraseRootFromParent_Done,
     /* 106879 */   // Label 2022: @106879
     /* 106879 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107207), // Rule ID 2700 //
     /* 106884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106919 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106919 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106922 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106926 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106933 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106936 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106940 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106945 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106948 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106953 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106956 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106960 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106965 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106968 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106972 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106975 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106980 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106985 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106990 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106993 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106997 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107004 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107007 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107011 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107016 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107019 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107024 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107027 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107031 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107036 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107039 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107043 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107046 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107051 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107056 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107061 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107064 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107068 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107075 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107078 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107082 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107087 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107090 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107095 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107098 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107102 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107107 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107110 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107114 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107117 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107122 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107127 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107132 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107135 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 107139 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107144 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107147 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107150 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107153 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107156 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107189 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107206 */     // GIR_Coverage, 2700,
     /* 107206 */     GIR_EraseRootFromParent_Done,
     /* 107207 */   // Label 2023: @107207
     /* 107207 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107535), // Rule ID 2702 //
     /* 107212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 107215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 107231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107247 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107247 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 107250 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107254 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 107261 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 107264 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107268 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107273 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 107276 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107281 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 107284 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107288 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107293 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 107296 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 107300 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 107303 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107308 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107313 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107318 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107321 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107325 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107332 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107335 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107339 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107344 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107347 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107352 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107355 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107359 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107364 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107367 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107371 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107374 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107379 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107384 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107389 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107392 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107396 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107403 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107406 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107410 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107415 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107418 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107423 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107426 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107430 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107435 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107438 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107442 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107445 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107450 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107455 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107460 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107463 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 107467 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107472 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107475 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107478 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107481 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107484 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107504 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107517 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107534 */     // GIR_Coverage, 2702,
     /* 107534 */     GIR_EraseRootFromParent_Done,
     /* 107535 */   // Label 2024: @107535
     /* 107535 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107571), // Rule ID 613 //
     /* 107540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 107543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107551 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 107551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 107554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107569 */     GIR_RootConstrainSelectedInstOperands,
     /* 107570 */     // GIR_Coverage, 613,
     /* 107570 */     GIR_EraseRootFromParent_Done,
     /* 107571 */   // Label 2025: @107571
     /* 107571 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107801), // Rule ID 2697 //
     /* 107576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 107579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107587 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107587 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107590 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107594 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107601 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107604 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107608 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107613 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107616 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107621 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107624 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107628 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107633 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107636 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107640 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107643 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107648 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107653 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107658 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107661 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107665 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107672 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107675 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107679 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107684 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107687 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107704 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107707 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107711 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107714 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107719 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107724 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107729 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107732 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107736 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107741 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107744 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107747 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107750 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107770 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107783 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107800 */     // GIR_Coverage, 2697,
     /* 107800 */     GIR_EraseRootFromParent_Done,
     /* 107801 */   // Label 2026: @107801
     /* 107801 */   GIM_Reject,
     /* 107802 */ // Label 2020: @107802
     /* 107802 */ GIM_Reject,
     /* 107803 */ // Label 2013: @107803
     /* 107803 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107849), // Rule ID 612 //
     /* 107808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107829 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107834 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107836 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107841 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107847 */   GIR_RootConstrainSelectedInstOperands,
     /* 107848 */   // GIR_Coverage, 612,
     /* 107848 */   GIR_EraseRootFromParent_Done,
     /* 107849 */ // Label 2027: @107849
     /* 107849 */ GIM_Reject,
     /* 107850 */ // Label 2014: @107850
     /* 107850 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107896), // Rule ID 764 //
     /* 107855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107876 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107881 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107883 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107894 */   GIR_RootConstrainSelectedInstOperands,
     /* 107895 */   // GIR_Coverage, 764,
     /* 107895 */   GIR_EraseRootFromParent_Done,
     /* 107896 */ // Label 2028: @107896
     /* 107896 */ GIM_Reject,
     /* 107897 */ // Label 2015: @107897
     /* 107897 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(108081),
     /* 107902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107912 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107978), // Rule ID 5584 //
     /* 107917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107952 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107957 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107976 */     GIR_RootConstrainSelectedInstOperands,
     /* 107977 */     // GIR_Coverage, 5584,
     /* 107977 */     GIR_EraseRootFromParent_Done,
     /* 107978 */   // Label 2030: @107978
     /* 107978 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(108044), // Rule ID 945 //
     /* 107983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 108006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108018 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 108018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 108021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108023 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108042 */     GIR_RootConstrainSelectedInstOperands,
     /* 108043 */     // GIR_Coverage, 945,
     /* 108043 */     GIR_EraseRootFromParent_Done,
     /* 108044 */   // Label 2031: @108044
     /* 108044 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(108080), // Rule ID 766 //
     /* 108049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108060 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 108060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 108063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108078 */     GIR_RootConstrainSelectedInstOperands,
     /* 108079 */     // GIR_Coverage, 766,
     /* 108079 */     GIR_EraseRootFromParent_Done,
     /* 108080 */   // Label 2032: @108080
     /* 108080 */   GIM_Reject,
     /* 108081 */ // Label 2029: @108081
     /* 108081 */ GIM_Reject,
     /* 108082 */ // Label 2016: @108082
     /* 108082 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(108195),
     /* 108087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 108093 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(108133), // Rule ID 765 //
     /* 108098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 108101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108113 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 108113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 108116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108131 */     GIR_RootConstrainSelectedInstOperands,
     /* 108132 */     // GIR_Coverage, 765,
     /* 108132 */     GIR_EraseRootFromParent_Done,
     /* 108133 */   // Label 2034: @108133
     /* 108133 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(108194), // Rule ID 4016 //
     /* 108138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108153 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 108153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 108168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108192 */     GIR_RootConstrainSelectedInstOperands,
     /* 108193 */     // GIR_Coverage, 4016,
     /* 108193 */     GIR_EraseRootFromParent_Done,
     /* 108194 */   // Label 2035: @108194
     /* 108194 */   GIM_Reject,
     /* 108195 */ // Label 2033: @108195
     /* 108195 */ GIM_Reject,
     /* 108196 */ // Label 2017: @108196
     /* 108196 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(108449),
     /* 108201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108207 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(108277), // Rule ID 5585 //
     /* 108212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108251 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108256 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108275 */     GIR_RootConstrainSelectedInstOperands,
     /* 108276 */     // GIR_Coverage, 5585,
     /* 108276 */     GIR_EraseRootFromParent_Done,
     /* 108277 */   // Label 2037: @108277
     /* 108277 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(108347), // Rule ID 946 //
     /* 108282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108321 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108326 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108345 */     GIR_RootConstrainSelectedInstOperands,
     /* 108346 */     // GIR_Coverage, 946,
     /* 108346 */     GIR_EraseRootFromParent_Done,
     /* 108347 */   // Label 2038: @108347
     /* 108347 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108387), // Rule ID 767 //
     /* 108352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108367 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 108370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108385 */     GIR_RootConstrainSelectedInstOperands,
     /* 108386 */     // GIR_Coverage, 767,
     /* 108386 */     GIR_EraseRootFromParent_Done,
     /* 108387 */   // Label 2039: @108387
     /* 108387 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(108448), // Rule ID 4020 //
     /* 108392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108407 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 108407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 108422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108446 */     GIR_RootConstrainSelectedInstOperands,
     /* 108447 */     // GIR_Coverage, 4020,
     /* 108447 */     GIR_EraseRootFromParent_Done,
     /* 108448 */   // Label 2040: @108448
     /* 108448 */   GIM_Reject,
     /* 108449 */ // Label 2036: @108449
     /* 108449 */ GIM_Reject,
     /* 108450 */ // Label 2018: @108450
     /* 108450 */ GIM_Reject,
     /* 108451 */ // Label 35: @108451
     /* 108451 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2048*/ GIMT_Encode4(110127),
     /* 108462 */ /*GILLT_s16*//*Label 2041*/ GIMT_Encode4(108514),
     /* 108466 */ /*GILLT_s32*//*Label 2042*/ GIMT_Encode4(108561),
     /* 108470 */ /*GILLT_s64*//*Label 2043*/ GIMT_Encode4(109488), GIMT_Encode4(0),
     /* 108478 */ /*GILLT_v2s32*//*Label 2044*/ GIMT_Encode4(109535), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108490 */ /*GILLT_v4s16*//*Label 2045*/ GIMT_Encode4(109582),
     /* 108494 */ /*GILLT_v4s32*//*Label 2046*/ GIMT_Encode4(109759), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108510 */ /*GILLT_v8s16*//*Label 2047*/ GIMT_Encode4(109873),
     /* 108514 */ // Label 2041: @108514
     /* 108514 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(108560), // Rule ID 617 //
     /* 108519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 108522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 108525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 108528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108540 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 108540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 108543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108545 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108547 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108552 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108558 */   GIR_RootConstrainSelectedInstOperands,
     /* 108559 */   // GIR_Coverage, 617,
     /* 108559 */   GIR_EraseRootFromParent_Done,
     /* 108560 */ // Label 2049: @108560
     /* 108560 */ GIM_Reject,
     /* 108561 */ // Label 2042: @108561
     /* 108561 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109487),
     /* 108566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108580 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(108904), // Rule ID 2701 //
     /* 108585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 108588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108616 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108616 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108619 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108623 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108630 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108633 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108637 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108642 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108645 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108650 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108653 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108657 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108662 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108665 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108669 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108672 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108677 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108682 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108687 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108690 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108694 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108701 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108704 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108708 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108713 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108716 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108721 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108724 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108728 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108733 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108736 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108740 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108743 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108748 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108753 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108758 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108761 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108765 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108772 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108775 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108779 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108784 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108787 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108792 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108795 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108799 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108804 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108807 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108811 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108814 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108819 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108824 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108841 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108844 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108847 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108850 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108853 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108886 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108903 */     // GIR_Coverage, 2701,
     /* 108903 */     GIR_EraseRootFromParent_Done,
     /* 108904 */   // Label 2051: @108904
     /* 108904 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109228), // Rule ID 2703 //
     /* 108909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108940 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108940 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108943 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108947 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108954 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108957 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108961 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108966 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108969 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108974 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108977 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108981 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108986 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108989 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108993 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108996 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109001 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109006 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109011 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 109014 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109018 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 109025 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109028 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109032 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109037 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109040 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109045 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109048 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109052 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109057 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109060 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 109064 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109067 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109072 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109077 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109082 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109085 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109089 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109096 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109099 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109103 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109108 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109111 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109116 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109119 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109123 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109128 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109131 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 109135 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109138 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109143 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109148 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109153 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109156 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 109160 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109165 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109168 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109171 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 109174 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109177 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109197 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109210 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109227 */     // GIR_Coverage, 2703,
     /* 109227 */     GIR_EraseRootFromParent_Done,
     /* 109228 */   // Label 2052: @109228
     /* 109228 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(109260), // Rule ID 616 //
     /* 109233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 109236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109240 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 109240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 109243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109258 */     GIR_RootConstrainSelectedInstOperands,
     /* 109259 */     // GIR_Coverage, 616,
     /* 109259 */     GIR_EraseRootFromParent_Done,
     /* 109260 */   // Label 2053: @109260
     /* 109260 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109486), // Rule ID 2698 //
     /* 109265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 109268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109272 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 109272 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 109275 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109279 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 109286 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109289 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109293 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109298 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109301 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109306 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109309 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109313 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109318 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109321 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 109325 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109328 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109333 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109338 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109343 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109346 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109350 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109357 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109360 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109364 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109369 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109372 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109377 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109380 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109384 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109389 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109392 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109396 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109399 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109404 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109409 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109429 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109432 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109435 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109468 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109485 */     // GIR_Coverage, 2698,
     /* 109485 */     GIR_EraseRootFromParent_Done,
     /* 109486 */   // Label 2054: @109486
     /* 109486 */   GIM_Reject,
     /* 109487 */ // Label 2050: @109487
     /* 109487 */ GIM_Reject,
     /* 109488 */ // Label 2043: @109488
     /* 109488 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109534), // Rule ID 615 //
     /* 109493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 109496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 109502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109514 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 109514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 109517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 109519 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 109521 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 109523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109526 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109532 */   GIR_RootConstrainSelectedInstOperands,
     /* 109533 */   // GIR_Coverage, 615,
     /* 109533 */   GIR_EraseRootFromParent_Done,
     /* 109534 */ // Label 2055: @109534
     /* 109534 */ GIM_Reject,
     /* 109535 */ // Label 2044: @109535
     /* 109535 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109581), // Rule ID 968 //
     /* 109540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 109549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109561 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 109561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109566 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109568 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109573 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109579 */   GIR_RootConstrainSelectedInstOperands,
     /* 109580 */   // GIR_Coverage, 968,
     /* 109580 */   GIR_EraseRootFromParent_Done,
     /* 109581 */ // Label 2056: @109581
     /* 109581 */ GIM_Reject,
     /* 109582 */ // Label 2045: @109582
     /* 109582 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109758),
     /* 109587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109601 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109663), // Rule ID 923 //
     /* 109606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109637 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109642 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109661 */     GIR_RootConstrainSelectedInstOperands,
     /* 109662 */     // GIR_Coverage, 923,
     /* 109662 */     GIR_EraseRootFromParent_Done,
     /* 109663 */   // Label 2058: @109663
     /* 109663 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109725), // Rule ID 949 //
     /* 109668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109699 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109723 */     GIR_RootConstrainSelectedInstOperands,
     /* 109724 */     // GIR_Coverage, 949,
     /* 109724 */     GIR_EraseRootFromParent_Done,
     /* 109725 */   // Label 2059: @109725
     /* 109725 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109757), // Rule ID 970 //
     /* 109730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109737 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109755 */     GIR_RootConstrainSelectedInstOperands,
     /* 109756 */     // GIR_Coverage, 970,
     /* 109756 */     GIR_EraseRootFromParent_Done,
     /* 109757 */   // Label 2060: @109757
     /* 109757 */   GIM_Reject,
     /* 109758 */ // Label 2057: @109758
     /* 109758 */ GIM_Reject,
     /* 109759 */ // Label 2046: @109759
     /* 109759 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109872),
     /* 109764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109770 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109810), // Rule ID 969 //
     /* 109775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109790 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109808 */     GIR_RootConstrainSelectedInstOperands,
     /* 109809 */     // GIR_Coverage, 969,
     /* 109809 */     GIR_EraseRootFromParent_Done,
     /* 109810 */   // Label 2062: @109810
     /* 109810 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109871), // Rule ID 4024 //
     /* 109815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109830 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109869 */     GIR_RootConstrainSelectedInstOperands,
     /* 109870 */     // GIR_Coverage, 4024,
     /* 109870 */     GIR_EraseRootFromParent_Done,
     /* 109871 */   // Label 2063: @109871
     /* 109871 */   GIM_Reject,
     /* 109872 */ // Label 2061: @109872
     /* 109872 */ GIM_Reject,
     /* 109873 */ // Label 2047: @109873
     /* 109873 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(110126),
     /* 109878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109884 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109954), // Rule ID 924 //
     /* 109889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109928 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109933 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109952 */     GIR_RootConstrainSelectedInstOperands,
     /* 109953 */     // GIR_Coverage, 924,
     /* 109953 */     GIR_EraseRootFromParent_Done,
     /* 109954 */   // Label 2065: @109954
     /* 109954 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(110024), // Rule ID 950 //
     /* 109959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109998 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 110001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110003 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 110005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 110009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 110013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110022 */     GIR_RootConstrainSelectedInstOperands,
     /* 110023 */     // GIR_Coverage, 950,
     /* 110023 */     GIR_EraseRootFromParent_Done,
     /* 110024 */   // Label 2066: @110024
     /* 110024 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(110064), // Rule ID 971 //
     /* 110029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110044 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 110047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110062 */     GIR_RootConstrainSelectedInstOperands,
     /* 110063 */     // GIR_Coverage, 971,
     /* 110063 */     GIR_EraseRootFromParent_Done,
     /* 110064 */   // Label 2067: @110064
     /* 110064 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(110125), // Rule ID 4028 //
     /* 110069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110084 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 110099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110123 */     GIR_RootConstrainSelectedInstOperands,
     /* 110124 */     // GIR_Coverage, 4028,
     /* 110124 */     GIR_EraseRootFromParent_Done,
     /* 110125 */   // Label 2068: @110125
     /* 110125 */   GIM_Reject,
     /* 110126 */ // Label 2064: @110126
     /* 110126 */ GIM_Reject,
     /* 110127 */ // Label 2048: @110127
     /* 110127 */ GIM_Reject,
     /* 110128 */ // Label 36: @110128
     /* 110128 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2076*/ GIMT_Encode4(111108),
     /* 110139 */ /*GILLT_s16*//*Label 2069*/ GIMT_Encode4(110191),
     /* 110143 */ /*GILLT_s32*//*Label 2070*/ GIMT_Encode4(110238),
     /* 110147 */ /*GILLT_s64*//*Label 2071*/ GIMT_Encode4(110627), GIMT_Encode4(0),
     /* 110155 */ /*GILLT_v2s32*//*Label 2072*/ GIMT_Encode4(110786), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110167 */ /*GILLT_v4s16*//*Label 2073*/ GIMT_Encode4(110833),
     /* 110171 */ /*GILLT_v4s32*//*Label 2074*/ GIMT_Encode4(110880), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110187 */ /*GILLT_v8s16*//*Label 2075*/ GIMT_Encode4(110994),
     /* 110191 */ // Label 2069: @110191
     /* 110191 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110237), // Rule ID 623 //
     /* 110196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110217 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 110220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110222 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110224 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110229 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110235 */   GIR_RootConstrainSelectedInstOperands,
     /* 110236 */   // GIR_Coverage, 623,
     /* 110236 */   GIR_EraseRootFromParent_Done,
     /* 110237 */ // Label 2077: @110237
     /* 110237 */ GIM_Reject,
     /* 110238 */ // Label 2070: @110238
     /* 110238 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110626),
     /* 110243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 110249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110253 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110306), // Rule ID 2302 //
     /* 110258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110284 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110293 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110304 */     GIR_RootConstrainSelectedInstOperands,
     /* 110305 */     // GIR_Coverage, 2302,
     /* 110305 */     GIR_EraseRootFromParent_Done,
     /* 110306 */   // Label 2079: @110306
     /* 110306 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110359), // Rule ID 5711 //
     /* 110311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110337 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110346 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110357 */     GIR_RootConstrainSelectedInstOperands,
     /* 110358 */     // GIR_Coverage, 5711,
     /* 110358 */     GIR_EraseRootFromParent_Done,
     /* 110359 */   // Label 2080: @110359
     /* 110359 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110395), // Rule ID 622 //
     /* 110364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 110367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110375 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 110375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 110378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110393 */     GIR_RootConstrainSelectedInstOperands,
     /* 110394 */     // GIR_Coverage, 622,
     /* 110394 */     GIR_EraseRootFromParent_Done,
     /* 110395 */   // Label 2081: @110395
     /* 110395 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110625), // Rule ID 2699 //
     /* 110400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 110403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110411 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 110411 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 110414 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110418 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 110425 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 110428 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110432 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110437 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 110440 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110445 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 110448 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110452 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110457 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 110460 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 110464 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 110467 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110472 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110477 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110482 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 110485 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110489 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 110496 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 110499 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110503 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110508 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 110511 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110516 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 110519 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110523 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110528 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 110531 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 110535 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 110538 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110543 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110548 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 110556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110565 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110568 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 110571 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 110574 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 110585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110594 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110607 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 110614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110624 */     // GIR_Coverage, 2699,
     /* 110624 */     GIR_EraseRootFromParent_Done,
     /* 110625 */   // Label 2082: @110625
     /* 110625 */   GIM_Reject,
     /* 110626 */ // Label 2078: @110626
     /* 110626 */ GIM_Reject,
     /* 110627 */ // Label 2071: @110627
     /* 110627 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110785),
     /* 110632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110642 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110695), // Rule ID 2301 //
     /* 110647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110673 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110682 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110693 */     GIR_RootConstrainSelectedInstOperands,
     /* 110694 */     // GIR_Coverage, 2301,
     /* 110694 */     GIR_EraseRootFromParent_Done,
     /* 110695 */   // Label 2084: @110695
     /* 110695 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110748), // Rule ID 5710 //
     /* 110700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110726 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110735 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110746 */     GIR_RootConstrainSelectedInstOperands,
     /* 110747 */     // GIR_Coverage, 5710,
     /* 110747 */     GIR_EraseRootFromParent_Done,
     /* 110748 */   // Label 2085: @110748
     /* 110748 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110784), // Rule ID 621 //
     /* 110753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110764 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110782 */     GIR_RootConstrainSelectedInstOperands,
     /* 110783 */     // GIR_Coverage, 621,
     /* 110783 */     GIR_EraseRootFromParent_Done,
     /* 110784 */   // Label 2086: @110784
     /* 110784 */   GIM_Reject,
     /* 110785 */ // Label 2083: @110785
     /* 110785 */ GIM_Reject,
     /* 110786 */ // Label 2072: @110786
     /* 110786 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110832), // Rule ID 843 //
     /* 110791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110812 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110817 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110819 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110830 */   GIR_RootConstrainSelectedInstOperands,
     /* 110831 */   // GIR_Coverage, 843,
     /* 110831 */   GIR_EraseRootFromParent_Done,
     /* 110832 */ // Label 2087: @110832
     /* 110832 */ GIM_Reject,
     /* 110833 */ // Label 2073: @110833
     /* 110833 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110879), // Rule ID 845 //
     /* 110838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110859 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110864 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110866 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110871 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110877 */   GIR_RootConstrainSelectedInstOperands,
     /* 110878 */   // GIR_Coverage, 845,
     /* 110878 */   GIR_EraseRootFromParent_Done,
     /* 110879 */ // Label 2088: @110879
     /* 110879 */ GIM_Reject,
     /* 110880 */ // Label 2074: @110880
     /* 110880 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110993),
     /* 110885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110891 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110931), // Rule ID 844 //
     /* 110896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110911 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110929 */     GIR_RootConstrainSelectedInstOperands,
     /* 110930 */     // GIR_Coverage, 844,
     /* 110930 */     GIR_EraseRootFromParent_Done,
     /* 110931 */   // Label 2090: @110931
     /* 110931 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(110992), // Rule ID 3988 //
     /* 110936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110951 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110990 */     GIR_RootConstrainSelectedInstOperands,
     /* 110991 */     // GIR_Coverage, 3988,
     /* 110991 */     GIR_EraseRootFromParent_Done,
     /* 110992 */   // Label 2091: @110992
     /* 110992 */   GIM_Reject,
     /* 110993 */ // Label 2089: @110993
     /* 110993 */ GIM_Reject,
     /* 110994 */ // Label 2075: @110994
     /* 110994 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(111107),
     /* 110999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 111005 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(111045), // Rule ID 846 //
     /* 111010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 111013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111025 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 111025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 111028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 111032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 111034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111043 */     GIR_RootConstrainSelectedInstOperands,
     /* 111044 */     // GIR_Coverage, 846,
     /* 111044 */     GIR_EraseRootFromParent_Done,
     /* 111045 */   // Label 2093: @111045
     /* 111045 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(111106), // Rule ID 3992 //
     /* 111050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 111053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 111057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 111061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 111065 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 111065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 111068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 111072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 111080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 111082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 111084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 111086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111104 */     GIR_RootConstrainSelectedInstOperands,
     /* 111105 */     // GIR_Coverage, 3992,
     /* 111105 */     GIR_EraseRootFromParent_Done,
     /* 111106 */   // Label 2094: @111106
     /* 111106 */   GIM_Reject,
     /* 111107 */ // Label 2092: @111107
     /* 111107 */ GIM_Reject,
     /* 111108 */ // Label 2076: @111108
     /* 111108 */ GIM_Reject,
     /* 111109 */ // Label 37: @111109
     /* 111109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2102*/ GIMT_Encode4(113199),
     /* 111120 */ /*GILLT_s16*//*Label 2095*/ GIMT_Encode4(111172),
     /* 111124 */ /*GILLT_s32*//*Label 2096*/ GIMT_Encode4(111559),
     /* 111128 */ /*GILLT_s64*//*Label 2097*/ GIMT_Encode4(111946), GIMT_Encode4(0),
     /* 111136 */ /*GILLT_v2s32*//*Label 2098*/ GIMT_Encode4(112333), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111148 */ /*GILLT_v4s16*//*Label 2099*/ GIMT_Encode4(112513),
     /* 111152 */ /*GILLT_v4s32*//*Label 2100*/ GIMT_Encode4(112569), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111168 */ /*GILLT_v8s16*//*Label 2101*/ GIMT_Encode4(112947),
     /* 111172 */ // Label 2095: @111172
     /* 111172 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(111558),
     /* 111177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 111180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 111183 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 111186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111190 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(111264), // Rule ID 2406 //
     /* 111195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111238 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111262 */     GIR_RootConstrainSelectedInstOperands,
     /* 111263 */     // GIR_Coverage, 2406,
     /* 111263 */     GIR_EraseRootFromParent_Done,
     /* 111264 */   // Label 2104: @111264
     /* 111264 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(111338), // Rule ID 5719 //
     /* 111269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111312 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111336 */     GIR_RootConstrainSelectedInstOperands,
     /* 111337 */     // GIR_Coverage, 5719,
     /* 111337 */     GIR_EraseRootFromParent_Done,
     /* 111338 */   // Label 2105: @111338
     /* 111338 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(111397), // Rule ID 2398 //
     /* 111343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111373 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111395 */     GIR_RootConstrainSelectedInstOperands,
     /* 111396 */     // GIR_Coverage, 2398,
     /* 111396 */     GIR_EraseRootFromParent_Done,
     /* 111397 */   // Label 2106: @111397
     /* 111397 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(111456), // Rule ID 5716 //
     /* 111402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111432 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111454 */     GIR_RootConstrainSelectedInstOperands,
     /* 111455 */     // GIR_Coverage, 5716,
     /* 111455 */     GIR_EraseRootFromParent_Done,
     /* 111456 */   // Label 2107: @111456
     /* 111456 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111515), // Rule ID 2411 //
     /* 111461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111491 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 111494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111513 */     GIR_RootConstrainSelectedInstOperands,
     /* 111514 */     // GIR_Coverage, 2411,
     /* 111514 */     GIR_EraseRootFromParent_Done,
     /* 111515 */   // Label 2108: @111515
     /* 111515 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111557), // Rule ID 2392 //
     /* 111520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111535 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 111538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111555 */     GIR_RootConstrainSelectedInstOperands,
     /* 111556 */     // GIR_Coverage, 2392,
     /* 111556 */     GIR_EraseRootFromParent_Done,
     /* 111557 */   // Label 2109: @111557
     /* 111557 */   GIM_Reject,
     /* 111558 */ // Label 2103: @111558
     /* 111558 */ GIM_Reject,
     /* 111559 */ // Label 2096: @111559
     /* 111559 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(111945),
     /* 111564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 111567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 111570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 111573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111577 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(111651), // Rule ID 2405 //
     /* 111582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111625 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111649 */     GIR_RootConstrainSelectedInstOperands,
     /* 111650 */     // GIR_Coverage, 2405,
     /* 111650 */     GIR_EraseRootFromParent_Done,
     /* 111651 */   // Label 2111: @111651
     /* 111651 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(111725), // Rule ID 5718 //
     /* 111656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111699 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111723 */     GIR_RootConstrainSelectedInstOperands,
     /* 111724 */     // GIR_Coverage, 5718,
     /* 111724 */     GIR_EraseRootFromParent_Done,
     /* 111725 */   // Label 2112: @111725
     /* 111725 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(111784), // Rule ID 2397 //
     /* 111730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111760 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111782 */     GIR_RootConstrainSelectedInstOperands,
     /* 111783 */     // GIR_Coverage, 2397,
     /* 111783 */     GIR_EraseRootFromParent_Done,
     /* 111784 */   // Label 2113: @111784
     /* 111784 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(111843), // Rule ID 5715 //
     /* 111789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111819 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111841 */     GIR_RootConstrainSelectedInstOperands,
     /* 111842 */     // GIR_Coverage, 5715,
     /* 111842 */     GIR_EraseRootFromParent_Done,
     /* 111843 */   // Label 2114: @111843
     /* 111843 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(111902), // Rule ID 2410 //
     /* 111848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111878 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111900 */     GIR_RootConstrainSelectedInstOperands,
     /* 111901 */     // GIR_Coverage, 2410,
     /* 111901 */     GIR_EraseRootFromParent_Done,
     /* 111902 */   // Label 2115: @111902
     /* 111902 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(111944), // Rule ID 2391 //
     /* 111907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111922 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111942 */     GIR_RootConstrainSelectedInstOperands,
     /* 111943 */     // GIR_Coverage, 2391,
     /* 111943 */     GIR_EraseRootFromParent_Done,
     /* 111944 */   // Label 2116: @111944
     /* 111944 */   GIM_Reject,
     /* 111945 */ // Label 2110: @111945
     /* 111945 */ GIM_Reject,
     /* 111946 */ // Label 2097: @111946
     /* 111946 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(112332),
     /* 111951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111964 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(112038), // Rule ID 2404 //
     /* 111969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 112005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112012 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 112015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 112021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112036 */     GIR_RootConstrainSelectedInstOperands,
     /* 112037 */     // GIR_Coverage, 2404,
     /* 112037 */     GIR_EraseRootFromParent_Done,
     /* 112038 */   // Label 2118: @112038
     /* 112038 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(112112), // Rule ID 5717 //
     /* 112043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 112071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 112079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112086 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 112089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 112095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 112101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112110 */     GIR_RootConstrainSelectedInstOperands,
     /* 112111 */     // GIR_Coverage, 5717,
     /* 112111 */     GIR_EraseRootFromParent_Done,
     /* 112112 */   // Label 2119: @112112
     /* 112112 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(112171), // Rule ID 2396 //
     /* 112117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112147 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112169 */     GIR_RootConstrainSelectedInstOperands,
     /* 112170 */     // GIR_Coverage, 2396,
     /* 112170 */     GIR_EraseRootFromParent_Done,
     /* 112171 */   // Label 2120: @112171
     /* 112171 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(112230), // Rule ID 5714 //
     /* 112176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112206 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 112219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112228 */     GIR_RootConstrainSelectedInstOperands,
     /* 112229 */     // GIR_Coverage, 5714,
     /* 112229 */     GIR_EraseRootFromParent_Done,
     /* 112230 */   // Label 2121: @112230
     /* 112230 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(112289), // Rule ID 2409 //
     /* 112235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 112250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112265 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 112268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 112274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112281 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112287 */     GIR_RootConstrainSelectedInstOperands,
     /* 112288 */     // GIR_Coverage, 2409,
     /* 112288 */     GIR_EraseRootFromParent_Done,
     /* 112289 */   // Label 2122: @112289
     /* 112289 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(112331), // Rule ID 2390 //
     /* 112294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112309 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 112312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112329 */     GIR_RootConstrainSelectedInstOperands,
     /* 112330 */     // GIR_Coverage, 2390,
     /* 112330 */     GIR_EraseRootFromParent_Done,
     /* 112331 */   // Label 2123: @112331
     /* 112331 */   GIM_Reject,
     /* 112332 */ // Label 2117: @112332
     /* 112332 */ GIM_Reject,
     /* 112333 */ // Label 2098: @112333
     /* 112333 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(112512),
     /* 112338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 112344 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 112347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112351 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(112410), // Rule ID 2503 //
     /* 112356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112386 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112391 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112408 */     GIR_RootConstrainSelectedInstOperands,
     /* 112409 */     // GIR_Coverage, 2503,
     /* 112409 */     GIR_EraseRootFromParent_Done,
     /* 112410 */   // Label 2125: @112410
     /* 112410 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(112469), // Rule ID 5757 //
     /* 112415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112445 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112450 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112467 */     GIR_RootConstrainSelectedInstOperands,
     /* 112468 */     // GIR_Coverage, 5757,
     /* 112468 */     GIR_EraseRootFromParent_Done,
     /* 112469 */   // Label 2126: @112469
     /* 112469 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112511), // Rule ID 2501 //
     /* 112474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112489 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 112492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112494 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112509 */     GIR_RootConstrainSelectedInstOperands,
     /* 112510 */     // GIR_Coverage, 2501,
     /* 112510 */     GIR_EraseRootFromParent_Done,
     /* 112511 */   // Label 2127: @112511
     /* 112511 */   GIM_Reject,
     /* 112512 */ // Label 2124: @112512
     /* 112512 */ GIM_Reject,
     /* 112513 */ // Label 2099: @112513
     /* 112513 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112568), // Rule ID 2499 //
     /* 112518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 112527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 112530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112542 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112546 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 112546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 112549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112551 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112553 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112555 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112560 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112566 */   GIR_RootConstrainSelectedInstOperands,
     /* 112567 */   // GIR_Coverage, 2499,
     /* 112567 */   GIR_EraseRootFromParent_Done,
     /* 112568 */ // Label 2128: @112568
     /* 112568 */ GIM_Reject,
     /* 112569 */ // Label 2100: @112569
     /* 112569 */ GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112946),
     /* 112574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 112580 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 112583 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112646), // Rule ID 2504 //
     /* 112588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112622 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112627 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112644 */     GIR_RootConstrainSelectedInstOperands,
     /* 112645 */     // GIR_Coverage, 2504,
     /* 112645 */     GIR_EraseRootFromParent_Done,
     /* 112646 */   // Label 2130: @112646
     /* 112646 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112715), // Rule ID 4002 //
     /* 112651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112685 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112690 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112696 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112713 */     GIR_RootConstrainSelectedInstOperands,
     /* 112714 */     // GIR_Coverage, 4002,
     /* 112714 */     GIR_EraseRootFromParent_Done,
     /* 112715 */   // Label 2131: @112715
     /* 112715 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112778), // Rule ID 5758 //
     /* 112720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112754 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112759 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112776 */     GIR_RootConstrainSelectedInstOperands,
     /* 112777 */     // GIR_Coverage, 5758,
     /* 112777 */     GIR_EraseRootFromParent_Done,
     /* 112778 */   // Label 2132: @112778
     /* 112778 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112847), // Rule ID 6038 //
     /* 112783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112817 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112822 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112828 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112845 */     GIR_RootConstrainSelectedInstOperands,
     /* 112846 */     // GIR_Coverage, 6038,
     /* 112846 */     GIR_EraseRootFromParent_Done,
     /* 112847 */   // Label 2133: @112847
     /* 112847 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112893), // Rule ID 2502 //
     /* 112852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112871 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112876 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112891 */     GIR_RootConstrainSelectedInstOperands,
     /* 112892 */     // GIR_Coverage, 2502,
     /* 112892 */     GIR_EraseRootFromParent_Done,
     /* 112893 */   // Label 2134: @112893
     /* 112893 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112945), // Rule ID 4006 //
     /* 112898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112917 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112922 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112924 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112926 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112943 */     GIR_RootConstrainSelectedInstOperands,
     /* 112944 */     // GIR_Coverage, 4006,
     /* 112944 */     GIR_EraseRootFromParent_Done,
     /* 112945 */   // Label 2135: @112945
     /* 112945 */   GIM_Reject,
     /* 112946 */ // Label 2129: @112946
     /* 112946 */ GIM_Reject,
     /* 112947 */ // Label 2101: @112947
     /* 112947 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113198),
     /* 112952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112958 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112961 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(113030), // Rule ID 4012 //
     /* 112966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113000 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 113000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 113003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 113005 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 113007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 113011 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 113013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113028 */     GIR_RootConstrainSelectedInstOperands,
     /* 113029 */     // GIR_Coverage, 4012,
     /* 113029 */     GIR_EraseRootFromParent_Done,
     /* 113030 */   // Label 2137: @113030
     /* 113030 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(113099), // Rule ID 6040 //
     /* 113035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 113038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 113050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113069 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 113069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 113072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 113074 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 113076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 113080 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 113082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113097 */     GIR_RootConstrainSelectedInstOperands,
     /* 113098 */     // GIR_Coverage, 6040,
     /* 113098 */     GIR_EraseRootFromParent_Done,
     /* 113099 */   // Label 2138: @113099
     /* 113099 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(113145), // Rule ID 2500 //
     /* 113104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 113107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 113111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 113115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 113119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 113123 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 113123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 113126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 113128 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 113130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 113132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 113134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113143 */     GIR_RootConstrainSelectedInstOperands,
     /* 113144 */     // GIR_Coverage, 2500,
     /* 113144 */     GIR_EraseRootFromParent_Done,
     /* 113145 */   // Label 2139: @113145
     /* 113145 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(113197), // Rule ID 4009 //
     /* 113150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 113153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113169 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 113169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 113172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 113174 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 113176 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 113178 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 113180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113195 */     GIR_RootConstrainSelectedInstOperands,
     /* 113196 */     // GIR_Coverage, 4009,
     /* 113196 */     GIR_EraseRootFromParent_Done,
     /* 113197 */   // Label 2140: @113197
     /* 113197 */   GIM_Reject,
     /* 113198 */ // Label 2136: @113198
     /* 113198 */ GIM_Reject,
     /* 113199 */ // Label 2102: @113199
     /* 113199 */ GIM_Reject,
     /* 113200 */ // Label 38: @113200
     /* 113200 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2144*/ GIMT_Encode4(113364),
     /* 113211 */ /*GILLT_s16*//*Label 2141*/ GIMT_Encode4(113223),
     /* 113215 */ /*GILLT_s32*//*Label 2142*/ GIMT_Encode4(113270),
     /* 113219 */ /*GILLT_s64*//*Label 2143*/ GIMT_Encode4(113317),
     /* 113223 */ // Label 2141: @113223
     /* 113223 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113269), // Rule ID 620 //
     /* 113228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 113237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113249 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 113252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113254 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113256 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113261 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113267 */   GIR_RootConstrainSelectedInstOperands,
     /* 113268 */   // GIR_Coverage, 620,
     /* 113268 */   GIR_EraseRootFromParent_Done,
     /* 113269 */ // Label 2145: @113269
     /* 113269 */ GIM_Reject,
     /* 113270 */ // Label 2142: @113270
     /* 113270 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113316), // Rule ID 619 //
     /* 113275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 113284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113296 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 113299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113301 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113303 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113308 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113314 */   GIR_RootConstrainSelectedInstOperands,
     /* 113315 */   // GIR_Coverage, 619,
     /* 113315 */   GIR_EraseRootFromParent_Done,
     /* 113316 */ // Label 2146: @113316
     /* 113316 */ GIM_Reject,
     /* 113317 */ // Label 2143: @113317
     /* 113317 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113363), // Rule ID 618 //
     /* 113322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 113331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113343 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 113346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113348 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 113350 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 113352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113361 */   GIR_RootConstrainSelectedInstOperands,
     /* 113362 */   // GIR_Coverage, 618,
     /* 113362 */   GIR_EraseRootFromParent_Done,
     /* 113363 */ // Label 2147: @113363
     /* 113363 */ GIM_Reject,
     /* 113364 */ // Label 2144: @113364
     /* 113364 */ GIM_Reject,
     /* 113365 */ // Label 39: @113365
     /* 113365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2155*/ GIMT_Encode4(114895),
     /* 113376 */ /*GILLT_s16*//*Label 2148*/ GIMT_Encode4(113428),
     /* 113380 */ /*GILLT_s32*//*Label 2149*/ GIMT_Encode4(113775),
     /* 113384 */ /*GILLT_s64*//*Label 2150*/ GIMT_Encode4(114274), GIMT_Encode4(0),
     /* 113392 */ /*GILLT_v2s32*//*Label 2151*/ GIMT_Encode4(114621), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113404 */ /*GILLT_v4s16*//*Label 2152*/ GIMT_Encode4(114659),
     /* 113408 */ /*GILLT_v4s32*//*Label 2153*/ GIMT_Encode4(114697), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113424 */ /*GILLT_v8s16*//*Label 2154*/ GIMT_Encode4(114796),
     /* 113428 */ // Label 2148: @113428
     /* 113428 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113774),
     /* 113433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113440 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113525), // Rule ID 2414 //
     /* 113445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113464 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113497 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113523 */     GIR_RootConstrainSelectedInstOperands,
     /* 113524 */     // GIR_Coverage, 2414,
     /* 113524 */     GIR_EraseRootFromParent_Done,
     /* 113525 */   // Label 2157: @113525
     /* 113525 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113610), // Rule ID 5722 //
     /* 113530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113582 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113608 */     GIR_RootConstrainSelectedInstOperands,
     /* 113609 */     // GIR_Coverage, 5722,
     /* 113609 */     GIR_EraseRootFromParent_Done,
     /* 113610 */   // Label 2158: @113610
     /* 113610 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113683), // Rule ID 2403 //
     /* 113615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113634 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113655 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113681 */     GIR_RootConstrainSelectedInstOperands,
     /* 113682 */     // GIR_Coverage, 2403,
     /* 113682 */     GIR_EraseRootFromParent_Done,
     /* 113683 */   // Label 2159: @113683
     /* 113683 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113743), // Rule ID 626 //
     /* 113688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113719 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113741 */     GIR_RootConstrainSelectedInstOperands,
     /* 113742 */     // GIR_Coverage, 626,
     /* 113742 */     GIR_EraseRootFromParent_Done,
     /* 113743 */   // Label 2160: @113743
     /* 113743 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113773), // Rule ID 664 //
     /* 113748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113755 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113771 */     GIR_RootConstrainSelectedInstOperands,
     /* 113772 */     // GIR_Coverage, 664,
     /* 113772 */     GIR_EraseRootFromParent_Done,
     /* 113773 */   // Label 2161: @113773
     /* 113773 */   GIM_Reject,
     /* 113774 */ // Label 2156: @113774
     /* 113774 */ GIM_Reject,
     /* 113775 */ // Label 2149: @113775
     /* 113775 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(114273),
     /* 113780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113787 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113872), // Rule ID 2413 //
     /* 113792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113811 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113844 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113870 */     GIR_RootConstrainSelectedInstOperands,
     /* 113871 */     // GIR_Coverage, 2413,
     /* 113871 */     GIR_EraseRootFromParent_Done,
     /* 113872 */   // Label 2163: @113872
     /* 113872 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113957), // Rule ID 5721 //
     /* 113877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113896 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113929 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113955 */     GIR_RootConstrainSelectedInstOperands,
     /* 113956 */     // GIR_Coverage, 5721,
     /* 113956 */     GIR_EraseRootFromParent_Done,
     /* 113957 */   // Label 2164: @113957
     /* 113957 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(114030), // Rule ID 2402 //
     /* 113962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113981 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114002 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 114002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 114005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 114011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 114015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 114019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114028 */     GIR_RootConstrainSelectedInstOperands,
     /* 114029 */     // GIR_Coverage, 2402,
     /* 114029 */     GIR_EraseRootFromParent_Done,
     /* 114030 */   // Label 2165: @114030
     /* 114030 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(114090), // Rule ID 625 //
     /* 114035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 114038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 114050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114066 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 114066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 114069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 114075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 114079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114088 */     GIR_RootConstrainSelectedInstOperands,
     /* 114089 */     // GIR_Coverage, 625,
     /* 114089 */     GIR_EraseRootFromParent_Done,
     /* 114090 */   // Label 2166: @114090
     /* 114090 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(114120), // Rule ID 663 //
     /* 114095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 114098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114102 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 114102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 114105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114118 */     GIR_RootConstrainSelectedInstOperands,
     /* 114119 */     // GIR_Coverage, 663,
     /* 114119 */     GIR_EraseRootFromParent_Done,
     /* 114120 */   // Label 2167: @114120
     /* 114120 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114272), // Rule ID 2705 //
     /* 114125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 114128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114132 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 114132 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 114135 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114139 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 114146 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 114149 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114153 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114158 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 114161 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114166 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 114169 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 114173 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114178 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 114181 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 114185 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 114188 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114193 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114198 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114215 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 114218 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 114221 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 114232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114241 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114254 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 114261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114271 */     // GIR_Coverage, 2705,
     /* 114271 */     GIR_EraseRootFromParent_Done,
     /* 114272 */   // Label 2168: @114272
     /* 114272 */   GIM_Reject,
     /* 114273 */ // Label 2162: @114273
     /* 114273 */ GIM_Reject,
     /* 114274 */ // Label 2150: @114274
     /* 114274 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114620),
     /* 114279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114286 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114371), // Rule ID 2412 //
     /* 114291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114310 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114343 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114369 */     GIR_RootConstrainSelectedInstOperands,
     /* 114370 */     // GIR_Coverage, 2412,
     /* 114370 */     GIR_EraseRootFromParent_Done,
     /* 114371 */   // Label 2170: @114371
     /* 114371 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114456), // Rule ID 5720 //
     /* 114376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114395 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114428 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 114445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114454 */     GIR_RootConstrainSelectedInstOperands,
     /* 114455 */     // GIR_Coverage, 5720,
     /* 114455 */     GIR_EraseRootFromParent_Done,
     /* 114456 */   // Label 2171: @114456
     /* 114456 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114529), // Rule ID 2401 //
     /* 114461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114501 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 114504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114527 */     GIR_RootConstrainSelectedInstOperands,
     /* 114528 */     // GIR_Coverage, 2401,
     /* 114528 */     GIR_EraseRootFromParent_Done,
     /* 114529 */   // Label 2172: @114529
     /* 114529 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114589), // Rule ID 624 //
     /* 114534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114565 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 114568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114587 */     GIR_RootConstrainSelectedInstOperands,
     /* 114588 */     // GIR_Coverage, 624,
     /* 114588 */     GIR_EraseRootFromParent_Done,
     /* 114589 */   // Label 2173: @114589
     /* 114589 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114619), // Rule ID 662 //
     /* 114594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114601 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 114601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 114604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114617 */     GIR_RootConstrainSelectedInstOperands,
     /* 114618 */     // GIR_Coverage, 662,
     /* 114618 */     GIR_EraseRootFromParent_Done,
     /* 114619 */   // Label 2174: @114619
     /* 114619 */   GIM_Reject,
     /* 114620 */ // Label 2169: @114620
     /* 114620 */ GIM_Reject,
     /* 114621 */ // Label 2151: @114621
     /* 114621 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114658), // Rule ID 1530 //
     /* 114626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114640 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114645 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114656 */   GIR_RootConstrainSelectedInstOperands,
     /* 114657 */   // GIR_Coverage, 1530,
     /* 114657 */   GIR_EraseRootFromParent_Done,
     /* 114658 */ // Label 2175: @114658
     /* 114658 */ GIM_Reject,
     /* 114659 */ // Label 2152: @114659
     /* 114659 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114696), // Rule ID 1532 //
     /* 114664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114678 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114683 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114688 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114694 */   GIR_RootConstrainSelectedInstOperands,
     /* 114695 */   // GIR_Coverage, 1532,
     /* 114695 */   GIR_EraseRootFromParent_Done,
     /* 114696 */ // Label 2176: @114696
     /* 114696 */ GIM_Reject,
     /* 114697 */ // Label 2153: @114697
     /* 114697 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114795),
     /* 114702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114705 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114739), // Rule ID 1531 //
     /* 114710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114721 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114737 */     GIR_RootConstrainSelectedInstOperands,
     /* 114738 */     // GIR_Coverage, 1531,
     /* 114738 */     GIR_EraseRootFromParent_Done,
     /* 114739 */   // Label 2178: @114739
     /* 114739 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114794), // Rule ID 4116 //
     /* 114744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114755 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114772 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114792 */     GIR_RootConstrainSelectedInstOperands,
     /* 114793 */     // GIR_Coverage, 4116,
     /* 114793 */     GIR_EraseRootFromParent_Done,
     /* 114794 */   // Label 2179: @114794
     /* 114794 */   GIM_Reject,
     /* 114795 */ // Label 2177: @114795
     /* 114795 */ GIM_Reject,
     /* 114796 */ // Label 2154: @114796
     /* 114796 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(114894),
     /* 114801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114804 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(114838), // Rule ID 1533 //
     /* 114809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114820 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114836 */     GIR_RootConstrainSelectedInstOperands,
     /* 114837 */     // GIR_Coverage, 1533,
     /* 114837 */     GIR_EraseRootFromParent_Done,
     /* 114838 */   // Label 2181: @114838
     /* 114838 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(114893), // Rule ID 4114 //
     /* 114843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114854 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114871 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114891 */     GIR_RootConstrainSelectedInstOperands,
     /* 114892 */     // GIR_Coverage, 4114,
     /* 114892 */     GIR_EraseRootFromParent_Done,
     /* 114893 */   // Label 2182: @114893
     /* 114893 */   GIM_Reject,
     /* 114894 */ // Label 2180: @114894
     /* 114894 */ GIM_Reject,
     /* 114895 */ // Label 2155: @114895
     /* 114895 */ GIM_Reject,
     /* 114896 */ // Label 40: @114896
     /* 114896 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2186*/ GIMT_Encode4(115131),
     /* 114907 */ /*GILLT_s32*//*Label 2183*/ GIMT_Encode4(114939),
     /* 114911 */ /*GILLT_s64*//*Label 2184*/ GIMT_Encode4(114999), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114935 */ /*GILLT_v4s32*//*Label 2185*/ GIMT_Encode4(115096),
     /* 114939 */ // Label 2183: @114939
     /* 114939 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(114998), // Rule ID 2303 //
     /* 114944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114958 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114970 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114974 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114990 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114996 */   GIR_RootConstrainSelectedInstOperands,
     /* 114997 */   // GIR_Coverage, 2303,
     /* 114997 */   GIR_EraseRootFromParent_Done,
     /* 114998 */ // Label 2187: @114998
     /* 114998 */ GIM_Reject,
     /* 114999 */ // Label 2184: @114999
     /* 114999 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(115036), // Rule ID 660 //
     /* 115004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115018 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 115018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 115021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 115023 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 115025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115028 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115034 */   GIR_RootConstrainSelectedInstOperands,
     /* 115035 */   // GIR_Coverage, 660,
     /* 115035 */   GIR_EraseRootFromParent_Done,
     /* 115036 */ // Label 2188: @115036
     /* 115036 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(115095), // Rule ID 2313 //
     /* 115041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115055 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 115055 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115058 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115062 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115067 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 115071 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 115076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 115079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 115081 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115087 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115093 */   GIR_RootConstrainSelectedInstOperands,
     /* 115094 */   // GIR_Coverage, 2313,
     /* 115094 */   GIR_EraseRootFromParent_Done,
     /* 115095 */ // Label 2189: @115095
     /* 115095 */ GIM_Reject,
     /* 115096 */ // Label 2185: @115096
     /* 115096 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(115130), // Rule ID 2670 //
     /* 115101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115112 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 115112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 115115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115117 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115122 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115128 */   GIR_RootConstrainSelectedInstOperands,
     /* 115129 */   // GIR_Coverage, 2670,
     /* 115129 */   GIR_EraseRootFromParent_Done,
     /* 115130 */ // Label 2190: @115130
     /* 115130 */ GIM_Reject,
     /* 115131 */ // Label 2186: @115131
     /* 115131 */ GIM_Reject,
     /* 115132 */ // Label 41: @115132
     /* 115132 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2194*/ GIMT_Encode4(115403),
     /* 115143 */ /*GILLT_s16*//*Label 2191*/ GIMT_Encode4(115175),
     /* 115147 */ /*GILLT_s32*//*Label 2192*/ GIMT_Encode4(115330), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115171 */ /*GILLT_v4s16*//*Label 2193*/ GIMT_Encode4(115368),
     /* 115175 */ // Label 2191: @115175
     /* 115175 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(115252), // Rule ID 2305 //
     /* 115180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 115183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115194 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 115194 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115197 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115201 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 115215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115220 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 115227 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115230 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115246 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115251 */   // GIR_Coverage, 2305,
     /* 115251 */   GIR_EraseRootFromParent_Done,
     /* 115252 */ // Label 2195: @115252
     /* 115252 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(115329), // Rule ID 2315 //
     /* 115257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115271 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 115271 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115274 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115278 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 115292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115297 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115300 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 115304 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115307 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115328 */   // GIR_Coverage, 2315,
     /* 115328 */   GIR_EraseRootFromParent_Done,
     /* 115329 */ // Label 2196: @115329
     /* 115329 */ GIM_Reject,
     /* 115330 */ // Label 2192: @115330
     /* 115330 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(115367), // Rule ID 661 //
     /* 115335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115349 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 115349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 115352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 115354 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 115356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115359 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115365 */   GIR_RootConstrainSelectedInstOperands,
     /* 115366 */   // GIR_Coverage, 661,
     /* 115366 */   GIR_EraseRootFromParent_Done,
     /* 115367 */ // Label 2197: @115367
     /* 115367 */ GIM_Reject,
     /* 115368 */ // Label 2193: @115368
     /* 115368 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(115402), // Rule ID 2669 //
     /* 115373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115384 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 115384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 115387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115389 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115394 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115400 */   GIR_RootConstrainSelectedInstOperands,
     /* 115401 */   // GIR_Coverage, 2669,
     /* 115401 */   GIR_EraseRootFromParent_Done,
     /* 115402 */ // Label 2198: @115402
     /* 115402 */ GIM_Reject,
     /* 115403 */ // Label 2194: @115403
     /* 115403 */ GIM_Reject,
     /* 115404 */ // Label 42: @115404
     /* 115404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2206*/ GIMT_Encode4(116737),
     /* 115415 */ /*GILLT_s32*//*Label 2199*/ GIMT_Encode4(115463), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115427 */ /*GILLT_v2s32*//*Label 2200*/ GIMT_Encode4(116357), GIMT_Encode4(0),
     /* 115435 */ /*GILLT_v4s1*//*Label 2201*/ GIMT_Encode4(116395),
     /* 115439 */ /*GILLT_v4s16*//*Label 2202*/ GIMT_Encode4(116448),
     /* 115443 */ /*GILLT_v4s32*//*Label 2203*/ GIMT_Encode4(116486), GIMT_Encode4(0),
     /* 115451 */ /*GILLT_v8s1*//*Label 2204*/ GIMT_Encode4(116585), GIMT_Encode4(0),
     /* 115459 */ /*GILLT_v8s16*//*Label 2205*/ GIMT_Encode4(116638),
     /* 115463 */ // Label 2199: @115463
     /* 115463 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(115529), // Rule ID 2323 //
     /* 115468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115478 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115486 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115490 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115495 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115497 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 115504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115528 */   // GIR_Coverage, 2323,
     /* 115528 */   GIR_EraseRootFromParent_Done,
     /* 115529 */ // Label 2207: @115529
     /* 115529 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(115595), // Rule ID 2325 //
     /* 115534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115544 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115548 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115552 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115556 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115561 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115563 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 115570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115575 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115594 */   // GIR_Coverage, 2325,
     /* 115594 */   GIR_EraseRootFromParent_Done,
     /* 115595 */ // Label 2208: @115595
     /* 115595 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(115661), // Rule ID 2327 //
     /* 115600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115618 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115622 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115627 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115629 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115641 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115655 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115660 */   // GIR_Coverage, 2327,
     /* 115660 */   GIR_EraseRootFromParent_Done,
     /* 115661 */ // Label 2209: @115661
     /* 115661 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(115727), // Rule ID 2329 //
     /* 115666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115676 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115684 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115688 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115693 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115695 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115707 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115726 */   // GIR_Coverage, 2329,
     /* 115726 */   GIR_EraseRootFromParent_Done,
     /* 115727 */ // Label 2210: @115727
     /* 115727 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(115793), // Rule ID 2331 //
     /* 115732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115750 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115754 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115759 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115761 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115773 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115792 */   // GIR_Coverage, 2331,
     /* 115792 */   GIR_EraseRootFromParent_Done,
     /* 115793 */ // Label 2211: @115793
     /* 115793 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(115859), // Rule ID 2333 //
     /* 115798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115812 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115816 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115820 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115825 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115827 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115839 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115858 */   // GIR_Coverage, 2333,
     /* 115858 */   GIR_EraseRootFromParent_Done,
     /* 115859 */ // Label 2212: @115859
     /* 115859 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(115925), // Rule ID 2317 //
     /* 115864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115882 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115886 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115891 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115893 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115905 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115919 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115924 */   // GIR_Coverage, 2317,
     /* 115924 */   GIR_EraseRootFromParent_Done,
     /* 115925 */ // Label 2213: @115925
     /* 115925 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(115991), // Rule ID 2319 //
     /* 115930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115940 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115948 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115952 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115957 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115959 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115971 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115990 */   // GIR_Coverage, 2319,
     /* 115990 */   GIR_EraseRootFromParent_Done,
     /* 115991 */ // Label 2214: @115991
     /* 115991 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(116057), // Rule ID 2321 //
     /* 115996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116006 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116014 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116018 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116023 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116025 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 116032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116037 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116048 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116056 */   // GIR_Coverage, 2321,
     /* 116056 */   GIR_EraseRootFromParent_Done,
     /* 116057 */ // Label 2215: @116057
     /* 116057 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(116117), // Rule ID 2352 //
     /* 116062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 116065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116076 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 116083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116088 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116092 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116095 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116116 */   // GIR_Coverage, 2352,
     /* 116116 */   GIR_EraseRootFromParent_Done,
     /* 116117 */ // Label 2216: @116117
     /* 116117 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(116177), // Rule ID 2356 //
     /* 116122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116136 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 116143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116148 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116152 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116155 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116171 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116176 */   // GIR_Coverage, 2356,
     /* 116176 */   GIR_EraseRootFromParent_Done,
     /* 116177 */ // Label 2217: @116177
     /* 116177 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(116237), // Rule ID 2360 //
     /* 116182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116196 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 116203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116208 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116212 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116215 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116236 */   // GIR_Coverage, 2360,
     /* 116236 */   GIR_EraseRootFromParent_Done,
     /* 116237 */ // Label 2218: @116237
     /* 116237 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116356), // Rule ID 2710 //
     /* 116242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 116245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116256 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 116256 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 116259 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116263 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116270 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 116273 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116277 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116282 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 116285 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116289 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 116292 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116297 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116302 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 116310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116319 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116322 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116325 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116331 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116338 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 116345 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116350 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116355 */   // GIR_Coverage, 2710,
     /* 116355 */   GIR_EraseRootFromParent_Done,
     /* 116356 */ // Label 2219: @116356
     /* 116356 */ GIM_Reject,
     /* 116357 */ // Label 2200: @116357
     /* 116357 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(116394), // Rule ID 1604 //
     /* 116362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116376 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 116376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116381 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116386 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116392 */   GIR_RootConstrainSelectedInstOperands,
     /* 116393 */   // GIR_Coverage, 1604,
     /* 116393 */   GIR_EraseRootFromParent_Done,
     /* 116394 */ // Label 2220: @116394
     /* 116394 */ GIM_Reject,
     /* 116395 */ // Label 2201: @116395
     /* 116395 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(116447), // Rule ID 5105 //
     /* 116400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116414 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 116417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116419 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116421 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116433 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116439 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116445 */   GIR_RootConstrainSelectedInstOperands,
     /* 116446 */   // GIR_Coverage, 5105,
     /* 116446 */   GIR_EraseRootFromParent_Done,
     /* 116447 */ // Label 2221: @116447
     /* 116447 */ GIM_Reject,
     /* 116448 */ // Label 2202: @116448
     /* 116448 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(116485), // Rule ID 1612 //
     /* 116453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116467 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 116467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 116470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116472 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116477 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116483 */   GIR_RootConstrainSelectedInstOperands,
     /* 116484 */   // GIR_Coverage, 1612,
     /* 116484 */   GIR_EraseRootFromParent_Done,
     /* 116485 */ // Label 2222: @116485
     /* 116485 */ GIM_Reject,
     /* 116486 */ // Label 2203: @116486
     /* 116486 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(116584),
     /* 116491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116494 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(116528), // Rule ID 1608 //
     /* 116499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116510 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 116510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 116513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116526 */     GIR_RootConstrainSelectedInstOperands,
     /* 116527 */     // GIR_Coverage, 1608,
     /* 116527 */     GIR_EraseRootFromParent_Done,
     /* 116528 */   // Label 2224: @116528
     /* 116528 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(116583), // Rule ID 4094 //
     /* 116533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116544 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 116544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 116559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116581 */     GIR_RootConstrainSelectedInstOperands,
     /* 116582 */     // GIR_Coverage, 4094,
     /* 116582 */     GIR_EraseRootFromParent_Done,
     /* 116583 */   // Label 2225: @116583
     /* 116583 */   GIM_Reject,
     /* 116584 */ // Label 2223: @116584
     /* 116584 */ GIM_Reject,
     /* 116585 */ // Label 2204: @116585
     /* 116585 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(116637), // Rule ID 5106 //
     /* 116590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116604 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 116607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116609 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116611 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116623 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116635 */   GIR_RootConstrainSelectedInstOperands,
     /* 116636 */   // GIR_Coverage, 5106,
     /* 116636 */   GIR_EraseRootFromParent_Done,
     /* 116637 */ // Label 2226: @116637
     /* 116637 */ GIM_Reject,
     /* 116638 */ // Label 2205: @116638
     /* 116638 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(116736),
     /* 116643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116646 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(116680), // Rule ID 1616 //
     /* 116651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116662 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116678 */     GIR_RootConstrainSelectedInstOperands,
     /* 116679 */     // GIR_Coverage, 1616,
     /* 116679 */     GIR_EraseRootFromParent_Done,
     /* 116680 */   // Label 2228: @116680
     /* 116680 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(116735), // Rule ID 4090 //
     /* 116685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116696 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116733 */     GIR_RootConstrainSelectedInstOperands,
     /* 116734 */     // GIR_Coverage, 4090,
     /* 116734 */     GIR_EraseRootFromParent_Done,
     /* 116735 */   // Label 2229: @116735
     /* 116735 */   GIM_Reject,
     /* 116736 */ // Label 2227: @116736
     /* 116736 */ GIM_Reject,
     /* 116737 */ // Label 2206: @116737
     /* 116737 */ GIM_Reject,
     /* 116738 */ // Label 43: @116738
     /* 116738 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2237*/ GIMT_Encode4(118071),
     /* 116749 */ /*GILLT_s32*//*Label 2230*/ GIMT_Encode4(116797), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116761 */ /*GILLT_v2s32*//*Label 2231*/ GIMT_Encode4(117691), GIMT_Encode4(0),
     /* 116769 */ /*GILLT_v4s1*//*Label 2232*/ GIMT_Encode4(117729),
     /* 116773 */ /*GILLT_v4s16*//*Label 2233*/ GIMT_Encode4(117782),
     /* 116777 */ /*GILLT_v4s32*//*Label 2234*/ GIMT_Encode4(117820), GIMT_Encode4(0),
     /* 116785 */ /*GILLT_v8s1*//*Label 2235*/ GIMT_Encode4(117919), GIMT_Encode4(0),
     /* 116793 */ /*GILLT_v8s16*//*Label 2236*/ GIMT_Encode4(117972),
     /* 116797 */ // Label 2230: @116797
     /* 116797 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(116863), // Rule ID 2324 //
     /* 116802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116820 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116824 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116831 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116843 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116857 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116862 */   // GIR_Coverage, 2324,
     /* 116862 */   GIR_EraseRootFromParent_Done,
     /* 116863 */ // Label 2238: @116863
     /* 116863 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(116929), // Rule ID 2326 //
     /* 116868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116886 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116890 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116897 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116909 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116923 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116928 */   // GIR_Coverage, 2326,
     /* 116928 */   GIR_EraseRootFromParent_Done,
     /* 116929 */ // Label 2239: @116929
     /* 116929 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(116995), // Rule ID 2328 //
     /* 116934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116944 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116952 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116956 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116961 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116963 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116975 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116994 */   // GIR_Coverage, 2328,
     /* 116994 */   GIR_EraseRootFromParent_Done,
     /* 116995 */ // Label 2240: @116995
     /* 116995 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(117061), // Rule ID 2330 //
     /* 117000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 117018 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 117022 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117029 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117029 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117032 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 117036 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117041 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117055 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117060 */   // GIR_Coverage, 2330,
     /* 117060 */   GIR_EraseRootFromParent_Done,
     /* 117061 */ // Label 2241: @117061
     /* 117061 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(117127), // Rule ID 2332 //
     /* 117066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117076 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117080 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 117084 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117088 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117095 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 117102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117107 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117126 */   // GIR_Coverage, 2332,
     /* 117126 */   GIR_EraseRootFromParent_Done,
     /* 117127 */ // Label 2242: @117127
     /* 117127 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(117193), // Rule ID 2334 //
     /* 117132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 117150 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117154 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117159 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117161 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 117168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117173 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117192 */   // GIR_Coverage, 2334,
     /* 117192 */   GIR_EraseRootFromParent_Done,
     /* 117193 */ // Label 2243: @117193
     /* 117193 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(117259), // Rule ID 2318 //
     /* 117198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117208 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117216 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 117220 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117225 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117227 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 117234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117239 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117258 */   // GIR_Coverage, 2318,
     /* 117258 */   GIR_EraseRootFromParent_Done,
     /* 117259 */ // Label 2244: @117259
     /* 117259 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(117325), // Rule ID 2320 //
     /* 117264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117282 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117286 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117293 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 117300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117319 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117324 */   // GIR_Coverage, 2320,
     /* 117324 */   GIR_EraseRootFromParent_Done,
     /* 117325 */ // Label 2245: @117325
     /* 117325 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(117391), // Rule ID 2322 //
     /* 117330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117340 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117344 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117348 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117352 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117357 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117359 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 117366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117371 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117385 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117390 */   // GIR_Coverage, 2322,
     /* 117390 */   GIR_EraseRootFromParent_Done,
     /* 117391 */ // Label 2246: @117391
     /* 117391 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117451), // Rule ID 2362 //
     /* 117396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117410 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 117417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117422 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117426 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117429 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117445 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117450 */   // GIR_Coverage, 2362,
     /* 117450 */   GIR_EraseRootFromParent_Done,
     /* 117451 */ // Label 2247: @117451
     /* 117451 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117511), // Rule ID 2366 //
     /* 117456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117470 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 117477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117482 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117486 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117489 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117510 */   // GIR_Coverage, 2366,
     /* 117510 */   GIR_EraseRootFromParent_Done,
     /* 117511 */ // Label 2248: @117511
     /* 117511 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117571), // Rule ID 2370 //
     /* 117516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117530 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 117537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117542 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117546 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117549 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117570 */   // GIR_Coverage, 2370,
     /* 117570 */   GIR_EraseRootFromParent_Done,
     /* 117571 */ // Label 2249: @117571
     /* 117571 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117690), // Rule ID 2711 //
     /* 117576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117590 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117590 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117593 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117597 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117604 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117607 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117611 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117616 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117619 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117623 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117626 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117631 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117636 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117653 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117656 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117659 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117672 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117684 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117689 */   // GIR_Coverage, 2711,
     /* 117689 */   GIR_EraseRootFromParent_Done,
     /* 117690 */ // Label 2250: @117690
     /* 117690 */ GIM_Reject,
     /* 117691 */ // Label 2231: @117691
     /* 117691 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(117728), // Rule ID 1605 //
     /* 117696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117710 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117715 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117720 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117726 */   GIR_RootConstrainSelectedInstOperands,
     /* 117727 */   // GIR_Coverage, 1605,
     /* 117727 */   GIR_EraseRootFromParent_Done,
     /* 117728 */ // Label 2251: @117728
     /* 117728 */ GIM_Reject,
     /* 117729 */ // Label 2232: @117729
     /* 117729 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(117781), // Rule ID 5103 //
     /* 117734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117748 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117753 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117755 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117767 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117773 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117779 */   GIR_RootConstrainSelectedInstOperands,
     /* 117780 */   // GIR_Coverage, 5103,
     /* 117780 */   GIR_EraseRootFromParent_Done,
     /* 117781 */ // Label 2252: @117781
     /* 117781 */ GIM_Reject,
     /* 117782 */ // Label 2233: @117782
     /* 117782 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(117819), // Rule ID 1613 //
     /* 117787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117801 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117806 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117811 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117817 */   GIR_RootConstrainSelectedInstOperands,
     /* 117818 */   // GIR_Coverage, 1613,
     /* 117818 */   GIR_EraseRootFromParent_Done,
     /* 117819 */ // Label 2253: @117819
     /* 117819 */ GIM_Reject,
     /* 117820 */ // Label 2234: @117820
     /* 117820 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(117918),
     /* 117825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117828 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(117862), // Rule ID 1609 //
     /* 117833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117844 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117860 */     GIR_RootConstrainSelectedInstOperands,
     /* 117861 */     // GIR_Coverage, 1609,
     /* 117861 */     GIR_EraseRootFromParent_Done,
     /* 117862 */   // Label 2255: @117862
     /* 117862 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(117917), // Rule ID 4096 //
     /* 117867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117878 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117915 */     GIR_RootConstrainSelectedInstOperands,
     /* 117916 */     // GIR_Coverage, 4096,
     /* 117916 */     GIR_EraseRootFromParent_Done,
     /* 117917 */   // Label 2256: @117917
     /* 117917 */   GIM_Reject,
     /* 117918 */ // Label 2254: @117918
     /* 117918 */ GIM_Reject,
     /* 117919 */ // Label 2235: @117919
     /* 117919 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(117971), // Rule ID 5104 //
     /* 117924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117938 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117943 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117945 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117957 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117963 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117969 */   GIR_RootConstrainSelectedInstOperands,
     /* 117970 */   // GIR_Coverage, 5104,
     /* 117970 */   GIR_EraseRootFromParent_Done,
     /* 117971 */ // Label 2257: @117971
     /* 117971 */ GIM_Reject,
     /* 117972 */ // Label 2236: @117972
     /* 117972 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(118070),
     /* 117977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117980 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(118014), // Rule ID 1617 //
     /* 117985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117996 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118012 */     GIR_RootConstrainSelectedInstOperands,
     /* 118013 */     // GIR_Coverage, 1617,
     /* 118013 */     GIR_EraseRootFromParent_Done,
     /* 118014 */   // Label 2259: @118014
     /* 118014 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(118069), // Rule ID 4092 //
     /* 118019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118030 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 118030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 118045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118047 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118067 */     GIR_RootConstrainSelectedInstOperands,
     /* 118068 */     // GIR_Coverage, 4092,
     /* 118068 */     GIR_EraseRootFromParent_Done,
     /* 118069 */   // Label 2260: @118069
     /* 118069 */   GIM_Reject,
     /* 118070 */ // Label 2258: @118070
     /* 118070 */ GIM_Reject,
     /* 118071 */ // Label 2237: @118071
     /* 118071 */ GIM_Reject,
     /* 118072 */ // Label 44: @118072
     /* 118072 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2268*/ GIMT_Encode4(118723),
     /* 118083 */ /*GILLT_s16*//*Label 2261*/ GIMT_Encode4(118135),
     /* 118087 */ /*GILLT_s32*//*Label 2262*/ GIMT_Encode4(118195),
     /* 118091 */ /*GILLT_s64*//*Label 2263*/ GIMT_Encode4(118389), GIMT_Encode4(0),
     /* 118099 */ /*GILLT_v2s32*//*Label 2264*/ GIMT_Encode4(118449), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118111 */ /*GILLT_v4s16*//*Label 2265*/ GIMT_Encode4(118487),
     /* 118115 */ /*GILLT_v4s32*//*Label 2266*/ GIMT_Encode4(118525), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118131 */ /*GILLT_v8s16*//*Label 2267*/ GIMT_Encode4(118624),
     /* 118135 */ // Label 2261: @118135
     /* 118135 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(118194), // Rule ID 2346 //
     /* 118140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118154 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118166 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118170 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 118178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118186 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118192 */   GIR_RootConstrainSelectedInstOperands,
     /* 118193 */   // GIR_Coverage, 2346,
     /* 118193 */   GIR_EraseRootFromParent_Done,
     /* 118194 */ // Label 2269: @118194
     /* 118194 */ GIM_Reject,
     /* 118195 */ // Label 2262: @118195
     /* 118195 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(118388),
     /* 118200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118211 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(118259), // Rule ID 2344 //
     /* 118216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118219 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 118243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118257 */     GIR_RootConstrainSelectedInstOperands,
     /* 118258 */     // GIR_Coverage, 2344,
     /* 118258 */     GIR_EraseRootFromParent_Done,
     /* 118259 */   // Label 2271: @118259
     /* 118259 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(118387), // Rule ID 2712 //
     /* 118264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118267 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118267 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118270 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118274 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118279 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118283 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118288 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118291 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118295 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118314 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118317 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118320 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118323 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118333 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118356 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118369 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118386 */     // GIR_Coverage, 2712,
     /* 118386 */     GIR_EraseRootFromParent_Done,
     /* 118387 */   // Label 2272: @118387
     /* 118387 */   GIM_Reject,
     /* 118388 */ // Label 2270: @118388
     /* 118388 */ GIM_Reject,
     /* 118389 */ // Label 2263: @118389
     /* 118389 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(118448), // Rule ID 2342 //
     /* 118394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118408 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118420 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 118432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118440 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118446 */   GIR_RootConstrainSelectedInstOperands,
     /* 118447 */   // GIR_Coverage, 2342,
     /* 118447 */   GIR_EraseRootFromParent_Done,
     /* 118448 */ // Label 2273: @118448
     /* 118448 */ GIM_Reject,
     /* 118449 */ // Label 2264: @118449
     /* 118449 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(118486), // Rule ID 1606 //
     /* 118454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118468 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118473 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118484 */   GIR_RootConstrainSelectedInstOperands,
     /* 118485 */   // GIR_Coverage, 1606,
     /* 118485 */   GIR_EraseRootFromParent_Done,
     /* 118486 */ // Label 2274: @118486
     /* 118486 */ GIM_Reject,
     /* 118487 */ // Label 2265: @118487
     /* 118487 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(118524), // Rule ID 1614 //
     /* 118492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118506 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 118509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118511 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118516 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118522 */   GIR_RootConstrainSelectedInstOperands,
     /* 118523 */   // GIR_Coverage, 1614,
     /* 118523 */   GIR_EraseRootFromParent_Done,
     /* 118524 */ // Label 2275: @118524
     /* 118524 */ GIM_Reject,
     /* 118525 */ // Label 2266: @118525
     /* 118525 */ GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(118623),
     /* 118530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118533 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(118567), // Rule ID 1610 //
     /* 118538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118549 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 118552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118565 */     GIR_RootConstrainSelectedInstOperands,
     /* 118566 */     // GIR_Coverage, 1610,
     /* 118566 */     GIR_EraseRootFromParent_Done,
     /* 118567 */   // Label 2277: @118567
     /* 118567 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(118622), // Rule ID 4102 //
     /* 118572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118583 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 118598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118600 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118620 */     GIR_RootConstrainSelectedInstOperands,
     /* 118621 */     // GIR_Coverage, 4102,
     /* 118621 */     GIR_EraseRootFromParent_Done,
     /* 118622 */   // Label 2278: @118622
     /* 118622 */   GIM_Reject,
     /* 118623 */ // Label 2276: @118623
     /* 118623 */ GIM_Reject,
     /* 118624 */ // Label 2267: @118624
     /* 118624 */ GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(118722),
     /* 118629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118632 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(118666), // Rule ID 1618 //
     /* 118637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118648 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118664 */     GIR_RootConstrainSelectedInstOperands,
     /* 118665 */     // GIR_Coverage, 1618,
     /* 118665 */     GIR_EraseRootFromParent_Done,
     /* 118666 */   // Label 2280: @118666
     /* 118666 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(118721), // Rule ID 4098 //
     /* 118671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118682 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118719 */     GIR_RootConstrainSelectedInstOperands,
     /* 118720 */     // GIR_Coverage, 4098,
     /* 118720 */     GIR_EraseRootFromParent_Done,
     /* 118721 */   // Label 2281: @118721
     /* 118721 */   GIM_Reject,
     /* 118722 */ // Label 2279: @118722
     /* 118722 */ GIM_Reject,
     /* 118723 */ // Label 2268: @118723
     /* 118723 */ GIM_Reject,
     /* 118724 */ // Label 45: @118724
     /* 118724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2289*/ GIMT_Encode4(119375),
     /* 118735 */ /*GILLT_s16*//*Label 2282*/ GIMT_Encode4(118787),
     /* 118739 */ /*GILLT_s32*//*Label 2283*/ GIMT_Encode4(118847),
     /* 118743 */ /*GILLT_s64*//*Label 2284*/ GIMT_Encode4(119041), GIMT_Encode4(0),
     /* 118751 */ /*GILLT_v2s32*//*Label 2285*/ GIMT_Encode4(119101), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118763 */ /*GILLT_v4s16*//*Label 2286*/ GIMT_Encode4(119139),
     /* 118767 */ /*GILLT_v4s32*//*Label 2287*/ GIMT_Encode4(119177), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118783 */ /*GILLT_v8s16*//*Label 2288*/ GIMT_Encode4(119276),
     /* 118787 */ // Label 2282: @118787
     /* 118787 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(118846), // Rule ID 2351 //
     /* 118792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118806 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118818 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118822 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118838 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118844 */   GIR_RootConstrainSelectedInstOperands,
     /* 118845 */   // GIR_Coverage, 2351,
     /* 118845 */   GIR_EraseRootFromParent_Done,
     /* 118846 */ // Label 2290: @118846
     /* 118846 */ GIM_Reject,
     /* 118847 */ // Label 2283: @118847
     /* 118847 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(119040),
     /* 118852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118863 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(118911), // Rule ID 2349 //
     /* 118868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118871 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118909 */     GIR_RootConstrainSelectedInstOperands,
     /* 118910 */     // GIR_Coverage, 2349,
     /* 118910 */     GIR_EraseRootFromParent_Done,
     /* 118911 */   // Label 2292: @118911
     /* 118911 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(119039), // Rule ID 2713 //
     /* 118916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118919 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118919 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118922 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118926 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118931 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118935 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118940 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118943 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118947 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118954 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118957 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118961 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118966 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118969 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118972 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118975 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 119008 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 119016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119021 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119038 */     // GIR_Coverage, 2713,
     /* 119038 */     GIR_EraseRootFromParent_Done,
     /* 119039 */   // Label 2293: @119039
     /* 119039 */   GIM_Reject,
     /* 119040 */ // Label 2291: @119040
     /* 119040 */ GIM_Reject,
     /* 119041 */ // Label 2284: @119041
     /* 119041 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(119100), // Rule ID 2347 //
     /* 119046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 119060 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 119060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119072 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119076 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 119084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119092 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119098 */   GIR_RootConstrainSelectedInstOperands,
     /* 119099 */   // GIR_Coverage, 2347,
     /* 119099 */   GIR_EraseRootFromParent_Done,
     /* 119100 */ // Label 2294: @119100
     /* 119100 */ GIM_Reject,
     /* 119101 */ // Label 2285: @119101
     /* 119101 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(119138), // Rule ID 1607 //
     /* 119106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119120 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 119120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 119123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119125 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119136 */   GIR_RootConstrainSelectedInstOperands,
     /* 119137 */   // GIR_Coverage, 1607,
     /* 119137 */   GIR_EraseRootFromParent_Done,
     /* 119138 */ // Label 2295: @119138
     /* 119138 */ GIM_Reject,
     /* 119139 */ // Label 2286: @119139
     /* 119139 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(119176), // Rule ID 1615 //
     /* 119144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119158 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 119158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 119161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119163 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119168 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119174 */   GIR_RootConstrainSelectedInstOperands,
     /* 119175 */   // GIR_Coverage, 1615,
     /* 119175 */   GIR_EraseRootFromParent_Done,
     /* 119176 */ // Label 2296: @119176
     /* 119176 */ GIM_Reject,
     /* 119177 */ // Label 2287: @119177
     /* 119177 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(119275),
     /* 119182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119185 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(119219), // Rule ID 1611 //
     /* 119190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119201 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 119201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 119204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119217 */     GIR_RootConstrainSelectedInstOperands,
     /* 119218 */     // GIR_Coverage, 1611,
     /* 119218 */     GIR_EraseRootFromParent_Done,
     /* 119219 */   // Label 2298: @119219
     /* 119219 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(119274), // Rule ID 4104 //
     /* 119224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119235 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 119235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 119250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119272 */     GIR_RootConstrainSelectedInstOperands,
     /* 119273 */     // GIR_Coverage, 4104,
     /* 119273 */     GIR_EraseRootFromParent_Done,
     /* 119274 */   // Label 2299: @119274
     /* 119274 */   GIM_Reject,
     /* 119275 */ // Label 2297: @119275
     /* 119275 */ GIM_Reject,
     /* 119276 */ // Label 2288: @119276
     /* 119276 */ GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(119374),
     /* 119281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119284 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(119318), // Rule ID 1619 //
     /* 119289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119300 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 119300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 119303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119316 */     GIR_RootConstrainSelectedInstOperands,
     /* 119317 */     // GIR_Coverage, 1619,
     /* 119317 */     GIR_EraseRootFromParent_Done,
     /* 119318 */   // Label 2301: @119318
     /* 119318 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(119373), // Rule ID 4100 //
     /* 119323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119334 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 119334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 119349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119351 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119371 */     GIR_RootConstrainSelectedInstOperands,
     /* 119372 */     // GIR_Coverage, 4100,
     /* 119372 */     GIR_EraseRootFromParent_Done,
     /* 119373 */   // Label 2302: @119373
     /* 119373 */   GIM_Reject,
     /* 119374 */ // Label 2300: @119374
     /* 119374 */ GIM_Reject,
     /* 119375 */ // Label 2289: @119375
     /* 119375 */ GIM_Reject,
     /* 119376 */ // Label 46: @119376
     /* 119376 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2310*/ GIMT_Encode4(120151),
     /* 119387 */ /*GILLT_s16*//*Label 2303*/ GIMT_Encode4(119439),
     /* 119391 */ /*GILLT_s32*//*Label 2304*/ GIMT_Encode4(119477),
     /* 119395 */ /*GILLT_s64*//*Label 2305*/ GIMT_Encode4(119669), GIMT_Encode4(0),
     /* 119403 */ /*GILLT_v2s32*//*Label 2306*/ GIMT_Encode4(119707), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119415 */ /*GILLT_v4s16*//*Label 2307*/ GIMT_Encode4(119745),
     /* 119419 */ /*GILLT_v4s32*//*Label 2308*/ GIMT_Encode4(119783), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119435 */ /*GILLT_v8s16*//*Label 2309*/ GIMT_Encode4(119967),
     /* 119439 */ // Label 2303: @119439
     /* 119439 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119476), // Rule ID 653 //
     /* 119444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119458 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 119458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 119461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119463 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119468 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119474 */   GIR_RootConstrainSelectedInstOperands,
     /* 119475 */   // GIR_Coverage, 653,
     /* 119475 */   GIR_EraseRootFromParent_Done,
     /* 119476 */ // Label 2311: @119476
     /* 119476 */ GIM_Reject,
     /* 119477 */ // Label 2304: @119477
     /* 119477 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(119668),
     /* 119482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119493 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119519), // Rule ID 652 //
     /* 119498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 119501 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 119501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 119504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119517 */     GIR_RootConstrainSelectedInstOperands,
     /* 119518 */     // GIR_Coverage, 652,
     /* 119518 */     GIR_EraseRootFromParent_Done,
     /* 119519 */   // Label 2313: @119519
     /* 119519 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119667), // Rule ID 2704 //
     /* 119524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 119527 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 119527 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 119530 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119534 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 119541 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 119544 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119548 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119553 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 119556 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 119564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119573 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 119576 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119580 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 119583 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119588 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119593 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119610 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 119613 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 119616 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 119627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119636 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119666 */     // GIR_Coverage, 2704,
     /* 119666 */     GIR_EraseRootFromParent_Done,
     /* 119667 */   // Label 2314: @119667
     /* 119667 */   GIM_Reject,
     /* 119668 */ // Label 2312: @119668
     /* 119668 */ GIM_Reject,
     /* 119669 */ // Label 2305: @119669
     /* 119669 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(119706), // Rule ID 651 //
     /* 119674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119688 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119693 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119698 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119704 */   GIR_RootConstrainSelectedInstOperands,
     /* 119705 */   // GIR_Coverage, 651,
     /* 119705 */   GIR_EraseRootFromParent_Done,
     /* 119706 */ // Label 2315: @119706
     /* 119706 */ GIM_Reject,
     /* 119707 */ // Label 2306: @119707
     /* 119707 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(119744), // Rule ID 1514 //
     /* 119712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119726 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119731 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119736 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119742 */   GIR_RootConstrainSelectedInstOperands,
     /* 119743 */   // GIR_Coverage, 1514,
     /* 119743 */   GIR_EraseRootFromParent_Done,
     /* 119744 */ // Label 2316: @119744
     /* 119744 */ GIM_Reject,
     /* 119745 */ // Label 2307: @119745
     /* 119745 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(119782), // Rule ID 1516 //
     /* 119750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119764 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119769 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119774 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119780 */   GIR_RootConstrainSelectedInstOperands,
     /* 119781 */   // GIR_Coverage, 1516,
     /* 119781 */   GIR_EraseRootFromParent_Done,
     /* 119782 */ // Label 2317: @119782
     /* 119782 */ GIM_Reject,
     /* 119783 */ // Label 2308: @119783
     /* 119783 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(119966),
     /* 119788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119791 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(119876), // Rule ID 4041 //
     /* 119796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119831 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119874 */     GIR_RootConstrainSelectedInstOperands,
     /* 119875 */     // GIR_Coverage, 4041,
     /* 119875 */     GIR_EraseRootFromParent_Done,
     /* 119876 */   // Label 2319: @119876
     /* 119876 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(119910), // Rule ID 1515 //
     /* 119881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119892 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119908 */     GIR_RootConstrainSelectedInstOperands,
     /* 119909 */     // GIR_Coverage, 1515,
     /* 119909 */     GIR_EraseRootFromParent_Done,
     /* 119910 */   // Label 2320: @119910
     /* 119910 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(119965), // Rule ID 4112 //
     /* 119915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119926 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119943 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119963 */     GIR_RootConstrainSelectedInstOperands,
     /* 119964 */     // GIR_Coverage, 4112,
     /* 119964 */     GIR_EraseRootFromParent_Done,
     /* 119965 */   // Label 2321: @119965
     /* 119965 */   GIM_Reject,
     /* 119966 */ // Label 2318: @119966
     /* 119966 */ GIM_Reject,
     /* 119967 */ // Label 2309: @119967
     /* 119967 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(120150),
     /* 119972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119975 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(120060), // Rule ID 4040 //
     /* 119980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120015 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 120030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 120036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 120040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120058 */     GIR_RootConstrainSelectedInstOperands,
     /* 120059 */     // GIR_Coverage, 4040,
     /* 120059 */     GIR_EraseRootFromParent_Done,
     /* 120060 */   // Label 2323: @120060
     /* 120060 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(120094), // Rule ID 1517 //
     /* 120065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 120068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120076 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 120076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 120079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 120081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 120083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 120086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120092 */     GIR_RootConstrainSelectedInstOperands,
     /* 120093 */     // GIR_Coverage, 1517,
     /* 120093 */     GIR_EraseRootFromParent_Done,
     /* 120094 */   // Label 2324: @120094
     /* 120094 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(120149), // Rule ID 4110 //
     /* 120099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120110 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 120110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 120125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120127 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 120129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120147 */     GIR_RootConstrainSelectedInstOperands,
     /* 120148 */     // GIR_Coverage, 4110,
     /* 120148 */     GIR_EraseRootFromParent_Done,
     /* 120149 */   // Label 2325: @120149
     /* 120149 */   GIM_Reject,
     /* 120150 */ // Label 2322: @120150
     /* 120150 */ GIM_Reject,
     /* 120151 */ // Label 2310: @120151
     /* 120151 */ GIM_Reject,
     /* 120152 */ // Label 47: @120152
     /* 120152 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2333*/ GIMT_Encode4(120743),
     /* 120163 */ /*GILLT_s16*//*Label 2326*/ GIMT_Encode4(120215),
     /* 120167 */ /*GILLT_s32*//*Label 2327*/ GIMT_Encode4(120249),
     /* 120171 */ /*GILLT_s64*//*Label 2328*/ GIMT_Encode4(120283), GIMT_Encode4(0),
     /* 120179 */ /*GILLT_v2s32*//*Label 2329*/ GIMT_Encode4(120317), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120191 */ /*GILLT_v4s16*//*Label 2330*/ GIMT_Encode4(120351),
     /* 120195 */ /*GILLT_v4s32*//*Label 2331*/ GIMT_Encode4(120385), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120211 */ /*GILLT_v8s16*//*Label 2332*/ GIMT_Encode4(120564),
     /* 120215 */ // Label 2326: @120215
     /* 120215 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(120248), // Rule ID 642 //
     /* 120220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120241 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 120246 */   GIR_RootConstrainSelectedInstOperands,
     /* 120247 */   // GIR_Coverage, 642,
     /* 120247 */   GIR_Done,
     /* 120248 */ // Label 2334: @120248
     /* 120248 */ GIM_Reject,
     /* 120249 */ // Label 2327: @120249
     /* 120249 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(120282), // Rule ID 643 //
     /* 120254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120275 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 120280 */   GIR_RootConstrainSelectedInstOperands,
     /* 120281 */   // GIR_Coverage, 643,
     /* 120281 */   GIR_Done,
     /* 120282 */ // Label 2335: @120282
     /* 120282 */ GIM_Reject,
     /* 120283 */ // Label 2328: @120283
     /* 120283 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(120316), // Rule ID 644 //
     /* 120288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120309 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 120314 */   GIR_RootConstrainSelectedInstOperands,
     /* 120315 */   // GIR_Coverage, 644,
     /* 120315 */   GIR_Done,
     /* 120316 */ // Label 2336: @120316
     /* 120316 */ GIM_Reject,
     /* 120317 */ // Label 2329: @120317
     /* 120317 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(120350), // Rule ID 1233 //
     /* 120322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120343 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 120348 */   GIR_RootConstrainSelectedInstOperands,
     /* 120349 */   // GIR_Coverage, 1233,
     /* 120349 */   GIR_Done,
     /* 120350 */ // Label 2337: @120350
     /* 120350 */ GIM_Reject,
     /* 120351 */ // Label 2330: @120351
     /* 120351 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(120384), // Rule ID 1235 //
     /* 120356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120377 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 120382 */   GIR_RootConstrainSelectedInstOperands,
     /* 120383 */   // GIR_Coverage, 1235,
     /* 120383 */   GIR_Done,
     /* 120384 */ // Label 2338: @120384
     /* 120384 */ GIM_Reject,
     /* 120385 */ // Label 2331: @120385
     /* 120385 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(120563),
     /* 120390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120396 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(120474), // Rule ID 4122 //
     /* 120401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120444 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 120447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120472 */     GIR_RootConstrainSelectedInstOperands,
     /* 120473 */     // GIR_Coverage, 4122,
     /* 120473 */     GIR_EraseRootFromParent_Done,
     /* 120474 */   // Label 2340: @120474
     /* 120474 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(120501), // Rule ID 1234 //
     /* 120479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120494 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 120499 */     GIR_RootConstrainSelectedInstOperands,
     /* 120500 */     // GIR_Coverage, 1234,
     /* 120500 */     GIR_Done,
     /* 120501 */   // Label 2341: @120501
     /* 120501 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(120562), // Rule ID 3288 //
     /* 120506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120521 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 120536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120560 */     GIR_RootConstrainSelectedInstOperands,
     /* 120561 */     // GIR_Coverage, 3288,
     /* 120561 */     GIR_EraseRootFromParent_Done,
     /* 120562 */   // Label 2342: @120562
     /* 120562 */   GIM_Reject,
     /* 120563 */ // Label 2339: @120563
     /* 120563 */ GIM_Reject,
     /* 120564 */ // Label 2332: @120564
     /* 120564 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(120742),
     /* 120569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120575 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(120653), // Rule ID 4124 //
     /* 120580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120623 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 120626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120651 */     GIR_RootConstrainSelectedInstOperands,
     /* 120652 */     // GIR_Coverage, 4124,
     /* 120652 */     GIR_EraseRootFromParent_Done,
     /* 120653 */   // Label 2344: @120653
     /* 120653 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(120680), // Rule ID 1236 //
     /* 120658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120673 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120678 */     GIR_RootConstrainSelectedInstOperands,
     /* 120679 */     // GIR_Coverage, 1236,
     /* 120679 */     GIR_Done,
     /* 120680 */   // Label 2345: @120680
     /* 120680 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(120741), // Rule ID 3291 //
     /* 120685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120700 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120739 */     GIR_RootConstrainSelectedInstOperands,
     /* 120740 */     // GIR_Coverage, 3291,
     /* 120740 */     GIR_EraseRootFromParent_Done,
     /* 120741 */   // Label 2346: @120741
     /* 120741 */   GIM_Reject,
     /* 120742 */ // Label 2343: @120742
     /* 120742 */ GIM_Reject,
     /* 120743 */ // Label 2333: @120743
     /* 120743 */ GIM_Reject,
     /* 120744 */ // Label 48: @120744
     /* 120744 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2354*/ GIMT_Encode4(121335),
     /* 120755 */ /*GILLT_s16*//*Label 2347*/ GIMT_Encode4(120807),
     /* 120759 */ /*GILLT_s32*//*Label 2348*/ GIMT_Encode4(120841),
     /* 120763 */ /*GILLT_s64*//*Label 2349*/ GIMT_Encode4(120875), GIMT_Encode4(0),
     /* 120771 */ /*GILLT_v2s32*//*Label 2350*/ GIMT_Encode4(120909), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120783 */ /*GILLT_v4s16*//*Label 2351*/ GIMT_Encode4(120943),
     /* 120787 */ /*GILLT_v4s32*//*Label 2352*/ GIMT_Encode4(120977), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120803 */ /*GILLT_v8s16*//*Label 2353*/ GIMT_Encode4(121156),
     /* 120807 */ // Label 2347: @120807
     /* 120807 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(120840), // Rule ID 639 //
     /* 120812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120833 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120838 */   GIR_RootConstrainSelectedInstOperands,
     /* 120839 */   // GIR_Coverage, 639,
     /* 120839 */   GIR_Done,
     /* 120840 */ // Label 2355: @120840
     /* 120840 */ GIM_Reject,
     /* 120841 */ // Label 2348: @120841
     /* 120841 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(120874), // Rule ID 640 //
     /* 120846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120867 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120872 */   GIR_RootConstrainSelectedInstOperands,
     /* 120873 */   // GIR_Coverage, 640,
     /* 120873 */   GIR_Done,
     /* 120874 */ // Label 2356: @120874
     /* 120874 */ GIM_Reject,
     /* 120875 */ // Label 2349: @120875
     /* 120875 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(120908), // Rule ID 641 //
     /* 120880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120901 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120906 */   GIR_RootConstrainSelectedInstOperands,
     /* 120907 */   // GIR_Coverage, 641,
     /* 120907 */   GIR_Done,
     /* 120908 */ // Label 2357: @120908
     /* 120908 */ GIM_Reject,
     /* 120909 */ // Label 2350: @120909
     /* 120909 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(120942), // Rule ID 1213 //
     /* 120914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120935 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120940 */   GIR_RootConstrainSelectedInstOperands,
     /* 120941 */   // GIR_Coverage, 1213,
     /* 120941 */   GIR_Done,
     /* 120942 */ // Label 2358: @120942
     /* 120942 */ GIM_Reject,
     /* 120943 */ // Label 2351: @120943
     /* 120943 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(120976), // Rule ID 1215 //
     /* 120948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120969 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120974 */   GIR_RootConstrainSelectedInstOperands,
     /* 120975 */   // GIR_Coverage, 1215,
     /* 120975 */   GIR_Done,
     /* 120976 */ // Label 2359: @120976
     /* 120976 */ GIM_Reject,
     /* 120977 */ // Label 2352: @120977
     /* 120977 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(121155),
     /* 120982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120988 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(121066), // Rule ID 4118 //
     /* 120993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121036 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 121036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 121039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 121045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 121049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121064 */     GIR_RootConstrainSelectedInstOperands,
     /* 121065 */     // GIR_Coverage, 4118,
     /* 121065 */     GIR_EraseRootFromParent_Done,
     /* 121066 */   // Label 2361: @121066
     /* 121066 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(121093), // Rule ID 1214 //
     /* 121071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 121074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121086 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 121091 */     GIR_RootConstrainSelectedInstOperands,
     /* 121092 */     // GIR_Coverage, 1214,
     /* 121092 */     GIR_Done,
     /* 121093 */   // Label 2362: @121093
     /* 121093 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(121154), // Rule ID 3030 //
     /* 121098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 121101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121113 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 121113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 121116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 121128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 121132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 121134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121152 */     GIR_RootConstrainSelectedInstOperands,
     /* 121153 */     // GIR_Coverage, 3030,
     /* 121153 */     GIR_EraseRootFromParent_Done,
     /* 121154 */   // Label 2363: @121154
     /* 121154 */   GIM_Reject,
     /* 121155 */ // Label 2360: @121155
     /* 121155 */ GIM_Reject,
     /* 121156 */ // Label 2353: @121156
     /* 121156 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(121334),
     /* 121161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121167 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(121245), // Rule ID 4120 //
     /* 121172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 121175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121215 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 121215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 121218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 121224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 121228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121243 */     GIR_RootConstrainSelectedInstOperands,
     /* 121244 */     // GIR_Coverage, 4120,
     /* 121244 */     GIR_EraseRootFromParent_Done,
     /* 121245 */   // Label 2365: @121245
     /* 121245 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(121272), // Rule ID 1216 //
     /* 121250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 121253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121265 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 121270 */     GIR_RootConstrainSelectedInstOperands,
     /* 121271 */     // GIR_Coverage, 1216,
     /* 121271 */     GIR_Done,
     /* 121272 */   // Label 2366: @121272
     /* 121272 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(121333), // Rule ID 3285 //
     /* 121277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 121280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121292 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 121292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 121295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 121307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 121311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 121313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121331 */     GIR_RootConstrainSelectedInstOperands,
     /* 121332 */     // GIR_Coverage, 3285,
     /* 121332 */     GIR_EraseRootFromParent_Done,
     /* 121333 */   // Label 2367: @121333
     /* 121333 */   GIM_Reject,
     /* 121334 */ // Label 2364: @121334
     /* 121334 */ GIM_Reject,
     /* 121335 */ // Label 2354: @121335
     /* 121335 */ GIM_Reject,
     /* 121336 */ // Label 49: @121336
     /* 121336 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2374*/ GIMT_Encode4(122069),
     /* 121347 */ /*GILLT_s16*//*Label 2368*/ GIMT_Encode4(121399),
     /* 121351 */ /*GILLT_s32*//*Label 2369*/ GIMT_Encode4(121640), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121363 */ /*GILLT_v2s32*//*Label 2370*/ GIMT_Encode4(121881), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121375 */ /*GILLT_v4s16*//*Label 2371*/ GIMT_Encode4(121928),
     /* 121379 */ /*GILLT_v4s32*//*Label 2372*/ GIMT_Encode4(121975), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121395 */ /*GILLT_v8s16*//*Label 2373*/ GIMT_Encode4(122022),
     /* 121399 */ // Label 2368: @121399
     /* 121399 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(121639), // Rule ID 2707 //
     /* 121404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121425 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121425 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121428 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121432 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121439 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121442 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121446 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121451 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121454 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121459 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121462 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121466 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121471 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121474 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121478 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121481 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121486 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121491 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121496 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121499 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121503 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121510 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121513 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121517 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121522 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121525 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121530 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121533 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121537 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121542 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121545 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121549 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121552 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121557 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121562 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121567 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121570 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121574 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121579 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121582 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121585 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121588 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121608 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121611 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121621 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121628 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121638 */   // GIR_Coverage, 2707,
     /* 121638 */   GIR_EraseRootFromParent_Done,
     /* 121639 */ // Label 2375: @121639
     /* 121639 */ GIM_Reject,
     /* 121640 */ // Label 2369: @121640
     /* 121640 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(121880), // Rule ID 2709 //
     /* 121645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121666 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121666 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121669 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121673 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121680 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121683 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121687 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121692 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121695 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121700 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121703 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121707 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121712 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121715 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121719 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121722 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121727 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121732 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121737 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121740 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121744 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121751 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121754 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121758 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121763 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121766 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121771 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121774 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121778 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121783 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121786 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121790 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121793 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121798 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121803 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121808 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121811 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121815 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121820 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121823 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121826 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121829 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121849 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121852 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121862 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121874 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121879 */   // GIR_Coverage, 2709,
     /* 121879 */   GIR_EraseRootFromParent_Done,
     /* 121880 */ // Label 2376: @121880
     /* 121880 */ GIM_Reject,
     /* 121881 */ // Label 2370: @121881
     /* 121881 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(121927), // Rule ID 1229 //
     /* 121886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121907 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121912 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121914 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121919 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121925 */   GIR_RootConstrainSelectedInstOperands,
     /* 121926 */   // GIR_Coverage, 1229,
     /* 121926 */   GIR_EraseRootFromParent_Done,
     /* 121927 */ // Label 2377: @121927
     /* 121927 */ GIM_Reject,
     /* 121928 */ // Label 2371: @121928
     /* 121928 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(121974), // Rule ID 1231 //
     /* 121933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121954 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121959 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121961 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121966 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121972 */   GIR_RootConstrainSelectedInstOperands,
     /* 121973 */   // GIR_Coverage, 1231,
     /* 121973 */   GIR_EraseRootFromParent_Done,
     /* 121974 */ // Label 2378: @121974
     /* 121974 */ GIM_Reject,
     /* 121975 */ // Label 2372: @121975
     /* 121975 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(122021), // Rule ID 1230 //
     /* 121980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122001 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 122004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122006 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122008 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122013 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122019 */   GIR_RootConstrainSelectedInstOperands,
     /* 122020 */   // GIR_Coverage, 1230,
     /* 122020 */   GIR_EraseRootFromParent_Done,
     /* 122021 */ // Label 2379: @122021
     /* 122021 */ GIM_Reject,
     /* 122022 */ // Label 2373: @122022
     /* 122022 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(122068), // Rule ID 1232 //
     /* 122027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122048 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 122051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122053 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122055 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122060 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122066 */   GIR_RootConstrainSelectedInstOperands,
     /* 122067 */   // GIR_Coverage, 1232,
     /* 122067 */   GIR_EraseRootFromParent_Done,
     /* 122068 */ // Label 2380: @122068
     /* 122068 */ GIM_Reject,
     /* 122069 */ // Label 2374: @122069
     /* 122069 */ GIM_Reject,
     /* 122070 */ // Label 50: @122070
     /* 122070 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2387*/ GIMT_Encode4(122803),
     /* 122081 */ /*GILLT_s16*//*Label 2381*/ GIMT_Encode4(122133),
     /* 122085 */ /*GILLT_s32*//*Label 2382*/ GIMT_Encode4(122374), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122097 */ /*GILLT_v2s32*//*Label 2383*/ GIMT_Encode4(122615), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122109 */ /*GILLT_v4s16*//*Label 2384*/ GIMT_Encode4(122662),
     /* 122113 */ /*GILLT_v4s32*//*Label 2385*/ GIMT_Encode4(122709), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122129 */ /*GILLT_v8s16*//*Label 2386*/ GIMT_Encode4(122756),
     /* 122133 */ // Label 2381: @122133
     /* 122133 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122373), // Rule ID 2706 //
     /* 122138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 122141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 122144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 122147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122159 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122159 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 122162 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122166 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122173 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 122176 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122180 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122185 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122188 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122193 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 122196 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122200 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122205 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122208 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122212 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122215 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122220 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122225 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122230 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 122233 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122237 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122244 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 122247 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122251 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122256 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122259 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122264 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 122267 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122271 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122276 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122279 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122283 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122286 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122291 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122296 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122301 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122304 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122308 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122313 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122316 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122319 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122322 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 122333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122342 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122345 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122355 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122367 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122372 */   // GIR_Coverage, 2706,
     /* 122372 */   GIR_EraseRootFromParent_Done,
     /* 122373 */ // Label 2388: @122373
     /* 122373 */ GIM_Reject,
     /* 122374 */ // Label 2382: @122374
     /* 122374 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(122614), // Rule ID 2708 //
     /* 122379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122400 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122400 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 122403 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122407 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122414 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 122417 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122421 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122426 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122429 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122434 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 122437 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122441 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122446 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122449 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122453 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122456 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122461 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122466 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122471 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 122474 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122478 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122485 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 122488 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122492 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122497 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122500 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122505 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 122508 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122512 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122517 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122520 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122524 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122527 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122532 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122537 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122542 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122545 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122549 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122554 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122557 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122560 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122563 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 122574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122583 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122586 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122596 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122613 */   // GIR_Coverage, 2708,
     /* 122613 */   GIR_EraseRootFromParent_Done,
     /* 122614 */ // Label 2389: @122614
     /* 122614 */ GIM_Reject,
     /* 122615 */ // Label 2383: @122615
     /* 122615 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(122661), // Rule ID 1209 //
     /* 122620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122641 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122646 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122648 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122653 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122659 */   GIR_RootConstrainSelectedInstOperands,
     /* 122660 */   // GIR_Coverage, 1209,
     /* 122660 */   GIR_EraseRootFromParent_Done,
     /* 122661 */ // Label 2390: @122661
     /* 122661 */ GIM_Reject,
     /* 122662 */ // Label 2384: @122662
     /* 122662 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(122708), // Rule ID 1211 //
     /* 122667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122688 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122693 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122695 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122700 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122706 */   GIR_RootConstrainSelectedInstOperands,
     /* 122707 */   // GIR_Coverage, 1211,
     /* 122707 */   GIR_EraseRootFromParent_Done,
     /* 122708 */ // Label 2391: @122708
     /* 122708 */ GIM_Reject,
     /* 122709 */ // Label 2385: @122709
     /* 122709 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(122755), // Rule ID 1210 //
     /* 122714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122735 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122740 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122742 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122753 */   GIR_RootConstrainSelectedInstOperands,
     /* 122754 */   // GIR_Coverage, 1210,
     /* 122754 */   GIR_EraseRootFromParent_Done,
     /* 122755 */ // Label 2392: @122755
     /* 122755 */ GIM_Reject,
     /* 122756 */ // Label 2386: @122756
     /* 122756 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(122802), // Rule ID 1212 //
     /* 122761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122778 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122782 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122787 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122789 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122794 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122800 */   GIR_RootConstrainSelectedInstOperands,
     /* 122801 */   // GIR_Coverage, 1212,
     /* 122801 */   GIR_EraseRootFromParent_Done,
     /* 122802 */ // Label 2393: @122802
     /* 122802 */ GIM_Reject,
     /* 122803 */ // Label 2387: @122803
     /* 122803 */ GIM_Reject,
     /* 122804 */ // Label 51: @122804
     /* 122804 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(122836), // Rule ID 2419 //
     /* 122809 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122816 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122834 */   GIR_RootConstrainSelectedInstOperands,
     /* 122835 */   // GIR_Coverage, 2419,
     /* 122835 */   GIR_EraseRootFromParent_Done,
     /* 122836 */ // Label 2394: @122836
     /* 122836 */ GIM_Reject,
     /* 122837 */ // Label 52: @122837
     /* 122837 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(122872), // Rule ID 2420 //
     /* 122842 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122849 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /* 122849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122852 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122857 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122863 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122866 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122870 */   GIR_RootConstrainSelectedInstOperands,
     /* 122871 */   // GIR_Coverage, 2420,
     /* 122871 */   GIR_EraseRootFromParent_Done,
     /* 122872 */ // Label 2395: @122872
     /* 122872 */ GIM_Reject,
     /* 122873 */ // Label 53: @122873
     /* 122873 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(122937), // Rule ID 2421 //
     /* 122878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122881 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122893 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122896 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122899 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122905 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122922 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122928 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122931 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122935 */   GIR_RootConstrainSelectedInstOperands,
     /* 122936 */   // GIR_Coverage, 2421,
     /* 122936 */   GIR_EraseRootFromParent_Done,
     /* 122937 */ // Label 2396: @122937
     /* 122937 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(123001), // Rule ID 2422 //
     /* 122942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122945 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122957 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122963 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122966 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122969 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122986 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122992 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122995 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122999 */   GIR_RootConstrainSelectedInstOperands,
     /* 123000 */   // GIR_Coverage, 2422,
     /* 123000 */   GIR_EraseRootFromParent_Done,
     /* 123001 */ // Label 2397: @123001
     /* 123001 */ GIM_Reject,
     /* 123002 */ // Label 54: @123002
     /* 123002 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(123034), // Rule ID 2423 //
     /* 123007 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 123010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 123014 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 123014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 123017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123022 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123028 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123032 */   GIR_RootConstrainSelectedInstOperands,
     /* 123033 */   // GIR_Coverage, 2423,
     /* 123033 */   GIR_EraseRootFromParent_Done,
     /* 123034 */ // Label 2398: @123034
     /* 123034 */ GIM_Reject,
     /* 123035 */ // Label 55: @123035
     /* 123035 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2405*/ GIMT_Encode4(123577),
     /* 123046 */ /*GILLT_v2s32*//*Label 2399*/ GIMT_Encode4(123094), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123058 */ /*GILLT_v4s16*//*Label 2400*/ GIMT_Encode4(123141),
     /* 123062 */ /*GILLT_v4s32*//*Label 2401*/ GIMT_Encode4(123188), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123074 */ /*GILLT_v8s8*//*Label 2402*/ GIMT_Encode4(123302),
     /* 123078 */ /*GILLT_v8s16*//*Label 2403*/ GIMT_Encode4(123349), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123090 */ /*GILLT_v16s8*//*Label 2404*/ GIMT_Encode4(123463),
     /* 123094 */ // Label 2399: @123094
     /* 123094 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(123140), // Rule ID 1218 //
     /* 123099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123120 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 123123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123125 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123127 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123132 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123138 */   GIR_RootConstrainSelectedInstOperands,
     /* 123139 */   // GIR_Coverage, 1218,
     /* 123139 */   GIR_EraseRootFromParent_Done,
     /* 123140 */ // Label 2406: @123140
     /* 123140 */ GIM_Reject,
     /* 123141 */ // Label 2400: @123141
     /* 123141 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(123187), // Rule ID 1217 //
     /* 123146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123167 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 123170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123172 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123174 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123179 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123185 */   GIR_RootConstrainSelectedInstOperands,
     /* 123186 */   // GIR_Coverage, 1217,
     /* 123186 */   GIR_EraseRootFromParent_Done,
     /* 123187 */ // Label 2407: @123187
     /* 123187 */ GIM_Reject,
     /* 123188 */ // Label 2401: @123188
     /* 123188 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(123301),
     /* 123193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123199 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(123239), // Rule ID 1220 //
     /* 123204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123219 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 123222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123237 */     GIR_RootConstrainSelectedInstOperands,
     /* 123238 */     // GIR_Coverage, 1220,
     /* 123238 */     GIR_EraseRootFromParent_Done,
     /* 123239 */   // Label 2409: @123239
     /* 123239 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(123300), // Rule ID 3300 //
     /* 123244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123259 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 123274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123298 */     GIR_RootConstrainSelectedInstOperands,
     /* 123299 */     // GIR_Coverage, 3300,
     /* 123299 */     GIR_EraseRootFromParent_Done,
     /* 123300 */   // Label 2410: @123300
     /* 123300 */   GIM_Reject,
     /* 123301 */ // Label 2408: @123301
     /* 123301 */ GIM_Reject,
     /* 123302 */ // Label 2402: @123302
     /* 123302 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(123348), // Rule ID 1221 //
     /* 123307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123328 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 123331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123333 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123335 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123340 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123346 */   GIR_RootConstrainSelectedInstOperands,
     /* 123347 */   // GIR_Coverage, 1221,
     /* 123347 */   GIR_EraseRootFromParent_Done,
     /* 123348 */ // Label 2411: @123348
     /* 123348 */ GIM_Reject,
     /* 123349 */ // Label 2403: @123349
     /* 123349 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(123462),
     /* 123354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123360 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(123400), // Rule ID 1219 //
     /* 123365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123380 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 123383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123398 */     GIR_RootConstrainSelectedInstOperands,
     /* 123399 */     // GIR_Coverage, 1219,
     /* 123399 */     GIR_EraseRootFromParent_Done,
     /* 123400 */   // Label 2413: @123400
     /* 123400 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(123461), // Rule ID 3297 //
     /* 123405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123420 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 123435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123459 */     GIR_RootConstrainSelectedInstOperands,
     /* 123460 */     // GIR_Coverage, 3297,
     /* 123460 */     GIR_EraseRootFromParent_Done,
     /* 123461 */   // Label 2414: @123461
     /* 123461 */   GIM_Reject,
     /* 123462 */ // Label 2412: @123462
     /* 123462 */ GIM_Reject,
     /* 123463 */ // Label 2404: @123463
     /* 123463 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(123576),
     /* 123468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123474 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(123514), // Rule ID 1222 //
     /* 123479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123494 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 123497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123512 */     GIR_RootConstrainSelectedInstOperands,
     /* 123513 */     // GIR_Coverage, 1222,
     /* 123513 */     GIR_EraseRootFromParent_Done,
     /* 123514 */   // Label 2416: @123514
     /* 123514 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(123575), // Rule ID 3294 //
     /* 123519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123534 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 123549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123573 */     GIR_RootConstrainSelectedInstOperands,
     /* 123574 */     // GIR_Coverage, 3294,
     /* 123574 */     GIR_EraseRootFromParent_Done,
     /* 123575 */   // Label 2417: @123575
     /* 123575 */   GIM_Reject,
     /* 123576 */ // Label 2415: @123576
     /* 123576 */ GIM_Reject,
     /* 123577 */ // Label 2405: @123577
     /* 123577 */ GIM_Reject,
     /* 123578 */ // Label 56: @123578
     /* 123578 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2424*/ GIMT_Encode4(124120),
     /* 123589 */ /*GILLT_v2s32*//*Label 2418*/ GIMT_Encode4(123637), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123601 */ /*GILLT_v4s16*//*Label 2419*/ GIMT_Encode4(123684),
     /* 123605 */ /*GILLT_v4s32*//*Label 2420*/ GIMT_Encode4(123731), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123617 */ /*GILLT_v8s8*//*Label 2421*/ GIMT_Encode4(123845),
     /* 123621 */ /*GILLT_v8s16*//*Label 2422*/ GIMT_Encode4(123892), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123633 */ /*GILLT_v16s8*//*Label 2423*/ GIMT_Encode4(124006),
     /* 123637 */ // Label 2418: @123637
     /* 123637 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123683), // Rule ID 1198 //
     /* 123642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123663 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123668 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123670 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123675 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123681 */   GIR_RootConstrainSelectedInstOperands,
     /* 123682 */   // GIR_Coverage, 1198,
     /* 123682 */   GIR_EraseRootFromParent_Done,
     /* 123683 */ // Label 2425: @123683
     /* 123683 */ GIM_Reject,
     /* 123684 */ // Label 2419: @123684
     /* 123684 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123730), // Rule ID 1197 //
     /* 123689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123710 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123715 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123717 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123722 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123728 */   GIR_RootConstrainSelectedInstOperands,
     /* 123729 */   // GIR_Coverage, 1197,
     /* 123729 */   GIR_EraseRootFromParent_Done,
     /* 123730 */ // Label 2426: @123730
     /* 123730 */ GIM_Reject,
     /* 123731 */ // Label 2420: @123731
     /* 123731 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(123844),
     /* 123736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123742 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(123782), // Rule ID 1200 //
     /* 123747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123762 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123780 */     GIR_RootConstrainSelectedInstOperands,
     /* 123781 */     // GIR_Coverage, 1200,
     /* 123781 */     GIR_EraseRootFromParent_Done,
     /* 123782 */   // Label 2428: @123782
     /* 123782 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(123843), // Rule ID 3318 //
     /* 123787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123802 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123841 */     GIR_RootConstrainSelectedInstOperands,
     /* 123842 */     // GIR_Coverage, 3318,
     /* 123842 */     GIR_EraseRootFromParent_Done,
     /* 123843 */   // Label 2429: @123843
     /* 123843 */   GIM_Reject,
     /* 123844 */ // Label 2427: @123844
     /* 123844 */ GIM_Reject,
     /* 123845 */ // Label 2421: @123845
     /* 123845 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(123891), // Rule ID 1201 //
     /* 123850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123871 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123876 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123878 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123883 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123889 */   GIR_RootConstrainSelectedInstOperands,
     /* 123890 */   // GIR_Coverage, 1201,
     /* 123890 */   GIR_EraseRootFromParent_Done,
     /* 123891 */ // Label 2430: @123891
     /* 123891 */ GIM_Reject,
     /* 123892 */ // Label 2422: @123892
     /* 123892 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(124005),
     /* 123897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123903 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(123943), // Rule ID 1199 //
     /* 123908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123923 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123941 */     GIR_RootConstrainSelectedInstOperands,
     /* 123942 */     // GIR_Coverage, 1199,
     /* 123942 */     GIR_EraseRootFromParent_Done,
     /* 123943 */   // Label 2432: @123943
     /* 123943 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(124004), // Rule ID 3315 //
     /* 123948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123963 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124002 */     GIR_RootConstrainSelectedInstOperands,
     /* 124003 */     // GIR_Coverage, 3315,
     /* 124003 */     GIR_EraseRootFromParent_Done,
     /* 124004 */   // Label 2433: @124004
     /* 124004 */   GIM_Reject,
     /* 124005 */ // Label 2431: @124005
     /* 124005 */ GIM_Reject,
     /* 124006 */ // Label 2423: @124006
     /* 124006 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(124119),
     /* 124011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124017 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(124057), // Rule ID 1202 //
     /* 124022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124037 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 124040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124055 */     GIR_RootConstrainSelectedInstOperands,
     /* 124056 */     // GIR_Coverage, 1202,
     /* 124056 */     GIR_EraseRootFromParent_Done,
     /* 124057 */   // Label 2435: @124057
     /* 124057 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(124118), // Rule ID 3312 //
     /* 124062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124077 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 124092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124116 */     GIR_RootConstrainSelectedInstOperands,
     /* 124117 */     // GIR_Coverage, 3312,
     /* 124117 */     GIR_EraseRootFromParent_Done,
     /* 124118 */   // Label 2436: @124118
     /* 124118 */   GIM_Reject,
     /* 124119 */ // Label 2434: @124119
     /* 124119 */ GIM_Reject,
     /* 124120 */ // Label 2424: @124120
     /* 124120 */ GIM_Reject,
     /* 124121 */ // Label 57: @124121
     /* 124121 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2443*/ GIMT_Encode4(125041),
     /* 124132 */ /*GILLT_v2s32*//*Label 2437*/ GIMT_Encode4(124180), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124144 */ /*GILLT_v4s16*//*Label 2438*/ GIMT_Encode4(124227),
     /* 124148 */ /*GILLT_v4s32*//*Label 2439*/ GIMT_Encode4(124274), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124160 */ /*GILLT_v8s8*//*Label 2440*/ GIMT_Encode4(124514),
     /* 124164 */ /*GILLT_v8s16*//*Label 2441*/ GIMT_Encode4(124561), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124176 */ /*GILLT_v16s8*//*Label 2442*/ GIMT_Encode4(124801),
     /* 124180 */ // Label 2437: @124180
     /* 124180 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(124226), // Rule ID 1224 //
     /* 124185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124206 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 124209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124211 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124213 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124218 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124224 */   GIR_RootConstrainSelectedInstOperands,
     /* 124225 */   // GIR_Coverage, 1224,
     /* 124225 */   GIR_EraseRootFromParent_Done,
     /* 124226 */ // Label 2444: @124226
     /* 124226 */ GIM_Reject,
     /* 124227 */ // Label 2438: @124227
     /* 124227 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(124273), // Rule ID 1223 //
     /* 124232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124253 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 124256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124258 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124260 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124265 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124271 */   GIR_RootConstrainSelectedInstOperands,
     /* 124272 */   // GIR_Coverage, 1223,
     /* 124272 */   GIR_EraseRootFromParent_Done,
     /* 124273 */ // Label 2445: @124273
     /* 124273 */ GIM_Reject,
     /* 124274 */ // Label 2439: @124274
     /* 124274 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(124513),
     /* 124279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124285 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(124348), // Rule ID 6027 //
     /* 124290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124320 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124340 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124346 */     GIR_RootConstrainSelectedInstOperands,
     /* 124347 */     // GIR_Coverage, 6027,
     /* 124347 */     GIR_EraseRootFromParent_Done,
     /* 124348 */   // Label 2447: @124348
     /* 124348 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(124411), // Rule ID 3697 //
     /* 124353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124383 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124409 */     GIR_RootConstrainSelectedInstOperands,
     /* 124410 */     // GIR_Coverage, 3697,
     /* 124410 */     GIR_EraseRootFromParent_Done,
     /* 124411 */   // Label 2448: @124411
     /* 124411 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124451), // Rule ID 1226 //
     /* 124416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124431 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 124434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124449 */     GIR_RootConstrainSelectedInstOperands,
     /* 124450 */     // GIR_Coverage, 1226,
     /* 124450 */     GIR_EraseRootFromParent_Done,
     /* 124451 */   // Label 2449: @124451
     /* 124451 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(124512), // Rule ID 3309 //
     /* 124456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124471 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 124486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124510 */     GIR_RootConstrainSelectedInstOperands,
     /* 124511 */     // GIR_Coverage, 3309,
     /* 124511 */     GIR_EraseRootFromParent_Done,
     /* 124512 */   // Label 2450: @124512
     /* 124512 */   GIM_Reject,
     /* 124513 */ // Label 2446: @124513
     /* 124513 */ GIM_Reject,
     /* 124514 */ // Label 2440: @124514
     /* 124514 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124560), // Rule ID 1227 //
     /* 124519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124540 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 124543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124545 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124547 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124552 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124558 */   GIR_RootConstrainSelectedInstOperands,
     /* 124559 */   // GIR_Coverage, 1227,
     /* 124559 */   GIR_EraseRootFromParent_Done,
     /* 124560 */ // Label 2451: @124560
     /* 124560 */ GIM_Reject,
     /* 124561 */ // Label 2441: @124561
     /* 124561 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(124800),
     /* 124566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124572 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(124635), // Rule ID 6026 //
     /* 124577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124607 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124633 */     GIR_RootConstrainSelectedInstOperands,
     /* 124634 */     // GIR_Coverage, 6026,
     /* 124634 */     GIR_EraseRootFromParent_Done,
     /* 124635 */   // Label 2453: @124635
     /* 124635 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(124698), // Rule ID 3695 //
     /* 124640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124670 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124696 */     GIR_RootConstrainSelectedInstOperands,
     /* 124697 */     // GIR_Coverage, 3695,
     /* 124697 */     GIR_EraseRootFromParent_Done,
     /* 124698 */   // Label 2454: @124698
     /* 124698 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(124738), // Rule ID 1225 //
     /* 124703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124718 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124736 */     GIR_RootConstrainSelectedInstOperands,
     /* 124737 */     // GIR_Coverage, 1225,
     /* 124737 */     GIR_EraseRootFromParent_Done,
     /* 124738 */   // Label 2455: @124738
     /* 124738 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(124799), // Rule ID 3306 //
     /* 124743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124758 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124797 */     GIR_RootConstrainSelectedInstOperands,
     /* 124798 */     // GIR_Coverage, 3306,
     /* 124798 */     GIR_EraseRootFromParent_Done,
     /* 124799 */   // Label 2456: @124799
     /* 124799 */   GIM_Reject,
     /* 124800 */ // Label 2452: @124800
     /* 124800 */ GIM_Reject,
     /* 124801 */ // Label 2442: @124801
     /* 124801 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(125040),
     /* 124806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124812 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(124875), // Rule ID 6025 //
     /* 124817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124847 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124873 */     GIR_RootConstrainSelectedInstOperands,
     /* 124874 */     // GIR_Coverage, 6025,
     /* 124874 */     GIR_EraseRootFromParent_Done,
     /* 124875 */   // Label 2458: @124875
     /* 124875 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(124938), // Rule ID 3693 //
     /* 124880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124910 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124936 */     GIR_RootConstrainSelectedInstOperands,
     /* 124937 */     // GIR_Coverage, 3693,
     /* 124937 */     GIR_EraseRootFromParent_Done,
     /* 124938 */   // Label 2459: @124938
     /* 124938 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(124978), // Rule ID 1228 //
     /* 124943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124958 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124976 */     GIR_RootConstrainSelectedInstOperands,
     /* 124977 */     // GIR_Coverage, 1228,
     /* 124977 */     GIR_EraseRootFromParent_Done,
     /* 124978 */   // Label 2460: @124978
     /* 124978 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(125039), // Rule ID 3303 //
     /* 124983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124998 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 125013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125037 */     GIR_RootConstrainSelectedInstOperands,
     /* 125038 */     // GIR_Coverage, 3303,
     /* 125038 */     GIR_EraseRootFromParent_Done,
     /* 125039 */   // Label 2461: @125039
     /* 125039 */   GIM_Reject,
     /* 125040 */ // Label 2457: @125040
     /* 125040 */ GIM_Reject,
     /* 125041 */ // Label 2443: @125041
     /* 125041 */ GIM_Reject,
     /* 125042 */ // Label 58: @125042
     /* 125042 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2468*/ GIMT_Encode4(125962),
     /* 125053 */ /*GILLT_v2s32*//*Label 2462*/ GIMT_Encode4(125101), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125065 */ /*GILLT_v4s16*//*Label 2463*/ GIMT_Encode4(125148),
     /* 125069 */ /*GILLT_v4s32*//*Label 2464*/ GIMT_Encode4(125195), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125081 */ /*GILLT_v8s8*//*Label 2465*/ GIMT_Encode4(125435),
     /* 125085 */ /*GILLT_v8s16*//*Label 2466*/ GIMT_Encode4(125482), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125097 */ /*GILLT_v16s8*//*Label 2467*/ GIMT_Encode4(125722),
     /* 125101 */ // Label 2462: @125101
     /* 125101 */ GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(125147), // Rule ID 1204 //
     /* 125106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 125115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125127 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 125127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 125130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125132 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125134 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125139 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125145 */   GIR_RootConstrainSelectedInstOperands,
     /* 125146 */   // GIR_Coverage, 1204,
     /* 125146 */   GIR_EraseRootFromParent_Done,
     /* 125147 */ // Label 2469: @125147
     /* 125147 */ GIM_Reject,
     /* 125148 */ // Label 2463: @125148
     /* 125148 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(125194), // Rule ID 1203 //
     /* 125153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 125162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125174 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 125174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 125177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125179 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125181 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125186 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125192 */   GIR_RootConstrainSelectedInstOperands,
     /* 125193 */   // GIR_Coverage, 1203,
     /* 125193 */   GIR_EraseRootFromParent_Done,
     /* 125194 */ // Label 2470: @125194
     /* 125194 */ GIM_Reject,
     /* 125195 */ // Label 2464: @125195
     /* 125195 */ GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(125434),
     /* 125200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 125206 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(125269), // Rule ID 6030 //
     /* 125211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125241 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125267 */     GIR_RootConstrainSelectedInstOperands,
     /* 125268 */     // GIR_Coverage, 6030,
     /* 125268 */     GIR_EraseRootFromParent_Done,
     /* 125269 */   // Label 2472: @125269
     /* 125269 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(125332), // Rule ID 3703 //
     /* 125274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125304 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125330 */     GIR_RootConstrainSelectedInstOperands,
     /* 125331 */     // GIR_Coverage, 3703,
     /* 125331 */     GIR_EraseRootFromParent_Done,
     /* 125332 */   // Label 2473: @125332
     /* 125332 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125372), // Rule ID 1206 //
     /* 125337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125352 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 125352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 125355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125370 */     GIR_RootConstrainSelectedInstOperands,
     /* 125371 */     // GIR_Coverage, 1206,
     /* 125371 */     GIR_EraseRootFromParent_Done,
     /* 125372 */   // Label 2474: @125372
     /* 125372 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(125433), // Rule ID 3327 //
     /* 125377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125392 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 125392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 125407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125431 */     GIR_RootConstrainSelectedInstOperands,
     /* 125432 */     // GIR_Coverage, 3327,
     /* 125432 */     GIR_EraseRootFromParent_Done,
     /* 125433 */   // Label 2475: @125433
     /* 125433 */   GIM_Reject,
     /* 125434 */ // Label 2471: @125434
     /* 125434 */ GIM_Reject,
     /* 125435 */ // Label 2465: @125435
     /* 125435 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(125481), // Rule ID 1207 //
     /* 125440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 125449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125461 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 125461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 125464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125466 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125468 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125473 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125479 */   GIR_RootConstrainSelectedInstOperands,
     /* 125480 */   // GIR_Coverage, 1207,
     /* 125480 */   GIR_EraseRootFromParent_Done,
     /* 125481 */ // Label 2476: @125481
     /* 125481 */ GIM_Reject,
     /* 125482 */ // Label 2466: @125482
     /* 125482 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(125721),
     /* 125487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 125493 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(125556), // Rule ID 6029 //
     /* 125498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125528 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125554 */     GIR_RootConstrainSelectedInstOperands,
     /* 125555 */     // GIR_Coverage, 6029,
     /* 125555 */     GIR_EraseRootFromParent_Done,
     /* 125556 */   // Label 2478: @125556
     /* 125556 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(125619), // Rule ID 3701 //
     /* 125561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125591 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125617 */     GIR_RootConstrainSelectedInstOperands,
     /* 125618 */     // GIR_Coverage, 3701,
     /* 125618 */     GIR_EraseRootFromParent_Done,
     /* 125619 */   // Label 2479: @125619
     /* 125619 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(125659), // Rule ID 1205 //
     /* 125624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125639 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125657 */     GIR_RootConstrainSelectedInstOperands,
     /* 125658 */     // GIR_Coverage, 1205,
     /* 125658 */     GIR_EraseRootFromParent_Done,
     /* 125659 */   // Label 2480: @125659
     /* 125659 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(125720), // Rule ID 3324 //
     /* 125664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125679 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125718 */     GIR_RootConstrainSelectedInstOperands,
     /* 125719 */     // GIR_Coverage, 3324,
     /* 125719 */     GIR_EraseRootFromParent_Done,
     /* 125720 */   // Label 2481: @125720
     /* 125720 */   GIM_Reject,
     /* 125721 */ // Label 2477: @125721
     /* 125721 */ GIM_Reject,
     /* 125722 */ // Label 2467: @125722
     /* 125722 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(125961),
     /* 125727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125733 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(125796), // Rule ID 6028 //
     /* 125738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125768 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125794 */     GIR_RootConstrainSelectedInstOperands,
     /* 125795 */     // GIR_Coverage, 6028,
     /* 125795 */     GIR_EraseRootFromParent_Done,
     /* 125796 */   // Label 2483: @125796
     /* 125796 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(125859), // Rule ID 3699 //
     /* 125801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125831 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125857 */     GIR_RootConstrainSelectedInstOperands,
     /* 125858 */     // GIR_Coverage, 3699,
     /* 125858 */     GIR_EraseRootFromParent_Done,
     /* 125859 */   // Label 2484: @125859
     /* 125859 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(125899), // Rule ID 1208 //
     /* 125864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125879 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125897 */     GIR_RootConstrainSelectedInstOperands,
     /* 125898 */     // GIR_Coverage, 1208,
     /* 125898 */     GIR_EraseRootFromParent_Done,
     /* 125899 */   // Label 2485: @125899
     /* 125899 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(125960), // Rule ID 3321 //
     /* 125904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125919 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125958 */     GIR_RootConstrainSelectedInstOperands,
     /* 125959 */     // GIR_Coverage, 3321,
     /* 125959 */     GIR_EraseRootFromParent_Done,
     /* 125960 */   // Label 2486: @125960
     /* 125960 */   GIM_Reject,
     /* 125961 */ // Label 2482: @125961
     /* 125961 */ GIM_Reject,
     /* 125962 */ // Label 2468: @125962
     /* 125962 */ GIM_Reject,
     /* 125963 */ // Label 59: @125963
     /* 125963 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2493*/ GIMT_Encode4(126433),
     /* 125974 */ /*GILLT_v2s32*//*Label 2487*/ GIMT_Encode4(126022), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125986 */ /*GILLT_v4s16*//*Label 2488*/ GIMT_Encode4(126060),
     /* 125990 */ /*GILLT_v4s32*//*Label 2489*/ GIMT_Encode4(126098), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126002 */ /*GILLT_v8s8*//*Label 2490*/ GIMT_Encode4(126197),
     /* 126006 */ /*GILLT_v8s16*//*Label 2491*/ GIMT_Encode4(126235), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126018 */ /*GILLT_v16s8*//*Label 2492*/ GIMT_Encode4(126334),
     /* 126022 */ // Label 2487: @126022
     /* 126022 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(126059), // Rule ID 1510 //
     /* 126027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126041 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 126044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126046 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126051 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126057 */   GIR_RootConstrainSelectedInstOperands,
     /* 126058 */   // GIR_Coverage, 1510,
     /* 126058 */   GIR_EraseRootFromParent_Done,
     /* 126059 */ // Label 2494: @126059
     /* 126059 */ GIM_Reject,
     /* 126060 */ // Label 2488: @126060
     /* 126060 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(126097), // Rule ID 1509 //
     /* 126065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126079 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 126082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126084 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126089 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126095 */   GIR_RootConstrainSelectedInstOperands,
     /* 126096 */   // GIR_Coverage, 1509,
     /* 126096 */   GIR_EraseRootFromParent_Done,
     /* 126097 */ // Label 2495: @126097
     /* 126097 */ GIM_Reject,
     /* 126098 */ // Label 2489: @126098
     /* 126098 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(126196),
     /* 126103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126106 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(126140), // Rule ID 1513 //
     /* 126111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126122 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 126125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126138 */     GIR_RootConstrainSelectedInstOperands,
     /* 126139 */     // GIR_Coverage, 1513,
     /* 126139 */     GIR_EraseRootFromParent_Done,
     /* 126140 */   // Label 2497: @126140
     /* 126140 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(126195), // Rule ID 3672 //
     /* 126145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126156 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 126156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 126171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126173 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126193 */     GIR_RootConstrainSelectedInstOperands,
     /* 126194 */     // GIR_Coverage, 3672,
     /* 126194 */     GIR_EraseRootFromParent_Done,
     /* 126195 */   // Label 2498: @126195
     /* 126195 */   GIM_Reject,
     /* 126196 */ // Label 2496: @126196
     /* 126196 */ GIM_Reject,
     /* 126197 */ // Label 2490: @126197
     /* 126197 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(126234), // Rule ID 1508 //
     /* 126202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126216 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 126219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126221 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126226 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126232 */   GIR_RootConstrainSelectedInstOperands,
     /* 126233 */   // GIR_Coverage, 1508,
     /* 126233 */   GIR_EraseRootFromParent_Done,
     /* 126234 */ // Label 2499: @126234
     /* 126234 */ GIM_Reject,
     /* 126235 */ // Label 2491: @126235
     /* 126235 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(126333),
     /* 126240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126243 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(126277), // Rule ID 1512 //
     /* 126248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126259 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 126262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126275 */     GIR_RootConstrainSelectedInstOperands,
     /* 126276 */     // GIR_Coverage, 1512,
     /* 126276 */     GIR_EraseRootFromParent_Done,
     /* 126277 */   // Label 2501: @126277
     /* 126277 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(126332), // Rule ID 3666 //
     /* 126282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126293 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 126293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 126308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126310 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126330 */     GIR_RootConstrainSelectedInstOperands,
     /* 126331 */     // GIR_Coverage, 3666,
     /* 126331 */     GIR_EraseRootFromParent_Done,
     /* 126332 */   // Label 2502: @126332
     /* 126332 */   GIM_Reject,
     /* 126333 */ // Label 2500: @126333
     /* 126333 */ GIM_Reject,
     /* 126334 */ // Label 2492: @126334
     /* 126334 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(126432),
     /* 126339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126342 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(126376), // Rule ID 1511 //
     /* 126347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126358 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 126361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126374 */     GIR_RootConstrainSelectedInstOperands,
     /* 126375 */     // GIR_Coverage, 1511,
     /* 126375 */     GIR_EraseRootFromParent_Done,
     /* 126376 */   // Label 2504: @126376
     /* 126376 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(126431), // Rule ID 3660 //
     /* 126381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126392 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 126392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 126407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126409 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126429 */     GIR_RootConstrainSelectedInstOperands,
     /* 126430 */     // GIR_Coverage, 3660,
     /* 126430 */     GIR_EraseRootFromParent_Done,
     /* 126431 */   // Label 2505: @126431
     /* 126431 */   GIM_Reject,
     /* 126432 */ // Label 2503: @126432
     /* 126432 */ GIM_Reject,
     /* 126433 */ // Label 2493: @126433
     /* 126433 */ GIM_Reject,
     /* 126434 */ // Label 60: @126434
     /* 126434 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(126506),
     /* 126439 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 126442 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(126457), // Rule ID 32 //
     /* 126447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 126450 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 126450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 126455 */     GIR_RootConstrainSelectedInstOperands,
     /* 126456 */     // GIR_Coverage, 32,
     /* 126456 */     GIR_Done,
     /* 126457 */   // Label 2507: @126457
     /* 126457 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(126481), // Rule ID 283 //
     /* 126462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 126465 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 126465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 126468 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126479 */     GIR_RootConstrainSelectedInstOperands,
     /* 126480 */     // GIR_Coverage, 283,
     /* 126480 */     GIR_EraseRootFromParent_Done,
     /* 126481 */   // Label 2508: @126481
     /* 126481 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(126505), // Rule ID 577 //
     /* 126486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 126489 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 126489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 126492 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126497 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126503 */     GIR_RootConstrainSelectedInstOperands,
     /* 126504 */     // GIR_Coverage, 577,
     /* 126504 */     GIR_EraseRootFromParent_Done,
     /* 126505 */   // Label 2509: @126505
     /* 126505 */   GIM_Reject,
     /* 126506 */ // Label 2506: @126506
     /* 126506 */ GIM_Reject,
     /* 126507 */ // Label 61: @126507
     /* 126507 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2514*/ GIMT_Encode4(126806),
     /* 126518 */ /*GILLT_v4s16*//*Label 2510*/ GIMT_Encode4(126554), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126534 */ /*GILLT_v8s8*//*Label 2511*/ GIMT_Encode4(126617),
     /* 126538 */ /*GILLT_v8s16*//*Label 2512*/ GIMT_Encode4(126680), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126550 */ /*GILLT_v16s8*//*Label 2513*/ GIMT_Encode4(126743),
     /* 126554 */ // Label 2510: @126554
     /* 126554 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(126616), // Rule ID 1572 //
     /* 126559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126568 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126591 */   // MIs[1] Operand 1
     /* 126591 */   // No operand predicates
     /* 126591 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126593 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 126596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126600 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126602 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126608 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126614 */   GIR_RootConstrainSelectedInstOperands,
     /* 126615 */   // GIR_Coverage, 1572,
     /* 126615 */   GIR_EraseRootFromParent_Done,
     /* 126616 */ // Label 2515: @126616
     /* 126616 */ GIM_Reject,
     /* 126617 */ // Label 2511: @126617
     /* 126617 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(126679), // Rule ID 1571 //
     /* 126622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126631 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126646 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126650 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126654 */   // MIs[1] Operand 1
     /* 126654 */   // No operand predicates
     /* 126654 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126656 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126661 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126663 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126665 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126671 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126677 */   GIR_RootConstrainSelectedInstOperands,
     /* 126678 */   // GIR_Coverage, 1571,
     /* 126678 */   GIR_EraseRootFromParent_Done,
     /* 126679 */ // Label 2516: @126679
     /* 126679 */ GIM_Reject,
     /* 126680 */ // Label 2512: @126680
     /* 126680 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(126742), // Rule ID 3436 //
     /* 126685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126694 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126709 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126713 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126717 */   // MIs[1] Operand 1
     /* 126717 */   // No operand predicates
     /* 126717 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126719 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126724 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126726 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126728 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126734 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126740 */   GIR_RootConstrainSelectedInstOperands,
     /* 126741 */   // GIR_Coverage, 3436,
     /* 126741 */   GIR_EraseRootFromParent_Done,
     /* 126742 */ // Label 2517: @126742
     /* 126742 */ GIM_Reject,
     /* 126743 */ // Label 2513: @126743
     /* 126743 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(126805), // Rule ID 3435 //
     /* 126748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126757 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126772 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126780 */   // MIs[1] Operand 1
     /* 126780 */   // No operand predicates
     /* 126780 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126782 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126787 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126789 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126791 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126797 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126803 */   GIR_RootConstrainSelectedInstOperands,
     /* 126804 */   // GIR_Coverage, 3435,
     /* 126804 */   GIR_EraseRootFromParent_Done,
     /* 126805 */ // Label 2518: @126805
     /* 126805 */ GIM_Reject,
     /* 126806 */ // Label 2514: @126806
     /* 126806 */ GIM_Reject,
     /* 126807 */ // Label 62: @126807
     /* 126807 */ GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(126863), // Rule ID 1570 //
     /* 126812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126815 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126832 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126836 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126840 */   // MIs[1] Operand 1
     /* 126840 */   // No operand predicates
     /* 126840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126842 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126847 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126849 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126855 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126861 */   GIR_RootConstrainSelectedInstOperands,
     /* 126862 */   // GIR_Coverage, 1570,
     /* 126862 */   GIR_EraseRootFromParent_Done,
     /* 126863 */ // Label 2519: @126863
     /* 126863 */ GIM_Reject,
     /* 126864 */ // Label 63: @126864
     /* 126864 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2527*/ GIMT_Encode4(127424),
     /* 126875 */ /*GILLT_s32*//*Label 2520*/ GIMT_Encode4(126935), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126887 */ /*GILLT_v2s32*//*Label 2521*/ GIMT_Encode4(127013), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126899 */ /*GILLT_v4s16*//*Label 2522*/ GIMT_Encode4(127051),
     /* 126903 */ /*GILLT_v4s32*//*Label 2523*/ GIMT_Encode4(127089), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126915 */ /*GILLT_v8s8*//*Label 2524*/ GIMT_Encode4(127188),
     /* 126919 */ /*GILLT_v8s16*//*Label 2525*/ GIMT_Encode4(127226), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126931 */ /*GILLT_v16s8*//*Label 2526*/ GIMT_Encode4(127325),
     /* 126935 */ // Label 2520: @126935
     /* 126935 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(127012),
     /* 126940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126943 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(126977), // Rule ID 197 //
     /* 126948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126959 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126975 */     GIR_RootConstrainSelectedInstOperands,
     /* 126976 */     // GIR_Coverage, 197,
     /* 126976 */     GIR_EraseRootFromParent_Done,
     /* 126977 */   // Label 2529: @126977
     /* 126977 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(127011), // Rule ID 534 //
     /* 126982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126993 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127009 */     GIR_RootConstrainSelectedInstOperands,
     /* 127010 */     // GIR_Coverage, 534,
     /* 127010 */     GIR_EraseRootFromParent_Done,
     /* 127011 */   // Label 2530: @127011
     /* 127011 */   GIM_Reject,
     /* 127012 */ // Label 2528: @127012
     /* 127012 */ GIM_Reject,
     /* 127013 */ // Label 2521: @127013
     /* 127013 */ GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(127050), // Rule ID 1548 //
     /* 127018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 127024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127032 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 127032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 127035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127037 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127048 */   GIR_RootConstrainSelectedInstOperands,
     /* 127049 */   // GIR_Coverage, 1548,
     /* 127049 */   GIR_EraseRootFromParent_Done,
     /* 127050 */ // Label 2531: @127050
     /* 127050 */ GIM_Reject,
     /* 127051 */ // Label 2522: @127051
     /* 127051 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(127088), // Rule ID 1547 //
     /* 127056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 127062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127070 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 127070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 127073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127075 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127080 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127086 */   GIR_RootConstrainSelectedInstOperands,
     /* 127087 */   // GIR_Coverage, 1547,
     /* 127087 */   GIR_EraseRootFromParent_Done,
     /* 127088 */ // Label 2532: @127088
     /* 127088 */ GIM_Reject,
     /* 127089 */ // Label 2523: @127089
     /* 127089 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(127187),
     /* 127094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127097 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(127131), // Rule ID 1551 //
     /* 127102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127113 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 127113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 127116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127129 */     GIR_RootConstrainSelectedInstOperands,
     /* 127130 */     // GIR_Coverage, 1551,
     /* 127130 */     GIR_EraseRootFromParent_Done,
     /* 127131 */   // Label 2534: @127131
     /* 127131 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(127186), // Rule ID 3658 //
     /* 127136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127147 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 127147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 127162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127164 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127184 */     GIR_RootConstrainSelectedInstOperands,
     /* 127185 */     // GIR_Coverage, 3658,
     /* 127185 */     GIR_EraseRootFromParent_Done,
     /* 127186 */   // Label 2535: @127186
     /* 127186 */   GIM_Reject,
     /* 127187 */ // Label 2533: @127187
     /* 127187 */ GIM_Reject,
     /* 127188 */ // Label 2524: @127188
     /* 127188 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(127225), // Rule ID 1546 //
     /* 127193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127207 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 127210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127212 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127217 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127223 */   GIR_RootConstrainSelectedInstOperands,
     /* 127224 */   // GIR_Coverage, 1546,
     /* 127224 */   GIR_EraseRootFromParent_Done,
     /* 127225 */ // Label 2536: @127225
     /* 127225 */ GIM_Reject,
     /* 127226 */ // Label 2525: @127226
     /* 127226 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(127324),
     /* 127231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127234 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(127268), // Rule ID 1550 //
     /* 127239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127250 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 127250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 127253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127266 */     GIR_RootConstrainSelectedInstOperands,
     /* 127267 */     // GIR_Coverage, 1550,
     /* 127267 */     GIR_EraseRootFromParent_Done,
     /* 127268 */   // Label 2538: @127268
     /* 127268 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(127323), // Rule ID 3656 //
     /* 127273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127284 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 127284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 127299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127301 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127321 */     GIR_RootConstrainSelectedInstOperands,
     /* 127322 */     // GIR_Coverage, 3656,
     /* 127322 */     GIR_EraseRootFromParent_Done,
     /* 127323 */   // Label 2539: @127323
     /* 127323 */   GIM_Reject,
     /* 127324 */ // Label 2537: @127324
     /* 127324 */ GIM_Reject,
     /* 127325 */ // Label 2526: @127325
     /* 127325 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(127423),
     /* 127330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127333 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(127367), // Rule ID 1549 //
     /* 127338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127349 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 127352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127365 */     GIR_RootConstrainSelectedInstOperands,
     /* 127366 */     // GIR_Coverage, 1549,
     /* 127366 */     GIR_EraseRootFromParent_Done,
     /* 127367 */   // Label 2541: @127367
     /* 127367 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(127422), // Rule ID 3654 //
     /* 127372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127383 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 127383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 127398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127400 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127420 */     GIR_RootConstrainSelectedInstOperands,
     /* 127421 */     // GIR_Coverage, 3654,
     /* 127421 */     GIR_EraseRootFromParent_Done,
     /* 127422 */   // Label 2542: @127422
     /* 127422 */   GIM_Reject,
     /* 127423 */ // Label 2540: @127423
     /* 127423 */ GIM_Reject,
     /* 127424 */ // Label 2527: @127424
     /* 127424 */ GIM_Reject,
     /* 127425 */ // Label 64: @127425
     /* 127425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2545*/ GIMT_Encode4(127532),
     /* 127436 */ /*GILLT_v8s8*//*Label 2543*/ GIMT_Encode4(127456), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127452 */ /*GILLT_v16s8*//*Label 2544*/ GIMT_Encode4(127494),
     /* 127456 */ // Label 2543: @127456
     /* 127456 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(127493), // Rule ID 1552 //
     /* 127461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127475 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 127478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127480 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127485 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127491 */   GIR_RootConstrainSelectedInstOperands,
     /* 127492 */   // GIR_Coverage, 1552,
     /* 127492 */   GIR_EraseRootFromParent_Done,
     /* 127493 */ // Label 2546: @127493
     /* 127493 */ GIM_Reject,
     /* 127494 */ // Label 2544: @127494
     /* 127494 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(127531), // Rule ID 1553 //
     /* 127499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127513 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 127516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127518 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127523 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127529 */   GIR_RootConstrainSelectedInstOperands,
     /* 127530 */   // GIR_Coverage, 1553,
     /* 127530 */   GIR_EraseRootFromParent_Done,
     /* 127531 */ // Label 2547: @127531
     /* 127531 */ GIM_Reject,
     /* 127532 */ // Label 2545: @127532
     /* 127532 */ GIM_Reject,
     /* 127533 */ // Label 65: @127533
     /* 127533 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2551*/ GIMT_Encode4(127822),
     /* 127544 */ /*GILLT_s32*//*Label 2548*/ GIMT_Encode4(127592), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127572 */ /*GILLT_v4s32*//*Label 2549*/ GIMT_Encode4(127704), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127588 */ /*GILLT_v8s16*//*Label 2550*/ GIMT_Encode4(127763),
     /* 127592 */ // Label 2548: @127592
     /* 127592 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(127703),
     /* 127597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127600 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127634), // Rule ID 199 //
     /* 127605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 127608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127616 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 127619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127632 */     GIR_RootConstrainSelectedInstOperands,
     /* 127633 */     // GIR_Coverage, 199,
     /* 127633 */     GIR_EraseRootFromParent_Done,
     /* 127634 */   // Label 2553: @127634
     /* 127634 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(127668), // Rule ID 326 //
     /* 127639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127650 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127666 */     GIR_RootConstrainSelectedInstOperands,
     /* 127667 */     // GIR_Coverage, 326,
     /* 127667 */     GIR_EraseRootFromParent_Done,
     /* 127668 */   // Label 2554: @127668
     /* 127668 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(127702), // Rule ID 536 //
     /* 127673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127684 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127700 */     GIR_RootConstrainSelectedInstOperands,
     /* 127701 */     // GIR_Coverage, 536,
     /* 127701 */     GIR_EraseRootFromParent_Done,
     /* 127702 */   // Label 2555: @127702
     /* 127702 */   GIM_Reject,
     /* 127703 */ // Label 2552: @127703
     /* 127703 */ GIM_Reject,
     /* 127704 */ // Label 2549: @127704
     /* 127704 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(127762), // Rule ID 3331 //
     /* 127709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127723 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127740 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127745 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127751 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127760 */   GIR_RootConstrainSelectedInstOperands,
     /* 127761 */   // GIR_Coverage, 3331,
     /* 127761 */   GIR_EraseRootFromParent_Done,
     /* 127762 */ // Label 2556: @127762
     /* 127762 */ GIM_Reject,
     /* 127763 */ // Label 2550: @127763
     /* 127763 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(127821), // Rule ID 3330 //
     /* 127768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127782 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127799 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127804 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127810 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127819 */   GIR_RootConstrainSelectedInstOperands,
     /* 127820 */   // GIR_Coverage, 3330,
     /* 127820 */   GIR_EraseRootFromParent_Done,
     /* 127821 */ // Label 2557: @127821
     /* 127821 */ GIM_Reject,
     /* 127822 */ // Label 2551: @127822
     /* 127822 */ GIM_Reject,
     /* 127823 */ // Label 66: @127823
     /* 127823 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2562*/ GIMT_Encode4(128254),
     /* 127834 */ /*GILLT_s32*//*Label 2558*/ GIMT_Encode4(127894), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127862 */ /*GILLT_v4s32*//*Label 2559*/ GIMT_Encode4(127972), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127878 */ /*GILLT_v8s16*//*Label 2560*/ GIMT_Encode4(128066), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127890 */ /*GILLT_v16s8*//*Label 2561*/ GIMT_Encode4(128160),
     /* 127894 */ // Label 2558: @127894
     /* 127894 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(127971),
     /* 127899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127902 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(127936), // Rule ID 198 //
     /* 127907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127918 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127934 */     GIR_RootConstrainSelectedInstOperands,
     /* 127935 */     // GIR_Coverage, 198,
     /* 127935 */     GIR_EraseRootFromParent_Done,
     /* 127936 */   // Label 2564: @127936
     /* 127936 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(127970), // Rule ID 535 //
     /* 127941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127952 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127968 */     GIR_RootConstrainSelectedInstOperands,
     /* 127969 */     // GIR_Coverage, 535,
     /* 127969 */     GIR_EraseRootFromParent_Done,
     /* 127970 */   // Label 2565: @127970
     /* 127970 */   GIM_Reject,
     /* 127971 */ // Label 2563: @127971
     /* 127971 */ GIM_Reject,
     /* 127972 */ // Label 2559: @127972
     /* 127972 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(128065), // Rule ID 4758 //
     /* 127977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127991 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127991 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127994 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127998 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 128010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128015 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 128018 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 128021 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128027 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 128038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128040 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128048 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128054 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128063 */   GIR_RootConstrainSelectedInstOperands,
     /* 128064 */   // GIR_Coverage, 4758,
     /* 128064 */   GIR_EraseRootFromParent_Done,
     /* 128065 */ // Label 2566: @128065
     /* 128065 */ GIM_Reject,
     /* 128066 */ // Label 2560: @128066
     /* 128066 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(128159), // Rule ID 4759 //
     /* 128071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 128074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128085 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 128085 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 128088 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128092 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 128104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128109 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 128112 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 128115 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128121 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 128132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128134 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128148 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128157 */   GIR_RootConstrainSelectedInstOperands,
     /* 128158 */   // GIR_Coverage, 4759,
     /* 128158 */   GIR_EraseRootFromParent_Done,
     /* 128159 */ // Label 2567: @128159
     /* 128159 */ GIM_Reject,
     /* 128160 */ // Label 2561: @128160
     /* 128160 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(128253), // Rule ID 4757 //
     /* 128165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 128168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 128171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128179 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 128179 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 128182 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128186 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 128198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128203 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 128206 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 128209 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128215 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 128226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128228 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128236 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128242 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128251 */   GIR_RootConstrainSelectedInstOperands,
     /* 128252 */   // GIR_Coverage, 4757,
     /* 128252 */   GIR_EraseRootFromParent_Done,
     /* 128253 */ // Label 2568: @128253
     /* 128253 */ GIM_Reject,
     /* 128254 */ // Label 2562: @128254
     /* 128254 */ GIM_Reject,
     /* 128255 */ // Label 67: @128255
     /* 128255 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2574*/ GIMT_Encode4(128517),
     /* 128266 */ /*GILLT_s16*//*Label 2569*/ GIMT_Encode4(128318),
     /* 128270 */ /*GILLT_s32*//*Label 2570*/ GIMT_Encode4(128345),
     /* 128274 */ /*GILLT_s64*//*Label 2571*/ GIMT_Encode4(128372), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128298 */ /*GILLT_v4s32*//*Label 2572*/ GIMT_Encode4(128399), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128314 */ /*GILLT_v8s16*//*Label 2573*/ GIMT_Encode4(128458),
     /* 128318 */ // Label 2569: @128318
     /* 128318 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(128344), // Rule ID 683 //
     /* 128323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128337 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 128342 */   GIR_RootConstrainSelectedInstOperands,
     /* 128343 */   // GIR_Coverage, 683,
     /* 128343 */   GIR_Done,
     /* 128344 */ // Label 2575: @128344
     /* 128344 */ GIM_Reject,
     /* 128345 */ // Label 2570: @128345
     /* 128345 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(128371), // Rule ID 684 //
     /* 128350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128364 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 128369 */   GIR_RootConstrainSelectedInstOperands,
     /* 128370 */   // GIR_Coverage, 684,
     /* 128370 */   GIR_Done,
     /* 128371 */ // Label 2576: @128371
     /* 128371 */ GIM_Reject,
     /* 128372 */ // Label 2571: @128372
     /* 128372 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(128398), // Rule ID 685 //
     /* 128377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128391 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 128396 */   GIR_RootConstrainSelectedInstOperands,
     /* 128397 */   // GIR_Coverage, 685,
     /* 128397 */   GIR_Done,
     /* 128398 */ // Label 2577: @128398
     /* 128398 */ GIM_Reject,
     /* 128399 */ // Label 2572: @128399
     /* 128399 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(128457), // Rule ID 3986 //
     /* 128404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128418 */   // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 128433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128435 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128440 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128446 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128455 */   GIR_RootConstrainSelectedInstOperands,
     /* 128456 */   // GIR_Coverage, 3986,
     /* 128456 */   GIR_EraseRootFromParent_Done,
     /* 128457 */ // Label 2578: @128457
     /* 128457 */ GIM_Reject,
     /* 128458 */ // Label 2573: @128458
     /* 128458 */ GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(128516), // Rule ID 3974 //
     /* 128463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128477 */   // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 128492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128494 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128499 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128505 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128514 */   GIR_RootConstrainSelectedInstOperands,
     /* 128515 */   // GIR_Coverage, 3974,
     /* 128515 */   GIR_EraseRootFromParent_Done,
     /* 128516 */ // Label 2579: @128516
     /* 128516 */ GIM_Reject,
     /* 128517 */ // Label 2574: @128517
     /* 128517 */ GIM_Reject,
     /* 128518 */ // Label 68: @128518
     /* 128518 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2583*/ GIMT_Encode4(128655),
     /* 128529 */ /*GILLT_s16*//*Label 2580*/ GIMT_Encode4(128541),
     /* 128533 */ /*GILLT_s32*//*Label 2581*/ GIMT_Encode4(128579),
     /* 128537 */ /*GILLT_s64*//*Label 2582*/ GIMT_Encode4(128617),
     /* 128541 */ // Label 2580: @128541
     /* 128541 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(128578), // Rule ID 691 //
     /* 128546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128560 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128565 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128570 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128576 */   GIR_RootConstrainSelectedInstOperands,
     /* 128577 */   // GIR_Coverage, 691,
     /* 128577 */   GIR_EraseRootFromParent_Done,
     /* 128578 */ // Label 2584: @128578
     /* 128578 */ GIM_Reject,
     /* 128579 */ // Label 2581: @128579
     /* 128579 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(128616), // Rule ID 690 //
     /* 128584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128598 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128603 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128608 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128614 */   GIR_RootConstrainSelectedInstOperands,
     /* 128615 */   // GIR_Coverage, 690,
     /* 128615 */   GIR_EraseRootFromParent_Done,
     /* 128616 */ // Label 2585: @128616
     /* 128616 */ GIM_Reject,
     /* 128617 */ // Label 2582: @128617
     /* 128617 */ GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(128654), // Rule ID 689 //
     /* 128622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128636 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128641 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128646 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128652 */   GIR_RootConstrainSelectedInstOperands,
     /* 128653 */   // GIR_Coverage, 689,
     /* 128653 */   GIR_EraseRootFromParent_Done,
     /* 128654 */ // Label 2586: @128654
     /* 128654 */ GIM_Reject,
     /* 128655 */ // Label 2583: @128655
     /* 128655 */ GIM_Reject,
     /* 128656 */ // Label 69: @128656
     /* 128656 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2592*/ GIMT_Encode4(128918),
     /* 128667 */ /*GILLT_s16*//*Label 2587*/ GIMT_Encode4(128719),
     /* 128671 */ /*GILLT_s32*//*Label 2588*/ GIMT_Encode4(128746),
     /* 128675 */ /*GILLT_s64*//*Label 2589*/ GIMT_Encode4(128773), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128699 */ /*GILLT_v4s32*//*Label 2590*/ GIMT_Encode4(128800), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128715 */ /*GILLT_v8s16*//*Label 2591*/ GIMT_Encode4(128859),
     /* 128719 */ // Label 2587: @128719
     /* 128719 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(128745), // Rule ID 686 //
     /* 128724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128738 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128743 */   GIR_RootConstrainSelectedInstOperands,
     /* 128744 */   // GIR_Coverage, 686,
     /* 128744 */   GIR_Done,
     /* 128745 */ // Label 2593: @128745
     /* 128745 */ GIM_Reject,
     /* 128746 */ // Label 2588: @128746
     /* 128746 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(128772), // Rule ID 687 //
     /* 128751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128765 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128770 */   GIR_RootConstrainSelectedInstOperands,
     /* 128771 */   // GIR_Coverage, 687,
     /* 128771 */   GIR_Done,
     /* 128772 */ // Label 2594: @128772
     /* 128772 */ GIM_Reject,
     /* 128773 */ // Label 2589: @128773
     /* 128773 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(128799), // Rule ID 688 //
     /* 128778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128792 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128797 */   GIR_RootConstrainSelectedInstOperands,
     /* 128798 */   // GIR_Coverage, 688,
     /* 128798 */   GIR_Done,
     /* 128799 */ // Label 2595: @128799
     /* 128799 */ GIM_Reject,
     /* 128800 */ // Label 2590: @128800
     /* 128800 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(128858), // Rule ID 3984 //
     /* 128805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128819 */   // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128836 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128841 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128847 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128856 */   GIR_RootConstrainSelectedInstOperands,
     /* 128857 */   // GIR_Coverage, 3984,
     /* 128857 */   GIR_EraseRootFromParent_Done,
     /* 128858 */ // Label 2596: @128858
     /* 128858 */ GIM_Reject,
     /* 128859 */ // Label 2591: @128859
     /* 128859 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(128917), // Rule ID 3972 //
     /* 128864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128878 */   // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128895 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128900 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128906 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128912 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128915 */   GIR_RootConstrainSelectedInstOperands,
     /* 128916 */   // GIR_Coverage, 3972,
     /* 128916 */   GIR_EraseRootFromParent_Done,
     /* 128917 */ // Label 2597: @128917
     /* 128917 */ GIM_Reject,
     /* 128918 */ // Label 2592: @128918
     /* 128918 */ GIM_Reject,
     /* 128919 */ // Label 70: @128919
     /* 128919 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2603*/ GIMT_Encode4(129214),
     /* 128930 */ /*GILLT_s16*//*Label 2598*/ GIMT_Encode4(128982),
     /* 128934 */ /*GILLT_s32*//*Label 2599*/ GIMT_Encode4(129020),
     /* 128938 */ /*GILLT_s64*//*Label 2600*/ GIMT_Encode4(129058), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128962 */ /*GILLT_v4s32*//*Label 2601*/ GIMT_Encode4(129096), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128978 */ /*GILLT_v8s16*//*Label 2602*/ GIMT_Encode4(129155),
     /* 128982 */ // Label 2598: @128982
     /* 128982 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(129019), // Rule ID 671 //
     /* 128987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129001 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 129001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 129004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129006 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129011 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129017 */   GIR_RootConstrainSelectedInstOperands,
     /* 129018 */   // GIR_Coverage, 671,
     /* 129018 */   GIR_EraseRootFromParent_Done,
     /* 129019 */ // Label 2604: @129019
     /* 129019 */ GIM_Reject,
     /* 129020 */ // Label 2599: @129020
     /* 129020 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(129057), // Rule ID 672 //
     /* 129025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129039 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 129042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129044 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129049 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129055 */   GIR_RootConstrainSelectedInstOperands,
     /* 129056 */   // GIR_Coverage, 672,
     /* 129056 */   GIR_EraseRootFromParent_Done,
     /* 129057 */ // Label 2605: @129057
     /* 129057 */ GIM_Reject,
     /* 129058 */ // Label 2600: @129058
     /* 129058 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(129095), // Rule ID 673 //
     /* 129063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129077 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 129080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129082 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129087 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129093 */   GIR_RootConstrainSelectedInstOperands,
     /* 129094 */   // GIR_Coverage, 673,
     /* 129094 */   GIR_EraseRootFromParent_Done,
     /* 129095 */ // Label 2606: @129095
     /* 129095 */ GIM_Reject,
     /* 129096 */ // Label 2601: @129096
     /* 129096 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(129154), // Rule ID 3978 //
     /* 129101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129115 */   // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 129115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 129130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129132 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129137 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129143 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129152 */   GIR_RootConstrainSelectedInstOperands,
     /* 129153 */   // GIR_Coverage, 3978,
     /* 129153 */   GIR_EraseRootFromParent_Done,
     /* 129154 */ // Label 2607: @129154
     /* 129154 */ GIM_Reject,
     /* 129155 */ // Label 2602: @129155
     /* 129155 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(129213), // Rule ID 3966 //
     /* 129160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129174 */   // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 129174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 129189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129191 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129196 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129202 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129211 */   GIR_RootConstrainSelectedInstOperands,
     /* 129212 */   // GIR_Coverage, 3966,
     /* 129212 */   GIR_EraseRootFromParent_Done,
     /* 129213 */ // Label 2608: @129213
     /* 129213 */ GIM_Reject,
     /* 129214 */ // Label 2603: @129214
     /* 129214 */ GIM_Reject,
     /* 129215 */ // Label 71: @129215
     /* 129215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2612*/ GIMT_Encode4(129352),
     /* 129226 */ /*GILLT_s16*//*Label 2609*/ GIMT_Encode4(129238),
     /* 129230 */ /*GILLT_s32*//*Label 2610*/ GIMT_Encode4(129276),
     /* 129234 */ /*GILLT_s64*//*Label 2611*/ GIMT_Encode4(129314),
     /* 129238 */ // Label 2609: @129238
     /* 129238 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(129275), // Rule ID 668 //
     /* 129243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 129246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 129249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129257 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 129257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 129260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129262 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129267 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129273 */   GIR_RootConstrainSelectedInstOperands,
     /* 129274 */   // GIR_Coverage, 668,
     /* 129274 */   GIR_EraseRootFromParent_Done,
     /* 129275 */ // Label 2613: @129275
     /* 129275 */ GIM_Reject,
     /* 129276 */ // Label 2610: @129276
     /* 129276 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(129313), // Rule ID 669 //
     /* 129281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129295 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 129298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129300 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129305 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129311 */   GIR_RootConstrainSelectedInstOperands,
     /* 129312 */   // GIR_Coverage, 669,
     /* 129312 */   GIR_EraseRootFromParent_Done,
     /* 129313 */ // Label 2614: @129313
     /* 129313 */ GIM_Reject,
     /* 129314 */ // Label 2611: @129314
     /* 129314 */ GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(129351), // Rule ID 670 //
     /* 129319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129333 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129338 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129343 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129349 */   GIR_RootConstrainSelectedInstOperands,
     /* 129350 */   // GIR_Coverage, 670,
     /* 129350 */   GIR_EraseRootFromParent_Done,
     /* 129351 */ // Label 2615: @129351
     /* 129351 */ GIM_Reject,
     /* 129352 */ // Label 2612: @129352
     /* 129352 */ GIM_Reject,
     /* 129353 */ // Label 72: @129353
     /* 129353 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(129368), // Rule ID 12 //
     /* 129358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129361 */   // (trap)  =>  (TRAPNaCl)
     /* 129361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129366 */   GIR_RootConstrainSelectedInstOperands,
     /* 129367 */   // GIR_Coverage, 12,
     /* 129367 */   GIR_Done,
     /* 129368 */ // Label 2616: @129368
     /* 129368 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(129383), // Rule ID 13 //
     /* 129373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129376 */   // (trap)  =>  (TRAP)
     /* 129376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129381 */   GIR_RootConstrainSelectedInstOperands,
     /* 129382 */   // GIR_Coverage, 13,
     /* 129382 */   GIR_Done,
     /* 129383 */ // Label 2617: @129383
     /* 129383 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(129398), // Rule ID 285 //
     /* 129388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129391 */   // (trap)  =>  (tTRAP)
     /* 129391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129396 */   GIR_RootConstrainSelectedInstOperands,
     /* 129397 */   // GIR_Coverage, 285,
     /* 129397 */   GIR_Done,
     /* 129398 */ // Label 2618: @129398
     /* 129398 */ GIM_Reject,
     /* 129399 */ // Label 73: @129399
     /* 129399 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(129415), // Rule ID 1838 //
     /* 129404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129407 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129413 */   GIR_RootConstrainSelectedInstOperands,
     /* 129414 */   // GIR_Coverage, 1838,
     /* 129414 */   GIR_EraseRootFromParent_Done,
     /* 129415 */ // Label 2619: @129415
     /* 129415 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(129442), // Rule ID 1839 //
     /* 129420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129423 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129426 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129440 */   GIR_RootConstrainSelectedInstOperands,
     /* 129441 */   // GIR_Coverage, 1839,
     /* 129441 */   GIR_EraseRootFromParent_Done,
     /* 129442 */ // Label 2620: @129442
     /* 129442 */ GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(129458), // Rule ID 2024 //
     /* 129447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129450 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129456 */   GIR_RootConstrainSelectedInstOperands,
     /* 129457 */   // GIR_Coverage, 2024,
     /* 129457 */   GIR_EraseRootFromParent_Done,
     /* 129458 */ // Label 2621: @129458
     /* 129458 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(129485), // Rule ID 2025 //
     /* 129463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129466 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129469 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129479 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129483 */   GIR_RootConstrainSelectedInstOperands,
     /* 129484 */   // GIR_Coverage, 2025,
     /* 129484 */   GIR_EraseRootFromParent_Done,
     /* 129485 */ // Label 2622: @129485
     /* 129485 */ GIM_Reject,
     /* 129486 */ // Label 74: @129486
     /* 129486 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(129906),
     /* 129491 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129494 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2627*/ GIMT_Encode4(129792),
     /* 129505 */   /*GILLT_v4s32*//*Label 2624*/ GIMT_Encode4(129537), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129521 */   /*GILLT_v8s16*//*Label 2625*/ GIMT_Encode4(129608), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129533 */   /*GILLT_v16s8*//*Label 2626*/ GIMT_Encode4(129679),
     /* 129537 */   // Label 2624: @129537
     /* 129537 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(129607), // Rule ID 3241 //
     /* 129542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129577 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129605 */     GIR_RootConstrainSelectedInstOperands,
     /* 129606 */     // GIR_Coverage, 3241,
     /* 129606 */     GIR_EraseRootFromParent_Done,
     /* 129607 */   // Label 2628: @129607
     /* 129607 */   GIM_Reject,
     /* 129608 */   // Label 2625: @129608
     /* 129608 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(129678), // Rule ID 3242 //
     /* 129613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129648 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129676 */     GIR_RootConstrainSelectedInstOperands,
     /* 129677 */     // GIR_Coverage, 3242,
     /* 129677 */     GIR_EraseRootFromParent_Done,
     /* 129678 */   // Label 2629: @129678
     /* 129678 */   GIM_Reject,
     /* 129679 */   // Label 2626: @129679
     /* 129679 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(129791),
     /* 129684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129688 */     GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(129754), // Rule ID 3245 //
     /* 129693 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129696 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129700 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129704 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129708 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129712 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129717 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129722 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129724 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129724 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129727 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129729 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129733 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129737 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129740 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129746 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129752 */       GIR_RootConstrainSelectedInstOperands,
     /* 129753 */       // GIR_Coverage, 3245,
     /* 129753 */       GIR_EraseRootFromParent_Done,
     /* 129754 */     // Label 2631: @129754
     /* 129754 */     GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(129790), // Rule ID 3049 //
     /* 129759 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129762 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129766 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129766 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129769 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129771 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129773 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129776 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129782 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129788 */       GIR_RootConstrainSelectedInstOperands,
     /* 129789 */       // GIR_Coverage, 3049,
     /* 129789 */       GIR_EraseRootFromParent_Done,
     /* 129790 */     // Label 2632: @129790
     /* 129790 */     GIM_Reject,
     /* 129791 */   // Label 2630: @129791
     /* 129791 */   GIM_Reject,
     /* 129792 */   // Label 2627: @129792
     /* 129792 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2635*/ GIMT_Encode4(129905),
     /* 129803 */   /*GILLT_v4s32*//*Label 2633*/ GIMT_Encode4(129823), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129819 */   /*GILLT_v8s16*//*Label 2634*/ GIMT_Encode4(129864),
     /* 129823 */   // Label 2633: @129823
     /* 129823 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(129863), // Rule ID 3087 //
     /* 129828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129839 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129844 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129861 */     GIR_RootConstrainSelectedInstOperands,
     /* 129862 */     // GIR_Coverage, 3087,
     /* 129862 */     GIR_EraseRootFromParent_Done,
     /* 129863 */   // Label 2636: @129863
     /* 129863 */   GIM_Reject,
     /* 129864 */   // Label 2634: @129864
     /* 129864 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(129904), // Rule ID 3077 //
     /* 129869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129880 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129885 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129902 */     GIR_RootConstrainSelectedInstOperands,
     /* 129903 */     // GIR_Coverage, 3077,
     /* 129903 */     GIR_EraseRootFromParent_Done,
     /* 129904 */   // Label 2637: @129904
     /* 129904 */   GIM_Reject,
     /* 129905 */   // Label 2635: @129905
     /* 129905 */   GIM_Reject,
     /* 129906 */ // Label 2623: @129906
     /* 129906 */ GIM_Reject,
     /* 129907 */ // Label 75: @129907
     /* 129907 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(130186),
     /* 129912 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129915 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2642*/ GIMT_Encode4(130185),
     /* 129926 */   /*GILLT_v4s32*//*Label 2639*/ GIMT_Encode4(129958), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129942 */   /*GILLT_v8s16*//*Label 2640*/ GIMT_Encode4(130041), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129954 */   /*GILLT_v16s8*//*Label 2641*/ GIMT_Encode4(130109),
     /* 129958 */   // Label 2639: @129958
     /* 129958 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(130040), // Rule ID 3147 //
     /* 129963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129974 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129986 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129996 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129999 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130005 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 130016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130038 */     GIR_RootConstrainSelectedInstOperands,
     /* 130039 */     // GIR_Coverage, 3147,
     /* 130039 */     GIR_EraseRootFromParent_Done,
     /* 130040 */   // Label 2643: @130040
     /* 130040 */   GIM_Reject,
     /* 130041 */   // Label 2640: @130041
     /* 130041 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(130108), // Rule ID 3146 //
     /* 130046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130057 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 130064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130069 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 130079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 130084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130106 */     GIR_RootConstrainSelectedInstOperands,
     /* 130107 */     // GIR_Coverage, 3146,
     /* 130107 */     GIR_EraseRootFromParent_Done,
     /* 130108 */   // Label 2644: @130108
     /* 130108 */   GIM_Reject,
     /* 130109 */   // Label 2641: @130109
     /* 130109 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(130184), // Rule ID 3145 //
     /* 130114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130125 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130137 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130143 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130149 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 130160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130182 */     GIR_RootConstrainSelectedInstOperands,
     /* 130183 */     // GIR_Coverage, 3145,
     /* 130183 */     GIR_EraseRootFromParent_Done,
     /* 130184 */   // Label 2645: @130184
     /* 130184 */   GIM_Reject,
     /* 130185 */   // Label 2642: @130185
     /* 130185 */   GIM_Reject,
     /* 130186 */ // Label 2638: @130186
     /* 130186 */ GIM_Reject,
     /* 130187 */ // Label 76: @130187
     /* 130187 */ GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(130475),
     /* 130192 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130195 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2650*/ GIMT_Encode4(130474),
     /* 130206 */   /*GILLT_v4s32*//*Label 2647*/ GIMT_Encode4(130238), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130222 */   /*GILLT_v8s16*//*Label 2648*/ GIMT_Encode4(130321), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130234 */   /*GILLT_v16s8*//*Label 2649*/ GIMT_Encode4(130398),
     /* 130238 */   // Label 2647: @130238
     /* 130238 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(130320), // Rule ID 3153 //
     /* 130243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130254 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130266 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 130276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130279 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130285 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 130296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130301 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130318 */     GIR_RootConstrainSelectedInstOperands,
     /* 130319 */     // GIR_Coverage, 3153,
     /* 130319 */     GIR_EraseRootFromParent_Done,
     /* 130320 */   // Label 2651: @130320
     /* 130320 */   GIM_Reject,
     /* 130321 */   // Label 2648: @130321
     /* 130321 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(130397), // Rule ID 3152 //
     /* 130326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130337 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130349 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130359 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130362 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130395 */     GIR_RootConstrainSelectedInstOperands,
     /* 130396 */     // GIR_Coverage, 3152,
     /* 130396 */     GIR_EraseRootFromParent_Done,
     /* 130397 */   // Label 2652: @130397
     /* 130397 */   GIM_Reject,
     /* 130398 */   // Label 2649: @130398
     /* 130398 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(130473), // Rule ID 3151 //
     /* 130403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130414 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130426 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130429 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130432 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130438 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130471 */     GIR_RootConstrainSelectedInstOperands,
     /* 130472 */     // GIR_Coverage, 3151,
     /* 130472 */     GIR_EraseRootFromParent_Done,
     /* 130473 */   // Label 2653: @130473
     /* 130473 */   GIM_Reject,
     /* 130474 */   // Label 2650: @130474
     /* 130474 */   GIM_Reject,
     /* 130475 */ // Label 2646: @130475
     /* 130475 */ GIM_Reject,
     /* 130476 */ // Label 77: @130476
     /* 130476 */ GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(130756),
     /* 130481 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130484 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2658*/ GIMT_Encode4(130755),
     /* 130495 */   /*GILLT_v4s32*//*Label 2655*/ GIMT_Encode4(130527), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130511 */   /*GILLT_v8s16*//*Label 2656*/ GIMT_Encode4(130603), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130523 */   /*GILLT_v16s8*//*Label 2657*/ GIMT_Encode4(130679),
     /* 130527 */   // Label 2655: @130527
     /* 130527 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(130602), // Rule ID 3150 //
     /* 130532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130543 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130558 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130561 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130567 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130600 */     GIR_RootConstrainSelectedInstOperands,
     /* 130601 */     // GIR_Coverage, 3150,
     /* 130601 */     GIR_EraseRootFromParent_Done,
     /* 130602 */   // Label 2659: @130602
     /* 130602 */   GIM_Reject,
     /* 130603 */   // Label 2656: @130603
     /* 130603 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(130678), // Rule ID 3149 //
     /* 130608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130619 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130631 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130634 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130637 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130643 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130676 */     GIR_RootConstrainSelectedInstOperands,
     /* 130677 */     // GIR_Coverage, 3149,
     /* 130677 */     GIR_EraseRootFromParent_Done,
     /* 130678 */   // Label 2660: @130678
     /* 130678 */   GIM_Reject,
     /* 130679 */   // Label 2657: @130679
     /* 130679 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(130754), // Rule ID 3148 //
     /* 130684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130695 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130707 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130710 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130713 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130719 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130752 */     GIR_RootConstrainSelectedInstOperands,
     /* 130753 */     // GIR_Coverage, 3148,
     /* 130753 */     GIR_EraseRootFromParent_Done,
     /* 130754 */   // Label 2661: @130754
     /* 130754 */   GIM_Reject,
     /* 130755 */   // Label 2658: @130755
     /* 130755 */   GIM_Reject,
     /* 130756 */ // Label 2654: @130756
     /* 130756 */ GIM_Reject,
     /* 130757 */ // Label 78: @130757
     /* 130757 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(131052),
     /* 130762 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130765 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2666*/ GIMT_Encode4(131051),
     /* 130776 */   /*GILLT_v4s32*//*Label 2663*/ GIMT_Encode4(130808), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130792 */   /*GILLT_v8s16*//*Label 2664*/ GIMT_Encode4(130891), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130804 */   /*GILLT_v16s8*//*Label 2665*/ GIMT_Encode4(130968),
     /* 130808 */   // Label 2663: @130808
     /* 130808 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(130890), // Rule ID 3156 //
     /* 130813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130824 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130836 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130846 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130849 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130855 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130871 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130888 */     GIR_RootConstrainSelectedInstOperands,
     /* 130889 */     // GIR_Coverage, 3156,
     /* 130889 */     GIR_EraseRootFromParent_Done,
     /* 130890 */   // Label 2667: @130890
     /* 130890 */   GIM_Reject,
     /* 130891 */   // Label 2664: @130891
     /* 130891 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(130967), // Rule ID 3155 //
     /* 130896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130907 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130919 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130929 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130932 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130948 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130965 */     GIR_RootConstrainSelectedInstOperands,
     /* 130966 */     // GIR_Coverage, 3155,
     /* 130966 */     GIR_EraseRootFromParent_Done,
     /* 130967 */   // Label 2668: @130967
     /* 130967 */   GIM_Reject,
     /* 130968 */   // Label 2665: @130968
     /* 130968 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(131050), // Rule ID 3154 //
     /* 130973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130984 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130996 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 131006 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 131009 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131015 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 131026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 131028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 131033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131048 */     GIR_RootConstrainSelectedInstOperands,
     /* 131049 */     // GIR_Coverage, 3154,
     /* 131049 */     GIR_EraseRootFromParent_Done,
     /* 131050 */   // Label 2669: @131050
     /* 131050 */   GIM_Reject,
     /* 131051 */   // Label 2666: @131051
     /* 131051 */   GIM_Reject,
     /* 131052 */ // Label 2662: @131052
     /* 131052 */ GIM_Reject,
     /* 131053 */ // Label 79: @131053
     /* 131053 */ GIM_Reject,
     /* 131054 */ }; // Size: 131054 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
