/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the Mips target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 44;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(MipsInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(MipsInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static MipsInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static MipsInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s16,
  GILLT_v2s64,
  GILLT_v4s8,
  GILLT_v4s32,
  GILLT_v8s16,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 9;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 16),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 8),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasMips2Bit = 7,
  Feature_HasMips3Bit = 17,
  Feature_HasMips4_32Bit = 27,
  Feature_NotMips4_32Bit = 28,
  Feature_HasMips4_32r2Bit = 18,
  Feature_HasMips32Bit = 3,
  Feature_HasMips32r2Bit = 6,
  Feature_HasMips32r6Bit = 29,
  Feature_NotMips32r6Bit = 4,
  Feature_IsGP64bitBit = 22,
  Feature_IsPTR64bitBit = 24,
  Feature_HasMips64Bit = 25,
  Feature_HasMips64r2Bit = 23,
  Feature_HasMips64r6Bit = 30,
  Feature_NotMips64r6Bit = 5,
  Feature_InMips16ModeBit = 31,
  Feature_NotInMips16ModeBit = 0,
  Feature_HasCnMipsBit = 26,
  Feature_NotCnMipsBit = 8,
  Feature_IsSym32Bit = 38,
  Feature_IsSym64Bit = 39,
  Feature_IsN64Bit = 40,
  Feature_RelocNotPICBit = 9,
  Feature_RelocPICBit = 37,
  Feature_NoNaNsFPMathBit = 21,
  Feature_UseAbsBit = 14,
  Feature_HasStdEncBit = 1,
  Feature_NotDSPBit = 11,
  Feature_InMicroMipsBit = 35,
  Feature_NotInMicroMipsBit = 2,
  Feature_IsLEBit = 42,
  Feature_IsBEBit = 43,
  Feature_IsNotNaClBit = 19,
  Feature_HasEVABit = 36,
  Feature_HasMSABit = 34,
  Feature_HasMadd4Bit = 20,
  Feature_UseIndirectJumpsHazardBit = 12,
  Feature_NoIndirectJumpGuardsBit = 10,
  Feature_AllowFPOpFusionBit = 41,
  Feature_IsFP64bitBit = 16,
  Feature_NotFP64bitBit = 15,
  Feature_IsNotSoftFloatBit = 13,
  Feature_HasDSPBit = 32,
  Feature_HasDSPR2Bit = 33,
};

PredicateBitset MipsInstructionSelector::
computeAvailableModuleFeatures(const MipsSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasMips2())
    Features.set(Feature_HasMips2Bit);
  if (Subtarget->hasMips3())
    Features.set(Feature_HasMips3Bit);
  if (Subtarget->hasMips4_32())
    Features.set(Feature_HasMips4_32Bit);
  if (!Subtarget->hasMips4_32())
    Features.set(Feature_NotMips4_32Bit);
  if (Subtarget->hasMips4_32r2())
    Features.set(Feature_HasMips4_32r2Bit);
  if (Subtarget->hasMips32())
    Features.set(Feature_HasMips32Bit);
  if (Subtarget->hasMips32r2())
    Features.set(Feature_HasMips32r2Bit);
  if (Subtarget->hasMips32r6())
    Features.set(Feature_HasMips32r6Bit);
  if (!Subtarget->hasMips32r6())
    Features.set(Feature_NotMips32r6Bit);
  if (Subtarget->isGP64bit())
    Features.set(Feature_IsGP64bitBit);
  if (Subtarget->isABI_N64())
    Features.set(Feature_IsPTR64bitBit);
  if (Subtarget->hasMips64())
    Features.set(Feature_HasMips64Bit);
  if (Subtarget->hasMips64r2())
    Features.set(Feature_HasMips64r2Bit);
  if (Subtarget->hasMips64r6())
    Features.set(Feature_HasMips64r6Bit);
  if (!Subtarget->hasMips64r6())
    Features.set(Feature_NotMips64r6Bit);
  if (Subtarget->inMips16Mode())
    Features.set(Feature_InMips16ModeBit);
  if (!Subtarget->inMips16Mode())
    Features.set(Feature_NotInMips16ModeBit);
  if (Subtarget->hasCnMips())
    Features.set(Feature_HasCnMipsBit);
  if (!Subtarget->hasCnMips())
    Features.set(Feature_NotCnMipsBit);
  if (Subtarget->hasSym32())
    Features.set(Feature_IsSym32Bit);
  if (!Subtarget->hasSym32())
    Features.set(Feature_IsSym64Bit);
  if (Subtarget->isABI_N64())
    Features.set(Feature_IsN64Bit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_RelocNotPICBit);
  if (TM.isPositionIndependent())
    Features.set(Feature_RelocPICBit);
  if (TM.Options.NoNaNsFPMath)
    Features.set(Feature_NoNaNsFPMathBit);
  if (Subtarget->inAbs2008Mode() ||TM.Options.NoNaNsFPMath)
    Features.set(Feature_UseAbsBit);
  if (Subtarget->hasStandardEncoding())
    Features.set(Feature_HasStdEncBit);
  if (!Subtarget->hasDSP())
    Features.set(Feature_NotDSPBit);
  if (Subtarget->inMicroMipsMode())
    Features.set(Feature_InMicroMipsBit);
  if (!Subtarget->inMicroMipsMode())
    Features.set(Feature_NotInMicroMipsBit);
  if (Subtarget->isLittle())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittle())
    Features.set(Feature_IsBEBit);
  if (!Subtarget->isTargetNaCl())
    Features.set(Feature_IsNotNaClBit);
  if (Subtarget->hasEVA())
    Features.set(Feature_HasEVABit);
  if (Subtarget->hasMSA())
    Features.set(Feature_HasMSABit);
  if (!Subtarget->disableMadd4())
    Features.set(Feature_HasMadd4Bit);
  if (Subtarget->useIndirectJumpsHazard())
    Features.set(Feature_UseIndirectJumpsHazardBit);
  if (!Subtarget->useIndirectJumpsHazard())
    Features.set(Feature_NoIndirectJumpGuardsBit);
  if (TM.Options.AllowFPOpFusion == FPOpFusion::Fast)
    Features.set(Feature_AllowFPOpFusionBit);
  if (Subtarget->isFP64bit())
    Features.set(Feature_IsFP64bitBit);
  if (!Subtarget->isFP64bit())
    Features.set(Feature_NotFP64bitBit);
  if (!Subtarget->useSoftFloat())
    Features.set(Feature_IsNotSoftFloatBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDSPR2())
    Features.set(Feature_HasDSPR2Bit);
  return Features;
}

void MipsInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const MipsSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset MipsInstructionSelector::
computeAvailableFunctionFeatures(const MipsSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasCnMips,
  GIFBS_HasDSP,
  GIFBS_HasDSPR2,
  GIFBS_HasMSA,
  GIFBS_InMicroMips,
  GIFBS_InMips16Mode,
  GIFBS_IsFP64bit,
  GIFBS_NotFP64bit,
  GIFBS_NotInMips16Mode,
  GIFBS_HasDSP_InMicroMips,
  GIFBS_HasDSP_NotInMicroMips,
  GIFBS_HasDSPR2_InMicroMips,
  GIFBS_HasMSA_HasStdEnc,
  GIFBS_HasMSA_IsBE,
  GIFBS_HasMSA_IsLE,
  GIFBS_HasMips32r6_HasStdEnc,
  GIFBS_HasMips32r6_InMicroMips,
  GIFBS_HasMips64r2_HasStdEnc,
  GIFBS_HasMips64r6_HasStdEnc,
  GIFBS_HasStdEnc_IsNotSoftFloat,
  GIFBS_HasStdEnc_NotInMicroMips,
  GIFBS_HasStdEnc_NotMips4_32,
  GIFBS_InMicroMips_IsFP64bit,
  GIFBS_InMicroMips_IsNotSoftFloat,
  GIFBS_InMicroMips_NotFP64bit,
  GIFBS_InMicroMips_NotMips32r6,
  GIFBS_IsGP64bit_NotInMips16Mode,
  GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc,
  GIFBS_HasMSA_HasMips64_HasStdEnc,
  GIFBS_HasMips3_HasStdEnc_IsGP64bit,
  GIFBS_HasMips3_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r2_HasStdEnc_IsGP64bit,
  GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat,
  GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_NotMips4_32,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_NotFP64bit_NotMips4_32,
  GIFBS_HasStdEnc_NotInMicroMips_RelocNotPIC,
  GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat,
  GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit,
  GIFBS_InMicroMips_IsNotSoftFloat_UseAbs,
  GIFBS_InMicroMips_NotFP64bit_NotMips32r6,
  GIFBS_InMicroMips_NotMips32r6_RelocNotPIC,
  GIFBS_InMicroMips_NotMips32r6_RelocPIC,
  GIFBS_IsFP64bit_IsNotSoftFloat_NotInMips16Mode,
  GIFBS_IsNotSoftFloat_NotFP64bit_NotInMips16Mode,
  GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6,
  GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips,
  GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips32_HasStdEnc_NotMips32r6_NotMips64r6,
  GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6,
  GIFBS_HasMips64r2_HasStdEnc_IsGP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips_UseAbs,
  GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6,
  GIFBS_HasMips2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips,
  GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6,
  GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_UseAbs,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_UseAbs,
  GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasCnMipsBit, },
  {Feature_HasDSPBit, },
  {Feature_HasDSPR2Bit, },
  {Feature_HasMSABit, },
  {Feature_InMicroMipsBit, },
  {Feature_InMips16ModeBit, },
  {Feature_IsFP64bitBit, },
  {Feature_NotFP64bitBit, },
  {Feature_NotInMips16ModeBit, },
  {Feature_HasDSPBit, Feature_InMicroMipsBit, },
  {Feature_HasDSPBit, Feature_NotInMicroMipsBit, },
  {Feature_HasDSPR2Bit, Feature_InMicroMipsBit, },
  {Feature_HasMSABit, Feature_HasStdEncBit, },
  {Feature_HasMSABit, Feature_IsBEBit, },
  {Feature_HasMSABit, Feature_IsLEBit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, },
  {Feature_HasMips32r6Bit, Feature_InMicroMipsBit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, },
  {Feature_HasMips64r6Bit, Feature_HasStdEncBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, },
  {Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotMips4_32Bit, },
  {Feature_InMicroMipsBit, Feature_IsFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, },
  {Feature_InMicroMipsBit, Feature_NotFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, },
  {Feature_IsGP64bitBit, Feature_NotInMips16ModeBit, },
  {Feature_AllowFPOpFusionBit, Feature_HasMSABit, Feature_HasStdEncBit, },
  {Feature_HasMSABit, Feature_HasMips64Bit, Feature_HasStdEncBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r2Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, },
  {Feature_HasMips32r2Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r6Bit, Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips64r6Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotMips4_32Bit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotMips4_32Bit, },
  {Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_RelocNotPICBit, },
  {Feature_InMicroMipsBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, Feature_UseAbsBit, },
  {Feature_InMicroMipsBit, Feature_NotFP64bitBit, Feature_NotMips32r6Bit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, Feature_RelocNotPICBit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, Feature_RelocPICBit, },
  {Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMips16ModeBit, },
  {Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMips16ModeBit, },
  {Feature_HasMadd4Bit, Feature_InMicroMipsBit, Feature_NoNaNsFPMathBit, Feature_NotMips32r6Bit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32Bit, Feature_HasStdEncBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasMadd4Bit, Feature_InMicroMipsBit, Feature_NoNaNsFPMathBit, Feature_NotFP64bitBit, Feature_NotMips32r6Bit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips64Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips64r6Bit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_NoNaNsFPMathBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NoNaNsFPMathBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_NoNaNsFPMathBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

MipsInstructionSelector::ComplexMatcherMemFn
MipsInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool MipsInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool MipsInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_immLi16 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_immSExt6,
  GICXXPred_I64_Predicate_immSExt10,
  GICXXPred_I64_Predicate_immSExtAddiur2,
  GICXXPred_I64_Predicate_immSExtAddius5,
  GICXXPred_I64_Predicate_immZExt1,
  GICXXPred_I64_Predicate_immZExt1Ptr,
  GICXXPred_I64_Predicate_immZExt2,
  GICXXPred_I64_Predicate_immZExt2Lsa,
  GICXXPred_I64_Predicate_immZExt2Ptr,
  GICXXPred_I64_Predicate_immZExt2Shift,
  GICXXPred_I64_Predicate_immZExt3,
  GICXXPred_I64_Predicate_immZExt3Ptr,
  GICXXPred_I64_Predicate_immZExt4,
  GICXXPred_I64_Predicate_immZExt4Ptr,
  GICXXPred_I64_Predicate_immZExt5,
  GICXXPred_I64_Predicate_immZExt5_64,
  GICXXPred_I64_Predicate_immZExt6,
  GICXXPred_I64_Predicate_immZExt8,
  GICXXPred_I64_Predicate_immZExt10,
  GICXXPred_I64_Predicate_immZExtAndi16,
  GICXXPred_I64_Predicate_immi32Cst7,
  GICXXPred_I64_Predicate_immi32Cst15,
  GICXXPred_I64_Predicate_immi32Cst31,
  GICXXPred_I64_Predicate_timmSExt6,
  GICXXPred_I64_Predicate_timmZExt1,
  GICXXPred_I64_Predicate_timmZExt1Ptr,
  GICXXPred_I64_Predicate_timmZExt2,
  GICXXPred_I64_Predicate_timmZExt2Ptr,
  GICXXPred_I64_Predicate_timmZExt3,
  GICXXPred_I64_Predicate_timmZExt3Ptr,
  GICXXPred_I64_Predicate_timmZExt4,
  GICXXPred_I64_Predicate_timmZExt4Ptr,
  GICXXPred_I64_Predicate_timmZExt5,
  GICXXPred_I64_Predicate_timmZExt6,
  GICXXPred_I64_Predicate_timmZExt8,
  GICXXPred_I64_Predicate_timmZExt10,
};
bool MipsInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_immLi16: {
    return Imm >= -1 && Imm <= 126;
  }
  case GICXXPred_I64_Predicate_immSExt6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_immSExt10: {
    return isInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immSExtAddiur2: {
    return Imm == 1 || Imm == -1 ||
                                               ((Imm % 4 == 0) &&
                                                Imm < 28 && Imm > 0);
  }
  case GICXXPred_I64_Predicate_immSExtAddius5: {
    return Imm >= -8 && Imm <= 7;
  }
  case GICXXPred_I64_Predicate_immZExt1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt1Ptr: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2Lsa: {
    return isUInt<2>(Imm - 1);
  }
  case GICXXPred_I64_Predicate_immZExt2Ptr: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2Shift: {
    return Imm >= 1 && Imm <= 8;
  }
  case GICXXPred_I64_Predicate_immZExt3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt3Ptr: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt4Ptr: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt5: {
    return Imm == (Imm & 0x1f);
  }
  case GICXXPred_I64_Predicate_immZExt5_64: {
     return Imm == (Imm & 0x1f); 
  }
  case GICXXPred_I64_Predicate_immZExt6: {
    return Imm == (Imm & 0x3f);
  }
  case GICXXPred_I64_Predicate_immZExt8: {
    return isUInt<8>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExtAndi16: {
    return (Imm == 128 || (Imm >= 1 && Imm <= 4) || Imm == 7 || Imm == 8 ||
                Imm == 15 || Imm == 16 || Imm == 31 || Imm == 32 || Imm == 63 ||
                Imm == 64 || Imm == 255 || Imm == 32768 || Imm == 65535 );
  }
  case GICXXPred_I64_Predicate_immi32Cst7: {
    return isUInt<32>(Imm) && Imm == 7;
  }
  case GICXXPred_I64_Predicate_immi32Cst15: {
    return isUInt<32>(Imm) && Imm == 15;
  }
  case GICXXPred_I64_Predicate_immi32Cst31: {
    return isUInt<32>(Imm) && Imm == 31;
  }
  case GICXXPred_I64_Predicate_timmSExt6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt1Ptr: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt2Ptr: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt3Ptr: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt4Ptr: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt5: {
    return Imm == (Imm & 0x1f);
  }
  case GICXXPred_I64_Predicate_timmZExt6: {
    return Imm == (Imm & 0x3f);
  }
  case GICXXPred_I64_Predicate_timmZExt8: {
    return isUInt<8>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt10: {
    return isUInt<10>(Imm);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool MipsInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_imm32SExt16 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_imm32ZExt16,
};
bool MipsInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_imm32SExt16: {
     return isInt<16>(Imm.getSExtValue()); 
  }
  case GICXXPred_APInt_Predicate_imm32ZExt16: {
    
      return (uint32_t)Imm.getZExtValue() == (unsigned short)Imm.getZExtValue();
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool MipsInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("MipsInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
MipsInstructionSelector::CustomRendererFn
MipsInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool MipsInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool MipsInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("MipsInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *MipsInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*     0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(289), /*)*//*default:*//*Label 79*/ GIMT_Encode4(69777),
     /*    10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(954),
     /*    14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(2252),
     /*    18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(2943),
     /*    22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(3424),
     /*    26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(3693),
     /*    30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(3962),
     /*    34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(4231), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(4500),
     /*    50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(5056),
     /*    54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(5460), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 10*/ GIMT_Encode4(6352),
     /*   106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 11*/ GIMT_Encode4(6425), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   126 */ /*TargetOpcode::G_BITCAST*//*Label 12*/ GIMT_Encode4(6766), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   170 */ /*TargetOpcode::G_LOAD*//*Label 13*/ GIMT_Encode4(11077),
     /*   174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 14*/ GIMT_Encode4(11142),
     /*   178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 15*/ GIMT_Encode4(11210), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 16*/ GIMT_Encode4(11278),
     /*   210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 17*/ GIMT_Encode4(11470),
     /*   214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 18*/ GIMT_Encode4(11640),
     /*   218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 19*/ GIMT_Encode4(11810),
     /*   222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 20*/ GIMT_Encode4(11980),
     /*   226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 21*/ GIMT_Encode4(12150),
     /*   230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 22*/ GIMT_Encode4(12320),
     /*   234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 23*/ GIMT_Encode4(12490),
     /*   238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 24*/ GIMT_Encode4(12660),
     /*   242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 25*/ GIMT_Encode4(12830),
     /*   246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 26*/ GIMT_Encode4(13000),
     /*   250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 27*/ GIMT_Encode4(13170), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   302 */ /*TargetOpcode::G_BRCOND*//*Label 28*/ GIMT_Encode4(13340), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   314 */ /*TargetOpcode::G_INTRINSIC*//*Label 29*/ GIMT_Encode4(18061),
     /*   318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 30*/ GIMT_Encode4(32326), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   330 */ /*TargetOpcode::G_ANYEXT*//*Label 31*/ GIMT_Encode4(37420),
     /*   334 */ /*TargetOpcode::G_TRUNC*//*Label 32*/ GIMT_Encode4(37486),
     /*   338 */ /*TargetOpcode::G_CONSTANT*//*Label 33*/ GIMT_Encode4(37550), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   354 */ /*TargetOpcode::G_SEXT*//*Label 34*/ GIMT_Encode4(37611),
     /*   358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 35*/ GIMT_Encode4(39075),
     /*   362 */ /*TargetOpcode::G_ZEXT*//*Label 36*/ GIMT_Encode4(39423),
     /*   366 */ /*TargetOpcode::G_SHL*//*Label 37*/ GIMT_Encode4(39624),
     /*   370 */ /*TargetOpcode::G_LSHR*//*Label 38*/ GIMT_Encode4(41421),
     /*   374 */ /*TargetOpcode::G_ASHR*//*Label 39*/ GIMT_Encode4(43218), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   386 */ /*TargetOpcode::G_ROTR*//*Label 40*/ GIMT_Encode4(44973), GIMT_Encode4(0),
     /*   394 */ /*TargetOpcode::G_ICMP*//*Label 41*/ GIMT_Encode4(45261),
     /*   398 */ /*TargetOpcode::G_FCMP*//*Label 42*/ GIMT_Encode4(47792), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   410 */ /*TargetOpcode::G_SELECT*//*Label 43*/ GIMT_Encode4(49498), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   454 */ /*TargetOpcode::G_UMULH*//*Label 44*/ GIMT_Encode4(61536),
     /*   458 */ /*TargetOpcode::G_SMULH*//*Label 45*/ GIMT_Encode4(61645), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   518 */ /*TargetOpcode::G_FADD*//*Label 46*/ GIMT_Encode4(61754),
     /*   522 */ /*TargetOpcode::G_FSUB*//*Label 47*/ GIMT_Encode4(62667),
     /*   526 */ /*TargetOpcode::G_FMUL*//*Label 48*/ GIMT_Encode4(63279),
     /*   530 */ /*TargetOpcode::G_FMA*//*Label 49*/ GIMT_Encode4(63766), GIMT_Encode4(0),
     /*   538 */ /*TargetOpcode::G_FDIV*//*Label 50*/ GIMT_Encode4(63872), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   558 */ /*TargetOpcode::G_FEXP2*//*Label 51*/ GIMT_Encode4(64171), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   570 */ /*TargetOpcode::G_FLOG2*//*Label 52*/ GIMT_Encode4(64249), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   586 */ /*TargetOpcode::G_FNEG*//*Label 53*/ GIMT_Encode4(64327),
     /*   590 */ /*TargetOpcode::G_FPEXT*//*Label 54*/ GIMT_Encode4(65696),
     /*   594 */ /*TargetOpcode::G_FPTRUNC*//*Label 55*/ GIMT_Encode4(65874),
     /*   598 */ /*TargetOpcode::G_FPTOSI*//*Label 56*/ GIMT_Encode4(66037),
     /*   602 */ /*TargetOpcode::G_FPTOUI*//*Label 57*/ GIMT_Encode4(66115),
     /*   606 */ /*TargetOpcode::G_SITOFP*//*Label 58*/ GIMT_Encode4(66193),
     /*   610 */ /*TargetOpcode::G_UITOFP*//*Label 59*/ GIMT_Encode4(66446), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   622 */ /*TargetOpcode::G_FABS*//*Label 60*/ GIMT_Encode4(66524), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 61*/ GIMT_Encode4(66764),
     /*   638 */ /*TargetOpcode::G_FMINNUM*//*Label 62*/ GIMT_Encode4(66838),
     /*   642 */ /*TargetOpcode::G_FMAXNUM*//*Label 63*/ GIMT_Encode4(66910),
     /*   646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 64*/ GIMT_Encode4(66982),
     /*   650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 65*/ GIMT_Encode4(67054), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   702 */ /*TargetOpcode::G_SMIN*//*Label 66*/ GIMT_Encode4(67126),
     /*   706 */ /*TargetOpcode::G_SMAX*//*Label 67*/ GIMT_Encode4(67294),
     /*   710 */ /*TargetOpcode::G_UMIN*//*Label 68*/ GIMT_Encode4(67462),
     /*   714 */ /*TargetOpcode::G_UMAX*//*Label 69*/ GIMT_Encode4(67630), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   730 */ /*TargetOpcode::G_BR*//*Label 70*/ GIMT_Encode4(67798), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 71*/ GIMT_Encode4(67922),
     /*   754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 72*/ GIMT_Encode4(68486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   782 */ /*TargetOpcode::G_CTLZ*//*Label 73*/ GIMT_Encode4(68538), GIMT_Encode4(0),
     /*   790 */ /*TargetOpcode::G_CTPOP*//*Label 74*/ GIMT_Encode4(69043),
     /*   794 */ /*TargetOpcode::G_BSWAP*//*Label 75*/ GIMT_Encode4(69249), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   850 */ /*TargetOpcode::G_FSQRT*//*Label 76*/ GIMT_Encode4(69413), GIMT_Encode4(0),
     /*   858 */ /*TargetOpcode::G_FRINT*//*Label 77*/ GIMT_Encode4(69653), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   950 */ /*TargetOpcode::G_TRAP*//*Label 78*/ GIMT_Encode4(69731),
     /*   954 */ // Label 0: @954
     /*   954 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 88*/ GIMT_Encode4(2251),
     /*   965 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(997),
     /*   969 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(1405),
     /*   973 */ /*GILLT_v2s16*//*Label 82*/ GIMT_Encode4(1571),
     /*   977 */ /*GILLT_v2s64*//*Label 83*/ GIMT_Encode4(1603),
     /*   981 */ /*GILLT_v4s8*//*Label 84*/ GIMT_Encode4(1757),
     /*   985 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(1789),
     /*   989 */ /*GILLT_v8s16*//*Label 86*/ GIMT_Encode4(1943),
     /*   993 */ /*GILLT_v16s8*//*Label 87*/ GIMT_Encode4(2097),
     /*   997 */ // Label 80: @997
     /*   997 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1404),
     /*  1002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  1005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  1008 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1075), // Rule ID 2400 //
     /*  1013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  1032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1049 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1053 */     // MIs[2] Operand 1
     /*  1053 */     // No operand predicates
     /*  1053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1059 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa), GPR32Opnd:{ *:[i32] }:$rt)  =>  (LSA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LSA),
     /*  1062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /*  1070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1073 */     GIR_RootConstrainSelectedInstOperands,
     /*  1074 */     // GIR_Coverage, 2400,
     /*  1074 */     GIR_EraseRootFromParent_Done,
     /*  1075 */   // Label 90: @1075
     /*  1075 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1142), // Rule ID 834 //
     /*  1080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  1103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1120 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1124 */     // MIs[2] Operand 1
     /*  1124 */     // No operand predicates
     /*  1124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1126 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa))  =>  (LSA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LSA),
     /*  1129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /*  1137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1140 */     GIR_RootConstrainSelectedInstOperands,
     /*  1141 */     // GIR_Coverage, 834,
     /*  1141 */     GIR_EraseRootFromParent_Done,
     /*  1142 */   // Label 91: @1142
     /*  1142 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1184), // Rule ID 40 //
     /*  1147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  1150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1166 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32SExt16),
     /*  1170 */     // MIs[1] Operand 1
     /*  1170 */     // No operand predicates
     /*  1170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1172 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm16)  =>  (ADDiu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  1172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDiu),
     /*  1175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  1177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  1179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  1182 */     GIR_RootConstrainSelectedInstOperands,
     /*  1183 */     // GIR_Coverage, 40,
     /*  1183 */     GIR_EraseRootFromParent_Done,
     /*  1184 */   // Label 92: @1184
     /*  1184 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1226), // Rule ID 2169 //
     /*  1189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  1192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExtAddiur2),
     /*  1212 */     // MIs[1] Operand 1
     /*  1212 */     // No operand predicates
     /*  1212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1214 */     // (add:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddiur2>>:$imm)  =>  (ADDIUR2_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddiur2>>:$imm)
     /*  1214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDIUR2_MM),
     /*  1217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1219 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  1224 */     GIR_RootConstrainSelectedInstOperands,
     /*  1225 */     // GIR_Coverage, 2169,
     /*  1225 */     GIR_EraseRootFromParent_Done,
     /*  1226 */   // Label 93: @1226
     /*  1226 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1268), // Rule ID 2170 //
     /*  1231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  1234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExtAddius5),
     /*  1254 */     // MIs[1] Operand 1
     /*  1254 */     // No operand predicates
     /*  1254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1256 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddius5>>:$imm)  =>  (ADDIUS5_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddius5>>:$imm)
     /*  1256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDIUS5_MM),
     /*  1259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1261 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  1266 */     GIR_RootConstrainSelectedInstOperands,
     /*  1267 */     // GIR_Coverage, 2170,
     /*  1267 */     GIR_EraseRootFromParent_Done,
     /*  1268 */   // Label 94: @1268
     /*  1268 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1295), // Rule ID 1208 //
     /*  1273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  1276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1288 */     // (add:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (ADDU16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  1288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU16_MMR6),
     /*  1293 */     GIR_RootConstrainSelectedInstOperands,
     /*  1294 */     // GIR_Coverage, 1208,
     /*  1294 */     GIR_Done,
     /*  1295 */   // Label 95: @1295
     /*  1295 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1322), // Rule ID 46 //
     /*  1300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  1303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1315 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  1315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDu),
     /*  1320 */     GIR_RootConstrainSelectedInstOperands,
     /*  1321 */     // GIR_Coverage, 46,
     /*  1321 */     GIR_Done,
     /*  1322 */   // Label 96: @1322
     /*  1322 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1349), // Rule ID 1060 //
     /*  1327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  1330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1342 */     // (add:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (ADDU16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  1342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU16_MM),
     /*  1347 */     GIR_RootConstrainSelectedInstOperands,
     /*  1348 */     // GIR_Coverage, 1060,
     /*  1348 */     GIR_Done,
     /*  1349 */   // Label 97: @1349
     /*  1349 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1376), // Rule ID 1072 //
     /*  1354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  1357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1369 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  1369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDu_MM),
     /*  1374 */     GIR_RootConstrainSelectedInstOperands,
     /*  1375 */     // GIR_Coverage, 1072,
     /*  1375 */     GIR_Done,
     /*  1376 */   // Label 98: @1376
     /*  1376 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1403), // Rule ID 1827 //
     /*  1381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  1384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1396 */     // (add:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (AdduRxRyRz16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  1396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AdduRxRyRz16),
     /*  1401 */     GIR_RootConstrainSelectedInstOperands,
     /*  1402 */     // GIR_Coverage, 1827,
     /*  1402 */     GIR_Done,
     /*  1403 */   // Label 99: @1403
     /*  1403 */   GIM_Reject,
     /*  1404 */ // Label 89: @1404
     /*  1404 */ GIM_Reject,
     /*  1405 */ // Label 81: @1405
     /*  1405 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1570),
     /*  1410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  1413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  1416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1420 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1483), // Rule ID 2401 //
     /*  1425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  1428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  1440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1457 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1461 */     // MIs[2] Operand 1
     /*  1461 */     // No operand predicates
     /*  1461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1467 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa), GPR64Opnd:{ *:[i64] }:$rt)  =>  (DLSA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DLSA),
     /*  1470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /*  1478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1481 */     GIR_RootConstrainSelectedInstOperands,
     /*  1482 */     // GIR_Coverage, 2401,
     /*  1482 */     GIR_EraseRootFromParent_Done,
     /*  1483 */   // Label 101: @1483
     /*  1483 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1546), // Rule ID 835 //
     /*  1488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  1491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  1507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1524 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1528 */     // MIs[2] Operand 1
     /*  1528 */     // No operand predicates
     /*  1528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1530 */     // (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa))  =>  (DLSA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DLSA),
     /*  1533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /*  1541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1544 */     GIR_RootConstrainSelectedInstOperands,
     /*  1545 */     // GIR_Coverage, 835,
     /*  1545 */     GIR_EraseRootFromParent_Done,
     /*  1546 */   // Label 102: @1546
     /*  1546 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1569), // Rule ID 202 //
     /*  1551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /*  1554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1562 */     // (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DADDu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  1562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DADDu),
     /*  1567 */     GIR_RootConstrainSelectedInstOperands,
     /*  1568 */     // GIR_Coverage, 202,
     /*  1568 */     GIR_Done,
     /*  1569 */   // Label 103: @1569
     /*  1569 */   GIM_Reject,
     /*  1570 */ // Label 100: @1570
     /*  1570 */ GIM_Reject,
     /*  1571 */ // Label 82: @1571
     /*  1571 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1602), // Rule ID 1926 //
     /*  1576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  1579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  1582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  1585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  1589 */   // (add:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (ADDQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  1589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDQ_PH),
     /*  1594 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  1600 */   GIR_RootConstrainSelectedInstOperands,
     /*  1601 */   // GIR_Coverage, 1926,
     /*  1601 */   GIR_Done,
     /*  1602 */ // Label 104: @1602
     /*  1602 */ GIM_Reject,
     /*  1603 */ // Label 83: @1603
     /*  1603 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1756),
     /*  1608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1618 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1675), // Rule ID 2405 //
     /*  1623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1658 */     // (add:{ *:[v2i64] } (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt), MSA128DOpnd:{ *:[v2i64] }:$wd_in)  =>  (MADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_D),
     /*  1661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1663 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  1665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1673 */     GIR_RootConstrainSelectedInstOperands,
     /*  1674 */     // GIR_Coverage, 2405,
     /*  1674 */     GIR_EraseRootFromParent_Done,
     /*  1675 */   // Label 106: @1675
     /*  1675 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1732), // Rule ID 843 //
     /*  1680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1715 */     // (add:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt))  =>  (MADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_D),
     /*  1718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1720 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  1722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1730 */     GIR_RootConstrainSelectedInstOperands,
     /*  1731 */     // GIR_Coverage, 843,
     /*  1731 */     GIR_EraseRootFromParent_Done,
     /*  1732 */   // Label 107: @1732
     /*  1732 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1755), // Rule ID 510 //
     /*  1737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1748 */     // (add:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_D),
     /*  1753 */     GIR_RootConstrainSelectedInstOperands,
     /*  1754 */     // GIR_Coverage, 510,
     /*  1754 */     GIR_Done,
     /*  1755 */   // Label 108: @1755
     /*  1755 */   GIM_Reject,
     /*  1756 */ // Label 105: @1756
     /*  1756 */ GIM_Reject,
     /*  1757 */ // Label 84: @1757
     /*  1757 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1788), // Rule ID 1932 //
     /*  1762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  1765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  1768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /*  1771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  1775 */   // (add:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (ADDU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /*  1775 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU_QB),
     /*  1780 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  1786 */   GIR_RootConstrainSelectedInstOperands,
     /*  1787 */   // GIR_Coverage, 1932,
     /*  1787 */   GIR_Done,
     /*  1788 */ // Label 109: @1788
     /*  1788 */ GIM_Reject,
     /*  1789 */ // Label 85: @1789
     /*  1789 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1942),
     /*  1794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1804 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1861), // Rule ID 2404 //
     /*  1809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1844 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt), MSA128WOpnd:{ *:[v4i32] }:$wd_in)  =>  (MADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_W),
     /*  1847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1849 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  1851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1859 */     GIR_RootConstrainSelectedInstOperands,
     /*  1860 */     // GIR_Coverage, 2404,
     /*  1860 */     GIR_EraseRootFromParent_Done,
     /*  1861 */   // Label 111: @1861
     /*  1861 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1918), // Rule ID 842 //
     /*  1866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1901 */     // (add:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt))  =>  (MADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_W),
     /*  1904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1906 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  1908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1916 */     GIR_RootConstrainSelectedInstOperands,
     /*  1917 */     // GIR_Coverage, 842,
     /*  1917 */     GIR_EraseRootFromParent_Done,
     /*  1918 */   // Label 112: @1918
     /*  1918 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1941), // Rule ID 509 //
     /*  1923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1934 */     // (add:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_W),
     /*  1939 */     GIR_RootConstrainSelectedInstOperands,
     /*  1940 */     // GIR_Coverage, 509,
     /*  1940 */     GIR_Done,
     /*  1941 */   // Label 113: @1941
     /*  1941 */   GIM_Reject,
     /*  1942 */ // Label 110: @1942
     /*  1942 */ GIM_Reject,
     /*  1943 */ // Label 86: @1943
     /*  1943 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(2096),
     /*  1948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  1951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  1954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1958 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(2015), // Rule ID 2403 //
     /*  1963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  1978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  1982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1998 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt), MSA128HOpnd:{ *:[v8i16] }:$wd_in)  =>  (MADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  1998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_H),
     /*  2001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2003 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  2005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2013 */     GIR_RootConstrainSelectedInstOperands,
     /*  2014 */     // GIR_Coverage, 2403,
     /*  2014 */     GIR_EraseRootFromParent_Done,
     /*  2015 */   // Label 115: @2015
     /*  2015 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(2072), // Rule ID 841 //
     /*  2020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2055 */     // (add:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt))  =>  (MADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_H),
     /*  2058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2060 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2070 */     GIR_RootConstrainSelectedInstOperands,
     /*  2071 */     // GIR_Coverage, 841,
     /*  2071 */     GIR_EraseRootFromParent_Done,
     /*  2072 */   // Label 116: @2072
     /*  2072 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2095), // Rule ID 508 //
     /*  2077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2088 */     // (add:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_H),
     /*  2093 */     GIR_RootConstrainSelectedInstOperands,
     /*  2094 */     // GIR_Coverage, 508,
     /*  2094 */     GIR_Done,
     /*  2095 */   // Label 117: @2095
     /*  2095 */   GIM_Reject,
     /*  2096 */ // Label 114: @2096
     /*  2096 */ GIM_Reject,
     /*  2097 */ // Label 87: @2097
     /*  2097 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2250),
     /*  2102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2112 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2169), // Rule ID 2402 //
     /*  2117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  2124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2152 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt), MSA128BOpnd:{ *:[v16i8] }:$wd_in)  =>  (MADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_B),
     /*  2155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2157 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  2159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2167 */     GIR_RootConstrainSelectedInstOperands,
     /*  2168 */     // GIR_Coverage, 2402,
     /*  2168 */     GIR_EraseRootFromParent_Done,
     /*  2169 */   // Label 119: @2169
     /*  2169 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2226), // Rule ID 840 //
     /*  2174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2209 */     // (add:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt))  =>  (MADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_B),
     /*  2212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2214 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2224 */     GIR_RootConstrainSelectedInstOperands,
     /*  2225 */     // GIR_Coverage, 840,
     /*  2225 */     GIR_EraseRootFromParent_Done,
     /*  2226 */   // Label 120: @2226
     /*  2226 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2249), // Rule ID 507 //
     /*  2231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2242 */     // (add:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_B),
     /*  2247 */     GIR_RootConstrainSelectedInstOperands,
     /*  2248 */     // GIR_Coverage, 507,
     /*  2248 */     GIR_Done,
     /*  2249 */   // Label 121: @2249
     /*  2249 */   GIM_Reject,
     /*  2250 */ // Label 118: @2250
     /*  2250 */ GIM_Reject,
     /*  2251 */ // Label 88: @2251
     /*  2251 */ GIM_Reject,
     /*  2252 */ // Label 1: @2252
     /*  2252 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 130*/ GIMT_Encode4(2942),
     /*  2263 */ /*GILLT_s32*//*Label 122*/ GIMT_Encode4(2295),
     /*  2267 */ /*GILLT_s64*//*Label 123*/ GIMT_Encode4(2472),
     /*  2271 */ /*GILLT_v2s16*//*Label 124*/ GIMT_Encode4(2506),
     /*  2275 */ /*GILLT_v2s64*//*Label 125*/ GIMT_Encode4(2538),
     /*  2279 */ /*GILLT_v4s8*//*Label 126*/ GIMT_Encode4(2631),
     /*  2283 */ /*GILLT_v4s32*//*Label 127*/ GIMT_Encode4(2663),
     /*  2287 */ /*GILLT_v8s16*//*Label 128*/ GIMT_Encode4(2756),
     /*  2291 */ /*GILLT_v16s8*//*Label 129*/ GIMT_Encode4(2849),
     /*  2295 */ // Label 122: @2295
     /*  2295 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2471),
     /*  2300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  2303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  2306 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2335), // Rule ID 1826 //
     /*  2311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  2314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  2322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2326 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, CPU16Regs:{ *:[i32] }:$r)  =>  (NegRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r)
     /*  2326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NegRxRy16),
     /*  2329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /*  2331 */     GIR_RootToRootCopy, /*OpIdx*/2, // r
     /*  2333 */     GIR_RootConstrainSelectedInstOperands,
     /*  2334 */     // GIR_Coverage, 1826,
     /*  2334 */     GIR_EraseRootFromParent_Done,
     /*  2335 */   // Label 132: @2335
     /*  2335 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2362), // Rule ID 1210 //
     /*  2340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  2343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2355 */     // (sub:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (SUBU16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  2355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU16_MMR6),
     /*  2360 */     GIR_RootConstrainSelectedInstOperands,
     /*  2361 */     // GIR_Coverage, 1210,
     /*  2361 */     GIR_Done,
     /*  2362 */   // Label 133: @2362
     /*  2362 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2389), // Rule ID 47 //
     /*  2367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  2370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2382 */     // (sub:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  2382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBu),
     /*  2387 */     GIR_RootConstrainSelectedInstOperands,
     /*  2388 */     // GIR_Coverage, 47,
     /*  2388 */     GIR_Done,
     /*  2389 */   // Label 134: @2389
     /*  2389 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2416), // Rule ID 1064 //
     /*  2394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  2397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2409 */     // (sub:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (SUBU16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  2409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU16_MM),
     /*  2414 */     GIR_RootConstrainSelectedInstOperands,
     /*  2415 */     // GIR_Coverage, 1064,
     /*  2415 */     GIR_Done,
     /*  2416 */   // Label 135: @2416
     /*  2416 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2443), // Rule ID 1073 //
     /*  2421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  2424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2436 */     // (sub:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  2436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBu_MM),
     /*  2441 */     GIR_RootConstrainSelectedInstOperands,
     /*  2442 */     // GIR_Coverage, 1073,
     /*  2442 */     GIR_Done,
     /*  2443 */   // Label 136: @2443
     /*  2443 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2470), // Rule ID 1831 //
     /*  2448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  2451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2463 */     // (sub:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (SubuRxRyRz16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  2463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SubuRxRyRz16),
     /*  2468 */     GIR_RootConstrainSelectedInstOperands,
     /*  2469 */     // GIR_Coverage, 1831,
     /*  2469 */     GIR_Done,
     /*  2470 */   // Label 137: @2470
     /*  2470 */   GIM_Reject,
     /*  2471 */ // Label 131: @2471
     /*  2471 */ GIM_Reject,
     /*  2472 */ // Label 123: @2472
     /*  2472 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2505), // Rule ID 203 //
     /*  2477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /*  2480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  2483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  2486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2498 */   // (sub:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DSUBu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  2498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSUBu),
     /*  2503 */   GIR_RootConstrainSelectedInstOperands,
     /*  2504 */   // GIR_Coverage, 203,
     /*  2504 */   GIR_Done,
     /*  2505 */ // Label 138: @2505
     /*  2505 */ GIM_Reject,
     /*  2506 */ // Label 124: @2506
     /*  2506 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2537), // Rule ID 1928 //
     /*  2511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  2514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  2517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  2520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  2524 */   // (sub:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (SUBQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  2524 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBQ_PH),
     /*  2529 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  2535 */   GIR_RootConstrainSelectedInstOperands,
     /*  2536 */   // GIR_Coverage, 1928,
     /*  2536 */   GIR_Done,
     /*  2537 */ // Label 139: @2537
     /*  2537 */ GIM_Reject,
     /*  2538 */ // Label 125: @2538
     /*  2538 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2630),
     /*  2543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  2546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  2549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2557 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2610), // Rule ID 899 //
     /*  2562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  2577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  2581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2593 */     // (sub:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt))  =>  (MSUBV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  2593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_D),
     /*  2596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2598 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2608 */     GIR_RootConstrainSelectedInstOperands,
     /*  2609 */     // GIR_Coverage, 899,
     /*  2609 */     GIR_EraseRootFromParent_Done,
     /*  2610 */   // Label 141: @2610
     /*  2610 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2629), // Rule ID 1028 //
     /*  2615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2622 */     // (sub:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  2622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_D),
     /*  2627 */     GIR_RootConstrainSelectedInstOperands,
     /*  2628 */     // GIR_Coverage, 1028,
     /*  2628 */     GIR_Done,
     /*  2629 */   // Label 142: @2629
     /*  2629 */   GIM_Reject,
     /*  2630 */ // Label 140: @2630
     /*  2630 */ GIM_Reject,
     /*  2631 */ // Label 126: @2631
     /*  2631 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2662), // Rule ID 1934 //
     /*  2636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  2639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  2642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /*  2645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  2649 */   // (sub:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (SUBU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /*  2649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU_QB),
     /*  2654 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  2660 */   GIR_RootConstrainSelectedInstOperands,
     /*  2661 */   // GIR_Coverage, 1934,
     /*  2661 */   GIR_Done,
     /*  2662 */ // Label 143: @2662
     /*  2662 */ GIM_Reject,
     /*  2663 */ // Label 127: @2663
     /*  2663 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2755),
     /*  2668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2682 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2735), // Rule ID 898 //
     /*  2687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2718 */     // (sub:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt))  =>  (MSUBV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  2718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_W),
     /*  2721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2723 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2733 */     GIR_RootConstrainSelectedInstOperands,
     /*  2734 */     // GIR_Coverage, 898,
     /*  2734 */     GIR_EraseRootFromParent_Done,
     /*  2735 */   // Label 145: @2735
     /*  2735 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2754), // Rule ID 1027 //
     /*  2740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2747 */     // (sub:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  2747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_W),
     /*  2752 */     GIR_RootConstrainSelectedInstOperands,
     /*  2753 */     // GIR_Coverage, 1027,
     /*  2753 */     GIR_Done,
     /*  2754 */   // Label 146: @2754
     /*  2754 */   GIM_Reject,
     /*  2755 */ // Label 144: @2755
     /*  2755 */ GIM_Reject,
     /*  2756 */ // Label 128: @2756
     /*  2756 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2848),
     /*  2761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2775 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2828), // Rule ID 897 //
     /*  2780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2811 */     // (sub:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt))  =>  (MSUBV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_H),
     /*  2814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2816 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2826 */     GIR_RootConstrainSelectedInstOperands,
     /*  2827 */     // GIR_Coverage, 897,
     /*  2827 */     GIR_EraseRootFromParent_Done,
     /*  2828 */   // Label 148: @2828
     /*  2828 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2847), // Rule ID 1026 //
     /*  2833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2840 */     // (sub:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_H),
     /*  2845 */     GIR_RootConstrainSelectedInstOperands,
     /*  2846 */     // GIR_Coverage, 1026,
     /*  2846 */     GIR_Done,
     /*  2847 */   // Label 149: @2847
     /*  2847 */   GIM_Reject,
     /*  2848 */ // Label 147: @2848
     /*  2848 */ GIM_Reject,
     /*  2849 */ // Label 129: @2849
     /*  2849 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2941),
     /*  2854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2868 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2921), // Rule ID 896 //
     /*  2873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2904 */     // (sub:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt))  =>  (MSUBV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_B),
     /*  2907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2909 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2919 */     GIR_RootConstrainSelectedInstOperands,
     /*  2920 */     // GIR_Coverage, 896,
     /*  2920 */     GIR_EraseRootFromParent_Done,
     /*  2921 */   // Label 151: @2921
     /*  2921 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2940), // Rule ID 1025 //
     /*  2926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2933 */     // (sub:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_B),
     /*  2938 */     GIR_RootConstrainSelectedInstOperands,
     /*  2939 */     // GIR_Coverage, 1025,
     /*  2939 */     GIR_Done,
     /*  2940 */   // Label 152: @2940
     /*  2940 */   GIM_Reject,
     /*  2941 */ // Label 150: @2941
     /*  2941 */ GIM_Reject,
     /*  2942 */ // Label 130: @2942
     /*  2942 */ GIM_Reject,
     /*  2943 */ // Label 2: @2943
     /*  2943 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 160*/ GIMT_Encode4(3423),
     /*  2954 */ /*GILLT_s32*//*Label 153*/ GIMT_Encode4(2986),
     /*  2958 */ /*GILLT_s64*//*Label 154*/ GIMT_Encode4(3170),
     /*  2962 */ /*GILLT_v2s16*//*Label 155*/ GIMT_Encode4(3255),
     /*  2966 */ /*GILLT_v2s64*//*Label 156*/ GIMT_Encode4(3287), GIMT_Encode4(0),
     /*  2974 */ /*GILLT_v4s32*//*Label 157*/ GIMT_Encode4(3321),
     /*  2978 */ /*GILLT_v8s16*//*Label 158*/ GIMT_Encode4(3355),
     /*  2982 */ /*GILLT_v16s8*//*Label 159*/ GIMT_Encode4(3389),
     /*  2986 */ // Label 153: @2986
     /*  2986 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3169),
     /*  2991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  2994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  2997 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3036), // Rule ID 48 //
     /*  3002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /*  3005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3017 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL:{ *:[i32] }:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL),
     /*  3022 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3028 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3034 */     GIR_RootConstrainSelectedInstOperands,
     /*  3035 */     // GIR_Coverage, 48,
     /*  3035 */     GIR_Done,
     /*  3036 */   // Label 162: @3036
     /*  3036 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3063), // Rule ID 332 //
     /*  3041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3056 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_R6),
     /*  3061 */     GIR_RootConstrainSelectedInstOperands,
     /*  3062 */     // GIR_Coverage, 332,
     /*  3062 */     GIR_Done,
     /*  3063 */   // Label 163: @3063
     /*  3063 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(3102), // Rule ID 1074 //
     /*  3068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  3071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3083 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_MM:{ *:[i32] }:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_MM),
     /*  3088 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3094 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3100 */     GIR_RootConstrainSelectedInstOperands,
     /*  3101 */     // GIR_Coverage, 1074,
     /*  3101 */     GIR_Done,
     /*  3102 */   // Label 164: @3102
     /*  3102 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(3129), // Rule ID 1179 //
     /*  3107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3122 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_MMR6),
     /*  3127 */     GIR_RootConstrainSelectedInstOperands,
     /*  3128 */     // GIR_Coverage, 1179,
     /*  3128 */     GIR_Done,
     /*  3129 */   // Label 165: @3129
     /*  3129 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(3168), // Rule ID 1829 //
     /*  3134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  3137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3149 */     // (mul:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (MultRxRyRz16:{ *:[i32] }:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  3149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MultRxRyRz16),
     /*  3154 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3160 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3166 */     GIR_RootConstrainSelectedInstOperands,
     /*  3167 */     // GIR_Coverage, 1829,
     /*  3167 */     GIR_Done,
     /*  3168 */   // Label 166: @3168
     /*  3168 */   GIM_Reject,
     /*  3169 */ // Label 161: @3169
     /*  3169 */ GIM_Reject,
     /*  3170 */ // Label 154: @3170
     /*  3170 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(3254),
     /*  3175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3193 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(3238), // Rule ID 274 //
     /*  3198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /*  3201 */     // (mul:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUL:{ *:[i64] }:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUL),
     /*  3206 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3212 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3218 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P0), GIMT_Encode2(RegState::Dead),
     /*  3224 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P1), GIMT_Encode2(RegState::Dead),
     /*  3230 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P2), GIMT_Encode2(RegState::Dead),
     /*  3236 */     GIR_RootConstrainSelectedInstOperands,
     /*  3237 */     // GIR_Coverage, 274,
     /*  3237 */     GIR_Done,
     /*  3238 */   // Label 168: @3238
     /*  3238 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(3253), // Rule ID 347 //
     /*  3243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3246 */     // (mul:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUL_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUL_R6),
     /*  3251 */     GIR_RootConstrainSelectedInstOperands,
     /*  3252 */     // GIR_Coverage, 347,
     /*  3252 */     GIR_Done,
     /*  3253 */   // Label 169: @3253
     /*  3253 */   GIM_Reject,
     /*  3254 */ // Label 167: @3254
     /*  3254 */ GIM_Reject,
     /*  3255 */ // Label 155: @3255
     /*  3255 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3286), // Rule ID 1930 //
     /*  3260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /*  3263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  3266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  3269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  3273 */   // (mul:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (MUL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  3273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_PH),
     /*  3278 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag21), GIMT_Encode2(RegState::Dead),
     /*  3284 */   GIR_RootConstrainSelectedInstOperands,
     /*  3285 */   // GIR_Coverage, 1930,
     /*  3285 */   GIR_Done,
     /*  3286 */ // Label 170: @3286
     /*  3286 */ GIM_Reject,
     /*  3287 */ // Label 156: @3287
     /*  3287 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3320), // Rule ID 907 //
     /*  3292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3313 */   // (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MULV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_D),
     /*  3318 */   GIR_RootConstrainSelectedInstOperands,
     /*  3319 */   // GIR_Coverage, 907,
     /*  3319 */   GIR_Done,
     /*  3320 */ // Label 171: @3320
     /*  3320 */ GIM_Reject,
     /*  3321 */ // Label 157: @3321
     /*  3321 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3354), // Rule ID 906 //
     /*  3326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3347 */   // (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MULV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_W),
     /*  3352 */   GIR_RootConstrainSelectedInstOperands,
     /*  3353 */   // GIR_Coverage, 906,
     /*  3353 */   GIR_Done,
     /*  3354 */ // Label 172: @3354
     /*  3354 */ GIM_Reject,
     /*  3355 */ // Label 158: @3355
     /*  3355 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3388), // Rule ID 905 //
     /*  3360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3381 */   // (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MULV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_H),
     /*  3386 */   GIR_RootConstrainSelectedInstOperands,
     /*  3387 */   // GIR_Coverage, 905,
     /*  3387 */   GIR_Done,
     /*  3388 */ // Label 173: @3388
     /*  3388 */ GIM_Reject,
     /*  3389 */ // Label 159: @3389
     /*  3389 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3422), // Rule ID 904 //
     /*  3394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3415 */   // (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MULV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_B),
     /*  3420 */   GIR_RootConstrainSelectedInstOperands,
     /*  3421 */   // GIR_Coverage, 904,
     /*  3421 */   GIR_Done,
     /*  3422 */ // Label 174: @3422
     /*  3422 */ GIM_Reject,
     /*  3423 */ // Label 160: @3423
     /*  3423 */ GIM_Reject,
     /*  3424 */ // Label 3: @3424
     /*  3424 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 181*/ GIMT_Encode4(3692),
     /*  3435 */ /*GILLT_s32*//*Label 175*/ GIMT_Encode4(3467),
     /*  3439 */ /*GILLT_s64*//*Label 176*/ GIMT_Encode4(3522), GIMT_Encode4(0),
     /*  3447 */ /*GILLT_v2s64*//*Label 177*/ GIMT_Encode4(3556), GIMT_Encode4(0),
     /*  3455 */ /*GILLT_v4s32*//*Label 178*/ GIMT_Encode4(3590),
     /*  3459 */ /*GILLT_v8s16*//*Label 179*/ GIMT_Encode4(3624),
     /*  3463 */ /*GILLT_v16s8*//*Label 180*/ GIMT_Encode4(3658),
     /*  3467 */ // Label 175: @3467
     /*  3467 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3521),
     /*  3472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3490 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3505), // Rule ID 326 //
     /*  3495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3498 */     // (sdiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV),
     /*  3503 */     GIR_RootConstrainSelectedInstOperands,
     /*  3504 */     // GIR_Coverage, 326,
     /*  3504 */     GIR_Done,
     /*  3505 */   // Label 183: @3505
     /*  3505 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3520), // Rule ID 1172 //
     /*  3510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3513 */     // (sdiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIV_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_MMR6),
     /*  3518 */     GIR_RootConstrainSelectedInstOperands,
     /*  3519 */     // GIR_Coverage, 1172,
     /*  3519 */     GIR_Done,
     /*  3520 */   // Label 184: @3520
     /*  3520 */   GIM_Reject,
     /*  3521 */ // Label 182: @3521
     /*  3521 */ GIM_Reject,
     /*  3522 */ // Label 176: @3522
     /*  3522 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3555), // Rule ID 341 //
     /*  3527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3548 */   // (sdiv:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DDIV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DDIV),
     /*  3553 */   GIR_RootConstrainSelectedInstOperands,
     /*  3554 */   // GIR_Coverage, 341,
     /*  3554 */   GIR_Done,
     /*  3555 */ // Label 185: @3555
     /*  3555 */ GIM_Reject,
     /*  3556 */ // Label 177: @3556
     /*  3556 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3589), // Rule ID 647 //
     /*  3561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3582 */   // (sdiv:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (DIV_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_D),
     /*  3587 */   GIR_RootConstrainSelectedInstOperands,
     /*  3588 */   // GIR_Coverage, 647,
     /*  3588 */   GIR_Done,
     /*  3589 */ // Label 186: @3589
     /*  3589 */ GIM_Reject,
     /*  3590 */ // Label 178: @3590
     /*  3590 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3623), // Rule ID 646 //
     /*  3595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3616 */   // (sdiv:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DIV_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_W),
     /*  3621 */   GIR_RootConstrainSelectedInstOperands,
     /*  3622 */   // GIR_Coverage, 646,
     /*  3622 */   GIR_Done,
     /*  3623 */ // Label 187: @3623
     /*  3623 */ GIM_Reject,
     /*  3624 */ // Label 179: @3624
     /*  3624 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3657), // Rule ID 645 //
     /*  3629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3650 */   // (sdiv:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DIV_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_H),
     /*  3655 */   GIR_RootConstrainSelectedInstOperands,
     /*  3656 */   // GIR_Coverage, 645,
     /*  3656 */   GIR_Done,
     /*  3657 */ // Label 188: @3657
     /*  3657 */ GIM_Reject,
     /*  3658 */ // Label 180: @3658
     /*  3658 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3691), // Rule ID 644 //
     /*  3663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3684 */   // (sdiv:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DIV_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_B),
     /*  3689 */   GIR_RootConstrainSelectedInstOperands,
     /*  3690 */   // GIR_Coverage, 644,
     /*  3690 */   GIR_Done,
     /*  3691 */ // Label 189: @3691
     /*  3691 */ GIM_Reject,
     /*  3692 */ // Label 181: @3692
     /*  3692 */ GIM_Reject,
     /*  3693 */ // Label 4: @3693
     /*  3693 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 196*/ GIMT_Encode4(3961),
     /*  3704 */ /*GILLT_s32*//*Label 190*/ GIMT_Encode4(3736),
     /*  3708 */ /*GILLT_s64*//*Label 191*/ GIMT_Encode4(3791), GIMT_Encode4(0),
     /*  3716 */ /*GILLT_v2s64*//*Label 192*/ GIMT_Encode4(3825), GIMT_Encode4(0),
     /*  3724 */ /*GILLT_v4s32*//*Label 193*/ GIMT_Encode4(3859),
     /*  3728 */ /*GILLT_v8s16*//*Label 194*/ GIMT_Encode4(3893),
     /*  3732 */ /*GILLT_v16s8*//*Label 195*/ GIMT_Encode4(3927),
     /*  3736 */ // Label 190: @3736
     /*  3736 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3790),
     /*  3741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3759 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3774), // Rule ID 327 //
     /*  3764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3767 */     // (udiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIVU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIVU),
     /*  3772 */     GIR_RootConstrainSelectedInstOperands,
     /*  3773 */     // GIR_Coverage, 327,
     /*  3773 */     GIR_Done,
     /*  3774 */   // Label 198: @3774
     /*  3774 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3789), // Rule ID 1173 //
     /*  3779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3782 */     // (udiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIVU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIVU_MMR6),
     /*  3787 */     GIR_RootConstrainSelectedInstOperands,
     /*  3788 */     // GIR_Coverage, 1173,
     /*  3788 */     GIR_Done,
     /*  3789 */   // Label 199: @3789
     /*  3789 */   GIM_Reject,
     /*  3790 */ // Label 197: @3790
     /*  3790 */ GIM_Reject,
     /*  3791 */ // Label 191: @3791
     /*  3791 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3824), // Rule ID 342 //
     /*  3796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3817 */   // (udiv:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DDIVU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DDIVU),
     /*  3822 */   GIR_RootConstrainSelectedInstOperands,
     /*  3823 */   // GIR_Coverage, 342,
     /*  3823 */   GIR_Done,
     /*  3824 */ // Label 200: @3824
     /*  3824 */ GIM_Reject,
     /*  3825 */ // Label 192: @3825
     /*  3825 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3858), // Rule ID 651 //
     /*  3830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3851 */   // (udiv:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (DIV_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_D),
     /*  3856 */   GIR_RootConstrainSelectedInstOperands,
     /*  3857 */   // GIR_Coverage, 651,
     /*  3857 */   GIR_Done,
     /*  3858 */ // Label 201: @3858
     /*  3858 */ GIM_Reject,
     /*  3859 */ // Label 193: @3859
     /*  3859 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3892), // Rule ID 650 //
     /*  3864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3885 */   // (udiv:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DIV_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_W),
     /*  3890 */   GIR_RootConstrainSelectedInstOperands,
     /*  3891 */   // GIR_Coverage, 650,
     /*  3891 */   GIR_Done,
     /*  3892 */ // Label 202: @3892
     /*  3892 */ GIM_Reject,
     /*  3893 */ // Label 194: @3893
     /*  3893 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3926), // Rule ID 649 //
     /*  3898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3919 */   // (udiv:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DIV_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_H),
     /*  3924 */   GIR_RootConstrainSelectedInstOperands,
     /*  3925 */   // GIR_Coverage, 649,
     /*  3925 */   GIR_Done,
     /*  3926 */ // Label 203: @3926
     /*  3926 */ GIM_Reject,
     /*  3927 */ // Label 195: @3927
     /*  3927 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3960), // Rule ID 648 //
     /*  3932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3953 */   // (udiv:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DIV_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_B),
     /*  3958 */   GIR_RootConstrainSelectedInstOperands,
     /*  3959 */   // GIR_Coverage, 648,
     /*  3959 */   GIR_Done,
     /*  3960 */ // Label 204: @3960
     /*  3960 */ GIM_Reject,
     /*  3961 */ // Label 196: @3961
     /*  3961 */ GIM_Reject,
     /*  3962 */ // Label 5: @3962
     /*  3962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 211*/ GIMT_Encode4(4230),
     /*  3973 */ /*GILLT_s32*//*Label 205*/ GIMT_Encode4(4005),
     /*  3977 */ /*GILLT_s64*//*Label 206*/ GIMT_Encode4(4060), GIMT_Encode4(0),
     /*  3985 */ /*GILLT_v2s64*//*Label 207*/ GIMT_Encode4(4094), GIMT_Encode4(0),
     /*  3993 */ /*GILLT_v4s32*//*Label 208*/ GIMT_Encode4(4128),
     /*  3997 */ /*GILLT_v8s16*//*Label 209*/ GIMT_Encode4(4162),
     /*  4001 */ /*GILLT_v16s8*//*Label 210*/ GIMT_Encode4(4196),
     /*  4005 */ // Label 205: @4005
     /*  4005 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(4059),
     /*  4010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4028 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(4043), // Rule ID 328 //
     /*  4033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  4036 */     // (srem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MOD:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD),
     /*  4041 */     GIR_RootConstrainSelectedInstOperands,
     /*  4042 */     // GIR_Coverage, 328,
     /*  4042 */     GIR_Done,
     /*  4043 */   // Label 213: @4043
     /*  4043 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(4058), // Rule ID 1177 //
     /*  4048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4051 */     // (srem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MOD_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_MMR6),
     /*  4056 */     GIR_RootConstrainSelectedInstOperands,
     /*  4057 */     // GIR_Coverage, 1177,
     /*  4057 */     GIR_Done,
     /*  4058 */   // Label 214: @4058
     /*  4058 */   GIM_Reject,
     /*  4059 */ // Label 212: @4059
     /*  4059 */ GIM_Reject,
     /*  4060 */ // Label 206: @4060
     /*  4060 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(4093), // Rule ID 343 //
     /*  4065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  4068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4086 */   // (srem:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMOD:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMOD),
     /*  4091 */   GIR_RootConstrainSelectedInstOperands,
     /*  4092 */   // GIR_Coverage, 343,
     /*  4092 */   GIR_Done,
     /*  4093 */ // Label 215: @4093
     /*  4093 */ GIM_Reject,
     /*  4094 */ // Label 207: @4094
     /*  4094 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(4127), // Rule ID 887 //
     /*  4099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4120 */   // (srem:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MOD_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_D),
     /*  4125 */   GIR_RootConstrainSelectedInstOperands,
     /*  4126 */   // GIR_Coverage, 887,
     /*  4126 */   GIR_Done,
     /*  4127 */ // Label 216: @4127
     /*  4127 */ GIM_Reject,
     /*  4128 */ // Label 208: @4128
     /*  4128 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(4161), // Rule ID 886 //
     /*  4133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4154 */   // (srem:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MOD_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_W),
     /*  4159 */   GIR_RootConstrainSelectedInstOperands,
     /*  4160 */   // GIR_Coverage, 886,
     /*  4160 */   GIR_Done,
     /*  4161 */ // Label 217: @4161
     /*  4161 */ GIM_Reject,
     /*  4162 */ // Label 209: @4162
     /*  4162 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(4195), // Rule ID 885 //
     /*  4167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4188 */   // (srem:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MOD_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  4188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_H),
     /*  4193 */   GIR_RootConstrainSelectedInstOperands,
     /*  4194 */   // GIR_Coverage, 885,
     /*  4194 */   GIR_Done,
     /*  4195 */ // Label 218: @4195
     /*  4195 */ GIM_Reject,
     /*  4196 */ // Label 210: @4196
     /*  4196 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(4229), // Rule ID 884 //
     /*  4201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  4207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  4210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4222 */   // (srem:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MOD_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  4222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_B),
     /*  4227 */   GIR_RootConstrainSelectedInstOperands,
     /*  4228 */   // GIR_Coverage, 884,
     /*  4228 */   GIR_Done,
     /*  4229 */ // Label 219: @4229
     /*  4229 */ GIM_Reject,
     /*  4230 */ // Label 211: @4230
     /*  4230 */ GIM_Reject,
     /*  4231 */ // Label 6: @4231
     /*  4231 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 226*/ GIMT_Encode4(4499),
     /*  4242 */ /*GILLT_s32*//*Label 220*/ GIMT_Encode4(4274),
     /*  4246 */ /*GILLT_s64*//*Label 221*/ GIMT_Encode4(4329), GIMT_Encode4(0),
     /*  4254 */ /*GILLT_v2s64*//*Label 222*/ GIMT_Encode4(4363), GIMT_Encode4(0),
     /*  4262 */ /*GILLT_v4s32*//*Label 223*/ GIMT_Encode4(4397),
     /*  4266 */ /*GILLT_v8s16*//*Label 224*/ GIMT_Encode4(4431),
     /*  4270 */ /*GILLT_v16s8*//*Label 225*/ GIMT_Encode4(4465),
     /*  4274 */ // Label 220: @4274
     /*  4274 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4328),
     /*  4279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4297 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4312), // Rule ID 329 //
     /*  4302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  4305 */     // (urem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MODU),
     /*  4310 */     GIR_RootConstrainSelectedInstOperands,
     /*  4311 */     // GIR_Coverage, 329,
     /*  4311 */     GIR_Done,
     /*  4312 */   // Label 228: @4312
     /*  4312 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4327), // Rule ID 1178 //
     /*  4317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4320 */     // (urem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MODU_MMR6),
     /*  4325 */     GIR_RootConstrainSelectedInstOperands,
     /*  4326 */     // GIR_Coverage, 1178,
     /*  4326 */     GIR_Done,
     /*  4327 */   // Label 229: @4327
     /*  4327 */   GIM_Reject,
     /*  4328 */ // Label 227: @4328
     /*  4328 */ GIM_Reject,
     /*  4329 */ // Label 221: @4329
     /*  4329 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4362), // Rule ID 344 //
     /*  4334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  4337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4355 */   // (urem:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMODU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMODU),
     /*  4360 */   GIR_RootConstrainSelectedInstOperands,
     /*  4361 */   // GIR_Coverage, 344,
     /*  4361 */   GIR_Done,
     /*  4362 */ // Label 230: @4362
     /*  4362 */ GIM_Reject,
     /*  4363 */ // Label 222: @4363
     /*  4363 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4396), // Rule ID 891 //
     /*  4368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4389 */   // (urem:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MOD_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_D),
     /*  4394 */   GIR_RootConstrainSelectedInstOperands,
     /*  4395 */   // GIR_Coverage, 891,
     /*  4395 */   GIR_Done,
     /*  4396 */ // Label 231: @4396
     /*  4396 */ GIM_Reject,
     /*  4397 */ // Label 223: @4397
     /*  4397 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4430), // Rule ID 890 //
     /*  4402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4423 */   // (urem:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MOD_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_W),
     /*  4428 */   GIR_RootConstrainSelectedInstOperands,
     /*  4429 */   // GIR_Coverage, 890,
     /*  4429 */   GIR_Done,
     /*  4430 */ // Label 232: @4430
     /*  4430 */ GIM_Reject,
     /*  4431 */ // Label 224: @4431
     /*  4431 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(4464), // Rule ID 889 //
     /*  4436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4457 */   // (urem:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MOD_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  4457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_H),
     /*  4462 */   GIR_RootConstrainSelectedInstOperands,
     /*  4463 */   // GIR_Coverage, 889,
     /*  4463 */   GIR_Done,
     /*  4464 */ // Label 233: @4464
     /*  4464 */ GIM_Reject,
     /*  4465 */ // Label 225: @4465
     /*  4465 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(4498), // Rule ID 888 //
     /*  4470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  4476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  4479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4491 */   // (urem:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MOD_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  4491 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_B),
     /*  4496 */   GIR_RootConstrainSelectedInstOperands,
     /*  4497 */   // GIR_Coverage, 888,
     /*  4497 */   GIR_Done,
     /*  4498 */ // Label 234: @4498
     /*  4498 */ GIM_Reject,
     /*  4499 */ // Label 226: @4499
     /*  4499 */ GIM_Reject,
     /*  4500 */ // Label 7: @4500
     /*  4500 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 241*/ GIMT_Encode4(5055),
     /*  4511 */ /*GILLT_s32*//*Label 235*/ GIMT_Encode4(4543),
     /*  4515 */ /*GILLT_s64*//*Label 236*/ GIMT_Encode4(4817), GIMT_Encode4(0),
     /*  4523 */ /*GILLT_v2s64*//*Label 237*/ GIMT_Encode4(4919), GIMT_Encode4(0),
     /*  4531 */ /*GILLT_v4s32*//*Label 238*/ GIMT_Encode4(4953),
     /*  4535 */ /*GILLT_v8s16*//*Label 239*/ GIMT_Encode4(4987),
     /*  4539 */ /*GILLT_v16s8*//*Label 240*/ GIMT_Encode4(5021),
     /*  4543 */ // Label 235: @4543
     /*  4543 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(4816),
     /*  4548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4554 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(4596), // Rule ID 41 //
     /*  4559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  4562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4578 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  4582 */     // MIs[1] Operand 1
     /*  4582 */     // No operand predicates
     /*  4582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4584 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (ANDi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  4584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDi),
     /*  4587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  4589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  4591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  4594 */     GIR_RootConstrainSelectedInstOperands,
     /*  4595 */     // GIR_Coverage, 41,
     /*  4595 */     GIR_EraseRootFromParent_Done,
     /*  4596 */   // Label 243: @4596
     /*  4596 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(4638), // Rule ID 2172 //
     /*  4601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  4604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExtAndi16),
     /*  4624 */     // MIs[1] Operand 1
     /*  4624 */     // No operand predicates
     /*  4624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4626 */     // (and:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)  =>  (ANDI16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)
     /*  4626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDI16_MM),
     /*  4629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  4633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  4636 */     GIR_RootConstrainSelectedInstOperands,
     /*  4637 */     // GIR_Coverage, 2172,
     /*  4637 */     GIR_EraseRootFromParent_Done,
     /*  4638 */   // Label 244: @4638
     /*  4638 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(4680), // Rule ID 2331 //
     /*  4643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExtAndi16),
     /*  4666 */     // MIs[1] Operand 1
     /*  4666 */     // No operand predicates
     /*  4666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4668 */     // (and:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)  =>  (ANDI16_MMR6:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)
     /*  4668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDI16_MMR6),
     /*  4671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4673 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  4675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  4678 */     GIR_RootConstrainSelectedInstOperands,
     /*  4679 */     // GIR_Coverage, 2331,
     /*  4679 */     GIR_EraseRootFromParent_Done,
     /*  4680 */   // Label 245: @4680
     /*  4680 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(4707), // Rule ID 51 //
     /*  4685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  4688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4700 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND),
     /*  4705 */     GIR_RootConstrainSelectedInstOperands,
     /*  4706 */     // GIR_Coverage, 51,
     /*  4706 */     GIR_Done,
     /*  4707 */   // Label 246: @4707
     /*  4707 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(4734), // Rule ID 1061 //
     /*  4712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  4715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4727 */     // (and:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (AND16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  4727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND16_MM),
     /*  4732 */     GIR_RootConstrainSelectedInstOperands,
     /*  4733 */     // GIR_Coverage, 1061,
     /*  4733 */     GIR_Done,
     /*  4734 */   // Label 247: @4734
     /*  4734 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(4761), // Rule ID 1077 //
     /*  4739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  4742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4754 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_MM),
     /*  4759 */     GIR_RootConstrainSelectedInstOperands,
     /*  4760 */     // GIR_Coverage, 1077,
     /*  4760 */     GIR_Done,
     /*  4761 */   // Label 248: @4761
     /*  4761 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(4788), // Rule ID 1170 //
     /*  4766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4781 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_MMR6),
     /*  4786 */     GIR_RootConstrainSelectedInstOperands,
     /*  4787 */     // GIR_Coverage, 1170,
     /*  4787 */     GIR_Done,
     /*  4788 */   // Label 249: @4788
     /*  4788 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(4815), // Rule ID 1828 //
     /*  4793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  4796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4808 */     // (and:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (AndRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  4808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AndRxRxRy16),
     /*  4813 */     GIR_RootConstrainSelectedInstOperands,
     /*  4814 */     // GIR_Coverage, 1828,
     /*  4814 */     GIR_Done,
     /*  4815 */   // Label 250: @4815
     /*  4815 */   GIM_Reject,
     /*  4816 */ // Label 242: @4816
     /*  4816 */ GIM_Reject,
     /*  4817 */ // Label 236: @4817
     /*  4817 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(4918),
     /*  4822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4832 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(4894), // Rule ID 269 //
     /*  4837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /*  4840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  4844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  4848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  4852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  4856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4866 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  4877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4879 */     // (and:{ *:[i64] } (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt), 255:{ *:[i64] })  =>  (BADDu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BADDu),
     /*  4882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  4888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  4892 */     GIR_RootConstrainSelectedInstOperands,
     /*  4893 */     // GIR_Coverage, 269,
     /*  4893 */     GIR_EraseRootFromParent_Done,
     /*  4894 */   // Label 252: @4894
     /*  4894 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(4917), // Rule ID 206 //
     /*  4899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  4902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4910 */     // (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (AND64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND64),
     /*  4915 */     GIR_RootConstrainSelectedInstOperands,
     /*  4916 */     // GIR_Coverage, 206,
     /*  4916 */     GIR_Done,
     /*  4917 */   // Label 253: @4917
     /*  4917 */   GIM_Reject,
     /*  4918 */ // Label 251: @4918
     /*  4918 */ GIM_Reject,
     /*  4919 */ // Label 237: @4919
     /*  4919 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(4952), // Rule ID 518 //
     /*  4924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4945 */   // (and:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AND_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_D_PSEUDO),
     /*  4950 */   GIR_RootConstrainSelectedInstOperands,
     /*  4951 */   // GIR_Coverage, 518,
     /*  4951 */   GIR_Done,
     /*  4952 */ // Label 254: @4952
     /*  4952 */ GIM_Reject,
     /*  4953 */ // Label 238: @4953
     /*  4953 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(4986), // Rule ID 517 //
     /*  4958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4979 */   // (and:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AND_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_W_PSEUDO),
     /*  4984 */   GIR_RootConstrainSelectedInstOperands,
     /*  4985 */   // GIR_Coverage, 517,
     /*  4985 */   GIR_Done,
     /*  4986 */ // Label 255: @4986
     /*  4986 */ GIM_Reject,
     /*  4987 */ // Label 239: @4987
     /*  4987 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(5020), // Rule ID 516 //
     /*  4992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  5001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5013 */   // (and:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AND_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  5013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_H_PSEUDO),
     /*  5018 */   GIR_RootConstrainSelectedInstOperands,
     /*  5019 */   // GIR_Coverage, 516,
     /*  5019 */   GIR_Done,
     /*  5020 */ // Label 256: @5020
     /*  5020 */ GIM_Reject,
     /*  5021 */ // Label 240: @5021
     /*  5021 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(5054), // Rule ID 515 //
     /*  5026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  5032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  5035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5047 */   // (and:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AND_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  5047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V),
     /*  5052 */   GIR_RootConstrainSelectedInstOperands,
     /*  5053 */   // GIR_Coverage, 515,
     /*  5053 */   GIR_Done,
     /*  5054 */ // Label 257: @5054
     /*  5054 */ GIM_Reject,
     /*  5055 */ // Label 241: @5055
     /*  5055 */ GIM_Reject,
     /*  5056 */ // Label 8: @5056
     /*  5056 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 264*/ GIMT_Encode4(5459),
     /*  5067 */ /*GILLT_s32*//*Label 258*/ GIMT_Encode4(5099),
     /*  5071 */ /*GILLT_s64*//*Label 259*/ GIMT_Encode4(5289), GIMT_Encode4(0),
     /*  5079 */ /*GILLT_v2s64*//*Label 260*/ GIMT_Encode4(5323), GIMT_Encode4(0),
     /*  5087 */ /*GILLT_v4s32*//*Label 261*/ GIMT_Encode4(5357),
     /*  5091 */ /*GILLT_v8s16*//*Label 262*/ GIMT_Encode4(5391),
     /*  5095 */ /*GILLT_v16s8*//*Label 263*/ GIMT_Encode4(5425),
     /*  5099 */ // Label 258: @5099
     /*  5099 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5288),
     /*  5104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  5107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  5110 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5152), // Rule ID 42 //
     /*  5115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5134 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  5138 */     // MIs[1] Operand 1
     /*  5138 */     // No operand predicates
     /*  5138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5140 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (ORi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  5140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ORi),
     /*  5143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  5150 */     GIR_RootConstrainSelectedInstOperands,
     /*  5151 */     // GIR_Coverage, 42,
     /*  5151 */     GIR_EraseRootFromParent_Done,
     /*  5152 */   // Label 266: @5152
     /*  5152 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(5179), // Rule ID 52 //
     /*  5157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5172 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR),
     /*  5177 */     GIR_RootConstrainSelectedInstOperands,
     /*  5178 */     // GIR_Coverage, 52,
     /*  5178 */     GIR_Done,
     /*  5179 */   // Label 267: @5179
     /*  5179 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(5206), // Rule ID 1063 //
     /*  5184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5199 */     // (or:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (OR16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  5199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR16_MM),
     /*  5204 */     GIR_RootConstrainSelectedInstOperands,
     /*  5205 */     // GIR_Coverage, 1063,
     /*  5205 */     GIR_Done,
     /*  5206 */   // Label 268: @5206
     /*  5206 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(5233), // Rule ID 1078 //
     /*  5211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5226 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_MM),
     /*  5231 */     GIR_RootConstrainSelectedInstOperands,
     /*  5232 */     // GIR_Coverage, 1078,
     /*  5232 */     GIR_Done,
     /*  5233 */   // Label 269: @5233
     /*  5233 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(5260), // Rule ID 1183 //
     /*  5238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5253 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_MMR6),
     /*  5258 */     GIR_RootConstrainSelectedInstOperands,
     /*  5259 */     // GIR_Coverage, 1183,
     /*  5259 */     GIR_Done,
     /*  5260 */   // Label 270: @5260
     /*  5260 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(5287), // Rule ID 1830 //
     /*  5265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  5268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5280 */     // (or:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (OrRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  5280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OrRxRxRy16),
     /*  5285 */     GIR_RootConstrainSelectedInstOperands,
     /*  5286 */     // GIR_Coverage, 1830,
     /*  5286 */     GIR_Done,
     /*  5287 */   // Label 271: @5287
     /*  5287 */   GIM_Reject,
     /*  5288 */ // Label 265: @5288
     /*  5288 */ GIM_Reject,
     /*  5289 */ // Label 259: @5289
     /*  5289 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(5322), // Rule ID 207 //
     /*  5294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  5297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  5300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  5303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5315 */   // (or:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (OR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  5315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /*  5320 */   GIR_RootConstrainSelectedInstOperands,
     /*  5321 */   // GIR_Coverage, 207,
     /*  5321 */   GIR_Done,
     /*  5322 */ // Label 272: @5322
     /*  5322 */ GIM_Reject,
     /*  5323 */ // Label 260: @5323
     /*  5323 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(5356), // Rule ID 924 //
     /*  5328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  5334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  5337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5349 */   // (or:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (OR_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  5349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_D_PSEUDO),
     /*  5354 */   GIR_RootConstrainSelectedInstOperands,
     /*  5355 */   // GIR_Coverage, 924,
     /*  5355 */   GIR_Done,
     /*  5356 */ // Label 273: @5356
     /*  5356 */ GIM_Reject,
     /*  5357 */ // Label 261: @5357
     /*  5357 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(5390), // Rule ID 923 //
     /*  5362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  5368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  5371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5383 */   // (or:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (OR_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  5383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_W_PSEUDO),
     /*  5388 */   GIR_RootConstrainSelectedInstOperands,
     /*  5389 */   // GIR_Coverage, 923,
     /*  5389 */   GIR_Done,
     /*  5390 */ // Label 274: @5390
     /*  5390 */ GIM_Reject,
     /*  5391 */ // Label 262: @5391
     /*  5391 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(5424), // Rule ID 922 //
     /*  5396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  5402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  5405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5417 */   // (or:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (OR_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  5417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_H_PSEUDO),
     /*  5422 */   GIR_RootConstrainSelectedInstOperands,
     /*  5423 */   // GIR_Coverage, 922,
     /*  5423 */   GIR_Done,
     /*  5424 */ // Label 275: @5424
     /*  5424 */ GIM_Reject,
     /*  5425 */ // Label 263: @5425
     /*  5425 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(5458), // Rule ID 921 //
     /*  5430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  5436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  5439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5451 */   // (or:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (OR_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  5451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V),
     /*  5456 */   GIR_RootConstrainSelectedInstOperands,
     /*  5457 */   // GIR_Coverage, 921,
     /*  5457 */   GIR_Done,
     /*  5458 */ // Label 276: @5458
     /*  5458 */ GIM_Reject,
     /*  5459 */ // Label 264: @5459
     /*  5459 */ GIM_Reject,
     /*  5460 */ // Label 9: @5460
     /*  5460 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 283*/ GIMT_Encode4(6351),
     /*  5471 */ /*GILLT_s32*//*Label 277*/ GIMT_Encode4(5503),
     /*  5475 */ /*GILLT_s64*//*Label 278*/ GIMT_Encode4(6120), GIMT_Encode4(0),
     /*  5483 */ /*GILLT_v2s64*//*Label 279*/ GIMT_Encode4(6215), GIMT_Encode4(0),
     /*  5491 */ /*GILLT_v4s32*//*Label 280*/ GIMT_Encode4(6249),
     /*  5495 */ /*GILLT_v8s16*//*Label 281*/ GIMT_Encode4(6283),
     /*  5499 */ /*GILLT_v16s8*//*Label 282*/ GIMT_Encode4(6317),
     /*  5503 */ // Label 277: @5503
     /*  5503 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(6119),
     /*  5508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  5511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  5514 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(5573), // Rule ID 54 //
     /*  5519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5558 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /*  5561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5571 */     GIR_RootConstrainSelectedInstOperands,
     /*  5572 */     // GIR_Coverage, 54,
     /*  5572 */     GIR_EraseRootFromParent_Done,
     /*  5573 */   // Label 285: @5573
     /*  5573 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(5632), // Rule ID 1080 //
     /*  5578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5617 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MM),
     /*  5620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5630 */     GIR_RootConstrainSelectedInstOperands,
     /*  5631 */     // GIR_Coverage, 1080,
     /*  5631 */     GIR_EraseRootFromParent_Done,
     /*  5632 */   // Label 286: @5632
     /*  5632 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(5691), // Rule ID 1182 //
     /*  5637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5676 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /*  5679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5689 */     GIR_RootConstrainSelectedInstOperands,
     /*  5690 */     // GIR_Coverage, 1182,
     /*  5690 */     GIR_EraseRootFromParent_Done,
     /*  5691 */   // Label 287: @5691
     /*  5691 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(5720), // Rule ID 1209 //
     /*  5696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5711 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] })  =>  (NOT16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs)
     /*  5711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MMR6),
     /*  5714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5718 */     GIR_RootConstrainSelectedInstOperands,
     /*  5719 */     // GIR_Coverage, 1209,
     /*  5719 */     GIR_EraseRootFromParent_Done,
     /*  5720 */   // Label 288: @5720
     /*  5720 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(5749), // Rule ID 1062 //
     /*  5725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5740 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] })  =>  (NOT16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs)
     /*  5740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MM),
     /*  5743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5747 */     GIR_RootConstrainSelectedInstOperands,
     /*  5748 */     // GIR_Coverage, 1062,
     /*  5748 */     GIR_EraseRootFromParent_Done,
     /*  5749 */   // Label 289: @5749
     /*  5749 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(5784), // Rule ID 1397 //
     /*  5754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5769 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /*  5772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5774 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5782 */     GIR_RootConstrainSelectedInstOperands,
     /*  5783 */     // GIR_Coverage, 1397,
     /*  5783 */     GIR_EraseRootFromParent_Done,
     /*  5784 */   // Label 290: @5784
     /*  5784 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(5813), // Rule ID 1825 //
     /*  5789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  5792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5804 */     // (xor:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, -1:{ *:[i32] })  =>  (NotRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r)
     /*  5804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NotRxRy16),
     /*  5807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /*  5809 */     GIR_RootToRootCopy, /*OpIdx*/1, // r
     /*  5811 */     GIR_RootConstrainSelectedInstOperands,
     /*  5812 */     // GIR_Coverage, 1825,
     /*  5812 */     GIR_EraseRootFromParent_Done,
     /*  5813 */   // Label 291: @5813
     /*  5813 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(5842), // Rule ID 2167 //
     /*  5818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  5821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5833 */     // (xor:{ *:[i32] } GPRMM16:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOT16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$in)
     /*  5833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MM),
     /*  5836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5838 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5840 */     GIR_RootConstrainSelectedInstOperands,
     /*  5841 */     // GIR_Coverage, 2167,
     /*  5841 */     GIR_EraseRootFromParent_Done,
     /*  5842 */   // Label 292: @5842
     /*  5842 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(5877), // Rule ID 2168 //
     /*  5847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  5850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5862 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MM),
     /*  5865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5867 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5875 */     GIR_RootConstrainSelectedInstOperands,
     /*  5876 */     // GIR_Coverage, 2168,
     /*  5876 */     GIR_EraseRootFromParent_Done,
     /*  5877 */   // Label 293: @5877
     /*  5877 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(5906), // Rule ID 2334 //
     /*  5882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5897 */     // (xor:{ *:[i32] } GPRMM16:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOT16_MMR6:{ *:[i32] } GPRMM16:{ *:[i32] }:$in)
     /*  5897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MMR6),
     /*  5900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5902 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5904 */     GIR_RootConstrainSelectedInstOperands,
     /*  5905 */     // GIR_Coverage, 2334,
     /*  5905 */     GIR_EraseRootFromParent_Done,
     /*  5906 */   // Label 294: @5906
     /*  5906 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(5941), // Rule ID 2335 //
     /*  5911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5926 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /*  5929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5931 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5939 */     GIR_RootConstrainSelectedInstOperands,
     /*  5940 */     // GIR_Coverage, 2335,
     /*  5940 */     GIR_EraseRootFromParent_Done,
     /*  5941 */   // Label 295: @5941
     /*  5941 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(5983), // Rule ID 43 //
     /*  5946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5965 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  5969 */     // MIs[1] Operand 1
     /*  5969 */     // No operand predicates
     /*  5969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5971 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (XORi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  5971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /*  5974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  5981 */     GIR_RootConstrainSelectedInstOperands,
     /*  5982 */     // GIR_Coverage, 43,
     /*  5982 */     GIR_EraseRootFromParent_Done,
     /*  5983 */   // Label 296: @5983
     /*  5983 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(6010), // Rule ID 53 //
     /*  5988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6003 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  6003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /*  6008 */     GIR_RootConstrainSelectedInstOperands,
     /*  6009 */     // GIR_Coverage, 53,
     /*  6009 */     GIR_Done,
     /*  6010 */   // Label 297: @6010
     /*  6010 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(6037), // Rule ID 1065 //
     /*  6015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  6018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6030 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (XOR16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  6030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR16_MM),
     /*  6035 */     GIR_RootConstrainSelectedInstOperands,
     /*  6036 */     // GIR_Coverage, 1065,
     /*  6036 */     GIR_Done,
     /*  6037 */   // Label 298: @6037
     /*  6037 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(6064), // Rule ID 1079 //
     /*  6042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  6045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6057 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  6057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /*  6062 */     GIR_RootConstrainSelectedInstOperands,
     /*  6063 */     // GIR_Coverage, 1079,
     /*  6063 */     GIR_Done,
     /*  6064 */   // Label 299: @6064
     /*  6064 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(6091), // Rule ID 1186 //
     /*  6069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  6072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6084 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  6084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_MMR6),
     /*  6089 */     GIR_RootConstrainSelectedInstOperands,
     /*  6090 */     // GIR_Coverage, 1186,
     /*  6090 */     GIR_Done,
     /*  6091 */   // Label 300: @6091
     /*  6091 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(6118), // Rule ID 1832 //
     /*  6096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  6099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6111 */     // (xor:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  6111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /*  6116 */     GIR_RootConstrainSelectedInstOperands,
     /*  6117 */     // GIR_Coverage, 1832,
     /*  6117 */     GIR_Done,
     /*  6118 */   // Label 301: @6118
     /*  6118 */   GIM_Reject,
     /*  6119 */ // Label 284: @6119
     /*  6119 */ GIM_Reject,
     /*  6120 */ // Label 278: @6120
     /*  6120 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(6214),
     /*  6125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  6128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  6131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6135 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(6190), // Rule ID 209 //
     /*  6140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  6143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  6147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  6151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  6155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  6159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  6173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  6175 */     // (xor:{ *:[i64] } (or:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt), -1:{ *:[i64] })  =>  (NOR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  6175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR64),
     /*  6178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  6180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  6184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  6188 */     GIR_RootConstrainSelectedInstOperands,
     /*  6189 */     // GIR_Coverage, 209,
     /*  6189 */     GIR_EraseRootFromParent_Done,
     /*  6190 */   // Label 303: @6190
     /*  6190 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(6213), // Rule ID 208 //
     /*  6195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  6198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6206 */     // (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (XOR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  6206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /*  6211 */     GIR_RootConstrainSelectedInstOperands,
     /*  6212 */     // GIR_Coverage, 208,
     /*  6212 */     GIR_Done,
     /*  6213 */   // Label 304: @6213
     /*  6213 */   GIM_Reject,
     /*  6214 */ // Label 302: @6214
     /*  6214 */ GIM_Reject,
     /*  6215 */ // Label 279: @6215
     /*  6215 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(6248), // Rule ID 1040 //
     /*  6220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  6226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  6229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6241 */   // (xor:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (XOR_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  6241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_D_PSEUDO),
     /*  6246 */   GIR_RootConstrainSelectedInstOperands,
     /*  6247 */   // GIR_Coverage, 1040,
     /*  6247 */   GIR_Done,
     /*  6248 */ // Label 305: @6248
     /*  6248 */ GIM_Reject,
     /*  6249 */ // Label 280: @6249
     /*  6249 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(6282), // Rule ID 1039 //
     /*  6254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  6260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  6263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6275 */   // (xor:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (XOR_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  6275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_W_PSEUDO),
     /*  6280 */   GIR_RootConstrainSelectedInstOperands,
     /*  6281 */   // GIR_Coverage, 1039,
     /*  6281 */   GIR_Done,
     /*  6282 */ // Label 306: @6282
     /*  6282 */ GIM_Reject,
     /*  6283 */ // Label 281: @6283
     /*  6283 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(6316), // Rule ID 1038 //
     /*  6288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  6294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  6297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6309 */   // (xor:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (XOR_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  6309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_H_PSEUDO),
     /*  6314 */   GIR_RootConstrainSelectedInstOperands,
     /*  6315 */   // GIR_Coverage, 1038,
     /*  6315 */   GIR_Done,
     /*  6316 */ // Label 307: @6316
     /*  6316 */ GIM_Reject,
     /*  6317 */ // Label 282: @6317
     /*  6317 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(6350), // Rule ID 1037 //
     /*  6322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  6328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  6331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6343 */   // (xor:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (XOR_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  6343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V),
     /*  6348 */   GIR_RootConstrainSelectedInstOperands,
     /*  6349 */   // GIR_Coverage, 1037,
     /*  6349 */   GIR_Done,
     /*  6350 */ // Label 308: @6350
     /*  6350 */ GIM_Reject,
     /*  6351 */ // Label 283: @6351
     /*  6351 */ GIM_Reject,
     /*  6352 */ // Label 10: @6352
     /*  6352 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(6424),
     /*  6357 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  6360 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  6363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  6369 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(6396), // Rule ID 180 //
     /*  6374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotSoftFloat_NotFP64bit_NotInMips16Mode),
     /*  6377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /*  6381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6389 */     // (MipsBuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)  =>  (BuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)
     /*  6389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BuildPairF64),
     /*  6394 */     GIR_RootConstrainSelectedInstOperands,
     /*  6395 */     // GIR_Coverage, 180,
     /*  6395 */     GIR_Done,
     /*  6396 */   // Label 310: @6396
     /*  6396 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(6423), // Rule ID 181 //
     /*  6401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit_IsNotSoftFloat_NotInMips16Mode),
     /*  6404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  6408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6416 */     // (MipsBuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)  =>  (BuildPairF64_64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)
     /*  6416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BuildPairF64_64),
     /*  6421 */     GIR_RootConstrainSelectedInstOperands,
     /*  6422 */     // GIR_Coverage, 181,
     /*  6422 */     GIR_Done,
     /*  6423 */   // Label 311: @6423
     /*  6423 */   GIM_Reject,
     /*  6424 */ // Label 309: @6424
     /*  6424 */ GIM_Reject,
     /*  6425 */ // Label 11: @6425
     /*  6425 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(6496),
     /*  6430 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  6433 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  6436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  6439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6443 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(6469), // Rule ID 719 //
     /*  6448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  6451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6455 */     // MIs[0] rs
     /*  6455 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6460 */     // (build_vector:{ *:[v2i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rs)  =>  (FILL_D:{ *:[v2i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /*  6460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_D),
     /*  6463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6467 */     GIR_RootConstrainSelectedInstOperands,
     /*  6468 */     // GIR_Coverage, 719,
     /*  6468 */     GIR_EraseRootFromParent_Done,
     /*  6469 */   // Label 313: @6469
     /*  6469 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(6495), // Rule ID 721 //
     /*  6474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  6481 */     // MIs[0] fs
     /*  6481 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6486 */     // (build_vector:{ *:[v2f64] } FGR64:{ *:[f64] }:$fs, FGR64:{ *:[f64] }:$fs)  =>  (FILL_FD_PSEUDO:{ *:[v2f64] } FGR64:{ *:[f64] }:$fs)
     /*  6486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_FD_PSEUDO),
     /*  6489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6491 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /*  6493 */     GIR_RootConstrainSelectedInstOperands,
     /*  6494 */     // GIR_Coverage, 721,
     /*  6494 */     GIR_EraseRootFromParent_Done,
     /*  6495 */   // Label 314: @6495
     /*  6495 */   GIM_Reject,
     /*  6496 */ // Label 312: @6496
     /*  6496 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(6587),
     /*  6501 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  6504 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  6507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6514 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(6550), // Rule ID 718 //
     /*  6519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6526 */     // MIs[0] rs
     /*  6526 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6531 */     // MIs[0] rs
     /*  6531 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6536 */     // MIs[0] rs
     /*  6536 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6541 */     // (build_vector:{ *:[v4i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_W:{ *:[v4i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_W),
     /*  6544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6548 */     GIR_RootConstrainSelectedInstOperands,
     /*  6549 */     // GIR_Coverage, 718,
     /*  6549 */     GIR_EraseRootFromParent_Done,
     /*  6550 */   // Label 316: @6550
     /*  6550 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(6586), // Rule ID 720 //
     /*  6555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6562 */     // MIs[0] fs
     /*  6562 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6567 */     // MIs[0] fs
     /*  6567 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6572 */     // MIs[0] fs
     /*  6572 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6577 */     // (build_vector:{ *:[v4f32] } FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs)  =>  (FILL_FW_PSEUDO:{ *:[v4f32] } FGR32:{ *:[f32] }:$fs)
     /*  6577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_FW_PSEUDO),
     /*  6580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6582 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /*  6584 */     GIR_RootConstrainSelectedInstOperands,
     /*  6585 */     // GIR_Coverage, 720,
     /*  6585 */     GIR_EraseRootFromParent_Done,
     /*  6586 */   // Label 317: @6586
     /*  6586 */   GIM_Reject,
     /*  6587 */ // Label 315: @6587
     /*  6587 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(6656), // Rule ID 717 //
     /*  6592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6595 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /*  6598 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  6601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6612 */   // MIs[0] rs
     /*  6612 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6617 */   // MIs[0] rs
     /*  6617 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6622 */   // MIs[0] rs
     /*  6622 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6627 */   // MIs[0] rs
     /*  6627 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6632 */   // MIs[0] rs
     /*  6632 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6637 */   // MIs[0] rs
     /*  6637 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6642 */   // MIs[0] rs
     /*  6642 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6647 */   // (build_vector:{ *:[v8i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_H:{ *:[v8i16] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_H),
     /*  6650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6652 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6654 */   GIR_RootConstrainSelectedInstOperands,
     /*  6655 */   // GIR_Coverage, 717,
     /*  6655 */   GIR_EraseRootFromParent_Done,
     /*  6656 */ // Label 318: @6656
     /*  6656 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(6765), // Rule ID 716 //
     /*  6661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6664 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/17,
     /*  6667 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  6670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6681 */   // MIs[0] rs
     /*  6681 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6686 */   // MIs[0] rs
     /*  6686 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6691 */   // MIs[0] rs
     /*  6691 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6696 */   // MIs[0] rs
     /*  6696 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6701 */   // MIs[0] rs
     /*  6701 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6706 */   // MIs[0] rs
     /*  6706 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6711 */   // MIs[0] rs
     /*  6711 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6716 */   // MIs[0] rs
     /*  6716 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/9, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6721 */   // MIs[0] rs
     /*  6721 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/10, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6726 */   // MIs[0] rs
     /*  6726 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/11, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6731 */   // MIs[0] rs
     /*  6731 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/12, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6736 */   // MIs[0] rs
     /*  6736 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/13, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6741 */   // MIs[0] rs
     /*  6741 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/14, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6746 */   // MIs[0] rs
     /*  6746 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/15, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6751 */   // MIs[0] rs
     /*  6751 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/16, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6756 */   // (build_vector:{ *:[v16i8] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_B:{ *:[v16i8] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_B),
     /*  6759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6761 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6763 */   GIR_RootConstrainSelectedInstOperands,
     /*  6764 */   // GIR_Coverage, 716,
     /*  6764 */   GIR_EraseRootFromParent_Done,
     /*  6765 */ // Label 319: @6765
     /*  6765 */ GIM_Reject,
     /*  6766 */ // Label 12: @6766
     /*  6766 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 328*/ GIMT_Encode4(11076),
     /*  6777 */ /*GILLT_s32*//*Label 320*/ GIMT_Encode4(6809),
     /*  6781 */ /*GILLT_s64*//*Label 321*/ GIMT_Encode4(7086),
     /*  6785 */ /*GILLT_v2s16*//*Label 322*/ GIMT_Encode4(7142),
     /*  6789 */ /*GILLT_v2s64*//*Label 323*/ GIMT_Encode4(7202),
     /*  6793 */ /*GILLT_v4s8*//*Label 324*/ GIMT_Encode4(8337),
     /*  6797 */ /*GILLT_v4s32*//*Label 325*/ GIMT_Encode4(8397),
     /*  6801 */ /*GILLT_v8s16*//*Label 326*/ GIMT_Encode4(9466),
     /*  6805 */ /*GILLT_v16s8*//*Label 327*/ GIMT_Encode4(10391),
     /*  6809 */ // Label 320: @6809
     /*  6809 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(6835), // Rule ID 135 //
     /*  6814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  6817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6828 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1),
     /*  6833 */   GIR_RootConstrainSelectedInstOperands,
     /*  6834 */   // GIR_Coverage, 135,
     /*  6834 */   GIR_Done,
     /*  6835 */ // Label 329: @6835
     /*  6835 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(6861), // Rule ID 136 //
     /*  6840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  6843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6854 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1),
     /*  6859 */   GIR_RootConstrainSelectedInstOperands,
     /*  6860 */   // GIR_Coverage, 136,
     /*  6860 */   GIR_Done,
     /*  6861 */ // Label 330: @6861
     /*  6861 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(6887), // Rule ID 1160 //
     /*  6866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /*  6869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6880 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1_MM:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1_MM),
     /*  6885 */   GIR_RootConstrainSelectedInstOperands,
     /*  6886 */   // GIR_Coverage, 1160,
     /*  6886 */   GIR_Done,
     /*  6887 */ // Label 331: @6887
     /*  6887 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(6913), // Rule ID 1161 //
     /*  6892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /*  6895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6906 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1_MM:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1_MM),
     /*  6911 */   GIR_RootConstrainSelectedInstOperands,
     /*  6912 */   // GIR_Coverage, 1161,
     /*  6912 */   GIR_Done,
     /*  6913 */ // Label 332: @6913
     /*  6913 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(6939), // Rule ID 1175 //
     /*  6918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /*  6921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6932 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1_MMR6:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1_MMR6),
     /*  6937 */   GIR_RootConstrainSelectedInstOperands,
     /*  6938 */   // GIR_Coverage, 1175,
     /*  6938 */   GIR_Done,
     /*  6939 */ // Label 333: @6939
     /*  6939 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(6965), // Rule ID 1176 //
     /*  6944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /*  6947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6958 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1_MMR6),
     /*  6963 */   GIR_RootConstrainSelectedInstOperands,
     /*  6964 */   // GIR_Coverage, 1176,
     /*  6964 */   GIR_Done,
     /*  6965 */ // Label 334: @6965
     /*  6965 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(6995), // Rule ID 1913 //
     /*  6970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  6973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  6976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  6984 */   // (bitconvert:{ *:[i32] } DSPR:{ *:[v2i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } DSPR:{ *:[v2i16] }:$src, GPR32:{ *:[i32] })
     /*  6984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6994 */   // GIR_Coverage, 1913,
     /*  6994 */   GIR_Done,
     /*  6995 */ // Label 335: @6995
     /*  6995 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(7025), // Rule ID 1914 //
     /*  7000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  7006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7014 */   // (bitconvert:{ *:[i32] } DSPR:{ *:[v4i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } DSPR:{ *:[v4i8] }:$src, GPR32:{ *:[i32] })
     /*  7014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7024 */   // GIR_Coverage, 1914,
     /*  7024 */   GIR_Done,
     /*  7025 */ // Label 336: @7025
     /*  7025 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(7055), // Rule ID 1917 //
     /*  7030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  7036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7044 */   // (bitconvert:{ *:[f32] } DSPR:{ *:[v2i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } DSPR:{ *:[v2i16] }:$src, FGR32:{ *:[i32] })
     /*  7044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7054 */   // GIR_Coverage, 1917,
     /*  7054 */   GIR_Done,
     /*  7055 */ // Label 337: @7055
     /*  7055 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(7085), // Rule ID 1918 //
     /*  7060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  7066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7074 */   // (bitconvert:{ *:[f32] } DSPR:{ *:[v4i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } DSPR:{ *:[v4i8] }:$src, FGR32:{ *:[i32] })
     /*  7074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7084 */   // GIR_Coverage, 1918,
     /*  7084 */   GIR_Done,
     /*  7085 */ // Label 338: @7085
     /*  7085 */ GIM_Reject,
     /*  7086 */ // Label 321: @7086
     /*  7086 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(7141),
     /*  7091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  7094 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(7117), // Rule ID 137 //
     /*  7099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  7102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  7106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  7110 */     // (bitconvert:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMTC1:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$rt)
     /*  7110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMTC1),
     /*  7115 */     GIR_RootConstrainSelectedInstOperands,
     /*  7116 */     // GIR_Coverage, 137,
     /*  7116 */     GIR_Done,
     /*  7117 */   // Label 340: @7117
     /*  7117 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(7140), // Rule ID 138 //
     /*  7122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  7125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  7129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  7133 */     // (bitconvert:{ *:[i64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (DMFC1:{ *:[i64] } FGR64Opnd:{ *:[f64] }:$fs)
     /*  7133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMFC1),
     /*  7138 */     GIR_RootConstrainSelectedInstOperands,
     /*  7139 */     // GIR_Coverage, 138,
     /*  7139 */     GIR_Done,
     /*  7140 */   // Label 341: @7140
     /*  7140 */   GIM_Reject,
     /*  7141 */ // Label 339: @7141
     /*  7141 */ GIM_Reject,
     /*  7142 */ // Label 322: @7142
     /*  7142 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(7201),
     /*  7147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  7150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7154 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(7177), // Rule ID 1915 //
     /*  7159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7166 */     // (bitconvert:{ *:[v2i16] } GPR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } GPR32:{ *:[i32] }:$src, DSPR:{ *:[i32] })
     /*  7166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7176 */     // GIR_Coverage, 1915,
     /*  7176 */     GIR_Done,
     /*  7177 */   // Label 343: @7177
     /*  7177 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(7200), // Rule ID 1919 //
     /*  7182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7189 */     // (bitconvert:{ *:[v2i16] } FGR32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } FGR32:{ *:[f32] }:$src, DSPR:{ *:[i32] })
     /*  7189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7199 */     // GIR_Coverage, 1919,
     /*  7199 */     GIR_Done,
     /*  7200 */   // Label 344: @7200
     /*  7200 */   GIM_Reject,
     /*  7201 */ // Label 342: @7201
     /*  7201 */ GIM_Reject,
     /*  7202 */ // Label 323: @7202
     /*  7202 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(7228), // Rule ID 2000 //
     /*  7207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  7210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  7213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7217 */   // (bitconvert:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$src, MSA128D:{ *:[i32] })
     /*  7217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7227 */   // GIR_Coverage, 2000,
     /*  7227 */   GIR_Done,
     /*  7228 */ // Label 345: @7228
     /*  7228 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(7254), // Rule ID 2003 //
     /*  7233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  7236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  7239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7243 */   // (bitconvert:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$src, MSA128D:{ *:[i32] })
     /*  7243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7253 */   // GIR_Coverage, 2003,
     /*  7253 */   GIR_Done,
     /*  7254 */ // Label 346: @7254
     /*  7254 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(7280), // Rule ID 2020 //
     /*  7259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7269 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src, MSA128D:{ *:[i32] })
     /*  7269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7274 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7279 */   // GIR_Coverage, 2020,
     /*  7279 */   GIR_Done,
     /*  7280 */ // Label 347: @7280
     /*  7280 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(7306), // Rule ID 2021 //
     /*  7285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7295 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src, MSA128D:{ *:[i32] })
     /*  7295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7305 */   // GIR_Coverage, 2021,
     /*  7305 */   GIR_Done,
     /*  7306 */ // Label 348: @7306
     /*  7306 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(7332), // Rule ID 2022 //
     /*  7311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7321 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src, MSA128D:{ *:[i32] })
     /*  7321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7326 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7331 */   // GIR_Coverage, 2022,
     /*  7331 */   GIR_Done,
     /*  7332 */ // Label 349: @7332
     /*  7332 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(7358), // Rule ID 2023 //
     /*  7337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7347 */   // (bitconvert:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src, MSA128D:{ *:[i32] })
     /*  7347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7357 */   // GIR_Coverage, 2023,
     /*  7357 */   GIR_Done,
     /*  7358 */ // Label 350: @7358
     /*  7358 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(7384), // Rule ID 2024 //
     /*  7363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7373 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src, MSA128D:{ *:[i32] })
     /*  7373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7383 */   // GIR_Coverage, 2024,
     /*  7383 */   GIR_Done,
     /*  7384 */ // Label 351: @7384
     /*  7384 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(7410), // Rule ID 2030 //
     /*  7389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7399 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src, MSA128D:{ *:[i32] })
     /*  7399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7404 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7409 */   // GIR_Coverage, 2030,
     /*  7409 */   GIR_Done,
     /*  7410 */ // Label 352: @7410
     /*  7410 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(7436), // Rule ID 2031 //
     /*  7415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7425 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src, MSA128D:{ *:[i32] })
     /*  7425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7435 */   // GIR_Coverage, 2031,
     /*  7435 */   GIR_Done,
     /*  7436 */ // Label 353: @7436
     /*  7436 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(7462), // Rule ID 2032 //
     /*  7441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7451 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src, MSA128D:{ *:[i32] })
     /*  7451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7456 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7461 */   // GIR_Coverage, 2032,
     /*  7461 */   GIR_Done,
     /*  7462 */ // Label 354: @7462
     /*  7462 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(7488), // Rule ID 2033 //
     /*  7467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7477 */   // (bitconvert:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src, MSA128D:{ *:[i32] })
     /*  7477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7482 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7487 */   // GIR_Coverage, 2033,
     /*  7487 */   GIR_Done,
     /*  7488 */ // Label 355: @7488
     /*  7488 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(7514), // Rule ID 2034 //
     /*  7493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7503 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src, MSA128D:{ *:[i32] })
     /*  7503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7513 */   // GIR_Coverage, 2034,
     /*  7513 */   GIR_Done,
     /*  7514 */ // Label 356: @7514
     /*  7514 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(7631), // Rule ID 2039 //
     /*  7519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7529 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7529 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /*  7532 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7536 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7541 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7545 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  7550 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  7553 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  7557 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7562 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  7565 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /*  7568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  7570 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  7573 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7577 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7582 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  7585 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  7590 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  7593 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  7597 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7602 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7605 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  7615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7630 */   // GIR_Coverage, 2039,
     /*  7630 */   GIR_EraseRootFromParent_Done,
     /*  7631 */ // Label 357: @7631
     /*  7631 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(7748), // Rule ID 2040 //
     /*  7636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7646 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7646 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /*  7649 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7653 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7658 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7662 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  7667 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  7670 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  7674 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7679 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  7682 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /*  7685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  7687 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  7690 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7694 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7699 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  7702 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  7707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  7710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  7714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7719 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7722 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  7732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7742 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7747 */   // GIR_Coverage, 2040,
     /*  7747 */   GIR_EraseRootFromParent_Done,
     /*  7748 */ // Label 358: @7748
     /*  7748 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(7818), // Rule ID 2044 //
     /*  7753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7763 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7763 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7766 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7770 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7775 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7779 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7784 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7787 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7791 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7796 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7799 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7812 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7817 */   // GIR_Coverage, 2044,
     /*  7817 */   GIR_EraseRootFromParent_Done,
     /*  7818 */ // Label 359: @7818
     /*  7818 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(7888), // Rule ID 2045 //
     /*  7823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7833 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7833 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7836 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7840 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7845 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7849 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7866 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7869 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7887 */   // GIR_Coverage, 2045,
     /*  7887 */   GIR_EraseRootFromParent_Done,
     /*  7888 */ // Label 360: @7888
     /*  7888 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(7958), // Rule ID 2049 //
     /*  7893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7903 */   // (bitconvert:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7903 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7906 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7910 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7915 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7919 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7924 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7927 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7931 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7936 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7939 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7952 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7957 */   // GIR_Coverage, 2049,
     /*  7957 */   GIR_EraseRootFromParent_Done,
     /*  7958 */ // Label 361: @7958
     /*  7958 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(8028), // Rule ID 2050 //
     /*  7963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7973 */   // (bitconvert:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7973 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7976 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7980 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7985 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7989 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  8001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8006 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8009 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8027 */   // GIR_Coverage, 2050,
     /*  8027 */   GIR_EraseRootFromParent_Done,
     /*  8028 */ // Label 362: @8028
     /*  8028 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(8105), // Rule ID 2054 //
     /*  8033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8043 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8043 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8046 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8050 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8055 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8059 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8076 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8079 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8104 */   // GIR_Coverage, 2054,
     /*  8104 */   GIR_EraseRootFromParent_Done,
     /*  8105 */ // Label 363: @8105
     /*  8105 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(8182), // Rule ID 2055 //
     /*  8110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8120 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8120 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8123 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8127 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8132 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8136 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8153 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8156 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8176 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8181 */   // GIR_Coverage, 2055,
     /*  8181 */   GIR_EraseRootFromParent_Done,
     /*  8182 */ // Label 364: @8182
     /*  8182 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(8259), // Rule ID 2059 //
     /*  8187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8197 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8197 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8200 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8204 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8209 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8213 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8230 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8233 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8258 */   // GIR_Coverage, 2059,
     /*  8258 */   GIR_EraseRootFromParent_Done,
     /*  8259 */ // Label 365: @8259
     /*  8259 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(8336), // Rule ID 2060 //
     /*  8264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8274 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8274 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8277 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8281 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8286 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8290 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8307 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8310 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8335 */   // GIR_Coverage, 2060,
     /*  8335 */   GIR_EraseRootFromParent_Done,
     /*  8336 */ // Label 366: @8336
     /*  8336 */ GIM_Reject,
     /*  8337 */ // Label 324: @8337
     /*  8337 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(8396),
     /*  8342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  8345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8349 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(8372), // Rule ID 1916 //
     /*  8354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  8357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  8361 */     // (bitconvert:{ *:[v4i8] } GPR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i8] } GPR32:{ *:[i32] }:$src, DSPR:{ *:[i32] })
     /*  8361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8371 */     // GIR_Coverage, 1916,
     /*  8371 */     GIR_Done,
     /*  8372 */   // Label 368: @8372
     /*  8372 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(8395), // Rule ID 1920 //
     /*  8377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  8380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  8384 */     // (bitconvert:{ *:[v4i8] } FGR32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i8] } FGR32:{ *:[f32] }:$src, DSPR:{ *:[i32] })
     /*  8384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8394 */     // GIR_Coverage, 1920,
     /*  8394 */     GIR_Done,
     /*  8395 */   // Label 369: @8395
     /*  8395 */   GIM_Reject,
     /*  8396 */ // Label 367: @8396
     /*  8396 */ GIM_Reject,
     /*  8397 */ // Label 325: @8397
     /*  8397 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(8423), // Rule ID 1999 //
     /*  8402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  8405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8412 */   // (bitconvert:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] })
     /*  8412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8422 */   // GIR_Coverage, 1999,
     /*  8422 */   GIR_Done,
     /*  8423 */ // Label 370: @8423
     /*  8423 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(8449), // Rule ID 2002 //
     /*  8428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  8431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8438 */   // (bitconvert:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] })
     /*  8438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8443 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8448 */   // GIR_Coverage, 2002,
     /*  8448 */   GIR_Done,
     /*  8449 */ // Label 371: @8449
     /*  8449 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(8475), // Rule ID 2015 //
     /*  8454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8464 */   // (bitconvert:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src, MSA128W:{ *:[i32] })
     /*  8464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8474 */   // GIR_Coverage, 2015,
     /*  8474 */   GIR_Done,
     /*  8475 */ // Label 372: @8475
     /*  8475 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(8501), // Rule ID 2016 //
     /*  8480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8490 */   // (bitconvert:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src, MSA128W:{ *:[i32] })
     /*  8490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8500 */   // GIR_Coverage, 2016,
     /*  8500 */   GIR_Done,
     /*  8501 */ // Label 373: @8501
     /*  8501 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(8527), // Rule ID 2017 //
     /*  8506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8516 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] })
     /*  8516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8521 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8526 */   // GIR_Coverage, 2017,
     /*  8526 */   GIR_Done,
     /*  8527 */ // Label 374: @8527
     /*  8527 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(8553), // Rule ID 2018 //
     /*  8532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8542 */   // (bitconvert:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src, MSA128W:{ *:[i32] })
     /*  8542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8552 */   // GIR_Coverage, 2018,
     /*  8552 */   GIR_Done,
     /*  8553 */ // Label 375: @8553
     /*  8553 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(8579), // Rule ID 2019 //
     /*  8558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8568 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] })
     /*  8568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8573 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8578 */   // GIR_Coverage, 2019,
     /*  8578 */   GIR_Done,
     /*  8579 */ // Label 376: @8579
     /*  8579 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(8605), // Rule ID 2025 //
     /*  8584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8594 */   // (bitconvert:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src, MSA128W:{ *:[i32] })
     /*  8594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8604 */   // GIR_Coverage, 2025,
     /*  8604 */   GIR_Done,
     /*  8605 */ // Label 377: @8605
     /*  8605 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(8631), // Rule ID 2026 //
     /*  8610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8620 */   // (bitconvert:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src, MSA128W:{ *:[i32] })
     /*  8620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8630 */   // GIR_Coverage, 2026,
     /*  8630 */   GIR_Done,
     /*  8631 */ // Label 378: @8631
     /*  8631 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(8657), // Rule ID 2027 //
     /*  8636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8646 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] })
     /*  8646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8651 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8656 */   // GIR_Coverage, 2027,
     /*  8656 */   GIR_Done,
     /*  8657 */ // Label 379: @8657
     /*  8657 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(8683), // Rule ID 2028 //
     /*  8662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8672 */   // (bitconvert:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src, MSA128W:{ *:[i32] })
     /*  8672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8682 */   // GIR_Coverage, 2028,
     /*  8682 */   GIR_Done,
     /*  8683 */ // Label 380: @8683
     /*  8683 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(8709), // Rule ID 2029 //
     /*  8688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8698 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] })
     /*  8698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8703 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8708 */   // GIR_Coverage, 2029,
     /*  8708 */   GIR_Done,
     /*  8709 */ // Label 381: @8709
     /*  8709 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(8779), // Rule ID 2037 //
     /*  8714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8724 */   // (bitconvert:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8724 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  8727 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8731 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8736 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8740 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  8745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  8748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  8752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8757 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8760 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8770 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8778 */   // GIR_Coverage, 2037,
     /*  8778 */   GIR_EraseRootFromParent_Done,
     /*  8779 */ // Label 382: @8779
     /*  8779 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(8849), // Rule ID 2038 //
     /*  8784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8794 */   // (bitconvert:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8794 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  8797 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8801 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8806 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8810 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  8815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  8818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  8822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8827 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8830 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8848 */   // GIR_Coverage, 2038,
     /*  8848 */   GIR_EraseRootFromParent_Done,
     /*  8849 */ // Label 383: @8849
     /*  8849 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(8926), // Rule ID 2042 //
     /*  8854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8864 */   // (bitconvert:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8864 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  8867 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8871 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8876 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8880 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  8885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  8888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  8892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8897 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8900 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8925 */   // GIR_Coverage, 2042,
     /*  8925 */   GIR_EraseRootFromParent_Done,
     /*  8926 */ // Label 384: @8926
     /*  8926 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(9003), // Rule ID 2043 //
     /*  8931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8941 */   // (bitconvert:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8941 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  8944 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8948 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8953 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8957 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  8962 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  8965 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  8969 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8974 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8977 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9002 */   // GIR_Coverage, 2043,
     /*  9002 */   GIR_EraseRootFromParent_Done,
     /*  9003 */ // Label 385: @9003
     /*  9003 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(9080), // Rule ID 2047 //
     /*  9008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9018 */   // (bitconvert:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9018 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9021 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9025 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9030 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9034 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9051 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9054 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9079 */   // GIR_Coverage, 2047,
     /*  9079 */   GIR_EraseRootFromParent_Done,
     /*  9080 */ // Label 386: @9080
     /*  9080 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(9157), // Rule ID 2048 //
     /*  9085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9095 */   // (bitconvert:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9095 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9098 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9102 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9107 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9111 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9128 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9131 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9156 */   // GIR_Coverage, 2048,
     /*  9156 */   GIR_EraseRootFromParent_Done,
     /*  9157 */ // Label 387: @9157
     /*  9157 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(9234), // Rule ID 2064 //
     /*  9162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9172 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9172 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9175 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9179 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9184 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9188 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9205 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9208 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9233 */   // GIR_Coverage, 2064,
     /*  9233 */   GIR_EraseRootFromParent_Done,
     /*  9234 */ // Label 388: @9234
     /*  9234 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(9311), // Rule ID 2065 //
     /*  9239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9249 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9249 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9252 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9256 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9261 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9265 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9282 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9285 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9305 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9310 */   // GIR_Coverage, 2065,
     /*  9310 */   GIR_EraseRootFromParent_Done,
     /*  9311 */ // Label 389: @9311
     /*  9311 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(9388), // Rule ID 2069 //
     /*  9316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9326 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9326 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9329 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9333 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9338 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9342 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9359 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9362 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9387 */   // GIR_Coverage, 2069,
     /*  9387 */   GIR_EraseRootFromParent_Done,
     /*  9388 */ // Label 390: @9388
     /*  9388 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(9465), // Rule ID 2070 //
     /*  9393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9403 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9403 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9406 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9410 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9415 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9419 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9436 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9439 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9464 */   // GIR_Coverage, 2070,
     /*  9464 */   GIR_EraseRootFromParent_Done,
     /*  9465 */ // Label 391: @9465
     /*  9465 */ GIM_Reject,
     /*  9466 */ // Label 326: @9466
     /*  9466 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(9492), // Rule ID 1998 //
     /*  9471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  9474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9481 */   // (bitconvert:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] })
     /*  9481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9491 */   // GIR_Coverage, 1998,
     /*  9491 */   GIR_Done,
     /*  9492 */ // Label 392: @9492
     /*  9492 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(9518), // Rule ID 2001 //
     /*  9497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  9500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9507 */   // (bitconvert:{ *:[v8f16] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] })
     /*  9507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9517 */   // GIR_Coverage, 2001,
     /*  9517 */   GIR_Done,
     /*  9518 */ // Label 393: @9518
     /*  9518 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(9544), // Rule ID 2010 //
     /*  9523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9533 */   // (bitconvert:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src, MSA128H:{ *:[i32] })
     /*  9533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9543 */   // GIR_Coverage, 2010,
     /*  9543 */   GIR_Done,
     /*  9544 */ // Label 394: @9544
     /*  9544 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(9570), // Rule ID 2011 //
     /*  9549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9559 */   // (bitconvert:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] })
     /*  9559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9564 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9569 */   // GIR_Coverage, 2011,
     /*  9569 */   GIR_Done,
     /*  9570 */ // Label 395: @9570
     /*  9570 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(9596), // Rule ID 2012 //
     /*  9575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9585 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] })
     /*  9585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9595 */   // GIR_Coverage, 2012,
     /*  9595 */   GIR_Done,
     /*  9596 */ // Label 396: @9596
     /*  9596 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(9622), // Rule ID 2013 //
     /*  9601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9611 */   // (bitconvert:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] })
     /*  9611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9621 */   // GIR_Coverage, 2013,
     /*  9621 */   GIR_Done,
     /*  9622 */ // Label 397: @9622
     /*  9622 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(9648), // Rule ID 2014 //
     /*  9627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9637 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] })
     /*  9637 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9642 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9647 */   // GIR_Coverage, 2014,
     /*  9647 */   GIR_Done,
     /*  9648 */ // Label 398: @9648
     /*  9648 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(9725), // Rule ID 2035 //
     /*  9653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9663 */   // (bitconvert:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9663 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  9666 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9670 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9675 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9679 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  9684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  9687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  9691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9696 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9699 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9724 */   // GIR_Coverage, 2035,
     /*  9724 */   GIR_EraseRootFromParent_Done,
     /*  9725 */ // Label 399: @9725
     /*  9725 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(9802), // Rule ID 2036 //
     /*  9730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9740 */   // (bitconvert:{ *:[v8f16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9740 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  9743 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9747 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9752 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9756 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  9761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  9764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  9768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9773 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9776 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9796 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9801 */   // GIR_Coverage, 2036,
     /*  9801 */   GIR_EraseRootFromParent_Done,
     /*  9802 */ // Label 400: @9802
     /*  9802 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(9879), // Rule ID 2052 //
     /*  9807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9817 */   // (bitconvert:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9817 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9820 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9824 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9829 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9833 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9850 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9853 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9873 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9878 */   // GIR_Coverage, 2052,
     /*  9878 */   GIR_EraseRootFromParent_Done,
     /*  9879 */ // Label 401: @9879
     /*  9879 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(9956), // Rule ID 2053 //
     /*  9884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9894 */   // (bitconvert:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9894 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9897 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9901 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9906 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9910 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9927 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9930 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9955 */   // GIR_Coverage, 2053,
     /*  9955 */   GIR_EraseRootFromParent_Done,
     /*  9956 */ // Label 402: @9956
     /*  9956 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(10033), // Rule ID 2057 //
     /*  9961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9971 */   // (bitconvert:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9971 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9974 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9978 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9983 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9987 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10004 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10007 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10032 */   // GIR_Coverage, 2057,
     /* 10032 */   GIR_EraseRootFromParent_Done,
     /* 10033 */ // Label 403: @10033
     /* 10033 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(10110), // Rule ID 2058 //
     /* 10038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10048 */   // (bitconvert:{ *:[v8f16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10048 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10051 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10055 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10060 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10064 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10069 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10072 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10076 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10081 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10084 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10109 */   // GIR_Coverage, 2058,
     /* 10109 */   GIR_EraseRootFromParent_Done,
     /* 10110 */ // Label 404: @10110
     /* 10110 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(10180), // Rule ID 2062 //
     /* 10115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10125 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10125 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10128 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10132 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10137 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10141 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10158 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10161 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10179 */   // GIR_Coverage, 2062,
     /* 10179 */   GIR_EraseRootFromParent_Done,
     /* 10180 */ // Label 405: @10180
     /* 10180 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(10250), // Rule ID 2063 //
     /* 10185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10195 */   // (bitconvert:{ *:[v8f16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10195 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10198 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10202 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10207 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10211 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10228 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10231 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10249 */   // GIR_Coverage, 2063,
     /* 10249 */   GIR_EraseRootFromParent_Done,
     /* 10250 */ // Label 406: @10250
     /* 10250 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(10320), // Rule ID 2067 //
     /* 10255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10265 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10265 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10268 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10272 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10277 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10281 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10298 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10301 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10314 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10319 */   // GIR_Coverage, 2067,
     /* 10319 */   GIR_EraseRootFromParent_Done,
     /* 10320 */ // Label 407: @10320
     /* 10320 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(10390), // Rule ID 2068 //
     /* 10325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10335 */   // (bitconvert:{ *:[v8f16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10335 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10338 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10342 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10347 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10351 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10368 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10371 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10389 */   // GIR_Coverage, 2068,
     /* 10389 */   GIR_EraseRootFromParent_Done,
     /* 10390 */ // Label 408: @10390
     /* 10390 */ GIM_Reject,
     /* 10391 */ // Label 327: @10391
     /* 10391 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(10417), // Rule ID 2004 //
     /* 10396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10406 */   // (bitconvert:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src, MSA128B:{ *:[i32] })
     /* 10406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10411 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10416 */   // GIR_Coverage, 2004,
     /* 10416 */   GIR_Done,
     /* 10417 */ // Label 409: @10417
     /* 10417 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(10443), // Rule ID 2005 //
     /* 10422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10432 */   // (bitconvert:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src, MSA128B:{ *:[i32] })
     /* 10432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10437 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10442 */   // GIR_Coverage, 2005,
     /* 10442 */   GIR_Done,
     /* 10443 */ // Label 410: @10443
     /* 10443 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(10469), // Rule ID 2006 //
     /* 10448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10458 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src, MSA128B:{ *:[i32] })
     /* 10458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10468 */   // GIR_Coverage, 2006,
     /* 10468 */   GIR_Done,
     /* 10469 */ // Label 411: @10469
     /* 10469 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(10495), // Rule ID 2007 //
     /* 10474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10484 */   // (bitconvert:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src, MSA128B:{ *:[i32] })
     /* 10484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10489 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10494 */   // GIR_Coverage, 2007,
     /* 10494 */   GIR_Done,
     /* 10495 */ // Label 412: @10495
     /* 10495 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(10521), // Rule ID 2008 //
     /* 10500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10510 */   // (bitconvert:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src, MSA128B:{ *:[i32] })
     /* 10510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10520 */   // GIR_Coverage, 2008,
     /* 10520 */   GIR_Done,
     /* 10521 */ // Label 413: @10521
     /* 10521 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(10547), // Rule ID 2009 //
     /* 10526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10536 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src, MSA128B:{ *:[i32] })
     /* 10536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10541 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10546 */   // GIR_Coverage, 2009,
     /* 10546 */   GIR_Done,
     /* 10547 */ // Label 414: @10547
     /* 10547 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(10624), // Rule ID 2041 //
     /* 10552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10562 */   // (bitconvert:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10562 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10565 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10569 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10574 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10578 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10595 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10598 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10615 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10623 */   // GIR_Coverage, 2041,
     /* 10623 */   GIR_EraseRootFromParent_Done,
     /* 10624 */ // Label 415: @10624
     /* 10624 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(10701), // Rule ID 2046 //
     /* 10629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10639 */   // (bitconvert:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10639 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10642 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10646 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10651 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10655 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10672 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10675 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10700 */   // GIR_Coverage, 2046,
     /* 10700 */   GIR_EraseRootFromParent_Done,
     /* 10701 */ // Label 416: @10701
     /* 10701 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(10771), // Rule ID 2051 //
     /* 10706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10716 */   // (bitconvert:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10732 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10752 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10770 */   // GIR_Coverage, 2051,
     /* 10770 */   GIR_EraseRootFromParent_Done,
     /* 10771 */ // Label 417: @10771
     /* 10771 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(10841), // Rule ID 2056 //
     /* 10776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10786 */   // (bitconvert:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10786 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10789 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10793 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10798 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10802 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10819 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10822 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10840 */   // GIR_Coverage, 2056,
     /* 10840 */   GIR_EraseRootFromParent_Done,
     /* 10841 */ // Label 418: @10841
     /* 10841 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(10958), // Rule ID 2061 //
     /* 10846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10856 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10856 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 10859 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10863 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10868 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10872 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10877 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 10880 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10884 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10889 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 10892 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /* 10895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 10897 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 10900 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10904 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10909 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 10912 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 10917 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 10920 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /* 10924 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10929 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10932 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10952 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10957 */   // GIR_Coverage, 2061,
     /* 10957 */   GIR_EraseRootFromParent_Done,
     /* 10958 */ // Label 419: @10958
     /* 10958 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(11075), // Rule ID 2066 //
     /* 10963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10973 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10973 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 10976 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10980 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10985 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10989 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10994 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 10997 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 11001 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11006 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 11009 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /* 11012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 11014 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 11017 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11021 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11026 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 11029 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 11034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 11037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /* 11041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11046 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 11049 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 11059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 11061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 11069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 11074 */   // GIR_Coverage, 2066,
     /* 11074 */   GIR_EraseRootFromParent_Done,
     /* 11075 */ // Label 420: @11075
     /* 11075 */ GIM_Reject,
     /* 11076 */ // Label 328: @11076
     /* 11076 */ GIM_Reject,
     /* 11077 */ // Label 13: @11077
     /* 11077 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(11141), // Rule ID 1989 //
     /* 11082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11085 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11091 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 11095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11099 */   // MIs[0] Operand 1
     /* 11099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11111 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11115 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11121 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LWX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX),
     /* 11124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11126 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11130 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11139 */   GIR_RootConstrainSelectedInstOperands,
     /* 11140 */   // GIR_Coverage, 1989,
     /* 11140 */   GIR_EraseRootFromParent_Done,
     /* 11141 */ // Label 421: @11141
     /* 11141 */ GIM_Reject,
     /* 11142 */ // Label 14: @11142
     /* 11142 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(11209), // Rule ID 1988 //
     /* 11147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11150 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11153 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11167 */   // MIs[0] Operand 1
     /* 11167 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11171 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11175 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11179 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11183 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11189 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LHX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX),
     /* 11192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11194 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11198 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11207 */   GIR_RootConstrainSelectedInstOperands,
     /* 11208 */   // GIR_Coverage, 1988,
     /* 11208 */   GIR_EraseRootFromParent_Done,
     /* 11209 */ // Label 422: @11209
     /* 11209 */ GIM_Reject,
     /* 11210 */ // Label 15: @11210
     /* 11210 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(11277), // Rule ID 1987 //
     /* 11215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11218 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11221 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11235 */   // MIs[0] Operand 1
     /* 11235 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11247 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11251 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11255 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11257 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBUX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX),
     /* 11260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11262 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11266 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11275 */   GIR_RootConstrainSelectedInstOperands,
     /* 11276 */   // GIR_Coverage, 1987,
     /* 11276 */   GIR_EraseRootFromParent_Done,
     /* 11277 */ // Label 423: @11277
     /* 11277 */ GIM_Reject,
     /* 11278 */ // Label 16: @11278
     /* 11278 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 426*/ GIMT_Encode4(11469),
     /* 11289 */ /*GILLT_s32*//*Label 424*/ GIMT_Encode4(11297),
     /* 11293 */ /*GILLT_s64*//*Label 425*/ GIMT_Encode4(11424),
     /* 11297 */ // Label 424: @11297
     /* 11297 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(11423),
     /* 11302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 11308 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(11346), // Rule ID 25 //
     /* 11313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11327 */     // MIs[0] ptr
     /* 11327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11339 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (ATOMIC_CMP_SWAP_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I8),
     /* 11344 */     GIR_RootConstrainSelectedInstOperands,
     /* 11345 */     // GIR_Coverage, 25,
     /* 11345 */     GIR_Done,
     /* 11346 */   // Label 428: @11346
     /* 11346 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(11384), // Rule ID 26 //
     /* 11351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11365 */     // MIs[0] ptr
     /* 11365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11377 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (ATOMIC_CMP_SWAP_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I16),
     /* 11382 */     GIR_RootConstrainSelectedInstOperands,
     /* 11383 */     // GIR_Coverage, 26,
     /* 11383 */     GIR_Done,
     /* 11384 */   // Label 429: @11384
     /* 11384 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(11422), // Rule ID 27 //
     /* 11389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11403 */     // MIs[0] ptr
     /* 11403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11415 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (ATOMIC_CMP_SWAP_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I32),
     /* 11420 */     GIR_RootConstrainSelectedInstOperands,
     /* 11421 */     // GIR_Coverage, 27,
     /* 11421 */     GIR_Done,
     /* 11422 */   // Label 430: @11422
     /* 11422 */   GIM_Reject,
     /* 11423 */ // Label 427: @11423
     /* 11423 */ GIM_Reject,
     /* 11424 */ // Label 425: @11424
     /* 11424 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(11468), // Rule ID 191 //
     /* 11429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11435 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 11438 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11449 */   // MIs[0] ptr
     /* 11449 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11457 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11461 */   // (atomic_cmp_swap:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$cmp, GPR64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (ATOMIC_CMP_SWAP_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$cmp, GPR64:{ *:[i64] }:$swap)
     /* 11461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I64),
     /* 11466 */   GIR_RootConstrainSelectedInstOperands,
     /* 11467 */   // GIR_Coverage, 191,
     /* 11467 */   GIR_Done,
     /* 11468 */ // Label 431: @11468
     /* 11468 */ GIM_Reject,
     /* 11469 */ // Label 426: @11469
     /* 11469 */ GIM_Reject,
     /* 11470 */ // Label 17: @11470
     /* 11470 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 434*/ GIMT_Encode4(11639),
     /* 11481 */ /*GILLT_s32*//*Label 432*/ GIMT_Encode4(11489),
     /* 11485 */ /*GILLT_s64*//*Label 433*/ GIMT_Encode4(11601),
     /* 11489 */ // Label 432: @11489
     /* 11489 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(11600),
     /* 11494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11497 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(11531), // Rule ID 22 //
     /* 11502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11505 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11516 */     // MIs[0] ptr
     /* 11516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11524 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i8>>  =>  (ATOMIC_SWAP_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I8),
     /* 11529 */     GIR_RootConstrainSelectedInstOperands,
     /* 11530 */     // GIR_Coverage, 22,
     /* 11530 */     GIR_Done,
     /* 11531 */   // Label 436: @11531
     /* 11531 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(11565), // Rule ID 23 //
     /* 11536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11550 */     // MIs[0] ptr
     /* 11550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11558 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i16>>  =>  (ATOMIC_SWAP_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I16),
     /* 11563 */     GIR_RootConstrainSelectedInstOperands,
     /* 11564 */     // GIR_Coverage, 23,
     /* 11564 */     GIR_Done,
     /* 11565 */   // Label 437: @11565
     /* 11565 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(11599), // Rule ID 24 //
     /* 11570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11584 */     // MIs[0] ptr
     /* 11584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11592 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i32>>  =>  (ATOMIC_SWAP_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I32),
     /* 11597 */     GIR_RootConstrainSelectedInstOperands,
     /* 11598 */     // GIR_Coverage, 24,
     /* 11598 */     GIR_Done,
     /* 11599 */   // Label 438: @11599
     /* 11599 */   GIM_Reject,
     /* 11600 */ // Label 435: @11600
     /* 11600 */ GIM_Reject,
     /* 11601 */ // Label 433: @11601
     /* 11601 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(11638), // Rule ID 190 //
     /* 11606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11612 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11623 */   // MIs[0] ptr
     /* 11623 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11631 */   // (atomic_swap:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_swap_i64>>  =>  (ATOMIC_SWAP_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I64),
     /* 11636 */   GIR_RootConstrainSelectedInstOperands,
     /* 11637 */   // GIR_Coverage, 190,
     /* 11637 */   GIR_Done,
     /* 11638 */ // Label 439: @11638
     /* 11638 */ GIM_Reject,
     /* 11639 */ // Label 434: @11639
     /* 11639 */ GIM_Reject,
     /* 11640 */ // Label 18: @11640
     /* 11640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 442*/ GIMT_Encode4(11809),
     /* 11651 */ /*GILLT_s32*//*Label 440*/ GIMT_Encode4(11659),
     /* 11655 */ /*GILLT_s64*//*Label 441*/ GIMT_Encode4(11771),
     /* 11659 */ // Label 440: @11659
     /* 11659 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(11770),
     /* 11664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11667 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(11701), // Rule ID 4 //
     /* 11672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11675 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11686 */     // MIs[0] ptr
     /* 11686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11694 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i8>>  =>  (ATOMIC_LOAD_ADD_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I8),
     /* 11699 */     GIR_RootConstrainSelectedInstOperands,
     /* 11700 */     // GIR_Coverage, 4,
     /* 11700 */     GIR_Done,
     /* 11701 */   // Label 444: @11701
     /* 11701 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(11735), // Rule ID 5 //
     /* 11706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11709 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11720 */     // MIs[0] ptr
     /* 11720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11728 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i16>>  =>  (ATOMIC_LOAD_ADD_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I16),
     /* 11733 */     GIR_RootConstrainSelectedInstOperands,
     /* 11734 */     // GIR_Coverage, 5,
     /* 11734 */     GIR_Done,
     /* 11735 */   // Label 445: @11735
     /* 11735 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(11769), // Rule ID 6 //
     /* 11740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11754 */     // MIs[0] ptr
     /* 11754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11762 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i32>>  =>  (ATOMIC_LOAD_ADD_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I32),
     /* 11767 */     GIR_RootConstrainSelectedInstOperands,
     /* 11768 */     // GIR_Coverage, 6,
     /* 11768 */     GIR_Done,
     /* 11769 */   // Label 446: @11769
     /* 11769 */   GIM_Reject,
     /* 11770 */ // Label 443: @11770
     /* 11770 */ GIM_Reject,
     /* 11771 */ // Label 441: @11771
     /* 11771 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(11808), // Rule ID 184 //
     /* 11776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11793 */   // MIs[0] ptr
     /* 11793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11801 */   // (atomic_load_add:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_add_i64>>  =>  (ATOMIC_LOAD_ADD_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I64),
     /* 11806 */   GIR_RootConstrainSelectedInstOperands,
     /* 11807 */   // GIR_Coverage, 184,
     /* 11807 */   GIR_Done,
     /* 11808 */ // Label 447: @11808
     /* 11808 */ GIM_Reject,
     /* 11809 */ // Label 442: @11809
     /* 11809 */ GIM_Reject,
     /* 11810 */ // Label 19: @11810
     /* 11810 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 450*/ GIMT_Encode4(11979),
     /* 11821 */ /*GILLT_s32*//*Label 448*/ GIMT_Encode4(11829),
     /* 11825 */ /*GILLT_s64*//*Label 449*/ GIMT_Encode4(11941),
     /* 11829 */ // Label 448: @11829
     /* 11829 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(11940),
     /* 11834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11837 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(11871), // Rule ID 7 //
     /* 11842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11845 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11856 */     // MIs[0] ptr
     /* 11856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11864 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i8>>  =>  (ATOMIC_LOAD_SUB_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I8),
     /* 11869 */     GIR_RootConstrainSelectedInstOperands,
     /* 11870 */     // GIR_Coverage, 7,
     /* 11870 */     GIR_Done,
     /* 11871 */   // Label 452: @11871
     /* 11871 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(11905), // Rule ID 8 //
     /* 11876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11879 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11890 */     // MIs[0] ptr
     /* 11890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11898 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i16>>  =>  (ATOMIC_LOAD_SUB_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I16),
     /* 11903 */     GIR_RootConstrainSelectedInstOperands,
     /* 11904 */     // GIR_Coverage, 8,
     /* 11904 */     GIR_Done,
     /* 11905 */   // Label 453: @11905
     /* 11905 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(11939), // Rule ID 9 //
     /* 11910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11924 */     // MIs[0] ptr
     /* 11924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11932 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i32>>  =>  (ATOMIC_LOAD_SUB_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I32),
     /* 11937 */     GIR_RootConstrainSelectedInstOperands,
     /* 11938 */     // GIR_Coverage, 9,
     /* 11938 */     GIR_Done,
     /* 11939 */   // Label 454: @11939
     /* 11939 */   GIM_Reject,
     /* 11940 */ // Label 451: @11940
     /* 11940 */ GIM_Reject,
     /* 11941 */ // Label 449: @11941
     /* 11941 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(11978), // Rule ID 185 //
     /* 11946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11952 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11963 */   // MIs[0] ptr
     /* 11963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11971 */   // (atomic_load_sub:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_sub_i64>>  =>  (ATOMIC_LOAD_SUB_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I64),
     /* 11976 */   GIR_RootConstrainSelectedInstOperands,
     /* 11977 */   // GIR_Coverage, 185,
     /* 11977 */   GIR_Done,
     /* 11978 */ // Label 455: @11978
     /* 11978 */ GIM_Reject,
     /* 11979 */ // Label 450: @11979
     /* 11979 */ GIM_Reject,
     /* 11980 */ // Label 20: @11980
     /* 11980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 458*/ GIMT_Encode4(12149),
     /* 11991 */ /*GILLT_s32*//*Label 456*/ GIMT_Encode4(11999),
     /* 11995 */ /*GILLT_s64*//*Label 457*/ GIMT_Encode4(12111),
     /* 11999 */ // Label 456: @11999
     /* 11999 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(12110),
     /* 12004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12007 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(12041), // Rule ID 10 //
     /* 12012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12026 */     // MIs[0] ptr
     /* 12026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12034 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i8>>  =>  (ATOMIC_LOAD_AND_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I8),
     /* 12039 */     GIR_RootConstrainSelectedInstOperands,
     /* 12040 */     // GIR_Coverage, 10,
     /* 12040 */     GIR_Done,
     /* 12041 */   // Label 460: @12041
     /* 12041 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(12075), // Rule ID 11 //
     /* 12046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12049 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12060 */     // MIs[0] ptr
     /* 12060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12068 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i16>>  =>  (ATOMIC_LOAD_AND_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I16),
     /* 12073 */     GIR_RootConstrainSelectedInstOperands,
     /* 12074 */     // GIR_Coverage, 11,
     /* 12074 */     GIR_Done,
     /* 12075 */   // Label 461: @12075
     /* 12075 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(12109), // Rule ID 12 //
     /* 12080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12094 */     // MIs[0] ptr
     /* 12094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12102 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i32>>  =>  (ATOMIC_LOAD_AND_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I32),
     /* 12107 */     GIR_RootConstrainSelectedInstOperands,
     /* 12108 */     // GIR_Coverage, 12,
     /* 12108 */     GIR_Done,
     /* 12109 */   // Label 462: @12109
     /* 12109 */   GIM_Reject,
     /* 12110 */ // Label 459: @12110
     /* 12110 */ GIM_Reject,
     /* 12111 */ // Label 457: @12111
     /* 12111 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(12148), // Rule ID 186 //
     /* 12116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12122 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12133 */   // MIs[0] ptr
     /* 12133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12141 */   // (atomic_load_and:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_and_i64>>  =>  (ATOMIC_LOAD_AND_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I64),
     /* 12146 */   GIR_RootConstrainSelectedInstOperands,
     /* 12147 */   // GIR_Coverage, 186,
     /* 12147 */   GIR_Done,
     /* 12148 */ // Label 463: @12148
     /* 12148 */ GIM_Reject,
     /* 12149 */ // Label 458: @12149
     /* 12149 */ GIM_Reject,
     /* 12150 */ // Label 21: @12150
     /* 12150 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 466*/ GIMT_Encode4(12319),
     /* 12161 */ /*GILLT_s32*//*Label 464*/ GIMT_Encode4(12169),
     /* 12165 */ /*GILLT_s64*//*Label 465*/ GIMT_Encode4(12281),
     /* 12169 */ // Label 464: @12169
     /* 12169 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(12280),
     /* 12174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12177 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(12211), // Rule ID 19 //
     /* 12182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12185 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12196 */     // MIs[0] ptr
     /* 12196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12204 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i8>>  =>  (ATOMIC_LOAD_NAND_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I8),
     /* 12209 */     GIR_RootConstrainSelectedInstOperands,
     /* 12210 */     // GIR_Coverage, 19,
     /* 12210 */     GIR_Done,
     /* 12211 */   // Label 468: @12211
     /* 12211 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(12245), // Rule ID 20 //
     /* 12216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12219 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12230 */     // MIs[0] ptr
     /* 12230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12238 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i16>>  =>  (ATOMIC_LOAD_NAND_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I16),
     /* 12243 */     GIR_RootConstrainSelectedInstOperands,
     /* 12244 */     // GIR_Coverage, 20,
     /* 12244 */     GIR_Done,
     /* 12245 */   // Label 469: @12245
     /* 12245 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(12279), // Rule ID 21 //
     /* 12250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12264 */     // MIs[0] ptr
     /* 12264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12272 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>>  =>  (ATOMIC_LOAD_NAND_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I32),
     /* 12277 */     GIR_RootConstrainSelectedInstOperands,
     /* 12278 */     // GIR_Coverage, 21,
     /* 12278 */     GIR_Done,
     /* 12279 */   // Label 470: @12279
     /* 12279 */   GIM_Reject,
     /* 12280 */ // Label 467: @12280
     /* 12280 */ GIM_Reject,
     /* 12281 */ // Label 465: @12281
     /* 12281 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(12318), // Rule ID 189 //
     /* 12286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12292 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12303 */   // MIs[0] ptr
     /* 12303 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12311 */   // (atomic_load_nand:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>>  =>  (ATOMIC_LOAD_NAND_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I64),
     /* 12316 */   GIR_RootConstrainSelectedInstOperands,
     /* 12317 */   // GIR_Coverage, 189,
     /* 12317 */   GIR_Done,
     /* 12318 */ // Label 471: @12318
     /* 12318 */ GIM_Reject,
     /* 12319 */ // Label 466: @12319
     /* 12319 */ GIM_Reject,
     /* 12320 */ // Label 22: @12320
     /* 12320 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 474*/ GIMT_Encode4(12489),
     /* 12331 */ /*GILLT_s32*//*Label 472*/ GIMT_Encode4(12339),
     /* 12335 */ /*GILLT_s64*//*Label 473*/ GIMT_Encode4(12451),
     /* 12339 */ // Label 472: @12339
     /* 12339 */ GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(12450),
     /* 12344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12347 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(12381), // Rule ID 13 //
     /* 12352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12355 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12366 */     // MIs[0] ptr
     /* 12366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12374 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i8>>  =>  (ATOMIC_LOAD_OR_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I8),
     /* 12379 */     GIR_RootConstrainSelectedInstOperands,
     /* 12380 */     // GIR_Coverage, 13,
     /* 12380 */     GIR_Done,
     /* 12381 */   // Label 476: @12381
     /* 12381 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(12415), // Rule ID 14 //
     /* 12386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12389 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12400 */     // MIs[0] ptr
     /* 12400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12408 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i16>>  =>  (ATOMIC_LOAD_OR_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I16),
     /* 12413 */     GIR_RootConstrainSelectedInstOperands,
     /* 12414 */     // GIR_Coverage, 14,
     /* 12414 */     GIR_Done,
     /* 12415 */   // Label 477: @12415
     /* 12415 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(12449), // Rule ID 15 //
     /* 12420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12423 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12434 */     // MIs[0] ptr
     /* 12434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12442 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i32>>  =>  (ATOMIC_LOAD_OR_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I32),
     /* 12447 */     GIR_RootConstrainSelectedInstOperands,
     /* 12448 */     // GIR_Coverage, 15,
     /* 12448 */     GIR_Done,
     /* 12449 */   // Label 478: @12449
     /* 12449 */   GIM_Reject,
     /* 12450 */ // Label 475: @12450
     /* 12450 */ GIM_Reject,
     /* 12451 */ // Label 473: @12451
     /* 12451 */ GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(12488), // Rule ID 187 //
     /* 12456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12462 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12473 */   // MIs[0] ptr
     /* 12473 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12481 */   // (atomic_load_or:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_or_i64>>  =>  (ATOMIC_LOAD_OR_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I64),
     /* 12486 */   GIR_RootConstrainSelectedInstOperands,
     /* 12487 */   // GIR_Coverage, 187,
     /* 12487 */   GIR_Done,
     /* 12488 */ // Label 479: @12488
     /* 12488 */ GIM_Reject,
     /* 12489 */ // Label 474: @12489
     /* 12489 */ GIM_Reject,
     /* 12490 */ // Label 23: @12490
     /* 12490 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 482*/ GIMT_Encode4(12659),
     /* 12501 */ /*GILLT_s32*//*Label 480*/ GIMT_Encode4(12509),
     /* 12505 */ /*GILLT_s64*//*Label 481*/ GIMT_Encode4(12621),
     /* 12509 */ // Label 480: @12509
     /* 12509 */ GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(12620),
     /* 12514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12517 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(12551), // Rule ID 16 //
     /* 12522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12525 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12536 */     // MIs[0] ptr
     /* 12536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12544 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i8>>  =>  (ATOMIC_LOAD_XOR_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I8),
     /* 12549 */     GIR_RootConstrainSelectedInstOperands,
     /* 12550 */     // GIR_Coverage, 16,
     /* 12550 */     GIR_Done,
     /* 12551 */   // Label 484: @12551
     /* 12551 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(12585), // Rule ID 17 //
     /* 12556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12570 */     // MIs[0] ptr
     /* 12570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12578 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i16>>  =>  (ATOMIC_LOAD_XOR_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I16),
     /* 12583 */     GIR_RootConstrainSelectedInstOperands,
     /* 12584 */     // GIR_Coverage, 17,
     /* 12584 */     GIR_Done,
     /* 12585 */   // Label 485: @12585
     /* 12585 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(12619), // Rule ID 18 //
     /* 12590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12593 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12604 */     // MIs[0] ptr
     /* 12604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12612 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i32>>  =>  (ATOMIC_LOAD_XOR_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I32),
     /* 12617 */     GIR_RootConstrainSelectedInstOperands,
     /* 12618 */     // GIR_Coverage, 18,
     /* 12618 */     GIR_Done,
     /* 12619 */   // Label 486: @12619
     /* 12619 */   GIM_Reject,
     /* 12620 */ // Label 483: @12620
     /* 12620 */ GIM_Reject,
     /* 12621 */ // Label 481: @12621
     /* 12621 */ GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(12658), // Rule ID 188 //
     /* 12626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12632 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12643 */   // MIs[0] ptr
     /* 12643 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12651 */   // (atomic_load_xor:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_xor_i64>>  =>  (ATOMIC_LOAD_XOR_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I64),
     /* 12656 */   GIR_RootConstrainSelectedInstOperands,
     /* 12657 */   // GIR_Coverage, 188,
     /* 12657 */   GIR_Done,
     /* 12658 */ // Label 487: @12658
     /* 12658 */ GIM_Reject,
     /* 12659 */ // Label 482: @12659
     /* 12659 */ GIM_Reject,
     /* 12660 */ // Label 24: @12660
     /* 12660 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 490*/ GIMT_Encode4(12829),
     /* 12671 */ /*GILLT_s32*//*Label 488*/ GIMT_Encode4(12679),
     /* 12675 */ /*GILLT_s64*//*Label 489*/ GIMT_Encode4(12791),
     /* 12679 */ // Label 488: @12679
     /* 12679 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(12790),
     /* 12684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12687 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(12721), // Rule ID 31 //
     /* 12692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12706 */     // MIs[0] ptr
     /* 12706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12714 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i8>>  =>  (ATOMIC_LOAD_MAX_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I8),
     /* 12719 */     GIR_RootConstrainSelectedInstOperands,
     /* 12720 */     // GIR_Coverage, 31,
     /* 12720 */     GIR_Done,
     /* 12721 */   // Label 492: @12721
     /* 12721 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(12755), // Rule ID 32 //
     /* 12726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12740 */     // MIs[0] ptr
     /* 12740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12748 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i16>>  =>  (ATOMIC_LOAD_MAX_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I16),
     /* 12753 */     GIR_RootConstrainSelectedInstOperands,
     /* 12754 */     // GIR_Coverage, 32,
     /* 12754 */     GIR_Done,
     /* 12755 */   // Label 493: @12755
     /* 12755 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(12789), // Rule ID 33 //
     /* 12760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12763 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12774 */     // MIs[0] ptr
     /* 12774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12782 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i32>>  =>  (ATOMIC_LOAD_MAX_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I32),
     /* 12787 */     GIR_RootConstrainSelectedInstOperands,
     /* 12788 */     // GIR_Coverage, 33,
     /* 12788 */     GIR_Done,
     /* 12789 */   // Label 494: @12789
     /* 12789 */   GIM_Reject,
     /* 12790 */ // Label 491: @12790
     /* 12790 */ GIM_Reject,
     /* 12791 */ // Label 489: @12791
     /* 12791 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(12828), // Rule ID 193 //
     /* 12796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12802 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12813 */   // MIs[0] ptr
     /* 12813 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12817 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12821 */   // (atomic_load_max:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_max_i64>>  =>  (ATOMIC_LOAD_MAX_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I64),
     /* 12826 */   GIR_RootConstrainSelectedInstOperands,
     /* 12827 */   // GIR_Coverage, 193,
     /* 12827 */   GIR_Done,
     /* 12828 */ // Label 495: @12828
     /* 12828 */ GIM_Reject,
     /* 12829 */ // Label 490: @12829
     /* 12829 */ GIM_Reject,
     /* 12830 */ // Label 25: @12830
     /* 12830 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 498*/ GIMT_Encode4(12999),
     /* 12841 */ /*GILLT_s32*//*Label 496*/ GIMT_Encode4(12849),
     /* 12845 */ /*GILLT_s64*//*Label 497*/ GIMT_Encode4(12961),
     /* 12849 */ // Label 496: @12849
     /* 12849 */ GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(12960),
     /* 12854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12857 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(12891), // Rule ID 28 //
     /* 12862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12865 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12876 */     // MIs[0] ptr
     /* 12876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12884 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i8>>  =>  (ATOMIC_LOAD_MIN_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I8),
     /* 12889 */     GIR_RootConstrainSelectedInstOperands,
     /* 12890 */     // GIR_Coverage, 28,
     /* 12890 */     GIR_Done,
     /* 12891 */   // Label 500: @12891
     /* 12891 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(12925), // Rule ID 29 //
     /* 12896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12910 */     // MIs[0] ptr
     /* 12910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12918 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i16>>  =>  (ATOMIC_LOAD_MIN_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I16),
     /* 12923 */     GIR_RootConstrainSelectedInstOperands,
     /* 12924 */     // GIR_Coverage, 29,
     /* 12924 */     GIR_Done,
     /* 12925 */   // Label 501: @12925
     /* 12925 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(12959), // Rule ID 30 //
     /* 12930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12944 */     // MIs[0] ptr
     /* 12944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12952 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i32>>  =>  (ATOMIC_LOAD_MIN_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I32),
     /* 12957 */     GIR_RootConstrainSelectedInstOperands,
     /* 12958 */     // GIR_Coverage, 30,
     /* 12958 */     GIR_Done,
     /* 12959 */   // Label 502: @12959
     /* 12959 */   GIM_Reject,
     /* 12960 */ // Label 499: @12960
     /* 12960 */ GIM_Reject,
     /* 12961 */ // Label 497: @12961
     /* 12961 */ GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(12998), // Rule ID 192 //
     /* 12966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12972 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12983 */   // MIs[0] ptr
     /* 12983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12991 */   // (atomic_load_min:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_min_i64>>  =>  (ATOMIC_LOAD_MIN_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I64),
     /* 12996 */   GIR_RootConstrainSelectedInstOperands,
     /* 12997 */   // GIR_Coverage, 192,
     /* 12997 */   GIR_Done,
     /* 12998 */ // Label 503: @12998
     /* 12998 */ GIM_Reject,
     /* 12999 */ // Label 498: @12999
     /* 12999 */ GIM_Reject,
     /* 13000 */ // Label 26: @13000
     /* 13000 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 506*/ GIMT_Encode4(13169),
     /* 13011 */ /*GILLT_s32*//*Label 504*/ GIMT_Encode4(13019),
     /* 13015 */ /*GILLT_s64*//*Label 505*/ GIMT_Encode4(13131),
     /* 13019 */ // Label 504: @13019
     /* 13019 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(13130),
     /* 13024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13027 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(13061), // Rule ID 37 //
     /* 13032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 13042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13046 */     // MIs[0] ptr
     /* 13046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13054 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i8>>  =>  (ATOMIC_LOAD_UMAX_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I8),
     /* 13059 */     GIR_RootConstrainSelectedInstOperands,
     /* 13060 */     // GIR_Coverage, 37,
     /* 13060 */     GIR_Done,
     /* 13061 */   // Label 508: @13061
     /* 13061 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(13095), // Rule ID 38 //
     /* 13066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13069 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 13076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13080 */     // MIs[0] ptr
     /* 13080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13088 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i16>>  =>  (ATOMIC_LOAD_UMAX_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I16),
     /* 13093 */     GIR_RootConstrainSelectedInstOperands,
     /* 13094 */     // GIR_Coverage, 38,
     /* 13094 */     GIR_Done,
     /* 13095 */   // Label 509: @13095
     /* 13095 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(13129), // Rule ID 39 //
     /* 13100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 13110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13114 */     // MIs[0] ptr
     /* 13114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13122 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i32>>  =>  (ATOMIC_LOAD_UMAX_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I32),
     /* 13127 */     GIR_RootConstrainSelectedInstOperands,
     /* 13128 */     // GIR_Coverage, 39,
     /* 13128 */     GIR_Done,
     /* 13129 */   // Label 510: @13129
     /* 13129 */   GIM_Reject,
     /* 13130 */ // Label 507: @13130
     /* 13130 */ GIM_Reject,
     /* 13131 */ // Label 505: @13131
     /* 13131 */ GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(13168), // Rule ID 195 //
     /* 13136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 13142 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 13149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13153 */   // MIs[0] ptr
     /* 13153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13161 */   // (atomic_load_umax:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_umax_i64>>  =>  (ATOMIC_LOAD_UMAX_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 13161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I64),
     /* 13166 */   GIR_RootConstrainSelectedInstOperands,
     /* 13167 */   // GIR_Coverage, 195,
     /* 13167 */   GIR_Done,
     /* 13168 */ // Label 511: @13168
     /* 13168 */ GIM_Reject,
     /* 13169 */ // Label 506: @13169
     /* 13169 */ GIM_Reject,
     /* 13170 */ // Label 27: @13170
     /* 13170 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 514*/ GIMT_Encode4(13339),
     /* 13181 */ /*GILLT_s32*//*Label 512*/ GIMT_Encode4(13189),
     /* 13185 */ /*GILLT_s64*//*Label 513*/ GIMT_Encode4(13301),
     /* 13189 */ // Label 512: @13189
     /* 13189 */ GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(13300),
     /* 13194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13197 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(13231), // Rule ID 34 //
     /* 13202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 13212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13216 */     // MIs[0] ptr
     /* 13216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13224 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i8>>  =>  (ATOMIC_LOAD_UMIN_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I8),
     /* 13229 */     GIR_RootConstrainSelectedInstOperands,
     /* 13230 */     // GIR_Coverage, 34,
     /* 13230 */     GIR_Done,
     /* 13231 */   // Label 516: @13231
     /* 13231 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(13265), // Rule ID 35 //
     /* 13236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13239 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 13246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13250 */     // MIs[0] ptr
     /* 13250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13258 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i16>>  =>  (ATOMIC_LOAD_UMIN_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I16),
     /* 13263 */     GIR_RootConstrainSelectedInstOperands,
     /* 13264 */     // GIR_Coverage, 35,
     /* 13264 */     GIR_Done,
     /* 13265 */   // Label 517: @13265
     /* 13265 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(13299), // Rule ID 36 //
     /* 13270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 13280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13284 */     // MIs[0] ptr
     /* 13284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13292 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i32>>  =>  (ATOMIC_LOAD_UMIN_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I32),
     /* 13297 */     GIR_RootConstrainSelectedInstOperands,
     /* 13298 */     // GIR_Coverage, 36,
     /* 13298 */     GIR_Done,
     /* 13299 */   // Label 518: @13299
     /* 13299 */   GIM_Reject,
     /* 13300 */ // Label 515: @13300
     /* 13300 */ GIM_Reject,
     /* 13301 */ // Label 513: @13301
     /* 13301 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(13338), // Rule ID 194 //
     /* 13306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 13312 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 13319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13323 */   // MIs[0] ptr
     /* 13323 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13331 */   // (atomic_load_umin:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_umin_i64>>  =>  (ATOMIC_LOAD_UMIN_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 13331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I64),
     /* 13336 */   GIR_RootConstrainSelectedInstOperands,
     /* 13337 */   // GIR_Coverage, 194,
     /* 13337 */   GIR_Done,
     /* 13338 */ // Label 519: @13338
     /* 13338 */ GIM_Reject,
     /* 13339 */ // Label 514: @13339
     /* 13339 */ GIM_Reject,
     /* 13340 */ // Label 28: @13340
     /* 13340 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 522*/ GIMT_Encode4(18060),
     /* 13351 */ /*GILLT_s32*//*Label 520*/ GIMT_Encode4(13359),
     /* 13355 */ /*GILLT_s64*//*Label 521*/ GIMT_Encode4(18026),
     /* 13359 */ // Label 520: @13359
     /* 13359 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(13467), // Rule ID 2365 //
     /* 13364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13367 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13375 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13379 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13383 */   // MIs[1] Operand 1
     /* 13383 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13388 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13392 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13396 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13400 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13404 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13408 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13412 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13416 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13420 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13424 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13428 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13432 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13436 */   // MIs[4] Operand 1
     /* 13436 */   // No operand predicates
     /* 13436 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13441 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13445 */   // MIs[0] offset
     /* 13445 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13448 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13450 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT0 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT0),
     /* 13453 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13457 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13460 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13462 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13465 */   GIR_RootConstrainSelectedInstOperands,
     /* 13466 */   // GIR_Coverage, 2365,
     /* 13466 */   GIR_EraseRootFromParent_Done,
     /* 13467 */ // Label 523: @13467
     /* 13467 */ GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(13582), // Rule ID 2366 //
     /* 13472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13483 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13487 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13491 */   // MIs[1] Operand 1
     /* 13491 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13496 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13500 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13504 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13508 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13512 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13516 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13520 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13524 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13528 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13539 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13543 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13547 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13551 */   // MIs[4] Operand 1
     /* 13551 */   // No operand predicates
     /* 13551 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13556 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13560 */   // MIs[0] offset
     /* 13560 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13563 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13565 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT032 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT032),
     /* 13568 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13572 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13575 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13577 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13580 */   GIR_RootConstrainSelectedInstOperands,
     /* 13581 */   // GIR_Coverage, 2366,
     /* 13581 */   GIR_EraseRootFromParent_Done,
     /* 13582 */ // Label 524: @13582
     /* 13582 */ GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(13690), // Rule ID 2367 //
     /* 13587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13590 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13598 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13602 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13606 */   // MIs[1] Operand 1
     /* 13606 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 13611 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13615 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13619 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13623 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13627 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13631 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13635 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13639 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13643 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13647 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13651 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13655 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13659 */   // MIs[4] Operand 1
     /* 13659 */   // No operand predicates
     /* 13659 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13664 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13668 */   // MIs[0] offset
     /* 13668 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13671 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13673 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT1 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT1),
     /* 13676 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13680 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13683 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13685 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13688 */   GIR_RootConstrainSelectedInstOperands,
     /* 13689 */   // GIR_Coverage, 2367,
     /* 13689 */   GIR_EraseRootFromParent_Done,
     /* 13690 */ // Label 525: @13690
     /* 13690 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(13805), // Rule ID 2368 //
     /* 13695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13698 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13706 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13710 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13714 */   // MIs[1] Operand 1
     /* 13714 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 13719 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13723 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13727 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13731 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13735 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13739 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13743 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13747 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13751 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13762 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13766 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13770 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13774 */   // MIs[4] Operand 1
     /* 13774 */   // No operand predicates
     /* 13774 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13779 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13783 */   // MIs[0] offset
     /* 13783 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13786 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13788 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT132 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT132),
     /* 13791 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13795 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13798 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13800 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13803 */   GIR_RootConstrainSelectedInstOperands,
     /* 13804 */   // GIR_Coverage, 2368,
     /* 13804 */   GIR_EraseRootFromParent_Done,
     /* 13805 */ // Label 526: @13805
     /* 13805 */ GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(13913), // Rule ID 270 //
     /* 13810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13821 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13825 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13829 */   // MIs[1] Operand 1
     /* 13829 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13834 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13838 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13842 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13846 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13850 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13855 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 13859 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13863 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13867 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13871 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13875 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13879 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13883 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13887 */   // MIs[4] Operand 1
     /* 13887 */   // No operand predicates
     /* 13887 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13891 */   // MIs[0] offset
     /* 13891 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13894 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13896 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT0 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT0),
     /* 13899 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 13903 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13906 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13908 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13911 */   GIR_RootConstrainSelectedInstOperands,
     /* 13912 */   // GIR_Coverage, 270,
     /* 13912 */   GIR_EraseRootFromParent_Done,
     /* 13913 */ // Label 527: @13913
     /* 13913 */ GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(14028), // Rule ID 271 //
     /* 13918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13921 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13925 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13929 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13933 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13937 */   // MIs[1] Operand 1
     /* 13937 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13942 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13946 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13950 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13954 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13958 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13963 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 13967 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13971 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13975 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13979 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13990 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13994 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13998 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 14002 */   // MIs[4] Operand 1
     /* 14002 */   // No operand predicates
     /* 14002 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14006 */   // MIs[0] offset
     /* 14006 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14009 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14011 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT032 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT032),
     /* 14014 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14018 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14021 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14023 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14026 */   GIR_RootConstrainSelectedInstOperands,
     /* 14027 */   // GIR_Coverage, 271,
     /* 14027 */   GIR_EraseRootFromParent_Done,
     /* 14028 */ // Label 528: @14028
     /* 14028 */ GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(14136), // Rule ID 272 //
     /* 14033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 14036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14044 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14048 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14052 */   // MIs[1] Operand 1
     /* 14052 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14057 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 14061 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 14065 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 14069 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14073 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14078 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 14082 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14086 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 14090 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 14094 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 14098 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 14102 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14106 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 14110 */   // MIs[4] Operand 1
     /* 14110 */   // No operand predicates
     /* 14110 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14114 */   // MIs[0] offset
     /* 14114 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14117 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14119 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT1 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT1),
     /* 14122 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14126 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14129 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14131 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14134 */   GIR_RootConstrainSelectedInstOperands,
     /* 14135 */   // GIR_Coverage, 272,
     /* 14135 */   GIR_EraseRootFromParent_Done,
     /* 14136 */ // Label 529: @14136
     /* 14136 */ GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(14251), // Rule ID 273 //
     /* 14141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 14144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14152 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14156 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14160 */   // MIs[1] Operand 1
     /* 14160 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14165 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 14169 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 14173 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 14177 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14181 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14186 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 14190 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14194 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 14198 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 14202 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 14213 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 14217 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14221 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 14225 */   // MIs[4] Operand 1
     /* 14225 */   // No operand predicates
     /* 14225 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14229 */   // MIs[0] offset
     /* 14229 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14232 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14234 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT132 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT132),
     /* 14237 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14241 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14244 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14246 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14249 */   GIR_RootConstrainSelectedInstOperands,
     /* 14250 */   // GIR_Coverage, 273,
     /* 14250 */   GIR_EraseRootFromParent_Done,
     /* 14251 */ // Label 530: @14251
     /* 14251 */ GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(14308), // Rule ID 94 //
     /* 14256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14259 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14263 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14267 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14271 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14275 */   // MIs[1] Operand 1
     /* 14275 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14280 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14285 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14289 */   // MIs[0] offset
     /* 14289 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14292 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14294 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ),
     /* 14297 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14301 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14303 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14306 */   GIR_RootConstrainSelectedInstOperands,
     /* 14307 */   // GIR_Coverage, 94,
     /* 14307 */   GIR_EraseRootFromParent_Done,
     /* 14308 */ // Label 531: @14308
     /* 14308 */ GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(14365), // Rule ID 95 //
     /* 14313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14316 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14324 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14328 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14332 */   // MIs[1] Operand 1
     /* 14332 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14337 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14342 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14346 */   // MIs[0] offset
     /* 14346 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14349 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14351 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ),
     /* 14354 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14358 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14360 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14363 */   GIR_RootConstrainSelectedInstOperands,
     /* 14364 */   // GIR_Coverage, 95,
     /* 14364 */   GIR_EraseRootFromParent_Done,
     /* 14365 */ // Label 532: @14365
     /* 14365 */ GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(14422), // Rule ID 96 //
     /* 14370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14373 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14381 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14385 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14389 */   // MIs[1] Operand 1
     /* 14389 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14394 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14399 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14403 */   // MIs[0] offset
     /* 14403 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14408 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ),
     /* 14411 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14415 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14417 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14420 */   GIR_RootConstrainSelectedInstOperands,
     /* 14421 */   // GIR_Coverage, 96,
     /* 14421 */   GIR_EraseRootFromParent_Done,
     /* 14422 */ // Label 533: @14422
     /* 14422 */ GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(14479), // Rule ID 97 //
     /* 14427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14430 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14434 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14438 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14442 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14446 */   // MIs[1] Operand 1
     /* 14446 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14451 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14456 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14460 */   // MIs[0] offset
     /* 14460 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14463 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14465 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ),
     /* 14468 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14472 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14474 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14477 */   GIR_RootConstrainSelectedInstOperands,
     /* 14478 */   // GIR_Coverage, 97,
     /* 14478 */   GIR_EraseRootFromParent_Done,
     /* 14479 */ // Label 534: @14479
     /* 14479 */ GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(14536), // Rule ID 245 //
     /* 14484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14495 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14499 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14503 */   // MIs[1] Operand 1
     /* 14503 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14508 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14513 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14517 */   // MIs[0] offset
     /* 14517 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14522 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ64),
     /* 14525 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14529 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14531 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14534 */   GIR_RootConstrainSelectedInstOperands,
     /* 14535 */   // GIR_Coverage, 245,
     /* 14535 */   GIR_EraseRootFromParent_Done,
     /* 14536 */ // Label 535: @14536
     /* 14536 */ GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(14593), // Rule ID 246 //
     /* 14541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14544 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14548 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14552 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14556 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14560 */   // MIs[1] Operand 1
     /* 14560 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14565 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14570 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14574 */   // MIs[0] offset
     /* 14574 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14577 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14579 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ64),
     /* 14582 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14586 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14588 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14591 */   GIR_RootConstrainSelectedInstOperands,
     /* 14592 */   // GIR_Coverage, 246,
     /* 14592 */   GIR_EraseRootFromParent_Done,
     /* 14593 */ // Label 536: @14593
     /* 14593 */ GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(14650), // Rule ID 247 //
     /* 14598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14609 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14613 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14617 */   // MIs[1] Operand 1
     /* 14617 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14622 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14627 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14631 */   // MIs[0] offset
     /* 14631 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14634 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14636 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ64),
     /* 14639 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14643 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14645 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14648 */   GIR_RootConstrainSelectedInstOperands,
     /* 14649 */   // GIR_Coverage, 247,
     /* 14649 */   GIR_EraseRootFromParent_Done,
     /* 14650 */ // Label 537: @14650
     /* 14650 */ GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(14707), // Rule ID 248 //
     /* 14655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14658 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14662 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14666 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14670 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14674 */   // MIs[1] Operand 1
     /* 14674 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14679 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14684 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14688 */   // MIs[0] offset
     /* 14688 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14691 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14693 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ64),
     /* 14696 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14700 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14702 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14705 */   GIR_RootConstrainSelectedInstOperands,
     /* 14706 */   // GIR_Coverage, 248,
     /* 14706 */   GIR_EraseRootFromParent_Done,
     /* 14707 */ // Label 538: @14707
     /* 14707 */ GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(14764), // Rule ID 1109 //
     /* 14712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14715 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14719 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14723 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14727 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14731 */   // MIs[1] Operand 1
     /* 14731 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14736 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14741 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14745 */   // MIs[0] offset
     /* 14745 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14750 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ_MM),
     /* 14753 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14757 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14759 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14762 */   GIR_RootConstrainSelectedInstOperands,
     /* 14763 */   // GIR_Coverage, 1109,
     /* 14763 */   GIR_EraseRootFromParent_Done,
     /* 14764 */ // Label 539: @14764
     /* 14764 */ GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(14821), // Rule ID 1110 //
     /* 14769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14772 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14780 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14784 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14788 */   // MIs[1] Operand 1
     /* 14788 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14793 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14798 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14802 */   // MIs[0] offset
     /* 14802 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14805 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14807 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ_MM),
     /* 14810 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14814 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14816 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14819 */   GIR_RootConstrainSelectedInstOperands,
     /* 14820 */   // GIR_Coverage, 1110,
     /* 14820 */   GIR_EraseRootFromParent_Done,
     /* 14821 */ // Label 540: @14821
     /* 14821 */ GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(14878), // Rule ID 1111 //
     /* 14826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14837 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14841 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14845 */   // MIs[1] Operand 1
     /* 14845 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14850 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14855 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14859 */   // MIs[0] offset
     /* 14859 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14864 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ_MM),
     /* 14867 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14871 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14873 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14876 */   GIR_RootConstrainSelectedInstOperands,
     /* 14877 */   // GIR_Coverage, 1111,
     /* 14877 */   GIR_EraseRootFromParent_Done,
     /* 14878 */ // Label 541: @14878
     /* 14878 */ GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(14935), // Rule ID 1112 //
     /* 14883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14886 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14890 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14894 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14898 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14902 */   // MIs[1] Operand 1
     /* 14902 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14907 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14912 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14916 */   // MIs[0] offset
     /* 14916 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14919 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14921 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ_MM),
     /* 14924 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14928 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14930 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14933 */   GIR_RootConstrainSelectedInstOperands,
     /* 14934 */   // GIR_Coverage, 1112,
     /* 14934 */   GIR_EraseRootFromParent_Done,
     /* 14935 */ // Label 542: @14935
     /* 14935 */ GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(14998), // Rule ID 1402 //
     /* 14940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14951 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14955 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14959 */   // MIs[1] Operand 1
     /* 14959 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14964 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14969 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14973 */   // MIs[0] dst
     /* 14973 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14976 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14978 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 14978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 14981 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 14985 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 14991 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 14993 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14996 */   GIR_RootConstrainSelectedInstOperands,
     /* 14997 */   // GIR_Coverage, 1402,
     /* 14997 */   GIR_EraseRootFromParent_Done,
     /* 14998 */ // Label 543: @14998
     /* 14998 */ GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(15061), // Rule ID 1403 //
     /* 15003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15006 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15014 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15018 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15022 */   // MIs[1] Operand 1
     /* 15022 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15027 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15032 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15036 */   // MIs[0] dst
     /* 15036 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15039 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15041 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 15044 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15048 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15054 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15056 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15059 */   GIR_RootConstrainSelectedInstOperands,
     /* 15060 */   // GIR_Coverage, 1403,
     /* 15060 */   GIR_EraseRootFromParent_Done,
     /* 15061 */ // Label 544: @15061
     /* 15061 */ GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(15124), // Rule ID 1548 //
     /* 15066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15069 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15073 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15077 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15081 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15085 */   // MIs[1] Operand 1
     /* 15085 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15090 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15095 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15099 */   // MIs[0] dst
     /* 15099 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15104 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE64 GPR64:{ *:[i64] }:$lhs, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 15104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 15107 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15111 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15117 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15119 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15122 */   GIR_RootConstrainSelectedInstOperands,
     /* 15123 */   // GIR_Coverage, 1548,
     /* 15123 */   GIR_EraseRootFromParent_Done,
     /* 15124 */ // Label 545: @15124
     /* 15124 */ GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(15187), // Rule ID 1549 //
     /* 15129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15140 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15144 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15148 */   // MIs[1] Operand 1
     /* 15148 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15153 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15158 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15162 */   // MIs[0] dst
     /* 15162 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15165 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15167 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ64 GPR64:{ *:[i64] }:$lhs, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 15167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ64),
     /* 15170 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15174 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15180 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15182 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15185 */   GIR_RootConstrainSelectedInstOperands,
     /* 15186 */   // GIR_Coverage, 1549,
     /* 15186 */   GIR_EraseRootFromParent_Done,
     /* 15187 */ // Label 546: @15187
     /* 15187 */ GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(15241), // Rule ID 1856 //
     /* 15192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 15195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15203 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15207 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15211 */   // MIs[1] Operand 1
     /* 15211 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15216 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 15221 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15225 */   // MIs[0] targ16
     /* 15225 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15228 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15230 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$targ16)  =>  (BeqzRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 15230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BeqzRxImm16),
     /* 15233 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 15237 */   GIR_RootToRootCopy, /*OpIdx*/1, // targ16
     /* 15239 */   GIR_RootConstrainSelectedInstOperands,
     /* 15240 */   // GIR_Coverage, 1856,
     /* 15240 */   GIR_EraseRootFromParent_Done,
     /* 15241 */ // Label 547: @15241
     /* 15241 */ GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(15295), // Rule ID 1865 //
     /* 15246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 15249 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15253 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15257 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15261 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15265 */   // MIs[1] Operand 1
     /* 15265 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15270 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 15275 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15279 */   // MIs[0] targ16
     /* 15279 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15282 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15284 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$targ16)  =>  (BnezRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 15284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BnezRxImm16),
     /* 15287 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 15291 */   GIR_RootToRootCopy, /*OpIdx*/1, // targ16
     /* 15293 */   GIR_RootConstrainSelectedInstOperands,
     /* 15294 */   // GIR_Coverage, 1865,
     /* 15294 */   GIR_EraseRootFromParent_Done,
     /* 15295 */ // Label 548: @15295
     /* 15295 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(15358), // Rule ID 2195 //
     /* 15300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15303 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15307 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15311 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15315 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15319 */   // MIs[1] Operand 1
     /* 15319 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15324 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15329 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15333 */   // MIs[0] dst
     /* 15333 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15336 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15338 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE_MM GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 15341 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15345 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15351 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15353 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15356 */   GIR_RootConstrainSelectedInstOperands,
     /* 15357 */   // GIR_Coverage, 2195,
     /* 15357 */   GIR_EraseRootFromParent_Done,
     /* 15358 */ // Label 549: @15358
     /* 15358 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(15421), // Rule ID 2196 //
     /* 15363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15374 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15378 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15382 */   // MIs[1] Operand 1
     /* 15382 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15387 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15392 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15396 */   // MIs[0] dst
     /* 15396 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15399 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15401 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 15404 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15408 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15414 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15416 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15419 */   GIR_RootConstrainSelectedInstOperands,
     /* 15420 */   // GIR_Coverage, 2196,
     /* 15420 */   GIR_EraseRootFromParent_Done,
     /* 15421 */ // Label 550: @15421
     /* 15421 */ GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(15478), // Rule ID 2342 //
     /* 15426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 15429 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15433 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15437 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15441 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15445 */   // MIs[1] Operand 1
     /* 15445 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15450 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15455 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15459 */   // MIs[0] dst
     /* 15459 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15464 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNEZC_MMR6 GPR32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNEZC_MMR6),
     /* 15467 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15471 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15473 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15476 */   GIR_RootConstrainSelectedInstOperands,
     /* 15477 */   // GIR_Coverage, 2342,
     /* 15477 */   GIR_EraseRootFromParent_Done,
     /* 15478 */ // Label 551: @15478
     /* 15478 */ GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(15535), // Rule ID 2343 //
     /* 15483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 15486 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15494 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15498 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15502 */   // MIs[1] Operand 1
     /* 15502 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15507 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15512 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15516 */   // MIs[0] dst
     /* 15516 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15519 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15521 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 GPR32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 15524 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15528 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15530 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15533 */   GIR_RootConstrainSelectedInstOperands,
     /* 15534 */   // GIR_Coverage, 2343,
     /* 15534 */   GIR_EraseRootFromParent_Done,
     /* 15535 */ // Label 552: @15535
     /* 15535 */ GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(15587), // Rule ID 1413 //
     /* 15540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15551 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15555 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15559 */   // MIs[1] Operand 1
     /* 15559 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15564 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15568 */   // MIs[0] dst
     /* 15568 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15573 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, 1:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ),
     /* 15576 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15580 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15582 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15585 */   GIR_RootConstrainSelectedInstOperands,
     /* 15586 */   // GIR_Coverage, 1413,
     /* 15586 */   GIR_EraseRootFromParent_Done,
     /* 15587 */ // Label 553: @15587
     /* 15587 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(15639), // Rule ID 1414 //
     /* 15592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15595 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15603 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15607 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15611 */   // MIs[1] Operand 1
     /* 15611 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15616 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15620 */   // MIs[0] dst
     /* 15620 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15623 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15625 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, -1:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ),
     /* 15628 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15632 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15634 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15637 */   GIR_RootConstrainSelectedInstOperands,
     /* 15638 */   // GIR_Coverage, 1414,
     /* 15638 */   GIR_EraseRootFromParent_Done,
     /* 15639 */ // Label 554: @15639
     /* 15639 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(15691), // Rule ID 1559 //
     /* 15644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15647 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15655 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15659 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15663 */   // MIs[1] Operand 1
     /* 15663 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15668 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15672 */   // MIs[0] dst
     /* 15672 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15675 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15677 */   // (brcond (setcc:{ *:[i32] } i64:{ *:[i64] }:$lhs, 1:{ *:[i64] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ64 i64:{ *:[i64] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ64),
     /* 15680 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15684 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15686 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15689 */   GIR_RootConstrainSelectedInstOperands,
     /* 15690 */   // GIR_Coverage, 1559,
     /* 15690 */   GIR_EraseRootFromParent_Done,
     /* 15691 */ // Label 555: @15691
     /* 15691 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(15743), // Rule ID 1560 //
     /* 15696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15699 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15703 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15707 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15711 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15715 */   // MIs[1] Operand 1
     /* 15715 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15720 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15724 */   // MIs[0] dst
     /* 15724 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15727 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15729 */   // (brcond (setcc:{ *:[i32] } i64:{ *:[i64] }:$lhs, -1:{ *:[i64] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ64 i64:{ *:[i64] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ64),
     /* 15732 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15736 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15738 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15741 */   GIR_RootConstrainSelectedInstOperands,
     /* 15742 */   // GIR_Coverage, 1560,
     /* 15742 */   GIR_EraseRootFromParent_Done,
     /* 15743 */ // Label 556: @15743
     /* 15743 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(15795), // Rule ID 2206 //
     /* 15748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15759 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15763 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15767 */   // MIs[1] Operand 1
     /* 15767 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15772 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15776 */   // MIs[0] dst
     /* 15776 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15781 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, 1:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ_MM i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ_MM),
     /* 15784 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15788 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15790 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15793 */   GIR_RootConstrainSelectedInstOperands,
     /* 15794 */   // GIR_Coverage, 2206,
     /* 15794 */   GIR_EraseRootFromParent_Done,
     /* 15795 */ // Label 557: @15795
     /* 15795 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(15847), // Rule ID 2207 //
     /* 15800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15803 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15807 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15811 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15815 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15819 */   // MIs[1] Operand 1
     /* 15819 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15824 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15828 */   // MIs[0] dst
     /* 15828 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15833 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, -1:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ_MM i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ_MM),
     /* 15836 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15840 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15842 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15845 */   GIR_RootConstrainSelectedInstOperands,
     /* 15846 */   // GIR_Coverage, 2207,
     /* 15846 */   GIR_EraseRootFromParent_Done,
     /* 15847 */ // Label 558: @15847
     /* 15847 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(15909), // Rule ID 92 //
     /* 15852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15855 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15859 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15863 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15867 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15871 */   // MIs[1] Operand 1
     /* 15871 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15876 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15881 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15886 */   // MIs[0] offset
     /* 15886 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15889 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15891 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 15891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 15894 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 15898 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 15902 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 15904 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15907 */   GIR_RootConstrainSelectedInstOperands,
     /* 15908 */   // GIR_Coverage, 92,
     /* 15908 */   GIR_EraseRootFromParent_Done,
     /* 15909 */ // Label 559: @15909
     /* 15909 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(15971), // Rule ID 93 //
     /* 15914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15925 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15929 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15933 */   // MIs[1] Operand 1
     /* 15933 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15938 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15943 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15948 */   // MIs[0] offset
     /* 15948 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15951 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15953 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 15953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 15956 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 15960 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 15964 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 15966 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15969 */   GIR_RootConstrainSelectedInstOperands,
     /* 15970 */   // GIR_Coverage, 93,
     /* 15970 */   GIR_EraseRootFromParent_Done,
     /* 15971 */ // Label 560: @15971
     /* 15971 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(16033), // Rule ID 243 //
     /* 15976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 15979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15987 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15991 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15995 */   // MIs[1] Operand 1
     /* 15995 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 16000 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16005 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16010 */   // MIs[0] offset
     /* 16010 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16013 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16015 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ64 GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ64),
     /* 16018 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16022 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16026 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16028 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16031 */   GIR_RootConstrainSelectedInstOperands,
     /* 16032 */   // GIR_Coverage, 243,
     /* 16032 */   GIR_EraseRootFromParent_Done,
     /* 16033 */ // Label 561: @16033
     /* 16033 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(16095), // Rule ID 244 //
     /* 16038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 16041 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16045 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16049 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16053 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16057 */   // MIs[1] Operand 1
     /* 16057 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 16062 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16067 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16072 */   // MIs[0] offset
     /* 16072 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16077 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE64 GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 16080 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16084 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16088 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16090 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16093 */   GIR_RootConstrainSelectedInstOperands,
     /* 16094 */   // GIR_Coverage, 244,
     /* 16094 */   GIR_EraseRootFromParent_Done,
     /* 16095 */ // Label 562: @16095
     /* 16095 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(16157), // Rule ID 1107 //
     /* 16100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 16103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16111 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16115 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16119 */   // MIs[1] Operand 1
     /* 16119 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 16124 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16129 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16134 */   // MIs[0] offset
     /* 16134 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16137 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16139 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ_MM GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 16142 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16146 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16150 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16152 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16155 */   GIR_RootConstrainSelectedInstOperands,
     /* 16156 */   // GIR_Coverage, 1107,
     /* 16156 */   GIR_EraseRootFromParent_Done,
     /* 16157 */ // Label 563: @16157
     /* 16157 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(16219), // Rule ID 1108 //
     /* 16162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 16165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16173 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16177 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16181 */   // MIs[1] Operand 1
     /* 16181 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 16186 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16191 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16196 */   // MIs[0] offset
     /* 16196 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16199 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16201 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE_MM GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 16204 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16208 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16212 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16214 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16217 */   GIR_RootConstrainSelectedInstOperands,
     /* 16218 */   // GIR_Coverage, 1108,
     /* 16218 */   GIR_EraseRootFromParent_Done,
     /* 16219 */ // Label 564: @16219
     /* 16219 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(16304), // Rule ID 1404 //
     /* 16224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16235 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16239 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16243 */   // MIs[1] Operand 1
     /* 16243 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 16248 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16253 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16258 */   // MIs[0] dst
     /* 16258 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16261 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16263 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 16270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16275 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16279 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16291 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16297 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16299 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16302 */   GIR_RootConstrainSelectedInstOperands,
     /* 16303 */   // GIR_Coverage, 1404,
     /* 16303 */   GIR_EraseRootFromParent_Done,
     /* 16304 */ // Label 565: @16304
     /* 16304 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(16389), // Rule ID 1405 //
     /* 16309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16312 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16316 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16320 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16324 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16328 */   // MIs[1] Operand 1
     /* 16328 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 16333 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16338 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16343 */   // MIs[0] dst
     /* 16343 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16346 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16348 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 16355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16360 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16364 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16376 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16382 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16384 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16387 */   GIR_RootConstrainSelectedInstOperands,
     /* 16388 */   // GIR_Coverage, 1405,
     /* 16388 */   GIR_EraseRootFromParent_Done,
     /* 16389 */ // Label 566: @16389
     /* 16389 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(16474), // Rule ID 1410 //
     /* 16394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16405 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16409 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16413 */   // MIs[1] Operand 1
     /* 16413 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 16418 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16423 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16428 */   // MIs[0] dst
     /* 16428 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16433 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16433 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16436 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 16440 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16445 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16449 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16461 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16467 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16469 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16472 */   GIR_RootConstrainSelectedInstOperands,
     /* 16473 */   // GIR_Coverage, 1410,
     /* 16473 */   GIR_EraseRootFromParent_Done,
     /* 16474 */ // Label 567: @16474
     /* 16474 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(16559), // Rule ID 1411 //
     /* 16479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16490 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16494 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16498 */   // MIs[1] Operand 1
     /* 16498 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 16503 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16508 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16513 */   // MIs[0] dst
     /* 16513 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16516 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16518 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 16525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16530 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16534 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16552 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16554 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16557 */   GIR_RootConstrainSelectedInstOperands,
     /* 16558 */   // GIR_Coverage, 1411,
     /* 16558 */   GIR_EraseRootFromParent_Done,
     /* 16559 */ // Label 568: @16559
     /* 16559 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(16644), // Rule ID 1550 //
     /* 16564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16567 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16571 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16575 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16579 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16583 */   // MIs[1] Operand 1
     /* 16583 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 16588 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16593 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16598 */   // MIs[0] dst
     /* 16598 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16603 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 16610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16615 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16619 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16631 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16637 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16639 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16642 */   GIR_RootConstrainSelectedInstOperands,
     /* 16643 */   // GIR_Coverage, 1550,
     /* 16643 */   GIR_EraseRootFromParent_Done,
     /* 16644 */ // Label 569: @16644
     /* 16644 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(16729), // Rule ID 1551 //
     /* 16649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16660 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16664 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16668 */   // MIs[1] Operand 1
     /* 16668 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 16673 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16678 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16683 */   // MIs[0] dst
     /* 16683 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16686 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16688 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 16695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16700 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16704 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16716 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16722 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16724 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16727 */   GIR_RootConstrainSelectedInstOperands,
     /* 16728 */   // GIR_Coverage, 1551,
     /* 16728 */   GIR_EraseRootFromParent_Done,
     /* 16729 */ // Label 570: @16729
     /* 16729 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(16814), // Rule ID 1556 //
     /* 16734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16745 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16749 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16753 */   // MIs[1] Operand 1
     /* 16753 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 16758 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16763 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16768 */   // MIs[0] dst
     /* 16768 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16773 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16773 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16776 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 16780 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16785 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16789 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16801 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16807 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16809 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16812 */   GIR_RootConstrainSelectedInstOperands,
     /* 16813 */   // GIR_Coverage, 1556,
     /* 16813 */   GIR_EraseRootFromParent_Done,
     /* 16814 */ // Label 571: @16814
     /* 16814 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(16899), // Rule ID 1557 //
     /* 16819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16830 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16834 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16838 */   // MIs[1] Operand 1
     /* 16838 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 16843 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16848 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16853 */   // MIs[0] dst
     /* 16853 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16856 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16858 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 16865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16870 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16874 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16886 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16892 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16894 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16897 */   GIR_RootConstrainSelectedInstOperands,
     /* 16898 */   // GIR_Coverage, 1557,
     /* 16898 */   GIR_EraseRootFromParent_Done,
     /* 16899 */ // Label 572: @16899
     /* 16899 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(16958), // Rule ID 1854 //
     /* 16904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 16907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16915 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16919 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16923 */   // MIs[1] Operand 1
     /* 16923 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 16928 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16933 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16938 */   // MIs[0] imm16
     /* 16938 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16941 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16943 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8CmpX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 16943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8CmpX16),
     /* 16946 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 16950 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 16954 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 16956 */   GIR_RootConstrainSelectedInstOperands,
     /* 16957 */   // GIR_Coverage, 1854,
     /* 16957 */   GIR_EraseRootFromParent_Done,
     /* 16958 */ // Label 573: @16958
     /* 16958 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(17017), // Rule ID 1857 //
     /* 16963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 16966 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16970 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16974 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16978 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16982 */   // MIs[1] Operand 1
     /* 16982 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 16987 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16997 */   // MIs[0] imm16
     /* 16997 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17000 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17002 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8SltX16 CPU16Regs:{ *:[i32] }:$ry, CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$imm16)
     /* 17002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8SltX16),
     /* 17005 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17009 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17013 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17015 */   GIR_RootConstrainSelectedInstOperands,
     /* 17016 */   // GIR_Coverage, 1857,
     /* 17016 */   GIR_EraseRootFromParent_Done,
     /* 17017 */ // Label 574: @17017
     /* 17017 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(17076), // Rule ID 1858 //
     /* 17022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17033 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17037 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17041 */   // MIs[1] Operand 1
     /* 17041 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17051 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17056 */   // MIs[0] imm16
     /* 17056 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17061 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8SltX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8SltX16),
     /* 17064 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17068 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17072 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17074 */   GIR_RootConstrainSelectedInstOperands,
     /* 17075 */   // GIR_Coverage, 1858,
     /* 17075 */   GIR_EraseRootFromParent_Done,
     /* 17076 */ // Label 575: @17076
     /* 17076 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(17135), // Rule ID 1860 //
     /* 17081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17092 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17096 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17100 */   // MIs[1] Operand 1
     /* 17100 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 17105 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17110 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17115 */   // MIs[0] imm16
     /* 17115 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17118 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17120 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8SltX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8SltX16),
     /* 17123 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17127 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17131 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17133 */   GIR_RootConstrainSelectedInstOperands,
     /* 17134 */   // GIR_Coverage, 1860,
     /* 17134 */   GIR_EraseRootFromParent_Done,
     /* 17135 */ // Label 576: @17135
     /* 17135 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(17194), // Rule ID 1862 //
     /* 17140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17151 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17155 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17159 */   // MIs[1] Operand 1
     /* 17159 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17164 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17169 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17174 */   // MIs[0] imm16
     /* 17174 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17177 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17179 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8SltX16 CPU16Regs:{ *:[i32] }:$ry, CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$imm16)
     /* 17179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8SltX16),
     /* 17182 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17186 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17190 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17192 */   GIR_RootConstrainSelectedInstOperands,
     /* 17193 */   // GIR_Coverage, 1862,
     /* 17193 */   GIR_EraseRootFromParent_Done,
     /* 17194 */ // Label 577: @17194
     /* 17194 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(17253), // Rule ID 1863 //
     /* 17199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17210 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17214 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17218 */   // MIs[1] Operand 1
     /* 17218 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 17223 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17228 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17233 */   // MIs[0] imm16
     /* 17233 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17236 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17238 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8CmpX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8CmpX16),
     /* 17241 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17245 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17249 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17251 */   GIR_RootConstrainSelectedInstOperands,
     /* 17252 */   // GIR_Coverage, 1863,
     /* 17252 */   GIR_EraseRootFromParent_Done,
     /* 17253 */ // Label 578: @17253
     /* 17253 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(17338), // Rule ID 2197 //
     /* 17258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17261 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17265 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17269 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17273 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17277 */   // MIs[1] Operand 1
     /* 17277 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17282 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17287 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17292 */   // MIs[0] dst
     /* 17292 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17297 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17297 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17300 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17304 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17309 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17313 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17325 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17331 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17333 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17336 */   GIR_RootConstrainSelectedInstOperands,
     /* 17337 */   // GIR_Coverage, 2197,
     /* 17337 */   GIR_EraseRootFromParent_Done,
     /* 17338 */ // Label 579: @17338
     /* 17338 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(17423), // Rule ID 2198 //
     /* 17343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17354 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17358 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17362 */   // MIs[1] Operand 1
     /* 17362 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 17367 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17372 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17377 */   // MIs[0] dst
     /* 17377 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17380 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17382 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17394 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17410 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17416 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17418 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17421 */   GIR_RootConstrainSelectedInstOperands,
     /* 17422 */   // GIR_Coverage, 2198,
     /* 17422 */   GIR_EraseRootFromParent_Done,
     /* 17423 */ // Label 580: @17423
     /* 17423 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(17508), // Rule ID 2203 //
     /* 17428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17431 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17435 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17439 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17443 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17447 */   // MIs[1] Operand 1
     /* 17447 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17452 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17457 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17462 */   // MIs[0] dst
     /* 17462 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17465 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17467 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17479 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17483 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17495 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17501 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17503 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17506 */   GIR_RootConstrainSelectedInstOperands,
     /* 17507 */   // GIR_Coverage, 2203,
     /* 17507 */   GIR_EraseRootFromParent_Done,
     /* 17508 */ // Label 581: @17508
     /* 17508 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(17593), // Rule ID 2204 //
     /* 17513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17516 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17520 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17524 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17528 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17532 */   // MIs[1] Operand 1
     /* 17532 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 17537 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17542 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17547 */   // MIs[0] dst
     /* 17547 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17550 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17552 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17552 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17555 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17559 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17564 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17568 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17580 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17586 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17588 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17591 */   GIR_RootConstrainSelectedInstOperands,
     /* 17592 */   // GIR_Coverage, 2204,
     /* 17592 */   GIR_EraseRootFromParent_Done,
     /* 17593 */ // Label 582: @17593
     /* 17593 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(17672), // Rule ID 2344 //
     /* 17598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17609 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17613 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17617 */   // MIs[1] Operand 1
     /* 17617 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17622 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17627 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17632 */   // MIs[0] dst
     /* 17632 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17635 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17637 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), (bb:{ *:[Other] }):$dst)
     /* 17637 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17640 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17644 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17649 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17653 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17665 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17667 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17670 */   GIR_RootConstrainSelectedInstOperands,
     /* 17671 */   // GIR_Coverage, 2344,
     /* 17671 */   GIR_EraseRootFromParent_Done,
     /* 17672 */ // Label 583: @17672
     /* 17672 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(17751), // Rule ID 2345 //
     /* 17677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17680 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17684 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17688 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17692 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17696 */   // MIs[1] Operand 1
     /* 17696 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 17701 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17706 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17711 */   // MIs[0] dst
     /* 17711 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17714 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17716 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), (bb:{ *:[Other] }):$dst)
     /* 17716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17728 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17732 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17744 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17746 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17749 */   GIR_RootConstrainSelectedInstOperands,
     /* 17750 */   // GIR_Coverage, 2345,
     /* 17750 */   GIR_EraseRootFromParent_Done,
     /* 17751 */ // Label 584: @17751
     /* 17751 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(17830), // Rule ID 2350 //
     /* 17756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17767 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17771 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17775 */   // MIs[1] Operand 1
     /* 17775 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17780 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17785 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17790 */   // MIs[0] dst
     /* 17790 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17793 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17795 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), (bb:{ *:[Other] }):$dst)
     /* 17795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17807 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17811 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17823 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17825 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17828 */   GIR_RootConstrainSelectedInstOperands,
     /* 17829 */   // GIR_Coverage, 2350,
     /* 17829 */   GIR_EraseRootFromParent_Done,
     /* 17830 */ // Label 585: @17830
     /* 17830 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(17909), // Rule ID 2351 //
     /* 17835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17846 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17850 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17854 */   // MIs[1] Operand 1
     /* 17854 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 17859 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17864 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17869 */   // MIs[0] dst
     /* 17869 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17872 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17874 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), (bb:{ *:[Other] }):$dst)
     /* 17874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17886 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17890 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17902 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17904 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17907 */   GIR_RootConstrainSelectedInstOperands,
     /* 17908 */   // GIR_Coverage, 2351,
     /* 17908 */   GIR_EraseRootFromParent_Done,
     /* 17909 */ // Label 586: @17909
     /* 17909 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(17942), // Rule ID 1412 //
     /* 17914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 17917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17921 */   // MIs[0] dst
     /* 17921 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17924 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE GPR32:{ *:[i32] }:$cond, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 17927 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 17929 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17935 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17937 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17940 */   GIR_RootConstrainSelectedInstOperands,
     /* 17941 */   // GIR_Coverage, 1412,
     /* 17941 */   GIR_EraseRootFromParent_Done,
     /* 17942 */ // Label 587: @17942
     /* 17942 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(17964), // Rule ID 1866 //
     /* 17947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17954 */   // MIs[0] targ16
     /* 17954 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17957 */   // (brcond CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)  =>  (BnezRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 17957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BnezRxImm16),
     /* 17962 */   GIR_RootConstrainSelectedInstOperands,
     /* 17963 */   // GIR_Coverage, 1866,
     /* 17963 */   GIR_Done,
     /* 17964 */ // Label 588: @17964
     /* 17964 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(17997), // Rule ID 2205 //
     /* 17969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17976 */   // MIs[0] dst
     /* 17976 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17979 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE_MM GPR32:{ *:[i32] }:$cond, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 17982 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 17984 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17990 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17992 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17995 */   GIR_RootConstrainSelectedInstOperands,
     /* 17996 */   // GIR_Coverage, 2205,
     /* 17996 */   GIR_EraseRootFromParent_Done,
     /* 17997 */ // Label 589: @17997
     /* 17997 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(18025), // Rule ID 2352 //
     /* 18002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 18005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18009 */   // MIs[0] dst
     /* 18009 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 18012 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNEZC_MMR6 GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)
     /* 18012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BNEZC_MMR6),
     /* 18017 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 18023 */   GIR_RootConstrainSelectedInstOperands,
     /* 18024 */   // GIR_Coverage, 2352,
     /* 18024 */   GIR_Done,
     /* 18025 */ // Label 590: @18025
     /* 18025 */ GIM_Reject,
     /* 18026 */ // Label 521: @18026
     /* 18026 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(18059), // Rule ID 1558 //
     /* 18031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 18034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 18038 */   // MIs[0] dst
     /* 18038 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 18041 */   // (brcond GPR64:{ *:[i64] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE64 GPR64:{ *:[i64] }:$cond, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 18041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 18044 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 18046 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 18052 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 18054 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 18057 */   GIR_RootConstrainSelectedInstOperands,
     /* 18058 */   // GIR_Coverage, 1558,
     /* 18058 */   GIR_EraseRootFromParent_Done,
     /* 18059 */ // Label 591: @18059
     /* 18059 */ GIM_Reject,
     /* 18060 */ // Label 522: @18060
     /* 18060 */ GIM_Reject,
     /* 18061 */ // Label 29: @18061
     /* 18061 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(20058),
     /* 18066 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 18069 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(18116), // Rule ID 428 //
     /* 18074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt8),
     /* 18104 */     // MIs[1] Operand 1
     /* 18104 */     // No operand predicates
     /* 18104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18106 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8123:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immZExt8>>:$imm)  =>  (REPL_QB:{ *:[v4i8] } (imm:{ *:[i32] }):$imm)
     /* 18106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_QB),
     /* 18109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18114 */     GIR_RootConstrainSelectedInstOperands,
     /* 18115 */     // GIR_Coverage, 428,
     /* 18115 */     GIR_EraseRootFromParent_Done,
     /* 18116 */   // Label 593: @18116
     /* 18116 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(18163), // Rule ID 429 //
     /* 18121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt10),
     /* 18151 */     // MIs[1] Operand 1
     /* 18151 */     // No operand predicates
     /* 18151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18153 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8122:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immSExt10>>:$imm)  =>  (REPL_PH:{ *:[v2i16] } (imm:{ *:[i32] }):$imm)
     /* 18153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_PH),
     /* 18156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18161 */     GIR_RootConstrainSelectedInstOperands,
     /* 18162 */     // GIR_Coverage, 429,
     /* 18162 */     GIR_EraseRootFromParent_Done,
     /* 18163 */   // Label 594: @18163
     /* 18163 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(18210), // Rule ID 1288 //
     /* 18168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 18171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt10),
     /* 18198 */     // MIs[1] Operand 1
     /* 18198 */     // No operand predicates
     /* 18198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18200 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8122:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immSExt10>>:$imm)  =>  (REPL_PH_MM:{ *:[v2i16] } (imm:{ *:[i32] }):$imm)
     /* 18200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_PH_MM),
     /* 18203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18208 */     GIR_RootConstrainSelectedInstOperands,
     /* 18209 */     // GIR_Coverage, 1288,
     /* 18209 */     GIR_EraseRootFromParent_Done,
     /* 18210 */   // Label 595: @18210
     /* 18210 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(18257), // Rule ID 1289 //
     /* 18215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 18218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt8),
     /* 18245 */     // MIs[1] Operand 1
     /* 18245 */     // No operand predicates
     /* 18245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18247 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8123:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immZExt8>>:$imm)  =>  (REPL_QB_MM:{ *:[v4i8] } (imm:{ *:[i32] }):$imm)
     /* 18247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_QB_MM),
     /* 18250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 18252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18255 */     GIR_RootConstrainSelectedInstOperands,
     /* 18256 */     // GIR_Coverage, 1289,
     /* 18256 */     GIR_EraseRootFromParent_Done,
     /* 18257 */   // Label 596: @18257
     /* 18257 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(18293), // Rule ID 362 //
     /* 18262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_raddu_w_qb),
     /* 18270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18284 */     // (intrinsic_wo_chain:{ *:[i32] } 8120:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (RADDU_W_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 18284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RADDU_W_QB),
     /* 18287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 18291 */     GIR_RootConstrainSelectedInstOperands,
     /* 18292 */     // GIR_Coverage, 362,
     /* 18292 */     GIR_EraseRootFromParent_Done,
     /* 18293 */   // Label 597: @18293
     /* 18293 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(18329), // Rule ID 369 //
     /* 18298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phl),
     /* 18306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 18312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18320 */     // (intrinsic_wo_chain:{ *:[i32] } 8102:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECEQ_W_PHL:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 18320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHL),
     /* 18323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18327 */     GIR_RootConstrainSelectedInstOperands,
     /* 18328 */     // GIR_Coverage, 369,
     /* 18328 */     GIR_EraseRootFromParent_Done,
     /* 18329 */   // Label 598: @18329
     /* 18329 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(18365), // Rule ID 370 //
     /* 18334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phr),
     /* 18342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 18348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18356 */     // (intrinsic_wo_chain:{ *:[i32] } 8103:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECEQ_W_PHR:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 18356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHR),
     /* 18359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18363 */     GIR_RootConstrainSelectedInstOperands,
     /* 18364 */     // GIR_Coverage, 370,
     /* 18364 */     GIR_EraseRootFromParent_Done,
     /* 18365 */   // Label 599: @18365
     /* 18365 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(18401), // Rule ID 371 //
     /* 18370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbl),
     /* 18378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18392 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8104:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBL),
     /* 18395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18399 */     GIR_RootConstrainSelectedInstOperands,
     /* 18400 */     // GIR_Coverage, 371,
     /* 18400 */     GIR_EraseRootFromParent_Done,
     /* 18401 */   // Label 600: @18401
     /* 18401 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(18437), // Rule ID 372 //
     /* 18406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbr),
     /* 18414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18428 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8106:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBR),
     /* 18431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18435 */     GIR_RootConstrainSelectedInstOperands,
     /* 18436 */     // GIR_Coverage, 372,
     /* 18436 */     GIR_EraseRootFromParent_Done,
     /* 18437 */   // Label 601: @18437
     /* 18437 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(18473), // Rule ID 373 //
     /* 18442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbla),
     /* 18450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18464 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8105:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBLA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBLA),
     /* 18467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18471 */     GIR_RootConstrainSelectedInstOperands,
     /* 18472 */     // GIR_Coverage, 373,
     /* 18472 */     GIR_EraseRootFromParent_Done,
     /* 18473 */   // Label 602: @18473
     /* 18473 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(18509), // Rule ID 374 //
     /* 18478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbra),
     /* 18486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18500 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8107:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBRA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBRA),
     /* 18503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18507 */     GIR_RootConstrainSelectedInstOperands,
     /* 18508 */     // GIR_Coverage, 374,
     /* 18508 */     GIR_EraseRootFromParent_Done,
     /* 18509 */   // Label 603: @18509
     /* 18509 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(18545), // Rule ID 375 //
     /* 18514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbl),
     /* 18522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18536 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8108:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBL),
     /* 18539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18543 */     GIR_RootConstrainSelectedInstOperands,
     /* 18544 */     // GIR_Coverage, 375,
     /* 18544 */     GIR_EraseRootFromParent_Done,
     /* 18545 */   // Label 604: @18545
     /* 18545 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(18581), // Rule ID 376 //
     /* 18550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbr),
     /* 18558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18572 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8110:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBR),
     /* 18575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18579 */     GIR_RootConstrainSelectedInstOperands,
     /* 18580 */     // GIR_Coverage, 376,
     /* 18580 */     GIR_EraseRootFromParent_Done,
     /* 18581 */   // Label 605: @18581
     /* 18581 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(18617), // Rule ID 377 //
     /* 18586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbla),
     /* 18594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18608 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8109:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBLA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBLA),
     /* 18611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18615 */     GIR_RootConstrainSelectedInstOperands,
     /* 18616 */     // GIR_Coverage, 377,
     /* 18616 */     GIR_EraseRootFromParent_Done,
     /* 18617 */   // Label 606: @18617
     /* 18617 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(18653), // Rule ID 378 //
     /* 18622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbra),
     /* 18630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18644 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8111:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBRA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBRA),
     /* 18647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18651 */     GIR_RootConstrainSelectedInstOperands,
     /* 18652 */     // GIR_Coverage, 378,
     /* 18652 */     GIR_EraseRootFromParent_Done,
     /* 18653 */   // Label 607: @18653
     /* 18653 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(18689), // Rule ID 426 //
     /* 18658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bitrev),
     /* 18666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18680 */     // (intrinsic_wo_chain:{ *:[i32] } 7676:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (BITREV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BITREV),
     /* 18683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18687 */     GIR_RootConstrainSelectedInstOperands,
     /* 18688 */     // GIR_Coverage, 426,
     /* 18688 */     GIR_EraseRootFromParent_Done,
     /* 18689 */   // Label 608: @18689
     /* 18689 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(18725), // Rule ID 430 //
     /* 18694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18716 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8123:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (REPLV_QB:{ *:[v4i8] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_QB),
     /* 18719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18723 */     GIR_RootConstrainSelectedInstOperands,
     /* 18724 */     // GIR_Coverage, 430,
     /* 18724 */     GIR_EraseRootFromParent_Done,
     /* 18725 */   // Label 609: @18725
     /* 18725 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(18761), // Rule ID 431 //
     /* 18730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18752 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8122:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (REPLV_PH:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_PH),
     /* 18755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18759 */     GIR_RootConstrainSelectedInstOperands,
     /* 18760 */     // GIR_Coverage, 431,
     /* 18760 */     GIR_EraseRootFromParent_Done,
     /* 18761 */   // Label 610: @18761
     /* 18761 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(18797), // Rule ID 680 //
     /* 18766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fclass_w),
     /* 18774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18788 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7828:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FCLASS_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCLASS_W),
     /* 18791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18793 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18795 */     GIR_RootConstrainSelectedInstOperands,
     /* 18796 */     // GIR_Coverage, 680,
     /* 18796 */     GIR_EraseRootFromParent_Done,
     /* 18797 */   // Label 611: @18797
     /* 18797 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(18833), // Rule ID 681 //
     /* 18802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fclass_d),
     /* 18810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 18816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18824 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7827:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FCLASS_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 18824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCLASS_D),
     /* 18827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18829 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18831 */     GIR_RootConstrainSelectedInstOperands,
     /* 18832 */     // GIR_Coverage, 681,
     /* 18832 */     GIR_EraseRootFromParent_Done,
     /* 18833 */   // Label 612: @18833
     /* 18833 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(18869), // Rule ID 704 //
     /* 18838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupl_w),
     /* 18846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 18860 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7854:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8f16] }:$ws)  =>  (FEXUPL_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8f16] }:$ws)
     /* 18860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPL_W),
     /* 18863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18865 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18867 */     GIR_RootConstrainSelectedInstOperands,
     /* 18868 */     // GIR_Coverage, 704,
     /* 18868 */     GIR_EraseRootFromParent_Done,
     /* 18869 */   // Label 613: @18869
     /* 18869 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(18905), // Rule ID 705 //
     /* 18874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupl_d),
     /* 18882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18896 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7853:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXUPL_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPL_D),
     /* 18899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18901 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18903 */     GIR_RootConstrainSelectedInstOperands,
     /* 18904 */     // GIR_Coverage, 705,
     /* 18904 */     GIR_EraseRootFromParent_Done,
     /* 18905 */   // Label 614: @18905
     /* 18905 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(18941), // Rule ID 706 //
     /* 18910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupr_w),
     /* 18918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 18932 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7856:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8f16] }:$ws)  =>  (FEXUPR_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8f16] }:$ws)
     /* 18932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPR_W),
     /* 18935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18937 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18939 */     GIR_RootConstrainSelectedInstOperands,
     /* 18940 */     // GIR_Coverage, 706,
     /* 18940 */     GIR_EraseRootFromParent_Done,
     /* 18941 */   // Label 615: @18941
     /* 18941 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(18977), // Rule ID 707 //
     /* 18946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupr_d),
     /* 18954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18968 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7855:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXUPR_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPR_D),
     /* 18971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18973 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18975 */     GIR_RootConstrainSelectedInstOperands,
     /* 18976 */     // GIR_Coverage, 707,
     /* 18976 */     GIR_EraseRootFromParent_Done,
     /* 18977 */   // Label 616: @18977
     /* 18977 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(19013), // Rule ID 712 //
     /* 18982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffql_w),
     /* 18990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19004 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7862:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (FFQL_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 19004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQL_W),
     /* 19007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19009 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19011 */     GIR_RootConstrainSelectedInstOperands,
     /* 19012 */     // GIR_Coverage, 712,
     /* 19012 */     GIR_EraseRootFromParent_Done,
     /* 19013 */   // Label 617: @19013
     /* 19013 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(19049), // Rule ID 713 //
     /* 19018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffql_d),
     /* 19026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19040 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7861:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFQL_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQL_D),
     /* 19043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19045 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19047 */     GIR_RootConstrainSelectedInstOperands,
     /* 19048 */     // GIR_Coverage, 713,
     /* 19048 */     GIR_EraseRootFromParent_Done,
     /* 19049 */   // Label 618: @19049
     /* 19049 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(19085), // Rule ID 714 //
     /* 19054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffqr_w),
     /* 19062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 19068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19076 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7864:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (FFQR_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 19076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQR_W),
     /* 19079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19081 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19083 */     GIR_RootConstrainSelectedInstOperands,
     /* 19084 */     // GIR_Coverage, 714,
     /* 19084 */     GIR_EraseRootFromParent_Done,
     /* 19085 */   // Label 619: @19085
     /* 19085 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(19121), // Rule ID 715 //
     /* 19090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffqr_d),
     /* 19098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19112 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7863:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFQR_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQR_D),
     /* 19115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19117 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19119 */     GIR_RootConstrainSelectedInstOperands,
     /* 19120 */     // GIR_Coverage, 715,
     /* 19120 */     GIR_EraseRootFromParent_Done,
     /* 19121 */   // Label 620: @19121
     /* 19121 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(19157), // Rule ID 740 //
     /* 19126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frcp_w),
     /* 19134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19148 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7886:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRCP_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRCP_W),
     /* 19151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19153 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19155 */     GIR_RootConstrainSelectedInstOperands,
     /* 19156 */     // GIR_Coverage, 740,
     /* 19156 */     GIR_EraseRootFromParent_Done,
     /* 19157 */   // Label 621: @19157
     /* 19157 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(19193), // Rule ID 741 //
     /* 19162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frcp_d),
     /* 19170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19184 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7885:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRCP_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRCP_D),
     /* 19187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19189 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19191 */     GIR_RootConstrainSelectedInstOperands,
     /* 19192 */     // GIR_Coverage, 741,
     /* 19192 */     GIR_EraseRootFromParent_Done,
     /* 19193 */   // Label 622: @19193
     /* 19193 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(19229), // Rule ID 742 //
     /* 19198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frsqrt_w),
     /* 19206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19220 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7890:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRSQRT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRSQRT_W),
     /* 19223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19225 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19227 */     GIR_RootConstrainSelectedInstOperands,
     /* 19228 */     // GIR_Coverage, 742,
     /* 19228 */     GIR_EraseRootFromParent_Done,
     /* 19229 */   // Label 623: @19229
     /* 19229 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(19265), // Rule ID 743 //
     /* 19234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frsqrt_d),
     /* 19242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19256 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7889:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRSQRT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRSQRT_D),
     /* 19259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19261 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19263 */     GIR_RootConstrainSelectedInstOperands,
     /* 19264 */     // GIR_Coverage, 743,
     /* 19264 */     GIR_EraseRootFromParent_Done,
     /* 19265 */   // Label 624: @19265
     /* 19265 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(19301), // Rule ID 770 //
     /* 19270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_s_w),
     /* 19278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19292 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7918:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTINT_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_S_W),
     /* 19295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19297 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19299 */     GIR_RootConstrainSelectedInstOperands,
     /* 19300 */     // GIR_Coverage, 770,
     /* 19300 */     GIR_EraseRootFromParent_Done,
     /* 19301 */   // Label 625: @19301
     /* 19301 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(19337), // Rule ID 771 //
     /* 19306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_s_d),
     /* 19314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19328 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7917:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTINT_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_S_D),
     /* 19331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19333 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19335 */     GIR_RootConstrainSelectedInstOperands,
     /* 19336 */     // GIR_Coverage, 771,
     /* 19336 */     GIR_EraseRootFromParent_Done,
     /* 19337 */   // Label 626: @19337
     /* 19337 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(19373), // Rule ID 772 //
     /* 19342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_u_w),
     /* 19350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19364 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7920:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTINT_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_U_W),
     /* 19367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19369 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19371 */     GIR_RootConstrainSelectedInstOperands,
     /* 19372 */     // GIR_Coverage, 772,
     /* 19372 */     GIR_EraseRootFromParent_Done,
     /* 19373 */   // Label 627: @19373
     /* 19373 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(19409), // Rule ID 773 //
     /* 19378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_u_d),
     /* 19386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19400 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7919:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTINT_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_U_D),
     /* 19403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19405 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19407 */     GIR_RootConstrainSelectedInstOperands,
     /* 19408 */     // GIR_Coverage, 773,
     /* 19408 */     GIR_EraseRootFromParent_Done,
     /* 19409 */   // Label 628: @19409
     /* 19409 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(19445), // Rule ID 908 //
     /* 19414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_b),
     /* 19422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 19425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 19428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 19432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 19436 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8075:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (NLOC_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 19436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_B),
     /* 19439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19441 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19443 */     GIR_RootConstrainSelectedInstOperands,
     /* 19444 */     // GIR_Coverage, 908,
     /* 19444 */     GIR_EraseRootFromParent_Done,
     /* 19445 */   // Label 629: @19445
     /* 19445 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(19481), // Rule ID 909 //
     /* 19450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_h),
     /* 19458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 19461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 19464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19472 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8077:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (NLOC_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 19472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_H),
     /* 19475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19477 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19479 */     GIR_RootConstrainSelectedInstOperands,
     /* 19480 */     // GIR_Coverage, 909,
     /* 19480 */     GIR_EraseRootFromParent_Done,
     /* 19481 */   // Label 630: @19481
     /* 19481 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(19517), // Rule ID 910 //
     /* 19486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_w),
     /* 19494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19508 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8078:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (NLOC_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_W),
     /* 19511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19513 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19515 */     GIR_RootConstrainSelectedInstOperands,
     /* 19516 */     // GIR_Coverage, 910,
     /* 19516 */     GIR_EraseRootFromParent_Done,
     /* 19517 */   // Label 631: @19517
     /* 19517 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(19553), // Rule ID 911 //
     /* 19522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_d),
     /* 19530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19544 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8076:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (NLOC_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 19544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_D),
     /* 19547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19549 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19551 */     GIR_RootConstrainSelectedInstOperands,
     /* 19552 */     // GIR_Coverage, 911,
     /* 19552 */     GIR_EraseRootFromParent_Done,
     /* 19553 */   // Label 632: @19553
     /* 19553 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(19589), // Rule ID 1251 //
     /* 19558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phl),
     /* 19566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 19572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19580 */     // (intrinsic_wo_chain:{ *:[i32] } 8102:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (PRECEQ_W_PHL_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 19580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHL_MM),
     /* 19583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19587 */     GIR_RootConstrainSelectedInstOperands,
     /* 19588 */     // GIR_Coverage, 1251,
     /* 19588 */     GIR_EraseRootFromParent_Done,
     /* 19589 */   // Label 633: @19589
     /* 19589 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(19625), // Rule ID 1252 //
     /* 19594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phr),
     /* 19602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 19608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19616 */     // (intrinsic_wo_chain:{ *:[i32] } 8103:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (PRECEQ_W_PHR_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 19616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHR_MM),
     /* 19619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19623 */     GIR_RootConstrainSelectedInstOperands,
     /* 19624 */     // GIR_Coverage, 1252,
     /* 19624 */     GIR_EraseRootFromParent_Done,
     /* 19625 */   // Label 634: @19625
     /* 19625 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(19661), // Rule ID 1253 //
     /* 19630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbl),
     /* 19638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19652 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8104:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBL_MM),
     /* 19655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19659 */     GIR_RootConstrainSelectedInstOperands,
     /* 19660 */     // GIR_Coverage, 1253,
     /* 19660 */     GIR_EraseRootFromParent_Done,
     /* 19661 */   // Label 635: @19661
     /* 19661 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(19697), // Rule ID 1254 //
     /* 19666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbla),
     /* 19674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19688 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8105:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBLA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBLA_MM),
     /* 19691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19695 */     GIR_RootConstrainSelectedInstOperands,
     /* 19696 */     // GIR_Coverage, 1254,
     /* 19696 */     GIR_EraseRootFromParent_Done,
     /* 19697 */   // Label 636: @19697
     /* 19697 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(19733), // Rule ID 1255 //
     /* 19702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbr),
     /* 19710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19724 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8106:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBR_MM),
     /* 19727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19731 */     GIR_RootConstrainSelectedInstOperands,
     /* 19732 */     // GIR_Coverage, 1255,
     /* 19732 */     GIR_EraseRootFromParent_Done,
     /* 19733 */   // Label 637: @19733
     /* 19733 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(19769), // Rule ID 1256 //
     /* 19738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbra),
     /* 19746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19760 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8107:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBRA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBRA_MM),
     /* 19763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19767 */     GIR_RootConstrainSelectedInstOperands,
     /* 19768 */     // GIR_Coverage, 1256,
     /* 19768 */     GIR_EraseRootFromParent_Done,
     /* 19769 */   // Label 638: @19769
     /* 19769 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(19805), // Rule ID 1257 //
     /* 19774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbl),
     /* 19782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19796 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8108:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBL_MM),
     /* 19799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19803 */     GIR_RootConstrainSelectedInstOperands,
     /* 19804 */     // GIR_Coverage, 1257,
     /* 19804 */     GIR_EraseRootFromParent_Done,
     /* 19805 */   // Label 639: @19805
     /* 19805 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(19841), // Rule ID 1258 //
     /* 19810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbla),
     /* 19818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19832 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8109:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBLA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBLA_MM),
     /* 19835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19839 */     GIR_RootConstrainSelectedInstOperands,
     /* 19840 */     // GIR_Coverage, 1258,
     /* 19840 */     GIR_EraseRootFromParent_Done,
     /* 19841 */   // Label 640: @19841
     /* 19841 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(19877), // Rule ID 1259 //
     /* 19846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbr),
     /* 19854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19868 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8110:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBR_MM),
     /* 19871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19875 */     GIR_RootConstrainSelectedInstOperands,
     /* 19876 */     // GIR_Coverage, 1259,
     /* 19876 */     GIR_EraseRootFromParent_Done,
     /* 19877 */   // Label 641: @19877
     /* 19877 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(19913), // Rule ID 1260 //
     /* 19882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbra),
     /* 19890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19904 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8111:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBRA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBRA_MM),
     /* 19907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19911 */     GIR_RootConstrainSelectedInstOperands,
     /* 19912 */     // GIR_Coverage, 1260,
     /* 19912 */     GIR_EraseRootFromParent_Done,
     /* 19913 */   // Label 642: @19913
     /* 19913 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(19949), // Rule ID 1286 //
     /* 19918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_raddu_w_qb),
     /* 19926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19940 */     // (intrinsic_wo_chain:{ *:[i32] } 8120:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (RADDU_W_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RADDU_W_QB_MM),
     /* 19943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19947 */     GIR_RootConstrainSelectedInstOperands,
     /* 19948 */     // GIR_Coverage, 1286,
     /* 19948 */     GIR_EraseRootFromParent_Done,
     /* 19949 */   // Label 643: @19949
     /* 19949 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(19985), // Rule ID 1290 //
     /* 19954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 19962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 19968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19976 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8122:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (REPLV_PH_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 19976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_PH_MM),
     /* 19979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19983 */     GIR_RootConstrainSelectedInstOperands,
     /* 19984 */     // GIR_Coverage, 1290,
     /* 19984 */     GIR_EraseRootFromParent_Done,
     /* 19985 */   // Label 644: @19985
     /* 19985 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(20021), // Rule ID 1291 //
     /* 19990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 19998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 20001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 20004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20012 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8123:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (REPLV_QB_MM:{ *:[v4i8] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 20012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_QB_MM),
     /* 20015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 20017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 20019 */     GIR_RootConstrainSelectedInstOperands,
     /* 20020 */     // GIR_Coverage, 1291,
     /* 20020 */     GIR_EraseRootFromParent_Done,
     /* 20021 */   // Label 645: @20021
     /* 20021 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(20057), // Rule ID 1301 //
     /* 20026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 20029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bitrev),
     /* 20034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 20037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 20040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20048 */     // (intrinsic_wo_chain:{ *:[i32] } 7676:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (BITREV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 20048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BITREV_MM),
     /* 20051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 20053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 20055 */     GIR_RootConstrainSelectedInstOperands,
     /* 20056 */     // GIR_Coverage, 1301,
     /* 20056 */     GIR_EraseRootFromParent_Done,
     /* 20057 */   // Label 646: @20057
     /* 20057 */   GIM_Reject,
     /* 20058 */ // Label 592: @20058
     /* 20058 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(29811),
     /* 20063 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 20066 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(20112), // Rule ID 938 //
     /* 20071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_b),
     /* 20079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20093 */     // MIs[0] m
     /* 20093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20101 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8124:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SAT_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_B),
     /* 20104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20106 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20108 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20110 */     GIR_RootConstrainSelectedInstOperands,
     /* 20111 */     // GIR_Coverage, 938,
     /* 20111 */     GIR_EraseRootFromParent_Done,
     /* 20112 */   // Label 648: @20112
     /* 20112 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(20158), // Rule ID 939 //
     /* 20117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_h),
     /* 20125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20139 */     // MIs[0] m
     /* 20139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20147 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8126:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SAT_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_H),
     /* 20150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20152 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20154 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20156 */     GIR_RootConstrainSelectedInstOperands,
     /* 20157 */     // GIR_Coverage, 939,
     /* 20157 */     GIR_EraseRootFromParent_Done,
     /* 20158 */   // Label 649: @20158
     /* 20158 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(20204), // Rule ID 940 //
     /* 20163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_w),
     /* 20171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20185 */     // MIs[0] m
     /* 20185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20193 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8127:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SAT_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_W),
     /* 20196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20198 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20200 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20202 */     GIR_RootConstrainSelectedInstOperands,
     /* 20203 */     // GIR_Coverage, 940,
     /* 20203 */     GIR_EraseRootFromParent_Done,
     /* 20204 */   // Label 650: @20204
     /* 20204 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(20250), // Rule ID 941 //
     /* 20209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_d),
     /* 20217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20231 */     // MIs[0] m
     /* 20231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20239 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8125:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SAT_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_D),
     /* 20242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20244 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20246 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20248 */     GIR_RootConstrainSelectedInstOperands,
     /* 20249 */     // GIR_Coverage, 941,
     /* 20249 */     GIR_EraseRootFromParent_Done,
     /* 20250 */   // Label 651: @20250
     /* 20250 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(20296), // Rule ID 942 //
     /* 20255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_b),
     /* 20263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20277 */     // MIs[0] m
     /* 20277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20285 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8128:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SAT_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_B),
     /* 20288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20290 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20292 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20294 */     GIR_RootConstrainSelectedInstOperands,
     /* 20295 */     // GIR_Coverage, 942,
     /* 20295 */     GIR_EraseRootFromParent_Done,
     /* 20296 */   // Label 652: @20296
     /* 20296 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(20342), // Rule ID 943 //
     /* 20301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_h),
     /* 20309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20323 */     // MIs[0] m
     /* 20323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20331 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8130:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SAT_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_H),
     /* 20334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20336 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20338 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20340 */     GIR_RootConstrainSelectedInstOperands,
     /* 20341 */     // GIR_Coverage, 943,
     /* 20341 */     GIR_EraseRootFromParent_Done,
     /* 20342 */   // Label 653: @20342
     /* 20342 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(20388), // Rule ID 944 //
     /* 20347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_w),
     /* 20355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20369 */     // MIs[0] m
     /* 20369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20377 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8131:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SAT_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_W),
     /* 20380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20382 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20384 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20386 */     GIR_RootConstrainSelectedInstOperands,
     /* 20387 */     // GIR_Coverage, 944,
     /* 20387 */     GIR_EraseRootFromParent_Done,
     /* 20388 */   // Label 654: @20388
     /* 20388 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(20434), // Rule ID 945 //
     /* 20393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_d),
     /* 20401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20415 */     // MIs[0] m
     /* 20415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20423 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8129:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SAT_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_D),
     /* 20426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20428 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20430 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20432 */     GIR_RootConstrainSelectedInstOperands,
     /* 20433 */     // GIR_Coverage, 945,
     /* 20433 */     GIR_EraseRootFromParent_Done,
     /* 20434 */   // Label 655: @20434
     /* 20434 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(20480), // Rule ID 985 //
     /* 20439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_b),
     /* 20447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20461 */     // MIs[0] m
     /* 20461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20469 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8183:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SRARI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_B),
     /* 20472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20474 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20476 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20478 */     GIR_RootConstrainSelectedInstOperands,
     /* 20479 */     // GIR_Coverage, 985,
     /* 20479 */     GIR_EraseRootFromParent_Done,
     /* 20480 */   // Label 656: @20480
     /* 20480 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(20526), // Rule ID 986 //
     /* 20485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_h),
     /* 20493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20507 */     // MIs[0] m
     /* 20507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20515 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8185:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SRARI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_H),
     /* 20518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20520 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20522 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20524 */     GIR_RootConstrainSelectedInstOperands,
     /* 20525 */     // GIR_Coverage, 986,
     /* 20525 */     GIR_EraseRootFromParent_Done,
     /* 20526 */   // Label 657: @20526
     /* 20526 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(20572), // Rule ID 987 //
     /* 20531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_w),
     /* 20539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20553 */     // MIs[0] m
     /* 20553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20561 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8186:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SRARI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_W),
     /* 20564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20566 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20568 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20570 */     GIR_RootConstrainSelectedInstOperands,
     /* 20571 */     // GIR_Coverage, 987,
     /* 20571 */     GIR_EraseRootFromParent_Done,
     /* 20572 */   // Label 658: @20572
     /* 20572 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(20618), // Rule ID 988 //
     /* 20577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_d),
     /* 20585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20599 */     // MIs[0] m
     /* 20599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20607 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8184:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SRARI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_D),
     /* 20610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20612 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20614 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20616 */     GIR_RootConstrainSelectedInstOperands,
     /* 20617 */     // GIR_Coverage, 988,
     /* 20617 */     GIR_EraseRootFromParent_Done,
     /* 20618 */   // Label 659: @20618
     /* 20618 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(20664), // Rule ID 1001 //
     /* 20623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_b),
     /* 20631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20645 */     // MIs[0] m
     /* 20645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20653 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8199:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SRLRI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_B),
     /* 20656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20658 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20660 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20662 */     GIR_RootConstrainSelectedInstOperands,
     /* 20663 */     // GIR_Coverage, 1001,
     /* 20663 */     GIR_EraseRootFromParent_Done,
     /* 20664 */   // Label 660: @20664
     /* 20664 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(20710), // Rule ID 1002 //
     /* 20669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_h),
     /* 20677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20691 */     // MIs[0] m
     /* 20691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20699 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8201:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SRLRI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_H),
     /* 20702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20704 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20706 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20708 */     GIR_RootConstrainSelectedInstOperands,
     /* 20709 */     // GIR_Coverage, 1002,
     /* 20709 */     GIR_EraseRootFromParent_Done,
     /* 20710 */   // Label 661: @20710
     /* 20710 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(20756), // Rule ID 1003 //
     /* 20715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_w),
     /* 20723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20737 */     // MIs[0] m
     /* 20737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20745 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8202:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SRLRI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_W),
     /* 20748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20750 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20752 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20754 */     GIR_RootConstrainSelectedInstOperands,
     /* 20755 */     // GIR_Coverage, 1003,
     /* 20755 */     GIR_EraseRootFromParent_Done,
     /* 20756 */   // Label 662: @20756
     /* 20756 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(20802), // Rule ID 1004 //
     /* 20761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_d),
     /* 20769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20783 */     // MIs[0] m
     /* 20783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20791 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8200:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SRLRI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_D),
     /* 20794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20796 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20798 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20800 */     GIR_RootConstrainSelectedInstOperands,
     /* 20801 */     // GIR_Coverage, 1004,
     /* 20801 */     GIR_EraseRootFromParent_Done,
     /* 20802 */   // Label 663: @20802
     /* 20802 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(20858), // Rule ID 385 //
     /* 20807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 20810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 20815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 20818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 20821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 20844 */     // MIs[1] Operand 1
     /* 20844 */     // No operand predicates
     /* 20844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20846 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8142:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$rs_sa)  =>  (SHRA_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_PH),
     /* 20849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20856 */     GIR_RootConstrainSelectedInstOperands,
     /* 20857 */     // GIR_Coverage, 385,
     /* 20857 */     GIR_EraseRootFromParent_Done,
     /* 20858 */   // Label 664: @20858
     /* 20858 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(20914), // Rule ID 389 //
     /* 20863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 20866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 20871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 20874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 20877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 20900 */     // MIs[1] Operand 1
     /* 20900 */     // No operand predicates
     /* 20900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20902 */     // (intrinsic_wo_chain:{ *:[i32] } 8144:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$rs_sa)  =>  (SHRA_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_W),
     /* 20905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20912 */     GIR_RootConstrainSelectedInstOperands,
     /* 20913 */     // GIR_Coverage, 389,
     /* 20913 */     GIR_EraseRootFromParent_Done,
     /* 20914 */   // Label 665: @20914
     /* 20914 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(20970), // Rule ID 480 //
     /* 20919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 20922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 20927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 20930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 20933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 20956 */     // MIs[1] Operand 1
     /* 20956 */     // No operand predicates
     /* 20956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20958 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8143:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$rs_sa)  =>  (SHRA_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_QB),
     /* 20961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20968 */     GIR_RootConstrainSelectedInstOperands,
     /* 20969 */     // GIR_Coverage, 480,
     /* 20969 */     GIR_EraseRootFromParent_Done,
     /* 20970 */   // Label 666: @20970
     /* 20970 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(21026), // Rule ID 1245 //
     /* 20975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 20978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 20983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 20986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 20989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21012 */     // MIs[1] Operand 1
     /* 21012 */     // No operand predicates
     /* 21012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21014 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8142:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$sa)  =>  (SHRA_R_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_PH_MM),
     /* 21017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21024 */     GIR_RootConstrainSelectedInstOperands,
     /* 21025 */     // GIR_Coverage, 1245,
     /* 21025 */     GIR_EraseRootFromParent_Done,
     /* 21026 */   // Label 667: @21026
     /* 21026 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(21082), // Rule ID 1249 //
     /* 21031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 21034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 21039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 21068 */     // MIs[1] Operand 1
     /* 21068 */     // No operand predicates
     /* 21068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21070 */     // (intrinsic_wo_chain:{ *:[i32] } 8144:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$sa)  =>  (SHRA_R_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_W_MM),
     /* 21073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21080 */     GIR_RootConstrainSelectedInstOperands,
     /* 21081 */     // GIR_Coverage, 1249,
     /* 21081 */     GIR_EraseRootFromParent_Done,
     /* 21082 */   // Label 668: @21082
     /* 21082 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(21138), // Rule ID 1324 //
     /* 21087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 21090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 21095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21124 */     // MIs[1] Operand 1
     /* 21124 */     // No operand predicates
     /* 21124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21126 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8143:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$sa)  =>  (SHRA_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_QB_MMR2),
     /* 21129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21136 */     GIR_RootConstrainSelectedInstOperands,
     /* 21137 */     // GIR_Coverage, 1324,
     /* 21137 */     GIR_EraseRootFromParent_Done,
     /* 21138 */   // Label 669: @21138
     /* 21138 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(21190), // Rule ID 1943 //
     /* 21143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 21151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21176 */     // MIs[1] Operand 1
     /* 21176 */     // No operand predicates
     /* 21176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21178 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8140:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHRA_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 21178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_PH),
     /* 21181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21183 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21188 */     GIR_RootConstrainSelectedInstOperands,
     /* 21189 */     // GIR_Coverage, 1943,
     /* 21189 */     GIR_EraseRootFromParent_Done,
     /* 21190 */   // Label 670: @21190
     /* 21190 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(21242), // Rule ID 1944 //
     /* 21195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 21203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21228 */     // MIs[1] Operand 1
     /* 21228 */     // No operand predicates
     /* 21228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21230 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8145:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHRL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 21230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRL_PH),
     /* 21233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21235 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21240 */     GIR_RootConstrainSelectedInstOperands,
     /* 21241 */     // GIR_Coverage, 1944,
     /* 21241 */     GIR_EraseRootFromParent_Done,
     /* 21242 */   // Label 671: @21242
     /* 21242 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(21294), // Rule ID 1949 //
     /* 21247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 21255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21280 */     // MIs[1] Operand 1
     /* 21280 */     // No operand predicates
     /* 21280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21282 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8141:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHRA_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 21282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_QB),
     /* 21285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21287 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21292 */     GIR_RootConstrainSelectedInstOperands,
     /* 21293 */     // GIR_Coverage, 1949,
     /* 21293 */     GIR_EraseRootFromParent_Done,
     /* 21294 */   // Label 672: @21294
     /* 21294 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(21346), // Rule ID 1950 //
     /* 21299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 21307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21332 */     // MIs[1] Operand 1
     /* 21332 */     // No operand predicates
     /* 21332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21334 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8146:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHRL_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 21334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRL_QB),
     /* 21337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21339 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21344 */     GIR_RootConstrainSelectedInstOperands,
     /* 21345 */     // GIR_Coverage, 1950,
     /* 21345 */     GIR_EraseRootFromParent_Done,
     /* 21346 */   // Label 673: @21346
     /* 21346 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(21394), // Rule ID 355 //
     /* 21351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_qb),
     /* 21359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21380 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7612:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDU_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_QB),
     /* 21383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21392 */     GIR_RootConstrainSelectedInstOperands,
     /* 21393 */     // GIR_Coverage, 355,
     /* 21393 */     GIR_EraseRootFromParent_Done,
     /* 21394 */   // Label 674: @21394
     /* 21394 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(21442), // Rule ID 356 //
     /* 21399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_qb),
     /* 21407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21428 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8235:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBU_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_QB),
     /* 21431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21440 */     GIR_RootConstrainSelectedInstOperands,
     /* 21441 */     // GIR_Coverage, 356,
     /* 21441 */     GIR_EraseRootFromParent_Done,
     /* 21442 */   // Label 675: @21442
     /* 21442 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(21490), // Rule ID 357 //
     /* 21447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_ph),
     /* 21455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21476 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7590:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_PH),
     /* 21479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21488 */     GIR_RootConstrainSelectedInstOperands,
     /* 21489 */     // GIR_Coverage, 357,
     /* 21489 */     GIR_EraseRootFromParent_Done,
     /* 21490 */   // Label 676: @21490
     /* 21490 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(21538), // Rule ID 358 //
     /* 21495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_ph),
     /* 21503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21524 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8210:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_PH),
     /* 21527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21536 */     GIR_RootConstrainSelectedInstOperands,
     /* 21537 */     // GIR_Coverage, 358,
     /* 21537 */     GIR_EraseRootFromParent_Done,
     /* 21538 */   // Label 677: @21538
     /* 21538 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(21583), // Rule ID 361 //
     /* 21543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_modsub),
     /* 21551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21572 */     // (intrinsic_wo_chain:{ *:[i32] } 8040:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODSUB:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 21572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MODSUB),
     /* 21575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21581 */     GIR_RootConstrainSelectedInstOperands,
     /* 21582 */     // GIR_Coverage, 361,
     /* 21582 */     GIR_EraseRootFromParent_Done,
     /* 21583 */   // Label 678: @21583
     /* 21583 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(21628), // Rule ID 365 //
     /* 21588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_qb_ph),
     /* 21596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21617 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8116:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQ_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_QB_PH),
     /* 21620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21626 */     GIR_RootConstrainSelectedInstOperands,
     /* 21627 */     // GIR_Coverage, 365,
     /* 21627 */     GIR_EraseRootFromParent_Done,
     /* 21628 */   // Label 679: @21628
     /* 21628 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(21673), // Rule ID 366 //
     /* 21633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_ph_w),
     /* 21641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21662 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8115:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 21662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_PH_W),
     /* 21665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21671 */     GIR_RootConstrainSelectedInstOperands,
     /* 21672 */     // GIR_Coverage, 366,
     /* 21672 */     GIR_EraseRootFromParent_Done,
     /* 21673 */   // Label 680: @21673
     /* 21673 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(21718), // Rule ID 380 //
     /* 21678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 21686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21707 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8146:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRLV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_QB),
     /* 21710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21716 */     GIR_RootConstrainSelectedInstOperands,
     /* 21717 */     // GIR_Coverage, 380,
     /* 21717 */     GIR_EraseRootFromParent_Done,
     /* 21718 */   // Label 681: @21718
     /* 21718 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(21763), // Rule ID 384 //
     /* 21723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 21731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21752 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8140:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_PH),
     /* 21755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21761 */     GIR_RootConstrainSelectedInstOperands,
     /* 21762 */     // GIR_Coverage, 384,
     /* 21762 */     GIR_EraseRootFromParent_Done,
     /* 21763 */   // Label 682: @21763
     /* 21763 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(21808), // Rule ID 386 //
     /* 21768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 21776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21797 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8142:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_PH),
     /* 21800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21806 */     GIR_RootConstrainSelectedInstOperands,
     /* 21807 */     // GIR_Coverage, 386,
     /* 21807 */     GIR_EraseRootFromParent_Done,
     /* 21808 */   // Label 683: @21808
     /* 21808 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(21853), // Rule ID 390 //
     /* 21813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 21821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21842 */     // (intrinsic_wo_chain:{ *:[i32] } 8144:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_W),
     /* 21845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21851 */     GIR_RootConstrainSelectedInstOperands,
     /* 21852 */     // GIR_Coverage, 390,
     /* 21852 */     GIR_EraseRootFromParent_Done,
     /* 21853 */   // Label 684: @21853
     /* 21853 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(21898), // Rule ID 427 //
     /* 21858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_packrl_ph),
     /* 21866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21887 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8087:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PACKRL_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PACKRL_PH),
     /* 21890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21896 */     GIR_RootConstrainSelectedInstOperands,
     /* 21897 */     // GIR_Coverage, 427,
     /* 21897 */     GIR_EraseRootFromParent_Done,
     /* 21898 */   // Label 685: @21898
     /* 21898 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(21943), // Rule ID 451 //
     /* 21903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_qb),
     /* 21911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21932 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7613:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_QB),
     /* 21935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21941 */     GIR_RootConstrainSelectedInstOperands,
     /* 21942 */     // GIR_Coverage, 451,
     /* 21942 */     GIR_EraseRootFromParent_Done,
     /* 21943 */   // Label 686: @21943
     /* 21943 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(21988), // Rule ID 452 //
     /* 21948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_r_qb),
     /* 21956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21977 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7614:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_R_QB),
     /* 21980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21986 */     GIR_RootConstrainSelectedInstOperands,
     /* 21987 */     // GIR_Coverage, 452,
     /* 21987 */     GIR_EraseRootFromParent_Done,
     /* 21988 */   // Label 687: @21988
     /* 21988 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(22033), // Rule ID 453 //
     /* 21993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_qb),
     /* 22001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 22010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22022 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8236:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 22022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_QB),
     /* 22025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22031 */     GIR_RootConstrainSelectedInstOperands,
     /* 22032 */     // GIR_Coverage, 453,
     /* 22032 */     GIR_EraseRootFromParent_Done,
     /* 22033 */   // Label 688: @22033
     /* 22033 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(22078), // Rule ID 454 //
     /* 22038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_r_qb),
     /* 22046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 22055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22067 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8237:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 22067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_R_QB),
     /* 22070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22076 */     GIR_RootConstrainSelectedInstOperands,
     /* 22077 */     // GIR_Coverage, 454,
     /* 22077 */     GIR_EraseRootFromParent_Done,
     /* 22078 */   // Label 689: @22078
     /* 22078 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(22123), // Rule ID 455 //
     /* 22083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_ph),
     /* 22091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22112 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7592:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_PH),
     /* 22115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22121 */     GIR_RootConstrainSelectedInstOperands,
     /* 22122 */     // GIR_Coverage, 455,
     /* 22122 */     GIR_EraseRootFromParent_Done,
     /* 22123 */   // Label 690: @22123
     /* 22123 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(22168), // Rule ID 456 //
     /* 22128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_ph),
     /* 22136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22157 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7593:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_PH),
     /* 22160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22166 */     GIR_RootConstrainSelectedInstOperands,
     /* 22167 */     // GIR_Coverage, 456,
     /* 22167 */     GIR_EraseRootFromParent_Done,
     /* 22168 */   // Label 691: @22168
     /* 22168 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(22213), // Rule ID 457 //
     /* 22173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_ph),
     /* 22181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22202 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8212:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_PH),
     /* 22205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22211 */     GIR_RootConstrainSelectedInstOperands,
     /* 22212 */     // GIR_Coverage, 457,
     /* 22212 */     GIR_EraseRootFromParent_Done,
     /* 22213 */   // Label 692: @22213
     /* 22213 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(22258), // Rule ID 458 //
     /* 22218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_ph),
     /* 22226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22247 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8213:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_PH),
     /* 22250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22256 */     GIR_RootConstrainSelectedInstOperands,
     /* 22257 */     // GIR_Coverage, 458,
     /* 22257 */     GIR_EraseRootFromParent_Done,
     /* 22258 */   // Label 693: @22258
     /* 22258 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(22303), // Rule ID 459 //
     /* 22263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_w),
     /* 22271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22292 */     // (intrinsic_wo_chain:{ *:[i32] } 7595:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_W),
     /* 22295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22301 */     GIR_RootConstrainSelectedInstOperands,
     /* 22302 */     // GIR_Coverage, 459,
     /* 22302 */     GIR_EraseRootFromParent_Done,
     /* 22303 */   // Label 694: @22303
     /* 22303 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(22348), // Rule ID 460 //
     /* 22308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_w),
     /* 22316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22337 */     // (intrinsic_wo_chain:{ *:[i32] } 7594:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_W),
     /* 22340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22346 */     GIR_RootConstrainSelectedInstOperands,
     /* 22347 */     // GIR_Coverage, 460,
     /* 22347 */     GIR_EraseRootFromParent_Done,
     /* 22348 */   // Label 695: @22348
     /* 22348 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(22393), // Rule ID 461 //
     /* 22353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_w),
     /* 22361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22382 */     // (intrinsic_wo_chain:{ *:[i32] } 8215:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_W),
     /* 22385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22391 */     GIR_RootConstrainSelectedInstOperands,
     /* 22392 */     // GIR_Coverage, 461,
     /* 22392 */     GIR_EraseRootFromParent_Done,
     /* 22393 */   // Label 696: @22393
     /* 22393 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(22438), // Rule ID 462 //
     /* 22398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_w),
     /* 22406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22427 */     // (intrinsic_wo_chain:{ *:[i32] } 8214:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_W),
     /* 22430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22436 */     GIR_RootConstrainSelectedInstOperands,
     /* 22437 */     // GIR_Coverage, 462,
     /* 22437 */     GIR_EraseRootFromParent_Done,
     /* 22438 */   // Label 697: @22438
     /* 22438 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(22483), // Rule ID 479 //
     /* 22443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 22451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22472 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8141:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_QB),
     /* 22475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22481 */     GIR_RootConstrainSelectedInstOperands,
     /* 22482 */     // GIR_Coverage, 479,
     /* 22482 */     GIR_EraseRootFromParent_Done,
     /* 22483 */   // Label 698: @22483
     /* 22483 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(22528), // Rule ID 481 //
     /* 22488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 22496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22517 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8143:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_QB),
     /* 22520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22526 */     GIR_RootConstrainSelectedInstOperands,
     /* 22527 */     // GIR_Coverage, 481,
     /* 22527 */     GIR_EraseRootFromParent_Done,
     /* 22528 */   // Label 699: @22528
     /* 22528 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(22573), // Rule ID 482 //
     /* 22533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 22541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22562 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8145:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRLV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_PH),
     /* 22565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22571 */     GIR_RootConstrainSelectedInstOperands,
     /* 22572 */     // GIR_Coverage, 482,
     /* 22572 */     GIR_EraseRootFromParent_Done,
     /* 22573 */   // Label 700: @22573
     /* 22573 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(22618), // Rule ID 491 //
     /* 22578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_b),
     /* 22586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22607 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7585:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADD_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_B),
     /* 22610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22612 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22614 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22616 */     GIR_RootConstrainSelectedInstOperands,
     /* 22617 */     // GIR_Coverage, 491,
     /* 22617 */     GIR_EraseRootFromParent_Done,
     /* 22618 */   // Label 701: @22618
     /* 22618 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(22663), // Rule ID 492 //
     /* 22623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_h),
     /* 22631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 22640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7587:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADD_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 22652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_H),
     /* 22655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22657 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22659 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22661 */     GIR_RootConstrainSelectedInstOperands,
     /* 22662 */     // GIR_Coverage, 492,
     /* 22662 */     GIR_EraseRootFromParent_Done,
     /* 22663 */   // Label 702: @22663
     /* 22663 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(22708), // Rule ID 493 //
     /* 22668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_w),
     /* 22676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 22679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 22682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 22685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22697 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7588:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADD_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 22697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_W),
     /* 22700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22702 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22704 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22706 */     GIR_RootConstrainSelectedInstOperands,
     /* 22707 */     // GIR_Coverage, 493,
     /* 22707 */     GIR_EraseRootFromParent_Done,
     /* 22708 */   // Label 703: @22708
     /* 22708 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(22753), // Rule ID 494 //
     /* 22713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_d),
     /* 22721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 22724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 22727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 22730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22742 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7586:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADD_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 22742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_D),
     /* 22745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22747 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22749 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22751 */     GIR_RootConstrainSelectedInstOperands,
     /* 22752 */     // GIR_Coverage, 494,
     /* 22752 */     GIR_EraseRootFromParent_Done,
     /* 22753 */   // Label 704: @22753
     /* 22753 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(22798), // Rule ID 495 //
     /* 22758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_b),
     /* 22766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22787 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7596:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_B),
     /* 22790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22792 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22794 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22796 */     GIR_RootConstrainSelectedInstOperands,
     /* 22797 */     // GIR_Coverage, 495,
     /* 22797 */     GIR_EraseRootFromParent_Done,
     /* 22798 */   // Label 705: @22798
     /* 22798 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(22843), // Rule ID 496 //
     /* 22803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_h),
     /* 22811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 22820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22832 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7598:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 22832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_H),
     /* 22835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22837 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22839 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22841 */     GIR_RootConstrainSelectedInstOperands,
     /* 22842 */     // GIR_Coverage, 496,
     /* 22842 */     GIR_EraseRootFromParent_Done,
     /* 22843 */   // Label 706: @22843
     /* 22843 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(22888), // Rule ID 497 //
     /* 22848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_w),
     /* 22856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 22859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 22862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 22865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22877 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7599:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 22877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_W),
     /* 22880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22882 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22884 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22886 */     GIR_RootConstrainSelectedInstOperands,
     /* 22887 */     // GIR_Coverage, 497,
     /* 22887 */     GIR_EraseRootFromParent_Done,
     /* 22888 */   // Label 707: @22888
     /* 22888 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(22933), // Rule ID 498 //
     /* 22893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_d),
     /* 22901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 22904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 22907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 22910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22922 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7597:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 22922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_D),
     /* 22925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22927 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22929 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22931 */     GIR_RootConstrainSelectedInstOperands,
     /* 22932 */     // GIR_Coverage, 498,
     /* 22932 */     GIR_EraseRootFromParent_Done,
     /* 22933 */   // Label 708: @22933
     /* 22933 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(22978), // Rule ID 499 //
     /* 22938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_b),
     /* 22946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22967 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7600:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_B),
     /* 22970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22972 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22974 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22976 */     GIR_RootConstrainSelectedInstOperands,
     /* 22977 */     // GIR_Coverage, 499,
     /* 22977 */     GIR_EraseRootFromParent_Done,
     /* 22978 */   // Label 709: @22978
     /* 22978 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(23023), // Rule ID 500 //
     /* 22983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_h),
     /* 22991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7602:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_H),
     /* 23015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23017 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23019 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23021 */     GIR_RootConstrainSelectedInstOperands,
     /* 23022 */     // GIR_Coverage, 500,
     /* 23022 */     GIR_EraseRootFromParent_Done,
     /* 23023 */   // Label 710: @23023
     /* 23023 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(23068), // Rule ID 501 //
     /* 23028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_w),
     /* 23036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23057 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7603:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_W),
     /* 23060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23062 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23064 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23066 */     GIR_RootConstrainSelectedInstOperands,
     /* 23067 */     // GIR_Coverage, 501,
     /* 23067 */     GIR_EraseRootFromParent_Done,
     /* 23068 */   // Label 711: @23068
     /* 23068 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(23113), // Rule ID 502 //
     /* 23073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_d),
     /* 23081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23102 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7601:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_D),
     /* 23105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23107 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23109 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23111 */     GIR_RootConstrainSelectedInstOperands,
     /* 23112 */     // GIR_Coverage, 502,
     /* 23112 */     GIR_EraseRootFromParent_Done,
     /* 23113 */   // Label 712: @23113
     /* 23113 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(23158), // Rule ID 503 //
     /* 23118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_b),
     /* 23126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23147 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7604:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_B),
     /* 23150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23152 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23154 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23156 */     GIR_RootConstrainSelectedInstOperands,
     /* 23157 */     // GIR_Coverage, 503,
     /* 23157 */     GIR_EraseRootFromParent_Done,
     /* 23158 */   // Label 713: @23158
     /* 23158 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(23203), // Rule ID 504 //
     /* 23163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_h),
     /* 23171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23192 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7606:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_H),
     /* 23195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23197 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23199 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23201 */     GIR_RootConstrainSelectedInstOperands,
     /* 23202 */     // GIR_Coverage, 504,
     /* 23202 */     GIR_EraseRootFromParent_Done,
     /* 23203 */   // Label 714: @23203
     /* 23203 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(23248), // Rule ID 505 //
     /* 23208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_w),
     /* 23216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23237 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7607:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_W),
     /* 23240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23242 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23244 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23246 */     GIR_RootConstrainSelectedInstOperands,
     /* 23247 */     // GIR_Coverage, 505,
     /* 23247 */     GIR_EraseRootFromParent_Done,
     /* 23248 */   // Label 715: @23248
     /* 23248 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(23293), // Rule ID 506 //
     /* 23253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_d),
     /* 23261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23282 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7605:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_D),
     /* 23285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23287 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23289 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23291 */     GIR_RootConstrainSelectedInstOperands,
     /* 23292 */     // GIR_Coverage, 506,
     /* 23292 */     GIR_EraseRootFromParent_Done,
     /* 23293 */   // Label 716: @23293
     /* 23293 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(23338), // Rule ID 520 //
     /* 23298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_b),
     /* 23306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23327 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7627:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ASUB_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_B),
     /* 23330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23332 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23334 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23336 */     GIR_RootConstrainSelectedInstOperands,
     /* 23337 */     // GIR_Coverage, 520,
     /* 23337 */     GIR_EraseRootFromParent_Done,
     /* 23338 */   // Label 717: @23338
     /* 23338 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(23383), // Rule ID 521 //
     /* 23343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_h),
     /* 23351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23372 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7629:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ASUB_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_H),
     /* 23375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23377 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23379 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23381 */     GIR_RootConstrainSelectedInstOperands,
     /* 23382 */     // GIR_Coverage, 521,
     /* 23382 */     GIR_EraseRootFromParent_Done,
     /* 23383 */   // Label 718: @23383
     /* 23383 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(23428), // Rule ID 522 //
     /* 23388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_w),
     /* 23396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23417 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7630:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ASUB_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_W),
     /* 23420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23422 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23424 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23426 */     GIR_RootConstrainSelectedInstOperands,
     /* 23427 */     // GIR_Coverage, 522,
     /* 23427 */     GIR_EraseRootFromParent_Done,
     /* 23428 */   // Label 719: @23428
     /* 23428 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(23473), // Rule ID 523 //
     /* 23433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_d),
     /* 23441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23462 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7628:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ASUB_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_D),
     /* 23465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23467 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23469 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23471 */     GIR_RootConstrainSelectedInstOperands,
     /* 23472 */     // GIR_Coverage, 523,
     /* 23472 */     GIR_EraseRootFromParent_Done,
     /* 23473 */   // Label 720: @23473
     /* 23473 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(23518), // Rule ID 524 //
     /* 23478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_b),
     /* 23486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23507 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7631:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ASUB_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_B),
     /* 23510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23512 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23514 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23516 */     GIR_RootConstrainSelectedInstOperands,
     /* 23517 */     // GIR_Coverage, 524,
     /* 23517 */     GIR_EraseRootFromParent_Done,
     /* 23518 */   // Label 721: @23518
     /* 23518 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(23563), // Rule ID 525 //
     /* 23523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_h),
     /* 23531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23552 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7633:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ASUB_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_H),
     /* 23555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23557 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23559 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23561 */     GIR_RootConstrainSelectedInstOperands,
     /* 23562 */     // GIR_Coverage, 525,
     /* 23562 */     GIR_EraseRootFromParent_Done,
     /* 23563 */   // Label 722: @23563
     /* 23563 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(23608), // Rule ID 526 //
     /* 23568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_w),
     /* 23576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23597 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7634:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ASUB_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_W),
     /* 23600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23602 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23604 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23606 */     GIR_RootConstrainSelectedInstOperands,
     /* 23607 */     // GIR_Coverage, 526,
     /* 23607 */     GIR_EraseRootFromParent_Done,
     /* 23608 */   // Label 723: @23608
     /* 23608 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(23653), // Rule ID 527 //
     /* 23613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_d),
     /* 23621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23642 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7632:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ASUB_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_D),
     /* 23645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23647 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23649 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23651 */     GIR_RootConstrainSelectedInstOperands,
     /* 23652 */     // GIR_Coverage, 527,
     /* 23652 */     GIR_EraseRootFromParent_Done,
     /* 23653 */   // Label 724: @23653
     /* 23653 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(23698), // Rule ID 528 //
     /* 23658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_b),
     /* 23666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23687 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7635:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVE_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_B),
     /* 23690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23692 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23694 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23696 */     GIR_RootConstrainSelectedInstOperands,
     /* 23697 */     // GIR_Coverage, 528,
     /* 23697 */     GIR_EraseRootFromParent_Done,
     /* 23698 */   // Label 725: @23698
     /* 23698 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(23743), // Rule ID 529 //
     /* 23703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_h),
     /* 23711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23732 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7637:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVE_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_H),
     /* 23735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23737 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23739 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23741 */     GIR_RootConstrainSelectedInstOperands,
     /* 23742 */     // GIR_Coverage, 529,
     /* 23742 */     GIR_EraseRootFromParent_Done,
     /* 23743 */   // Label 726: @23743
     /* 23743 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(23788), // Rule ID 530 //
     /* 23748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_w),
     /* 23756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23777 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7638:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVE_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_W),
     /* 23780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23782 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23784 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23786 */     GIR_RootConstrainSelectedInstOperands,
     /* 23787 */     // GIR_Coverage, 530,
     /* 23787 */     GIR_EraseRootFromParent_Done,
     /* 23788 */   // Label 727: @23788
     /* 23788 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(23833), // Rule ID 531 //
     /* 23793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_d),
     /* 23801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23822 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7636:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVE_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_D),
     /* 23825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23827 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23829 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23831 */     GIR_RootConstrainSelectedInstOperands,
     /* 23832 */     // GIR_Coverage, 531,
     /* 23832 */     GIR_EraseRootFromParent_Done,
     /* 23833 */   // Label 728: @23833
     /* 23833 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(23878), // Rule ID 532 //
     /* 23838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_b),
     /* 23846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23867 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7639:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVE_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_B),
     /* 23870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23872 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23874 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23876 */     GIR_RootConstrainSelectedInstOperands,
     /* 23877 */     // GIR_Coverage, 532,
     /* 23877 */     GIR_EraseRootFromParent_Done,
     /* 23878 */   // Label 729: @23878
     /* 23878 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(23923), // Rule ID 533 //
     /* 23883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_h),
     /* 23891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23912 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7641:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVE_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_H),
     /* 23915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23917 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23919 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23921 */     GIR_RootConstrainSelectedInstOperands,
     /* 23922 */     // GIR_Coverage, 533,
     /* 23922 */     GIR_EraseRootFromParent_Done,
     /* 23923 */   // Label 730: @23923
     /* 23923 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(23968), // Rule ID 534 //
     /* 23928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_w),
     /* 23936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23957 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7642:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVE_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_W),
     /* 23960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23962 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23964 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23966 */     GIR_RootConstrainSelectedInstOperands,
     /* 23967 */     // GIR_Coverage, 534,
     /* 23967 */     GIR_EraseRootFromParent_Done,
     /* 23968 */   // Label 731: @23968
     /* 23968 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(24013), // Rule ID 535 //
     /* 23973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_d),
     /* 23981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24002 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7640:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVE_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 24002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_D),
     /* 24005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24007 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24009 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24011 */     GIR_RootConstrainSelectedInstOperands,
     /* 24012 */     // GIR_Coverage, 535,
     /* 24012 */     GIR_EraseRootFromParent_Done,
     /* 24013 */   // Label 732: @24013
     /* 24013 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(24058), // Rule ID 536 //
     /* 24018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_b),
     /* 24026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 24029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24047 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7643:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVER_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_B),
     /* 24050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24052 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24054 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24056 */     GIR_RootConstrainSelectedInstOperands,
     /* 24057 */     // GIR_Coverage, 536,
     /* 24057 */     GIR_EraseRootFromParent_Done,
     /* 24058 */   // Label 733: @24058
     /* 24058 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(24103), // Rule ID 537 //
     /* 24063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_h),
     /* 24071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24092 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7645:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVER_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_H),
     /* 24095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24097 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24099 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24101 */     GIR_RootConstrainSelectedInstOperands,
     /* 24102 */     // GIR_Coverage, 537,
     /* 24102 */     GIR_EraseRootFromParent_Done,
     /* 24103 */   // Label 734: @24103
     /* 24103 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(24148), // Rule ID 538 //
     /* 24108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_w),
     /* 24116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24137 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7646:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVER_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_W),
     /* 24140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24142 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24144 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24146 */     GIR_RootConstrainSelectedInstOperands,
     /* 24147 */     // GIR_Coverage, 538,
     /* 24147 */     GIR_EraseRootFromParent_Done,
     /* 24148 */   // Label 735: @24148
     /* 24148 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(24193), // Rule ID 539 //
     /* 24153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_d),
     /* 24161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24182 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7644:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVER_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 24182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_D),
     /* 24185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24187 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24189 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24191 */     GIR_RootConstrainSelectedInstOperands,
     /* 24192 */     // GIR_Coverage, 539,
     /* 24192 */     GIR_EraseRootFromParent_Done,
     /* 24193 */   // Label 736: @24193
     /* 24193 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(24238), // Rule ID 540 //
     /* 24198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_b),
     /* 24206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 24209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24227 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7647:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVER_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_B),
     /* 24230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24232 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24234 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24236 */     GIR_RootConstrainSelectedInstOperands,
     /* 24237 */     // GIR_Coverage, 540,
     /* 24237 */     GIR_EraseRootFromParent_Done,
     /* 24238 */   // Label 737: @24238
     /* 24238 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(24283), // Rule ID 541 //
     /* 24243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_h),
     /* 24251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24272 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7649:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVER_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_H),
     /* 24275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24277 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24279 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24281 */     GIR_RootConstrainSelectedInstOperands,
     /* 24282 */     // GIR_Coverage, 541,
     /* 24282 */     GIR_EraseRootFromParent_Done,
     /* 24283 */   // Label 738: @24283
     /* 24283 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(24328), // Rule ID 542 //
     /* 24288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_w),
     /* 24296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24317 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7650:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVER_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_W),
     /* 24320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24322 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24324 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24326 */     GIR_RootConstrainSelectedInstOperands,
     /* 24327 */     // GIR_Coverage, 542,
     /* 24327 */     GIR_EraseRootFromParent_Done,
     /* 24328 */   // Label 739: @24328
     /* 24328 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(24373), // Rule ID 543 //
     /* 24333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_d),
     /* 24341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24362 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7648:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVER_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 24362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_D),
     /* 24365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24367 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24369 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24371 */     GIR_RootConstrainSelectedInstOperands,
     /* 24372 */     // GIR_Coverage, 543,
     /* 24372 */     GIR_EraseRootFromParent_Done,
     /* 24373 */   // Label 740: @24373
     /* 24373 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(24418), // Rule ID 652 //
     /* 24378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_h),
     /* 24386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24407 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7782:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DOTP_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_H),
     /* 24410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24412 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24414 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24416 */     GIR_RootConstrainSelectedInstOperands,
     /* 24417 */     // GIR_Coverage, 652,
     /* 24417 */     GIR_EraseRootFromParent_Done,
     /* 24418 */   // Label 741: @24418
     /* 24418 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(24463), // Rule ID 653 //
     /* 24423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_w),
     /* 24431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24452 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7783:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DOTP_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_W),
     /* 24455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24457 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24459 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24461 */     GIR_RootConstrainSelectedInstOperands,
     /* 24462 */     // GIR_Coverage, 653,
     /* 24462 */     GIR_EraseRootFromParent_Done,
     /* 24463 */   // Label 742: @24463
     /* 24463 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(24508), // Rule ID 654 //
     /* 24468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_d),
     /* 24476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24497 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7781:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DOTP_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_D),
     /* 24500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24502 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24504 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24506 */     GIR_RootConstrainSelectedInstOperands,
     /* 24507 */     // GIR_Coverage, 654,
     /* 24507 */     GIR_EraseRootFromParent_Done,
     /* 24508 */   // Label 743: @24508
     /* 24508 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(24553), // Rule ID 655 //
     /* 24513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_h),
     /* 24521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24542 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7785:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DOTP_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_H),
     /* 24545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24547 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24549 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24551 */     GIR_RootConstrainSelectedInstOperands,
     /* 24552 */     // GIR_Coverage, 655,
     /* 24552 */     GIR_EraseRootFromParent_Done,
     /* 24553 */   // Label 744: @24553
     /* 24553 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(24598), // Rule ID 656 //
     /* 24558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_w),
     /* 24566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24587 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7786:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DOTP_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_W),
     /* 24590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24592 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24594 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24596 */     GIR_RootConstrainSelectedInstOperands,
     /* 24597 */     // GIR_Coverage, 656,
     /* 24597 */     GIR_EraseRootFromParent_Done,
     /* 24598 */   // Label 745: @24598
     /* 24598 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(24643), // Rule ID 657 //
     /* 24603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_d),
     /* 24611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24632 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7784:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DOTP_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_D),
     /* 24635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24637 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24639 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24641 */     GIR_RootConstrainSelectedInstOperands,
     /* 24642 */     // GIR_Coverage, 657,
     /* 24642 */     GIR_EraseRootFromParent_Done,
     /* 24643 */   // Label 746: @24643
     /* 24643 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(24688), // Rule ID 672 //
     /* 24648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fcaf_w),
     /* 24656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24677 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7824:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FCAF_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCAF_W),
     /* 24680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24682 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24684 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24686 */     GIR_RootConstrainSelectedInstOperands,
     /* 24687 */     // GIR_Coverage, 672,
     /* 24687 */     GIR_EraseRootFromParent_Done,
     /* 24688 */   // Label 747: @24688
     /* 24688 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(24733), // Rule ID 673 //
     /* 24693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fcaf_d),
     /* 24701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24722 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7823:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FCAF_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCAF_D),
     /* 24725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24727 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24729 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24731 */     GIR_RootConstrainSelectedInstOperands,
     /* 24732 */     // GIR_Coverage, 673,
     /* 24732 */     GIR_EraseRootFromParent_Done,
     /* 24733 */   // Label 748: @24733
     /* 24733 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(24778), // Rule ID 698 //
     /* 24738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexdo_h),
     /* 24746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24767 */     // (intrinsic_wo_chain:{ *:[v8f16] } 7849:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FEXDO_H:{ *:[v8f16] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXDO_H),
     /* 24770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24772 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24774 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24776 */     GIR_RootConstrainSelectedInstOperands,
     /* 24777 */     // GIR_Coverage, 698,
     /* 24777 */     GIR_EraseRootFromParent_Done,
     /* 24778 */   // Label 749: @24778
     /* 24778 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(24823), // Rule ID 699 //
     /* 24783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexdo_w),
     /* 24791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24812 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7850:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FEXDO_W:{ *:[v4f32] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXDO_W),
     /* 24815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24817 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24819 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24821 */     GIR_RootConstrainSelectedInstOperands,
     /* 24822 */     // GIR_Coverage, 699,
     /* 24822 */     GIR_EraseRootFromParent_Done,
     /* 24823 */   // Label 750: @24823
     /* 24823 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(24868), // Rule ID 726 //
     /* 24828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_w),
     /* 24836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24857 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7876:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMAX_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_W),
     /* 24860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24862 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24864 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24866 */     GIR_RootConstrainSelectedInstOperands,
     /* 24867 */     // GIR_Coverage, 726,
     /* 24867 */     GIR_EraseRootFromParent_Done,
     /* 24868 */   // Label 751: @24868
     /* 24868 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(24913), // Rule ID 727 //
     /* 24873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_d),
     /* 24881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24902 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7875:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMAX_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_D),
     /* 24905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24907 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24909 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24911 */     GIR_RootConstrainSelectedInstOperands,
     /* 24912 */     // GIR_Coverage, 727,
     /* 24912 */     GIR_EraseRootFromParent_Done,
     /* 24913 */   // Label 752: @24913
     /* 24913 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(24958), // Rule ID 728 //
     /* 24918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_a_w),
     /* 24926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24947 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7874:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMAX_A_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_A_W),
     /* 24950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24952 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24954 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24956 */     GIR_RootConstrainSelectedInstOperands,
     /* 24957 */     // GIR_Coverage, 728,
     /* 24957 */     GIR_EraseRootFromParent_Done,
     /* 24958 */   // Label 753: @24958
     /* 24958 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(25003), // Rule ID 729 //
     /* 24963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_a_d),
     /* 24971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24992 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7873:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMAX_A_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_A_D),
     /* 24995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24997 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24999 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25001 */     GIR_RootConstrainSelectedInstOperands,
     /* 25002 */     // GIR_Coverage, 729,
     /* 25002 */     GIR_EraseRootFromParent_Done,
     /* 25003 */   // Label 754: @25003
     /* 25003 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(25048), // Rule ID 730 //
     /* 25008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_w),
     /* 25016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25037 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7880:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMIN_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_W),
     /* 25040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25042 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25044 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25046 */     GIR_RootConstrainSelectedInstOperands,
     /* 25047 */     // GIR_Coverage, 730,
     /* 25047 */     GIR_EraseRootFromParent_Done,
     /* 25048 */   // Label 755: @25048
     /* 25048 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(25093), // Rule ID 731 //
     /* 25053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_d),
     /* 25061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25082 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7879:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMIN_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_D),
     /* 25085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25087 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25089 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25091 */     GIR_RootConstrainSelectedInstOperands,
     /* 25092 */     // GIR_Coverage, 731,
     /* 25092 */     GIR_EraseRootFromParent_Done,
     /* 25093 */   // Label 756: @25093
     /* 25093 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(25138), // Rule ID 732 //
     /* 25098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_a_w),
     /* 25106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25127 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7878:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMIN_A_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_A_W),
     /* 25130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25132 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25134 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25136 */     GIR_RootConstrainSelectedInstOperands,
     /* 25137 */     // GIR_Coverage, 732,
     /* 25137 */     GIR_EraseRootFromParent_Done,
     /* 25138 */   // Label 757: @25138
     /* 25138 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(25183), // Rule ID 733 //
     /* 25143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_a_d),
     /* 25151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25172 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7877:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMIN_A_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_A_D),
     /* 25175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25177 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25179 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25181 */     GIR_RootConstrainSelectedInstOperands,
     /* 25182 */     // GIR_Coverage, 733,
     /* 25182 */     GIR_EraseRootFromParent_Done,
     /* 25183 */   // Label 758: @25183
     /* 25183 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(25228), // Rule ID 744 //
     /* 25188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsaf_w),
     /* 25196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25217 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7892:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSAF_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSAF_W),
     /* 25220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25222 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25224 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25226 */     GIR_RootConstrainSelectedInstOperands,
     /* 25227 */     // GIR_Coverage, 744,
     /* 25227 */     GIR_EraseRootFromParent_Done,
     /* 25228 */   // Label 759: @25228
     /* 25228 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(25273), // Rule ID 745 //
     /* 25233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsaf_d),
     /* 25241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25262 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7891:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSAF_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSAF_D),
     /* 25265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25267 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25269 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25271 */     GIR_RootConstrainSelectedInstOperands,
     /* 25272 */     // GIR_Coverage, 745,
     /* 25272 */     GIR_EraseRootFromParent_Done,
     /* 25273 */   // Label 760: @25273
     /* 25273 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(25318), // Rule ID 746 //
     /* 25278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fseq_w),
     /* 25286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25307 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7894:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSEQ_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSEQ_W),
     /* 25310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25312 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25314 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25316 */     GIR_RootConstrainSelectedInstOperands,
     /* 25317 */     // GIR_Coverage, 746,
     /* 25317 */     GIR_EraseRootFromParent_Done,
     /* 25318 */   // Label 761: @25318
     /* 25318 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(25363), // Rule ID 747 //
     /* 25323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fseq_d),
     /* 25331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25352 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7893:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSEQ_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSEQ_D),
     /* 25355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25357 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25359 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25361 */     GIR_RootConstrainSelectedInstOperands,
     /* 25362 */     // GIR_Coverage, 747,
     /* 25362 */     GIR_EraseRootFromParent_Done,
     /* 25363 */   // Label 762: @25363
     /* 25363 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(25408), // Rule ID 748 //
     /* 25368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsle_w),
     /* 25376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25397 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7896:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSLE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLE_W),
     /* 25400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25402 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25404 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25406 */     GIR_RootConstrainSelectedInstOperands,
     /* 25407 */     // GIR_Coverage, 748,
     /* 25407 */     GIR_EraseRootFromParent_Done,
     /* 25408 */   // Label 763: @25408
     /* 25408 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(25453), // Rule ID 749 //
     /* 25413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsle_d),
     /* 25421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25442 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7895:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSLE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLE_D),
     /* 25445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25447 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25449 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25451 */     GIR_RootConstrainSelectedInstOperands,
     /* 25452 */     // GIR_Coverage, 749,
     /* 25452 */     GIR_EraseRootFromParent_Done,
     /* 25453 */   // Label 764: @25453
     /* 25453 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(25498), // Rule ID 750 //
     /* 25458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fslt_w),
     /* 25466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25487 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7898:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSLT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLT_W),
     /* 25490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25492 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25494 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25496 */     GIR_RootConstrainSelectedInstOperands,
     /* 25497 */     // GIR_Coverage, 750,
     /* 25497 */     GIR_EraseRootFromParent_Done,
     /* 25498 */   // Label 765: @25498
     /* 25498 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(25543), // Rule ID 751 //
     /* 25503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fslt_d),
     /* 25511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25532 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7897:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSLT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLT_D),
     /* 25535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25537 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25539 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25541 */     GIR_RootConstrainSelectedInstOperands,
     /* 25542 */     // GIR_Coverage, 751,
     /* 25542 */     GIR_EraseRootFromParent_Done,
     /* 25543 */   // Label 766: @25543
     /* 25543 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(25588), // Rule ID 752 //
     /* 25548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsne_w),
     /* 25556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25577 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7900:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSNE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSNE_W),
     /* 25580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25582 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25584 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25586 */     GIR_RootConstrainSelectedInstOperands,
     /* 25587 */     // GIR_Coverage, 752,
     /* 25587 */     GIR_EraseRootFromParent_Done,
     /* 25588 */   // Label 767: @25588
     /* 25588 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(25633), // Rule ID 753 //
     /* 25593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsne_d),
     /* 25601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25622 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7899:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSNE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSNE_D),
     /* 25625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25627 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25629 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25631 */     GIR_RootConstrainSelectedInstOperands,
     /* 25632 */     // GIR_Coverage, 753,
     /* 25632 */     GIR_EraseRootFromParent_Done,
     /* 25633 */   // Label 768: @25633
     /* 25633 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(25678), // Rule ID 754 //
     /* 25638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsor_w),
     /* 25646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25667 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7902:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSOR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSOR_W),
     /* 25670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25672 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25674 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25676 */     GIR_RootConstrainSelectedInstOperands,
     /* 25677 */     // GIR_Coverage, 754,
     /* 25677 */     GIR_EraseRootFromParent_Done,
     /* 25678 */   // Label 769: @25678
     /* 25678 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(25723), // Rule ID 755 //
     /* 25683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsor_d),
     /* 25691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25712 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7901:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSOR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSOR_D),
     /* 25715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25717 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25719 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25721 */     GIR_RootConstrainSelectedInstOperands,
     /* 25722 */     // GIR_Coverage, 755,
     /* 25722 */     GIR_EraseRootFromParent_Done,
     /* 25723 */   // Label 770: @25723
     /* 25723 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(25768), // Rule ID 760 //
     /* 25728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsueq_w),
     /* 25736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25757 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7908:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUEQ_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUEQ_W),
     /* 25760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25762 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25764 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25766 */     GIR_RootConstrainSelectedInstOperands,
     /* 25767 */     // GIR_Coverage, 760,
     /* 25767 */     GIR_EraseRootFromParent_Done,
     /* 25768 */   // Label 771: @25768
     /* 25768 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(25813), // Rule ID 761 //
     /* 25773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsueq_d),
     /* 25781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25802 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7907:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUEQ_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUEQ_D),
     /* 25805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25807 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25809 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25811 */     GIR_RootConstrainSelectedInstOperands,
     /* 25812 */     // GIR_Coverage, 761,
     /* 25812 */     GIR_EraseRootFromParent_Done,
     /* 25813 */   // Label 772: @25813
     /* 25813 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(25858), // Rule ID 762 //
     /* 25818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsule_w),
     /* 25826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25847 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7910:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSULE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULE_W),
     /* 25850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25852 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25854 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25856 */     GIR_RootConstrainSelectedInstOperands,
     /* 25857 */     // GIR_Coverage, 762,
     /* 25857 */     GIR_EraseRootFromParent_Done,
     /* 25858 */   // Label 773: @25858
     /* 25858 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(25903), // Rule ID 763 //
     /* 25863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsule_d),
     /* 25871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25892 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7909:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSULE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULE_D),
     /* 25895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25897 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25899 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25901 */     GIR_RootConstrainSelectedInstOperands,
     /* 25902 */     // GIR_Coverage, 763,
     /* 25902 */     GIR_EraseRootFromParent_Done,
     /* 25903 */   // Label 774: @25903
     /* 25903 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(25948), // Rule ID 764 //
     /* 25908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsult_w),
     /* 25916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25937 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7912:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSULT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULT_W),
     /* 25940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25942 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25944 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25946 */     GIR_RootConstrainSelectedInstOperands,
     /* 25947 */     // GIR_Coverage, 764,
     /* 25947 */     GIR_EraseRootFromParent_Done,
     /* 25948 */   // Label 775: @25948
     /* 25948 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(25993), // Rule ID 765 //
     /* 25953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsult_d),
     /* 25961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25982 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7911:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSULT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULT_D),
     /* 25985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25987 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25989 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25991 */     GIR_RootConstrainSelectedInstOperands,
     /* 25992 */     // GIR_Coverage, 765,
     /* 25992 */     GIR_EraseRootFromParent_Done,
     /* 25993 */   // Label 776: @25993
     /* 25993 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(26038), // Rule ID 766 //
     /* 25998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsun_w),
     /* 26006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26027 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7914:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUN_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUN_W),
     /* 26030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26032 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26034 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26036 */     GIR_RootConstrainSelectedInstOperands,
     /* 26037 */     // GIR_Coverage, 766,
     /* 26037 */     GIR_EraseRootFromParent_Done,
     /* 26038 */   // Label 777: @26038
     /* 26038 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(26083), // Rule ID 767 //
     /* 26043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsun_d),
     /* 26051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26072 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7913:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUN_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUN_D),
     /* 26075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26077 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26079 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26081 */     GIR_RootConstrainSelectedInstOperands,
     /* 26082 */     // GIR_Coverage, 767,
     /* 26082 */     GIR_EraseRootFromParent_Done,
     /* 26083 */   // Label 778: @26083
     /* 26083 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(26128), // Rule ID 768 //
     /* 26088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsune_w),
     /* 26096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26117 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7916:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUNE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUNE_W),
     /* 26120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26122 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26124 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26126 */     GIR_RootConstrainSelectedInstOperands,
     /* 26127 */     // GIR_Coverage, 768,
     /* 26127 */     GIR_EraseRootFromParent_Done,
     /* 26128 */   // Label 779: @26128
     /* 26128 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(26173), // Rule ID 769 //
     /* 26133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsune_d),
     /* 26141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26162 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7915:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUNE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUNE_D),
     /* 26165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26167 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26169 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26171 */     GIR_RootConstrainSelectedInstOperands,
     /* 26172 */     // GIR_Coverage, 769,
     /* 26172 */     GIR_EraseRootFromParent_Done,
     /* 26173 */   // Label 780: @26173
     /* 26173 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(26218), // Rule ID 774 //
     /* 26178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftq_h),
     /* 26186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26207 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7921:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FTQ_H:{ *:[v8i16] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTQ_H),
     /* 26210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26212 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26214 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26216 */     GIR_RootConstrainSelectedInstOperands,
     /* 26217 */     // GIR_Coverage, 774,
     /* 26217 */     GIR_EraseRootFromParent_Done,
     /* 26218 */   // Label 781: @26218
     /* 26218 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(26263), // Rule ID 775 //
     /* 26223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftq_w),
     /* 26231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26252 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7922:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FTQ_W:{ *:[v4i32] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTQ_W),
     /* 26255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26257 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26259 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26261 */     GIR_RootConstrainSelectedInstOperands,
     /* 26262 */     // GIR_Coverage, 775,
     /* 26262 */     GIR_EraseRootFromParent_Done,
     /* 26263 */   // Label 782: @26263
     /* 26263 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(26308), // Rule ID 780 //
     /* 26268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_h),
     /* 26276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26297 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7928:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HADD_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_H),
     /* 26300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26302 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26304 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26306 */     GIR_RootConstrainSelectedInstOperands,
     /* 26307 */     // GIR_Coverage, 780,
     /* 26307 */     GIR_EraseRootFromParent_Done,
     /* 26308 */   // Label 783: @26308
     /* 26308 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(26353), // Rule ID 781 //
     /* 26313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_w),
     /* 26321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26342 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7929:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HADD_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_W),
     /* 26345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26347 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26349 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26351 */     GIR_RootConstrainSelectedInstOperands,
     /* 26352 */     // GIR_Coverage, 781,
     /* 26352 */     GIR_EraseRootFromParent_Done,
     /* 26353 */   // Label 784: @26353
     /* 26353 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(26398), // Rule ID 782 //
     /* 26358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_d),
     /* 26366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26387 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7927:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HADD_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_D),
     /* 26390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26392 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26394 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26396 */     GIR_RootConstrainSelectedInstOperands,
     /* 26397 */     // GIR_Coverage, 782,
     /* 26397 */     GIR_EraseRootFromParent_Done,
     /* 26398 */   // Label 785: @26398
     /* 26398 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(26443), // Rule ID 783 //
     /* 26403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_h),
     /* 26411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26432 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7931:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HADD_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_H),
     /* 26435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26437 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26439 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26441 */     GIR_RootConstrainSelectedInstOperands,
     /* 26442 */     // GIR_Coverage, 783,
     /* 26442 */     GIR_EraseRootFromParent_Done,
     /* 26443 */   // Label 786: @26443
     /* 26443 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(26488), // Rule ID 784 //
     /* 26448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_w),
     /* 26456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26477 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7932:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HADD_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_W),
     /* 26480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26482 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26484 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26486 */     GIR_RootConstrainSelectedInstOperands,
     /* 26487 */     // GIR_Coverage, 784,
     /* 26487 */     GIR_EraseRootFromParent_Done,
     /* 26488 */   // Label 787: @26488
     /* 26488 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(26533), // Rule ID 785 //
     /* 26493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_d),
     /* 26501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26522 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7930:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HADD_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_D),
     /* 26525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26527 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26529 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26531 */     GIR_RootConstrainSelectedInstOperands,
     /* 26532 */     // GIR_Coverage, 785,
     /* 26532 */     GIR_EraseRootFromParent_Done,
     /* 26533 */   // Label 788: @26533
     /* 26533 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(26578), // Rule ID 786 //
     /* 26538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_h),
     /* 26546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26567 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7934:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HSUB_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_H),
     /* 26570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26572 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26574 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26576 */     GIR_RootConstrainSelectedInstOperands,
     /* 26577 */     // GIR_Coverage, 786,
     /* 26577 */     GIR_EraseRootFromParent_Done,
     /* 26578 */   // Label 789: @26578
     /* 26578 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(26623), // Rule ID 787 //
     /* 26583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_w),
     /* 26591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26612 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7935:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HSUB_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_W),
     /* 26615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26617 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26619 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26621 */     GIR_RootConstrainSelectedInstOperands,
     /* 26622 */     // GIR_Coverage, 787,
     /* 26622 */     GIR_EraseRootFromParent_Done,
     /* 26623 */   // Label 790: @26623
     /* 26623 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(26668), // Rule ID 788 //
     /* 26628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_d),
     /* 26636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26657 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7933:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HSUB_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_D),
     /* 26660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26662 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26664 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26666 */     GIR_RootConstrainSelectedInstOperands,
     /* 26667 */     // GIR_Coverage, 788,
     /* 26667 */     GIR_EraseRootFromParent_Done,
     /* 26668 */   // Label 791: @26668
     /* 26668 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(26713), // Rule ID 789 //
     /* 26673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_h),
     /* 26681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26702 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7937:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HSUB_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_H),
     /* 26705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26707 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26709 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26711 */     GIR_RootConstrainSelectedInstOperands,
     /* 26712 */     // GIR_Coverage, 789,
     /* 26712 */     GIR_EraseRootFromParent_Done,
     /* 26713 */   // Label 792: @26713
     /* 26713 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(26758), // Rule ID 790 //
     /* 26718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_w),
     /* 26726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26747 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7938:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HSUB_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_W),
     /* 26750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26752 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26754 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26756 */     GIR_RootConstrainSelectedInstOperands,
     /* 26757 */     // GIR_Coverage, 790,
     /* 26757 */     GIR_EraseRootFromParent_Done,
     /* 26758 */   // Label 793: @26758
     /* 26758 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(26803), // Rule ID 791 //
     /* 26763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_d),
     /* 26771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26792 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7936:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HSUB_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_D),
     /* 26795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26797 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26799 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26801 */     GIR_RootConstrainSelectedInstOperands,
     /* 26802 */     // GIR_Coverage, 791,
     /* 26802 */     GIR_EraseRootFromParent_Done,
     /* 26803 */   // Label 794: @26803
     /* 26803 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(26848), // Rule ID 844 //
     /* 26808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_b),
     /* 26816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 26819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26837 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7992:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_B),
     /* 26840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26842 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26844 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26846 */     GIR_RootConstrainSelectedInstOperands,
     /* 26847 */     // GIR_Coverage, 844,
     /* 26847 */     GIR_EraseRootFromParent_Done,
     /* 26848 */   // Label 795: @26848
     /* 26848 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(26893), // Rule ID 845 //
     /* 26853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_h),
     /* 26861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26882 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7994:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_H),
     /* 26885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26887 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26889 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26891 */     GIR_RootConstrainSelectedInstOperands,
     /* 26892 */     // GIR_Coverage, 845,
     /* 26892 */     GIR_EraseRootFromParent_Done,
     /* 26893 */   // Label 796: @26893
     /* 26893 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(26938), // Rule ID 846 //
     /* 26898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_w),
     /* 26906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26927 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7995:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_W),
     /* 26930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26932 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26934 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26936 */     GIR_RootConstrainSelectedInstOperands,
     /* 26937 */     // GIR_Coverage, 846,
     /* 26937 */     GIR_EraseRootFromParent_Done,
     /* 26938 */   // Label 797: @26938
     /* 26938 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(26983), // Rule ID 847 //
     /* 26943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_d),
     /* 26951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26972 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7993:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 26972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_D),
     /* 26975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26977 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26979 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26981 */     GIR_RootConstrainSelectedInstOperands,
     /* 26982 */     // GIR_Coverage, 847,
     /* 26982 */     GIR_EraseRootFromParent_Done,
     /* 26983 */   // Label 798: @26983
     /* 26983 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(27028), // Rule ID 864 //
     /* 26988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_b),
     /* 26996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 26999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27017 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8012:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_B),
     /* 27020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27022 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27024 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27026 */     GIR_RootConstrainSelectedInstOperands,
     /* 27027 */     // GIR_Coverage, 864,
     /* 27027 */     GIR_EraseRootFromParent_Done,
     /* 27028 */   // Label 799: @27028
     /* 27028 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(27073), // Rule ID 865 //
     /* 27033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_h),
     /* 27041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27062 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8014:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_H),
     /* 27065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27067 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27069 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27071 */     GIR_RootConstrainSelectedInstOperands,
     /* 27072 */     // GIR_Coverage, 865,
     /* 27072 */     GIR_EraseRootFromParent_Done,
     /* 27073 */   // Label 800: @27073
     /* 27073 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(27118), // Rule ID 866 //
     /* 27078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_w),
     /* 27086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27107 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8015:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_W),
     /* 27110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27112 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27114 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27116 */     GIR_RootConstrainSelectedInstOperands,
     /* 27117 */     // GIR_Coverage, 866,
     /* 27117 */     GIR_EraseRootFromParent_Done,
     /* 27118 */   // Label 801: @27118
     /* 27118 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(27163), // Rule ID 867 //
     /* 27123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_d),
     /* 27131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27152 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8013:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_D),
     /* 27155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27157 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27159 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27161 */     GIR_RootConstrainSelectedInstOperands,
     /* 27162 */     // GIR_Coverage, 867,
     /* 27162 */     GIR_EraseRootFromParent_Done,
     /* 27163 */   // Label 802: @27163
     /* 27163 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(27208), // Rule ID 900 //
     /* 27168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_q_h),
     /* 27176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27197 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8054:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MUL_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_Q_H),
     /* 27200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27202 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27204 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27206 */     GIR_RootConstrainSelectedInstOperands,
     /* 27207 */     // GIR_Coverage, 900,
     /* 27207 */     GIR_EraseRootFromParent_Done,
     /* 27208 */   // Label 803: @27208
     /* 27208 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(27253), // Rule ID 901 //
     /* 27213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_q_w),
     /* 27221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27242 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8055:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MUL_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_Q_W),
     /* 27245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27247 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27249 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27251 */     GIR_RootConstrainSelectedInstOperands,
     /* 27252 */     // GIR_Coverage, 901,
     /* 27252 */     GIR_EraseRootFromParent_Done,
     /* 27253 */   // Label 804: @27253
     /* 27253 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(27298), // Rule ID 902 //
     /* 27258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulr_q_h),
     /* 27266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27287 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8065:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MULR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULR_Q_H),
     /* 27290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27292 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27294 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27296 */     GIR_RootConstrainSelectedInstOperands,
     /* 27297 */     // GIR_Coverage, 902,
     /* 27297 */     GIR_EraseRootFromParent_Done,
     /* 27298 */   // Label 805: @27298
     /* 27298 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(27343), // Rule ID 903 //
     /* 27303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulr_q_w),
     /* 27311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27332 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8066:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MULR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULR_Q_W),
     /* 27335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27337 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27339 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27341 */     GIR_RootConstrainSelectedInstOperands,
     /* 27342 */     // GIR_Coverage, 903,
     /* 27342 */     GIR_EraseRootFromParent_Done,
     /* 27343 */   // Label 806: @27343
     /* 27343 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(27388), // Rule ID 981 //
     /* 27348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_b),
     /* 27356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27377 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8179:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRAR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_B),
     /* 27380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27382 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27384 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27386 */     GIR_RootConstrainSelectedInstOperands,
     /* 27387 */     // GIR_Coverage, 981,
     /* 27387 */     GIR_EraseRootFromParent_Done,
     /* 27388 */   // Label 807: @27388
     /* 27388 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(27433), // Rule ID 982 //
     /* 27393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_h),
     /* 27401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27422 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8181:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRAR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_H),
     /* 27425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27427 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27429 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27431 */     GIR_RootConstrainSelectedInstOperands,
     /* 27432 */     // GIR_Coverage, 982,
     /* 27432 */     GIR_EraseRootFromParent_Done,
     /* 27433 */   // Label 808: @27433
     /* 27433 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(27478), // Rule ID 983 //
     /* 27438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_w),
     /* 27446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27467 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8182:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRAR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_W),
     /* 27470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27472 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27474 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27476 */     GIR_RootConstrainSelectedInstOperands,
     /* 27477 */     // GIR_Coverage, 983,
     /* 27477 */     GIR_EraseRootFromParent_Done,
     /* 27478 */   // Label 809: @27478
     /* 27478 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(27523), // Rule ID 984 //
     /* 27483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_d),
     /* 27491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27512 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8180:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRAR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_D),
     /* 27515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27517 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27519 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27521 */     GIR_RootConstrainSelectedInstOperands,
     /* 27522 */     // GIR_Coverage, 984,
     /* 27522 */     GIR_EraseRootFromParent_Done,
     /* 27523 */   // Label 810: @27523
     /* 27523 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(27568), // Rule ID 997 //
     /* 27528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_b),
     /* 27536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27557 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8195:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRLR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_B),
     /* 27560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27562 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27564 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27566 */     GIR_RootConstrainSelectedInstOperands,
     /* 27567 */     // GIR_Coverage, 997,
     /* 27567 */     GIR_EraseRootFromParent_Done,
     /* 27568 */   // Label 811: @27568
     /* 27568 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(27613), // Rule ID 998 //
     /* 27573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_h),
     /* 27581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27602 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8197:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRLR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_H),
     /* 27605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27607 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27609 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27611 */     GIR_RootConstrainSelectedInstOperands,
     /* 27612 */     // GIR_Coverage, 998,
     /* 27612 */     GIR_EraseRootFromParent_Done,
     /* 27613 */   // Label 812: @27613
     /* 27613 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(27658), // Rule ID 999 //
     /* 27618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_w),
     /* 27626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27647 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8198:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRLR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_W),
     /* 27650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27652 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27654 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27656 */     GIR_RootConstrainSelectedInstOperands,
     /* 27657 */     // GIR_Coverage, 999,
     /* 27657 */     GIR_EraseRootFromParent_Done,
     /* 27658 */   // Label 813: @27658
     /* 27658 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(27703), // Rule ID 1000 //
     /* 27663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_d),
     /* 27671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27692 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8196:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRLR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_D),
     /* 27695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27697 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27699 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27701 */     GIR_RootConstrainSelectedInstOperands,
     /* 27702 */     // GIR_Coverage, 1000,
     /* 27702 */     GIR_EraseRootFromParent_Done,
     /* 27703 */   // Label 814: @27703
     /* 27703 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(27748), // Rule ID 1009 //
     /* 27708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_b),
     /* 27716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27737 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8216:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBS_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_B),
     /* 27740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27742 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27744 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27746 */     GIR_RootConstrainSelectedInstOperands,
     /* 27747 */     // GIR_Coverage, 1009,
     /* 27747 */     GIR_EraseRootFromParent_Done,
     /* 27748 */   // Label 815: @27748
     /* 27748 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(27793), // Rule ID 1010 //
     /* 27753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_h),
     /* 27761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27782 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8218:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBS_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_H),
     /* 27785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27787 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27789 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27791 */     GIR_RootConstrainSelectedInstOperands,
     /* 27792 */     // GIR_Coverage, 1010,
     /* 27792 */     GIR_EraseRootFromParent_Done,
     /* 27793 */   // Label 816: @27793
     /* 27793 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(27838), // Rule ID 1011 //
     /* 27798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_w),
     /* 27806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27827 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8219:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBS_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_W),
     /* 27830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27832 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27834 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27836 */     GIR_RootConstrainSelectedInstOperands,
     /* 27837 */     // GIR_Coverage, 1011,
     /* 27837 */     GIR_EraseRootFromParent_Done,
     /* 27838 */   // Label 817: @27838
     /* 27838 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(27883), // Rule ID 1012 //
     /* 27843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_d),
     /* 27851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27872 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8217:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBS_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_D),
     /* 27875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27877 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27879 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27881 */     GIR_RootConstrainSelectedInstOperands,
     /* 27882 */     // GIR_Coverage, 1012,
     /* 27882 */     GIR_EraseRootFromParent_Done,
     /* 27883 */   // Label 818: @27883
     /* 27883 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(27928), // Rule ID 1013 //
     /* 27888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_b),
     /* 27896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27917 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8220:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_B),
     /* 27920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27922 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27924 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27926 */     GIR_RootConstrainSelectedInstOperands,
     /* 27927 */     // GIR_Coverage, 1013,
     /* 27927 */     GIR_EraseRootFromParent_Done,
     /* 27928 */   // Label 819: @27928
     /* 27928 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(27973), // Rule ID 1014 //
     /* 27933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_h),
     /* 27941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27962 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8222:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_H),
     /* 27965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27967 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27969 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27971 */     GIR_RootConstrainSelectedInstOperands,
     /* 27972 */     // GIR_Coverage, 1014,
     /* 27972 */     GIR_EraseRootFromParent_Done,
     /* 27973 */   // Label 820: @27973
     /* 27973 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(28018), // Rule ID 1015 //
     /* 27978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_w),
     /* 27986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28007 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8223:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 28007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_W),
     /* 28010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28012 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28014 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28016 */     GIR_RootConstrainSelectedInstOperands,
     /* 28017 */     // GIR_Coverage, 1015,
     /* 28017 */     GIR_EraseRootFromParent_Done,
     /* 28018 */   // Label 821: @28018
     /* 28018 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(28063), // Rule ID 1016 //
     /* 28023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_d),
     /* 28031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28052 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8221:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_D),
     /* 28055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28057 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28059 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28061 */     GIR_RootConstrainSelectedInstOperands,
     /* 28062 */     // GIR_Coverage, 1016,
     /* 28062 */     GIR_EraseRootFromParent_Done,
     /* 28063 */   // Label 822: @28063
     /* 28063 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(28108), // Rule ID 1017 //
     /* 28068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_b),
     /* 28076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 28079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 28085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28097 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8224:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBSUS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 28097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_B),
     /* 28100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28102 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28104 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28106 */     GIR_RootConstrainSelectedInstOperands,
     /* 28107 */     // GIR_Coverage, 1017,
     /* 28107 */     GIR_EraseRootFromParent_Done,
     /* 28108 */   // Label 823: @28108
     /* 28108 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(28153), // Rule ID 1018 //
     /* 28113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_h),
     /* 28121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 28130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28142 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8226:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBSUS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 28142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_H),
     /* 28145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28147 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28149 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28151 */     GIR_RootConstrainSelectedInstOperands,
     /* 28152 */     // GIR_Coverage, 1018,
     /* 28152 */     GIR_EraseRootFromParent_Done,
     /* 28153 */   // Label 824: @28153
     /* 28153 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(28198), // Rule ID 1019 //
     /* 28158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_w),
     /* 28166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 28175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28187 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8227:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBSUS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 28187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_W),
     /* 28190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28192 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28194 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28196 */     GIR_RootConstrainSelectedInstOperands,
     /* 28197 */     // GIR_Coverage, 1019,
     /* 28197 */     GIR_EraseRootFromParent_Done,
     /* 28198 */   // Label 825: @28198
     /* 28198 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(28243), // Rule ID 1020 //
     /* 28203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_d),
     /* 28211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28232 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8225:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBSUS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_D),
     /* 28235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28237 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28239 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28241 */     GIR_RootConstrainSelectedInstOperands,
     /* 28242 */     // GIR_Coverage, 1020,
     /* 28242 */     GIR_EraseRootFromParent_Done,
     /* 28243 */   // Label 826: @28243
     /* 28243 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(28288), // Rule ID 1021 //
     /* 28248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_b),
     /* 28256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 28259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 28265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28277 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8228:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBSUU_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 28277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_B),
     /* 28280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28282 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28284 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28286 */     GIR_RootConstrainSelectedInstOperands,
     /* 28287 */     // GIR_Coverage, 1021,
     /* 28287 */     GIR_EraseRootFromParent_Done,
     /* 28288 */   // Label 827: @28288
     /* 28288 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(28333), // Rule ID 1022 //
     /* 28293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_h),
     /* 28301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 28310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28322 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8230:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBSUU_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 28322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_H),
     /* 28325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28327 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28329 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28331 */     GIR_RootConstrainSelectedInstOperands,
     /* 28332 */     // GIR_Coverage, 1022,
     /* 28332 */     GIR_EraseRootFromParent_Done,
     /* 28333 */   // Label 828: @28333
     /* 28333 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(28378), // Rule ID 1023 //
     /* 28338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_w),
     /* 28346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 28355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28367 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8231:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBSUU_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 28367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_W),
     /* 28370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28372 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28374 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28376 */     GIR_RootConstrainSelectedInstOperands,
     /* 28377 */     // GIR_Coverage, 1023,
     /* 28377 */     GIR_EraseRootFromParent_Done,
     /* 28378 */   // Label 829: @28378
     /* 28378 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(28423), // Rule ID 1024 //
     /* 28383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_d),
     /* 28391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28412 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8229:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBSUU_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_D),
     /* 28415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28417 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28419 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28421 */     GIR_RootConstrainSelectedInstOperands,
     /* 28422 */     // GIR_Coverage, 1024,
     /* 28422 */     GIR_EraseRootFromParent_Done,
     /* 28423 */   // Label 830: @28423
     /* 28423 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(28471), // Rule ID 1223 //
     /* 28428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_ph),
     /* 28436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28457 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7590:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_PH_MM),
     /* 28460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28469 */     GIR_RootConstrainSelectedInstOperands,
     /* 28470 */     // GIR_Coverage, 1223,
     /* 28470 */     GIR_EraseRootFromParent_Done,
     /* 28471 */   // Label 831: @28471
     /* 28471 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(28519), // Rule ID 1225 //
     /* 28476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_qb),
     /* 28484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 28493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28505 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7612:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDU_S_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 28505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_QB_MM),
     /* 28508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28517 */     GIR_RootConstrainSelectedInstOperands,
     /* 28518 */     // GIR_Coverage, 1225,
     /* 28518 */     GIR_EraseRootFromParent_Done,
     /* 28519 */   // Label 832: @28519
     /* 28519 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(28564), // Rule ID 1246 //
     /* 28524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 28532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28553 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8140:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_PH_MM),
     /* 28556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28562 */     GIR_RootConstrainSelectedInstOperands,
     /* 28563 */     // GIR_Coverage, 1246,
     /* 28563 */     GIR_EraseRootFromParent_Done,
     /* 28564 */   // Label 833: @28564
     /* 28564 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(28609), // Rule ID 1247 //
     /* 28569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 28577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28598 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8142:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_PH_MM),
     /* 28601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28607 */     GIR_RootConstrainSelectedInstOperands,
     /* 28608 */     // GIR_Coverage, 1247,
     /* 28608 */     GIR_EraseRootFromParent_Done,
     /* 28609 */   // Label 834: @28609
     /* 28609 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(28654), // Rule ID 1248 //
     /* 28614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 28622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 28625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28643 */     // (intrinsic_wo_chain:{ *:[i32] } 8144:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_W_MM),
     /* 28646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28652 */     GIR_RootConstrainSelectedInstOperands,
     /* 28653 */     // GIR_Coverage, 1248,
     /* 28653 */     GIR_EraseRootFromParent_Done,
     /* 28654 */   // Label 835: @28654
     /* 28654 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(28699), // Rule ID 1250 //
     /* 28659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 28667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28688 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8146:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRLV_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_QB_MM),
     /* 28691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28697 */     GIR_RootConstrainSelectedInstOperands,
     /* 28698 */     // GIR_Coverage, 1250,
     /* 28698 */     GIR_EraseRootFromParent_Done,
     /* 28699 */   // Label 836: @28699
     /* 28699 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(28747), // Rule ID 1261 //
     /* 28704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_ph),
     /* 28712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28733 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8210:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_PH_MM),
     /* 28736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28745 */     GIR_RootConstrainSelectedInstOperands,
     /* 28746 */     // GIR_Coverage, 1261,
     /* 28746 */     GIR_EraseRootFromParent_Done,
     /* 28747 */   // Label 837: @28747
     /* 28747 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(28795), // Rule ID 1263 //
     /* 28752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_qb),
     /* 28760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 28769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28781 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8235:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBU_S_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 28781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_QB_MM),
     /* 28784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28793 */     GIR_RootConstrainSelectedInstOperands,
     /* 28794 */     // GIR_Coverage, 1263,
     /* 28794 */     GIR_EraseRootFromParent_Done,
     /* 28795 */   // Label 838: @28795
     /* 28795 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(28840), // Rule ID 1273 //
     /* 28800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_ph_w),
     /* 28808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28829 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8115:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_PH_W_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 28829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_PH_W_MM),
     /* 28832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28838 */     GIR_RootConstrainSelectedInstOperands,
     /* 28839 */     // GIR_Coverage, 1273,
     /* 28839 */     GIR_EraseRootFromParent_Done,
     /* 28840 */   // Label 839: @28840
     /* 28840 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(28885), // Rule ID 1274 //
     /* 28845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_qb_ph),
     /* 28853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28874 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8116:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQ_QB_PH_MM:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_QB_PH_MM),
     /* 28877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28883 */     GIR_RootConstrainSelectedInstOperands,
     /* 28884 */     // GIR_Coverage, 1274,
     /* 28884 */     GIR_EraseRootFromParent_Done,
     /* 28885 */   // Label 840: @28885
     /* 28885 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(28930), // Rule ID 1293 //
     /* 28890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_packrl_ph),
     /* 28898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28919 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8087:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PACKRL_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PACKRL_PH_MM),
     /* 28922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28928 */     GIR_RootConstrainSelectedInstOperands,
     /* 28929 */     // GIR_Coverage, 1293,
     /* 28929 */     GIR_EraseRootFromParent_Done,
     /* 28930 */   // Label 841: @28930
     /* 28930 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(28975), // Rule ID 1299 //
     /* 28935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_modsub),
     /* 28943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 28946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28964 */     // (intrinsic_wo_chain:{ *:[i32] } 8040:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODSUB_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 28964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MODSUB_MM),
     /* 28967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28973 */     GIR_RootConstrainSelectedInstOperands,
     /* 28974 */     // GIR_Coverage, 1299,
     /* 28974 */     GIR_EraseRootFromParent_Done,
     /* 28975 */   // Label 842: @28975
     /* 28975 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(29020), // Rule ID 1312 //
     /* 28980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 28983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_ph),
     /* 28988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29009 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7592:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_PH_MMR2),
     /* 29012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29018 */     GIR_RootConstrainSelectedInstOperands,
     /* 29019 */     // GIR_Coverage, 1312,
     /* 29019 */     GIR_EraseRootFromParent_Done,
     /* 29020 */   // Label 843: @29020
     /* 29020 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(29065), // Rule ID 1313 //
     /* 29025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_ph),
     /* 29033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29054 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7593:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_R_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_PH_MMR2),
     /* 29057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29063 */     GIR_RootConstrainSelectedInstOperands,
     /* 29064 */     // GIR_Coverage, 1313,
     /* 29064 */     GIR_EraseRootFromParent_Done,
     /* 29065 */   // Label 844: @29065
     /* 29065 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(29110), // Rule ID 1314 //
     /* 29070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_w),
     /* 29078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29099 */     // (intrinsic_wo_chain:{ *:[i32] } 7595:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_W_MMR2),
     /* 29102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29108 */     GIR_RootConstrainSelectedInstOperands,
     /* 29109 */     // GIR_Coverage, 1314,
     /* 29109 */     GIR_EraseRootFromParent_Done,
     /* 29110 */   // Label 845: @29110
     /* 29110 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(29155), // Rule ID 1315 //
     /* 29115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_w),
     /* 29123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29144 */     // (intrinsic_wo_chain:{ *:[i32] } 7594:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_R_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_W_MMR2),
     /* 29147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29153 */     GIR_RootConstrainSelectedInstOperands,
     /* 29154 */     // GIR_Coverage, 1315,
     /* 29154 */     GIR_EraseRootFromParent_Done,
     /* 29155 */   // Label 846: @29155
     /* 29155 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(29200), // Rule ID 1318 //
     /* 29160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_qb),
     /* 29168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29189 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7613:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_QB_MMR2),
     /* 29192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29198 */     GIR_RootConstrainSelectedInstOperands,
     /* 29199 */     // GIR_Coverage, 1318,
     /* 29199 */     GIR_EraseRootFromParent_Done,
     /* 29200 */   // Label 847: @29200
     /* 29200 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(29245), // Rule ID 1319 //
     /* 29205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_r_qb),
     /* 29213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29234 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7614:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_R_QB_MMR2),
     /* 29237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29243 */     GIR_RootConstrainSelectedInstOperands,
     /* 29244 */     // GIR_Coverage, 1319,
     /* 29244 */     GIR_EraseRootFromParent_Done,
     /* 29245 */   // Label 848: @29245
     /* 29245 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(29290), // Rule ID 1325 //
     /* 29250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 29258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29279 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8141:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_QB_MMR2),
     /* 29282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29288 */     GIR_RootConstrainSelectedInstOperands,
     /* 29289 */     // GIR_Coverage, 1325,
     /* 29289 */     GIR_EraseRootFromParent_Done,
     /* 29290 */   // Label 849: @29290
     /* 29290 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(29335), // Rule ID 1326 //
     /* 29295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 29303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29324 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8143:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_QB_MMR2),
     /* 29327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29333 */     GIR_RootConstrainSelectedInstOperands,
     /* 29334 */     // GIR_Coverage, 1326,
     /* 29334 */     GIR_EraseRootFromParent_Done,
     /* 29335 */   // Label 850: @29335
     /* 29335 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(29380), // Rule ID 1331 //
     /* 29340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 29348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29369 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8145:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRLV_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_PH_MMR2),
     /* 29372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29378 */     GIR_RootConstrainSelectedInstOperands,
     /* 29379 */     // GIR_Coverage, 1331,
     /* 29379 */     GIR_EraseRootFromParent_Done,
     /* 29380 */   // Label 851: @29380
     /* 29380 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(29425), // Rule ID 1332 //
     /* 29385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_ph),
     /* 29393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29414 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8212:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_PH_MMR2),
     /* 29417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29423 */     GIR_RootConstrainSelectedInstOperands,
     /* 29424 */     // GIR_Coverage, 1332,
     /* 29424 */     GIR_EraseRootFromParent_Done,
     /* 29425 */   // Label 852: @29425
     /* 29425 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(29470), // Rule ID 1333 //
     /* 29430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_ph),
     /* 29438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29459 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8213:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_R_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_PH_MMR2),
     /* 29462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29468 */     GIR_RootConstrainSelectedInstOperands,
     /* 29469 */     // GIR_Coverage, 1333,
     /* 29469 */     GIR_EraseRootFromParent_Done,
     /* 29470 */   // Label 853: @29470
     /* 29470 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(29515), // Rule ID 1334 //
     /* 29475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_w),
     /* 29483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29504 */     // (intrinsic_wo_chain:{ *:[i32] } 8215:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_W_MMR2),
     /* 29507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29513 */     GIR_RootConstrainSelectedInstOperands,
     /* 29514 */     // GIR_Coverage, 1334,
     /* 29514 */     GIR_EraseRootFromParent_Done,
     /* 29515 */   // Label 854: @29515
     /* 29515 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(29560), // Rule ID 1335 //
     /* 29520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_w),
     /* 29528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29549 */     // (intrinsic_wo_chain:{ *:[i32] } 8214:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_R_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_W_MMR2),
     /* 29552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29558 */     GIR_RootConstrainSelectedInstOperands,
     /* 29559 */     // GIR_Coverage, 1335,
     /* 29559 */     GIR_EraseRootFromParent_Done,
     /* 29560 */   // Label 855: @29560
     /* 29560 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(29605), // Rule ID 1338 //
     /* 29565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_qb),
     /* 29573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29594 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8236:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_QB_MMR2),
     /* 29597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29603 */     GIR_RootConstrainSelectedInstOperands,
     /* 29604 */     // GIR_Coverage, 1338,
     /* 29604 */     GIR_EraseRootFromParent_Done,
     /* 29605 */   // Label 856: @29605
     /* 29605 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(29650), // Rule ID 1339 //
     /* 29610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_r_qb),
     /* 29618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29639 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8237:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_R_QB_MMR2),
     /* 29642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29648 */     GIR_RootConstrainSelectedInstOperands,
     /* 29649 */     // GIR_Coverage, 1339,
     /* 29649 */     GIR_EraseRootFromParent_Done,
     /* 29650 */   // Label 857: @29650
     /* 29650 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(29690), // Rule ID 1925 //
     /* 29655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_ph),
     /* 29663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29676 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7589:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (ADDQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 29676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_PH),
     /* 29679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29681 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29683 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29688 */     GIR_RootConstrainSelectedInstOperands,
     /* 29689 */     // GIR_Coverage, 1925,
     /* 29689 */     GIR_EraseRootFromParent_Done,
     /* 29690 */   // Label 858: @29690
     /* 29690 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(29730), // Rule ID 1927 //
     /* 29695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_ph),
     /* 29703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29716 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8209:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (SUBQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 29716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_PH),
     /* 29719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29721 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29723 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29728 */     GIR_RootConstrainSelectedInstOperands,
     /* 29729 */     // GIR_Coverage, 1927,
     /* 29729 */     GIR_EraseRootFromParent_Done,
     /* 29730 */   // Label 859: @29730
     /* 29730 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(29770), // Rule ID 1931 //
     /* 29735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_qb),
     /* 29743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29756 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7610:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (ADDU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /* 29756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_QB),
     /* 29759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29761 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29763 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29768 */     GIR_RootConstrainSelectedInstOperands,
     /* 29769 */     // GIR_Coverage, 1931,
     /* 29769 */     GIR_EraseRootFromParent_Done,
     /* 29770 */   // Label 860: @29770
     /* 29770 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(29810), // Rule ID 1933 //
     /* 29775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_qb),
     /* 29783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29796 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8233:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (SUBU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /* 29796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_QB),
     /* 29799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29801 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29803 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29808 */     GIR_RootConstrainSelectedInstOperands,
     /* 29809 */     // GIR_Coverage, 1933,
     /* 29809 */     GIR_EraseRootFromParent_Done,
     /* 29810 */   // Label 861: @29810
     /* 29810 */   GIM_Reject,
     /* 29811 */ // Label 647: @29811
     /* 29811 */ GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(32325),
     /* 29816 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 29819 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(29874), // Rule ID 477 //
     /* 29824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_ph_w),
     /* 29832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29853 */     // MIs[0] sa
     /* 29853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29861 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8113:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_PH_W),
     /* 29864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29868 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29870 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29872 */     GIR_RootConstrainSelectedInstOperands,
     /* 29873 */     // GIR_Coverage, 477,
     /* 29873 */     GIR_EraseRootFromParent_Done,
     /* 29874 */   // Label 863: @29874
     /* 29874 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(29929), // Rule ID 478 //
     /* 29879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_r_ph_w),
     /* 29887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29908 */     // MIs[0] sa
     /* 29908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29916 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8114:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_R_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_R_PH_W),
     /* 29919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29923 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29925 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29927 */     GIR_RootConstrainSelectedInstOperands,
     /* 29928 */     // GIR_Coverage, 478,
     /* 29928 */     GIR_EraseRootFromParent_Done,
     /* 29929 */   // Label 864: @29929
     /* 29929 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(29984), // Rule ID 483 //
     /* 29934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_append),
     /* 29942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29963 */     // MIs[0] sa
     /* 29963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29971 */     // (intrinsic_wo_chain:{ *:[i32] } 7626:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (APPEND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::APPEND),
     /* 29974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29978 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29982 */     GIR_RootConstrainSelectedInstOperands,
     /* 29983 */     // GIR_Coverage, 483,
     /* 29983 */     GIR_EraseRootFromParent_Done,
     /* 29984 */   // Label 865: @29984
     /* 29984 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(30039), // Rule ID 484 //
     /* 29989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_balign),
     /* 29997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30018 */     // MIs[0] sa
     /* 30018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt2),
     /* 30026 */     // (intrinsic_wo_chain:{ *:[i32] } 7651:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt2>>:$sa)  =>  (BALIGN:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BALIGN),
     /* 30029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30033 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30035 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30037 */     GIR_RootConstrainSelectedInstOperands,
     /* 30038 */     // GIR_Coverage, 484,
     /* 30038 */     GIR_EraseRootFromParent_Done,
     /* 30039 */   // Label 866: @30039
     /* 30039 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(30094), // Rule ID 485 //
     /* 30044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 30047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_prepend),
     /* 30052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30073 */     // MIs[0] sa
     /* 30073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30081 */     // (intrinsic_wo_chain:{ *:[i32] } 8119:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PREPEND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PREPEND),
     /* 30084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30088 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30090 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30092 */     GIR_RootConstrainSelectedInstOperands,
     /* 30093 */     // GIR_Coverage, 485,
     /* 30093 */     GIR_EraseRootFromParent_Done,
     /* 30094 */   // Label 867: @30094
     /* 30094 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(30149), // Rule ID 953 //
     /* 30099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_b),
     /* 30107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30128 */     // MIs[0] n
     /* 30128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 30136 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8151:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$n)  =>  (SLDI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_B),
     /* 30139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30141 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30143 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30145 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30147 */     GIR_RootConstrainSelectedInstOperands,
     /* 30148 */     // GIR_Coverage, 953,
     /* 30148 */     GIR_EraseRootFromParent_Done,
     /* 30149 */   // Label 868: @30149
     /* 30149 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(30204), // Rule ID 954 //
     /* 30154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_h),
     /* 30162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30183 */     // MIs[0] n
     /* 30183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 30191 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8153:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$n)  =>  (SLDI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_H),
     /* 30194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30196 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30198 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30200 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30202 */     GIR_RootConstrainSelectedInstOperands,
     /* 30203 */     // GIR_Coverage, 954,
     /* 30203 */     GIR_EraseRootFromParent_Done,
     /* 30204 */   // Label 869: @30204
     /* 30204 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(30259), // Rule ID 955 //
     /* 30209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_w),
     /* 30217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30238 */     // MIs[0] n
     /* 30238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt2),
     /* 30246 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8154:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt2>>:$n)  =>  (SLDI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_W),
     /* 30249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30251 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30253 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30255 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30257 */     GIR_RootConstrainSelectedInstOperands,
     /* 30258 */     // GIR_Coverage, 955,
     /* 30258 */     GIR_EraseRootFromParent_Done,
     /* 30259 */   // Label 870: @30259
     /* 30259 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(30314), // Rule ID 956 //
     /* 30264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_d),
     /* 30272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30293 */     // MIs[0] n
     /* 30293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt1),
     /* 30301 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8152:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt1>>:$n)  =>  (SLDI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_D),
     /* 30304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30306 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30308 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30310 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30312 */     GIR_RootConstrainSelectedInstOperands,
     /* 30313 */     // GIR_Coverage, 956,
     /* 30313 */     GIR_EraseRootFromParent_Done,
     /* 30314 */   // Label 871: @30314
     /* 30314 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(30369), // Rule ID 1349 //
     /* 30319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_ph_w),
     /* 30327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 30330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 30340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30348 */     // MIs[0] sa
     /* 30348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30356 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8113:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_PH_W_MMR2:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_PH_W_MMR2),
     /* 30359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30363 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30365 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30367 */     GIR_RootConstrainSelectedInstOperands,
     /* 30368 */     // GIR_Coverage, 1349,
     /* 30368 */     GIR_EraseRootFromParent_Done,
     /* 30369 */   // Label 872: @30369
     /* 30369 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(30424), // Rule ID 1350 //
     /* 30374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_r_ph_w),
     /* 30382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 30385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 30395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30403 */     // MIs[0] sa
     /* 30403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30411 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8114:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_R_PH_W_MMR2:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_R_PH_W_MMR2),
     /* 30414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30418 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30422 */     GIR_RootConstrainSelectedInstOperands,
     /* 30423 */     // GIR_Coverage, 1350,
     /* 30423 */     GIR_EraseRootFromParent_Done,
     /* 30424 */   // Label 873: @30424
     /* 30424 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(30479), // Rule ID 1351 //
     /* 30429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_prepend),
     /* 30437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30458 */     // MIs[0] sa
     /* 30458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30466 */     // (intrinsic_wo_chain:{ *:[i32] } 8119:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PREPEND_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PREPEND_MMR2),
     /* 30469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30473 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30477 */     GIR_RootConstrainSelectedInstOperands,
     /* 30478 */     // GIR_Coverage, 1351,
     /* 30478 */     GIR_EraseRootFromParent_Done,
     /* 30479 */   // Label 874: @30479
     /* 30479 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(30534), // Rule ID 1352 //
     /* 30484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_append),
     /* 30492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30513 */     // MIs[0] sa
     /* 30513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30521 */     // (intrinsic_wo_chain:{ *:[i32] } 7626:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (APPEND_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::APPEND_MMR2),
     /* 30524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30528 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30530 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30532 */     GIR_RootConstrainSelectedInstOperands,
     /* 30533 */     // GIR_Coverage, 1352,
     /* 30533 */     GIR_EraseRootFromParent_Done,
     /* 30534 */   // Label 875: @30534
     /* 30534 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(30596), // Rule ID 1327 //
     /* 30539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_balign),
     /* 30547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30568 */     // MIs[0] bp
     /* 30568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 30572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 30576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2),
     /* 30580 */     // MIs[1] Operand 1
     /* 30580 */     // No operand predicates
     /* 30580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 30582 */     // (intrinsic_wo_chain:{ *:[i32] } 7651:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2>>:$bp)  =>  (BALIGN_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$bp, GPR32Opnd:{ *:[i32] }:$src)
     /* 30582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BALIGN_MMR2),
     /* 30585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // bp
     /* 30592 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30594 */     GIR_RootConstrainSelectedInstOperands,
     /* 30595 */     // GIR_Coverage, 1327,
     /* 30595 */     GIR_EraseRootFromParent_Done,
     /* 30596 */   // Label 876: @30596
     /* 30596 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(30650), // Rule ID 552 //
     /* 30601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_b),
     /* 30609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 30621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30637 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7660:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (BINSL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 30637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_B),
     /* 30640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30642 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30644 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30646 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30648 */     GIR_RootConstrainSelectedInstOperands,
     /* 30649 */     // GIR_Coverage, 552,
     /* 30649 */     GIR_EraseRootFromParent_Done,
     /* 30650 */   // Label 877: @30650
     /* 30650 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(30704), // Rule ID 553 //
     /* 30655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_h),
     /* 30663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 30675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30691 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7662:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (BINSL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 30691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_H),
     /* 30694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30696 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30698 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30700 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30702 */     GIR_RootConstrainSelectedInstOperands,
     /* 30703 */     // GIR_Coverage, 553,
     /* 30703 */     GIR_EraseRootFromParent_Done,
     /* 30704 */   // Label 878: @30704
     /* 30704 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(30758), // Rule ID 554 //
     /* 30709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_w),
     /* 30717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 30729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30745 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7663:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (BINSL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 30745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_W),
     /* 30748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30750 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30752 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30754 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30756 */     GIR_RootConstrainSelectedInstOperands,
     /* 30757 */     // GIR_Coverage, 554,
     /* 30757 */     GIR_EraseRootFromParent_Done,
     /* 30758 */   // Label 879: @30758
     /* 30758 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(30812), // Rule ID 555 //
     /* 30763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_d),
     /* 30771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 30783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30799 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7661:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (BINSL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 30799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_D),
     /* 30802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30804 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30806 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30808 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30810 */     GIR_RootConstrainSelectedInstOperands,
     /* 30811 */     // GIR_Coverage, 555,
     /* 30811 */     GIR_EraseRootFromParent_Done,
     /* 30812 */   // Label 880: @30812
     /* 30812 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(30866), // Rule ID 560 //
     /* 30817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_b),
     /* 30825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 30837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30853 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7668:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (BINSR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 30853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_B),
     /* 30856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30858 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30860 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30862 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30864 */     GIR_RootConstrainSelectedInstOperands,
     /* 30865 */     // GIR_Coverage, 560,
     /* 30865 */     GIR_EraseRootFromParent_Done,
     /* 30866 */   // Label 881: @30866
     /* 30866 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(30920), // Rule ID 561 //
     /* 30871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_h),
     /* 30879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 30891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30907 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7670:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (BINSR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 30907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_H),
     /* 30910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30912 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30914 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30916 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30918 */     GIR_RootConstrainSelectedInstOperands,
     /* 30919 */     // GIR_Coverage, 561,
     /* 30919 */     GIR_EraseRootFromParent_Done,
     /* 30920 */   // Label 882: @30920
     /* 30920 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(30974), // Rule ID 562 //
     /* 30925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_w),
     /* 30933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 30945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30961 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7671:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (BINSR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 30961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_W),
     /* 30964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30966 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30968 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30970 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30972 */     GIR_RootConstrainSelectedInstOperands,
     /* 30973 */     // GIR_Coverage, 562,
     /* 30973 */     GIR_EraseRootFromParent_Done,
     /* 30974 */   // Label 883: @30974
     /* 30974 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(31028), // Rule ID 563 //
     /* 30979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_d),
     /* 30987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 30999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31015 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7669:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (BINSR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 31015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_D),
     /* 31018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31020 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31022 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31024 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31026 */     GIR_RootConstrainSelectedInstOperands,
     /* 31027 */     // GIR_Coverage, 563,
     /* 31027 */     GIR_EraseRootFromParent_Done,
     /* 31028 */   // Label 884: @31028
     /* 31028 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(31082), // Rule ID 658 //
     /* 31033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_h),
     /* 31041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31069 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7789:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPADD_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_H),
     /* 31072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31074 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31076 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31078 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31080 */     GIR_RootConstrainSelectedInstOperands,
     /* 31081 */     // GIR_Coverage, 658,
     /* 31081 */     GIR_EraseRootFromParent_Done,
     /* 31082 */   // Label 885: @31082
     /* 31082 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(31136), // Rule ID 659 //
     /* 31087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_w),
     /* 31095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31123 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7790:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPADD_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_W),
     /* 31126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31128 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31130 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31132 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31134 */     GIR_RootConstrainSelectedInstOperands,
     /* 31135 */     // GIR_Coverage, 659,
     /* 31135 */     GIR_EraseRootFromParent_Done,
     /* 31136 */   // Label 886: @31136
     /* 31136 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(31190), // Rule ID 660 //
     /* 31141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_d),
     /* 31149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31177 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7788:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPADD_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_D),
     /* 31180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31182 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31184 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31186 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31188 */     GIR_RootConstrainSelectedInstOperands,
     /* 31189 */     // GIR_Coverage, 660,
     /* 31189 */     GIR_EraseRootFromParent_Done,
     /* 31190 */   // Label 887: @31190
     /* 31190 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(31244), // Rule ID 661 //
     /* 31195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_h),
     /* 31203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31231 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7792:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPADD_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_H),
     /* 31234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31236 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31238 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31240 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31242 */     GIR_RootConstrainSelectedInstOperands,
     /* 31243 */     // GIR_Coverage, 661,
     /* 31243 */     GIR_EraseRootFromParent_Done,
     /* 31244 */   // Label 888: @31244
     /* 31244 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(31298), // Rule ID 662 //
     /* 31249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_w),
     /* 31257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31285 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7793:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPADD_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_W),
     /* 31288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31290 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31292 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31294 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31296 */     GIR_RootConstrainSelectedInstOperands,
     /* 31297 */     // GIR_Coverage, 662,
     /* 31297 */     GIR_EraseRootFromParent_Done,
     /* 31298 */   // Label 889: @31298
     /* 31298 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(31352), // Rule ID 663 //
     /* 31303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_d),
     /* 31311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31339 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7791:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPADD_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_D),
     /* 31342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31344 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31346 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31348 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31350 */     GIR_RootConstrainSelectedInstOperands,
     /* 31351 */     // GIR_Coverage, 663,
     /* 31351 */     GIR_EraseRootFromParent_Done,
     /* 31352 */   // Label 890: @31352
     /* 31352 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(31406), // Rule ID 664 //
     /* 31357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_h),
     /* 31365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31393 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7809:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPSUB_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_H),
     /* 31396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31398 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31400 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31402 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31404 */     GIR_RootConstrainSelectedInstOperands,
     /* 31405 */     // GIR_Coverage, 664,
     /* 31405 */     GIR_EraseRootFromParent_Done,
     /* 31406 */   // Label 891: @31406
     /* 31406 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(31460), // Rule ID 665 //
     /* 31411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_w),
     /* 31419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31447 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7810:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPSUB_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_W),
     /* 31450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31452 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31454 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31456 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31458 */     GIR_RootConstrainSelectedInstOperands,
     /* 31459 */     // GIR_Coverage, 665,
     /* 31459 */     GIR_EraseRootFromParent_Done,
     /* 31460 */   // Label 892: @31460
     /* 31460 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(31514), // Rule ID 666 //
     /* 31465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_d),
     /* 31473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31501 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7808:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPSUB_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_D),
     /* 31504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31506 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31508 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31510 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31512 */     GIR_RootConstrainSelectedInstOperands,
     /* 31513 */     // GIR_Coverage, 666,
     /* 31513 */     GIR_EraseRootFromParent_Done,
     /* 31514 */   // Label 893: @31514
     /* 31514 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(31568), // Rule ID 667 //
     /* 31519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_h),
     /* 31527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31555 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7812:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPSUB_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_H),
     /* 31558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31560 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31562 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31564 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31566 */     GIR_RootConstrainSelectedInstOperands,
     /* 31567 */     // GIR_Coverage, 667,
     /* 31567 */     GIR_EraseRootFromParent_Done,
     /* 31568 */   // Label 894: @31568
     /* 31568 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(31622), // Rule ID 668 //
     /* 31573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_w),
     /* 31581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31609 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7813:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPSUB_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_W),
     /* 31612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31614 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31616 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31618 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31620 */     GIR_RootConstrainSelectedInstOperands,
     /* 31621 */     // GIR_Coverage, 668,
     /* 31621 */     GIR_EraseRootFromParent_Done,
     /* 31622 */   // Label 895: @31622
     /* 31622 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(31676), // Rule ID 669 //
     /* 31627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_d),
     /* 31635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31663 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7811:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPSUB_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_D),
     /* 31666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31668 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31670 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31672 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31674 */     GIR_RootConstrainSelectedInstOperands,
     /* 31675 */     // GIR_Coverage, 669,
     /* 31675 */     GIR_EraseRootFromParent_Done,
     /* 31676 */   // Label 896: @31676
     /* 31676 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(31730), // Rule ID 836 //
     /* 31681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_madd_q_h),
     /* 31689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31717 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7979:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MADD_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_Q_H),
     /* 31720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31722 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31724 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31726 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31728 */     GIR_RootConstrainSelectedInstOperands,
     /* 31729 */     // GIR_Coverage, 836,
     /* 31729 */     GIR_EraseRootFromParent_Done,
     /* 31730 */   // Label 897: @31730
     /* 31730 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(31784), // Rule ID 837 //
     /* 31735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_madd_q_w),
     /* 31743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31771 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7980:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MADD_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_Q_W),
     /* 31774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31776 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31778 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31780 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31782 */     GIR_RootConstrainSelectedInstOperands,
     /* 31783 */     // GIR_Coverage, 837,
     /* 31783 */     GIR_EraseRootFromParent_Done,
     /* 31784 */   // Label 898: @31784
     /* 31784 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(31838), // Rule ID 838 //
     /* 31789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_maddr_q_h),
     /* 31797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31825 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7981:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MADDR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDR_Q_H),
     /* 31828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31830 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31832 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31834 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31836 */     GIR_RootConstrainSelectedInstOperands,
     /* 31837 */     // GIR_Coverage, 838,
     /* 31837 */     GIR_EraseRootFromParent_Done,
     /* 31838 */   // Label 899: @31838
     /* 31838 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(31892), // Rule ID 839 //
     /* 31843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_maddr_q_w),
     /* 31851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31879 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7982:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MADDR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDR_Q_W),
     /* 31882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31884 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31886 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31888 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31890 */     GIR_RootConstrainSelectedInstOperands,
     /* 31891 */     // GIR_Coverage, 839,
     /* 31891 */     GIR_EraseRootFromParent_Done,
     /* 31892 */   // Label 900: @31892
     /* 31892 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(31946), // Rule ID 892 //
     /* 31897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msub_q_h),
     /* 31905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31933 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8043:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MSUB_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_Q_H),
     /* 31936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31938 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31940 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31942 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31944 */     GIR_RootConstrainSelectedInstOperands,
     /* 31945 */     // GIR_Coverage, 892,
     /* 31945 */     GIR_EraseRootFromParent_Done,
     /* 31946 */   // Label 901: @31946
     /* 31946 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(32000), // Rule ID 893 //
     /* 31951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msub_q_w),
     /* 31959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31987 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8044:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MSUB_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_Q_W),
     /* 31990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31992 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31994 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31996 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31998 */     GIR_RootConstrainSelectedInstOperands,
     /* 31999 */     // GIR_Coverage, 893,
     /* 31999 */     GIR_EraseRootFromParent_Done,
     /* 32000 */   // Label 902: @32000
     /* 32000 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(32054), // Rule ID 894 //
     /* 32005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msubr_q_h),
     /* 32013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 32016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 32025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32041 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8045:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MSUBR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 32041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBR_Q_H),
     /* 32044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32046 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32048 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32050 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 32052 */     GIR_RootConstrainSelectedInstOperands,
     /* 32053 */     // GIR_Coverage, 894,
     /* 32053 */     GIR_EraseRootFromParent_Done,
     /* 32054 */   // Label 903: @32054
     /* 32054 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(32108), // Rule ID 895 //
     /* 32059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msubr_q_w),
     /* 32067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 32079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32095 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8046:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MSUBR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 32095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBR_Q_W),
     /* 32098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32100 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32102 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32104 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 32106 */     GIR_RootConstrainSelectedInstOperands,
     /* 32107 */     // GIR_Coverage, 895,
     /* 32107 */     GIR_EraseRootFromParent_Done,
     /* 32108 */   // Label 904: @32108
     /* 32108 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(32162), // Rule ID 949 //
     /* 32113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_b),
     /* 32121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 32124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 32127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 32130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32149 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8147:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_B),
     /* 32152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32154 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32156 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32160 */     GIR_RootConstrainSelectedInstOperands,
     /* 32161 */     // GIR_Coverage, 949,
     /* 32161 */     GIR_EraseRootFromParent_Done,
     /* 32162 */   // Label 905: @32162
     /* 32162 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(32216), // Rule ID 950 //
     /* 32167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_h),
     /* 32175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 32178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32203 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8149:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_H),
     /* 32206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32208 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32210 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32214 */     GIR_RootConstrainSelectedInstOperands,
     /* 32215 */     // GIR_Coverage, 950,
     /* 32215 */     GIR_EraseRootFromParent_Done,
     /* 32216 */   // Label 906: @32216
     /* 32216 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(32270), // Rule ID 951 //
     /* 32221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_w),
     /* 32229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32257 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8150:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_W),
     /* 32260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32262 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32264 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32268 */     GIR_RootConstrainSelectedInstOperands,
     /* 32269 */     // GIR_Coverage, 951,
     /* 32269 */     GIR_EraseRootFromParent_Done,
     /* 32270 */   // Label 907: @32270
     /* 32270 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(32324), // Rule ID 952 //
     /* 32275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_d),
     /* 32283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32311 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8148:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_D),
     /* 32314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32316 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32318 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32322 */     GIR_RootConstrainSelectedInstOperands,
     /* 32323 */     // GIR_Coverage, 952,
     /* 32323 */     GIR_EraseRootFromParent_Done,
     /* 32324 */   // Label 908: @32324
     /* 32324 */   GIM_Reject,
     /* 32325 */ // Label 862: @32325
     /* 32325 */ GIM_Reject,
     /* 32326 */ // Label 30: @32326
     /* 32326 */ GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(32357), // Rule ID 354 //
     /* 32331 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 32334 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bposge32),
     /* 32339 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32346 */   // (intrinsic_w_chain:{ *:[i32] } 7694:{ *:[iPTR] })  =>  (BPOSGE32_PSEUDO:{ *:[i32] })
     /* 32346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BPOSGE32_PSEUDO),
     /* 32349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32351 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32355 */   GIR_RootConstrainSelectedInstOperands,
     /* 32356 */   // GIR_Coverage, 354,
     /* 32356 */   GIR_EraseRootFromParent_Done,
     /* 32357 */ // Label 909: @32357
     /* 32357 */ GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(33294),
     /* 32362 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 32365 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(32406), // Rule ID 441 //
     /* 32370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_rddsp),
     /* 32378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32385 */     // MIs[0] mask
     /* 32385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt10),
     /* 32393 */     // (intrinsic_w_chain:{ *:[i32] } 8121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timmZExt10>>:$mask)  =>  (RDDSP:{ *:[i32] } (timm:{ *:[i32] }):$mask)
     /* 32393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RDDSP),
     /* 32396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32398 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32404 */     GIR_RootConstrainSelectedInstOperands,
     /* 32405 */     // GIR_Coverage, 441,
     /* 32405 */     GIR_EraseRootFromParent_Done,
     /* 32406 */   // Label 911: @32406
     /* 32406 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(32442), // Rule ID 1287 //
     /* 32411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_rddsp),
     /* 32419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32426 */     // MIs[0] mask
     /* 32426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32429 */     // (intrinsic_w_chain:{ *:[i32] } 8121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timmZExt7>>:$mask)  =>  (RDDSP_MM:{ *:[i32] } (timm:{ *:[i32] }):$mask)
     /* 32429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RDDSP_MM),
     /* 32432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32434 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32440 */     GIR_RootConstrainSelectedInstOperands,
     /* 32441 */     // GIR_Coverage, 1287,
     /* 32441 */     GIR_EraseRootFromParent_Done,
     /* 32442 */   // Label 912: @32442
     /* 32442 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(32483), // Rule ID 442 //
     /* 32447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_NotInMicroMips),
     /* 32450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_wrdsp),
     /* 32455 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 32458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32462 */     // MIs[0] mask
     /* 32462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt10),
     /* 32470 */     // (intrinsic_void 8250:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt10>>:$mask)  =>  (WRDSP GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$mask)
     /* 32470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::WRDSP),
     /* 32473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32475 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32481 */     GIR_RootConstrainSelectedInstOperands,
     /* 32482 */     // GIR_Coverage, 442,
     /* 32482 */     GIR_EraseRootFromParent_Done,
     /* 32483 */   // Label 913: @32483
     /* 32483 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(32519), // Rule ID 1298 //
     /* 32488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_wrdsp),
     /* 32496 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 32499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32503 */     // MIs[0] mask
     /* 32503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32506 */     // (intrinsic_void 8250:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (timm:{ *:[i32] })<<P:Predicate_timmZExt7>>:$mask)  =>  (WRDSP_MM GPR32Opnd:{ *:[i32] }:$rt, (timm:{ *:[i32] }):$mask)
     /* 32506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::WRDSP_MM),
     /* 32509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 32511 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32517 */     GIR_RootConstrainSelectedInstOperands,
     /* 32518 */     // GIR_Coverage, 1298,
     /* 32518 */     GIR_EraseRootFromParent_Done,
     /* 32519 */   // Label 914: @32519
     /* 32519 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(32562), // Rule ID 363 //
     /* 32524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_ph),
     /* 32532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 32535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32546 */     // (intrinsic_w_chain:{ *:[v2i16] } 7582:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ABSQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_PH),
     /* 32549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32560 */     GIR_RootConstrainSelectedInstOperands,
     /* 32561 */     // GIR_Coverage, 363,
     /* 32561 */     GIR_EraseRootFromParent_Done,
     /* 32562 */   // Label 915: @32562
     /* 32562 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(32605), // Rule ID 364 //
     /* 32567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_w),
     /* 32575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 32581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32589 */     // (intrinsic_w_chain:{ *:[i32] } 7584:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ABSQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 32589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_W),
     /* 32592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32603 */     GIR_RootConstrainSelectedInstOperands,
     /* 32604 */     // GIR_Coverage, 364,
     /* 32604 */     GIR_EraseRootFromParent_Done,
     /* 32605 */   // Label 916: @32605
     /* 32605 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(32648), // Rule ID 450 //
     /* 32610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 32613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_qb),
     /* 32618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 32621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32632 */     // (intrinsic_w_chain:{ *:[v4i8] } 7583:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ABSQ_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_QB),
     /* 32635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32646 */     GIR_RootConstrainSelectedInstOperands,
     /* 32647 */     // GIR_Coverage, 450,
     /* 32647 */     GIR_EraseRootFromParent_Done,
     /* 32648 */   // Label 917: @32648
     /* 32648 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(32691), // Rule ID 1230 //
     /* 32653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_ph),
     /* 32661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 32664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32675 */     // (intrinsic_w_chain:{ *:[v2i16] } 7582:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (ABSQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 32675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_PH_MM),
     /* 32678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32689 */     GIR_RootConstrainSelectedInstOperands,
     /* 32690 */     // GIR_Coverage, 1230,
     /* 32690 */     GIR_EraseRootFromParent_Done,
     /* 32691 */   // Label 918: @32691
     /* 32691 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(32734), // Rule ID 1231 //
     /* 32696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_w),
     /* 32704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 32710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32718 */     // (intrinsic_w_chain:{ *:[i32] } 7584:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ABSQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 32718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_W_MM),
     /* 32721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32732 */     GIR_RootConstrainSelectedInstOperands,
     /* 32733 */     // GIR_Coverage, 1231,
     /* 32733 */     GIR_EraseRootFromParent_Done,
     /* 32734 */   // Label 919: @32734
     /* 32734 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(32777), // Rule ID 1311 //
     /* 32739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 32742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_qb),
     /* 32747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 32750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32761 */     // (intrinsic_w_chain:{ *:[v4i8] } 7583:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (ABSQ_S_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 32761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_QB_MMR2),
     /* 32764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32775 */     GIR_RootConstrainSelectedInstOperands,
     /* 32776 */     // GIR_Coverage, 1311,
     /* 32776 */     GIR_EraseRootFromParent_Done,
     /* 32777 */   // Label 920: @32777
     /* 32777 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(32820), // Rule ID 417 //
     /* 32782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_eq_qb),
     /* 32790 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32804 */     // (intrinsic_void 7760:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_EQ_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_EQ_QB),
     /* 32807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32818 */     GIR_RootConstrainSelectedInstOperands,
     /* 32819 */     // GIR_Coverage, 417,
     /* 32819 */     GIR_EraseRootFromParent_Done,
     /* 32820 */   // Label 921: @32820
     /* 32820 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(32863), // Rule ID 418 //
     /* 32825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_lt_qb),
     /* 32833 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32847 */     // (intrinsic_void 7762:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LT_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LT_QB),
     /* 32850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32861 */     GIR_RootConstrainSelectedInstOperands,
     /* 32862 */     // GIR_Coverage, 418,
     /* 32862 */     GIR_EraseRootFromParent_Done,
     /* 32863 */   // Label 922: @32863
     /* 32863 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(32906), // Rule ID 419 //
     /* 32868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_le_qb),
     /* 32876 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32890 */     // (intrinsic_void 7761:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LE_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LE_QB),
     /* 32893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32904 */     GIR_RootConstrainSelectedInstOperands,
     /* 32905 */     // GIR_Coverage, 419,
     /* 32905 */     GIR_EraseRootFromParent_Done,
     /* 32906 */   // Label 923: @32906
     /* 32906 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(32949), // Rule ID 423 //
     /* 32911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_eq_ph),
     /* 32919 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 32922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32933 */     // (intrinsic_void 7751:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_EQ_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_PH),
     /* 32936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32947 */     GIR_RootConstrainSelectedInstOperands,
     /* 32948 */     // GIR_Coverage, 423,
     /* 32948 */     GIR_EraseRootFromParent_Done,
     /* 32949 */   // Label 924: @32949
     /* 32949 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(32992), // Rule ID 424 //
     /* 32954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_lt_ph),
     /* 32962 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 32965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32976 */     // (intrinsic_void 7753:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LT_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_PH),
     /* 32979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32990 */     GIR_RootConstrainSelectedInstOperands,
     /* 32991 */     // GIR_Coverage, 424,
     /* 32991 */     GIR_EraseRootFromParent_Done,
     /* 32992 */   // Label 925: @32992
     /* 32992 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(33035), // Rule ID 425 //
     /* 32997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_le_ph),
     /* 33005 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33019 */     // (intrinsic_void 7752:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LE_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_PH),
     /* 33022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33033 */     GIR_RootConstrainSelectedInstOperands,
     /* 33034 */     // GIR_Coverage, 425,
     /* 33034 */     GIR_EraseRootFromParent_Done,
     /* 33035 */   // Label 926: @33035
     /* 33035 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(33078), // Rule ID 1302 //
     /* 33040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_eq_ph),
     /* 33048 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33062 */     // (intrinsic_void 7751:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_EQ_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_PH_MM),
     /* 33065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33076 */     GIR_RootConstrainSelectedInstOperands,
     /* 33077 */     // GIR_Coverage, 1302,
     /* 33077 */     GIR_EraseRootFromParent_Done,
     /* 33078 */   // Label 927: @33078
     /* 33078 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(33121), // Rule ID 1303 //
     /* 33083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_lt_ph),
     /* 33091 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33105 */     // (intrinsic_void 7753:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LT_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_PH_MM),
     /* 33108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33119 */     GIR_RootConstrainSelectedInstOperands,
     /* 33120 */     // GIR_Coverage, 1303,
     /* 33120 */     GIR_EraseRootFromParent_Done,
     /* 33121 */   // Label 928: @33121
     /* 33121 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(33164), // Rule ID 1304 //
     /* 33126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_le_ph),
     /* 33134 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33148 */     // (intrinsic_void 7752:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LE_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_PH_MM),
     /* 33151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33162 */     GIR_RootConstrainSelectedInstOperands,
     /* 33163 */     // GIR_Coverage, 1304,
     /* 33163 */     GIR_EraseRootFromParent_Done,
     /* 33164 */   // Label 929: @33164
     /* 33164 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(33207), // Rule ID 1308 //
     /* 33169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_eq_qb),
     /* 33177 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33191 */     // (intrinsic_void 7760:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_EQ_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_EQ_QB_MM),
     /* 33194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33205 */     GIR_RootConstrainSelectedInstOperands,
     /* 33206 */     // GIR_Coverage, 1308,
     /* 33206 */     GIR_EraseRootFromParent_Done,
     /* 33207 */   // Label 930: @33207
     /* 33207 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(33250), // Rule ID 1309 //
     /* 33212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_lt_qb),
     /* 33220 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33234 */     // (intrinsic_void 7762:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LT_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LT_QB_MM),
     /* 33237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33248 */     GIR_RootConstrainSelectedInstOperands,
     /* 33249 */     // GIR_Coverage, 1309,
     /* 33249 */     GIR_EraseRootFromParent_Done,
     /* 33250 */   // Label 931: @33250
     /* 33250 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(33293), // Rule ID 1310 //
     /* 33255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_le_qb),
     /* 33263 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33277 */     // (intrinsic_void 7761:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LE_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LE_QB_MM),
     /* 33280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33291 */     GIR_RootConstrainSelectedInstOperands,
     /* 33292 */     // GIR_Coverage, 1310,
     /* 33292 */     GIR_EraseRootFromParent_Done,
     /* 33293 */   // Label 932: @33293
     /* 33293 */   GIM_Reject,
     /* 33294 */ // Label 910: @33294
     /* 33294 */ GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(37419),
     /* 33299 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 33302 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(33366), // Rule ID 382 //
     /* 33307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33344 */     // MIs[1] Operand 1
     /* 33344 */     // No operand predicates
     /* 33344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33346 */     // (intrinsic_w_chain:{ *:[v2i16] } 8138:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$rs_sa)  =>  (SHLL_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 33346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_PH),
     /* 33349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 33356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33364 */     GIR_RootConstrainSelectedInstOperands,
     /* 33365 */     // GIR_Coverage, 382,
     /* 33365 */     GIR_EraseRootFromParent_Done,
     /* 33366 */   // Label 934: @33366
     /* 33366 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(33430), // Rule ID 387 //
     /* 33371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 33379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 33408 */     // MIs[1] Operand 1
     /* 33408 */     // No operand predicates
     /* 33408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33410 */     // (intrinsic_w_chain:{ *:[i32] } 8139:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$rs_sa)  =>  (SHLL_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 33410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_W),
     /* 33413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 33420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33428 */     GIR_RootConstrainSelectedInstOperands,
     /* 33429 */     // GIR_Coverage, 387,
     /* 33429 */     GIR_EraseRootFromParent_Done,
     /* 33430 */   // Label 935: @33430
     /* 33430 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(33494), // Rule ID 1239 //
     /* 33435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33472 */     // MIs[1] Operand 1
     /* 33472 */     // No operand predicates
     /* 33472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33474 */     // (intrinsic_w_chain:{ *:[v2i16] } 8138:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$sa)  =>  (SHLL_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 33474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_PH_MM),
     /* 33477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 33479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 33484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33492 */     GIR_RootConstrainSelectedInstOperands,
     /* 33493 */     // GIR_Coverage, 1239,
     /* 33493 */     GIR_EraseRootFromParent_Done,
     /* 33494 */   // Label 936: @33494
     /* 33494 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(33558), // Rule ID 1244 //
     /* 33499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 33507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 33536 */     // MIs[1] Operand 1
     /* 33536 */     // No operand predicates
     /* 33536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33538 */     // (intrinsic_w_chain:{ *:[i32] } 8139:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$sa)  =>  (SHLL_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 33538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_W_MM),
     /* 33541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 33543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 33548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33556 */     GIR_RootConstrainSelectedInstOperands,
     /* 33557 */     // GIR_Coverage, 1244,
     /* 33557 */     GIR_EraseRootFromParent_Done,
     /* 33558 */   // Label 937: @33558
     /* 33558 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(33613), // Rule ID 1942 //
     /* 33563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 33571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33596 */     // MIs[1] Operand 1
     /* 33596 */     // No operand predicates
     /* 33596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33598 */     // (intrinsic_w_chain:{ *:[v2i16] } 8136:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHLL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 33598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_PH),
     /* 33601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33603 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 33605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 33608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33611 */     GIR_RootConstrainSelectedInstOperands,
     /* 33612 */     // GIR_Coverage, 1942,
     /* 33612 */     GIR_EraseRootFromParent_Done,
     /* 33613 */   // Label 938: @33613
     /* 33613 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(33668), // Rule ID 1948 //
     /* 33618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 33626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 33651 */     // MIs[1] Operand 1
     /* 33651 */     // No operand predicates
     /* 33651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33653 */     // (intrinsic_w_chain:{ *:[v4i8] } 8137:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHLL_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 33653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_QB),
     /* 33656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33658 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 33660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 33663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33666 */     GIR_RootConstrainSelectedInstOperands,
     /* 33667 */     // GIR_Coverage, 1948,
     /* 33667 */     GIR_EraseRootFromParent_Done,
     /* 33668 */   // Label 939: @33668
     /* 33668 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(33720), // Rule ID 359 //
     /* 33673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_w),
     /* 33681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33702 */     // (intrinsic_w_chain:{ *:[i32] } 7591:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_W),
     /* 33705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 33714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33718 */     GIR_RootConstrainSelectedInstOperands,
     /* 33719 */     // GIR_Coverage, 359,
     /* 33719 */     GIR_EraseRootFromParent_Done,
     /* 33720 */   // Label 940: @33720
     /* 33720 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(33772), // Rule ID 360 //
     /* 33725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_w),
     /* 33733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33754 */     // (intrinsic_w_chain:{ *:[i32] } 8211:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_W),
     /* 33757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 33766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33770 */     GIR_RootConstrainSelectedInstOperands,
     /* 33771 */     // GIR_Coverage, 360,
     /* 33771 */     GIR_EraseRootFromParent_Done,
     /* 33772 */   // Label 941: @33772
     /* 33772 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(33824), // Rule ID 367 //
     /* 33777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_rs_ph_w),
     /* 33785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33806 */     // (intrinsic_w_chain:{ *:[v2i16] } 8117:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_RS_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_RS_PH_W),
     /* 33809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33822 */     GIR_RootConstrainSelectedInstOperands,
     /* 33823 */     // GIR_Coverage, 367,
     /* 33823 */     GIR_EraseRootFromParent_Done,
     /* 33824 */   // Label 942: @33824
     /* 33824 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(33876), // Rule ID 368 //
     /* 33829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrqu_s_qb_ph),
     /* 33837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 33846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33858 */     // (intrinsic_w_chain:{ *:[v4i8] } 8118:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQU_S_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQU_S_QB_PH),
     /* 33861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33874 */     GIR_RootConstrainSelectedInstOperands,
     /* 33875 */     // GIR_Coverage, 368,
     /* 33875 */     GIR_EraseRootFromParent_Done,
     /* 33876 */   // Label 943: @33876
     /* 33876 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(33928), // Rule ID 379 //
     /* 33881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 33889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33910 */     // (intrinsic_w_chain:{ *:[v4i8] } 8137:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 33910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_QB),
     /* 33913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 33919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33926 */     GIR_RootConstrainSelectedInstOperands,
     /* 33927 */     // GIR_Coverage, 379,
     /* 33927 */     GIR_EraseRootFromParent_Done,
     /* 33928 */   // Label 944: @33928
     /* 33928 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(33980), // Rule ID 381 //
     /* 33933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 33941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33962 */     // (intrinsic_w_chain:{ *:[v2i16] } 8136:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 33962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_PH),
     /* 33965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 33971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33978 */     GIR_RootConstrainSelectedInstOperands,
     /* 33979 */     // GIR_Coverage, 381,
     /* 33979 */     GIR_EraseRootFromParent_Done,
     /* 33980 */   // Label 945: @33980
     /* 33980 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(34032), // Rule ID 383 //
     /* 33985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 34002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34014 */     // (intrinsic_w_chain:{ *:[v2i16] } 8138:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 34014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_PH),
     /* 34017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 34021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 34023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 34026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34030 */     GIR_RootConstrainSelectedInstOperands,
     /* 34031 */     // GIR_Coverage, 383,
     /* 34031 */     GIR_EraseRootFromParent_Done,
     /* 34032 */   // Label 946: @34032
     /* 34032 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(34084), // Rule ID 388 //
     /* 34037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 34045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 34051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 34054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34066 */     // (intrinsic_w_chain:{ *:[i32] } 8139:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 34066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_W),
     /* 34069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 34073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 34075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 34078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34082 */     GIR_RootConstrainSelectedInstOperands,
     /* 34083 */     // GIR_Coverage, 388,
     /* 34083 */     GIR_EraseRootFromParent_Done,
     /* 34084 */   // Label 947: @34084
     /* 34084 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(34136), // Rule ID 391 //
     /* 34089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbl),
     /* 34097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34118 */     // (intrinsic_w_chain:{ *:[v2i16] } 8059:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBL),
     /* 34121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34134 */     GIR_RootConstrainSelectedInstOperands,
     /* 34135 */     // GIR_Coverage, 391,
     /* 34135 */     GIR_EraseRootFromParent_Done,
     /* 34136 */   // Label 948: @34136
     /* 34136 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(34188), // Rule ID 392 //
     /* 34141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbr),
     /* 34149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34170 */     // (intrinsic_w_chain:{ *:[v2i16] } 8060:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBR),
     /* 34173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34186 */     GIR_RootConstrainSelectedInstOperands,
     /* 34187 */     // GIR_Coverage, 392,
     /* 34187 */     GIR_EraseRootFromParent_Done,
     /* 34188 */   // Label 949: @34188
     /* 34188 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(34240), // Rule ID 393 //
     /* 34193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phl),
     /* 34201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34222 */     // (intrinsic_w_chain:{ *:[i32] } 8057:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHL:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHL),
     /* 34225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34238 */     GIR_RootConstrainSelectedInstOperands,
     /* 34239 */     // GIR_Coverage, 393,
     /* 34239 */     GIR_EraseRootFromParent_Done,
     /* 34240 */   // Label 950: @34240
     /* 34240 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(34292), // Rule ID 394 //
     /* 34245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phr),
     /* 34253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34274 */     // (intrinsic_w_chain:{ *:[i32] } 8058:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHR:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHR),
     /* 34277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34290 */     GIR_RootConstrainSelectedInstOperands,
     /* 34291 */     // GIR_Coverage, 394,
     /* 34291 */     GIR_EraseRootFromParent_Done,
     /* 34292 */   // Label 951: @34292
     /* 34292 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(34344), // Rule ID 395 //
     /* 34297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_ph),
     /* 34305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34326 */     // (intrinsic_w_chain:{ *:[v2i16] } 8061:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_RS_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_PH),
     /* 34329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34342 */     GIR_RootConstrainSelectedInstOperands,
     /* 34343 */     // GIR_Coverage, 395,
     /* 34343 */     GIR_EraseRootFromParent_Done,
     /* 34344 */   // Label 952: @34344
     /* 34344 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(34393), // Rule ID 420 //
     /* 34349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_eq_qb),
     /* 34357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34378 */     // (intrinsic_w_chain:{ *:[i32] } 7757:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_EQ_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_EQ_QB),
     /* 34381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34391 */     GIR_RootConstrainSelectedInstOperands,
     /* 34392 */     // GIR_Coverage, 420,
     /* 34392 */     GIR_EraseRootFromParent_Done,
     /* 34393 */   // Label 953: @34393
     /* 34393 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(34442), // Rule ID 421 //
     /* 34398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_lt_qb),
     /* 34406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34427 */     // (intrinsic_w_chain:{ *:[i32] } 7759:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LT_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LT_QB),
     /* 34430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34440 */     GIR_RootConstrainSelectedInstOperands,
     /* 34441 */     // GIR_Coverage, 421,
     /* 34441 */     GIR_EraseRootFromParent_Done,
     /* 34442 */   // Label 954: @34442
     /* 34442 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(34491), // Rule ID 422 //
     /* 34447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_le_qb),
     /* 34455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34476 */     // (intrinsic_w_chain:{ *:[i32] } 7758:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LE_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LE_QB),
     /* 34479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34489 */     GIR_RootConstrainSelectedInstOperands,
     /* 34490 */     // GIR_Coverage, 422,
     /* 34490 */     GIR_EraseRootFromParent_Done,
     /* 34491 */   // Label 955: @34491
     /* 34491 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(34540), // Rule ID 432 //
     /* 34496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_qb),
     /* 34504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 34507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34525 */     // (intrinsic_w_chain:{ *:[v4i8] } 8101:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PICK_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_QB),
     /* 34528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34538 */     GIR_RootConstrainSelectedInstOperands,
     /* 34539 */     // GIR_Coverage, 432,
     /* 34539 */     GIR_EraseRootFromParent_Done,
     /* 34540 */   // Label 956: @34540
     /* 34540 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(34589), // Rule ID 433 //
     /* 34545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_ph),
     /* 34553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34574 */     // (intrinsic_w_chain:{ *:[v2i16] } 8100:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PICK_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_PH),
     /* 34577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34587 */     GIR_RootConstrainSelectedInstOperands,
     /* 34588 */     // GIR_Coverage, 433,
     /* 34588 */     GIR_EraseRootFromParent_Done,
     /* 34589 */   // Label 957: @34589
     /* 34589 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(34638), // Rule ID 437 //
     /* 34594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_insv),
     /* 34602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 34608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 34611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34623 */     // (intrinsic_w_chain:{ *:[i32] } 7959:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)  =>  (INSV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)
     /* 34623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSV),
     /* 34626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 34628 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 34630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 34632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34636 */     GIR_RootConstrainSelectedInstOperands,
     /* 34637 */     // GIR_Coverage, 437,
     /* 34637 */     GIR_EraseRootFromParent_Done,
     /* 34638 */   // Label 958: @34638
     /* 34638 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(34690), // Rule ID 443 //
     /* 34643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_ph),
     /* 34651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34672 */     // (intrinsic_w_chain:{ *:[v2i16] } 7609:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_PH),
     /* 34675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34688 */     GIR_RootConstrainSelectedInstOperands,
     /* 34689 */     // GIR_Coverage, 443,
     /* 34689 */     GIR_EraseRootFromParent_Done,
     /* 34690 */   // Label 959: @34690
     /* 34690 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(34742), // Rule ID 444 //
     /* 34695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_ph),
     /* 34703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34724 */     // (intrinsic_w_chain:{ *:[v2i16] } 7611:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_PH),
     /* 34727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34740 */     GIR_RootConstrainSelectedInstOperands,
     /* 34741 */     // GIR_Coverage, 444,
     /* 34741 */     GIR_EraseRootFromParent_Done,
     /* 34742 */   // Label 960: @34742
     /* 34742 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(34794), // Rule ID 445 //
     /* 34747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_ph),
     /* 34755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34776 */     // (intrinsic_w_chain:{ *:[v2i16] } 8232:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_PH),
     /* 34779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34792 */     GIR_RootConstrainSelectedInstOperands,
     /* 34793 */     // GIR_Coverage, 445,
     /* 34793 */     GIR_EraseRootFromParent_Done,
     /* 34794 */   // Label 961: @34794
     /* 34794 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(34846), // Rule ID 446 //
     /* 34799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_ph),
     /* 34807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34828 */     // (intrinsic_w_chain:{ *:[v2i16] } 8234:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_PH),
     /* 34831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34844 */     GIR_RootConstrainSelectedInstOperands,
     /* 34845 */     // GIR_Coverage, 446,
     /* 34845 */     GIR_EraseRootFromParent_Done,
     /* 34846 */   // Label 962: @34846
     /* 34846 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(34898), // Rule ID 447 //
     /* 34851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_eq_qb),
     /* 34859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34880 */     // (intrinsic_w_chain:{ *:[i32] } 7754:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_EQ_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_EQ_QB),
     /* 34883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34896 */     GIR_RootConstrainSelectedInstOperands,
     /* 34897 */     // GIR_Coverage, 447,
     /* 34897 */     GIR_EraseRootFromParent_Done,
     /* 34898 */   // Label 963: @34898
     /* 34898 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(34950), // Rule ID 448 //
     /* 34903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_lt_qb),
     /* 34911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34932 */     // (intrinsic_w_chain:{ *:[i32] } 7756:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LT_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LT_QB),
     /* 34935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34948 */     GIR_RootConstrainSelectedInstOperands,
     /* 34949 */     // GIR_Coverage, 448,
     /* 34949 */     GIR_EraseRootFromParent_Done,
     /* 34950 */   // Label 964: @34950
     /* 34950 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(35002), // Rule ID 449 //
     /* 34955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_le_qb),
     /* 34963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34984 */     // (intrinsic_w_chain:{ *:[i32] } 7755:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LE_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LE_QB),
     /* 34987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35000 */     GIR_RootConstrainSelectedInstOperands,
     /* 35001 */     // GIR_Coverage, 449,
     /* 35001 */     GIR_EraseRootFromParent_Done,
     /* 35002 */   // Label 965: @35002
     /* 35002 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(35054), // Rule ID 463 //
     /* 35007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_s_ph),
     /* 35015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35036 */     // (intrinsic_w_chain:{ *:[v2i16] } 8056:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MUL_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_S_PH),
     /* 35039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35052 */     GIR_RootConstrainSelectedInstOperands,
     /* 35053 */     // GIR_Coverage, 463,
     /* 35053 */     GIR_EraseRootFromParent_Done,
     /* 35054 */   // Label 966: @35054
     /* 35054 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(35106), // Rule ID 464 //
     /* 35059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_w),
     /* 35067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35088 */     // (intrinsic_w_chain:{ *:[i32] } 8064:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_W),
     /* 35091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35104 */     GIR_RootConstrainSelectedInstOperands,
     /* 35105 */     // GIR_Coverage, 464,
     /* 35105 */     GIR_EraseRootFromParent_Done,
     /* 35106 */   // Label 967: @35106
     /* 35106 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(35158), // Rule ID 465 //
     /* 35111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_w),
     /* 35119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35140 */     // (intrinsic_w_chain:{ *:[i32] } 8062:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_RS_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_W),
     /* 35143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35156 */     GIR_RootConstrainSelectedInstOperands,
     /* 35157 */     // GIR_Coverage, 465,
     /* 35157 */     GIR_EraseRootFromParent_Done,
     /* 35158 */   // Label 968: @35158
     /* 35158 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(35210), // Rule ID 466 //
     /* 35163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_ph),
     /* 35171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35192 */     // (intrinsic_w_chain:{ *:[v2i16] } 8063:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_PH),
     /* 35195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35208 */     GIR_RootConstrainSelectedInstOperands,
     /* 35209 */     // GIR_Coverage, 466,
     /* 35209 */     GIR_EraseRootFromParent_Done,
     /* 35210 */   // Label 969: @35210
     /* 35210 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(35259), // Rule ID 476 //
     /* 35215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_qb_ph),
     /* 35223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35244 */     // (intrinsic_w_chain:{ *:[v4i8] } 8112:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECR_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_QB_PH),
     /* 35247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35257 */     GIR_RootConstrainSelectedInstOperands,
     /* 35258 */     // GIR_Coverage, 476,
     /* 35258 */     GIR_EraseRootFromParent_Done,
     /* 35259 */   // Label 970: @35259
     /* 35259 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(35311), // Rule ID 1224 //
     /* 35264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_w),
     /* 35272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35293 */     // (intrinsic_w_chain:{ *:[i32] } 7591:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_W_MM),
     /* 35296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 35305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35309 */     GIR_RootConstrainSelectedInstOperands,
     /* 35310 */     // GIR_Coverage, 1224,
     /* 35310 */     GIR_EraseRootFromParent_Done,
     /* 35311 */   // Label 971: @35311
     /* 35311 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(35360), // Rule ID 1232 //
     /* 35316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_insv),
     /* 35324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35345 */     // (intrinsic_w_chain:{ *:[i32] } 7959:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)  =>  (INSV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSV_MM),
     /* 35348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 35350 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35358 */     GIR_RootConstrainSelectedInstOperands,
     /* 35359 */     // GIR_Coverage, 1232,
     /* 35359 */     GIR_EraseRootFromParent_Done,
     /* 35360 */   // Label 972: @35360
     /* 35360 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(35412), // Rule ID 1240 //
     /* 35365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 35373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35394 */     // (intrinsic_w_chain:{ *:[v2i16] } 8136:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_PH_MM),
     /* 35397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35410 */     GIR_RootConstrainSelectedInstOperands,
     /* 35411 */     // GIR_Coverage, 1240,
     /* 35411 */     GIR_EraseRootFromParent_Done,
     /* 35412 */   // Label 973: @35412
     /* 35412 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(35464), // Rule ID 1241 //
     /* 35417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 35425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35446 */     // (intrinsic_w_chain:{ *:[v2i16] } 8138:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_PH_MM),
     /* 35449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35462 */     GIR_RootConstrainSelectedInstOperands,
     /* 35463 */     // GIR_Coverage, 1241,
     /* 35463 */     GIR_EraseRootFromParent_Done,
     /* 35464 */   // Label 974: @35464
     /* 35464 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(35516), // Rule ID 1242 //
     /* 35469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 35477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35498 */     // (intrinsic_w_chain:{ *:[v4i8] } 8137:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_QB_MM),
     /* 35501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35514 */     GIR_RootConstrainSelectedInstOperands,
     /* 35515 */     // GIR_Coverage, 1242,
     /* 35515 */     GIR_EraseRootFromParent_Done,
     /* 35516 */   // Label 975: @35516
     /* 35516 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(35568), // Rule ID 1243 //
     /* 35521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 35529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35550 */     // (intrinsic_w_chain:{ *:[i32] } 8139:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_W_MM),
     /* 35553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35566 */     GIR_RootConstrainSelectedInstOperands,
     /* 35567 */     // GIR_Coverage, 1243,
     /* 35567 */     GIR_EraseRootFromParent_Done,
     /* 35568 */   // Label 976: @35568
     /* 35568 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(35620), // Rule ID 1262 //
     /* 35573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_w),
     /* 35581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35602 */     // (intrinsic_w_chain:{ *:[i32] } 8211:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_W_MM),
     /* 35605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 35614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35618 */     GIR_RootConstrainSelectedInstOperands,
     /* 35619 */     // GIR_Coverage, 1262,
     /* 35619 */     GIR_EraseRootFromParent_Done,
     /* 35620 */   // Label 977: @35620
     /* 35620 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(35672), // Rule ID 1268 //
     /* 35625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phl),
     /* 35633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35654 */     // (intrinsic_w_chain:{ *:[i32] } 8057:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHL_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHL_MM),
     /* 35657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35670 */     GIR_RootConstrainSelectedInstOperands,
     /* 35671 */     // GIR_Coverage, 1268,
     /* 35671 */     GIR_EraseRootFromParent_Done,
     /* 35672 */   // Label 978: @35672
     /* 35672 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(35724), // Rule ID 1269 //
     /* 35677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phr),
     /* 35685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35706 */     // (intrinsic_w_chain:{ *:[i32] } 8058:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHR_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHR_MM),
     /* 35709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35722 */     GIR_RootConstrainSelectedInstOperands,
     /* 35723 */     // GIR_Coverage, 1269,
     /* 35723 */     GIR_EraseRootFromParent_Done,
     /* 35724 */   // Label 979: @35724
     /* 35724 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(35776), // Rule ID 1270 //
     /* 35729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbl),
     /* 35737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35758 */     // (intrinsic_w_chain:{ *:[v2i16] } 8059:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBL_MM),
     /* 35761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35774 */     GIR_RootConstrainSelectedInstOperands,
     /* 35775 */     // GIR_Coverage, 1270,
     /* 35775 */     GIR_EraseRootFromParent_Done,
     /* 35776 */   // Label 980: @35776
     /* 35776 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(35828), // Rule ID 1271 //
     /* 35781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbr),
     /* 35789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35810 */     // (intrinsic_w_chain:{ *:[v2i16] } 8060:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBR_MM),
     /* 35813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35826 */     GIR_RootConstrainSelectedInstOperands,
     /* 35827 */     // GIR_Coverage, 1271,
     /* 35827 */     GIR_EraseRootFromParent_Done,
     /* 35828 */   // Label 981: @35828
     /* 35828 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(35880), // Rule ID 1272 //
     /* 35833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_ph),
     /* 35841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35862 */     // (intrinsic_w_chain:{ *:[v2i16] } 8061:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_RS_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_PH_MM),
     /* 35865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35878 */     GIR_RootConstrainSelectedInstOperands,
     /* 35879 */     // GIR_Coverage, 1272,
     /* 35879 */     GIR_EraseRootFromParent_Done,
     /* 35880 */   // Label 982: @35880
     /* 35880 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(35932), // Rule ID 1275 //
     /* 35885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrqu_s_qb_ph),
     /* 35893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35914 */     // (intrinsic_w_chain:{ *:[v4i8] } 8118:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQU_S_QB_PH_MM:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQU_S_QB_PH_MM),
     /* 35917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35930 */     GIR_RootConstrainSelectedInstOperands,
     /* 35931 */     // GIR_Coverage, 1275,
     /* 35931 */     GIR_EraseRootFromParent_Done,
     /* 35932 */   // Label 983: @35932
     /* 35932 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(35984), // Rule ID 1276 //
     /* 35937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_rs_ph_w),
     /* 35945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35966 */     // (intrinsic_w_chain:{ *:[v2i16] } 8117:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_RS_PH_W_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_RS_PH_W_MM),
     /* 35969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35982 */     GIR_RootConstrainSelectedInstOperands,
     /* 35983 */     // GIR_Coverage, 1276,
     /* 35983 */     GIR_EraseRootFromParent_Done,
     /* 35984 */   // Label 984: @35984
     /* 35984 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(36033), // Rule ID 1294 //
     /* 35989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_ph),
     /* 35997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36018 */     // (intrinsic_w_chain:{ *:[v2i16] } 8100:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PICK_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_PH_MM),
     /* 36021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36031 */     GIR_RootConstrainSelectedInstOperands,
     /* 36032 */     // GIR_Coverage, 1294,
     /* 36032 */     GIR_EraseRootFromParent_Done,
     /* 36033 */   // Label 985: @36033
     /* 36033 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(36082), // Rule ID 1295 //
     /* 36038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_qb),
     /* 36046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 36049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36067 */     // (intrinsic_w_chain:{ *:[v4i8] } 8101:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PICK_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_QB_MM),
     /* 36070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36080 */     GIR_RootConstrainSelectedInstOperands,
     /* 36081 */     // GIR_Coverage, 1295,
     /* 36081 */     GIR_EraseRootFromParent_Done,
     /* 36082 */   // Label 986: @36082
     /* 36082 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(36131), // Rule ID 1305 //
     /* 36087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_eq_qb),
     /* 36095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36116 */     // (intrinsic_w_chain:{ *:[i32] } 7757:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_EQ_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_EQ_QB_MM),
     /* 36119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36129 */     GIR_RootConstrainSelectedInstOperands,
     /* 36130 */     // GIR_Coverage, 1305,
     /* 36130 */     GIR_EraseRootFromParent_Done,
     /* 36131 */   // Label 987: @36131
     /* 36131 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(36180), // Rule ID 1306 //
     /* 36136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_lt_qb),
     /* 36144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36165 */     // (intrinsic_w_chain:{ *:[i32] } 7759:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LT_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LT_QB_MM),
     /* 36168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36178 */     GIR_RootConstrainSelectedInstOperands,
     /* 36179 */     // GIR_Coverage, 1306,
     /* 36179 */     GIR_EraseRootFromParent_Done,
     /* 36180 */   // Label 988: @36180
     /* 36180 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(36229), // Rule ID 1307 //
     /* 36185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_le_qb),
     /* 36193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36214 */     // (intrinsic_w_chain:{ *:[i32] } 7758:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LE_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LE_QB_MM),
     /* 36217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36227 */     GIR_RootConstrainSelectedInstOperands,
     /* 36228 */     // GIR_Coverage, 1307,
     /* 36228 */     GIR_EraseRootFromParent_Done,
     /* 36229 */   // Label 989: @36229
     /* 36229 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(36281), // Rule ID 1316 //
     /* 36234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_ph),
     /* 36242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36263 */     // (intrinsic_w_chain:{ *:[v2i16] } 7609:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_PH_MMR2),
     /* 36266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36279 */     GIR_RootConstrainSelectedInstOperands,
     /* 36280 */     // GIR_Coverage, 1316,
     /* 36280 */     GIR_EraseRootFromParent_Done,
     /* 36281 */   // Label 990: @36281
     /* 36281 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(36333), // Rule ID 1317 //
     /* 36286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_ph),
     /* 36294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36315 */     // (intrinsic_w_chain:{ *:[v2i16] } 7611:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_PH_MMR2),
     /* 36318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36331 */     GIR_RootConstrainSelectedInstOperands,
     /* 36332 */     // GIR_Coverage, 1317,
     /* 36332 */     GIR_EraseRootFromParent_Done,
     /* 36333 */   // Label 991: @36333
     /* 36333 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(36385), // Rule ID 1328 //
     /* 36338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_eq_qb),
     /* 36346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36367 */     // (intrinsic_w_chain:{ *:[i32] } 7754:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_EQ_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_EQ_QB_MMR2),
     /* 36370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36383 */     GIR_RootConstrainSelectedInstOperands,
     /* 36384 */     // GIR_Coverage, 1328,
     /* 36384 */     GIR_EraseRootFromParent_Done,
     /* 36385 */   // Label 992: @36385
     /* 36385 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(36437), // Rule ID 1329 //
     /* 36390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_lt_qb),
     /* 36398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36419 */     // (intrinsic_w_chain:{ *:[i32] } 7756:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LT_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LT_QB_MMR2),
     /* 36422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36435 */     GIR_RootConstrainSelectedInstOperands,
     /* 36436 */     // GIR_Coverage, 1329,
     /* 36436 */     GIR_EraseRootFromParent_Done,
     /* 36437 */   // Label 993: @36437
     /* 36437 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(36489), // Rule ID 1330 //
     /* 36442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_le_qb),
     /* 36450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36471 */     // (intrinsic_w_chain:{ *:[i32] } 7755:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LE_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LE_QB_MMR2),
     /* 36474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36487 */     GIR_RootConstrainSelectedInstOperands,
     /* 36488 */     // GIR_Coverage, 1330,
     /* 36488 */     GIR_EraseRootFromParent_Done,
     /* 36489 */   // Label 994: @36489
     /* 36489 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(36541), // Rule ID 1336 //
     /* 36494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_ph),
     /* 36502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36523 */     // (intrinsic_w_chain:{ *:[v2i16] } 8232:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_PH_MMR2),
     /* 36526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36539 */     GIR_RootConstrainSelectedInstOperands,
     /* 36540 */     // GIR_Coverage, 1336,
     /* 36540 */     GIR_EraseRootFromParent_Done,
     /* 36541 */   // Label 995: @36541
     /* 36541 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(36593), // Rule ID 1337 //
     /* 36546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_ph),
     /* 36554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36575 */     // (intrinsic_w_chain:{ *:[v2i16] } 8234:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_PH_MMR2),
     /* 36578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36591 */     GIR_RootConstrainSelectedInstOperands,
     /* 36592 */     // GIR_Coverage, 1337,
     /* 36592 */     GIR_EraseRootFromParent_Done,
     /* 36593 */   // Label 996: @36593
     /* 36593 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(36645), // Rule ID 1344 //
     /* 36598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_s_ph),
     /* 36606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36627 */     // (intrinsic_w_chain:{ *:[v2i16] } 8056:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MUL_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_S_PH_MMR2),
     /* 36630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36643 */     GIR_RootConstrainSelectedInstOperands,
     /* 36644 */     // GIR_Coverage, 1344,
     /* 36644 */     GIR_EraseRootFromParent_Done,
     /* 36645 */   // Label 997: @36645
     /* 36645 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(36697), // Rule ID 1345 //
     /* 36650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_w),
     /* 36658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36679 */     // (intrinsic_w_chain:{ *:[i32] } 8062:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_RS_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 36679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_W_MMR2),
     /* 36682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36695 */     GIR_RootConstrainSelectedInstOperands,
     /* 36696 */     // GIR_Coverage, 1345,
     /* 36696 */     GIR_EraseRootFromParent_Done,
     /* 36697 */   // Label 998: @36697
     /* 36697 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(36749), // Rule ID 1346 //
     /* 36702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_ph),
     /* 36710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36731 */     // (intrinsic_w_chain:{ *:[v2i16] } 8063:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_PH_MMR2),
     /* 36734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36747 */     GIR_RootConstrainSelectedInstOperands,
     /* 36748 */     // GIR_Coverage, 1346,
     /* 36748 */     GIR_EraseRootFromParent_Done,
     /* 36749 */   // Label 999: @36749
     /* 36749 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(36801), // Rule ID 1347 //
     /* 36754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_w),
     /* 36762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36783 */     // (intrinsic_w_chain:{ *:[i32] } 8064:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_S_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 36783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_W_MMR2),
     /* 36786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36799 */     GIR_RootConstrainSelectedInstOperands,
     /* 36800 */     // GIR_Coverage, 1347,
     /* 36800 */     GIR_EraseRootFromParent_Done,
     /* 36801 */   // Label 1000: @36801
     /* 36801 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(36850), // Rule ID 1348 //
     /* 36806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_qb_ph),
     /* 36814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 36817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36835 */     // (intrinsic_w_chain:{ *:[v4i8] } 8112:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECR_QB_PH_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_QB_PH_MMR2),
     /* 36838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36848 */     GIR_RootConstrainSelectedInstOperands,
     /* 36849 */     // GIR_Coverage, 1348,
     /* 36849 */     GIR_EraseRootFromParent_Done,
     /* 36850 */   // Label 1001: @36850
     /* 36850 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(36894), // Rule ID 1929 //
     /* 36855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 36858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_ph),
     /* 36863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36876 */     // (intrinsic_w_chain:{ *:[v2i16] } 8053:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (MUL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 36876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_PH),
     /* 36879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36881 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36883 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36892 */     GIR_RootConstrainSelectedInstOperands,
     /* 36893 */     // GIR_Coverage, 1929,
     /* 36893 */     GIR_EraseRootFromParent_Done,
     /* 36894 */   // Label 1002: @36894
     /* 36894 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(36938), // Rule ID 1935 //
     /* 36899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 36902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addsc),
     /* 36907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36920 */     // (intrinsic_w_chain:{ *:[i32] } 7608:{ *:[iPTR] }, i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)  =>  (ADDSC:{ *:[i32] } i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)
     /* 36920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDSC),
     /* 36923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36925 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36927 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCarry*/0,
     /* 36932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36936 */     GIR_RootConstrainSelectedInstOperands,
     /* 36937 */     // GIR_Coverage, 1935,
     /* 36937 */     GIR_EraseRootFromParent_Done,
     /* 36938 */   // Label 1003: @36938
     /* 36938 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(36982), // Rule ID 1937 //
     /* 36943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 36946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addwc),
     /* 36951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36964 */     // (intrinsic_w_chain:{ *:[i32] } 7623:{ *:[iPTR] }, i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)  =>  (ADDWC:{ *:[i32] } i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)
     /* 36964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDWC),
     /* 36967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36969 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36971 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36980 */     GIR_RootConstrainSelectedInstOperands,
     /* 36981 */     // GIR_Coverage, 1937,
     /* 36981 */     GIR_EraseRootFromParent_Done,
     /* 36982 */   // Label 1004: @36982
     /* 36982 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(37028), // Rule ID 487 //
     /* 36987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 36990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ldr_d),
     /* 36995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 36998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 37005 */     // MIs[0] ptr
     /* 37005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37013 */     // (intrinsic_w_chain:{ *:[v2i64] } 7973:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (LDR_D:{ *:[v2i64] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LDR_D),
     /* 37016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37018 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37020 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37026 */     GIR_RootConstrainSelectedInstOperands,
     /* 37027 */     // GIR_Coverage, 487,
     /* 37027 */     GIR_EraseRootFromParent_Done,
     /* 37028 */   // Label 1005: @37028
     /* 37028 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(37074), // Rule ID 488 //
     /* 37033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ldr_w),
     /* 37041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 37044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 37051 */     // MIs[0] ptr
     /* 37051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37059 */     // (intrinsic_w_chain:{ *:[v4i32] } 7974:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (LDR_W:{ *:[v4i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LDR_W),
     /* 37062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37064 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37066 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37072 */     GIR_RootConstrainSelectedInstOperands,
     /* 37073 */     // GIR_Coverage, 488,
     /* 37073 */     GIR_EraseRootFromParent_Done,
     /* 37074 */   // Label 1006: @37074
     /* 37074 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(37116), // Rule ID 434 //
     /* 37079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lwx),
     /* 37087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37097 */     // MIs[0] base
     /* 37097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37101 */     // (intrinsic_w_chain:{ *:[i32] } 7977:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LWX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX),
     /* 37104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37106 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37108 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37114 */     GIR_RootConstrainSelectedInstOperands,
     /* 37115 */     // GIR_Coverage, 434,
     /* 37115 */     GIR_EraseRootFromParent_Done,
     /* 37116 */   // Label 1007: @37116
     /* 37116 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(37158), // Rule ID 435 //
     /* 37121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lhx),
     /* 37129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37139 */     // MIs[0] base
     /* 37139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37143 */     // (intrinsic_w_chain:{ *:[i32] } 7975:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LHX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX),
     /* 37146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37148 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37150 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37156 */     GIR_RootConstrainSelectedInstOperands,
     /* 37157 */     // GIR_Coverage, 435,
     /* 37157 */     GIR_EraseRootFromParent_Done,
     /* 37158 */   // Label 1008: @37158
     /* 37158 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(37200), // Rule ID 436 //
     /* 37163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lbux),
     /* 37171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37181 */     // MIs[0] base
     /* 37181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37185 */     // (intrinsic_w_chain:{ *:[i32] } 7964:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LBUX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX),
     /* 37188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37190 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37192 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37198 */     GIR_RootConstrainSelectedInstOperands,
     /* 37199 */     // GIR_Coverage, 436,
     /* 37199 */     GIR_EraseRootFromParent_Done,
     /* 37200 */   // Label 1009: @37200
     /* 37200 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(37242), // Rule ID 1277 //
     /* 37205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lbux),
     /* 37213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37223 */     // MIs[0] base
     /* 37223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37227 */     // (intrinsic_w_chain:{ *:[i32] } 7964:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LBUX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX_MM),
     /* 37230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37232 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37234 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37240 */     GIR_RootConstrainSelectedInstOperands,
     /* 37241 */     // GIR_Coverage, 1277,
     /* 37241 */     GIR_EraseRootFromParent_Done,
     /* 37242 */   // Label 1010: @37242
     /* 37242 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(37284), // Rule ID 1278 //
     /* 37247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lhx),
     /* 37255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37265 */     // MIs[0] base
     /* 37265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37269 */     // (intrinsic_w_chain:{ *:[i32] } 7975:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LHX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX_MM),
     /* 37272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37274 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37276 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37282 */     GIR_RootConstrainSelectedInstOperands,
     /* 37283 */     // GIR_Coverage, 1278,
     /* 37283 */     GIR_EraseRootFromParent_Done,
     /* 37284 */   // Label 1011: @37284
     /* 37284 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(37326), // Rule ID 1279 //
     /* 37289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lwx),
     /* 37297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37307 */     // MIs[0] base
     /* 37307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37311 */     // (intrinsic_w_chain:{ *:[i32] } 7977:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LWX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX_MM),
     /* 37314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37316 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37318 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37324 */     GIR_RootConstrainSelectedInstOperands,
     /* 37325 */     // GIR_Coverage, 1279,
     /* 37325 */     GIR_EraseRootFromParent_Done,
     /* 37326 */   // Label 1012: @37326
     /* 37326 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(37372), // Rule ID 489 //
     /* 37331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_str_d),
     /* 37339 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 37342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 37349 */     // MIs[0] ptr
     /* 37349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37357 */     // (intrinsic_void 8207:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (STR_D MSA128DOpnd:{ *:[v2i64] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::STR_D),
     /* 37360 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 37362 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37364 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37370 */     GIR_RootConstrainSelectedInstOperands,
     /* 37371 */     // GIR_Coverage, 489,
     /* 37371 */     GIR_EraseRootFromParent_Done,
     /* 37372 */   // Label 1013: @37372
     /* 37372 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(37418), // Rule ID 490 //
     /* 37377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_str_w),
     /* 37385 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 37388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 37395 */     // MIs[0] ptr
     /* 37395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37403 */     // (intrinsic_void 8208:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (STR_W MSA128WOpnd:{ *:[v4i32] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::STR_W),
     /* 37406 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 37408 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37410 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37416 */     GIR_RootConstrainSelectedInstOperands,
     /* 37417 */     // GIR_Coverage, 490,
     /* 37417 */     GIR_EraseRootFromParent_Done,
     /* 37418 */   // Label 1014: @37418
     /* 37418 */   GIM_Reject,
     /* 37419 */ // Label 933: @37419
     /* 37419 */ GIM_Reject,
     /* 37420 */ // Label 31: @37420
     /* 37420 */ GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(37485), // Rule ID 1582 //
     /* 37425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 37428 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 37431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37442 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 37442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37464 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37484 */   // GIR_Coverage, 1582,
     /* 37484 */   GIR_EraseRootFromParent_Done,
     /* 37485 */ // Label 1015: @37485
     /* 37485 */ GIM_Reject,
     /* 37486 */ // Label 32: @37486
     /* 37486 */ GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(37549), // Rule ID 1575 //
     /* 37491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 37494 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 37500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37508 */   // (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$src)  =>  (SLL:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i32] })
     /* 37508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 37511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37520 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 37526 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 37531 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 37539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 37547 */   GIR_RootConstrainSelectedInstOperands,
     /* 37548 */   // GIR_Coverage, 1575,
     /* 37548 */   GIR_EraseRootFromParent_Done,
     /* 37549 */ // Label 1016: @37549
     /* 37549 */ GIM_Reject,
     /* 37550 */ // Label 33: @37550
     /* 37550 */ GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(37610),
     /* 37555 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37558 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(37584), // Rule ID 2162 //
     /* 37563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 37566 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immLi16),
     /* 37570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 37574 */     // MIs[0] Operand 1
     /* 37574 */     // No operand predicates
     /* 37574 */     // (imm:{ *:[i32] })<<P:Predicate_immLi16>>:$imm  =>  (LI16_MM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_immLi16>>:$imm)
     /* 37574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LI16_MM),
     /* 37577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 37582 */     GIR_RootConstrainSelectedInstOperands,
     /* 37583 */     // GIR_Coverage, 2162,
     /* 37583 */     GIR_EraseRootFromParent_Done,
     /* 37584 */   // Label 1018: @37584
     /* 37584 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(37609), // Rule ID 1853 //
     /* 37589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 37592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 37596 */     // MIs[0] Operand 1
     /* 37596 */     // No operand predicates
     /* 37596 */     // (imm:{ *:[i32] }):$imm  =>  (LwConstant32:{ *:[i32] } (imm:{ *:[i32] }):$imm, -1:{ *:[i32] })
     /* 37596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LwConstant32),
     /* 37599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 37601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 37604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 37607 */     GIR_RootConstrainSelectedInstOperands,
     /* 37608 */     // GIR_Coverage, 1853,
     /* 37608 */     GIR_EraseRootFromParent_Done,
     /* 37609 */   // Label 1019: @37609
     /* 37609 */   GIM_Reject,
     /* 37610 */ // Label 1017: @37610
     /* 37610 */ GIM_Reject,
     /* 37611 */ // Label 34: @37611
     /* 37611 */ GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(39074),
     /* 37616 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 37619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37626 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(37731), // Rule ID 1631 //
     /* 37631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 37639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37664 */     // MIs[2] Operand 1
     /* 37664 */     // No operand predicates
     /* 37664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37666 */     // (sext:{ *:[i64] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRA:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRA),
     /* 37673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37730 */     // GIR_Coverage, 1631,
     /* 37730 */     GIR_EraseRootFromParent_Done,
     /* 37731 */   // Label 1021: @37731
     /* 37731 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(37836), // Rule ID 1627 //
     /* 37736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 37744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37765 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37769 */     // MIs[2] Operand 1
     /* 37769 */     // No operand predicates
     /* 37769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37771 */     // (sext:{ *:[i64] } (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRL:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37771 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37774 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRL),
     /* 37778 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37783 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37835 */     // GIR_Coverage, 1627,
     /* 37835 */     GIR_EraseRootFromParent_Done,
     /* 37836 */   // Label 1022: @37836
     /* 37836 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(37941), // Rule ID 1623 //
     /* 37841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 37849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37870 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37874 */     // MIs[2] Operand 1
     /* 37874 */     // No operand predicates
     /* 37874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37876 */     // (sext:{ *:[i64] } (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SLL:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37876 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37879 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 37883 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37888 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37940 */     // GIR_Coverage, 1623,
     /* 37940 */     GIR_EraseRootFromParent_Done,
     /* 37941 */   // Label 1023: @37941
     /* 37941 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(38040), // Rule ID 1613 //
     /* 37946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 37954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 37974 */     // (sext:{ *:[i64] } (add:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ADDu:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 37974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::ADDu),
     /* 37981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37986 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37990 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 37994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38039 */     // GIR_Coverage, 1613,
     /* 38039 */     GIR_EraseRootFromParent_Done,
     /* 38040 */   // Label 1024: @38040
     /* 38040 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(38139), // Rule ID 1633 //
     /* 38045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 38053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38073 */     // (sext:{ *:[i64] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRAV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38073 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38076 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRAV),
     /* 38080 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38085 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38089 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38138 */     // GIR_Coverage, 1633,
     /* 38138 */     GIR_EraseRootFromParent_Done,
     /* 38139 */   // Label 1025: @38139
     /* 38139 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(38238), // Rule ID 1629 //
     /* 38144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 38152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38172 */     // (sext:{ *:[i64] } (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRLV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRLV),
     /* 38179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38184 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38188 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38237 */     // GIR_Coverage, 1629,
     /* 38237 */     GIR_EraseRootFromParent_Done,
     /* 38238 */   // Label 1026: @38238
     /* 38238 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(38346), // Rule ID 1617 //
     /* 38243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 38246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 38254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38274 */     // (sext:{ *:[i64] } (mul:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MUL:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38274 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38277 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MUL),
     /* 38281 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38286 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38290 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38294 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for Mips::HI0*/0,
     /* 38297 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for Mips::LO0*/1,
     /* 38300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38345 */     // GIR_Coverage, 1617,
     /* 38345 */     GIR_EraseRootFromParent_Done,
     /* 38346 */   // Label 1027: @38346
     /* 38346 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(38448), // Rule ID 1820 //
     /* 38351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 38362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38382 */     // (sext:{ *:[i64] } (mul:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MUL_R6:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38382 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38385 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MUL_R6),
     /* 38389 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38394 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38398 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38447 */     // GIR_Coverage, 1820,
     /* 38447 */     GIR_EraseRootFromParent_Done,
     /* 38448 */   // Label 1028: @38448
     /* 38448 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(38550), // Rule ID 1821 //
     /* 38453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SDIV),
     /* 38464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38484 */     // (sext:{ *:[i64] } (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (DIV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38484 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38487 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::DIV),
     /* 38491 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38496 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38500 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38549 */     // GIR_Coverage, 1821,
     /* 38549 */     GIR_EraseRootFromParent_Done,
     /* 38550 */   // Label 1029: @38550
     /* 38550 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(38649), // Rule ID 1625 //
     /* 38555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 38563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38583 */     // (sext:{ *:[i64] } (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SLLV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLLV),
     /* 38590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38648 */     // GIR_Coverage, 1625,
     /* 38648 */     GIR_EraseRootFromParent_Done,
     /* 38649 */   // Label 1030: @38649
     /* 38649 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(38751), // Rule ID 1823 //
     /* 38654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SREM),
     /* 38665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38685 */     // (sext:{ *:[i64] } (srem:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MOD:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MOD),
     /* 38692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38697 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38701 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38750 */     // GIR_Coverage, 1823,
     /* 38750 */     GIR_EraseRootFromParent_Done,
     /* 38751 */   // Label 1031: @38751
     /* 38751 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(38850), // Rule ID 1615 //
     /* 38756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 38764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38784 */     // (sext:{ *:[i64] } (sub:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SUBu:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SUBu),
     /* 38791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38796 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38800 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38849 */     // GIR_Coverage, 1615,
     /* 38849 */     GIR_EraseRootFromParent_Done,
     /* 38850 */   // Label 1032: @38850
     /* 38850 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(38952), // Rule ID 1822 //
     /* 38855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UDIV),
     /* 38866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38886 */     // (sext:{ *:[i64] } (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (DIVU:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38886 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38889 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::DIVU),
     /* 38893 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38898 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38902 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38951 */     // GIR_Coverage, 1822,
     /* 38951 */     GIR_EraseRootFromParent_Done,
     /* 38952 */   // Label 1033: @38952
     /* 38952 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(39054), // Rule ID 1824 //
     /* 38957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UREM),
     /* 38968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38988 */     // (sext:{ *:[i64] } (urem:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MODU:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38988 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38991 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MODU),
     /* 38995 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39000 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 39004 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 39008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 39010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 39013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 39017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 39027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 39035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 39038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39053 */     // GIR_Coverage, 1824,
     /* 39053 */     GIR_EraseRootFromParent_Done,
     /* 39054 */   // Label 1034: @39054
     /* 39054 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(39073), // Rule ID 1585 //
     /* 39059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39066 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SLL64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src)
     /* 39066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 39071 */     GIR_RootConstrainSelectedInstOperands,
     /* 39072 */     // GIR_Coverage, 1585,
     /* 39072 */     GIR_Done,
     /* 39073 */   // Label 1035: @39073
     /* 39073 */   GIM_Reject,
     /* 39074 */ // Label 1020: @39074
     /* 39074 */ GIM_Reject,
     /* 39075 */ // Label 35: @39075
     /* 39075 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1038*/ GIMT_Encode4(39422),
     /* 39086 */ /*GILLT_s32*//*Label 1036*/ GIMT_Encode4(39094),
     /* 39090 */ /*GILLT_s64*//*Label 1037*/ GIMT_Encode4(39320),
     /* 39094 */ // Label 1036: @39094
     /* 39094 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(39319),
     /* 39099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39102 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(39138), // Rule ID 106 //
     /* 39107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 39110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39118 */     // MIs[0] Operand 2
     /* 39118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39129 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i8:{ *:[Other] })  =>  (SEB:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB),
     /* 39132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39136 */     GIR_RootConstrainSelectedInstOperands,
     /* 39137 */     // GIR_Coverage, 106,
     /* 39137 */     GIR_EraseRootFromParent_Done,
     /* 39138 */   // Label 1040: @39138
     /* 39138 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(39174), // Rule ID 107 //
     /* 39143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 39146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39154 */     // MIs[0] Operand 2
     /* 39154 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39165 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i16:{ *:[Other] })  =>  (SEH:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH),
     /* 39168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39172 */     GIR_RootConstrainSelectedInstOperands,
     /* 39173 */     // GIR_Coverage, 107,
     /* 39173 */     GIR_EraseRootFromParent_Done,
     /* 39174 */   // Label 1041: @39174
     /* 39174 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(39210), // Rule ID 1101 //
     /* 39179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39190 */     // MIs[0] Operand 2
     /* 39190 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39201 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i8:{ *:[Other] })  =>  (SEB_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB_MM),
     /* 39204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39208 */     GIR_RootConstrainSelectedInstOperands,
     /* 39209 */     // GIR_Coverage, 1101,
     /* 39209 */     GIR_EraseRootFromParent_Done,
     /* 39210 */   // Label 1042: @39210
     /* 39210 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(39246), // Rule ID 1102 //
     /* 39215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39226 */     // MIs[0] Operand 2
     /* 39226 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39237 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i16:{ *:[Other] })  =>  (SEH_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH_MM),
     /* 39240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39244 */     GIR_RootConstrainSelectedInstOperands,
     /* 39245 */     // GIR_Coverage, 1102,
     /* 39245 */     GIR_EraseRootFromParent_Done,
     /* 39246 */   // Label 1043: @39246
     /* 39246 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(39282), // Rule ID 1911 //
     /* 39251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39262 */     // MIs[0] Operand 2
     /* 39262 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39273 */     // (sext_inreg:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val, i8:{ *:[Other] })  =>  (SebRx16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val)
     /* 39273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SebRx16),
     /* 39276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39278 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 39280 */     GIR_RootConstrainSelectedInstOperands,
     /* 39281 */     // GIR_Coverage, 1911,
     /* 39281 */     GIR_EraseRootFromParent_Done,
     /* 39282 */   // Label 1044: @39282
     /* 39282 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(39318), // Rule ID 1912 //
     /* 39287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39298 */     // MIs[0] Operand 2
     /* 39298 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39309 */     // (sext_inreg:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val, i16:{ *:[Other] })  =>  (SehRx16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val)
     /* 39309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SehRx16),
     /* 39312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39314 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 39316 */     GIR_RootConstrainSelectedInstOperands,
     /* 39317 */     // GIR_Coverage, 1912,
     /* 39317 */     GIR_EraseRootFromParent_Done,
     /* 39318 */   // Label 1045: @39318
     /* 39318 */   GIM_Reject,
     /* 39319 */ // Label 1039: @39319
     /* 39319 */ GIM_Reject,
     /* 39320 */ // Label 1037: @39320
     /* 39320 */ GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(39421),
     /* 39325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 39328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39336 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(39364), // Rule ID 261 //
     /* 39341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_IsGP64bit),
     /* 39344 */     // MIs[0] Operand 2
     /* 39344 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39355 */     // (sext_inreg:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, i8:{ *:[Other] })  =>  (SEB64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt)
     /* 39355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB64),
     /* 39358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39362 */     GIR_RootConstrainSelectedInstOperands,
     /* 39363 */     // GIR_Coverage, 261,
     /* 39363 */     GIR_EraseRootFromParent_Done,
     /* 39364 */   // Label 1047: @39364
     /* 39364 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(39392), // Rule ID 262 //
     /* 39369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_IsGP64bit),
     /* 39372 */     // MIs[0] Operand 2
     /* 39372 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39383 */     // (sext_inreg:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, i16:{ *:[Other] })  =>  (SEH64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt)
     /* 39383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH64),
     /* 39386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39390 */     GIR_RootConstrainSelectedInstOperands,
     /* 39391 */     // GIR_Coverage, 262,
     /* 39391 */     GIR_EraseRootFromParent_Done,
     /* 39392 */   // Label 1048: @39392
     /* 39392 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(39420), // Rule ID 1588 //
     /* 39397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39400 */     // MIs[0] Operand 2
     /* 39400 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 39411 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SLL64_64:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 39411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL64_64),
     /* 39414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39416 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39418 */     GIR_RootConstrainSelectedInstOperands,
     /* 39419 */     // GIR_Coverage, 1588,
     /* 39419 */     GIR_EraseRootFromParent_Done,
     /* 39420 */   // Label 1049: @39420
     /* 39420 */   GIM_Reject,
     /* 39421 */ // Label 1046: @39421
     /* 39421 */ GIM_Reject,
     /* 39422 */ // Label 1038: @39422
     /* 39422 */ GIM_Reject,
     /* 39423 */ // Label 36: @39423
     /* 39423 */ GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(39623),
     /* 39428 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 39431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39438 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(39494), // Rule ID 280 //
     /* 39443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 39446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 39450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 39454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 39458 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 39462 */     // MIs[1] Operand 1
     /* 39462 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 39467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39479 */     // (zext:{ *:[i64] } (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETEQ:{ *:[Other] }))  =>  (SEQ:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 39479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEQ),
     /* 39482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 39488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 39492 */     GIR_RootConstrainSelectedInstOperands,
     /* 39493 */     // GIR_Coverage, 280,
     /* 39493 */     GIR_EraseRootFromParent_Done,
     /* 39494 */   // Label 1051: @39494
     /* 39494 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(39550), // Rule ID 282 //
     /* 39499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 39502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 39506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 39510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 39514 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 39518 */     // MIs[1] Operand 1
     /* 39518 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 39523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39535 */     // (zext:{ *:[i64] } (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETNE:{ *:[Other] }))  =>  (SNE:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 39535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SNE),
     /* 39538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 39544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 39548 */     GIR_RootConstrainSelectedInstOperands,
     /* 39549 */     // GIR_Coverage, 282,
     /* 39549 */     GIR_EraseRootFromParent_Done,
     /* 39550 */   // Label 1052: @39550
     /* 39550 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(39622),
     /* 39555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39559 */     GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(39598), // Rule ID 1583 //
     /* 39564 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39567 */       // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (DSRL:{ *:[i64] } (DSLL64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src), 32:{ *:[i32] })
     /* 39567 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 39570 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::DSLL64_32),
     /* 39574 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39579 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 39583 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39585 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRL),
     /* 39588 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39590 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39593 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 39596 */       GIR_RootConstrainSelectedInstOperands,
     /* 39597 */       // GIR_Coverage, 1583,
     /* 39597 */       GIR_EraseRootFromParent_Done,
     /* 39598 */     // Label 1054: @39598
     /* 39598 */     GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(39621), // Rule ID 1586 //
     /* 39603 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 39606 */       // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (DEXT64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src, 0:{ *:[i32] }, 32:{ *:[i32] })
     /* 39606 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DEXT64_32),
     /* 39609 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 39611 */       GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39613 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 39616 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 39619 */       GIR_RootConstrainSelectedInstOperands,
     /* 39620 */       // GIR_Coverage, 1586,
     /* 39620 */       GIR_EraseRootFromParent_Done,
     /* 39621 */     // Label 1055: @39621
     /* 39621 */     GIM_Reject,
     /* 39622 */   // Label 1053: @39622
     /* 39622 */   GIM_Reject,
     /* 39623 */ // Label 1050: @39623
     /* 39623 */ GIM_Reject,
     /* 39624 */ // Label 37: @39624
     /* 39624 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1062*/ GIMT_Encode4(41420),
     /* 39635 */ /*GILLT_s32*//*Label 1056*/ GIMT_Encode4(39667),
     /* 39639 */ /*GILLT_s64*//*Label 1057*/ GIMT_Encode4(39929), GIMT_Encode4(0),
     /* 39647 */ /*GILLT_v2s64*//*Label 1058*/ GIMT_Encode4(40070), GIMT_Encode4(0),
     /* 39655 */ /*GILLT_v4s32*//*Label 1059*/ GIMT_Encode4(40104),
     /* 39659 */ /*GILLT_v8s16*//*Label 1060*/ GIMT_Encode4(40372),
     /* 39663 */ /*GILLT_v16s8*//*Label 1061*/ GIMT_Encode4(40768),
     /* 39667 */ // Label 1056: @39667
     /* 39667 */ GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(39928),
     /* 39672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 39678 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(39720), // Rule ID 55 //
     /* 39683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 39686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39706 */     // MIs[1] Operand 1
     /* 39706 */     // No operand predicates
     /* 39706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39708 */     // (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SLL:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 39708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 39711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 39718 */     GIR_RootConstrainSelectedInstOperands,
     /* 39719 */     // GIR_Coverage, 55,
     /* 39719 */     GIR_EraseRootFromParent_Done,
     /* 39720 */   // Label 1064: @39720
     /* 39720 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(39762), // Rule ID 1835 //
     /* 39725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39748 */     // MIs[1] Operand 1
     /* 39748 */     // No operand predicates
     /* 39748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39750 */     // (shl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SllX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 39750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SllX16),
     /* 39753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39755 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 39757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39760 */     GIR_RootConstrainSelectedInstOperands,
     /* 39761 */     // GIR_Coverage, 1835,
     /* 39761 */     GIR_EraseRootFromParent_Done,
     /* 39762 */   // Label 1065: @39762
     /* 39762 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(39804), // Rule ID 2174 //
     /* 39767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 39774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 39778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Shift),
     /* 39790 */     // MIs[1] Operand 1
     /* 39790 */     // No operand predicates
     /* 39790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39792 */     // (shl:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)  =>  (SLL16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)
     /* 39792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL16_MM),
     /* 39795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39797 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39802 */     GIR_RootConstrainSelectedInstOperands,
     /* 39803 */     // GIR_Coverage, 2174,
     /* 39803 */     GIR_EraseRootFromParent_Done,
     /* 39804 */   // Label 1066: @39804
     /* 39804 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(39846), // Rule ID 2175 //
     /* 39809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39832 */     // MIs[1] Operand 1
     /* 39832 */     // No operand predicates
     /* 39832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39834 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SLL_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 39834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_MM),
     /* 39837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39839 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39844 */     GIR_RootConstrainSelectedInstOperands,
     /* 39845 */     // GIR_Coverage, 2175,
     /* 39845 */     GIR_EraseRootFromParent_Done,
     /* 39846 */   // Label 1067: @39846
     /* 39846 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(39873), // Rule ID 61 //
     /* 39851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 39854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39866 */     // (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SLLV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 39866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLLV),
     /* 39871 */     GIR_RootConstrainSelectedInstOperands,
     /* 39872 */     // GIR_Coverage, 61,
     /* 39872 */     GIR_Done,
     /* 39873 */   // Label 1068: @39873
     /* 39873 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(39900), // Rule ID 1838 //
     /* 39878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39893 */     // (shl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SllvRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 39893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SllvRxRy16),
     /* 39898 */     GIR_RootConstrainSelectedInstOperands,
     /* 39899 */     // GIR_Coverage, 1838,
     /* 39899 */     GIR_Done,
     /* 39900 */   // Label 1069: @39900
     /* 39900 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(39927), // Rule ID 2176 //
     /* 39905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39920 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SLLV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 39920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLLV_MM),
     /* 39925 */     GIR_RootConstrainSelectedInstOperands,
     /* 39926 */     // GIR_Coverage, 2176,
     /* 39926 */     GIR_Done,
     /* 39927 */   // Label 1070: @39927
     /* 39927 */   GIM_Reject,
     /* 39928 */ // Label 1063: @39928
     /* 39928 */ GIM_Reject,
     /* 39929 */ // Label 1057: @39929
     /* 39929 */ GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(40069),
     /* 39934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 39937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 39940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39948 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(39982), // Rule ID 210 //
     /* 39953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 39956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 39968 */     // MIs[1] Operand 1
     /* 39968 */     // No operand predicates
     /* 39968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39970 */     // (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSLL:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 39970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSLL),
     /* 39973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 39980 */     GIR_RootConstrainSelectedInstOperands,
     /* 39981 */     // GIR_Coverage, 210,
     /* 39981 */     GIR_EraseRootFromParent_Done,
     /* 39982 */   // Label 1072: @39982
     /* 39982 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(40049), // Rule ID 1576 //
     /* 39987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 39998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 40002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 40007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 40009 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSLLV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 40009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 40012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 40016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40021 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 40027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 40032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 40037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSLLV),
     /* 40040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 40042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 40044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40047 */     GIR_RootConstrainSelectedInstOperands,
     /* 40048 */     // GIR_Coverage, 1576,
     /* 40048 */     GIR_EraseRootFromParent_Done,
     /* 40049 */   // Label 1073: @40049
     /* 40049 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(40068), // Rule ID 216 //
     /* 40054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 40057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 40061 */     // (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSLLV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 40061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSLLV),
     /* 40066 */     GIR_RootConstrainSelectedInstOperands,
     /* 40067 */     // GIR_Coverage, 216,
     /* 40067 */     GIR_Done,
     /* 40068 */   // Label 1074: @40068
     /* 40068 */   GIM_Reject,
     /* 40069 */ // Label 1071: @40069
     /* 40069 */ GIM_Reject,
     /* 40070 */ // Label 1058: @40070
     /* 40070 */ GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(40103), // Rule ID 960 //
     /* 40075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 40081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 40084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40096 */   // (shl:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SLL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 40096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_D),
     /* 40101 */   GIR_RootConstrainSelectedInstOperands,
     /* 40102 */   // GIR_Coverage, 960,
     /* 40102 */   GIR_Done,
     /* 40103 */ // Label 1075: @40103
     /* 40103 */ GIM_Reject,
     /* 40104 */ // Label 1059: @40104
     /* 40104 */ GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(40371),
     /* 40109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40119 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(40233), // Rule ID 2466 //
     /* 40124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40151 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 40154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40162 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40166 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40178 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40182 */     // MIs[3] Operand 1
     /* 40182 */     // No operand predicates
     /* 40182 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40186 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40190 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40194 */     // MIs[4] Operand 1
     /* 40194 */     // No operand predicates
     /* 40194 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40198 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40202 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40206 */     // MIs[5] Operand 1
     /* 40206 */     // No operand predicates
     /* 40206 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40210 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40214 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40218 */     // MIs[6] Operand 1
     /* 40218 */     // No operand predicates
     /* 40218 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 40220 */     // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SLL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 40220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40225 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 40231 */     GIR_RootConstrainSelectedInstOperands,
     /* 40232 */     // GIR_Coverage, 2466,
     /* 40232 */     GIR_EraseRootFromParent_Done,
     /* 40233 */   // Label 1077: @40233
     /* 40233 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(40347), // Rule ID 2075 //
     /* 40238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 40261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40265 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 40268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40276 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40280 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40292 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40296 */     // MIs[3] Operand 1
     /* 40296 */     // No operand predicates
     /* 40296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40300 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40304 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40308 */     // MIs[4] Operand 1
     /* 40308 */     // No operand predicates
     /* 40308 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40312 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40316 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40320 */     // MIs[5] Operand 1
     /* 40320 */     // No operand predicates
     /* 40320 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40324 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40328 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40332 */     // MIs[6] Operand 1
     /* 40332 */     // No operand predicates
     /* 40332 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 40334 */     // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SLL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 40334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40339 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 40345 */     GIR_RootConstrainSelectedInstOperands,
     /* 40346 */     // GIR_Coverage, 2075,
     /* 40346 */     GIR_EraseRootFromParent_Done,
     /* 40347 */   // Label 1078: @40347
     /* 40347 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(40370), // Rule ID 959 //
     /* 40352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40363 */     // (shl:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SLL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 40363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40368 */     GIR_RootConstrainSelectedInstOperands,
     /* 40369 */     // GIR_Coverage, 959,
     /* 40369 */     GIR_Done,
     /* 40370 */   // Label 1079: @40370
     /* 40370 */   GIM_Reject,
     /* 40371 */ // Label 1076: @40371
     /* 40371 */ GIM_Reject,
     /* 40372 */ // Label 1060: @40372
     /* 40372 */ GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(40767),
     /* 40377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40387 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(40565), // Rule ID 2465 //
     /* 40392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40419 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 40422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40430 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40434 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40438 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40442 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40446 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40450 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40466 */     // MIs[3] Operand 1
     /* 40466 */     // No operand predicates
     /* 40466 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40470 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40474 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40478 */     // MIs[4] Operand 1
     /* 40478 */     // No operand predicates
     /* 40478 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40482 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40486 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40490 */     // MIs[5] Operand 1
     /* 40490 */     // No operand predicates
     /* 40490 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40494 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40498 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40502 */     // MIs[6] Operand 1
     /* 40502 */     // No operand predicates
     /* 40502 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40506 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40510 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40514 */     // MIs[7] Operand 1
     /* 40514 */     // No operand predicates
     /* 40514 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40518 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40522 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40526 */     // MIs[8] Operand 1
     /* 40526 */     // No operand predicates
     /* 40526 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40530 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40534 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40538 */     // MIs[9] Operand 1
     /* 40538 */     // No operand predicates
     /* 40538 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40542 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40546 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40550 */     // MIs[10] Operand 1
     /* 40550 */     // No operand predicates
     /* 40550 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 40552 */     // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SLL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 40552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40557 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 40563 */     GIR_RootConstrainSelectedInstOperands,
     /* 40564 */     // GIR_Coverage, 2465,
     /* 40564 */     GIR_EraseRootFromParent_Done,
     /* 40565 */   // Label 1081: @40565
     /* 40565 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(40743), // Rule ID 2074 //
     /* 40570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 40593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40597 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 40600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40608 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40612 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40616 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40620 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40624 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40628 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40640 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40644 */     // MIs[3] Operand 1
     /* 40644 */     // No operand predicates
     /* 40644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40648 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40652 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40656 */     // MIs[4] Operand 1
     /* 40656 */     // No operand predicates
     /* 40656 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40660 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40664 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40668 */     // MIs[5] Operand 1
     /* 40668 */     // No operand predicates
     /* 40668 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40672 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40676 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40680 */     // MIs[6] Operand 1
     /* 40680 */     // No operand predicates
     /* 40680 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40684 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40688 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40692 */     // MIs[7] Operand 1
     /* 40692 */     // No operand predicates
     /* 40692 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40696 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40700 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40704 */     // MIs[8] Operand 1
     /* 40704 */     // No operand predicates
     /* 40704 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40708 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40712 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40716 */     // MIs[9] Operand 1
     /* 40716 */     // No operand predicates
     /* 40716 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40720 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40724 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40728 */     // MIs[10] Operand 1
     /* 40728 */     // No operand predicates
     /* 40728 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 40730 */     // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SLL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 40730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40735 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 40741 */     GIR_RootConstrainSelectedInstOperands,
     /* 40742 */     // GIR_Coverage, 2074,
     /* 40742 */     GIR_EraseRootFromParent_Done,
     /* 40743 */   // Label 1082: @40743
     /* 40743 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(40766), // Rule ID 958 //
     /* 40748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40759 */     // (shl:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SLL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 40759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40764 */     GIR_RootConstrainSelectedInstOperands,
     /* 40765 */     // GIR_Coverage, 958,
     /* 40765 */     GIR_Done,
     /* 40766 */   // Label 1083: @40766
     /* 40766 */   GIM_Reject,
     /* 40767 */ // Label 1080: @40767
     /* 40767 */ GIM_Reject,
     /* 40768 */ // Label 1061: @40768
     /* 40768 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(41419),
     /* 40773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 40779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 40783 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(41089), // Rule ID 2464 //
     /* 40788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 40807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40815 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 40818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40826 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40830 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40834 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40838 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40842 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40846 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40850 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 40854 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 40858 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 40862 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 40866 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 40870 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 40874 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 40878 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 40882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40890 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40894 */     // MIs[3] Operand 1
     /* 40894 */     // No operand predicates
     /* 40894 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40898 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40902 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40906 */     // MIs[4] Operand 1
     /* 40906 */     // No operand predicates
     /* 40906 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40910 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40914 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40918 */     // MIs[5] Operand 1
     /* 40918 */     // No operand predicates
     /* 40918 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40922 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40926 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40930 */     // MIs[6] Operand 1
     /* 40930 */     // No operand predicates
     /* 40930 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40934 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40938 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40942 */     // MIs[7] Operand 1
     /* 40942 */     // No operand predicates
     /* 40942 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40946 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40950 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40954 */     // MIs[8] Operand 1
     /* 40954 */     // No operand predicates
     /* 40954 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40958 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40962 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40966 */     // MIs[9] Operand 1
     /* 40966 */     // No operand predicates
     /* 40966 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40970 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40974 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40978 */     // MIs[10] Operand 1
     /* 40978 */     // No operand predicates
     /* 40978 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 40982 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40986 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40990 */     // MIs[11] Operand 1
     /* 40990 */     // No operand predicates
     /* 40990 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 40994 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40998 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41002 */     // MIs[12] Operand 1
     /* 41002 */     // No operand predicates
     /* 41002 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 41006 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41010 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41014 */     // MIs[13] Operand 1
     /* 41014 */     // No operand predicates
     /* 41014 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 41018 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41022 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41026 */     // MIs[14] Operand 1
     /* 41026 */     // No operand predicates
     /* 41026 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 41030 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41034 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41038 */     // MIs[15] Operand 1
     /* 41038 */     // No operand predicates
     /* 41038 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 41042 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41046 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41050 */     // MIs[16] Operand 1
     /* 41050 */     // No operand predicates
     /* 41050 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 41054 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41058 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41062 */     // MIs[17] Operand 1
     /* 41062 */     // No operand predicates
     /* 41062 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 41066 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41070 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41074 */     // MIs[18] Operand 1
     /* 41074 */     // No operand predicates
     /* 41074 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 41076 */     // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SLL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 41076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 41081 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 41083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 41087 */     GIR_RootConstrainSelectedInstOperands,
     /* 41088 */     // GIR_Coverage, 2464,
     /* 41088 */     GIR_EraseRootFromParent_Done,
     /* 41089 */   // Label 1085: @41089
     /* 41089 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(41395), // Rule ID 2073 //
     /* 41094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 41097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 41105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 41109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 41113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 41117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 41121 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 41124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 41128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 41132 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 41136 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 41140 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 41144 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 41148 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 41152 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 41156 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 41160 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 41164 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 41168 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 41172 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 41176 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 41180 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 41184 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 41188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 41192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41196 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41200 */     // MIs[3] Operand 1
     /* 41200 */     // No operand predicates
     /* 41200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 41204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41208 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41212 */     // MIs[4] Operand 1
     /* 41212 */     // No operand predicates
     /* 41212 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 41216 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41220 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41224 */     // MIs[5] Operand 1
     /* 41224 */     // No operand predicates
     /* 41224 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 41228 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41232 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41236 */     // MIs[6] Operand 1
     /* 41236 */     // No operand predicates
     /* 41236 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 41240 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41244 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41248 */     // MIs[7] Operand 1
     /* 41248 */     // No operand predicates
     /* 41248 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 41252 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41256 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41260 */     // MIs[8] Operand 1
     /* 41260 */     // No operand predicates
     /* 41260 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 41264 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41268 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41272 */     // MIs[9] Operand 1
     /* 41272 */     // No operand predicates
     /* 41272 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 41276 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41280 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41284 */     // MIs[10] Operand 1
     /* 41284 */     // No operand predicates
     /* 41284 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 41288 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41292 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41296 */     // MIs[11] Operand 1
     /* 41296 */     // No operand predicates
     /* 41296 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 41300 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41304 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41308 */     // MIs[12] Operand 1
     /* 41308 */     // No operand predicates
     /* 41308 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 41312 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41316 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41320 */     // MIs[13] Operand 1
     /* 41320 */     // No operand predicates
     /* 41320 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 41324 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41328 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41332 */     // MIs[14] Operand 1
     /* 41332 */     // No operand predicates
     /* 41332 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 41336 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41340 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41344 */     // MIs[15] Operand 1
     /* 41344 */     // No operand predicates
     /* 41344 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 41348 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41352 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41356 */     // MIs[16] Operand 1
     /* 41356 */     // No operand predicates
     /* 41356 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 41360 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41364 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41368 */     // MIs[17] Operand 1
     /* 41368 */     // No operand predicates
     /* 41368 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 41372 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41376 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41380 */     // MIs[18] Operand 1
     /* 41380 */     // No operand predicates
     /* 41380 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 41382 */     // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SLL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 41382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 41387 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 41389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 41393 */     GIR_RootConstrainSelectedInstOperands,
     /* 41394 */     // GIR_Coverage, 2073,
     /* 41394 */     GIR_EraseRootFromParent_Done,
     /* 41395 */   // Label 1086: @41395
     /* 41395 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(41418), // Rule ID 957 //
     /* 41400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 41403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 41407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 41411 */     // (shl:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SLL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 41411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41416 */     GIR_RootConstrainSelectedInstOperands,
     /* 41417 */     // GIR_Coverage, 957,
     /* 41417 */     GIR_Done,
     /* 41418 */   // Label 1087: @41418
     /* 41418 */   GIM_Reject,
     /* 41419 */ // Label 1084: @41419
     /* 41419 */ GIM_Reject,
     /* 41420 */ // Label 1062: @41420
     /* 41420 */ GIM_Reject,
     /* 41421 */ // Label 38: @41421
     /* 41421 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1094*/ GIMT_Encode4(43217),
     /* 41432 */ /*GILLT_s32*//*Label 1088*/ GIMT_Encode4(41464),
     /* 41436 */ /*GILLT_s64*//*Label 1089*/ GIMT_Encode4(41726), GIMT_Encode4(0),
     /* 41444 */ /*GILLT_v2s64*//*Label 1090*/ GIMT_Encode4(41867), GIMT_Encode4(0),
     /* 41452 */ /*GILLT_v4s32*//*Label 1091*/ GIMT_Encode4(41901),
     /* 41456 */ /*GILLT_v8s16*//*Label 1092*/ GIMT_Encode4(42169),
     /* 41460 */ /*GILLT_v16s8*//*Label 1093*/ GIMT_Encode4(42565),
     /* 41464 */ // Label 1088: @41464
     /* 41464 */ GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(41725),
     /* 41469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 41472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 41475 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(41517), // Rule ID 57 //
     /* 41480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 41483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41503 */     // MIs[1] Operand 1
     /* 41503 */     // No operand predicates
     /* 41503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41505 */     // (srl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SRL:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 41505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL),
     /* 41508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 41515 */     GIR_RootConstrainSelectedInstOperands,
     /* 41516 */     // GIR_Coverage, 57,
     /* 41516 */     GIR_EraseRootFromParent_Done,
     /* 41517 */   // Label 1096: @41517
     /* 41517 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(41559), // Rule ID 1836 //
     /* 41522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 41525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41545 */     // MIs[1] Operand 1
     /* 41545 */     // No operand predicates
     /* 41545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41547 */     // (srl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SrlX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 41547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SrlX16),
     /* 41550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 41552 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 41554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41557 */     GIR_RootConstrainSelectedInstOperands,
     /* 41558 */     // GIR_Coverage, 1836,
     /* 41558 */     GIR_EraseRootFromParent_Done,
     /* 41559 */   // Label 1097: @41559
     /* 41559 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(41601), // Rule ID 2177 //
     /* 41564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 41571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 41575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Shift),
     /* 41587 */     // MIs[1] Operand 1
     /* 41587 */     // No operand predicates
     /* 41587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41589 */     // (srl:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)  =>  (SRL16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)
     /* 41589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL16_MM),
     /* 41592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41594 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 41596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41599 */     GIR_RootConstrainSelectedInstOperands,
     /* 41600 */     // GIR_Coverage, 2177,
     /* 41600 */     GIR_EraseRootFromParent_Done,
     /* 41601 */   // Label 1098: @41601
     /* 41601 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(41643), // Rule ID 2178 //
     /* 41606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41629 */     // MIs[1] Operand 1
     /* 41629 */     // No operand predicates
     /* 41629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41631 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SRL_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 41631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_MM),
     /* 41634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41636 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 41638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41641 */     GIR_RootConstrainSelectedInstOperands,
     /* 41642 */     // GIR_Coverage, 2178,
     /* 41642 */     GIR_EraseRootFromParent_Done,
     /* 41643 */   // Label 1099: @41643
     /* 41643 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(41670), // Rule ID 63 //
     /* 41648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 41651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41663 */     // (srl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SRLV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 41663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRLV),
     /* 41668 */     GIR_RootConstrainSelectedInstOperands,
     /* 41669 */     // GIR_Coverage, 63,
     /* 41669 */     GIR_Done,
     /* 41670 */   // Label 1100: @41670
     /* 41670 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(41697), // Rule ID 1840 //
     /* 41675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 41678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41690 */     // (srl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SrlvRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 41690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SrlvRxRy16),
     /* 41695 */     GIR_RootConstrainSelectedInstOperands,
     /* 41696 */     // GIR_Coverage, 1840,
     /* 41696 */     GIR_Done,
     /* 41697 */   // Label 1101: @41697
     /* 41697 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(41724), // Rule ID 2179 //
     /* 41702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41717 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SRLV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 41717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRLV_MM),
     /* 41722 */     GIR_RootConstrainSelectedInstOperands,
     /* 41723 */     // GIR_Coverage, 2179,
     /* 41723 */     GIR_Done,
     /* 41724 */   // Label 1102: @41724
     /* 41724 */   GIM_Reject,
     /* 41725 */ // Label 1095: @41725
     /* 41725 */ GIM_Reject,
     /* 41726 */ // Label 1089: @41726
     /* 41726 */ GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(41866),
     /* 41731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 41734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 41737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41745 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(41779), // Rule ID 212 //
     /* 41750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 41753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 41765 */     // MIs[1] Operand 1
     /* 41765 */     // No operand predicates
     /* 41765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41767 */     // (srl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSRL:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 41767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRL),
     /* 41770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 41777 */     GIR_RootConstrainSelectedInstOperands,
     /* 41778 */     // GIR_Coverage, 212,
     /* 41778 */     GIR_EraseRootFromParent_Done,
     /* 41779 */   // Label 1104: @41779
     /* 41779 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(41846), // Rule ID 1577 //
     /* 41784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 41787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 41795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 41799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41806 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSRLV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 41806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41818 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 41824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 41829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRLV),
     /* 41837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41844 */     GIR_RootConstrainSelectedInstOperands,
     /* 41845 */     // GIR_Coverage, 1577,
     /* 41845 */     GIR_EraseRootFromParent_Done,
     /* 41846 */   // Label 1105: @41846
     /* 41846 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(41865), // Rule ID 220 //
     /* 41851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 41854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41858 */     // (srl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSRLV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 41858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSRLV),
     /* 41863 */     GIR_RootConstrainSelectedInstOperands,
     /* 41864 */     // GIR_Coverage, 220,
     /* 41864 */     GIR_Done,
     /* 41865 */   // Label 1106: @41865
     /* 41865 */   GIM_Reject,
     /* 41866 */ // Label 1103: @41866
     /* 41866 */ GIM_Reject,
     /* 41867 */ // Label 1090: @41867
     /* 41867 */ GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(41900), // Rule ID 992 //
     /* 41872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 41875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 41878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 41881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41893 */   // (srl:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 41893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_D),
     /* 41898 */   GIR_RootConstrainSelectedInstOperands,
     /* 41899 */   // GIR_Coverage, 992,
     /* 41899 */   GIR_Done,
     /* 41900 */ // Label 1107: @41900
     /* 41900 */ GIM_Reject,
     /* 41901 */ // Label 1091: @41901
     /* 41901 */ GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(42168),
     /* 41906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 41909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 41912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 41916 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(42030), // Rule ID 2482 //
     /* 41921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 41924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 41932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 41936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 41940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 41944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 41948 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 41951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 41955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 41959 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 41963 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 41967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 41971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41975 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 41979 */     // MIs[3] Operand 1
     /* 41979 */     // No operand predicates
     /* 41979 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 41983 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41987 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 41991 */     // MIs[4] Operand 1
     /* 41991 */     // No operand predicates
     /* 41991 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 41995 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41999 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42003 */     // MIs[5] Operand 1
     /* 42003 */     // No operand predicates
     /* 42003 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42007 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42011 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42015 */     // MIs[6] Operand 1
     /* 42015 */     // No operand predicates
     /* 42015 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 42017 */     // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SRL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 42017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42022 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42028 */     GIR_RootConstrainSelectedInstOperands,
     /* 42029 */     // GIR_Coverage, 2482,
     /* 42029 */     GIR_EraseRootFromParent_Done,
     /* 42030 */   // Label 1109: @42030
     /* 42030 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(42144), // Rule ID 2083 //
     /* 42035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 42050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 42054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42062 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 42065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42073 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42077 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42089 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42093 */     // MIs[3] Operand 1
     /* 42093 */     // No operand predicates
     /* 42093 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42097 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42101 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42105 */     // MIs[4] Operand 1
     /* 42105 */     // No operand predicates
     /* 42105 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42109 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42113 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42117 */     // MIs[5] Operand 1
     /* 42117 */     // No operand predicates
     /* 42117 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42121 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42125 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42129 */     // MIs[6] Operand 1
     /* 42129 */     // No operand predicates
     /* 42129 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 42131 */     // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SRL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 42131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42136 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 42142 */     GIR_RootConstrainSelectedInstOperands,
     /* 42143 */     // GIR_Coverage, 2083,
     /* 42143 */     GIR_EraseRootFromParent_Done,
     /* 42144 */   // Label 1110: @42144
     /* 42144 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(42167), // Rule ID 991 //
     /* 42149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 42152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 42156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 42160 */     // (srl:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 42160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42165 */     GIR_RootConstrainSelectedInstOperands,
     /* 42166 */     // GIR_Coverage, 991,
     /* 42166 */     GIR_Done,
     /* 42167 */   // Label 1111: @42167
     /* 42167 */   GIM_Reject,
     /* 42168 */ // Label 1108: @42168
     /* 42168 */ GIM_Reject,
     /* 42169 */ // Label 1092: @42169
     /* 42169 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(42564),
     /* 42174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42184 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(42362), // Rule ID 2481 //
     /* 42189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 42212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42216 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 42219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42227 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42231 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42235 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42239 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42243 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42247 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42259 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42263 */     // MIs[3] Operand 1
     /* 42263 */     // No operand predicates
     /* 42263 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42267 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42271 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42275 */     // MIs[4] Operand 1
     /* 42275 */     // No operand predicates
     /* 42275 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42279 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42283 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42287 */     // MIs[5] Operand 1
     /* 42287 */     // No operand predicates
     /* 42287 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42291 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42295 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42299 */     // MIs[6] Operand 1
     /* 42299 */     // No operand predicates
     /* 42299 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42303 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42307 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42311 */     // MIs[7] Operand 1
     /* 42311 */     // No operand predicates
     /* 42311 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42315 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42319 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42323 */     // MIs[8] Operand 1
     /* 42323 */     // No operand predicates
     /* 42323 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42327 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42331 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42335 */     // MIs[9] Operand 1
     /* 42335 */     // No operand predicates
     /* 42335 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42339 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42343 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42347 */     // MIs[10] Operand 1
     /* 42347 */     // No operand predicates
     /* 42347 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 42349 */     // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SRL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 42349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42354 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42360 */     GIR_RootConstrainSelectedInstOperands,
     /* 42361 */     // GIR_Coverage, 2481,
     /* 42361 */     GIR_EraseRootFromParent_Done,
     /* 42362 */   // Label 1113: @42362
     /* 42362 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(42540), // Rule ID 2082 //
     /* 42367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42394 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 42397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42405 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42409 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42413 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42417 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42421 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42425 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42437 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42441 */     // MIs[3] Operand 1
     /* 42441 */     // No operand predicates
     /* 42441 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42445 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42449 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42453 */     // MIs[4] Operand 1
     /* 42453 */     // No operand predicates
     /* 42453 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42457 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42461 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42465 */     // MIs[5] Operand 1
     /* 42465 */     // No operand predicates
     /* 42465 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42469 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42473 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42477 */     // MIs[6] Operand 1
     /* 42477 */     // No operand predicates
     /* 42477 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42481 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42485 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42489 */     // MIs[7] Operand 1
     /* 42489 */     // No operand predicates
     /* 42489 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42493 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42497 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42501 */     // MIs[8] Operand 1
     /* 42501 */     // No operand predicates
     /* 42501 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42505 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42509 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42513 */     // MIs[9] Operand 1
     /* 42513 */     // No operand predicates
     /* 42513 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42517 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42521 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42525 */     // MIs[10] Operand 1
     /* 42525 */     // No operand predicates
     /* 42525 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 42527 */     // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SRL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 42527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42532 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 42538 */     GIR_RootConstrainSelectedInstOperands,
     /* 42539 */     // GIR_Coverage, 2082,
     /* 42539 */     GIR_EraseRootFromParent_Done,
     /* 42540 */   // Label 1114: @42540
     /* 42540 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(42563), // Rule ID 990 //
     /* 42545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 42548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42556 */     // (srl:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 42556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42561 */     GIR_RootConstrainSelectedInstOperands,
     /* 42562 */     // GIR_Coverage, 990,
     /* 42562 */     GIR_Done,
     /* 42563 */   // Label 1115: @42563
     /* 42563 */   GIM_Reject,
     /* 42564 */ // Label 1112: @42564
     /* 42564 */ GIM_Reject,
     /* 42565 */ // Label 1093: @42565
     /* 42565 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(43216),
     /* 42570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 42580 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(42886), // Rule ID 2480 //
     /* 42585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 42608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42612 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 42615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42623 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42627 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42631 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42635 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42639 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42643 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42647 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 42651 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 42655 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 42659 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 42663 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 42667 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 42671 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 42675 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 42679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42687 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42691 */     // MIs[3] Operand 1
     /* 42691 */     // No operand predicates
     /* 42691 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42695 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42699 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42703 */     // MIs[4] Operand 1
     /* 42703 */     // No operand predicates
     /* 42703 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42707 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42711 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42715 */     // MIs[5] Operand 1
     /* 42715 */     // No operand predicates
     /* 42715 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42719 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42723 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42727 */     // MIs[6] Operand 1
     /* 42727 */     // No operand predicates
     /* 42727 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42731 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42735 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42739 */     // MIs[7] Operand 1
     /* 42739 */     // No operand predicates
     /* 42739 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42743 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42747 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42751 */     // MIs[8] Operand 1
     /* 42751 */     // No operand predicates
     /* 42751 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42755 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42759 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42763 */     // MIs[9] Operand 1
     /* 42763 */     // No operand predicates
     /* 42763 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42767 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42771 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42775 */     // MIs[10] Operand 1
     /* 42775 */     // No operand predicates
     /* 42775 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 42779 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42783 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42787 */     // MIs[11] Operand 1
     /* 42787 */     // No operand predicates
     /* 42787 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 42791 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42795 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42799 */     // MIs[12] Operand 1
     /* 42799 */     // No operand predicates
     /* 42799 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 42803 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42807 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42811 */     // MIs[13] Operand 1
     /* 42811 */     // No operand predicates
     /* 42811 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 42815 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42819 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42823 */     // MIs[14] Operand 1
     /* 42823 */     // No operand predicates
     /* 42823 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 42827 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42831 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42835 */     // MIs[15] Operand 1
     /* 42835 */     // No operand predicates
     /* 42835 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 42839 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42843 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42847 */     // MIs[16] Operand 1
     /* 42847 */     // No operand predicates
     /* 42847 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 42851 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42855 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42859 */     // MIs[17] Operand 1
     /* 42859 */     // No operand predicates
     /* 42859 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 42863 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42867 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42871 */     // MIs[18] Operand 1
     /* 42871 */     // No operand predicates
     /* 42871 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 42873 */     // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SRL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 42873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 42876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42878 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42884 */     GIR_RootConstrainSelectedInstOperands,
     /* 42885 */     // GIR_Coverage, 2480,
     /* 42885 */     GIR_EraseRootFromParent_Done,
     /* 42886 */   // Label 1117: @42886
     /* 42886 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(43192), // Rule ID 2081 //
     /* 42891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42918 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 42921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42929 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42933 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42937 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42941 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42945 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42949 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42953 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 42957 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 42961 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 42965 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 42969 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 42973 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 42977 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 42981 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 42985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42993 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42997 */     // MIs[3] Operand 1
     /* 42997 */     // No operand predicates
     /* 42997 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 43001 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43005 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43009 */     // MIs[4] Operand 1
     /* 43009 */     // No operand predicates
     /* 43009 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43013 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43017 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43021 */     // MIs[5] Operand 1
     /* 43021 */     // No operand predicates
     /* 43021 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43025 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43029 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43033 */     // MIs[6] Operand 1
     /* 43033 */     // No operand predicates
     /* 43033 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 43037 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43041 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43045 */     // MIs[7] Operand 1
     /* 43045 */     // No operand predicates
     /* 43045 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 43049 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43053 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43057 */     // MIs[8] Operand 1
     /* 43057 */     // No operand predicates
     /* 43057 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 43061 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43065 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43069 */     // MIs[9] Operand 1
     /* 43069 */     // No operand predicates
     /* 43069 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 43073 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43077 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43081 */     // MIs[10] Operand 1
     /* 43081 */     // No operand predicates
     /* 43081 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 43085 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43089 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43093 */     // MIs[11] Operand 1
     /* 43093 */     // No operand predicates
     /* 43093 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 43097 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43101 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43105 */     // MIs[12] Operand 1
     /* 43105 */     // No operand predicates
     /* 43105 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 43109 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43113 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43117 */     // MIs[13] Operand 1
     /* 43117 */     // No operand predicates
     /* 43117 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 43121 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43125 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43129 */     // MIs[14] Operand 1
     /* 43129 */     // No operand predicates
     /* 43129 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 43133 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43137 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43141 */     // MIs[15] Operand 1
     /* 43141 */     // No operand predicates
     /* 43141 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 43145 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43149 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43153 */     // MIs[16] Operand 1
     /* 43153 */     // No operand predicates
     /* 43153 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 43157 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43161 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43165 */     // MIs[17] Operand 1
     /* 43165 */     // No operand predicates
     /* 43165 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 43169 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43173 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43177 */     // MIs[18] Operand 1
     /* 43177 */     // No operand predicates
     /* 43177 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 43179 */     // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SRL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 43179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 43182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43184 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 43190 */     GIR_RootConstrainSelectedInstOperands,
     /* 43191 */     // GIR_Coverage, 2081,
     /* 43191 */     GIR_EraseRootFromParent_Done,
     /* 43192 */   // Label 1118: @43192
     /* 43192 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(43215), // Rule ID 989 //
     /* 43197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 43204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 43208 */     // (srl:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 43208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 43213 */     GIR_RootConstrainSelectedInstOperands,
     /* 43214 */     // GIR_Coverage, 989,
     /* 43214 */     GIR_Done,
     /* 43215 */   // Label 1119: @43215
     /* 43215 */   GIM_Reject,
     /* 43216 */ // Label 1116: @43216
     /* 43216 */ GIM_Reject,
     /* 43217 */ // Label 1094: @43217
     /* 43217 */ GIM_Reject,
     /* 43218 */ // Label 39: @43218
     /* 43218 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1126*/ GIMT_Encode4(44972),
     /* 43229 */ /*GILLT_s32*//*Label 1120*/ GIMT_Encode4(43261),
     /* 43233 */ /*GILLT_s64*//*Label 1121*/ GIMT_Encode4(43481), GIMT_Encode4(0),
     /* 43241 */ /*GILLT_v2s64*//*Label 1122*/ GIMT_Encode4(43622), GIMT_Encode4(0),
     /* 43249 */ /*GILLT_v4s32*//*Label 1123*/ GIMT_Encode4(43656),
     /* 43253 */ /*GILLT_v8s16*//*Label 1124*/ GIMT_Encode4(43924),
     /* 43257 */ /*GILLT_v16s8*//*Label 1125*/ GIMT_Encode4(44320),
     /* 43261 */ // Label 1120: @43261
     /* 43261 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(43480),
     /* 43266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 43269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 43272 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(43314), // Rule ID 59 //
     /* 43277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 43280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43300 */     // MIs[1] Operand 1
     /* 43300 */     // No operand predicates
     /* 43300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43302 */     // (sra:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SRA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 43302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA),
     /* 43305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 43312 */     GIR_RootConstrainSelectedInstOperands,
     /* 43313 */     // GIR_Coverage, 59,
     /* 43313 */     GIR_EraseRootFromParent_Done,
     /* 43314 */   // Label 1128: @43314
     /* 43314 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(43356), // Rule ID 1837 //
     /* 43319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 43322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43342 */     // MIs[1] Operand 1
     /* 43342 */     // No operand predicates
     /* 43342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43344 */     // (sra:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SraX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 43344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SraX16),
     /* 43347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 43349 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 43351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 43354 */     GIR_RootConstrainSelectedInstOperands,
     /* 43355 */     // GIR_Coverage, 1837,
     /* 43355 */     GIR_EraseRootFromParent_Done,
     /* 43356 */   // Label 1129: @43356
     /* 43356 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(43398), // Rule ID 2180 //
     /* 43361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 43364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43384 */     // MIs[1] Operand 1
     /* 43384 */     // No operand predicates
     /* 43384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43386 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SRA_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 43386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_MM),
     /* 43389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 43393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 43396 */     GIR_RootConstrainSelectedInstOperands,
     /* 43397 */     // GIR_Coverage, 2180,
     /* 43397 */     GIR_EraseRootFromParent_Done,
     /* 43398 */   // Label 1130: @43398
     /* 43398 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(43425), // Rule ID 65 //
     /* 43403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 43406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43418 */     // (sra:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SRAV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 43418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRAV),
     /* 43423 */     GIR_RootConstrainSelectedInstOperands,
     /* 43424 */     // GIR_Coverage, 65,
     /* 43424 */     GIR_Done,
     /* 43425 */   // Label 1131: @43425
     /* 43425 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(43452), // Rule ID 1839 //
     /* 43430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 43433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43445 */     // (sra:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SravRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 43445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SravRxRy16),
     /* 43450 */     GIR_RootConstrainSelectedInstOperands,
     /* 43451 */     // GIR_Coverage, 1839,
     /* 43451 */     GIR_Done,
     /* 43452 */   // Label 1132: @43452
     /* 43452 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(43479), // Rule ID 2181 //
     /* 43457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 43460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43472 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SRAV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 43472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRAV_MM),
     /* 43477 */     GIR_RootConstrainSelectedInstOperands,
     /* 43478 */     // GIR_Coverage, 2181,
     /* 43478 */     GIR_Done,
     /* 43479 */   // Label 1133: @43479
     /* 43479 */   GIM_Reject,
     /* 43480 */ // Label 1127: @43480
     /* 43480 */ GIM_Reject,
     /* 43481 */ // Label 1121: @43481
     /* 43481 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(43621),
     /* 43486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 43489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 43492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43500 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(43534), // Rule ID 214 //
     /* 43505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 43508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 43520 */     // MIs[1] Operand 1
     /* 43520 */     // No operand predicates
     /* 43520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43522 */     // (sra:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSRA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 43522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRA),
     /* 43525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 43532 */     GIR_RootConstrainSelectedInstOperands,
     /* 43533 */     // GIR_Coverage, 214,
     /* 43533 */     GIR_EraseRootFromParent_Done,
     /* 43534 */   // Label 1135: @43534
     /* 43534 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(43601), // Rule ID 1578 //
     /* 43539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 43542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 43550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 43554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43561 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSRAV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 43561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 43564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43573 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 43579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 43584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRAV),
     /* 43592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43599 */     GIR_RootConstrainSelectedInstOperands,
     /* 43600 */     // GIR_Coverage, 1578,
     /* 43600 */     GIR_EraseRootFromParent_Done,
     /* 43601 */   // Label 1136: @43601
     /* 43601 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(43620), // Rule ID 218 //
     /* 43606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 43609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43613 */     // (sra:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSRAV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 43613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSRAV),
     /* 43618 */     GIR_RootConstrainSelectedInstOperands,
     /* 43619 */     // GIR_Coverage, 218,
     /* 43619 */     GIR_Done,
     /* 43620 */   // Label 1137: @43620
     /* 43620 */   GIM_Reject,
     /* 43621 */ // Label 1134: @43621
     /* 43621 */ GIM_Reject,
     /* 43622 */ // Label 1122: @43622
     /* 43622 */ GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(43655), // Rule ID 976 //
     /* 43627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 43633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 43636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43648 */   // (sra:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRA_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 43648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_D),
     /* 43653 */   GIR_RootConstrainSelectedInstOperands,
     /* 43654 */   // GIR_Coverage, 976,
     /* 43654 */   GIR_Done,
     /* 43655 */ // Label 1138: @43655
     /* 43655 */ GIM_Reject,
     /* 43656 */ // Label 1123: @43656
     /* 43656 */ GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(43923),
     /* 43661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43671 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(43785), // Rule ID 2486 //
     /* 43676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 43699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43703 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 43706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43714 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43718 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 43726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43730 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43734 */     // MIs[3] Operand 1
     /* 43734 */     // No operand predicates
     /* 43734 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 43738 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43742 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43746 */     // MIs[4] Operand 1
     /* 43746 */     // No operand predicates
     /* 43746 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43750 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43754 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43758 */     // MIs[5] Operand 1
     /* 43758 */     // No operand predicates
     /* 43758 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43762 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43766 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43770 */     // MIs[6] Operand 1
     /* 43770 */     // No operand predicates
     /* 43770 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 43772 */     // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SRA_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 43772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43777 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 43783 */     GIR_RootConstrainSelectedInstOperands,
     /* 43784 */     // GIR_Coverage, 2486,
     /* 43784 */     GIR_EraseRootFromParent_Done,
     /* 43785 */   // Label 1140: @43785
     /* 43785 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(43899), // Rule ID 2087 //
     /* 43790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 43813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43817 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 43820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43828 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43832 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 43840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43844 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43848 */     // MIs[3] Operand 1
     /* 43848 */     // No operand predicates
     /* 43848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 43852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43856 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43860 */     // MIs[4] Operand 1
     /* 43860 */     // No operand predicates
     /* 43860 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43864 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43868 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43872 */     // MIs[5] Operand 1
     /* 43872 */     // No operand predicates
     /* 43872 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43876 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43880 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43884 */     // MIs[6] Operand 1
     /* 43884 */     // No operand predicates
     /* 43884 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 43886 */     // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SRA_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 43886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43891 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 43897 */     GIR_RootConstrainSelectedInstOperands,
     /* 43898 */     // GIR_Coverage, 2087,
     /* 43898 */     GIR_EraseRootFromParent_Done,
     /* 43899 */   // Label 1141: @43899
     /* 43899 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(43922), // Rule ID 975 //
     /* 43904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43915 */     // (sra:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRA_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 43915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43920 */     GIR_RootConstrainSelectedInstOperands,
     /* 43921 */     // GIR_Coverage, 975,
     /* 43921 */     GIR_Done,
     /* 43922 */   // Label 1142: @43922
     /* 43922 */   GIM_Reject,
     /* 43923 */ // Label 1139: @43923
     /* 43923 */ GIM_Reject,
     /* 43924 */ // Label 1124: @43924
     /* 43924 */ GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(44319),
     /* 43929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 43932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 43935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 43939 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(44117), // Rule ID 2485 //
     /* 43944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 43959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 43963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 43967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43971 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 43974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43982 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43986 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43990 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 43994 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 43998 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44002 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44014 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44018 */     // MIs[3] Operand 1
     /* 44018 */     // No operand predicates
     /* 44018 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44022 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44026 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44030 */     // MIs[4] Operand 1
     /* 44030 */     // No operand predicates
     /* 44030 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44034 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44038 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44042 */     // MIs[5] Operand 1
     /* 44042 */     // No operand predicates
     /* 44042 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44046 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44050 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44054 */     // MIs[6] Operand 1
     /* 44054 */     // No operand predicates
     /* 44054 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44058 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44062 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44066 */     // MIs[7] Operand 1
     /* 44066 */     // No operand predicates
     /* 44066 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44070 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44074 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44078 */     // MIs[8] Operand 1
     /* 44078 */     // No operand predicates
     /* 44078 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44082 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44086 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44090 */     // MIs[9] Operand 1
     /* 44090 */     // No operand predicates
     /* 44090 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44094 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44098 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44102 */     // MIs[10] Operand 1
     /* 44102 */     // No operand predicates
     /* 44102 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 44104 */     // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SRA_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 44104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44109 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 44115 */     GIR_RootConstrainSelectedInstOperands,
     /* 44116 */     // GIR_Coverage, 2485,
     /* 44116 */     GIR_EraseRootFromParent_Done,
     /* 44117 */   // Label 1144: @44117
     /* 44117 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(44295), // Rule ID 2086 //
     /* 44122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 44137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 44141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 44145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44149 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 44152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44160 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44164 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44168 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44172 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44176 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44180 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44192 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44196 */     // MIs[3] Operand 1
     /* 44196 */     // No operand predicates
     /* 44196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44200 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44204 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44208 */     // MIs[4] Operand 1
     /* 44208 */     // No operand predicates
     /* 44208 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44212 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44216 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44220 */     // MIs[5] Operand 1
     /* 44220 */     // No operand predicates
     /* 44220 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44224 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44228 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44232 */     // MIs[6] Operand 1
     /* 44232 */     // No operand predicates
     /* 44232 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44236 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44240 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44244 */     // MIs[7] Operand 1
     /* 44244 */     // No operand predicates
     /* 44244 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44248 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44252 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44256 */     // MIs[8] Operand 1
     /* 44256 */     // No operand predicates
     /* 44256 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44260 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44264 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44268 */     // MIs[9] Operand 1
     /* 44268 */     // No operand predicates
     /* 44268 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44272 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44276 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44280 */     // MIs[10] Operand 1
     /* 44280 */     // No operand predicates
     /* 44280 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 44282 */     // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SRA_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 44282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44287 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 44293 */     GIR_RootConstrainSelectedInstOperands,
     /* 44294 */     // GIR_Coverage, 2086,
     /* 44294 */     GIR_EraseRootFromParent_Done,
     /* 44295 */   // Label 1145: @44295
     /* 44295 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(44318), // Rule ID 974 //
     /* 44300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 44303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 44307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 44311 */     // (sra:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRA_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 44311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44316 */     GIR_RootConstrainSelectedInstOperands,
     /* 44317 */     // GIR_Coverage, 974,
     /* 44317 */     GIR_Done,
     /* 44318 */   // Label 1146: @44318
     /* 44318 */   GIM_Reject,
     /* 44319 */ // Label 1143: @44319
     /* 44319 */ GIM_Reject,
     /* 44320 */ // Label 1125: @44320
     /* 44320 */ GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(44971),
     /* 44325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44335 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(44641), // Rule ID 2484 //
     /* 44340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 44363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44367 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 44370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44378 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44382 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44386 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44390 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44394 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44398 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44402 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 44406 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 44410 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 44414 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 44418 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 44422 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 44426 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 44430 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 44434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44442 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44446 */     // MIs[3] Operand 1
     /* 44446 */     // No operand predicates
     /* 44446 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44450 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44454 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44458 */     // MIs[4] Operand 1
     /* 44458 */     // No operand predicates
     /* 44458 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44462 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44466 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44470 */     // MIs[5] Operand 1
     /* 44470 */     // No operand predicates
     /* 44470 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44474 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44478 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44482 */     // MIs[6] Operand 1
     /* 44482 */     // No operand predicates
     /* 44482 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44486 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44490 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44494 */     // MIs[7] Operand 1
     /* 44494 */     // No operand predicates
     /* 44494 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44498 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44502 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44506 */     // MIs[8] Operand 1
     /* 44506 */     // No operand predicates
     /* 44506 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44510 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44514 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44518 */     // MIs[9] Operand 1
     /* 44518 */     // No operand predicates
     /* 44518 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44522 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44526 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44530 */     // MIs[10] Operand 1
     /* 44530 */     // No operand predicates
     /* 44530 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 44534 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44538 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44542 */     // MIs[11] Operand 1
     /* 44542 */     // No operand predicates
     /* 44542 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 44546 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44550 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44554 */     // MIs[12] Operand 1
     /* 44554 */     // No operand predicates
     /* 44554 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 44558 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44562 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44566 */     // MIs[13] Operand 1
     /* 44566 */     // No operand predicates
     /* 44566 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 44570 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44574 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44578 */     // MIs[14] Operand 1
     /* 44578 */     // No operand predicates
     /* 44578 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 44582 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44586 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44590 */     // MIs[15] Operand 1
     /* 44590 */     // No operand predicates
     /* 44590 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 44594 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44598 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44602 */     // MIs[16] Operand 1
     /* 44602 */     // No operand predicates
     /* 44602 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 44606 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44610 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44614 */     // MIs[17] Operand 1
     /* 44614 */     // No operand predicates
     /* 44614 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 44618 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44622 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44626 */     // MIs[18] Operand 1
     /* 44626 */     // No operand predicates
     /* 44626 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 44628 */     // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SRA_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 44628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44633 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 44639 */     GIR_RootConstrainSelectedInstOperands,
     /* 44640 */     // GIR_Coverage, 2484,
     /* 44640 */     GIR_EraseRootFromParent_Done,
     /* 44641 */   // Label 1148: @44641
     /* 44641 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(44947), // Rule ID 2085 //
     /* 44646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 44669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44673 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 44676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44684 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44688 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44692 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44696 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44700 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44704 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44708 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 44712 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 44716 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 44720 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 44724 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 44728 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 44732 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 44736 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 44740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44748 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44752 */     // MIs[3] Operand 1
     /* 44752 */     // No operand predicates
     /* 44752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44756 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44760 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44764 */     // MIs[4] Operand 1
     /* 44764 */     // No operand predicates
     /* 44764 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44768 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44772 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44776 */     // MIs[5] Operand 1
     /* 44776 */     // No operand predicates
     /* 44776 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44780 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44784 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44788 */     // MIs[6] Operand 1
     /* 44788 */     // No operand predicates
     /* 44788 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44792 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44796 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44800 */     // MIs[7] Operand 1
     /* 44800 */     // No operand predicates
     /* 44800 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44804 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44808 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44812 */     // MIs[8] Operand 1
     /* 44812 */     // No operand predicates
     /* 44812 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44816 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44820 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44824 */     // MIs[9] Operand 1
     /* 44824 */     // No operand predicates
     /* 44824 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44828 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44832 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44836 */     // MIs[10] Operand 1
     /* 44836 */     // No operand predicates
     /* 44836 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 44840 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44844 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44848 */     // MIs[11] Operand 1
     /* 44848 */     // No operand predicates
     /* 44848 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 44852 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44856 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44860 */     // MIs[12] Operand 1
     /* 44860 */     // No operand predicates
     /* 44860 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 44864 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44868 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44872 */     // MIs[13] Operand 1
     /* 44872 */     // No operand predicates
     /* 44872 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 44876 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44880 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44884 */     // MIs[14] Operand 1
     /* 44884 */     // No operand predicates
     /* 44884 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 44888 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44892 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44896 */     // MIs[15] Operand 1
     /* 44896 */     // No operand predicates
     /* 44896 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 44900 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44904 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44908 */     // MIs[16] Operand 1
     /* 44908 */     // No operand predicates
     /* 44908 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 44912 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44916 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44920 */     // MIs[17] Operand 1
     /* 44920 */     // No operand predicates
     /* 44920 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 44924 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44928 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44932 */     // MIs[18] Operand 1
     /* 44932 */     // No operand predicates
     /* 44932 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 44934 */     // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SRA_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 44934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44939 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 44945 */     GIR_RootConstrainSelectedInstOperands,
     /* 44946 */     // GIR_Coverage, 2085,
     /* 44946 */     GIR_EraseRootFromParent_Done,
     /* 44947 */   // Label 1149: @44947
     /* 44947 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(44970), // Rule ID 973 //
     /* 44952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 44955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44963 */     // (sra:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRA_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 44963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44968 */     GIR_RootConstrainSelectedInstOperands,
     /* 44969 */     // GIR_Coverage, 973,
     /* 44969 */     GIR_Done,
     /* 44970 */   // Label 1150: @44970
     /* 44970 */   GIM_Reject,
     /* 44971 */ // Label 1147: @44971
     /* 44971 */ GIM_Reject,
     /* 44972 */ // Label 1126: @44972
     /* 44972 */ GIM_Reject,
     /* 44973 */ // Label 40: @44973
     /* 44973 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1153*/ GIMT_Encode4(45260),
     /* 44984 */ /*GILLT_s32*//*Label 1151*/ GIMT_Encode4(44992),
     /* 44988 */ /*GILLT_s64*//*Label 1152*/ GIMT_Encode4(45119),
     /* 44992 */ // Label 1151: @44992
     /* 44992 */ GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(45118),
     /* 44997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 45000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 45003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45011 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(45045), // Rule ID 67 //
     /* 45016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 45019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 45031 */     // MIs[1] Operand 1
     /* 45031 */     // No operand predicates
     /* 45031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45033 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (ROTR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR),
     /* 45036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45043 */     GIR_RootConstrainSelectedInstOperands,
     /* 45044 */     // GIR_Coverage, 67,
     /* 45044 */     GIR_EraseRootFromParent_Done,
     /* 45045 */   // Label 1155: @45045
     /* 45045 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(45079), // Rule ID 1081 //
     /* 45050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 45065 */     // MIs[1] Operand 1
     /* 45065 */     // No operand predicates
     /* 45065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45067 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (ROTR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR_MM),
     /* 45070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45077 */     GIR_RootConstrainSelectedInstOperands,
     /* 45078 */     // GIR_Coverage, 1081,
     /* 45078 */     GIR_EraseRootFromParent_Done,
     /* 45079 */   // Label 1156: @45079
     /* 45079 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(45098), // Rule ID 68 //
     /* 45084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 45087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45091 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ROTRV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ROTRV),
     /* 45096 */     GIR_RootConstrainSelectedInstOperands,
     /* 45097 */     // GIR_Coverage, 68,
     /* 45097 */     GIR_Done,
     /* 45098 */   // Label 1157: @45098
     /* 45098 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(45117), // Rule ID 1082 //
     /* 45103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45110 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ROTRV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ROTRV_MM),
     /* 45115 */     GIR_RootConstrainSelectedInstOperands,
     /* 45116 */     // GIR_Coverage, 1082,
     /* 45116 */     GIR_Done,
     /* 45117 */   // Label 1158: @45117
     /* 45117 */   GIM_Reject,
     /* 45118 */ // Label 1154: @45118
     /* 45118 */ GIM_Reject,
     /* 45119 */ // Label 1152: @45119
     /* 45119 */ GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(45259),
     /* 45124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 45127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 45130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45138 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(45172), // Rule ID 222 //
     /* 45143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips),
     /* 45146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 45158 */     // MIs[1] Operand 1
     /* 45158 */     // No operand predicates
     /* 45158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45160 */     // (rotr:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DROTR:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DROTR),
     /* 45163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45170 */     GIR_RootConstrainSelectedInstOperands,
     /* 45171 */     // GIR_Coverage, 222,
     /* 45171 */     GIR_EraseRootFromParent_Done,
     /* 45172 */   // Label 1160: @45172
     /* 45172 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(45239), // Rule ID 1579 //
     /* 45177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 45180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 45188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 45192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45199 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DROTRV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 45199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45211 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 45217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 45222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DROTRV),
     /* 45230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45237 */     GIR_RootConstrainSelectedInstOperands,
     /* 45238 */     // GIR_Coverage, 1579,
     /* 45238 */     GIR_EraseRootFromParent_Done,
     /* 45239 */   // Label 1161: @45239
     /* 45239 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(45258), // Rule ID 223 //
     /* 45244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips),
     /* 45247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45251 */     // (rotr:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DROTRV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DROTRV),
     /* 45256 */     GIR_RootConstrainSelectedInstOperands,
     /* 45257 */     // GIR_Coverage, 223,
     /* 45257 */     GIR_Done,
     /* 45258 */   // Label 1162: @45258
     /* 45258 */   GIM_Reject,
     /* 45259 */ // Label 1159: @45259
     /* 45259 */ GIM_Reject,
     /* 45260 */ // Label 1153: @45260
     /* 45260 */ GIM_Reject,
     /* 45261 */ // Label 41: @45261
     /* 45261 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(47791),
     /* 45266 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 45269 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1166*/ GIMT_Encode4(45454),
     /* 45280 */   /*GILLT_s32*//*Label 1164*/ GIMT_Encode4(45288),
     /* 45284 */   /*GILLT_s64*//*Label 1165*/ GIMT_Encode4(45371),
     /* 45288 */   // Label 1164: @45288
     /* 45288 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(45370),
     /* 45293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45300 */     GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(45333), // Rule ID 1415 //
     /* 45305 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45308 */       // MIs[0] Operand 1
     /* 45308 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45313 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45317 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45321 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTiu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45321 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu),
     /* 45324 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45326 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45328 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45331 */       GIR_RootConstrainSelectedInstOperands,
     /* 45332 */       // GIR_Coverage, 1415,
     /* 45332 */       GIR_EraseRootFromParent_Done,
     /* 45333 */     // Label 1168: @45333
     /* 45333 */     GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(45369), // Rule ID 1416 //
     /* 45338 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45341 */       // MIs[0] Operand 1
     /* 45341 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45346 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45350 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45354 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTu:{ *:[i32] } ZERO:{ *:[i32] }, GPR32:{ *:[i32] }:$lhs)
     /* 45354 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 45357 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45359 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45365 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45367 */       GIR_RootConstrainSelectedInstOperands,
     /* 45368 */       // GIR_Coverage, 1416,
     /* 45368 */       GIR_EraseRootFromParent_Done,
     /* 45369 */     // Label 1169: @45369
     /* 45369 */     GIM_Reject,
     /* 45370 */   // Label 1167: @45370
     /* 45370 */   GIM_Reject,
     /* 45371 */   // Label 1165: @45371
     /* 45371 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(45453),
     /* 45376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 45379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45383 */     GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(45416), // Rule ID 1561 //
     /* 45388 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 45391 */       // MIs[0] Operand 1
     /* 45391 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45396 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45400 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45404 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTiu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 1:{ *:[i64] })
     /* 45404 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu64),
     /* 45407 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45409 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45411 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45414 */       GIR_RootConstrainSelectedInstOperands,
     /* 45415 */       // GIR_Coverage, 1561,
     /* 45415 */       GIR_EraseRootFromParent_Done,
     /* 45416 */     // Label 1171: @45416
     /* 45416 */     GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(45452), // Rule ID 1562 //
     /* 45421 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 45424 */       // MIs[0] Operand 1
     /* 45424 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45429 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45433 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45437 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } ZERO_64:{ *:[i64] }, GPR64:{ *:[i64] }:$lhs)
     /* 45437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 45440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45442 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45448 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45450 */       GIR_RootConstrainSelectedInstOperands,
     /* 45451 */       // GIR_Coverage, 1562,
     /* 45451 */       GIR_EraseRootFromParent_Done,
     /* 45452 */     // Label 1172: @45452
     /* 45452 */     GIM_Reject,
     /* 45453 */   // Label 1170: @45453
     /* 45453 */   GIM_Reject,
     /* 45454 */   // Label 1166: @45454
     /* 45454 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1175*/ GIMT_Encode4(45837),
     /* 45465 */   /*GILLT_s32*//*Label 1173*/ GIMT_Encode4(45473),
     /* 45469 */   /*GILLT_s64*//*Label 1174*/ GIMT_Encode4(45759),
     /* 45473 */   // Label 1173: @45473
     /* 45473 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(45758),
     /* 45478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45481 */     GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(45518), // Rule ID 1887 //
     /* 45486 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 45489 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45493 */       // MIs[0] Operand 1
     /* 45493 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45498 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45502 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45506 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SltiuCCRxImmX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45506 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltiuCCRxImmX16),
     /* 45509 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 45511 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45513 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45516 */       GIR_RootConstrainSelectedInstOperands,
     /* 45517 */       // GIR_Coverage, 1887,
     /* 45517 */       GIR_EraseRootFromParent_Done,
     /* 45518 */     // Label 1177: @45518
     /* 45518 */     GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(45608), // Rule ID 1889 //
     /* 45523 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 45526 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45530 */       // MIs[0] Operand 1
     /* 45530 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 45535 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45539 */       GIM_CheckConstantInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-32769),
     /* 45550 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, -32769:{ *:[i32] }, SETGT:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltiCCRxImmX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, -32768:{ *:[i32] }), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 45550 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 45553 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 45557 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45562 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 45565 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45567 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45570 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltiCCRxImmX16),
     /* 45574 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45579 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 45583 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 45593 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 45595 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 45598 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 45600 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45603 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 45606 */       GIR_RootConstrainSelectedInstOperands,
     /* 45607 */       // GIR_Coverage, 1889,
     /* 45607 */       GIR_EraseRootFromParent_Done,
     /* 45608 */     // Label 1178: @45608
     /* 45608 */     GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(45645), // Rule ID 2208 //
     /* 45613 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45616 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45620 */       // MIs[0] Operand 1
     /* 45620 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45625 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45629 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45633 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTiu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45633 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu_MM),
     /* 45636 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45638 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45640 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45643 */       GIR_RootConstrainSelectedInstOperands,
     /* 45644 */       // GIR_Coverage, 2208,
     /* 45644 */       GIR_EraseRootFromParent_Done,
     /* 45645 */     // Label 1179: @45645
     /* 45645 */     GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(45685), // Rule ID 2209 //
     /* 45650 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45653 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45657 */       // MIs[0] Operand 1
     /* 45657 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45662 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45666 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45670 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } ZERO:{ *:[i32] }, GPR32:{ *:[i32] }:$lhs)
     /* 45670 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 45673 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45675 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45681 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45683 */       GIR_RootConstrainSelectedInstOperands,
     /* 45684 */       // GIR_Coverage, 2209,
     /* 45684 */       GIR_EraseRootFromParent_Done,
     /* 45685 */     // Label 1180: @45685
     /* 45685 */     GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(45721), // Rule ID 49 //
     /* 45690 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45693 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45697 */       // MIs[0] Operand 1
     /* 45697 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45702 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45706 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45710 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45710 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 45713 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45715 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45717 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45719 */       GIR_RootConstrainSelectedInstOperands,
     /* 45720 */       // GIR_Coverage, 49,
     /* 45720 */       GIR_EraseRootFromParent_Done,
     /* 45721 */     // Label 1181: @45721
     /* 45721 */     GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(45757), // Rule ID 50 //
     /* 45726 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45729 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45733 */       // MIs[0] Operand 1
     /* 45733 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45738 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45742 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45746 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45746 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 45749 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45751 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45753 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45755 */       GIR_RootConstrainSelectedInstOperands,
     /* 45756 */       // GIR_Coverage, 50,
     /* 45756 */       GIR_EraseRootFromParent_Done,
     /* 45757 */     // Label 1182: @45757
     /* 45757 */     GIM_Reject,
     /* 45758 */   // Label 1176: @45758
     /* 45758 */   GIM_Reject,
     /* 45759 */   // Label 1174: @45759
     /* 45759 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(45836),
     /* 45764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 45767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45771 */     GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(45803), // Rule ID 204 //
     /* 45776 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 45779 */       // MIs[0] Operand 1
     /* 45779 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45784 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45788 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45792 */       // (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETLT:{ *:[Other] })  =>  (SLT64:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 45792 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 45795 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45797 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45799 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45801 */       GIR_RootConstrainSelectedInstOperands,
     /* 45802 */       // GIR_Coverage, 204,
     /* 45802 */       GIR_EraseRootFromParent_Done,
     /* 45803 */     // Label 1184: @45803
     /* 45803 */     GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(45835), // Rule ID 205 //
     /* 45808 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 45811 */       // MIs[0] Operand 1
     /* 45811 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45816 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45820 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45824 */       // (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 45824 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 45827 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45829 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45831 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45833 */       GIR_RootConstrainSelectedInstOperands,
     /* 45834 */       // GIR_Coverage, 205,
     /* 45834 */       GIR_EraseRootFromParent_Done,
     /* 45835 */     // Label 1185: @45835
     /* 45835 */     GIM_Reject,
     /* 45836 */   // Label 1183: @45836
     /* 45836 */   GIM_Reject,
     /* 45837 */   // Label 1175: @45837
     /* 45837 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1188*/ GIMT_Encode4(46754),
     /* 45848 */   /*GILLT_s32*//*Label 1186*/ GIMT_Encode4(45856),
     /* 45852 */   /*GILLT_s64*//*Label 1187*/ GIMT_Encode4(46337),
     /* 45856 */   // Label 1186: @45856
     /* 45856 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(46336),
     /* 45861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45868 */     GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(45900), // Rule ID 1075 //
     /* 45873 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45876 */       // MIs[0] Operand 1
     /* 45876 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45881 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45885 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45889 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETLT:{ *:[Other] })  =>  (SLT_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45889 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 45892 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45894 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45896 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45898 */       GIR_RootConstrainSelectedInstOperands,
     /* 45899 */       // GIR_Coverage, 1075,
     /* 45899 */       GIR_EraseRootFromParent_Done,
     /* 45900 */     // Label 1190: @45900
     /* 45900 */     GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(45932), // Rule ID 1076 //
     /* 45905 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45908 */       // MIs[0] Operand 1
     /* 45908 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45913 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45917 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45921 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45921 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 45924 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45926 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45928 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45930 */       GIR_RootConstrainSelectedInstOperands,
     /* 45931 */       // GIR_Coverage, 1076,
     /* 45931 */       GIR_EraseRootFromParent_Done,
     /* 45932 */     // Label 1191: @45932
     /* 45932 */     GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(45988), // Rule ID 1417 //
     /* 45937 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45940 */       // MIs[0] Operand 1
     /* 45940 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45945 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45949 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45953 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu:{ *:[i32] } (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 45953 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45956 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 45960 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45965 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 45969 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 45973 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 45975 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu),
     /* 45978 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45980 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45983 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45986 */       GIR_RootConstrainSelectedInstOperands,
     /* 45987 */       // GIR_Coverage, 1417,
     /* 45987 */       GIR_EraseRootFromParent_Done,
     /* 45988 */     // Label 1192: @45988
     /* 45988 */     GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(46047), // Rule ID 1418 //
     /* 45993 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45996 */       // MIs[0] Operand 1
     /* 45996 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 46001 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46005 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46009 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu:{ *:[i32] } ZERO:{ *:[i32] }, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs))
     /* 46009 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46012 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 46016 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46021 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46025 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46029 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46031 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46034 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46036 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 46042 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46045 */       GIR_RootConstrainSelectedInstOperands,
     /* 46046 */       // GIR_Coverage, 1418,
     /* 46046 */       GIR_EraseRootFromParent_Done,
     /* 46047 */     // Label 1193: @46047
     /* 46047 */     GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(46103), // Rule ID 1419 //
     /* 46052 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46055 */       // MIs[0] Operand 1
     /* 46055 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46060 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46064 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46068 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 46068 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46071 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46075 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46080 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46084 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46088 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46090 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46093 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46095 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46098 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46101 */       GIR_RootConstrainSelectedInstOperands,
     /* 46102 */       // GIR_Coverage, 1419,
     /* 46102 */       GIR_EraseRootFromParent_Done,
     /* 46103 */     // Label 1194: @46103
     /* 46103 */     GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(46159), // Rule ID 1420 //
     /* 46108 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46111 */       // MIs[0] Operand 1
     /* 46111 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 46116 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46120 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46124 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 46124 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46127 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46131 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46136 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46140 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46144 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46146 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46149 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46151 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46154 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46157 */       GIR_RootConstrainSelectedInstOperands,
     /* 46158 */       // GIR_Coverage, 1420,
     /* 46158 */       GIR_EraseRootFromParent_Done,
     /* 46159 */     // Label 1195: @46159
     /* 46159 */     GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(46191), // Rule ID 1421 //
     /* 46164 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46167 */       // MIs[0] Operand 1
     /* 46167 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46172 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46176 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46180 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 46180 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46183 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46185 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46187 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46189 */       GIR_RootConstrainSelectedInstOperands,
     /* 46190 */       // GIR_Coverage, 1421,
     /* 46190 */       GIR_EraseRootFromParent_Done,
     /* 46191 */     // Label 1196: @46191
     /* 46191 */     GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(46223), // Rule ID 1422 //
     /* 46196 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46199 */       // MIs[0] Operand 1
     /* 46199 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 46204 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46208 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46212 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 46212 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46215 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46217 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46219 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46221 */       GIR_RootConstrainSelectedInstOperands,
     /* 46222 */       // GIR_Coverage, 1422,
     /* 46222 */       GIR_EraseRootFromParent_Done,
     /* 46223 */     // Label 1197: @46223
     /* 46223 */     GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(46279), // Rule ID 1423 //
     /* 46228 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46231 */       // MIs[0] Operand 1
     /* 46231 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46236 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46240 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46244 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46244 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46247 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46251 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46256 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46260 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46264 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46266 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46269 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46271 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46274 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46277 */       GIR_RootConstrainSelectedInstOperands,
     /* 46278 */       // GIR_Coverage, 1423,
     /* 46278 */       GIR_EraseRootFromParent_Done,
     /* 46279 */     // Label 1198: @46279
     /* 46279 */     GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(46335), // Rule ID 1424 //
     /* 46284 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46287 */       // MIs[0] Operand 1
     /* 46287 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 46292 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46296 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46300 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46300 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46303 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46307 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46312 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46316 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46320 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46322 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46325 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46327 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46330 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46333 */       GIR_RootConstrainSelectedInstOperands,
     /* 46334 */       // GIR_Coverage, 1424,
     /* 46334 */       GIR_EraseRootFromParent_Done,
     /* 46335 */     // Label 1199: @46335
     /* 46335 */     GIM_Reject,
     /* 46336 */   // Label 1189: @46336
     /* 46336 */   GIM_Reject,
     /* 46337 */   // Label 1187: @46337
     /* 46337 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(46753),
     /* 46342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 46345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46349 */     GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(46405), // Rule ID 1563 //
     /* 46354 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46357 */       // MIs[0] Operand 1
     /* 46357 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 46362 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46366 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46370 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu64:{ *:[i32] } (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i64] })
     /* 46370 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 46373 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 46377 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46382 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46386 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46390 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46392 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu64),
     /* 46395 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46397 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46400 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46403 */       GIR_RootConstrainSelectedInstOperands,
     /* 46404 */       // GIR_Coverage, 1563,
     /* 46404 */       GIR_EraseRootFromParent_Done,
     /* 46405 */     // Label 1201: @46405
     /* 46405 */     GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(46464), // Rule ID 1564 //
     /* 46410 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46413 */       // MIs[0] Operand 1
     /* 46413 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 46418 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46422 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46426 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } ZERO_64:{ *:[i64] }, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs))
     /* 46426 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 46429 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 46433 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46438 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46442 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46446 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46448 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46451 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46453 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 46459 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46462 */       GIR_RootConstrainSelectedInstOperands,
     /* 46463 */       // GIR_Coverage, 1564,
     /* 46463 */       GIR_EraseRootFromParent_Done,
     /* 46464 */     // Label 1202: @46464
     /* 46464 */     GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(46520), // Rule ID 1565 //
     /* 46469 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46472 */       // MIs[0] Operand 1
     /* 46472 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46477 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46481 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46485 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), 1:{ *:[i32] })
     /* 46485 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46488 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46492 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46497 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46501 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46505 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46507 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46510 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46512 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46515 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46518 */       GIR_RootConstrainSelectedInstOperands,
     /* 46519 */       // GIR_Coverage, 1565,
     /* 46519 */       GIR_EraseRootFromParent_Done,
     /* 46520 */     // Label 1203: @46520
     /* 46520 */     GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(46576), // Rule ID 1566 //
     /* 46525 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46528 */       // MIs[0] Operand 1
     /* 46528 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 46533 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46537 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46541 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), 1:{ *:[i32] })
     /* 46541 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46544 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46548 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46553 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46557 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46561 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46563 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46566 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46568 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46571 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46574 */       GIR_RootConstrainSelectedInstOperands,
     /* 46575 */       // GIR_Coverage, 1566,
     /* 46575 */       GIR_EraseRootFromParent_Done,
     /* 46576 */     // Label 1204: @46576
     /* 46576 */     GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(46608), // Rule ID 1567 //
     /* 46581 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46584 */       // MIs[0] Operand 1
     /* 46584 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46589 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46593 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46597 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs)
     /* 46597 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46600 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46602 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46604 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46606 */       GIR_RootConstrainSelectedInstOperands,
     /* 46607 */       // GIR_Coverage, 1567,
     /* 46607 */       GIR_EraseRootFromParent_Done,
     /* 46608 */     // Label 1205: @46608
     /* 46608 */     GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(46640), // Rule ID 1568 //
     /* 46613 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46616 */       // MIs[0] Operand 1
     /* 46616 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 46621 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46625 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46629 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs)
     /* 46629 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46632 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46634 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46636 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46638 */       GIR_RootConstrainSelectedInstOperands,
     /* 46639 */       // GIR_Coverage, 1568,
     /* 46639 */       GIR_EraseRootFromParent_Done,
     /* 46640 */     // Label 1206: @46640
     /* 46640 */     GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(46696), // Rule ID 1569 //
     /* 46645 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46648 */       // MIs[0] Operand 1
     /* 46648 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46653 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46657 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46661 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i32] })
     /* 46661 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46664 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46668 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46673 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46677 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46681 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46683 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46686 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46688 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46691 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46694 */       GIR_RootConstrainSelectedInstOperands,
     /* 46695 */       // GIR_Coverage, 1569,
     /* 46695 */       GIR_EraseRootFromParent_Done,
     /* 46696 */     // Label 1207: @46696
     /* 46696 */     GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(46752), // Rule ID 1570 //
     /* 46701 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46704 */       // MIs[0] Operand 1
     /* 46704 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 46709 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46713 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46717 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i32] })
     /* 46717 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46720 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46724 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46729 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46733 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46737 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46739 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46742 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46744 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46747 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46750 */       GIR_RootConstrainSelectedInstOperands,
     /* 46751 */       // GIR_Coverage, 1570,
     /* 46751 */       GIR_EraseRootFromParent_Done,
     /* 46752 */     // Label 1208: @46752
     /* 46752 */     GIM_Reject,
     /* 46753 */   // Label 1200: @46753
     /* 46753 */   GIM_Reject,
     /* 46754 */   // Label 1188: @46754
     /* 46754 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(47790),
     /* 46759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 46762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 46765 */     GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(46825), // Rule ID 1886 //
     /* 46770 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46773 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46777 */       // MIs[0] Operand 1
     /* 46777 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 46782 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46786 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46790 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SltiuCCRxImmX16:{ *:[i32] } (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46790 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46793 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 46797 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46802 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46806 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46810 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46812 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltiuCCRxImmX16),
     /* 46815 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 46817 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46820 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46823 */       GIR_RootConstrainSelectedInstOperands,
     /* 46824 */       // GIR_Coverage, 1886,
     /* 46824 */       GIR_EraseRootFromParent_Done,
     /* 46825 */     // Label 1210: @46825
     /* 46825 */     GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(46902), // Rule ID 1888 //
     /* 46830 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46833 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46837 */       // MIs[0] Operand 1
     /* 46837 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46842 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46846 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46850 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 46850 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 46853 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 46857 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46862 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 46865 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 46867 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46870 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46874 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46879 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46883 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46887 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46889 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 46892 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 46894 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46897 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 46900 */       GIR_RootConstrainSelectedInstOperands,
     /* 46901 */       // GIR_Coverage, 1888,
     /* 46901 */       GIR_EraseRootFromParent_Done,
     /* 46902 */     // Label 1211: @46902
     /* 46902 */     GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(46938), // Rule ID 1890 //
     /* 46907 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46910 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46914 */       // MIs[0] Operand 1
     /* 46914 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46919 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46923 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46927 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs)
     /* 46927 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46930 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 46932 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46934 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46936 */       GIR_RootConstrainSelectedInstOperands,
     /* 46937 */       // GIR_Coverage, 1890,
     /* 46937 */       GIR_EraseRootFromParent_Done,
     /* 46938 */     // Label 1212: @46938
     /* 46938 */     GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(47015), // Rule ID 1891 //
     /* 46943 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46946 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46950 */       // MIs[0] Operand 1
     /* 46950 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46955 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46959 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46963 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs), (LiRxImm16:{ *:[i32] } 1:{ *:[i32] }))
     /* 46963 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 46966 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImm16),
     /* 46970 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46975 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 46978 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 46980 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46983 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46987 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46992 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46996 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47000 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47002 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47005 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 47007 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47010 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47013 */       GIR_RootConstrainSelectedInstOperands,
     /* 47014 */       // GIR_Coverage, 1891,
     /* 47014 */       GIR_EraseRootFromParent_Done,
     /* 47015 */     // Label 1213: @47015
     /* 47015 */     GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(47051), // Rule ID 1892 //
     /* 47020 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47023 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47027 */       // MIs[0] Operand 1
     /* 47027 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 47032 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47036 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47040 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLT:{ *:[Other] })  =>  (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry)
     /* 47040 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 47043 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47045 */       GIR_RootToRootCopy, /*OpIdx*/2, // rx
     /* 47047 */       GIR_RootToRootCopy, /*OpIdx*/3, // ry
     /* 47049 */       GIR_RootConstrainSelectedInstOperands,
     /* 47050 */       // GIR_Coverage, 1892,
     /* 47050 */       GIR_EraseRootFromParent_Done,
     /* 47051 */     // Label 1214: @47051
     /* 47051 */     GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(47128), // Rule ID 1894 //
     /* 47056 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47059 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47063 */       // MIs[0] Operand 1
     /* 47063 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 47068 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47072 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47076 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } (LiRxImmX16:{ *:[i32] } 0:{ *:[i32] }), (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs))
     /* 47076 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47079 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47083 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47088 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47092 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47096 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47098 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47101 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47105 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47110 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 47113 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47115 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47118 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47120 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47123 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47126 */       GIR_RootConstrainSelectedInstOperands,
     /* 47127 */       // GIR_Coverage, 1894,
     /* 47127 */       GIR_EraseRootFromParent_Done,
     /* 47128 */     // Label 1215: @47128
     /* 47128 */     GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(47205), // Rule ID 1895 //
     /* 47133 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47136 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47140 */       // MIs[0] Operand 1
     /* 47140 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 47145 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47149 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47153 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 47153 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47156 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47160 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47165 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 47168 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47170 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47173 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47177 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47182 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47186 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47190 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47192 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47195 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 47197 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47200 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47203 */       GIR_RootConstrainSelectedInstOperands,
     /* 47204 */       // GIR_Coverage, 1895,
     /* 47204 */       GIR_EraseRootFromParent_Done,
     /* 47205 */     // Label 1216: @47205
     /* 47205 */     GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(47241), // Rule ID 1896 //
     /* 47210 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47213 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47217 */       // MIs[0] Operand 1
     /* 47217 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 47222 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47226 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47230 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs)
     /* 47230 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47233 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47235 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47237 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47239 */       GIR_RootConstrainSelectedInstOperands,
     /* 47240 */       // GIR_Coverage, 1896,
     /* 47240 */       GIR_EraseRootFromParent_Done,
     /* 47241 */     // Label 1217: @47241
     /* 47241 */     GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(47318), // Rule ID 1897 //
     /* 47246 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47249 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47253 */       // MIs[0] Operand 1
     /* 47253 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 47258 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47262 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47266 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 47266 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47269 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47273 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47278 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 47281 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47283 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47286 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47290 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47295 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47299 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47303 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47305 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47308 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 47310 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47313 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47316 */       GIR_RootConstrainSelectedInstOperands,
     /* 47317 */       // GIR_Coverage, 1897,
     /* 47317 */       GIR_EraseRootFromParent_Done,
     /* 47318 */     // Label 1218: @47318
     /* 47318 */     GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(47354), // Rule ID 1898 //
     /* 47323 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47326 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47330 */       // MIs[0] Operand 1
     /* 47330 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 47335 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47339 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47343 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETULT:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry)
     /* 47343 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47346 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47348 */       GIR_RootToRootCopy, /*OpIdx*/2, // rx
     /* 47350 */       GIR_RootToRootCopy, /*OpIdx*/3, // ry
     /* 47352 */       GIR_RootConstrainSelectedInstOperands,
     /* 47353 */       // GIR_Coverage, 1898,
     /* 47353 */       GIR_EraseRootFromParent_Done,
     /* 47354 */     // Label 1219: @47354
     /* 47354 */     GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(47414), // Rule ID 2210 //
     /* 47359 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47362 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47366 */       // MIs[0] Operand 1
     /* 47366 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 47371 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47375 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47379 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu_MM:{ *:[i32] } (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47379 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47382 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 47386 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47391 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47395 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47399 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47401 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu_MM),
     /* 47404 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47406 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47409 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47412 */       GIR_RootConstrainSelectedInstOperands,
     /* 47413 */       // GIR_Coverage, 2210,
     /* 47413 */       GIR_EraseRootFromParent_Done,
     /* 47414 */     // Label 1220: @47414
     /* 47414 */     GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(47477), // Rule ID 2211 //
     /* 47419 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47422 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47426 */       // MIs[0] Operand 1
     /* 47426 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 47431 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47435 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47439 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } ZERO:{ *:[i32] }, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs))
     /* 47439 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47442 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 47446 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47451 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47455 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47459 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47461 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47464 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47466 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 47472 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47475 */       GIR_RootConstrainSelectedInstOperands,
     /* 47476 */       // GIR_Coverage, 2211,
     /* 47476 */       GIR_EraseRootFromParent_Done,
     /* 47477 */     // Label 1221: @47477
     /* 47477 */     GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(47537), // Rule ID 2212 //
     /* 47482 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47485 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47489 */       // MIs[0] Operand 1
     /* 47489 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 47494 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47498 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47502 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 47502 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47505 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47509 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47514 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47518 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47522 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47524 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47527 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47529 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47532 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47535 */       GIR_RootConstrainSelectedInstOperands,
     /* 47536 */       // GIR_Coverage, 2212,
     /* 47536 */       GIR_EraseRootFromParent_Done,
     /* 47537 */     // Label 1222: @47537
     /* 47537 */     GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(47597), // Rule ID 2213 //
     /* 47542 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47545 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47549 */       // MIs[0] Operand 1
     /* 47549 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 47554 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47558 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47562 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 47562 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47565 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47569 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47574 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47578 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47582 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47584 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47587 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47589 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47592 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47595 */       GIR_RootConstrainSelectedInstOperands,
     /* 47596 */       // GIR_Coverage, 2213,
     /* 47596 */       GIR_EraseRootFromParent_Done,
     /* 47597 */     // Label 1223: @47597
     /* 47597 */     GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(47633), // Rule ID 2214 //
     /* 47602 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47605 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47609 */       // MIs[0] Operand 1
     /* 47609 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 47614 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47618 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47622 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 47622 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47625 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47627 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47629 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47631 */       GIR_RootConstrainSelectedInstOperands,
     /* 47632 */       // GIR_Coverage, 2214,
     /* 47632 */       GIR_EraseRootFromParent_Done,
     /* 47633 */     // Label 1224: @47633
     /* 47633 */     GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(47669), // Rule ID 2215 //
     /* 47638 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47641 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47645 */       // MIs[0] Operand 1
     /* 47645 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 47650 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47654 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47658 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 47658 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47661 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47663 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47665 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47667 */       GIR_RootConstrainSelectedInstOperands,
     /* 47668 */       // GIR_Coverage, 2215,
     /* 47668 */       GIR_EraseRootFromParent_Done,
     /* 47669 */     // Label 1225: @47669
     /* 47669 */     GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(47729), // Rule ID 2216 //
     /* 47674 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47677 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47681 */       // MIs[0] Operand 1
     /* 47681 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 47686 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47690 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47694 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47694 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47697 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47701 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47706 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47710 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47714 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47716 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47719 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47721 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47724 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47727 */       GIR_RootConstrainSelectedInstOperands,
     /* 47728 */       // GIR_Coverage, 2216,
     /* 47728 */       GIR_EraseRootFromParent_Done,
     /* 47729 */     // Label 1226: @47729
     /* 47729 */     GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(47789), // Rule ID 2217 //
     /* 47734 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47737 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47741 */       // MIs[0] Operand 1
     /* 47741 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 47746 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47750 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47754 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47754 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47757 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47761 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47766 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47770 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47774 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47776 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47779 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47781 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47784 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47787 */       GIR_RootConstrainSelectedInstOperands,
     /* 47788 */       // GIR_Coverage, 2217,
     /* 47788 */       GIR_EraseRootFromParent_Done,
     /* 47789 */     // Label 1227: @47789
     /* 47789 */     GIM_Reject,
     /* 47790 */   // Label 1209: @47790
     /* 47790 */   GIM_Reject,
     /* 47791 */ // Label 1163: @47791
     /* 47791 */ GIM_Reject,
     /* 47792 */ // Label 42: @47792
     /* 47792 */ GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(49497),
     /* 47797 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 47800 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1231*/ GIMT_Encode4(48295),
     /* 47811 */   /*GILLT_s32*//*Label 1229*/ GIMT_Encode4(47819),
     /* 47815 */   /*GILLT_s64*//*Label 1230*/ GIMT_Encode4(48057),
     /* 47819 */   // Label 1229: @47819
     /* 47819 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(48056),
     /* 47824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 47827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 47831 */     GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(47863), // Rule ID 312 //
     /* 47836 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47839 */       // MIs[0] Operand 1
     /* 47839 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 47844 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47848 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47852 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47852 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S),
     /* 47855 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47857 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47859 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47861 */       GIR_RootConstrainSelectedInstOperands,
     /* 47862 */       // GIR_Coverage, 312,
     /* 47862 */       GIR_EraseRootFromParent_Done,
     /* 47863 */     // Label 1233: @47863
     /* 47863 */     GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(47895), // Rule ID 313 //
     /* 47868 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47871 */       // MIs[0] Operand 1
     /* 47871 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 47876 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47880 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47884 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47884 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S),
     /* 47887 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47889 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47891 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47893 */       GIR_RootConstrainSelectedInstOperands,
     /* 47894 */       // GIR_Coverage, 313,
     /* 47894 */       GIR_EraseRootFromParent_Done,
     /* 47895 */     // Label 1234: @47895
     /* 47895 */     GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(47927), // Rule ID 314 //
     /* 47900 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47903 */       // MIs[0] Operand 1
     /* 47903 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 47908 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47912 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47916 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47916 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S),
     /* 47919 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47921 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47923 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47925 */       GIR_RootConstrainSelectedInstOperands,
     /* 47926 */       // GIR_Coverage, 314,
     /* 47926 */       GIR_EraseRootFromParent_Done,
     /* 47927 */     // Label 1235: @47927
     /* 47927 */     GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(47959), // Rule ID 315 //
     /* 47932 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47935 */       // MIs[0] Operand 1
     /* 47935 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 47940 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47944 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47948 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47948 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_S),
     /* 47951 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47953 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47955 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47957 */       GIR_RootConstrainSelectedInstOperands,
     /* 47958 */       // GIR_Coverage, 315,
     /* 47958 */       GIR_EraseRootFromParent_Done,
     /* 47959 */     // Label 1236: @47959
     /* 47959 */     GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(47991), // Rule ID 316 //
     /* 47964 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47967 */       // MIs[0] Operand 1
     /* 47967 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 47972 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47976 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47980 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47980 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_S),
     /* 47983 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47985 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47987 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47989 */       GIR_RootConstrainSelectedInstOperands,
     /* 47990 */       // GIR_Coverage, 316,
     /* 47990 */       GIR_EraseRootFromParent_Done,
     /* 47991 */     // Label 1237: @47991
     /* 47991 */     GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(48023), // Rule ID 317 //
     /* 47996 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47999 */       // MIs[0] Operand 1
     /* 47999 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48004 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48008 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48012 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48012 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_S),
     /* 48015 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48017 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48019 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48021 */       GIR_RootConstrainSelectedInstOperands,
     /* 48022 */       // GIR_Coverage, 317,
     /* 48022 */       GIR_EraseRootFromParent_Done,
     /* 48023 */     // Label 1238: @48023
     /* 48023 */     GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(48055), // Rule ID 318 //
     /* 48028 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48031 */       // MIs[0] Operand 1
     /* 48031 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48036 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48040 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48044 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48044 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_S),
     /* 48047 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48049 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48051 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48053 */       GIR_RootConstrainSelectedInstOperands,
     /* 48054 */       // GIR_Coverage, 318,
     /* 48054 */       GIR_EraseRootFromParent_Done,
     /* 48055 */     // Label 1239: @48055
     /* 48055 */     GIM_Reject,
     /* 48056 */   // Label 1232: @48056
     /* 48056 */   GIM_Reject,
     /* 48057 */   // Label 1230: @48057
     /* 48057 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(48294),
     /* 48062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48069 */     GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(48101), // Rule ID 319 //
     /* 48074 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48077 */       // MIs[0] Operand 1
     /* 48077 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48082 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48086 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48090 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48090 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D),
     /* 48093 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48095 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48097 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48099 */       GIR_RootConstrainSelectedInstOperands,
     /* 48100 */       // GIR_Coverage, 319,
     /* 48100 */       GIR_EraseRootFromParent_Done,
     /* 48101 */     // Label 1241: @48101
     /* 48101 */     GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(48133), // Rule ID 320 //
     /* 48106 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48109 */       // MIs[0] Operand 1
     /* 48109 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48114 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48118 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48122 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48122 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D),
     /* 48125 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48127 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48129 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48131 */       GIR_RootConstrainSelectedInstOperands,
     /* 48132 */       // GIR_Coverage, 320,
     /* 48132 */       GIR_EraseRootFromParent_Done,
     /* 48133 */     // Label 1242: @48133
     /* 48133 */     GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(48165), // Rule ID 321 //
     /* 48138 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48141 */       // MIs[0] Operand 1
     /* 48141 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48146 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48150 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48154 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48154 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D),
     /* 48157 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48159 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48161 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48163 */       GIR_RootConstrainSelectedInstOperands,
     /* 48164 */       // GIR_Coverage, 321,
     /* 48164 */       GIR_EraseRootFromParent_Done,
     /* 48165 */     // Label 1243: @48165
     /* 48165 */     GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(48197), // Rule ID 322 //
     /* 48170 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48173 */       // MIs[0] Operand 1
     /* 48173 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48178 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48182 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48186 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48186 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_D),
     /* 48189 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48191 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48193 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48195 */       GIR_RootConstrainSelectedInstOperands,
     /* 48196 */       // GIR_Coverage, 322,
     /* 48196 */       GIR_EraseRootFromParent_Done,
     /* 48197 */     // Label 1244: @48197
     /* 48197 */     GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(48229), // Rule ID 323 //
     /* 48202 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48205 */       // MIs[0] Operand 1
     /* 48205 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48210 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48214 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48218 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48218 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_D),
     /* 48221 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48223 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48225 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48227 */       GIR_RootConstrainSelectedInstOperands,
     /* 48228 */       // GIR_Coverage, 323,
     /* 48228 */       GIR_EraseRootFromParent_Done,
     /* 48229 */     // Label 1245: @48229
     /* 48229 */     GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(48261), // Rule ID 324 //
     /* 48234 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48237 */       // MIs[0] Operand 1
     /* 48237 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48242 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48246 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48250 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48250 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_D),
     /* 48253 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48255 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48257 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48259 */       GIR_RootConstrainSelectedInstOperands,
     /* 48260 */       // GIR_Coverage, 324,
     /* 48260 */       GIR_EraseRootFromParent_Done,
     /* 48261 */     // Label 1246: @48261
     /* 48261 */     GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(48293), // Rule ID 325 //
     /* 48266 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48269 */       // MIs[0] Operand 1
     /* 48269 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48274 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48278 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48282 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48282 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_D),
     /* 48285 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48287 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48289 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48291 */       GIR_RootConstrainSelectedInstOperands,
     /* 48292 */       // GIR_Coverage, 325,
     /* 48292 */       GIR_EraseRootFromParent_Done,
     /* 48293 */     // Label 1247: @48293
     /* 48293 */     GIM_Reject,
     /* 48294 */   // Label 1240: @48294
     /* 48294 */   GIM_Reject,
     /* 48295 */   // Label 1231: @48295
     /* 48295 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1250*/ GIMT_Encode4(48790),
     /* 48306 */   /*GILLT_s32*//*Label 1248*/ GIMT_Encode4(48314),
     /* 48310 */   /*GILLT_s64*//*Label 1249*/ GIMT_Encode4(48552),
     /* 48314 */   // Label 1248: @48314
     /* 48314 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(48551),
     /* 48319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 48322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48326 */     GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(48358), // Rule ID 1193 //
     /* 48331 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48334 */       // MIs[0] Operand 1
     /* 48334 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48339 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48343 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48347 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48347 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S_MMR6),
     /* 48350 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48352 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48354 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48356 */       GIR_RootConstrainSelectedInstOperands,
     /* 48357 */       // GIR_Coverage, 1193,
     /* 48357 */       GIR_EraseRootFromParent_Done,
     /* 48358 */     // Label 1252: @48358
     /* 48358 */     GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(48390), // Rule ID 1194 //
     /* 48363 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48366 */       // MIs[0] Operand 1
     /* 48366 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48371 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48375 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48379 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48379 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S_MMR6),
     /* 48382 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48384 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48386 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48388 */       GIR_RootConstrainSelectedInstOperands,
     /* 48389 */       // GIR_Coverage, 1194,
     /* 48389 */       GIR_EraseRootFromParent_Done,
     /* 48390 */     // Label 1253: @48390
     /* 48390 */     GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(48422), // Rule ID 1195 //
     /* 48395 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48398 */       // MIs[0] Operand 1
     /* 48398 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48403 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48407 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48411 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48411 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S_MMR6),
     /* 48414 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48416 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48418 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48420 */       GIR_RootConstrainSelectedInstOperands,
     /* 48421 */       // GIR_Coverage, 1195,
     /* 48421 */       GIR_EraseRootFromParent_Done,
     /* 48422 */     // Label 1254: @48422
     /* 48422 */     GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(48454), // Rule ID 1196 //
     /* 48427 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48430 */       // MIs[0] Operand 1
     /* 48430 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48435 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48439 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48443 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48443 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_S_MMR6),
     /* 48446 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48448 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48450 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48452 */       GIR_RootConstrainSelectedInstOperands,
     /* 48453 */       // GIR_Coverage, 1196,
     /* 48453 */       GIR_EraseRootFromParent_Done,
     /* 48454 */     // Label 1255: @48454
     /* 48454 */     GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(48486), // Rule ID 1197 //
     /* 48459 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48462 */       // MIs[0] Operand 1
     /* 48462 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48467 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48471 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48475 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48475 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_S_MMR6),
     /* 48478 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48480 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48482 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48484 */       GIR_RootConstrainSelectedInstOperands,
     /* 48485 */       // GIR_Coverage, 1197,
     /* 48485 */       GIR_EraseRootFromParent_Done,
     /* 48486 */     // Label 1256: @48486
     /* 48486 */     GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(48518), // Rule ID 1198 //
     /* 48491 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48494 */       // MIs[0] Operand 1
     /* 48494 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48499 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48503 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48507 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48507 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_S_MMR6),
     /* 48510 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48512 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48514 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48516 */       GIR_RootConstrainSelectedInstOperands,
     /* 48517 */       // GIR_Coverage, 1198,
     /* 48517 */       GIR_EraseRootFromParent_Done,
     /* 48518 */     // Label 1257: @48518
     /* 48518 */     GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(48550), // Rule ID 1199 //
     /* 48523 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48526 */       // MIs[0] Operand 1
     /* 48526 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48531 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48535 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48539 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48539 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_S_MMR6),
     /* 48542 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48544 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48546 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48548 */       GIR_RootConstrainSelectedInstOperands,
     /* 48549 */       // GIR_Coverage, 1199,
     /* 48549 */       GIR_EraseRootFromParent_Done,
     /* 48550 */     // Label 1258: @48550
     /* 48550 */     GIM_Reject,
     /* 48551 */   // Label 1251: @48551
     /* 48551 */   GIM_Reject,
     /* 48552 */   // Label 1249: @48552
     /* 48552 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(48789),
     /* 48557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48564 */     GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(48596), // Rule ID 1200 //
     /* 48569 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48572 */       // MIs[0] Operand 1
     /* 48572 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48577 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48581 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48585 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48585 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D_MMR6),
     /* 48588 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48590 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48592 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48594 */       GIR_RootConstrainSelectedInstOperands,
     /* 48595 */       // GIR_Coverage, 1200,
     /* 48595 */       GIR_EraseRootFromParent_Done,
     /* 48596 */     // Label 1260: @48596
     /* 48596 */     GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(48628), // Rule ID 1201 //
     /* 48601 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48604 */       // MIs[0] Operand 1
     /* 48604 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48609 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48613 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48617 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48617 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D_MMR6),
     /* 48620 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48622 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48624 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48626 */       GIR_RootConstrainSelectedInstOperands,
     /* 48627 */       // GIR_Coverage, 1201,
     /* 48627 */       GIR_EraseRootFromParent_Done,
     /* 48628 */     // Label 1261: @48628
     /* 48628 */     GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(48660), // Rule ID 1202 //
     /* 48633 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48636 */       // MIs[0] Operand 1
     /* 48636 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48641 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48645 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48649 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48649 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D_MMR6),
     /* 48652 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48654 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48656 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48658 */       GIR_RootConstrainSelectedInstOperands,
     /* 48659 */       // GIR_Coverage, 1202,
     /* 48659 */       GIR_EraseRootFromParent_Done,
     /* 48660 */     // Label 1262: @48660
     /* 48660 */     GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(48692), // Rule ID 1203 //
     /* 48665 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48668 */       // MIs[0] Operand 1
     /* 48668 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48673 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48677 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48681 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48681 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_D_MMR6),
     /* 48684 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48686 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48688 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48690 */       GIR_RootConstrainSelectedInstOperands,
     /* 48691 */       // GIR_Coverage, 1203,
     /* 48691 */       GIR_EraseRootFromParent_Done,
     /* 48692 */     // Label 1263: @48692
     /* 48692 */     GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(48724), // Rule ID 1204 //
     /* 48697 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48700 */       // MIs[0] Operand 1
     /* 48700 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48705 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48709 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48713 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48713 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_D_MMR6),
     /* 48716 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48718 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48720 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48722 */       GIR_RootConstrainSelectedInstOperands,
     /* 48723 */       // GIR_Coverage, 1204,
     /* 48723 */       GIR_EraseRootFromParent_Done,
     /* 48724 */     // Label 1264: @48724
     /* 48724 */     GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(48756), // Rule ID 1205 //
     /* 48729 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48732 */       // MIs[0] Operand 1
     /* 48732 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48737 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48741 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48745 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48745 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_D_MMR6),
     /* 48748 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48750 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48752 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48754 */       GIR_RootConstrainSelectedInstOperands,
     /* 48755 */       // GIR_Coverage, 1205,
     /* 48755 */       GIR_EraseRootFromParent_Done,
     /* 48756 */     // Label 1265: @48756
     /* 48756 */     GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(48788), // Rule ID 1206 //
     /* 48761 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48764 */       // MIs[0] Operand 1
     /* 48764 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48769 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48773 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48777 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48777 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_D_MMR6),
     /* 48780 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48782 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48784 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48786 */       GIR_RootConstrainSelectedInstOperands,
     /* 48787 */       // GIR_Coverage, 1206,
     /* 48787 */       GIR_EraseRootFromParent_Done,
     /* 48788 */     // Label 1266: @48788
     /* 48788 */     GIM_Reject,
     /* 48789 */   // Label 1259: @48789
     /* 48789 */   GIM_Reject,
     /* 48790 */   // Label 1250: @48790
     /* 48790 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1269*/ GIMT_Encode4(49143),
     /* 48801 */   /*GILLT_s32*//*Label 1267*/ GIMT_Encode4(48809),
     /* 48805 */   /*GILLT_s64*//*Label 1268*/ GIMT_Encode4(48976),
     /* 48809 */   // Label 1267: @48809
     /* 48809 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(48975),
     /* 48814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 48817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 48821 */     GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(48872), // Rule ID 1755 //
     /* 48826 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48829 */       // MIs[0] Operand 1
     /* 48829 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 48834 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UEQ_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48834 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48837 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S),
     /* 48841 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48846 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48850 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48854 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48856 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48859 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48861 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48864 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48870 */       GIR_RootConstrainSelectedInstOperands,
     /* 48871 */       // GIR_Coverage, 1755,
     /* 48871 */       GIR_EraseRootFromParent_Done,
     /* 48872 */     // Label 1271: @48872
     /* 48872 */     GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(48923), // Rule ID 1756 //
     /* 48877 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48880 */       // MIs[0] Operand 1
     /* 48880 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 48885 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETO:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UN_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48885 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48888 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S),
     /* 48892 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48897 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48901 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48905 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48907 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48910 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48912 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48915 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48921 */       GIR_RootConstrainSelectedInstOperands,
     /* 48922 */       // GIR_Coverage, 1756,
     /* 48922 */       GIR_EraseRootFromParent_Done,
     /* 48923 */     // Label 1272: @48923
     /* 48923 */     GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(48974), // Rule ID 1757 //
     /* 48928 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48931 */       // MIs[0] Operand 1
     /* 48931 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 48936 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_EQ_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48936 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48939 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S),
     /* 48943 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48948 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48952 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48956 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48958 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48961 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48963 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48966 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48972 */       GIR_RootConstrainSelectedInstOperands,
     /* 48973 */       // GIR_Coverage, 1757,
     /* 48973 */       GIR_EraseRootFromParent_Done,
     /* 48974 */     // Label 1273: @48974
     /* 48974 */     GIM_Reject,
     /* 48975 */   // Label 1270: @48975
     /* 48975 */   GIM_Reject,
     /* 48976 */   // Label 1268: @48976
     /* 48976 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(49142),
     /* 48981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 48988 */     GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(49039), // Rule ID 1764 //
     /* 48993 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48996 */       // MIs[0] Operand 1
     /* 48996 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 49001 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UEQ_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49001 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49004 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D),
     /* 49008 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49013 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49017 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49021 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49023 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49026 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49028 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49031 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49037 */       GIR_RootConstrainSelectedInstOperands,
     /* 49038 */       // GIR_Coverage, 1764,
     /* 49038 */       GIR_EraseRootFromParent_Done,
     /* 49039 */     // Label 1275: @49039
     /* 49039 */     GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(49090), // Rule ID 1765 //
     /* 49044 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 49047 */       // MIs[0] Operand 1
     /* 49047 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49052 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETO:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UN_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49052 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49055 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D),
     /* 49059 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49064 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49068 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49072 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49074 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49077 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49079 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49082 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49088 */       GIR_RootConstrainSelectedInstOperands,
     /* 49089 */       // GIR_Coverage, 1765,
     /* 49089 */       GIR_EraseRootFromParent_Done,
     /* 49090 */     // Label 1276: @49090
     /* 49090 */     GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(49141), // Rule ID 1766 //
     /* 49095 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 49098 */       // MIs[0] Operand 1
     /* 49098 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49103 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_EQ_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49103 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49106 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D),
     /* 49110 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49115 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49119 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49123 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49125 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49128 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49130 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49133 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49139 */       GIR_RootConstrainSelectedInstOperands,
     /* 49140 */       // GIR_Coverage, 1766,
     /* 49140 */       GIR_EraseRootFromParent_Done,
     /* 49141 */     // Label 1277: @49141
     /* 49141 */     GIM_Reject,
     /* 49142 */   // Label 1274: @49142
     /* 49142 */   GIM_Reject,
     /* 49143 */   // Label 1269: @49143
     /* 49143 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1280*/ GIMT_Encode4(49496),
     /* 49154 */   /*GILLT_s32*//*Label 1278*/ GIMT_Encode4(49162),
     /* 49158 */   /*GILLT_s64*//*Label 1279*/ GIMT_Encode4(49329),
     /* 49162 */   // Label 1278: @49162
     /* 49162 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(49328),
     /* 49167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49174 */     GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(49225), // Rule ID 2309 //
     /* 49179 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49182 */       // MIs[0] Operand 1
     /* 49182 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 49187 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UEQ_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49187 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49190 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S_MMR6),
     /* 49194 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49199 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49203 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49207 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49209 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49212 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49214 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49217 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49223 */       GIR_RootConstrainSelectedInstOperands,
     /* 49224 */       // GIR_Coverage, 2309,
     /* 49224 */       GIR_EraseRootFromParent_Done,
     /* 49225 */     // Label 1282: @49225
     /* 49225 */     GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(49276), // Rule ID 2310 //
     /* 49230 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49233 */       // MIs[0] Operand 1
     /* 49233 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49238 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETO:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UN_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49238 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49241 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S_MMR6),
     /* 49245 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49250 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49254 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49258 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49260 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49263 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49265 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49268 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49274 */       GIR_RootConstrainSelectedInstOperands,
     /* 49275 */       // GIR_Coverage, 2310,
     /* 49275 */       GIR_EraseRootFromParent_Done,
     /* 49276 */     // Label 1283: @49276
     /* 49276 */     GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(49327), // Rule ID 2311 //
     /* 49281 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49284 */       // MIs[0] Operand 1
     /* 49284 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49289 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_EQ_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49289 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49292 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S_MMR6),
     /* 49296 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49301 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49305 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49309 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49311 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49314 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49316 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49319 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49325 */       GIR_RootConstrainSelectedInstOperands,
     /* 49326 */       // GIR_Coverage, 2311,
     /* 49326 */       GIR_EraseRootFromParent_Done,
     /* 49327 */     // Label 1284: @49327
     /* 49327 */     GIM_Reject,
     /* 49328 */   // Label 1281: @49328
     /* 49328 */   GIM_Reject,
     /* 49329 */   // Label 1279: @49329
     /* 49329 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(49495),
     /* 49334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 49337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49341 */     GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(49392), // Rule ID 2318 //
     /* 49346 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49349 */       // MIs[0] Operand 1
     /* 49349 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 49354 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UEQ_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49354 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49357 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D_MMR6),
     /* 49361 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49366 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49370 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49374 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49376 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49379 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49381 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49384 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49390 */       GIR_RootConstrainSelectedInstOperands,
     /* 49391 */       // GIR_Coverage, 2318,
     /* 49391 */       GIR_EraseRootFromParent_Done,
     /* 49392 */     // Label 1286: @49392
     /* 49392 */     GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(49443), // Rule ID 2319 //
     /* 49397 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49400 */       // MIs[0] Operand 1
     /* 49400 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49405 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETO:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UN_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49405 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49408 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D_MMR6),
     /* 49412 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49417 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49421 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49425 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49427 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49430 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49432 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49435 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49441 */       GIR_RootConstrainSelectedInstOperands,
     /* 49442 */       // GIR_Coverage, 2319,
     /* 49442 */       GIR_EraseRootFromParent_Done,
     /* 49443 */     // Label 1287: @49443
     /* 49443 */     GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(49494), // Rule ID 2320 //
     /* 49448 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49451 */       // MIs[0] Operand 1
     /* 49451 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49456 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_EQ_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49456 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49459 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D_MMR6),
     /* 49463 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49468 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49472 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49476 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49478 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49481 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49483 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49486 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49492 */       GIR_RootConstrainSelectedInstOperands,
     /* 49493 */       // GIR_Coverage, 2320,
     /* 49493 */       GIR_EraseRootFromParent_Done,
     /* 49494 */     // Label 1288: @49494
     /* 49494 */     GIM_Reject,
     /* 49495 */   // Label 1285: @49495
     /* 49495 */   GIM_Reject,
     /* 49496 */   // Label 1280: @49496
     /* 49496 */   GIM_Reject,
     /* 49497 */ // Label 1228: @49497
     /* 49497 */ GIM_Reject,
     /* 49498 */ // Label 43: @49498
     /* 49498 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1295*/ GIMT_Encode4(61535),
     /* 49509 */ /*GILLT_s32*//*Label 1289*/ GIMT_Encode4(49541),
     /* 49513 */ /*GILLT_s64*//*Label 1290*/ GIMT_Encode4(56218), GIMT_Encode4(0),
     /* 49521 */ /*GILLT_v2s64*//*Label 1291*/ GIMT_Encode4(61245), GIMT_Encode4(0),
     /* 49529 */ /*GILLT_v4s32*//*Label 1292*/ GIMT_Encode4(61319),
     /* 49533 */ /*GILLT_v8s16*//*Label 1293*/ GIMT_Encode4(61393),
     /* 49537 */ /*GILLT_v16s8*//*Label 1294*/ GIMT_Encode4(61440),
     /* 49541 */ // Label 1289: @49541
     /* 49541 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(49617), // Rule ID 1643 //
     /* 49546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49562 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49566 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49570 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49574 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49578 */   // MIs[1] Operand 1
     /* 49578 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49583 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49588 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49596 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49600 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49602 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 49605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49607 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49609 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49613 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49615 */   GIR_RootConstrainSelectedInstOperands,
     /* 49616 */   // GIR_Coverage, 1643,
     /* 49616 */   GIR_EraseRootFromParent_Done,
     /* 49617 */ // Label 1296: @49617
     /* 49617 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(49693), // Rule ID 1647 //
     /* 49622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49631 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49638 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49642 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49646 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49650 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49654 */   // MIs[1] Operand 1
     /* 49654 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49659 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49664 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49672 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49676 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49678 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 49681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49683 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49685 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49689 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49691 */   GIR_RootConstrainSelectedInstOperands,
     /* 49692 */   // GIR_Coverage, 1647,
     /* 49692 */   GIR_EraseRootFromParent_Done,
     /* 49693 */ // Label 1297: @49693
     /* 49693 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(49769), // Rule ID 1675 //
     /* 49698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49714 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49722 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 49726 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 49730 */   // MIs[1] Operand 1
     /* 49730 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49735 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 49740 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49748 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49754 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I),
     /* 49757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49759 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49761 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49765 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49767 */   GIR_RootConstrainSelectedInstOperands,
     /* 49768 */   // GIR_Coverage, 1675,
     /* 49768 */   GIR_EraseRootFromParent_Done,
     /* 49769 */ // Label 1298: @49769
     /* 49769 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(49845), // Rule ID 1686 //
     /* 49774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49798 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 49802 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 49806 */   // MIs[1] Operand 1
     /* 49806 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49811 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 49816 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49824 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49828 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49830 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 49833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49835 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49837 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49841 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49843 */   GIR_RootConstrainSelectedInstOperands,
     /* 49844 */   // GIR_Coverage, 1686,
     /* 49844 */   GIR_EraseRootFromParent_Done,
     /* 49845 */ // Label 1299: @49845
     /* 49845 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(49921), // Rule ID 1699 //
     /* 49850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49859 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49874 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49878 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49882 */   // MIs[1] Operand 1
     /* 49882 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49887 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49892 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49900 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49904 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49906 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 49906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 49909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 49911 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49913 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49917 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49919 */   GIR_RootConstrainSelectedInstOperands,
     /* 49920 */   // GIR_Coverage, 1699,
     /* 49920 */   GIR_EraseRootFromParent_Done,
     /* 49921 */ // Label 1300: @49921
     /* 49921 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(49997), // Rule ID 1702 //
     /* 49926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49935 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49942 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49946 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49950 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49954 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49958 */   // MIs[1] Operand 1
     /* 49958 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49963 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49968 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49976 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49980 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49982 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 49982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 49985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 49987 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49989 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49993 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49995 */   GIR_RootConstrainSelectedInstOperands,
     /* 49996 */   // GIR_Coverage, 1702,
     /* 49996 */   GIR_EraseRootFromParent_Done,
     /* 49997 */ // Label 1301: @49997
     /* 49997 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(50073), // Rule ID 1712 //
     /* 50002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50026 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 50030 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 50034 */   // MIs[1] Operand 1
     /* 50034 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50039 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 50044 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50052 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50056 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50058 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_S),
     /* 50061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50063 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50065 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50069 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50071 */   GIR_RootConstrainSelectedInstOperands,
     /* 50072 */   // GIR_Coverage, 1712,
     /* 50072 */   GIR_EraseRootFromParent_Done,
     /* 50073 */ // Label 1302: @50073
     /* 50073 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(50149), // Rule ID 1715 //
     /* 50078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50087 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50094 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50098 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50102 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 50106 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 50110 */   // MIs[1] Operand 1
     /* 50110 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50115 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 50120 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50128 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50132 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50134 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 50137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50139 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50141 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50145 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50147 */   GIR_RootConstrainSelectedInstOperands,
     /* 50148 */   // GIR_Coverage, 1715,
     /* 50148 */   GIR_EraseRootFromParent_Done,
     /* 50149 */ // Label 1303: @50149
     /* 50149 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(50225), // Rule ID 1880 //
     /* 50154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 50157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50163 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50182 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50186 */   // MIs[1] Operand 1
     /* 50186 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50191 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50196 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50204 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50208 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50210 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBeqZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 50210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBeqZ),
     /* 50213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 50215 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 50217 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 50219 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 50223 */   GIR_RootConstrainSelectedInstOperands,
     /* 50224 */   // GIR_Coverage, 1880,
     /* 50224 */   GIR_EraseRootFromParent_Done,
     /* 50225 */ // Label 1304: @50225
     /* 50225 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(50301), // Rule ID 1883 //
     /* 50230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 50233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50239 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50246 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50250 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50258 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50262 */   // MIs[1] Operand 1
     /* 50262 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50267 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50272 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50280 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50284 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50286 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, 0:{ *:[i32] }, SETNE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBneZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 50286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBneZ),
     /* 50289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 50291 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 50293 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 50295 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 50299 */   GIR_RootConstrainSelectedInstOperands,
     /* 50300 */   // GIR_Coverage, 1883,
     /* 50300 */   GIR_EraseRootFromParent_Done,
     /* 50301 */ // Label 1305: @50301
     /* 50301 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(50377), // Rule ID 2229 //
     /* 50306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50315 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50322 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50326 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50330 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50334 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50338 */   // MIs[1] Operand 1
     /* 50338 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50343 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50348 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50356 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50362 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 50365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50367 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50369 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50373 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50375 */   GIR_RootConstrainSelectedInstOperands,
     /* 50376 */   // GIR_Coverage, 2229,
     /* 50376 */   GIR_EraseRootFromParent_Done,
     /* 50377 */ // Label 1306: @50377
     /* 50377 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(50453), // Rule ID 2233 //
     /* 50382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 50385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50391 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50398 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50402 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50406 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50410 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50414 */   // MIs[1] Operand 1
     /* 50414 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50419 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50424 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50436 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50438 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 50441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50443 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50445 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50449 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50451 */   GIR_RootConstrainSelectedInstOperands,
     /* 50452 */   // GIR_Coverage, 2233,
     /* 50452 */   GIR_EraseRootFromParent_Done,
     /* 50453 */ // Label 1307: @50453
     /* 50453 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(50529), // Rule ID 2243 //
     /* 50458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50467 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50474 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50478 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50482 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50486 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50490 */   // MIs[1] Operand 1
     /* 50490 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50495 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50500 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50508 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50514 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 50517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50519 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50521 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50525 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50527 */   GIR_RootConstrainSelectedInstOperands,
     /* 50528 */   // GIR_Coverage, 2243,
     /* 50528 */   GIR_EraseRootFromParent_Done,
     /* 50529 */ // Label 1308: @50529
     /* 50529 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(50605), // Rule ID 2247 //
     /* 50534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50543 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50550 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50554 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50558 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50562 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50566 */   // MIs[1] Operand 1
     /* 50566 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50571 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50576 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50584 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50588 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50590 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 50593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50595 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50597 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50601 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50603 */   GIR_RootConstrainSelectedInstOperands,
     /* 50604 */   // GIR_Coverage, 2247,
     /* 50604 */   GIR_EraseRootFromParent_Done,
     /* 50605 */ // Label 1309: @50605
     /* 50605 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(50681), // Rule ID 2277 //
     /* 50610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50619 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50626 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50634 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50638 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50642 */   // MIs[1] Operand 1
     /* 50642 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50647 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50652 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50660 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50666 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 50669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50671 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50673 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50677 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50679 */   GIR_RootConstrainSelectedInstOperands,
     /* 50680 */   // GIR_Coverage, 2277,
     /* 50680 */   GIR_EraseRootFromParent_Done,
     /* 50681 */ // Label 1310: @50681
     /* 50681 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(50757), // Rule ID 2280 //
     /* 50686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50702 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50710 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50714 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50718 */   // MIs[1] Operand 1
     /* 50718 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50723 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50728 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50736 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50740 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50742 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 50745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50747 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50749 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50753 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50755 */   GIR_RootConstrainSelectedInstOperands,
     /* 50756 */   // GIR_Coverage, 2280,
     /* 50756 */   GIR_EraseRootFromParent_Done,
     /* 50757 */ // Label 1311: @50757
     /* 50757 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(50855), // Rule ID 1634 //
     /* 50762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50778 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50786 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50790 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50794 */   // MIs[1] Operand 1
     /* 50794 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 50799 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50804 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50813 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50817 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50819 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 50819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 50822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 50826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50831 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50835 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 50839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 50844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50846 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50851 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50853 */   GIR_RootConstrainSelectedInstOperands,
     /* 50854 */   // GIR_Coverage, 1634,
     /* 50854 */   GIR_EraseRootFromParent_Done,
     /* 50855 */ // Label 1312: @50855
     /* 50855 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(50953), // Rule ID 1635 //
     /* 50860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50869 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50876 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50884 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50888 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50892 */   // MIs[1] Operand 1
     /* 50892 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 50897 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50902 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50911 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50915 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50917 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 50917 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 50920 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 50924 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50929 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50933 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 50937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 50942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50944 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50949 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50951 */   GIR_RootConstrainSelectedInstOperands,
     /* 50952 */   // GIR_Coverage, 1635,
     /* 50952 */   GIR_EraseRootFromParent_Done,
     /* 50953 */ // Label 1313: @50953
     /* 50953 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(51051), // Rule ID 1638 //
     /* 50958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50967 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50974 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50982 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50986 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50990 */   // MIs[1] Operand 1
     /* 50990 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 50995 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51000 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51009 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51013 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51015 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 51022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51027 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51042 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51047 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51049 */   GIR_RootConstrainSelectedInstOperands,
     /* 51050 */   // GIR_Coverage, 1638,
     /* 51050 */   GIR_EraseRootFromParent_Done,
     /* 51051 */ // Label 1314: @51051
     /* 51051 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(51149), // Rule ID 1639 //
     /* 51056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51072 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51080 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51084 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51088 */   // MIs[1] Operand 1
     /* 51088 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 51093 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51098 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51107 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51111 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51113 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51113 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51116 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 51120 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51125 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51129 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51140 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51145 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51147 */   GIR_RootConstrainSelectedInstOperands,
     /* 51148 */   // GIR_Coverage, 1639,
     /* 51148 */   GIR_EraseRootFromParent_Done,
     /* 51149 */ // Label 1315: @51149
     /* 51149 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(51247), // Rule ID 1642 //
     /* 51154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51163 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51182 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51186 */   // MIs[1] Operand 1
     /* 51186 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 51191 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51196 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51205 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51211 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 51218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51227 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51238 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51243 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51245 */   GIR_RootConstrainSelectedInstOperands,
     /* 51246 */   // GIR_Coverage, 1642,
     /* 51246 */   GIR_EraseRootFromParent_Done,
     /* 51247 */ // Label 1316: @51247
     /* 51247 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(51345), // Rule ID 1645 //
     /* 51252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51261 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51268 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51272 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51276 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51280 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51284 */   // MIs[1] Operand 1
     /* 51284 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 51289 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51294 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51303 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51309 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 51316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51321 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51325 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 51334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51336 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51341 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51343 */   GIR_RootConstrainSelectedInstOperands,
     /* 51344 */   // GIR_Coverage, 1645,
     /* 51344 */   GIR_EraseRootFromParent_Done,
     /* 51345 */ // Label 1317: @51345
     /* 51345 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(51443), // Rule ID 1656 //
     /* 51350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51374 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51378 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51382 */   // MIs[1] Operand 1
     /* 51382 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 51387 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51392 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51401 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51407 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 51414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51419 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51423 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51434 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51439 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51441 */   GIR_RootConstrainSelectedInstOperands,
     /* 51442 */   // GIR_Coverage, 1656,
     /* 51442 */   GIR_EraseRootFromParent_Done,
     /* 51443 */ // Label 1318: @51443
     /* 51443 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(51541), // Rule ID 1657 //
     /* 51448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51464 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51468 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51472 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51476 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51480 */   // MIs[1] Operand 1
     /* 51480 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 51485 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51490 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51499 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51505 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 51512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51517 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51521 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51532 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51537 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51539 */   GIR_RootConstrainSelectedInstOperands,
     /* 51540 */   // GIR_Coverage, 1657,
     /* 51540 */   GIR_EraseRootFromParent_Done,
     /* 51541 */ // Label 1319: @51541
     /* 51541 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(51639), // Rule ID 1660 //
     /* 51546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51562 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51566 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51570 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51574 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51578 */   // MIs[1] Operand 1
     /* 51578 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 51583 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51588 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51597 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51603 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 51610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51615 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51619 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51630 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51635 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51637 */   GIR_RootConstrainSelectedInstOperands,
     /* 51638 */   // GIR_Coverage, 1660,
     /* 51638 */   GIR_EraseRootFromParent_Done,
     /* 51639 */ // Label 1320: @51639
     /* 51639 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(51737), // Rule ID 1661 //
     /* 51644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51660 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51664 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51668 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51672 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51676 */   // MIs[1] Operand 1
     /* 51676 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 51681 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51686 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51695 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51699 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51701 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 51708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51713 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51717 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51728 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51733 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51735 */   GIR_RootConstrainSelectedInstOperands,
     /* 51736 */   // GIR_Coverage, 1661,
     /* 51736 */   GIR_EraseRootFromParent_Done,
     /* 51737 */ // Label 1321: @51737
     /* 51737 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(51835), // Rule ID 1674 //
     /* 51742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51766 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51770 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51774 */   // MIs[1] Operand 1
     /* 51774 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 51779 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51784 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51793 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51797 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51799 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 51802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 51806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51811 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51815 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I),
     /* 51824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51826 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51828 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51831 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51833 */   GIR_RootConstrainSelectedInstOperands,
     /* 51834 */   // GIR_Coverage, 1674,
     /* 51834 */   GIR_EraseRootFromParent_Done,
     /* 51835 */ // Label 1322: @51835
     /* 51835 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(51933), // Rule ID 1684 //
     /* 51840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51864 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51868 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51872 */   // MIs[1] Operand 1
     /* 51872 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 51877 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51882 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51891 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51897 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 51900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 51904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51909 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51913 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 51922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51924 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51929 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51931 */   GIR_RootConstrainSelectedInstOperands,
     /* 51932 */   // GIR_Coverage, 1684,
     /* 51932 */   GIR_EraseRootFromParent_Done,
     /* 51933 */ // Label 1323: @51933
     /* 51933 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(52031), // Rule ID 1690 //
     /* 51938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 51954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51962 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51966 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51970 */   // MIs[1] Operand 1
     /* 51970 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 51975 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51980 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 51989 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 51993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51995 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 51995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 52002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52007 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52011 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52022 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52027 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52029 */   GIR_RootConstrainSelectedInstOperands,
     /* 52030 */   // GIR_Coverage, 1690,
     /* 52030 */   GIR_EraseRootFromParent_Done,
     /* 52031 */ // Label 1324: @52031
     /* 52031 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(52129), // Rule ID 1691 //
     /* 52036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52045 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52052 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52056 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52060 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52064 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52068 */   // MIs[1] Operand 1
     /* 52068 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 52073 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52078 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52087 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52091 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52093 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 52100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52105 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52109 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52120 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52125 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52127 */   GIR_RootConstrainSelectedInstOperands,
     /* 52128 */   // GIR_Coverage, 1691,
     /* 52128 */   GIR_EraseRootFromParent_Done,
     /* 52129 */ // Label 1325: @52129
     /* 52129 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(52227), // Rule ID 1694 //
     /* 52134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52162 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52166 */   // MIs[1] Operand 1
     /* 52166 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 52171 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52176 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52185 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52191 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 52198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52218 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52223 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52225 */   GIR_RootConstrainSelectedInstOperands,
     /* 52226 */   // GIR_Coverage, 1694,
     /* 52226 */   GIR_EraseRootFromParent_Done,
     /* 52227 */ // Label 1326: @52227
     /* 52227 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(52325), // Rule ID 1695 //
     /* 52232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52241 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52256 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52260 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52264 */   // MIs[1] Operand 1
     /* 52264 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 52269 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52274 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52283 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52287 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52289 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 52296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52301 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52316 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52321 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52323 */   GIR_RootConstrainSelectedInstOperands,
     /* 52324 */   // GIR_Coverage, 1695,
     /* 52324 */   GIR_EraseRootFromParent_Done,
     /* 52325 */ // Label 1327: @52325
     /* 52325 */ GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(52423), // Rule ID 1698 //
     /* 52330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52339 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52354 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52358 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52362 */   // MIs[1] Operand 1
     /* 52362 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 52367 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52372 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52381 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52387 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 52394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52399 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52403 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52414 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52419 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52421 */   GIR_RootConstrainSelectedInstOperands,
     /* 52422 */   // GIR_Coverage, 1698,
     /* 52422 */   GIR_EraseRootFromParent_Done,
     /* 52423 */ // Label 1328: @52423
     /* 52423 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(52521), // Rule ID 1700 //
     /* 52428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52444 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52448 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52452 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52456 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52460 */   // MIs[1] Operand 1
     /* 52460 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 52465 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52470 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52479 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52483 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52485 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 52492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52497 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52501 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 52510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52512 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52517 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52519 */   GIR_RootConstrainSelectedInstOperands,
     /* 52520 */   // GIR_Coverage, 1700,
     /* 52520 */   GIR_EraseRootFromParent_Done,
     /* 52521 */ // Label 1329: @52521
     /* 52521 */ GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(52619), // Rule ID 1703 //
     /* 52526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52535 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52550 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52554 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52558 */   // MIs[1] Operand 1
     /* 52558 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 52563 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52568 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52577 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52581 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52583 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 52590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52595 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52610 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52615 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52617 */   GIR_RootConstrainSelectedInstOperands,
     /* 52618 */   // GIR_Coverage, 1703,
     /* 52618 */   GIR_EraseRootFromParent_Done,
     /* 52619 */ // Label 1330: @52619
     /* 52619 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(52717), // Rule ID 1704 //
     /* 52624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52633 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52640 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52644 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52648 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52652 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52656 */   // MIs[1] Operand 1
     /* 52656 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 52661 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52666 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52675 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52681 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 52688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52693 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52697 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52708 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52713 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52715 */   GIR_RootConstrainSelectedInstOperands,
     /* 52716 */   // GIR_Coverage, 1704,
     /* 52716 */   GIR_EraseRootFromParent_Done,
     /* 52717 */ // Label 1331: @52717
     /* 52717 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(52815), // Rule ID 1707 //
     /* 52722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52746 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52750 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52754 */   // MIs[1] Operand 1
     /* 52754 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 52759 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52764 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52773 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52779 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 52786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52791 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52795 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52806 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52811 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52813 */   GIR_RootConstrainSelectedInstOperands,
     /* 52814 */   // GIR_Coverage, 1707,
     /* 52814 */   GIR_EraseRootFromParent_Done,
     /* 52815 */ // Label 1332: @52815
     /* 52815 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(52913), // Rule ID 1708 //
     /* 52820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52829 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52836 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52840 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52844 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52848 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52852 */   // MIs[1] Operand 1
     /* 52852 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 52857 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52862 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52871 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52875 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52877 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 52884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52889 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52893 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52904 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52909 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52911 */   GIR_RootConstrainSelectedInstOperands,
     /* 52912 */   // GIR_Coverage, 1708,
     /* 52912 */   GIR_EraseRootFromParent_Done,
     /* 52913 */ // Label 1333: @52913
     /* 52913 */ GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(53011), // Rule ID 1711 //
     /* 52918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52942 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52946 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52950 */   // MIs[1] Operand 1
     /* 52950 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 52955 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52960 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52969 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52973 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52975 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 52978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 52982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52987 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52991 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_S),
     /* 53000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 53002 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53004 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53007 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53009 */   GIR_RootConstrainSelectedInstOperands,
     /* 53010 */   // GIR_Coverage, 1711,
     /* 53010 */   GIR_EraseRootFromParent_Done,
     /* 53011 */ // Label 1334: @53011
     /* 53011 */ GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(53109), // Rule ID 1713 //
     /* 53016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 53019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53040 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 53044 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 53048 */   // MIs[1] Operand 1
     /* 53048 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 53053 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 53058 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 53063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53067 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53071 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53073 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 53073 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 53076 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 53080 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53085 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53089 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 53098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 53100 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53105 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53107 */   GIR_RootConstrainSelectedInstOperands,
     /* 53108 */   // GIR_Coverage, 1713,
     /* 53108 */   GIR_EraseRootFromParent_Done,
     /* 53109 */ // Label 1335: @53109
     /* 53109 */ GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(53190), // Rule ID 1872 //
     /* 53114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53123 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53130 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53134 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53138 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53142 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53146 */   // MIs[1] Operand 1
     /* 53146 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 53151 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53156 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53165 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53171 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETGE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b)
     /* 53171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSlt),
     /* 53174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53176 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53178 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53180 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53184 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53188 */   GIR_RootConstrainSelectedInstOperands,
     /* 53189 */   // GIR_Coverage, 1872,
     /* 53189 */   GIR_EraseRootFromParent_Done,
     /* 53190 */ // Label 1336: @53190
     /* 53190 */ GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(53271), // Rule ID 1873 //
     /* 53195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53204 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53211 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53219 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53223 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53227 */   // MIs[1] Operand 1
     /* 53227 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 53232 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53237 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53246 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53250 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53252 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETGT:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZSlt),
     /* 53255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53257 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53259 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53261 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53265 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53269 */   GIR_RootConstrainSelectedInstOperands,
     /* 53270 */   // GIR_Coverage, 1873,
     /* 53270 */   GIR_EraseRootFromParent_Done,
     /* 53271 */ // Label 1337: @53271
     /* 53271 */ GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(53352), // Rule ID 1874 //
     /* 53276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53300 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53304 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53308 */   // MIs[1] Operand 1
     /* 53308 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 53313 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53318 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53327 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53331 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53333 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETUGE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b)
     /* 53333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSltu),
     /* 53336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53338 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53340 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53342 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53346 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53350 */   GIR_RootConstrainSelectedInstOperands,
     /* 53351 */   // GIR_Coverage, 1874,
     /* 53351 */   GIR_EraseRootFromParent_Done,
     /* 53352 */ // Label 1338: @53352
     /* 53352 */ GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(53433), // Rule ID 1875 //
     /* 53357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53366 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53373 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53381 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53385 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53389 */   // MIs[1] Operand 1
     /* 53389 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 53394 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53399 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53408 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53412 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53414 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETUGT:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZSltu),
     /* 53417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53419 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53421 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53423 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53427 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53431 */   GIR_RootConstrainSelectedInstOperands,
     /* 53432 */   // GIR_Coverage, 1875,
     /* 53432 */   GIR_EraseRootFromParent_Done,
     /* 53433 */ // Label 1339: @53433
     /* 53433 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(53514), // Rule ID 1877 //
     /* 53438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53454 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53462 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53466 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53470 */   // MIs[1] Operand 1
     /* 53470 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 53475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53480 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53489 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53493 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53495 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETLE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSlt),
     /* 53498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53500 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53502 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53504 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53508 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53512 */   GIR_RootConstrainSelectedInstOperands,
     /* 53513 */   // GIR_Coverage, 1877,
     /* 53513 */   GIR_EraseRootFromParent_Done,
     /* 53514 */ // Label 1340: @53514
     /* 53514 */ GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(53595), // Rule ID 1878 //
     /* 53519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53535 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53543 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53547 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53551 */   // MIs[1] Operand 1
     /* 53551 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 53556 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53570 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53576 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETULE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSltu),
     /* 53579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53581 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53583 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53585 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53589 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53593 */   GIR_RootConstrainSelectedInstOperands,
     /* 53594 */   // GIR_Coverage, 1878,
     /* 53594 */   GIR_EraseRootFromParent_Done,
     /* 53595 */ // Label 1341: @53595
     /* 53595 */ GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(53676), // Rule ID 1879 //
     /* 53600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53609 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53624 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53628 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53632 */   // MIs[1] Operand 1
     /* 53632 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 53637 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53642 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53657 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETEQ:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZCmp:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZCmp),
     /* 53660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53662 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53664 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53666 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53670 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53674 */   GIR_RootConstrainSelectedInstOperands,
     /* 53675 */   // GIR_Coverage, 1879,
     /* 53675 */   GIR_EraseRootFromParent_Done,
     /* 53676 */ // Label 1342: @53676
     /* 53676 */ GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(53757), // Rule ID 1882 //
     /* 53681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53690 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53697 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53701 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53705 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53709 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53713 */   // MIs[1] Operand 1
     /* 53713 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 53718 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53723 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53732 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53736 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53738 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETNE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZCmp:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZCmp),
     /* 53741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53743 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53745 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53747 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53751 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53755 */   GIR_RootConstrainSelectedInstOperands,
     /* 53756 */   // GIR_Coverage, 1882,
     /* 53756 */   GIR_EraseRootFromParent_Done,
     /* 53757 */ // Label 1343: @53757
     /* 53757 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(53855), // Rule ID 2220 //
     /* 53762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53778 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53786 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53790 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53794 */   // MIs[1] Operand 1
     /* 53794 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 53799 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53804 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53813 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53817 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53819 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 53819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 53822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 53826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53831 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53835 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 53844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 53846 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53851 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53853 */   GIR_RootConstrainSelectedInstOperands,
     /* 53854 */   // GIR_Coverage, 2220,
     /* 53854 */   GIR_EraseRootFromParent_Done,
     /* 53855 */ // Label 1344: @53855
     /* 53855 */ GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(53953), // Rule ID 2221 //
     /* 53860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53869 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53876 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53884 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53888 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53892 */   // MIs[1] Operand 1
     /* 53892 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 53897 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53902 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53911 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53915 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53917 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 53917 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 53920 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 53924 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53929 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53933 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 53942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 53944 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53949 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53951 */   GIR_RootConstrainSelectedInstOperands,
     /* 53952 */   // GIR_Coverage, 2221,
     /* 53952 */   GIR_EraseRootFromParent_Done,
     /* 53953 */ // Label 1345: @53953
     /* 53953 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(54051), // Rule ID 2224 //
     /* 53958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53967 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53974 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53982 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53986 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53990 */   // MIs[1] Operand 1
     /* 53990 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 53995 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54000 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54009 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54013 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54015 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54027 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54042 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54047 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54049 */   GIR_RootConstrainSelectedInstOperands,
     /* 54050 */   // GIR_Coverage, 2224,
     /* 54050 */   GIR_EraseRootFromParent_Done,
     /* 54051 */ // Label 1346: @54051
     /* 54051 */ GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(54149), // Rule ID 2225 //
     /* 54056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54072 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54080 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54084 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54088 */   // MIs[1] Operand 1
     /* 54088 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 54093 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54098 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54107 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54111 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54113 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54113 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54116 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54120 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54125 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54129 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54140 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54145 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54147 */   GIR_RootConstrainSelectedInstOperands,
     /* 54148 */   // GIR_Coverage, 2225,
     /* 54148 */   GIR_EraseRootFromParent_Done,
     /* 54149 */ // Label 1347: @54149
     /* 54149 */ GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(54247), // Rule ID 2228 //
     /* 54154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54163 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54182 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54186 */   // MIs[1] Operand 1
     /* 54186 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 54191 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54196 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54205 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54211 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54227 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54238 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54243 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54245 */   GIR_RootConstrainSelectedInstOperands,
     /* 54246 */   // GIR_Coverage, 2228,
     /* 54246 */   GIR_EraseRootFromParent_Done,
     /* 54247 */ // Label 1348: @54247
     /* 54247 */ GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(54345), // Rule ID 2231 //
     /* 54252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 54255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54261 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54268 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54272 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54276 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54280 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54284 */   // MIs[1] Operand 1
     /* 54284 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 54289 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54294 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54303 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54309 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54321 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54325 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 54334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54336 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54341 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54343 */   GIR_RootConstrainSelectedInstOperands,
     /* 54344 */   // GIR_Coverage, 2231,
     /* 54344 */   GIR_EraseRootFromParent_Done,
     /* 54345 */ // Label 1349: @54345
     /* 54345 */ GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(54443), // Rule ID 2234 //
     /* 54350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54374 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54378 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54382 */   // MIs[1] Operand 1
     /* 54382 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 54387 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54392 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54401 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54407 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54419 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54423 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54434 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54439 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54441 */   GIR_RootConstrainSelectedInstOperands,
     /* 54442 */   // GIR_Coverage, 2234,
     /* 54442 */   GIR_EraseRootFromParent_Done,
     /* 54443 */ // Label 1350: @54443
     /* 54443 */ GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(54541), // Rule ID 2235 //
     /* 54448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54464 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54468 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54472 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54476 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54480 */   // MIs[1] Operand 1
     /* 54480 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 54485 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54490 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54499 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54505 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54517 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54521 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54532 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54537 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54539 */   GIR_RootConstrainSelectedInstOperands,
     /* 54540 */   // GIR_Coverage, 2235,
     /* 54540 */   GIR_EraseRootFromParent_Done,
     /* 54541 */ // Label 1351: @54541
     /* 54541 */ GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(54639), // Rule ID 2238 //
     /* 54546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54562 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54566 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54570 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54574 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54578 */   // MIs[1] Operand 1
     /* 54578 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 54583 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54588 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54597 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54603 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54615 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54619 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54630 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54635 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54637 */   GIR_RootConstrainSelectedInstOperands,
     /* 54638 */   // GIR_Coverage, 2238,
     /* 54638 */   GIR_EraseRootFromParent_Done,
     /* 54639 */ // Label 1352: @54639
     /* 54639 */ GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(54737), // Rule ID 2239 //
     /* 54644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54660 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54664 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54668 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54672 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54676 */   // MIs[1] Operand 1
     /* 54676 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 54681 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54686 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54695 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54699 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54701 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54713 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54717 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54728 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54733 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54735 */   GIR_RootConstrainSelectedInstOperands,
     /* 54736 */   // GIR_Coverage, 2239,
     /* 54736 */   GIR_EraseRootFromParent_Done,
     /* 54737 */ // Label 1353: @54737
     /* 54737 */ GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(54835), // Rule ID 2242 //
     /* 54742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54766 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54770 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54774 */   // MIs[1] Operand 1
     /* 54774 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 54779 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54784 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54793 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54797 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54799 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54811 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54815 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54826 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54828 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54831 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54833 */   GIR_RootConstrainSelectedInstOperands,
     /* 54834 */   // GIR_Coverage, 2242,
     /* 54834 */   GIR_EraseRootFromParent_Done,
     /* 54835 */ // Label 1354: @54835
     /* 54835 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(54933), // Rule ID 2245 //
     /* 54840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54864 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54868 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54872 */   // MIs[1] Operand 1
     /* 54872 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 54877 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54882 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54891 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54897 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54909 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54913 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 54922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54924 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54929 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54931 */   GIR_RootConstrainSelectedInstOperands,
     /* 54932 */   // GIR_Coverage, 2245,
     /* 54932 */   GIR_EraseRootFromParent_Done,
     /* 54933 */ // Label 1355: @54933
     /* 54933 */ GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(55031), // Rule ID 2268 //
     /* 54938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 54954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54962 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54966 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54970 */   // MIs[1] Operand 1
     /* 54970 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 54975 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54980 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 54989 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 54993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54995 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 54995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 55002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55007 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55011 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55022 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55027 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55029 */   GIR_RootConstrainSelectedInstOperands,
     /* 55030 */   // GIR_Coverage, 2268,
     /* 55030 */   GIR_EraseRootFromParent_Done,
     /* 55031 */ // Label 1356: @55031
     /* 55031 */ GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(55129), // Rule ID 2269 //
     /* 55036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55045 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55052 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55056 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55060 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55064 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55068 */   // MIs[1] Operand 1
     /* 55068 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 55073 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55078 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55087 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55091 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55093 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 55100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55105 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55109 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55120 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55125 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55127 */   GIR_RootConstrainSelectedInstOperands,
     /* 55128 */   // GIR_Coverage, 2269,
     /* 55128 */   GIR_EraseRootFromParent_Done,
     /* 55129 */ // Label 1357: @55129
     /* 55129 */ GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(55227), // Rule ID 2272 //
     /* 55134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55162 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55166 */   // MIs[1] Operand 1
     /* 55166 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 55171 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55176 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55185 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55191 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 55191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 55198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55218 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55223 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55225 */   GIR_RootConstrainSelectedInstOperands,
     /* 55226 */   // GIR_Coverage, 2272,
     /* 55226 */   GIR_EraseRootFromParent_Done,
     /* 55227 */ // Label 1358: @55227
     /* 55227 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(55325), // Rule ID 2273 //
     /* 55232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55241 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55256 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55260 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55264 */   // MIs[1] Operand 1
     /* 55264 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 55269 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55274 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55283 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55287 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55289 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 55289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 55296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55301 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55316 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55321 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55323 */   GIR_RootConstrainSelectedInstOperands,
     /* 55324 */   // GIR_Coverage, 2273,
     /* 55324 */   GIR_EraseRootFromParent_Done,
     /* 55325 */ // Label 1359: @55325
     /* 55325 */ GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(55423), // Rule ID 2276 //
     /* 55330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55339 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55354 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55358 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55362 */   // MIs[1] Operand 1
     /* 55362 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 55367 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55372 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55381 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55387 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 55394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55399 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55403 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55414 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55419 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55421 */   GIR_RootConstrainSelectedInstOperands,
     /* 55422 */   // GIR_Coverage, 2276,
     /* 55422 */   GIR_EraseRootFromParent_Done,
     /* 55423 */ // Label 1360: @55423
     /* 55423 */ GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(55521), // Rule ID 2278 //
     /* 55428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55444 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55448 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55452 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55456 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55460 */   // MIs[1] Operand 1
     /* 55460 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 55465 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55470 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55479 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55483 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55485 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 55492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55497 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55501 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 55510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55512 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55517 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55519 */   GIR_RootConstrainSelectedInstOperands,
     /* 55520 */   // GIR_Coverage, 2278,
     /* 55520 */   GIR_EraseRootFromParent_Done,
     /* 55521 */ // Label 1361: @55521
     /* 55521 */ GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(55561), // Rule ID 295 //
     /* 55526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 55529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55535 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55550 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55554 */   // (select:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$cond, GPR32Opnd:{ *:[i32] }:$T, GPR32Opnd:{ *:[i32] }:$F)  =>  (PseudoSELECT_I:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$cond, GPR32Opnd:{ *:[i32] }:$T, GPR32Opnd:{ *:[i32] }:$F)
     /* 55554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_I),
     /* 55559 */   GIR_RootConstrainSelectedInstOperands,
     /* 55560 */   // GIR_Coverage, 295,
     /* 55560 */   GIR_Done,
     /* 55561 */ // Label 1362: @55561
     /* 55561 */ GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(55601), // Rule ID 297 //
     /* 55566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 55569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55575 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55590 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55594 */   // (select:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$cond, FGR32Opnd:{ *:[f32] }:$T, FGR32Opnd:{ *:[f32] }:$F)  =>  (PseudoSELECT_S:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$cond, FGR32Opnd:{ *:[f32] }:$T, FGR32Opnd:{ *:[f32] }:$F)
     /* 55594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_S),
     /* 55599 */   GIR_RootConstrainSelectedInstOperands,
     /* 55600 */   // GIR_Coverage, 297,
     /* 55600 */   GIR_Done,
     /* 55601 */ // Label 1363: @55601
     /* 55601 */ GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(55647), // Rule ID 334 //
     /* 55606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 55609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55615 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 55626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55630 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55634 */   // (select:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)  =>  (SEL_S:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 55634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEL_S),
     /* 55637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55639 */   GIR_RootToRootCopy, /*OpIdx*/1, // fd_in
     /* 55641 */   GIR_RootToRootCopy, /*OpIdx*/3, // fs
     /* 55643 */   GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 55645 */   GIR_RootConstrainSelectedInstOperands,
     /* 55646 */   // GIR_Coverage, 334,
     /* 55646 */   GIR_EraseRootFromParent_Done,
     /* 55647 */ // Label 1364: @55647
     /* 55647 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(55693), // Rule ID 1213 //
     /* 55652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 55655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55661 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 55672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55676 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55680 */   // (select:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)  =>  (SEL_S_MMR6:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 55680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEL_S_MMR6),
     /* 55683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55685 */   GIR_RootToRootCopy, /*OpIdx*/1, // fd_in
     /* 55687 */   GIR_RootToRootCopy, /*OpIdx*/3, // fs
     /* 55689 */   GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 55691 */   GIR_RootConstrainSelectedInstOperands,
     /* 55692 */   // GIR_Coverage, 1213,
     /* 55692 */   GIR_EraseRootFromParent_Done,
     /* 55693 */ // Label 1365: @55693
     /* 55693 */ GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(55739), // Rule ID 1646 //
     /* 55698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55722 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55726 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 55729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55731 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55733 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55735 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55737 */   GIR_RootConstrainSelectedInstOperands,
     /* 55738 */   // GIR_Coverage, 1646,
     /* 55738 */   GIR_EraseRootFromParent_Done,
     /* 55739 */ // Label 1366: @55739
     /* 55739 */ GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(55785), // Rule ID 1685 //
     /* 55744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 55750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 55764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55768 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55772 */   // (select:{ *:[i32] } GPR64:{ *:[i64] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 55775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55777 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55779 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55781 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55783 */   GIR_RootConstrainSelectedInstOperands,
     /* 55784 */   // GIR_Coverage, 1685,
     /* 55784 */   GIR_EraseRootFromParent_Done,
     /* 55785 */ // Label 1367: @55785
     /* 55785 */ GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(55831), // Rule ID 1701 //
     /* 55790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55799 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55814 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55818 */   // (select:{ *:[f32] } GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 55818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 55821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55823 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55825 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55827 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55829 */   GIR_RootConstrainSelectedInstOperands,
     /* 55830 */   // GIR_Coverage, 1701,
     /* 55830 */   GIR_EraseRootFromParent_Done,
     /* 55831 */ // Label 1368: @55831
     /* 55831 */ GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(55877), // Rule ID 1714 //
     /* 55836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 55842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55845 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 55856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55860 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55864 */   // (select:{ *:[f32] } GPR64:{ *:[i64] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 55864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 55867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55869 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55871 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55873 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55875 */   GIR_RootConstrainSelectedInstOperands,
     /* 55876 */   // GIR_Coverage, 1714,
     /* 55876 */   GIR_EraseRootFromParent_Done,
     /* 55877 */ // Label 1369: @55877
     /* 55877 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(55923), // Rule ID 1884 //
     /* 55882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 55885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55891 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55906 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55910 */   // (select:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBneZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 55910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBneZ),
     /* 55913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 55915 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 55917 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 55919 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 55921 */   GIR_RootConstrainSelectedInstOperands,
     /* 55922 */   // GIR_Coverage, 1884,
     /* 55922 */   GIR_EraseRootFromParent_Done,
     /* 55923 */ // Label 1370: @55923
     /* 55923 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(55969), // Rule ID 2232 //
     /* 55928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 55931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55952 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55956 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 55959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55961 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55963 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55965 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55967 */   GIR_RootConstrainSelectedInstOperands,
     /* 55968 */   // GIR_Coverage, 2232,
     /* 55968 */   GIR_EraseRootFromParent_Done,
     /* 55969 */ // Label 1371: @55969
     /* 55969 */ GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(56015), // Rule ID 2246 //
     /* 55974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55983 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55998 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56002 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 56002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 56005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56007 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56009 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 56011 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56013 */   GIR_RootConstrainSelectedInstOperands,
     /* 56014 */   // GIR_Coverage, 2246,
     /* 56014 */   GIR_EraseRootFromParent_Done,
     /* 56015 */ // Label 1372: @56015
     /* 56015 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(56061), // Rule ID 2279 //
     /* 56020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 56023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56044 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56048 */   // (select:{ *:[f32] } GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 56048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 56051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56053 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56055 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 56057 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56059 */   GIR_RootConstrainSelectedInstOperands,
     /* 56060 */   // GIR_Coverage, 2279,
     /* 56060 */   GIR_EraseRootFromParent_Done,
     /* 56061 */ // Label 1373: @56061
     /* 56061 */ GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(56139), // Rule ID 1783 //
     /* 56066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 56069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56082 */   // (select:{ *:[i32] } i32:{ *:[i32] }:$cond, i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$f)  =>  (OR:{ *:[i32] } (SELNEZ:{ *:[i32] } i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$cond), (SELEQZ:{ *:[i32] } i32:{ *:[i32] }:$f, i32:{ *:[i32] }:$cond))
     /* 56082 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 56085 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ),
     /* 56089 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56094 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 56098 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 56104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 56107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ),
     /* 56111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56116 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 56120 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR),
     /* 56129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 56134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 56137 */   GIR_RootConstrainSelectedInstOperands,
     /* 56138 */   // GIR_Coverage, 1783,
     /* 56138 */   GIR_EraseRootFromParent_Done,
     /* 56139 */ // Label 1374: @56139
     /* 56139 */ GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(56217), // Rule ID 2296 //
     /* 56144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 56147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56153 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56160 */   // (select:{ *:[i32] } i32:{ *:[i32] }:$cond, i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$f)  =>  (OR_MM:{ *:[i32] } (SELNEZ_MMR6:{ *:[i32] } i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$cond), (SELEQZ_MMR6:{ *:[i32] } i32:{ *:[i32] }:$f, i32:{ *:[i32] }:$cond))
     /* 56160 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 56163 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ_MMR6),
     /* 56167 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56172 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 56176 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 56182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 56185 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ_MMR6),
     /* 56189 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56194 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 56198 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR_MM),
     /* 56207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 56212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 56215 */   GIR_RootConstrainSelectedInstOperands,
     /* 56216 */   // GIR_Coverage, 2296,
     /* 56216 */   GIR_EraseRootFromParent_Done,
     /* 56217 */ // Label 1375: @56217
     /* 56217 */ GIM_Reject,
     /* 56218 */ // Label 1290: @56218
     /* 56218 */ GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(56294), // Rule ID 1673 //
     /* 56223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56232 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56247 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56251 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56255 */   // MIs[1] Operand 1
     /* 56255 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56260 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56265 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56273 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56279 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 56282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56284 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56286 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56290 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56292 */   GIR_RootConstrainSelectedInstOperands,
     /* 56293 */   // GIR_Coverage, 1673,
     /* 56293 */   GIR_EraseRootFromParent_Done,
     /* 56294 */ // Label 1376: @56294
     /* 56294 */ GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(56370), // Rule ID 1677 //
     /* 56299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56308 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56315 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56319 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56323 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56327 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56331 */   // MIs[1] Operand 1
     /* 56331 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56336 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56341 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56349 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56353 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56355 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I64),
     /* 56358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56360 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56362 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56366 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56368 */   GIR_RootConstrainSelectedInstOperands,
     /* 56369 */   // GIR_Coverage, 1677,
     /* 56369 */   GIR_EraseRootFromParent_Done,
     /* 56370 */ // Label 1377: @56370
     /* 56370 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(56446), // Rule ID 1683 //
     /* 56375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56384 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56391 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56395 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56399 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56403 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56407 */   // MIs[1] Operand 1
     /* 56407 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56412 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56417 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56425 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56429 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56431 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 56434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56436 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56438 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56442 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56444 */   GIR_RootConstrainSelectedInstOperands,
     /* 56445 */   // GIR_Coverage, 1683,
     /* 56445 */   GIR_EraseRootFromParent_Done,
     /* 56446 */ // Label 1378: @56446
     /* 56446 */ GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(56522), // Rule ID 1689 //
     /* 56451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56460 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56479 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56483 */   // MIs[1] Operand 1
     /* 56483 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56488 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56493 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56497 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56501 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56507 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 56510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56512 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56514 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56518 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56520 */   GIR_RootConstrainSelectedInstOperands,
     /* 56521 */   // GIR_Coverage, 1689,
     /* 56521 */   GIR_EraseRootFromParent_Done,
     /* 56522 */ // Label 1379: @56522
     /* 56522 */ GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(56598), // Rule ID 1725 //
     /* 56527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56551 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56555 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56559 */   // MIs[1] Operand 1
     /* 56559 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56564 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56569 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56577 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56581 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56583 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 56583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 56586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56588 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56590 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56594 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56596 */   GIR_RootConstrainSelectedInstOperands,
     /* 56597 */   // GIR_Coverage, 1725,
     /* 56597 */   GIR_EraseRootFromParent_Done,
     /* 56598 */ // Label 1380: @56598
     /* 56598 */ GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(56674), // Rule ID 1728 //
     /* 56603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56612 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56627 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56631 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56635 */   // MIs[1] Operand 1
     /* 56635 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56640 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56645 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56653 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56657 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56659 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 56659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 56662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56664 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56666 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56670 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56672 */   GIR_RootConstrainSelectedInstOperands,
     /* 56673 */   // GIR_Coverage, 1728,
     /* 56673 */   GIR_EraseRootFromParent_Done,
     /* 56674 */ // Label 1381: @56674
     /* 56674 */ GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(56750), // Rule ID 1746 //
     /* 56679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56695 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56699 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56703 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56707 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56711 */   // MIs[1] Operand 1
     /* 56711 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56716 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56721 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56729 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56735 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 56738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56740 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56742 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56746 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56748 */   GIR_RootConstrainSelectedInstOperands,
     /* 56749 */   // GIR_Coverage, 1746,
     /* 56749 */   GIR_EraseRootFromParent_Done,
     /* 56750 */ // Label 1382: @56750
     /* 56750 */ GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(56826), // Rule ID 1748 //
     /* 56755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56764 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56771 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56779 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56783 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56787 */   // MIs[1] Operand 1
     /* 56787 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56792 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56797 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56805 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56811 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_D64),
     /* 56814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56816 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56818 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56822 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56824 */   GIR_RootConstrainSelectedInstOperands,
     /* 56825 */   // GIR_Coverage, 1748,
     /* 56825 */   GIR_EraseRootFromParent_Done,
     /* 56826 */ // Label 1383: @56826
     /* 56826 */ GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(56902), // Rule ID 1751 //
     /* 56831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56855 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56859 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56863 */   // MIs[1] Operand 1
     /* 56863 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56868 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56873 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56881 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56885 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56887 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 56890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56892 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56894 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56898 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56900 */   GIR_RootConstrainSelectedInstOperands,
     /* 56901 */   // GIR_Coverage, 1751,
     /* 56901 */   GIR_EraseRootFromParent_Done,
     /* 56902 */ // Label 1384: @56902
     /* 56902 */ GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(56978), // Rule ID 1754 //
     /* 56907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56916 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56923 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56931 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56935 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56939 */   // MIs[1] Operand 1
     /* 56939 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56944 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56949 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56957 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56961 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56963 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 56966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56968 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56970 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56974 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56976 */   GIR_RootConstrainSelectedInstOperands,
     /* 56977 */   // GIR_Coverage, 1754,
     /* 56977 */   GIR_EraseRootFromParent_Done,
     /* 56978 */ // Label 1385: @56978
     /* 56978 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(57054), // Rule ID 2290 //
     /* 56983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 56986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56999 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57007 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57011 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57015 */   // MIs[1] Operand 1
     /* 57015 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 57020 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57025 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 57029 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57033 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57037 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57039 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 57039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 57042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 57044 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57046 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57050 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57052 */   GIR_RootConstrainSelectedInstOperands,
     /* 57053 */   // GIR_Coverage, 2290,
     /* 57053 */   GIR_EraseRootFromParent_Done,
     /* 57054 */ // Label 1386: @57054
     /* 57054 */ GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(57130), // Rule ID 2293 //
     /* 57059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 57062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57083 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57087 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57091 */   // MIs[1] Operand 1
     /* 57091 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 57096 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57101 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 57105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57109 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57113 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57115 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 57115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 57118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 57120 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57122 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57126 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57128 */   GIR_RootConstrainSelectedInstOperands,
     /* 57129 */   // GIR_Coverage, 2293,
     /* 57129 */   GIR_EraseRootFromParent_Done,
     /* 57130 */ // Label 1387: @57130
     /* 57130 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(57228), // Rule ID 1648 //
     /* 57135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57144 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57159 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57163 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57167 */   // MIs[1] Operand 1
     /* 57167 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 57172 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57177 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57186 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57190 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57192 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 57199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57204 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57208 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57219 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57221 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57224 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57226 */   GIR_RootConstrainSelectedInstOperands,
     /* 57227 */   // GIR_Coverage, 1648,
     /* 57227 */   GIR_EraseRootFromParent_Done,
     /* 57228 */ // Label 1388: @57228
     /* 57228 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(57326), // Rule ID 1649 //
     /* 57233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57249 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57253 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57257 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57261 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57265 */   // MIs[1] Operand 1
     /* 57265 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 57270 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57275 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57284 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57288 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57290 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 57297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57302 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57306 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57317 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57322 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57324 */   GIR_RootConstrainSelectedInstOperands,
     /* 57325 */   // GIR_Coverage, 1649,
     /* 57325 */   GIR_EraseRootFromParent_Done,
     /* 57326 */ // Label 1389: @57326
     /* 57326 */ GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(57424), // Rule ID 1652 //
     /* 57331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57340 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57355 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57359 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57363 */   // MIs[1] Operand 1
     /* 57363 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 57368 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57373 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57382 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57386 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57388 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 57395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57400 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57404 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57415 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57420 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57422 */   GIR_RootConstrainSelectedInstOperands,
     /* 57423 */   // GIR_Coverage, 1652,
     /* 57423 */   GIR_EraseRootFromParent_Done,
     /* 57424 */ // Label 1390: @57424
     /* 57424 */ GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(57522), // Rule ID 1653 //
     /* 57429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57445 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57449 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57453 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57457 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57461 */   // MIs[1] Operand 1
     /* 57461 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 57466 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57471 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57480 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57486 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 57493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57498 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57502 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57513 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57518 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57520 */   GIR_RootConstrainSelectedInstOperands,
     /* 57521 */   // GIR_Coverage, 1653,
     /* 57521 */   GIR_EraseRootFromParent_Done,
     /* 57522 */ // Label 1391: @57522
     /* 57522 */ GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(57620), // Rule ID 1664 //
     /* 57527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57551 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57555 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57559 */   // MIs[1] Operand 1
     /* 57559 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 57564 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57569 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57578 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57582 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57584 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 57591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57596 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57600 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57611 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57616 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57618 */   GIR_RootConstrainSelectedInstOperands,
     /* 57619 */   // GIR_Coverage, 1664,
     /* 57619 */   GIR_EraseRootFromParent_Done,
     /* 57620 */ // Label 1392: @57620
     /* 57620 */ GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(57718), // Rule ID 1665 //
     /* 57625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57634 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57641 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57649 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57653 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57657 */   // MIs[1] Operand 1
     /* 57657 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 57662 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57667 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57676 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57680 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57682 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 57689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57694 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57698 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57709 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57711 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57714 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57716 */   GIR_RootConstrainSelectedInstOperands,
     /* 57717 */   // GIR_Coverage, 1665,
     /* 57717 */   GIR_EraseRootFromParent_Done,
     /* 57718 */ // Label 1393: @57718
     /* 57718 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(57816), // Rule ID 1668 //
     /* 57723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57732 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57739 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57747 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57751 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57755 */   // MIs[1] Operand 1
     /* 57755 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 57760 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57765 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57774 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57778 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57780 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 57787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57792 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57796 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57807 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57812 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57814 */   GIR_RootConstrainSelectedInstOperands,
     /* 57815 */   // GIR_Coverage, 1668,
     /* 57815 */   GIR_EraseRootFromParent_Done,
     /* 57816 */ // Label 1394: @57816
     /* 57816 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(57914), // Rule ID 1669 //
     /* 57821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57830 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57845 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57849 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57853 */   // MIs[1] Operand 1
     /* 57853 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 57858 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57863 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57872 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57876 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57878 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 57885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57890 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57894 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57905 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57910 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57912 */   GIR_RootConstrainSelectedInstOperands,
     /* 57913 */   // GIR_Coverage, 1669,
     /* 57913 */   GIR_EraseRootFromParent_Done,
     /* 57914 */ // Label 1395: @57914
     /* 57914 */ GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(58012), // Rule ID 1672 //
     /* 57919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57943 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57947 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57951 */   // MIs[1] Operand 1
     /* 57951 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 57956 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57961 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57970 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57974 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57976 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 57983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57988 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57992 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 58001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58003 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58005 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58008 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58010 */   GIR_RootConstrainSelectedInstOperands,
     /* 58011 */   // GIR_Coverage, 1672,
     /* 58011 */   GIR_EraseRootFromParent_Done,
     /* 58012 */ // Label 1396: @58012
     /* 58012 */ GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(58110), // Rule ID 1676 //
     /* 58017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58026 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58033 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58037 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58041 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 58045 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 58049 */   // MIs[1] Operand 1
     /* 58049 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 58054 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58059 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58068 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58072 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58074 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 58077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 58081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58086 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58090 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I64),
     /* 58099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58101 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58103 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58106 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58108 */   GIR_RootConstrainSelectedInstOperands,
     /* 58109 */   // GIR_Coverage, 1676,
     /* 58109 */   GIR_EraseRootFromParent_Done,
     /* 58110 */ // Label 1397: @58110
     /* 58110 */ GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(58208), // Rule ID 1681 //
     /* 58115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58124 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58131 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58139 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58143 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58147 */   // MIs[1] Operand 1
     /* 58147 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58152 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58166 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58172 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58184 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58188 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 58197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58199 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58204 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58206 */   GIR_RootConstrainSelectedInstOperands,
     /* 58207 */   // GIR_Coverage, 1681,
     /* 58207 */   GIR_EraseRootFromParent_Done,
     /* 58208 */ // Label 1398: @58208
     /* 58208 */ GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(58306), // Rule ID 1687 //
     /* 58213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58222 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58229 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58233 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58237 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 58241 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 58245 */   // MIs[1] Operand 1
     /* 58245 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58250 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58255 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58264 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58268 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58270 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 58273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 58277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58282 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58286 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 58295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58297 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58302 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58304 */   GIR_RootConstrainSelectedInstOperands,
     /* 58305 */   // GIR_Coverage, 1687,
     /* 58305 */   GIR_EraseRootFromParent_Done,
     /* 58306 */ // Label 1399: @58306
     /* 58306 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(58404), // Rule ID 1716 //
     /* 58311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58327 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58331 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58335 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58339 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58343 */   // MIs[1] Operand 1
     /* 58343 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 58348 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58353 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58362 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58366 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58368 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58380 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58384 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58395 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58400 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58402 */   GIR_RootConstrainSelectedInstOperands,
     /* 58403 */   // GIR_Coverage, 1716,
     /* 58403 */   GIR_EraseRootFromParent_Done,
     /* 58404 */ // Label 1400: @58404
     /* 58404 */ GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(58502), // Rule ID 1717 //
     /* 58409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58418 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58425 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58429 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58433 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58437 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58441 */   // MIs[1] Operand 1
     /* 58441 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 58446 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58451 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58460 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58464 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58466 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 58473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58478 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58482 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58493 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58498 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58500 */   GIR_RootConstrainSelectedInstOperands,
     /* 58501 */   // GIR_Coverage, 1717,
     /* 58501 */   GIR_EraseRootFromParent_Done,
     /* 58502 */ // Label 1401: @58502
     /* 58502 */ GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(58600), // Rule ID 1720 //
     /* 58507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58516 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58523 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58527 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58531 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58535 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58539 */   // MIs[1] Operand 1
     /* 58539 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 58544 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58554 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58558 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58562 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58564 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 58564 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58567 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58571 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58576 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58580 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58591 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58596 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58598 */   GIR_RootConstrainSelectedInstOperands,
     /* 58599 */   // GIR_Coverage, 1720,
     /* 58599 */   GIR_EraseRootFromParent_Done,
     /* 58600 */ // Label 1402: @58600
     /* 58600 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(58698), // Rule ID 1721 //
     /* 58605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58614 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58629 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58633 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58637 */   // MIs[1] Operand 1
     /* 58637 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 58642 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58647 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58656 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58662 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 58662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 58669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58674 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58678 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58689 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58694 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58696 */   GIR_RootConstrainSelectedInstOperands,
     /* 58697 */   // GIR_Coverage, 1721,
     /* 58697 */   GIR_EraseRootFromParent_Done,
     /* 58698 */ // Label 1403: @58698
     /* 58698 */ GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(58796), // Rule ID 1724 //
     /* 58703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58712 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58719 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58727 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58731 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58735 */   // MIs[1] Operand 1
     /* 58735 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 58740 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58745 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58754 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58758 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58760 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58772 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58776 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58787 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58792 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58794 */   GIR_RootConstrainSelectedInstOperands,
     /* 58795 */   // GIR_Coverage, 1724,
     /* 58795 */   GIR_EraseRootFromParent_Done,
     /* 58796 */ // Label 1404: @58796
     /* 58796 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(58894), // Rule ID 1726 //
     /* 58801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58810 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58817 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58821 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58825 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58829 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58833 */   // MIs[1] Operand 1
     /* 58833 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58838 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58843 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58852 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58856 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58858 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58870 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58874 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 58883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58885 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58890 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58892 */   GIR_RootConstrainSelectedInstOperands,
     /* 58893 */   // GIR_Coverage, 1726,
     /* 58893 */   GIR_EraseRootFromParent_Done,
     /* 58894 */ // Label 1405: @58894
     /* 58894 */ GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(58992), // Rule ID 1729 //
     /* 58899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58923 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58927 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58931 */   // MIs[1] Operand 1
     /* 58931 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 58936 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58941 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58950 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58954 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58956 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 58956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58968 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58972 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 58981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58983 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58988 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58990 */   GIR_RootConstrainSelectedInstOperands,
     /* 58991 */   // GIR_Coverage, 1729,
     /* 58991 */   GIR_EraseRootFromParent_Done,
     /* 58992 */ // Label 1406: @58992
     /* 58992 */ GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(59090), // Rule ID 1730 //
     /* 58997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59006 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59013 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59021 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59025 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59029 */   // MIs[1] Operand 1
     /* 59029 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 59034 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59039 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59052 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59054 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 59061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59066 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59070 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59081 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59086 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59088 */   GIR_RootConstrainSelectedInstOperands,
     /* 59089 */   // GIR_Coverage, 1730,
     /* 59089 */   GIR_EraseRootFromParent_Done,
     /* 59090 */ // Label 1407: @59090
     /* 59090 */ GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(59188), // Rule ID 1733 //
     /* 59095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59111 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59119 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59123 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59127 */   // MIs[1] Operand 1
     /* 59127 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 59132 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59137 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59150 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59152 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 59159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59164 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59168 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59179 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59181 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59184 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59186 */   GIR_RootConstrainSelectedInstOperands,
     /* 59187 */   // GIR_Coverage, 1733,
     /* 59187 */   GIR_EraseRootFromParent_Done,
     /* 59188 */ // Label 1408: @59188
     /* 59188 */ GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(59286), // Rule ID 1734 //
     /* 59193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59209 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59213 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59217 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59221 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59225 */   // MIs[1] Operand 1
     /* 59225 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 59230 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59235 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59244 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59248 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59250 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 59257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59262 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59266 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59277 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59282 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59284 */   GIR_RootConstrainSelectedInstOperands,
     /* 59285 */   // GIR_Coverage, 1734,
     /* 59285 */   GIR_EraseRootFromParent_Done,
     /* 59286 */ // Label 1409: @59286
     /* 59286 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(59384), // Rule ID 1737 //
     /* 59291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59300 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59307 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59311 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59315 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59319 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59323 */   // MIs[1] Operand 1
     /* 59323 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 59328 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59333 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59342 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59346 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59348 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 59355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59360 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59364 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59375 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59380 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59382 */   GIR_RootConstrainSelectedInstOperands,
     /* 59383 */   // GIR_Coverage, 1737,
     /* 59383 */   GIR_EraseRootFromParent_Done,
     /* 59384 */ // Label 1410: @59384
     /* 59384 */ GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(59482), // Rule ID 1738 //
     /* 59389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59398 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59405 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59413 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59417 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59421 */   // MIs[1] Operand 1
     /* 59421 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 59426 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59431 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59440 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59444 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59446 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 59453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59458 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59462 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59473 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59478 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59480 */   GIR_RootConstrainSelectedInstOperands,
     /* 59481 */   // GIR_Coverage, 1738,
     /* 59481 */   GIR_EraseRootFromParent_Done,
     /* 59482 */ // Label 1411: @59482
     /* 59482 */ GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(59580), // Rule ID 1741 //
     /* 59487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59503 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59511 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59515 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59519 */   // MIs[1] Operand 1
     /* 59519 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 59524 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59529 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59538 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59542 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59544 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 59551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59556 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59560 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59571 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59576 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59578 */   GIR_RootConstrainSelectedInstOperands,
     /* 59579 */   // GIR_Coverage, 1741,
     /* 59579 */   GIR_EraseRootFromParent_Done,
     /* 59580 */ // Label 1412: @59580
     /* 59580 */ GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(59678), // Rule ID 1742 //
     /* 59585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59594 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59609 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59613 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59617 */   // MIs[1] Operand 1
     /* 59617 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 59622 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59627 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59636 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59640 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59642 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59642 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59645 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 59649 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59654 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59658 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59669 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59674 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59676 */   GIR_RootConstrainSelectedInstOperands,
     /* 59677 */   // GIR_Coverage, 1742,
     /* 59677 */   GIR_EraseRootFromParent_Done,
     /* 59678 */ // Label 1413: @59678
     /* 59678 */ GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(59776), // Rule ID 1745 //
     /* 59683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59699 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59703 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59707 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59711 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59715 */   // MIs[1] Operand 1
     /* 59715 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 59720 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59725 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59734 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59738 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59740 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 59747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59752 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59756 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59767 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59772 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59774 */   GIR_RootConstrainSelectedInstOperands,
     /* 59775 */   // GIR_Coverage, 1745,
     /* 59775 */   GIR_EraseRootFromParent_Done,
     /* 59776 */ // Label 1414: @59776
     /* 59776 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(59874), // Rule ID 1747 //
     /* 59781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59790 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59805 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59809 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59813 */   // MIs[1] Operand 1
     /* 59813 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 59818 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59823 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59832 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59838 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 59841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 59845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59850 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59854 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_D64),
     /* 59863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59865 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59870 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59872 */   GIR_RootConstrainSelectedInstOperands,
     /* 59873 */   // GIR_Coverage, 1747,
     /* 59873 */   GIR_EraseRootFromParent_Done,
     /* 59874 */ // Label 1415: @59874
     /* 59874 */ GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(59972), // Rule ID 1749 //
     /* 59879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59895 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59899 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59903 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59907 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59911 */   // MIs[1] Operand 1
     /* 59911 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 59916 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59921 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59930 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59934 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59936 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 59943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59948 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59952 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 59961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59963 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59968 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59970 */   GIR_RootConstrainSelectedInstOperands,
     /* 59971 */   // GIR_Coverage, 1749,
     /* 59971 */   GIR_EraseRootFromParent_Done,
     /* 59972 */ // Label 1416: @59972
     /* 59972 */ GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(60070), // Rule ID 1752 //
     /* 59977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59993 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59997 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60001 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 60005 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 60009 */   // MIs[1] Operand 1
     /* 60009 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 60014 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60019 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60028 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60032 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60034 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 60034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 60037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 60041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60046 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60050 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 60059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60061 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60066 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60068 */   GIR_RootConstrainSelectedInstOperands,
     /* 60069 */   // GIR_Coverage, 1752,
     /* 60069 */   GIR_EraseRootFromParent_Done,
     /* 60070 */ // Label 1417: @60070
     /* 60070 */ GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(60168), // Rule ID 2281 //
     /* 60075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60084 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60099 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60103 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60107 */   // MIs[1] Operand 1
     /* 60107 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 60112 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60117 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60126 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60130 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60132 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 60139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60144 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60148 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60159 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60161 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60164 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60166 */   GIR_RootConstrainSelectedInstOperands,
     /* 60167 */   // GIR_Coverage, 2281,
     /* 60167 */   GIR_EraseRootFromParent_Done,
     /* 60168 */ // Label 1418: @60168
     /* 60168 */ GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(60266), // Rule ID 2282 //
     /* 60173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60182 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60189 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60197 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60201 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60205 */   // MIs[1] Operand 1
     /* 60205 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 60210 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60215 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60224 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60228 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60230 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 60237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60242 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60246 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60257 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60262 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60264 */   GIR_RootConstrainSelectedInstOperands,
     /* 60265 */   // GIR_Coverage, 2282,
     /* 60265 */   GIR_EraseRootFromParent_Done,
     /* 60266 */ // Label 1419: @60266
     /* 60266 */ GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(60364), // Rule ID 2285 //
     /* 60271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60280 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60287 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60291 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60295 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60299 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60303 */   // MIs[1] Operand 1
     /* 60303 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 60308 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60313 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60322 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60326 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60328 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 60328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 60335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60340 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60344 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60355 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60357 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60360 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60362 */   GIR_RootConstrainSelectedInstOperands,
     /* 60363 */   // GIR_Coverage, 2285,
     /* 60363 */   GIR_EraseRootFromParent_Done,
     /* 60364 */ // Label 1420: @60364
     /* 60364 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(60462), // Rule ID 2286 //
     /* 60369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60385 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60389 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60393 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60397 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60401 */   // MIs[1] Operand 1
     /* 60401 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 60406 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60411 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60426 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 60426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 60433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60438 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60442 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60453 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60458 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60460 */   GIR_RootConstrainSelectedInstOperands,
     /* 60461 */   // GIR_Coverage, 2286,
     /* 60461 */   GIR_EraseRootFromParent_Done,
     /* 60462 */ // Label 1421: @60462
     /* 60462 */ GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(60560), // Rule ID 2289 //
     /* 60467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60483 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60487 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60491 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60495 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60499 */   // MIs[1] Operand 1
     /* 60499 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 60504 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60509 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60518 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60522 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60524 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 60531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60536 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60540 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60551 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60556 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60558 */   GIR_RootConstrainSelectedInstOperands,
     /* 60559 */   // GIR_Coverage, 2289,
     /* 60559 */   GIR_EraseRootFromParent_Done,
     /* 60560 */ // Label 1422: @60560
     /* 60560 */ GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(60658), // Rule ID 2291 //
     /* 60565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60574 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60589 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60593 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60597 */   // MIs[1] Operand 1
     /* 60597 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 60602 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60607 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60616 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60622 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 60629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60634 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60638 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 60647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60649 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60651 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60654 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60656 */   GIR_RootConstrainSelectedInstOperands,
     /* 60657 */   // GIR_Coverage, 2291,
     /* 60657 */   GIR_EraseRootFromParent_Done,
     /* 60658 */ // Label 1423: @60658
     /* 60658 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(60698), // Rule ID 296 //
     /* 60663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 60666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60687 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60691 */   // (select:{ *:[i64] } GPR32Opnd:{ *:[i32] }:$cond, GPR64Opnd:{ *:[i64] }:$T, GPR64Opnd:{ *:[i64] }:$F)  =>  (PseudoSELECT_I64:{ *:[i64] } GPR32Opnd:{ *:[i32] }:$cond, GPR64Opnd:{ *:[i64] }:$T, GPR64Opnd:{ *:[i64] }:$F)
     /* 60691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_I64),
     /* 60696 */   GIR_RootConstrainSelectedInstOperands,
     /* 60697 */   // GIR_Coverage, 296,
     /* 60697 */   GIR_Done,
     /* 60698 */ // Label 1424: @60698
     /* 60698 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(60738), // Rule ID 298 //
     /* 60703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotMips4_32),
     /* 60706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60712 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60727 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60731 */   // (select:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, AFGR64Opnd:{ *:[f64] }:$T, AFGR64Opnd:{ *:[f64] }:$F)  =>  (PseudoSELECT_D32:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, AFGR64Opnd:{ *:[f64] }:$T, AFGR64Opnd:{ *:[f64] }:$F)
     /* 60731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_D32),
     /* 60736 */   GIR_RootConstrainSelectedInstOperands,
     /* 60737 */   // GIR_Coverage, 298,
     /* 60737 */   GIR_Done,
     /* 60738 */ // Label 1425: @60738
     /* 60738 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(60778), // Rule ID 299 //
     /* 60743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotMips4_32),
     /* 60746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60752 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60763 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60767 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60771 */   // (select:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, FGR64Opnd:{ *:[f64] }:$T, FGR64Opnd:{ *:[f64] }:$F)  =>  (PseudoSELECT_D64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, FGR64Opnd:{ *:[f64] }:$T, FGR64Opnd:{ *:[f64] }:$F)
     /* 60771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_D64),
     /* 60776 */   GIR_RootConstrainSelectedInstOperands,
     /* 60777 */   // GIR_Coverage, 299,
     /* 60777 */   GIR_Done,
     /* 60778 */ // Label 1426: @60778
     /* 60778 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(60824), // Rule ID 1682 //
     /* 60783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60807 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60811 */   // (select:{ *:[i64] } GPR32:{ *:[i32] }:$cond, GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$cond, GPR64:{ *:[i64] }:$F)
     /* 60811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 60814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 60816 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60818 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60820 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60822 */   GIR_RootConstrainSelectedInstOperands,
     /* 60823 */   // GIR_Coverage, 1682,
     /* 60823 */   GIR_EraseRootFromParent_Done,
     /* 60824 */ // Label 1427: @60824
     /* 60824 */ GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(60870), // Rule ID 1688 //
     /* 60829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 60835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60838 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60853 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60857 */   // (select:{ *:[i64] } GPR64:{ *:[i64] }:$cond, GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$cond, GPR64:{ *:[i64] }:$F)
     /* 60857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 60860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 60862 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60864 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60866 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60868 */   GIR_RootConstrainSelectedInstOperands,
     /* 60869 */   // GIR_Coverage, 1688,
     /* 60869 */   GIR_EraseRootFromParent_Done,
     /* 60870 */ // Label 1428: @60870
     /* 60870 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(60916), // Rule ID 1727 //
     /* 60875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60899 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60903 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$F)
     /* 60903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 60906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60908 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60910 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60912 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60914 */   GIR_RootConstrainSelectedInstOperands,
     /* 60915 */   // GIR_Coverage, 1727,
     /* 60915 */   GIR_EraseRootFromParent_Done,
     /* 60916 */ // Label 1429: @60916
     /* 60916 */ GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(60962), // Rule ID 1750 //
     /* 60921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60930 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60945 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60949 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, FGR64:{ *:[f64] }:$F)
     /* 60949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 60952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60954 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60956 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60958 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60960 */   GIR_RootConstrainSelectedInstOperands,
     /* 60961 */   // GIR_Coverage, 1750,
     /* 60961 */   GIR_EraseRootFromParent_Done,
     /* 60962 */ // Label 1430: @60962
     /* 60962 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(61008), // Rule ID 1753 //
     /* 60967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 60973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60991 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60995 */   // (select:{ *:[f64] } GPR64:{ *:[i64] }:$cond, FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$cond, FGR64:{ *:[f64] }:$F)
     /* 60995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 60998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61000 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 61002 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 61004 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 61006 */   GIR_RootConstrainSelectedInstOperands,
     /* 61007 */   // GIR_Coverage, 1753,
     /* 61007 */   GIR_EraseRootFromParent_Done,
     /* 61008 */ // Label 1431: @61008
     /* 61008 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(61054), // Rule ID 2292 //
     /* 61013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 61016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61037 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61041 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$F)
     /* 61041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 61044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61046 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 61048 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 61050 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 61052 */   GIR_RootConstrainSelectedInstOperands,
     /* 61053 */   // GIR_Coverage, 2292,
     /* 61053 */   GIR_EraseRootFromParent_Done,
     /* 61054 */ // Label 1432: @61054
     /* 61054 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(61132), // Rule ID 1798 //
     /* 61059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 61062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61075 */   // (select:{ *:[i64] } i64:{ *:[i64] }:$cond, i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$f)  =>  (OR64:{ *:[i64] } (SELNEZ64:{ *:[i64] } i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$cond), (SELEQZ64:{ *:[i64] } i64:{ *:[i64] }:$f, i64:{ *:[i64] }:$cond))
     /* 61075 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 61078 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ64),
     /* 61082 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61087 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 61091 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 61097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 61100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ64),
     /* 61104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61109 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 61113 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 61119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /* 61122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 61124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 61127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 61130 */   GIR_RootConstrainSelectedInstOperands,
     /* 61131 */   // GIR_Coverage, 1798,
     /* 61131 */   GIR_EraseRootFromParent_Done,
     /* 61132 */ // Label 1433: @61132
     /* 61132 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(61244), // Rule ID 1809 //
     /* 61137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 61140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61146 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61153 */   // (select:{ *:[i64] } i32:{ *:[i32] }:$cond, i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$f)  =>  (OR64:{ *:[i64] } (SELNEZ64:{ *:[i64] } i64:{ *:[i64] }:$t, (SLL64_32:{ *:[i64] } i32:{ *:[i32] }:$cond)), (SELEQZ64:{ *:[i64] } i64:{ *:[i64] }:$f, (SLL64_32:{ *:[i64] } i32:{ *:[i32] }:$cond)))
     /* 61153 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 61156 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 61160 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61165 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 61171 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 61174 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SELEQZ64),
     /* 61178 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61183 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 61187 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 61190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 61192 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 61195 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 61199 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61204 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 61210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 61213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ64),
     /* 61217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61222 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 61226 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 61229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 61231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /* 61234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 61236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 61239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 61242 */   GIR_RootConstrainSelectedInstOperands,
     /* 61243 */   // GIR_Coverage, 1809,
     /* 61243 */   GIR_EraseRootFromParent_Done,
     /* 61244 */ // Label 1434: @61244
     /* 61244 */ GIM_Reject,
     /* 61245 */ // Label 1291: @61245
     /* 61245 */ GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(61318),
     /* 61250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 61253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 61256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 61259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61271 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61275 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(61296), // Rule ID 583 //
     /* 61280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61283 */     // (vselect:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$wt, MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (BSEL_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 61283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_D_PSEUDO),
     /* 61286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61288 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61290 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61292 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61294 */     GIR_RootConstrainSelectedInstOperands,
     /* 61295 */     // GIR_Coverage, 583,
     /* 61295 */     GIR_EraseRootFromParent_Done,
     /* 61296 */   // Label 1436: @61296
     /* 61296 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(61317), // Rule ID 585 //
     /* 61301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61304 */     // (vselect:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$wt, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (BSEL_FD_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 61304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_FD_PSEUDO),
     /* 61307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61309 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61311 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61313 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61315 */     GIR_RootConstrainSelectedInstOperands,
     /* 61316 */     // GIR_Coverage, 585,
     /* 61316 */     GIR_EraseRootFromParent_Done,
     /* 61317 */   // Label 1437: @61317
     /* 61317 */   GIM_Reject,
     /* 61318 */ // Label 1435: @61318
     /* 61318 */ GIM_Reject,
     /* 61319 */ // Label 1292: @61319
     /* 61319 */ GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(61392),
     /* 61324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 61327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 61330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 61333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61345 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61349 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(61370), // Rule ID 582 //
     /* 61354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61357 */     // (vselect:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$wt, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (BSEL_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 61357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_W_PSEUDO),
     /* 61360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61362 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61364 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61366 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61368 */     GIR_RootConstrainSelectedInstOperands,
     /* 61369 */     // GIR_Coverage, 582,
     /* 61369 */     GIR_EraseRootFromParent_Done,
     /* 61370 */   // Label 1439: @61370
     /* 61370 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(61391), // Rule ID 584 //
     /* 61375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61378 */     // (vselect:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$wt, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (BSEL_FW_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 61378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_FW_PSEUDO),
     /* 61381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61383 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61385 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61387 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61389 */     GIR_RootConstrainSelectedInstOperands,
     /* 61390 */     // GIR_Coverage, 584,
     /* 61390 */     GIR_EraseRootFromParent_Done,
     /* 61391 */   // Label 1440: @61391
     /* 61391 */   GIM_Reject,
     /* 61392 */ // Label 1438: @61392
     /* 61392 */ GIM_Reject,
     /* 61393 */ // Label 1293: @61393
     /* 61393 */ GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(61439), // Rule ID 581 //
     /* 61398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 61404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 61407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 61410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61422 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61426 */   // (vselect:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$wt, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (BSEL_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 61426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_H_PSEUDO),
     /* 61429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61431 */   GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61433 */   GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61435 */   GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61437 */   GIR_RootConstrainSelectedInstOperands,
     /* 61438 */   // GIR_Coverage, 581,
     /* 61438 */   GIR_EraseRootFromParent_Done,
     /* 61439 */ // Label 1441: @61439
     /* 61439 */ GIM_Reject,
     /* 61440 */ // Label 1294: @61440
     /* 61440 */ GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(61534),
     /* 61445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 61448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 61451 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 61454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61466 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61470 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(61491), // Rule ID 568 //
     /* 61475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61478 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wd_in)  =>  (BMNZ_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BMNZ_V),
     /* 61481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61483 */     GIR_RootToRootCopy, /*OpIdx*/3, // wd_in
     /* 61485 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 61487 */     GIR_RootToRootCopy, /*OpIdx*/1, // wt
     /* 61489 */     GIR_RootConstrainSelectedInstOperands,
     /* 61490 */     // GIR_Coverage, 568,
     /* 61490 */     GIR_EraseRootFromParent_Done,
     /* 61491 */   // Label 1443: @61491
     /* 61491 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(61512), // Rule ID 570 //
     /* 61496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61499 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (BMZ_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BMZ_V),
     /* 61502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61504 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 61506 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61508 */     GIR_RootToRootCopy, /*OpIdx*/1, // wt
     /* 61510 */     GIR_RootConstrainSelectedInstOperands,
     /* 61511 */     // GIR_Coverage, 570,
     /* 61511 */     GIR_EraseRootFromParent_Done,
     /* 61512 */   // Label 1444: @61512
     /* 61512 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(61533), // Rule ID 580 //
     /* 61517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61520 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (BSEL_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_V),
     /* 61523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61525 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61527 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61529 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61531 */     GIR_RootConstrainSelectedInstOperands,
     /* 61532 */     // GIR_Coverage, 580,
     /* 61532 */     GIR_EraseRootFromParent_Done,
     /* 61533 */   // Label 1445: @61533
     /* 61533 */   GIM_Reject,
     /* 61534 */ // Label 1442: @61534
     /* 61534 */ GIM_Reject,
     /* 61535 */ // Label 1295: @61535
     /* 61535 */ GIM_Reject,
     /* 61536 */ // Label 44: @61536
     /* 61536 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1448*/ GIMT_Encode4(61644),
     /* 61547 */ /*GILLT_s32*//*Label 1446*/ GIMT_Encode4(61555),
     /* 61551 */ /*GILLT_s64*//*Label 1447*/ GIMT_Encode4(61610),
     /* 61555 */ // Label 1446: @61555
     /* 61555 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(61609),
     /* 61560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61578 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(61593), // Rule ID 331 //
     /* 61583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 61586 */     // (mulhu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUHU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUHU),
     /* 61591 */     GIR_RootConstrainSelectedInstOperands,
     /* 61592 */     // GIR_Coverage, 331,
     /* 61592 */     GIR_Done,
     /* 61593 */   // Label 1450: @61593
     /* 61593 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(61608), // Rule ID 1181 //
     /* 61598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 61601 */     // (mulhu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUHU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUHU_MMR6),
     /* 61606 */     GIR_RootConstrainSelectedInstOperands,
     /* 61607 */     // GIR_Coverage, 1181,
     /* 61607 */     GIR_Done,
     /* 61608 */   // Label 1451: @61608
     /* 61608 */   GIM_Reject,
     /* 61609 */ // Label 1449: @61609
     /* 61609 */ GIM_Reject,
     /* 61610 */ // Label 1447: @61610
     /* 61610 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(61643), // Rule ID 346 //
     /* 61615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 61618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61636 */   // (mulhu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUHU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 61636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUHU),
     /* 61641 */   GIR_RootConstrainSelectedInstOperands,
     /* 61642 */   // GIR_Coverage, 346,
     /* 61642 */   GIR_Done,
     /* 61643 */ // Label 1452: @61643
     /* 61643 */ GIM_Reject,
     /* 61644 */ // Label 1448: @61644
     /* 61644 */ GIM_Reject,
     /* 61645 */ // Label 45: @61645
     /* 61645 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1455*/ GIMT_Encode4(61753),
     /* 61656 */ /*GILLT_s32*//*Label 1453*/ GIMT_Encode4(61664),
     /* 61660 */ /*GILLT_s64*//*Label 1454*/ GIMT_Encode4(61719),
     /* 61664 */ // Label 1453: @61664
     /* 61664 */ GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(61718),
     /* 61669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61687 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(61702), // Rule ID 330 //
     /* 61692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 61695 */     // (mulhs:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUH:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUH),
     /* 61700 */     GIR_RootConstrainSelectedInstOperands,
     /* 61701 */     // GIR_Coverage, 330,
     /* 61701 */     GIR_Done,
     /* 61702 */   // Label 1457: @61702
     /* 61702 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(61717), // Rule ID 1180 //
     /* 61707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 61710 */     // (mulhs:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUH_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUH_MMR6),
     /* 61715 */     GIR_RootConstrainSelectedInstOperands,
     /* 61716 */     // GIR_Coverage, 1180,
     /* 61716 */     GIR_Done,
     /* 61717 */   // Label 1458: @61717
     /* 61717 */   GIM_Reject,
     /* 61718 */ // Label 1456: @61718
     /* 61718 */ GIM_Reject,
     /* 61719 */ // Label 1454: @61719
     /* 61719 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(61752), // Rule ID 345 //
     /* 61724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 61727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61745 */   // (mulhs:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUH:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 61745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUH),
     /* 61750 */   GIR_RootConstrainSelectedInstOperands,
     /* 61751 */   // GIR_Coverage, 345,
     /* 61751 */   GIR_Done,
     /* 61752 */ // Label 1459: @61752
     /* 61752 */ GIM_Reject,
     /* 61753 */ // Label 1455: @61753
     /* 61753 */ GIM_Reject,
     /* 61754 */ // Label 46: @61754
     /* 61754 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1464*/ GIMT_Encode4(62666),
     /* 61765 */ /*GILLT_s32*//*Label 1460*/ GIMT_Encode4(61789),
     /* 61769 */ /*GILLT_s64*//*Label 1461*/ GIMT_Encode4(61993), GIMT_Encode4(0),
     /* 61777 */ /*GILLT_v2s64*//*Label 1462*/ GIMT_Encode4(62358), GIMT_Encode4(0),
     /* 61785 */ /*GILLT_v4s32*//*Label 1463*/ GIMT_Encode4(62512),
     /* 61789 */ // Label 1460: @61789
     /* 61789 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(61992),
     /* 61794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61804 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(61861), // Rule ID 163 //
     /* 61809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 61812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 61816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 61820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 61824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 61828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 61844 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr)  =>  (MADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_S),
     /* 61847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61849 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 61851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 61855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 61859 */     GIR_RootConstrainSelectedInstOperands,
     /* 61860 */     // GIR_Coverage, 163,
     /* 61860 */     GIR_EraseRootFromParent_Done,
     /* 61861 */   // Label 1466: @61861
     /* 61861 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(61918), // Rule ID 2356 //
     /* 61866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 61869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 61877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 61881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 61885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 61889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 61901 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft))  =>  (MADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_S),
     /* 61904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61906 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 61908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 61912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 61916 */     GIR_RootConstrainSelectedInstOperands,
     /* 61917 */     // GIR_Coverage, 2356,
     /* 61917 */     GIR_EraseRootFromParent_Done,
     /* 61918 */   // Label 1467: @61918
     /* 61918 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(61941), // Rule ID 151 //
     /* 61923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 61926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61934 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_S),
     /* 61939 */     GIR_RootConstrainSelectedInstOperands,
     /* 61940 */     // GIR_Coverage, 151,
     /* 61940 */     GIR_Done,
     /* 61941 */   // Label 1468: @61941
     /* 61941 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(61964), // Rule ID 1130 //
     /* 61946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 61949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61957 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_S_MM),
     /* 61962 */     GIR_RootConstrainSelectedInstOperands,
     /* 61963 */     // GIR_Coverage, 1130,
     /* 61963 */     GIR_Done,
     /* 61964 */   // Label 1469: @61964
     /* 61964 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(61991), // Rule ID 1188 //
     /* 61969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 61972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61980 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 61980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FADD_S_MMR6),
     /* 61983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61985 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 61987 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 61989 */     GIR_RootConstrainSelectedInstOperands,
     /* 61990 */     // GIR_Coverage, 1188,
     /* 61990 */     GIR_EraseRootFromParent_Done,
     /* 61991 */   // Label 1470: @61991
     /* 61991 */   GIM_Reject,
     /* 61992 */ // Label 1465: @61992
     /* 61992 */ GIM_Reject,
     /* 61993 */ // Label 1461: @61993
     /* 61993 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(62357),
     /* 61998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 62001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 62004 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(62065), // Rule ID 165 //
     /* 62009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62048 */     // (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr)  =>  (MADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D32),
     /* 62051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62053 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62063 */     GIR_RootConstrainSelectedInstOperands,
     /* 62064 */     // GIR_Coverage, 165,
     /* 62064 */     GIR_EraseRootFromParent_Done,
     /* 62065 */   // Label 1472: @62065
     /* 62065 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(62126), // Rule ID 167 //
     /* 62070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62109 */     // (fadd:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr)  =>  (MADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D64),
     /* 62112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62114 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62124 */     GIR_RootConstrainSelectedInstOperands,
     /* 62125 */     // GIR_Coverage, 167,
     /* 62125 */     GIR_EraseRootFromParent_Done,
     /* 62126 */   // Label 1473: @62126
     /* 62126 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(62187), // Rule ID 2357 //
     /* 62131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62170 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft))  =>  (MADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D32),
     /* 62173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62175 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 62177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62185 */     GIR_RootConstrainSelectedInstOperands,
     /* 62186 */     // GIR_Coverage, 2357,
     /* 62186 */     GIR_EraseRootFromParent_Done,
     /* 62187 */   // Label 1474: @62187
     /* 62187 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(62248), // Rule ID 2358 //
     /* 62192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62231 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft))  =>  (MADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D64),
     /* 62234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62236 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 62238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62246 */     GIR_RootConstrainSelectedInstOperands,
     /* 62247 */     // GIR_Coverage, 2358,
     /* 62247 */     GIR_EraseRootFromParent_Done,
     /* 62248 */   // Label 1475: @62248
     /* 62248 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(62275), // Rule ID 152 //
     /* 62253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 62256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62268 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D32),
     /* 62273 */     GIR_RootConstrainSelectedInstOperands,
     /* 62274 */     // GIR_Coverage, 152,
     /* 62274 */     GIR_Done,
     /* 62275 */   // Label 1476: @62275
     /* 62275 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(62302), // Rule ID 153 //
     /* 62280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 62283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62295 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D64),
     /* 62300 */     GIR_RootConstrainSelectedInstOperands,
     /* 62301 */     // GIR_Coverage, 153,
     /* 62301 */     GIR_Done,
     /* 62302 */   // Label 1477: @62302
     /* 62302 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(62329), // Rule ID 1134 //
     /* 62307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 62310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62322 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D32_MM),
     /* 62327 */     GIR_RootConstrainSelectedInstOperands,
     /* 62328 */     // GIR_Coverage, 1134,
     /* 62328 */     GIR_Done,
     /* 62329 */   // Label 1478: @62329
     /* 62329 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(62356), // Rule ID 1135 //
     /* 62334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 62337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62349 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D64_MM),
     /* 62354 */     GIR_RootConstrainSelectedInstOperands,
     /* 62355 */     // GIR_Coverage, 1135,
     /* 62355 */     GIR_Done,
     /* 62356 */   // Label 1479: @62356
     /* 62356 */   GIM_Reject,
     /* 62357 */ // Label 1471: @62357
     /* 62357 */ GIM_Reject,
     /* 62358 */ // Label 1462: @62358
     /* 62358 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(62511),
     /* 62363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62373 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(62430), // Rule ID 2463 //
     /* 62378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62413 */     // (fadd:{ *:[v2f64] } (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt), MSA128DOpnd:{ *:[v2f64] }:$wd)  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 62416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62418 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd
     /* 62420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62428 */     GIR_RootConstrainSelectedInstOperands,
     /* 62429 */     // GIR_Coverage, 2463,
     /* 62429 */     GIR_EraseRootFromParent_Done,
     /* 62430 */   // Label 1481: @62430
     /* 62430 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(62487), // Rule ID 1993 //
     /* 62435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62470 */     // (fadd:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 62473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62475 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 62477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62485 */     GIR_RootConstrainSelectedInstOperands,
     /* 62486 */     // GIR_Coverage, 1993,
     /* 62486 */     GIR_EraseRootFromParent_Done,
     /* 62487 */   // Label 1482: @62487
     /* 62487 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(62510), // Rule ID 671 //
     /* 62492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 62495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62503 */     // (fadd:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D),
     /* 62508 */     GIR_RootConstrainSelectedInstOperands,
     /* 62509 */     // GIR_Coverage, 671,
     /* 62509 */     GIR_Done,
     /* 62510 */   // Label 1483: @62510
     /* 62510 */   GIM_Reject,
     /* 62511 */ // Label 1480: @62511
     /* 62511 */ GIM_Reject,
     /* 62512 */ // Label 1463: @62512
     /* 62512 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(62665),
     /* 62517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62527 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(62584), // Rule ID 2462 //
     /* 62532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62567 */     // (fadd:{ *:[v4f32] } (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt), MSA128WOpnd:{ *:[v4f32] }:$wd)  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 62570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62572 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd
     /* 62574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62582 */     GIR_RootConstrainSelectedInstOperands,
     /* 62583 */     // GIR_Coverage, 2462,
     /* 62583 */     GIR_EraseRootFromParent_Done,
     /* 62584 */   // Label 1485: @62584
     /* 62584 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(62641), // Rule ID 1992 //
     /* 62589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62624 */     // (fadd:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 62627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62629 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 62631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62639 */     GIR_RootConstrainSelectedInstOperands,
     /* 62640 */     // GIR_Coverage, 1992,
     /* 62640 */     GIR_EraseRootFromParent_Done,
     /* 62641 */   // Label 1486: @62641
     /* 62641 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(62664), // Rule ID 670 //
     /* 62646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 62649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62657 */     // (fadd:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_W),
     /* 62662 */     GIR_RootConstrainSelectedInstOperands,
     /* 62663 */     // GIR_Coverage, 670,
     /* 62663 */     GIR_Done,
     /* 62664 */   // Label 1487: @62664
     /* 62664 */   GIM_Reject,
     /* 62665 */ // Label 1484: @62665
     /* 62665 */ GIM_Reject,
     /* 62666 */ // Label 1464: @62666
     /* 62666 */ GIM_Reject,
     /* 62667 */ // Label 47: @62667
     /* 62667 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1492*/ GIMT_Encode4(63278),
     /* 62678 */ /*GILLT_s32*//*Label 1488*/ GIMT_Encode4(62702),
     /* 62682 */ /*GILLT_s64*//*Label 1489*/ GIMT_Encode4(62849), GIMT_Encode4(0),
     /* 62690 */ /*GILLT_v2s64*//*Label 1490*/ GIMT_Encode4(63092), GIMT_Encode4(0),
     /* 62698 */ /*GILLT_v4s32*//*Label 1491*/ GIMT_Encode4(63185),
     /* 62702 */ // Label 1488: @62702
     /* 62702 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(62848),
     /* 62707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 62710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 62713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62717 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(62774), // Rule ID 164 //
     /* 62722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 62737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 62741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62757 */     // (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr)  =>  (MSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_S),
     /* 62760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62762 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62772 */     GIR_RootConstrainSelectedInstOperands,
     /* 62773 */     // GIR_Coverage, 164,
     /* 62773 */     GIR_EraseRootFromParent_Done,
     /* 62774 */   // Label 1494: @62774
     /* 62774 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(62797), // Rule ID 160 //
     /* 62779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 62782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62790 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_S),
     /* 62795 */     GIR_RootConstrainSelectedInstOperands,
     /* 62796 */     // GIR_Coverage, 160,
     /* 62796 */     GIR_Done,
     /* 62797 */   // Label 1495: @62797
     /* 62797 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(62820), // Rule ID 1133 //
     /* 62802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 62805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62813 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_S_MM),
     /* 62818 */     GIR_RootConstrainSelectedInstOperands,
     /* 62819 */     // GIR_Coverage, 1133,
     /* 62819 */     GIR_Done,
     /* 62820 */   // Label 1496: @62820
     /* 62820 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(62847), // Rule ID 1189 //
     /* 62825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 62828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62836 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 62836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUB_S_MMR6),
     /* 62839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62841 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 62843 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 62845 */     GIR_RootConstrainSelectedInstOperands,
     /* 62846 */     // GIR_Coverage, 1189,
     /* 62846 */     GIR_EraseRootFromParent_Done,
     /* 62847 */   // Label 1497: @62847
     /* 62847 */   GIM_Reject,
     /* 62848 */ // Label 1493: @62848
     /* 62848 */ GIM_Reject,
     /* 62849 */ // Label 1489: @62849
     /* 62849 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(63091),
     /* 62854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 62857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 62860 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(62921), // Rule ID 166 //
     /* 62865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62904 */     // (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr)  =>  (MSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_D32),
     /* 62907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62909 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62919 */     GIR_RootConstrainSelectedInstOperands,
     /* 62920 */     // GIR_Coverage, 166,
     /* 62920 */     GIR_EraseRootFromParent_Done,
     /* 62921 */   // Label 1499: @62921
     /* 62921 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(62982), // Rule ID 168 //
     /* 62926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62965 */     // (fsub:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr)  =>  (MSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_D64),
     /* 62968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62970 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62980 */     GIR_RootConstrainSelectedInstOperands,
     /* 62981 */     // GIR_Coverage, 168,
     /* 62981 */     GIR_EraseRootFromParent_Done,
     /* 62982 */   // Label 1500: @62982
     /* 62982 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(63009), // Rule ID 161 //
     /* 62987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 62990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63002 */     // (fsub:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D32),
     /* 63007 */     GIR_RootConstrainSelectedInstOperands,
     /* 63008 */     // GIR_Coverage, 161,
     /* 63008 */     GIR_Done,
     /* 63009 */   // Label 1501: @63009
     /* 63009 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(63036), // Rule ID 162 //
     /* 63014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 63017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63029 */     // (fsub:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D64),
     /* 63034 */     GIR_RootConstrainSelectedInstOperands,
     /* 63035 */     // GIR_Coverage, 162,
     /* 63035 */     GIR_Done,
     /* 63036 */   // Label 1502: @63036
     /* 63036 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(63063), // Rule ID 1140 //
     /* 63041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 63044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63056 */     // (fsub:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D32_MM),
     /* 63061 */     GIR_RootConstrainSelectedInstOperands,
     /* 63062 */     // GIR_Coverage, 1140,
     /* 63062 */     GIR_Done,
     /* 63063 */   // Label 1503: @63063
     /* 63063 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(63090), // Rule ID 1141 //
     /* 63068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 63071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63083 */     // (fsub:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D64_MM),
     /* 63088 */     GIR_RootConstrainSelectedInstOperands,
     /* 63089 */     // GIR_Coverage, 1141,
     /* 63089 */     GIR_Done,
     /* 63090 */   // Label 1504: @63090
     /* 63090 */   GIM_Reject,
     /* 63091 */ // Label 1498: @63091
     /* 63091 */ GIM_Reject,
     /* 63092 */ // Label 1490: @63092
     /* 63092 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(63184),
     /* 63097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63111 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(63164), // Rule ID 1991 //
     /* 63116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 63119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 63127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63147 */     // (fsub:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FMSUB_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMSUB_D),
     /* 63150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63152 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 63154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 63158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 63162 */     GIR_RootConstrainSelectedInstOperands,
     /* 63163 */     // GIR_Coverage, 1991,
     /* 63163 */     GIR_EraseRootFromParent_Done,
     /* 63164 */   // Label 1506: @63164
     /* 63164 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(63183), // Rule ID 759 //
     /* 63169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63176 */     // (fsub:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUB_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D),
     /* 63181 */     GIR_RootConstrainSelectedInstOperands,
     /* 63182 */     // GIR_Coverage, 759,
     /* 63182 */     GIR_Done,
     /* 63183 */   // Label 1507: @63183
     /* 63183 */   GIM_Reject,
     /* 63184 */ // Label 1505: @63184
     /* 63184 */ GIM_Reject,
     /* 63185 */ // Label 1491: @63185
     /* 63185 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(63277),
     /* 63190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63204 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(63257), // Rule ID 1990 //
     /* 63209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 63212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 63220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63240 */     // (fsub:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FMSUB_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMSUB_W),
     /* 63243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63245 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 63247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 63251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 63255 */     GIR_RootConstrainSelectedInstOperands,
     /* 63256 */     // GIR_Coverage, 1990,
     /* 63256 */     GIR_EraseRootFromParent_Done,
     /* 63257 */   // Label 1509: @63257
     /* 63257 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(63276), // Rule ID 758 //
     /* 63262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63269 */     // (fsub:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUB_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_W),
     /* 63274 */     GIR_RootConstrainSelectedInstOperands,
     /* 63275 */     // GIR_Coverage, 758,
     /* 63275 */     GIR_Done,
     /* 63276 */   // Label 1510: @63276
     /* 63276 */   GIM_Reject,
     /* 63277 */ // Label 1508: @63277
     /* 63277 */ GIM_Reject,
     /* 63278 */ // Label 1492: @63278
     /* 63278 */ GIM_Reject,
     /* 63279 */ // Label 48: @63279
     /* 63279 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1515*/ GIMT_Encode4(63765),
     /* 63290 */ /*GILLT_s32*//*Label 1511*/ GIMT_Encode4(63314),
     /* 63294 */ /*GILLT_s64*//*Label 1512*/ GIMT_Encode4(63388), GIMT_Encode4(0),
     /* 63302 */ /*GILLT_v2s64*//*Label 1513*/ GIMT_Encode4(63509), GIMT_Encode4(0),
     /* 63310 */ /*GILLT_v4s32*//*Label 1514*/ GIMT_Encode4(63637),
     /* 63314 */ // Label 1511: @63314
     /* 63314 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(63387),
     /* 63319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 63322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 63325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63337 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(63352), // Rule ID 157 //
     /* 63342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 63345 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_S),
     /* 63350 */     GIR_RootConstrainSelectedInstOperands,
     /* 63351 */     // GIR_Coverage, 157,
     /* 63351 */     GIR_Done,
     /* 63352 */   // Label 1517: @63352
     /* 63352 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(63367), // Rule ID 1132 //
     /* 63357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 63360 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_S_MM),
     /* 63365 */     GIR_RootConstrainSelectedInstOperands,
     /* 63366 */     // GIR_Coverage, 1132,
     /* 63366 */     GIR_Done,
     /* 63367 */   // Label 1518: @63367
     /* 63367 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(63386), // Rule ID 1190 //
     /* 63372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 63375 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 63375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMUL_S_MMR6),
     /* 63378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 63380 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 63382 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 63384 */     GIR_RootConstrainSelectedInstOperands,
     /* 63385 */     // GIR_Coverage, 1190,
     /* 63385 */     GIR_EraseRootFromParent_Done,
     /* 63386 */   // Label 1519: @63386
     /* 63386 */   GIM_Reject,
     /* 63387 */ // Label 1516: @63387
     /* 63387 */ GIM_Reject,
     /* 63388 */ // Label 1512: @63388
     /* 63388 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(63508),
     /* 63393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 63396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 63399 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(63426), // Rule ID 158 //
     /* 63404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 63407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63419 */     // (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D32),
     /* 63424 */     GIR_RootConstrainSelectedInstOperands,
     /* 63425 */     // GIR_Coverage, 158,
     /* 63425 */     GIR_Done,
     /* 63426 */   // Label 1521: @63426
     /* 63426 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(63453), // Rule ID 159 //
     /* 63431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 63434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63446 */     // (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D64),
     /* 63451 */     GIR_RootConstrainSelectedInstOperands,
     /* 63452 */     // GIR_Coverage, 159,
     /* 63452 */     GIR_Done,
     /* 63453 */   // Label 1522: @63453
     /* 63453 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(63480), // Rule ID 1138 //
     /* 63458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 63461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63473 */     // (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D32_MM),
     /* 63478 */     GIR_RootConstrainSelectedInstOperands,
     /* 63479 */     // GIR_Coverage, 1138,
     /* 63479 */     GIR_Done,
     /* 63480 */   // Label 1523: @63480
     /* 63480 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(63507), // Rule ID 1139 //
     /* 63485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 63488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63500 */     // (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D64_MM),
     /* 63505 */     GIR_RootConstrainSelectedInstOperands,
     /* 63506 */     // GIR_Coverage, 1139,
     /* 63506 */     GIR_Done,
     /* 63507 */   // Label 1524: @63507
     /* 63507 */   GIM_Reject,
     /* 63508 */ // Label 1520: @63508
     /* 63508 */ GIM_Reject,
     /* 63509 */ // Label 1513: @63509
     /* 63509 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(63636),
     /* 63514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63524 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(63568), // Rule ID 2399 //
     /* 63529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 63536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63555 */     // (fmul:{ *:[v2f64] } (fexp2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wt), MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FEXP2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D),
     /* 63558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63560 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 63562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63566 */     GIR_RootConstrainSelectedInstOperands,
     /* 63567 */     // GIR_Coverage, 2399,
     /* 63567 */     GIR_EraseRootFromParent_Done,
     /* 63568 */   // Label 1526: @63568
     /* 63568 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(63612), // Rule ID 701 //
     /* 63573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63599 */     // (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, (fexp2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FEXP2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D),
     /* 63602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63604 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 63606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63610 */     GIR_RootConstrainSelectedInstOperands,
     /* 63611 */     // GIR_Coverage, 701,
     /* 63611 */     GIR_EraseRootFromParent_Done,
     /* 63612 */   // Label 1527: @63612
     /* 63612 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(63635), // Rule ID 737 //
     /* 63617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63628 */     // (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMUL_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D),
     /* 63633 */     GIR_RootConstrainSelectedInstOperands,
     /* 63634 */     // GIR_Coverage, 737,
     /* 63634 */     GIR_Done,
     /* 63635 */   // Label 1528: @63635
     /* 63635 */   GIM_Reject,
     /* 63636 */ // Label 1525: @63636
     /* 63636 */ GIM_Reject,
     /* 63637 */ // Label 1514: @63637
     /* 63637 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(63764),
     /* 63642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63652 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(63696), // Rule ID 2398 //
     /* 63657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 63664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63683 */     // (fmul:{ *:[v4f32] } (fexp2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wt), MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXP2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W),
     /* 63686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63688 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 63690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63694 */     GIR_RootConstrainSelectedInstOperands,
     /* 63695 */     // GIR_Coverage, 2398,
     /* 63695 */     GIR_EraseRootFromParent_Done,
     /* 63696 */   // Label 1530: @63696
     /* 63696 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(63740), // Rule ID 700 //
     /* 63701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63727 */     // (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, (fexp2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FEXP2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W),
     /* 63730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63732 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 63734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63738 */     GIR_RootConstrainSelectedInstOperands,
     /* 63739 */     // GIR_Coverage, 700,
     /* 63739 */     GIR_EraseRootFromParent_Done,
     /* 63740 */   // Label 1531: @63740
     /* 63740 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(63763), // Rule ID 736 //
     /* 63745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63756 */     // (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMUL_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_W),
     /* 63761 */     GIR_RootConstrainSelectedInstOperands,
     /* 63762 */     // GIR_Coverage, 736,
     /* 63762 */     GIR_Done,
     /* 63763 */   // Label 1532: @63763
     /* 63763 */   GIM_Reject,
     /* 63764 */ // Label 1529: @63764
     /* 63764 */ GIM_Reject,
     /* 63765 */ // Label 1515: @63765
     /* 63765 */ GIM_Reject,
     /* 63766 */ // Label 49: @63766
     /* 63766 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1535*/ GIMT_Encode4(63871),
     /* 63777 */ /*GILLT_v2s64*//*Label 1533*/ GIMT_Encode4(63789), GIMT_Encode4(0),
     /* 63785 */ /*GILLT_v4s32*//*Label 1534*/ GIMT_Encode4(63830),
     /* 63789 */ // Label 1533: @63789
     /* 63789 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(63829), // Rule ID 725 //
     /* 63794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63803 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 63806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63818 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63822 */   // (fma:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 63827 */   GIR_RootConstrainSelectedInstOperands,
     /* 63828 */   // GIR_Coverage, 725,
     /* 63828 */   GIR_Done,
     /* 63829 */ // Label 1536: @63829
     /* 63829 */ GIM_Reject,
     /* 63830 */ // Label 1534: @63830
     /* 63830 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(63870), // Rule ID 724 //
     /* 63835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 63847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63859 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63863 */   // (fma:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 63868 */   GIR_RootConstrainSelectedInstOperands,
     /* 63869 */   // GIR_Coverage, 724,
     /* 63869 */   GIR_Done,
     /* 63870 */ // Label 1537: @63870
     /* 63870 */ GIM_Reject,
     /* 63871 */ // Label 1535: @63871
     /* 63871 */ GIM_Reject,
     /* 63872 */ // Label 50: @63872
     /* 63872 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1542*/ GIMT_Encode4(64170),
     /* 63883 */ /*GILLT_s32*//*Label 1538*/ GIMT_Encode4(63907),
     /* 63887 */ /*GILLT_s64*//*Label 1539*/ GIMT_Encode4(63981), GIMT_Encode4(0),
     /* 63895 */ /*GILLT_v2s64*//*Label 1540*/ GIMT_Encode4(64102), GIMT_Encode4(0),
     /* 63903 */ /*GILLT_v4s32*//*Label 1541*/ GIMT_Encode4(64136),
     /* 63907 */ // Label 1538: @63907
     /* 63907 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(63980),
     /* 63912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 63915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 63918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63930 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(63945), // Rule ID 154 //
     /* 63935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 63938 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_S),
     /* 63943 */     GIR_RootConstrainSelectedInstOperands,
     /* 63944 */     // GIR_Coverage, 154,
     /* 63944 */     GIR_Done,
     /* 63945 */   // Label 1544: @63945
     /* 63945 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(63960), // Rule ID 1131 //
     /* 63950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 63953 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_S_MM),
     /* 63958 */     GIR_RootConstrainSelectedInstOperands,
     /* 63959 */     // GIR_Coverage, 1131,
     /* 63959 */     GIR_Done,
     /* 63960 */   // Label 1545: @63960
     /* 63960 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(63979), // Rule ID 1191 //
     /* 63965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 63968 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 63968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FDIV_S_MMR6),
     /* 63971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 63973 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 63975 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 63977 */     GIR_RootConstrainSelectedInstOperands,
     /* 63978 */     // GIR_Coverage, 1191,
     /* 63978 */     GIR_EraseRootFromParent_Done,
     /* 63979 */   // Label 1546: @63979
     /* 63979 */   GIM_Reject,
     /* 63980 */ // Label 1543: @63980
     /* 63980 */ GIM_Reject,
     /* 63981 */ // Label 1539: @63981
     /* 63981 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(64101),
     /* 63986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 63989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 63992 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(64019), // Rule ID 155 //
     /* 63997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 64000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64012 */     // (fdiv:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D32),
     /* 64017 */     GIR_RootConstrainSelectedInstOperands,
     /* 64018 */     // GIR_Coverage, 155,
     /* 64018 */     GIR_Done,
     /* 64019 */   // Label 1548: @64019
     /* 64019 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(64046), // Rule ID 156 //
     /* 64024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 64027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64039 */     // (fdiv:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 64039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D64),
     /* 64044 */     GIR_RootConstrainSelectedInstOperands,
     /* 64045 */     // GIR_Coverage, 156,
     /* 64045 */     GIR_Done,
     /* 64046 */   // Label 1549: @64046
     /* 64046 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(64073), // Rule ID 1136 //
     /* 64051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 64054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64066 */     // (fdiv:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D32_MM),
     /* 64071 */     GIR_RootConstrainSelectedInstOperands,
     /* 64072 */     // GIR_Coverage, 1136,
     /* 64072 */     GIR_Done,
     /* 64073 */   // Label 1550: @64073
     /* 64073 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(64100), // Rule ID 1137 //
     /* 64078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 64081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64093 */     // (fdiv:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 64093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D64_MM),
     /* 64098 */     GIR_RootConstrainSelectedInstOperands,
     /* 64099 */     // GIR_Coverage, 1137,
     /* 64099 */     GIR_Done,
     /* 64100 */   // Label 1551: @64100
     /* 64100 */   GIM_Reject,
     /* 64101 */ // Label 1547: @64101
     /* 64101 */ GIM_Reject,
     /* 64102 */ // Label 1540: @64102
     /* 64102 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(64135), // Rule ID 697 //
     /* 64107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 64116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64128 */   // (fdiv:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FDIV_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 64128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D),
     /* 64133 */   GIR_RootConstrainSelectedInstOperands,
     /* 64134 */   // GIR_Coverage, 697,
     /* 64134 */   GIR_Done,
     /* 64135 */ // Label 1552: @64135
     /* 64135 */ GIM_Reject,
     /* 64136 */ // Label 1541: @64136
     /* 64136 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(64169), // Rule ID 696 //
     /* 64141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 64150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64162 */   // (fdiv:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FDIV_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 64162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_W),
     /* 64167 */   GIR_RootConstrainSelectedInstOperands,
     /* 64168 */   // GIR_Coverage, 696,
     /* 64168 */   GIR_Done,
     /* 64169 */ // Label 1553: @64169
     /* 64169 */ GIM_Reject,
     /* 64170 */ // Label 1542: @64170
     /* 64170 */ GIM_Reject,
     /* 64171 */ // Label 51: @64171
     /* 64171 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1556*/ GIMT_Encode4(64248),
     /* 64182 */ /*GILLT_v2s64*//*Label 1554*/ GIMT_Encode4(64194), GIMT_Encode4(0),
     /* 64190 */ /*GILLT_v4s32*//*Label 1555*/ GIMT_Encode4(64221),
     /* 64194 */ // Label 1554: @64194
     /* 64194 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(64220), // Rule ID 703 //
     /* 64199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64213 */   // (fexp2:{ *:[v2f64] } MSA128D:{ *:[v2f64] }:$ws)  =>  (FEXP2_D_1_PSEUDO:{ *:[v2f64] } MSA128D:{ *:[v2f64] }:$ws)
     /* 64213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D_1_PSEUDO),
     /* 64218 */   GIR_RootConstrainSelectedInstOperands,
     /* 64219 */   // GIR_Coverage, 703,
     /* 64219 */   GIR_Done,
     /* 64220 */ // Label 1557: @64220
     /* 64220 */ GIM_Reject,
     /* 64221 */ // Label 1555: @64221
     /* 64221 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(64247), // Rule ID 702 //
     /* 64226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64240 */   // (fexp2:{ *:[v4f32] } MSA128W:{ *:[v4f32] }:$ws)  =>  (FEXP2_W_1_PSEUDO:{ *:[v4f32] } MSA128W:{ *:[v4f32] }:$ws)
     /* 64240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W_1_PSEUDO),
     /* 64245 */   GIR_RootConstrainSelectedInstOperands,
     /* 64246 */   // GIR_Coverage, 702,
     /* 64246 */   GIR_Done,
     /* 64247 */ // Label 1558: @64247
     /* 64247 */ GIM_Reject,
     /* 64248 */ // Label 1556: @64248
     /* 64248 */ GIM_Reject,
     /* 64249 */ // Label 52: @64249
     /* 64249 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1561*/ GIMT_Encode4(64326),
     /* 64260 */ /*GILLT_v2s64*//*Label 1559*/ GIMT_Encode4(64272), GIMT_Encode4(0),
     /* 64268 */ /*GILLT_v4s32*//*Label 1560*/ GIMT_Encode4(64299),
     /* 64272 */ // Label 1559: @64272
     /* 64272 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(64298), // Rule ID 723 //
     /* 64277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64291 */   // (flog2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FLOG2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 64291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FLOG2_D),
     /* 64296 */   GIR_RootConstrainSelectedInstOperands,
     /* 64297 */   // GIR_Coverage, 723,
     /* 64297 */   GIR_Done,
     /* 64298 */ // Label 1562: @64298
     /* 64298 */ GIM_Reject,
     /* 64299 */ // Label 1560: @64299
     /* 64299 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(64325), // Rule ID 722 //
     /* 64304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64318 */   // (flog2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FLOG2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 64318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FLOG2_W),
     /* 64323 */   GIR_RootConstrainSelectedInstOperands,
     /* 64324 */   // GIR_Coverage, 722,
     /* 64324 */   GIR_Done,
     /* 64325 */ // Label 1563: @64325
     /* 64325 */ GIM_Reject,
     /* 64326 */ // Label 1561: @64326
     /* 64326 */ GIM_Reject,
     /* 64327 */ // Label 53: @64327
     /* 64327 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1566*/ GIMT_Encode4(65695),
     /* 64338 */ /*GILLT_s32*//*Label 1564*/ GIMT_Encode4(64346),
     /* 64342 */ /*GILLT_s64*//*Label 1565*/ GIMT_Encode4(64873),
     /* 64346 */ // Label 1564: @64346
     /* 64346 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(64872),
     /* 64351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 64354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64358 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(64434), // Rule ID 1460 //
     /* 64363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64415 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S),
     /* 64418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64432 */     GIR_RootConstrainSelectedInstOperands,
     /* 64433 */     // GIR_Coverage, 1460,
     /* 64433 */     GIR_EraseRootFromParent_Done,
     /* 64434 */   // Label 1568: @64434
     /* 64434 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(64510), // Rule ID 2248 //
     /* 64439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64491 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S_MM),
     /* 64494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64508 */     GIR_RootConstrainSelectedInstOperands,
     /* 64509 */     // GIR_Coverage, 2248,
     /* 64509 */     GIR_EraseRootFromParent_Done,
     /* 64510 */   // Label 1569: @64510
     /* 64510 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(64586), // Rule ID 2434 //
     /* 64515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 64543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64567 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)))  =>  (NMADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S),
     /* 64570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 64576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64584 */     GIR_RootConstrainSelectedInstOperands,
     /* 64585 */     // GIR_Coverage, 2434,
     /* 64585 */     GIR_EraseRootFromParent_Done,
     /* 64586 */   // Label 1570: @64586
     /* 64586 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(64662), // Rule ID 2520 //
     /* 64591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 64619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64643 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)))  =>  (NMADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S_MM),
     /* 64646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 64652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64660 */     GIR_RootConstrainSelectedInstOperands,
     /* 64661 */     // GIR_Coverage, 2520,
     /* 64661 */     GIR_EraseRootFromParent_Done,
     /* 64662 */   // Label 1571: @64662
     /* 64662 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(64738), // Rule ID 1461 //
     /* 64667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 64678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64719 */     // (fneg:{ *:[f32] } (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_S),
     /* 64722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64736 */     GIR_RootConstrainSelectedInstOperands,
     /* 64737 */     // GIR_Coverage, 1461,
     /* 64737 */     GIR_EraseRootFromParent_Done,
     /* 64738 */   // Label 1572: @64738
     /* 64738 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(64814), // Rule ID 2249 //
     /* 64743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 64754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64795 */     // (fneg:{ *:[f32] } (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMSUB_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_S_MM),
     /* 64798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64812 */     GIR_RootConstrainSelectedInstOperands,
     /* 64813 */     // GIR_Coverage, 2249,
     /* 64813 */     GIR_EraseRootFromParent_Done,
     /* 64814 */   // Label 1573: @64814
     /* 64814 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(64833), // Rule ID 129 //
     /* 64819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat),
     /* 64822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64826 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S),
     /* 64831 */     GIR_RootConstrainSelectedInstOperands,
     /* 64832 */     // GIR_Coverage, 129,
     /* 64832 */     GIR_Done,
     /* 64833 */   // Label 1574: @64833
     /* 64833 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(64852), // Rule ID 1153 //
     /* 64838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 64841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64845 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S_MM),
     /* 64850 */     GIR_RootConstrainSelectedInstOperands,
     /* 64851 */     // GIR_Coverage, 1153,
     /* 64851 */     GIR_Done,
     /* 64852 */   // Label 1575: @64852
     /* 64852 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(64871), // Rule ID 1192 //
     /* 64857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 64860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64864 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S_MMR6),
     /* 64869 */     GIR_RootConstrainSelectedInstOperands,
     /* 64870 */     // GIR_Coverage, 1192,
     /* 64870 */     GIR_Done,
     /* 64871 */   // Label 1576: @64871
     /* 64871 */   GIM_Reject,
     /* 64872 */ // Label 1567: @64872
     /* 64872 */ GIM_Reject,
     /* 64873 */ // Label 1565: @64873
     /* 64873 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(65694),
     /* 64878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 64881 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(64961), // Rule ID 1462 //
     /* 64886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 64905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 64909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 64921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 64925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64942 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32),
     /* 64945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64959 */     GIR_RootConstrainSelectedInstOperands,
     /* 64960 */     // GIR_Coverage, 1462,
     /* 64960 */     GIR_EraseRootFromParent_Done,
     /* 64961 */   // Label 1578: @64961
     /* 64961 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(65041), // Rule ID 1464 //
     /* 64966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 64985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 64989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65022 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D64),
     /* 65025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65039 */     GIR_RootConstrainSelectedInstOperands,
     /* 65040 */     // GIR_Coverage, 1464,
     /* 65040 */     GIR_EraseRootFromParent_Done,
     /* 65041 */   // Label 1579: @65041
     /* 65041 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(65121), // Rule ID 2250 //
     /* 65046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65102 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32_MM),
     /* 65105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65119 */     GIR_RootConstrainSelectedInstOperands,
     /* 65120 */     // GIR_Coverage, 2250,
     /* 65120 */     GIR_EraseRootFromParent_Done,
     /* 65121 */   // Label 1580: @65121
     /* 65121 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(65201), // Rule ID 2435 //
     /* 65126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65182 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32),
     /* 65185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65199 */     GIR_RootConstrainSelectedInstOperands,
     /* 65200 */     // GIR_Coverage, 2435,
     /* 65200 */     GIR_EraseRootFromParent_Done,
     /* 65201 */   // Label 1581: @65201
     /* 65201 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(65281), // Rule ID 2436 //
     /* 65206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65262 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D64),
     /* 65265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65279 */     GIR_RootConstrainSelectedInstOperands,
     /* 65280 */     // GIR_Coverage, 2436,
     /* 65280 */     GIR_EraseRootFromParent_Done,
     /* 65281 */   // Label 1582: @65281
     /* 65281 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(65361), // Rule ID 2521 //
     /* 65286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65342 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32_MM),
     /* 65345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65359 */     GIR_RootConstrainSelectedInstOperands,
     /* 65360 */     // GIR_Coverage, 2521,
     /* 65360 */     GIR_EraseRootFromParent_Done,
     /* 65361 */   // Label 1583: @65361
     /* 65361 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(65441), // Rule ID 1463 //
     /* 65366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65422 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D32),
     /* 65425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65439 */     GIR_RootConstrainSelectedInstOperands,
     /* 65440 */     // GIR_Coverage, 1463,
     /* 65440 */     GIR_EraseRootFromParent_Done,
     /* 65441 */   // Label 1584: @65441
     /* 65441 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(65521), // Rule ID 1465 //
     /* 65446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65502 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D64),
     /* 65505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65519 */     GIR_RootConstrainSelectedInstOperands,
     /* 65520 */     // GIR_Coverage, 1465,
     /* 65520 */     GIR_EraseRootFromParent_Done,
     /* 65521 */   // Label 1585: @65521
     /* 65521 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(65601), // Rule ID 2251 //
     /* 65526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65561 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65582 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D32_MM),
     /* 65585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65599 */     GIR_RootConstrainSelectedInstOperands,
     /* 65600 */     // GIR_Coverage, 2251,
     /* 65600 */     GIR_EraseRootFromParent_Done,
     /* 65601 */   // Label 1586: @65601
     /* 65601 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(65624), // Rule ID 130 //
     /* 65606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 65609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65617 */     // (fneg:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 65617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D32),
     /* 65622 */     GIR_RootConstrainSelectedInstOperands,
     /* 65623 */     // GIR_Coverage, 130,
     /* 65623 */     GIR_Done,
     /* 65624 */   // Label 1587: @65624
     /* 65624 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(65647), // Rule ID 131 //
     /* 65629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 65632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65640 */     // (fneg:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D64),
     /* 65645 */     GIR_RootConstrainSelectedInstOperands,
     /* 65646 */     // GIR_Coverage, 131,
     /* 65646 */     GIR_Done,
     /* 65647 */   // Label 1588: @65647
     /* 65647 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(65670), // Rule ID 1154 //
     /* 65652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 65655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65663 */     // (fneg:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 65663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D32_MM),
     /* 65668 */     GIR_RootConstrainSelectedInstOperands,
     /* 65669 */     // GIR_Coverage, 1154,
     /* 65669 */     GIR_Done,
     /* 65670 */   // Label 1589: @65670
     /* 65670 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(65693), // Rule ID 1155 //
     /* 65675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 65678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65686 */     // (fneg:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D64_MM),
     /* 65691 */     GIR_RootConstrainSelectedInstOperands,
     /* 65692 */     // GIR_Coverage, 1155,
     /* 65692 */     GIR_Done,
     /* 65693 */   // Label 1590: @65693
     /* 65693 */   GIM_Reject,
     /* 65694 */ // Label 1577: @65694
     /* 65694 */ GIM_Reject,
     /* 65695 */ // Label 1566: @65695
     /* 65695 */ GIM_Reject,
     /* 65696 */ // Label 54: @65696
     /* 65696 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1593*/ GIMT_Encode4(65873),
     /* 65707 */ /*GILLT_s32*//*Label 1591*/ GIMT_Encode4(65715),
     /* 65711 */ /*GILLT_s64*//*Label 1592*/ GIMT_Encode4(65742),
     /* 65715 */ // Label 1591: @65715
     /* 65715 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(65741), // Rule ID 1056 //
     /* 65720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 65726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65734 */   // (fpextend:{ *:[f32] } MSA128F16:{ *:[f16] }:$ws)  =>  (MSA_FP_EXTEND_W_PSEUDO:{ *:[f32] } MSA128F16:{ *:[f16] }:$ws)
     /* 65734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_EXTEND_W_PSEUDO),
     /* 65739 */   GIR_RootConstrainSelectedInstOperands,
     /* 65740 */   // GIR_Coverage, 1056,
     /* 65740 */   GIR_Done,
     /* 65741 */ // Label 1594: @65741
     /* 65741 */ GIM_Reject,
     /* 65742 */ // Label 1592: @65742
     /* 65742 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(65768), // Rule ID 1058 //
     /* 65747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 65753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65761 */   // (fpextend:{ *:[f64] } MSA128F16:{ *:[f16] }:$ws)  =>  (MSA_FP_EXTEND_D_PSEUDO:{ *:[f64] } MSA128F16:{ *:[f16] }:$ws)
     /* 65761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_EXTEND_D_PSEUDO),
     /* 65766 */   GIR_RootConstrainSelectedInstOperands,
     /* 65767 */   // GIR_Coverage, 1058,
     /* 65767 */   GIR_Done,
     /* 65768 */ // Label 1595: @65768
     /* 65768 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(65794), // Rule ID 1449 //
     /* 65773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips),
     /* 65776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65787 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D32_S:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D32_S),
     /* 65792 */   GIR_RootConstrainSelectedInstOperands,
     /* 65793 */   // GIR_Coverage, 1449,
     /* 65793 */   GIR_Done,
     /* 65794 */ // Label 1596: @65794
     /* 65794 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(65820), // Rule ID 1459 //
     /* 65799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips),
     /* 65802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65813 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D64_S:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D64_S),
     /* 65818 */   GIR_RootConstrainSelectedInstOperands,
     /* 65819 */   // GIR_Coverage, 1459,
     /* 65819 */   GIR_Done,
     /* 65820 */ // Label 1597: @65820
     /* 65820 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(65846), // Rule ID 2262 //
     /* 65825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit),
     /* 65828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65839 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D64_S_MM:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D64_S_MM),
     /* 65844 */   GIR_RootConstrainSelectedInstOperands,
     /* 65845 */   // GIR_Coverage, 2262,
     /* 65845 */   GIR_Done,
     /* 65846 */ // Label 1598: @65846
     /* 65846 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(65872), // Rule ID 2264 //
     /* 65851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit),
     /* 65854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65865 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D32_S_MM:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D32_S_MM),
     /* 65870 */   GIR_RootConstrainSelectedInstOperands,
     /* 65871 */   // GIR_Coverage, 2264,
     /* 65871 */   GIR_Done,
     /* 65872 */ // Label 1599: @65872
     /* 65872 */ GIM_Reject,
     /* 65873 */ // Label 1593: @65873
     /* 65873 */ GIM_Reject,
     /* 65874 */ // Label 55: @65874
     /* 65874 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 1602*/ GIMT_Encode4(66036),
     /* 65885 */ /*GILLT_s16*//*Label 1600*/ GIMT_Encode4(65893),
     /* 65889 */ /*GILLT_s32*//*Label 1601*/ GIMT_Encode4(65946),
     /* 65893 */ // Label 1600: @65893
     /* 65893 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(65919), // Rule ID 1057 //
     /* 65898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65912 */   // (fpround:{ *:[f16] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MSA_FP_ROUND_W_PSEUDO:{ *:[f16] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 65912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_ROUND_W_PSEUDO),
     /* 65917 */   GIR_RootConstrainSelectedInstOperands,
     /* 65918 */   // GIR_Coverage, 1057,
     /* 65918 */   GIR_Done,
     /* 65919 */ // Label 1603: @65919
     /* 65919 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(65945), // Rule ID 1059 //
     /* 65924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 65930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65938 */   // (fpround:{ *:[f16] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (MSA_FP_ROUND_D_PSEUDO:{ *:[f16] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_ROUND_D_PSEUDO),
     /* 65943 */   GIR_RootConstrainSelectedInstOperands,
     /* 65944 */   // GIR_Coverage, 1059,
     /* 65944 */   GIR_Done,
     /* 65945 */ // Label 1604: @65945
     /* 65945 */ GIM_Reject,
     /* 65946 */ // Label 1601: @65946
     /* 65946 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(66035),
     /* 65951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 65954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65958 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(65977), // Rule ID 1448 //
     /* 65963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips),
     /* 65966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65970 */     // (fpround:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D32:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)
     /* 65970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D32),
     /* 65975 */     GIR_RootConstrainSelectedInstOperands,
     /* 65976 */     // GIR_Coverage, 1448,
     /* 65976 */     GIR_Done,
     /* 65977 */   // Label 1606: @65977
     /* 65977 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(65996), // Rule ID 1458 //
     /* 65982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips),
     /* 65985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65989 */     // (fpround:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D64:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)
     /* 65989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D64),
     /* 65994 */     GIR_RootConstrainSelectedInstOperands,
     /* 65995 */     // GIR_Coverage, 1458,
     /* 65995 */     GIR_Done,
     /* 65996 */   // Label 1607: @65996
     /* 65996 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(66015), // Rule ID 2261 //
     /* 66001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit),
     /* 66004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66008 */     // (fpround:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D64_MM:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)
     /* 66008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D64_MM),
     /* 66013 */     GIR_RootConstrainSelectedInstOperands,
     /* 66014 */     // GIR_Coverage, 2261,
     /* 66014 */     GIR_Done,
     /* 66015 */   // Label 1608: @66015
     /* 66015 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(66034), // Rule ID 2263 //
     /* 66020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit),
     /* 66023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66027 */     // (fpround:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D32_MM:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)
     /* 66027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D32_MM),
     /* 66032 */     GIR_RootConstrainSelectedInstOperands,
     /* 66033 */     // GIR_Coverage, 2263,
     /* 66033 */     GIR_Done,
     /* 66034 */   // Label 1609: @66034
     /* 66034 */   GIM_Reject,
     /* 66035 */ // Label 1605: @66035
     /* 66035 */ GIM_Reject,
     /* 66036 */ // Label 1602: @66036
     /* 66036 */ GIM_Reject,
     /* 66037 */ // Label 56: @66037
     /* 66037 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1612*/ GIMT_Encode4(66114),
     /* 66048 */ /*GILLT_v2s64*//*Label 1610*/ GIMT_Encode4(66060), GIMT_Encode4(0),
     /* 66056 */ /*GILLT_v4s32*//*Label 1611*/ GIMT_Encode4(66087),
     /* 66060 */ // Label 1610: @66060
     /* 66060 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(66086), // Rule ID 777 //
     /* 66065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66079 */   // (fp_to_sint:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTRUNC_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_S_D),
     /* 66084 */   GIR_RootConstrainSelectedInstOperands,
     /* 66085 */   // GIR_Coverage, 777,
     /* 66085 */   GIR_Done,
     /* 66086 */ // Label 1613: @66086
     /* 66086 */ GIM_Reject,
     /* 66087 */ // Label 1611: @66087
     /* 66087 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(66113), // Rule ID 776 //
     /* 66092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66106 */   // (fp_to_sint:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTRUNC_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_S_W),
     /* 66111 */   GIR_RootConstrainSelectedInstOperands,
     /* 66112 */   // GIR_Coverage, 776,
     /* 66112 */   GIR_Done,
     /* 66113 */ // Label 1614: @66113
     /* 66113 */ GIM_Reject,
     /* 66114 */ // Label 1612: @66114
     /* 66114 */ GIM_Reject,
     /* 66115 */ // Label 57: @66115
     /* 66115 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1617*/ GIMT_Encode4(66192),
     /* 66126 */ /*GILLT_v2s64*//*Label 1615*/ GIMT_Encode4(66138), GIMT_Encode4(0),
     /* 66134 */ /*GILLT_v4s32*//*Label 1616*/ GIMT_Encode4(66165),
     /* 66138 */ // Label 1615: @66138
     /* 66138 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(66164), // Rule ID 779 //
     /* 66143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66157 */   // (fp_to_uint:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTRUNC_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_U_D),
     /* 66162 */   GIR_RootConstrainSelectedInstOperands,
     /* 66163 */   // GIR_Coverage, 779,
     /* 66163 */   GIR_Done,
     /* 66164 */ // Label 1618: @66164
     /* 66164 */ GIM_Reject,
     /* 66165 */ // Label 1616: @66165
     /* 66165 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(66191), // Rule ID 778 //
     /* 66170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66184 */   // (fp_to_uint:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTRUNC_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_U_W),
     /* 66189 */   GIR_RootConstrainSelectedInstOperands,
     /* 66190 */   // GIR_Coverage, 778,
     /* 66190 */   GIR_Done,
     /* 66191 */ // Label 1619: @66191
     /* 66191 */ GIM_Reject,
     /* 66192 */ // Label 1617: @66192
     /* 66192 */ GIM_Reject,
     /* 66193 */ // Label 58: @66193
     /* 66193 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1624*/ GIMT_Encode4(66445),
     /* 66204 */ /*GILLT_s32*//*Label 1620*/ GIMT_Encode4(66228),
     /* 66208 */ /*GILLT_s64*//*Label 1621*/ GIMT_Encode4(66312), GIMT_Encode4(0),
     /* 66216 */ /*GILLT_v2s64*//*Label 1622*/ GIMT_Encode4(66391), GIMT_Encode4(0),
     /* 66224 */ /*GILLT_v4s32*//*Label 1623*/ GIMT_Encode4(66418),
     /* 66228 */ // Label 1620: @66228
     /* 66228 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(66251), // Rule ID 1443 //
     /* 66233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66244 */   // (sint_to_fp:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_S_W:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_S_W),
     /* 66249 */   GIR_RootConstrainSelectedInstOperands,
     /* 66250 */   // GIR_Coverage, 1443,
     /* 66250 */   GIR_Done,
     /* 66251 */ // Label 1625: @66251
     /* 66251 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(66311), // Rule ID 1453 //
     /* 66256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 66270 */   // (sint_to_fp:{ *:[f32] } GPR64Opnd:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[f32] } (PseudoCVT_S_L:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src), sub_lo:{ *:[i32] })
     /* 66270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 66273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_S_L),
     /* 66277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66282 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 66286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 66291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66293 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(Mips::sub_lo),
     /* 66300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66305 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66310 */   // GIR_Coverage, 1453,
     /* 66310 */   GIR_EraseRootFromParent_Done,
     /* 66311 */ // Label 1626: @66311
     /* 66311 */ GIM_Reject,
     /* 66312 */ // Label 1621: @66312
     /* 66312 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(66338), // Rule ID 1446 //
     /* 66317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotFP64bit),
     /* 66320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66331 */   // (sint_to_fp:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_D32_W:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D32_W),
     /* 66336 */   GIR_RootConstrainSelectedInstOperands,
     /* 66337 */   // GIR_Coverage, 1446,
     /* 66337 */   GIR_Done,
     /* 66338 */ // Label 1627: @66338
     /* 66338 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(66364), // Rule ID 1452 //
     /* 66343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66357 */   // (sint_to_fp:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_D64_W:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D64_W),
     /* 66362 */   GIR_RootConstrainSelectedInstOperands,
     /* 66363 */   // GIR_Coverage, 1452,
     /* 66363 */   GIR_Done,
     /* 66364 */ // Label 1628: @66364
     /* 66364 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(66390), // Rule ID 1454 //
     /* 66369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 66383 */   // (sint_to_fp:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src)  =>  (PseudoCVT_D64_L:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src)
     /* 66383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D64_L),
     /* 66388 */   GIR_RootConstrainSelectedInstOperands,
     /* 66389 */   // GIR_Coverage, 1454,
     /* 66389 */   GIR_Done,
     /* 66390 */ // Label 1629: @66390
     /* 66390 */ GIM_Reject,
     /* 66391 */ // Label 1622: @66391
     /* 66391 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(66417), // Rule ID 709 //
     /* 66396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66410 */   // (sint_to_fp:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (FFINT_S_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 66410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_S_D),
     /* 66415 */   GIR_RootConstrainSelectedInstOperands,
     /* 66416 */   // GIR_Coverage, 709,
     /* 66416 */   GIR_Done,
     /* 66417 */ // Label 1630: @66417
     /* 66417 */ GIM_Reject,
     /* 66418 */ // Label 1623: @66418
     /* 66418 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(66444), // Rule ID 708 //
     /* 66423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66437 */   // (sint_to_fp:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFINT_S_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 66437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_S_W),
     /* 66442 */   GIR_RootConstrainSelectedInstOperands,
     /* 66443 */   // GIR_Coverage, 708,
     /* 66443 */   GIR_Done,
     /* 66444 */ // Label 1631: @66444
     /* 66444 */ GIM_Reject,
     /* 66445 */ // Label 1624: @66445
     /* 66445 */ GIM_Reject,
     /* 66446 */ // Label 59: @66446
     /* 66446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1634*/ GIMT_Encode4(66523),
     /* 66457 */ /*GILLT_v2s64*//*Label 1632*/ GIMT_Encode4(66469), GIMT_Encode4(0),
     /* 66465 */ /*GILLT_v4s32*//*Label 1633*/ GIMT_Encode4(66496),
     /* 66469 */ // Label 1632: @66469
     /* 66469 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(66495), // Rule ID 711 //
     /* 66474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66488 */   // (uint_to_fp:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (FFINT_U_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 66488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_U_D),
     /* 66493 */   GIR_RootConstrainSelectedInstOperands,
     /* 66494 */   // GIR_Coverage, 711,
     /* 66494 */   GIR_Done,
     /* 66495 */ // Label 1635: @66495
     /* 66495 */ GIM_Reject,
     /* 66496 */ // Label 1633: @66496
     /* 66496 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(66522), // Rule ID 710 //
     /* 66501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66515 */   // (uint_to_fp:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFINT_U_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 66515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_U_W),
     /* 66520 */   GIR_RootConstrainSelectedInstOperands,
     /* 66521 */   // GIR_Coverage, 710,
     /* 66521 */   GIR_Done,
     /* 66522 */ // Label 1636: @66522
     /* 66522 */ GIM_Reject,
     /* 66523 */ // Label 1634: @66523
     /* 66523 */ GIM_Reject,
     /* 66524 */ // Label 60: @66524
     /* 66524 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1641*/ GIMT_Encode4(66763),
     /* 66535 */ /*GILLT_s32*//*Label 1637*/ GIMT_Encode4(66559),
     /* 66539 */ /*GILLT_s64*//*Label 1638*/ GIMT_Encode4(66607), GIMT_Encode4(0),
     /* 66547 */ /*GILLT_v2s64*//*Label 1639*/ GIMT_Encode4(66709), GIMT_Encode4(0),
     /* 66555 */ /*GILLT_v4s32*//*Label 1640*/ GIMT_Encode4(66736),
     /* 66559 */ // Label 1637: @66559
     /* 66559 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(66606),
     /* 66564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66575 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(66590), // Rule ID 126 //
     /* 66580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips_UseAbs),
     /* 66583 */     // (fabs:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FABS_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 66583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_S),
     /* 66588 */     GIR_RootConstrainSelectedInstOperands,
     /* 66589 */     // GIR_Coverage, 126,
     /* 66589 */     GIR_Done,
     /* 66590 */   // Label 1643: @66590
     /* 66590 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(66605), // Rule ID 1152 //
     /* 66595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_UseAbs),
     /* 66598 */     // (fabs:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FABS_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 66598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_S_MM),
     /* 66603 */     GIR_RootConstrainSelectedInstOperands,
     /* 66604 */     // GIR_Coverage, 1152,
     /* 66604 */     GIR_Done,
     /* 66605 */   // Label 1644: @66605
     /* 66605 */   GIM_Reject,
     /* 66606 */ // Label 1642: @66606
     /* 66606 */ GIM_Reject,
     /* 66607 */ // Label 1638: @66607
     /* 66607 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(66708),
     /* 66612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66615 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(66638), // Rule ID 127 //
     /* 66620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_UseAbs),
     /* 66623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66631 */     // (fabs:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 66631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D32),
     /* 66636 */     GIR_RootConstrainSelectedInstOperands,
     /* 66637 */     // GIR_Coverage, 127,
     /* 66637 */     GIR_Done,
     /* 66638 */   // Label 1646: @66638
     /* 66638 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(66661), // Rule ID 128 //
     /* 66643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_UseAbs),
     /* 66646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66654 */     // (fabs:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 66654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D64),
     /* 66659 */     GIR_RootConstrainSelectedInstOperands,
     /* 66660 */     // GIR_Coverage, 128,
     /* 66660 */     GIR_Done,
     /* 66661 */   // Label 1647: @66661
     /* 66661 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(66684), // Rule ID 1150 //
     /* 66666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 66669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66677 */     // (fabs:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 66677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D32_MM),
     /* 66682 */     GIR_RootConstrainSelectedInstOperands,
     /* 66683 */     // GIR_Coverage, 1150,
     /* 66683 */     GIR_Done,
     /* 66684 */   // Label 1648: @66684
     /* 66684 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(66707), // Rule ID 1151 //
     /* 66689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 66692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66700 */     // (fabs:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 66700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D64_MM),
     /* 66705 */     GIR_RootConstrainSelectedInstOperands,
     /* 66706 */     // GIR_Coverage, 1151,
     /* 66706 */     GIR_Done,
     /* 66707 */   // Label 1649: @66707
     /* 66707 */   GIM_Reject,
     /* 66708 */ // Label 1645: @66708
     /* 66708 */ GIM_Reject,
     /* 66709 */ // Label 1639: @66709
     /* 66709 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(66735), // Rule ID 1043 //
     /* 66714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66728 */   // (fabs:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FABS_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D),
     /* 66733 */   GIR_RootConstrainSelectedInstOperands,
     /* 66734 */   // GIR_Coverage, 1043,
     /* 66734 */   GIR_Done,
     /* 66735 */ // Label 1650: @66735
     /* 66735 */ GIM_Reject,
     /* 66736 */ // Label 1640: @66736
     /* 66736 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(66762), // Rule ID 1042 //
     /* 66741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66755 */   // (fabs:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FABS_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_W),
     /* 66760 */   GIR_RootConstrainSelectedInstOperands,
     /* 66761 */   // GIR_Coverage, 1042,
     /* 66761 */   GIR_Done,
     /* 66762 */ // Label 1651: @66762
     /* 66762 */ GIM_Reject,
     /* 66763 */ // Label 1641: @66763
     /* 66763 */ GIM_Reject,
     /* 66764 */ // Label 61: @66764
     /* 66764 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1654*/ GIMT_Encode4(66837),
     /* 66775 */ /*GILLT_s32*//*Label 1652*/ GIMT_Encode4(66783),
     /* 66779 */ /*GILLT_s64*//*Label 1653*/ GIMT_Encode4(66810),
     /* 66783 */ // Label 1652: @66783
     /* 66783 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(66809), // Rule ID 1794 //
     /* 66788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66798 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$src)  =>  (MIN_S:{ *:[f32] } f32:{ *:[f32] }:$src, f32:{ *:[f32] }:$src)
     /* 66798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_S),
     /* 66801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 66803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66807 */   GIR_RootConstrainSelectedInstOperands,
     /* 66808 */   // GIR_Coverage, 1794,
     /* 66808 */   GIR_EraseRootFromParent_Done,
     /* 66809 */ // Label 1655: @66809
     /* 66809 */ GIM_Reject,
     /* 66810 */ // Label 1653: @66810
     /* 66810 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(66836), // Rule ID 1795 //
     /* 66815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66825 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$src)  =>  (MIN_D:{ *:[f64] } f64:{ *:[f64] }:$src, f64:{ *:[f64] }:$src)
     /* 66825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_D),
     /* 66828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 66830 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66832 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66834 */   GIR_RootConstrainSelectedInstOperands,
     /* 66835 */   // GIR_Coverage, 1795,
     /* 66835 */   GIR_EraseRootFromParent_Done,
     /* 66836 */ // Label 1656: @66836
     /* 66836 */ GIM_Reject,
     /* 66837 */ // Label 1654: @66837
     /* 66837 */ GIM_Reject,
     /* 66838 */ // Label 62: @66838
     /* 66838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1659*/ GIMT_Encode4(66909),
     /* 66849 */ /*GILLT_s32*//*Label 1657*/ GIMT_Encode4(66857),
     /* 66853 */ /*GILLT_s64*//*Label 1658*/ GIMT_Encode4(66883),
     /* 66857 */ // Label 1657: @66857
     /* 66857 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(66882), // Rule ID 1791 //
     /* 66862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 66871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66875 */   // (fminnum:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MIN_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 66875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S),
     /* 66880 */   GIR_RootConstrainSelectedInstOperands,
     /* 66881 */   // GIR_Coverage, 1791,
     /* 66881 */   GIR_Done,
     /* 66882 */ // Label 1660: @66882
     /* 66882 */ GIM_Reject,
     /* 66883 */ // Label 1658: @66883
     /* 66883 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(66908), // Rule ID 1793 //
     /* 66888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 66897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66901 */   // (fminnum:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MIN_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 66901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_D),
     /* 66906 */   GIR_RootConstrainSelectedInstOperands,
     /* 66907 */   // GIR_Coverage, 1793,
     /* 66907 */   GIR_Done,
     /* 66908 */ // Label 1661: @66908
     /* 66908 */ GIM_Reject,
     /* 66909 */ // Label 1659: @66909
     /* 66909 */ GIM_Reject,
     /* 66910 */ // Label 63: @66910
     /* 66910 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1664*/ GIMT_Encode4(66981),
     /* 66921 */ /*GILLT_s32*//*Label 1662*/ GIMT_Encode4(66929),
     /* 66925 */ /*GILLT_s64*//*Label 1663*/ GIMT_Encode4(66955),
     /* 66929 */ // Label 1662: @66929
     /* 66929 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(66954), // Rule ID 1787 //
     /* 66934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 66943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66947 */   // (fmaxnum:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MAX_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 66947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S),
     /* 66952 */   GIR_RootConstrainSelectedInstOperands,
     /* 66953 */   // GIR_Coverage, 1787,
     /* 66953 */   GIR_Done,
     /* 66954 */ // Label 1665: @66954
     /* 66954 */ GIM_Reject,
     /* 66955 */ // Label 1663: @66955
     /* 66955 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(66980), // Rule ID 1789 //
     /* 66960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 66969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66973 */   // (fmaxnum:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MAX_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 66973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_D),
     /* 66978 */   GIR_RootConstrainSelectedInstOperands,
     /* 66979 */   // GIR_Coverage, 1789,
     /* 66979 */   GIR_Done,
     /* 66980 */ // Label 1666: @66980
     /* 66980 */ GIM_Reject,
     /* 66981 */ // Label 1664: @66981
     /* 66981 */ GIM_Reject,
     /* 66982 */ // Label 64: @66982
     /* 66982 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1669*/ GIMT_Encode4(67053),
     /* 66993 */ /*GILLT_s32*//*Label 1667*/ GIMT_Encode4(67001),
     /* 66997 */ /*GILLT_s64*//*Label 1668*/ GIMT_Encode4(67027),
     /* 67001 */ // Label 1667: @67001
     /* 67001 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(67026), // Rule ID 1790 //
     /* 67006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 67009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 67015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 67019 */   // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MIN_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 67019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S),
     /* 67024 */   GIR_RootConstrainSelectedInstOperands,
     /* 67025 */   // GIR_Coverage, 1790,
     /* 67025 */   GIR_Done,
     /* 67026 */ // Label 1670: @67026
     /* 67026 */ GIM_Reject,
     /* 67027 */ // Label 1668: @67027
     /* 67027 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(67052), // Rule ID 1792 //
     /* 67032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 67035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 67041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 67045 */   // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MIN_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 67045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_D),
     /* 67050 */   GIR_RootConstrainSelectedInstOperands,
     /* 67051 */   // GIR_Coverage, 1792,
     /* 67051 */   GIR_Done,
     /* 67052 */ // Label 1671: @67052
     /* 67052 */ GIM_Reject,
     /* 67053 */ // Label 1669: @67053
     /* 67053 */ GIM_Reject,
     /* 67054 */ // Label 65: @67054
     /* 67054 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1674*/ GIMT_Encode4(67125),
     /* 67065 */ /*GILLT_s32*//*Label 1672*/ GIMT_Encode4(67073),
     /* 67069 */ /*GILLT_s64*//*Label 1673*/ GIMT_Encode4(67099),
     /* 67073 */ // Label 1672: @67073
     /* 67073 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(67098), // Rule ID 1786 //
     /* 67078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 67081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 67087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 67091 */   // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MAX_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 67091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S),
     /* 67096 */   GIR_RootConstrainSelectedInstOperands,
     /* 67097 */   // GIR_Coverage, 1786,
     /* 67097 */   GIR_Done,
     /* 67098 */ // Label 1675: @67098
     /* 67098 */ GIM_Reject,
     /* 67099 */ // Label 1673: @67099
     /* 67099 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(67124), // Rule ID 1788 //
     /* 67104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 67107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 67113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 67117 */   // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MAX_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 67117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_D),
     /* 67122 */   GIR_RootConstrainSelectedInstOperands,
     /* 67123 */   // GIR_Coverage, 1788,
     /* 67123 */   GIR_Done,
     /* 67124 */ // Label 1676: @67124
     /* 67124 */ GIM_Reject,
     /* 67125 */ // Label 1674: @67125
     /* 67125 */ GIM_Reject,
     /* 67126 */ // Label 66: @67126
     /* 67126 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1681*/ GIMT_Encode4(67293),
     /* 67137 */ /*GILLT_v2s64*//*Label 1677*/ GIMT_Encode4(67157), GIMT_Encode4(0),
     /* 67145 */ /*GILLT_v4s32*//*Label 1678*/ GIMT_Encode4(67191),
     /* 67149 */ /*GILLT_v8s16*//*Label 1679*/ GIMT_Encode4(67225),
     /* 67153 */ /*GILLT_v16s8*//*Label 1680*/ GIMT_Encode4(67259),
     /* 67157 */ // Label 1677: @67157
     /* 67157 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(67190), // Rule ID 871 //
     /* 67162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67183 */   // (smin:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_D),
     /* 67188 */   GIR_RootConstrainSelectedInstOperands,
     /* 67189 */   // GIR_Coverage, 871,
     /* 67189 */   GIR_Done,
     /* 67190 */ // Label 1682: @67190
     /* 67190 */ GIM_Reject,
     /* 67191 */ // Label 1678: @67191
     /* 67191 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(67224), // Rule ID 870 //
     /* 67196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67217 */   // (smin:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_W),
     /* 67222 */   GIR_RootConstrainSelectedInstOperands,
     /* 67223 */   // GIR_Coverage, 870,
     /* 67223 */   GIR_Done,
     /* 67224 */ // Label 1683: @67224
     /* 67224 */ GIM_Reject,
     /* 67225 */ // Label 1679: @67225
     /* 67225 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(67258), // Rule ID 869 //
     /* 67230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67251 */   // (smin:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_H),
     /* 67256 */   GIR_RootConstrainSelectedInstOperands,
     /* 67257 */   // GIR_Coverage, 869,
     /* 67257 */   GIR_Done,
     /* 67258 */ // Label 1684: @67258
     /* 67258 */ GIM_Reject,
     /* 67259 */ // Label 1680: @67259
     /* 67259 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(67292), // Rule ID 868 //
     /* 67264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67285 */   // (smin:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_B),
     /* 67290 */   GIR_RootConstrainSelectedInstOperands,
     /* 67291 */   // GIR_Coverage, 868,
     /* 67291 */   GIR_Done,
     /* 67292 */ // Label 1685: @67292
     /* 67292 */ GIM_Reject,
     /* 67293 */ // Label 1681: @67293
     /* 67293 */ GIM_Reject,
     /* 67294 */ // Label 67: @67294
     /* 67294 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1690*/ GIMT_Encode4(67461),
     /* 67305 */ /*GILLT_v2s64*//*Label 1686*/ GIMT_Encode4(67325), GIMT_Encode4(0),
     /* 67313 */ /*GILLT_v4s32*//*Label 1687*/ GIMT_Encode4(67359),
     /* 67317 */ /*GILLT_v8s16*//*Label 1688*/ GIMT_Encode4(67393),
     /* 67321 */ /*GILLT_v16s8*//*Label 1689*/ GIMT_Encode4(67427),
     /* 67325 */ // Label 1686: @67325
     /* 67325 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(67358), // Rule ID 851 //
     /* 67330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67351 */   // (smax:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_D),
     /* 67356 */   GIR_RootConstrainSelectedInstOperands,
     /* 67357 */   // GIR_Coverage, 851,
     /* 67357 */   GIR_Done,
     /* 67358 */ // Label 1691: @67358
     /* 67358 */ GIM_Reject,
     /* 67359 */ // Label 1687: @67359
     /* 67359 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(67392), // Rule ID 850 //
     /* 67364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67385 */   // (smax:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_W),
     /* 67390 */   GIR_RootConstrainSelectedInstOperands,
     /* 67391 */   // GIR_Coverage, 850,
     /* 67391 */   GIR_Done,
     /* 67392 */ // Label 1692: @67392
     /* 67392 */ GIM_Reject,
     /* 67393 */ // Label 1688: @67393
     /* 67393 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(67426), // Rule ID 849 //
     /* 67398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67419 */   // (smax:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_H),
     /* 67424 */   GIR_RootConstrainSelectedInstOperands,
     /* 67425 */   // GIR_Coverage, 849,
     /* 67425 */   GIR_Done,
     /* 67426 */ // Label 1693: @67426
     /* 67426 */ GIM_Reject,
     /* 67427 */ // Label 1689: @67427
     /* 67427 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(67460), // Rule ID 848 //
     /* 67432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67453 */   // (smax:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_B),
     /* 67458 */   GIR_RootConstrainSelectedInstOperands,
     /* 67459 */   // GIR_Coverage, 848,
     /* 67459 */   GIR_Done,
     /* 67460 */ // Label 1694: @67460
     /* 67460 */ GIM_Reject,
     /* 67461 */ // Label 1690: @67461
     /* 67461 */ GIM_Reject,
     /* 67462 */ // Label 68: @67462
     /* 67462 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1699*/ GIMT_Encode4(67629),
     /* 67473 */ /*GILLT_v2s64*//*Label 1695*/ GIMT_Encode4(67493), GIMT_Encode4(0),
     /* 67481 */ /*GILLT_v4s32*//*Label 1696*/ GIMT_Encode4(67527),
     /* 67485 */ /*GILLT_v8s16*//*Label 1697*/ GIMT_Encode4(67561),
     /* 67489 */ /*GILLT_v16s8*//*Label 1698*/ GIMT_Encode4(67595),
     /* 67493 */ // Label 1695: @67493
     /* 67493 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(67526), // Rule ID 875 //
     /* 67498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67519 */   // (umin:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_D),
     /* 67524 */   GIR_RootConstrainSelectedInstOperands,
     /* 67525 */   // GIR_Coverage, 875,
     /* 67525 */   GIR_Done,
     /* 67526 */ // Label 1700: @67526
     /* 67526 */ GIM_Reject,
     /* 67527 */ // Label 1696: @67527
     /* 67527 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(67560), // Rule ID 874 //
     /* 67532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67553 */   // (umin:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_W),
     /* 67558 */   GIR_RootConstrainSelectedInstOperands,
     /* 67559 */   // GIR_Coverage, 874,
     /* 67559 */   GIR_Done,
     /* 67560 */ // Label 1701: @67560
     /* 67560 */ GIM_Reject,
     /* 67561 */ // Label 1697: @67561
     /* 67561 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(67594), // Rule ID 873 //
     /* 67566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67587 */   // (umin:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_H),
     /* 67592 */   GIR_RootConstrainSelectedInstOperands,
     /* 67593 */   // GIR_Coverage, 873,
     /* 67593 */   GIR_Done,
     /* 67594 */ // Label 1702: @67594
     /* 67594 */ GIM_Reject,
     /* 67595 */ // Label 1698: @67595
     /* 67595 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(67628), // Rule ID 872 //
     /* 67600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67621 */   // (umin:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_B),
     /* 67626 */   GIR_RootConstrainSelectedInstOperands,
     /* 67627 */   // GIR_Coverage, 872,
     /* 67627 */   GIR_Done,
     /* 67628 */ // Label 1703: @67628
     /* 67628 */ GIM_Reject,
     /* 67629 */ // Label 1699: @67629
     /* 67629 */ GIM_Reject,
     /* 67630 */ // Label 69: @67630
     /* 67630 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1708*/ GIMT_Encode4(67797),
     /* 67641 */ /*GILLT_v2s64*//*Label 1704*/ GIMT_Encode4(67661), GIMT_Encode4(0),
     /* 67649 */ /*GILLT_v4s32*//*Label 1705*/ GIMT_Encode4(67695),
     /* 67653 */ /*GILLT_v8s16*//*Label 1706*/ GIMT_Encode4(67729),
     /* 67657 */ /*GILLT_v16s8*//*Label 1707*/ GIMT_Encode4(67763),
     /* 67661 */ // Label 1704: @67661
     /* 67661 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(67694), // Rule ID 855 //
     /* 67666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67687 */   // (umax:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_D),
     /* 67692 */   GIR_RootConstrainSelectedInstOperands,
     /* 67693 */   // GIR_Coverage, 855,
     /* 67693 */   GIR_Done,
     /* 67694 */ // Label 1709: @67694
     /* 67694 */ GIM_Reject,
     /* 67695 */ // Label 1705: @67695
     /* 67695 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(67728), // Rule ID 854 //
     /* 67700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67721 */   // (umax:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_W),
     /* 67726 */   GIR_RootConstrainSelectedInstOperands,
     /* 67727 */   // GIR_Coverage, 854,
     /* 67727 */   GIR_Done,
     /* 67728 */ // Label 1710: @67728
     /* 67728 */ GIM_Reject,
     /* 67729 */ // Label 1706: @67729
     /* 67729 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(67762), // Rule ID 853 //
     /* 67734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67755 */   // (umax:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_H),
     /* 67760 */   GIR_RootConstrainSelectedInstOperands,
     /* 67761 */   // GIR_Coverage, 853,
     /* 67761 */   GIR_Done,
     /* 67762 */ // Label 1711: @67762
     /* 67762 */ GIM_Reject,
     /* 67763 */ // Label 1707: @67763
     /* 67763 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(67796), // Rule ID 852 //
     /* 67768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67789 */   // (umax:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_B),
     /* 67794 */   GIR_RootConstrainSelectedInstOperands,
     /* 67795 */   // GIR_Coverage, 852,
     /* 67795 */   GIR_Done,
     /* 67796 */ // Label 1712: @67796
     /* 67796 */ GIM_Reject,
     /* 67797 */ // Label 1708: @67797
     /* 67797 */ GIM_Reject,
     /* 67798 */ // Label 70: @67798
     /* 67798 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(67921),
     /* 67803 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 67806 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(67827), // Rule ID 91 //
     /* 67811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips_RelocNotPIC),
     /* 67814 */     // (br (bb:{ *:[Other] }):$target)  =>  (J (bb:{ *:[Other] }):$target)
     /* 67814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::J),
     /* 67819 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67825 */     GIR_RootConstrainSelectedInstOperands,
     /* 67826 */     // GIR_Coverage, 91,
     /* 67826 */     GIR_Done,
     /* 67827 */   // Label 1714: @67827
     /* 67827 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(67848), // Rule ID 98 //
     /* 67832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 67835 */     // (br (bb:{ *:[Other] }):$offset)  =>  (B (bb:{ *:[Other] }):$offset)
     /* 67835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::B),
     /* 67840 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67846 */     GIR_RootConstrainSelectedInstOperands,
     /* 67847 */     // GIR_Coverage, 98,
     /* 67847 */     GIR_Done,
     /* 67848 */   // Label 1715: @67848
     /* 67848 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(67869), // Rule ID 1104 //
     /* 67853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6_RelocNotPIC),
     /* 67856 */     // (br (bb:{ *:[Other] }):$target)  =>  (J_MM (bb:{ *:[Other] }):$target)
     /* 67856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::J_MM),
     /* 67861 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67867 */     GIR_RootConstrainSelectedInstOperands,
     /* 67868 */     // GIR_Coverage, 1104,
     /* 67868 */     GIR_Done,
     /* 67869 */   // Label 1716: @67869
     /* 67869 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(67890), // Rule ID 1113 //
     /* 67874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6_RelocPIC),
     /* 67877 */     // (br (bb:{ *:[Other] }):$offset)  =>  (B_MM (bb:{ *:[Other] }):$offset)
     /* 67877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::B_MM),
     /* 67882 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67888 */     GIR_RootConstrainSelectedInstOperands,
     /* 67889 */     // GIR_Coverage, 1113,
     /* 67889 */     GIR_Done,
     /* 67890 */   // Label 1717: @67890
     /* 67890 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(67905), // Rule ID 1171 //
     /* 67895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 67898 */     // (br (bb:{ *:[Other] }):$offset)  =>  (BC_MMR6 (bb:{ *:[Other] }):$offset)
     /* 67898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BC_MMR6),
     /* 67903 */     GIR_RootConstrainSelectedInstOperands,
     /* 67904 */     // GIR_Coverage, 1171,
     /* 67904 */     GIR_Done,
     /* 67905 */   // Label 1718: @67905
     /* 67905 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(67920), // Rule ID 1867 //
     /* 67910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 67913 */     // (br (bb:{ *:[Other] }):$imm16)  =>  (Bimm16 (bb:{ *:[Other] }):$imm16)
     /* 67913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::Bimm16),
     /* 67918 */     GIR_RootConstrainSelectedInstOperands,
     /* 67919 */     // GIR_Coverage, 1867,
     /* 67919 */     GIR_Done,
     /* 67920 */   // Label 1719: @67920
     /* 67920 */   GIM_Reject,
     /* 67921 */ // Label 1713: @67921
     /* 67921 */ GIM_Reject,
     /* 67922 */ // Label 71: @67922
     /* 67922 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1724*/ GIMT_Encode4(68485),
     /* 67933 */ /*GILLT_v2s64*//*Label 1720*/ GIMT_Encode4(67953), GIMT_Encode4(0),
     /* 67941 */ /*GILLT_v4s32*//*Label 1721*/ GIMT_Encode4(68126),
     /* 67945 */ /*GILLT_v8s16*//*Label 1722*/ GIMT_Encode4(68299),
     /* 67949 */ /*GILLT_v16s8*//*Label 1723*/ GIMT_Encode4(68392),
     /* 67953 */ // Label 1720: @67953
     /* 67953 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(68125),
     /* 67958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 67964 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(68004), // Rule ID 821 //
     /* 67969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 67975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 67987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 67991 */     // (vector_insert:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_D_VIDX_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR64Opnd:{ *:[i64] }:$fs)
     /* 67991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_D_VIDX_PSEUDO),
     /* 67994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 67996 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 67998 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68000 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68002 */     GIR_RootConstrainSelectedInstOperands,
     /* 68003 */     // GIR_Coverage, 821,
     /* 68003 */     GIR_EraseRootFromParent_Done,
     /* 68004 */   // Label 1726: @68004
     /* 68004 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(68044), // Rule ID 823 //
     /* 68009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 68027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68031 */     // (vector_insert:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, FGR64Opnd:{ *:[f64] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_FD_VIDX_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, FGR64Opnd:{ *:[f64] }:$fs)
     /* 68031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FD_VIDX_PSEUDO),
     /* 68034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68036 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68038 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68040 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68042 */     GIR_RootConstrainSelectedInstOperands,
     /* 68043 */     // GIR_Coverage, 823,
     /* 68043 */     GIR_EraseRootFromParent_Done,
     /* 68044 */   // Label 1727: @68044
     /* 68044 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(68084), // Rule ID 827 //
     /* 68049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68071 */     // (vector_insert:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_D_VIDX64_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR64Opnd:{ *:[i64] }:$fs)
     /* 68071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_D_VIDX64_PSEUDO),
     /* 68074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68076 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68078 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68080 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68082 */     GIR_RootConstrainSelectedInstOperands,
     /* 68083 */     // GIR_Coverage, 827,
     /* 68083 */     GIR_EraseRootFromParent_Done,
     /* 68084 */   // Label 1728: @68084
     /* 68084 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(68124), // Rule ID 829 //
     /* 68089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 68107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68111 */     // (vector_insert:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, FGR64Opnd:{ *:[f64] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_FD_VIDX64_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, FGR64Opnd:{ *:[f64] }:$fs)
     /* 68111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FD_VIDX64_PSEUDO),
     /* 68114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68116 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68118 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68120 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68122 */     GIR_RootConstrainSelectedInstOperands,
     /* 68123 */     // GIR_Coverage, 829,
     /* 68123 */     GIR_EraseRootFromParent_Done,
     /* 68124 */   // Label 1729: @68124
     /* 68124 */   GIM_Reject,
     /* 68125 */ // Label 1725: @68125
     /* 68125 */ GIM_Reject,
     /* 68126 */ // Label 1721: @68126
     /* 68126 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(68298),
     /* 68131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68137 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(68177), // Rule ID 820 //
     /* 68142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68164 */     // (vector_insert:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_W_VIDX_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_W_VIDX_PSEUDO),
     /* 68167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68169 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68171 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68173 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68175 */     GIR_RootConstrainSelectedInstOperands,
     /* 68176 */     // GIR_Coverage, 820,
     /* 68176 */     GIR_EraseRootFromParent_Done,
     /* 68177 */   // Label 1731: @68177
     /* 68177 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(68217), // Rule ID 822 //
     /* 68182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 68200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68204 */     // (vector_insert:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, FGR32Opnd:{ *:[f32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_FW_VIDX_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, FGR32Opnd:{ *:[f32] }:$fs)
     /* 68204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FW_VIDX_PSEUDO),
     /* 68207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68209 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68211 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68213 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68215 */     GIR_RootConstrainSelectedInstOperands,
     /* 68216 */     // GIR_Coverage, 822,
     /* 68216 */     GIR_EraseRootFromParent_Done,
     /* 68217 */   // Label 1732: @68217
     /* 68217 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(68257), // Rule ID 826 //
     /* 68222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68244 */     // (vector_insert:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_W_VIDX64_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_W_VIDX64_PSEUDO),
     /* 68247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68249 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68251 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68253 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68255 */     GIR_RootConstrainSelectedInstOperands,
     /* 68256 */     // GIR_Coverage, 826,
     /* 68256 */     GIR_EraseRootFromParent_Done,
     /* 68257 */   // Label 1733: @68257
     /* 68257 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(68297), // Rule ID 828 //
     /* 68262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 68280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68284 */     // (vector_insert:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, FGR32Opnd:{ *:[f32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_FW_VIDX64_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, FGR32Opnd:{ *:[f32] }:$fs)
     /* 68284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FW_VIDX64_PSEUDO),
     /* 68287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68289 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68291 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68293 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68295 */     GIR_RootConstrainSelectedInstOperands,
     /* 68296 */     // GIR_Coverage, 828,
     /* 68296 */     GIR_EraseRootFromParent_Done,
     /* 68297 */   // Label 1734: @68297
     /* 68297 */   GIM_Reject,
     /* 68298 */ // Label 1730: @68298
     /* 68298 */ GIM_Reject,
     /* 68299 */ // Label 1722: @68299
     /* 68299 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(68391),
     /* 68304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 68307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68310 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(68350), // Rule ID 819 //
     /* 68315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68337 */     // (vector_insert:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_H_VIDX_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_H_VIDX_PSEUDO),
     /* 68340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68342 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68344 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68346 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68348 */     GIR_RootConstrainSelectedInstOperands,
     /* 68349 */     // GIR_Coverage, 819,
     /* 68349 */     GIR_EraseRootFromParent_Done,
     /* 68350 */   // Label 1736: @68350
     /* 68350 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(68390), // Rule ID 825 //
     /* 68355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68377 */     // (vector_insert:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_H_VIDX64_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_H_VIDX64_PSEUDO),
     /* 68380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68382 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68384 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68386 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68388 */     GIR_RootConstrainSelectedInstOperands,
     /* 68389 */     // GIR_Coverage, 825,
     /* 68389 */     GIR_EraseRootFromParent_Done,
     /* 68390 */   // Label 1737: @68390
     /* 68390 */   GIM_Reject,
     /* 68391 */ // Label 1735: @68391
     /* 68391 */ GIM_Reject,
     /* 68392 */ // Label 1723: @68392
     /* 68392 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(68484),
     /* 68397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 68400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68403 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(68443), // Rule ID 818 //
     /* 68408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68430 */     // (vector_insert:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_B_VIDX_PSEUDO:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_B_VIDX_PSEUDO),
     /* 68433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68435 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68437 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68439 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68441 */     GIR_RootConstrainSelectedInstOperands,
     /* 68442 */     // GIR_Coverage, 818,
     /* 68442 */     GIR_EraseRootFromParent_Done,
     /* 68443 */   // Label 1739: @68443
     /* 68443 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(68483), // Rule ID 824 //
     /* 68448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68470 */     // (vector_insert:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_B_VIDX64_PSEUDO:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_B_VIDX64_PSEUDO),
     /* 68473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68475 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68477 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68479 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68481 */     GIR_RootConstrainSelectedInstOperands,
     /* 68482 */     // GIR_Coverage, 824,
     /* 68482 */     GIR_EraseRootFromParent_Done,
     /* 68483 */   // Label 1740: @68483
     /* 68483 */   GIM_Reject,
     /* 68484 */ // Label 1738: @68484
     /* 68484 */ GIM_Reject,
     /* 68485 */ // Label 1724: @68485
     /* 68485 */ GIM_Reject,
     /* 68486 */ // Label 72: @68486
     /* 68486 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(68537), // Rule ID 1994 //
     /* 68491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 68494 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 68497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68511 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 68515 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 68519 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 68523 */   // MIs[1] Operand 1
     /* 68523 */   // No operand predicates
     /* 68523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68525 */   // (extractelt:{ *:[i32] } MSA128W:{ *:[v4i32] }:$ws, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$idx)  =>  (COPY_S_W:{ *:[i32] } MSA128W:{ *:[v4i32] }:$ws, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$idx)
     /* 68525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::COPY_S_W),
     /* 68528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68530 */   GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 68532 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 68535 */   GIR_RootConstrainSelectedInstOperands,
     /* 68536 */   // GIR_Coverage, 1994,
     /* 68536 */   GIR_EraseRootFromParent_Done,
     /* 68537 */ // Label 1741: @68537
     /* 68537 */ GIM_Reject,
     /* 68538 */ // Label 73: @68538
     /* 68538 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1748*/ GIMT_Encode4(69042),
     /* 68549 */ /*GILLT_s32*//*Label 1742*/ GIMT_Encode4(68581),
     /* 68553 */ /*GILLT_s64*//*Label 1743*/ GIMT_Encode4(68790), GIMT_Encode4(0),
     /* 68561 */ /*GILLT_v2s64*//*Label 1744*/ GIMT_Encode4(68934), GIMT_Encode4(0),
     /* 68569 */ /*GILLT_v4s32*//*Label 1745*/ GIMT_Encode4(68961),
     /* 68573 */ /*GILLT_v8s16*//*Label 1746*/ GIMT_Encode4(68988),
     /* 68577 */ /*GILLT_v16s8*//*Label 1747*/ GIMT_Encode4(69015),
     /* 68581 */ // Label 1742: @68581
     /* 68581 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(68789),
     /* 68586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68593 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(68639), // Rule ID 109 //
     /* 68598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 68601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68622 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68628 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO),
     /* 68631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68637 */     GIR_RootConstrainSelectedInstOperands,
     /* 68638 */     // GIR_Coverage, 109,
     /* 68638 */     GIR_EraseRootFromParent_Done,
     /* 68639 */   // Label 1750: @68639
     /* 68639 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(68685), // Rule ID 310 //
     /* 68644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc),
     /* 68647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68668 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68674 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO_R6),
     /* 68677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68683 */     GIR_RootConstrainSelectedInstOperands,
     /* 68684 */     // GIR_Coverage, 310,
     /* 68684 */     GIR_EraseRootFromParent_Done,
     /* 68685 */   // Label 1751: @68685
     /* 68685 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(68731), // Rule ID 1100 //
     /* 68690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 68693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68714 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68720 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO_MM),
     /* 68723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68729 */     GIR_RootConstrainSelectedInstOperands,
     /* 68730 */     // GIR_Coverage, 1100,
     /* 68730 */     GIR_EraseRootFromParent_Done,
     /* 68731 */   // Label 1752: @68731
     /* 68731 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(68750), // Rule ID 108 //
     /* 68736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 68739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68743 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ),
     /* 68748 */     GIR_RootConstrainSelectedInstOperands,
     /* 68749 */     // GIR_Coverage, 108,
     /* 68749 */     GIR_Done,
     /* 68750 */   // Label 1753: @68750
     /* 68750 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(68769), // Rule ID 311 //
     /* 68755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc),
     /* 68758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68762 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ_R6),
     /* 68767 */     GIR_RootConstrainSelectedInstOperands,
     /* 68768 */     // GIR_Coverage, 311,
     /* 68768 */     GIR_Done,
     /* 68769 */   // Label 1754: @68769
     /* 68769 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(68788), // Rule ID 1099 //
     /* 68774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 68777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68781 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ_MM),
     /* 68786 */     GIR_RootConstrainSelectedInstOperands,
     /* 68787 */     // GIR_Coverage, 1099,
     /* 68787 */     GIR_Done,
     /* 68788 */   // Label 1755: @68788
     /* 68788 */   GIM_Reject,
     /* 68789 */ // Label 1749: @68789
     /* 68789 */ GIM_Reject,
     /* 68790 */ // Label 1743: @68790
     /* 68790 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(68933),
     /* 68795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68802 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(68848), // Rule ID 264 //
     /* 68807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6),
     /* 68810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 68822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 68826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68831 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68837 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, -1:{ *:[i64] }))  =>  (DCLO:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DCLO),
     /* 68840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68846 */     GIR_RootConstrainSelectedInstOperands,
     /* 68847 */     // GIR_Coverage, 264,
     /* 68847 */     GIR_EraseRootFromParent_Done,
     /* 68848 */   // Label 1757: @68848
     /* 68848 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(68894), // Rule ID 339 //
     /* 68853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 68856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 68868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 68872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68877 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68883 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, -1:{ *:[i64] }))  =>  (DCLO_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DCLO_R6),
     /* 68886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68892 */     GIR_RootConstrainSelectedInstOperands,
     /* 68893 */     // GIR_Coverage, 339,
     /* 68893 */     GIR_EraseRootFromParent_Done,
     /* 68894 */   // Label 1758: @68894
     /* 68894 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(68913), // Rule ID 263 //
     /* 68899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6),
     /* 68902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68906 */     // (ctlz:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DCLZ:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DCLZ),
     /* 68911 */     GIR_RootConstrainSelectedInstOperands,
     /* 68912 */     // GIR_Coverage, 263,
     /* 68912 */     GIR_Done,
     /* 68913 */   // Label 1759: @68913
     /* 68913 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(68932), // Rule ID 340 //
     /* 68918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 68921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68925 */     // (ctlz:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DCLZ_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DCLZ_R6),
     /* 68930 */     GIR_RootConstrainSelectedInstOperands,
     /* 68931 */     // GIR_Coverage, 340,
     /* 68931 */     GIR_Done,
     /* 68932 */   // Label 1760: @68932
     /* 68932 */   GIM_Reject,
     /* 68933 */ // Label 1756: @68933
     /* 68933 */ GIM_Reject,
     /* 68934 */ // Label 1744: @68934
     /* 68934 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(68960), // Rule ID 915 //
     /* 68939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 68945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68953 */   // (ctlz:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (NLZC_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 68953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_D),
     /* 68958 */   GIR_RootConstrainSelectedInstOperands,
     /* 68959 */   // GIR_Coverage, 915,
     /* 68959 */   GIR_Done,
     /* 68960 */ // Label 1761: @68960
     /* 68960 */ GIM_Reject,
     /* 68961 */ // Label 1745: @68961
     /* 68961 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(68987), // Rule ID 914 //
     /* 68966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68980 */   // (ctlz:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (NLZC_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 68980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_W),
     /* 68985 */   GIR_RootConstrainSelectedInstOperands,
     /* 68986 */   // GIR_Coverage, 914,
     /* 68986 */   GIR_Done,
     /* 68987 */ // Label 1762: @68987
     /* 68987 */ GIM_Reject,
     /* 68988 */ // Label 1746: @68988
     /* 68988 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(69014), // Rule ID 913 //
     /* 68993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 68999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69007 */   // (ctlz:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (NLZC_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 69007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_H),
     /* 69012 */   GIR_RootConstrainSelectedInstOperands,
     /* 69013 */   // GIR_Coverage, 913,
     /* 69013 */   GIR_Done,
     /* 69014 */ // Label 1763: @69014
     /* 69014 */ GIM_Reject,
     /* 69015 */ // Label 1747: @69015
     /* 69015 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(69041), // Rule ID 912 //
     /* 69020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 69026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69034 */   // (ctlz:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (NLZC_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 69034 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_B),
     /* 69039 */   GIR_RootConstrainSelectedInstOperands,
     /* 69040 */   // GIR_Coverage, 912,
     /* 69040 */   GIR_Done,
     /* 69041 */ // Label 1764: @69041
     /* 69041 */ GIM_Reject,
     /* 69042 */ // Label 1748: @69042
     /* 69042 */ GIM_Reject,
     /* 69043 */ // Label 74: @69043
     /* 69043 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1771*/ GIMT_Encode4(69248),
     /* 69054 */ /*GILLT_s32*//*Label 1765*/ GIMT_Encode4(69086),
     /* 69058 */ /*GILLT_s64*//*Label 1766*/ GIMT_Encode4(69113), GIMT_Encode4(0),
     /* 69066 */ /*GILLT_v2s64*//*Label 1767*/ GIMT_Encode4(69140), GIMT_Encode4(0),
     /* 69074 */ /*GILLT_v4s32*//*Label 1768*/ GIMT_Encode4(69167),
     /* 69078 */ /*GILLT_v8s16*//*Label 1769*/ GIMT_Encode4(69194),
     /* 69082 */ /*GILLT_v16s8*//*Label 1770*/ GIMT_Encode4(69221),
     /* 69086 */ // Label 1765: @69086
     /* 69086 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(69112), // Rule ID 278 //
     /* 69091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 69094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69105 */   // (ctpop:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (POP:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 69105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::POP),
     /* 69110 */   GIR_RootConstrainSelectedInstOperands,
     /* 69111 */   // GIR_Coverage, 278,
     /* 69111 */   GIR_Done,
     /* 69112 */ // Label 1772: @69112
     /* 69112 */ GIM_Reject,
     /* 69113 */ // Label 1766: @69113
     /* 69113 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(69139), // Rule ID 279 //
     /* 69118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 69121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69132 */   // (ctpop:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DPOP:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 69132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DPOP),
     /* 69137 */   GIR_RootConstrainSelectedInstOperands,
     /* 69138 */   // GIR_Coverage, 279,
     /* 69138 */   GIR_Done,
     /* 69139 */ // Label 1773: @69139
     /* 69139 */ GIM_Reject,
     /* 69140 */ // Label 1767: @69140
     /* 69140 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(69166), // Rule ID 937 //
     /* 69145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69159 */   // (ctpop:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (PCNT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 69159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_D),
     /* 69164 */   GIR_RootConstrainSelectedInstOperands,
     /* 69165 */   // GIR_Coverage, 937,
     /* 69165 */   GIR_Done,
     /* 69166 */ // Label 1774: @69166
     /* 69166 */ GIM_Reject,
     /* 69167 */ // Label 1768: @69167
     /* 69167 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(69193), // Rule ID 936 //
     /* 69172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69186 */   // (ctpop:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (PCNT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 69186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_W),
     /* 69191 */   GIR_RootConstrainSelectedInstOperands,
     /* 69192 */   // GIR_Coverage, 936,
     /* 69192 */   GIR_Done,
     /* 69193 */ // Label 1775: @69193
     /* 69193 */ GIM_Reject,
     /* 69194 */ // Label 1769: @69194
     /* 69194 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(69220), // Rule ID 935 //
     /* 69199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 69205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69213 */   // (ctpop:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (PCNT_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 69213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_H),
     /* 69218 */   GIR_RootConstrainSelectedInstOperands,
     /* 69219 */   // GIR_Coverage, 935,
     /* 69219 */   GIR_Done,
     /* 69220 */ // Label 1776: @69220
     /* 69220 */ GIM_Reject,
     /* 69221 */ // Label 1770: @69221
     /* 69221 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(69247), // Rule ID 934 //
     /* 69226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 69232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69240 */   // (ctpop:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (PCNT_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 69240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_B),
     /* 69245 */   GIR_RootConstrainSelectedInstOperands,
     /* 69246 */   // GIR_Coverage, 934,
     /* 69246 */   GIR_Done,
     /* 69247 */ // Label 1777: @69247
     /* 69247 */ GIM_Reject,
     /* 69248 */ // Label 1771: @69248
     /* 69248 */ GIM_Reject,
     /* 69249 */ // Label 75: @69249
     /* 69249 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1780*/ GIMT_Encode4(69412),
     /* 69260 */ /*GILLT_s32*//*Label 1778*/ GIMT_Encode4(69268),
     /* 69264 */ /*GILLT_s64*//*Label 1779*/ GIMT_Encode4(69364),
     /* 69268 */ // Label 1778: @69268
     /* 69268 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(69363),
     /* 69273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69284 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(69323), // Rule ID 1427 //
     /* 69289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 69292 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$rt)  =>  (ROTR:{ *:[i32] } (WSBH:{ *:[i32] } GPR32:{ *:[i32] }:$rt), 16:{ *:[i32] })
     /* 69292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::WSBH),
     /* 69299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR),
     /* 69313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 69321 */     GIR_RootConstrainSelectedInstOperands,
     /* 69322 */     // GIR_Coverage, 1427,
     /* 69322 */     GIR_EraseRootFromParent_Done,
     /* 69323 */   // Label 1782: @69323
     /* 69323 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(69362), // Rule ID 2191 //
     /* 69328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 69331 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$rt)  =>  (ROTR_MM:{ *:[i32] } (WSBH_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rt), 16:{ *:[i32] })
     /* 69331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::WSBH_MM),
     /* 69338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR_MM),
     /* 69352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 69360 */     GIR_RootConstrainSelectedInstOperands,
     /* 69361 */     // GIR_Coverage, 2191,
     /* 69361 */     GIR_EraseRootFromParent_Done,
     /* 69362 */   // Label 1783: @69362
     /* 69362 */   GIM_Reject,
     /* 69363 */ // Label 1781: @69363
     /* 69363 */ GIM_Reject,
     /* 69364 */ // Label 1779: @69364
     /* 69364 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(69411), // Rule ID 1589 //
     /* 69369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc),
     /* 69372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69383 */   // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$rt)  =>  (DSHD:{ *:[i64] } (DSBH:{ *:[i64] } GPR64:{ *:[i64] }:$rt))
     /* 69383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 69386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::DSBH),
     /* 69390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69395 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSHD),
     /* 69404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69409 */   GIR_RootConstrainSelectedInstOperands,
     /* 69410 */   // GIR_Coverage, 1589,
     /* 69410 */   GIR_EraseRootFromParent_Done,
     /* 69411 */ // Label 1784: @69411
     /* 69411 */ GIM_Reject,
     /* 69412 */ // Label 1780: @69412
     /* 69412 */ GIM_Reject,
     /* 69413 */ // Label 76: @69413
     /* 69413 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1789*/ GIMT_Encode4(69652),
     /* 69424 */ /*GILLT_s32*//*Label 1785*/ GIMT_Encode4(69448),
     /* 69428 */ /*GILLT_s64*//*Label 1786*/ GIMT_Encode4(69496), GIMT_Encode4(0),
     /* 69436 */ /*GILLT_v2s64*//*Label 1787*/ GIMT_Encode4(69598), GIMT_Encode4(0),
     /* 69444 */ /*GILLT_v4s32*//*Label 1788*/ GIMT_Encode4(69625),
     /* 69448 */ // Label 1785: @69448
     /* 69448 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(69495),
     /* 69453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 69460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 69464 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(69479), // Rule ID 132 //
     /* 69469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 69472 */     // (fsqrt:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FSQRT_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 69472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_S),
     /* 69477 */     GIR_RootConstrainSelectedInstOperands,
     /* 69478 */     // GIR_Coverage, 132,
     /* 69478 */     GIR_Done,
     /* 69479 */   // Label 1791: @69479
     /* 69479 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(69494), // Rule ID 1162 //
     /* 69484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 69487 */     // (fsqrt:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FSQRT_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 69487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_S_MM),
     /* 69492 */     GIR_RootConstrainSelectedInstOperands,
     /* 69493 */     // GIR_Coverage, 1162,
     /* 69493 */     GIR_Done,
     /* 69494 */   // Label 1792: @69494
     /* 69494 */   GIM_Reject,
     /* 69495 */ // Label 1790: @69495
     /* 69495 */ GIM_Reject,
     /* 69496 */ // Label 1786: @69496
     /* 69496 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(69597),
     /* 69501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69504 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(69527), // Rule ID 133 //
     /* 69509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 69512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69520 */     // (fsqrt:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 69520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D32),
     /* 69525 */     GIR_RootConstrainSelectedInstOperands,
     /* 69526 */     // GIR_Coverage, 133,
     /* 69526 */     GIR_Done,
     /* 69527 */   // Label 1794: @69527
     /* 69527 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(69550), // Rule ID 134 //
     /* 69532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 69535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69543 */     // (fsqrt:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 69543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D64),
     /* 69548 */     GIR_RootConstrainSelectedInstOperands,
     /* 69549 */     // GIR_Coverage, 134,
     /* 69549 */     GIR_Done,
     /* 69550 */   // Label 1795: @69550
     /* 69550 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(69573), // Rule ID 1148 //
     /* 69555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 69558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69566 */     // (fsqrt:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 69566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D32_MM),
     /* 69571 */     GIR_RootConstrainSelectedInstOperands,
     /* 69572 */     // GIR_Coverage, 1148,
     /* 69572 */     GIR_Done,
     /* 69573 */   // Label 1796: @69573
     /* 69573 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(69596), // Rule ID 1149 //
     /* 69578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 69581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69589 */     // (fsqrt:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 69589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D64_MM),
     /* 69594 */     GIR_RootConstrainSelectedInstOperands,
     /* 69595 */     // GIR_Coverage, 1149,
     /* 69595 */     GIR_Done,
     /* 69596 */   // Label 1797: @69596
     /* 69596 */   GIM_Reject,
     /* 69597 */ // Label 1793: @69597
     /* 69597 */ GIM_Reject,
     /* 69598 */ // Label 1787: @69598
     /* 69598 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(69624), // Rule ID 757 //
     /* 69603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69617 */   // (fsqrt:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FSQRT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 69617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D),
     /* 69622 */   GIR_RootConstrainSelectedInstOperands,
     /* 69623 */   // GIR_Coverage, 757,
     /* 69623 */   GIR_Done,
     /* 69624 */ // Label 1798: @69624
     /* 69624 */ GIM_Reject,
     /* 69625 */ // Label 1788: @69625
     /* 69625 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(69651), // Rule ID 756 //
     /* 69630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69644 */   // (fsqrt:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FSQRT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 69644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_W),
     /* 69649 */   GIR_RootConstrainSelectedInstOperands,
     /* 69650 */   // GIR_Coverage, 756,
     /* 69650 */   GIR_Done,
     /* 69651 */ // Label 1799: @69651
     /* 69651 */ GIM_Reject,
     /* 69652 */ // Label 1789: @69652
     /* 69652 */ GIM_Reject,
     /* 69653 */ // Label 77: @69653
     /* 69653 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1802*/ GIMT_Encode4(69730),
     /* 69664 */ /*GILLT_v2s64*//*Label 1800*/ GIMT_Encode4(69676), GIMT_Encode4(0),
     /* 69672 */ /*GILLT_v4s32*//*Label 1801*/ GIMT_Encode4(69703),
     /* 69676 */ // Label 1800: @69676
     /* 69676 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(69702), // Rule ID 739 //
     /* 69681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69695 */   // (frint:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRINT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 69695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FRINT_D),
     /* 69700 */   GIR_RootConstrainSelectedInstOperands,
     /* 69701 */   // GIR_Coverage, 739,
     /* 69701 */   GIR_Done,
     /* 69702 */ // Label 1803: @69702
     /* 69702 */ GIM_Reject,
     /* 69703 */ // Label 1801: @69703
     /* 69703 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(69729), // Rule ID 738 //
     /* 69708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69722 */   // (frint:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRINT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 69722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FRINT_W),
     /* 69727 */   GIR_RootConstrainSelectedInstOperands,
     /* 69728 */   // GIR_Coverage, 738,
     /* 69728 */   GIR_Done,
     /* 69729 */ // Label 1804: @69729
     /* 69729 */ GIM_Reject,
     /* 69730 */ // Label 1802: @69730
     /* 69730 */ GIM_Reject,
     /* 69731 */ // Label 78: @69731
     /* 69731 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(69746), // Rule ID 90 //
     /* 69736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 69739 */   // (trap)  =>  (TRAP)
     /* 69739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::TRAP),
     /* 69744 */   GIR_RootConstrainSelectedInstOperands,
     /* 69745 */   // GIR_Coverage, 90,
     /* 69745 */   GIR_Done,
     /* 69746 */ // Label 1805: @69746
     /* 69746 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(69761), // Rule ID 1115 //
     /* 69751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 69754 */   // (trap)  =>  (TRAP_MM)
     /* 69754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::TRAP_MM),
     /* 69759 */   GIR_RootConstrainSelectedInstOperands,
     /* 69760 */   // GIR_Coverage, 1115,
     /* 69760 */   GIR_Done,
     /* 69761 */ // Label 1806: @69761
     /* 69761 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(69776), // Rule ID 1910 //
     /* 69766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 69769 */   // (trap)  =>  (Break16)
     /* 69769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::Break16),
     /* 69774 */   GIR_RootConstrainSelectedInstOperands,
     /* 69775 */   // GIR_Coverage, 1910,
     /* 69775 */   GIR_Done,
     /* 69776 */ // Label 1807: @69776
     /* 69776 */ GIM_Reject,
     /* 69777 */ // Label 79: @69777
     /* 69777 */ GIM_Reject,
     /* 69778 */ }; // Size: 69778 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const MipsSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const MipsSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
